
#ifndef __RNA_BLENDER_H__
#define __RNA_BLENDER_H__

/* Automatically generated function declarations for the Data API.
 * Do not edit manually, changes will be overwritten.              */

#include "RNA_types.hh"

#include "DNA_node_types.h"

#define FOREACH_BEGIN(property, sptr, itemptr) \
    { \
        CollectionPropertyIterator rna_macro_iter; \
        for (property##_begin(&rna_macro_iter, sptr); rna_macro_iter.valid; property##_next(&rna_macro_iter)) { \
            itemptr = rna_macro_iter.ptr;

#define FOREACH_END(property) \
        } \
        property##_end(&rna_macro_iter); \
    }

/**************** Shader AOV ****************/

extern StructRNA RNA_AOV;

PointerRNA AOV_rna_type_get(PointerRNA *ptr);

#define AOV_name_MAX 64

void AOV_name_get(PointerRNA *ptr, char *value);
int AOV_name_length(PointerRNA *ptr);
void AOV_name_set(PointerRNA *ptr, const char *value);

enum {
	AOV_type_COLOR = 1,
	AOV_type_VALUE = 0,
};

int AOV_type_get(PointerRNA *ptr);
void AOV_type_set(PointerRNA *ptr, int value);

bool AOV_is_valid_get(PointerRNA *ptr);
void AOV_is_valid_set(PointerRNA *ptr, bool value);

/**************** List of AOVs ****************/

extern StructRNA RNA_AOVs;

PointerRNA AOVs_rna_type_get(PointerRNA *ptr);

struct ViewLayerAOV *AOVs_add_func(struct ViewLayer *_self);
void AOVs_remove_func(struct ViewLayer *_self, ReportList *reports, struct ViewLayerAOV *aov);
/**************** Action ****************/

extern StructRNA RNA_Action;
extern StructRNA RNA_ID;

void Action_curve_frame_range_get(PointerRNA *ptr, float values[2]);
void Action_curve_frame_range_set(PointerRNA *ptr, const float values[2]);

bool Action_use_cyclic_get(PointerRNA *ptr);
void Action_use_cyclic_set(PointerRNA *ptr, bool value);

float Action_frame_end_get(PointerRNA *ptr);
void Action_frame_end_set(PointerRNA *ptr, float value);

void Action_fcurves_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Action_fcurves_next(CollectionPropertyIterator *iter);
void Action_fcurves_end(CollectionPropertyIterator *iter);
int Action_fcurves_length(PointerRNA *ptr);

void Action_frame_range_get(PointerRNA *ptr, float values[2]);
void Action_frame_range_set(PointerRNA *ptr, const float values[2]);

void Action_groups_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Action_groups_next(CollectionPropertyIterator *iter);
void Action_groups_end(CollectionPropertyIterator *iter);
int Action_groups_length(PointerRNA *ptr);
bool Action_groups_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

enum {
	Action_id_root_UNSPECIFIED = 0,
};

int Action_id_root_get(PointerRNA *ptr);
void Action_id_root_set(PointerRNA *ptr, int value);

bool Action_is_empty_get(PointerRNA *ptr);
void Action_is_empty_set(PointerRNA *ptr, bool value);

bool Action_is_action_layered_get(PointerRNA *ptr);
void Action_is_action_layered_set(PointerRNA *ptr, bool value);

bool Action_is_action_legacy_get(PointerRNA *ptr);
void Action_is_action_legacy_set(PointerRNA *ptr, bool value);

void Action_layers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Action_layers_next(CollectionPropertyIterator *iter);
void Action_layers_end(CollectionPropertyIterator *iter);
int Action_layers_length(PointerRNA *ptr);

bool Action_use_frame_range_get(PointerRNA *ptr);
void Action_use_frame_range_set(PointerRNA *ptr, bool value);

void Action_pose_markers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Action_pose_markers_next(CollectionPropertyIterator *iter);
void Action_pose_markers_end(CollectionPropertyIterator *iter);
bool Action_pose_markers_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Action_pose_markers_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void Action_slots_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Action_slots_next(CollectionPropertyIterator *iter);
void Action_slots_end(CollectionPropertyIterator *iter);
int Action_slots_length(PointerRNA *ptr);

float Action_frame_start_get(PointerRNA *ptr);
void Action_frame_start_set(PointerRNA *ptr, float value);

void Action_deselect_keys_func(struct bAction *_self);
struct FCurve *Action_fcurve_ensure_for_datablock_func(struct bAction *_self, Main *bmain, ReportList *reports, struct ID *datablock, const char * data_path, int index);
void Action_flip_with_pose_func(struct bAction *_self, ReportList *reports, struct Object *object);
/**************** Animation Channel Bag ****************/

extern StructRNA RNA_ActionChannelbag;

PointerRNA ActionChannelbag_rna_type_get(PointerRNA *ptr);

void ActionChannelbag_groups_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ActionChannelbag_groups_next(CollectionPropertyIterator *iter);
void ActionChannelbag_groups_end(CollectionPropertyIterator *iter);
int ActionChannelbag_groups_length(PointerRNA *ptr);

void ActionChannelbag_fcurves_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ActionChannelbag_fcurves_next(CollectionPropertyIterator *iter);
void ActionChannelbag_fcurves_end(CollectionPropertyIterator *iter);
int ActionChannelbag_fcurves_length(PointerRNA *ptr);

PointerRNA ActionChannelbag_slot_get(PointerRNA *ptr);

int ActionChannelbag_slot_handle_get(PointerRNA *ptr);
void ActionChannelbag_slot_handle_set(PointerRNA *ptr, int value);

/**************** F-Curves ****************/

extern StructRNA RNA_ActionChannelbagFCurves;

PointerRNA ActionChannelbagFCurves_rna_type_get(PointerRNA *ptr);

struct FCurve *ActionChannelbagFCurves_new_func(struct ActionChannelbag *_self, Main *bmain, ReportList *reports, const char * data_path, int index);
struct FCurve *ActionChannelbagFCurves_find_func(struct ActionChannelbag *_self, ReportList *reports, const char * data_path, int index);
void ActionChannelbagFCurves_remove_func(struct ID *_selfid, struct ActionChannelbag *_self, bContext *C, ReportList *reports, struct PointerRNA *fcurve);
void ActionChannelbagFCurves_clear_func(struct ID *_selfid, struct ActionChannelbag *_self, bContext *C);
/**************** F-Curve Groups ****************/

extern StructRNA RNA_ActionChannelbagGroups;

PointerRNA ActionChannelbagGroups_rna_type_get(PointerRNA *ptr);

struct bActionGroup *ActionChannelbagGroups_new_func(struct ActionChannelbag *_self, const char * name);
void ActionChannelbagGroups_remove_func(struct ActionChannelbag *_self, ReportList *reports, struct PointerRNA *action_group);
/**************** Animation Channels for Slots ****************/

extern StructRNA RNA_ActionChannelbags;

PointerRNA ActionChannelbags_rna_type_get(PointerRNA *ptr);

struct ActionChannelbag *ActionChannelbags_new_func(struct ID *_selfid, struct ActionStrip *_self, bContext *C, ReportList *reports, struct ActionSlot *slot);
void ActionChannelbags_remove_func(struct ID *_selfid, struct ActionStrip *_self, bContext *C, ReportList *reports, struct PointerRNA *channelbag);
/**************** Action Constraint ****************/

extern StructRNA RNA_ActionConstraint;
extern StructRNA RNA_Constraint;

PointerRNA ActionConstraint_action_get(PointerRNA *ptr);

PointerRNA ActionConstraint_action_slot_get(PointerRNA *ptr);

int ActionConstraint_action_slot_handle_get(PointerRNA *ptr);
void ActionConstraint_action_slot_handle_set(PointerRNA *ptr, int value);

void ActionConstraint_action_suitable_slots_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ActionConstraint_action_suitable_slots_next(CollectionPropertyIterator *iter);
void ActionConstraint_action_suitable_slots_end(CollectionPropertyIterator *iter);

int ActionConstraint_frame_end_get(PointerRNA *ptr);
void ActionConstraint_frame_end_set(PointerRNA *ptr, int value);

float ActionConstraint_eval_time_get(PointerRNA *ptr);
void ActionConstraint_eval_time_set(PointerRNA *ptr, float value);

#define ActionConstraint_last_slot_identifier_MAX 66

void ActionConstraint_last_slot_identifier_get(PointerRNA *ptr, char *value);
int ActionConstraint_last_slot_identifier_length(PointerRNA *ptr);
void ActionConstraint_last_slot_identifier_set(PointerRNA *ptr, const char *value);

float ActionConstraint_max_get(PointerRNA *ptr);
void ActionConstraint_max_set(PointerRNA *ptr, float value);

float ActionConstraint_min_get(PointerRNA *ptr);
void ActionConstraint_min_set(PointerRNA *ptr, float value);

enum {
	ActionConstraint_mix_mode_REPLACE = 6,
	ActionConstraint_mix_mode_BEFORE_FULL = 3,
	ActionConstraint_mix_mode_BEFORE = 2,
	ActionConstraint_mix_mode_BEFORE_SPLIT = 5,
	ActionConstraint_mix_mode_AFTER_FULL = 0,
	ActionConstraint_mix_mode_AFTER = 1,
	ActionConstraint_mix_mode_AFTER_SPLIT = 4,
};

int ActionConstraint_mix_mode_get(PointerRNA *ptr);
void ActionConstraint_mix_mode_set(PointerRNA *ptr, int value);

bool ActionConstraint_use_bone_object_action_get(PointerRNA *ptr);
void ActionConstraint_use_bone_object_action_set(PointerRNA *ptr, bool value);

int ActionConstraint_frame_start_get(PointerRNA *ptr);
void ActionConstraint_frame_start_set(PointerRNA *ptr, int value);

#define ActionConstraint_subtarget_MAX 64

void ActionConstraint_subtarget_get(PointerRNA *ptr, char *value);
int ActionConstraint_subtarget_length(PointerRNA *ptr);
void ActionConstraint_subtarget_set(PointerRNA *ptr, const char *value);

PointerRNA ActionConstraint_target_get(PointerRNA *ptr);

enum {
	ActionConstraint_transform_channel_LOCATION_X = 20,
	ActionConstraint_transform_channel_LOCATION_Y = 21,
	ActionConstraint_transform_channel_LOCATION_Z = 22,
	ActionConstraint_transform_channel_ROTATION_X = 0,
	ActionConstraint_transform_channel_ROTATION_Y = 1,
	ActionConstraint_transform_channel_ROTATION_Z = 2,
	ActionConstraint_transform_channel_SCALE_X = 10,
	ActionConstraint_transform_channel_SCALE_Y = 11,
	ActionConstraint_transform_channel_SCALE_Z = 12,
};

int ActionConstraint_transform_channel_get(PointerRNA *ptr);
void ActionConstraint_transform_channel_set(PointerRNA *ptr, int value);

bool ActionConstraint_use_eval_time_get(PointerRNA *ptr);
void ActionConstraint_use_eval_time_set(PointerRNA *ptr, bool value);

/**************** Action F-Curves ****************/

extern StructRNA RNA_ActionFCurves;

PointerRNA ActionFCurves_rna_type_get(PointerRNA *ptr);

struct FCurve *ActionFCurves_new_func(struct bAction *_self, Main *bmain, ReportList *reports, const char * data_path, int index, const char * action_group);
struct FCurve *ActionFCurves_find_func(struct bAction *_self, ReportList *reports, const char * data_path, int index);
void ActionFCurves_remove_func(struct bAction *_self, ReportList *reports, struct PointerRNA *fcurve);
void ActionFCurves_clear_func(struct bAction *_self);
/**************** Action Group ****************/

extern StructRNA RNA_ActionGroup;

PointerRNA ActionGroup_rna_type_get(PointerRNA *ptr);

#define ActionGroup_name_MAX 64

void ActionGroup_name_get(PointerRNA *ptr, char *value);
int ActionGroup_name_length(PointerRNA *ptr);
void ActionGroup_name_set(PointerRNA *ptr, const char *value);

void ActionGroup_channels_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ActionGroup_channels_next(CollectionPropertyIterator *iter);
void ActionGroup_channels_end(CollectionPropertyIterator *iter);

enum {
	ActionGroup_color_set_DEFAULT = 0,
	ActionGroup_color_set_THEME01 = 1,
	ActionGroup_color_set_THEME02 = 2,
	ActionGroup_color_set_THEME03 = 3,
	ActionGroup_color_set_THEME04 = 4,
	ActionGroup_color_set_THEME05 = 5,
	ActionGroup_color_set_THEME06 = 6,
	ActionGroup_color_set_THEME07 = 7,
	ActionGroup_color_set_THEME08 = 8,
	ActionGroup_color_set_THEME09 = 9,
	ActionGroup_color_set_THEME10 = 10,
	ActionGroup_color_set_THEME11 = 11,
	ActionGroup_color_set_THEME12 = 12,
	ActionGroup_color_set_THEME13 = 13,
	ActionGroup_color_set_THEME14 = 14,
	ActionGroup_color_set_THEME15 = 15,
	ActionGroup_color_set_THEME16 = 16,
	ActionGroup_color_set_THEME17 = 17,
	ActionGroup_color_set_THEME18 = 18,
	ActionGroup_color_set_THEME19 = 19,
	ActionGroup_color_set_THEME20 = 20,
	ActionGroup_color_set_CUSTOM = -1,
};

int ActionGroup_color_set_get(PointerRNA *ptr);
void ActionGroup_color_set_set(PointerRNA *ptr, int value);

PointerRNA ActionGroup_colors_get(PointerRNA *ptr);

bool ActionGroup_is_custom_color_set_get(PointerRNA *ptr);
void ActionGroup_is_custom_color_set_set(PointerRNA *ptr, bool value);

bool ActionGroup_show_expanded_get(PointerRNA *ptr);
void ActionGroup_show_expanded_set(PointerRNA *ptr, bool value);

bool ActionGroup_show_expanded_graph_get(PointerRNA *ptr);
void ActionGroup_show_expanded_graph_set(PointerRNA *ptr, bool value);

bool ActionGroup_lock_get(PointerRNA *ptr);
void ActionGroup_lock_set(PointerRNA *ptr, bool value);

bool ActionGroup_mute_get(PointerRNA *ptr);
void ActionGroup_mute_set(PointerRNA *ptr, bool value);

bool ActionGroup_use_pin_get(PointerRNA *ptr);
void ActionGroup_use_pin_set(PointerRNA *ptr, bool value);

bool ActionGroup_select_get(PointerRNA *ptr);
void ActionGroup_select_set(PointerRNA *ptr, bool value);

/**************** Action Groups ****************/

extern StructRNA RNA_ActionGroups;

PointerRNA ActionGroups_rna_type_get(PointerRNA *ptr);

struct bActionGroup *ActionGroups_new_func(struct bAction *_self, const char * name);
void ActionGroups_remove_func(struct bAction *_self, ReportList *reports, struct PointerRNA *action_group);
/**************** Keyframe Animation Strip ****************/

extern StructRNA RNA_ActionKeyframeStrip;
extern StructRNA RNA_ActionStrip;

void ActionKeyframeStrip_channelbags_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ActionKeyframeStrip_channelbags_next(CollectionPropertyIterator *iter);
void ActionKeyframeStrip_channelbags_end(CollectionPropertyIterator *iter);
int ActionKeyframeStrip_channelbags_length(PointerRNA *ptr);

struct ActionChannelbag *ActionKeyframeStrip_channelbag_func(struct ID *_selfid, struct ActionStrip *_self, ReportList *reports, struct ActionSlot *slot, bool ensure);
bool ActionKeyframeStrip_key_insert_func(struct ID *_selfid, struct ActionStrip *_self, Main *bmain, ReportList *reports, struct ActionSlot *slot, const char * data_path, int array_index, float value, float time);
/**************** Action Layer ****************/

extern StructRNA RNA_ActionLayer;

PointerRNA ActionLayer_rna_type_get(PointerRNA *ptr);

#define ActionLayer_name_MAX 64

void ActionLayer_name_get(PointerRNA *ptr, char *value);
int ActionLayer_name_length(PointerRNA *ptr);
void ActionLayer_name_set(PointerRNA *ptr, const char *value);

void ActionLayer_strips_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ActionLayer_strips_next(CollectionPropertyIterator *iter);
void ActionLayer_strips_end(CollectionPropertyIterator *iter);
int ActionLayer_strips_length(PointerRNA *ptr);

/**************** Action Layers ****************/

extern StructRNA RNA_ActionLayers;

PointerRNA ActionLayers_rna_type_get(PointerRNA *ptr);

struct ActionLayer *ActionLayers_new_func(struct bAction *_self, bContext *C, ReportList *reports, const char * name);
void ActionLayers_remove_func(struct bAction *_self, bContext *C, ReportList *reports, struct PointerRNA *anim_layer);
/**************** Action Pose Markers ****************/

extern StructRNA RNA_ActionPoseMarkers;

PointerRNA ActionPoseMarkers_rna_type_get(PointerRNA *ptr);

PointerRNA ActionPoseMarkers_active_get(PointerRNA *ptr);

int ActionPoseMarkers_active_index_get(PointerRNA *ptr);
void ActionPoseMarkers_active_index_set(PointerRNA *ptr, int value);

struct TimeMarker *ActionPoseMarkers_new_func(struct bAction *_self, const char * name);
void ActionPoseMarkers_remove_func(struct bAction *_self, ReportList *reports, struct PointerRNA *marker);
/**************** Action slot ****************/

extern StructRNA RNA_ActionSlot;

PointerRNA ActionSlot_rna_type_get(PointerRNA *ptr);

bool ActionSlot_active_get(PointerRNA *ptr);
void ActionSlot_active_set(PointerRNA *ptr, bool value);

bool ActionSlot_select_get(PointerRNA *ptr);
void ActionSlot_select_set(PointerRNA *ptr, bool value);

bool ActionSlot_show_expanded_get(PointerRNA *ptr);
void ActionSlot_show_expanded_set(PointerRNA *ptr, bool value);

#define ActionSlot_name_display_MAX 64

void ActionSlot_name_display_get(PointerRNA *ptr, char *value);
int ActionSlot_name_display_length(PointerRNA *ptr);
void ActionSlot_name_display_set(PointerRNA *ptr, const char *value);

int ActionSlot_handle_get(PointerRNA *ptr);
void ActionSlot_handle_set(PointerRNA *ptr, int value);

#define ActionSlot_identifier_MAX 66

void ActionSlot_identifier_get(PointerRNA *ptr, char *value);
int ActionSlot_identifier_length(PointerRNA *ptr);
void ActionSlot_identifier_set(PointerRNA *ptr, const char *value);

enum {
	ActionSlot_target_id_type_UNSPECIFIED = 0,
};

int ActionSlot_target_id_type_get(PointerRNA *ptr);
void ActionSlot_target_id_type_set(PointerRNA *ptr, int value);

int ActionSlot_target_id_type_icon_get(PointerRNA *ptr);
void ActionSlot_target_id_type_icon_set(PointerRNA *ptr, int value);

struct CollectionVector ActionSlot_users_func(struct ActionSlot *_self, Main *bmain);
struct ActionSlot *ActionSlot_duplicate_func(struct ID *_selfid, struct ActionSlot *_self);
/**************** Action Slots ****************/

extern StructRNA RNA_ActionSlots;

PointerRNA ActionSlots_rna_type_get(PointerRNA *ptr);

PointerRNA ActionSlots_active_get(PointerRNA *ptr);

struct ActionSlot *ActionSlots_new_func(struct bAction *_self, Main *bmain, bContext *C, ReportList *reports, int id_type, const char * name);
void ActionSlots_remove_func(struct bAction *_self, bContext *C, ReportList *reports, struct PointerRNA *action_slot);
/**************** Action Strip ****************/

extern StructRNA RNA_ActionStrip;

PointerRNA ActionStrip_rna_type_get(PointerRNA *ptr);

enum {
	ActionStrip_type_KEYFRAME = 0,
};

int ActionStrip_type_get(PointerRNA *ptr);
void ActionStrip_type_set(PointerRNA *ptr, int value);

/**************** Action Strips ****************/

extern StructRNA RNA_ActionStrips;

PointerRNA ActionStrips_rna_type_get(PointerRNA *ptr);

struct ActionStrip *ActionStrips_new_func(struct ID *_selfid, struct ActionLayer *_self, bContext *C, ReportList *reports, int type);
void ActionStrips_remove_func(struct ID *_selfid, struct ActionLayer *_self, bContext *C, ReportList *reports, struct PointerRNA *anim_strip);
/**************** Add Strip ****************/

extern StructRNA RNA_AddStrip;
extern StructRNA RNA_EffectStrip;
extern StructRNA RNA_Strip;

PointerRNA AddStrip_input_1_get(PointerRNA *ptr);

PointerRNA AddStrip_input_2_get(PointerRNA *ptr);

int AddStrip_input_count_get(PointerRNA *ptr);
void AddStrip_input_count_set(PointerRNA *ptr, int value);

/**************** Add-on ****************/

extern StructRNA RNA_Addon;

PointerRNA Addon_rna_type_get(PointerRNA *ptr);

#define Addon_module_MAX 128

void Addon_module_get(PointerRNA *ptr, char *value);
int Addon_module_length(PointerRNA *ptr);
void Addon_module_set(PointerRNA *ptr, const char *value);

PointerRNA Addon_preferences_get(PointerRNA *ptr);

/**************** Add-on Preferences ****************/

extern StructRNA RNA_AddonPreferences;

PointerRNA AddonPreferences_rna_type_get(PointerRNA *ptr);

#define AddonPreferences_bl_idname_MAX 128

void AddonPreferences_bl_idname_get(PointerRNA *ptr, char *value);
int AddonPreferences_bl_idname_length(PointerRNA *ptr);
void AddonPreferences_bl_idname_set(PointerRNA *ptr, const char *value);

/**************** User Add-ons ****************/

extern StructRNA RNA_Addons;

PointerRNA Addons_rna_type_get(PointerRNA *ptr);

struct bAddon *Addons_new_func(void);
void Addons_remove_func(ReportList *reports, struct PointerRNA *addon);
/**************** Adjustment Layer Strip ****************/

extern StructRNA RNA_AdjustmentStrip;
extern StructRNA RNA_EffectStrip;
extern StructRNA RNA_Strip;

int AdjustmentStrip_animation_offset_end_get(PointerRNA *ptr);
void AdjustmentStrip_animation_offset_end_set(PointerRNA *ptr, int value);

int AdjustmentStrip_animation_offset_start_get(PointerRNA *ptr);
void AdjustmentStrip_animation_offset_start_set(PointerRNA *ptr, int value);

int AdjustmentStrip_input_count_get(PointerRNA *ptr);
void AdjustmentStrip_input_count_set(PointerRNA *ptr, int value);

/**************** Alpha Over Strip ****************/

extern StructRNA RNA_AlphaOverStrip;
extern StructRNA RNA_EffectStrip;
extern StructRNA RNA_Strip;

PointerRNA AlphaOverStrip_input_1_get(PointerRNA *ptr);

PointerRNA AlphaOverStrip_input_2_get(PointerRNA *ptr);

int AlphaOverStrip_input_count_get(PointerRNA *ptr);
void AlphaOverStrip_input_count_set(PointerRNA *ptr, int value);

/**************** Alpha Under Strip ****************/

extern StructRNA RNA_AlphaUnderStrip;
extern StructRNA RNA_EffectStrip;
extern StructRNA RNA_Strip;

PointerRNA AlphaUnderStrip_input_1_get(PointerRNA *ptr);

PointerRNA AlphaUnderStrip_input_2_get(PointerRNA *ptr);

int AlphaUnderStrip_input_count_get(PointerRNA *ptr);
void AlphaUnderStrip_input_count_set(PointerRNA *ptr, int value);

/**************** Animation Data ****************/

extern StructRNA RNA_AnimData;

PointerRNA AnimData_rna_type_get(PointerRNA *ptr);

PointerRNA AnimData_action_get(PointerRNA *ptr);

enum {
	AnimData_action_blend_type_REPLACE = 0,
	AnimData_action_blend_type_COMBINE = 4,
	AnimData_action_blend_type_ADD = 1,
	AnimData_action_blend_type_SUBTRACT = 2,
	AnimData_action_blend_type_MULTIPLY = 3,
};

int AnimData_action_blend_type_get(PointerRNA *ptr);
void AnimData_action_blend_type_set(PointerRNA *ptr, int value);

enum {
	AnimData_action_extrapolation_NOTHING = 2,
	AnimData_action_extrapolation_HOLD = 0,
	AnimData_action_extrapolation_HOLD_FORWARD = 1,
};

int AnimData_action_extrapolation_get(PointerRNA *ptr);
void AnimData_action_extrapolation_set(PointerRNA *ptr, int value);

float AnimData_action_influence_get(PointerRNA *ptr);
void AnimData_action_influence_set(PointerRNA *ptr, float value);

PointerRNA AnimData_action_slot_get(PointerRNA *ptr);

int AnimData_action_slot_handle_get(PointerRNA *ptr);
void AnimData_action_slot_handle_set(PointerRNA *ptr, int value);

void AnimData_drivers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void AnimData_drivers_next(CollectionPropertyIterator *iter);
void AnimData_drivers_end(CollectionPropertyIterator *iter);
bool AnimData_drivers_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

#define AnimData_last_slot_identifier_MAX 66

void AnimData_last_slot_identifier_get(PointerRNA *ptr, char *value);
int AnimData_last_slot_identifier_length(PointerRNA *ptr);
void AnimData_last_slot_identifier_set(PointerRNA *ptr, const char *value);

bool AnimData_use_nla_get(PointerRNA *ptr);
void AnimData_use_nla_set(PointerRNA *ptr, bool value);

void AnimData_nla_tracks_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void AnimData_nla_tracks_next(CollectionPropertyIterator *iter);
void AnimData_nla_tracks_end(CollectionPropertyIterator *iter);
bool AnimData_nla_tracks_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool AnimData_nla_tracks_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool AnimData_use_pin_get(PointerRNA *ptr);
void AnimData_use_pin_set(PointerRNA *ptr, bool value);

void AnimData_action_suitable_slots_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void AnimData_action_suitable_slots_next(CollectionPropertyIterator *iter);
void AnimData_action_suitable_slots_end(CollectionPropertyIterator *iter);

PointerRNA AnimData_action_tweak_storage_get(PointerRNA *ptr);

bool AnimData_use_tweak_mode_get(PointerRNA *ptr);
void AnimData_use_tweak_mode_set(PointerRNA *ptr, bool value);

float AnimData_nla_tweak_strip_time_to_scene_func(struct AnimData *_self, float frame, bool invert);
void AnimData_fix_paths_rename_all_func(struct ID *_selfid, struct AnimData *_self, Main *bmain, const char * prefix, const char * old_name, const char * new_name);
/**************** Drivers ****************/

extern StructRNA RNA_AnimDataDrivers;

PointerRNA AnimDataDrivers_rna_type_get(PointerRNA *ptr);

struct FCurve *AnimDataDrivers_new_func(struct ID *_selfid, struct AnimData *_self, Main *bmain, ReportList *reports, const char * data_path, int index);
void AnimDataDrivers_remove_func(struct AnimData *_self, Main *bmain, ReportList *reports, struct FCurve *driver);
struct FCurve *AnimDataDrivers_from_existing_func(struct AnimData *_self, bContext *C, struct FCurve *src_driver);
struct FCurve *AnimDataDrivers_find_func(struct AnimData *_self, ReportList *reports, const char * data_path, int index);
/**************** Animation Visualization ****************/

extern StructRNA RNA_AnimViz;

PointerRNA AnimViz_rna_type_get(PointerRNA *ptr);

PointerRNA AnimViz_motion_path_get(PointerRNA *ptr);

/**************** Motion Path Settings ****************/

extern StructRNA RNA_AnimVizMotionPaths;

PointerRNA AnimVizMotionPaths_rna_type_get(PointerRNA *ptr);

int AnimVizMotionPaths_frame_after_get(PointerRNA *ptr);
void AnimVizMotionPaths_frame_after_set(PointerRNA *ptr, int value);

bool AnimVizMotionPaths_show_keyframe_action_all_get(PointerRNA *ptr);
void AnimVizMotionPaths_show_keyframe_action_all_set(PointerRNA *ptr, bool value);

enum {
	AnimVizMotionPaths_bake_location_HEADS = 2,
	AnimVizMotionPaths_bake_location_TAILS = 0,
};

int AnimVizMotionPaths_bake_location_get(PointerRNA *ptr);
void AnimVizMotionPaths_bake_location_set(PointerRNA *ptr, int value);

bool AnimVizMotionPaths_use_camera_space_bake_get(PointerRNA *ptr);
void AnimVizMotionPaths_use_camera_space_bake_set(PointerRNA *ptr, bool value);

int AnimVizMotionPaths_frame_before_get(PointerRNA *ptr);
void AnimVizMotionPaths_frame_before_set(PointerRNA *ptr, int value);

int AnimVizMotionPaths_frame_end_get(PointerRNA *ptr);
void AnimVizMotionPaths_frame_end_set(PointerRNA *ptr, int value);

int AnimVizMotionPaths_frame_step_get(PointerRNA *ptr);
void AnimVizMotionPaths_frame_step_set(PointerRNA *ptr, int value);

bool AnimVizMotionPaths_has_motion_paths_get(PointerRNA *ptr);
void AnimVizMotionPaths_has_motion_paths_set(PointerRNA *ptr, bool value);

bool AnimVizMotionPaths_show_keyframe_highlight_get(PointerRNA *ptr);
void AnimVizMotionPaths_show_keyframe_highlight_set(PointerRNA *ptr, bool value);

enum {
	AnimVizMotionPaths_range_KEYS_ALL = 2,
	AnimVizMotionPaths_range_KEYS_SELECTED = 1,
	AnimVizMotionPaths_range_SCENE = 0,
	AnimVizMotionPaths_range_MANUAL = 3,
};

int AnimVizMotionPaths_range_get(PointerRNA *ptr);
void AnimVizMotionPaths_range_set(PointerRNA *ptr, int value);

enum {
	AnimVizMotionPaths_type_CURRENT_FRAME = 1,
	AnimVizMotionPaths_type_RANGE = 0,
};

int AnimVizMotionPaths_type_get(PointerRNA *ptr);
void AnimVizMotionPaths_type_set(PointerRNA *ptr, int value);

bool AnimVizMotionPaths_show_frame_numbers_get(PointerRNA *ptr);
void AnimVizMotionPaths_show_frame_numbers_set(PointerRNA *ptr, bool value);

bool AnimVizMotionPaths_show_keyframe_numbers_get(PointerRNA *ptr);
void AnimVizMotionPaths_show_keyframe_numbers_set(PointerRNA *ptr, bool value);

int AnimVizMotionPaths_frame_start_get(PointerRNA *ptr);
void AnimVizMotionPaths_frame_start_set(PointerRNA *ptr, int value);

/**************** Any Type ****************/

extern StructRNA RNA_AnyType;

PointerRNA AnyType_rna_type_get(PointerRNA *ptr);

/**************** Area ****************/

extern StructRNA RNA_Area;

PointerRNA Area_rna_type_get(PointerRNA *ptr);

enum {
	Area_type_EMPTY = 0,
	Area_type_VIEW_3D = 1,
	Area_type_IMAGE_EDITOR = 6,
	Area_type_NODE_EDITOR = 16,
	Area_type_SEQUENCE_EDITOR = 8,
	Area_type_CLIP_EDITOR = 20,
	Area_type_DOPESHEET_EDITOR = 12,
	Area_type_GRAPH_EDITOR = 2,
	Area_type_NLA_EDITOR = 13,
	Area_type_TEXT_EDITOR = 9,
	Area_type_CONSOLE = 18,
	Area_type_INFO = 7,
	Area_type_TOPBAR = 21,
	Area_type_STATUSBAR = 22,
	Area_type_OUTLINER = 3,
	Area_type_PROPERTIES = 4,
	Area_type_FILE_BROWSER = 5,
	Area_type_SPREADSHEET = 23,
	Area_type_PREFERENCES = 19,
};

int Area_type_get(PointerRNA *ptr);
void Area_type_set(PointerRNA *ptr, int value);

int Area_ui_type_get(PointerRNA *ptr);
void Area_ui_type_set(PointerRNA *ptr, int value);

int Area_height_get(PointerRNA *ptr);
void Area_height_set(PointerRNA *ptr, int value);

void Area_regions_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Area_regions_next(CollectionPropertyIterator *iter);
void Area_regions_end(CollectionPropertyIterator *iter);
bool Area_regions_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool Area_show_menus_get(PointerRNA *ptr);
void Area_show_menus_set(PointerRNA *ptr, bool value);

void Area_spaces_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Area_spaces_next(CollectionPropertyIterator *iter);
void Area_spaces_end(CollectionPropertyIterator *iter);
bool Area_spaces_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

int Area_width_get(PointerRNA *ptr);
void Area_width_set(PointerRNA *ptr, int value);

int Area_x_get(PointerRNA *ptr);
void Area_x_set(PointerRNA *ptr, int value);

int Area_y_get(PointerRNA *ptr);
void Area_y_set(PointerRNA *ptr, int value);

void Area_tag_redraw_func(struct ScrArea *_self);
void Area_header_text_set_func(struct ScrArea *_self, const char * text);
/**************** Area Light ****************/

extern StructRNA RNA_AreaLight;
extern StructRNA RNA_Light;
extern StructRNA RNA_ID;

bool AreaLight_use_absolute_resolution_get(PointerRNA *ptr);
void AreaLight_use_absolute_resolution_set(PointerRNA *ptr, bool value);

float AreaLight_energy_get(PointerRNA *ptr);
void AreaLight_energy_set(PointerRNA *ptr, float value);

float AreaLight_shadow_buffer_clip_start_get(PointerRNA *ptr);
void AreaLight_shadow_buffer_clip_start_set(PointerRNA *ptr, float value);

float AreaLight_shadow_filter_radius_get(PointerRNA *ptr);
void AreaLight_shadow_filter_radius_set(PointerRNA *ptr, float value);

bool AreaLight_use_shadow_jitter_get(PointerRNA *ptr);
void AreaLight_use_shadow_jitter_set(PointerRNA *ptr, bool value);

float AreaLight_shadow_jitter_overblur_get(PointerRNA *ptr);
void AreaLight_shadow_jitter_overblur_set(PointerRNA *ptr, float value);

float AreaLight_shadow_soft_size_get(PointerRNA *ptr);
void AreaLight_shadow_soft_size_set(PointerRNA *ptr, float value);

float AreaLight_shadow_maximum_resolution_get(PointerRNA *ptr);
void AreaLight_shadow_maximum_resolution_set(PointerRNA *ptr, float value);

enum {
	AreaLight_shape_SQUARE = 0,
	AreaLight_shape_RECTANGLE = 1,
	AreaLight_shape_DISK = 4,
	AreaLight_shape_ELLIPSE = 5,
};

int AreaLight_shape_get(PointerRNA *ptr);
void AreaLight_shape_set(PointerRNA *ptr, int value);

float AreaLight_size_get(PointerRNA *ptr);
void AreaLight_size_set(PointerRNA *ptr, float value);

float AreaLight_size_y_get(PointerRNA *ptr);
void AreaLight_size_y_set(PointerRNA *ptr, float value);

float AreaLight_spread_get(PointerRNA *ptr);
void AreaLight_spread_set(PointerRNA *ptr, float value);

/**************** Area Spaces ****************/

extern StructRNA RNA_AreaSpaces;

PointerRNA AreaSpaces_rna_type_get(PointerRNA *ptr);

PointerRNA AreaSpaces_active_get(PointerRNA *ptr);

/**************** Armature ****************/

extern StructRNA RNA_Armature;
extern StructRNA RNA_ID;

PointerRNA Armature_animation_data_get(PointerRNA *ptr);

float Armature_axes_position_get(PointerRNA *ptr);
void Armature_axes_position_set(PointerRNA *ptr, float value);

void Armature_collections_all_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Armature_collections_all_next(CollectionPropertyIterator *iter);
void Armature_collections_all_end(CollectionPropertyIterator *iter);
int Armature_collections_all_length(PointerRNA *ptr);

void Armature_collections_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Armature_collections_next(CollectionPropertyIterator *iter);
void Armature_collections_end(CollectionPropertyIterator *iter);
int Armature_collections_length(PointerRNA *ptr);

void Armature_bones_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Armature_bones_next(CollectionPropertyIterator *iter);
void Armature_bones_end(CollectionPropertyIterator *iter);
bool Armature_bones_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool Armature_show_axes_get(PointerRNA *ptr);
void Armature_show_axes_set(PointerRNA *ptr, bool value);

bool Armature_show_bone_colors_get(PointerRNA *ptr);
void Armature_show_bone_colors_set(PointerRNA *ptr, bool value);

bool Armature_show_bone_custom_shapes_get(PointerRNA *ptr);
void Armature_show_bone_custom_shapes_set(PointerRNA *ptr, bool value);

bool Armature_show_names_get(PointerRNA *ptr);
void Armature_show_names_set(PointerRNA *ptr, bool value);

enum {
	Armature_display_type_OCTAHEDRAL = 0,
	Armature_display_type_STICK = 1,
	Armature_display_type_BBONE = 2,
	Armature_display_type_ENVELOPE = 3,
	Armature_display_type_WIRE = 4,
};

int Armature_display_type_get(PointerRNA *ptr);
void Armature_display_type_set(PointerRNA *ptr, int value);

void Armature_edit_bones_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Armature_edit_bones_next(CollectionPropertyIterator *iter);
void Armature_edit_bones_end(CollectionPropertyIterator *iter);
bool Armature_edit_bones_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Armature_edit_bones_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool Armature_is_editmode_get(PointerRNA *ptr);
void Armature_is_editmode_set(PointerRNA *ptr, bool value);

enum {
	Armature_pose_position_POSE = 0,
	Armature_pose_position_REST = 1,
};

int Armature_pose_position_get(PointerRNA *ptr);
void Armature_pose_position_set(PointerRNA *ptr, int value);

enum {
	Armature_relation_line_position_TAIL = 0,
	Armature_relation_line_position_HEAD = 1,
};

int Armature_relation_line_position_get(PointerRNA *ptr);
void Armature_relation_line_position_set(PointerRNA *ptr, int value);

bool Armature_use_mirror_x_get(PointerRNA *ptr);
void Armature_use_mirror_x_set(PointerRNA *ptr, bool value);

void Armature_transform_func(struct bArmature *_self, float matrix[16]);
/**************** Armature Bones ****************/

extern StructRNA RNA_ArmatureBones;

PointerRNA ArmatureBones_rna_type_get(PointerRNA *ptr);

PointerRNA ArmatureBones_active_get(PointerRNA *ptr);

/**************** Armature Constraint ****************/

extern StructRNA RNA_ArmatureConstraint;
extern StructRNA RNA_Constraint;

bool ArmatureConstraint_use_deform_preserve_volume_get(PointerRNA *ptr);
void ArmatureConstraint_use_deform_preserve_volume_set(PointerRNA *ptr, bool value);

void ArmatureConstraint_targets_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ArmatureConstraint_targets_next(CollectionPropertyIterator *iter);
void ArmatureConstraint_targets_end(CollectionPropertyIterator *iter);
bool ArmatureConstraint_targets_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool ArmatureConstraint_use_current_location_get(PointerRNA *ptr);
void ArmatureConstraint_use_current_location_set(PointerRNA *ptr, bool value);

bool ArmatureConstraint_use_bone_envelopes_get(PointerRNA *ptr);
void ArmatureConstraint_use_bone_envelopes_set(PointerRNA *ptr, bool value);

/**************** Armature Deform Constraint Targets ****************/

extern StructRNA RNA_ArmatureConstraintTargets;

PointerRNA ArmatureConstraintTargets_rna_type_get(PointerRNA *ptr);

struct bConstraintTarget *ArmatureConstraintTargets_new_func(struct ID *_selfid, struct bConstraint *_self, Main *bmain);
void ArmatureConstraintTargets_remove_func(struct ID *_selfid, struct bConstraint *_self, Main *bmain, ReportList *reports, struct PointerRNA *target);
void ArmatureConstraintTargets_clear_func(struct ID *_selfid, struct bConstraint *_self, Main *bmain);
/**************** Armature EditBones ****************/

extern StructRNA RNA_ArmatureEditBones;

PointerRNA ArmatureEditBones_rna_type_get(PointerRNA *ptr);

PointerRNA ArmatureEditBones_active_get(PointerRNA *ptr);

struct EditBone *ArmatureEditBones_new_func(struct bArmature *_self, ReportList *reports, const char * name);
void ArmatureEditBones_remove_func(struct bArmature *_self, ReportList *reports, struct PointerRNA *bone);
/**************** Armature Modifier ****************/

extern StructRNA RNA_ArmatureModifier;
extern StructRNA RNA_Modifier;

bool ArmatureModifier_invert_vertex_group_get(PointerRNA *ptr);
void ArmatureModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

bool ArmatureModifier_use_multi_modifier_get(PointerRNA *ptr);
void ArmatureModifier_use_multi_modifier_set(PointerRNA *ptr, bool value);

PointerRNA ArmatureModifier_object_get(PointerRNA *ptr);

bool ArmatureModifier_use_deform_preserve_volume_get(PointerRNA *ptr);
void ArmatureModifier_use_deform_preserve_volume_set(PointerRNA *ptr, bool value);

bool ArmatureModifier_use_bone_envelopes_get(PointerRNA *ptr);
void ArmatureModifier_use_bone_envelopes_set(PointerRNA *ptr, bool value);

bool ArmatureModifier_use_vertex_groups_get(PointerRNA *ptr);
void ArmatureModifier_use_vertex_groups_set(PointerRNA *ptr, bool value);

#define ArmatureModifier_vertex_group_MAX 64

void ArmatureModifier_vertex_group_get(PointerRNA *ptr, char *value);
int ArmatureModifier_vertex_group_length(PointerRNA *ptr);
void ArmatureModifier_vertex_group_set(PointerRNA *ptr, const char *value);

/**************** Array Modifier ****************/

extern StructRNA RNA_ArrayModifier;
extern StructRNA RNA_Modifier;

bool ArrayModifier_use_constant_offset_get(PointerRNA *ptr);
void ArrayModifier_use_constant_offset_set(PointerRNA *ptr, bool value);

void ArrayModifier_constant_offset_displace_get(PointerRNA *ptr, float values[3]);
void ArrayModifier_constant_offset_displace_set(PointerRNA *ptr, const float values[3]);

int ArrayModifier_count_get(PointerRNA *ptr);
void ArrayModifier_count_set(PointerRNA *ptr, int value);

PointerRNA ArrayModifier_curve_get(PointerRNA *ptr);

PointerRNA ArrayModifier_end_cap_get(PointerRNA *ptr);

enum {
	ArrayModifier_fit_type_FIXED_COUNT = 0,
	ArrayModifier_fit_type_FIT_LENGTH = 1,
	ArrayModifier_fit_type_FIT_CURVE = 2,
};

int ArrayModifier_fit_type_get(PointerRNA *ptr);
void ArrayModifier_fit_type_set(PointerRNA *ptr, int value);

float ArrayModifier_fit_length_get(PointerRNA *ptr);
void ArrayModifier_fit_length_set(PointerRNA *ptr, float value);

float ArrayModifier_merge_threshold_get(PointerRNA *ptr);
void ArrayModifier_merge_threshold_set(PointerRNA *ptr, float value);

bool ArrayModifier_use_merge_vertices_cap_get(PointerRNA *ptr);
void ArrayModifier_use_merge_vertices_cap_set(PointerRNA *ptr, bool value);

bool ArrayModifier_use_merge_vertices_get(PointerRNA *ptr);
void ArrayModifier_use_merge_vertices_set(PointerRNA *ptr, bool value);

bool ArrayModifier_use_object_offset_get(PointerRNA *ptr);
void ArrayModifier_use_object_offset_set(PointerRNA *ptr, bool value);

PointerRNA ArrayModifier_offset_object_get(PointerRNA *ptr);

bool ArrayModifier_use_relative_offset_get(PointerRNA *ptr);
void ArrayModifier_use_relative_offset_set(PointerRNA *ptr, bool value);

void ArrayModifier_relative_offset_displace_get(PointerRNA *ptr, float values[3]);
void ArrayModifier_relative_offset_displace_set(PointerRNA *ptr, const float values[3]);

PointerRNA ArrayModifier_start_cap_get(PointerRNA *ptr);

float ArrayModifier_offset_u_get(PointerRNA *ptr);
void ArrayModifier_offset_u_set(PointerRNA *ptr, float value);

float ArrayModifier_offset_v_get(PointerRNA *ptr);
void ArrayModifier_offset_v_set(PointerRNA *ptr, float value);

/**************** Catalog Path ****************/

extern StructRNA RNA_AssetCatalogPath;

PointerRNA AssetCatalogPath_rna_type_get(PointerRNA *ptr);

/**************** Asset Handle ****************/

extern StructRNA RNA_AssetHandle;
extern StructRNA RNA_PropertyGroup;

PointerRNA AssetHandle_file_data_get(PointerRNA *ptr);

/**************** User Asset Libraries ****************/

extern StructRNA RNA_AssetLibraryCollection;

PointerRNA AssetLibraryCollection_rna_type_get(PointerRNA *ptr);

struct bUserAssetLibrary *AssetLibraryCollection_new_func(bContext *C, const char * name, const char * directory);
void AssetLibraryCollection_remove_func(bContext *C, ReportList *reports, struct PointerRNA *library);
/**************** Asset Library Reference ****************/

extern StructRNA RNA_AssetLibraryReference;

PointerRNA AssetLibraryReference_rna_type_get(PointerRNA *ptr);

/**************** Asset Data ****************/

extern StructRNA RNA_AssetMetaData;

PointerRNA AssetMetaData_rna_type_get(PointerRNA *ptr);

int AssetMetaData_active_tag_get(PointerRNA *ptr);
void AssetMetaData_active_tag_set(PointerRNA *ptr, int value);

void AssetMetaData_author_get(PointerRNA *ptr, char *value);
int AssetMetaData_author_length(PointerRNA *ptr);
void AssetMetaData_author_set(PointerRNA *ptr, const char *value);

#define AssetMetaData_catalog_simple_name_MAX 64

void AssetMetaData_catalog_simple_name_get(PointerRNA *ptr, char *value);
int AssetMetaData_catalog_simple_name_length(PointerRNA *ptr);
void AssetMetaData_catalog_simple_name_set(PointerRNA *ptr, const char *value);

void AssetMetaData_catalog_id_get(PointerRNA *ptr, char *value);
int AssetMetaData_catalog_id_length(PointerRNA *ptr);
void AssetMetaData_catalog_id_set(PointerRNA *ptr, const char *value);

void AssetMetaData_copyright_get(PointerRNA *ptr, char *value);
int AssetMetaData_copyright_length(PointerRNA *ptr);
void AssetMetaData_copyright_set(PointerRNA *ptr, const char *value);

void AssetMetaData_description_get(PointerRNA *ptr, char *value);
int AssetMetaData_description_length(PointerRNA *ptr);
void AssetMetaData_description_set(PointerRNA *ptr, const char *value);

void AssetMetaData_license_get(PointerRNA *ptr, char *value);
int AssetMetaData_license_length(PointerRNA *ptr);
void AssetMetaData_license_set(PointerRNA *ptr, const char *value);

void AssetMetaData_tags_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void AssetMetaData_tags_next(CollectionPropertyIterator *iter);
void AssetMetaData_tags_end(CollectionPropertyIterator *iter);
bool AssetMetaData_tags_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool AssetMetaData_tags_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

/**************** Asset Representation ****************/

extern StructRNA RNA_AssetRepresentation;

PointerRNA AssetRepresentation_rna_type_get(PointerRNA *ptr);

void AssetRepresentation_name_get(PointerRNA *ptr, char *value);
int AssetRepresentation_name_length(PointerRNA *ptr);
void AssetRepresentation_name_set(PointerRNA *ptr, const char *value);

PointerRNA AssetRepresentation_local_id_get(PointerRNA *ptr);

PointerRNA AssetRepresentation_metadata_get(PointerRNA *ptr);

enum {
	AssetRepresentation_id_type_ACTION = 17217,
	AssetRepresentation_id_type_ARMATURE = 21057,
	AssetRepresentation_id_type_BRUSH = 21058,
	AssetRepresentation_id_type_CACHEFILE = 17987,
	AssetRepresentation_id_type_CAMERA = 16707,
	AssetRepresentation_id_type_COLLECTION = 21063,
	AssetRepresentation_id_type_CURVE = 21827,
	AssetRepresentation_id_type_CURVES = 22083,
	AssetRepresentation_id_type_FONT = 18006,
	AssetRepresentation_id_type_GREASEPENCIL = 17479,
	AssetRepresentation_id_type_GREASEPENCIL_V3 = 20551,
	AssetRepresentation_id_type_IMAGE = 19785,
	AssetRepresentation_id_type_KEY = 17739,
	AssetRepresentation_id_type_LATTICE = 21580,
	AssetRepresentation_id_type_LIBRARY = 18764,
	AssetRepresentation_id_type_LIGHT = 16716,
	AssetRepresentation_id_type_LIGHT_PROBE = 20556,
	AssetRepresentation_id_type_LINESTYLE = 21324,
	AssetRepresentation_id_type_MASK = 21325,
	AssetRepresentation_id_type_MATERIAL = 16717,
	AssetRepresentation_id_type_MESH = 17741,
	AssetRepresentation_id_type_META = 16973,
	AssetRepresentation_id_type_MOVIECLIP = 17229,
	AssetRepresentation_id_type_NODETREE = 21582,
	AssetRepresentation_id_type_OBJECT = 16975,
	AssetRepresentation_id_type_PAINTCURVE = 17232,
	AssetRepresentation_id_type_PALETTE = 19536,
	AssetRepresentation_id_type_PARTICLE = 16720,
	AssetRepresentation_id_type_POINTCLOUD = 21584,
	AssetRepresentation_id_type_SCENE = 17235,
	AssetRepresentation_id_type_SCREEN = 21075,
	AssetRepresentation_id_type_SOUND = 20307,
	AssetRepresentation_id_type_SPEAKER = 19283,
	AssetRepresentation_id_type_TEXT = 22612,
	AssetRepresentation_id_type_TEXTURE = 17748,
	AssetRepresentation_id_type_VOLUME = 20310,
	AssetRepresentation_id_type_WINDOWMANAGER = 19799,
	AssetRepresentation_id_type_WORKSPACE = 21335,
	AssetRepresentation_id_type_WORLD = 20311,
};

int AssetRepresentation_id_type_get(PointerRNA *ptr);
void AssetRepresentation_id_type_set(PointerRNA *ptr, int value);

void AssetRepresentation_full_library_path_get(PointerRNA *ptr, char *value);
int AssetRepresentation_full_library_path_length(PointerRNA *ptr);
void AssetRepresentation_full_library_path_set(PointerRNA *ptr, const char *value);

void AssetRepresentation_full_path_get(PointerRNA *ptr, char *value);
int AssetRepresentation_full_path_length(PointerRNA *ptr);
void AssetRepresentation_full_path_set(PointerRNA *ptr, const char *value);

/**************** Asset Shelf ****************/

extern StructRNA RNA_AssetShelf;

PointerRNA AssetShelf_rna_type_get(PointerRNA *ptr);

void AssetShelf_bl_activate_operator_get(PointerRNA *ptr, char *value);
int AssetShelf_bl_activate_operator_length(PointerRNA *ptr);
void AssetShelf_bl_activate_operator_set(PointerRNA *ptr, const char *value);

enum {
	AssetShelf_asset_library_reference_ALL = 2,
	AssetShelf_asset_library_reference_LOCAL = 1,
	AssetShelf_asset_library_reference_ESSENTIALS = 3,
	AssetShelf_asset_library_reference_CUSTOM = 100,
};

int AssetShelf_asset_library_reference_get(PointerRNA *ptr);
void AssetShelf_asset_library_reference_set(PointerRNA *ptr, int value);

int AssetShelf_bl_default_preview_size_get(PointerRNA *ptr);
void AssetShelf_bl_default_preview_size_set(PointerRNA *ptr, int value);

#define AssetShelf_search_filter_MAX 64

void AssetShelf_search_filter_get(PointerRNA *ptr, char *value);
int AssetShelf_search_filter_length(PointerRNA *ptr);
void AssetShelf_search_filter_set(PointerRNA *ptr, const char *value);

void AssetShelf_bl_idname_get(PointerRNA *ptr, char *value);
int AssetShelf_bl_idname_length(PointerRNA *ptr);
void AssetShelf_bl_idname_set(PointerRNA *ptr, const char *value);

enum {
	AssetShelf_bl_options_NO_ASSET_DRAG = 1,
	AssetShelf_bl_options_DEFAULT_VISIBLE = 2,
	AssetShelf_bl_options_STORE_ENABLED_CATALOGS_IN_PREFERENCES = 4,
};

int AssetShelf_bl_options_get(PointerRNA *ptr);
void AssetShelf_bl_options_set(PointerRNA *ptr, int value);

int AssetShelf_preview_size_get(PointerRNA *ptr);
void AssetShelf_preview_size_set(PointerRNA *ptr, int value);

bool AssetShelf_show_names_get(PointerRNA *ptr);
void AssetShelf_show_names_set(PointerRNA *ptr, bool value);

enum {
	AssetShelf_bl_space_type_EMPTY = 0,
	AssetShelf_bl_space_type_VIEW_3D = 1,
	AssetShelf_bl_space_type_IMAGE_EDITOR = 6,
	AssetShelf_bl_space_type_NODE_EDITOR = 16,
	AssetShelf_bl_space_type_SEQUENCE_EDITOR = 8,
	AssetShelf_bl_space_type_CLIP_EDITOR = 20,
	AssetShelf_bl_space_type_DOPESHEET_EDITOR = 12,
	AssetShelf_bl_space_type_GRAPH_EDITOR = 2,
	AssetShelf_bl_space_type_NLA_EDITOR = 13,
	AssetShelf_bl_space_type_TEXT_EDITOR = 9,
	AssetShelf_bl_space_type_CONSOLE = 18,
	AssetShelf_bl_space_type_INFO = 7,
	AssetShelf_bl_space_type_TOPBAR = 21,
	AssetShelf_bl_space_type_STATUSBAR = 22,
	AssetShelf_bl_space_type_OUTLINER = 3,
	AssetShelf_bl_space_type_PROPERTIES = 4,
	AssetShelf_bl_space_type_FILE_BROWSER = 5,
	AssetShelf_bl_space_type_SPREADSHEET = 23,
	AssetShelf_bl_space_type_PREFERENCES = 19,
};

int AssetShelf_bl_space_type_get(PointerRNA *ptr);
void AssetShelf_bl_space_type_set(PointerRNA *ptr, int value);

bool AssetShelf_poll_func(struct bContext *context);
bool AssetShelf_asset_poll_func(struct AssetRepresentation *asset);
struct AssetWeakReference *AssetShelf_get_active_asset_func(void);
void AssetShelf_draw_context_menu_func(struct bContext *context, struct AssetRepresentation *asset, struct uiLayout *layout);
/**************** Asset Tag ****************/

extern StructRNA RNA_AssetTag;

PointerRNA AssetTag_rna_type_get(PointerRNA *ptr);

#define AssetTag_name_MAX 64

void AssetTag_name_get(PointerRNA *ptr, char *value);
int AssetTag_name_length(PointerRNA *ptr);
void AssetTag_name_set(PointerRNA *ptr, const char *value);

/**************** Asset Tags ****************/

extern StructRNA RNA_AssetTags;

PointerRNA AssetTags_rna_type_get(PointerRNA *ptr);

struct AssetTag *AssetTags_new_func(struct ID *_selfid, struct AssetMetaData *_self, ReportList *reports, const char * name, bool skip_if_exists);
void AssetTags_remove_func(struct ID *_selfid, struct AssetMetaData *_self, ReportList *reports, struct PointerRNA *tag);
/**************** Asset Weak Reference ****************/

extern StructRNA RNA_AssetWeakReference;

PointerRNA AssetWeakReference_rna_type_get(PointerRNA *ptr);

void AssetWeakReference_asset_library_identifier_get(PointerRNA *ptr, char *value);
int AssetWeakReference_asset_library_identifier_length(PointerRNA *ptr);
void AssetWeakReference_asset_library_identifier_set(PointerRNA *ptr, const char *value);

enum {
	AssetWeakReference_asset_library_type_ALL = 2,
	AssetWeakReference_asset_library_type_LOCAL = 1,
	AssetWeakReference_asset_library_type_ESSENTIALS = 3,
	AssetWeakReference_asset_library_type_CUSTOM = 100,
};

int AssetWeakReference_asset_library_type_get(PointerRNA *ptr);
void AssetWeakReference_asset_library_type_set(PointerRNA *ptr, int value);

void AssetWeakReference_relative_asset_identifier_get(PointerRNA *ptr, char *value);
int AssetWeakReference_relative_asset_identifier_length(PointerRNA *ptr);
void AssetWeakReference_relative_asset_identifier_set(PointerRNA *ptr, const char *value);

/**************** Attribute ****************/

extern StructRNA RNA_Attribute;

PointerRNA Attribute_rna_type_get(PointerRNA *ptr);

#define Attribute_name_MAX 68

void Attribute_name_get(PointerRNA *ptr, char *value);
int Attribute_name_length(PointerRNA *ptr);
void Attribute_name_set(PointerRNA *ptr, const char *value);

enum {
	Attribute_data_type_FLOAT = 10,
	Attribute_data_type_INT = 11,
	Attribute_data_type_FLOAT_VECTOR = 48,
	Attribute_data_type_FLOAT_COLOR = 47,
	Attribute_data_type_BYTE_COLOR = 17,
	Attribute_data_type_STRING = 12,
	Attribute_data_type_BOOLEAN = 50,
	Attribute_data_type_FLOAT2 = 49,
	Attribute_data_type_INT8 = 45,
	Attribute_data_type_INT16_2D = 22,
	Attribute_data_type_INT32_2D = 46,
	Attribute_data_type_QUATERNION = 52,
	Attribute_data_type_FLOAT4X4 = 20,
};

int Attribute_data_type_get(PointerRNA *ptr);
void Attribute_data_type_set(PointerRNA *ptr, int value);

enum {
	Attribute_domain_POINT = 0,
	Attribute_domain_EDGE = 1,
	Attribute_domain_FACE = 2,
	Attribute_domain_CORNER = 3,
	Attribute_domain_CURVE = 4,
	Attribute_domain_INSTANCE = 5,
	Attribute_domain_LAYER = 6,
};

int Attribute_domain_get(PointerRNA *ptr);
void Attribute_domain_set(PointerRNA *ptr, int value);

bool Attribute_is_internal_get(PointerRNA *ptr);
void Attribute_is_internal_set(PointerRNA *ptr, bool value);

bool Attribute_is_required_get(PointerRNA *ptr);
void Attribute_is_required_set(PointerRNA *ptr, bool value);

/**************** Attribute Group ****************/

extern StructRNA RNA_AttributeGroupCurves;

PointerRNA AttributeGroupCurves_rna_type_get(PointerRNA *ptr);

PointerRNA AttributeGroupCurves_active_get(PointerRNA *ptr);

int AttributeGroupCurves_active_index_get(PointerRNA *ptr);
void AttributeGroupCurves_active_index_set(PointerRNA *ptr, int value);

struct PointerRNA AttributeGroupCurves_new_func(struct ID *_self, ReportList *reports, const char * name, int type, int domain);
void AttributeGroupCurves_remove_func(struct ID *_self, ReportList *reports, struct PointerRNA *attribute);
int AttributeGroupCurves_domain_size_func(struct ID *_self, int domain);
/**************** Attribute Group ****************/

extern StructRNA RNA_AttributeGroupGreasePencil;

PointerRNA AttributeGroupGreasePencil_rna_type_get(PointerRNA *ptr);

PointerRNA AttributeGroupGreasePencil_active_get(PointerRNA *ptr);

int AttributeGroupGreasePencil_active_index_get(PointerRNA *ptr);
void AttributeGroupGreasePencil_active_index_set(PointerRNA *ptr, int value);

struct PointerRNA AttributeGroupGreasePencil_new_func(struct ID *_self, ReportList *reports, const char * name, int type, int domain);
void AttributeGroupGreasePencil_remove_func(struct ID *_self, ReportList *reports, struct PointerRNA *attribute);
int AttributeGroupGreasePencil_domain_size_func(struct ID *_self, int domain);
/**************** Attribute Group ****************/

extern StructRNA RNA_AttributeGroupGreasePencilDrawing;

PointerRNA AttributeGroupGreasePencilDrawing_rna_type_get(PointerRNA *ptr);

PointerRNA AttributeGroupGreasePencilDrawing_active_get(PointerRNA *ptr);

int AttributeGroupGreasePencilDrawing_active_index_get(PointerRNA *ptr);
void AttributeGroupGreasePencilDrawing_active_index_set(PointerRNA *ptr, int value);

struct PointerRNA AttributeGroupGreasePencilDrawing_new_func(struct ID *_selfid, struct GreasePencilDrawing *_self, ReportList *reports, const char * name, int type, int domain);
void AttributeGroupGreasePencilDrawing_remove_func(struct ID *_selfid, struct GreasePencilDrawing *_self, ReportList *reports, struct PointerRNA *attribute);
int AttributeGroupGreasePencilDrawing_domain_size_func(struct GreasePencilDrawing *_self, int domain);
/**************** Attribute Group ****************/

extern StructRNA RNA_AttributeGroupMesh;

PointerRNA AttributeGroupMesh_rna_type_get(PointerRNA *ptr);

PointerRNA AttributeGroupMesh_active_get(PointerRNA *ptr);

int AttributeGroupMesh_active_index_get(PointerRNA *ptr);
void AttributeGroupMesh_active_index_set(PointerRNA *ptr, int value);

PointerRNA AttributeGroupMesh_active_color_get(PointerRNA *ptr);

#define AttributeGroupMesh_active_color_name_MAX 64

void AttributeGroupMesh_active_color_name_get(PointerRNA *ptr, char *value);
int AttributeGroupMesh_active_color_name_length(PointerRNA *ptr);
void AttributeGroupMesh_active_color_name_set(PointerRNA *ptr, const char *value);

int AttributeGroupMesh_active_color_index_get(PointerRNA *ptr);
void AttributeGroupMesh_active_color_index_set(PointerRNA *ptr, int value);

int AttributeGroupMesh_render_color_index_get(PointerRNA *ptr);
void AttributeGroupMesh_render_color_index_set(PointerRNA *ptr, int value);

#define AttributeGroupMesh_default_color_name_MAX 64

void AttributeGroupMesh_default_color_name_get(PointerRNA *ptr, char *value);
int AttributeGroupMesh_default_color_name_length(PointerRNA *ptr);
void AttributeGroupMesh_default_color_name_set(PointerRNA *ptr, const char *value);

struct PointerRNA AttributeGroupMesh_new_func(struct ID *_self, ReportList *reports, const char * name, int type, int domain);
void AttributeGroupMesh_remove_func(struct ID *_self, ReportList *reports, struct PointerRNA *attribute);
int AttributeGroupMesh_domain_size_func(struct ID *_self, int domain);
/**************** Attribute Group ****************/

extern StructRNA RNA_AttributeGroupPointCloud;

PointerRNA AttributeGroupPointCloud_rna_type_get(PointerRNA *ptr);

PointerRNA AttributeGroupPointCloud_active_get(PointerRNA *ptr);

int AttributeGroupPointCloud_active_index_get(PointerRNA *ptr);
void AttributeGroupPointCloud_active_index_set(PointerRNA *ptr, int value);

struct PointerRNA AttributeGroupPointCloud_new_func(struct ID *_self, ReportList *reports, const char * name, int type, int domain);
void AttributeGroupPointCloud_remove_func(struct ID *_self, ReportList *reports, struct PointerRNA *attribute);
int AttributeGroupPointCloud_domain_size_func(struct ID *_self, int domain);
/**************** Bake Data ****************/

extern StructRNA RNA_BakeSettings;

PointerRNA BakeSettings_rna_type_get(PointerRNA *ptr);

bool BakeSettings_use_automatic_name_get(PointerRNA *ptr);
void BakeSettings_use_automatic_name_set(PointerRNA *ptr, bool value);

bool BakeSettings_use_cage_get(PointerRNA *ptr);
void BakeSettings_use_cage_set(PointerRNA *ptr, bool value);

float BakeSettings_cage_extrusion_get(PointerRNA *ptr);
void BakeSettings_cage_extrusion_set(PointerRNA *ptr, float value);

PointerRNA BakeSettings_cage_object_get(PointerRNA *ptr);

bool BakeSettings_use_clear_get(PointerRNA *ptr);
void BakeSettings_use_clear_set(PointerRNA *ptr, bool value);

bool BakeSettings_use_pass_color_get(PointerRNA *ptr);
void BakeSettings_use_pass_color_set(PointerRNA *ptr, bool value);

bool BakeSettings_use_pass_diffuse_get(PointerRNA *ptr);
void BakeSettings_use_pass_diffuse_set(PointerRNA *ptr, bool value);

bool BakeSettings_use_pass_direct_get(PointerRNA *ptr);
void BakeSettings_use_pass_direct_set(PointerRNA *ptr, bool value);

bool BakeSettings_use_pass_emit_get(PointerRNA *ptr);
void BakeSettings_use_pass_emit_set(PointerRNA *ptr, bool value);

#define BakeSettings_filepath_MAX 1024

void BakeSettings_filepath_get(PointerRNA *ptr, char *value);
int BakeSettings_filepath_length(PointerRNA *ptr);
void BakeSettings_filepath_set(PointerRNA *ptr, const char *value);

bool BakeSettings_use_pass_glossy_get(PointerRNA *ptr);
void BakeSettings_use_pass_glossy_set(PointerRNA *ptr, bool value);

int BakeSettings_height_get(PointerRNA *ptr);
void BakeSettings_height_set(PointerRNA *ptr, int value);

PointerRNA BakeSettings_image_settings_get(PointerRNA *ptr);

bool BakeSettings_use_pass_indirect_get(PointerRNA *ptr);
void BakeSettings_use_pass_indirect_set(PointerRNA *ptr, bool value);

int BakeSettings_margin_get(PointerRNA *ptr);
void BakeSettings_margin_set(PointerRNA *ptr, int value);

enum {
	BakeSettings_margin_type_ADJACENT_FACES = 0,
	BakeSettings_margin_type_EXTEND = 1,
};

int BakeSettings_margin_type_get(PointerRNA *ptr);
void BakeSettings_margin_type_set(PointerRNA *ptr, int value);

float BakeSettings_max_ray_distance_get(PointerRNA *ptr);
void BakeSettings_max_ray_distance_set(PointerRNA *ptr, float value);

enum {
	BakeSettings_normal_space_OBJECT = 2,
	BakeSettings_normal_space_TANGENT = 3,
};

int BakeSettings_normal_space_get(PointerRNA *ptr);
void BakeSettings_normal_space_set(PointerRNA *ptr, int value);

enum {
	BakeSettings_normal_r_POS_X = 0,
	BakeSettings_normal_r_POS_Y = 1,
	BakeSettings_normal_r_POS_Z = 2,
	BakeSettings_normal_r_NEG_X = 3,
	BakeSettings_normal_r_NEG_Y = 4,
	BakeSettings_normal_r_NEG_Z = 5,
};

int BakeSettings_normal_r_get(PointerRNA *ptr);
void BakeSettings_normal_r_set(PointerRNA *ptr, int value);

enum {
	BakeSettings_normal_g_POS_X = 0,
	BakeSettings_normal_g_POS_Y = 1,
	BakeSettings_normal_g_POS_Z = 2,
	BakeSettings_normal_g_NEG_X = 3,
	BakeSettings_normal_g_NEG_Y = 4,
	BakeSettings_normal_g_NEG_Z = 5,
};

int BakeSettings_normal_g_get(PointerRNA *ptr);
void BakeSettings_normal_g_set(PointerRNA *ptr, int value);

enum {
	BakeSettings_normal_b_POS_X = 0,
	BakeSettings_normal_b_POS_Y = 1,
	BakeSettings_normal_b_POS_Z = 2,
	BakeSettings_normal_b_NEG_X = 3,
	BakeSettings_normal_b_NEG_Y = 4,
	BakeSettings_normal_b_NEG_Z = 5,
};

int BakeSettings_normal_b_get(PointerRNA *ptr);
void BakeSettings_normal_b_set(PointerRNA *ptr, int value);

enum {
	BakeSettings_pass_filter_NONE = 0,
	BakeSettings_pass_filter_EMIT = 2,
	BakeSettings_pass_filter_DIRECT = 64,
	BakeSettings_pass_filter_INDIRECT = 128,
	BakeSettings_pass_filter_COLOR = 256,
	BakeSettings_pass_filter_DIFFUSE = 4,
	BakeSettings_pass_filter_GLOSSY = 8,
	BakeSettings_pass_filter_TRANSMISSION = 16,
};

int BakeSettings_pass_filter_get(PointerRNA *ptr);
void BakeSettings_pass_filter_set(PointerRNA *ptr, int value);

enum {
	BakeSettings_save_mode_INTERNAL = 0,
	BakeSettings_save_mode_EXTERNAL = 1,
};

int BakeSettings_save_mode_get(PointerRNA *ptr);
void BakeSettings_save_mode_set(PointerRNA *ptr, int value);

bool BakeSettings_use_selected_to_active_get(PointerRNA *ptr);
void BakeSettings_use_selected_to_active_set(PointerRNA *ptr, bool value);

bool BakeSettings_use_split_materials_get(PointerRNA *ptr);
void BakeSettings_use_split_materials_set(PointerRNA *ptr, bool value);

enum {
	BakeSettings_target_IMAGE_TEXTURES = 0,
	BakeSettings_target_VERTEX_COLORS = 1,
};

int BakeSettings_target_get(PointerRNA *ptr);
void BakeSettings_target_set(PointerRNA *ptr, int value);

bool BakeSettings_use_pass_transmission_get(PointerRNA *ptr);
void BakeSettings_use_pass_transmission_set(PointerRNA *ptr, bool value);

enum {
	BakeSettings_view_from_ABOVE_SURFACE = 0,
	BakeSettings_view_from_ACTIVE_CAMERA = 1,
};

int BakeSettings_view_from_get(PointerRNA *ptr);
void BakeSettings_view_from_set(PointerRNA *ptr, int value);

int BakeSettings_width_get(PointerRNA *ptr);
void BakeSettings_width_set(PointerRNA *ptr, int value);

/**************** Bevel Modifier ****************/

extern StructRNA RNA_BevelModifier;
extern StructRNA RNA_Modifier;

enum {
	BevelModifier_affect_VERTICES = 0,
	BevelModifier_affect_EDGES = 1,
};

int BevelModifier_affect_get(PointerRNA *ptr);
void BevelModifier_affect_set(PointerRNA *ptr, int value);

float BevelModifier_angle_limit_get(PointerRNA *ptr);
void BevelModifier_angle_limit_set(PointerRNA *ptr, float value);

bool BevelModifier_use_clamp_overlap_get(PointerRNA *ptr);
void BevelModifier_use_clamp_overlap_set(PointerRNA *ptr, bool value);

PointerRNA BevelModifier_custom_profile_get(PointerRNA *ptr);

#define BevelModifier_edge_weight_MAX 64

void BevelModifier_edge_weight_get(PointerRNA *ptr, char *value);
int BevelModifier_edge_weight_length(PointerRNA *ptr);
void BevelModifier_edge_weight_set(PointerRNA *ptr, const char *value);

enum {
	BevelModifier_face_strength_mode_FSTR_NONE = 0,
	BevelModifier_face_strength_mode_FSTR_NEW = 1,
	BevelModifier_face_strength_mode_FSTR_AFFECTED = 2,
	BevelModifier_face_strength_mode_FSTR_ALL = 3,
};

int BevelModifier_face_strength_mode_get(PointerRNA *ptr);
void BevelModifier_face_strength_mode_set(PointerRNA *ptr, int value);

bool BevelModifier_harden_normals_get(PointerRNA *ptr);
void BevelModifier_harden_normals_set(PointerRNA *ptr, bool value);

enum {
	BevelModifier_miter_inner_MITER_SHARP = 0,
	BevelModifier_miter_inner_MITER_ARC = 2,
};

int BevelModifier_miter_inner_get(PointerRNA *ptr);
void BevelModifier_miter_inner_set(PointerRNA *ptr, int value);

bool BevelModifier_invert_vertex_group_get(PointerRNA *ptr);
void BevelModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

enum {
	BevelModifier_limit_method_NONE = 0,
	BevelModifier_limit_method_ANGLE = 8,
	BevelModifier_limit_method_WEIGHT = 16,
	BevelModifier_limit_method_VGROUP = 32,
};

int BevelModifier_limit_method_get(PointerRNA *ptr);
void BevelModifier_limit_method_set(PointerRNA *ptr, int value);

bool BevelModifier_loop_slide_get(PointerRNA *ptr);
void BevelModifier_loop_slide_set(PointerRNA *ptr, bool value);

bool BevelModifier_mark_seam_get(PointerRNA *ptr);
void BevelModifier_mark_seam_set(PointerRNA *ptr, bool value);

bool BevelModifier_mark_sharp_get(PointerRNA *ptr);
void BevelModifier_mark_sharp_set(PointerRNA *ptr, bool value);

int BevelModifier_material_get(PointerRNA *ptr);
void BevelModifier_material_set(PointerRNA *ptr, int value);

enum {
	BevelModifier_miter_outer_MITER_SHARP = 0,
	BevelModifier_miter_outer_MITER_PATCH = 1,
	BevelModifier_miter_outer_MITER_ARC = 2,
};

int BevelModifier_miter_outer_get(PointerRNA *ptr);
void BevelModifier_miter_outer_set(PointerRNA *ptr, int value);

float BevelModifier_profile_get(PointerRNA *ptr);
void BevelModifier_profile_set(PointerRNA *ptr, float value);

enum {
	BevelModifier_profile_type_SUPERELLIPSE = 0,
	BevelModifier_profile_type_CUSTOM = 1,
};

int BevelModifier_profile_type_get(PointerRNA *ptr);
void BevelModifier_profile_type_set(PointerRNA *ptr, int value);

int BevelModifier_segments_get(PointerRNA *ptr);
void BevelModifier_segments_set(PointerRNA *ptr, int value);

float BevelModifier_spread_get(PointerRNA *ptr);
void BevelModifier_spread_set(PointerRNA *ptr, float value);

#define BevelModifier_vertex_group_MAX 64

void BevelModifier_vertex_group_get(PointerRNA *ptr, char *value);
int BevelModifier_vertex_group_length(PointerRNA *ptr);
void BevelModifier_vertex_group_set(PointerRNA *ptr, const char *value);

enum {
	BevelModifier_vmesh_method_ADJ = 0,
	BevelModifier_vmesh_method_CUTOFF = 1,
};

int BevelModifier_vmesh_method_get(PointerRNA *ptr);
void BevelModifier_vmesh_method_set(PointerRNA *ptr, int value);

#define BevelModifier_vertex_weight_MAX 64

void BevelModifier_vertex_weight_get(PointerRNA *ptr, char *value);
int BevelModifier_vertex_weight_length(PointerRNA *ptr);
void BevelModifier_vertex_weight_set(PointerRNA *ptr, const char *value);

float BevelModifier_width_get(PointerRNA *ptr);
void BevelModifier_width_set(PointerRNA *ptr, float value);

float BevelModifier_width_pct_get(PointerRNA *ptr);
void BevelModifier_width_pct_set(PointerRNA *ptr, float value);

enum {
	BevelModifier_offset_type_OFFSET = 0,
	BevelModifier_offset_type_WIDTH = 1,
	BevelModifier_offset_type_DEPTH = 2,
	BevelModifier_offset_type_PERCENT = 3,
	BevelModifier_offset_type_ABSOLUTE = 4,
};

int BevelModifier_offset_type_get(PointerRNA *ptr);
void BevelModifier_offset_type_set(PointerRNA *ptr, int value);

/**************** Bézier Curve Point ****************/

extern StructRNA RNA_BezierSplinePoint;

PointerRNA BezierSplinePoint_rna_type_get(PointerRNA *ptr);

float BezierSplinePoint_radius_get(PointerRNA *ptr);
void BezierSplinePoint_radius_set(PointerRNA *ptr, float value);

void BezierSplinePoint_co_get(PointerRNA *ptr, float values[3]);
void BezierSplinePoint_co_set(PointerRNA *ptr, const float values[3]);

bool BezierSplinePoint_select_control_point_get(PointerRNA *ptr);
void BezierSplinePoint_select_control_point_set(PointerRNA *ptr, bool value);

void BezierSplinePoint_handle_left_get(PointerRNA *ptr, float values[3]);
void BezierSplinePoint_handle_left_set(PointerRNA *ptr, const float values[3]);

enum {
	BezierSplinePoint_handle_left_type_FREE = 0,
	BezierSplinePoint_handle_left_type_VECTOR = 2,
	BezierSplinePoint_handle_left_type_ALIGNED = 3,
	BezierSplinePoint_handle_left_type_AUTO = 1,
};

int BezierSplinePoint_handle_left_type_get(PointerRNA *ptr);
void BezierSplinePoint_handle_left_type_set(PointerRNA *ptr, int value);

bool BezierSplinePoint_select_left_handle_get(PointerRNA *ptr);
void BezierSplinePoint_select_left_handle_set(PointerRNA *ptr, bool value);

void BezierSplinePoint_handle_right_get(PointerRNA *ptr, float values[3]);
void BezierSplinePoint_handle_right_set(PointerRNA *ptr, const float values[3]);

enum {
	BezierSplinePoint_handle_right_type_FREE = 0,
	BezierSplinePoint_handle_right_type_VECTOR = 2,
	BezierSplinePoint_handle_right_type_ALIGNED = 3,
	BezierSplinePoint_handle_right_type_AUTO = 1,
};

int BezierSplinePoint_handle_right_type_get(PointerRNA *ptr);
void BezierSplinePoint_handle_right_type_set(PointerRNA *ptr, int value);

bool BezierSplinePoint_select_right_handle_get(PointerRNA *ptr);
void BezierSplinePoint_select_right_handle_set(PointerRNA *ptr, bool value);

bool BezierSplinePoint_hide_get(PointerRNA *ptr);
void BezierSplinePoint_hide_set(PointerRNA *ptr, bool value);

float BezierSplinePoint_tilt_get(PointerRNA *ptr);
void BezierSplinePoint_tilt_set(PointerRNA *ptr, float value);

float BezierSplinePoint_weight_softbody_get(PointerRNA *ptr);
void BezierSplinePoint_weight_softbody_set(PointerRNA *ptr, float value);

/**************** Blend-File Data ****************/

extern StructRNA RNA_BlendData;

PointerRNA BlendData_rna_type_get(PointerRNA *ptr);

void BlendData_actions_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_actions_next(CollectionPropertyIterator *iter);
void BlendData_actions_end(CollectionPropertyIterator *iter);

void BlendData_grease_pencils_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_grease_pencils_next(CollectionPropertyIterator *iter);
void BlendData_grease_pencils_end(CollectionPropertyIterator *iter);

void BlendData_armatures_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_armatures_next(CollectionPropertyIterator *iter);
void BlendData_armatures_end(CollectionPropertyIterator *iter);

void BlendData_brushes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_brushes_next(CollectionPropertyIterator *iter);
void BlendData_brushes_end(CollectionPropertyIterator *iter);

void BlendData_cache_files_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_cache_files_next(CollectionPropertyIterator *iter);
void BlendData_cache_files_end(CollectionPropertyIterator *iter);

void BlendData_cameras_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_cameras_next(CollectionPropertyIterator *iter);
void BlendData_cameras_end(CollectionPropertyIterator *iter);

void BlendData_collections_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_collections_next(CollectionPropertyIterator *iter);
void BlendData_collections_end(CollectionPropertyIterator *iter);

void BlendData_curves_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_curves_next(CollectionPropertyIterator *iter);
void BlendData_curves_end(CollectionPropertyIterator *iter);

bool BlendData_is_dirty_get(PointerRNA *ptr);
void BlendData_is_dirty_set(PointerRNA *ptr, bool value);

bool BlendData_is_saved_get(PointerRNA *ptr);
void BlendData_is_saved_set(PointerRNA *ptr, bool value);

#define BlendData_filepath_MAX 1024

void BlendData_filepath_get(PointerRNA *ptr, char *value);
int BlendData_filepath_length(PointerRNA *ptr);
void BlendData_filepath_set(PointerRNA *ptr, const char *value);

void BlendData_grease_pencils_v3_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_grease_pencils_v3_next(CollectionPropertyIterator *iter);
void BlendData_grease_pencils_v3_end(CollectionPropertyIterator *iter);

void BlendData_hair_curves_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_hair_curves_next(CollectionPropertyIterator *iter);
void BlendData_hair_curves_end(CollectionPropertyIterator *iter);

void BlendData_images_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_images_next(CollectionPropertyIterator *iter);
void BlendData_images_end(CollectionPropertyIterator *iter);

void BlendData_lattices_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_lattices_next(CollectionPropertyIterator *iter);
void BlendData_lattices_end(CollectionPropertyIterator *iter);

void BlendData_libraries_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_libraries_next(CollectionPropertyIterator *iter);
void BlendData_libraries_end(CollectionPropertyIterator *iter);

void BlendData_lightprobes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_lightprobes_next(CollectionPropertyIterator *iter);
void BlendData_lightprobes_end(CollectionPropertyIterator *iter);

void BlendData_lights_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_lights_next(CollectionPropertyIterator *iter);
void BlendData_lights_end(CollectionPropertyIterator *iter);

void BlendData_linestyles_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_linestyles_next(CollectionPropertyIterator *iter);
void BlendData_linestyles_end(CollectionPropertyIterator *iter);

void BlendData_masks_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_masks_next(CollectionPropertyIterator *iter);
void BlendData_masks_end(CollectionPropertyIterator *iter);

void BlendData_materials_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_materials_next(CollectionPropertyIterator *iter);
void BlendData_materials_end(CollectionPropertyIterator *iter);

void BlendData_meshes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_meshes_next(CollectionPropertyIterator *iter);
void BlendData_meshes_end(CollectionPropertyIterator *iter);

void BlendData_metaballs_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_metaballs_next(CollectionPropertyIterator *iter);
void BlendData_metaballs_end(CollectionPropertyIterator *iter);

void BlendData_movieclips_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_movieclips_next(CollectionPropertyIterator *iter);
void BlendData_movieclips_end(CollectionPropertyIterator *iter);

void BlendData_node_groups_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_node_groups_next(CollectionPropertyIterator *iter);
void BlendData_node_groups_end(CollectionPropertyIterator *iter);

void BlendData_objects_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_objects_next(CollectionPropertyIterator *iter);
void BlendData_objects_end(CollectionPropertyIterator *iter);

void BlendData_paint_curves_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_paint_curves_next(CollectionPropertyIterator *iter);
void BlendData_paint_curves_end(CollectionPropertyIterator *iter);

void BlendData_palettes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_palettes_next(CollectionPropertyIterator *iter);
void BlendData_palettes_end(CollectionPropertyIterator *iter);

void BlendData_particles_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_particles_next(CollectionPropertyIterator *iter);
void BlendData_particles_end(CollectionPropertyIterator *iter);

void BlendData_pointclouds_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_pointclouds_next(CollectionPropertyIterator *iter);
void BlendData_pointclouds_end(CollectionPropertyIterator *iter);

void BlendData_scenes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_scenes_next(CollectionPropertyIterator *iter);
void BlendData_scenes_end(CollectionPropertyIterator *iter);

void BlendData_screens_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_screens_next(CollectionPropertyIterator *iter);
void BlendData_screens_end(CollectionPropertyIterator *iter);

void BlendData_shape_keys_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_shape_keys_next(CollectionPropertyIterator *iter);
void BlendData_shape_keys_end(CollectionPropertyIterator *iter);

void BlendData_sounds_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_sounds_next(CollectionPropertyIterator *iter);
void BlendData_sounds_end(CollectionPropertyIterator *iter);

void BlendData_speakers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_speakers_next(CollectionPropertyIterator *iter);
void BlendData_speakers_end(CollectionPropertyIterator *iter);

void BlendData_texts_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_texts_next(CollectionPropertyIterator *iter);
void BlendData_texts_end(CollectionPropertyIterator *iter);

void BlendData_textures_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_textures_next(CollectionPropertyIterator *iter);
void BlendData_textures_end(CollectionPropertyIterator *iter);

bool BlendData_use_autopack_get(PointerRNA *ptr);
void BlendData_use_autopack_set(PointerRNA *ptr, bool value);

void BlendData_fonts_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_fonts_next(CollectionPropertyIterator *iter);
void BlendData_fonts_end(CollectionPropertyIterator *iter);

void BlendData_version_get(PointerRNA *ptr, int values[3]);
void BlendData_version_set(PointerRNA *ptr, const int values[3]);

void BlendData_volumes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_volumes_next(CollectionPropertyIterator *iter);
void BlendData_volumes_end(CollectionPropertyIterator *iter);

void BlendData_window_managers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_window_managers_next(CollectionPropertyIterator *iter);
void BlendData_window_managers_end(CollectionPropertyIterator *iter);

void BlendData_workspaces_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_workspaces_next(CollectionPropertyIterator *iter);
void BlendData_workspaces_end(CollectionPropertyIterator *iter);

void BlendData_worlds_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendData_worlds_next(CollectionPropertyIterator *iter);
void BlendData_worlds_end(CollectionPropertyIterator *iter);

/**************** Main Actions ****************/

extern StructRNA RNA_BlendDataActions;

PointerRNA BlendDataActions_rna_type_get(PointerRNA *ptr);

struct bAction *BlendDataActions_new_func(struct Main *_self, const char * name);
void BlendDataActions_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *action, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataActions_tag_func(struct Main *_self, bool value);
/**************** Main Armatures ****************/

extern StructRNA RNA_BlendDataArmatures;

PointerRNA BlendDataArmatures_rna_type_get(PointerRNA *ptr);

struct bArmature *BlendDataArmatures_new_func(struct Main *_self, const char * name);
void BlendDataArmatures_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *armature, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataArmatures_tag_func(struct Main *_self, bool value);
/**************** Main Brushes ****************/

extern StructRNA RNA_BlendDataBrushes;

PointerRNA BlendDataBrushes_rna_type_get(PointerRNA *ptr);

struct Brush *BlendDataBrushes_new_func(struct Main *_self, const char * name, int mode);
void BlendDataBrushes_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *brush, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataBrushes_tag_func(struct Main *_self, bool value);
void BlendDataBrushes_create_gpencil_data_func(struct Main *_self, struct PointerRNA *brush);
/**************** Main Cache Files ****************/

extern StructRNA RNA_BlendDataCacheFiles;

PointerRNA BlendDataCacheFiles_rna_type_get(PointerRNA *ptr);

void BlendDataCacheFiles_tag_func(struct Main *_self, bool value);
/**************** Main Cameras ****************/

extern StructRNA RNA_BlendDataCameras;

PointerRNA BlendDataCameras_rna_type_get(PointerRNA *ptr);

struct Camera *BlendDataCameras_new_func(struct Main *_self, const char * name);
void BlendDataCameras_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *camera, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataCameras_tag_func(struct Main *_self, bool value);
/**************** Main Collections ****************/

extern StructRNA RNA_BlendDataCollections;

PointerRNA BlendDataCollections_rna_type_get(PointerRNA *ptr);

struct Collection *BlendDataCollections_new_func(struct Main *_self, const char * name);
void BlendDataCollections_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *collection, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataCollections_tag_func(struct Main *_self, bool value);
/**************** Main Curves ****************/

extern StructRNA RNA_BlendDataCurves;

PointerRNA BlendDataCurves_rna_type_get(PointerRNA *ptr);

struct Curve *BlendDataCurves_new_func(struct Main *_self, const char * name, int type);
void BlendDataCurves_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *curve, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataCurves_tag_func(struct Main *_self, bool value);
/**************** Main Fonts ****************/

extern StructRNA RNA_BlendDataFonts;

PointerRNA BlendDataFonts_rna_type_get(PointerRNA *ptr);

struct VFont *BlendDataFonts_load_func(struct Main *_self, ReportList *reports, const char * filepath, bool check_existing);
void BlendDataFonts_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *vfont, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataFonts_tag_func(struct Main *_self, bool value);
/**************** Main Annotations ****************/

extern StructRNA RNA_BlendDataGreasePencils;

PointerRNA BlendDataGreasePencils_rna_type_get(PointerRNA *ptr);

void BlendDataGreasePencils_tag_func(struct Main *_self, bool value);
struct bGPdata *BlendDataGreasePencils_new_func(struct Main *_self, const char * name);
void BlendDataGreasePencils_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *grease_pencil, bool do_unlink, bool do_id_user, bool do_ui_user);
/**************** Main Grease Pencils ****************/

extern StructRNA RNA_BlendDataGreasePencilsV3;

PointerRNA BlendDataGreasePencilsV3_rna_type_get(PointerRNA *ptr);

void BlendDataGreasePencilsV3_tag_func(struct Main *_self, bool value);
struct GreasePencil *BlendDataGreasePencilsV3_new_func(struct Main *_self, const char * name);
void BlendDataGreasePencilsV3_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *grease_pencil, bool do_unlink, bool do_id_user, bool do_ui_user);
/**************** Main Hair Curves ****************/

extern StructRNA RNA_BlendDataHairCurves;

PointerRNA BlendDataHairCurves_rna_type_get(PointerRNA *ptr);

struct Curves *BlendDataHairCurves_new_func(struct Main *_self, const char * name);
void BlendDataHairCurves_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *curves, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataHairCurves_tag_func(struct Main *_self, bool value);
/**************** Main Images ****************/

extern StructRNA RNA_BlendDataImages;

PointerRNA BlendDataImages_rna_type_get(PointerRNA *ptr);

struct Image *BlendDataImages_new_func(struct Main *_self, const char * name, int width, int height, bool alpha, bool float_buffer, bool stereo3d, bool is_data, bool tiled);
struct Image *BlendDataImages_load_func(struct Main *_self, ReportList *reports, const char * filepath, bool check_existing);
void BlendDataImages_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *image, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataImages_tag_func(struct Main *_self, bool value);
/**************** Main Lattices ****************/

extern StructRNA RNA_BlendDataLattices;

PointerRNA BlendDataLattices_rna_type_get(PointerRNA *ptr);

struct Lattice *BlendDataLattices_new_func(struct Main *_self, const char * name);
void BlendDataLattices_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *lattice, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataLattices_tag_func(struct Main *_self, bool value);
/**************** Main Libraries ****************/

extern StructRNA RNA_BlendDataLibraries;

PointerRNA BlendDataLibraries_rna_type_get(PointerRNA *ptr);

void BlendDataLibraries_tag_func(struct Main *_self, bool value);
void BlendDataLibraries_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *library, bool do_unlink, bool do_id_user, bool do_ui_user);
/**************** Main Lights ****************/

extern StructRNA RNA_BlendDataLights;

PointerRNA BlendDataLights_rna_type_get(PointerRNA *ptr);

struct Light *BlendDataLights_new_func(struct Main *_self, const char * name, int type);
void BlendDataLights_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *light, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataLights_tag_func(struct Main *_self, bool value);
/**************** Main Line Styles ****************/

extern StructRNA RNA_BlendDataLineStyles;

PointerRNA BlendDataLineStyles_rna_type_get(PointerRNA *ptr);

void BlendDataLineStyles_tag_func(struct Main *_self, bool value);
struct FreestyleLineStyle *BlendDataLineStyles_new_func(struct Main *_self, const char * name);
void BlendDataLineStyles_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *linestyle, bool do_unlink, bool do_id_user, bool do_ui_user);
/**************** Main Masks ****************/

extern StructRNA RNA_BlendDataMasks;

PointerRNA BlendDataMasks_rna_type_get(PointerRNA *ptr);

void BlendDataMasks_tag_func(struct Main *_self, bool value);
struct Mask *BlendDataMasks_new_func(struct Main *_self, const char * name);
void BlendDataMasks_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *mask, bool do_unlink, bool do_id_user, bool do_ui_user);
/**************** Main Materials ****************/

extern StructRNA RNA_BlendDataMaterials;

PointerRNA BlendDataMaterials_rna_type_get(PointerRNA *ptr);

struct Material *BlendDataMaterials_new_func(struct Main *_self, const char * name);
void BlendDataMaterials_create_gpencil_data_func(struct Main *_self, struct PointerRNA *material);
void BlendDataMaterials_remove_gpencil_data_func(struct Main *_self, struct PointerRNA *material);
void BlendDataMaterials_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *material, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataMaterials_tag_func(struct Main *_self, bool value);
/**************** Main Meshes ****************/

extern StructRNA RNA_BlendDataMeshes;

PointerRNA BlendDataMeshes_rna_type_get(PointerRNA *ptr);

struct Mesh *BlendDataMeshes_new_func(struct Main *_self, const char * name);
struct Mesh *BlendDataMeshes_new_from_object_func(struct Main *_self, ReportList *reports, struct Object *object, bool preserve_all_data_layers, struct Depsgraph *depsgraph);
void BlendDataMeshes_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *mesh, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataMeshes_tag_func(struct Main *_self, bool value);
/**************** Main Metaballs ****************/

extern StructRNA RNA_BlendDataMetaBalls;

PointerRNA BlendDataMetaBalls_rna_type_get(PointerRNA *ptr);

struct MetaBall *BlendDataMetaBalls_new_func(struct Main *_self, const char * name);
void BlendDataMetaBalls_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *metaball, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataMetaBalls_tag_func(struct Main *_self, bool value);
/**************** Main Movie Clips ****************/

extern StructRNA RNA_BlendDataMovieClips;

PointerRNA BlendDataMovieClips_rna_type_get(PointerRNA *ptr);

void BlendDataMovieClips_tag_func(struct Main *_self, bool value);
void BlendDataMovieClips_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *clip, bool do_unlink, bool do_id_user, bool do_ui_user);
struct MovieClip *BlendDataMovieClips_load_func(struct Main *_self, ReportList *reports, const char * filepath, bool check_existing);
/**************** Main Node Trees ****************/

extern StructRNA RNA_BlendDataNodeTrees;

PointerRNA BlendDataNodeTrees_rna_type_get(PointerRNA *ptr);

struct bNodeTree *BlendDataNodeTrees_new_func(struct Main *_self, const char * name, int type);
void BlendDataNodeTrees_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *tree, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataNodeTrees_tag_func(struct Main *_self, bool value);
/**************** Main Objects ****************/

extern StructRNA RNA_BlendDataObjects;

PointerRNA BlendDataObjects_rna_type_get(PointerRNA *ptr);

struct Object *BlendDataObjects_new_func(struct Main *_self, ReportList *reports, const char * name, struct ID *object_data);
void BlendDataObjects_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *object, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataObjects_tag_func(struct Main *_self, bool value);
/**************** Main Paint Curves ****************/

extern StructRNA RNA_BlendDataPaintCurves;

PointerRNA BlendDataPaintCurves_rna_type_get(PointerRNA *ptr);

void BlendDataPaintCurves_tag_func(struct Main *_self, bool value);
/**************** Main Palettes ****************/

extern StructRNA RNA_BlendDataPalettes;

PointerRNA BlendDataPalettes_rna_type_get(PointerRNA *ptr);

struct Palette *BlendDataPalettes_new_func(struct Main *_self, const char * name);
void BlendDataPalettes_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *palette, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataPalettes_tag_func(struct Main *_self, bool value);
/**************** Main Particle Settings ****************/

extern StructRNA RNA_BlendDataParticles;

PointerRNA BlendDataParticles_rna_type_get(PointerRNA *ptr);

struct ParticleSettings *BlendDataParticles_new_func(struct Main *_self, const char * name);
void BlendDataParticles_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *particle, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataParticles_tag_func(struct Main *_self, bool value);
/**************** Main Point Clouds ****************/

extern StructRNA RNA_BlendDataPointClouds;

PointerRNA BlendDataPointClouds_rna_type_get(PointerRNA *ptr);

struct PointCloud *BlendDataPointClouds_new_func(struct Main *_self, const char * name);
void BlendDataPointClouds_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *pointcloud, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataPointClouds_tag_func(struct Main *_self, bool value);
/**************** Main Light Probes ****************/

extern StructRNA RNA_BlendDataProbes;

PointerRNA BlendDataProbes_rna_type_get(PointerRNA *ptr);

struct LightProbe *BlendDataProbes_new_func(struct Main *_self, const char * name, int type);
void BlendDataProbes_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *lightprobe, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataProbes_tag_func(struct Main *_self, bool value);
/**************** Main Scenes ****************/

extern StructRNA RNA_BlendDataScenes;

PointerRNA BlendDataScenes_rna_type_get(PointerRNA *ptr);

struct Scene *BlendDataScenes_new_func(struct Main *_self, const char * name);
void BlendDataScenes_remove_func(struct Main *_self, bContext *C, ReportList *reports, struct PointerRNA *scene, bool do_unlink);
void BlendDataScenes_tag_func(struct Main *_self, bool value);
/**************** Main Screens ****************/

extern StructRNA RNA_BlendDataScreens;

PointerRNA BlendDataScreens_rna_type_get(PointerRNA *ptr);

void BlendDataScreens_tag_func(struct Main *_self, bool value);
/**************** Main Sounds ****************/

extern StructRNA RNA_BlendDataSounds;

PointerRNA BlendDataSounds_rna_type_get(PointerRNA *ptr);

struct bSound *BlendDataSounds_load_func(struct Main *_self, const char * filepath, bool check_existing);
void BlendDataSounds_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *sound, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataSounds_tag_func(struct Main *_self, bool value);
/**************** Main Speakers ****************/

extern StructRNA RNA_BlendDataSpeakers;

PointerRNA BlendDataSpeakers_rna_type_get(PointerRNA *ptr);

struct Speaker *BlendDataSpeakers_new_func(struct Main *_self, const char * name);
void BlendDataSpeakers_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *speaker, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataSpeakers_tag_func(struct Main *_self, bool value);
/**************** Main Texts ****************/

extern StructRNA RNA_BlendDataTexts;

PointerRNA BlendDataTexts_rna_type_get(PointerRNA *ptr);

struct Text *BlendDataTexts_new_func(struct Main *_self, const char * name);
void BlendDataTexts_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *text, bool do_unlink, bool do_id_user, bool do_ui_user);
struct Text *BlendDataTexts_load_func(struct Main *_self, ReportList *reports, const char * filepath, bool internal);
void BlendDataTexts_tag_func(struct Main *_self, bool value);
/**************** Main Textures ****************/

extern StructRNA RNA_BlendDataTextures;

PointerRNA BlendDataTextures_rna_type_get(PointerRNA *ptr);

struct Tex *BlendDataTextures_new_func(struct Main *_self, const char * name, int type);
void BlendDataTextures_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *texture, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataTextures_tag_func(struct Main *_self, bool value);
/**************** Main Volumes ****************/

extern StructRNA RNA_BlendDataVolumes;

PointerRNA BlendDataVolumes_rna_type_get(PointerRNA *ptr);

struct Volume *BlendDataVolumes_new_func(struct Main *_self, const char * name);
void BlendDataVolumes_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *volume, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataVolumes_tag_func(struct Main *_self, bool value);
/**************** Main Window Managers ****************/

extern StructRNA RNA_BlendDataWindowManagers;

PointerRNA BlendDataWindowManagers_rna_type_get(PointerRNA *ptr);

void BlendDataWindowManagers_tag_func(struct Main *_self, bool value);
/**************** Main Workspaces ****************/

extern StructRNA RNA_BlendDataWorkSpaces;

PointerRNA BlendDataWorkSpaces_rna_type_get(PointerRNA *ptr);

void BlendDataWorkSpaces_tag_func(struct Main *_self, bool value);
/**************** Main Worlds ****************/

extern StructRNA RNA_BlendDataWorlds;

PointerRNA BlendDataWorlds_rna_type_get(PointerRNA *ptr);

struct World *BlendDataWorlds_new_func(struct Main *_self, const char * name);
void BlendDataWorlds_remove_func(struct Main *_self, ReportList *reports, struct PointerRNA *world, bool do_unlink, bool do_id_user, bool do_ui_user);
void BlendDataWorlds_tag_func(struct Main *_self, bool value);
/**************** Blendfile Import Context ****************/

extern StructRNA RNA_BlendImportContext;

PointerRNA BlendImportContext_rna_type_get(PointerRNA *ptr);

enum {
	BlendImportContext_options_LINK = 4,
	BlendImportContext_options_MAKE_PATHS_RELATIVE = 2,
	BlendImportContext_options_USE_PLACEHOLDERS = 65536,
	BlendImportContext_options_FORCE_INDIRECT = 131072,
	BlendImportContext_options_APPEND_SET_FAKEUSER = 524288,
	BlendImportContext_options_APPEND_RECURSIVE = 1048576,
	BlendImportContext_options_APPEND_LOCAL_ID_REUSE = 2097152,
	BlendImportContext_options_APPEND_ASSET_DATA_CLEAR = 4194304,
	BlendImportContext_options_SELECT_OBJECTS = 16,
	BlendImportContext_options_USE_ACTIVE_COLLECTION = 32,
	BlendImportContext_options_OBDATA_INSTANCE = 16777216,
	BlendImportContext_options_COLLECTION_INSTANCE = 33554432,
};

int BlendImportContext_options_get(PointerRNA *ptr);
void BlendImportContext_options_set(PointerRNA *ptr, int value);

enum {
	BlendImportContext_process_stage_INIT = 0,
	BlendImportContext_process_stage_DONE = 4,
};

int BlendImportContext_process_stage_get(PointerRNA *ptr);
void BlendImportContext_process_stage_set(PointerRNA *ptr, int value);

void BlendImportContext_import_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendImportContext_import_items_next(CollectionPropertyIterator *iter);
void BlendImportContext_import_items_end(CollectionPropertyIterator *iter);
int BlendImportContext_import_items_length(PointerRNA *ptr);

/**************** Blendfile Import Context Item ****************/

extern StructRNA RNA_BlendImportContextItem;

PointerRNA BlendImportContextItem_rna_type_get(PointerRNA *ptr);

void BlendImportContextItem_name_get(PointerRNA *ptr, char *value);
int BlendImportContextItem_name_length(PointerRNA *ptr);
void BlendImportContextItem_name_set(PointerRNA *ptr, const char *value);

enum {
	BlendImportContextItem_append_action_UNSET = 0,
	BlendImportContextItem_append_action_KEEP_LINKED = 1,
	BlendImportContextItem_append_action_REUSE_LOCAL = 2,
	BlendImportContextItem_append_action_MAKE_LOCAL = 3,
	BlendImportContextItem_append_action_COPY_LOCAL = 4,
};

int BlendImportContextItem_append_action_get(PointerRNA *ptr);
void BlendImportContextItem_append_action_set(PointerRNA *ptr, int value);

enum {
	BlendImportContextItem_id_type_ACTION = 17217,
	BlendImportContextItem_id_type_ARMATURE = 21057,
	BlendImportContextItem_id_type_BRUSH = 21058,
	BlendImportContextItem_id_type_CACHEFILE = 17987,
	BlendImportContextItem_id_type_CAMERA = 16707,
	BlendImportContextItem_id_type_COLLECTION = 21063,
	BlendImportContextItem_id_type_CURVE = 21827,
	BlendImportContextItem_id_type_CURVES = 22083,
	BlendImportContextItem_id_type_FONT = 18006,
	BlendImportContextItem_id_type_GREASEPENCIL = 17479,
	BlendImportContextItem_id_type_GREASEPENCIL_V3 = 20551,
	BlendImportContextItem_id_type_IMAGE = 19785,
	BlendImportContextItem_id_type_KEY = 17739,
	BlendImportContextItem_id_type_LATTICE = 21580,
	BlendImportContextItem_id_type_LIBRARY = 18764,
	BlendImportContextItem_id_type_LIGHT = 16716,
	BlendImportContextItem_id_type_LIGHT_PROBE = 20556,
	BlendImportContextItem_id_type_LINESTYLE = 21324,
	BlendImportContextItem_id_type_MASK = 21325,
	BlendImportContextItem_id_type_MATERIAL = 16717,
	BlendImportContextItem_id_type_MESH = 17741,
	BlendImportContextItem_id_type_META = 16973,
	BlendImportContextItem_id_type_MOVIECLIP = 17229,
	BlendImportContextItem_id_type_NODETREE = 21582,
	BlendImportContextItem_id_type_OBJECT = 16975,
	BlendImportContextItem_id_type_PAINTCURVE = 17232,
	BlendImportContextItem_id_type_PALETTE = 19536,
	BlendImportContextItem_id_type_PARTICLE = 16720,
	BlendImportContextItem_id_type_POINTCLOUD = 21584,
	BlendImportContextItem_id_type_SCENE = 17235,
	BlendImportContextItem_id_type_SCREEN = 21075,
	BlendImportContextItem_id_type_SOUND = 20307,
	BlendImportContextItem_id_type_SPEAKER = 19283,
	BlendImportContextItem_id_type_TEXT = 22612,
	BlendImportContextItem_id_type_TEXTURE = 17748,
	BlendImportContextItem_id_type_VOLUME = 20310,
	BlendImportContextItem_id_type_WINDOWMANAGER = 19799,
	BlendImportContextItem_id_type_WORKSPACE = 21335,
	BlendImportContextItem_id_type_WORLD = 20311,
};

int BlendImportContextItem_id_type_get(PointerRNA *ptr);
void BlendImportContextItem_id_type_set(PointerRNA *ptr, int value);

enum {
	BlendImportContextItem_import_info_INDIRECT_USAGE = 1,
	BlendImportContextItem_import_info_LIBOVERRIDE_DEPENDENCY = 2,
	BlendImportContextItem_import_info_LIBOVERRIDE_DEPENDENCY_ONLY = 4,
};

int BlendImportContextItem_import_info_get(PointerRNA *ptr);
void BlendImportContextItem_import_info_set(PointerRNA *ptr, int value);

PointerRNA BlendImportContextItem_id_get(PointerRNA *ptr);

PointerRNA BlendImportContextItem_library_override_id_get(PointerRNA *ptr);

PointerRNA BlendImportContextItem_reusable_local_id_get(PointerRNA *ptr);

void BlendImportContextItem_source_libraries_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlendImportContextItem_source_libraries_next(CollectionPropertyIterator *iter);
void BlendImportContextItem_source_libraries_end(CollectionPropertyIterator *iter);
int BlendImportContextItem_source_libraries_length(PointerRNA *ptr);

PointerRNA BlendImportContextItem_source_library_get(PointerRNA *ptr);

/**************** Blendfile Import Context Items ****************/

extern StructRNA RNA_BlendImportContextItems;

PointerRNA BlendImportContextItems_rna_type_get(PointerRNA *ptr);

/**************** Blendfile Import Context Libraries ****************/

extern StructRNA RNA_BlendImportContextLibraries;

PointerRNA BlendImportContextLibraries_rna_type_get(PointerRNA *ptr);

/**************** Blendfile Import Context Library ****************/

extern StructRNA RNA_BlendImportContextLibrary;

PointerRNA BlendImportContextLibrary_rna_type_get(PointerRNA *ptr);

void BlendImportContextLibrary_filepath_get(PointerRNA *ptr, char *value);
int BlendImportContextLibrary_filepath_length(PointerRNA *ptr);
void BlendImportContextLibrary_filepath_set(PointerRNA *ptr, const char *value);

/**************** Blend Texture ****************/

extern StructRNA RNA_BlendTexture;
extern StructRNA RNA_Texture;
extern StructRNA RNA_ID;

enum {
	BlendTexture_use_flip_axis_HORIZONTAL = 0,
	BlendTexture_use_flip_axis_VERTICAL = 2,
};

int BlendTexture_use_flip_axis_get(PointerRNA *ptr);
void BlendTexture_use_flip_axis_set(PointerRNA *ptr, int value);

enum {
	BlendTexture_progression_LINEAR = 0,
	BlendTexture_progression_QUADRATIC = 1,
	BlendTexture_progression_EASING = 2,
	BlendTexture_progression_DIAGONAL = 3,
	BlendTexture_progression_SPHERICAL = 4,
	BlendTexture_progression_QUADRATIC_SPHERE = 5,
	BlendTexture_progression_RADIAL = 6,
};

int BlendTexture_progression_get(PointerRNA *ptr);
void BlendTexture_progression_set(PointerRNA *ptr, int value);

/**************** Blender RNA ****************/

extern StructRNA RNA_BlenderRNA;

PointerRNA BlenderRNA_rna_type_get(PointerRNA *ptr);

void BlenderRNA_structs_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BlenderRNA_structs_next(CollectionPropertyIterator *iter);
void BlenderRNA_structs_end(CollectionPropertyIterator *iter);
int BlenderRNA_structs_length(PointerRNA *ptr);
bool BlenderRNA_structs_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool BlenderRNA_structs_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

/**************** Boid Rule ****************/

extern StructRNA RNA_BoidRule;

PointerRNA BoidRule_rna_type_get(PointerRNA *ptr);

#define BoidRule_name_MAX 32

void BoidRule_name_get(PointerRNA *ptr, char *value);
int BoidRule_name_length(PointerRNA *ptr);
void BoidRule_name_set(PointerRNA *ptr, const char *value);

bool BoidRule_use_in_air_get(PointerRNA *ptr);
void BoidRule_use_in_air_set(PointerRNA *ptr, bool value);

bool BoidRule_use_on_land_get(PointerRNA *ptr);
void BoidRule_use_on_land_set(PointerRNA *ptr, bool value);

enum {
	BoidRule_type_GOAL = 1,
	BoidRule_type_AVOID = 2,
	BoidRule_type_AVOID_COLLISION = 3,
	BoidRule_type_SEPARATE = 4,
	BoidRule_type_FLOCK = 5,
	BoidRule_type_FOLLOW_LEADER = 6,
	BoidRule_type_AVERAGE_SPEED = 7,
	BoidRule_type_FIGHT = 8,
};

int BoidRule_type_get(PointerRNA *ptr);
void BoidRule_type_set(PointerRNA *ptr, int value);

/**************** Average Speed ****************/

extern StructRNA RNA_BoidRuleAverageSpeed;
extern StructRNA RNA_BoidRule;

float BoidRuleAverageSpeed_level_get(PointerRNA *ptr);
void BoidRuleAverageSpeed_level_set(PointerRNA *ptr, float value);

float BoidRuleAverageSpeed_speed_get(PointerRNA *ptr);
void BoidRuleAverageSpeed_speed_set(PointerRNA *ptr, float value);

float BoidRuleAverageSpeed_wander_get(PointerRNA *ptr);
void BoidRuleAverageSpeed_wander_set(PointerRNA *ptr, float value);

/**************** Avoid ****************/

extern StructRNA RNA_BoidRuleAvoid;
extern StructRNA RNA_BoidRule;

float BoidRuleAvoid_fear_factor_get(PointerRNA *ptr);
void BoidRuleAvoid_fear_factor_set(PointerRNA *ptr, float value);

PointerRNA BoidRuleAvoid_object_get(PointerRNA *ptr);

bool BoidRuleAvoid_use_predict_get(PointerRNA *ptr);
void BoidRuleAvoid_use_predict_set(PointerRNA *ptr, bool value);

/**************** Avoid Collision ****************/

extern StructRNA RNA_BoidRuleAvoidCollision;
extern StructRNA RNA_BoidRule;

bool BoidRuleAvoidCollision_use_avoid_get(PointerRNA *ptr);
void BoidRuleAvoidCollision_use_avoid_set(PointerRNA *ptr, bool value);

bool BoidRuleAvoidCollision_use_avoid_collision_get(PointerRNA *ptr);
void BoidRuleAvoidCollision_use_avoid_collision_set(PointerRNA *ptr, bool value);

float BoidRuleAvoidCollision_look_ahead_get(PointerRNA *ptr);
void BoidRuleAvoidCollision_look_ahead_set(PointerRNA *ptr, float value);

/**************** Fight ****************/

extern StructRNA RNA_BoidRuleFight;
extern StructRNA RNA_BoidRule;

float BoidRuleFight_distance_get(PointerRNA *ptr);
void BoidRuleFight_distance_set(PointerRNA *ptr, float value);

float BoidRuleFight_flee_distance_get(PointerRNA *ptr);
void BoidRuleFight_flee_distance_set(PointerRNA *ptr, float value);

/**************** Follow Leader ****************/

extern StructRNA RNA_BoidRuleFollowLeader;
extern StructRNA RNA_BoidRule;

float BoidRuleFollowLeader_distance_get(PointerRNA *ptr);
void BoidRuleFollowLeader_distance_set(PointerRNA *ptr, float value);

bool BoidRuleFollowLeader_use_line_get(PointerRNA *ptr);
void BoidRuleFollowLeader_use_line_set(PointerRNA *ptr, bool value);

PointerRNA BoidRuleFollowLeader_object_get(PointerRNA *ptr);

int BoidRuleFollowLeader_queue_count_get(PointerRNA *ptr);
void BoidRuleFollowLeader_queue_count_set(PointerRNA *ptr, int value);

/**************** Goal ****************/

extern StructRNA RNA_BoidRuleGoal;
extern StructRNA RNA_BoidRule;

PointerRNA BoidRuleGoal_object_get(PointerRNA *ptr);

bool BoidRuleGoal_use_predict_get(PointerRNA *ptr);
void BoidRuleGoal_use_predict_set(PointerRNA *ptr, bool value);

/**************** Boid Settings ****************/

extern StructRNA RNA_BoidSettings;

PointerRNA BoidSettings_rna_type_get(PointerRNA *ptr);

float BoidSettings_accuracy_get(PointerRNA *ptr);
void BoidSettings_accuracy_set(PointerRNA *ptr, float value);

PointerRNA BoidSettings_active_boid_state_get(PointerRNA *ptr);

int BoidSettings_active_boid_state_index_get(PointerRNA *ptr);
void BoidSettings_active_boid_state_index_set(PointerRNA *ptr, int value);

float BoidSettings_aggression_get(PointerRNA *ptr);
void BoidSettings_aggression_set(PointerRNA *ptr, float value);

float BoidSettings_air_personal_space_get(PointerRNA *ptr);
void BoidSettings_air_personal_space_set(PointerRNA *ptr, float value);

bool BoidSettings_use_climb_get(PointerRNA *ptr);
void BoidSettings_use_climb_set(PointerRNA *ptr, bool value);

bool BoidSettings_use_flight_get(PointerRNA *ptr);
void BoidSettings_use_flight_set(PointerRNA *ptr, bool value);

bool BoidSettings_use_land_get(PointerRNA *ptr);
void BoidSettings_use_land_set(PointerRNA *ptr, bool value);

float BoidSettings_bank_get(PointerRNA *ptr);
void BoidSettings_bank_set(PointerRNA *ptr, float value);

void BoidSettings_states_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BoidSettings_states_next(CollectionPropertyIterator *iter);
void BoidSettings_states_end(CollectionPropertyIterator *iter);
bool BoidSettings_states_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool BoidSettings_states_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

float BoidSettings_health_get(PointerRNA *ptr);
void BoidSettings_health_set(PointerRNA *ptr, float value);

float BoidSettings_height_get(PointerRNA *ptr);
void BoidSettings_height_set(PointerRNA *ptr, float value);

float BoidSettings_land_jump_speed_get(PointerRNA *ptr);
void BoidSettings_land_jump_speed_set(PointerRNA *ptr, float value);

float BoidSettings_land_personal_space_get(PointerRNA *ptr);
void BoidSettings_land_personal_space_set(PointerRNA *ptr, float value);

float BoidSettings_land_stick_force_get(PointerRNA *ptr);
void BoidSettings_land_stick_force_set(PointerRNA *ptr, float value);

float BoidSettings_land_smooth_get(PointerRNA *ptr);
void BoidSettings_land_smooth_set(PointerRNA *ptr, float value);

float BoidSettings_air_acc_max_get(PointerRNA *ptr);
void BoidSettings_air_acc_max_set(PointerRNA *ptr, float value);

float BoidSettings_air_ave_max_get(PointerRNA *ptr);
void BoidSettings_air_ave_max_set(PointerRNA *ptr, float value);

float BoidSettings_air_speed_max_get(PointerRNA *ptr);
void BoidSettings_air_speed_max_set(PointerRNA *ptr, float value);

float BoidSettings_land_acc_max_get(PointerRNA *ptr);
void BoidSettings_land_acc_max_set(PointerRNA *ptr, float value);

float BoidSettings_land_ave_max_get(PointerRNA *ptr);
void BoidSettings_land_ave_max_set(PointerRNA *ptr, float value);

float BoidSettings_land_speed_max_get(PointerRNA *ptr);
void BoidSettings_land_speed_max_set(PointerRNA *ptr, float value);

float BoidSettings_air_speed_min_get(PointerRNA *ptr);
void BoidSettings_air_speed_min_set(PointerRNA *ptr, float value);

float BoidSettings_pitch_get(PointerRNA *ptr);
void BoidSettings_pitch_set(PointerRNA *ptr, float value);

float BoidSettings_range_get(PointerRNA *ptr);
void BoidSettings_range_set(PointerRNA *ptr, float value);

float BoidSettings_strength_get(PointerRNA *ptr);
void BoidSettings_strength_set(PointerRNA *ptr, float value);

/**************** Boid State ****************/

extern StructRNA RNA_BoidState;

PointerRNA BoidState_rna_type_get(PointerRNA *ptr);

#define BoidState_name_MAX 32

void BoidState_name_get(PointerRNA *ptr, char *value);
int BoidState_name_length(PointerRNA *ptr);
void BoidState_name_set(PointerRNA *ptr, const char *value);

PointerRNA BoidState_active_boid_rule_get(PointerRNA *ptr);

int BoidState_active_boid_rule_index_get(PointerRNA *ptr);
void BoidState_active_boid_rule_index_set(PointerRNA *ptr, int value);

void BoidState_rules_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BoidState_rules_next(CollectionPropertyIterator *iter);
void BoidState_rules_end(CollectionPropertyIterator *iter);
bool BoidState_rules_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool BoidState_rules_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

float BoidState_falloff_get(PointerRNA *ptr);
void BoidState_falloff_set(PointerRNA *ptr, float value);

enum {
	BoidState_ruleset_type_FUZZY = 0,
	BoidState_ruleset_type_RANDOM = 1,
	BoidState_ruleset_type_AVERAGE = 2,
};

int BoidState_ruleset_type_get(PointerRNA *ptr);
void BoidState_ruleset_type_set(PointerRNA *ptr, int value);

float BoidState_rule_fuzzy_get(PointerRNA *ptr);
void BoidState_rule_fuzzy_set(PointerRNA *ptr, float value);

float BoidState_volume_get(PointerRNA *ptr);
void BoidState_volume_set(PointerRNA *ptr, float value);

/**************** Bone ****************/

extern StructRNA RNA_Bone;

PointerRNA Bone_rna_type_get(PointerRNA *ptr);

#define Bone_name_MAX 64

void Bone_name_get(PointerRNA *ptr, char *value);
int Bone_name_length(PointerRNA *ptr);
void Bone_name_set(PointerRNA *ptr, const char *value);

void Bone_head_local_get(PointerRNA *ptr, float values[3]);
void Bone_head_local_set(PointerRNA *ptr, const float values[3]);

void Bone_tail_local_get(PointerRNA *ptr, float values[3]);
void Bone_tail_local_set(PointerRNA *ptr, const float values[3]);

float Bone_bbone_x_get(PointerRNA *ptr);
void Bone_bbone_x_set(PointerRNA *ptr, float value);

float Bone_bbone_z_get(PointerRNA *ptr);
void Bone_bbone_z_set(PointerRNA *ptr, float value);

PointerRNA Bone_bbone_custom_handle_end_get(PointerRNA *ptr);

enum {
	Bone_bbone_handle_type_end_AUTO = 0,
	Bone_bbone_handle_type_end_ABSOLUTE = 1,
	Bone_bbone_handle_type_end_RELATIVE = 2,
	Bone_bbone_handle_type_end_TANGENT = 3,
};

int Bone_bbone_handle_type_end_get(PointerRNA *ptr);
void Bone_bbone_handle_type_end_set(PointerRNA *ptr, int value);

int Bone_bbone_segments_get(PointerRNA *ptr);
void Bone_bbone_segments_set(PointerRNA *ptr, int value);

PointerRNA Bone_bbone_custom_handle_start_get(PointerRNA *ptr);

enum {
	Bone_bbone_handle_type_start_AUTO = 0,
	Bone_bbone_handle_type_start_ABSOLUTE = 1,
	Bone_bbone_handle_type_start_RELATIVE = 2,
	Bone_bbone_handle_type_start_TANGENT = 3,
};

int Bone_bbone_handle_type_start_get(PointerRNA *ptr);
void Bone_bbone_handle_type_start_set(PointerRNA *ptr, int value);

enum {
	Bone_bbone_mapping_mode_STRAIGHT = 0,
	Bone_bbone_mapping_mode_CURVED = 1,
};

int Bone_bbone_mapping_mode_get(PointerRNA *ptr);
void Bone_bbone_mapping_mode_set(PointerRNA *ptr, int value);

void Bone_matrix_local_get(PointerRNA *ptr, float values[16]);
void Bone_matrix_local_set(PointerRNA *ptr, const float values[16]);

void Bone_matrix_get(PointerRNA *ptr, float values[9]);
void Bone_matrix_set(PointerRNA *ptr, const float values[9]);

void Bone_children_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Bone_children_next(CollectionPropertyIterator *iter);
void Bone_children_end(CollectionPropertyIterator *iter);
bool Bone_children_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Bone_children_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void Bone_collections_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Bone_collections_next(CollectionPropertyIterator *iter);
void Bone_collections_end(CollectionPropertyIterator *iter);

bool Bone_use_connect_get(PointerRNA *ptr);
void Bone_use_connect_set(PointerRNA *ptr, bool value);

bool Bone_use_cyclic_offset_get(PointerRNA *ptr);
void Bone_use_cyclic_offset_set(PointerRNA *ptr, bool value);

bool Bone_use_deform_get(PointerRNA *ptr);
void Bone_use_deform_set(PointerRNA *ptr, bool value);

enum {
	Bone_display_type_ARMATURE_DEFINED = -1,
	Bone_display_type_OCTAHEDRAL = 0,
	Bone_display_type_STICK = 1,
	Bone_display_type_BBONE = 2,
	Bone_display_type_ENVELOPE = 3,
	Bone_display_type_WIRE = 4,
};

int Bone_display_type_get(PointerRNA *ptr);
void Bone_display_type_set(PointerRNA *ptr, int value);

bool Bone_show_wire_get(PointerRNA *ptr);
void Bone_show_wire_set(PointerRNA *ptr, bool value);

float Bone_bbone_easein_get(PointerRNA *ptr);
void Bone_bbone_easein_set(PointerRNA *ptr, float value);

float Bone_bbone_easeout_get(PointerRNA *ptr);
void Bone_bbone_easeout_set(PointerRNA *ptr, float value);

bool Bone_bbone_handle_use_ease_end_get(PointerRNA *ptr);
void Bone_bbone_handle_use_ease_end_set(PointerRNA *ptr, bool value);

void Bone_bbone_handle_use_scale_end_get(PointerRNA *ptr, bool values[3]);
void Bone_bbone_handle_use_scale_end_set(PointerRNA *ptr, const bool values[3]);

float Bone_envelope_distance_get(PointerRNA *ptr);
void Bone_envelope_distance_set(PointerRNA *ptr, float value);

float Bone_envelope_weight_get(PointerRNA *ptr);
void Bone_envelope_weight_set(PointerRNA *ptr, float value);

float Bone_head_radius_get(PointerRNA *ptr);
void Bone_head_radius_set(PointerRNA *ptr, float value);

float Bone_tail_radius_get(PointerRNA *ptr);
void Bone_tail_radius_set(PointerRNA *ptr, float value);

void Bone_head_get(PointerRNA *ptr, float values[3]);
void Bone_head_set(PointerRNA *ptr, const float values[3]);

bool Bone_hide_get(PointerRNA *ptr);
void Bone_hide_set(PointerRNA *ptr, bool value);

float Bone_bbone_curveinx_get(PointerRNA *ptr);
void Bone_bbone_curveinx_set(PointerRNA *ptr, float value);

float Bone_bbone_curveinz_get(PointerRNA *ptr);
void Bone_bbone_curveinz_set(PointerRNA *ptr, float value);

bool Bone_use_endroll_as_inroll_get(PointerRNA *ptr);
void Bone_use_endroll_as_inroll_set(PointerRNA *ptr, bool value);

bool Bone_use_inherit_rotation_get(PointerRNA *ptr);
void Bone_use_inherit_rotation_set(PointerRNA *ptr, bool value);

enum {
	Bone_inherit_scale_FULL = 0,
	Bone_inherit_scale_FIX_SHEAR = 1,
	Bone_inherit_scale_ALIGNED = 5,
	Bone_inherit_scale_AVERAGE = 2,
	Bone_inherit_scale_NONE = 3,
	Bone_inherit_scale_NONE_LEGACY = 4,
};

int Bone_inherit_scale_get(PointerRNA *ptr);
void Bone_inherit_scale_set(PointerRNA *ptr, int value);

float Bone_length_get(PointerRNA *ptr);
void Bone_length_set(PointerRNA *ptr, float value);

bool Bone_use_local_location_get(PointerRNA *ptr);
void Bone_use_local_location_set(PointerRNA *ptr, bool value);

bool Bone_use_envelope_multiply_get(PointerRNA *ptr);
void Bone_use_envelope_multiply_set(PointerRNA *ptr, bool value);

float Bone_bbone_curveoutx_get(PointerRNA *ptr);
void Bone_bbone_curveoutx_set(PointerRNA *ptr, float value);

float Bone_bbone_curveoutz_get(PointerRNA *ptr);
void Bone_bbone_curveoutz_set(PointerRNA *ptr, float value);

PointerRNA Bone_parent_get(PointerRNA *ptr);

bool Bone_use_relative_parent_get(PointerRNA *ptr);
void Bone_use_relative_parent_set(PointerRNA *ptr, bool value);

float Bone_bbone_rollin_get(PointerRNA *ptr);
void Bone_bbone_rollin_set(PointerRNA *ptr, float value);

float Bone_bbone_rollout_get(PointerRNA *ptr);
void Bone_bbone_rollout_set(PointerRNA *ptr, float value);

bool Bone_use_scale_easing_get(PointerRNA *ptr);
void Bone_use_scale_easing_set(PointerRNA *ptr, bool value);

void Bone_bbone_scalein_get(PointerRNA *ptr, float values[3]);
void Bone_bbone_scalein_set(PointerRNA *ptr, const float values[3]);

void Bone_bbone_scaleout_get(PointerRNA *ptr, float values[3]);
void Bone_bbone_scaleout_set(PointerRNA *ptr, const float values[3]);

bool Bone_select_get(PointerRNA *ptr);
void Bone_select_set(PointerRNA *ptr, bool value);

bool Bone_select_head_get(PointerRNA *ptr);
void Bone_select_head_set(PointerRNA *ptr, bool value);

bool Bone_select_tail_get(PointerRNA *ptr);
void Bone_select_tail_set(PointerRNA *ptr, bool value);

bool Bone_hide_select_get(PointerRNA *ptr);
void Bone_hide_select_set(PointerRNA *ptr, bool value);

bool Bone_bbone_handle_use_ease_start_get(PointerRNA *ptr);
void Bone_bbone_handle_use_ease_start_set(PointerRNA *ptr, bool value);

void Bone_bbone_handle_use_scale_start_get(PointerRNA *ptr, bool values[3]);
void Bone_bbone_handle_use_scale_start_set(PointerRNA *ptr, const bool values[3]);

void Bone_tail_get(PointerRNA *ptr, float values[3]);
void Bone_tail_set(PointerRNA *ptr, const float values[3]);

PointerRNA Bone_color_get(PointerRNA *ptr);

float Bone_evaluate_envelope_func(struct Bone *_self, float point[3]);
void Bone_convert_local_to_pose_func(struct Bone *_self, float matrix_return[16], float matrix[16], float matrix_local[16], float parent_matrix[16], float parent_matrix_local[16], bool invert);
void Bone_MatrixFromAxisRoll_func(float axis[3], float roll, float result_matrix[9]);
void Bone_AxisRollFromMatrix_func(float matrix[9], float axis[3], float result_axis[3], float *result_roll);
/**************** BoneCollection ****************/

extern StructRNA RNA_BoneCollection;

PointerRNA BoneCollection_rna_type_get(PointerRNA *ptr);

#define BoneCollection_name_MAX 64

void BoneCollection_name_get(PointerRNA *ptr, char *value);
int BoneCollection_name_length(PointerRNA *ptr);
void BoneCollection_name_set(PointerRNA *ptr, const char *value);

bool BoneCollection_is_visible_ancestors_get(PointerRNA *ptr);
void BoneCollection_is_visible_ancestors_set(PointerRNA *ptr, bool value);

void BoneCollection_bones_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BoneCollection_bones_next(CollectionPropertyIterator *iter);
void BoneCollection_bones_end(CollectionPropertyIterator *iter);
bool BoneCollection_bones_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool BoneCollection_bones_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

int BoneCollection_child_number_get(PointerRNA *ptr);
void BoneCollection_child_number_set(PointerRNA *ptr, int value);

bool BoneCollection_is_visible_effectively_get(PointerRNA *ptr);
void BoneCollection_is_visible_effectively_set(PointerRNA *ptr, bool value);

bool BoneCollection_is_expanded_get(PointerRNA *ptr);
void BoneCollection_is_expanded_set(PointerRNA *ptr, bool value);

int BoneCollection_index_get(PointerRNA *ptr);
void BoneCollection_index_set(PointerRNA *ptr, int value);

bool BoneCollection_is_editable_get(PointerRNA *ptr);
void BoneCollection_is_editable_set(PointerRNA *ptr, bool value);

bool BoneCollection_is_local_override_get(PointerRNA *ptr);
void BoneCollection_is_local_override_set(PointerRNA *ptr, bool value);

PointerRNA BoneCollection_parent_get(PointerRNA *ptr);

bool BoneCollection_is_solo_get(PointerRNA *ptr);
void BoneCollection_is_solo_set(PointerRNA *ptr, bool value);

bool BoneCollection_is_visible_get(PointerRNA *ptr);
void BoneCollection_is_visible_set(PointerRNA *ptr, bool value);

void BoneCollection_children_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BoneCollection_children_next(CollectionPropertyIterator *iter);
void BoneCollection_children_end(CollectionPropertyIterator *iter);
int BoneCollection_children_length(PointerRNA *ptr);

bool BoneCollection_assign_func(struct BoneCollection *_self, bContext *C, ReportList *reports, struct PointerRNA *bone);
bool BoneCollection_unassign_func(struct BoneCollection *_self, bContext *C, ReportList *reports, struct PointerRNA *bone);
/**************** Bone Collection Memberships ****************/

extern StructRNA RNA_BoneCollectionMemberships;

PointerRNA BoneCollectionMemberships_rna_type_get(PointerRNA *ptr);

void BoneCollectionMemberships_clear_func(struct Bone *_self);
/**************** Armature Bone Collections ****************/

extern StructRNA RNA_BoneCollections;

PointerRNA BoneCollections_rna_type_get(PointerRNA *ptr);

PointerRNA BoneCollections_active_get(PointerRNA *ptr);

int BoneCollections_active_index_get(PointerRNA *ptr);
void BoneCollections_active_index_set(PointerRNA *ptr, int value);

#define BoneCollections_active_name_MAX 64

void BoneCollections_active_name_get(PointerRNA *ptr, char *value);
int BoneCollections_active_name_length(PointerRNA *ptr);
void BoneCollections_active_name_set(PointerRNA *ptr, const char *value);

bool BoneCollections_is_solo_active_get(PointerRNA *ptr);
void BoneCollections_is_solo_active_set(PointerRNA *ptr, bool value);

struct BoneCollection *BoneCollections_new_func(struct bArmature *_self, ReportList *reports, const char * name, struct BoneCollection *parent);
void BoneCollections_remove_func(struct bArmature *_self, struct BoneCollection *bone_collection);
void BoneCollections_move_func(struct bArmature *_self, ReportList *reports, int from_index, int to_index);
/**************** BoneColor ****************/

extern StructRNA RNA_BoneColor;

PointerRNA BoneColor_rna_type_get(PointerRNA *ptr);

enum {
	BoneColor_palette_DEFAULT = 0,
	BoneColor_palette_THEME01 = 1,
	BoneColor_palette_THEME02 = 2,
	BoneColor_palette_THEME03 = 3,
	BoneColor_palette_THEME04 = 4,
	BoneColor_palette_THEME05 = 5,
	BoneColor_palette_THEME06 = 6,
	BoneColor_palette_THEME07 = 7,
	BoneColor_palette_THEME08 = 8,
	BoneColor_palette_THEME09 = 9,
	BoneColor_palette_THEME10 = 10,
	BoneColor_palette_THEME11 = 11,
	BoneColor_palette_THEME12 = 12,
	BoneColor_palette_THEME13 = 13,
	BoneColor_palette_THEME14 = 14,
	BoneColor_palette_THEME15 = 15,
	BoneColor_palette_THEME16 = 16,
	BoneColor_palette_THEME17 = 17,
	BoneColor_palette_THEME18 = 18,
	BoneColor_palette_THEME19 = 19,
	BoneColor_palette_THEME20 = 20,
	BoneColor_palette_CUSTOM = -1,
};

int BoneColor_palette_get(PointerRNA *ptr);
void BoneColor_palette_set(PointerRNA *ptr, int value);

PointerRNA BoneColor_custom_get(PointerRNA *ptr);

bool BoneColor_is_custom_get(PointerRNA *ptr);
void BoneColor_is_custom_set(PointerRNA *ptr, bool value);

/**************** Bool Attribute ****************/

extern StructRNA RNA_BoolAttribute;
extern StructRNA RNA_Attribute;

void BoolAttribute_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void BoolAttribute_data_next(CollectionPropertyIterator *iter);
void BoolAttribute_data_end(CollectionPropertyIterator *iter);
int BoolAttribute_data_length(PointerRNA *ptr);
bool BoolAttribute_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Bool Attribute Value ****************/

extern StructRNA RNA_BoolAttributeValue;

PointerRNA BoolAttributeValue_rna_type_get(PointerRNA *ptr);

bool BoolAttributeValue_value_get(PointerRNA *ptr);
void BoolAttributeValue_value_set(PointerRNA *ptr, bool value);

/**************** Boolean Definition ****************/

extern StructRNA RNA_BoolProperty;
extern StructRNA RNA_Property;

void BoolProperty_array_dimensions_get(PointerRNA *ptr, int values[3]);
void BoolProperty_array_dimensions_set(PointerRNA *ptr, const int values[3]);

int BoolProperty_array_length_get(PointerRNA *ptr);
void BoolProperty_array_length_set(PointerRNA *ptr, int value);

bool BoolProperty_default_value_get(PointerRNA *ptr);
void BoolProperty_default_value_set(PointerRNA *ptr, bool value);

void BoolProperty_default_array_get(PointerRNA *ptr, bool values[]);
void BoolProperty_default_array_set(PointerRNA *ptr, const bool values[]);
int BoolProperty_default_array_get_length(PointerRNA *ptr, int *arraylen);

bool BoolProperty_is_array_get(PointerRNA *ptr);
void BoolProperty_is_array_set(PointerRNA *ptr, bool value);

/**************** Boolean Modifier ****************/

extern StructRNA RNA_BooleanModifier;
extern StructRNA RNA_Modifier;

PointerRNA BooleanModifier_collection_get(PointerRNA *ptr);

enum {
	BooleanModifier_debug_options_SEPARATE = 1,
	BooleanModifier_debug_options_NO_DISSOLVE = 2,
	BooleanModifier_debug_options_NO_CONNECT_REGIONS = 4,
};

int BooleanModifier_debug_options_get(PointerRNA *ptr);
void BooleanModifier_debug_options_set(PointerRNA *ptr, int value);

bool BooleanModifier_use_hole_tolerant_get(PointerRNA *ptr);
void BooleanModifier_use_hole_tolerant_set(PointerRNA *ptr, bool value);

enum {
	BooleanModifier_material_mode_INDEX = 0,
	BooleanModifier_material_mode_TRANSFER = 1,
};

int BooleanModifier_material_mode_get(PointerRNA *ptr);
void BooleanModifier_material_mode_set(PointerRNA *ptr, int value);

PointerRNA BooleanModifier_object_get(PointerRNA *ptr);

enum {
	BooleanModifier_operand_type_OBJECT = 2,
	BooleanModifier_operand_type_COLLECTION = 4,
};

int BooleanModifier_operand_type_get(PointerRNA *ptr);
void BooleanModifier_operand_type_set(PointerRNA *ptr, int value);

enum {
	BooleanModifier_operation_INTERSECT = 0,
	BooleanModifier_operation_UNION = 1,
	BooleanModifier_operation_DIFFERENCE = 2,
};

int BooleanModifier_operation_get(PointerRNA *ptr);
void BooleanModifier_operation_set(PointerRNA *ptr, int value);

float BooleanModifier_double_threshold_get(PointerRNA *ptr);
void BooleanModifier_double_threshold_set(PointerRNA *ptr, float value);

bool BooleanModifier_use_self_get(PointerRNA *ptr);
void BooleanModifier_use_self_set(PointerRNA *ptr, bool value);

enum {
	BooleanModifier_solver_FAST = 0,
	BooleanModifier_solver_EXACT = 1,
	BooleanModifier_solver_MANIFOLD = 2,
};

int BooleanModifier_solver_get(PointerRNA *ptr);
void BooleanModifier_solver_set(PointerRNA *ptr, int value);

/**************** BrightContrastModifier ****************/

extern StructRNA RNA_BrightContrastModifier;
extern StructRNA RNA_StripModifier;

float BrightContrastModifier_bright_get(PointerRNA *ptr);
void BrightContrastModifier_bright_set(PointerRNA *ptr, float value);

float BrightContrastModifier_contrast_get(PointerRNA *ptr);
void BrightContrastModifier_contrast_set(PointerRNA *ptr, float value);

/**************** Brush ****************/

extern StructRNA RNA_Brush;
extern StructRNA RNA_ID;

bool Brush_use_accumulate_get(PointerRNA *ptr);
void Brush_use_accumulate_set(PointerRNA *ptr, bool value);

bool Brush_use_adaptive_space_get(PointerRNA *ptr);
void Brush_use_adaptive_space_set(PointerRNA *ptr, bool value);

void Brush_cursor_color_add_get(PointerRNA *ptr, float values[4]);
void Brush_cursor_color_add_set(PointerRNA *ptr, const float values[4]);

bool Brush_use_space_attenuation_get(PointerRNA *ptr);
void Brush_use_space_attenuation_set(PointerRNA *ptr, bool value);

bool Brush_use_alpha_get(PointerRNA *ptr);
void Brush_use_alpha_set(PointerRNA *ptr, bool value);

bool Brush_use_airbrush_get(PointerRNA *ptr);
void Brush_use_airbrush_set(PointerRNA *ptr, bool value);

bool Brush_use_anchor_get(PointerRNA *ptr);
void Brush_use_anchor_set(PointerRNA *ptr, bool value);

bool Brush_use_paint_antialiasing_get(PointerRNA *ptr);
void Brush_use_paint_antialiasing_set(PointerRNA *ptr, bool value);

bool Brush_use_automasking_start_normal_get(PointerRNA *ptr);
void Brush_use_automasking_start_normal_set(PointerRNA *ptr, bool value);

float Brush_automasking_start_normal_falloff_get(PointerRNA *ptr);
void Brush_automasking_start_normal_falloff_set(PointerRNA *ptr, float value);

float Brush_automasking_start_normal_limit_get(PointerRNA *ptr);
void Brush_automasking_start_normal_limit_set(PointerRNA *ptr, float value);

float Brush_area_radius_factor_get(PointerRNA *ptr);
void Brush_area_radius_factor_set(PointerRNA *ptr, float value);

bool Brush_use_pressure_area_radius_get(PointerRNA *ptr);
void Brush_use_pressure_area_radius_set(PointerRNA *ptr, bool value);

float Brush_auto_smooth_factor_get(PointerRNA *ptr);
void Brush_auto_smooth_factor_set(PointerRNA *ptr, float value);

enum {
	Brush_blend_MIX = 0,
	Brush_blend_DARKEN = 5,
	Brush_blend_MUL = 3,
	Brush_blend_COLORBURN = 10,
	Brush_blend_LINEARBURN = 11,
	Brush_blend_LIGHTEN = 4,
	Brush_blend_SCREEN = 13,
	Brush_blend_COLORDODGE = 12,
	Brush_blend_ADD = 1,
	Brush_blend_OVERLAY = 8,
	Brush_blend_SOFTLIGHT = 14,
	Brush_blend_HARDLIGHT = 9,
	Brush_blend_VIVIDLIGHT = 16,
	Brush_blend_LINEARLIGHT = 17,
	Brush_blend_PINLIGHT = 15,
	Brush_blend_DIFFERENCE = 18,
	Brush_blend_EXCLUSION = 19,
	Brush_blend_SUB = 2,
	Brush_blend_HUE = 20,
	Brush_blend_SATURATION = 21,
	Brush_blend_COLOR = 23,
	Brush_blend_LUMINOSITY = 22,
	Brush_blend_ERASE_ALPHA = 6,
	Brush_blend_ADD_ALPHA = 7,
};

int Brush_blend_get(PointerRNA *ptr);
void Brush_blend_set(PointerRNA *ptr, int value);

enum {
	Brush_blur_mode_BOX = 1,
	Brush_blur_mode_GAUSSIAN = 0,
};

int Brush_blur_mode_get(PointerRNA *ptr);
void Brush_blur_mode_set(PointerRNA *ptr, int value);

int Brush_automasking_cavity_blur_steps_get(PointerRNA *ptr);
void Brush_automasking_cavity_blur_steps_set(PointerRNA *ptr, int value);

enum {
	Brush_boundary_falloff_type_CONSTANT = 0,
	Brush_boundary_falloff_type_RADIUS = 1,
	Brush_boundary_falloff_type_LOOP = 2,
	Brush_boundary_falloff_type_LOOP_INVERT = 3,
};

int Brush_boundary_falloff_type_get(PointerRNA *ptr);
void Brush_boundary_falloff_type_set(PointerRNA *ptr, int value);

float Brush_boundary_offset_get(PointerRNA *ptr);
void Brush_boundary_offset_set(PointerRNA *ptr, float value);

PointerRNA Brush_brush_capabilities_get(PointerRNA *ptr);

float Brush_height_get(PointerRNA *ptr);
void Brush_height_set(PointerRNA *ptr, float value);

#define Brush_icon_filepath_MAX 1024

void Brush_icon_filepath_get(PointerRNA *ptr, char *value);
int Brush_icon_filepath_length(PointerRNA *ptr);
void Brush_icon_filepath_set(PointerRNA *ptr, const char *value);

enum {
	Brush_sculpt_tool_DRAW = 1,
	Brush_sculpt_tool_DRAW_SHARP = 20,
	Brush_sculpt_tool_CLAY = 8,
	Brush_sculpt_tool_CLAY_STRIPS = 18,
	Brush_sculpt_tool_CLAY_THUMB = 25,
	Brush_sculpt_tool_LAYER = 6,
	Brush_sculpt_tool_INFLATE = 4,
	Brush_sculpt_tool_BLOB = 17,
	Brush_sculpt_tool_CREASE = 16,
	Brush_sculpt_tool_SMOOTH = 2,
	Brush_sculpt_tool_PLANE = 33,
	Brush_sculpt_tool_MULTIPLANE_SCRAPE = 23,
	Brush_sculpt_tool_PINCH = 3,
	Brush_sculpt_tool_GRAB = 5,
	Brush_sculpt_tool_ELASTIC_DEFORM = 21,
	Brush_sculpt_tool_SNAKE_HOOK = 13,
	Brush_sculpt_tool_THUMB = 12,
	Brush_sculpt_tool_POSE = 22,
	Brush_sculpt_tool_NUDGE = 11,
	Brush_sculpt_tool_ROTATE = 14,
	Brush_sculpt_tool_TOPOLOGY = 24,
	Brush_sculpt_tool_BOUNDARY = 30,
	Brush_sculpt_tool_CLOTH = 26,
	Brush_sculpt_tool_SIMPLIFY = 15,
	Brush_sculpt_tool_MASK = 19,
	Brush_sculpt_tool_DRAW_FACE_SETS = 27,
	Brush_sculpt_tool_DISPLACEMENT_ERASER = 31,
	Brush_sculpt_tool_DISPLACEMENT_SMEAR = 32,
	Brush_sculpt_tool_PAINT = 28,
	Brush_sculpt_tool_SMEAR = 29,
};

int Brush_sculpt_tool_get(PointerRNA *ptr);
void Brush_sculpt_tool_set(PointerRNA *ptr, int value);

enum {
	Brush_vertex_tool_DRAW = 0,
	Brush_vertex_tool_BLUR = 1,
	Brush_vertex_tool_AVERAGE = 2,
	Brush_vertex_tool_SMEAR = 3,
};

int Brush_vertex_tool_get(PointerRNA *ptr);
void Brush_vertex_tool_set(PointerRNA *ptr, int value);

enum {
	Brush_weight_tool_DRAW = 0,
	Brush_weight_tool_BLUR = 1,
	Brush_weight_tool_AVERAGE = 2,
	Brush_weight_tool_SMEAR = 3,
};

int Brush_weight_tool_get(PointerRNA *ptr);
void Brush_weight_tool_set(PointerRNA *ptr, int value);

enum {
	Brush_image_tool_DRAW = 0,
	Brush_image_tool_SOFTEN = 1,
	Brush_image_tool_SMEAR = 2,
	Brush_image_tool_CLONE = 3,
	Brush_image_tool_FILL = 4,
	Brush_image_tool_MASK = 5,
};

int Brush_image_tool_get(PointerRNA *ptr);
void Brush_image_tool_set(PointerRNA *ptr, int value);

enum {
	Brush_gpencil_tool_DRAW = 0,
	Brush_gpencil_tool_FILL = 1,
	Brush_gpencil_tool_ERASE = 2,
	Brush_gpencil_tool_TINT = 3,
};

int Brush_gpencil_tool_get(PointerRNA *ptr);
void Brush_gpencil_tool_set(PointerRNA *ptr, int value);

enum {
	Brush_gpencil_vertex_tool_DRAW = 0,
	Brush_gpencil_vertex_tool_BLUR = 1,
	Brush_gpencil_vertex_tool_AVERAGE = 2,
	Brush_gpencil_vertex_tool_SMEAR = 4,
	Brush_gpencil_vertex_tool_REPLACE = 5,
};

int Brush_gpencil_vertex_tool_get(PointerRNA *ptr);
void Brush_gpencil_vertex_tool_set(PointerRNA *ptr, int value);

enum {
	Brush_gpencil_sculpt_tool_SMOOTH = 0,
	Brush_gpencil_sculpt_tool_THICKNESS = 1,
	Brush_gpencil_sculpt_tool_STRENGTH = 2,
	Brush_gpencil_sculpt_tool_RANDOMIZE = 7,
	Brush_gpencil_sculpt_tool_GRAB = 3,
	Brush_gpencil_sculpt_tool_PUSH = 4,
	Brush_gpencil_sculpt_tool_TWIST = 5,
	Brush_gpencil_sculpt_tool_PINCH = 6,
	Brush_gpencil_sculpt_tool_CLONE = 8,
};

int Brush_gpencil_sculpt_tool_get(PointerRNA *ptr);
void Brush_gpencil_sculpt_tool_set(PointerRNA *ptr, int value);

enum {
	Brush_gpencil_weight_tool_WEIGHT = 0,
	Brush_gpencil_weight_tool_BLUR = 1,
	Brush_gpencil_weight_tool_AVERAGE = 2,
	Brush_gpencil_weight_tool_SMEAR = 3,
};

int Brush_gpencil_weight_tool_get(PointerRNA *ptr);
void Brush_gpencil_weight_tool_set(PointerRNA *ptr, int value);

enum {
	Brush_curves_sculpt_tool_SELECTION_PAINT = 5,
	Brush_curves_sculpt_tool_ADD = 3,
	Brush_curves_sculpt_tool_DELETE = 1,
	Brush_curves_sculpt_tool_DENSITY = 9,
	Brush_curves_sculpt_tool_COMB = 0,
	Brush_curves_sculpt_tool_SNAKE_HOOK = 2,
	Brush_curves_sculpt_tool_GROW_SHRINK = 4,
	Brush_curves_sculpt_tool_PINCH = 6,
	Brush_curves_sculpt_tool_PUFF = 8,
	Brush_curves_sculpt_tool_SMOOTH = 7,
	Brush_curves_sculpt_tool_SLIDE = 10,
};

int Brush_curves_sculpt_tool_get(PointerRNA *ptr);
void Brush_curves_sculpt_tool_set(PointerRNA *ptr, int value);

PointerRNA Brush_automasking_cavity_curve_get(PointerRNA *ptr);

float Brush_automasking_cavity_factor_get(PointerRNA *ptr);
void Brush_automasking_cavity_factor_set(PointerRNA *ptr, float value);

bool Brush_use_automasking_cavity_get(PointerRNA *ptr);
void Brush_use_automasking_cavity_set(PointerRNA *ptr, bool value);

float Brush_cloth_damping_get(PointerRNA *ptr);
void Brush_cloth_damping_set(PointerRNA *ptr, float value);

float Brush_cloth_mass_get(PointerRNA *ptr);
void Brush_cloth_mass_set(PointerRNA *ptr, float value);

void Brush_color_get(PointerRNA *ptr, float values[3]);
void Brush_color_set(PointerRNA *ptr, const float values[3]);

enum {
	Brush_color_type_COLOR = 0,
	Brush_color_type_GRADIENT = 2097152,
};

int Brush_color_type_get(PointerRNA *ptr);
void Brush_color_type_set(PointerRNA *ptr, int value);

bool Brush_use_connected_only_get(PointerRNA *ptr);
void Brush_use_connected_only_set(PointerRNA *ptr, bool value);

float Brush_crease_pinch_factor_get(PointerRNA *ptr);
void Brush_crease_pinch_factor_set(PointerRNA *ptr, float value);

bool Brush_use_curve_get(PointerRNA *ptr);
void Brush_use_curve_set(PointerRNA *ptr, bool value);

PointerRNA Brush_curve_get(PointerRNA *ptr);

enum {
	Brush_curve_preset_CUSTOM = 0,
	Brush_curve_preset_SMOOTH = 1,
	Brush_curve_preset_SMOOTHER = 9,
	Brush_curve_preset_SPHERE = 2,
	Brush_curve_preset_ROOT = 3,
	Brush_curve_preset_SHARP = 4,
	Brush_curve_preset_LIN = 5,
	Brush_curve_preset_POW4 = 6,
	Brush_curve_preset_INVSQUARE = 7,
	Brush_curve_preset_CONSTANT = 8,
};

int Brush_curve_preset_get(PointerRNA *ptr);
void Brush_curve_preset_set(PointerRNA *ptr, int value);

PointerRNA Brush_curves_sculpt_settings_get(PointerRNA *ptr);

bool Brush_use_automasking_custom_cavity_curve_get(PointerRNA *ptr);
void Brush_use_automasking_custom_cavity_curve_set(PointerRNA *ptr, bool value);

bool Brush_use_custom_icon_get(PointerRNA *ptr);
void Brush_use_custom_icon_set(PointerRNA *ptr, bool value);

int Brush_dash_samples_get(PointerRNA *ptr);
void Brush_dash_samples_set(PointerRNA *ptr, int value);

float Brush_dash_ratio_get(PointerRNA *ptr);
void Brush_dash_ratio_set(PointerRNA *ptr, float value);

enum {
	Brush_elastic_deform_type_GRAB = 0,
	Brush_elastic_deform_type_GRAB_BISCALE = 1,
	Brush_elastic_deform_type_GRAB_TRISCALE = 2,
	Brush_elastic_deform_type_SCALE = 3,
	Brush_elastic_deform_type_TWIST = 4,
};

int Brush_elastic_deform_type_get(PointerRNA *ptr);
void Brush_elastic_deform_type_set(PointerRNA *ptr, int value);

enum {
	Brush_snake_hook_deform_type_FALLOFF = 0,
	Brush_snake_hook_deform_type_ELASTIC = 1,
};

int Brush_snake_hook_deform_type_get(PointerRNA *ptr);
void Brush_snake_hook_deform_type_set(PointerRNA *ptr, int value);

enum {
	Brush_cloth_deform_type_DRAG = 0,
	Brush_cloth_deform_type_PUSH = 1,
	Brush_cloth_deform_type_PINCH_POINT = 3,
	Brush_cloth_deform_type_PINCH_PERPENDICULAR = 4,
	Brush_cloth_deform_type_INFLATE = 5,
	Brush_cloth_deform_type_GRAB = 2,
	Brush_cloth_deform_type_EXPAND = 6,
	Brush_cloth_deform_type_SNAKE_HOOK = 7,
};

int Brush_cloth_deform_type_get(PointerRNA *ptr);
void Brush_cloth_deform_type_set(PointerRNA *ptr, int value);

enum {
	Brush_smooth_deform_type_LAPLACIAN = 0,
	Brush_smooth_deform_type_SURFACE = 1,
};

int Brush_smooth_deform_type_get(PointerRNA *ptr);
void Brush_smooth_deform_type_set(PointerRNA *ptr, int value);

enum {
	Brush_smear_deform_type_DRAG = 0,
	Brush_smear_deform_type_PINCH = 1,
	Brush_smear_deform_type_EXPAND = 2,
};

int Brush_smear_deform_type_get(PointerRNA *ptr);
void Brush_smear_deform_type_set(PointerRNA *ptr, int value);

enum {
	Brush_slide_deform_type_DRAG = 0,
	Brush_slide_deform_type_PINCH = 1,
	Brush_slide_deform_type_EXPAND = 2,
};

int Brush_slide_deform_type_get(PointerRNA *ptr);
void Brush_slide_deform_type_set(PointerRNA *ptr, int value);

enum {
	Brush_boundary_deform_type_BEND = 0,
	Brush_boundary_deform_type_EXPAND = 1,
	Brush_boundary_deform_type_INFLATE = 2,
	Brush_boundary_deform_type_GRAB = 3,
	Brush_boundary_deform_type_TWIST = 4,
	Brush_boundary_deform_type_SMOOTH = 5,
};

int Brush_boundary_deform_type_get(PointerRNA *ptr);
void Brush_boundary_deform_type_set(PointerRNA *ptr, int value);

enum {
	Brush_pose_deform_type_ROTATE_TWIST = 0,
	Brush_pose_deform_type_SCALE_TRANSLATE = 1,
	Brush_pose_deform_type_SQUASH_STRETCH = 2,
};

int Brush_pose_deform_type_get(PointerRNA *ptr);
void Brush_pose_deform_type_set(PointerRNA *ptr, int value);

enum {
	Brush_deform_target_GEOMETRY = 0,
	Brush_deform_target_CLOTH_SIM = 1,
};

int Brush_deform_target_get(PointerRNA *ptr);
void Brush_deform_target_set(PointerRNA *ptr, int value);

float Brush_density_get(PointerRNA *ptr);
void Brush_density_set(PointerRNA *ptr, float value);

float Brush_plane_depth_get(PointerRNA *ptr);
void Brush_plane_depth_set(PointerRNA *ptr, float value);

enum {
	Brush_direction_ADD = 0,
	Brush_direction_SUBTRACT = 512,
};

int Brush_direction_get(PointerRNA *ptr);
void Brush_direction_set(PointerRNA *ptr, int value);

bool Brush_use_multiplane_scrape_dynamic_get(PointerRNA *ptr);
void Brush_use_multiplane_scrape_dynamic_set(PointerRNA *ptr, bool value);

bool Brush_use_edge_to_edge_get(PointerRNA *ptr);
void Brush_use_edge_to_edge_set(PointerRNA *ptr, bool value);

bool Brush_use_cloth_collision_get(PointerRNA *ptr);
void Brush_use_cloth_collision_set(PointerRNA *ptr, bool value);

bool Brush_use_automasking_face_sets_get(PointerRNA *ptr);
void Brush_use_automasking_face_sets_set(PointerRNA *ptr, bool value);

bool Brush_use_automasking_boundary_face_sets_get(PointerRNA *ptr);
void Brush_use_automasking_boundary_face_sets_set(PointerRNA *ptr, bool value);

float Brush_falloff_angle_get(PointerRNA *ptr);
void Brush_falloff_angle_set(PointerRNA *ptr, float value);

enum {
	Brush_falloff_shape_SPHERE = 0,
	Brush_falloff_shape_PROJECTED = 1,
};

int Brush_falloff_shape_get(PointerRNA *ptr);
void Brush_falloff_shape_set(PointerRNA *ptr, int value);

float Brush_fill_threshold_get(PointerRNA *ptr);
void Brush_fill_threshold_set(PointerRNA *ptr, float value);

float Brush_flow_get(PointerRNA *ptr);
void Brush_flow_set(PointerRNA *ptr, float value);

enum {
	Brush_cloth_force_falloff_type_RADIAL = 0,
	Brush_cloth_force_falloff_type_PLANE = 1,
};

int Brush_cloth_force_falloff_type_get(PointerRNA *ptr);
void Brush_cloth_force_falloff_type_set(PointerRNA *ptr, int value);

PointerRNA Brush_gpencil_settings_get(PointerRNA *ptr);

bool Brush_use_grab_active_vertex_get(PointerRNA *ptr);
void Brush_use_grab_active_vertex_set(PointerRNA *ptr, bool value);

bool Brush_use_grab_silhouette_get(PointerRNA *ptr);
void Brush_use_grab_silhouette_set(PointerRNA *ptr, bool value);

PointerRNA Brush_gradient_get(PointerRNA *ptr);

enum {
	Brush_gradient_fill_mode_LINEAR = 0,
	Brush_gradient_fill_mode_RADIAL = 1,
};

int Brush_gradient_fill_mode_get(PointerRNA *ptr);
void Brush_gradient_fill_mode_set(PointerRNA *ptr, int value);

int Brush_grad_spacing_get(PointerRNA *ptr);
void Brush_grad_spacing_set(PointerRNA *ptr, int value);

enum {
	Brush_gradient_stroke_mode_PRESSURE = 0,
	Brush_gradient_stroke_mode_SPACING_REPEAT = 1,
	Brush_gradient_stroke_mode_SPACING_CLAMP = 2,
};

int Brush_gradient_stroke_mode_get(PointerRNA *ptr);
void Brush_gradient_stroke_mode_set(PointerRNA *ptr, int value);

float Brush_hardness_get(PointerRNA *ptr);
void Brush_hardness_set(PointerRNA *ptr, float value);

bool Brush_has_unsaved_changes_get(PointerRNA *ptr);
void Brush_has_unsaved_changes_set(PointerRNA *ptr, bool value);

float Brush_plane_height_get(PointerRNA *ptr);
void Brush_plane_height_set(PointerRNA *ptr, float value);

float Brush_hue_jitter_get(PointerRNA *ptr);
void Brush_hue_jitter_set(PointerRNA *ptr, float value);

PointerRNA Brush_image_paint_capabilities_get(PointerRNA *ptr);

int Brush_input_samples_get(PointerRNA *ptr);
void Brush_input_samples_set(PointerRNA *ptr, int value);

bool Brush_use_inverse_smooth_pressure_get(PointerRNA *ptr);
void Brush_use_inverse_smooth_pressure_set(PointerRNA *ptr, bool value);

enum {
	Brush_plane_inversion_mode_INVERT_DISPLACEMENT = 0,
	Brush_plane_inversion_mode_SWAP_DEPTH_AND_HEIGHT = 1,
};

int Brush_plane_inversion_mode_get(PointerRNA *ptr);
void Brush_plane_inversion_mode_set(PointerRNA *ptr, int value);

bool Brush_invert_density_pressure_get(PointerRNA *ptr);
void Brush_invert_density_pressure_set(PointerRNA *ptr, bool value);

bool Brush_invert_flow_pressure_get(PointerRNA *ptr);
void Brush_invert_flow_pressure_set(PointerRNA *ptr, bool value);

bool Brush_invert_hardness_pressure_get(PointerRNA *ptr);
void Brush_invert_hardness_pressure_set(PointerRNA *ptr, bool value);

bool Brush_invert_wet_mix_pressure_get(PointerRNA *ptr);
void Brush_invert_wet_mix_pressure_set(PointerRNA *ptr, bool value);

bool Brush_invert_wet_persistence_pressure_get(PointerRNA *ptr);
void Brush_invert_wet_persistence_pressure_set(PointerRNA *ptr, bool value);

bool Brush_invert_to_scrape_fill_get(PointerRNA *ptr);
void Brush_invert_to_scrape_fill_set(PointerRNA *ptr, bool value);

bool Brush_use_automasking_cavity_inverted_get(PointerRNA *ptr);
void Brush_use_automasking_cavity_inverted_set(PointerRNA *ptr, bool value);

int Brush_surface_smooth_iterations_get(PointerRNA *ptr);
void Brush_surface_smooth_iterations_set(PointerRNA *ptr, int value);

float Brush_jitter_get(PointerRNA *ptr);
void Brush_jitter_set(PointerRNA *ptr, float value);

int Brush_jitter_absolute_get(PointerRNA *ptr);
void Brush_jitter_absolute_set(PointerRNA *ptr, int value);

bool Brush_use_pressure_jitter_get(PointerRNA *ptr);
void Brush_use_pressure_jitter_set(PointerRNA *ptr, bool value);

enum {
	Brush_jitter_unit_VIEW = 1073741824,
	Brush_jitter_unit_BRUSH = 0,
};

int Brush_jitter_unit_get(PointerRNA *ptr);
void Brush_jitter_unit_set(PointerRNA *ptr, int value);

bool Brush_use_pose_ik_anchored_get(PointerRNA *ptr);
void Brush_use_pose_ik_anchored_set(PointerRNA *ptr, bool value);

int Brush_blur_kernel_radius_get(PointerRNA *ptr);
void Brush_blur_kernel_radius_set(PointerRNA *ptr, int value);

bool Brush_use_line_get(PointerRNA *ptr);
void Brush_use_line_set(PointerRNA *ptr, bool value);

bool Brush_use_pose_lock_rotation_get(PointerRNA *ptr);
void Brush_use_pose_lock_rotation_set(PointerRNA *ptr, bool value);

enum {
	Brush_use_pressure_masking_NONE = 0,
	Brush_use_pressure_masking_RAMP = 2,
	Brush_use_pressure_masking_CUTOFF = 4,
};

int Brush_use_pressure_masking_get(PointerRNA *ptr);
void Brush_use_pressure_masking_set(PointerRNA *ptr, int value);

void Brush_mask_stencil_dimension_get(PointerRNA *ptr, float values[2]);
void Brush_mask_stencil_dimension_set(PointerRNA *ptr, const float values[2]);

void Brush_mask_stencil_pos_get(PointerRNA *ptr, float values[2]);
void Brush_mask_stencil_pos_set(PointerRNA *ptr, const float values[2]);

PointerRNA Brush_mask_texture_get(PointerRNA *ptr);

int Brush_mask_overlay_alpha_get(PointerRNA *ptr);
void Brush_mask_overlay_alpha_set(PointerRNA *ptr, int value);

int Brush_cursor_overlay_alpha_get(PointerRNA *ptr);
void Brush_cursor_overlay_alpha_set(PointerRNA *ptr, int value);

PointerRNA Brush_mask_texture_slot_get(PointerRNA *ptr);

enum {
	Brush_mask_tool_DRAW = 0,
	Brush_mask_tool_SMOOTH = 1,
};

int Brush_mask_tool_get(PointerRNA *ptr);
void Brush_mask_tool_set(PointerRNA *ptr, int value);

float Brush_disconnected_distance_max_get(PointerRNA *ptr);
void Brush_disconnected_distance_max_set(PointerRNA *ptr, float value);

bool Brush_use_automasking_boundary_edges_get(PointerRNA *ptr);
void Brush_use_automasking_boundary_edges_set(PointerRNA *ptr, bool value);

float Brush_normal_radius_factor_get(PointerRNA *ptr);
void Brush_normal_radius_factor_set(PointerRNA *ptr, float value);

float Brush_normal_weight_get(PointerRNA *ptr);
void Brush_normal_weight_set(PointerRNA *ptr, float value);

bool Brush_use_automasking_view_occlusion_get(PointerRNA *ptr);
void Brush_use_automasking_view_occlusion_set(PointerRNA *ptr, bool value);

bool Brush_use_original_normal_get(PointerRNA *ptr);
void Brush_use_original_normal_set(PointerRNA *ptr, bool value);

bool Brush_use_original_plane_get(PointerRNA *ptr);
void Brush_use_original_plane_set(PointerRNA *ptr, bool value);

bool Brush_use_cursor_overlay_override_get(PointerRNA *ptr);
void Brush_use_cursor_overlay_override_set(PointerRNA *ptr, bool value);

bool Brush_use_primary_overlay_override_get(PointerRNA *ptr);
void Brush_use_primary_overlay_override_set(PointerRNA *ptr, bool value);

bool Brush_use_secondary_overlay_override_get(PointerRNA *ptr);
void Brush_use_secondary_overlay_override_set(PointerRNA *ptr, bool value);

PointerRNA Brush_paint_curve_get(PointerRNA *ptr);

float Brush_surface_smooth_current_vertex_get(PointerRNA *ptr);
void Brush_surface_smooth_current_vertex_set(PointerRNA *ptr, float value);

bool Brush_use_persistent_get(PointerRNA *ptr);
void Brush_use_persistent_set(PointerRNA *ptr, bool value);

bool Brush_use_cloth_pin_simulation_boundary_get(PointerRNA *ptr);
void Brush_use_cloth_pin_simulation_boundary_set(PointerRNA *ptr, bool value);

float Brush_multiplane_scrape_angle_get(PointerRNA *ptr);
void Brush_multiplane_scrape_angle_set(PointerRNA *ptr, float value);

float Brush_plane_offset_get(PointerRNA *ptr);
void Brush_plane_offset_set(PointerRNA *ptr, float value);

bool Brush_use_offset_pressure_get(PointerRNA *ptr);
void Brush_use_offset_pressure_set(PointerRNA *ptr, bool value);

float Brush_plane_trim_get(PointerRNA *ptr);
void Brush_plane_trim_set(PointerRNA *ptr, float value);

int Brush_pose_ik_segments_get(PointerRNA *ptr);
void Brush_pose_ik_segments_set(PointerRNA *ptr, int value);

float Brush_pose_offset_get(PointerRNA *ptr);
void Brush_pose_offset_set(PointerRNA *ptr, float value);

int Brush_automasking_boundary_edges_propagation_steps_get(PointerRNA *ptr);
void Brush_automasking_boundary_edges_propagation_steps_set(PointerRNA *ptr, int value);

int Brush_size_get(PointerRNA *ptr);
void Brush_size_set(PointerRNA *ptr, int value);

enum {
	Brush_use_locked_size_VIEW = 0,
	Brush_use_locked_size_SCENE = 1048576,
};

int Brush_use_locked_size_get(PointerRNA *ptr);
void Brush_use_locked_size_set(PointerRNA *ptr, int value);

float Brush_rake_factor_get(PointerRNA *ptr);
void Brush_rake_factor_set(PointerRNA *ptr, float value);

PointerRNA Brush_curve_random_hue_get(PointerRNA *ptr);

PointerRNA Brush_curve_random_saturation_get(PointerRNA *ptr);

PointerRNA Brush_curve_random_value_get(PointerRNA *ptr);

float Brush_rate_get(PointerRNA *ptr);
void Brush_rate_set(PointerRNA *ptr, float value);

bool Brush_use_restore_mesh_get(PointerRNA *ptr);
void Brush_use_restore_mesh_set(PointerRNA *ptr, bool value);

enum {
	Brush_pose_origin_type_TOPOLOGY = 0,
	Brush_pose_origin_type_FACE_SETS = 1,
	Brush_pose_origin_type_FACE_SETS_FK = 2,
};

int Brush_pose_origin_type_get(PointerRNA *ptr);
void Brush_pose_origin_type_set(PointerRNA *ptr, int value);

float Brush_saturation_jitter_get(PointerRNA *ptr);
void Brush_saturation_jitter_set(PointerRNA *ptr, float value);

PointerRNA Brush_sculpt_capabilities_get(PointerRNA *ptr);

enum {
	Brush_sculpt_plane_AREA = 0,
	Brush_sculpt_plane_VIEW = 1,
	Brush_sculpt_plane_X = 2,
	Brush_sculpt_plane_Y = 3,
	Brush_sculpt_plane_Z = 4,
};

int Brush_sculpt_plane_get(PointerRNA *ptr);
void Brush_sculpt_plane_set(PointerRNA *ptr, int value);

void Brush_secondary_color_get(PointerRNA *ptr, float values[3]);
void Brush_secondary_color_set(PointerRNA *ptr, const float values[3]);

float Brush_surface_smooth_shape_preservation_get(PointerRNA *ptr);
void Brush_surface_smooth_shape_preservation_set(PointerRNA *ptr, float value);

float Brush_sharp_threshold_get(PointerRNA *ptr);
void Brush_sharp_threshold_set(PointerRNA *ptr, float value);

bool Brush_show_multiplane_scrape_planes_preview_get(PointerRNA *ptr);
void Brush_show_multiplane_scrape_planes_preview_set(PointerRNA *ptr, bool value);

enum {
	Brush_cloth_simulation_area_type_LOCAL = 0,
	Brush_cloth_simulation_area_type_GLOBAL = 1,
	Brush_cloth_simulation_area_type_DYNAMIC = 2,
};

int Brush_cloth_simulation_area_type_get(PointerRNA *ptr);
void Brush_cloth_simulation_area_type_set(PointerRNA *ptr, int value);

float Brush_cloth_sim_falloff_get(PointerRNA *ptr);
void Brush_cloth_sim_falloff_set(PointerRNA *ptr, float value);

float Brush_cloth_sim_limit_get(PointerRNA *ptr);
void Brush_cloth_sim_limit_set(PointerRNA *ptr, float value);

bool Brush_use_pressure_size_get(PointerRNA *ptr);
void Brush_use_pressure_size_set(PointerRNA *ptr, bool value);

int Brush_pose_smooth_iterations_get(PointerRNA *ptr);
void Brush_pose_smooth_iterations_set(PointerRNA *ptr, int value);

bool Brush_use_smooth_stroke_get(PointerRNA *ptr);
void Brush_use_smooth_stroke_set(PointerRNA *ptr, bool value);

float Brush_smooth_stroke_factor_get(PointerRNA *ptr);
void Brush_smooth_stroke_factor_set(PointerRNA *ptr, float value);

int Brush_smooth_stroke_radius_get(PointerRNA *ptr);
void Brush_smooth_stroke_radius_set(PointerRNA *ptr, int value);

float Brush_cloth_constraint_softbody_strength_get(PointerRNA *ptr);
void Brush_cloth_constraint_softbody_strength_set(PointerRNA *ptr, float value);

bool Brush_use_space_get(PointerRNA *ptr);
void Brush_use_space_set(PointerRNA *ptr, bool value);

int Brush_spacing_get(PointerRNA *ptr);
void Brush_spacing_set(PointerRNA *ptr, int value);

enum {
	Brush_use_scene_spacing_VIEW = 0,
	Brush_use_scene_spacing_SCENE = 131072,
};

int Brush_use_scene_spacing_get(PointerRNA *ptr);
void Brush_use_scene_spacing_set(PointerRNA *ptr, int value);

bool Brush_use_pressure_spacing_get(PointerRNA *ptr);
void Brush_use_pressure_spacing_set(PointerRNA *ptr, bool value);

float Brush_stabilize_normal_get(PointerRNA *ptr);
void Brush_stabilize_normal_set(PointerRNA *ptr, float value);

float Brush_stabilize_plane_get(PointerRNA *ptr);
void Brush_stabilize_plane_set(PointerRNA *ptr, float value);

void Brush_stencil_dimension_get(PointerRNA *ptr, float values[2]);
void Brush_stencil_dimension_set(PointerRNA *ptr, const float values[2]);

void Brush_stencil_pos_get(PointerRNA *ptr, float values[2]);
void Brush_stencil_pos_set(PointerRNA *ptr, const float values[2]);

float Brush_strength_get(PointerRNA *ptr);
void Brush_strength_set(PointerRNA *ptr, float value);

bool Brush_use_pressure_strength_get(PointerRNA *ptr);
void Brush_use_pressure_strength_set(PointerRNA *ptr, bool value);

enum {
	Brush_stroke_method_DOTS = 0,
	Brush_stroke_method_DRAG_DOT = 8388608,
	Brush_stroke_method_SPACE = 1024,
	Brush_stroke_method_AIRBRUSH = 1,
	Brush_stroke_method_ANCHORED = 256,
	Brush_stroke_method_LINE = 536870912,
	Brush_stroke_method_CURVE = -2147483648,
};

int Brush_stroke_method_get(PointerRNA *ptr);
void Brush_stroke_method_set(PointerRNA *ptr, int value);

bool Brush_use_stroke_random_hue_get(PointerRNA *ptr);
void Brush_use_stroke_random_hue_set(PointerRNA *ptr, bool value);

bool Brush_use_stroke_random_sat_get(PointerRNA *ptr);
void Brush_use_stroke_random_sat_set(PointerRNA *ptr, bool value);

bool Brush_use_stroke_random_val_get(PointerRNA *ptr);
void Brush_use_stroke_random_val_set(PointerRNA *ptr, bool value);

void Brush_cursor_color_subtract_get(PointerRNA *ptr, float values[4]);
void Brush_cursor_color_subtract_set(PointerRNA *ptr, const float values[4]);

PointerRNA Brush_texture_get(PointerRNA *ptr);

int Brush_texture_overlay_alpha_get(PointerRNA *ptr);
void Brush_texture_overlay_alpha_set(PointerRNA *ptr, int value);

float Brush_texture_sample_bias_get(PointerRNA *ptr);
void Brush_texture_sample_bias_set(PointerRNA *ptr, float value);

PointerRNA Brush_texture_slot_get(PointerRNA *ptr);

float Brush_tilt_strength_factor_get(PointerRNA *ptr);
void Brush_tilt_strength_factor_set(PointerRNA *ptr, float value);

float Brush_tip_roundness_get(PointerRNA *ptr);
void Brush_tip_roundness_set(PointerRNA *ptr, float value);

float Brush_tip_scale_x_get(PointerRNA *ptr);
void Brush_tip_scale_x_set(PointerRNA *ptr, float value);

bool Brush_use_automasking_topology_get(PointerRNA *ptr);
void Brush_use_automasking_topology_set(PointerRNA *ptr, bool value);

float Brush_topology_rake_factor_get(PointerRNA *ptr);
void Brush_topology_rake_factor_set(PointerRNA *ptr, float value);

float Brush_unprojected_radius_get(PointerRNA *ptr);
void Brush_unprojected_radius_set(PointerRNA *ptr, float value);

bool Brush_use_color_jitter_get(PointerRNA *ptr);
void Brush_use_color_jitter_set(PointerRNA *ptr, bool value);

bool Brush_use_cursor_overlay_get(PointerRNA *ptr);
void Brush_use_cursor_overlay_set(PointerRNA *ptr, bool value);

bool Brush_use_frontface_get(PointerRNA *ptr);
void Brush_use_frontface_set(PointerRNA *ptr, bool value);

bool Brush_use_frontface_falloff_get(PointerRNA *ptr);
void Brush_use_frontface_falloff_set(PointerRNA *ptr, bool value);

bool Brush_use_paint_grease_pencil_get(PointerRNA *ptr);
void Brush_use_paint_grease_pencil_set(PointerRNA *ptr, bool value);

bool Brush_use_plane_trim_get(PointerRNA *ptr);
void Brush_use_plane_trim_set(PointerRNA *ptr, bool value);

bool Brush_use_random_press_hue_get(PointerRNA *ptr);
void Brush_use_random_press_hue_set(PointerRNA *ptr, bool value);

bool Brush_use_random_press_sat_get(PointerRNA *ptr);
void Brush_use_random_press_sat_set(PointerRNA *ptr, bool value);

bool Brush_use_random_press_val_get(PointerRNA *ptr);
void Brush_use_random_press_val_set(PointerRNA *ptr, bool value);

bool Brush_use_density_pressure_get(PointerRNA *ptr);
void Brush_use_density_pressure_set(PointerRNA *ptr, bool value);

bool Brush_use_flow_pressure_get(PointerRNA *ptr);
void Brush_use_flow_pressure_set(PointerRNA *ptr, bool value);

bool Brush_use_hardness_pressure_get(PointerRNA *ptr);
void Brush_use_hardness_pressure_set(PointerRNA *ptr, bool value);

bool Brush_use_wet_mix_pressure_get(PointerRNA *ptr);
void Brush_use_wet_mix_pressure_set(PointerRNA *ptr, bool value);

bool Brush_use_wet_persistence_pressure_get(PointerRNA *ptr);
void Brush_use_wet_persistence_pressure_set(PointerRNA *ptr, bool value);

bool Brush_use_paint_sculpt_get(PointerRNA *ptr);
void Brush_use_paint_sculpt_set(PointerRNA *ptr, bool value);

bool Brush_use_paint_sculpt_curves_get(PointerRNA *ptr);
void Brush_use_paint_sculpt_curves_set(PointerRNA *ptr, bool value);

bool Brush_use_paint_image_get(PointerRNA *ptr);
void Brush_use_paint_image_set(PointerRNA *ptr, bool value);

bool Brush_use_primary_overlay_get(PointerRNA *ptr);
void Brush_use_primary_overlay_set(PointerRNA *ptr, bool value);

bool Brush_use_secondary_overlay_get(PointerRNA *ptr);
void Brush_use_secondary_overlay_set(PointerRNA *ptr, bool value);

bool Brush_use_paint_uv_sculpt_get(PointerRNA *ptr);
void Brush_use_paint_uv_sculpt_set(PointerRNA *ptr, bool value);

bool Brush_use_paint_vertex_get(PointerRNA *ptr);
void Brush_use_paint_vertex_set(PointerRNA *ptr, bool value);

bool Brush_use_vertex_grease_pencil_get(PointerRNA *ptr);
void Brush_use_vertex_grease_pencil_set(PointerRNA *ptr, bool value);

bool Brush_use_paint_weight_get(PointerRNA *ptr);
void Brush_use_paint_weight_set(PointerRNA *ptr, bool value);

float Brush_value_jitter_get(PointerRNA *ptr);
void Brush_value_jitter_set(PointerRNA *ptr, float value);

bool Brush_use_color_as_displacement_get(PointerRNA *ptr);
void Brush_use_color_as_displacement_set(PointerRNA *ptr, bool value);

PointerRNA Brush_vertex_paint_capabilities_get(PointerRNA *ptr);

bool Brush_use_automasking_view_normal_get(PointerRNA *ptr);
void Brush_use_automasking_view_normal_set(PointerRNA *ptr, bool value);

float Brush_automasking_view_normal_falloff_get(PointerRNA *ptr);
void Brush_automasking_view_normal_falloff_set(PointerRNA *ptr, float value);

float Brush_automasking_view_normal_limit_get(PointerRNA *ptr);
void Brush_automasking_view_normal_limit_set(PointerRNA *ptr, float value);

float Brush_elastic_deform_volume_preservation_get(PointerRNA *ptr);
void Brush_elastic_deform_volume_preservation_set(PointerRNA *ptr, float value);

float Brush_weight_get(PointerRNA *ptr);
void Brush_weight_set(PointerRNA *ptr, float value);

PointerRNA Brush_weight_paint_capabilities_get(PointerRNA *ptr);

float Brush_wet_mix_get(PointerRNA *ptr);
void Brush_wet_mix_set(PointerRNA *ptr, float value);

float Brush_wet_paint_radius_factor_get(PointerRNA *ptr);
void Brush_wet_paint_radius_factor_set(PointerRNA *ptr, float value);

float Brush_wet_persistence_get(PointerRNA *ptr);
void Brush_wet_persistence_set(PointerRNA *ptr, float value);

/**************** Brush Capabilities ****************/

extern StructRNA RNA_BrushCapabilities;

PointerRNA BrushCapabilities_rna_type_get(PointerRNA *ptr);

bool BrushCapabilities_has_overlay_get(PointerRNA *ptr);
void BrushCapabilities_has_overlay_set(PointerRNA *ptr, bool value);

bool BrushCapabilities_has_random_texture_angle_get(PointerRNA *ptr);
void BrushCapabilities_has_random_texture_angle_set(PointerRNA *ptr, bool value);

bool BrushCapabilities_has_smooth_stroke_get(PointerRNA *ptr);
void BrushCapabilities_has_smooth_stroke_set(PointerRNA *ptr, bool value);

bool BrushCapabilities_has_spacing_get(PointerRNA *ptr);
void BrushCapabilities_has_spacing_set(PointerRNA *ptr, bool value);

/**************** Image Paint Capabilities ****************/

extern StructRNA RNA_BrushCapabilitiesImagePaint;

PointerRNA BrushCapabilitiesImagePaint_rna_type_get(PointerRNA *ptr);

bool BrushCapabilitiesImagePaint_has_accumulate_get(PointerRNA *ptr);
void BrushCapabilitiesImagePaint_has_accumulate_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesImagePaint_has_color_get(PointerRNA *ptr);
void BrushCapabilitiesImagePaint_has_color_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesImagePaint_has_radius_get(PointerRNA *ptr);
void BrushCapabilitiesImagePaint_has_radius_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesImagePaint_has_space_attenuation_get(PointerRNA *ptr);
void BrushCapabilitiesImagePaint_has_space_attenuation_set(PointerRNA *ptr, bool value);

/**************** Sculpt Capabilities ****************/

extern StructRNA RNA_BrushCapabilitiesSculpt;

PointerRNA BrushCapabilitiesSculpt_rna_type_get(PointerRNA *ptr);

bool BrushCapabilitiesSculpt_has_accumulate_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_accumulate_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_auto_smooth_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_auto_smooth_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_color_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_color_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_normal_weight_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_normal_weight_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_direction_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_direction_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_dyntopo_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_dyntopo_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_gravity_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_gravity_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_height_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_height_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_jitter_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_jitter_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_persistence_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_persistence_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_pinch_factor_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_pinch_factor_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_plane_depth_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_plane_depth_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_plane_height_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_plane_height_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_plane_offset_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_plane_offset_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_rake_factor_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_rake_factor_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_random_texture_angle_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_random_texture_angle_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_sculpt_plane_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_sculpt_plane_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_secondary_color_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_secondary_color_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_smooth_stroke_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_smooth_stroke_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_space_attenuation_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_space_attenuation_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_strength_pressure_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_strength_pressure_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_tilt_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_tilt_set(PointerRNA *ptr, bool value);

bool BrushCapabilitiesSculpt_has_topology_rake_get(PointerRNA *ptr);
void BrushCapabilitiesSculpt_has_topology_rake_set(PointerRNA *ptr, bool value);

/**************** Vertex Paint Capabilities ****************/

extern StructRNA RNA_BrushCapabilitiesVertexPaint;

PointerRNA BrushCapabilitiesVertexPaint_rna_type_get(PointerRNA *ptr);

bool BrushCapabilitiesVertexPaint_has_color_get(PointerRNA *ptr);
void BrushCapabilitiesVertexPaint_has_color_set(PointerRNA *ptr, bool value);

/**************** Weight Paint Capabilities ****************/

extern StructRNA RNA_BrushCapabilitiesWeightPaint;

PointerRNA BrushCapabilitiesWeightPaint_rna_type_get(PointerRNA *ptr);

bool BrushCapabilitiesWeightPaint_has_weight_get(PointerRNA *ptr);
void BrushCapabilitiesWeightPaint_has_weight_set(PointerRNA *ptr, bool value);

/**************** Curves Sculpt Brush Settings ****************/

extern StructRNA RNA_BrushCurvesSculptSettings;

PointerRNA BrushCurvesSculptSettings_rna_type_get(PointerRNA *ptr);

int BrushCurvesSculptSettings_add_amount_get(PointerRNA *ptr);
void BrushCurvesSculptSettings_add_amount_set(PointerRNA *ptr, int value);

float BrushCurvesSculptSettings_curve_length_get(PointerRNA *ptr);
void BrushCurvesSculptSettings_curve_length_set(PointerRNA *ptr, float value);

PointerRNA BrushCurvesSculptSettings_curve_parameter_falloff_get(PointerRNA *ptr);

float BrushCurvesSculptSettings_curve_radius_get(PointerRNA *ptr);
void BrushCurvesSculptSettings_curve_radius_set(PointerRNA *ptr, float value);

int BrushCurvesSculptSettings_density_add_attempts_get(PointerRNA *ptr);
void BrushCurvesSculptSettings_density_add_attempts_set(PointerRNA *ptr, int value);

enum {
	BrushCurvesSculptSettings_density_mode_AUTO = 0,
	BrushCurvesSculptSettings_density_mode_ADD = 1,
	BrushCurvesSculptSettings_density_mode_REMOVE = 2,
};

int BrushCurvesSculptSettings_density_mode_get(PointerRNA *ptr);
void BrushCurvesSculptSettings_density_mode_set(PointerRNA *ptr, int value);

bool BrushCurvesSculptSettings_use_length_interpolate_get(PointerRNA *ptr);
void BrushCurvesSculptSettings_use_length_interpolate_set(PointerRNA *ptr, bool value);

bool BrushCurvesSculptSettings_use_point_count_interpolate_get(PointerRNA *ptr);
void BrushCurvesSculptSettings_use_point_count_interpolate_set(PointerRNA *ptr, bool value);

bool BrushCurvesSculptSettings_use_radius_interpolate_get(PointerRNA *ptr);
void BrushCurvesSculptSettings_use_radius_interpolate_set(PointerRNA *ptr, bool value);

bool BrushCurvesSculptSettings_use_shape_interpolate_get(PointerRNA *ptr);
void BrushCurvesSculptSettings_use_shape_interpolate_set(PointerRNA *ptr, bool value);

float BrushCurvesSculptSettings_minimum_distance_get(PointerRNA *ptr);
void BrushCurvesSculptSettings_minimum_distance_set(PointerRNA *ptr, float value);

float BrushCurvesSculptSettings_minimum_length_get(PointerRNA *ptr);
void BrushCurvesSculptSettings_minimum_length_set(PointerRNA *ptr, float value);

int BrushCurvesSculptSettings_points_per_curve_get(PointerRNA *ptr);
void BrushCurvesSculptSettings_points_per_curve_set(PointerRNA *ptr, int value);

bool BrushCurvesSculptSettings_use_uniform_scale_get(PointerRNA *ptr);
void BrushCurvesSculptSettings_use_uniform_scale_set(PointerRNA *ptr, bool value);

/**************** Grease Pencil Brush Settings ****************/

extern StructRNA RNA_BrushGpencilSettings;

PointerRNA BrushGpencilSettings_rna_type_get(PointerRNA *ptr);

bool BrushGpencilSettings_use_active_layer_only_get(PointerRNA *ptr);
void BrushGpencilSettings_use_active_layer_only_set(PointerRNA *ptr, bool value);

float BrushGpencilSettings_active_smooth_factor_get(PointerRNA *ptr);
void BrushGpencilSettings_active_smooth_factor_set(PointerRNA *ptr, float value);

bool BrushGpencilSettings_use_edit_position_get(PointerRNA *ptr);
void BrushGpencilSettings_use_edit_position_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_edit_strength_get(PointerRNA *ptr);
void BrushGpencilSettings_use_edit_strength_set(PointerRNA *ptr, bool value);

float BrushGpencilSettings_eraser_strength_factor_get(PointerRNA *ptr);
void BrushGpencilSettings_eraser_strength_factor_set(PointerRNA *ptr, float value);

float BrushGpencilSettings_eraser_thickness_factor_get(PointerRNA *ptr);
void BrushGpencilSettings_eraser_thickness_factor_set(PointerRNA *ptr, float value);

bool BrushGpencilSettings_use_edit_thickness_get(PointerRNA *ptr);
void BrushGpencilSettings_use_edit_thickness_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_edit_uv_get(PointerRNA *ptr);
void BrushGpencilSettings_use_edit_uv_set(PointerRNA *ptr, bool value);

float BrushGpencilSettings_angle_get(PointerRNA *ptr);
void BrushGpencilSettings_angle_set(PointerRNA *ptr, float value);

float BrushGpencilSettings_angle_factor_get(PointerRNA *ptr);
void BrushGpencilSettings_angle_factor_set(PointerRNA *ptr, float value);

void BrushGpencilSettings_aspect_get(PointerRNA *ptr, float values[2]);
void BrushGpencilSettings_aspect_set(PointerRNA *ptr, const float values[2]);

bool BrushGpencilSettings_use_auto_remove_fill_guides_get(PointerRNA *ptr);
void BrushGpencilSettings_use_auto_remove_fill_guides_set(PointerRNA *ptr, bool value);

enum {
	BrushGpencilSettings_caps_type_ROUND = 0,
	BrushGpencilSettings_caps_type_FLAT = 1,
};

int BrushGpencilSettings_caps_type_get(PointerRNA *ptr);
void BrushGpencilSettings_caps_type_set(PointerRNA *ptr, int value);

enum {
	BrushGpencilSettings_fill_extend_mode_EXTEND = 0,
	BrushGpencilSettings_fill_extend_mode_RADIUS = 1,
};

int BrushGpencilSettings_fill_extend_mode_get(PointerRNA *ptr);
void BrushGpencilSettings_fill_extend_mode_set(PointerRNA *ptr, int value);

float BrushGpencilSettings_extend_stroke_factor_get(PointerRNA *ptr);
void BrushGpencilSettings_extend_stroke_factor_set(PointerRNA *ptr, float value);

PointerRNA BrushGpencilSettings_curve_jitter_get(PointerRNA *ptr);

PointerRNA BrushGpencilSettings_curve_sensitivity_get(PointerRNA *ptr);

PointerRNA BrushGpencilSettings_curve_strength_get(PointerRNA *ptr);

int BrushGpencilSettings_dilate_get(PointerRNA *ptr);
void BrushGpencilSettings_dilate_set(PointerRNA *ptr, int value);

enum {
	BrushGpencilSettings_fill_direction_NORMAL = 0,
	BrushGpencilSettings_fill_direction_INVERT = 512,
};

int BrushGpencilSettings_fill_direction_get(PointerRNA *ptr);
void BrushGpencilSettings_fill_direction_set(PointerRNA *ptr, int value);

float BrushGpencilSettings_hardness_get(PointerRNA *ptr);
void BrushGpencilSettings_hardness_set(PointerRNA *ptr, float value);

float BrushGpencilSettings_random_hue_factor_get(PointerRNA *ptr);
void BrushGpencilSettings_random_hue_factor_set(PointerRNA *ptr, float value);

int BrushGpencilSettings_input_samples_get(PointerRNA *ptr);
void BrushGpencilSettings_input_samples_set(PointerRNA *ptr, int value);

int BrushGpencilSettings_pen_smooth_steps_get(PointerRNA *ptr);
void BrushGpencilSettings_pen_smooth_steps_set(PointerRNA *ptr, int value);

float BrushGpencilSettings_pen_jitter_get(PointerRNA *ptr);
void BrushGpencilSettings_pen_jitter_set(PointerRNA *ptr, float value);

bool BrushGpencilSettings_use_keep_caps_eraser_get(PointerRNA *ptr);
void BrushGpencilSettings_use_keep_caps_eraser_set(PointerRNA *ptr, bool value);

enum {
	BrushGpencilSettings_fill_layer_mode_VISIBLE = 0,
	BrushGpencilSettings_fill_layer_mode_ACTIVE = 1,
	BrushGpencilSettings_fill_layer_mode_ABOVE = 4,
	BrushGpencilSettings_fill_layer_mode_BELOW = 5,
	BrushGpencilSettings_fill_layer_mode_ALL_ABOVE = 2,
	BrushGpencilSettings_fill_layer_mode_ALL_BELOW = 3,
};

int BrushGpencilSettings_fill_layer_mode_get(PointerRNA *ptr);
void BrushGpencilSettings_fill_layer_mode_set(PointerRNA *ptr, int value);

bool BrushGpencilSettings_use_fill_limit_get(PointerRNA *ptr);
void BrushGpencilSettings_use_fill_limit_set(PointerRNA *ptr, bool value);

PointerRNA BrushGpencilSettings_material_get(PointerRNA *ptr);

PointerRNA BrushGpencilSettings_material_alt_get(PointerRNA *ptr);

enum {
	BrushGpencilSettings_eraser_mode_SOFT = 0,
	BrushGpencilSettings_eraser_mode_HARD = 1,
	BrushGpencilSettings_eraser_mode_STROKE = 2,
};

int BrushGpencilSettings_eraser_mode_get(PointerRNA *ptr);
void BrushGpencilSettings_eraser_mode_set(PointerRNA *ptr, int value);

enum {
	BrushGpencilSettings_fill_draw_mode_BOTH = 0,
	BrushGpencilSettings_fill_draw_mode_STROKE = 1,
	BrushGpencilSettings_fill_draw_mode_CONTROL = 2,
};

int BrushGpencilSettings_fill_draw_mode_get(PointerRNA *ptr);
void BrushGpencilSettings_fill_draw_mode_set(PointerRNA *ptr, int value);

enum {
	BrushGpencilSettings_brush_draw_mode_ACTIVE = 0,
	BrushGpencilSettings_brush_draw_mode_MATERIAL = 1,
	BrushGpencilSettings_brush_draw_mode_VERTEXCOLOR = 2,
};

int BrushGpencilSettings_brush_draw_mode_get(PointerRNA *ptr);
void BrushGpencilSettings_brush_draw_mode_set(PointerRNA *ptr, int value);

enum {
	BrushGpencilSettings_vertex_mode_STROKE = 0,
	BrushGpencilSettings_vertex_mode_FILL = 1,
	BrushGpencilSettings_vertex_mode_BOTH = 2,
};

int BrushGpencilSettings_vertex_mode_get(PointerRNA *ptr);
void BrushGpencilSettings_vertex_mode_set(PointerRNA *ptr, int value);

bool BrushGpencilSettings_use_occlude_eraser_get(PointerRNA *ptr);
void BrushGpencilSettings_use_occlude_eraser_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_settings_outline_get(PointerRNA *ptr);
void BrushGpencilSettings_use_settings_outline_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_material_pin_get(PointerRNA *ptr);
void BrushGpencilSettings_use_material_pin_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_pin_draw_mode_get(PointerRNA *ptr);
void BrushGpencilSettings_pin_draw_mode_set(PointerRNA *ptr, bool value);

float BrushGpencilSettings_fill_factor_get(PointerRNA *ptr);
void BrushGpencilSettings_fill_factor_set(PointerRNA *ptr, float value);

float BrushGpencilSettings_random_pressure_get(PointerRNA *ptr);
void BrushGpencilSettings_random_pressure_set(PointerRNA *ptr, float value);

PointerRNA BrushGpencilSettings_curve_random_pressure_get(PointerRNA *ptr);

PointerRNA BrushGpencilSettings_curve_random_strength_get(PointerRNA *ptr);

PointerRNA BrushGpencilSettings_curve_random_uv_get(PointerRNA *ptr);

PointerRNA BrushGpencilSettings_curve_random_hue_get(PointerRNA *ptr);

PointerRNA BrushGpencilSettings_curve_random_saturation_get(PointerRNA *ptr);

PointerRNA BrushGpencilSettings_curve_random_value_get(PointerRNA *ptr);

bool BrushGpencilSettings_use_settings_random_get(PointerRNA *ptr);
void BrushGpencilSettings_use_settings_random_set(PointerRNA *ptr, bool value);

float BrushGpencilSettings_random_saturation_factor_get(PointerRNA *ptr);
void BrushGpencilSettings_random_saturation_factor_set(PointerRNA *ptr, float value);

bool BrushGpencilSettings_show_fill_get(PointerRNA *ptr);
void BrushGpencilSettings_show_fill_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_show_lasso_get(PointerRNA *ptr);
void BrushGpencilSettings_show_lasso_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_show_fill_boundary_get(PointerRNA *ptr);
void BrushGpencilSettings_show_fill_boundary_set(PointerRNA *ptr, bool value);

float BrushGpencilSettings_simplify_factor_get(PointerRNA *ptr);
void BrushGpencilSettings_simplify_factor_set(PointerRNA *ptr, float value);

float BrushGpencilSettings_simplify_pixel_threshold_get(PointerRNA *ptr);
void BrushGpencilSettings_simplify_pixel_threshold_set(PointerRNA *ptr, float value);

int BrushGpencilSettings_fill_simplify_level_get(PointerRNA *ptr);
void BrushGpencilSettings_fill_simplify_level_set(PointerRNA *ptr, int value);

float BrushGpencilSettings_pen_smooth_factor_get(PointerRNA *ptr);
void BrushGpencilSettings_pen_smooth_factor_set(PointerRNA *ptr, float value);

float BrushGpencilSettings_pen_strength_get(PointerRNA *ptr);
void BrushGpencilSettings_pen_strength_set(PointerRNA *ptr, float value);

float BrushGpencilSettings_random_strength_get(PointerRNA *ptr);
void BrushGpencilSettings_random_strength_set(PointerRNA *ptr, float value);

bool BrushGpencilSettings_use_stroke_random_hue_get(PointerRNA *ptr);
void BrushGpencilSettings_use_stroke_random_hue_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_stroke_random_sat_get(PointerRNA *ptr);
void BrushGpencilSettings_use_stroke_random_sat_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_stroke_random_val_get(PointerRNA *ptr);
void BrushGpencilSettings_use_stroke_random_val_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_stroke_random_radius_get(PointerRNA *ptr);
void BrushGpencilSettings_use_stroke_random_radius_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_stroke_random_strength_get(PointerRNA *ptr);
void BrushGpencilSettings_use_stroke_random_strength_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_stroke_random_uv_get(PointerRNA *ptr);
void BrushGpencilSettings_use_stroke_random_uv_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_collide_strokes_get(PointerRNA *ptr);
void BrushGpencilSettings_use_collide_strokes_set(PointerRNA *ptr, bool value);

int BrushGpencilSettings_pen_subdivision_steps_get(PointerRNA *ptr);
void BrushGpencilSettings_pen_subdivision_steps_set(PointerRNA *ptr, int value);

float BrushGpencilSettings_outline_thickness_factor_get(PointerRNA *ptr);
void BrushGpencilSettings_outline_thickness_factor_set(PointerRNA *ptr, float value);

float BrushGpencilSettings_fill_threshold_get(PointerRNA *ptr);
void BrushGpencilSettings_fill_threshold_set(PointerRNA *ptr, float value);

bool BrushGpencilSettings_use_trim_get(PointerRNA *ptr);
void BrushGpencilSettings_use_trim_set(PointerRNA *ptr, bool value);

float BrushGpencilSettings_uv_random_get(PointerRNA *ptr);
void BrushGpencilSettings_uv_random_set(PointerRNA *ptr, float value);

bool BrushGpencilSettings_use_settings_postprocess_get(PointerRNA *ptr);
void BrushGpencilSettings_use_settings_postprocess_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_pressure_get(PointerRNA *ptr);
void BrushGpencilSettings_use_pressure_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_random_press_hue_get(PointerRNA *ptr);
void BrushGpencilSettings_use_random_press_hue_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_random_press_sat_get(PointerRNA *ptr);
void BrushGpencilSettings_use_random_press_sat_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_random_press_val_get(PointerRNA *ptr);
void BrushGpencilSettings_use_random_press_val_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_random_press_radius_get(PointerRNA *ptr);
void BrushGpencilSettings_use_random_press_radius_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_random_press_strength_get(PointerRNA *ptr);
void BrushGpencilSettings_use_random_press_strength_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_random_press_uv_get(PointerRNA *ptr);
void BrushGpencilSettings_use_random_press_uv_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_jitter_pressure_get(PointerRNA *ptr);
void BrushGpencilSettings_use_jitter_pressure_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_strength_pressure_get(PointerRNA *ptr);
void BrushGpencilSettings_use_strength_pressure_set(PointerRNA *ptr, bool value);

bool BrushGpencilSettings_use_settings_stabilizer_get(PointerRNA *ptr);
void BrushGpencilSettings_use_settings_stabilizer_set(PointerRNA *ptr, bool value);

float BrushGpencilSettings_random_value_factor_get(PointerRNA *ptr);
void BrushGpencilSettings_random_value_factor_set(PointerRNA *ptr, float value);

float BrushGpencilSettings_vertex_color_factor_get(PointerRNA *ptr);
void BrushGpencilSettings_vertex_color_factor_set(PointerRNA *ptr, float value);

bool BrushGpencilSettings_show_fill_extend_get(PointerRNA *ptr);
void BrushGpencilSettings_show_fill_extend_set(PointerRNA *ptr, bool value);

/**************** Brush Texture Slot ****************/

extern StructRNA RNA_BrushTextureSlot;
extern StructRNA RNA_TextureSlot;

float BrushTextureSlot_angle_get(PointerRNA *ptr);
void BrushTextureSlot_angle_set(PointerRNA *ptr, float value);

bool BrushTextureSlot_has_random_texture_angle_get(PointerRNA *ptr);
void BrushTextureSlot_has_random_texture_angle_set(PointerRNA *ptr, bool value);

bool BrushTextureSlot_has_texture_angle_source_get(PointerRNA *ptr);
void BrushTextureSlot_has_texture_angle_source_set(PointerRNA *ptr, bool value);

bool BrushTextureSlot_has_texture_angle_get(PointerRNA *ptr);
void BrushTextureSlot_has_texture_angle_set(PointerRNA *ptr, bool value);

enum {
	BrushTextureSlot_map_mode_VIEW_PLANE = 0,
	BrushTextureSlot_map_mode_AREA_PLANE = 3,
	BrushTextureSlot_map_mode_TILED = 1,
	BrushTextureSlot_map_mode_3D = 2,
	BrushTextureSlot_map_mode_RANDOM = 4,
	BrushTextureSlot_map_mode_STENCIL = 5,
};

int BrushTextureSlot_map_mode_get(PointerRNA *ptr);
void BrushTextureSlot_map_mode_set(PointerRNA *ptr, int value);

enum {
	BrushTextureSlot_mask_map_mode_VIEW_PLANE = 0,
	BrushTextureSlot_mask_map_mode_TILED = 1,
	BrushTextureSlot_mask_map_mode_RANDOM = 4,
	BrushTextureSlot_mask_map_mode_STENCIL = 5,
};

int BrushTextureSlot_mask_map_mode_get(PointerRNA *ptr);
void BrushTextureSlot_mask_map_mode_set(PointerRNA *ptr, int value);

bool BrushTextureSlot_use_rake_get(PointerRNA *ptr);
void BrushTextureSlot_use_rake_set(PointerRNA *ptr, bool value);

bool BrushTextureSlot_use_random_get(PointerRNA *ptr);
void BrushTextureSlot_use_random_set(PointerRNA *ptr, bool value);

float BrushTextureSlot_random_angle_get(PointerRNA *ptr);
void BrushTextureSlot_random_angle_set(PointerRNA *ptr, float value);

/**************** Build Modifier ****************/

extern StructRNA RNA_BuildModifier;
extern StructRNA RNA_Modifier;

float BuildModifier_frame_duration_get(PointerRNA *ptr);
void BuildModifier_frame_duration_set(PointerRNA *ptr, float value);

bool BuildModifier_use_random_order_get(PointerRNA *ptr);
void BuildModifier_use_random_order_set(PointerRNA *ptr, bool value);

bool BuildModifier_use_reverse_get(PointerRNA *ptr);
void BuildModifier_use_reverse_set(PointerRNA *ptr, bool value);

int BuildModifier_seed_get(PointerRNA *ptr);
void BuildModifier_seed_set(PointerRNA *ptr, int value);

float BuildModifier_frame_start_get(PointerRNA *ptr);
void BuildModifier_frame_start_set(PointerRNA *ptr, float value);

/**************** Byte Color Attribute ****************/

extern StructRNA RNA_ByteColorAttribute;
extern StructRNA RNA_Attribute;

void ByteColorAttribute_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ByteColorAttribute_data_next(CollectionPropertyIterator *iter);
void ByteColorAttribute_data_end(CollectionPropertyIterator *iter);
int ByteColorAttribute_data_length(PointerRNA *ptr);
bool ByteColorAttribute_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Byte Color Attribute Value ****************/

extern StructRNA RNA_ByteColorAttributeValue;

PointerRNA ByteColorAttributeValue_rna_type_get(PointerRNA *ptr);

void ByteColorAttributeValue_color_get(PointerRNA *ptr, float values[4]);
void ByteColorAttributeValue_color_set(PointerRNA *ptr, const float values[4]);

void ByteColorAttributeValue_color_srgb_get(PointerRNA *ptr, float values[4]);
void ByteColorAttributeValue_color_srgb_set(PointerRNA *ptr, const float values[4]);

/**************** 8-bit Integer Attribute ****************/

extern StructRNA RNA_ByteIntAttribute;
extern StructRNA RNA_Attribute;

void ByteIntAttribute_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ByteIntAttribute_data_next(CollectionPropertyIterator *iter);
void ByteIntAttribute_data_end(CollectionPropertyIterator *iter);
int ByteIntAttribute_data_length(PointerRNA *ptr);
bool ByteIntAttribute_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** 8-bit Integer Attribute Value ****************/

extern StructRNA RNA_ByteIntAttributeValue;

PointerRNA ByteIntAttributeValue_rna_type_get(PointerRNA *ptr);

int ByteIntAttributeValue_value_get(PointerRNA *ptr);
void ByteIntAttributeValue_value_set(PointerRNA *ptr, int value);

/**************** CacheFile ****************/

extern StructRNA RNA_CacheFile;
extern StructRNA RNA_ID;

PointerRNA CacheFile_animation_data_get(PointerRNA *ptr);

void CacheFile_layers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void CacheFile_layers_next(CollectionPropertyIterator *iter);
void CacheFile_layers_end(CollectionPropertyIterator *iter);
bool CacheFile_layers_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

#define CacheFile_filepath_MAX 1024

void CacheFile_filepath_get(PointerRNA *ptr, char *value);
int CacheFile_filepath_length(PointerRNA *ptr);
void CacheFile_filepath_set(PointerRNA *ptr, const char *value);

enum {
	CacheFile_forward_axis_POS_X = 0,
	CacheFile_forward_axis_POS_Y = 1,
	CacheFile_forward_axis_POS_Z = 2,
	CacheFile_forward_axis_NEG_X = 3,
	CacheFile_forward_axis_NEG_Y = 4,
	CacheFile_forward_axis_NEG_Z = 5,
};

int CacheFile_forward_axis_get(PointerRNA *ptr);
void CacheFile_forward_axis_set(PointerRNA *ptr, int value);

float CacheFile_frame_get(PointerRNA *ptr);
void CacheFile_frame_set(PointerRNA *ptr, float value);

float CacheFile_frame_offset_get(PointerRNA *ptr);
void CacheFile_frame_offset_set(PointerRNA *ptr, float value);

void CacheFile_object_paths_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void CacheFile_object_paths_next(CollectionPropertyIterator *iter);
void CacheFile_object_paths_end(CollectionPropertyIterator *iter);
bool CacheFile_object_paths_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool CacheFile_object_paths_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool CacheFile_override_frame_get(PointerRNA *ptr);
void CacheFile_override_frame_set(PointerRNA *ptr, bool value);

int CacheFile_prefetch_cache_size_get(PointerRNA *ptr);
void CacheFile_prefetch_cache_size_set(PointerRNA *ptr, int value);

float CacheFile_scale_get(PointerRNA *ptr);
void CacheFile_scale_set(PointerRNA *ptr, float value);

bool CacheFile_is_sequence_get(PointerRNA *ptr);
void CacheFile_is_sequence_set(PointerRNA *ptr, bool value);

enum {
	CacheFile_up_axis_POS_X = 0,
	CacheFile_up_axis_POS_Y = 1,
	CacheFile_up_axis_POS_Z = 2,
	CacheFile_up_axis_NEG_X = 3,
	CacheFile_up_axis_NEG_Y = 4,
	CacheFile_up_axis_NEG_Z = 5,
};

int CacheFile_up_axis_get(PointerRNA *ptr);
void CacheFile_up_axis_set(PointerRNA *ptr, int value);

bool CacheFile_use_prefetch_get(PointerRNA *ptr);
void CacheFile_use_prefetch_set(PointerRNA *ptr, bool value);

bool CacheFile_use_render_procedural_get(PointerRNA *ptr);
void CacheFile_use_render_procedural_set(PointerRNA *ptr, bool value);

#define CacheFile_velocity_name_MAX 64

void CacheFile_velocity_name_get(PointerRNA *ptr, char *value);
int CacheFile_velocity_name_length(PointerRNA *ptr);
void CacheFile_velocity_name_set(PointerRNA *ptr, const char *value);

enum {
	CacheFile_velocity_unit_SECOND = 1,
	CacheFile_velocity_unit_FRAME = 0,
};

int CacheFile_velocity_unit_get(PointerRNA *ptr);
void CacheFile_velocity_unit_set(PointerRNA *ptr, int value);

int CacheFile_active_index_get(PointerRNA *ptr);
void CacheFile_active_index_set(PointerRNA *ptr, int value);

/**************** Cache Layer ****************/

extern StructRNA RNA_CacheFileLayer;

PointerRNA CacheFileLayer_rna_type_get(PointerRNA *ptr);

#define CacheFileLayer_filepath_MAX 1024

void CacheFileLayer_filepath_get(PointerRNA *ptr, char *value);
int CacheFileLayer_filepath_length(PointerRNA *ptr);
void CacheFileLayer_filepath_set(PointerRNA *ptr, const char *value);

bool CacheFileLayer_hide_layer_get(PointerRNA *ptr);
void CacheFileLayer_hide_layer_set(PointerRNA *ptr, bool value);

/**************** Cache Layers ****************/

extern StructRNA RNA_CacheFileLayers;

PointerRNA CacheFileLayers_rna_type_get(PointerRNA *ptr);

PointerRNA CacheFileLayers_active_get(PointerRNA *ptr);

struct CacheFileLayer *CacheFileLayers_new_func(struct CacheFile *_self, bContext *C, ReportList *reports, const char * filepath);
void CacheFileLayers_remove_func(struct CacheFile *_self, bContext *C, struct PointerRNA *layer);
/**************** Object Path ****************/

extern StructRNA RNA_CacheObjectPath;

PointerRNA CacheObjectPath_rna_type_get(PointerRNA *ptr);

#define CacheObjectPath_path_MAX 4096

void CacheObjectPath_path_get(PointerRNA *ptr, char *value);
int CacheObjectPath_path_length(PointerRNA *ptr);
void CacheObjectPath_path_set(PointerRNA *ptr, const char *value);

/**************** Object Paths ****************/

extern StructRNA RNA_CacheObjectPaths;

PointerRNA CacheObjectPaths_rna_type_get(PointerRNA *ptr);

/**************** Camera ****************/

extern StructRNA RNA_Camera;
extern StructRNA RNA_ID;

PointerRNA Camera_animation_data_get(PointerRNA *ptr);

void Camera_background_images_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Camera_background_images_next(CollectionPropertyIterator *iter);
void Camera_background_images_end(CollectionPropertyIterator *iter);
bool Camera_background_images_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool Camera_show_composition_center_get(PointerRNA *ptr);
void Camera_show_composition_center_set(PointerRNA *ptr, bool value);

bool Camera_show_composition_center_diagonal_get(PointerRNA *ptr);
void Camera_show_composition_center_diagonal_set(PointerRNA *ptr, bool value);

float Camera_clip_end_get(PointerRNA *ptr);
void Camera_clip_end_set(PointerRNA *ptr, float value);

float Camera_clip_start_get(PointerRNA *ptr);
void Camera_clip_start_set(PointerRNA *ptr, float value);

void Camera_custom_bytecode_get(PointerRNA *ptr, char *value);
int Camera_custom_bytecode_length(PointerRNA *ptr);
void Camera_custom_bytecode_set(PointerRNA *ptr, const char *value);

#define Camera_custom_bytecode_hash_MAX 64

void Camera_custom_bytecode_hash_get(PointerRNA *ptr, char *value);
int Camera_custom_bytecode_hash_length(PointerRNA *ptr);
void Camera_custom_bytecode_hash_set(PointerRNA *ptr, const char *value);

#define Camera_custom_filepath_MAX 1024

void Camera_custom_filepath_get(PointerRNA *ptr, char *value);
int Camera_custom_filepath_length(PointerRNA *ptr);
void Camera_custom_filepath_set(PointerRNA *ptr, const char *value);

PointerRNA Camera_custom_shader_get(PointerRNA *ptr);

enum {
	Camera_custom_mode_INTERNAL = 0,
	Camera_custom_mode_EXTERNAL = 1,
};

int Camera_custom_mode_get(PointerRNA *ptr);
void Camera_custom_mode_set(PointerRNA *ptr, int value);

float Camera_central_cylindrical_radius_get(PointerRNA *ptr);
void Camera_central_cylindrical_radius_set(PointerRNA *ptr, float value);

PointerRNA Camera_dof_get(PointerRNA *ptr);

bool Camera_show_background_images_get(PointerRNA *ptr);
void Camera_show_background_images_set(PointerRNA *ptr, bool value);

float Camera_display_size_get(PointerRNA *ptr);
void Camera_display_size_set(PointerRNA *ptr, float value);

float Camera_angle_get(PointerRNA *ptr);
void Camera_angle_set(PointerRNA *ptr, float value);

float Camera_fisheye_fov_get(PointerRNA *ptr);
void Camera_fisheye_fov_set(PointerRNA *ptr, float value);

float Camera_fisheye_lens_get(PointerRNA *ptr);
void Camera_fisheye_lens_set(PointerRNA *ptr, float value);

float Camera_fisheye_polynomial_k0_get(PointerRNA *ptr);
void Camera_fisheye_polynomial_k0_set(PointerRNA *ptr, float value);

float Camera_fisheye_polynomial_k1_get(PointerRNA *ptr);
void Camera_fisheye_polynomial_k1_set(PointerRNA *ptr, float value);

float Camera_fisheye_polynomial_k2_get(PointerRNA *ptr);
void Camera_fisheye_polynomial_k2_set(PointerRNA *ptr, float value);

float Camera_fisheye_polynomial_k3_get(PointerRNA *ptr);
void Camera_fisheye_polynomial_k3_set(PointerRNA *ptr, float value);

float Camera_fisheye_polynomial_k4_get(PointerRNA *ptr);
void Camera_fisheye_polynomial_k4_set(PointerRNA *ptr, float value);

float Camera_lens_get(PointerRNA *ptr);
void Camera_lens_set(PointerRNA *ptr, float value);

bool Camera_show_composition_golden_get(PointerRNA *ptr);
void Camera_show_composition_golden_set(PointerRNA *ptr, bool value);

bool Camera_show_composition_golden_tria_a_get(PointerRNA *ptr);
void Camera_show_composition_golden_tria_a_set(PointerRNA *ptr, bool value);

bool Camera_show_composition_golden_tria_b_get(PointerRNA *ptr);
void Camera_show_composition_golden_tria_b_set(PointerRNA *ptr, bool value);

bool Camera_show_composition_harmony_tri_a_get(PointerRNA *ptr);
void Camera_show_composition_harmony_tri_a_set(PointerRNA *ptr, bool value);

bool Camera_show_composition_harmony_tri_b_get(PointerRNA *ptr);
void Camera_show_composition_harmony_tri_b_set(PointerRNA *ptr, bool value);

float Camera_angle_x_get(PointerRNA *ptr);
void Camera_angle_x_set(PointerRNA *ptr, float value);

enum {
	Camera_lens_unit_MILLIMETERS = 0,
	Camera_lens_unit_FOV = 32,
};

int Camera_lens_unit_get(PointerRNA *ptr);
void Camera_lens_unit_set(PointerRNA *ptr, int value);

float Camera_central_cylindrical_range_v_max_get(PointerRNA *ptr);
void Camera_central_cylindrical_range_v_max_set(PointerRNA *ptr, float value);

float Camera_latitude_max_get(PointerRNA *ptr);
void Camera_latitude_max_set(PointerRNA *ptr, float value);

float Camera_longitude_max_get(PointerRNA *ptr);
void Camera_longitude_max_set(PointerRNA *ptr, float value);

float Camera_central_cylindrical_range_u_max_get(PointerRNA *ptr);
void Camera_central_cylindrical_range_u_max_set(PointerRNA *ptr, float value);

float Camera_central_cylindrical_range_v_min_get(PointerRNA *ptr);
void Camera_central_cylindrical_range_v_min_set(PointerRNA *ptr, float value);

float Camera_latitude_min_get(PointerRNA *ptr);
void Camera_latitude_min_set(PointerRNA *ptr, float value);

float Camera_longitude_min_get(PointerRNA *ptr);
void Camera_longitude_min_set(PointerRNA *ptr, float value);

float Camera_central_cylindrical_range_u_min_get(PointerRNA *ptr);
void Camera_central_cylindrical_range_u_min_set(PointerRNA *ptr, float value);

float Camera_ortho_scale_get(PointerRNA *ptr);
void Camera_ortho_scale_set(PointerRNA *ptr, float value);

enum {
	Camera_panorama_type_EQUIRECTANGULAR = 0,
	Camera_panorama_type_EQUIANGULAR_CUBEMAP_FACE = 5,
	Camera_panorama_type_MIRRORBALL = 3,
	Camera_panorama_type_FISHEYE_EQUIDISTANT = 1,
	Camera_panorama_type_FISHEYE_EQUISOLID = 2,
	Camera_panorama_type_FISHEYE_LENS_POLYNOMIAL = 4,
	Camera_panorama_type_CENTRAL_CYLINDRICAL = 6,
};

int Camera_panorama_type_get(PointerRNA *ptr);
void Camera_panorama_type_set(PointerRNA *ptr, int value);

float Camera_passepartout_alpha_get(PointerRNA *ptr);
void Camera_passepartout_alpha_set(PointerRNA *ptr, float value);

enum {
	Camera_sensor_fit_AUTO = 0,
	Camera_sensor_fit_HORIZONTAL = 1,
	Camera_sensor_fit_VERTICAL = 2,
};

int Camera_sensor_fit_get(PointerRNA *ptr);
void Camera_sensor_fit_set(PointerRNA *ptr, int value);

float Camera_sensor_height_get(PointerRNA *ptr);
void Camera_sensor_height_set(PointerRNA *ptr, float value);

float Camera_sensor_width_get(PointerRNA *ptr);
void Camera_sensor_width_set(PointerRNA *ptr, float value);

float Camera_shift_x_get(PointerRNA *ptr);
void Camera_shift_x_set(PointerRNA *ptr, float value);

float Camera_shift_y_get(PointerRNA *ptr);
void Camera_shift_y_set(PointerRNA *ptr, float value);

bool Camera_show_safe_center_get(PointerRNA *ptr);
void Camera_show_safe_center_set(PointerRNA *ptr, bool value);

bool Camera_show_limits_get(PointerRNA *ptr);
void Camera_show_limits_set(PointerRNA *ptr, bool value);

bool Camera_show_mist_get(PointerRNA *ptr);
void Camera_show_mist_set(PointerRNA *ptr, bool value);

bool Camera_show_name_get(PointerRNA *ptr);
void Camera_show_name_set(PointerRNA *ptr, bool value);

bool Camera_show_passepartout_get(PointerRNA *ptr);
void Camera_show_passepartout_set(PointerRNA *ptr, bool value);

bool Camera_show_safe_areas_get(PointerRNA *ptr);
void Camera_show_safe_areas_set(PointerRNA *ptr, bool value);

bool Camera_show_sensor_get(PointerRNA *ptr);
void Camera_show_sensor_set(PointerRNA *ptr, bool value);

PointerRNA Camera_stereo_get(PointerRNA *ptr);

bool Camera_show_composition_thirds_get(PointerRNA *ptr);
void Camera_show_composition_thirds_set(PointerRNA *ptr, bool value);

enum {
	Camera_type_PERSP = 0,
	Camera_type_ORTHO = 1,
	Camera_type_PANO = 2,
	Camera_type_CUSTOM = 3,
};

int Camera_type_get(PointerRNA *ptr);
void Camera_type_set(PointerRNA *ptr, int value);

float Camera_angle_y_get(PointerRNA *ptr);
void Camera_angle_y_set(PointerRNA *ptr, float value);

void Camera_view_frame_func(struct Camera *_self, struct Scene *scene, float result_1[3], float result_2[3], float result_3[3], float result_4[3]);
/**************** Background Image ****************/

extern StructRNA RNA_CameraBackgroundImage;

PointerRNA CameraBackgroundImage_rna_type_get(PointerRNA *ptr);

enum {
	CameraBackgroundImage_source_IMAGE = 0,
	CameraBackgroundImage_source_MOVIE_CLIP = 1,
};

int CameraBackgroundImage_source_get(PointerRNA *ptr);
void CameraBackgroundImage_source_set(PointerRNA *ptr, int value);

bool CameraBackgroundImage_use_camera_clip_get(PointerRNA *ptr);
void CameraBackgroundImage_use_camera_clip_set(PointerRNA *ptr, bool value);

PointerRNA CameraBackgroundImage_clip_user_get(PointerRNA *ptr);

enum {
	CameraBackgroundImage_display_depth_BACK = 0,
	CameraBackgroundImage_display_depth_FRONT = 16,
};

int CameraBackgroundImage_display_depth_get(PointerRNA *ptr);
void CameraBackgroundImage_display_depth_set(PointerRNA *ptr, int value);

bool CameraBackgroundImage_use_flip_x_get(PointerRNA *ptr);
void CameraBackgroundImage_use_flip_x_set(PointerRNA *ptr, bool value);

bool CameraBackgroundImage_use_flip_y_get(PointerRNA *ptr);
void CameraBackgroundImage_use_flip_y_set(PointerRNA *ptr, bool value);

enum {
	CameraBackgroundImage_frame_method_STRETCH = 0,
	CameraBackgroundImage_frame_method_FIT = 32,
	CameraBackgroundImage_frame_method_CROP = 96,
};

int CameraBackgroundImage_frame_method_get(PointerRNA *ptr);
void CameraBackgroundImage_frame_method_set(PointerRNA *ptr, int value);

PointerRNA CameraBackgroundImage_image_get(PointerRNA *ptr);

PointerRNA CameraBackgroundImage_image_user_get(PointerRNA *ptr);

PointerRNA CameraBackgroundImage_clip_get(PointerRNA *ptr);

void CameraBackgroundImage_offset_get(PointerRNA *ptr, float values[2]);
void CameraBackgroundImage_offset_set(PointerRNA *ptr, const float values[2]);

float CameraBackgroundImage_alpha_get(PointerRNA *ptr);
void CameraBackgroundImage_alpha_set(PointerRNA *ptr, float value);

bool CameraBackgroundImage_is_override_data_get(PointerRNA *ptr);
void CameraBackgroundImage_is_override_data_set(PointerRNA *ptr, bool value);

float CameraBackgroundImage_rotation_get(PointerRNA *ptr);
void CameraBackgroundImage_rotation_set(PointerRNA *ptr, float value);

float CameraBackgroundImage_scale_get(PointerRNA *ptr);
void CameraBackgroundImage_scale_set(PointerRNA *ptr, float value);

bool CameraBackgroundImage_show_background_image_get(PointerRNA *ptr);
void CameraBackgroundImage_show_background_image_set(PointerRNA *ptr, bool value);

bool CameraBackgroundImage_show_expanded_get(PointerRNA *ptr);
void CameraBackgroundImage_show_expanded_set(PointerRNA *ptr, bool value);

bool CameraBackgroundImage_show_on_foreground_get(PointerRNA *ptr);
void CameraBackgroundImage_show_on_foreground_set(PointerRNA *ptr, bool value);

/**************** Background Images ****************/

extern StructRNA RNA_CameraBackgroundImages;

PointerRNA CameraBackgroundImages_rna_type_get(PointerRNA *ptr);

struct CameraBGImage *CameraBackgroundImages_new_func(struct Camera *_self);
void CameraBackgroundImages_remove_func(struct Camera *_self, ReportList *reports, struct PointerRNA *image);
void CameraBackgroundImages_clear_func(struct Camera *_self);
/**************** Depth of Field ****************/

extern StructRNA RNA_CameraDOFSettings;

PointerRNA CameraDOFSettings_rna_type_get(PointerRNA *ptr);

int CameraDOFSettings_aperture_blades_get(PointerRNA *ptr);
void CameraDOFSettings_aperture_blades_set(PointerRNA *ptr, int value);

bool CameraDOFSettings_use_dof_get(PointerRNA *ptr);
void CameraDOFSettings_use_dof_set(PointerRNA *ptr, bool value);

float CameraDOFSettings_aperture_fstop_get(PointerRNA *ptr);
void CameraDOFSettings_aperture_fstop_set(PointerRNA *ptr, float value);

#define CameraDOFSettings_focus_subtarget_MAX 64

void CameraDOFSettings_focus_subtarget_get(PointerRNA *ptr, char *value);
int CameraDOFSettings_focus_subtarget_length(PointerRNA *ptr);
void CameraDOFSettings_focus_subtarget_set(PointerRNA *ptr, const char *value);

float CameraDOFSettings_focus_distance_get(PointerRNA *ptr);
void CameraDOFSettings_focus_distance_set(PointerRNA *ptr, float value);

PointerRNA CameraDOFSettings_focus_object_get(PointerRNA *ptr);

float CameraDOFSettings_aperture_ratio_get(PointerRNA *ptr);
void CameraDOFSettings_aperture_ratio_set(PointerRNA *ptr, float value);

float CameraDOFSettings_aperture_rotation_get(PointerRNA *ptr);
void CameraDOFSettings_aperture_rotation_set(PointerRNA *ptr, float value);

/**************** Camera Solver Constraint ****************/

extern StructRNA RNA_CameraSolverConstraint;
extern StructRNA RNA_Constraint;

bool CameraSolverConstraint_use_active_clip_get(PointerRNA *ptr);
void CameraSolverConstraint_use_active_clip_set(PointerRNA *ptr, bool value);

PointerRNA CameraSolverConstraint_clip_get(PointerRNA *ptr);

/**************** Stereo ****************/

extern StructRNA RNA_CameraStereoData;

PointerRNA CameraStereoData_rna_type_get(PointerRNA *ptr);

float CameraStereoData_convergence_distance_get(PointerRNA *ptr);
void CameraStereoData_convergence_distance_set(PointerRNA *ptr, float value);

float CameraStereoData_interocular_distance_get(PointerRNA *ptr);
void CameraStereoData_interocular_distance_set(PointerRNA *ptr, float value);

enum {
	CameraStereoData_convergence_mode_OFFAXIS = 0,
	CameraStereoData_convergence_mode_PARALLEL = 1,
	CameraStereoData_convergence_mode_TOE = 2,
};

int CameraStereoData_convergence_mode_get(PointerRNA *ptr);
void CameraStereoData_convergence_mode_set(PointerRNA *ptr, int value);

enum {
	CameraStereoData_pivot_LEFT = 0,
	CameraStereoData_pivot_RIGHT = 1,
	CameraStereoData_pivot_CENTER = 2,
};

int CameraStereoData_pivot_get(PointerRNA *ptr);
void CameraStereoData_pivot_set(PointerRNA *ptr, int value);

float CameraStereoData_pole_merge_angle_to_get(PointerRNA *ptr);
void CameraStereoData_pole_merge_angle_to_set(PointerRNA *ptr, float value);

float CameraStereoData_pole_merge_angle_from_get(PointerRNA *ptr);
void CameraStereoData_pole_merge_angle_from_set(PointerRNA *ptr, float value);

bool CameraStereoData_use_spherical_stereo_get(PointerRNA *ptr);
void CameraStereoData_use_spherical_stereo_set(PointerRNA *ptr, bool value);

bool CameraStereoData_use_pole_merge_get(PointerRNA *ptr);
void CameraStereoData_use_pole_merge_set(PointerRNA *ptr, bool value);

/**************** Cast Modifier ****************/

extern StructRNA RNA_CastModifier;
extern StructRNA RNA_Modifier;

float CastModifier_factor_get(PointerRNA *ptr);
void CastModifier_factor_set(PointerRNA *ptr, float value);

bool CastModifier_invert_vertex_group_get(PointerRNA *ptr);
void CastModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

PointerRNA CastModifier_object_get(PointerRNA *ptr);

float CastModifier_radius_get(PointerRNA *ptr);
void CastModifier_radius_set(PointerRNA *ptr, float value);

enum {
	CastModifier_cast_type_SPHERE = 0,
	CastModifier_cast_type_CYLINDER = 1,
	CastModifier_cast_type_CUBOID = 2,
};

int CastModifier_cast_type_get(PointerRNA *ptr);
void CastModifier_cast_type_set(PointerRNA *ptr, int value);

float CastModifier_size_get(PointerRNA *ptr);
void CastModifier_size_set(PointerRNA *ptr, float value);

bool CastModifier_use_radius_as_size_get(PointerRNA *ptr);
void CastModifier_use_radius_as_size_set(PointerRNA *ptr, bool value);

bool CastModifier_use_transform_get(PointerRNA *ptr);
void CastModifier_use_transform_set(PointerRNA *ptr, bool value);

#define CastModifier_vertex_group_MAX 64

void CastModifier_vertex_group_get(PointerRNA *ptr, char *value);
int CastModifier_vertex_group_length(PointerRNA *ptr);
void CastModifier_vertex_group_set(PointerRNA *ptr, const char *value);

bool CastModifier_use_x_get(PointerRNA *ptr);
void CastModifier_use_x_set(PointerRNA *ptr, bool value);

bool CastModifier_use_y_get(PointerRNA *ptr);
void CastModifier_use_y_set(PointerRNA *ptr, bool value);

bool CastModifier_use_z_get(PointerRNA *ptr);
void CastModifier_use_z_set(PointerRNA *ptr, bool value);

/**************** ChannelDriver Variables ****************/

extern StructRNA RNA_ChannelDriverVariables;

PointerRNA ChannelDriverVariables_rna_type_get(PointerRNA *ptr);

struct DriverVar *ChannelDriverVariables_new_func(struct ChannelDriver *_self);
void ChannelDriverVariables_remove_func(struct ChannelDriver *_self, ReportList *reports, struct PointerRNA *variable);
/**************** Child Of Constraint ****************/

extern StructRNA RNA_ChildOfConstraint;
extern StructRNA RNA_Constraint;

void ChildOfConstraint_inverse_matrix_get(PointerRNA *ptr, float values[16]);
void ChildOfConstraint_inverse_matrix_set(PointerRNA *ptr, const float values[16]);

bool ChildOfConstraint_use_location_x_get(PointerRNA *ptr);
void ChildOfConstraint_use_location_x_set(PointerRNA *ptr, bool value);

bool ChildOfConstraint_use_location_y_get(PointerRNA *ptr);
void ChildOfConstraint_use_location_y_set(PointerRNA *ptr, bool value);

bool ChildOfConstraint_use_location_z_get(PointerRNA *ptr);
void ChildOfConstraint_use_location_z_set(PointerRNA *ptr, bool value);

bool ChildOfConstraint_use_rotation_x_get(PointerRNA *ptr);
void ChildOfConstraint_use_rotation_x_set(PointerRNA *ptr, bool value);

bool ChildOfConstraint_use_rotation_y_get(PointerRNA *ptr);
void ChildOfConstraint_use_rotation_y_set(PointerRNA *ptr, bool value);

bool ChildOfConstraint_use_rotation_z_get(PointerRNA *ptr);
void ChildOfConstraint_use_rotation_z_set(PointerRNA *ptr, bool value);

bool ChildOfConstraint_use_scale_x_get(PointerRNA *ptr);
void ChildOfConstraint_use_scale_x_set(PointerRNA *ptr, bool value);

bool ChildOfConstraint_use_scale_y_get(PointerRNA *ptr);
void ChildOfConstraint_use_scale_y_set(PointerRNA *ptr, bool value);

bool ChildOfConstraint_use_scale_z_get(PointerRNA *ptr);
void ChildOfConstraint_use_scale_z_set(PointerRNA *ptr, bool value);

bool ChildOfConstraint_set_inverse_pending_get(PointerRNA *ptr);
void ChildOfConstraint_set_inverse_pending_set(PointerRNA *ptr, bool value);

#define ChildOfConstraint_subtarget_MAX 64

void ChildOfConstraint_subtarget_get(PointerRNA *ptr, char *value);
int ChildOfConstraint_subtarget_length(PointerRNA *ptr);
void ChildOfConstraint_subtarget_set(PointerRNA *ptr, const char *value);

PointerRNA ChildOfConstraint_target_get(PointerRNA *ptr);

/**************** Child Particle ****************/

extern StructRNA RNA_ChildParticle;

PointerRNA ChildParticle_rna_type_get(PointerRNA *ptr);

/**************** Clamp To Constraint ****************/

extern StructRNA RNA_ClampToConstraint;
extern StructRNA RNA_Constraint;

bool ClampToConstraint_use_cyclic_get(PointerRNA *ptr);
void ClampToConstraint_use_cyclic_set(PointerRNA *ptr, bool value);

enum {
	ClampToConstraint_main_axis_CLAMPTO_AUTO = 0,
	ClampToConstraint_main_axis_CLAMPTO_X = 1,
	ClampToConstraint_main_axis_CLAMPTO_Y = 2,
	ClampToConstraint_main_axis_CLAMPTO_Z = 3,
};

int ClampToConstraint_main_axis_get(PointerRNA *ptr);
void ClampToConstraint_main_axis_set(PointerRNA *ptr, int value);

PointerRNA ClampToConstraint_target_get(PointerRNA *ptr);

/**************** Cloth Collision Settings ****************/

extern StructRNA RNA_ClothCollisionSettings;

PointerRNA ClothCollisionSettings_rna_type_get(PointerRNA *ptr);

PointerRNA ClothCollisionSettings_collection_get(PointerRNA *ptr);

int ClothCollisionSettings_collision_quality_get(PointerRNA *ptr);
void ClothCollisionSettings_collision_quality_set(PointerRNA *ptr, int value);

void ClothCollisionSettings_vertex_group_object_collisions_get(PointerRNA *ptr, char *value);
int ClothCollisionSettings_vertex_group_object_collisions_length(PointerRNA *ptr);
void ClothCollisionSettings_vertex_group_object_collisions_set(PointerRNA *ptr, const char *value);

bool ClothCollisionSettings_use_collision_get(PointerRNA *ptr);
void ClothCollisionSettings_use_collision_set(PointerRNA *ptr, bool value);

bool ClothCollisionSettings_use_self_collision_get(PointerRNA *ptr);
void ClothCollisionSettings_use_self_collision_set(PointerRNA *ptr, bool value);

float ClothCollisionSettings_friction_get(PointerRNA *ptr);
void ClothCollisionSettings_friction_set(PointerRNA *ptr, float value);

float ClothCollisionSettings_impulse_clamp_get(PointerRNA *ptr);
void ClothCollisionSettings_impulse_clamp_set(PointerRNA *ptr, float value);

float ClothCollisionSettings_self_impulse_clamp_get(PointerRNA *ptr);
void ClothCollisionSettings_self_impulse_clamp_set(PointerRNA *ptr, float value);

float ClothCollisionSettings_distance_min_get(PointerRNA *ptr);
void ClothCollisionSettings_distance_min_set(PointerRNA *ptr, float value);

float ClothCollisionSettings_damping_get(PointerRNA *ptr);
void ClothCollisionSettings_damping_set(PointerRNA *ptr, float value);

float ClothCollisionSettings_self_friction_get(PointerRNA *ptr);
void ClothCollisionSettings_self_friction_set(PointerRNA *ptr, float value);

float ClothCollisionSettings_self_distance_min_get(PointerRNA *ptr);
void ClothCollisionSettings_self_distance_min_set(PointerRNA *ptr, float value);

void ClothCollisionSettings_vertex_group_self_collisions_get(PointerRNA *ptr, char *value);
int ClothCollisionSettings_vertex_group_self_collisions_length(PointerRNA *ptr);
void ClothCollisionSettings_vertex_group_self_collisions_set(PointerRNA *ptr, const char *value);

/**************** Cloth Modifier ****************/

extern StructRNA RNA_ClothModifier;
extern StructRNA RNA_Modifier;

PointerRNA ClothModifier_collision_settings_get(PointerRNA *ptr);

PointerRNA ClothModifier_settings_get(PointerRNA *ptr);

void ClothModifier_hair_grid_max_get(PointerRNA *ptr, float values[3]);
void ClothModifier_hair_grid_max_set(PointerRNA *ptr, const float values[3]);

void ClothModifier_hair_grid_min_get(PointerRNA *ptr, float values[3]);
void ClothModifier_hair_grid_min_set(PointerRNA *ptr, const float values[3]);

void ClothModifier_hair_grid_resolution_get(PointerRNA *ptr, int values[3]);
void ClothModifier_hair_grid_resolution_set(PointerRNA *ptr, const int values[3]);

PointerRNA ClothModifier_point_cache_get(PointerRNA *ptr);

PointerRNA ClothModifier_solver_result_get(PointerRNA *ptr);

/**************** Cloth Settings ****************/

extern StructRNA RNA_ClothSettings;

PointerRNA ClothSettings_rna_type_get(PointerRNA *ptr);

float ClothSettings_air_damping_get(PointerRNA *ptr);
void ClothSettings_air_damping_set(PointerRNA *ptr, float value);

enum {
	ClothSettings_bending_model_ANGULAR = 1,
	ClothSettings_bending_model_LINEAR = 0,
};

int ClothSettings_bending_model_get(PointerRNA *ptr);
void ClothSettings_bending_model_set(PointerRNA *ptr, int value);

float ClothSettings_bending_damping_get(PointerRNA *ptr);
void ClothSettings_bending_damping_set(PointerRNA *ptr, float value);

float ClothSettings_bending_stiffness_get(PointerRNA *ptr);
void ClothSettings_bending_stiffness_set(PointerRNA *ptr, float value);

float ClothSettings_bending_stiffness_max_get(PointerRNA *ptr);
void ClothSettings_bending_stiffness_max_set(PointerRNA *ptr, float value);

void ClothSettings_vertex_group_bending_get(PointerRNA *ptr, char *value);
int ClothSettings_vertex_group_bending_length(PointerRNA *ptr);
void ClothSettings_vertex_group_bending_set(PointerRNA *ptr, const char *value);

bool ClothSettings_internal_spring_normal_check_get(PointerRNA *ptr);
void ClothSettings_internal_spring_normal_check_set(PointerRNA *ptr, bool value);

float ClothSettings_collider_friction_get(PointerRNA *ptr);
void ClothSettings_collider_friction_set(PointerRNA *ptr, float value);

float ClothSettings_compression_damping_get(PointerRNA *ptr);
void ClothSettings_compression_damping_set(PointerRNA *ptr, float value);

float ClothSettings_compression_stiffness_get(PointerRNA *ptr);
void ClothSettings_compression_stiffness_set(PointerRNA *ptr, float value);

float ClothSettings_internal_compression_stiffness_get(PointerRNA *ptr);
void ClothSettings_internal_compression_stiffness_set(PointerRNA *ptr, float value);

float ClothSettings_compression_stiffness_max_get(PointerRNA *ptr);
void ClothSettings_compression_stiffness_max_set(PointerRNA *ptr, float value);

float ClothSettings_internal_compression_stiffness_max_get(PointerRNA *ptr);
void ClothSettings_internal_compression_stiffness_max_set(PointerRNA *ptr, float value);

bool ClothSettings_use_internal_springs_get(PointerRNA *ptr);
void ClothSettings_use_internal_springs_set(PointerRNA *ptr, bool value);

bool ClothSettings_use_dynamic_mesh_get(PointerRNA *ptr);
void ClothSettings_use_dynamic_mesh_set(PointerRNA *ptr, bool value);

PointerRNA ClothSettings_effector_weights_get(PointerRNA *ptr);

float ClothSettings_fluid_density_get(PointerRNA *ptr);
void ClothSettings_fluid_density_set(PointerRNA *ptr, float value);

float ClothSettings_goal_friction_get(PointerRNA *ptr);
void ClothSettings_goal_friction_set(PointerRNA *ptr, float value);

float ClothSettings_goal_default_get(PointerRNA *ptr);
void ClothSettings_goal_default_set(PointerRNA *ptr, float value);

float ClothSettings_goal_max_get(PointerRNA *ptr);
void ClothSettings_goal_max_set(PointerRNA *ptr, float value);

float ClothSettings_goal_min_get(PointerRNA *ptr);
void ClothSettings_goal_min_set(PointerRNA *ptr, float value);

float ClothSettings_goal_spring_get(PointerRNA *ptr);
void ClothSettings_goal_spring_set(PointerRNA *ptr, float value);

void ClothSettings_gravity_get(PointerRNA *ptr, float values[3]);
void ClothSettings_gravity_set(PointerRNA *ptr, const float values[3]);

float ClothSettings_internal_friction_get(PointerRNA *ptr);
void ClothSettings_internal_friction_set(PointerRNA *ptr, float value);

float ClothSettings_internal_spring_max_diversion_get(PointerRNA *ptr);
void ClothSettings_internal_spring_max_diversion_set(PointerRNA *ptr, float value);

float ClothSettings_internal_spring_max_length_get(PointerRNA *ptr);
void ClothSettings_internal_spring_max_length_set(PointerRNA *ptr, float value);

void ClothSettings_vertex_group_intern_get(PointerRNA *ptr, char *value);
int ClothSettings_vertex_group_intern_length(PointerRNA *ptr);
void ClothSettings_vertex_group_intern_set(PointerRNA *ptr, const char *value);

float ClothSettings_pin_stiffness_get(PointerRNA *ptr);
void ClothSettings_pin_stiffness_set(PointerRNA *ptr, float value);

void ClothSettings_vertex_group_mass_get(PointerRNA *ptr, char *value);
int ClothSettings_vertex_group_mass_length(PointerRNA *ptr);
void ClothSettings_vertex_group_mass_set(PointerRNA *ptr, const char *value);

float ClothSettings_uniform_pressure_force_get(PointerRNA *ptr);
void ClothSettings_uniform_pressure_force_set(PointerRNA *ptr, float value);

float ClothSettings_pressure_factor_get(PointerRNA *ptr);
void ClothSettings_pressure_factor_set(PointerRNA *ptr, float value);

void ClothSettings_vertex_group_pressure_get(PointerRNA *ptr, char *value);
int ClothSettings_vertex_group_pressure_length(PointerRNA *ptr);
void ClothSettings_vertex_group_pressure_set(PointerRNA *ptr, const char *value);

int ClothSettings_quality_get(PointerRNA *ptr);
void ClothSettings_quality_set(PointerRNA *ptr, int value);

PointerRNA ClothSettings_rest_shape_key_get(PointerRNA *ptr);

bool ClothSettings_use_sewing_springs_get(PointerRNA *ptr);
void ClothSettings_use_sewing_springs_set(PointerRNA *ptr, bool value);

float ClothSettings_sewing_force_max_get(PointerRNA *ptr);
void ClothSettings_sewing_force_max_set(PointerRNA *ptr, float value);

float ClothSettings_shear_damping_get(PointerRNA *ptr);
void ClothSettings_shear_damping_set(PointerRNA *ptr, float value);

float ClothSettings_shear_stiffness_get(PointerRNA *ptr);
void ClothSettings_shear_stiffness_set(PointerRNA *ptr, float value);

float ClothSettings_shear_stiffness_max_get(PointerRNA *ptr);
void ClothSettings_shear_stiffness_max_set(PointerRNA *ptr, float value);

void ClothSettings_vertex_group_shear_stiffness_get(PointerRNA *ptr, char *value);
int ClothSettings_vertex_group_shear_stiffness_length(PointerRNA *ptr);
void ClothSettings_vertex_group_shear_stiffness_set(PointerRNA *ptr, const char *value);

float ClothSettings_shrink_min_get(PointerRNA *ptr);
void ClothSettings_shrink_min_set(PointerRNA *ptr, float value);

float ClothSettings_shrink_max_get(PointerRNA *ptr);
void ClothSettings_shrink_max_set(PointerRNA *ptr, float value);

void ClothSettings_vertex_group_shrink_get(PointerRNA *ptr, char *value);
int ClothSettings_vertex_group_shrink_length(PointerRNA *ptr);
void ClothSettings_vertex_group_shrink_set(PointerRNA *ptr, const char *value);

float ClothSettings_time_scale_get(PointerRNA *ptr);
void ClothSettings_time_scale_set(PointerRNA *ptr, float value);

void ClothSettings_vertex_group_structural_stiffness_get(PointerRNA *ptr, char *value);
int ClothSettings_vertex_group_structural_stiffness_length(PointerRNA *ptr);
void ClothSettings_vertex_group_structural_stiffness_set(PointerRNA *ptr, const char *value);

float ClothSettings_density_target_get(PointerRNA *ptr);
void ClothSettings_density_target_set(PointerRNA *ptr, float value);

float ClothSettings_density_strength_get(PointerRNA *ptr);
void ClothSettings_density_strength_set(PointerRNA *ptr, float value);

float ClothSettings_target_volume_get(PointerRNA *ptr);
void ClothSettings_target_volume_set(PointerRNA *ptr, float value);

float ClothSettings_tension_damping_get(PointerRNA *ptr);
void ClothSettings_tension_damping_set(PointerRNA *ptr, float value);

float ClothSettings_tension_stiffness_get(PointerRNA *ptr);
void ClothSettings_tension_stiffness_set(PointerRNA *ptr, float value);

float ClothSettings_internal_tension_stiffness_get(PointerRNA *ptr);
void ClothSettings_internal_tension_stiffness_set(PointerRNA *ptr, float value);

float ClothSettings_tension_stiffness_max_get(PointerRNA *ptr);
void ClothSettings_tension_stiffness_max_set(PointerRNA *ptr, float value);

float ClothSettings_internal_tension_stiffness_max_get(PointerRNA *ptr);
void ClothSettings_internal_tension_stiffness_max_set(PointerRNA *ptr, float value);

bool ClothSettings_use_pressure_volume_get(PointerRNA *ptr);
void ClothSettings_use_pressure_volume_set(PointerRNA *ptr, bool value);

bool ClothSettings_use_pressure_get(PointerRNA *ptr);
void ClothSettings_use_pressure_set(PointerRNA *ptr, bool value);

float ClothSettings_mass_get(PointerRNA *ptr);
void ClothSettings_mass_set(PointerRNA *ptr, float value);

float ClothSettings_voxel_cell_size_get(PointerRNA *ptr);
void ClothSettings_voxel_cell_size_set(PointerRNA *ptr, float value);

/**************** Solver Result ****************/

extern StructRNA RNA_ClothSolverResult;

PointerRNA ClothSolverResult_rna_type_get(PointerRNA *ptr);

float ClothSolverResult_avg_error_get(PointerRNA *ptr);
void ClothSolverResult_avg_error_set(PointerRNA *ptr, float value);

float ClothSolverResult_avg_iterations_get(PointerRNA *ptr);
void ClothSolverResult_avg_iterations_set(PointerRNA *ptr, float value);

float ClothSolverResult_max_error_get(PointerRNA *ptr);
void ClothSolverResult_max_error_set(PointerRNA *ptr, float value);

int ClothSolverResult_max_iterations_get(PointerRNA *ptr);
void ClothSolverResult_max_iterations_set(PointerRNA *ptr, int value);

float ClothSolverResult_min_error_get(PointerRNA *ptr);
void ClothSolverResult_min_error_set(PointerRNA *ptr, float value);

int ClothSolverResult_min_iterations_get(PointerRNA *ptr);
void ClothSolverResult_min_iterations_set(PointerRNA *ptr, int value);

enum {
	ClothSolverResult_status_SUCCESS = 1,
	ClothSolverResult_status_NUMERICAL_ISSUE = 2,
	ClothSolverResult_status_NO_CONVERGENCE = 4,
	ClothSolverResult_status_INVALID_INPUT = 8,
};

int ClothSolverResult_status_get(PointerRNA *ptr);
void ClothSolverResult_status_set(PointerRNA *ptr, int value);

/**************** Clouds Texture ****************/

extern StructRNA RNA_CloudsTexture;
extern StructRNA RNA_Texture;
extern StructRNA RNA_ID;

enum {
	CloudsTexture_cloud_type_GRAYSCALE = 0,
	CloudsTexture_cloud_type_COLOR = 1,
};

int CloudsTexture_cloud_type_get(PointerRNA *ptr);
void CloudsTexture_cloud_type_set(PointerRNA *ptr, int value);

float CloudsTexture_nabla_get(PointerRNA *ptr);
void CloudsTexture_nabla_set(PointerRNA *ptr, float value);

enum {
	CloudsTexture_noise_basis_BLENDER_ORIGINAL = 0,
	CloudsTexture_noise_basis_ORIGINAL_PERLIN = 1,
	CloudsTexture_noise_basis_IMPROVED_PERLIN = 2,
	CloudsTexture_noise_basis_VORONOI_F1 = 3,
	CloudsTexture_noise_basis_VORONOI_F2 = 4,
	CloudsTexture_noise_basis_VORONOI_F3 = 5,
	CloudsTexture_noise_basis_VORONOI_F4 = 6,
	CloudsTexture_noise_basis_VORONOI_F2_F1 = 7,
	CloudsTexture_noise_basis_VORONOI_CRACKLE = 8,
	CloudsTexture_noise_basis_CELL_NOISE = 14,
};

int CloudsTexture_noise_basis_get(PointerRNA *ptr);
void CloudsTexture_noise_basis_set(PointerRNA *ptr, int value);

int CloudsTexture_noise_depth_get(PointerRNA *ptr);
void CloudsTexture_noise_depth_set(PointerRNA *ptr, int value);

float CloudsTexture_noise_scale_get(PointerRNA *ptr);
void CloudsTexture_noise_scale_set(PointerRNA *ptr, float value);

enum {
	CloudsTexture_noise_type_SOFT_NOISE = 0,
	CloudsTexture_noise_type_HARD_NOISE = 1,
};

int CloudsTexture_noise_type_get(PointerRNA *ptr);
void CloudsTexture_noise_type_set(PointerRNA *ptr, int value);

/**************** Collection ****************/

extern StructRNA RNA_Collection;
extern StructRNA RNA_ID;

int Collection_active_exporter_index_get(PointerRNA *ptr);
void Collection_active_exporter_index_set(PointerRNA *ptr, int value);

void Collection_all_objects_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Collection_all_objects_next(CollectionPropertyIterator *iter);
void Collection_all_objects_end(CollectionPropertyIterator *iter);

void Collection_children_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Collection_children_next(CollectionPropertyIterator *iter);
void Collection_children_end(CollectionPropertyIterator *iter);
bool Collection_children_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Collection_children_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void Collection_collection_children_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Collection_collection_children_next(CollectionPropertyIterator *iter);
void Collection_collection_children_end(CollectionPropertyIterator *iter);
bool Collection_collection_children_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

enum {
	Collection_color_tag_NONE = -1,
	Collection_color_tag_COLOR_01 = 0,
	Collection_color_tag_COLOR_02 = 1,
	Collection_color_tag_COLOR_03 = 2,
	Collection_color_tag_COLOR_04 = 3,
	Collection_color_tag_COLOR_05 = 4,
	Collection_color_tag_COLOR_06 = 5,
	Collection_color_tag_COLOR_07 = 6,
	Collection_color_tag_COLOR_08 = 7,
};

int Collection_color_tag_get(PointerRNA *ptr);
void Collection_color_tag_set(PointerRNA *ptr, int value);

void Collection_exporters_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Collection_exporters_next(CollectionPropertyIterator *iter);
void Collection_exporters_end(CollectionPropertyIterator *iter);
bool Collection_exporters_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Collection_exporters_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void Collection_collection_objects_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Collection_collection_objects_next(CollectionPropertyIterator *iter);
void Collection_collection_objects_end(CollectionPropertyIterator *iter);
bool Collection_collection_objects_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool Collection_hide_select_get(PointerRNA *ptr);
void Collection_hide_select_set(PointerRNA *ptr, bool value);

bool Collection_hide_render_get(PointerRNA *ptr);
void Collection_hide_render_set(PointerRNA *ptr, bool value);

bool Collection_hide_viewport_get(PointerRNA *ptr);
void Collection_hide_viewport_set(PointerRNA *ptr, bool value);

void Collection_instance_offset_get(PointerRNA *ptr, float values[3]);
void Collection_instance_offset_set(PointerRNA *ptr, const float values[3]);

int Collection_lineart_intersection_priority_get(PointerRNA *ptr);
void Collection_lineart_intersection_priority_set(PointerRNA *ptr, int value);

void Collection_lineart_intersection_mask_get(PointerRNA *ptr, bool values[8]);
void Collection_lineart_intersection_mask_set(PointerRNA *ptr, const bool values[8]);

void Collection_objects_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Collection_objects_next(CollectionPropertyIterator *iter);
void Collection_objects_end(CollectionPropertyIterator *iter);

enum {
	Collection_lineart_usage_INCLUDE = 0,
	Collection_lineart_usage_OCCLUSION_ONLY = 1,
	Collection_lineart_usage_EXCLUDE = 2,
	Collection_lineart_usage_INTERSECTION_ONLY = 4,
	Collection_lineart_usage_NO_INTERSECTION = 8,
	Collection_lineart_usage_FORCE_INTERSECTION = 16,
};

int Collection_lineart_usage_get(PointerRNA *ptr);
void Collection_lineart_usage_set(PointerRNA *ptr, int value);

bool Collection_lineart_use_intersection_mask_get(PointerRNA *ptr);
void Collection_lineart_use_intersection_mask_set(PointerRNA *ptr, bool value);

bool Collection_use_lineart_intersection_priority_get(PointerRNA *ptr);
void Collection_use_lineart_intersection_priority_set(PointerRNA *ptr, bool value);

/**************** Collection Child ****************/

extern StructRNA RNA_CollectionChild;

PointerRNA CollectionChild_rna_type_get(PointerRNA *ptr);

PointerRNA CollectionChild_light_linking_get(PointerRNA *ptr);

/**************** Collection Children ****************/

extern StructRNA RNA_CollectionChildren;

PointerRNA CollectionChildren_rna_type_get(PointerRNA *ptr);

void CollectionChildren_link_func(struct Collection *_self, Main *bmain, ReportList *reports, struct Collection *child);
void CollectionChildren_unlink_func(struct Collection *_self, Main *bmain, ReportList *reports, struct Collection *child);
/**************** Name ****************/

extern StructRNA RNA_CollectionExport;

PointerRNA CollectionExport_rna_type_get(PointerRNA *ptr);

#define CollectionExport_name_MAX 64

void CollectionExport_name_get(PointerRNA *ptr, char *value);
int CollectionExport_name_length(PointerRNA *ptr);
void CollectionExport_name_set(PointerRNA *ptr, const char *value);

PointerRNA CollectionExport_export_properties_get(PointerRNA *ptr);

#define CollectionExport_filepath_MAX 1024

void CollectionExport_filepath_get(PointerRNA *ptr, char *value);
int CollectionExport_filepath_length(PointerRNA *ptr);
void CollectionExport_filepath_set(PointerRNA *ptr, const char *value);

bool CollectionExport_is_open_get(PointerRNA *ptr);
void CollectionExport_is_open_set(PointerRNA *ptr, bool value);

/**************** Collection Light Linking ****************/

extern StructRNA RNA_CollectionLightLinking;

PointerRNA CollectionLightLinking_rna_type_get(PointerRNA *ptr);

enum {
	CollectionLightLinking_link_state_INCLUDE = 0,
	CollectionLightLinking_link_state_EXCLUDE = 1,
};

int CollectionLightLinking_link_state_get(PointerRNA *ptr);
void CollectionLightLinking_link_state_set(PointerRNA *ptr, int value);

/**************** Collection Object ****************/

extern StructRNA RNA_CollectionObject;

PointerRNA CollectionObject_rna_type_get(PointerRNA *ptr);

PointerRNA CollectionObject_light_linking_get(PointerRNA *ptr);

/**************** Collection Objects ****************/

extern StructRNA RNA_CollectionObjects;

PointerRNA CollectionObjects_rna_type_get(PointerRNA *ptr);

void CollectionObjects_link_func(struct Collection *_self, Main *bmain, ReportList *reports, struct Object *object);
void CollectionObjects_unlink_func(struct Collection *_self, Main *bmain, ReportList *reports, struct Object *object);
/**************** Collection Definition ****************/

extern StructRNA RNA_CollectionProperty;
extern StructRNA RNA_Property;

PointerRNA CollectionProperty_fixed_type_get(PointerRNA *ptr);

/**************** Collision Modifier ****************/

extern StructRNA RNA_CollisionModifier;
extern StructRNA RNA_Modifier;

PointerRNA CollisionModifier_settings_get(PointerRNA *ptr);

/**************** Collision Settings ****************/

extern StructRNA RNA_CollisionSettings;

PointerRNA CollisionSettings_rna_type_get(PointerRNA *ptr);

float CollisionSettings_absorption_get(PointerRNA *ptr);
void CollisionSettings_absorption_set(PointerRNA *ptr, float value);

float CollisionSettings_damping_get(PointerRNA *ptr);
void CollisionSettings_damping_set(PointerRNA *ptr, float value);

float CollisionSettings_damping_factor_get(PointerRNA *ptr);
void CollisionSettings_damping_factor_set(PointerRNA *ptr, float value);

bool CollisionSettings_use_get(PointerRNA *ptr);
void CollisionSettings_use_set(PointerRNA *ptr, bool value);

float CollisionSettings_cloth_friction_get(PointerRNA *ptr);
void CollisionSettings_cloth_friction_set(PointerRNA *ptr, float value);

float CollisionSettings_friction_factor_get(PointerRNA *ptr);
void CollisionSettings_friction_factor_set(PointerRNA *ptr, float value);

float CollisionSettings_thickness_inner_get(PointerRNA *ptr);
void CollisionSettings_thickness_inner_set(PointerRNA *ptr, float value);

bool CollisionSettings_use_particle_kill_get(PointerRNA *ptr);
void CollisionSettings_use_particle_kill_set(PointerRNA *ptr, bool value);

float CollisionSettings_thickness_outer_get(PointerRNA *ptr);
void CollisionSettings_thickness_outer_set(PointerRNA *ptr, float value);

bool CollisionSettings_use_normal_get(PointerRNA *ptr);
void CollisionSettings_use_normal_set(PointerRNA *ptr, bool value);

float CollisionSettings_permeability_get(PointerRNA *ptr);
void CollisionSettings_permeability_set(PointerRNA *ptr, float value);

float CollisionSettings_damping_random_get(PointerRNA *ptr);
void CollisionSettings_damping_random_set(PointerRNA *ptr, float value);

float CollisionSettings_friction_random_get(PointerRNA *ptr);
void CollisionSettings_friction_random_set(PointerRNA *ptr, float value);

bool CollisionSettings_use_culling_get(PointerRNA *ptr);
void CollisionSettings_use_culling_set(PointerRNA *ptr, bool value);

float CollisionSettings_stickiness_get(PointerRNA *ptr);
void CollisionSettings_stickiness_set(PointerRNA *ptr, float value);

/**************** ColorBalanceModifier ****************/

extern StructRNA RNA_ColorBalanceModifier;
extern StructRNA RNA_StripModifier;

float ColorBalanceModifier_color_multiply_get(PointerRNA *ptr);
void ColorBalanceModifier_color_multiply_set(PointerRNA *ptr, float value);

PointerRNA ColorBalanceModifier_color_balance_get(PointerRNA *ptr);

/**************** ColorManagedDisplaySettings ****************/

extern StructRNA RNA_ColorManagedDisplaySettings;

PointerRNA ColorManagedDisplaySettings_rna_type_get(PointerRNA *ptr);

enum {
	ColorManagedDisplaySettings_display_device_NONE = 0,
};

int ColorManagedDisplaySettings_display_device_get(PointerRNA *ptr);
void ColorManagedDisplaySettings_display_device_set(PointerRNA *ptr, int value);

/**************** ColorManagedInputColorspaceSettings ****************/

extern StructRNA RNA_ColorManagedInputColorspaceSettings;

PointerRNA ColorManagedInputColorspaceSettings_rna_type_get(PointerRNA *ptr);

enum {
	ColorManagedInputColorspaceSettings_name_NONE = 0,
};

int ColorManagedInputColorspaceSettings_name_get(PointerRNA *ptr);
void ColorManagedInputColorspaceSettings_name_set(PointerRNA *ptr, int value);

bool ColorManagedInputColorspaceSettings_is_data_get(PointerRNA *ptr);
void ColorManagedInputColorspaceSettings_is_data_set(PointerRNA *ptr, bool value);

/**************** ColorManagedSequencerColorspaceSettings ****************/

extern StructRNA RNA_ColorManagedSequencerColorspaceSettings;

PointerRNA ColorManagedSequencerColorspaceSettings_rna_type_get(PointerRNA *ptr);

enum {
	ColorManagedSequencerColorspaceSettings_name_NONE = 0,
};

int ColorManagedSequencerColorspaceSettings_name_get(PointerRNA *ptr);
void ColorManagedSequencerColorspaceSettings_name_set(PointerRNA *ptr, int value);

/**************** ColorManagedViewSettings ****************/

extern StructRNA RNA_ColorManagedViewSettings;

PointerRNA ColorManagedViewSettings_rna_type_get(PointerRNA *ptr);

PointerRNA ColorManagedViewSettings_curve_mapping_get(PointerRNA *ptr);

float ColorManagedViewSettings_exposure_get(PointerRNA *ptr);
void ColorManagedViewSettings_exposure_set(PointerRNA *ptr, float value);

float ColorManagedViewSettings_gamma_get(PointerRNA *ptr);
void ColorManagedViewSettings_gamma_set(PointerRNA *ptr, float value);

bool ColorManagedViewSettings_use_hdr_view_get(PointerRNA *ptr);
void ColorManagedViewSettings_use_hdr_view_set(PointerRNA *ptr, bool value);

enum {
	ColorManagedViewSettings_look_NONE = 0,
};

int ColorManagedViewSettings_look_get(PointerRNA *ptr);
void ColorManagedViewSettings_look_set(PointerRNA *ptr, int value);

float ColorManagedViewSettings_white_balance_temperature_get(PointerRNA *ptr);
void ColorManagedViewSettings_white_balance_temperature_set(PointerRNA *ptr, float value);

float ColorManagedViewSettings_white_balance_tint_get(PointerRNA *ptr);
void ColorManagedViewSettings_white_balance_tint_set(PointerRNA *ptr, float value);

bool ColorManagedViewSettings_use_curve_mapping_get(PointerRNA *ptr);
void ColorManagedViewSettings_use_curve_mapping_set(PointerRNA *ptr, bool value);

bool ColorManagedViewSettings_use_white_balance_get(PointerRNA *ptr);
void ColorManagedViewSettings_use_white_balance_set(PointerRNA *ptr, bool value);

enum {
	ColorManagedViewSettings_view_transform_NONE = 0,
};

int ColorManagedViewSettings_view_transform_get(PointerRNA *ptr);
void ColorManagedViewSettings_view_transform_set(PointerRNA *ptr, int value);

void ColorManagedViewSettings_white_balance_whitepoint_get(PointerRNA *ptr, float values[3]);
void ColorManagedViewSettings_white_balance_whitepoint_set(PointerRNA *ptr, const float values[3]);

/**************** Color Mapping ****************/

extern StructRNA RNA_ColorMapping;

PointerRNA ColorMapping_rna_type_get(PointerRNA *ptr);

float ColorMapping_blend_factor_get(PointerRNA *ptr);
void ColorMapping_blend_factor_set(PointerRNA *ptr, float value);

enum {
	ColorMapping_blend_type_MIX = 0,
	ColorMapping_blend_type_DARKEN = 5,
	ColorMapping_blend_type_MULTIPLY = 1,
	ColorMapping_blend_type_LIGHTEN = 7,
	ColorMapping_blend_type_SCREEN = 8,
	ColorMapping_blend_type_ADD = 2,
	ColorMapping_blend_type_OVERLAY = 9,
	ColorMapping_blend_type_SOFT_LIGHT = 15,
	ColorMapping_blend_type_LINEAR_LIGHT = 16,
	ColorMapping_blend_type_DIFFERENCE = 6,
	ColorMapping_blend_type_SUBTRACT = 3,
	ColorMapping_blend_type_DIVIDE = 4,
	ColorMapping_blend_type_HUE = 10,
	ColorMapping_blend_type_SATURATION = 11,
	ColorMapping_blend_type_COLOR = 13,
	ColorMapping_blend_type_VALUE = 12,
};

int ColorMapping_blend_type_get(PointerRNA *ptr);
void ColorMapping_blend_type_set(PointerRNA *ptr, int value);

float ColorMapping_brightness_get(PointerRNA *ptr);
void ColorMapping_brightness_set(PointerRNA *ptr, float value);

void ColorMapping_blend_color_get(PointerRNA *ptr, float values[3]);
void ColorMapping_blend_color_set(PointerRNA *ptr, const float values[3]);

PointerRNA ColorMapping_color_ramp_get(PointerRNA *ptr);

float ColorMapping_contrast_get(PointerRNA *ptr);
void ColorMapping_contrast_set(PointerRNA *ptr, float value);

float ColorMapping_saturation_get(PointerRNA *ptr);
void ColorMapping_saturation_set(PointerRNA *ptr, float value);

bool ColorMapping_use_color_ramp_get(PointerRNA *ptr);
void ColorMapping_use_color_ramp_set(PointerRNA *ptr, bool value);

/**************** Color Mix Strip ****************/

extern StructRNA RNA_ColorMixStrip;
extern StructRNA RNA_EffectStrip;
extern StructRNA RNA_Strip;

float ColorMixStrip_factor_get(PointerRNA *ptr);
void ColorMixStrip_factor_set(PointerRNA *ptr, float value);

enum {
	ColorMixStrip_blend_effect_DARKEN = 46,
	ColorMixStrip_blend_effect_MULTIPLY = 14,
	ColorMixStrip_blend_effect_BURN = 47,
	ColorMixStrip_blend_effect_LINEAR_BURN = 48,
	ColorMixStrip_blend_effect_LIGHTEN = 44,
	ColorMixStrip_blend_effect_SCREEN = 43,
	ColorMixStrip_blend_effect_DODGE = 45,
	ColorMixStrip_blend_effect_ADD = 9,
	ColorMixStrip_blend_effect_OVERLAY = 49,
	ColorMixStrip_blend_effect_SOFT_LIGHT = 51,
	ColorMixStrip_blend_effect_HARD_LIGHT = 50,
	ColorMixStrip_blend_effect_VIVID_LIGHT = 54,
	ColorMixStrip_blend_effect_LINEAR_LIGHT = 53,
	ColorMixStrip_blend_effect_PIN_LIGHT = 52,
	ColorMixStrip_blend_effect_DIFFERENCE = 59,
	ColorMixStrip_blend_effect_EXCLUSION = 60,
	ColorMixStrip_blend_effect_SUBTRACT = 10,
	ColorMixStrip_blend_effect_HUE = 55,
	ColorMixStrip_blend_effect_SATURATION = 56,
	ColorMixStrip_blend_effect_COLOR = 58,
	ColorMixStrip_blend_effect_VALUE = 57,
};

int ColorMixStrip_blend_effect_get(PointerRNA *ptr);
void ColorMixStrip_blend_effect_set(PointerRNA *ptr, int value);

PointerRNA ColorMixStrip_input_1_get(PointerRNA *ptr);

PointerRNA ColorMixStrip_input_2_get(PointerRNA *ptr);

int ColorMixStrip_input_count_get(PointerRNA *ptr);
void ColorMixStrip_input_count_set(PointerRNA *ptr, int value);

/**************** Color Ramp ****************/

extern StructRNA RNA_ColorRamp;

PointerRNA ColorRamp_rna_type_get(PointerRNA *ptr);

enum {
	ColorRamp_hue_interpolation_NEAR = 0,
	ColorRamp_hue_interpolation_FAR = 1,
	ColorRamp_hue_interpolation_CW = 2,
	ColorRamp_hue_interpolation_CCW = 3,
};

int ColorRamp_hue_interpolation_get(PointerRNA *ptr);
void ColorRamp_hue_interpolation_set(PointerRNA *ptr, int value);

enum {
	ColorRamp_color_mode_RGB = 0,
	ColorRamp_color_mode_HSV = 1,
	ColorRamp_color_mode_HSL = 2,
};

int ColorRamp_color_mode_get(PointerRNA *ptr);
void ColorRamp_color_mode_set(PointerRNA *ptr, int value);

void ColorRamp_elements_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ColorRamp_elements_next(CollectionPropertyIterator *iter);
void ColorRamp_elements_end(CollectionPropertyIterator *iter);
int ColorRamp_elements_length(PointerRNA *ptr);
bool ColorRamp_elements_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

enum {
	ColorRamp_interpolation_EASE = 1,
	ColorRamp_interpolation_CARDINAL = 3,
	ColorRamp_interpolation_LINEAR = 0,
	ColorRamp_interpolation_B_SPLINE = 2,
	ColorRamp_interpolation_CONSTANT = 4,
};

int ColorRamp_interpolation_get(PointerRNA *ptr);
void ColorRamp_interpolation_set(PointerRNA *ptr, int value);

void ColorRamp_evaluate_func(struct ColorBand *_self, float position, float color[4]);
/**************** Color Ramp Element ****************/

extern StructRNA RNA_ColorRampElement;

PointerRNA ColorRampElement_rna_type_get(PointerRNA *ptr);

float ColorRampElement_alpha_get(PointerRNA *ptr);
void ColorRampElement_alpha_set(PointerRNA *ptr, float value);

void ColorRampElement_color_get(PointerRNA *ptr, float values[4]);
void ColorRampElement_color_set(PointerRNA *ptr, const float values[4]);

float ColorRampElement_position_get(PointerRNA *ptr);
void ColorRampElement_position_set(PointerRNA *ptr, float value);

/**************** Color Ramp Elements ****************/

extern StructRNA RNA_ColorRampElements;

PointerRNA ColorRampElements_rna_type_get(PointerRNA *ptr);

struct CBData *ColorRampElements_new_func(struct ColorBand *_self, ReportList *reports, float position);
void ColorRampElements_remove_func(struct ColorBand *_self, ReportList *reports, struct PointerRNA *element);
/**************** Color Strip ****************/

extern StructRNA RNA_ColorStrip;
extern StructRNA RNA_EffectStrip;
extern StructRNA RNA_Strip;

void ColorStrip_color_get(PointerRNA *ptr, float values[3]);
void ColorStrip_color_set(PointerRNA *ptr, const float values[3]);

int ColorStrip_input_count_get(PointerRNA *ptr);
void ColorStrip_input_count_set(PointerRNA *ptr, int value);

/**************** Compositor Node ****************/

extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

void CompositorNode_tag_need_exec_func(struct bNode *_self);
/**************** CompositorNodeAlphaOver ****************/

extern StructRNA RNA_CompositorNodeAlphaOver;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeAlphaOver_use_premultiply_get(PointerRNA *ptr);
void CompositorNodeAlphaOver_use_premultiply_set(PointerRNA *ptr, bool value);

float CompositorNodeAlphaOver_premul_get(PointerRNA *ptr);
void CompositorNodeAlphaOver_premul_set(PointerRNA *ptr, float value);

bool CompositorNodeAlphaOver_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeAlphaOver_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeAlphaOver_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeAntiAliasing ****************/

extern StructRNA RNA_CompositorNodeAntiAliasing;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float CompositorNodeAntiAliasing_contrast_limit_get(PointerRNA *ptr);
void CompositorNodeAntiAliasing_contrast_limit_set(PointerRNA *ptr, float value);

float CompositorNodeAntiAliasing_corner_rounding_get(PointerRNA *ptr);
void CompositorNodeAntiAliasing_corner_rounding_set(PointerRNA *ptr, float value);

float CompositorNodeAntiAliasing_threshold_get(PointerRNA *ptr);
void CompositorNodeAntiAliasing_threshold_set(PointerRNA *ptr, float value);

bool CompositorNodeAntiAliasing_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeAntiAliasing_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeAntiAliasing_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeBilateralblur ****************/

extern StructRNA RNA_CompositorNodeBilateralblur;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float CompositorNodeBilateralblur_sigma_color_get(PointerRNA *ptr);
void CompositorNodeBilateralblur_sigma_color_set(PointerRNA *ptr, float value);

int CompositorNodeBilateralblur_iterations_get(PointerRNA *ptr);
void CompositorNodeBilateralblur_iterations_set(PointerRNA *ptr, int value);

float CompositorNodeBilateralblur_sigma_space_get(PointerRNA *ptr);
void CompositorNodeBilateralblur_sigma_space_set(PointerRNA *ptr, float value);

bool CompositorNodeBilateralblur_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeBilateralblur_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeBilateralblur_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeBlur ****************/

extern StructRNA RNA_CompositorNodeBlur;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeBlur_aspect_correction_NONE = 0,
	CompositorNodeBlur_aspect_correction_Y = 1,
	CompositorNodeBlur_aspect_correction_X = 2,
};

int CompositorNodeBlur_aspect_correction_get(PointerRNA *ptr);
void CompositorNodeBlur_aspect_correction_set(PointerRNA *ptr, int value);

bool CompositorNodeBlur_use_bokeh_get(PointerRNA *ptr);
void CompositorNodeBlur_use_bokeh_set(PointerRNA *ptr, bool value);

bool CompositorNodeBlur_use_extended_bounds_get(PointerRNA *ptr);
void CompositorNodeBlur_use_extended_bounds_set(PointerRNA *ptr, bool value);

float CompositorNodeBlur_factor_get(PointerRNA *ptr);
void CompositorNodeBlur_factor_set(PointerRNA *ptr, float value);

enum {
	CompositorNodeBlur_filter_type_FLAT = 0,
	CompositorNodeBlur_filter_type_TENT = 1,
	CompositorNodeBlur_filter_type_QUAD = 2,
	CompositorNodeBlur_filter_type_CUBIC = 3,
	CompositorNodeBlur_filter_type_GAUSS = 5,
	CompositorNodeBlur_filter_type_FAST_GAUSS = 7,
	CompositorNodeBlur_filter_type_CATROM = 4,
	CompositorNodeBlur_filter_type_MITCH = 6,
};

int CompositorNodeBlur_filter_type_get(PointerRNA *ptr);
void CompositorNodeBlur_filter_type_set(PointerRNA *ptr, int value);

bool CompositorNodeBlur_use_gamma_correction_get(PointerRNA *ptr);
void CompositorNodeBlur_use_gamma_correction_set(PointerRNA *ptr, bool value);

bool CompositorNodeBlur_use_relative_get(PointerRNA *ptr);
void CompositorNodeBlur_use_relative_set(PointerRNA *ptr, bool value);

float CompositorNodeBlur_factor_x_get(PointerRNA *ptr);
void CompositorNodeBlur_factor_x_set(PointerRNA *ptr, float value);

float CompositorNodeBlur_factor_y_get(PointerRNA *ptr);
void CompositorNodeBlur_factor_y_set(PointerRNA *ptr, float value);

int CompositorNodeBlur_size_x_get(PointerRNA *ptr);
void CompositorNodeBlur_size_x_set(PointerRNA *ptr, int value);

int CompositorNodeBlur_size_y_get(PointerRNA *ptr);
void CompositorNodeBlur_size_y_set(PointerRNA *ptr, int value);

bool CompositorNodeBlur_use_variable_size_get(PointerRNA *ptr);
void CompositorNodeBlur_use_variable_size_set(PointerRNA *ptr, bool value);

bool CompositorNodeBlur_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeBlur_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeBlur_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeBokehBlur ****************/

extern StructRNA RNA_CompositorNodeBokehBlur;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeBokehBlur_use_extended_bounds_get(PointerRNA *ptr);
void CompositorNodeBokehBlur_use_extended_bounds_set(PointerRNA *ptr, bool value);

float CompositorNodeBokehBlur_blur_max_get(PointerRNA *ptr);
void CompositorNodeBokehBlur_blur_max_set(PointerRNA *ptr, float value);

bool CompositorNodeBokehBlur_use_variable_size_get(PointerRNA *ptr);
void CompositorNodeBokehBlur_use_variable_size_set(PointerRNA *ptr, bool value);

bool CompositorNodeBokehBlur_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeBokehBlur_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeBokehBlur_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeBokehImage ****************/

extern StructRNA RNA_CompositorNodeBokehImage;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float CompositorNodeBokehImage_angle_get(PointerRNA *ptr);
void CompositorNodeBokehImage_angle_set(PointerRNA *ptr, float value);

float CompositorNodeBokehImage_catadioptric_get(PointerRNA *ptr);
void CompositorNodeBokehImage_catadioptric_set(PointerRNA *ptr, float value);

int CompositorNodeBokehImage_flaps_get(PointerRNA *ptr);
void CompositorNodeBokehImage_flaps_set(PointerRNA *ptr, int value);

float CompositorNodeBokehImage_shift_get(PointerRNA *ptr);
void CompositorNodeBokehImage_shift_set(PointerRNA *ptr, float value);

float CompositorNodeBokehImage_rounding_get(PointerRNA *ptr);
void CompositorNodeBokehImage_rounding_set(PointerRNA *ptr, float value);

bool CompositorNodeBokehImage_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeBokehImage_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeBokehImage_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeBoxMask ****************/

extern StructRNA RNA_CompositorNodeBoxMask;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float CompositorNodeBoxMask_mask_height_get(PointerRNA *ptr);
void CompositorNodeBoxMask_mask_height_set(PointerRNA *ptr, float value);

enum {
	CompositorNodeBoxMask_mask_type_ADD = 0,
	CompositorNodeBoxMask_mask_type_SUBTRACT = 1,
	CompositorNodeBoxMask_mask_type_MULTIPLY = 2,
	CompositorNodeBoxMask_mask_type_NOT = 3,
};

int CompositorNodeBoxMask_mask_type_get(PointerRNA *ptr);
void CompositorNodeBoxMask_mask_type_set(PointerRNA *ptr, int value);

float CompositorNodeBoxMask_rotation_get(PointerRNA *ptr);
void CompositorNodeBoxMask_rotation_set(PointerRNA *ptr, float value);

float CompositorNodeBoxMask_mask_width_get(PointerRNA *ptr);
void CompositorNodeBoxMask_mask_width_set(PointerRNA *ptr, float value);

float CompositorNodeBoxMask_x_get(PointerRNA *ptr);
void CompositorNodeBoxMask_x_set(PointerRNA *ptr, float value);

float CompositorNodeBoxMask_y_get(PointerRNA *ptr);
void CompositorNodeBoxMask_y_set(PointerRNA *ptr, float value);

bool CompositorNodeBoxMask_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeBoxMask_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeBoxMask_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeBrightContrast ****************/

extern StructRNA RNA_CompositorNodeBrightContrast;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeBrightContrast_use_premultiply_get(PointerRNA *ptr);
void CompositorNodeBrightContrast_use_premultiply_set(PointerRNA *ptr, bool value);

bool CompositorNodeBrightContrast_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeBrightContrast_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeBrightContrast_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeChannelMatte ****************/

extern StructRNA RNA_CompositorNodeChannelMatte;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeChannelMatte_limit_method_SINGLE = 0,
	CompositorNodeChannelMatte_limit_method_MAX = 1,
};

int CompositorNodeChannelMatte_limit_method_get(PointerRNA *ptr);
void CompositorNodeChannelMatte_limit_method_set(PointerRNA *ptr, int value);

enum {
	CompositorNodeChannelMatte_matte_channel_R = 1,
	CompositorNodeChannelMatte_matte_channel_G = 2,
	CompositorNodeChannelMatte_matte_channel_B = 3,
};

int CompositorNodeChannelMatte_matte_channel_get(PointerRNA *ptr);
void CompositorNodeChannelMatte_matte_channel_set(PointerRNA *ptr, int value);

enum {
	CompositorNodeChannelMatte_color_space_RGB = 1,
	CompositorNodeChannelMatte_color_space_HSV = 2,
	CompositorNodeChannelMatte_color_space_YUV = 3,
	CompositorNodeChannelMatte_color_space_YCC = 4,
};

int CompositorNodeChannelMatte_color_space_get(PointerRNA *ptr);
void CompositorNodeChannelMatte_color_space_set(PointerRNA *ptr, int value);

float CompositorNodeChannelMatte_limit_max_get(PointerRNA *ptr);
void CompositorNodeChannelMatte_limit_max_set(PointerRNA *ptr, float value);

enum {
	CompositorNodeChannelMatte_limit_channel_R = 1,
	CompositorNodeChannelMatte_limit_channel_G = 2,
	CompositorNodeChannelMatte_limit_channel_B = 3,
};

int CompositorNodeChannelMatte_limit_channel_get(PointerRNA *ptr);
void CompositorNodeChannelMatte_limit_channel_set(PointerRNA *ptr, int value);

float CompositorNodeChannelMatte_limit_min_get(PointerRNA *ptr);
void CompositorNodeChannelMatte_limit_min_set(PointerRNA *ptr, float value);

bool CompositorNodeChannelMatte_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeChannelMatte_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeChannelMatte_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeChromaMatte ****************/

extern StructRNA RNA_CompositorNodeChromaMatte;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float CompositorNodeChromaMatte_tolerance_get(PointerRNA *ptr);
void CompositorNodeChromaMatte_tolerance_set(PointerRNA *ptr, float value);

float CompositorNodeChromaMatte_threshold_get(PointerRNA *ptr);
void CompositorNodeChromaMatte_threshold_set(PointerRNA *ptr, float value);

float CompositorNodeChromaMatte_gain_get(PointerRNA *ptr);
void CompositorNodeChromaMatte_gain_set(PointerRNA *ptr, float value);

float CompositorNodeChromaMatte_lift_get(PointerRNA *ptr);
void CompositorNodeChromaMatte_lift_set(PointerRNA *ptr, float value);

float CompositorNodeChromaMatte_shadow_adjust_get(PointerRNA *ptr);
void CompositorNodeChromaMatte_shadow_adjust_set(PointerRNA *ptr, float value);

bool CompositorNodeChromaMatte_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeChromaMatte_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeChromaMatte_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeColorBalance ****************/

extern StructRNA RNA_CompositorNodeColorBalance;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float CompositorNodeColorBalance_offset_basis_get(PointerRNA *ptr);
void CompositorNodeColorBalance_offset_basis_set(PointerRNA *ptr, float value);

enum {
	CompositorNodeColorBalance_correction_method_LIFT_GAMMA_GAIN = 0,
	CompositorNodeColorBalance_correction_method_OFFSET_POWER_SLOPE = 1,
	CompositorNodeColorBalance_correction_method_WHITEPOINT = 2,
};

int CompositorNodeColorBalance_correction_method_get(PointerRNA *ptr);
void CompositorNodeColorBalance_correction_method_set(PointerRNA *ptr, int value);

void CompositorNodeColorBalance_gain_get(PointerRNA *ptr, float values[3]);
void CompositorNodeColorBalance_gain_set(PointerRNA *ptr, const float values[3]);

void CompositorNodeColorBalance_gamma_get(PointerRNA *ptr, float values[3]);
void CompositorNodeColorBalance_gamma_set(PointerRNA *ptr, const float values[3]);

float CompositorNodeColorBalance_input_temperature_get(PointerRNA *ptr);
void CompositorNodeColorBalance_input_temperature_set(PointerRNA *ptr, float value);

float CompositorNodeColorBalance_input_tint_get(PointerRNA *ptr);
void CompositorNodeColorBalance_input_tint_set(PointerRNA *ptr, float value);

void CompositorNodeColorBalance_input_whitepoint_get(PointerRNA *ptr, float values[3]);
void CompositorNodeColorBalance_input_whitepoint_set(PointerRNA *ptr, const float values[3]);

void CompositorNodeColorBalance_lift_get(PointerRNA *ptr, float values[3]);
void CompositorNodeColorBalance_lift_set(PointerRNA *ptr, const float values[3]);

void CompositorNodeColorBalance_offset_get(PointerRNA *ptr, float values[3]);
void CompositorNodeColorBalance_offset_set(PointerRNA *ptr, const float values[3]);

float CompositorNodeColorBalance_output_temperature_get(PointerRNA *ptr);
void CompositorNodeColorBalance_output_temperature_set(PointerRNA *ptr, float value);

float CompositorNodeColorBalance_output_tint_get(PointerRNA *ptr);
void CompositorNodeColorBalance_output_tint_set(PointerRNA *ptr, float value);

void CompositorNodeColorBalance_output_whitepoint_get(PointerRNA *ptr, float values[3]);
void CompositorNodeColorBalance_output_whitepoint_set(PointerRNA *ptr, const float values[3]);

void CompositorNodeColorBalance_power_get(PointerRNA *ptr, float values[3]);
void CompositorNodeColorBalance_power_set(PointerRNA *ptr, const float values[3]);

void CompositorNodeColorBalance_slope_get(PointerRNA *ptr, float values[3]);
void CompositorNodeColorBalance_slope_set(PointerRNA *ptr, const float values[3]);

bool CompositorNodeColorBalance_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeColorBalance_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeColorBalance_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeColorCorrection ****************/

extern StructRNA RNA_CompositorNodeColorCorrection;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeColorCorrection_blue_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_blue_set(PointerRNA *ptr, bool value);

bool CompositorNodeColorCorrection_green_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_green_set(PointerRNA *ptr, bool value);

float CompositorNodeColorCorrection_highlights_contrast_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_highlights_contrast_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_highlights_gain_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_highlights_gain_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_highlights_gamma_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_highlights_gamma_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_highlights_lift_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_highlights_lift_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_highlights_saturation_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_highlights_saturation_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_master_contrast_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_master_contrast_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_master_gain_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_master_gain_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_master_gamma_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_master_gamma_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_master_lift_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_master_lift_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_master_saturation_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_master_saturation_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_midtones_contrast_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_midtones_contrast_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_midtones_end_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_midtones_end_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_midtones_gain_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_midtones_gain_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_midtones_gamma_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_midtones_gamma_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_midtones_lift_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_midtones_lift_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_midtones_saturation_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_midtones_saturation_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_midtones_start_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_midtones_start_set(PointerRNA *ptr, float value);

bool CompositorNodeColorCorrection_red_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_red_set(PointerRNA *ptr, bool value);

float CompositorNodeColorCorrection_shadows_contrast_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_shadows_contrast_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_shadows_gain_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_shadows_gain_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_shadows_gamma_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_shadows_gamma_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_shadows_lift_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_shadows_lift_set(PointerRNA *ptr, float value);

float CompositorNodeColorCorrection_shadows_saturation_get(PointerRNA *ptr);
void CompositorNodeColorCorrection_shadows_saturation_set(PointerRNA *ptr, float value);

bool CompositorNodeColorCorrection_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeColorCorrection_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeColorCorrection_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeColorMatte ****************/

extern StructRNA RNA_CompositorNodeColorMatte;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float CompositorNodeColorMatte_color_hue_get(PointerRNA *ptr);
void CompositorNodeColorMatte_color_hue_set(PointerRNA *ptr, float value);

float CompositorNodeColorMatte_color_saturation_get(PointerRNA *ptr);
void CompositorNodeColorMatte_color_saturation_set(PointerRNA *ptr, float value);

float CompositorNodeColorMatte_color_value_get(PointerRNA *ptr);
void CompositorNodeColorMatte_color_value_set(PointerRNA *ptr, float value);

bool CompositorNodeColorMatte_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeColorMatte_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeColorMatte_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeColorSpill ****************/

extern StructRNA RNA_CompositorNodeColorSpill;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeColorSpill_limit_method_SIMPLE = 0,
	CompositorNodeColorSpill_limit_method_AVERAGE = 1,
};

int CompositorNodeColorSpill_limit_method_get(PointerRNA *ptr);
void CompositorNodeColorSpill_limit_method_set(PointerRNA *ptr, int value);

float CompositorNodeColorSpill_unspill_blue_get(PointerRNA *ptr);
void CompositorNodeColorSpill_unspill_blue_set(PointerRNA *ptr, float value);

enum {
	CompositorNodeColorSpill_channel_R = 1,
	CompositorNodeColorSpill_channel_G = 2,
	CompositorNodeColorSpill_channel_B = 3,
};

int CompositorNodeColorSpill_channel_get(PointerRNA *ptr);
void CompositorNodeColorSpill_channel_set(PointerRNA *ptr, int value);

float CompositorNodeColorSpill_unspill_green_get(PointerRNA *ptr);
void CompositorNodeColorSpill_unspill_green_set(PointerRNA *ptr, float value);

enum {
	CompositorNodeColorSpill_limit_channel_R = 0,
	CompositorNodeColorSpill_limit_channel_G = 1,
	CompositorNodeColorSpill_limit_channel_B = 2,
};

int CompositorNodeColorSpill_limit_channel_get(PointerRNA *ptr);
void CompositorNodeColorSpill_limit_channel_set(PointerRNA *ptr, int value);

float CompositorNodeColorSpill_unspill_red_get(PointerRNA *ptr);
void CompositorNodeColorSpill_unspill_red_set(PointerRNA *ptr, float value);

float CompositorNodeColorSpill_ratio_get(PointerRNA *ptr);
void CompositorNodeColorSpill_ratio_set(PointerRNA *ptr, float value);

bool CompositorNodeColorSpill_use_unspill_get(PointerRNA *ptr);
void CompositorNodeColorSpill_use_unspill_set(PointerRNA *ptr, bool value);

bool CompositorNodeColorSpill_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeColorSpill_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeColorSpill_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeCombHSVA ****************/

extern StructRNA RNA_CompositorNodeCombHSVA;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeCombHSVA_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeCombHSVA_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeCombHSVA_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeCombRGBA ****************/

extern StructRNA RNA_CompositorNodeCombRGBA;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeCombRGBA_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeCombRGBA_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeCombRGBA_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeCombYCCA ****************/

extern StructRNA RNA_CompositorNodeCombYCCA;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeCombYCCA_mode_ITUBT601 = 0,
	CompositorNodeCombYCCA_mode_ITUBT709 = 1,
	CompositorNodeCombYCCA_mode_JFIF = 2,
};

int CompositorNodeCombYCCA_mode_get(PointerRNA *ptr);
void CompositorNodeCombYCCA_mode_set(PointerRNA *ptr, int value);

bool CompositorNodeCombYCCA_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeCombYCCA_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeCombYCCA_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeCombYUVA ****************/

extern StructRNA RNA_CompositorNodeCombYUVA;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeCombYUVA_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeCombYUVA_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeCombYUVA_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeCombineColor ****************/

extern StructRNA RNA_CompositorNodeCombineColor;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeCombineColor_ycc_mode_ITUBT601 = 0,
	CompositorNodeCombineColor_ycc_mode_ITUBT709 = 1,
	CompositorNodeCombineColor_ycc_mode_JFIF = 2,
};

int CompositorNodeCombineColor_ycc_mode_get(PointerRNA *ptr);
void CompositorNodeCombineColor_ycc_mode_set(PointerRNA *ptr, int value);

enum {
	CompositorNodeCombineColor_mode_RGB = 0,
	CompositorNodeCombineColor_mode_HSV = 1,
	CompositorNodeCombineColor_mode_HSL = 2,
	CompositorNodeCombineColor_mode_YCC = 3,
	CompositorNodeCombineColor_mode_YUV = 4,
};

int CompositorNodeCombineColor_mode_get(PointerRNA *ptr);
void CompositorNodeCombineColor_mode_set(PointerRNA *ptr, int value);

bool CompositorNodeCombineColor_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeCombineColor_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeCombineColor_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeCombineXYZ ****************/

extern StructRNA RNA_CompositorNodeCombineXYZ;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeCombineXYZ_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeCombineXYZ_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeCombineXYZ_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeComposite ****************/

extern StructRNA RNA_CompositorNodeComposite;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeComposite_use_alpha_get(PointerRNA *ptr);
void CompositorNodeComposite_use_alpha_set(PointerRNA *ptr, bool value);

bool CompositorNodeComposite_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeComposite_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeComposite_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeConvertColorSpace ****************/

extern StructRNA RNA_CompositorNodeConvertColorSpace;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeConvertColorSpace_from_color_space_NONE = 0,
};

int CompositorNodeConvertColorSpace_from_color_space_get(PointerRNA *ptr);
void CompositorNodeConvertColorSpace_from_color_space_set(PointerRNA *ptr, int value);

enum {
	CompositorNodeConvertColorSpace_to_color_space_NONE = 0,
};

int CompositorNodeConvertColorSpace_to_color_space_get(PointerRNA *ptr);
void CompositorNodeConvertColorSpace_to_color_space_set(PointerRNA *ptr, int value);

bool CompositorNodeConvertColorSpace_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeConvertColorSpace_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeConvertColorSpace_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeCornerPin ****************/

extern StructRNA RNA_CompositorNodeCornerPin;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeCornerPin_interpolation_NEAREST = 0,
	CompositorNodeCornerPin_interpolation_BILINEAR = 1,
	CompositorNodeCornerPin_interpolation_BICUBIC = 2,
	CompositorNodeCornerPin_interpolation_ANISOTROPIC = 3,
};

int CompositorNodeCornerPin_interpolation_get(PointerRNA *ptr);
void CompositorNodeCornerPin_interpolation_set(PointerRNA *ptr, int value);

bool CompositorNodeCornerPin_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeCornerPin_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeCornerPin_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeCrop ****************/

extern StructRNA RNA_CompositorNodeCrop;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeCrop_use_crop_size_get(PointerRNA *ptr);
void CompositorNodeCrop_use_crop_size_set(PointerRNA *ptr, bool value);

bool CompositorNodeCrop_relative_get(PointerRNA *ptr);
void CompositorNodeCrop_relative_set(PointerRNA *ptr, bool value);

int CompositorNodeCrop_min_x_get(PointerRNA *ptr);
void CompositorNodeCrop_min_x_set(PointerRNA *ptr, int value);

float CompositorNodeCrop_rel_min_x_get(PointerRNA *ptr);
void CompositorNodeCrop_rel_min_x_set(PointerRNA *ptr, float value);

int CompositorNodeCrop_max_x_get(PointerRNA *ptr);
void CompositorNodeCrop_max_x_set(PointerRNA *ptr, int value);

float CompositorNodeCrop_rel_max_x_get(PointerRNA *ptr);
void CompositorNodeCrop_rel_max_x_set(PointerRNA *ptr, float value);

int CompositorNodeCrop_min_y_get(PointerRNA *ptr);
void CompositorNodeCrop_min_y_set(PointerRNA *ptr, int value);

float CompositorNodeCrop_rel_min_y_get(PointerRNA *ptr);
void CompositorNodeCrop_rel_min_y_set(PointerRNA *ptr, float value);

int CompositorNodeCrop_max_y_get(PointerRNA *ptr);
void CompositorNodeCrop_max_y_set(PointerRNA *ptr, int value);

float CompositorNodeCrop_rel_max_y_get(PointerRNA *ptr);
void CompositorNodeCrop_rel_max_y_set(PointerRNA *ptr, float value);

bool CompositorNodeCrop_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeCrop_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeCrop_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeCryptomatte ****************/

extern StructRNA RNA_CompositorNodeCryptomatte;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

void CompositorNodeCryptomatte_add_get(PointerRNA *ptr, float values[3]);
void CompositorNodeCryptomatte_add_set(PointerRNA *ptr, const float values[3]);

void CompositorNodeCryptomatte_matte_id_get(PointerRNA *ptr, char *value);
int CompositorNodeCryptomatte_matte_id_length(PointerRNA *ptr);
void CompositorNodeCryptomatte_matte_id_set(PointerRNA *ptr, const char *value);

void CompositorNodeCryptomatte_remove_get(PointerRNA *ptr, float values[3]);
void CompositorNodeCryptomatte_remove_set(PointerRNA *ptr, const float values[3]);

bool CompositorNodeCryptomatte_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeCryptomatte_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeCryptomatte_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeCryptomatteV2 ****************/

extern StructRNA RNA_CompositorNodeCryptomatteV2;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

void CompositorNodeCryptomatteV2_add_get(PointerRNA *ptr, float values[3]);
void CompositorNodeCryptomatteV2_add_set(PointerRNA *ptr, const float values[3]);

bool CompositorNodeCryptomatteV2_use_auto_refresh_get(PointerRNA *ptr);
void CompositorNodeCryptomatteV2_use_auto_refresh_set(PointerRNA *ptr, bool value);

enum {
	CompositorNodeCryptomatteV2_layer_name_CryptoObject = 0,
	CompositorNodeCryptomatteV2_layer_name_CryptoMaterial = 1,
	CompositorNodeCryptomatteV2_layer_name_CryptoAsset = 2,
};

int CompositorNodeCryptomatteV2_layer_name_get(PointerRNA *ptr);
void CompositorNodeCryptomatteV2_layer_name_set(PointerRNA *ptr, int value);

bool CompositorNodeCryptomatteV2_use_cyclic_get(PointerRNA *ptr);
void CompositorNodeCryptomatteV2_use_cyclic_set(PointerRNA *ptr, bool value);

int CompositorNodeCryptomatteV2_frame_duration_get(PointerRNA *ptr);
void CompositorNodeCryptomatteV2_frame_duration_set(PointerRNA *ptr, int value);

bool CompositorNodeCryptomatteV2_has_layers_get(PointerRNA *ptr);
void CompositorNodeCryptomatteV2_has_layers_set(PointerRNA *ptr, bool value);

bool CompositorNodeCryptomatteV2_has_views_get(PointerRNA *ptr);
void CompositorNodeCryptomatteV2_has_views_set(PointerRNA *ptr, bool value);

PointerRNA CompositorNodeCryptomatteV2_image_get(PointerRNA *ptr);

enum {
	CompositorNodeCryptomatteV2_layer_PLACEHOLDER = 0,
};

int CompositorNodeCryptomatteV2_layer_get(PointerRNA *ptr);
void CompositorNodeCryptomatteV2_layer_set(PointerRNA *ptr, int value);

void CompositorNodeCryptomatteV2_matte_id_get(PointerRNA *ptr, char *value);
int CompositorNodeCryptomatteV2_matte_id_length(PointerRNA *ptr);
void CompositorNodeCryptomatteV2_matte_id_set(PointerRNA *ptr, const char *value);

void CompositorNodeCryptomatteV2_entries_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void CompositorNodeCryptomatteV2_entries_next(CollectionPropertyIterator *iter);
void CompositorNodeCryptomatteV2_entries_end(CollectionPropertyIterator *iter);
bool CompositorNodeCryptomatteV2_entries_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool CompositorNodeCryptomatteV2_entries_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

int CompositorNodeCryptomatteV2_frame_offset_get(PointerRNA *ptr);
void CompositorNodeCryptomatteV2_frame_offset_set(PointerRNA *ptr, int value);

void CompositorNodeCryptomatteV2_remove_get(PointerRNA *ptr, float values[3]);
void CompositorNodeCryptomatteV2_remove_set(PointerRNA *ptr, const float values[3]);

PointerRNA CompositorNodeCryptomatteV2_scene_get(PointerRNA *ptr);

enum {
	CompositorNodeCryptomatteV2_source_RENDER = 0,
	CompositorNodeCryptomatteV2_source_IMAGE = 1,
};

int CompositorNodeCryptomatteV2_source_get(PointerRNA *ptr);
void CompositorNodeCryptomatteV2_source_set(PointerRNA *ptr, int value);

int CompositorNodeCryptomatteV2_frame_start_get(PointerRNA *ptr);
void CompositorNodeCryptomatteV2_frame_start_set(PointerRNA *ptr, int value);

enum {
	CompositorNodeCryptomatteV2_view_ALL = 0,
};

int CompositorNodeCryptomatteV2_view_get(PointerRNA *ptr);
void CompositorNodeCryptomatteV2_view_set(PointerRNA *ptr, int value);

bool CompositorNodeCryptomatteV2_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeCryptomatteV2_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeCryptomatteV2_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeCurveRGB ****************/

extern StructRNA RNA_CompositorNodeCurveRGB;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA CompositorNodeCurveRGB_mapping_get(PointerRNA *ptr);

bool CompositorNodeCurveRGB_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeCurveRGB_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeCurveRGB_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeCurveVec ****************/

extern StructRNA RNA_CompositorNodeCurveVec;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA CompositorNodeCurveVec_mapping_get(PointerRNA *ptr);

bool CompositorNodeCurveVec_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeCurveVec_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeCurveVec_output_template_func(struct StructRNA *_type, int index);
/**************** Compositor Custom Group ****************/

extern StructRNA RNA_CompositorNodeCustomGroup;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA CompositorNodeCustomGroup_node_tree_get(PointerRNA *ptr);

/**************** CompositorNodeDBlur ****************/

extern StructRNA RNA_CompositorNodeDBlur;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float CompositorNodeDBlur_angle_get(PointerRNA *ptr);
void CompositorNodeDBlur_angle_set(PointerRNA *ptr, float value);

float CompositorNodeDBlur_center_x_get(PointerRNA *ptr);
void CompositorNodeDBlur_center_x_set(PointerRNA *ptr, float value);

float CompositorNodeDBlur_center_y_get(PointerRNA *ptr);
void CompositorNodeDBlur_center_y_set(PointerRNA *ptr, float value);

float CompositorNodeDBlur_distance_get(PointerRNA *ptr);
void CompositorNodeDBlur_distance_set(PointerRNA *ptr, float value);

int CompositorNodeDBlur_iterations_get(PointerRNA *ptr);
void CompositorNodeDBlur_iterations_set(PointerRNA *ptr, int value);

float CompositorNodeDBlur_spin_get(PointerRNA *ptr);
void CompositorNodeDBlur_spin_set(PointerRNA *ptr, float value);

float CompositorNodeDBlur_zoom_get(PointerRNA *ptr);
void CompositorNodeDBlur_zoom_set(PointerRNA *ptr, float value);

bool CompositorNodeDBlur_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeDBlur_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeDBlur_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeDefocus ****************/

extern StructRNA RNA_CompositorNodeDefocus;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float CompositorNodeDefocus_angle_get(PointerRNA *ptr);
void CompositorNodeDefocus_angle_set(PointerRNA *ptr, float value);

enum {
	CompositorNodeDefocus_bokeh_OCTAGON = 8,
	CompositorNodeDefocus_bokeh_HEPTAGON = 7,
	CompositorNodeDefocus_bokeh_HEXAGON = 6,
	CompositorNodeDefocus_bokeh_PENTAGON = 5,
	CompositorNodeDefocus_bokeh_SQUARE = 4,
	CompositorNodeDefocus_bokeh_TRIANGLE = 3,
	CompositorNodeDefocus_bokeh_CIRCLE = 0,
};

int CompositorNodeDefocus_bokeh_get(PointerRNA *ptr);
void CompositorNodeDefocus_bokeh_set(PointerRNA *ptr, int value);

float CompositorNodeDefocus_f_stop_get(PointerRNA *ptr);
void CompositorNodeDefocus_f_stop_set(PointerRNA *ptr, float value);

bool CompositorNodeDefocus_use_gamma_correction_get(PointerRNA *ptr);
void CompositorNodeDefocus_use_gamma_correction_set(PointerRNA *ptr, bool value);

float CompositorNodeDefocus_blur_max_get(PointerRNA *ptr);
void CompositorNodeDefocus_blur_max_set(PointerRNA *ptr, float value);

bool CompositorNodeDefocus_use_preview_get(PointerRNA *ptr);
void CompositorNodeDefocus_use_preview_set(PointerRNA *ptr, bool value);

PointerRNA CompositorNodeDefocus_scene_get(PointerRNA *ptr);

float CompositorNodeDefocus_threshold_get(PointerRNA *ptr);
void CompositorNodeDefocus_threshold_set(PointerRNA *ptr, float value);

bool CompositorNodeDefocus_use_zbuffer_get(PointerRNA *ptr);
void CompositorNodeDefocus_use_zbuffer_set(PointerRNA *ptr, bool value);

float CompositorNodeDefocus_z_scale_get(PointerRNA *ptr);
void CompositorNodeDefocus_z_scale_set(PointerRNA *ptr, float value);

bool CompositorNodeDefocus_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeDefocus_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeDefocus_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeDenoise ****************/

extern StructRNA RNA_CompositorNodeDenoise;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeDenoise_prefilter_NONE = 1,
	CompositorNodeDenoise_prefilter_FAST = 0,
	CompositorNodeDenoise_prefilter_ACCURATE = 2,
};

int CompositorNodeDenoise_prefilter_get(PointerRNA *ptr);
void CompositorNodeDenoise_prefilter_set(PointerRNA *ptr, int value);

enum {
	CompositorNodeDenoise_quality_FOLLOW_SCENE = 0,
	CompositorNodeDenoise_quality_HIGH = 1,
	CompositorNodeDenoise_quality_BALANCED = 2,
	CompositorNodeDenoise_quality_FAST = 3,
};

int CompositorNodeDenoise_quality_get(PointerRNA *ptr);
void CompositorNodeDenoise_quality_set(PointerRNA *ptr, int value);

bool CompositorNodeDenoise_use_hdr_get(PointerRNA *ptr);
void CompositorNodeDenoise_use_hdr_set(PointerRNA *ptr, bool value);

bool CompositorNodeDenoise_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeDenoise_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeDenoise_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeDespeckle ****************/

extern StructRNA RNA_CompositorNodeDespeckle;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float CompositorNodeDespeckle_threshold_neighbor_get(PointerRNA *ptr);
void CompositorNodeDespeckle_threshold_neighbor_set(PointerRNA *ptr, float value);

float CompositorNodeDespeckle_threshold_get(PointerRNA *ptr);
void CompositorNodeDespeckle_threshold_set(PointerRNA *ptr, float value);

bool CompositorNodeDespeckle_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeDespeckle_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeDespeckle_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeDiffMatte ****************/

extern StructRNA RNA_CompositorNodeDiffMatte;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float CompositorNodeDiffMatte_falloff_get(PointerRNA *ptr);
void CompositorNodeDiffMatte_falloff_set(PointerRNA *ptr, float value);

float CompositorNodeDiffMatte_tolerance_get(PointerRNA *ptr);
void CompositorNodeDiffMatte_tolerance_set(PointerRNA *ptr, float value);

bool CompositorNodeDiffMatte_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeDiffMatte_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeDiffMatte_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeDilateErode ****************/

extern StructRNA RNA_CompositorNodeDilateErode;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int CompositorNodeDilateErode_distance_get(PointerRNA *ptr);
void CompositorNodeDilateErode_distance_set(PointerRNA *ptr, int value);

float CompositorNodeDilateErode_edge_get(PointerRNA *ptr);
void CompositorNodeDilateErode_edge_set(PointerRNA *ptr, float value);

enum {
	CompositorNodeDilateErode_falloff_SMOOTH = 0,
	CompositorNodeDilateErode_falloff_SPHERE = 1,
	CompositorNodeDilateErode_falloff_ROOT = 2,
	CompositorNodeDilateErode_falloff_INVERSE_SQUARE = 7,
	CompositorNodeDilateErode_falloff_SHARP = 3,
	CompositorNodeDilateErode_falloff_LINEAR = 4,
};

int CompositorNodeDilateErode_falloff_get(PointerRNA *ptr);
void CompositorNodeDilateErode_falloff_set(PointerRNA *ptr, int value);

enum {
	CompositorNodeDilateErode_mode_STEP = 0,
	CompositorNodeDilateErode_mode_THRESHOLD = 1,
	CompositorNodeDilateErode_mode_DISTANCE = 2,
	CompositorNodeDilateErode_mode_FEATHER = 3,
};

int CompositorNodeDilateErode_mode_get(PointerRNA *ptr);
void CompositorNodeDilateErode_mode_set(PointerRNA *ptr, int value);

bool CompositorNodeDilateErode_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeDilateErode_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeDilateErode_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeDisplace ****************/

extern StructRNA RNA_CompositorNodeDisplace;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeDisplace_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeDisplace_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeDisplace_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeDistanceMatte ****************/

extern StructRNA RNA_CompositorNodeDistanceMatte;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeDistanceMatte_channel_RGB = 1,
	CompositorNodeDistanceMatte_channel_YCC = 2,
};

int CompositorNodeDistanceMatte_channel_get(PointerRNA *ptr);
void CompositorNodeDistanceMatte_channel_set(PointerRNA *ptr, int value);

float CompositorNodeDistanceMatte_falloff_get(PointerRNA *ptr);
void CompositorNodeDistanceMatte_falloff_set(PointerRNA *ptr, float value);

float CompositorNodeDistanceMatte_tolerance_get(PointerRNA *ptr);
void CompositorNodeDistanceMatte_tolerance_set(PointerRNA *ptr, float value);

bool CompositorNodeDistanceMatte_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeDistanceMatte_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeDistanceMatte_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeDoubleEdgeMask ****************/

extern StructRNA RNA_CompositorNodeDoubleEdgeMask;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeDoubleEdgeMask_edge_mode_BLEED_OUT = 0,
	CompositorNodeDoubleEdgeMask_edge_mode_KEEP_IN = 1,
};

int CompositorNodeDoubleEdgeMask_edge_mode_get(PointerRNA *ptr);
void CompositorNodeDoubleEdgeMask_edge_mode_set(PointerRNA *ptr, int value);

enum {
	CompositorNodeDoubleEdgeMask_inner_mode_ALL = 0,
	CompositorNodeDoubleEdgeMask_inner_mode_ADJACENT_ONLY = 1,
};

int CompositorNodeDoubleEdgeMask_inner_mode_get(PointerRNA *ptr);
void CompositorNodeDoubleEdgeMask_inner_mode_set(PointerRNA *ptr, int value);

bool CompositorNodeDoubleEdgeMask_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeDoubleEdgeMask_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeDoubleEdgeMask_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeEllipseMask ****************/

extern StructRNA RNA_CompositorNodeEllipseMask;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float CompositorNodeEllipseMask_mask_height_get(PointerRNA *ptr);
void CompositorNodeEllipseMask_mask_height_set(PointerRNA *ptr, float value);

enum {
	CompositorNodeEllipseMask_mask_type_ADD = 0,
	CompositorNodeEllipseMask_mask_type_SUBTRACT = 1,
	CompositorNodeEllipseMask_mask_type_MULTIPLY = 2,
	CompositorNodeEllipseMask_mask_type_NOT = 3,
};

int CompositorNodeEllipseMask_mask_type_get(PointerRNA *ptr);
void CompositorNodeEllipseMask_mask_type_set(PointerRNA *ptr, int value);

float CompositorNodeEllipseMask_rotation_get(PointerRNA *ptr);
void CompositorNodeEllipseMask_rotation_set(PointerRNA *ptr, float value);

float CompositorNodeEllipseMask_mask_width_get(PointerRNA *ptr);
void CompositorNodeEllipseMask_mask_width_set(PointerRNA *ptr, float value);

float CompositorNodeEllipseMask_x_get(PointerRNA *ptr);
void CompositorNodeEllipseMask_x_set(PointerRNA *ptr, float value);

float CompositorNodeEllipseMask_y_get(PointerRNA *ptr);
void CompositorNodeEllipseMask_y_set(PointerRNA *ptr, float value);

bool CompositorNodeEllipseMask_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeEllipseMask_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeEllipseMask_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeExposure ****************/

extern StructRNA RNA_CompositorNodeExposure;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeExposure_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeExposure_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeExposure_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeFilter ****************/

extern StructRNA RNA_CompositorNodeFilter;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeFilter_filter_type_SOFTEN = 0,
	CompositorNodeFilter_filter_type_SHARPEN = 1,
	CompositorNodeFilter_filter_type_SHARPEN_DIAMOND = 7,
	CompositorNodeFilter_filter_type_LAPLACE = 2,
	CompositorNodeFilter_filter_type_SOBEL = 3,
	CompositorNodeFilter_filter_type_PREWITT = 4,
	CompositorNodeFilter_filter_type_KIRSCH = 5,
	CompositorNodeFilter_filter_type_SHADOW = 6,
};

int CompositorNodeFilter_filter_type_get(PointerRNA *ptr);
void CompositorNodeFilter_filter_type_set(PointerRNA *ptr, int value);

bool CompositorNodeFilter_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeFilter_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeFilter_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeFlip ****************/

extern StructRNA RNA_CompositorNodeFlip;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeFlip_axis_X = 0,
	CompositorNodeFlip_axis_Y = 1,
	CompositorNodeFlip_axis_XY = 2,
};

int CompositorNodeFlip_axis_get(PointerRNA *ptr);
void CompositorNodeFlip_axis_set(PointerRNA *ptr, int value);

bool CompositorNodeFlip_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeFlip_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeFlip_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeGamma ****************/

extern StructRNA RNA_CompositorNodeGamma;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeGamma_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeGamma_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeGamma_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeGlare ****************/

extern StructRNA RNA_CompositorNodeGlare;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float CompositorNodeGlare_angle_offset_get(PointerRNA *ptr);
void CompositorNodeGlare_angle_offset_set(PointerRNA *ptr, float value);

float CompositorNodeGlare_color_modulation_get(PointerRNA *ptr);
void CompositorNodeGlare_color_modulation_set(PointerRNA *ptr, float value);

float CompositorNodeGlare_fade_get(PointerRNA *ptr);
void CompositorNodeGlare_fade_set(PointerRNA *ptr, float value);

enum {
	CompositorNodeGlare_glare_type_BLOOM = 4,
	CompositorNodeGlare_glare_type_GHOSTS = 3,
	CompositorNodeGlare_glare_type_STREAKS = 2,
	CompositorNodeGlare_glare_type_FOG_GLOW = 1,
	CompositorNodeGlare_glare_type_SIMPLE_STAR = 0,
};

int CompositorNodeGlare_glare_type_get(PointerRNA *ptr);
void CompositorNodeGlare_glare_type_set(PointerRNA *ptr, int value);

int CompositorNodeGlare_iterations_get(PointerRNA *ptr);
void CompositorNodeGlare_iterations_set(PointerRNA *ptr, int value);

float CompositorNodeGlare_mix_get(PointerRNA *ptr);
void CompositorNodeGlare_mix_set(PointerRNA *ptr, float value);

enum {
	CompositorNodeGlare_quality_HIGH = 0,
	CompositorNodeGlare_quality_MEDIUM = 1,
	CompositorNodeGlare_quality_LOW = 2,
};

int CompositorNodeGlare_quality_get(PointerRNA *ptr);
void CompositorNodeGlare_quality_set(PointerRNA *ptr, int value);

bool CompositorNodeGlare_use_rotate_45_get(PointerRNA *ptr);
void CompositorNodeGlare_use_rotate_45_set(PointerRNA *ptr, bool value);

int CompositorNodeGlare_size_get(PointerRNA *ptr);
void CompositorNodeGlare_size_set(PointerRNA *ptr, int value);

int CompositorNodeGlare_streaks_get(PointerRNA *ptr);
void CompositorNodeGlare_streaks_set(PointerRNA *ptr, int value);

float CompositorNodeGlare_threshold_get(PointerRNA *ptr);
void CompositorNodeGlare_threshold_set(PointerRNA *ptr, float value);

bool CompositorNodeGlare_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeGlare_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeGlare_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeGroup ****************/

extern StructRNA RNA_CompositorNodeGroup;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA CompositorNodeGroup_node_tree_get(PointerRNA *ptr);

bool CompositorNodeGroup_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeGroup_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeGroup_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeHueCorrect ****************/

extern StructRNA RNA_CompositorNodeHueCorrect;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA CompositorNodeHueCorrect_mapping_get(PointerRNA *ptr);

bool CompositorNodeHueCorrect_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeHueCorrect_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeHueCorrect_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeHueSat ****************/

extern StructRNA RNA_CompositorNodeHueSat;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeHueSat_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeHueSat_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeHueSat_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeIDMask ****************/

extern StructRNA RNA_CompositorNodeIDMask;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeIDMask_use_antialiasing_get(PointerRNA *ptr);
void CompositorNodeIDMask_use_antialiasing_set(PointerRNA *ptr, bool value);

int CompositorNodeIDMask_index_get(PointerRNA *ptr);
void CompositorNodeIDMask_index_set(PointerRNA *ptr, int value);

bool CompositorNodeIDMask_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeIDMask_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeIDMask_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeImage ****************/

extern StructRNA RNA_CompositorNodeImage;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeImage_use_auto_refresh_get(PointerRNA *ptr);
void CompositorNodeImage_use_auto_refresh_set(PointerRNA *ptr, bool value);

bool CompositorNodeImage_use_cyclic_get(PointerRNA *ptr);
void CompositorNodeImage_use_cyclic_set(PointerRNA *ptr, bool value);

int CompositorNodeImage_frame_duration_get(PointerRNA *ptr);
void CompositorNodeImage_frame_duration_set(PointerRNA *ptr, int value);

bool CompositorNodeImage_has_layers_get(PointerRNA *ptr);
void CompositorNodeImage_has_layers_set(PointerRNA *ptr, bool value);

bool CompositorNodeImage_has_views_get(PointerRNA *ptr);
void CompositorNodeImage_has_views_set(PointerRNA *ptr, bool value);

PointerRNA CompositorNodeImage_image_get(PointerRNA *ptr);

enum {
	CompositorNodeImage_layer_PLACEHOLDER = 0,
};

int CompositorNodeImage_layer_get(PointerRNA *ptr);
void CompositorNodeImage_layer_set(PointerRNA *ptr, int value);

int CompositorNodeImage_frame_offset_get(PointerRNA *ptr);
void CompositorNodeImage_frame_offset_set(PointerRNA *ptr, int value);

int CompositorNodeImage_frame_start_get(PointerRNA *ptr);
void CompositorNodeImage_frame_start_set(PointerRNA *ptr, int value);

bool CompositorNodeImage_use_straight_alpha_output_get(PointerRNA *ptr);
void CompositorNodeImage_use_straight_alpha_output_set(PointerRNA *ptr, bool value);

enum {
	CompositorNodeImage_view_ALL = 0,
};

int CompositorNodeImage_view_get(PointerRNA *ptr);
void CompositorNodeImage_view_set(PointerRNA *ptr, int value);

bool CompositorNodeImage_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeImage_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeImage_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeImageCoordinates ****************/

extern StructRNA RNA_CompositorNodeImageCoordinates;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeImageCoordinates_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeImageCoordinates_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeImageCoordinates_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeImageInfo ****************/

extern StructRNA RNA_CompositorNodeImageInfo;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeImageInfo_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeImageInfo_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeImageInfo_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeInpaint ****************/

extern StructRNA RNA_CompositorNodeInpaint;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int CompositorNodeInpaint_distance_get(PointerRNA *ptr);
void CompositorNodeInpaint_distance_set(PointerRNA *ptr, int value);

bool CompositorNodeInpaint_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeInpaint_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeInpaint_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeInvert ****************/

extern StructRNA RNA_CompositorNodeInvert;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeInvert_invert_alpha_get(PointerRNA *ptr);
void CompositorNodeInvert_invert_alpha_set(PointerRNA *ptr, bool value);

bool CompositorNodeInvert_invert_rgb_get(PointerRNA *ptr);
void CompositorNodeInvert_invert_rgb_set(PointerRNA *ptr, bool value);

bool CompositorNodeInvert_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeInvert_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeInvert_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeKeying ****************/

extern StructRNA RNA_CompositorNodeKeying;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float CompositorNodeKeying_clip_black_get(PointerRNA *ptr);
void CompositorNodeKeying_clip_black_set(PointerRNA *ptr, float value);

float CompositorNodeKeying_clip_white_get(PointerRNA *ptr);
void CompositorNodeKeying_clip_white_set(PointerRNA *ptr, float value);

float CompositorNodeKeying_despill_balance_get(PointerRNA *ptr);
void CompositorNodeKeying_despill_balance_set(PointerRNA *ptr, float value);

float CompositorNodeKeying_despill_factor_get(PointerRNA *ptr);
void CompositorNodeKeying_despill_factor_set(PointerRNA *ptr, float value);

int CompositorNodeKeying_dilate_distance_get(PointerRNA *ptr);
void CompositorNodeKeying_dilate_distance_set(PointerRNA *ptr, int value);

int CompositorNodeKeying_edge_kernel_radius_get(PointerRNA *ptr);
void CompositorNodeKeying_edge_kernel_radius_set(PointerRNA *ptr, int value);

float CompositorNodeKeying_edge_kernel_tolerance_get(PointerRNA *ptr);
void CompositorNodeKeying_edge_kernel_tolerance_set(PointerRNA *ptr, float value);

int CompositorNodeKeying_feather_distance_get(PointerRNA *ptr);
void CompositorNodeKeying_feather_distance_set(PointerRNA *ptr, int value);

enum {
	CompositorNodeKeying_feather_falloff_SMOOTH = 0,
	CompositorNodeKeying_feather_falloff_SPHERE = 1,
	CompositorNodeKeying_feather_falloff_ROOT = 2,
	CompositorNodeKeying_feather_falloff_INVERSE_SQUARE = 7,
	CompositorNodeKeying_feather_falloff_SHARP = 3,
	CompositorNodeKeying_feather_falloff_LINEAR = 4,
};

int CompositorNodeKeying_feather_falloff_get(PointerRNA *ptr);
void CompositorNodeKeying_feather_falloff_set(PointerRNA *ptr, int value);

int CompositorNodeKeying_blur_post_get(PointerRNA *ptr);
void CompositorNodeKeying_blur_post_set(PointerRNA *ptr, int value);

int CompositorNodeKeying_blur_pre_get(PointerRNA *ptr);
void CompositorNodeKeying_blur_pre_set(PointerRNA *ptr, int value);

float CompositorNodeKeying_screen_balance_get(PointerRNA *ptr);
void CompositorNodeKeying_screen_balance_set(PointerRNA *ptr, float value);

bool CompositorNodeKeying_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeKeying_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeKeying_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeKeyingScreen ****************/

extern StructRNA RNA_CompositorNodeKeyingScreen;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA CompositorNodeKeyingScreen_clip_get(PointerRNA *ptr);

float CompositorNodeKeyingScreen_smoothness_get(PointerRNA *ptr);
void CompositorNodeKeyingScreen_smoothness_set(PointerRNA *ptr, float value);

#define CompositorNodeKeyingScreen_tracking_object_MAX 64

void CompositorNodeKeyingScreen_tracking_object_get(PointerRNA *ptr, char *value);
int CompositorNodeKeyingScreen_tracking_object_length(PointerRNA *ptr);
void CompositorNodeKeyingScreen_tracking_object_set(PointerRNA *ptr, const char *value);

bool CompositorNodeKeyingScreen_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeKeyingScreen_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeKeyingScreen_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeKuwahara ****************/

extern StructRNA RNA_CompositorNodeKuwahara;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeKuwahara_variation_CLASSIC = 0,
	CompositorNodeKuwahara_variation_ANISOTROPIC = 1,
};

int CompositorNodeKuwahara_variation_get(PointerRNA *ptr);
void CompositorNodeKuwahara_variation_set(PointerRNA *ptr, int value);

float CompositorNodeKuwahara_eccentricity_get(PointerRNA *ptr);
void CompositorNodeKuwahara_eccentricity_set(PointerRNA *ptr, float value);

bool CompositorNodeKuwahara_use_high_precision_get(PointerRNA *ptr);
void CompositorNodeKuwahara_use_high_precision_set(PointerRNA *ptr, bool value);

float CompositorNodeKuwahara_sharpness_get(PointerRNA *ptr);
void CompositorNodeKuwahara_sharpness_set(PointerRNA *ptr, float value);

int CompositorNodeKuwahara_uniformity_get(PointerRNA *ptr);
void CompositorNodeKuwahara_uniformity_set(PointerRNA *ptr, int value);

bool CompositorNodeKuwahara_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeKuwahara_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeKuwahara_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeLensdist ****************/

extern StructRNA RNA_CompositorNodeLensdist;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeLensdist_use_fit_get(PointerRNA *ptr);
void CompositorNodeLensdist_use_fit_set(PointerRNA *ptr, bool value);

bool CompositorNodeLensdist_use_jitter_get(PointerRNA *ptr);
void CompositorNodeLensdist_use_jitter_set(PointerRNA *ptr, bool value);

bool CompositorNodeLensdist_use_projector_get(PointerRNA *ptr);
void CompositorNodeLensdist_use_projector_set(PointerRNA *ptr, bool value);

enum {
	CompositorNodeLensdist_distortion_type_RADIAL = 0,
	CompositorNodeLensdist_distortion_type_HORIZONTAL = 1,
};

int CompositorNodeLensdist_distortion_type_get(PointerRNA *ptr);
void CompositorNodeLensdist_distortion_type_set(PointerRNA *ptr, int value);

bool CompositorNodeLensdist_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeLensdist_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeLensdist_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeLevels ****************/

extern StructRNA RNA_CompositorNodeLevels;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeLevels_channel_COMBINED_RGB = 1,
	CompositorNodeLevels_channel_RED = 2,
	CompositorNodeLevels_channel_GREEN = 3,
	CompositorNodeLevels_channel_BLUE = 4,
	CompositorNodeLevels_channel_LUMINANCE = 5,
};

int CompositorNodeLevels_channel_get(PointerRNA *ptr);
void CompositorNodeLevels_channel_set(PointerRNA *ptr, int value);

bool CompositorNodeLevels_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeLevels_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeLevels_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeLumaMatte ****************/

extern StructRNA RNA_CompositorNodeLumaMatte;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float CompositorNodeLumaMatte_limit_max_get(PointerRNA *ptr);
void CompositorNodeLumaMatte_limit_max_set(PointerRNA *ptr, float value);

float CompositorNodeLumaMatte_limit_min_get(PointerRNA *ptr);
void CompositorNodeLumaMatte_limit_min_set(PointerRNA *ptr, float value);

bool CompositorNodeLumaMatte_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeLumaMatte_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeLumaMatte_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeMapRange ****************/

extern StructRNA RNA_CompositorNodeMapRange;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeMapRange_use_clamp_get(PointerRNA *ptr);
void CompositorNodeMapRange_use_clamp_set(PointerRNA *ptr, bool value);

bool CompositorNodeMapRange_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeMapRange_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeMapRange_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeMapUV ****************/

extern StructRNA RNA_CompositorNodeMapUV;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int CompositorNodeMapUV_alpha_get(PointerRNA *ptr);
void CompositorNodeMapUV_alpha_set(PointerRNA *ptr, int value);

enum {
	CompositorNodeMapUV_filter_type_NEAREST = 0,
	CompositorNodeMapUV_filter_type_ANISOTROPIC = 3,
};

int CompositorNodeMapUV_filter_type_get(PointerRNA *ptr);
void CompositorNodeMapUV_filter_type_set(PointerRNA *ptr, int value);

bool CompositorNodeMapUV_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeMapUV_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeMapUV_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeMapValue ****************/

extern StructRNA RNA_CompositorNodeMapValue;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

void CompositorNodeMapValue_max_get(PointerRNA *ptr, float values[1]);
void CompositorNodeMapValue_max_set(PointerRNA *ptr, const float values[1]);

void CompositorNodeMapValue_min_get(PointerRNA *ptr, float values[1]);
void CompositorNodeMapValue_min_set(PointerRNA *ptr, const float values[1]);

void CompositorNodeMapValue_offset_get(PointerRNA *ptr, float values[1]);
void CompositorNodeMapValue_offset_set(PointerRNA *ptr, const float values[1]);

void CompositorNodeMapValue_size_get(PointerRNA *ptr, float values[1]);
void CompositorNodeMapValue_size_set(PointerRNA *ptr, const float values[1]);

bool CompositorNodeMapValue_use_max_get(PointerRNA *ptr);
void CompositorNodeMapValue_use_max_set(PointerRNA *ptr, bool value);

bool CompositorNodeMapValue_use_min_get(PointerRNA *ptr);
void CompositorNodeMapValue_use_min_set(PointerRNA *ptr, bool value);

bool CompositorNodeMapValue_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeMapValue_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeMapValue_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeMask ****************/

extern StructRNA RNA_CompositorNodeMask;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeMask_use_feather_get(PointerRNA *ptr);
void CompositorNodeMask_use_feather_set(PointerRNA *ptr, bool value);

PointerRNA CompositorNodeMask_mask_get(PointerRNA *ptr);

bool CompositorNodeMask_use_motion_blur_get(PointerRNA *ptr);
void CompositorNodeMask_use_motion_blur_set(PointerRNA *ptr, bool value);

int CompositorNodeMask_motion_blur_samples_get(PointerRNA *ptr);
void CompositorNodeMask_motion_blur_samples_set(PointerRNA *ptr, int value);

float CompositorNodeMask_motion_blur_shutter_get(PointerRNA *ptr);
void CompositorNodeMask_motion_blur_shutter_set(PointerRNA *ptr, float value);

enum {
	CompositorNodeMask_size_source_SCENE = 0,
	CompositorNodeMask_size_source_FIXED = 256,
	CompositorNodeMask_size_source_FIXED_SCENE = 512,
};

int CompositorNodeMask_size_source_get(PointerRNA *ptr);
void CompositorNodeMask_size_source_set(PointerRNA *ptr, int value);

int CompositorNodeMask_size_x_get(PointerRNA *ptr);
void CompositorNodeMask_size_x_set(PointerRNA *ptr, int value);

int CompositorNodeMask_size_y_get(PointerRNA *ptr);
void CompositorNodeMask_size_y_set(PointerRNA *ptr, int value);

bool CompositorNodeMask_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeMask_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeMask_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeMath ****************/

extern StructRNA RNA_CompositorNodeMath;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeMath_use_clamp_get(PointerRNA *ptr);
void CompositorNodeMath_use_clamp_set(PointerRNA *ptr, bool value);

enum {
	CompositorNodeMath_operation_ADD = 0,
	CompositorNodeMath_operation_SUBTRACT = 1,
	CompositorNodeMath_operation_MULTIPLY = 2,
	CompositorNodeMath_operation_DIVIDE = 3,
	CompositorNodeMath_operation_MULTIPLY_ADD = 36,
	CompositorNodeMath_operation_POWER = 10,
	CompositorNodeMath_operation_LOGARITHM = 11,
	CompositorNodeMath_operation_SQRT = 23,
	CompositorNodeMath_operation_INVERSE_SQRT = 24,
	CompositorNodeMath_operation_ABSOLUTE = 18,
	CompositorNodeMath_operation_EXPONENT = 26,
	CompositorNodeMath_operation_MINIMUM = 12,
	CompositorNodeMath_operation_MAXIMUM = 13,
	CompositorNodeMath_operation_LESS_THAN = 15,
	CompositorNodeMath_operation_GREATER_THAN = 16,
	CompositorNodeMath_operation_SIGN = 25,
	CompositorNodeMath_operation_COMPARE = 35,
	CompositorNodeMath_operation_SMOOTH_MIN = 38,
	CompositorNodeMath_operation_SMOOTH_MAX = 39,
	CompositorNodeMath_operation_ROUND = 14,
	CompositorNodeMath_operation_FLOOR = 20,
	CompositorNodeMath_operation_CEIL = 21,
	CompositorNodeMath_operation_TRUNC = 32,
	CompositorNodeMath_operation_FRACT = 22,
	CompositorNodeMath_operation_MODULO = 17,
	CompositorNodeMath_operation_FLOORED_MODULO = 40,
	CompositorNodeMath_operation_WRAP = 34,
	CompositorNodeMath_operation_SNAP = 33,
	CompositorNodeMath_operation_PINGPONG = 37,
	CompositorNodeMath_operation_SINE = 4,
	CompositorNodeMath_operation_COSINE = 5,
	CompositorNodeMath_operation_TANGENT = 6,
	CompositorNodeMath_operation_ARCSINE = 7,
	CompositorNodeMath_operation_ARCCOSINE = 8,
	CompositorNodeMath_operation_ARCTANGENT = 9,
	CompositorNodeMath_operation_ARCTAN2 = 19,
	CompositorNodeMath_operation_SINH = 29,
	CompositorNodeMath_operation_COSH = 30,
	CompositorNodeMath_operation_TANH = 31,
	CompositorNodeMath_operation_RADIANS = 27,
	CompositorNodeMath_operation_DEGREES = 28,
};

int CompositorNodeMath_operation_get(PointerRNA *ptr);
void CompositorNodeMath_operation_set(PointerRNA *ptr, int value);

bool CompositorNodeMath_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeMath_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeMath_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeMixRGB ****************/

extern StructRNA RNA_CompositorNodeMixRGB;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeMixRGB_use_alpha_get(PointerRNA *ptr);
void CompositorNodeMixRGB_use_alpha_set(PointerRNA *ptr, bool value);

enum {
	CompositorNodeMixRGB_blend_type_MIX = 0,
	CompositorNodeMixRGB_blend_type_DARKEN = 7,
	CompositorNodeMixRGB_blend_type_MULTIPLY = 2,
	CompositorNodeMixRGB_blend_type_BURN = 11,
	CompositorNodeMixRGB_blend_type_LIGHTEN = 8,
	CompositorNodeMixRGB_blend_type_SCREEN = 4,
	CompositorNodeMixRGB_blend_type_DODGE = 10,
	CompositorNodeMixRGB_blend_type_ADD = 1,
	CompositorNodeMixRGB_blend_type_OVERLAY = 9,
	CompositorNodeMixRGB_blend_type_SOFT_LIGHT = 16,
	CompositorNodeMixRGB_blend_type_LINEAR_LIGHT = 17,
	CompositorNodeMixRGB_blend_type_DIFFERENCE = 6,
	CompositorNodeMixRGB_blend_type_EXCLUSION = 18,
	CompositorNodeMixRGB_blend_type_SUBTRACT = 3,
	CompositorNodeMixRGB_blend_type_DIVIDE = 5,
	CompositorNodeMixRGB_blend_type_HUE = 12,
	CompositorNodeMixRGB_blend_type_SATURATION = 13,
	CompositorNodeMixRGB_blend_type_COLOR = 15,
	CompositorNodeMixRGB_blend_type_VALUE = 14,
};

int CompositorNodeMixRGB_blend_type_get(PointerRNA *ptr);
void CompositorNodeMixRGB_blend_type_set(PointerRNA *ptr, int value);

bool CompositorNodeMixRGB_use_clamp_get(PointerRNA *ptr);
void CompositorNodeMixRGB_use_clamp_set(PointerRNA *ptr, bool value);

bool CompositorNodeMixRGB_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeMixRGB_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeMixRGB_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeMovieClip ****************/

extern StructRNA RNA_CompositorNodeMovieClip;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA CompositorNodeMovieClip_clip_get(PointerRNA *ptr);

bool CompositorNodeMovieClip_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeMovieClip_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeMovieClip_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeMovieDistortion ****************/

extern StructRNA RNA_CompositorNodeMovieDistortion;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeMovieDistortion_distortion_type_UNDISTORT = 0,
	CompositorNodeMovieDistortion_distortion_type_DISTORT = 1,
};

int CompositorNodeMovieDistortion_distortion_type_get(PointerRNA *ptr);
void CompositorNodeMovieDistortion_distortion_type_set(PointerRNA *ptr, int value);

PointerRNA CompositorNodeMovieDistortion_clip_get(PointerRNA *ptr);

bool CompositorNodeMovieDistortion_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeMovieDistortion_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeMovieDistortion_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeNormal ****************/

extern StructRNA RNA_CompositorNodeNormal;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeNormal_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeNormal_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeNormal_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeNormalize ****************/

extern StructRNA RNA_CompositorNodeNormalize;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeNormalize_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeNormalize_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeNormalize_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeOutputFile ****************/

extern StructRNA RNA_CompositorNodeOutputFile;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int CompositorNodeOutputFile_active_input_index_get(PointerRNA *ptr);
void CompositorNodeOutputFile_active_input_index_set(PointerRNA *ptr, int value);

#define CompositorNodeOutputFile_base_path_MAX 1024

void CompositorNodeOutputFile_base_path_get(PointerRNA *ptr, char *value);
int CompositorNodeOutputFile_base_path_length(PointerRNA *ptr);
void CompositorNodeOutputFile_base_path_set(PointerRNA *ptr, const char *value);

void CompositorNodeOutputFile_layer_slots_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void CompositorNodeOutputFile_layer_slots_next(CollectionPropertyIterator *iter);
void CompositorNodeOutputFile_layer_slots_end(CollectionPropertyIterator *iter);

void CompositorNodeOutputFile_file_slots_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void CompositorNodeOutputFile_file_slots_next(CollectionPropertyIterator *iter);
void CompositorNodeOutputFile_file_slots_end(CollectionPropertyIterator *iter);

bool CompositorNodeOutputFile_save_as_render_get(PointerRNA *ptr);
void CompositorNodeOutputFile_save_as_render_set(PointerRNA *ptr, bool value);

PointerRNA CompositorNodeOutputFile_format_get(PointerRNA *ptr);

bool CompositorNodeOutputFile_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeOutputFile_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeOutputFile_output_template_func(struct StructRNA *_type, int index);
/**************** File Output Slots ****************/

extern StructRNA RNA_CompositorNodeOutputFileFileSlots;

PointerRNA CompositorNodeOutputFileFileSlots_rna_type_get(PointerRNA *ptr);

struct bNodeSocket *CompositorNodeOutputFileFileSlots_new_func(struct ID *_selfid, struct bNode *_self, bContext *C, ReportList *reports, const char * name);
void CompositorNodeOutputFileFileSlots_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct bNodeSocket *socket);
void CompositorNodeOutputFileFileSlots_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports);
void CompositorNodeOutputFileFileSlots_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, int from_index, int to_index);
/**************** File Output Slots ****************/

extern StructRNA RNA_CompositorNodeOutputFileLayerSlots;

PointerRNA CompositorNodeOutputFileLayerSlots_rna_type_get(PointerRNA *ptr);

struct bNodeSocket *CompositorNodeOutputFileLayerSlots_new_func(struct ID *_selfid, struct bNode *_self, bContext *C, ReportList *reports, const char * name);
void CompositorNodeOutputFileLayerSlots_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct bNodeSocket *socket);
void CompositorNodeOutputFileLayerSlots_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports);
void CompositorNodeOutputFileLayerSlots_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, int from_index, int to_index);
/**************** CompositorNodePixelate ****************/

extern StructRNA RNA_CompositorNodePixelate;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int CompositorNodePixelate_pixel_size_get(PointerRNA *ptr);
void CompositorNodePixelate_pixel_size_set(PointerRNA *ptr, int value);

bool CompositorNodePixelate_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodePixelate_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodePixelate_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodePlaneTrackDeform ****************/

extern StructRNA RNA_CompositorNodePlaneTrackDeform;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodePlaneTrackDeform_use_motion_blur_get(PointerRNA *ptr);
void CompositorNodePlaneTrackDeform_use_motion_blur_set(PointerRNA *ptr, bool value);

PointerRNA CompositorNodePlaneTrackDeform_clip_get(PointerRNA *ptr);

#define CompositorNodePlaneTrackDeform_plane_track_name_MAX 64

void CompositorNodePlaneTrackDeform_plane_track_name_get(PointerRNA *ptr, char *value);
int CompositorNodePlaneTrackDeform_plane_track_name_length(PointerRNA *ptr);
void CompositorNodePlaneTrackDeform_plane_track_name_set(PointerRNA *ptr, const char *value);

int CompositorNodePlaneTrackDeform_motion_blur_samples_get(PointerRNA *ptr);
void CompositorNodePlaneTrackDeform_motion_blur_samples_set(PointerRNA *ptr, int value);

float CompositorNodePlaneTrackDeform_motion_blur_shutter_get(PointerRNA *ptr);
void CompositorNodePlaneTrackDeform_motion_blur_shutter_set(PointerRNA *ptr, float value);

#define CompositorNodePlaneTrackDeform_tracking_object_MAX 64

void CompositorNodePlaneTrackDeform_tracking_object_get(PointerRNA *ptr, char *value);
int CompositorNodePlaneTrackDeform_tracking_object_length(PointerRNA *ptr);
void CompositorNodePlaneTrackDeform_tracking_object_set(PointerRNA *ptr, const char *value);

bool CompositorNodePlaneTrackDeform_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodePlaneTrackDeform_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodePlaneTrackDeform_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodePosterize ****************/

extern StructRNA RNA_CompositorNodePosterize;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodePosterize_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodePosterize_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodePosterize_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodePremulKey ****************/

extern StructRNA RNA_CompositorNodePremulKey;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodePremulKey_mapping_STRAIGHT_TO_PREMUL = 0,
	CompositorNodePremulKey_mapping_PREMUL_TO_STRAIGHT = 1,
};

int CompositorNodePremulKey_mapping_get(PointerRNA *ptr);
void CompositorNodePremulKey_mapping_set(PointerRNA *ptr, int value);

bool CompositorNodePremulKey_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodePremulKey_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodePremulKey_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeRGB ****************/

extern StructRNA RNA_CompositorNodeRGB;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeRGB_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeRGB_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeRGB_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeRGBToBW ****************/

extern StructRNA RNA_CompositorNodeRGBToBW;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeRGBToBW_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeRGBToBW_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeRGBToBW_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeRLayers ****************/

extern StructRNA RNA_CompositorNodeRLayers;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeRLayers_layer_PLACEHOLDER = 0,
};

int CompositorNodeRLayers_layer_get(PointerRNA *ptr);
void CompositorNodeRLayers_layer_set(PointerRNA *ptr, int value);

PointerRNA CompositorNodeRLayers_scene_get(PointerRNA *ptr);

bool CompositorNodeRLayers_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeRLayers_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeRLayers_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeRelativeToPixel ****************/

extern StructRNA RNA_CompositorNodeRelativeToPixel;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeRelativeToPixel_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeRelativeToPixel_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeRelativeToPixel_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeRotate ****************/

extern StructRNA RNA_CompositorNodeRotate;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeRotate_filter_type_NEAREST = 0,
	CompositorNodeRotate_filter_type_BILINEAR = 1,
	CompositorNodeRotate_filter_type_BICUBIC = 2,
};

int CompositorNodeRotate_filter_type_get(PointerRNA *ptr);
void CompositorNodeRotate_filter_type_set(PointerRNA *ptr, int value);

bool CompositorNodeRotate_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeRotate_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeRotate_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeScale ****************/

extern StructRNA RNA_CompositorNodeScale;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeScale_frame_method_STRETCH = 0,
	CompositorNodeScale_frame_method_FIT = 1,
	CompositorNodeScale_frame_method_CROP = 2,
};

int CompositorNodeScale_frame_method_get(PointerRNA *ptr);
void CompositorNodeScale_frame_method_set(PointerRNA *ptr, int value);

enum {
	CompositorNodeScale_interpolation_NEAREST = 0,
	CompositorNodeScale_interpolation_BILINEAR = 1,
	CompositorNodeScale_interpolation_BICUBIC = 2,
};

int CompositorNodeScale_interpolation_get(PointerRNA *ptr);
void CompositorNodeScale_interpolation_set(PointerRNA *ptr, int value);

enum {
	CompositorNodeScale_space_RELATIVE = 0,
	CompositorNodeScale_space_ABSOLUTE = 1,
	CompositorNodeScale_space_SCENE_SIZE = 2,
	CompositorNodeScale_space_RENDER_SIZE = 3,
};

int CompositorNodeScale_space_get(PointerRNA *ptr);
void CompositorNodeScale_space_set(PointerRNA *ptr, int value);

float CompositorNodeScale_offset_x_get(PointerRNA *ptr);
void CompositorNodeScale_offset_x_set(PointerRNA *ptr, float value);

float CompositorNodeScale_offset_y_get(PointerRNA *ptr);
void CompositorNodeScale_offset_y_set(PointerRNA *ptr, float value);

bool CompositorNodeScale_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeScale_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeScale_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeSceneTime ****************/

extern StructRNA RNA_CompositorNodeSceneTime;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeSceneTime_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeSceneTime_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeSceneTime_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeSepHSVA ****************/

extern StructRNA RNA_CompositorNodeSepHSVA;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeSepHSVA_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeSepHSVA_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeSepHSVA_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeSepRGBA ****************/

extern StructRNA RNA_CompositorNodeSepRGBA;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeSepRGBA_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeSepRGBA_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeSepRGBA_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeSepYCCA ****************/

extern StructRNA RNA_CompositorNodeSepYCCA;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeSepYCCA_mode_ITUBT601 = 0,
	CompositorNodeSepYCCA_mode_ITUBT709 = 1,
	CompositorNodeSepYCCA_mode_JFIF = 2,
};

int CompositorNodeSepYCCA_mode_get(PointerRNA *ptr);
void CompositorNodeSepYCCA_mode_set(PointerRNA *ptr, int value);

bool CompositorNodeSepYCCA_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeSepYCCA_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeSepYCCA_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeSepYUVA ****************/

extern StructRNA RNA_CompositorNodeSepYUVA;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeSepYUVA_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeSepYUVA_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeSepYUVA_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeSeparateColor ****************/

extern StructRNA RNA_CompositorNodeSeparateColor;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeSeparateColor_ycc_mode_ITUBT601 = 0,
	CompositorNodeSeparateColor_ycc_mode_ITUBT709 = 1,
	CompositorNodeSeparateColor_ycc_mode_JFIF = 2,
};

int CompositorNodeSeparateColor_ycc_mode_get(PointerRNA *ptr);
void CompositorNodeSeparateColor_ycc_mode_set(PointerRNA *ptr, int value);

enum {
	CompositorNodeSeparateColor_mode_RGB = 0,
	CompositorNodeSeparateColor_mode_HSV = 1,
	CompositorNodeSeparateColor_mode_HSL = 2,
	CompositorNodeSeparateColor_mode_YCC = 3,
	CompositorNodeSeparateColor_mode_YUV = 4,
};

int CompositorNodeSeparateColor_mode_get(PointerRNA *ptr);
void CompositorNodeSeparateColor_mode_set(PointerRNA *ptr, int value);

bool CompositorNodeSeparateColor_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeSeparateColor_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeSeparateColor_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeSeparateXYZ ****************/

extern StructRNA RNA_CompositorNodeSeparateXYZ;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeSeparateXYZ_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeSeparateXYZ_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeSeparateXYZ_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeSetAlpha ****************/

extern StructRNA RNA_CompositorNodeSetAlpha;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeSetAlpha_mode_APPLY = 0,
	CompositorNodeSetAlpha_mode_REPLACE_ALPHA = 1,
};

int CompositorNodeSetAlpha_mode_get(PointerRNA *ptr);
void CompositorNodeSetAlpha_mode_set(PointerRNA *ptr, int value);

bool CompositorNodeSetAlpha_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeSetAlpha_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeSetAlpha_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeSplit ****************/

extern StructRNA RNA_CompositorNodeSplit;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeSplit_axis_X = 0,
	CompositorNodeSplit_axis_Y = 1,
};

int CompositorNodeSplit_axis_get(PointerRNA *ptr);
void CompositorNodeSplit_axis_set(PointerRNA *ptr, int value);

int CompositorNodeSplit_factor_get(PointerRNA *ptr);
void CompositorNodeSplit_factor_set(PointerRNA *ptr, int value);

bool CompositorNodeSplit_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeSplit_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeSplit_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeStabilize ****************/

extern StructRNA RNA_CompositorNodeStabilize;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeStabilize_filter_type_NEAREST = 0,
	CompositorNodeStabilize_filter_type_BILINEAR = 1,
	CompositorNodeStabilize_filter_type_BICUBIC = 2,
};

int CompositorNodeStabilize_filter_type_get(PointerRNA *ptr);
void CompositorNodeStabilize_filter_type_set(PointerRNA *ptr, int value);

bool CompositorNodeStabilize_invert_get(PointerRNA *ptr);
void CompositorNodeStabilize_invert_set(PointerRNA *ptr, bool value);

PointerRNA CompositorNodeStabilize_clip_get(PointerRNA *ptr);

bool CompositorNodeStabilize_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeStabilize_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeStabilize_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeSunBeams ****************/

extern StructRNA RNA_CompositorNodeSunBeams;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float CompositorNodeSunBeams_ray_length_get(PointerRNA *ptr);
void CompositorNodeSunBeams_ray_length_set(PointerRNA *ptr, float value);

void CompositorNodeSunBeams_source_get(PointerRNA *ptr, float values[2]);
void CompositorNodeSunBeams_source_set(PointerRNA *ptr, const float values[2]);

bool CompositorNodeSunBeams_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeSunBeams_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeSunBeams_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeSwitch ****************/

extern StructRNA RNA_CompositorNodeSwitch;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeSwitch_check_get(PointerRNA *ptr);
void CompositorNodeSwitch_check_set(PointerRNA *ptr, bool value);

bool CompositorNodeSwitch_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeSwitch_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeSwitch_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeSwitchView ****************/

extern StructRNA RNA_CompositorNodeSwitchView;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeSwitchView_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeSwitchView_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeSwitchView_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeTexture ****************/

extern StructRNA RNA_CompositorNodeTexture;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int CompositorNodeTexture_node_output_get(PointerRNA *ptr);
void CompositorNodeTexture_node_output_set(PointerRNA *ptr, int value);

PointerRNA CompositorNodeTexture_texture_get(PointerRNA *ptr);

bool CompositorNodeTexture_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeTexture_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeTexture_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeTime ****************/

extern StructRNA RNA_CompositorNodeTime;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA CompositorNodeTime_curve_get(PointerRNA *ptr);

int CompositorNodeTime_frame_end_get(PointerRNA *ptr);
void CompositorNodeTime_frame_end_set(PointerRNA *ptr, int value);

int CompositorNodeTime_frame_start_get(PointerRNA *ptr);
void CompositorNodeTime_frame_start_set(PointerRNA *ptr, int value);

bool CompositorNodeTime_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeTime_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeTime_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeTonemap ****************/

extern StructRNA RNA_CompositorNodeTonemap;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float CompositorNodeTonemap_adaptation_get(PointerRNA *ptr);
void CompositorNodeTonemap_adaptation_set(PointerRNA *ptr, float value);

float CompositorNodeTonemap_correction_get(PointerRNA *ptr);
void CompositorNodeTonemap_correction_set(PointerRNA *ptr, float value);

float CompositorNodeTonemap_contrast_get(PointerRNA *ptr);
void CompositorNodeTonemap_contrast_set(PointerRNA *ptr, float value);

float CompositorNodeTonemap_gamma_get(PointerRNA *ptr);
void CompositorNodeTonemap_gamma_set(PointerRNA *ptr, float value);

float CompositorNodeTonemap_intensity_get(PointerRNA *ptr);
void CompositorNodeTonemap_intensity_set(PointerRNA *ptr, float value);

float CompositorNodeTonemap_key_get(PointerRNA *ptr);
void CompositorNodeTonemap_key_set(PointerRNA *ptr, float value);

float CompositorNodeTonemap_offset_get(PointerRNA *ptr);
void CompositorNodeTonemap_offset_set(PointerRNA *ptr, float value);

enum {
	CompositorNodeTonemap_tonemap_type_RD_PHOTORECEPTOR = 1,
	CompositorNodeTonemap_tonemap_type_RH_SIMPLE = 0,
};

int CompositorNodeTonemap_tonemap_type_get(PointerRNA *ptr);
void CompositorNodeTonemap_tonemap_type_set(PointerRNA *ptr, int value);

bool CompositorNodeTonemap_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeTonemap_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeTonemap_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeTrackPos ****************/

extern StructRNA RNA_CompositorNodeTrackPos;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int CompositorNodeTrackPos_frame_relative_get(PointerRNA *ptr);
void CompositorNodeTrackPos_frame_relative_set(PointerRNA *ptr, int value);

PointerRNA CompositorNodeTrackPos_clip_get(PointerRNA *ptr);

enum {
	CompositorNodeTrackPos_position_ABSOLUTE = 0,
	CompositorNodeTrackPos_position_RELATIVE_START = 1,
	CompositorNodeTrackPos_position_RELATIVE_FRAME = 2,
	CompositorNodeTrackPos_position_ABSOLUTE_FRAME = 3,
};

int CompositorNodeTrackPos_position_get(PointerRNA *ptr);
void CompositorNodeTrackPos_position_set(PointerRNA *ptr, int value);

#define CompositorNodeTrackPos_track_name_MAX 64

void CompositorNodeTrackPos_track_name_get(PointerRNA *ptr, char *value);
int CompositorNodeTrackPos_track_name_length(PointerRNA *ptr);
void CompositorNodeTrackPos_track_name_set(PointerRNA *ptr, const char *value);

#define CompositorNodeTrackPos_tracking_object_MAX 64

void CompositorNodeTrackPos_tracking_object_get(PointerRNA *ptr, char *value);
int CompositorNodeTrackPos_tracking_object_length(PointerRNA *ptr);
void CompositorNodeTrackPos_tracking_object_set(PointerRNA *ptr, const char *value);

bool CompositorNodeTrackPos_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeTrackPos_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeTrackPos_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeTransform ****************/

extern StructRNA RNA_CompositorNodeTransform;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeTransform_filter_type_NEAREST = 0,
	CompositorNodeTransform_filter_type_BILINEAR = 1,
	CompositorNodeTransform_filter_type_BICUBIC = 2,
};

int CompositorNodeTransform_filter_type_get(PointerRNA *ptr);
void CompositorNodeTransform_filter_type_set(PointerRNA *ptr, int value);

bool CompositorNodeTransform_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeTransform_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeTransform_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeTranslate ****************/

extern StructRNA RNA_CompositorNodeTranslate;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	CompositorNodeTranslate_interpolation_NEAREST = 0,
	CompositorNodeTranslate_interpolation_BILINEAR = 1,
	CompositorNodeTranslate_interpolation_BICUBIC = 2,
};

int CompositorNodeTranslate_interpolation_get(PointerRNA *ptr);
void CompositorNodeTranslate_interpolation_set(PointerRNA *ptr, int value);

bool CompositorNodeTranslate_use_relative_get(PointerRNA *ptr);
void CompositorNodeTranslate_use_relative_set(PointerRNA *ptr, bool value);

enum {
	CompositorNodeTranslate_wrap_axis_NONE = 0,
	CompositorNodeTranslate_wrap_axis_XAXIS = 1,
	CompositorNodeTranslate_wrap_axis_YAXIS = 2,
	CompositorNodeTranslate_wrap_axis_BOTH = 3,
};

int CompositorNodeTranslate_wrap_axis_get(PointerRNA *ptr);
void CompositorNodeTranslate_wrap_axis_set(PointerRNA *ptr, int value);

bool CompositorNodeTranslate_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeTranslate_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeTranslate_output_template_func(struct StructRNA *_type, int index);
/**************** Compositor Node Tree ****************/

extern StructRNA RNA_CompositorNodeTree;
extern StructRNA RNA_NodeTree;
extern StructRNA RNA_ID;

bool CompositorNodeTree_use_viewer_border_get(PointerRNA *ptr);
void CompositorNodeTree_use_viewer_border_set(PointerRNA *ptr, bool value);

/**************** CompositorNodeValToRGB ****************/

extern StructRNA RNA_CompositorNodeValToRGB;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA CompositorNodeValToRGB_color_ramp_get(PointerRNA *ptr);

bool CompositorNodeValToRGB_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeValToRGB_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeValToRGB_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeValue ****************/

extern StructRNA RNA_CompositorNodeValue;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeValue_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeValue_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeValue_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeVecBlur ****************/

extern StructRNA RNA_CompositorNodeVecBlur;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float CompositorNodeVecBlur_factor_get(PointerRNA *ptr);
void CompositorNodeVecBlur_factor_set(PointerRNA *ptr, float value);

bool CompositorNodeVecBlur_use_curved_get(PointerRNA *ptr);
void CompositorNodeVecBlur_use_curved_set(PointerRNA *ptr, bool value);

int CompositorNodeVecBlur_speed_max_get(PointerRNA *ptr);
void CompositorNodeVecBlur_speed_max_set(PointerRNA *ptr, int value);

int CompositorNodeVecBlur_speed_min_get(PointerRNA *ptr);
void CompositorNodeVecBlur_speed_min_set(PointerRNA *ptr, int value);

int CompositorNodeVecBlur_samples_get(PointerRNA *ptr);
void CompositorNodeVecBlur_samples_set(PointerRNA *ptr, int value);

bool CompositorNodeVecBlur_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeVecBlur_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeVecBlur_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeViewer ****************/

extern StructRNA RNA_CompositorNodeViewer;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeViewer_use_alpha_get(PointerRNA *ptr);
void CompositorNodeViewer_use_alpha_set(PointerRNA *ptr, bool value);

int CompositorNodeViewer_ui_shortcut_get(PointerRNA *ptr);
void CompositorNodeViewer_ui_shortcut_set(PointerRNA *ptr, int value);

bool CompositorNodeViewer_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeViewer_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeViewer_output_template_func(struct StructRNA *_type, int index);
/**************** CompositorNodeZcombine ****************/

extern StructRNA RNA_CompositorNodeZcombine;
extern StructRNA RNA_CompositorNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool CompositorNodeZcombine_use_antialias_z_get(PointerRNA *ptr);
void CompositorNodeZcombine_use_antialias_z_set(PointerRNA *ptr, bool value);

bool CompositorNodeZcombine_use_alpha_get(PointerRNA *ptr);
void CompositorNodeZcombine_use_alpha_set(PointerRNA *ptr, bool value);

bool CompositorNodeZcombine_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA CompositorNodeZcombine_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA CompositorNodeZcombine_output_template_func(struct StructRNA *_type, int index);
/**************** Console Input ****************/

extern StructRNA RNA_ConsoleLine;

PointerRNA ConsoleLine_rna_type_get(PointerRNA *ptr);

void ConsoleLine_body_get(PointerRNA *ptr, char *value);
int ConsoleLine_body_length(PointerRNA *ptr);
void ConsoleLine_body_set(PointerRNA *ptr, const char *value);

enum {
	ConsoleLine_type_OUTPUT = 0,
	ConsoleLine_type_INPUT = 1,
	ConsoleLine_type_INFO = 2,
	ConsoleLine_type_ERROR = 3,
};

int ConsoleLine_type_get(PointerRNA *ptr);
void ConsoleLine_type_set(PointerRNA *ptr, int value);

int ConsoleLine_current_character_get(PointerRNA *ptr);
void ConsoleLine_current_character_set(PointerRNA *ptr, int value);

/**************** Constraint ****************/

extern StructRNA RNA_Constraint;

PointerRNA Constraint_rna_type_get(PointerRNA *ptr);

#define Constraint_name_MAX 64

void Constraint_name_get(PointerRNA *ptr, char *value);
int Constraint_name_length(PointerRNA *ptr);
void Constraint_name_set(PointerRNA *ptr, const char *value);

bool Constraint_active_get(PointerRNA *ptr);
void Constraint_active_set(PointerRNA *ptr, bool value);

bool Constraint_mute_get(PointerRNA *ptr);
void Constraint_mute_set(PointerRNA *ptr, bool value);

bool Constraint_enabled_get(PointerRNA *ptr);
void Constraint_enabled_set(PointerRNA *ptr, bool value);

bool Constraint_show_expanded_get(PointerRNA *ptr);
void Constraint_show_expanded_set(PointerRNA *ptr, bool value);

float Constraint_influence_get(PointerRNA *ptr);
void Constraint_influence_set(PointerRNA *ptr, float value);

float Constraint_error_location_get(PointerRNA *ptr);
void Constraint_error_location_set(PointerRNA *ptr, float value);

PointerRNA Constraint_space_object_get(PointerRNA *ptr);

bool Constraint_is_override_data_get(PointerRNA *ptr);
void Constraint_is_override_data_set(PointerRNA *ptr, bool value);

enum {
	Constraint_owner_space_WORLD = 0,
	Constraint_owner_space_CUSTOM = 5,
	Constraint_owner_space_POSE = 2,
	Constraint_owner_space_LOCAL_WITH_PARENT = 3,
	Constraint_owner_space_LOCAL = 1,
};

int Constraint_owner_space_get(PointerRNA *ptr);
void Constraint_owner_space_set(PointerRNA *ptr, int value);

float Constraint_error_rotation_get(PointerRNA *ptr);
void Constraint_error_rotation_set(PointerRNA *ptr, float value);

#define Constraint_space_subtarget_MAX 64

void Constraint_space_subtarget_get(PointerRNA *ptr, char *value);
int Constraint_space_subtarget_length(PointerRNA *ptr);
void Constraint_space_subtarget_set(PointerRNA *ptr, const char *value);

enum {
	Constraint_target_space_WORLD = 0,
	Constraint_target_space_CUSTOM = 5,
	Constraint_target_space_POSE = 2,
	Constraint_target_space_LOCAL_WITH_PARENT = 3,
	Constraint_target_space_LOCAL = 1,
	Constraint_target_space_LOCAL_OWNER_ORIENT = 6,
};

int Constraint_target_space_get(PointerRNA *ptr);
void Constraint_target_space_set(PointerRNA *ptr, int value);

enum {
	Constraint_type_CAMERA_SOLVER = 27,
	Constraint_type_FOLLOW_TRACK = 26,
	Constraint_type_OBJECT_SOLVER = 28,
	Constraint_type_COPY_LOCATION = 9,
	Constraint_type_COPY_ROTATION = 8,
	Constraint_type_COPY_SCALE = 10,
	Constraint_type_COPY_TRANSFORMS = 23,
	Constraint_type_LIMIT_DISTANCE = 14,
	Constraint_type_LIMIT_LOCATION = 6,
	Constraint_type_LIMIT_ROTATION = 5,
	Constraint_type_LIMIT_SCALE = 7,
	Constraint_type_MAINTAIN_VOLUME = 24,
	Constraint_type_TRANSFORM = 19,
	Constraint_type_TRANSFORM_CACHE = 29,
	Constraint_type_CLAMP_TO = 18,
	Constraint_type_DAMPED_TRACK = 21,
	Constraint_type_IK = 3,
	Constraint_type_LOCKED_TRACK = 13,
	Constraint_type_SPLINE_IK = 22,
	Constraint_type_STRETCH_TO = 15,
	Constraint_type_TRACK_TO = 2,
	Constraint_type_ACTION = 12,
	Constraint_type_ARMATURE = 30,
	Constraint_type_CHILD_OF = 1,
	Constraint_type_FLOOR = 16,
	Constraint_type_FOLLOW_PATH = 4,
	Constraint_type_PIVOT = 25,
	Constraint_type_SHRINKWRAP = 20,
};

int Constraint_type_get(PointerRNA *ptr);
void Constraint_type_set(PointerRNA *ptr, int value);

bool Constraint_is_valid_get(PointerRNA *ptr);
void Constraint_is_valid_set(PointerRNA *ptr, bool value);

/**************** Constraint Target ****************/

extern StructRNA RNA_ConstraintTarget;

PointerRNA ConstraintTarget_rna_type_get(PointerRNA *ptr);

#define ConstraintTarget_subtarget_MAX 64

void ConstraintTarget_subtarget_get(PointerRNA *ptr, char *value);
int ConstraintTarget_subtarget_length(PointerRNA *ptr);
void ConstraintTarget_subtarget_set(PointerRNA *ptr, const char *value);

PointerRNA ConstraintTarget_target_get(PointerRNA *ptr);

/**************** Constraint Target Bone ****************/

extern StructRNA RNA_ConstraintTargetBone;

PointerRNA ConstraintTargetBone_rna_type_get(PointerRNA *ptr);

float ConstraintTargetBone_weight_get(PointerRNA *ptr);
void ConstraintTargetBone_weight_set(PointerRNA *ptr, float value);

#define ConstraintTargetBone_subtarget_MAX 64

void ConstraintTargetBone_subtarget_get(PointerRNA *ptr, char *value);
int ConstraintTargetBone_subtarget_length(PointerRNA *ptr);
void ConstraintTargetBone_subtarget_set(PointerRNA *ptr, const char *value);

PointerRNA ConstraintTargetBone_target_get(PointerRNA *ptr);

/**************** Context ****************/

extern StructRNA RNA_Context;

PointerRNA Context_rna_type_get(PointerRNA *ptr);

PointerRNA Context_space_data_get(PointerRNA *ptr);

PointerRNA Context_region_popup_get(PointerRNA *ptr);

PointerRNA Context_area_get(PointerRNA *ptr);

PointerRNA Context_asset_get(PointerRNA *ptr);

PointerRNA Context_blend_data_get(PointerRNA *ptr);

PointerRNA Context_collection_get(PointerRNA *ptr);

void Context_engine_get(PointerRNA *ptr, char *value);
int Context_engine_length(PointerRNA *ptr);
void Context_engine_set(PointerRNA *ptr, const char *value);

PointerRNA Context_gizmo_group_get(PointerRNA *ptr);

PointerRNA Context_layer_collection_get(PointerRNA *ptr);

enum {
	Context_mode_EDIT_MESH = 0,
	Context_mode_EDIT_CURVE = 1,
	Context_mode_EDIT_CURVES = 7,
	Context_mode_EDIT_SURFACE = 2,
	Context_mode_EDIT_TEXT = 3,
	Context_mode_EDIT_ARMATURE = 4,
	Context_mode_EDIT_METABALL = 5,
	Context_mode_EDIT_LATTICE = 6,
	Context_mode_EDIT_GREASE_PENCIL = 8,
	Context_mode_EDIT_POINTCLOUD = 9,
	Context_mode_POSE = 10,
	Context_mode_SCULPT = 11,
	Context_mode_PAINT_WEIGHT = 12,
	Context_mode_PAINT_VERTEX = 13,
	Context_mode_PAINT_TEXTURE = 14,
	Context_mode_PARTICLE = 15,
	Context_mode_OBJECT = 16,
	Context_mode_PAINT_GPENCIL = 17,
	Context_mode_EDIT_GPENCIL = 18,
	Context_mode_SCULPT_GPENCIL = 19,
	Context_mode_WEIGHT_GPENCIL = 20,
	Context_mode_VERTEX_GPENCIL = 21,
	Context_mode_SCULPT_CURVES = 22,
	Context_mode_PAINT_GREASE_PENCIL = 23,
	Context_mode_SCULPT_GREASE_PENCIL = 24,
	Context_mode_WEIGHT_GREASE_PENCIL = 25,
	Context_mode_VERTEX_GREASE_PENCIL = 26,
};

int Context_mode_get(PointerRNA *ptr);
void Context_mode_set(PointerRNA *ptr, int value);

PointerRNA Context_preferences_get(PointerRNA *ptr);

PointerRNA Context_region_get(PointerRNA *ptr);

PointerRNA Context_region_data_get(PointerRNA *ptr);

PointerRNA Context_scene_get(PointerRNA *ptr);

PointerRNA Context_screen_get(PointerRNA *ptr);

PointerRNA Context_tool_settings_get(PointerRNA *ptr);

PointerRNA Context_view_layer_get(PointerRNA *ptr);

PointerRNA Context_window_get(PointerRNA *ptr);

PointerRNA Context_window_manager_get(PointerRNA *ptr);

PointerRNA Context_workspace_get(PointerRNA *ptr);

struct Depsgraph *Context_evaluated_depsgraph_get_func(struct bContext *_self);
/**************** Copy Location Constraint ****************/

extern StructRNA RNA_CopyLocationConstraint;
extern StructRNA RNA_Constraint;

bool CopyLocationConstraint_use_x_get(PointerRNA *ptr);
void CopyLocationConstraint_use_x_set(PointerRNA *ptr, bool value);

bool CopyLocationConstraint_use_y_get(PointerRNA *ptr);
void CopyLocationConstraint_use_y_set(PointerRNA *ptr, bool value);

bool CopyLocationConstraint_use_z_get(PointerRNA *ptr);
void CopyLocationConstraint_use_z_set(PointerRNA *ptr, bool value);

bool CopyLocationConstraint_use_bbone_shape_get(PointerRNA *ptr);
void CopyLocationConstraint_use_bbone_shape_set(PointerRNA *ptr, bool value);

float CopyLocationConstraint_head_tail_get(PointerRNA *ptr);
void CopyLocationConstraint_head_tail_set(PointerRNA *ptr, float value);

bool CopyLocationConstraint_invert_x_get(PointerRNA *ptr);
void CopyLocationConstraint_invert_x_set(PointerRNA *ptr, bool value);

bool CopyLocationConstraint_invert_y_get(PointerRNA *ptr);
void CopyLocationConstraint_invert_y_set(PointerRNA *ptr, bool value);

bool CopyLocationConstraint_invert_z_get(PointerRNA *ptr);
void CopyLocationConstraint_invert_z_set(PointerRNA *ptr, bool value);

bool CopyLocationConstraint_use_offset_get(PointerRNA *ptr);
void CopyLocationConstraint_use_offset_set(PointerRNA *ptr, bool value);

#define CopyLocationConstraint_subtarget_MAX 64

void CopyLocationConstraint_subtarget_get(PointerRNA *ptr, char *value);
int CopyLocationConstraint_subtarget_length(PointerRNA *ptr);
void CopyLocationConstraint_subtarget_set(PointerRNA *ptr, const char *value);

PointerRNA CopyLocationConstraint_target_get(PointerRNA *ptr);

/**************** Copy Rotation Constraint ****************/

extern StructRNA RNA_CopyRotationConstraint;
extern StructRNA RNA_Constraint;

bool CopyRotationConstraint_use_x_get(PointerRNA *ptr);
void CopyRotationConstraint_use_x_set(PointerRNA *ptr, bool value);

bool CopyRotationConstraint_use_y_get(PointerRNA *ptr);
void CopyRotationConstraint_use_y_set(PointerRNA *ptr, bool value);

bool CopyRotationConstraint_use_z_get(PointerRNA *ptr);
void CopyRotationConstraint_use_z_set(PointerRNA *ptr, bool value);

enum {
	CopyRotationConstraint_euler_order_AUTO = 0,
	CopyRotationConstraint_euler_order_XYZ = 1,
	CopyRotationConstraint_euler_order_XZY = 2,
	CopyRotationConstraint_euler_order_YXZ = 3,
	CopyRotationConstraint_euler_order_YZX = 4,
	CopyRotationConstraint_euler_order_ZXY = 5,
	CopyRotationConstraint_euler_order_ZYX = 6,
};

int CopyRotationConstraint_euler_order_get(PointerRNA *ptr);
void CopyRotationConstraint_euler_order_set(PointerRNA *ptr, int value);

bool CopyRotationConstraint_invert_x_get(PointerRNA *ptr);
void CopyRotationConstraint_invert_x_set(PointerRNA *ptr, bool value);

bool CopyRotationConstraint_invert_y_get(PointerRNA *ptr);
void CopyRotationConstraint_invert_y_set(PointerRNA *ptr, bool value);

bool CopyRotationConstraint_invert_z_get(PointerRNA *ptr);
void CopyRotationConstraint_invert_z_set(PointerRNA *ptr, bool value);

enum {
	CopyRotationConstraint_mix_mode_REPLACE = 0,
	CopyRotationConstraint_mix_mode_ADD = 2,
	CopyRotationConstraint_mix_mode_BEFORE = 3,
	CopyRotationConstraint_mix_mode_AFTER = 4,
	CopyRotationConstraint_mix_mode_OFFSET = 1,
};

int CopyRotationConstraint_mix_mode_get(PointerRNA *ptr);
void CopyRotationConstraint_mix_mode_set(PointerRNA *ptr, int value);

bool CopyRotationConstraint_use_offset_get(PointerRNA *ptr);
void CopyRotationConstraint_use_offset_set(PointerRNA *ptr, bool value);

#define CopyRotationConstraint_subtarget_MAX 64

void CopyRotationConstraint_subtarget_get(PointerRNA *ptr, char *value);
int CopyRotationConstraint_subtarget_length(PointerRNA *ptr);
void CopyRotationConstraint_subtarget_set(PointerRNA *ptr, const char *value);

PointerRNA CopyRotationConstraint_target_get(PointerRNA *ptr);

/**************** Copy Scale Constraint ****************/

extern StructRNA RNA_CopyScaleConstraint;
extern StructRNA RNA_Constraint;

bool CopyScaleConstraint_use_add_get(PointerRNA *ptr);
void CopyScaleConstraint_use_add_set(PointerRNA *ptr, bool value);

bool CopyScaleConstraint_use_x_get(PointerRNA *ptr);
void CopyScaleConstraint_use_x_set(PointerRNA *ptr, bool value);

bool CopyScaleConstraint_use_y_get(PointerRNA *ptr);
void CopyScaleConstraint_use_y_set(PointerRNA *ptr, bool value);

bool CopyScaleConstraint_use_z_get(PointerRNA *ptr);
void CopyScaleConstraint_use_z_set(PointerRNA *ptr, bool value);

bool CopyScaleConstraint_use_make_uniform_get(PointerRNA *ptr);
void CopyScaleConstraint_use_make_uniform_set(PointerRNA *ptr, bool value);

bool CopyScaleConstraint_use_offset_get(PointerRNA *ptr);
void CopyScaleConstraint_use_offset_set(PointerRNA *ptr, bool value);

float CopyScaleConstraint_power_get(PointerRNA *ptr);
void CopyScaleConstraint_power_set(PointerRNA *ptr, float value);

#define CopyScaleConstraint_subtarget_MAX 64

void CopyScaleConstraint_subtarget_get(PointerRNA *ptr, char *value);
int CopyScaleConstraint_subtarget_length(PointerRNA *ptr);
void CopyScaleConstraint_subtarget_set(PointerRNA *ptr, const char *value);

PointerRNA CopyScaleConstraint_target_get(PointerRNA *ptr);

/**************** Copy Transforms Constraint ****************/

extern StructRNA RNA_CopyTransformsConstraint;
extern StructRNA RNA_Constraint;

bool CopyTransformsConstraint_use_bbone_shape_get(PointerRNA *ptr);
void CopyTransformsConstraint_use_bbone_shape_set(PointerRNA *ptr, bool value);

float CopyTransformsConstraint_head_tail_get(PointerRNA *ptr);
void CopyTransformsConstraint_head_tail_set(PointerRNA *ptr, float value);

enum {
	CopyTransformsConstraint_mix_mode_REPLACE = 0,
	CopyTransformsConstraint_mix_mode_BEFORE_FULL = 5,
	CopyTransformsConstraint_mix_mode_BEFORE = 1,
	CopyTransformsConstraint_mix_mode_BEFORE_SPLIT = 3,
	CopyTransformsConstraint_mix_mode_AFTER_FULL = 6,
	CopyTransformsConstraint_mix_mode_AFTER = 2,
	CopyTransformsConstraint_mix_mode_AFTER_SPLIT = 4,
};

int CopyTransformsConstraint_mix_mode_get(PointerRNA *ptr);
void CopyTransformsConstraint_mix_mode_set(PointerRNA *ptr, int value);

bool CopyTransformsConstraint_remove_target_shear_get(PointerRNA *ptr);
void CopyTransformsConstraint_remove_target_shear_set(PointerRNA *ptr, bool value);

#define CopyTransformsConstraint_subtarget_MAX 64

void CopyTransformsConstraint_subtarget_get(PointerRNA *ptr, char *value);
int CopyTransformsConstraint_subtarget_length(PointerRNA *ptr);
void CopyTransformsConstraint_subtarget_set(PointerRNA *ptr, const char *value);

PointerRNA CopyTransformsConstraint_target_get(PointerRNA *ptr);

/**************** Corrective Smooth Modifier ****************/

extern StructRNA RNA_CorrectiveSmoothModifier;
extern StructRNA RNA_Modifier;

bool CorrectiveSmoothModifier_is_bind_get(PointerRNA *ptr);
void CorrectiveSmoothModifier_is_bind_set(PointerRNA *ptr, bool value);

bool CorrectiveSmoothModifier_invert_vertex_group_get(PointerRNA *ptr);
void CorrectiveSmoothModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

float CorrectiveSmoothModifier_factor_get(PointerRNA *ptr);
void CorrectiveSmoothModifier_factor_set(PointerRNA *ptr, float value);

bool CorrectiveSmoothModifier_use_only_smooth_get(PointerRNA *ptr);
void CorrectiveSmoothModifier_use_only_smooth_set(PointerRNA *ptr, bool value);

bool CorrectiveSmoothModifier_use_pin_boundary_get(PointerRNA *ptr);
void CorrectiveSmoothModifier_use_pin_boundary_set(PointerRNA *ptr, bool value);

int CorrectiveSmoothModifier_iterations_get(PointerRNA *ptr);
void CorrectiveSmoothModifier_iterations_set(PointerRNA *ptr, int value);

enum {
	CorrectiveSmoothModifier_rest_source_ORCO = 0,
	CorrectiveSmoothModifier_rest_source_BIND = 1,
};

int CorrectiveSmoothModifier_rest_source_get(PointerRNA *ptr);
void CorrectiveSmoothModifier_rest_source_set(PointerRNA *ptr, int value);

float CorrectiveSmoothModifier_scale_get(PointerRNA *ptr);
void CorrectiveSmoothModifier_scale_set(PointerRNA *ptr, float value);

enum {
	CorrectiveSmoothModifier_smooth_type_SIMPLE = 0,
	CorrectiveSmoothModifier_smooth_type_LENGTH_WEIGHTED = 1,
};

int CorrectiveSmoothModifier_smooth_type_get(PointerRNA *ptr);
void CorrectiveSmoothModifier_smooth_type_set(PointerRNA *ptr, int value);

#define CorrectiveSmoothModifier_vertex_group_MAX 64

void CorrectiveSmoothModifier_vertex_group_get(PointerRNA *ptr, char *value);
int CorrectiveSmoothModifier_vertex_group_length(PointerRNA *ptr);
void CorrectiveSmoothModifier_vertex_group_set(PointerRNA *ptr, const char *value);

/**************** Crossfade Strip ****************/

extern StructRNA RNA_CrossStrip;
extern StructRNA RNA_EffectStrip;
extern StructRNA RNA_Strip;

PointerRNA CrossStrip_input_1_get(PointerRNA *ptr);

PointerRNA CrossStrip_input_2_get(PointerRNA *ptr);

int CrossStrip_input_count_get(PointerRNA *ptr);
void CrossStrip_input_count_set(PointerRNA *ptr, int value);

/**************** CryptomatteEntry ****************/

extern StructRNA RNA_CryptomatteEntry;

PointerRNA CryptomatteEntry_rna_type_get(PointerRNA *ptr);

#define CryptomatteEntry_name_MAX 64

void CryptomatteEntry_name_get(PointerRNA *ptr, char *value);
int CryptomatteEntry_name_length(PointerRNA *ptr);
void CryptomatteEntry_name_set(PointerRNA *ptr, const char *value);

float CryptomatteEntry_encoded_hash_get(PointerRNA *ptr);
void CryptomatteEntry_encoded_hash_set(PointerRNA *ptr, float value);

/**************** Curve ****************/

extern StructRNA RNA_Curve;
extern StructRNA RNA_ID;

PointerRNA Curve_animation_data_get(PointerRNA *ptr);

bool Curve_use_auto_texspace_get(PointerRNA *ptr);
void Curve_use_auto_texspace_set(PointerRNA *ptr, bool value);

float Curve_bevel_depth_get(PointerRNA *ptr);
void Curve_bevel_depth_set(PointerRNA *ptr, float value);

enum {
	Curve_bevel_mode_ROUND = 0,
	Curve_bevel_mode_OBJECT = 1,
	Curve_bevel_mode_PROFILE = 2,
};

int Curve_bevel_mode_get(PointerRNA *ptr);
void Curve_bevel_mode_set(PointerRNA *ptr, int value);

PointerRNA Curve_bevel_object_get(PointerRNA *ptr);

int Curve_bevel_resolution_get(PointerRNA *ptr);
void Curve_bevel_resolution_set(PointerRNA *ptr, int value);

bool Curve_use_deform_bounds_get(PointerRNA *ptr);
void Curve_use_deform_bounds_set(PointerRNA *ptr, bool value);

bool Curve_use_path_clamp_get(PointerRNA *ptr);
void Curve_use_path_clamp_set(PointerRNA *ptr, bool value);

PointerRNA Curve_bevel_profile_get(PointerRNA *ptr);

enum {
	Curve_dimensions_2D = 0,
	Curve_dimensions_3D = 1,
};

int Curve_dimensions_get(PointerRNA *ptr);
void Curve_dimensions_set(PointerRNA *ptr, int value);

enum {
	Curve_bevel_factor_mapping_end_RESOLUTION = 0,
	Curve_bevel_factor_mapping_end_SEGMENTS = 1,
	Curve_bevel_factor_mapping_end_SPLINE = 2,
};

int Curve_bevel_factor_mapping_end_get(PointerRNA *ptr);
void Curve_bevel_factor_mapping_end_set(PointerRNA *ptr, int value);

float Curve_eval_time_get(PointerRNA *ptr);
void Curve_eval_time_set(PointerRNA *ptr, float value);

float Curve_extrude_get(PointerRNA *ptr);
void Curve_extrude_set(PointerRNA *ptr, float value);

bool Curve_use_fill_caps_get(PointerRNA *ptr);
void Curve_use_fill_caps_set(PointerRNA *ptr, bool value);

enum {
	Curve_fill_mode_FULL = 0,
	Curve_fill_mode_BACK = 4,
	Curve_fill_mode_FRONT = 2,
	Curve_fill_mode_HALF = 6,
};

int Curve_fill_mode_get(PointerRNA *ptr);
void Curve_fill_mode_set(PointerRNA *ptr, int value);

bool Curve_use_path_follow_get(PointerRNA *ptr);
void Curve_use_path_follow_set(PointerRNA *ptr, bool value);

float Curve_bevel_factor_end_get(PointerRNA *ptr);
void Curve_bevel_factor_end_set(PointerRNA *ptr, float value);

float Curve_bevel_factor_start_get(PointerRNA *ptr);
void Curve_bevel_factor_start_set(PointerRNA *ptr, float value);

bool Curve_is_editmode_get(PointerRNA *ptr);
void Curve_is_editmode_set(PointerRNA *ptr, bool value);

bool Curve_use_map_taper_get(PointerRNA *ptr);
void Curve_use_map_taper_set(PointerRNA *ptr, bool value);

void Curve_materials_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Curve_materials_next(CollectionPropertyIterator *iter);
void Curve_materials_end(CollectionPropertyIterator *iter);
int Curve_materials_length(PointerRNA *ptr);
bool Curve_materials_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Curve_materials_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

float Curve_offset_get(PointerRNA *ptr);
void Curve_offset_set(PointerRNA *ptr, float value);

bool Curve_use_path_get(PointerRNA *ptr);
void Curve_use_path_set(PointerRNA *ptr, bool value);

int Curve_path_duration_get(PointerRNA *ptr);
void Curve_path_duration_set(PointerRNA *ptr, int value);

bool Curve_use_radius_get(PointerRNA *ptr);
void Curve_use_radius_set(PointerRNA *ptr, bool value);

int Curve_render_resolution_u_get(PointerRNA *ptr);
void Curve_render_resolution_u_set(PointerRNA *ptr, int value);

int Curve_render_resolution_v_get(PointerRNA *ptr);
void Curve_render_resolution_v_set(PointerRNA *ptr, int value);

int Curve_resolution_u_get(PointerRNA *ptr);
void Curve_resolution_u_set(PointerRNA *ptr, int value);

int Curve_resolution_v_get(PointerRNA *ptr);
void Curve_resolution_v_set(PointerRNA *ptr, int value);

PointerRNA Curve_shape_keys_get(PointerRNA *ptr);

void Curve_splines_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Curve_splines_next(CollectionPropertyIterator *iter);
void Curve_splines_end(CollectionPropertyIterator *iter);

enum {
	Curve_bevel_factor_mapping_start_RESOLUTION = 0,
	Curve_bevel_factor_mapping_start_SEGMENTS = 1,
	Curve_bevel_factor_mapping_start_SPLINE = 2,
};

int Curve_bevel_factor_mapping_start_get(PointerRNA *ptr);
void Curve_bevel_factor_mapping_start_set(PointerRNA *ptr, int value);

bool Curve_use_stretch_get(PointerRNA *ptr);
void Curve_use_stretch_set(PointerRNA *ptr, bool value);

PointerRNA Curve_taper_object_get(PointerRNA *ptr);

enum {
	Curve_taper_radius_mode_OVERRIDE = 0,
	Curve_taper_radius_mode_MULTIPLY = 1,
	Curve_taper_radius_mode_ADD = 2,
};

int Curve_taper_radius_mode_get(PointerRNA *ptr);
void Curve_taper_radius_mode_set(PointerRNA *ptr, int value);

void Curve_texspace_location_get(PointerRNA *ptr, float values[3]);
void Curve_texspace_location_set(PointerRNA *ptr, const float values[3]);

void Curve_texspace_size_get(PointerRNA *ptr, float values[3]);
void Curve_texspace_size_set(PointerRNA *ptr, const float values[3]);

enum {
	Curve_twist_mode_Z_UP = 0,
	Curve_twist_mode_MINIMUM = 3,
	Curve_twist_mode_TANGENT = 4,
};

int Curve_twist_mode_get(PointerRNA *ptr);
void Curve_twist_mode_set(PointerRNA *ptr, int value);

float Curve_twist_smooth_get(PointerRNA *ptr);
void Curve_twist_smooth_set(PointerRNA *ptr, float value);

void Curve_transform_func(struct Curve *_self, float matrix[16], bool shape_keys);
bool Curve_validate_material_indices_func(struct Curve *_self);
void Curve_update_gpu_tag_func(struct Curve *_self);
/**************** CurveMap ****************/

extern StructRNA RNA_CurveMap;

PointerRNA CurveMap_rna_type_get(PointerRNA *ptr);

void CurveMap_points_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void CurveMap_points_next(CollectionPropertyIterator *iter);
void CurveMap_points_end(CollectionPropertyIterator *iter);
int CurveMap_points_length(PointerRNA *ptr);
bool CurveMap_points_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** CurveMapPoint ****************/

extern StructRNA RNA_CurveMapPoint;

PointerRNA CurveMapPoint_rna_type_get(PointerRNA *ptr);

enum {
	CurveMapPoint_handle_type_AUTO = 0,
	CurveMapPoint_handle_type_AUTO_CLAMPED = 4,
	CurveMapPoint_handle_type_VECTOR = 2,
};

int CurveMapPoint_handle_type_get(PointerRNA *ptr);
void CurveMapPoint_handle_type_set(PointerRNA *ptr, int value);

void CurveMapPoint_location_get(PointerRNA *ptr, float values[2]);
void CurveMapPoint_location_set(PointerRNA *ptr, const float values[2]);

bool CurveMapPoint_select_get(PointerRNA *ptr);
void CurveMapPoint_select_set(PointerRNA *ptr, bool value);

/**************** Curve Map Point ****************/

extern StructRNA RNA_CurveMapPoints;

PointerRNA CurveMapPoints_rna_type_get(PointerRNA *ptr);

struct CurveMapPoint *CurveMapPoints_new_func(struct CurveMap *_self, float position, float value);
void CurveMapPoints_remove_func(struct CurveMap *_self, ReportList *reports, struct PointerRNA *point);
/**************** CurveMapping ****************/

extern StructRNA RNA_CurveMapping;

PointerRNA CurveMapping_rna_type_get(PointerRNA *ptr);

void CurveMapping_black_level_get(PointerRNA *ptr, float values[3]);
void CurveMapping_black_level_set(PointerRNA *ptr, const float values[3]);

bool CurveMapping_use_clip_get(PointerRNA *ptr);
void CurveMapping_use_clip_set(PointerRNA *ptr, bool value);

float CurveMapping_clip_max_x_get(PointerRNA *ptr);
void CurveMapping_clip_max_x_set(PointerRNA *ptr, float value);

float CurveMapping_clip_max_y_get(PointerRNA *ptr);
void CurveMapping_clip_max_y_set(PointerRNA *ptr, float value);

float CurveMapping_clip_min_x_get(PointerRNA *ptr);
void CurveMapping_clip_min_x_set(PointerRNA *ptr, float value);

float CurveMapping_clip_min_y_get(PointerRNA *ptr);
void CurveMapping_clip_min_y_set(PointerRNA *ptr, float value);

void CurveMapping_curves_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void CurveMapping_curves_next(CollectionPropertyIterator *iter);
void CurveMapping_curves_end(CollectionPropertyIterator *iter);
int CurveMapping_curves_length(PointerRNA *ptr);

enum {
	CurveMapping_extend_HORIZONTAL = 0,
	CurveMapping_extend_EXTRAPOLATED = 16,
};

int CurveMapping_extend_get(PointerRNA *ptr);
void CurveMapping_extend_set(PointerRNA *ptr, int value);

enum {
	CurveMapping_tone_STANDARD = 0,
	CurveMapping_tone_FILMLIKE = 2,
};

int CurveMapping_tone_get(PointerRNA *ptr);
void CurveMapping_tone_set(PointerRNA *ptr, int value);

void CurveMapping_white_level_get(PointerRNA *ptr, float values[3]);
void CurveMapping_white_level_set(PointerRNA *ptr, const float values[3]);

void CurveMapping_update_func(struct CurveMapping *_self);
void CurveMapping_reset_view_func(struct CurveMapping *_self);
void CurveMapping_initialize_func(struct CurveMapping *_self);
float CurveMapping_evaluate_func(struct CurveMapping *_self, ReportList *reports, struct CurveMap *curve, float position);
/**************** Curve Modifier ****************/

extern StructRNA RNA_CurveModifier;
extern StructRNA RNA_Modifier;

enum {
	CurveModifier_deform_axis_POS_X = 1,
	CurveModifier_deform_axis_POS_Y = 2,
	CurveModifier_deform_axis_POS_Z = 3,
	CurveModifier_deform_axis_NEG_X = 4,
	CurveModifier_deform_axis_NEG_Y = 5,
	CurveModifier_deform_axis_NEG_Z = 6,
};

int CurveModifier_deform_axis_get(PointerRNA *ptr);
void CurveModifier_deform_axis_set(PointerRNA *ptr, int value);

bool CurveModifier_invert_vertex_group_get(PointerRNA *ptr);
void CurveModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

PointerRNA CurveModifier_object_get(PointerRNA *ptr);

#define CurveModifier_vertex_group_MAX 64

void CurveModifier_vertex_group_get(PointerRNA *ptr, char *value);
int CurveModifier_vertex_group_length(PointerRNA *ptr);
void CurveModifier_vertex_group_set(PointerRNA *ptr, const char *value);

/**************** Curve Paint Settings ****************/

extern StructRNA RNA_CurvePaintSettings;

PointerRNA CurvePaintSettings_rna_type_get(PointerRNA *ptr);

bool CurvePaintSettings_use_offset_absolute_get(PointerRNA *ptr);
void CurvePaintSettings_use_offset_absolute_set(PointerRNA *ptr, bool value);

float CurvePaintSettings_corner_angle_get(PointerRNA *ptr);
void CurvePaintSettings_corner_angle_set(PointerRNA *ptr, float value);

enum {
	CurvePaintSettings_depth_mode_CURSOR = 0,
	CurvePaintSettings_depth_mode_SURFACE = 1,
};

int CurvePaintSettings_depth_mode_get(PointerRNA *ptr);
void CurvePaintSettings_depth_mode_set(PointerRNA *ptr, int value);

bool CurvePaintSettings_use_corners_detect_get(PointerRNA *ptr);
void CurvePaintSettings_use_corners_detect_set(PointerRNA *ptr, bool value);

enum {
	CurvePaintSettings_fit_method_REFIT = 0,
	CurvePaintSettings_fit_method_SPLIT = 1,
};

int CurvePaintSettings_fit_method_get(PointerRNA *ptr);
void CurvePaintSettings_fit_method_set(PointerRNA *ptr, int value);

float CurvePaintSettings_surface_offset_get(PointerRNA *ptr);
void CurvePaintSettings_surface_offset_set(PointerRNA *ptr, float value);

bool CurvePaintSettings_use_stroke_endpoints_get(PointerRNA *ptr);
void CurvePaintSettings_use_stroke_endpoints_set(PointerRNA *ptr, bool value);

enum {
	CurvePaintSettings_surface_plane_NORMAL_VIEW = 0,
	CurvePaintSettings_surface_plane_NORMAL_SURFACE = 1,
	CurvePaintSettings_surface_plane_VIEW = 2,
};

int CurvePaintSettings_surface_plane_get(PointerRNA *ptr);
void CurvePaintSettings_surface_plane_set(PointerRNA *ptr, int value);

bool CurvePaintSettings_use_project_only_selected_get(PointerRNA *ptr);
void CurvePaintSettings_use_project_only_selected_set(PointerRNA *ptr, bool value);

float CurvePaintSettings_radius_max_get(PointerRNA *ptr);
void CurvePaintSettings_radius_max_set(PointerRNA *ptr, float value);

float CurvePaintSettings_radius_taper_end_get(PointerRNA *ptr);
void CurvePaintSettings_radius_taper_end_set(PointerRNA *ptr, float value);

float CurvePaintSettings_radius_min_get(PointerRNA *ptr);
void CurvePaintSettings_radius_min_set(PointerRNA *ptr, float value);

float CurvePaintSettings_radius_taper_start_get(PointerRNA *ptr);
void CurvePaintSettings_radius_taper_start_set(PointerRNA *ptr, float value);

int CurvePaintSettings_error_threshold_get(PointerRNA *ptr);
void CurvePaintSettings_error_threshold_set(PointerRNA *ptr, int value);

enum {
	CurvePaintSettings_curve_type_POLY = 0,
	CurvePaintSettings_curve_type_BEZIER = 1,
};

int CurvePaintSettings_curve_type_get(PointerRNA *ptr);
void CurvePaintSettings_curve_type_set(PointerRNA *ptr, int value);

bool CurvePaintSettings_use_pressure_radius_get(PointerRNA *ptr);
void CurvePaintSettings_use_pressure_radius_set(PointerRNA *ptr, bool value);

/**************** Curve Point ****************/

extern StructRNA RNA_CurvePoint;

PointerRNA CurvePoint_rna_type_get(PointerRNA *ptr);

int CurvePoint_index_get(PointerRNA *ptr);
void CurvePoint_index_set(PointerRNA *ptr, int value);

void CurvePoint_position_get(PointerRNA *ptr, float values[3]);
void CurvePoint_position_set(PointerRNA *ptr, const float values[3]);

float CurvePoint_radius_get(PointerRNA *ptr);
void CurvePoint_radius_set(PointerRNA *ptr, float value);

/**************** CurveProfile ****************/

extern StructRNA RNA_CurveProfile;

PointerRNA CurveProfile_rna_type_get(PointerRNA *ptr);

bool CurveProfile_use_clip_get(PointerRNA *ptr);
void CurveProfile_use_clip_set(PointerRNA *ptr, bool value);

void CurveProfile_points_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void CurveProfile_points_next(CollectionPropertyIterator *iter);
void CurveProfile_points_end(CollectionPropertyIterator *iter);
int CurveProfile_points_length(PointerRNA *ptr);
bool CurveProfile_points_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

enum {
	CurveProfile_preset_LINE = 0,
	CurveProfile_preset_SUPPORTS = 1,
	CurveProfile_preset_CORNICE = 2,
	CurveProfile_preset_CROWN = 3,
	CurveProfile_preset_STEPS = 4,
};

int CurveProfile_preset_get(PointerRNA *ptr);
void CurveProfile_preset_set(PointerRNA *ptr, int value);

bool CurveProfile_use_sample_even_lengths_get(PointerRNA *ptr);
void CurveProfile_use_sample_even_lengths_set(PointerRNA *ptr, bool value);

bool CurveProfile_use_sample_straight_edges_get(PointerRNA *ptr);
void CurveProfile_use_sample_straight_edges_set(PointerRNA *ptr, bool value);

void CurveProfile_segments_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void CurveProfile_segments_next(CollectionPropertyIterator *iter);
void CurveProfile_segments_end(CollectionPropertyIterator *iter);
int CurveProfile_segments_length(PointerRNA *ptr);
bool CurveProfile_segments_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

void CurveProfile_update_func(struct CurveProfile *_self);
void CurveProfile_reset_view_func(struct CurveProfile *_self);
void CurveProfile_initialize_func(struct CurveProfile *_self, int totsegments);
void CurveProfile_evaluate_func(struct CurveProfile *_self, ReportList *reports, float length_portion, float location[2]);
/**************** CurveProfilePoint ****************/

extern StructRNA RNA_CurveProfilePoint;

PointerRNA CurveProfilePoint_rna_type_get(PointerRNA *ptr);

enum {
	CurveProfilePoint_handle_type_1_AUTO = 1,
	CurveProfilePoint_handle_type_1_VECTOR = 2,
	CurveProfilePoint_handle_type_1_FREE = 0,
	CurveProfilePoint_handle_type_1_ALIGN = 3,
};

int CurveProfilePoint_handle_type_1_get(PointerRNA *ptr);
void CurveProfilePoint_handle_type_1_set(PointerRNA *ptr, int value);

void CurveProfilePoint_location_get(PointerRNA *ptr, float values[2]);
void CurveProfilePoint_location_set(PointerRNA *ptr, const float values[2]);

enum {
	CurveProfilePoint_handle_type_2_AUTO = 1,
	CurveProfilePoint_handle_type_2_VECTOR = 2,
	CurveProfilePoint_handle_type_2_FREE = 0,
	CurveProfilePoint_handle_type_2_ALIGN = 3,
};

int CurveProfilePoint_handle_type_2_get(PointerRNA *ptr);
void CurveProfilePoint_handle_type_2_set(PointerRNA *ptr, int value);

bool CurveProfilePoint_select_get(PointerRNA *ptr);
void CurveProfilePoint_select_set(PointerRNA *ptr, bool value);

/**************** Profile Point ****************/

extern StructRNA RNA_CurveProfilePoints;

PointerRNA CurveProfilePoints_rna_type_get(PointerRNA *ptr);

struct CurveProfilePoint *CurveProfilePoints_add_func(struct CurveProfile *_self, float x, float y);
void CurveProfilePoints_remove_func(struct CurveProfile *_self, ReportList *reports, struct PointerRNA *point);
/**************** Curve Slice ****************/

extern StructRNA RNA_CurveSlice;

PointerRNA CurveSlice_rna_type_get(PointerRNA *ptr);

int CurveSlice_first_point_index_get(PointerRNA *ptr);
void CurveSlice_first_point_index_set(PointerRNA *ptr, int value);

int CurveSlice_index_get(PointerRNA *ptr);
void CurveSlice_index_set(PointerRNA *ptr, int value);

int CurveSlice_points_length_get(PointerRNA *ptr);
void CurveSlice_points_length_set(PointerRNA *ptr, int value);

void CurveSlice_points_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void CurveSlice_points_next(CollectionPropertyIterator *iter);
void CurveSlice_points_end(CollectionPropertyIterator *iter);
int CurveSlice_points_length(PointerRNA *ptr);

/**************** Curve Splines ****************/

extern StructRNA RNA_CurveSplines;

PointerRNA CurveSplines_rna_type_get(PointerRNA *ptr);

PointerRNA CurveSplines_active_get(PointerRNA *ptr);

struct Nurb *CurveSplines_new_func(struct Curve *_self, int type);
void CurveSplines_remove_func(struct Curve *_self, ReportList *reports, struct PointerRNA *spline);
void CurveSplines_clear_func(struct Curve *_self);
/**************** Hair Curves ****************/

extern StructRNA RNA_Curves;
extern StructRNA RNA_ID;

PointerRNA Curves_animation_data_get(PointerRNA *ptr);

void Curves_attributes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Curves_attributes_next(CollectionPropertyIterator *iter);
void Curves_attributes_end(CollectionPropertyIterator *iter);
int Curves_attributes_length(PointerRNA *ptr);
bool Curves_attributes_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

float Curves_surface_collision_distance_get(PointerRNA *ptr);
void Curves_surface_collision_distance_set(PointerRNA *ptr, float value);

void Curves_color_attributes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Curves_color_attributes_next(CollectionPropertyIterator *iter);
void Curves_color_attributes_end(CollectionPropertyIterator *iter);
int Curves_color_attributes_length(PointerRNA *ptr);

void Curves_curves_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Curves_curves_next(CollectionPropertyIterator *iter);
void Curves_curves_end(CollectionPropertyIterator *iter);
int Curves_curves_length(PointerRNA *ptr);
bool Curves_curves_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

void Curves_materials_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Curves_materials_next(CollectionPropertyIterator *iter);
void Curves_materials_end(CollectionPropertyIterator *iter);
int Curves_materials_length(PointerRNA *ptr);
bool Curves_materials_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Curves_materials_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void Curves_normals_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Curves_normals_next(CollectionPropertyIterator *iter);
void Curves_normals_end(CollectionPropertyIterator *iter);
int Curves_normals_length(PointerRNA *ptr);

void Curves_points_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Curves_points_next(CollectionPropertyIterator *iter);
void Curves_points_end(CollectionPropertyIterator *iter);
int Curves_points_length(PointerRNA *ptr);
bool Curves_points_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

enum {
	Curves_selection_domain_POINT = 0,
	Curves_selection_domain_CURVE = 4,
};

int Curves_selection_domain_get(PointerRNA *ptr);
void Curves_selection_domain_set(PointerRNA *ptr, int value);

PointerRNA Curves_surface_get(PointerRNA *ptr);

void Curves_surface_uv_map_get(PointerRNA *ptr, char *value);
int Curves_surface_uv_map_length(PointerRNA *ptr);
void Curves_surface_uv_map_set(PointerRNA *ptr, const char *value);

bool Curves_use_sculpt_collision_get(PointerRNA *ptr);
void Curves_use_sculpt_collision_set(PointerRNA *ptr, bool value);

bool Curves_use_mirror_x_get(PointerRNA *ptr);
void Curves_use_mirror_x_set(PointerRNA *ptr, bool value);

bool Curves_use_mirror_y_get(PointerRNA *ptr);
void Curves_use_mirror_y_set(PointerRNA *ptr, bool value);

bool Curves_use_mirror_z_get(PointerRNA *ptr);
void Curves_use_mirror_z_set(PointerRNA *ptr, bool value);

void Curves_curve_offset_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Curves_curve_offset_data_next(CollectionPropertyIterator *iter);
void Curves_curve_offset_data_end(CollectionPropertyIterator *iter);
int Curves_curve_offset_data_length(PointerRNA *ptr);
bool Curves_curve_offset_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

void Curves_position_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Curves_position_data_next(CollectionPropertyIterator *iter);
void Curves_position_data_end(CollectionPropertyIterator *iter);
int Curves_position_data_length(PointerRNA *ptr);
bool Curves_position_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

void Curves_add_curves_func(struct Curves *_self, ReportList *reports, int sizes_num, int *sizes);
void Curves_remove_curves_func(struct Curves *_self, ReportList *reports, int indices_num, int *indices);
void Curves_resize_curves_func(struct Curves *_self, ReportList *reports, int sizes_num, int *sizes, int indices_num, int *indices);
void Curves_reorder_curves_func(struct Curves *_self, ReportList *reports, int new_indices_num, int *new_indices);
void Curves_set_types_func(struct Curves *_self, ReportList *reports, int type, int indices_num, int *indices);
const char * Curves_unit_test_compare_func(struct Curves *_self, struct Curves *curves, float threshold);
/**************** CurvesModifier ****************/

extern StructRNA RNA_CurvesModifier;
extern StructRNA RNA_StripModifier;

PointerRNA CurvesModifier_curve_mapping_get(PointerRNA *ptr);

/**************** Curves Sculpt Paint ****************/

extern StructRNA RNA_CurvesSculpt;
extern StructRNA RNA_Paint;

/**************** Damped Track Constraint ****************/

extern StructRNA RNA_DampedTrackConstraint;
extern StructRNA RNA_Constraint;

bool DampedTrackConstraint_use_bbone_shape_get(PointerRNA *ptr);
void DampedTrackConstraint_use_bbone_shape_set(PointerRNA *ptr, bool value);

float DampedTrackConstraint_head_tail_get(PointerRNA *ptr);
void DampedTrackConstraint_head_tail_set(PointerRNA *ptr, float value);

#define DampedTrackConstraint_subtarget_MAX 64

void DampedTrackConstraint_subtarget_get(PointerRNA *ptr, char *value);
int DampedTrackConstraint_subtarget_length(PointerRNA *ptr);
void DampedTrackConstraint_subtarget_set(PointerRNA *ptr, const char *value);

PointerRNA DampedTrackConstraint_target_get(PointerRNA *ptr);

enum {
	DampedTrackConstraint_track_axis_TRACK_X = 0,
	DampedTrackConstraint_track_axis_TRACK_Y = 1,
	DampedTrackConstraint_track_axis_TRACK_Z = 2,
	DampedTrackConstraint_track_axis_TRACK_NEGATIVE_X = 3,
	DampedTrackConstraint_track_axis_TRACK_NEGATIVE_Y = 4,
	DampedTrackConstraint_track_axis_TRACK_NEGATIVE_Z = 5,
};

int DampedTrackConstraint_track_axis_get(PointerRNA *ptr);
void DampedTrackConstraint_track_axis_set(PointerRNA *ptr, int value);

/**************** Data Transfer Modifier ****************/

extern StructRNA RNA_DataTransferModifier;
extern StructRNA RNA_Modifier;

enum {
	DataTransferModifier_layers_vgroup_select_dst_ACTIVE = -1,
	DataTransferModifier_layers_vgroup_select_dst_NAME = -2,
	DataTransferModifier_layers_vgroup_select_dst_INDEX = -3,
};

int DataTransferModifier_layers_vgroup_select_dst_get(PointerRNA *ptr);
void DataTransferModifier_layers_vgroup_select_dst_set(PointerRNA *ptr, int value);

enum {
	DataTransferModifier_layers_vcol_vert_select_dst_ACTIVE = -1,
	DataTransferModifier_layers_vcol_vert_select_dst_NAME = -2,
	DataTransferModifier_layers_vcol_vert_select_dst_INDEX = -3,
};

int DataTransferModifier_layers_vcol_vert_select_dst_get(PointerRNA *ptr);
void DataTransferModifier_layers_vcol_vert_select_dst_set(PointerRNA *ptr, int value);

enum {
	DataTransferModifier_layers_vcol_loop_select_dst_ACTIVE = -1,
	DataTransferModifier_layers_vcol_loop_select_dst_NAME = -2,
	DataTransferModifier_layers_vcol_loop_select_dst_INDEX = -3,
};

int DataTransferModifier_layers_vcol_loop_select_dst_get(PointerRNA *ptr);
void DataTransferModifier_layers_vcol_loop_select_dst_set(PointerRNA *ptr, int value);

enum {
	DataTransferModifier_layers_uv_select_dst_ACTIVE = -1,
	DataTransferModifier_layers_uv_select_dst_NAME = -2,
	DataTransferModifier_layers_uv_select_dst_INDEX = -3,
};

int DataTransferModifier_layers_uv_select_dst_get(PointerRNA *ptr);
void DataTransferModifier_layers_uv_select_dst_set(PointerRNA *ptr, int value);

bool DataTransferModifier_use_edge_data_get(PointerRNA *ptr);
void DataTransferModifier_use_edge_data_set(PointerRNA *ptr, bool value);

enum {
	DataTransferModifier_data_types_edges_SHARP_EDGE = 256,
	DataTransferModifier_data_types_edges_SEAM = 512,
	DataTransferModifier_data_types_edges_CREASE = 1024,
	DataTransferModifier_data_types_edges_BEVEL_WEIGHT_EDGE = 2048,
	DataTransferModifier_data_types_edges_FREESTYLE_EDGE = 4096,
};

int DataTransferModifier_data_types_edges_get(PointerRNA *ptr);
void DataTransferModifier_data_types_edges_set(PointerRNA *ptr, int value);

enum {
	DataTransferModifier_edge_mapping_TOPOLOGY = 251658240,
	DataTransferModifier_edge_mapping_VERT_NEAREST = 33554704,
	DataTransferModifier_edge_mapping_NEAREST = 33554720,
	DataTransferModifier_edge_mapping_POLY_NEAREST = 33554816,
	DataTransferModifier_edge_mapping_EDGEINTERP_VNORPROJ = 33555984,
};

int DataTransferModifier_edge_mapping_get(PointerRNA *ptr);
void DataTransferModifier_edge_mapping_set(PointerRNA *ptr, int value);

bool DataTransferModifier_use_loop_data_get(PointerRNA *ptr);
void DataTransferModifier_use_loop_data_set(PointerRNA *ptr, bool value);

enum {
	DataTransferModifier_data_types_loops_CUSTOM_NORMAL = 131072,
	DataTransferModifier_data_types_loops_COLOR_CORNER = 805306368,
	DataTransferModifier_data_types_loops_UV = 16777216,
};

int DataTransferModifier_data_types_loops_get(PointerRNA *ptr);
void DataTransferModifier_data_types_loops_set(PointerRNA *ptr, int value);

enum {
	DataTransferModifier_loop_mapping_TOPOLOGY = 251658240,
	DataTransferModifier_loop_mapping_NEAREST_NORMAL = 67111248,
	DataTransferModifier_loop_mapping_NEAREST_POLYNOR = 67111312,
	DataTransferModifier_loop_mapping_NEAREST_POLY = 67109248,
	DataTransferModifier_loop_mapping_POLYINTERP_NEAREST = 67110272,
	DataTransferModifier_loop_mapping_POLYINTERP_LNORPROJ = 67110528,
};

int DataTransferModifier_loop_mapping_get(PointerRNA *ptr);
void DataTransferModifier_loop_mapping_set(PointerRNA *ptr, int value);

bool DataTransferModifier_use_poly_data_get(PointerRNA *ptr);
void DataTransferModifier_use_poly_data_set(PointerRNA *ptr, bool value);

enum {
	DataTransferModifier_poly_mapping_TOPOLOGY = 251658240,
	DataTransferModifier_poly_mapping_NEAREST = 134218112,
	DataTransferModifier_poly_mapping_NORMAL = 134219904,
	DataTransferModifier_poly_mapping_POLYINTERP_PNORPROJ = 134219392,
};

int DataTransferModifier_poly_mapping_get(PointerRNA *ptr);
void DataTransferModifier_poly_mapping_set(PointerRNA *ptr, int value);

bool DataTransferModifier_invert_vertex_group_get(PointerRNA *ptr);
void DataTransferModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

float DataTransferModifier_islands_precision_get(PointerRNA *ptr);
void DataTransferModifier_islands_precision_set(PointerRNA *ptr, float value);

float DataTransferModifier_max_distance_get(PointerRNA *ptr);
void DataTransferModifier_max_distance_set(PointerRNA *ptr, float value);

float DataTransferModifier_mix_factor_get(PointerRNA *ptr);
void DataTransferModifier_mix_factor_set(PointerRNA *ptr, float value);

enum {
	DataTransferModifier_mix_mode_REPLACE = 0,
	DataTransferModifier_mix_mode_ABOVE_THRESHOLD = 1,
	DataTransferModifier_mix_mode_BELOW_THRESHOLD = 2,
	DataTransferModifier_mix_mode_MIX = 16,
	DataTransferModifier_mix_mode_ADD = 17,
	DataTransferModifier_mix_mode_SUB = 18,
	DataTransferModifier_mix_mode_MUL = 19,
};

int DataTransferModifier_mix_mode_get(PointerRNA *ptr);
void DataTransferModifier_mix_mode_set(PointerRNA *ptr, int value);

bool DataTransferModifier_use_object_transform_get(PointerRNA *ptr);
void DataTransferModifier_use_object_transform_set(PointerRNA *ptr, bool value);

bool DataTransferModifier_use_max_distance_get(PointerRNA *ptr);
void DataTransferModifier_use_max_distance_set(PointerRNA *ptr, bool value);

enum {
	DataTransferModifier_data_types_polys_SMOOTH = 33554432,
	DataTransferModifier_data_types_polys_FREESTYLE_FACE = 67108864,
};

int DataTransferModifier_data_types_polys_get(PointerRNA *ptr);
void DataTransferModifier_data_types_polys_set(PointerRNA *ptr, int value);

float DataTransferModifier_ray_radius_get(PointerRNA *ptr);
void DataTransferModifier_ray_radius_set(PointerRNA *ptr, float value);

enum {
	DataTransferModifier_layers_vgroup_select_src_ACTIVE = -1,
	DataTransferModifier_layers_vgroup_select_src_ALL = -2,
	DataTransferModifier_layers_vgroup_select_src_BONE_SELECT = -257,
	DataTransferModifier_layers_vgroup_select_src_BONE_DEFORM = -258,
};

int DataTransferModifier_layers_vgroup_select_src_get(PointerRNA *ptr);
void DataTransferModifier_layers_vgroup_select_src_set(PointerRNA *ptr, int value);

enum {
	DataTransferModifier_layers_vcol_vert_select_src_ACTIVE = -1,
	DataTransferModifier_layers_vcol_vert_select_src_ALL = -2,
	DataTransferModifier_layers_vcol_vert_select_src_BONE_SELECT = -257,
	DataTransferModifier_layers_vcol_vert_select_src_BONE_DEFORM = -258,
};

int DataTransferModifier_layers_vcol_vert_select_src_get(PointerRNA *ptr);
void DataTransferModifier_layers_vcol_vert_select_src_set(PointerRNA *ptr, int value);

enum {
	DataTransferModifier_layers_vcol_loop_select_src_ACTIVE = -1,
	DataTransferModifier_layers_vcol_loop_select_src_ALL = -2,
	DataTransferModifier_layers_vcol_loop_select_src_BONE_SELECT = -257,
	DataTransferModifier_layers_vcol_loop_select_src_BONE_DEFORM = -258,
};

int DataTransferModifier_layers_vcol_loop_select_src_get(PointerRNA *ptr);
void DataTransferModifier_layers_vcol_loop_select_src_set(PointerRNA *ptr, int value);

enum {
	DataTransferModifier_layers_uv_select_src_ACTIVE = -1,
	DataTransferModifier_layers_uv_select_src_ALL = -2,
	DataTransferModifier_layers_uv_select_src_BONE_SELECT = -257,
	DataTransferModifier_layers_uv_select_src_BONE_DEFORM = -258,
};

int DataTransferModifier_layers_uv_select_src_get(PointerRNA *ptr);
void DataTransferModifier_layers_uv_select_src_set(PointerRNA *ptr, int value);

PointerRNA DataTransferModifier_object_get(PointerRNA *ptr);

bool DataTransferModifier_use_vert_data_get(PointerRNA *ptr);
void DataTransferModifier_use_vert_data_set(PointerRNA *ptr, bool value);

enum {
	DataTransferModifier_data_types_verts_VGROUP_WEIGHTS = 1,
	DataTransferModifier_data_types_verts_BEVEL_WEIGHT_VERT = 8,
	DataTransferModifier_data_types_verts_COLOR_VERTEX = 134283264,
};

int DataTransferModifier_data_types_verts_get(PointerRNA *ptr);
void DataTransferModifier_data_types_verts_set(PointerRNA *ptr, int value);

#define DataTransferModifier_vertex_group_MAX 64

void DataTransferModifier_vertex_group_get(PointerRNA *ptr, char *value);
int DataTransferModifier_vertex_group_length(PointerRNA *ptr);
void DataTransferModifier_vertex_group_set(PointerRNA *ptr, const char *value);

enum {
	DataTransferModifier_vert_mapping_TOPOLOGY = 251658240,
	DataTransferModifier_vert_mapping_NEAREST = 16777488,
	DataTransferModifier_vert_mapping_EDGE_NEAREST = 16777504,
	DataTransferModifier_vert_mapping_EDGEINTERP_NEAREST = 16778528,
	DataTransferModifier_vert_mapping_POLY_NEAREST = 16777600,
	DataTransferModifier_vert_mapping_POLYINTERP_NEAREST = 16778624,
	DataTransferModifier_vert_mapping_POLYINTERP_VNORPROJ = 16778880,
};

int DataTransferModifier_vert_mapping_get(PointerRNA *ptr);
void DataTransferModifier_vert_mapping_set(PointerRNA *ptr, int value);

/**************** Decimate Modifier ****************/

extern StructRNA RNA_DecimateModifier;
extern StructRNA RNA_Modifier;

bool DecimateModifier_use_dissolve_boundaries_get(PointerRNA *ptr);
void DecimateModifier_use_dissolve_boundaries_set(PointerRNA *ptr, bool value);

float DecimateModifier_angle_limit_get(PointerRNA *ptr);
void DecimateModifier_angle_limit_set(PointerRNA *ptr, float value);

enum {
	DecimateModifier_symmetry_axis_X = 0,
	DecimateModifier_symmetry_axis_Y = 1,
	DecimateModifier_symmetry_axis_Z = 2,
};

int DecimateModifier_symmetry_axis_get(PointerRNA *ptr);
void DecimateModifier_symmetry_axis_set(PointerRNA *ptr, int value);

enum {
	DecimateModifier_delimit_NORMAL = 1,
	DecimateModifier_delimit_MATERIAL = 2,
	DecimateModifier_delimit_SEAM = 4,
	DecimateModifier_delimit_SHARP = 8,
	DecimateModifier_delimit_UV = 16,
};

int DecimateModifier_delimit_get(PointerRNA *ptr);
void DecimateModifier_delimit_set(PointerRNA *ptr, int value);

int DecimateModifier_face_count_get(PointerRNA *ptr);
void DecimateModifier_face_count_set(PointerRNA *ptr, int value);

float DecimateModifier_vertex_group_factor_get(PointerRNA *ptr);
void DecimateModifier_vertex_group_factor_set(PointerRNA *ptr, float value);

bool DecimateModifier_invert_vertex_group_get(PointerRNA *ptr);
void DecimateModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

int DecimateModifier_iterations_get(PointerRNA *ptr);
void DecimateModifier_iterations_set(PointerRNA *ptr, int value);

enum {
	DecimateModifier_decimate_type_COLLAPSE = 0,
	DecimateModifier_decimate_type_UNSUBDIV = 1,
	DecimateModifier_decimate_type_DISSOLVE = 2,
};

int DecimateModifier_decimate_type_get(PointerRNA *ptr);
void DecimateModifier_decimate_type_set(PointerRNA *ptr, int value);

float DecimateModifier_ratio_get(PointerRNA *ptr);
void DecimateModifier_ratio_set(PointerRNA *ptr, float value);

bool DecimateModifier_use_symmetry_get(PointerRNA *ptr);
void DecimateModifier_use_symmetry_set(PointerRNA *ptr, bool value);

bool DecimateModifier_use_collapse_triangulate_get(PointerRNA *ptr);
void DecimateModifier_use_collapse_triangulate_set(PointerRNA *ptr, bool value);

#define DecimateModifier_vertex_group_MAX 64

void DecimateModifier_vertex_group_get(PointerRNA *ptr, char *value);
int DecimateModifier_vertex_group_length(PointerRNA *ptr);
void DecimateModifier_vertex_group_set(PointerRNA *ptr, const char *value);

/**************** Dependency Graph ****************/

extern StructRNA RNA_Depsgraph;

PointerRNA Depsgraph_rna_type_get(PointerRNA *ptr);

void Depsgraph_ids_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Depsgraph_ids_next(CollectionPropertyIterator *iter);
void Depsgraph_ids_end(CollectionPropertyIterator *iter);

enum {
	Depsgraph_mode_VIEWPORT = 0,
	Depsgraph_mode_RENDER = 1,
};

int Depsgraph_mode_get(PointerRNA *ptr);
void Depsgraph_mode_set(PointerRNA *ptr, int value);

void Depsgraph_object_instances_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Depsgraph_object_instances_next(CollectionPropertyIterator *iter);
void Depsgraph_object_instances_end(CollectionPropertyIterator *iter);

void Depsgraph_objects_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Depsgraph_objects_next(CollectionPropertyIterator *iter);
void Depsgraph_objects_end(CollectionPropertyIterator *iter);

PointerRNA Depsgraph_scene_get(PointerRNA *ptr);

PointerRNA Depsgraph_scene_eval_get(PointerRNA *ptr);

void Depsgraph_updates_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Depsgraph_updates_next(CollectionPropertyIterator *iter);
void Depsgraph_updates_end(CollectionPropertyIterator *iter);

PointerRNA Depsgraph_view_layer_get(PointerRNA *ptr);

PointerRNA Depsgraph_view_layer_eval_get(PointerRNA *ptr);

void Depsgraph_debug_relations_graphviz_func(struct Depsgraph *_self, const char * filepath, int *dot_graph_num, const char * *dot_graph);
void Depsgraph_debug_stats_gnuplot_func(struct Depsgraph *_self, const char * filepath, const char * output_filepath);
void Depsgraph_debug_tag_update_func(struct Depsgraph *_self);
void Depsgraph_debug_stats_func(struct Depsgraph *_self, char * result);
void Depsgraph_update_func(struct Depsgraph *_self, Main *bmain, ReportList *reports);
struct ID *Depsgraph_id_eval_get_func(struct Depsgraph *_self, struct ID *id);
bool Depsgraph_id_type_updated_func(struct Depsgraph *_self, int id_type);
/**************** Dependency Graph Object Instance ****************/

extern StructRNA RNA_DepsgraphObjectInstance;

PointerRNA DepsgraphObjectInstance_rna_type_get(PointerRNA *ptr);

void DepsgraphObjectInstance_orco_get(PointerRNA *ptr, float values[3]);
void DepsgraphObjectInstance_orco_set(PointerRNA *ptr, const float values[3]);

void DepsgraphObjectInstance_matrix_world_get(PointerRNA *ptr, float values[16]);
void DepsgraphObjectInstance_matrix_world_set(PointerRNA *ptr, const float values[16]);

PointerRNA DepsgraphObjectInstance_instance_object_get(PointerRNA *ptr);

int DepsgraphObjectInstance_random_id_get(PointerRNA *ptr);
void DepsgraphObjectInstance_random_id_set(PointerRNA *ptr, int value);

bool DepsgraphObjectInstance_is_instance_get(PointerRNA *ptr);
void DepsgraphObjectInstance_is_instance_set(PointerRNA *ptr, bool value);

PointerRNA DepsgraphObjectInstance_object_get(PointerRNA *ptr);

PointerRNA DepsgraphObjectInstance_parent_get(PointerRNA *ptr);

PointerRNA DepsgraphObjectInstance_particle_system_get(PointerRNA *ptr);

void DepsgraphObjectInstance_persistent_id_get(PointerRNA *ptr, int values[8]);
void DepsgraphObjectInstance_persistent_id_set(PointerRNA *ptr, const int values[8]);

bool DepsgraphObjectInstance_show_particles_get(PointerRNA *ptr);
void DepsgraphObjectInstance_show_particles_set(PointerRNA *ptr, bool value);

bool DepsgraphObjectInstance_show_self_get(PointerRNA *ptr);
void DepsgraphObjectInstance_show_self_set(PointerRNA *ptr, bool value);

void DepsgraphObjectInstance_uv_get(PointerRNA *ptr, float values[2]);
void DepsgraphObjectInstance_uv_set(PointerRNA *ptr, const float values[2]);

/**************** Dependency Graph Update ****************/

extern StructRNA RNA_DepsgraphUpdate;

PointerRNA DepsgraphUpdate_rna_type_get(PointerRNA *ptr);

bool DepsgraphUpdate_is_updated_geometry_get(PointerRNA *ptr);
void DepsgraphUpdate_is_updated_geometry_set(PointerRNA *ptr, bool value);

PointerRNA DepsgraphUpdate_id_get(PointerRNA *ptr);

bool DepsgraphUpdate_is_updated_shading_get(PointerRNA *ptr);
void DepsgraphUpdate_is_updated_shading_set(PointerRNA *ptr, bool value);

bool DepsgraphUpdate_is_updated_transform_get(PointerRNA *ptr);
void DepsgraphUpdate_is_updated_transform_set(PointerRNA *ptr, bool value);

/**************** Displace Modifier ****************/

extern StructRNA RNA_DisplaceModifier;
extern StructRNA RNA_Modifier;

enum {
	DisplaceModifier_direction_X = 0,
	DisplaceModifier_direction_Y = 1,
	DisplaceModifier_direction_Z = 2,
	DisplaceModifier_direction_NORMAL = 3,
	DisplaceModifier_direction_CUSTOM_NORMAL = 5,
	DisplaceModifier_direction_RGB_TO_XYZ = 4,
};

int DisplaceModifier_direction_get(PointerRNA *ptr);
void DisplaceModifier_direction_set(PointerRNA *ptr, int value);

bool DisplaceModifier_invert_vertex_group_get(PointerRNA *ptr);
void DisplaceModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

float DisplaceModifier_mid_level_get(PointerRNA *ptr);
void DisplaceModifier_mid_level_set(PointerRNA *ptr, float value);

enum {
	DisplaceModifier_space_LOCAL = 0,
	DisplaceModifier_space_GLOBAL = 1,
};

int DisplaceModifier_space_get(PointerRNA *ptr);
void DisplaceModifier_space_set(PointerRNA *ptr, int value);

float DisplaceModifier_strength_get(PointerRNA *ptr);
void DisplaceModifier_strength_set(PointerRNA *ptr, float value);

PointerRNA DisplaceModifier_texture_get(PointerRNA *ptr);

#define DisplaceModifier_texture_coords_bone_MAX 64

void DisplaceModifier_texture_coords_bone_get(PointerRNA *ptr, char *value);
int DisplaceModifier_texture_coords_bone_length(PointerRNA *ptr);
void DisplaceModifier_texture_coords_bone_set(PointerRNA *ptr, const char *value);

PointerRNA DisplaceModifier_texture_coords_object_get(PointerRNA *ptr);

enum {
	DisplaceModifier_texture_coords_LOCAL = 0,
	DisplaceModifier_texture_coords_GLOBAL = 1,
	DisplaceModifier_texture_coords_OBJECT = 2,
	DisplaceModifier_texture_coords_UV = 3,
};

int DisplaceModifier_texture_coords_get(PointerRNA *ptr);
void DisplaceModifier_texture_coords_set(PointerRNA *ptr, int value);

#define DisplaceModifier_uv_layer_MAX 68

void DisplaceModifier_uv_layer_get(PointerRNA *ptr, char *value);
int DisplaceModifier_uv_layer_length(PointerRNA *ptr);
void DisplaceModifier_uv_layer_set(PointerRNA *ptr, const char *value);

#define DisplaceModifier_vertex_group_MAX 64

void DisplaceModifier_vertex_group_get(PointerRNA *ptr, char *value);
int DisplaceModifier_vertex_group_length(PointerRNA *ptr);
void DisplaceModifier_vertex_group_set(PointerRNA *ptr, const char *value);

/**************** Safe Areas ****************/

extern StructRNA RNA_DisplaySafeAreas;

PointerRNA DisplaySafeAreas_rna_type_get(PointerRNA *ptr);

void DisplaySafeAreas_action_get(PointerRNA *ptr, float values[2]);
void DisplaySafeAreas_action_set(PointerRNA *ptr, const float values[2]);

void DisplaySafeAreas_action_center_get(PointerRNA *ptr, float values[2]);
void DisplaySafeAreas_action_center_set(PointerRNA *ptr, const float values[2]);

void DisplaySafeAreas_title_center_get(PointerRNA *ptr, float values[2]);
void DisplaySafeAreas_title_center_set(PointerRNA *ptr, const float values[2]);

void DisplaySafeAreas_title_get(PointerRNA *ptr, float values[2]);
void DisplaySafeAreas_title_set(PointerRNA *ptr, const float values[2]);

/**************** Distorted Noise ****************/

extern StructRNA RNA_DistortedNoiseTexture;
extern StructRNA RNA_Texture;
extern StructRNA RNA_ID;

float DistortedNoiseTexture_distortion_get(PointerRNA *ptr);
void DistortedNoiseTexture_distortion_set(PointerRNA *ptr, float value);

float DistortedNoiseTexture_nabla_get(PointerRNA *ptr);
void DistortedNoiseTexture_nabla_set(PointerRNA *ptr, float value);

enum {
	DistortedNoiseTexture_noise_basis_BLENDER_ORIGINAL = 0,
	DistortedNoiseTexture_noise_basis_ORIGINAL_PERLIN = 1,
	DistortedNoiseTexture_noise_basis_IMPROVED_PERLIN = 2,
	DistortedNoiseTexture_noise_basis_VORONOI_F1 = 3,
	DistortedNoiseTexture_noise_basis_VORONOI_F2 = 4,
	DistortedNoiseTexture_noise_basis_VORONOI_F3 = 5,
	DistortedNoiseTexture_noise_basis_VORONOI_F4 = 6,
	DistortedNoiseTexture_noise_basis_VORONOI_F2_F1 = 7,
	DistortedNoiseTexture_noise_basis_VORONOI_CRACKLE = 8,
	DistortedNoiseTexture_noise_basis_CELL_NOISE = 14,
};

int DistortedNoiseTexture_noise_basis_get(PointerRNA *ptr);
void DistortedNoiseTexture_noise_basis_set(PointerRNA *ptr, int value);

enum {
	DistortedNoiseTexture_noise_distortion_BLENDER_ORIGINAL = 0,
	DistortedNoiseTexture_noise_distortion_ORIGINAL_PERLIN = 1,
	DistortedNoiseTexture_noise_distortion_IMPROVED_PERLIN = 2,
	DistortedNoiseTexture_noise_distortion_VORONOI_F1 = 3,
	DistortedNoiseTexture_noise_distortion_VORONOI_F2 = 4,
	DistortedNoiseTexture_noise_distortion_VORONOI_F3 = 5,
	DistortedNoiseTexture_noise_distortion_VORONOI_F4 = 6,
	DistortedNoiseTexture_noise_distortion_VORONOI_F2_F1 = 7,
	DistortedNoiseTexture_noise_distortion_VORONOI_CRACKLE = 8,
	DistortedNoiseTexture_noise_distortion_CELL_NOISE = 14,
};

int DistortedNoiseTexture_noise_distortion_get(PointerRNA *ptr);
void DistortedNoiseTexture_noise_distortion_set(PointerRNA *ptr, int value);

float DistortedNoiseTexture_noise_scale_get(PointerRNA *ptr);
void DistortedNoiseTexture_noise_scale_set(PointerRNA *ptr, float value);

/**************** Dope Sheet ****************/

extern StructRNA RNA_DopeSheet;

PointerRNA DopeSheet_rna_type_get(PointerRNA *ptr);

bool DopeSheet_show_expanded_summary_get(PointerRNA *ptr);
void DopeSheet_show_expanded_summary_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_armatures_get(PointerRNA *ptr);
void DopeSheet_show_armatures_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_cache_files_get(PointerRNA *ptr);
void DopeSheet_show_cache_files_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_cameras_get(PointerRNA *ptr);
void DopeSheet_show_cameras_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_curves_get(PointerRNA *ptr);
void DopeSheet_show_curves_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_gpencil_get(PointerRNA *ptr);
void DopeSheet_show_gpencil_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_hair_curves_get(PointerRNA *ptr);
void DopeSheet_show_hair_curves_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_lattices_get(PointerRNA *ptr);
void DopeSheet_show_lattices_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_lights_get(PointerRNA *ptr);
void DopeSheet_show_lights_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_lightprobes_get(PointerRNA *ptr);
void DopeSheet_show_lightprobes_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_linestyles_get(PointerRNA *ptr);
void DopeSheet_show_linestyles_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_materials_get(PointerRNA *ptr);
void DopeSheet_show_materials_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_meshes_get(PointerRNA *ptr);
void DopeSheet_show_meshes_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_metaballs_get(PointerRNA *ptr);
void DopeSheet_show_metaballs_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_modifiers_get(PointerRNA *ptr);
void DopeSheet_show_modifiers_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_movieclips_get(PointerRNA *ptr);
void DopeSheet_show_movieclips_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_nodes_get(PointerRNA *ptr);
void DopeSheet_show_nodes_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_particles_get(PointerRNA *ptr);
void DopeSheet_show_particles_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_pointclouds_get(PointerRNA *ptr);
void DopeSheet_show_pointclouds_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_scenes_get(PointerRNA *ptr);
void DopeSheet_show_scenes_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_shapekeys_get(PointerRNA *ptr);
void DopeSheet_show_shapekeys_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_speakers_get(PointerRNA *ptr);
void DopeSheet_show_speakers_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_summary_get(PointerRNA *ptr);
void DopeSheet_show_summary_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_textures_get(PointerRNA *ptr);
void DopeSheet_show_textures_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_transforms_get(PointerRNA *ptr);
void DopeSheet_show_transforms_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_volumes_get(PointerRNA *ptr);
void DopeSheet_show_volumes_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_worlds_get(PointerRNA *ptr);
void DopeSheet_show_worlds_set(PointerRNA *ptr, bool value);

#define DopeSheet_filter_fcurve_name_MAX 64

void DopeSheet_filter_fcurve_name_get(PointerRNA *ptr, char *value);
int DopeSheet_filter_fcurve_name_length(PointerRNA *ptr);
void DopeSheet_filter_fcurve_name_set(PointerRNA *ptr, const char *value);

PointerRNA DopeSheet_filter_collection_get(PointerRNA *ptr);

bool DopeSheet_show_missing_nla_get(PointerRNA *ptr);
void DopeSheet_show_missing_nla_set(PointerRNA *ptr, bool value);

bool DopeSheet_use_filter_invert_get(PointerRNA *ptr);
void DopeSheet_use_filter_invert_set(PointerRNA *ptr, bool value);

bool DopeSheet_use_multi_word_filter_get(PointerRNA *ptr);
void DopeSheet_use_multi_word_filter_set(PointerRNA *ptr, bool value);

#define DopeSheet_filter_text_MAX 64

void DopeSheet_filter_text_get(PointerRNA *ptr, char *value);
int DopeSheet_filter_text_length(PointerRNA *ptr);
void DopeSheet_filter_text_set(PointerRNA *ptr, const char *value);

bool DopeSheet_show_only_errors_get(PointerRNA *ptr);
void DopeSheet_show_only_errors_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_only_selected_get(PointerRNA *ptr);
void DopeSheet_show_only_selected_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_only_slot_of_active_object_get(PointerRNA *ptr);
void DopeSheet_show_only_slot_of_active_object_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_datablock_filters_get(PointerRNA *ptr);
void DopeSheet_show_datablock_filters_set(PointerRNA *ptr, bool value);

bool DopeSheet_show_hidden_get(PointerRNA *ptr);
void DopeSheet_show_hidden_set(PointerRNA *ptr, bool value);

bool DopeSheet_use_datablock_sort_get(PointerRNA *ptr);
void DopeSheet_use_datablock_sort_set(PointerRNA *ptr, bool value);

PointerRNA DopeSheet_source_get(PointerRNA *ptr);

bool DopeSheet_show_driver_fallback_as_error_get(PointerRNA *ptr);
void DopeSheet_show_driver_fallback_as_error_set(PointerRNA *ptr, bool value);

/**************** Driver ****************/

extern StructRNA RNA_Driver;

PointerRNA Driver_rna_type_get(PointerRNA *ptr);

#define Driver_expression_MAX 256

void Driver_expression_get(PointerRNA *ptr, char *value);
int Driver_expression_length(PointerRNA *ptr);
void Driver_expression_set(PointerRNA *ptr, const char *value);

bool Driver_is_valid_get(PointerRNA *ptr);
void Driver_is_valid_set(PointerRNA *ptr, bool value);

bool Driver_is_simple_expression_get(PointerRNA *ptr);
void Driver_is_simple_expression_set(PointerRNA *ptr, bool value);

enum {
	Driver_type_AVERAGE = 0,
	Driver_type_SUM = 2,
	Driver_type_SCRIPTED = 1,
	Driver_type_MIN = 3,
	Driver_type_MAX = 4,
};

int Driver_type_get(PointerRNA *ptr);
void Driver_type_set(PointerRNA *ptr, int value);

bool Driver_use_self_get(PointerRNA *ptr);
void Driver_use_self_set(PointerRNA *ptr, bool value);

void Driver_variables_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Driver_variables_next(CollectionPropertyIterator *iter);
void Driver_variables_end(CollectionPropertyIterator *iter);
bool Driver_variables_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Driver_variables_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

/**************** Driver Target ****************/

extern StructRNA RNA_DriverTarget;

PointerRNA DriverTarget_rna_type_get(PointerRNA *ptr);

#define DriverTarget_bone_target_MAX 64

void DriverTarget_bone_target_get(PointerRNA *ptr, char *value);
int DriverTarget_bone_target_length(PointerRNA *ptr);
void DriverTarget_bone_target_set(PointerRNA *ptr, const char *value);

enum {
	DriverTarget_context_property_ACTIVE_SCENE = 0,
	DriverTarget_context_property_ACTIVE_VIEW_LAYER = 1,
};

int DriverTarget_context_property_get(PointerRNA *ptr);
void DriverTarget_context_property_set(PointerRNA *ptr, int value);

void DriverTarget_data_path_get(PointerRNA *ptr, char *value);
int DriverTarget_data_path_length(PointerRNA *ptr);
void DriverTarget_data_path_set(PointerRNA *ptr, const char *value);

float DriverTarget_fallback_value_get(PointerRNA *ptr);
void DriverTarget_fallback_value_set(PointerRNA *ptr, float value);

PointerRNA DriverTarget_id_get(PointerRNA *ptr);

enum {
	DriverTarget_id_type_ACTION = 17217,
	DriverTarget_id_type_ARMATURE = 21057,
	DriverTarget_id_type_BRUSH = 21058,
	DriverTarget_id_type_CACHEFILE = 17987,
	DriverTarget_id_type_CAMERA = 16707,
	DriverTarget_id_type_COLLECTION = 21063,
	DriverTarget_id_type_CURVE = 21827,
	DriverTarget_id_type_CURVES = 22083,
	DriverTarget_id_type_FONT = 18006,
	DriverTarget_id_type_GREASEPENCIL = 17479,
	DriverTarget_id_type_GREASEPENCIL_V3 = 20551,
	DriverTarget_id_type_IMAGE = 19785,
	DriverTarget_id_type_KEY = 17739,
	DriverTarget_id_type_LATTICE = 21580,
	DriverTarget_id_type_LIBRARY = 18764,
	DriverTarget_id_type_LIGHT = 16716,
	DriverTarget_id_type_LIGHT_PROBE = 20556,
	DriverTarget_id_type_LINESTYLE = 21324,
	DriverTarget_id_type_MASK = 21325,
	DriverTarget_id_type_MATERIAL = 16717,
	DriverTarget_id_type_MESH = 17741,
	DriverTarget_id_type_META = 16973,
	DriverTarget_id_type_MOVIECLIP = 17229,
	DriverTarget_id_type_NODETREE = 21582,
	DriverTarget_id_type_OBJECT = 16975,
	DriverTarget_id_type_PAINTCURVE = 17232,
	DriverTarget_id_type_PALETTE = 19536,
	DriverTarget_id_type_PARTICLE = 16720,
	DriverTarget_id_type_POINTCLOUD = 21584,
	DriverTarget_id_type_SCENE = 17235,
	DriverTarget_id_type_SCREEN = 21075,
	DriverTarget_id_type_SOUND = 20307,
	DriverTarget_id_type_SPEAKER = 19283,
	DriverTarget_id_type_TEXT = 22612,
	DriverTarget_id_type_TEXTURE = 17748,
	DriverTarget_id_type_VOLUME = 20310,
	DriverTarget_id_type_WINDOWMANAGER = 19799,
	DriverTarget_id_type_WORKSPACE = 21335,
	DriverTarget_id_type_WORLD = 20311,
};

int DriverTarget_id_type_get(PointerRNA *ptr);
void DriverTarget_id_type_set(PointerRNA *ptr, int value);

bool DriverTarget_is_fallback_used_get(PointerRNA *ptr);
void DriverTarget_is_fallback_used_set(PointerRNA *ptr, bool value);

enum {
	DriverTarget_rotation_mode_AUTO = 0,
	DriverTarget_rotation_mode_XYZ = 1,
	DriverTarget_rotation_mode_XZY = 2,
	DriverTarget_rotation_mode_YXZ = 3,
	DriverTarget_rotation_mode_YZX = 4,
	DriverTarget_rotation_mode_ZXY = 5,
	DriverTarget_rotation_mode_ZYX = 6,
	DriverTarget_rotation_mode_QUATERNION = 7,
	DriverTarget_rotation_mode_SWING_TWIST_X = 8,
	DriverTarget_rotation_mode_SWING_TWIST_Y = 9,
	DriverTarget_rotation_mode_SWING_TWIST_Z = 10,
};

int DriverTarget_rotation_mode_get(PointerRNA *ptr);
void DriverTarget_rotation_mode_set(PointerRNA *ptr, int value);

enum {
	DriverTarget_transform_space_WORLD_SPACE = 0,
	DriverTarget_transform_space_TRANSFORM_SPACE = 4,
	DriverTarget_transform_space_LOCAL_SPACE = 12,
};

int DriverTarget_transform_space_get(PointerRNA *ptr);
void DriverTarget_transform_space_set(PointerRNA *ptr, int value);

enum {
	DriverTarget_transform_type_LOC_X = 0,
	DriverTarget_transform_type_LOC_Y = 1,
	DriverTarget_transform_type_LOC_Z = 2,
	DriverTarget_transform_type_ROT_X = 3,
	DriverTarget_transform_type_ROT_Y = 4,
	DriverTarget_transform_type_ROT_Z = 5,
	DriverTarget_transform_type_ROT_W = 10,
	DriverTarget_transform_type_SCALE_X = 6,
	DriverTarget_transform_type_SCALE_Y = 7,
	DriverTarget_transform_type_SCALE_Z = 8,
	DriverTarget_transform_type_SCALE_AVG = 9,
};

int DriverTarget_transform_type_get(PointerRNA *ptr);
void DriverTarget_transform_type_set(PointerRNA *ptr, int value);

bool DriverTarget_use_fallback_value_get(PointerRNA *ptr);
void DriverTarget_use_fallback_value_set(PointerRNA *ptr, bool value);

/**************** Driver Variable ****************/

extern StructRNA RNA_DriverVariable;

PointerRNA DriverVariable_rna_type_get(PointerRNA *ptr);

#define DriverVariable_name_MAX 64

void DriverVariable_name_get(PointerRNA *ptr, char *value);
int DriverVariable_name_length(PointerRNA *ptr);
void DriverVariable_name_set(PointerRNA *ptr, const char *value);

bool DriverVariable_is_name_valid_get(PointerRNA *ptr);
void DriverVariable_is_name_valid_set(PointerRNA *ptr, bool value);

void DriverVariable_targets_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void DriverVariable_targets_next(CollectionPropertyIterator *iter);
void DriverVariable_targets_end(CollectionPropertyIterator *iter);
int DriverVariable_targets_length(PointerRNA *ptr);
bool DriverVariable_targets_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

enum {
	DriverVariable_type_SINGLE_PROP = 0,
	DriverVariable_type_TRANSFORMS = 3,
	DriverVariable_type_ROTATION_DIFF = 1,
	DriverVariable_type_LOC_DIFF = 2,
	DriverVariable_type_CONTEXT_PROP = 4,
};

int DriverVariable_type_get(PointerRNA *ptr);
void DriverVariable_type_set(PointerRNA *ptr, int value);

/**************** Brush Settings ****************/

extern StructRNA RNA_DynamicPaintBrushSettings;

PointerRNA DynamicPaintBrushSettings_rna_type_get(PointerRNA *ptr);

bool DynamicPaintBrushSettings_use_absolute_alpha_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_use_absolute_alpha_set(PointerRNA *ptr, bool value);

float DynamicPaintBrushSettings_wave_clamp_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_wave_clamp_set(PointerRNA *ptr, float value);

bool DynamicPaintBrushSettings_use_smudge_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_use_smudge_set(PointerRNA *ptr, bool value);

bool DynamicPaintBrushSettings_use_paint_erase_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_use_paint_erase_set(PointerRNA *ptr, bool value);

float DynamicPaintBrushSettings_wave_factor_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_wave_factor_set(PointerRNA *ptr, float value);

enum {
	DynamicPaintBrushSettings_proximity_falloff_SMOOTH = 1,
	DynamicPaintBrushSettings_proximity_falloff_CONSTANT = 0,
	DynamicPaintBrushSettings_proximity_falloff_RAMP = 2,
};

int DynamicPaintBrushSettings_proximity_falloff_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_proximity_falloff_set(PointerRNA *ptr, int value);

bool DynamicPaintBrushSettings_invert_proximity_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_invert_proximity_set(PointerRNA *ptr, bool value);

float DynamicPaintBrushSettings_velocity_max_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_velocity_max_set(PointerRNA *ptr, float value);

bool DynamicPaintBrushSettings_use_velocity_alpha_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_use_velocity_alpha_set(PointerRNA *ptr, bool value);

bool DynamicPaintBrushSettings_use_velocity_depth_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_use_velocity_depth_set(PointerRNA *ptr, bool value);

bool DynamicPaintBrushSettings_use_negative_volume_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_use_negative_volume_set(PointerRNA *ptr, bool value);

bool DynamicPaintBrushSettings_use_proximity_ramp_alpha_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_use_proximity_ramp_alpha_set(PointerRNA *ptr, bool value);

float DynamicPaintBrushSettings_paint_alpha_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_paint_alpha_set(PointerRNA *ptr, float value);

void DynamicPaintBrushSettings_paint_color_get(PointerRNA *ptr, float values[3]);
void DynamicPaintBrushSettings_paint_color_set(PointerRNA *ptr, const float values[3]);

PointerRNA DynamicPaintBrushSettings_paint_ramp_get(PointerRNA *ptr);

enum {
	DynamicPaintBrushSettings_paint_source_PARTICLE_SYSTEM = 3,
	DynamicPaintBrushSettings_paint_source_POINT = 4,
	DynamicPaintBrushSettings_paint_source_DISTANCE = 1,
	DynamicPaintBrushSettings_paint_source_VOLUME_DISTANCE = 2,
	DynamicPaintBrushSettings_paint_source_VOLUME = 0,
};

int DynamicPaintBrushSettings_paint_source_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_paint_source_set(PointerRNA *ptr, int value);

float DynamicPaintBrushSettings_paint_wetness_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_paint_wetness_set(PointerRNA *ptr, float value);

PointerRNA DynamicPaintBrushSettings_particle_system_get(PointerRNA *ptr);

bool DynamicPaintBrushSettings_use_proximity_project_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_use_proximity_project_set(PointerRNA *ptr, bool value);

float DynamicPaintBrushSettings_paint_distance_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_paint_distance_set(PointerRNA *ptr, float value);

enum {
	DynamicPaintBrushSettings_ray_direction_CANVAS = 0,
	DynamicPaintBrushSettings_ray_direction_BRUSH = 1,
	DynamicPaintBrushSettings_ray_direction_Z_AXIS = 2,
};

int DynamicPaintBrushSettings_ray_direction_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_ray_direction_set(PointerRNA *ptr, int value);

bool DynamicPaintBrushSettings_use_velocity_color_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_use_velocity_color_set(PointerRNA *ptr, bool value);

float DynamicPaintBrushSettings_smooth_radius_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_smooth_radius_set(PointerRNA *ptr, float value);

float DynamicPaintBrushSettings_smudge_strength_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_smudge_strength_set(PointerRNA *ptr, float value);

float DynamicPaintBrushSettings_solid_radius_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_solid_radius_set(PointerRNA *ptr, float value);

bool DynamicPaintBrushSettings_use_particle_radius_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_use_particle_radius_set(PointerRNA *ptr, bool value);

PointerRNA DynamicPaintBrushSettings_velocity_ramp_get(PointerRNA *ptr);

enum {
	DynamicPaintBrushSettings_wave_type_CHANGE = 3,
	DynamicPaintBrushSettings_wave_type_DEPTH = 0,
	DynamicPaintBrushSettings_wave_type_FORCE = 1,
	DynamicPaintBrushSettings_wave_type_REFLECT = 2,
};

int DynamicPaintBrushSettings_wave_type_get(PointerRNA *ptr);
void DynamicPaintBrushSettings_wave_type_set(PointerRNA *ptr, int value);

/**************** Canvas Settings ****************/

extern StructRNA RNA_DynamicPaintCanvasSettings;

PointerRNA DynamicPaintCanvasSettings_rna_type_get(PointerRNA *ptr);

void DynamicPaintCanvasSettings_canvas_surfaces_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void DynamicPaintCanvasSettings_canvas_surfaces_next(CollectionPropertyIterator *iter);
void DynamicPaintCanvasSettings_canvas_surfaces_end(CollectionPropertyIterator *iter);

/**************** Dynamic Paint Modifier ****************/

extern StructRNA RNA_DynamicPaintModifier;
extern StructRNA RNA_Modifier;

PointerRNA DynamicPaintModifier_brush_settings_get(PointerRNA *ptr);

PointerRNA DynamicPaintModifier_canvas_settings_get(PointerRNA *ptr);

enum {
	DynamicPaintModifier_ui_type_CANVAS = 1,
	DynamicPaintModifier_ui_type_BRUSH = 2,
};

int DynamicPaintModifier_ui_type_get(PointerRNA *ptr);
void DynamicPaintModifier_ui_type_set(PointerRNA *ptr, int value);

/**************** Paint Surface ****************/

extern StructRNA RNA_DynamicPaintSurface;

PointerRNA DynamicPaintSurface_rna_type_get(PointerRNA *ptr);

#define DynamicPaintSurface_name_MAX 64

void DynamicPaintSurface_name_get(PointerRNA *ptr, char *value);
int DynamicPaintSurface_name_length(PointerRNA *ptr);
void DynamicPaintSurface_name_set(PointerRNA *ptr, const char *value);

float DynamicPaintSurface_drip_acceleration_get(PointerRNA *ptr);
void DynamicPaintSurface_drip_acceleration_set(PointerRNA *ptr, float value);

bool DynamicPaintSurface_use_antialiasing_get(PointerRNA *ptr);
void DynamicPaintSurface_use_antialiasing_set(PointerRNA *ptr, bool value);

PointerRNA DynamicPaintSurface_brush_collection_get(PointerRNA *ptr);

void DynamicPaintSurface_init_color_get(PointerRNA *ptr, float values[4]);
void DynamicPaintSurface_init_color_set(PointerRNA *ptr, const float values[4]);

float DynamicPaintSurface_color_dry_threshold_get(PointerRNA *ptr);
void DynamicPaintSurface_color_dry_threshold_set(PointerRNA *ptr, float value);

float DynamicPaintSurface_color_spread_speed_get(PointerRNA *ptr);
void DynamicPaintSurface_color_spread_speed_set(PointerRNA *ptr, float value);

float DynamicPaintSurface_wave_damping_get(PointerRNA *ptr);
void DynamicPaintSurface_wave_damping_set(PointerRNA *ptr, float value);

#define DynamicPaintSurface_init_layername_MAX 68

void DynamicPaintSurface_init_layername_get(PointerRNA *ptr, char *value);
int DynamicPaintSurface_init_layername_length(PointerRNA *ptr);
void DynamicPaintSurface_init_layername_set(PointerRNA *ptr, const char *value);

enum {
	DynamicPaintSurface_displace_type_DISPLACE = 0,
	DynamicPaintSurface_displace_type_DEPTH = 1,
};

int DynamicPaintSurface_displace_type_get(PointerRNA *ptr);
void DynamicPaintSurface_displace_type_set(PointerRNA *ptr, int value);

float DynamicPaintSurface_displace_factor_get(PointerRNA *ptr);
void DynamicPaintSurface_displace_factor_set(PointerRNA *ptr, float value);

bool DynamicPaintSurface_use_dissolve_get(PointerRNA *ptr);
void DynamicPaintSurface_use_dissolve_set(PointerRNA *ptr, bool value);

int DynamicPaintSurface_dissolve_speed_get(PointerRNA *ptr);
void DynamicPaintSurface_dissolve_speed_set(PointerRNA *ptr, int value);

bool DynamicPaintSurface_use_drying_get(PointerRNA *ptr);
void DynamicPaintSurface_use_drying_set(PointerRNA *ptr, bool value);

int DynamicPaintSurface_dry_speed_get(PointerRNA *ptr);
void DynamicPaintSurface_dry_speed_set(PointerRNA *ptr, int value);

enum {
	DynamicPaintSurface_effect_ui_SPREAD = 1,
	DynamicPaintSurface_effect_ui_DRIP = 2,
	DynamicPaintSurface_effect_ui_SHRINK = 3,
};

int DynamicPaintSurface_effect_ui_get(PointerRNA *ptr);
void DynamicPaintSurface_effect_ui_set(PointerRNA *ptr, int value);

PointerRNA DynamicPaintSurface_effector_weights_get(PointerRNA *ptr);

int DynamicPaintSurface_frame_end_get(PointerRNA *ptr);
void DynamicPaintSurface_frame_end_set(PointerRNA *ptr, int value);

enum {
	DynamicPaintSurface_image_fileformat_PNG = 0,
	DynamicPaintSurface_image_fileformat_OPENEXR = 1,
};

int DynamicPaintSurface_image_fileformat_get(PointerRNA *ptr);
void DynamicPaintSurface_image_fileformat_set(PointerRNA *ptr, int value);

enum {
	DynamicPaintSurface_surface_format_VERTEX = 1,
	DynamicPaintSurface_surface_format_IMAGE = 2,
};

int DynamicPaintSurface_surface_format_get(PointerRNA *ptr);
void DynamicPaintSurface_surface_format_set(PointerRNA *ptr, int value);

bool DynamicPaintSurface_use_incremental_displace_get(PointerRNA *ptr);
void DynamicPaintSurface_use_incremental_displace_set(PointerRNA *ptr, bool value);

float DynamicPaintSurface_brush_influence_scale_get(PointerRNA *ptr);
void DynamicPaintSurface_brush_influence_scale_set(PointerRNA *ptr, float value);

enum {
	DynamicPaintSurface_init_color_type_NONE = 0,
	DynamicPaintSurface_init_color_type_COLOR = 1,
	DynamicPaintSurface_init_color_type_TEXTURE = 2,
	DynamicPaintSurface_init_color_type_VERTEX_COLOR = 3,
};

int DynamicPaintSurface_init_color_type_get(PointerRNA *ptr);
void DynamicPaintSurface_init_color_type_set(PointerRNA *ptr, int value);

bool DynamicPaintSurface_is_active_get(PointerRNA *ptr);
void DynamicPaintSurface_is_active_set(PointerRNA *ptr, bool value);

float DynamicPaintSurface_depth_clamp_get(PointerRNA *ptr);
void DynamicPaintSurface_depth_clamp_set(PointerRNA *ptr, float value);

bool DynamicPaintSurface_use_wave_open_border_get(PointerRNA *ptr);
void DynamicPaintSurface_use_wave_open_border_set(PointerRNA *ptr, bool value);

#define DynamicPaintSurface_output_name_a_MAX 68

void DynamicPaintSurface_output_name_a_get(PointerRNA *ptr, char *value);
int DynamicPaintSurface_output_name_a_length(PointerRNA *ptr);
void DynamicPaintSurface_output_name_a_set(PointerRNA *ptr, const char *value);

#define DynamicPaintSurface_output_name_b_MAX 68

void DynamicPaintSurface_output_name_b_get(PointerRNA *ptr, char *value);
int DynamicPaintSurface_output_name_b_length(PointerRNA *ptr);
void DynamicPaintSurface_output_name_b_set(PointerRNA *ptr, const char *value);

#define DynamicPaintSurface_image_output_path_MAX 1024

void DynamicPaintSurface_image_output_path_get(PointerRNA *ptr, char *value);
int DynamicPaintSurface_image_output_path_length(PointerRNA *ptr);
void DynamicPaintSurface_image_output_path_set(PointerRNA *ptr, const char *value);

PointerRNA DynamicPaintSurface_point_cache_get(PointerRNA *ptr);

bool DynamicPaintSurface_use_premultiply_get(PointerRNA *ptr);
void DynamicPaintSurface_use_premultiply_set(PointerRNA *ptr, bool value);

float DynamicPaintSurface_brush_radius_scale_get(PointerRNA *ptr);
void DynamicPaintSurface_brush_radius_scale_set(PointerRNA *ptr, float value);

int DynamicPaintSurface_image_resolution_get(PointerRNA *ptr);
void DynamicPaintSurface_image_resolution_set(PointerRNA *ptr, int value);

float DynamicPaintSurface_shrink_speed_get(PointerRNA *ptr);
void DynamicPaintSurface_shrink_speed_set(PointerRNA *ptr, float value);

bool DynamicPaintSurface_use_dry_log_get(PointerRNA *ptr);
void DynamicPaintSurface_use_dry_log_set(PointerRNA *ptr, bool value);

bool DynamicPaintSurface_use_dissolve_log_get(PointerRNA *ptr);
void DynamicPaintSurface_use_dissolve_log_set(PointerRNA *ptr, bool value);

float DynamicPaintSurface_wave_smoothness_get(PointerRNA *ptr);
void DynamicPaintSurface_wave_smoothness_set(PointerRNA *ptr, float value);

float DynamicPaintSurface_wave_speed_get(PointerRNA *ptr);
void DynamicPaintSurface_wave_speed_set(PointerRNA *ptr, float value);

float DynamicPaintSurface_spread_speed_get(PointerRNA *ptr);
void DynamicPaintSurface_spread_speed_set(PointerRNA *ptr, float value);

float DynamicPaintSurface_wave_spring_get(PointerRNA *ptr);
void DynamicPaintSurface_wave_spring_set(PointerRNA *ptr, float value);

int DynamicPaintSurface_frame_start_get(PointerRNA *ptr);
void DynamicPaintSurface_frame_start_set(PointerRNA *ptr, int value);

int DynamicPaintSurface_frame_substeps_get(PointerRNA *ptr);
void DynamicPaintSurface_frame_substeps_set(PointerRNA *ptr, int value);

enum {
	DynamicPaintSurface_surface_type_PAINT = 0,
};

int DynamicPaintSurface_surface_type_get(PointerRNA *ptr);
void DynamicPaintSurface_surface_type_set(PointerRNA *ptr, int value);

PointerRNA DynamicPaintSurface_init_texture_get(PointerRNA *ptr);

float DynamicPaintSurface_wave_timescale_get(PointerRNA *ptr);
void DynamicPaintSurface_wave_timescale_set(PointerRNA *ptr, float value);

#define DynamicPaintSurface_uv_layer_MAX 68

void DynamicPaintSurface_uv_layer_get(PointerRNA *ptr, char *value);
int DynamicPaintSurface_uv_layer_length(PointerRNA *ptr);
void DynamicPaintSurface_uv_layer_set(PointerRNA *ptr, const char *value);

bool DynamicPaintSurface_is_cache_user_get(PointerRNA *ptr);
void DynamicPaintSurface_is_cache_user_set(PointerRNA *ptr, bool value);

bool DynamicPaintSurface_use_drip_get(PointerRNA *ptr);
void DynamicPaintSurface_use_drip_set(PointerRNA *ptr, bool value);

bool DynamicPaintSurface_use_output_a_get(PointerRNA *ptr);
void DynamicPaintSurface_use_output_a_set(PointerRNA *ptr, bool value);

bool DynamicPaintSurface_use_output_b_get(PointerRNA *ptr);
void DynamicPaintSurface_use_output_b_set(PointerRNA *ptr, bool value);

bool DynamicPaintSurface_use_shrink_get(PointerRNA *ptr);
void DynamicPaintSurface_use_shrink_set(PointerRNA *ptr, bool value);

bool DynamicPaintSurface_use_spread_get(PointerRNA *ptr);
void DynamicPaintSurface_use_spread_set(PointerRNA *ptr, bool value);

float DynamicPaintSurface_drip_velocity_get(PointerRNA *ptr);
void DynamicPaintSurface_drip_velocity_set(PointerRNA *ptr, float value);

bool DynamicPaintSurface_output_exists_func(struct DynamicPaintSurface *_self, struct Object *object, int index);
/**************** Canvas Surfaces ****************/

extern StructRNA RNA_DynamicPaintSurfaces;

PointerRNA DynamicPaintSurfaces_rna_type_get(PointerRNA *ptr);

int DynamicPaintSurfaces_active_index_get(PointerRNA *ptr);
void DynamicPaintSurfaces_active_index_set(PointerRNA *ptr, int value);

PointerRNA DynamicPaintSurfaces_active_get(PointerRNA *ptr);

/**************** EQCurveMappingData ****************/

extern StructRNA RNA_EQCurveMappingData;

PointerRNA EQCurveMappingData_rna_type_get(PointerRNA *ptr);

PointerRNA EQCurveMappingData_curve_mapping_get(PointerRNA *ptr);

/**************** EdgeSplit Modifier ****************/

extern StructRNA RNA_EdgeSplitModifier;
extern StructRNA RNA_Modifier;

float EdgeSplitModifier_split_angle_get(PointerRNA *ptr);
void EdgeSplitModifier_split_angle_set(PointerRNA *ptr, float value);

bool EdgeSplitModifier_use_edge_angle_get(PointerRNA *ptr);
void EdgeSplitModifier_use_edge_angle_set(PointerRNA *ptr, bool value);

bool EdgeSplitModifier_use_edge_sharp_get(PointerRNA *ptr);
void EdgeSplitModifier_use_edge_sharp_set(PointerRNA *ptr, bool value);

/**************** Edit Bone ****************/

extern StructRNA RNA_EditBone;

PointerRNA EditBone_rna_type_get(PointerRNA *ptr);

void EditBone_name_get(PointerRNA *ptr, char *value);
int EditBone_name_length(PointerRNA *ptr);
void EditBone_name_set(PointerRNA *ptr, const char *value);

float EditBone_bbone_x_get(PointerRNA *ptr);
void EditBone_bbone_x_set(PointerRNA *ptr, float value);

float EditBone_bbone_z_get(PointerRNA *ptr);
void EditBone_bbone_z_set(PointerRNA *ptr, float value);

PointerRNA EditBone_bbone_custom_handle_end_get(PointerRNA *ptr);

enum {
	EditBone_bbone_handle_type_end_AUTO = 0,
	EditBone_bbone_handle_type_end_ABSOLUTE = 1,
	EditBone_bbone_handle_type_end_RELATIVE = 2,
	EditBone_bbone_handle_type_end_TANGENT = 3,
};

int EditBone_bbone_handle_type_end_get(PointerRNA *ptr);
void EditBone_bbone_handle_type_end_set(PointerRNA *ptr, int value);

int EditBone_bbone_segments_get(PointerRNA *ptr);
void EditBone_bbone_segments_set(PointerRNA *ptr, int value);

PointerRNA EditBone_bbone_custom_handle_start_get(PointerRNA *ptr);

enum {
	EditBone_bbone_handle_type_start_AUTO = 0,
	EditBone_bbone_handle_type_start_ABSOLUTE = 1,
	EditBone_bbone_handle_type_start_RELATIVE = 2,
	EditBone_bbone_handle_type_start_TANGENT = 3,
};

int EditBone_bbone_handle_type_start_get(PointerRNA *ptr);
void EditBone_bbone_handle_type_start_set(PointerRNA *ptr, int value);

enum {
	EditBone_bbone_mapping_mode_STRAIGHT = 0,
	EditBone_bbone_mapping_mode_CURVED = 1,
};

int EditBone_bbone_mapping_mode_get(PointerRNA *ptr);
void EditBone_bbone_mapping_mode_set(PointerRNA *ptr, int value);

void EditBone_collections_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void EditBone_collections_next(CollectionPropertyIterator *iter);
void EditBone_collections_end(CollectionPropertyIterator *iter);

bool EditBone_use_connect_get(PointerRNA *ptr);
void EditBone_use_connect_set(PointerRNA *ptr, bool value);

bool EditBone_use_cyclic_offset_get(PointerRNA *ptr);
void EditBone_use_cyclic_offset_set(PointerRNA *ptr, bool value);

bool EditBone_use_deform_get(PointerRNA *ptr);
void EditBone_use_deform_set(PointerRNA *ptr, bool value);

enum {
	EditBone_display_type_ARMATURE_DEFINED = -1,
	EditBone_display_type_OCTAHEDRAL = 0,
	EditBone_display_type_STICK = 1,
	EditBone_display_type_BBONE = 2,
	EditBone_display_type_ENVELOPE = 3,
	EditBone_display_type_WIRE = 4,
};

int EditBone_display_type_get(PointerRNA *ptr);
void EditBone_display_type_set(PointerRNA *ptr, int value);

bool EditBone_show_wire_get(PointerRNA *ptr);
void EditBone_show_wire_set(PointerRNA *ptr, bool value);

float EditBone_bbone_easein_get(PointerRNA *ptr);
void EditBone_bbone_easein_set(PointerRNA *ptr, float value);

float EditBone_bbone_easeout_get(PointerRNA *ptr);
void EditBone_bbone_easeout_set(PointerRNA *ptr, float value);

void EditBone_matrix_get(PointerRNA *ptr, float values[16]);
void EditBone_matrix_set(PointerRNA *ptr, const float values[16]);

bool EditBone_bbone_handle_use_ease_end_get(PointerRNA *ptr);
void EditBone_bbone_handle_use_ease_end_set(PointerRNA *ptr, bool value);

void EditBone_bbone_handle_use_scale_end_get(PointerRNA *ptr, bool values[3]);
void EditBone_bbone_handle_use_scale_end_set(PointerRNA *ptr, const bool values[3]);

float EditBone_envelope_distance_get(PointerRNA *ptr);
void EditBone_envelope_distance_set(PointerRNA *ptr, float value);

float EditBone_envelope_weight_get(PointerRNA *ptr);
void EditBone_envelope_weight_set(PointerRNA *ptr, float value);

float EditBone_head_radius_get(PointerRNA *ptr);
void EditBone_head_radius_set(PointerRNA *ptr, float value);

float EditBone_tail_radius_get(PointerRNA *ptr);
void EditBone_tail_radius_set(PointerRNA *ptr, float value);

void EditBone_head_get(PointerRNA *ptr, float values[3]);
void EditBone_head_set(PointerRNA *ptr, const float values[3]);

bool EditBone_select_head_get(PointerRNA *ptr);
void EditBone_select_head_set(PointerRNA *ptr, bool value);

bool EditBone_hide_get(PointerRNA *ptr);
void EditBone_hide_set(PointerRNA *ptr, bool value);

float EditBone_bbone_curveinx_get(PointerRNA *ptr);
void EditBone_bbone_curveinx_set(PointerRNA *ptr, float value);

float EditBone_bbone_curveinz_get(PointerRNA *ptr);
void EditBone_bbone_curveinz_set(PointerRNA *ptr, float value);

bool EditBone_use_endroll_as_inroll_get(PointerRNA *ptr);
void EditBone_use_endroll_as_inroll_set(PointerRNA *ptr, bool value);

bool EditBone_use_inherit_rotation_get(PointerRNA *ptr);
void EditBone_use_inherit_rotation_set(PointerRNA *ptr, bool value);

enum {
	EditBone_inherit_scale_FULL = 0,
	EditBone_inherit_scale_FIX_SHEAR = 1,
	EditBone_inherit_scale_ALIGNED = 5,
	EditBone_inherit_scale_AVERAGE = 2,
	EditBone_inherit_scale_NONE = 3,
	EditBone_inherit_scale_NONE_LEGACY = 4,
};

int EditBone_inherit_scale_get(PointerRNA *ptr);
void EditBone_inherit_scale_set(PointerRNA *ptr, int value);

float EditBone_length_get(PointerRNA *ptr);
void EditBone_length_set(PointerRNA *ptr, float value);

bool EditBone_use_local_location_get(PointerRNA *ptr);
void EditBone_use_local_location_set(PointerRNA *ptr, bool value);

bool EditBone_lock_get(PointerRNA *ptr);
void EditBone_lock_set(PointerRNA *ptr, bool value);

bool EditBone_use_envelope_multiply_get(PointerRNA *ptr);
void EditBone_use_envelope_multiply_set(PointerRNA *ptr, bool value);

float EditBone_bbone_curveoutx_get(PointerRNA *ptr);
void EditBone_bbone_curveoutx_set(PointerRNA *ptr, float value);

float EditBone_bbone_curveoutz_get(PointerRNA *ptr);
void EditBone_bbone_curveoutz_set(PointerRNA *ptr, float value);

PointerRNA EditBone_parent_get(PointerRNA *ptr);

bool EditBone_use_relative_parent_get(PointerRNA *ptr);
void EditBone_use_relative_parent_set(PointerRNA *ptr, bool value);

float EditBone_roll_get(PointerRNA *ptr);
void EditBone_roll_set(PointerRNA *ptr, float value);

float EditBone_bbone_rollin_get(PointerRNA *ptr);
void EditBone_bbone_rollin_set(PointerRNA *ptr, float value);

float EditBone_bbone_rollout_get(PointerRNA *ptr);
void EditBone_bbone_rollout_set(PointerRNA *ptr, float value);

bool EditBone_use_scale_easing_get(PointerRNA *ptr);
void EditBone_use_scale_easing_set(PointerRNA *ptr, bool value);

void EditBone_bbone_scalein_get(PointerRNA *ptr, float values[3]);
void EditBone_bbone_scalein_set(PointerRNA *ptr, const float values[3]);

void EditBone_bbone_scaleout_get(PointerRNA *ptr, float values[3]);
void EditBone_bbone_scaleout_set(PointerRNA *ptr, const float values[3]);

bool EditBone_select_get(PointerRNA *ptr);
void EditBone_select_set(PointerRNA *ptr, bool value);

bool EditBone_hide_select_get(PointerRNA *ptr);
void EditBone_hide_select_set(PointerRNA *ptr, bool value);

bool EditBone_bbone_handle_use_ease_start_get(PointerRNA *ptr);
void EditBone_bbone_handle_use_ease_start_set(PointerRNA *ptr, bool value);

void EditBone_bbone_handle_use_scale_start_get(PointerRNA *ptr, bool values[3]);
void EditBone_bbone_handle_use_scale_start_set(PointerRNA *ptr, const bool values[3]);

void EditBone_tail_get(PointerRNA *ptr, float values[3]);
void EditBone_tail_set(PointerRNA *ptr, const float values[3]);

bool EditBone_select_tail_get(PointerRNA *ptr);
void EditBone_select_tail_set(PointerRNA *ptr, bool value);

PointerRNA EditBone_color_get(PointerRNA *ptr);

void EditBone_align_roll_func(struct EditBone *_self, float vector[3]);
/**************** Effect Strip ****************/

extern StructRNA RNA_EffectStrip;
extern StructRNA RNA_Strip;

enum {
	EffectStrip_alpha_mode_STRAIGHT = 0,
	EffectStrip_alpha_mode_PREMUL = 1,
};

int EffectStrip_alpha_mode_get(PointerRNA *ptr);
void EffectStrip_alpha_mode_set(PointerRNA *ptr, int value);

bool EffectStrip_use_float_get(PointerRNA *ptr);
void EffectStrip_use_float_set(PointerRNA *ptr, bool value);

PointerRNA EffectStrip_crop_get(PointerRNA *ptr);

bool EffectStrip_use_deinterlace_get(PointerRNA *ptr);
void EffectStrip_use_deinterlace_set(PointerRNA *ptr, bool value);

bool EffectStrip_use_flip_x_get(PointerRNA *ptr);
void EffectStrip_use_flip_x_set(PointerRNA *ptr, bool value);

bool EffectStrip_use_flip_y_get(PointerRNA *ptr);
void EffectStrip_use_flip_y_set(PointerRNA *ptr, bool value);

bool EffectStrip_multiply_alpha_get(PointerRNA *ptr);
void EffectStrip_multiply_alpha_set(PointerRNA *ptr, bool value);

float EffectStrip_color_multiply_get(PointerRNA *ptr);
void EffectStrip_color_multiply_set(PointerRNA *ptr, float value);

PointerRNA EffectStrip_proxy_get(PointerRNA *ptr);

bool EffectStrip_use_reverse_frames_get(PointerRNA *ptr);
void EffectStrip_use_reverse_frames_set(PointerRNA *ptr, bool value);

float EffectStrip_color_saturation_get(PointerRNA *ptr);
void EffectStrip_color_saturation_set(PointerRNA *ptr, float value);

float EffectStrip_strobe_get(PointerRNA *ptr);
void EffectStrip_strobe_set(PointerRNA *ptr, float value);

PointerRNA EffectStrip_transform_get(PointerRNA *ptr);

bool EffectStrip_use_proxy_get(PointerRNA *ptr);
void EffectStrip_use_proxy_set(PointerRNA *ptr, bool value);

/**************** Effector Weights ****************/

extern StructRNA RNA_EffectorWeights;

PointerRNA EffectorWeights_rna_type_get(PointerRNA *ptr);

float EffectorWeights_all_get(PointerRNA *ptr);
void EffectorWeights_all_set(PointerRNA *ptr, float value);

float EffectorWeights_boid_get(PointerRNA *ptr);
void EffectorWeights_boid_set(PointerRNA *ptr, float value);

float EffectorWeights_charge_get(PointerRNA *ptr);
void EffectorWeights_charge_set(PointerRNA *ptr, float value);

float EffectorWeights_curve_guide_get(PointerRNA *ptr);
void EffectorWeights_curve_guide_set(PointerRNA *ptr, float value);

float EffectorWeights_drag_get(PointerRNA *ptr);
void EffectorWeights_drag_set(PointerRNA *ptr, float value);

PointerRNA EffectorWeights_collection_get(PointerRNA *ptr);

float EffectorWeights_smokeflow_get(PointerRNA *ptr);
void EffectorWeights_smokeflow_set(PointerRNA *ptr, float value);

float EffectorWeights_force_get(PointerRNA *ptr);
void EffectorWeights_force_set(PointerRNA *ptr, float value);

float EffectorWeights_gravity_get(PointerRNA *ptr);
void EffectorWeights_gravity_set(PointerRNA *ptr, float value);

float EffectorWeights_harmonic_get(PointerRNA *ptr);
void EffectorWeights_harmonic_set(PointerRNA *ptr, float value);

float EffectorWeights_lennardjones_get(PointerRNA *ptr);
void EffectorWeights_lennardjones_set(PointerRNA *ptr, float value);

float EffectorWeights_magnetic_get(PointerRNA *ptr);
void EffectorWeights_magnetic_set(PointerRNA *ptr, float value);

float EffectorWeights_texture_get(PointerRNA *ptr);
void EffectorWeights_texture_set(PointerRNA *ptr, float value);

float EffectorWeights_turbulence_get(PointerRNA *ptr);
void EffectorWeights_turbulence_set(PointerRNA *ptr, float value);

bool EffectorWeights_apply_to_hair_growing_get(PointerRNA *ptr);
void EffectorWeights_apply_to_hair_growing_set(PointerRNA *ptr, bool value);

float EffectorWeights_vortex_get(PointerRNA *ptr);
void EffectorWeights_vortex_set(PointerRNA *ptr, float value);

float EffectorWeights_wind_get(PointerRNA *ptr);
void EffectorWeights_wind_set(PointerRNA *ptr, float value);

/**************** Enum Definition ****************/

extern StructRNA RNA_EnumProperty;
extern StructRNA RNA_Property;

enum {
	EnumProperty_default_DEFAULT = 0,
};

int EnumProperty_default_value_get(PointerRNA *ptr);
void EnumProperty_default_value_set(PointerRNA *ptr, int value);

enum {
	EnumProperty_default_flag_DEFAULT = 0,
};

int EnumProperty_default_flag_get(PointerRNA *ptr);
void EnumProperty_default_flag_set(PointerRNA *ptr, int value);

void EnumProperty_enum_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void EnumProperty_enum_items_next(CollectionPropertyIterator *iter);
void EnumProperty_enum_items_end(CollectionPropertyIterator *iter);

void EnumProperty_enum_items_static_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void EnumProperty_enum_items_static_next(CollectionPropertyIterator *iter);
void EnumProperty_enum_items_static_end(CollectionPropertyIterator *iter);

void EnumProperty_enum_items_static_ui_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void EnumProperty_enum_items_static_ui_next(CollectionPropertyIterator *iter);
void EnumProperty_enum_items_static_ui_end(CollectionPropertyIterator *iter);

/**************** Enum Item Definition ****************/

extern StructRNA RNA_EnumPropertyItem;

PointerRNA EnumPropertyItem_rna_type_get(PointerRNA *ptr);

void EnumPropertyItem_name_get(PointerRNA *ptr, char *value);
int EnumPropertyItem_name_length(PointerRNA *ptr);
void EnumPropertyItem_name_set(PointerRNA *ptr, const char *value);

void EnumPropertyItem_description_get(PointerRNA *ptr, char *value);
int EnumPropertyItem_description_length(PointerRNA *ptr);
void EnumPropertyItem_description_set(PointerRNA *ptr, const char *value);

enum {
	EnumPropertyItem_icon_NONE = 0,
	EnumPropertyItem_icon_CHAR_NOTDEF = 1,
	EnumPropertyItem_icon_CHAR_REPLACEMENT = 2,
	EnumPropertyItem_icon_NOT_FOUND = 3,
	EnumPropertyItem_icon_BLANK1 = 4,
	EnumPropertyItem_icon_AUTOMERGE_OFF = 5,
	EnumPropertyItem_icon_AUTOMERGE_ON = 6,
	EnumPropertyItem_icon_CHECKBOX_DEHLT = 7,
	EnumPropertyItem_icon_CHECKBOX_HLT = 8,
	EnumPropertyItem_icon_CLIPUV_DEHLT = 9,
	EnumPropertyItem_icon_CLIPUV_HLT = 10,
	EnumPropertyItem_icon_DECORATE_UNLOCKED = 11,
	EnumPropertyItem_icon_DECORATE_LOCKED = 12,
	EnumPropertyItem_icon_FAKE_USER_OFF = 13,
	EnumPropertyItem_icon_FAKE_USER_ON = 14,
	EnumPropertyItem_icon_HIDE_ON = 15,
	EnumPropertyItem_icon_HIDE_OFF = 16,
	EnumPropertyItem_icon_INDIRECT_ONLY_OFF = 17,
	EnumPropertyItem_icon_INDIRECT_ONLY_ON = 18,
	EnumPropertyItem_icon_ONIONSKIN_OFF = 19,
	EnumPropertyItem_icon_ONIONSKIN_ON = 20,
	EnumPropertyItem_icon_UNPINNED = 21,
	EnumPropertyItem_icon_PINNED = 22,
	EnumPropertyItem_icon_RADIOBUT_OFF = 23,
	EnumPropertyItem_icon_RADIOBUT_ON = 24,
	EnumPropertyItem_icon_RECORD_OFF = 25,
	EnumPropertyItem_icon_RECORD_ON = 26,
	EnumPropertyItem_icon_RESTRICT_RENDER_ON = 27,
	EnumPropertyItem_icon_RESTRICT_RENDER_OFF = 28,
	EnumPropertyItem_icon_RESTRICT_SELECT_ON = 29,
	EnumPropertyItem_icon_RESTRICT_SELECT_OFF = 30,
	EnumPropertyItem_icon_RESTRICT_VIEW_ON = 31,
	EnumPropertyItem_icon_RESTRICT_VIEW_OFF = 32,
	EnumPropertyItem_icon_RIGHTARROW = 33,
	EnumPropertyItem_icon_DOWNARROW_HLT = 34,
	EnumPropertyItem_icon_SELECT_INTERSECT = 35,
	EnumPropertyItem_icon_SELECT_DIFFERENCE = 36,
	EnumPropertyItem_icon_SNAP_OFF = 37,
	EnumPropertyItem_icon_SNAP_ON = 38,
	EnumPropertyItem_icon_UNLOCKED = 39,
	EnumPropertyItem_icon_LOCKED = 40,
	EnumPropertyItem_icon_VIS_SEL_11 = 41,
	EnumPropertyItem_icon_VIS_SEL_10 = 42,
	EnumPropertyItem_icon_VIS_SEL_01 = 43,
	EnumPropertyItem_icon_VIS_SEL_00 = 44,
	EnumPropertyItem_icon_CANCEL = 45,
	EnumPropertyItem_icon_ERROR = 46,
	EnumPropertyItem_icon_QUESTION = 47,
	EnumPropertyItem_icon_ADD = 48,
	EnumPropertyItem_icon_ARROW_LEFTRIGHT = 49,
	EnumPropertyItem_icon_AUTO = 50,
	EnumPropertyItem_icon_BLENDER = 51,
	EnumPropertyItem_icon_BORDERMOVE = 52,
	EnumPropertyItem_icon_BRUSHES_ALL = 53,
	EnumPropertyItem_icon_CHECKMARK = 54,
	EnumPropertyItem_icon_COLLAPSEMENU = 55,
	EnumPropertyItem_icon_COLLECTION_NEW = 56,
	EnumPropertyItem_icon_COLOR = 57,
	EnumPropertyItem_icon_COPY_ID = 58,
	EnumPropertyItem_icon_DISCLOSURE_TRI_DOWN = 59,
	EnumPropertyItem_icon_DISCLOSURE_TRI_RIGHT = 60,
	EnumPropertyItem_icon_DOT = 61,
	EnumPropertyItem_icon_DRIVER_DISTANCE = 62,
	EnumPropertyItem_icon_DRIVER_ROTATIONAL_DIFFERENCE = 63,
	EnumPropertyItem_icon_DRIVER_TRANSFORM = 64,
	EnumPropertyItem_icon_DUPLICATE = 65,
	EnumPropertyItem_icon_EYEDROPPER = 66,
	EnumPropertyItem_icon_FCURVE_SNAPSHOT = 67,
	EnumPropertyItem_icon_FILE_NEW = 68,
	EnumPropertyItem_icon_FILE_TICK = 69,
	EnumPropertyItem_icon_FREEZE = 70,
	EnumPropertyItem_icon_FULLSCREEN_ENTER = 71,
	EnumPropertyItem_icon_FULLSCREEN_EXIT = 72,
	EnumPropertyItem_icon_GHOST_DISABLED = 73,
	EnumPropertyItem_icon_GHOST_ENABLED = 74,
	EnumPropertyItem_icon_GRIP = 75,
	EnumPropertyItem_icon_GRIP_V = 76,
	EnumPropertyItem_icon_HAND = 77,
	EnumPropertyItem_icon_HELP = 78,
	EnumPropertyItem_icon_LINKED = 79,
	EnumPropertyItem_icon_MENU_PANEL = 80,
	EnumPropertyItem_icon_NODE_SEL = 81,
	EnumPropertyItem_icon_NODE = 82,
	EnumPropertyItem_icon_OBJECT_HIDDEN = 83,
	EnumPropertyItem_icon_OPTIONS = 84,
	EnumPropertyItem_icon_PANEL_CLOSE = 85,
	EnumPropertyItem_icon_PLUGIN = 86,
	EnumPropertyItem_icon_PLUS = 87,
	EnumPropertyItem_icon_PRESET_NEW = 88,
	EnumPropertyItem_icon_QUIT = 89,
	EnumPropertyItem_icon_RECOVER_LAST = 90,
	EnumPropertyItem_icon_REMOVE = 91,
	EnumPropertyItem_icon_RIGHTARROW_THIN = 92,
	EnumPropertyItem_icon_SCREEN_BACK = 93,
	EnumPropertyItem_icon_STATUSBAR = 94,
	EnumPropertyItem_icon_STYLUS_PRESSURE = 95,
	EnumPropertyItem_icon_THREE_DOTS = 96,
	EnumPropertyItem_icon_TOPBAR = 97,
	EnumPropertyItem_icon_TRASH = 98,
	EnumPropertyItem_icon_TRIA_DOWN = 99,
	EnumPropertyItem_icon_TRIA_LEFT = 100,
	EnumPropertyItem_icon_TRIA_RIGHT = 101,
	EnumPropertyItem_icon_TRIA_UP = 102,
	EnumPropertyItem_icon_UNLINKED = 103,
	EnumPropertyItem_icon_URL = 104,
	EnumPropertyItem_icon_VIEWZOOM = 105,
	EnumPropertyItem_icon_WINDOW = 106,
	EnumPropertyItem_icon_WORKSPACE = 107,
	EnumPropertyItem_icon_X = 108,
	EnumPropertyItem_icon_ZOOM_ALL = 109,
	EnumPropertyItem_icon_ZOOM_IN = 110,
	EnumPropertyItem_icon_ZOOM_OUT = 111,
	EnumPropertyItem_icon_ZOOM_PREVIOUS = 112,
	EnumPropertyItem_icon_ZOOM_SELECTED = 113,
	EnumPropertyItem_icon_MODIFIER = 114,
	EnumPropertyItem_icon_PARTICLES = 115,
	EnumPropertyItem_icon_PHYSICS = 116,
	EnumPropertyItem_icon_SHADERFX = 117,
	EnumPropertyItem_icon_SPEAKER = 118,
	EnumPropertyItem_icon_OUTPUT = 119,
	EnumPropertyItem_icon_SCENE = 120,
	EnumPropertyItem_icon_TOOL_SETTINGS = 121,
	EnumPropertyItem_icon_LIGHT = 122,
	EnumPropertyItem_icon_MATERIAL = 123,
	EnumPropertyItem_icon_TEXTURE = 124,
	EnumPropertyItem_icon_WORLD = 125,
	EnumPropertyItem_icon_ANIM = 126,
	EnumPropertyItem_icon_SCRIPT = 127,
	EnumPropertyItem_icon_GEOMETRY_NODES = 128,
	EnumPropertyItem_icon_TEXT = 129,
	EnumPropertyItem_icon_ACTION = 130,
	EnumPropertyItem_icon_ASSET_MANAGER = 131,
	EnumPropertyItem_icon_CONSOLE = 132,
	EnumPropertyItem_icon_FILEBROWSER = 133,
	EnumPropertyItem_icon_GEOMETRY_SET = 134,
	EnumPropertyItem_icon_GRAPH = 135,
	EnumPropertyItem_icon_IMAGE = 136,
	EnumPropertyItem_icon_INFO = 137,
	EnumPropertyItem_icon_NLA = 138,
	EnumPropertyItem_icon_NODE_COMPOSITING = 139,
	EnumPropertyItem_icon_NODE_MATERIAL = 140,
	EnumPropertyItem_icon_NODE_TEXTURE = 141,
	EnumPropertyItem_icon_NODETREE = 142,
	EnumPropertyItem_icon_OUTLINER = 143,
	EnumPropertyItem_icon_PREFERENCES = 144,
	EnumPropertyItem_icon_PROPERTIES = 145,
	EnumPropertyItem_icon_SEQUENCE = 146,
	EnumPropertyItem_icon_SOUND = 147,
	EnumPropertyItem_icon_SPREADSHEET = 148,
	EnumPropertyItem_icon_TIME = 149,
	EnumPropertyItem_icon_TRACKER = 150,
	EnumPropertyItem_icon_UV = 151,
	EnumPropertyItem_icon_VIEW3D = 152,
	EnumPropertyItem_icon_EDITMODE_HLT = 153,
	EnumPropertyItem_icon_OBJECT_DATAMODE = 154,
	EnumPropertyItem_icon_PARTICLEMODE = 155,
	EnumPropertyItem_icon_POSE_HLT = 156,
	EnumPropertyItem_icon_SCULPTMODE_HLT = 157,
	EnumPropertyItem_icon_TPAINT_HLT = 158,
	EnumPropertyItem_icon_UV_DATA = 159,
	EnumPropertyItem_icon_VPAINT_HLT = 160,
	EnumPropertyItem_icon_WPAINT_HLT = 161,
	EnumPropertyItem_icon_TRACKER_DATA = 162,
	EnumPropertyItem_icon_TRACKING_BACKWARDS_SINGLE = 163,
	EnumPropertyItem_icon_TRACKING_BACKWARDS = 164,
	EnumPropertyItem_icon_TRACKING_CLEAR_BACKWARDS = 165,
	EnumPropertyItem_icon_TRACKING_CLEAR_FORWARDS = 166,
	EnumPropertyItem_icon_TRACKING_FORWARDS_SINGLE = 167,
	EnumPropertyItem_icon_TRACKING_FORWARDS = 168,
	EnumPropertyItem_icon_TRACKING_REFINE_BACKWARDS = 169,
	EnumPropertyItem_icon_TRACKING_REFINE_FORWARDS = 170,
	EnumPropertyItem_icon_TRACKING = 171,
	EnumPropertyItem_icon_GROUP = 172,
	EnumPropertyItem_icon_CONSTRAINT_BONE = 173,
	EnumPropertyItem_icon_CONSTRAINT = 174,
	EnumPropertyItem_icon_ARMATURE_DATA = 175,
	EnumPropertyItem_icon_BONE_DATA = 176,
	EnumPropertyItem_icon_CAMERA_DATA = 177,
	EnumPropertyItem_icon_CURVE_DATA = 178,
	EnumPropertyItem_icon_EMPTY_DATA = 179,
	EnumPropertyItem_icon_FONT_DATA = 180,
	EnumPropertyItem_icon_LATTICE_DATA = 181,
	EnumPropertyItem_icon_LIGHT_DATA = 182,
	EnumPropertyItem_icon_MESH_DATA = 183,
	EnumPropertyItem_icon_META_DATA = 184,
	EnumPropertyItem_icon_PARTICLE_DATA = 185,
	EnumPropertyItem_icon_SHAPEKEY_DATA = 186,
	EnumPropertyItem_icon_SURFACE_DATA = 187,
	EnumPropertyItem_icon_OBJECT_DATA = 188,
	EnumPropertyItem_icon_RENDER_RESULT = 189,
	EnumPropertyItem_icon_RENDERLAYERS = 190,
	EnumPropertyItem_icon_SCENE_DATA = 191,
	EnumPropertyItem_icon_BRUSH_DATA = 192,
	EnumPropertyItem_icon_IMAGE_DATA = 193,
	EnumPropertyItem_icon_LINE_DATA = 194,
	EnumPropertyItem_icon_MATERIAL_DATA = 195,
	EnumPropertyItem_icon_TEXTURE_DATA = 196,
	EnumPropertyItem_icon_WORLD_DATA = 197,
	EnumPropertyItem_icon_ANIM_DATA = 198,
	EnumPropertyItem_icon_BOIDS = 199,
	EnumPropertyItem_icon_CAMERA_STEREO = 200,
	EnumPropertyItem_icon_COMMUNITY = 201,
	EnumPropertyItem_icon_FACE_MAPS = 202,
	EnumPropertyItem_icon_FCURVE = 203,
	EnumPropertyItem_icon_FILE = 204,
	EnumPropertyItem_icon_GREASEPENCIL = 205,
	EnumPropertyItem_icon_GREASEPENCIL_LAYER_GROUP = 206,
	EnumPropertyItem_icon_GROUP_BONE = 207,
	EnumPropertyItem_icon_GROUP_UVS = 208,
	EnumPropertyItem_icon_GROUP_VCOL = 209,
	EnumPropertyItem_icon_GROUP_VERTEX = 210,
	EnumPropertyItem_icon_LIBRARY_DATA_BROKEN = 211,
	EnumPropertyItem_icon_LIBRARY_DATA_DIRECT = 212,
	EnumPropertyItem_icon_LIBRARY_DATA_OVERRIDE = 213,
	EnumPropertyItem_icon_ORPHAN_DATA = 214,
	EnumPropertyItem_icon_PACKAGE = 215,
	EnumPropertyItem_icon_PRESET = 216,
	EnumPropertyItem_icon_RENDER_ANIMATION = 217,
	EnumPropertyItem_icon_RENDER_STILL = 218,
	EnumPropertyItem_icon_RNA_ADD = 219,
	EnumPropertyItem_icon_RNA = 220,
	EnumPropertyItem_icon_STRANDS = 221,
	EnumPropertyItem_icon_UGLYPACKAGE = 222,
	EnumPropertyItem_icon_MOUSE_LMB = 223,
	EnumPropertyItem_icon_MOUSE_MMB = 224,
	EnumPropertyItem_icon_MOUSE_RMB = 225,
	EnumPropertyItem_icon_MOUSE_MMB_SCROLL = 226,
	EnumPropertyItem_icon_MOUSE_LMB_2X = 227,
	EnumPropertyItem_icon_MOUSE_MOVE = 228,
	EnumPropertyItem_icon_MOUSE_LMB_DRAG = 229,
	EnumPropertyItem_icon_MOUSE_MMB_DRAG = 230,
	EnumPropertyItem_icon_MOUSE_RMB_DRAG = 231,
	EnumPropertyItem_icon_DECORATE_ANIMATE = 232,
	EnumPropertyItem_icon_DECORATE_DRIVER = 233,
	EnumPropertyItem_icon_DECORATE_KEYFRAME = 234,
	EnumPropertyItem_icon_DECORATE_LIBRARY_OVERRIDE = 235,
	EnumPropertyItem_icon_DECORATE_LINKED = 236,
	EnumPropertyItem_icon_DECORATE_OVERRIDE = 237,
	EnumPropertyItem_icon_DECORATE = 238,
	EnumPropertyItem_icon_OUTLINER_COLLECTION = 239,
	EnumPropertyItem_icon_CURVES_DATA = 240,
	EnumPropertyItem_icon_OUTLINER_DATA_ARMATURE = 241,
	EnumPropertyItem_icon_OUTLINER_DATA_CAMERA = 242,
	EnumPropertyItem_icon_OUTLINER_DATA_CURVE = 243,
	EnumPropertyItem_icon_OUTLINER_DATA_CURVES = 244,
	EnumPropertyItem_icon_OUTLINER_DATA_EMPTY = 245,
	EnumPropertyItem_icon_OUTLINER_DATA_FONT = 246,
	EnumPropertyItem_icon_OUTLINER_DATA_GP_LAYER = 247,
	EnumPropertyItem_icon_OUTLINER_DATA_GREASEPENCIL = 248,
	EnumPropertyItem_icon_OUTLINER_DATA_LATTICE = 249,
	EnumPropertyItem_icon_OUTLINER_DATA_LIGHT = 250,
	EnumPropertyItem_icon_OUTLINER_DATA_LIGHTPROBE = 251,
	EnumPropertyItem_icon_OUTLINER_DATA_MESH = 252,
	EnumPropertyItem_icon_OUTLINER_DATA_META = 253,
	EnumPropertyItem_icon_OUTLINER_DATA_POINTCLOUD = 254,
	EnumPropertyItem_icon_OUTLINER_DATA_SPEAKER = 255,
	EnumPropertyItem_icon_OUTLINER_DATA_SURFACE = 256,
	EnumPropertyItem_icon_OUTLINER_DATA_VOLUME = 257,
	EnumPropertyItem_icon_POINTCLOUD_DATA = 258,
	EnumPropertyItem_icon_POINTCLOUD_POINT = 259,
	EnumPropertyItem_icon_VOLUME_DATA = 260,
	EnumPropertyItem_icon_OUTLINER_OB_ARMATURE = 261,
	EnumPropertyItem_icon_OUTLINER_OB_CAMERA = 262,
	EnumPropertyItem_icon_OUTLINER_OB_CURVE = 263,
	EnumPropertyItem_icon_OUTLINER_OB_CURVES = 264,
	EnumPropertyItem_icon_OUTLINER_OB_EMPTY = 265,
	EnumPropertyItem_icon_OUTLINER_OB_FONT = 266,
	EnumPropertyItem_icon_OUTLINER_OB_FORCE_FIELD = 267,
	EnumPropertyItem_icon_OUTLINER_OB_GREASEPENCIL = 268,
	EnumPropertyItem_icon_OUTLINER_OB_GROUP_INSTANCE = 269,
	EnumPropertyItem_icon_OUTLINER_OB_IMAGE = 270,
	EnumPropertyItem_icon_OUTLINER_OB_LATTICE = 271,
	EnumPropertyItem_icon_OUTLINER_OB_LIGHT = 272,
	EnumPropertyItem_icon_OUTLINER_OB_LIGHTPROBE = 273,
	EnumPropertyItem_icon_OUTLINER_OB_MESH = 274,
	EnumPropertyItem_icon_OUTLINER_OB_META = 275,
	EnumPropertyItem_icon_OUTLINER_OB_POINTCLOUD = 276,
	EnumPropertyItem_icon_OUTLINER_OB_SPEAKER = 277,
	EnumPropertyItem_icon_OUTLINER_OB_SURFACE = 278,
	EnumPropertyItem_icon_OUTLINER_OB_VOLUME = 279,
	EnumPropertyItem_icon_GP_MULTIFRAME_EDITING = 280,
	EnumPropertyItem_icon_GP_ONLY_SELECTED = 281,
	EnumPropertyItem_icon_GP_SELECT_BETWEEN_STROKES = 282,
	EnumPropertyItem_icon_GP_SELECT_POINTS = 283,
	EnumPropertyItem_icon_GP_SELECT_STROKES = 284,
	EnumPropertyItem_icon_HOLDOUT_OFF = 285,
	EnumPropertyItem_icon_HOLDOUT_ON = 286,
	EnumPropertyItem_icon_MODIFIER_OFF = 287,
	EnumPropertyItem_icon_MODIFIER_ON = 288,
	EnumPropertyItem_icon_RESTRICT_COLOR_OFF = 289,
	EnumPropertyItem_icon_RESTRICT_COLOR_ON = 290,
	EnumPropertyItem_icon_RESTRICT_INSTANCED_OFF = 291,
	EnumPropertyItem_icon_RESTRICT_INSTANCED_ON = 292,
	EnumPropertyItem_icon_LIGHT_AREA = 293,
	EnumPropertyItem_icon_LIGHT_HEMI = 294,
	EnumPropertyItem_icon_LIGHT_POINT = 295,
	EnumPropertyItem_icon_LIGHT_SPOT = 296,
	EnumPropertyItem_icon_LIGHT_SUN = 297,
	EnumPropertyItem_icon_LIGHTPROBE_PLANE = 298,
	EnumPropertyItem_icon_LIGHTPROBE_SPHERE = 299,
	EnumPropertyItem_icon_LIGHTPROBE_VOLUME = 300,
	EnumPropertyItem_icon_COLOR_BLUE = 301,
	EnumPropertyItem_icon_COLOR_GREEN = 302,
	EnumPropertyItem_icon_COLOR_RED = 303,
	EnumPropertyItem_icon_CONE = 304,
	EnumPropertyItem_icon_CUBE = 305,
	EnumPropertyItem_icon_CURVE_BEZCIRCLE = 306,
	EnumPropertyItem_icon_CURVE_BEZCURVE = 307,
	EnumPropertyItem_icon_CURVE_NCIRCLE = 308,
	EnumPropertyItem_icon_CURVE_NCURVE = 309,
	EnumPropertyItem_icon_CURVE_PATH = 310,
	EnumPropertyItem_icon_CURVES = 311,
	EnumPropertyItem_icon_EMPTY_ARROWS = 312,
	EnumPropertyItem_icon_EMPTY_AXIS = 313,
	EnumPropertyItem_icon_EMPTY_SINGLE_ARROW = 314,
	EnumPropertyItem_icon_MESH_CAPSULE = 315,
	EnumPropertyItem_icon_MESH_CIRCLE = 316,
	EnumPropertyItem_icon_MESH_CONE = 317,
	EnumPropertyItem_icon_MESH_CUBE = 318,
	EnumPropertyItem_icon_MESH_CYLINDER = 319,
	EnumPropertyItem_icon_MESH_GRID = 320,
	EnumPropertyItem_icon_MESH_ICOSPHERE = 321,
	EnumPropertyItem_icon_MESH_MONKEY = 322,
	EnumPropertyItem_icon_MESH_PLANE = 323,
	EnumPropertyItem_icon_MESH_TORUS = 324,
	EnumPropertyItem_icon_MESH_UVSPHERE = 325,
	EnumPropertyItem_icon_META_BALL = 326,
	EnumPropertyItem_icon_META_CAPSULE = 327,
	EnumPropertyItem_icon_META_CUBE = 328,
	EnumPropertyItem_icon_META_ELLIPSOID = 329,
	EnumPropertyItem_icon_META_PLANE = 330,
	EnumPropertyItem_icon_MONKEY = 331,
	EnumPropertyItem_icon_SPHERE = 332,
	EnumPropertyItem_icon_STROKE = 333,
	EnumPropertyItem_icon_SURFACE_NCIRCLE = 334,
	EnumPropertyItem_icon_SURFACE_NCURVE = 335,
	EnumPropertyItem_icon_SURFACE_NCYLINDER = 336,
	EnumPropertyItem_icon_SURFACE_NSPHERE = 337,
	EnumPropertyItem_icon_SURFACE_NSURFACE = 338,
	EnumPropertyItem_icon_SURFACE_NTORUS = 339,
	EnumPropertyItem_icon_TRIA_DOWN_BAR = 340,
	EnumPropertyItem_icon_TRIA_LEFT_BAR = 341,
	EnumPropertyItem_icon_TRIA_RIGHT_BAR = 342,
	EnumPropertyItem_icon_TRIA_UP_BAR = 343,
	EnumPropertyItem_icon_AREA_DOCK = 344,
	EnumPropertyItem_icon_AREA_JOIN_DOWN = 345,
	EnumPropertyItem_icon_AREA_JOIN_LEFT = 346,
	EnumPropertyItem_icon_AREA_JOIN_UP = 347,
	EnumPropertyItem_icon_AREA_JOIN = 348,
	EnumPropertyItem_icon_AREA_SWAP = 349,
	EnumPropertyItem_icon_FORCE_BOID = 350,
	EnumPropertyItem_icon_FORCE_CHARGE = 351,
	EnumPropertyItem_icon_FORCE_CURVE = 352,
	EnumPropertyItem_icon_FORCE_DRAG = 353,
	EnumPropertyItem_icon_FORCE_FLUIDFLOW = 354,
	EnumPropertyItem_icon_FORCE_FORCE = 355,
	EnumPropertyItem_icon_FORCE_HARMONIC = 356,
	EnumPropertyItem_icon_FORCE_LENNARDJONES = 357,
	EnumPropertyItem_icon_FORCE_MAGNETIC = 358,
	EnumPropertyItem_icon_FORCE_TEXTURE = 359,
	EnumPropertyItem_icon_FORCE_TURBULENCE = 360,
	EnumPropertyItem_icon_FORCE_VORTEX = 361,
	EnumPropertyItem_icon_FORCE_WIND = 362,
	EnumPropertyItem_icon_IMAGE_BACKGROUND = 363,
	EnumPropertyItem_icon_IMAGE_PLANE = 364,
	EnumPropertyItem_icon_IMAGE_REFERENCE = 365,
	EnumPropertyItem_icon_RIGID_BODY_CONSTRAINT = 366,
	EnumPropertyItem_icon_RIGID_BODY = 367,
	EnumPropertyItem_icon_SPLIT_HORIZONTAL = 368,
	EnumPropertyItem_icon_SPLIT_VERTICAL = 369,
	EnumPropertyItem_icon_ANCHOR_BOTTOM = 370,
	EnumPropertyItem_icon_ANCHOR_CENTER = 371,
	EnumPropertyItem_icon_ANCHOR_LEFT = 372,
	EnumPropertyItem_icon_ANCHOR_RIGHT = 373,
	EnumPropertyItem_icon_ANCHOR_TOP = 374,
	EnumPropertyItem_icon_NODE_CORNER = 375,
	EnumPropertyItem_icon_NODE_INSERT_OFF = 376,
	EnumPropertyItem_icon_NODE_INSERT_ON = 377,
	EnumPropertyItem_icon_NODE_SIDE = 378,
	EnumPropertyItem_icon_NODE_TOP = 379,
	EnumPropertyItem_icon_SELECT_EXTEND = 380,
	EnumPropertyItem_icon_SELECT_SET = 381,
	EnumPropertyItem_icon_SELECT_SUBTRACT = 382,
	EnumPropertyItem_icon_ALIGN_BOTTOM = 383,
	EnumPropertyItem_icon_ALIGN_CENTER = 384,
	EnumPropertyItem_icon_ALIGN_FLUSH = 385,
	EnumPropertyItem_icon_ALIGN_JUSTIFY = 386,
	EnumPropertyItem_icon_ALIGN_LEFT = 387,
	EnumPropertyItem_icon_ALIGN_MIDDLE = 388,
	EnumPropertyItem_icon_ALIGN_RIGHT = 389,
	EnumPropertyItem_icon_ALIGN_TOP = 390,
	EnumPropertyItem_icon_BOLD = 391,
	EnumPropertyItem_icon_ITALIC = 392,
	EnumPropertyItem_icon_LINENUMBERS_OFF = 393,
	EnumPropertyItem_icon_LINENUMBERS_ON = 394,
	EnumPropertyItem_icon_SCRIPTPLUGINS = 395,
	EnumPropertyItem_icon_SMALL_CAPS = 396,
	EnumPropertyItem_icon_SYNTAX_OFF = 397,
	EnumPropertyItem_icon_SYNTAX_ON = 398,
	EnumPropertyItem_icon_UNDERLINE = 399,
	EnumPropertyItem_icon_WORDWRAP_OFF = 400,
	EnumPropertyItem_icon_WORDWRAP_ON = 401,
	EnumPropertyItem_icon_CON_ACTION = 402,
	EnumPropertyItem_icon_CON_ARMATURE = 403,
	EnumPropertyItem_icon_CON_CAMERASOLVER = 404,
	EnumPropertyItem_icon_CON_CHILDOF = 405,
	EnumPropertyItem_icon_CON_CLAMPTO = 406,
	EnumPropertyItem_icon_CON_DISTLIMIT = 407,
	EnumPropertyItem_icon_CON_FLOOR = 408,
	EnumPropertyItem_icon_CON_FOLLOWPATH = 409,
	EnumPropertyItem_icon_CON_FOLLOWTRACK = 410,
	EnumPropertyItem_icon_CON_KINEMATIC = 411,
	EnumPropertyItem_icon_CON_LOCKTRACK = 412,
	EnumPropertyItem_icon_CON_LOCLIKE = 413,
	EnumPropertyItem_icon_CON_LOCLIMIT = 414,
	EnumPropertyItem_icon_CON_OBJECTSOLVER = 415,
	EnumPropertyItem_icon_CON_PIVOT = 416,
	EnumPropertyItem_icon_CON_ROTLIKE = 417,
	EnumPropertyItem_icon_CON_ROTLIMIT = 418,
	EnumPropertyItem_icon_CON_SAMEVOL = 419,
	EnumPropertyItem_icon_CON_SHRINKWRAP = 420,
	EnumPropertyItem_icon_CON_SIZELIKE = 421,
	EnumPropertyItem_icon_CON_SIZELIMIT = 422,
	EnumPropertyItem_icon_CON_SPLINEIK = 423,
	EnumPropertyItem_icon_CON_STRETCHTO = 424,
	EnumPropertyItem_icon_CON_TRACKTO = 425,
	EnumPropertyItem_icon_CON_TRANSFORM_CACHE = 426,
	EnumPropertyItem_icon_CON_TRANSFORM = 427,
	EnumPropertyItem_icon_CON_TRANSLIKE = 428,
	EnumPropertyItem_icon_HOOK = 429,
	EnumPropertyItem_icon_MOD_ARMATURE = 430,
	EnumPropertyItem_icon_MOD_ARRAY = 431,
	EnumPropertyItem_icon_MOD_BEVEL = 432,
	EnumPropertyItem_icon_MOD_BOOLEAN = 433,
	EnumPropertyItem_icon_MOD_BUILD = 434,
	EnumPropertyItem_icon_MOD_CAST = 435,
	EnumPropertyItem_icon_MOD_CLOTH = 436,
	EnumPropertyItem_icon_MOD_CURVE = 437,
	EnumPropertyItem_icon_MOD_DASH = 438,
	EnumPropertyItem_icon_MOD_DATA_TRANSFER = 439,
	EnumPropertyItem_icon_MOD_DECIM = 440,
	EnumPropertyItem_icon_MOD_DISPLACE = 441,
	EnumPropertyItem_icon_MOD_DYNAMICPAINT = 442,
	EnumPropertyItem_icon_MOD_EDGESPLIT = 443,
	EnumPropertyItem_icon_MOD_ENVELOPE = 444,
	EnumPropertyItem_icon_MOD_EXPLODE = 445,
	EnumPropertyItem_icon_MOD_FLUID = 446,
	EnumPropertyItem_icon_MOD_FLUIDSIM = 447,
	EnumPropertyItem_icon_MOD_HUE_SATURATION = 448,
	EnumPropertyItem_icon_MOD_INSTANCE = 449,
	EnumPropertyItem_icon_MOD_LATTICE = 450,
	EnumPropertyItem_icon_MOD_LENGTH = 451,
	EnumPropertyItem_icon_MOD_LINEART = 452,
	EnumPropertyItem_icon_MOD_MASK = 453,
	EnumPropertyItem_icon_MOD_MESHDEFORM = 454,
	EnumPropertyItem_icon_MOD_MIRROR = 455,
	EnumPropertyItem_icon_MOD_MULTIRES = 456,
	EnumPropertyItem_icon_MOD_NOISE = 457,
	EnumPropertyItem_icon_MOD_NORMALEDIT = 458,
	EnumPropertyItem_icon_MOD_OCEAN = 459,
	EnumPropertyItem_icon_MOD_OFFSET = 460,
	EnumPropertyItem_icon_MOD_OPACITY = 461,
	EnumPropertyItem_icon_MOD_OUTLINE = 462,
	EnumPropertyItem_icon_MOD_PARTICLE_INSTANCE = 463,
	EnumPropertyItem_icon_MOD_PARTICLES = 464,
	EnumPropertyItem_icon_MOD_PHYSICS = 465,
	EnumPropertyItem_icon_MOD_REMESH = 466,
	EnumPropertyItem_icon_MOD_SCREW = 467,
	EnumPropertyItem_icon_MOD_SHRINKWRAP = 468,
	EnumPropertyItem_icon_MOD_SIMPLEDEFORM = 469,
	EnumPropertyItem_icon_MOD_SIMPLIFY = 470,
	EnumPropertyItem_icon_MOD_SKIN = 471,
	EnumPropertyItem_icon_MOD_SMOOTH = 472,
	EnumPropertyItem_icon_MOD_SOFT = 473,
	EnumPropertyItem_icon_MOD_SOLIDIFY = 474,
	EnumPropertyItem_icon_MOD_SUBSURF = 475,
	EnumPropertyItem_icon_MOD_THICKNESS = 476,
	EnumPropertyItem_icon_MOD_TIME = 477,
	EnumPropertyItem_icon_MOD_TINT = 478,
	EnumPropertyItem_icon_MOD_TRIANGULATE = 479,
	EnumPropertyItem_icon_MOD_UVPROJECT = 480,
	EnumPropertyItem_icon_MOD_VERTEX_WEIGHT = 481,
	EnumPropertyItem_icon_MOD_WARP = 482,
	EnumPropertyItem_icon_MOD_WAVE = 483,
	EnumPropertyItem_icon_MOD_WIREFRAME = 484,
	EnumPropertyItem_icon_MODIFIER_DATA = 485,
	EnumPropertyItem_icon_ACTION_SLOT = 486,
	EnumPropertyItem_icon_ACTION_TWEAK = 487,
	EnumPropertyItem_icon_DRIVER = 488,
	EnumPropertyItem_icon_FF = 489,
	EnumPropertyItem_icon_FRAME_NEXT = 490,
	EnumPropertyItem_icon_FRAME_PREV = 491,
	EnumPropertyItem_icon_HANDLE_ALIGNED = 492,
	EnumPropertyItem_icon_HANDLE_AUTO = 493,
	EnumPropertyItem_icon_HANDLE_AUTOCLAMPED = 494,
	EnumPropertyItem_icon_HANDLE_FREE = 495,
	EnumPropertyItem_icon_HANDLE_VECTOR = 496,
	EnumPropertyItem_icon_IPO_BACK = 497,
	EnumPropertyItem_icon_IPO_BEZIER = 498,
	EnumPropertyItem_icon_IPO_BOUNCE = 499,
	EnumPropertyItem_icon_IPO_CIRC = 500,
	EnumPropertyItem_icon_IPO_CONSTANT = 501,
	EnumPropertyItem_icon_IPO_CUBIC = 502,
	EnumPropertyItem_icon_IPO_EASE_IN_OUT = 503,
	EnumPropertyItem_icon_IPO_EASE_IN = 504,
	EnumPropertyItem_icon_IPO_EASE_OUT = 505,
	EnumPropertyItem_icon_IPO_ELASTIC = 506,
	EnumPropertyItem_icon_IPO_EXPO = 507,
	EnumPropertyItem_icon_IPO_LINEAR = 508,
	EnumPropertyItem_icon_IPO_QUAD = 509,
	EnumPropertyItem_icon_IPO_QUART = 510,
	EnumPropertyItem_icon_IPO_QUINT = 511,
	EnumPropertyItem_icon_IPO_SINE = 512,
	EnumPropertyItem_icon_KEY_DEHLT = 513,
	EnumPropertyItem_icon_KEY_HLT = 514,
	EnumPropertyItem_icon_KEYFRAME_HLT = 515,
	EnumPropertyItem_icon_KEYFRAME = 516,
	EnumPropertyItem_icon_KEYINGSET = 517,
	EnumPropertyItem_icon_MARKER_HLT = 518,
	EnumPropertyItem_icon_MARKER = 519,
	EnumPropertyItem_icon_MUTE_IPO_OFF = 520,
	EnumPropertyItem_icon_MUTE_IPO_ON = 521,
	EnumPropertyItem_icon_NEXT_KEYFRAME = 522,
	EnumPropertyItem_icon_NLA_PUSHDOWN = 523,
	EnumPropertyItem_icon_NORMALIZE_FCURVES = 524,
	EnumPropertyItem_icon_ORIENTATION_PARENT = 525,
	EnumPropertyItem_icon_PAUSE = 526,
	EnumPropertyItem_icon_PLAY_REVERSE = 527,
	EnumPropertyItem_icon_PLAY_SOUND = 528,
	EnumPropertyItem_icon_PLAY = 529,
	EnumPropertyItem_icon_PMARKER_ACT = 530,
	EnumPropertyItem_icon_PMARKER_SEL = 531,
	EnumPropertyItem_icon_PMARKER = 532,
	EnumPropertyItem_icon_PREV_KEYFRAME = 533,
	EnumPropertyItem_icon_PREVIEW_RANGE = 534,
	EnumPropertyItem_icon_REC = 535,
	EnumPropertyItem_icon_REW = 536,
	EnumPropertyItem_icon_SOLO_OFF = 537,
	EnumPropertyItem_icon_SOLO_ON = 538,
	EnumPropertyItem_icon_CENTER_ONLY = 539,
	EnumPropertyItem_icon_CURSOR = 540,
	EnumPropertyItem_icon_EDGESEL = 541,
	EnumPropertyItem_icon_FACE_CORNER = 542,
	EnumPropertyItem_icon_FACESEL = 543,
	EnumPropertyItem_icon_INVERSESQUARECURVE = 544,
	EnumPropertyItem_icon_LINCURVE = 545,
	EnumPropertyItem_icon_NOCURVE = 546,
	EnumPropertyItem_icon_PARTICLE_PATH = 547,
	EnumPropertyItem_icon_PARTICLE_POINT = 548,
	EnumPropertyItem_icon_PARTICLE_TIP = 549,
	EnumPropertyItem_icon_PIVOT_ACTIVE = 550,
	EnumPropertyItem_icon_PIVOT_BOUNDBOX = 551,
	EnumPropertyItem_icon_PIVOT_CURSOR = 552,
	EnumPropertyItem_icon_PIVOT_INDIVIDUAL = 553,
	EnumPropertyItem_icon_PIVOT_MEDIAN = 554,
	EnumPropertyItem_icon_PROP_CON = 555,
	EnumPropertyItem_icon_PROP_OFF = 556,
	EnumPropertyItem_icon_PROP_ON = 557,
	EnumPropertyItem_icon_PROP_PROJECTED = 558,
	EnumPropertyItem_icon_RNDCURVE = 559,
	EnumPropertyItem_icon_ROOTCURVE = 560,
	EnumPropertyItem_icon_SHARPCURVE = 561,
	EnumPropertyItem_icon_SMOOTHCURVE = 562,
	EnumPropertyItem_icon_SPHERECURVE = 563,
	EnumPropertyItem_icon_VERTEXSEL = 564,
	EnumPropertyItem_icon_SNAP_EDGE = 565,
	EnumPropertyItem_icon_SNAP_FACE_CENTER = 566,
	EnumPropertyItem_icon_SNAP_FACE_NEAREST = 567,
	EnumPropertyItem_icon_SNAP_FACE = 568,
	EnumPropertyItem_icon_SNAP_GRID = 569,
	EnumPropertyItem_icon_SNAP_INCREMENT = 570,
	EnumPropertyItem_icon_SNAP_MIDPOINT = 571,
	EnumPropertyItem_icon_SNAP_NORMAL = 572,
	EnumPropertyItem_icon_SNAP_PEEL_OBJECT = 573,
	EnumPropertyItem_icon_SNAP_PERPENDICULAR = 574,
	EnumPropertyItem_icon_SNAP_VERTEX = 575,
	EnumPropertyItem_icon_SNAP_VOLUME = 576,
	EnumPropertyItem_icon_STICKY_UVS_DISABLE = 577,
	EnumPropertyItem_icon_STICKY_UVS_LOC = 578,
	EnumPropertyItem_icon_STICKY_UVS_VERT = 579,
	EnumPropertyItem_icon_ORIENTATION_GIMBAL = 580,
	EnumPropertyItem_icon_ORIENTATION_GLOBAL = 581,
	EnumPropertyItem_icon_ORIENTATION_LOCAL = 582,
	EnumPropertyItem_icon_ORIENTATION_NORMAL = 583,
	EnumPropertyItem_icon_ORIENTATION_VIEW = 584,
	EnumPropertyItem_icon_COPYDOWN = 585,
	EnumPropertyItem_icon_FIXED_SIZE = 586,
	EnumPropertyItem_icon_GIZMO = 587,
	EnumPropertyItem_icon_GP_CAPS_FLAT = 588,
	EnumPropertyItem_icon_GP_CAPS_ROUND = 589,
	EnumPropertyItem_icon_NORMALS_FACE = 590,
	EnumPropertyItem_icon_NORMALS_VERTEX_FACE = 591,
	EnumPropertyItem_icon_NORMALS_VERTEX = 592,
	EnumPropertyItem_icon_OBJECT_ORIGIN = 593,
	EnumPropertyItem_icon_ORIENTATION_CURSOR = 594,
	EnumPropertyItem_icon_PASTEDOWN = 595,
	EnumPropertyItem_icon_PASTEFLIPDOWN = 596,
	EnumPropertyItem_icon_PASTEFLIPUP = 597,
	EnumPropertyItem_icon_TRANSFORM_ORIGINS = 598,
	EnumPropertyItem_icon_UV_EDGESEL = 599,
	EnumPropertyItem_icon_UV_FACESEL = 600,
	EnumPropertyItem_icon_UV_ISLANDSEL = 601,
	EnumPropertyItem_icon_UV_SYNC_SELECT = 602,
	EnumPropertyItem_icon_UV_VERTEXSEL = 603,
	EnumPropertyItem_icon_AXIS_FRONT = 604,
	EnumPropertyItem_icon_AXIS_SIDE = 605,
	EnumPropertyItem_icon_AXIS_TOP = 606,
	EnumPropertyItem_icon_GRID = 607,
	EnumPropertyItem_icon_LAYER_ACTIVE = 608,
	EnumPropertyItem_icon_LAYER_USED = 609,
	EnumPropertyItem_icon_LOCKVIEW_OFF = 610,
	EnumPropertyItem_icon_LOCKVIEW_ON = 611,
	EnumPropertyItem_icon_OVERLAY = 612,
	EnumPropertyItem_icon_SHADING_BBOX = 613,
	EnumPropertyItem_icon_SHADING_RENDERED = 614,
	EnumPropertyItem_icon_SHADING_SOLID = 615,
	EnumPropertyItem_icon_SHADING_TEXTURE = 616,
	EnumPropertyItem_icon_SHADING_WIRE = 617,
	EnumPropertyItem_icon_XRAY = 618,
	EnumPropertyItem_icon_VIEW_CAMERA_UNSELECTED = 619,
	EnumPropertyItem_icon_VIEW_CAMERA = 620,
	EnumPropertyItem_icon_VIEW_LOCKED = 621,
	EnumPropertyItem_icon_VIEW_ORTHO = 622,
	EnumPropertyItem_icon_VIEW_PAN = 623,
	EnumPropertyItem_icon_VIEW_PERSPECTIVE = 624,
	EnumPropertyItem_icon_VIEW_UNLOCKED = 625,
	EnumPropertyItem_icon_VIEW_ZOOM = 626,
	EnumPropertyItem_icon_FILE_ALIAS = 627,
	EnumPropertyItem_icon_FILE_FOLDER = 628,
	EnumPropertyItem_icon_FOLDER_REDIRECT = 629,
	EnumPropertyItem_icon_APPEND_BLEND = 630,
	EnumPropertyItem_icon_BACK = 631,
	EnumPropertyItem_icon_BOOKMARKS = 632,
	EnumPropertyItem_icon_CURRENT_FILE = 633,
	EnumPropertyItem_icon_DESKTOP = 634,
	EnumPropertyItem_icon_DISC = 635,
	EnumPropertyItem_icon_DISK_DRIVE = 636,
	EnumPropertyItem_icon_DOCUMENTS = 637,
	EnumPropertyItem_icon_EXPORT = 638,
	EnumPropertyItem_icon_EXTERNAL_DRIVE = 639,
	EnumPropertyItem_icon_FILE_3D = 640,
	EnumPropertyItem_icon_FILE_ARCHIVE = 641,
	EnumPropertyItem_icon_FILE_BACKUP = 642,
	EnumPropertyItem_icon_FILE_BLANK = 643,
	EnumPropertyItem_icon_FILE_BLEND = 644,
	EnumPropertyItem_icon_FILE_CACHE = 645,
	EnumPropertyItem_icon_FILE_FONT = 646,
	EnumPropertyItem_icon_FILE_HIDDEN = 647,
	EnumPropertyItem_icon_FILE_IMAGE = 648,
	EnumPropertyItem_icon_FILE_MOVIE = 649,
	EnumPropertyItem_icon_FILE_PARENT = 650,
	EnumPropertyItem_icon_FILE_REFRESH = 651,
	EnumPropertyItem_icon_FILE_SCRIPT = 652,
	EnumPropertyItem_icon_FILE_SOUND = 653,
	EnumPropertyItem_icon_FILE_TEXT = 654,
	EnumPropertyItem_icon_FILE_VOLUME = 655,
	EnumPropertyItem_icon_FILTER = 656,
	EnumPropertyItem_icon_FONTPREVIEW = 657,
	EnumPropertyItem_icon_FORWARD = 658,
	EnumPropertyItem_icon_HOME = 659,
	EnumPropertyItem_icon_IMGDISPLAY = 660,
	EnumPropertyItem_icon_IMPORT = 661,
	EnumPropertyItem_icon_LINK_BLEND = 662,
	EnumPropertyItem_icon_LONGDISPLAY = 663,
	EnumPropertyItem_icon_LOOP_BACK = 664,
	EnumPropertyItem_icon_LOOP_FORWARDS = 665,
	EnumPropertyItem_icon_NETWORK_DRIVE = 666,
	EnumPropertyItem_icon_NEWFOLDER = 667,
	EnumPropertyItem_icon_PREVIEW_LOADING = 668,
	EnumPropertyItem_icon_SETTINGS = 669,
	EnumPropertyItem_icon_SHORTDISPLAY = 670,
	EnumPropertyItem_icon_SORT_ASC = 671,
	EnumPropertyItem_icon_SORT_DESC = 672,
	EnumPropertyItem_icon_SORTALPHA = 673,
	EnumPropertyItem_icon_SORTBYEXT = 674,
	EnumPropertyItem_icon_SORTSIZE = 675,
	EnumPropertyItem_icon_SORTTIME = 676,
	EnumPropertyItem_icon_SYSTEM = 677,
	EnumPropertyItem_icon_TAG = 678,
	EnumPropertyItem_icon_TEMP = 679,
	EnumPropertyItem_icon_ALIASED = 680,
	EnumPropertyItem_icon_ANTIALIASED = 681,
	EnumPropertyItem_icon_MAT_SPHERE_SKY = 682,
	EnumPropertyItem_icon_MATCLOTH = 683,
	EnumPropertyItem_icon_MATCUBE = 684,
	EnumPropertyItem_icon_MATFLUID = 685,
	EnumPropertyItem_icon_MATPLANE = 686,
	EnumPropertyItem_icon_MATSHADERBALL = 687,
	EnumPropertyItem_icon_MATSPHERE = 688,
	EnumPropertyItem_icon_SEQ_CHROMA_SCOPE = 689,
	EnumPropertyItem_icon_SEQ_HISTOGRAM = 690,
	EnumPropertyItem_icon_SEQ_LUMA_WAVEFORM = 691,
	EnumPropertyItem_icon_SEQ_PREVIEW = 692,
	EnumPropertyItem_icon_SEQ_SEQUENCER = 693,
	EnumPropertyItem_icon_SEQ_SPLITVIEW = 694,
	EnumPropertyItem_icon_SEQ_STRIP_DUPLICATE = 695,
	EnumPropertyItem_icon_SEQ_STRIP_META = 696,
	EnumPropertyItem_icon_IMAGE_ALPHA = 697,
	EnumPropertyItem_icon_IMAGE_RGB_ALPHA = 698,
	EnumPropertyItem_icon_IMAGE_RGB = 699,
	EnumPropertyItem_icon_IMAGE_ZDEPTH = 700,
	EnumPropertyItem_icon_BLENDER_LOGO_LARGE = 701,
	EnumPropertyItem_icon_CANCEL_LARGE = 702,
	EnumPropertyItem_icon_DISC_LARGE = 703,
	EnumPropertyItem_icon_DISK_DRIVE_LARGE = 704,
	EnumPropertyItem_icon_EXTERNAL_DRIVE_LARGE = 705,
	EnumPropertyItem_icon_FILE_FOLDER_LARGE = 706,
	EnumPropertyItem_icon_FILE_LARGE = 707,
	EnumPropertyItem_icon_FILE_PARENT_LARGE = 708,
	EnumPropertyItem_icon_INFO_LARGE = 709,
	EnumPropertyItem_icon_NETWORK_DRIVE_LARGE = 710,
	EnumPropertyItem_icon_QUESTION_LARGE = 711,
	EnumPropertyItem_icon_WARNING_LARGE = 712,
	EnumPropertyItem_icon_KEY_BACKSPACE_FILLED = 713,
	EnumPropertyItem_icon_KEY_BACKSPACE = 714,
	EnumPropertyItem_icon_KEY_COMMAND_FILLED = 715,
	EnumPropertyItem_icon_KEY_COMMAND = 716,
	EnumPropertyItem_icon_KEY_CONTROL_FILLED = 717,
	EnumPropertyItem_icon_KEY_CONTROL = 718,
	EnumPropertyItem_icon_KEY_EMPTY1_FILLED = 719,
	EnumPropertyItem_icon_KEY_EMPTY1 = 720,
	EnumPropertyItem_icon_KEY_EMPTY2_FILLED = 721,
	EnumPropertyItem_icon_KEY_EMPTY2 = 722,
	EnumPropertyItem_icon_KEY_EMPTY3_FILLED = 723,
	EnumPropertyItem_icon_KEY_EMPTY3 = 724,
	EnumPropertyItem_icon_KEY_MENU_FILLED = 725,
	EnumPropertyItem_icon_KEY_MENU = 726,
	EnumPropertyItem_icon_KEY_OPTION_FILLED = 727,
	EnumPropertyItem_icon_KEY_OPTION = 728,
	EnumPropertyItem_icon_KEY_RETURN_FILLED = 729,
	EnumPropertyItem_icon_KEY_RETURN = 730,
	EnumPropertyItem_icon_KEY_RING_FILLED = 731,
	EnumPropertyItem_icon_KEY_RING = 732,
	EnumPropertyItem_icon_KEY_SHIFT_FILLED = 733,
	EnumPropertyItem_icon_KEY_SHIFT = 734,
	EnumPropertyItem_icon_KEY_TAB_FILLED = 735,
	EnumPropertyItem_icon_KEY_TAB = 736,
	EnumPropertyItem_icon_KEY_WINDOWS_FILLED = 737,
	EnumPropertyItem_icon_KEY_WINDOWS = 738,
	EnumPropertyItem_icon_GESTURE_PAN = 739,
	EnumPropertyItem_icon_GESTURE_ROTATE = 740,
	EnumPropertyItem_icon_GESTURE_ZOOM = 741,
	EnumPropertyItem_icon_FUND = 742,
	EnumPropertyItem_icon_HEART = 743,
	EnumPropertyItem_icon_INTERNET_OFFLINE = 744,
	EnumPropertyItem_icon_INTERNET = 745,
	EnumPropertyItem_icon_USER = 746,
	EnumPropertyItem_icon_EXPERIMENTAL = 747,
	EnumPropertyItem_icon_MEMORY = 748,
	EnumPropertyItem_icon_RGB_RED = 750,
	EnumPropertyItem_icon_RGB_GREEN = 751,
	EnumPropertyItem_icon_RGB_BLUE = 752,
	EnumPropertyItem_icon_KEYTYPE_KEYFRAME_VEC = 753,
	EnumPropertyItem_icon_KEYTYPE_BREAKDOWN_VEC = 754,
	EnumPropertyItem_icon_KEYTYPE_EXTREME_VEC = 755,
	EnumPropertyItem_icon_KEYTYPE_JITTER_VEC = 756,
	EnumPropertyItem_icon_KEYTYPE_MOVING_HOLD_VEC = 757,
	EnumPropertyItem_icon_KEYTYPE_GENERATED_VEC = 758,
	EnumPropertyItem_icon_HANDLETYPE_FREE_VEC = 759,
	EnumPropertyItem_icon_HANDLETYPE_ALIGNED_VEC = 760,
	EnumPropertyItem_icon_HANDLETYPE_VECTOR_VEC = 761,
	EnumPropertyItem_icon_HANDLETYPE_AUTO_VEC = 762,
	EnumPropertyItem_icon_HANDLETYPE_AUTO_CLAMP_VEC = 763,
	EnumPropertyItem_icon_COLORSET_01_VEC = 764,
	EnumPropertyItem_icon_COLORSET_02_VEC = 765,
	EnumPropertyItem_icon_COLORSET_03_VEC = 766,
	EnumPropertyItem_icon_COLORSET_04_VEC = 767,
	EnumPropertyItem_icon_COLORSET_05_VEC = 768,
	EnumPropertyItem_icon_COLORSET_06_VEC = 769,
	EnumPropertyItem_icon_COLORSET_07_VEC = 770,
	EnumPropertyItem_icon_COLORSET_08_VEC = 771,
	EnumPropertyItem_icon_COLORSET_09_VEC = 772,
	EnumPropertyItem_icon_COLORSET_10_VEC = 773,
	EnumPropertyItem_icon_COLORSET_11_VEC = 774,
	EnumPropertyItem_icon_COLORSET_12_VEC = 775,
	EnumPropertyItem_icon_COLORSET_13_VEC = 776,
	EnumPropertyItem_icon_COLORSET_14_VEC = 777,
	EnumPropertyItem_icon_COLORSET_15_VEC = 778,
	EnumPropertyItem_icon_COLORSET_16_VEC = 779,
	EnumPropertyItem_icon_COLORSET_17_VEC = 780,
	EnumPropertyItem_icon_COLORSET_18_VEC = 781,
	EnumPropertyItem_icon_COLORSET_19_VEC = 782,
	EnumPropertyItem_icon_COLORSET_20_VEC = 783,
	EnumPropertyItem_icon_COLLECTION_COLOR_01 = 784,
	EnumPropertyItem_icon_COLLECTION_COLOR_02 = 785,
	EnumPropertyItem_icon_COLLECTION_COLOR_03 = 786,
	EnumPropertyItem_icon_COLLECTION_COLOR_04 = 787,
	EnumPropertyItem_icon_COLLECTION_COLOR_05 = 788,
	EnumPropertyItem_icon_COLLECTION_COLOR_06 = 789,
	EnumPropertyItem_icon_COLLECTION_COLOR_07 = 790,
	EnumPropertyItem_icon_COLLECTION_COLOR_08 = 791,
	EnumPropertyItem_icon_STRIP_COLOR_01 = 792,
	EnumPropertyItem_icon_STRIP_COLOR_02 = 793,
	EnumPropertyItem_icon_STRIP_COLOR_03 = 794,
	EnumPropertyItem_icon_STRIP_COLOR_04 = 795,
	EnumPropertyItem_icon_STRIP_COLOR_05 = 796,
	EnumPropertyItem_icon_STRIP_COLOR_06 = 797,
	EnumPropertyItem_icon_STRIP_COLOR_07 = 798,
	EnumPropertyItem_icon_STRIP_COLOR_08 = 799,
	EnumPropertyItem_icon_STRIP_COLOR_09 = 800,
	EnumPropertyItem_icon_LIBRARY_DATA_INDIRECT = 801,
	EnumPropertyItem_icon_LIBRARY_DATA_OVERRIDE_NONEDITABLE = 802,
	EnumPropertyItem_icon_LAYERGROUP_COLOR_01 = 803,
	EnumPropertyItem_icon_LAYERGROUP_COLOR_02 = 804,
	EnumPropertyItem_icon_LAYERGROUP_COLOR_03 = 805,
	EnumPropertyItem_icon_LAYERGROUP_COLOR_04 = 806,
	EnumPropertyItem_icon_LAYERGROUP_COLOR_05 = 807,
	EnumPropertyItem_icon_LAYERGROUP_COLOR_06 = 808,
	EnumPropertyItem_icon_LAYERGROUP_COLOR_07 = 809,
	EnumPropertyItem_icon_LAYERGROUP_COLOR_08 = 810,
	EnumPropertyItem_icon_EVENT_A = 811,
	EnumPropertyItem_icon_EVENT_B = 812,
	EnumPropertyItem_icon_EVENT_C = 813,
	EnumPropertyItem_icon_EVENT_D = 814,
	EnumPropertyItem_icon_EVENT_E = 815,
	EnumPropertyItem_icon_EVENT_F = 816,
	EnumPropertyItem_icon_EVENT_G = 817,
	EnumPropertyItem_icon_EVENT_H = 818,
	EnumPropertyItem_icon_EVENT_I = 819,
	EnumPropertyItem_icon_EVENT_J = 820,
	EnumPropertyItem_icon_EVENT_K = 821,
	EnumPropertyItem_icon_EVENT_L = 822,
	EnumPropertyItem_icon_EVENT_M = 823,
	EnumPropertyItem_icon_EVENT_N = 824,
	EnumPropertyItem_icon_EVENT_O = 825,
	EnumPropertyItem_icon_EVENT_P = 826,
	EnumPropertyItem_icon_EVENT_Q = 827,
	EnumPropertyItem_icon_EVENT_R = 828,
	EnumPropertyItem_icon_EVENT_S = 829,
	EnumPropertyItem_icon_EVENT_T = 830,
	EnumPropertyItem_icon_EVENT_U = 831,
	EnumPropertyItem_icon_EVENT_V = 832,
	EnumPropertyItem_icon_EVENT_W = 833,
	EnumPropertyItem_icon_EVENT_X = 834,
	EnumPropertyItem_icon_EVENT_Y = 835,
	EnumPropertyItem_icon_EVENT_Z = 836,
	EnumPropertyItem_icon_EVENT_SHIFT = 837,
	EnumPropertyItem_icon_EVENT_CTRL = 838,
	EnumPropertyItem_icon_EVENT_ALT = 839,
	EnumPropertyItem_icon_EVENT_OS = 840,
	EnumPropertyItem_icon_EVENT_HYPER = 841,
	EnumPropertyItem_icon_EVENT_F1 = 842,
	EnumPropertyItem_icon_EVENT_F2 = 843,
	EnumPropertyItem_icon_EVENT_F3 = 844,
	EnumPropertyItem_icon_EVENT_F4 = 845,
	EnumPropertyItem_icon_EVENT_F5 = 846,
	EnumPropertyItem_icon_EVENT_F6 = 847,
	EnumPropertyItem_icon_EVENT_F7 = 848,
	EnumPropertyItem_icon_EVENT_F8 = 849,
	EnumPropertyItem_icon_EVENT_F9 = 850,
	EnumPropertyItem_icon_EVENT_F10 = 851,
	EnumPropertyItem_icon_EVENT_F11 = 852,
	EnumPropertyItem_icon_EVENT_F12 = 853,
	EnumPropertyItem_icon_EVENT_F13 = 854,
	EnumPropertyItem_icon_EVENT_F14 = 855,
	EnumPropertyItem_icon_EVENT_F15 = 856,
	EnumPropertyItem_icon_EVENT_F16 = 857,
	EnumPropertyItem_icon_EVENT_F17 = 858,
	EnumPropertyItem_icon_EVENT_F18 = 859,
	EnumPropertyItem_icon_EVENT_F19 = 860,
	EnumPropertyItem_icon_EVENT_F20 = 861,
	EnumPropertyItem_icon_EVENT_F21 = 862,
	EnumPropertyItem_icon_EVENT_F22 = 863,
	EnumPropertyItem_icon_EVENT_F23 = 864,
	EnumPropertyItem_icon_EVENT_F24 = 865,
	EnumPropertyItem_icon_EVENT_ESC = 866,
	EnumPropertyItem_icon_EVENT_TAB = 867,
	EnumPropertyItem_icon_EVENT_PAGEUP = 868,
	EnumPropertyItem_icon_EVENT_PAGEDOWN = 869,
	EnumPropertyItem_icon_EVENT_RETURN = 870,
	EnumPropertyItem_icon_EVENT_SPACEKEY = 871,
	EnumPropertyItem_icon_EVENT_ZEROKEY = 872,
	EnumPropertyItem_icon_EVENT_ONEKEY = 873,
	EnumPropertyItem_icon_EVENT_TWOKEY = 874,
	EnumPropertyItem_icon_EVENT_THREEKEY = 875,
	EnumPropertyItem_icon_EVENT_FOURKEY = 876,
	EnumPropertyItem_icon_EVENT_FIVEKEY = 877,
	EnumPropertyItem_icon_EVENT_SIXKEY = 878,
	EnumPropertyItem_icon_EVENT_SEVENKEY = 879,
	EnumPropertyItem_icon_EVENT_EIGHTKEY = 880,
	EnumPropertyItem_icon_EVENT_NINEKEY = 881,
	EnumPropertyItem_icon_EVENT_PAD0 = 882,
	EnumPropertyItem_icon_EVENT_PAD1 = 883,
	EnumPropertyItem_icon_EVENT_PAD2 = 884,
	EnumPropertyItem_icon_EVENT_PAD3 = 885,
	EnumPropertyItem_icon_EVENT_PAD4 = 886,
	EnumPropertyItem_icon_EVENT_PAD5 = 887,
	EnumPropertyItem_icon_EVENT_PAD6 = 888,
	EnumPropertyItem_icon_EVENT_PAD7 = 889,
	EnumPropertyItem_icon_EVENT_PAD8 = 890,
	EnumPropertyItem_icon_EVENT_PAD9 = 891,
	EnumPropertyItem_icon_EVENT_PADASTER = 892,
	EnumPropertyItem_icon_EVENT_PADSLASH = 893,
	EnumPropertyItem_icon_EVENT_PADMINUS = 894,
	EnumPropertyItem_icon_EVENT_PADENTER = 895,
	EnumPropertyItem_icon_EVENT_PADPLUS = 896,
	EnumPropertyItem_icon_EVENT_PADPERIOD = 897,
	EnumPropertyItem_icon_EVENT_MOUSE_4 = 898,
	EnumPropertyItem_icon_EVENT_MOUSE_5 = 899,
	EnumPropertyItem_icon_EVENT_MOUSE_6 = 900,
	EnumPropertyItem_icon_EVENT_MOUSE_7 = 901,
	EnumPropertyItem_icon_EVENT_TABLET_STYLUS = 902,
	EnumPropertyItem_icon_EVENT_TABLET_ERASER = 903,
	EnumPropertyItem_icon_EVENT_LEFT_ARROW = 904,
	EnumPropertyItem_icon_EVENT_DOWN_ARROW = 905,
	EnumPropertyItem_icon_EVENT_RIGHT_ARROW = 906,
	EnumPropertyItem_icon_EVENT_UP_ARROW = 907,
	EnumPropertyItem_icon_EVENT_PAUSE = 908,
	EnumPropertyItem_icon_EVENT_INSERT = 909,
	EnumPropertyItem_icon_EVENT_HOME = 910,
	EnumPropertyItem_icon_EVENT_END = 911,
	EnumPropertyItem_icon_EVENT_UNKNOWN = 912,
	EnumPropertyItem_icon_EVENT_GRLESS = 913,
	EnumPropertyItem_icon_EVENT_MEDIAPLAY = 914,
	EnumPropertyItem_icon_EVENT_MEDIASTOP = 915,
	EnumPropertyItem_icon_EVENT_MEDIAFIRST = 916,
	EnumPropertyItem_icon_EVENT_MEDIALAST = 917,
	EnumPropertyItem_icon_EVENT_APP = 918,
	EnumPropertyItem_icon_EVENT_CAPSLOCK = 919,
	EnumPropertyItem_icon_EVENT_BACKSPACE = 920,
	EnumPropertyItem_icon_EVENT_DEL = 921,
	EnumPropertyItem_icon_EVENT_SEMICOLON = 922,
	EnumPropertyItem_icon_EVENT_PERIOD = 923,
	EnumPropertyItem_icon_EVENT_COMMA = 924,
	EnumPropertyItem_icon_EVENT_QUOTE = 925,
	EnumPropertyItem_icon_EVENT_ACCENTGRAVE = 926,
	EnumPropertyItem_icon_EVENT_MINUS = 927,
	EnumPropertyItem_icon_EVENT_PLUS = 928,
	EnumPropertyItem_icon_EVENT_SLASH = 929,
	EnumPropertyItem_icon_EVENT_BACKSLASH = 930,
	EnumPropertyItem_icon_EVENT_EQUAL = 931,
	EnumPropertyItem_icon_EVENT_LEFTBRACKET = 932,
	EnumPropertyItem_icon_EVENT_RIGHTBRACKET = 933,
	EnumPropertyItem_icon_EVENT_PAD_PAN = 934,
	EnumPropertyItem_icon_EVENT_PAD_ROTATE = 935,
	EnumPropertyItem_icon_EVENT_PAD_ZOOM = 936,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_V1 = 937,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_V2 = 938,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_V3 = 939,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_SAVE_V1 = 940,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_SAVE_V2 = 941,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_SAVE_V3 = 942,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_1 = 943,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_2 = 944,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_3 = 945,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_4 = 946,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_5 = 947,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_6 = 948,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_7 = 949,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_8 = 950,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_9 = 951,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_10 = 952,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_11 = 953,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_12 = 954,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_MENU = 955,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_FIT = 956,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_TOP = 957,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_BOTTOM = 958,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_LEFT = 959,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_RIGHT = 960,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_FRONT = 961,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_BACK = 962,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_ISO1 = 963,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_ISO2 = 964,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_ROLL_CW = 965,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_ROLL_CCW = 966,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_SPIN_CW = 967,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_SPIN_CCW = 968,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_TILT_CW = 969,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_TILT_CCW = 970,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_ROTATE = 971,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_PANZOOM = 972,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_DOMINANT = 973,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_PLUS = 974,
	EnumPropertyItem_icon_EVENT_NDOF_BUTTON_MINUS = 975,
	EnumPropertyItem_icon_NODE_SOCKET_FLOAT = 976,
	EnumPropertyItem_icon_NODE_SOCKET_VECTOR = 977,
	EnumPropertyItem_icon_NODE_SOCKET_RGBA = 978,
	EnumPropertyItem_icon_NODE_SOCKET_SHADER = 979,
	EnumPropertyItem_icon_NODE_SOCKET_BOOLEAN = 980,
	EnumPropertyItem_icon_NODE_SOCKET_INT = 981,
	EnumPropertyItem_icon_NODE_SOCKET_STRING = 982,
	EnumPropertyItem_icon_NODE_SOCKET_OBJECT = 983,
	EnumPropertyItem_icon_NODE_SOCKET_IMAGE = 984,
	EnumPropertyItem_icon_NODE_SOCKET_GEOMETRY = 985,
	EnumPropertyItem_icon_NODE_SOCKET_COLLECTION = 986,
	EnumPropertyItem_icon_NODE_SOCKET_TEXTURE = 987,
	EnumPropertyItem_icon_NODE_SOCKET_MATERIAL = 988,
	EnumPropertyItem_icon_NODE_SOCKET_ROTATION = 989,
	EnumPropertyItem_icon_NODE_SOCKET_MENU = 990,
	EnumPropertyItem_icon_NODE_SOCKET_MATRIX = 991,
	EnumPropertyItem_icon_NODE_SOCKET_BUNDLE = 992,
	EnumPropertyItem_icon_NODE_SOCKET_CLOSURE = 993,
};

int EnumPropertyItem_icon_get(PointerRNA *ptr);
void EnumPropertyItem_icon_set(PointerRNA *ptr, int value);

void EnumPropertyItem_identifier_get(PointerRNA *ptr, char *value);
int EnumPropertyItem_identifier_length(PointerRNA *ptr);
void EnumPropertyItem_identifier_set(PointerRNA *ptr, const char *value);

int EnumPropertyItem_value_get(PointerRNA *ptr);
void EnumPropertyItem_value_set(PointerRNA *ptr, int value);

/**************** EvaluateClosureNodeViewerPathElem ****************/

extern StructRNA RNA_EvaluateClosureNodeViewerPathElem;
extern StructRNA RNA_ViewerPathElem;

int EvaluateClosureNodeViewerPathElem_source_output_node_id_get(PointerRNA *ptr);
void EvaluateClosureNodeViewerPathElem_source_output_node_id_set(PointerRNA *ptr, int value);

int EvaluateClosureNodeViewerPathElem_evaluate_node_id_get(PointerRNA *ptr);
void EvaluateClosureNodeViewerPathElem_evaluate_node_id_set(PointerRNA *ptr, int value);

PointerRNA EvaluateClosureNodeViewerPathElem_source_node_tree_get(PointerRNA *ptr);

/**************** Event ****************/

extern StructRNA RNA_Event;

PointerRNA Event_rna_type_get(PointerRNA *ptr);

void Event_ascii_get(PointerRNA *ptr, char *value);
int Event_ascii_length(PointerRNA *ptr);
void Event_ascii_set(PointerRNA *ptr, const char *value);

bool Event_is_mouse_absolute_get(PointerRNA *ptr);
void Event_is_mouse_absolute_set(PointerRNA *ptr, bool value);

bool Event_alt_get(PointerRNA *ptr);
void Event_alt_set(PointerRNA *ptr, bool value);

bool Event_ctrl_get(PointerRNA *ptr);
void Event_ctrl_set(PointerRNA *ptr, bool value);

enum {
	Event_direction_ANY = -1,
	Event_direction_NORTH = 1,
	Event_direction_NORTH_EAST = 2,
	Event_direction_EAST = 3,
	Event_direction_SOUTH_EAST = 4,
	Event_direction_SOUTH = 5,
	Event_direction_SOUTH_WEST = 6,
	Event_direction_WEST = 7,
	Event_direction_NORTH_WEST = 8,
};

int Event_direction_get(PointerRNA *ptr);
void Event_direction_set(PointerRNA *ptr, int value);

bool Event_hyper_get(PointerRNA *ptr);
void Event_hyper_set(PointerRNA *ptr, bool value);

bool Event_is_consecutive_get(PointerRNA *ptr);
void Event_is_consecutive_set(PointerRNA *ptr, bool value);

bool Event_is_repeat_get(PointerRNA *ptr);
void Event_is_repeat_set(PointerRNA *ptr, bool value);

bool Event_is_tablet_get(PointerRNA *ptr);
void Event_is_tablet_set(PointerRNA *ptr, bool value);

int Event_mouse_prev_x_get(PointerRNA *ptr);
void Event_mouse_prev_x_set(PointerRNA *ptr, int value);

int Event_mouse_prev_press_x_get(PointerRNA *ptr);
void Event_mouse_prev_press_x_set(PointerRNA *ptr, int value);

int Event_mouse_prev_y_get(PointerRNA *ptr);
void Event_mouse_prev_y_set(PointerRNA *ptr, int value);

int Event_mouse_prev_press_y_get(PointerRNA *ptr);
void Event_mouse_prev_press_y_set(PointerRNA *ptr, int value);

int Event_mouse_x_get(PointerRNA *ptr);
void Event_mouse_x_set(PointerRNA *ptr, int value);

int Event_mouse_region_x_get(PointerRNA *ptr);
void Event_mouse_region_x_set(PointerRNA *ptr, int value);

int Event_mouse_y_get(PointerRNA *ptr);
void Event_mouse_y_set(PointerRNA *ptr, int value);

int Event_mouse_region_y_get(PointerRNA *ptr);
void Event_mouse_region_y_set(PointerRNA *ptr, int value);

PointerRNA Event_ndof_motion_get(PointerRNA *ptr);

bool Event_oskey_get(PointerRNA *ptr);
void Event_oskey_set(PointerRNA *ptr, bool value);

enum {
	Event_type_prev_NONE = 0,
	Event_type_prev_LEFTMOUSE = 1,
	Event_type_prev_MIDDLEMOUSE = 2,
	Event_type_prev_RIGHTMOUSE = 3,
	Event_type_prev_BUTTON4MOUSE = 7,
	Event_type_prev_BUTTON5MOUSE = 8,
	Event_type_prev_BUTTON6MOUSE = 18,
	Event_type_prev_BUTTON7MOUSE = 19,
	Event_type_prev_PEN = 26,
	Event_type_prev_ERASER = 27,
	Event_type_prev_MOUSEMOVE = 4,
	Event_type_prev_INBETWEEN_MOUSEMOVE = 17,
	Event_type_prev_TRACKPADPAN = 14,
	Event_type_prev_TRACKPADZOOM = 15,
	Event_type_prev_MOUSEROTATE = 16,
	Event_type_prev_MOUSESMARTZOOM = 23,
	Event_type_prev_WHEELUPMOUSE = 10,
	Event_type_prev_WHEELDOWNMOUSE = 11,
	Event_type_prev_WHEELINMOUSE = 12,
	Event_type_prev_WHEELOUTMOUSE = 13,
	Event_type_prev_WHEELLEFTMOUSE = 20,
	Event_type_prev_WHEELRIGHTMOUSE = 21,
	Event_type_prev_A = 97,
	Event_type_prev_B = 98,
	Event_type_prev_C = 99,
	Event_type_prev_D = 100,
	Event_type_prev_E = 101,
	Event_type_prev_F = 102,
	Event_type_prev_G = 103,
	Event_type_prev_H = 104,
	Event_type_prev_I = 105,
	Event_type_prev_J = 106,
	Event_type_prev_K = 107,
	Event_type_prev_L = 108,
	Event_type_prev_M = 109,
	Event_type_prev_N = 110,
	Event_type_prev_O = 111,
	Event_type_prev_P = 112,
	Event_type_prev_Q = 113,
	Event_type_prev_R = 114,
	Event_type_prev_S = 115,
	Event_type_prev_T = 116,
	Event_type_prev_U = 117,
	Event_type_prev_V = 118,
	Event_type_prev_W = 119,
	Event_type_prev_X = 120,
	Event_type_prev_Y = 121,
	Event_type_prev_Z = 122,
	Event_type_prev_ZERO = 48,
	Event_type_prev_ONE = 49,
	Event_type_prev_TWO = 50,
	Event_type_prev_THREE = 51,
	Event_type_prev_FOUR = 52,
	Event_type_prev_FIVE = 53,
	Event_type_prev_SIX = 54,
	Event_type_prev_SEVEN = 55,
	Event_type_prev_EIGHT = 56,
	Event_type_prev_NINE = 57,
	Event_type_prev_LEFT_CTRL = 212,
	Event_type_prev_LEFT_ALT = 213,
	Event_type_prev_LEFT_SHIFT = 217,
	Event_type_prev_RIGHT_ALT = 214,
	Event_type_prev_RIGHT_CTRL = 215,
	Event_type_prev_RIGHT_SHIFT = 216,
	Event_type_prev_OSKEY = 172,
	Event_type_prev_HYPER = 179,
	Event_type_prev_APP = 178,
	Event_type_prev_GRLESS = 173,
	Event_type_prev_ESC = 218,
	Event_type_prev_TAB = 219,
	Event_type_prev_RET = 220,
	Event_type_prev_SPACE = 221,
	Event_type_prev_LINE_FEED = 222,
	Event_type_prev_BACK_SPACE = 223,
	Event_type_prev_DEL = 224,
	Event_type_prev_SEMI_COLON = 225,
	Event_type_prev_PERIOD = 226,
	Event_type_prev_COMMA = 227,
	Event_type_prev_QUOTE = 228,
	Event_type_prev_ACCENT_GRAVE = 229,
	Event_type_prev_MINUS = 230,
	Event_type_prev_PLUS = 231,
	Event_type_prev_SLASH = 232,
	Event_type_prev_BACK_SLASH = 233,
	Event_type_prev_EQUAL = 234,
	Event_type_prev_LEFT_BRACKET = 235,
	Event_type_prev_RIGHT_BRACKET = 236,
	Event_type_prev_LEFT_ARROW = 137,
	Event_type_prev_DOWN_ARROW = 138,
	Event_type_prev_RIGHT_ARROW = 139,
	Event_type_prev_UP_ARROW = 140,
	Event_type_prev_NUMPAD_2 = 152,
	Event_type_prev_NUMPAD_4 = 154,
	Event_type_prev_NUMPAD_6 = 156,
	Event_type_prev_NUMPAD_8 = 158,
	Event_type_prev_NUMPAD_1 = 151,
	Event_type_prev_NUMPAD_3 = 153,
	Event_type_prev_NUMPAD_5 = 155,
	Event_type_prev_NUMPAD_7 = 157,
	Event_type_prev_NUMPAD_9 = 159,
	Event_type_prev_NUMPAD_PERIOD = 199,
	Event_type_prev_NUMPAD_SLASH = 161,
	Event_type_prev_NUMPAD_ASTERIX = 160,
	Event_type_prev_NUMPAD_0 = 150,
	Event_type_prev_NUMPAD_MINUS = 162,
	Event_type_prev_NUMPAD_ENTER = 163,
	Event_type_prev_NUMPAD_PLUS = 164,
	Event_type_prev_F1 = 300,
	Event_type_prev_F2 = 301,
	Event_type_prev_F3 = 302,
	Event_type_prev_F4 = 303,
	Event_type_prev_F5 = 304,
	Event_type_prev_F6 = 305,
	Event_type_prev_F7 = 306,
	Event_type_prev_F8 = 307,
	Event_type_prev_F9 = 308,
	Event_type_prev_F10 = 309,
	Event_type_prev_F11 = 310,
	Event_type_prev_F12 = 311,
	Event_type_prev_F13 = 312,
	Event_type_prev_F14 = 313,
	Event_type_prev_F15 = 314,
	Event_type_prev_F16 = 315,
	Event_type_prev_F17 = 316,
	Event_type_prev_F18 = 317,
	Event_type_prev_F19 = 318,
	Event_type_prev_F20 = 319,
	Event_type_prev_F21 = 320,
	Event_type_prev_F22 = 321,
	Event_type_prev_F23 = 322,
	Event_type_prev_F24 = 323,
	Event_type_prev_PAUSE = 165,
	Event_type_prev_INSERT = 166,
	Event_type_prev_HOME = 167,
	Event_type_prev_PAGE_UP = 168,
	Event_type_prev_PAGE_DOWN = 169,
	Event_type_prev_END = 170,
	Event_type_prev_MEDIA_PLAY = 174,
	Event_type_prev_MEDIA_STOP = 175,
	Event_type_prev_MEDIA_FIRST = 176,
	Event_type_prev_MEDIA_LAST = 177,
	Event_type_prev_TEXTINPUT = -2,
	Event_type_prev_WINDOW_DEACTIVATE = 260,
	Event_type_prev_TIMER = 272,
	Event_type_prev_TIMER0 = 273,
	Event_type_prev_TIMER1 = 274,
	Event_type_prev_TIMER2 = 275,
	Event_type_prev_TIMER_JOBS = 276,
	Event_type_prev_TIMER_AUTOSAVE = 277,
	Event_type_prev_TIMER_REPORT = 278,
	Event_type_prev_TIMERREGION = 279,
	Event_type_prev_NDOF_MOTION = 400,
	Event_type_prev_NDOF_BUTTON_MENU = 401,
	Event_type_prev_NDOF_BUTTON_FIT = 402,
	Event_type_prev_NDOF_BUTTON_TOP = 403,
	Event_type_prev_NDOF_BUTTON_BOTTOM = 404,
	Event_type_prev_NDOF_BUTTON_LEFT = 405,
	Event_type_prev_NDOF_BUTTON_RIGHT = 406,
	Event_type_prev_NDOF_BUTTON_FRONT = 407,
	Event_type_prev_NDOF_BUTTON_BACK = 408,
	Event_type_prev_NDOF_BUTTON_ISO1 = 409,
	Event_type_prev_NDOF_BUTTON_ISO2 = 410,
	Event_type_prev_NDOF_BUTTON_ROLL_CW = 411,
	Event_type_prev_NDOF_BUTTON_ROLL_CCW = 412,
	Event_type_prev_NDOF_BUTTON_SPIN_CW = 413,
	Event_type_prev_NDOF_BUTTON_SPIN_CCW = 414,
	Event_type_prev_NDOF_BUTTON_TILT_CW = 415,
	Event_type_prev_NDOF_BUTTON_TILT_CCW = 416,
	Event_type_prev_NDOF_BUTTON_ROTATE = 417,
	Event_type_prev_NDOF_BUTTON_PANZOOM = 418,
	Event_type_prev_NDOF_BUTTON_DOMINANT = 419,
	Event_type_prev_NDOF_BUTTON_PLUS = 420,
	Event_type_prev_NDOF_BUTTON_MINUS = 421,
	Event_type_prev_NDOF_BUTTON_V1 = 422,
	Event_type_prev_NDOF_BUTTON_V2 = 423,
	Event_type_prev_NDOF_BUTTON_V3 = 424,
	Event_type_prev_NDOF_BUTTON_SAVE_V1 = 446,
	Event_type_prev_NDOF_BUTTON_SAVE_V2 = 447,
	Event_type_prev_NDOF_BUTTON_SAVE_V3 = 448,
	Event_type_prev_NDOF_BUTTON_1 = 426,
	Event_type_prev_NDOF_BUTTON_2 = 427,
	Event_type_prev_NDOF_BUTTON_3 = 428,
	Event_type_prev_NDOF_BUTTON_4 = 429,
	Event_type_prev_NDOF_BUTTON_5 = 430,
	Event_type_prev_NDOF_BUTTON_6 = 431,
	Event_type_prev_NDOF_BUTTON_7 = 432,
	Event_type_prev_NDOF_BUTTON_8 = 433,
	Event_type_prev_NDOF_BUTTON_9 = 434,
	Event_type_prev_NDOF_BUTTON_10 = 435,
	Event_type_prev_NDOF_BUTTON_11 = 436,
	Event_type_prev_NDOF_BUTTON_12 = 437,
	Event_type_prev_ACTIONZONE_AREA = 20480,
	Event_type_prev_ACTIONZONE_REGION = 20481,
	Event_type_prev_ACTIONZONE_FULLSCREEN = 20497,
	Event_type_prev_XR_ACTION = 20528,
};

int Event_type_prev_get(PointerRNA *ptr);
void Event_type_prev_set(PointerRNA *ptr, int value);

enum {
	Event_value_prev_ANY = -1,
	Event_value_prev_PRESS = 1,
	Event_value_prev_RELEASE = 2,
	Event_value_prev_CLICK = 3,
	Event_value_prev_DOUBLE_CLICK = 4,
	Event_value_prev_CLICK_DRAG = 5,
	Event_value_prev_NOTHING = 0,
};

int Event_value_prev_get(PointerRNA *ptr);
void Event_value_prev_set(PointerRNA *ptr, int value);

bool Event_shift_get(PointerRNA *ptr);
void Event_shift_set(PointerRNA *ptr, bool value);

float Event_pressure_get(PointerRNA *ptr);
void Event_pressure_set(PointerRNA *ptr, float value);

void Event_tilt_get(PointerRNA *ptr, float values[2]);
void Event_tilt_set(PointerRNA *ptr, const float values[2]);

enum {
	Event_type_NONE = 0,
	Event_type_LEFTMOUSE = 1,
	Event_type_MIDDLEMOUSE = 2,
	Event_type_RIGHTMOUSE = 3,
	Event_type_BUTTON4MOUSE = 7,
	Event_type_BUTTON5MOUSE = 8,
	Event_type_BUTTON6MOUSE = 18,
	Event_type_BUTTON7MOUSE = 19,
	Event_type_PEN = 26,
	Event_type_ERASER = 27,
	Event_type_MOUSEMOVE = 4,
	Event_type_INBETWEEN_MOUSEMOVE = 17,
	Event_type_TRACKPADPAN = 14,
	Event_type_TRACKPADZOOM = 15,
	Event_type_MOUSEROTATE = 16,
	Event_type_MOUSESMARTZOOM = 23,
	Event_type_WHEELUPMOUSE = 10,
	Event_type_WHEELDOWNMOUSE = 11,
	Event_type_WHEELINMOUSE = 12,
	Event_type_WHEELOUTMOUSE = 13,
	Event_type_WHEELLEFTMOUSE = 20,
	Event_type_WHEELRIGHTMOUSE = 21,
	Event_type_A = 97,
	Event_type_B = 98,
	Event_type_C = 99,
	Event_type_D = 100,
	Event_type_E = 101,
	Event_type_F = 102,
	Event_type_G = 103,
	Event_type_H = 104,
	Event_type_I = 105,
	Event_type_J = 106,
	Event_type_K = 107,
	Event_type_L = 108,
	Event_type_M = 109,
	Event_type_N = 110,
	Event_type_O = 111,
	Event_type_P = 112,
	Event_type_Q = 113,
	Event_type_R = 114,
	Event_type_S = 115,
	Event_type_T = 116,
	Event_type_U = 117,
	Event_type_V = 118,
	Event_type_W = 119,
	Event_type_X = 120,
	Event_type_Y = 121,
	Event_type_Z = 122,
	Event_type_ZERO = 48,
	Event_type_ONE = 49,
	Event_type_TWO = 50,
	Event_type_THREE = 51,
	Event_type_FOUR = 52,
	Event_type_FIVE = 53,
	Event_type_SIX = 54,
	Event_type_SEVEN = 55,
	Event_type_EIGHT = 56,
	Event_type_NINE = 57,
	Event_type_LEFT_CTRL = 212,
	Event_type_LEFT_ALT = 213,
	Event_type_LEFT_SHIFT = 217,
	Event_type_RIGHT_ALT = 214,
	Event_type_RIGHT_CTRL = 215,
	Event_type_RIGHT_SHIFT = 216,
	Event_type_OSKEY = 172,
	Event_type_HYPER = 179,
	Event_type_APP = 178,
	Event_type_GRLESS = 173,
	Event_type_ESC = 218,
	Event_type_TAB = 219,
	Event_type_RET = 220,
	Event_type_SPACE = 221,
	Event_type_LINE_FEED = 222,
	Event_type_BACK_SPACE = 223,
	Event_type_DEL = 224,
	Event_type_SEMI_COLON = 225,
	Event_type_PERIOD = 226,
	Event_type_COMMA = 227,
	Event_type_QUOTE = 228,
	Event_type_ACCENT_GRAVE = 229,
	Event_type_MINUS = 230,
	Event_type_PLUS = 231,
	Event_type_SLASH = 232,
	Event_type_BACK_SLASH = 233,
	Event_type_EQUAL = 234,
	Event_type_LEFT_BRACKET = 235,
	Event_type_RIGHT_BRACKET = 236,
	Event_type_LEFT_ARROW = 137,
	Event_type_DOWN_ARROW = 138,
	Event_type_RIGHT_ARROW = 139,
	Event_type_UP_ARROW = 140,
	Event_type_NUMPAD_2 = 152,
	Event_type_NUMPAD_4 = 154,
	Event_type_NUMPAD_6 = 156,
	Event_type_NUMPAD_8 = 158,
	Event_type_NUMPAD_1 = 151,
	Event_type_NUMPAD_3 = 153,
	Event_type_NUMPAD_5 = 155,
	Event_type_NUMPAD_7 = 157,
	Event_type_NUMPAD_9 = 159,
	Event_type_NUMPAD_PERIOD = 199,
	Event_type_NUMPAD_SLASH = 161,
	Event_type_NUMPAD_ASTERIX = 160,
	Event_type_NUMPAD_0 = 150,
	Event_type_NUMPAD_MINUS = 162,
	Event_type_NUMPAD_ENTER = 163,
	Event_type_NUMPAD_PLUS = 164,
	Event_type_F1 = 300,
	Event_type_F2 = 301,
	Event_type_F3 = 302,
	Event_type_F4 = 303,
	Event_type_F5 = 304,
	Event_type_F6 = 305,
	Event_type_F7 = 306,
	Event_type_F8 = 307,
	Event_type_F9 = 308,
	Event_type_F10 = 309,
	Event_type_F11 = 310,
	Event_type_F12 = 311,
	Event_type_F13 = 312,
	Event_type_F14 = 313,
	Event_type_F15 = 314,
	Event_type_F16 = 315,
	Event_type_F17 = 316,
	Event_type_F18 = 317,
	Event_type_F19 = 318,
	Event_type_F20 = 319,
	Event_type_F21 = 320,
	Event_type_F22 = 321,
	Event_type_F23 = 322,
	Event_type_F24 = 323,
	Event_type_PAUSE = 165,
	Event_type_INSERT = 166,
	Event_type_HOME = 167,
	Event_type_PAGE_UP = 168,
	Event_type_PAGE_DOWN = 169,
	Event_type_END = 170,
	Event_type_MEDIA_PLAY = 174,
	Event_type_MEDIA_STOP = 175,
	Event_type_MEDIA_FIRST = 176,
	Event_type_MEDIA_LAST = 177,
	Event_type_TEXTINPUT = -2,
	Event_type_WINDOW_DEACTIVATE = 260,
	Event_type_TIMER = 272,
	Event_type_TIMER0 = 273,
	Event_type_TIMER1 = 274,
	Event_type_TIMER2 = 275,
	Event_type_TIMER_JOBS = 276,
	Event_type_TIMER_AUTOSAVE = 277,
	Event_type_TIMER_REPORT = 278,
	Event_type_TIMERREGION = 279,
	Event_type_NDOF_MOTION = 400,
	Event_type_NDOF_BUTTON_MENU = 401,
	Event_type_NDOF_BUTTON_FIT = 402,
	Event_type_NDOF_BUTTON_TOP = 403,
	Event_type_NDOF_BUTTON_BOTTOM = 404,
	Event_type_NDOF_BUTTON_LEFT = 405,
	Event_type_NDOF_BUTTON_RIGHT = 406,
	Event_type_NDOF_BUTTON_FRONT = 407,
	Event_type_NDOF_BUTTON_BACK = 408,
	Event_type_NDOF_BUTTON_ISO1 = 409,
	Event_type_NDOF_BUTTON_ISO2 = 410,
	Event_type_NDOF_BUTTON_ROLL_CW = 411,
	Event_type_NDOF_BUTTON_ROLL_CCW = 412,
	Event_type_NDOF_BUTTON_SPIN_CW = 413,
	Event_type_NDOF_BUTTON_SPIN_CCW = 414,
	Event_type_NDOF_BUTTON_TILT_CW = 415,
	Event_type_NDOF_BUTTON_TILT_CCW = 416,
	Event_type_NDOF_BUTTON_ROTATE = 417,
	Event_type_NDOF_BUTTON_PANZOOM = 418,
	Event_type_NDOF_BUTTON_DOMINANT = 419,
	Event_type_NDOF_BUTTON_PLUS = 420,
	Event_type_NDOF_BUTTON_MINUS = 421,
	Event_type_NDOF_BUTTON_V1 = 422,
	Event_type_NDOF_BUTTON_V2 = 423,
	Event_type_NDOF_BUTTON_V3 = 424,
	Event_type_NDOF_BUTTON_SAVE_V1 = 446,
	Event_type_NDOF_BUTTON_SAVE_V2 = 447,
	Event_type_NDOF_BUTTON_SAVE_V3 = 448,
	Event_type_NDOF_BUTTON_1 = 426,
	Event_type_NDOF_BUTTON_2 = 427,
	Event_type_NDOF_BUTTON_3 = 428,
	Event_type_NDOF_BUTTON_4 = 429,
	Event_type_NDOF_BUTTON_5 = 430,
	Event_type_NDOF_BUTTON_6 = 431,
	Event_type_NDOF_BUTTON_7 = 432,
	Event_type_NDOF_BUTTON_8 = 433,
	Event_type_NDOF_BUTTON_9 = 434,
	Event_type_NDOF_BUTTON_10 = 435,
	Event_type_NDOF_BUTTON_11 = 436,
	Event_type_NDOF_BUTTON_12 = 437,
	Event_type_ACTIONZONE_AREA = 20480,
	Event_type_ACTIONZONE_REGION = 20481,
	Event_type_ACTIONZONE_FULLSCREEN = 20497,
	Event_type_XR_ACTION = 20528,
};

int Event_type_get(PointerRNA *ptr);
void Event_type_set(PointerRNA *ptr, int value);

void Event_unicode_get(PointerRNA *ptr, char *value);
int Event_unicode_length(PointerRNA *ptr);
void Event_unicode_set(PointerRNA *ptr, const char *value);

enum {
	Event_value_ANY = -1,
	Event_value_PRESS = 1,
	Event_value_RELEASE = 2,
	Event_value_CLICK = 3,
	Event_value_DOUBLE_CLICK = 4,
	Event_value_CLICK_DRAG = 5,
	Event_value_NOTHING = 0,
};

int Event_value_get(PointerRNA *ptr);
void Event_value_set(PointerRNA *ptr, int value);

PointerRNA Event_xr_get(PointerRNA *ptr);

/**************** Explode Modifier ****************/

extern StructRNA RNA_ExplodeModifier;
extern StructRNA RNA_Modifier;

bool ExplodeModifier_show_alive_get(PointerRNA *ptr);
void ExplodeModifier_show_alive_set(PointerRNA *ptr, bool value);

bool ExplodeModifier_use_edge_cut_get(PointerRNA *ptr);
void ExplodeModifier_use_edge_cut_set(PointerRNA *ptr, bool value);

bool ExplodeModifier_show_dead_get(PointerRNA *ptr);
void ExplodeModifier_show_dead_set(PointerRNA *ptr, bool value);

bool ExplodeModifier_invert_vertex_group_get(PointerRNA *ptr);
void ExplodeModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

#define ExplodeModifier_particle_uv_MAX 64

void ExplodeModifier_particle_uv_get(PointerRNA *ptr, char *value);
int ExplodeModifier_particle_uv_length(PointerRNA *ptr);
void ExplodeModifier_particle_uv_set(PointerRNA *ptr, const char *value);

float ExplodeModifier_protect_get(PointerRNA *ptr);
void ExplodeModifier_protect_set(PointerRNA *ptr, float value);

bool ExplodeModifier_use_size_get(PointerRNA *ptr);
void ExplodeModifier_use_size_set(PointerRNA *ptr, bool value);

bool ExplodeModifier_show_unborn_get(PointerRNA *ptr);
void ExplodeModifier_show_unborn_set(PointerRNA *ptr, bool value);

void ExplodeModifier_vertex_group_get(PointerRNA *ptr, char *value);
int ExplodeModifier_vertex_group_length(PointerRNA *ptr);
void ExplodeModifier_vertex_group_set(PointerRNA *ptr, const char *value);

/**************** F-Curve ****************/

extern StructRNA RNA_FCurve;

PointerRNA FCurve_rna_type_get(PointerRNA *ptr);

enum {
	FCurve_auto_smoothing_NONE = 0,
	FCurve_auto_smoothing_CONT_ACCEL = 1,
};

int FCurve_auto_smoothing_get(PointerRNA *ptr);
void FCurve_auto_smoothing_set(PointerRNA *ptr, int value);

void FCurve_color_get(PointerRNA *ptr, float values[3]);
void FCurve_color_set(PointerRNA *ptr, const float values[3]);

enum {
	FCurve_color_mode_AUTO_RAINBOW = 0,
	FCurve_color_mode_AUTO_RGB = 1,
	FCurve_color_mode_AUTO_YRGB = 3,
	FCurve_color_mode_CUSTOM = 2,
};

int FCurve_color_mode_get(PointerRNA *ptr);
void FCurve_color_mode_set(PointerRNA *ptr, int value);

void FCurve_data_path_get(PointerRNA *ptr, char *value);
int FCurve_data_path_length(PointerRNA *ptr);
void FCurve_data_path_set(PointerRNA *ptr, const char *value);

PointerRNA FCurve_driver_get(PointerRNA *ptr);

bool FCurve_is_empty_get(PointerRNA *ptr);
void FCurve_is_empty_set(PointerRNA *ptr, bool value);

enum {
	FCurve_extrapolation_CONSTANT = 0,
	FCurve_extrapolation_LINEAR = 1,
};

int FCurve_extrapolation_get(PointerRNA *ptr);
void FCurve_extrapolation_set(PointerRNA *ptr, int value);

PointerRNA FCurve_group_get(PointerRNA *ptr);

bool FCurve_hide_get(PointerRNA *ptr);
void FCurve_hide_set(PointerRNA *ptr, bool value);

void FCurve_keyframe_points_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void FCurve_keyframe_points_next(CollectionPropertyIterator *iter);
void FCurve_keyframe_points_end(CollectionPropertyIterator *iter);
int FCurve_keyframe_points_length(PointerRNA *ptr);
bool FCurve_keyframe_points_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool FCurve_lock_get(PointerRNA *ptr);
void FCurve_lock_set(PointerRNA *ptr, bool value);

void FCurve_modifiers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void FCurve_modifiers_next(CollectionPropertyIterator *iter);
void FCurve_modifiers_end(CollectionPropertyIterator *iter);
bool FCurve_modifiers_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool FCurve_modifiers_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool FCurve_mute_get(PointerRNA *ptr);
void FCurve_mute_set(PointerRNA *ptr, bool value);

int FCurve_array_index_get(PointerRNA *ptr);
void FCurve_array_index_set(PointerRNA *ptr, int value);

void FCurve_sampled_points_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void FCurve_sampled_points_next(CollectionPropertyIterator *iter);
void FCurve_sampled_points_end(CollectionPropertyIterator *iter);
int FCurve_sampled_points_length(PointerRNA *ptr);
bool FCurve_sampled_points_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool FCurve_select_get(PointerRNA *ptr);
void FCurve_select_set(PointerRNA *ptr, bool value);

bool FCurve_is_valid_get(PointerRNA *ptr);
void FCurve_is_valid_set(PointerRNA *ptr, bool value);

float FCurve_evaluate_func(struct FCurve *_self, float frame);
void FCurve_update_func(struct ID *_selfid, struct FCurve *_self, Main *bmain);
void FCurve_range_func(struct FCurve *_self, float range[2]);
void FCurve_update_autoflags_func(struct FCurve *_self, bContext *C, ReportList *reports, struct PointerRNA *data);
void FCurve_convert_to_samples_func(struct FCurve *_self, ReportList *reports, int start, int end);
void FCurve_convert_to_keyframes_func(struct FCurve *_self, ReportList *reports, int start, int end);
void FCurve_bake_func(struct FCurve *_self, ReportList *reports, int start, int end, float step, int remove);
/**************** Keyframe Points ****************/

extern StructRNA RNA_FCurveKeyframePoints;

PointerRNA FCurveKeyframePoints_rna_type_get(PointerRNA *ptr);

struct BezTriple *FCurveKeyframePoints_insert_func(struct ID *_selfid, struct FCurve *_self, Main *bmain, float frame, float value, int options, int keyframe_type);
void FCurveKeyframePoints_add_func(struct ID *_selfid, struct FCurve *_self, Main *bmain, int count);
void FCurveKeyframePoints_remove_func(struct ID *_selfid, struct FCurve *_self, Main *bmain, ReportList *reports, struct PointerRNA *keyframe, bool fast);
void FCurveKeyframePoints_clear_func(struct ID *_selfid, struct FCurve *_self, Main *bmain);
void FCurveKeyframePoints_sort_func(struct ID *_selfid, struct FCurve *_self, Main *bmain);
void FCurveKeyframePoints_deduplicate_func(struct ID *_selfid, struct FCurve *_self, Main *bmain);
void FCurveKeyframePoints_handles_recalc_func(struct ID *_selfid, struct FCurve *_self, Main *bmain);
/**************** F-Curve Modifiers ****************/

extern StructRNA RNA_FCurveModifiers;

PointerRNA FCurveModifiers_rna_type_get(PointerRNA *ptr);

PointerRNA FCurveModifiers_active_get(PointerRNA *ptr);

struct FModifier *FCurveModifiers_new_func(struct FCurve *_self, int type);
void FCurveModifiers_remove_func(struct FCurve *_self, ReportList *reports, struct PointerRNA *modifier);
/**************** F-Curve Sample ****************/

extern StructRNA RNA_FCurveSample;

PointerRNA FCurveSample_rna_type_get(PointerRNA *ptr);

void FCurveSample_co_get(PointerRNA *ptr, float values[2]);
void FCurveSample_co_set(PointerRNA *ptr, const float values[2]);

bool FCurveSample_select_get(PointerRNA *ptr);
void FCurveSample_select_set(PointerRNA *ptr, bool value);

/**************** FFmpeg Settings ****************/

extern StructRNA RNA_FFmpegSettings;

PointerRNA FFmpegSettings_rna_type_get(PointerRNA *ptr);

enum {
	FFmpegSettings_audio_channels_MONO = 1,
	FFmpegSettings_audio_channels_STEREO = 2,
	FFmpegSettings_audio_channels_SURROUND4 = 4,
	FFmpegSettings_audio_channels_SURROUND51 = 6,
	FFmpegSettings_audio_channels_SURROUND71 = 8,
};

int FFmpegSettings_audio_channels_get(PointerRNA *ptr);
void FFmpegSettings_audio_channels_set(PointerRNA *ptr, int value);

enum {
	FFmpegSettings_audio_codec_NONE = 0,
	FFmpegSettings_audio_codec_AAC = 86018,
	FFmpegSettings_audio_codec_AC3 = 86019,
	FFmpegSettings_audio_codec_FLAC = 86028,
	FFmpegSettings_audio_codec_MP2 = 86016,
	FFmpegSettings_audio_codec_MP3 = 86017,
	FFmpegSettings_audio_codec_OPUS = 86076,
	FFmpegSettings_audio_codec_PCM = 65536,
	FFmpegSettings_audio_codec_VORBIS = 86021,
};

int FFmpegSettings_audio_codec_get(PointerRNA *ptr);
void FFmpegSettings_audio_codec_set(PointerRNA *ptr, int value);

bool FFmpegSettings_use_autosplit_get(PointerRNA *ptr);
void FFmpegSettings_use_autosplit_set(PointerRNA *ptr, bool value);

int FFmpegSettings_video_bitrate_get(PointerRNA *ptr);
void FFmpegSettings_video_bitrate_set(PointerRNA *ptr, int value);

int FFmpegSettings_audio_bitrate_get(PointerRNA *ptr);
void FFmpegSettings_audio_bitrate_set(PointerRNA *ptr, int value);

int FFmpegSettings_buffersize_get(PointerRNA *ptr);
void FFmpegSettings_buffersize_set(PointerRNA *ptr, int value);

enum {
	FFmpegSettings_format_MPEG4 = 2,
	FFmpegSettings_format_MKV = 9,
	FFmpegSettings_format_WEBM = 12,
	FFmpegSettings_format_AVI = 3,
	FFmpegSettings_format_DV = 5,
	FFmpegSettings_format_FLASH = 8,
	FFmpegSettings_format_MPEG1 = 0,
	FFmpegSettings_format_MPEG2 = 1,
	FFmpegSettings_format_OGG = 10,
	FFmpegSettings_format_QUICKTIME = 4,
};

int FFmpegSettings_format_get(PointerRNA *ptr);
void FFmpegSettings_format_set(PointerRNA *ptr, int value);

enum {
	FFmpegSettings_ffmpeg_preset_BEST = 11,
	FFmpegSettings_ffmpeg_preset_GOOD = 10,
	FFmpegSettings_ffmpeg_preset_REALTIME = 12,
};

int FFmpegSettings_ffmpeg_preset_get(PointerRNA *ptr);
void FFmpegSettings_ffmpeg_preset_set(PointerRNA *ptr, int value);

int FFmpegSettings_gopsize_get(PointerRNA *ptr);
void FFmpegSettings_gopsize_set(PointerRNA *ptr, int value);

bool FFmpegSettings_use_lossless_output_get(PointerRNA *ptr);
void FFmpegSettings_use_lossless_output_set(PointerRNA *ptr, bool value);

int FFmpegSettings_max_b_frames_get(PointerRNA *ptr);
void FFmpegSettings_max_b_frames_set(PointerRNA *ptr, int value);

int FFmpegSettings_maxrate_get(PointerRNA *ptr);
void FFmpegSettings_maxrate_set(PointerRNA *ptr, int value);

int FFmpegSettings_minrate_get(PointerRNA *ptr);
void FFmpegSettings_minrate_set(PointerRNA *ptr, int value);

int FFmpegSettings_packetsize_get(PointerRNA *ptr);
void FFmpegSettings_packetsize_set(PointerRNA *ptr, int value);

int FFmpegSettings_muxrate_get(PointerRNA *ptr);
void FFmpegSettings_muxrate_set(PointerRNA *ptr, int value);

enum {
	FFmpegSettings_constant_rate_factor_NONE = -1,
	FFmpegSettings_constant_rate_factor_LOSSLESS = 0,
	FFmpegSettings_constant_rate_factor_PERC_LOSSLESS = 17,
	FFmpegSettings_constant_rate_factor_HIGH = 20,
	FFmpegSettings_constant_rate_factor_MEDIUM = 23,
	FFmpegSettings_constant_rate_factor_LOW = 26,
	FFmpegSettings_constant_rate_factor_VERYLOW = 29,
	FFmpegSettings_constant_rate_factor_LOWEST = 32,
};

int FFmpegSettings_constant_rate_factor_get(PointerRNA *ptr);
void FFmpegSettings_constant_rate_factor_set(PointerRNA *ptr, int value);

enum {
	FFmpegSettings_ffmpeg_prores_profile_422_PROXY = 0,
	FFmpegSettings_ffmpeg_prores_profile_422_LT = 1,
	FFmpegSettings_ffmpeg_prores_profile_422_STD = 2,
	FFmpegSettings_ffmpeg_prores_profile_422_HQ = 3,
	FFmpegSettings_ffmpeg_prores_profile_4444 = 4,
	FFmpegSettings_ffmpeg_prores_profile_4444_XQ = 5,
};

int FFmpegSettings_ffmpeg_prores_profile_get(PointerRNA *ptr);
void FFmpegSettings_ffmpeg_prores_profile_set(PointerRNA *ptr, int value);

int FFmpegSettings_audio_mixrate_get(PointerRNA *ptr);
void FFmpegSettings_audio_mixrate_set(PointerRNA *ptr, int value);

bool FFmpegSettings_use_max_b_frames_get(PointerRNA *ptr);
void FFmpegSettings_use_max_b_frames_set(PointerRNA *ptr, bool value);

enum {
	FFmpegSettings_codec_NONE = 0,
	FFmpegSettings_codec_AV1 = 226,
	FFmpegSettings_codec_H264 = 27,
	FFmpegSettings_codec_H265 = 173,
	FFmpegSettings_codec_WEBM = 167,
	FFmpegSettings_codec_DNXHD = 99,
	FFmpegSettings_codec_DV = 24,
	FFmpegSettings_codec_FFV1 = 33,
	FFmpegSettings_codec_FLASH = 21,
	FFmpegSettings_codec_HUFFYUV = 25,
	FFmpegSettings_codec_MPEG1 = 1,
	FFmpegSettings_codec_MPEG2 = 2,
	FFmpegSettings_codec_MPEG4 = 12,
	FFmpegSettings_codec_PNG = 61,
	FFmpegSettings_codec_PRORES = 147,
	FFmpegSettings_codec_QTRLE = 55,
	FFmpegSettings_codec_THEORA = 30,
};

int FFmpegSettings_codec_get(PointerRNA *ptr);
void FFmpegSettings_codec_set(PointerRNA *ptr, int value);

float FFmpegSettings_audio_volume_get(PointerRNA *ptr);
void FFmpegSettings_audio_volume_set(PointerRNA *ptr, float value);

/**************** F-Modifier ****************/

extern StructRNA RNA_FModifier;

PointerRNA FModifier_rna_type_get(PointerRNA *ptr);

#define FModifier_name_MAX 64

void FModifier_name_get(PointerRNA *ptr, char *value);
int FModifier_name_length(PointerRNA *ptr);
void FModifier_name_set(PointerRNA *ptr, const char *value);

bool FModifier_active_get(PointerRNA *ptr);
void FModifier_active_set(PointerRNA *ptr, bool value);

float FModifier_blend_in_get(PointerRNA *ptr);
void FModifier_blend_in_set(PointerRNA *ptr, float value);

float FModifier_blend_out_get(PointerRNA *ptr);
void FModifier_blend_out_set(PointerRNA *ptr, float value);

bool FModifier_is_valid_get(PointerRNA *ptr);
void FModifier_is_valid_set(PointerRNA *ptr, bool value);

bool FModifier_mute_get(PointerRNA *ptr);
void FModifier_mute_set(PointerRNA *ptr, bool value);

float FModifier_frame_end_get(PointerRNA *ptr);
void FModifier_frame_end_set(PointerRNA *ptr, float value);

bool FModifier_show_expanded_get(PointerRNA *ptr);
void FModifier_show_expanded_set(PointerRNA *ptr, bool value);

float FModifier_influence_get(PointerRNA *ptr);
void FModifier_influence_set(PointerRNA *ptr, float value);

bool FModifier_use_restricted_range_get(PointerRNA *ptr);
void FModifier_use_restricted_range_set(PointerRNA *ptr, bool value);

float FModifier_frame_start_get(PointerRNA *ptr);
void FModifier_frame_start_set(PointerRNA *ptr, float value);

enum {
	FModifier_type_NULL = 0,
	FModifier_type_GENERATOR = 1,
	FModifier_type_FNGENERATOR = 2,
	FModifier_type_ENVELOPE = 3,
	FModifier_type_CYCLES = 4,
	FModifier_type_NOISE = 5,
	FModifier_type_LIMITS = 8,
	FModifier_type_STEPPED = 9,
};

int FModifier_type_get(PointerRNA *ptr);
void FModifier_type_set(PointerRNA *ptr, int value);

bool FModifier_use_influence_get(PointerRNA *ptr);
void FModifier_use_influence_set(PointerRNA *ptr, bool value);

/**************** Cycles F-Modifier ****************/

extern StructRNA RNA_FModifierCycles;
extern StructRNA RNA_FModifier;

int FModifierCycles_cycles_after_get(PointerRNA *ptr);
void FModifierCycles_cycles_after_set(PointerRNA *ptr, int value);

enum {
	FModifierCycles_mode_after_NONE = 0,
	FModifierCycles_mode_after_REPEAT = 1,
	FModifierCycles_mode_after_REPEAT_OFFSET = 2,
	FModifierCycles_mode_after_MIRROR = 3,
};

int FModifierCycles_mode_after_get(PointerRNA *ptr);
void FModifierCycles_mode_after_set(PointerRNA *ptr, int value);

int FModifierCycles_cycles_before_get(PointerRNA *ptr);
void FModifierCycles_cycles_before_set(PointerRNA *ptr, int value);

enum {
	FModifierCycles_mode_before_NONE = 0,
	FModifierCycles_mode_before_REPEAT = 1,
	FModifierCycles_mode_before_REPEAT_OFFSET = 2,
	FModifierCycles_mode_before_MIRROR = 3,
};

int FModifierCycles_mode_before_get(PointerRNA *ptr);
void FModifierCycles_mode_before_set(PointerRNA *ptr, int value);

/**************** Envelope F-Modifier ****************/

extern StructRNA RNA_FModifierEnvelope;
extern StructRNA RNA_FModifier;

void FModifierEnvelope_control_points_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void FModifierEnvelope_control_points_next(CollectionPropertyIterator *iter);
void FModifierEnvelope_control_points_end(CollectionPropertyIterator *iter);
int FModifierEnvelope_control_points_length(PointerRNA *ptr);
bool FModifierEnvelope_control_points_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

float FModifierEnvelope_default_max_get(PointerRNA *ptr);
void FModifierEnvelope_default_max_set(PointerRNA *ptr, float value);

float FModifierEnvelope_default_min_get(PointerRNA *ptr);
void FModifierEnvelope_default_min_set(PointerRNA *ptr, float value);

float FModifierEnvelope_reference_value_get(PointerRNA *ptr);
void FModifierEnvelope_reference_value_set(PointerRNA *ptr, float value);

/**************** Envelope Control Point ****************/

extern StructRNA RNA_FModifierEnvelopeControlPoint;

PointerRNA FModifierEnvelopeControlPoint_rna_type_get(PointerRNA *ptr);

float FModifierEnvelopeControlPoint_frame_get(PointerRNA *ptr);
void FModifierEnvelopeControlPoint_frame_set(PointerRNA *ptr, float value);

float FModifierEnvelopeControlPoint_max_get(PointerRNA *ptr);
void FModifierEnvelopeControlPoint_max_set(PointerRNA *ptr, float value);

float FModifierEnvelopeControlPoint_min_get(PointerRNA *ptr);
void FModifierEnvelopeControlPoint_min_set(PointerRNA *ptr, float value);

/**************** Control Points ****************/

extern StructRNA RNA_FModifierEnvelopeControlPoints;

PointerRNA FModifierEnvelopeControlPoints_rna_type_get(PointerRNA *ptr);

struct FCM_EnvelopeData *FModifierEnvelopeControlPoints_add_func(struct ID *_selfid, struct FModifier *_self, Main *bmain, ReportList *reports, float frame);
void FModifierEnvelopeControlPoints_remove_func(struct ID *_selfid, struct FModifier *_self, Main *bmain, ReportList *reports, struct PointerRNA *point);
/**************** Built-In Function F-Modifier ****************/

extern StructRNA RNA_FModifierFunctionGenerator;
extern StructRNA RNA_FModifier;

bool FModifierFunctionGenerator_use_additive_get(PointerRNA *ptr);
void FModifierFunctionGenerator_use_additive_set(PointerRNA *ptr, bool value);

float FModifierFunctionGenerator_amplitude_get(PointerRNA *ptr);
void FModifierFunctionGenerator_amplitude_set(PointerRNA *ptr, float value);

float FModifierFunctionGenerator_phase_multiplier_get(PointerRNA *ptr);
void FModifierFunctionGenerator_phase_multiplier_set(PointerRNA *ptr, float value);

float FModifierFunctionGenerator_phase_offset_get(PointerRNA *ptr);
void FModifierFunctionGenerator_phase_offset_set(PointerRNA *ptr, float value);

enum {
	FModifierFunctionGenerator_function_type_SIN = 0,
	FModifierFunctionGenerator_function_type_COS = 1,
	FModifierFunctionGenerator_function_type_TAN = 2,
	FModifierFunctionGenerator_function_type_SQRT = 3,
	FModifierFunctionGenerator_function_type_LN = 4,
	FModifierFunctionGenerator_function_type_SINC = 5,
};

int FModifierFunctionGenerator_function_type_get(PointerRNA *ptr);
void FModifierFunctionGenerator_function_type_set(PointerRNA *ptr, int value);

float FModifierFunctionGenerator_value_offset_get(PointerRNA *ptr);
void FModifierFunctionGenerator_value_offset_set(PointerRNA *ptr, float value);

/**************** Generator F-Modifier ****************/

extern StructRNA RNA_FModifierGenerator;
extern StructRNA RNA_FModifier;

bool FModifierGenerator_use_additive_get(PointerRNA *ptr);
void FModifierGenerator_use_additive_set(PointerRNA *ptr, bool value);

void FModifierGenerator_coefficients_get(PointerRNA *ptr, float values[]);
void FModifierGenerator_coefficients_set(PointerRNA *ptr, const float values[]);int FModifierGenerator_coefficients_get_length(PointerRNA *ptr, int *arraylen);

enum {
	FModifierGenerator_mode_POLYNOMIAL = 0,
	FModifierGenerator_mode_POLYNOMIAL_FACTORISED = 1,
};

int FModifierGenerator_mode_get(PointerRNA *ptr);
void FModifierGenerator_mode_set(PointerRNA *ptr, int value);

int FModifierGenerator_poly_order_get(PointerRNA *ptr);
void FModifierGenerator_poly_order_set(PointerRNA *ptr, int value);

/**************** Limit F-Modifier ****************/

extern StructRNA RNA_FModifierLimits;
extern StructRNA RNA_FModifier;

bool FModifierLimits_use_max_x_get(PointerRNA *ptr);
void FModifierLimits_use_max_x_set(PointerRNA *ptr, bool value);

float FModifierLimits_max_x_get(PointerRNA *ptr);
void FModifierLimits_max_x_set(PointerRNA *ptr, float value);

bool FModifierLimits_use_max_y_get(PointerRNA *ptr);
void FModifierLimits_use_max_y_set(PointerRNA *ptr, bool value);

float FModifierLimits_max_y_get(PointerRNA *ptr);
void FModifierLimits_max_y_set(PointerRNA *ptr, float value);

bool FModifierLimits_use_min_x_get(PointerRNA *ptr);
void FModifierLimits_use_min_x_set(PointerRNA *ptr, bool value);

float FModifierLimits_min_x_get(PointerRNA *ptr);
void FModifierLimits_min_x_set(PointerRNA *ptr, float value);

bool FModifierLimits_use_min_y_get(PointerRNA *ptr);
void FModifierLimits_use_min_y_set(PointerRNA *ptr, bool value);

float FModifierLimits_min_y_get(PointerRNA *ptr);
void FModifierLimits_min_y_set(PointerRNA *ptr, float value);

/**************** Noise F-Modifier ****************/

extern StructRNA RNA_FModifierNoise;
extern StructRNA RNA_FModifier;

enum {
	FModifierNoise_blend_type_REPLACE = 0,
	FModifierNoise_blend_type_ADD = 1,
	FModifierNoise_blend_type_SUBTRACT = 2,
	FModifierNoise_blend_type_MULTIPLY = 3,
};

int FModifierNoise_blend_type_get(PointerRNA *ptr);
void FModifierNoise_blend_type_set(PointerRNA *ptr, int value);

int FModifierNoise_depth_get(PointerRNA *ptr);
void FModifierNoise_depth_set(PointerRNA *ptr, int value);

float FModifierNoise_lacunarity_get(PointerRNA *ptr);
void FModifierNoise_lacunarity_set(PointerRNA *ptr, float value);

bool FModifierNoise_use_legacy_noise_get(PointerRNA *ptr);
void FModifierNoise_use_legacy_noise_set(PointerRNA *ptr, bool value);

float FModifierNoise_offset_get(PointerRNA *ptr);
void FModifierNoise_offset_set(PointerRNA *ptr, float value);

float FModifierNoise_phase_get(PointerRNA *ptr);
void FModifierNoise_phase_set(PointerRNA *ptr, float value);

float FModifierNoise_roughness_get(PointerRNA *ptr);
void FModifierNoise_roughness_set(PointerRNA *ptr, float value);

float FModifierNoise_scale_get(PointerRNA *ptr);
void FModifierNoise_scale_set(PointerRNA *ptr, float value);

float FModifierNoise_strength_get(PointerRNA *ptr);
void FModifierNoise_strength_set(PointerRNA *ptr, float value);

/**************** Stepped Interpolation F-Modifier ****************/

extern StructRNA RNA_FModifierStepped;
extern StructRNA RNA_FModifier;

float FModifierStepped_frame_end_get(PointerRNA *ptr);
void FModifierStepped_frame_end_set(PointerRNA *ptr, float value);

float FModifierStepped_frame_offset_get(PointerRNA *ptr);
void FModifierStepped_frame_offset_set(PointerRNA *ptr, float value);

float FModifierStepped_frame_start_get(PointerRNA *ptr);
void FModifierStepped_frame_start_set(PointerRNA *ptr, float value);

float FModifierStepped_frame_step_get(PointerRNA *ptr);
void FModifierStepped_frame_step_set(PointerRNA *ptr, float value);

bool FModifierStepped_use_frame_end_get(PointerRNA *ptr);
void FModifierStepped_use_frame_end_set(PointerRNA *ptr, bool value);

bool FModifierStepped_use_frame_start_get(PointerRNA *ptr);
void FModifierStepped_use_frame_start_set(PointerRNA *ptr, bool value);

/**************** Field Settings ****************/

extern StructRNA RNA_FieldSettings;

PointerRNA FieldSettings_rna_type_get(PointerRNA *ptr);

bool FieldSettings_use_2d_force_get(PointerRNA *ptr);
void FieldSettings_use_2d_force_set(PointerRNA *ptr, bool value);

bool FieldSettings_use_absorption_get(PointerRNA *ptr);
void FieldSettings_use_absorption_set(PointerRNA *ptr, bool value);

bool FieldSettings_use_guide_path_add_get(PointerRNA *ptr);
void FieldSettings_use_guide_path_add_set(PointerRNA *ptr, bool value);

float FieldSettings_guide_clump_amount_get(PointerRNA *ptr);
void FieldSettings_guide_clump_amount_set(PointerRNA *ptr, float value);

float FieldSettings_guide_kink_amplitude_get(PointerRNA *ptr);
void FieldSettings_guide_kink_amplitude_set(PointerRNA *ptr, float value);

bool FieldSettings_use_smoke_density_get(PointerRNA *ptr);
void FieldSettings_use_smoke_density_set(PointerRNA *ptr, bool value);

enum {
	FieldSettings_guide_kink_axis_X = 0,
	FieldSettings_guide_kink_axis_Y = 1,
	FieldSettings_guide_kink_axis_Z = 2,
};

int FieldSettings_guide_kink_axis_get(PointerRNA *ptr);
void FieldSettings_guide_kink_axis_set(PointerRNA *ptr, int value);

PointerRNA FieldSettings_source_object_get(PointerRNA *ptr);

enum {
	FieldSettings_falloff_type_CONE = 2,
	FieldSettings_falloff_type_SPHERE = 0,
	FieldSettings_falloff_type_TUBE = 1,
};

int FieldSettings_falloff_type_get(PointerRNA *ptr);
void FieldSettings_falloff_type_set(PointerRNA *ptr, int value);

float FieldSettings_falloff_power_get(PointerRNA *ptr);
void FieldSettings_falloff_power_set(PointerRNA *ptr, float value);

float FieldSettings_flow_get(PointerRNA *ptr);
void FieldSettings_flow_set(PointerRNA *ptr, float value);

float FieldSettings_guide_free_get(PointerRNA *ptr);
void FieldSettings_guide_free_set(PointerRNA *ptr, float value);

float FieldSettings_guide_kink_frequency_get(PointerRNA *ptr);
void FieldSettings_guide_kink_frequency_set(PointerRNA *ptr, float value);

bool FieldSettings_use_gravity_falloff_get(PointerRNA *ptr);
void FieldSettings_use_gravity_falloff_set(PointerRNA *ptr, bool value);

float FieldSettings_harmonic_damping_get(PointerRNA *ptr);
void FieldSettings_harmonic_damping_set(PointerRNA *ptr, float value);

float FieldSettings_inflow_get(PointerRNA *ptr);
void FieldSettings_inflow_set(PointerRNA *ptr, float value);

enum {
	FieldSettings_guide_kink_type_NONE = 0,
	FieldSettings_guide_kink_type_BRAID = 4,
	FieldSettings_guide_kink_type_CURL = 1,
	FieldSettings_guide_kink_type_RADIAL = 2,
	FieldSettings_guide_kink_type_ROLL = 6,
	FieldSettings_guide_kink_type_ROTATION = 5,
	FieldSettings_guide_kink_type_WAVE = 3,
};

int FieldSettings_guide_kink_type_get(PointerRNA *ptr);
void FieldSettings_guide_kink_type_set(PointerRNA *ptr, int value);

float FieldSettings_linear_drag_get(PointerRNA *ptr);
void FieldSettings_linear_drag_set(PointerRNA *ptr, float value);

bool FieldSettings_apply_to_location_get(PointerRNA *ptr);
void FieldSettings_apply_to_location_set(PointerRNA *ptr, bool value);

float FieldSettings_distance_max_get(PointerRNA *ptr);
void FieldSettings_distance_max_set(PointerRNA *ptr, float value);

float FieldSettings_radial_max_get(PointerRNA *ptr);
void FieldSettings_radial_max_set(PointerRNA *ptr, float value);

float FieldSettings_distance_min_get(PointerRNA *ptr);
void FieldSettings_distance_min_set(PointerRNA *ptr, float value);

float FieldSettings_guide_minimum_get(PointerRNA *ptr);
void FieldSettings_guide_minimum_set(PointerRNA *ptr, float value);

float FieldSettings_radial_min_get(PointerRNA *ptr);
void FieldSettings_radial_min_set(PointerRNA *ptr, float value);

bool FieldSettings_use_multiple_springs_get(PointerRNA *ptr);
void FieldSettings_use_multiple_springs_set(PointerRNA *ptr, bool value);

float FieldSettings_texture_nabla_get(PointerRNA *ptr);
void FieldSettings_texture_nabla_set(PointerRNA *ptr, float value);

float FieldSettings_noise_get(PointerRNA *ptr);
void FieldSettings_noise_set(PointerRNA *ptr, float value);

float FieldSettings_quadratic_drag_get(PointerRNA *ptr);
void FieldSettings_quadratic_drag_set(PointerRNA *ptr, float value);

float FieldSettings_radial_falloff_get(PointerRNA *ptr);
void FieldSettings_radial_falloff_set(PointerRNA *ptr, float value);

float FieldSettings_rest_length_get(PointerRNA *ptr);
void FieldSettings_rest_length_set(PointerRNA *ptr, float value);

bool FieldSettings_use_root_coords_get(PointerRNA *ptr);
void FieldSettings_use_root_coords_set(PointerRNA *ptr, bool value);

bool FieldSettings_apply_to_rotation_get(PointerRNA *ptr);
void FieldSettings_apply_to_rotation_set(PointerRNA *ptr, bool value);

int FieldSettings_seed_get(PointerRNA *ptr);
void FieldSettings_seed_set(PointerRNA *ptr, int value);

enum {
	FieldSettings_shape_POINT = 0,
	FieldSettings_shape_LINE = 4,
	FieldSettings_shape_PLANE = 1,
	FieldSettings_shape_SURFACE = 2,
	FieldSettings_shape_POINTS = 3,
};

int FieldSettings_shape_get(PointerRNA *ptr);
void FieldSettings_shape_set(PointerRNA *ptr, int value);

float FieldSettings_guide_clump_shape_get(PointerRNA *ptr);
void FieldSettings_guide_clump_shape_set(PointerRNA *ptr, float value);

float FieldSettings_guide_kink_shape_get(PointerRNA *ptr);
void FieldSettings_guide_kink_shape_set(PointerRNA *ptr, float value);

float FieldSettings_size_get(PointerRNA *ptr);
void FieldSettings_size_set(PointerRNA *ptr, float value);

float FieldSettings_strength_get(PointerRNA *ptr);
void FieldSettings_strength_set(PointerRNA *ptr, float value);

PointerRNA FieldSettings_texture_get(PointerRNA *ptr);

enum {
	FieldSettings_texture_mode_CURL = 2,
	FieldSettings_texture_mode_GRADIENT = 1,
	FieldSettings_texture_mode_RGB = 0,
};

int FieldSettings_texture_mode_get(PointerRNA *ptr);
void FieldSettings_texture_mode_set(PointerRNA *ptr, int value);

enum {
	FieldSettings_type_NONE = 0,
	FieldSettings_type_BOID = 10,
	FieldSettings_type_CHARGE = 8,
	FieldSettings_type_GUIDE = 5,
	FieldSettings_type_DRAG = 12,
	FieldSettings_type_FLUID_FLOW = 13,
	FieldSettings_type_FORCE = 1,
	FieldSettings_type_HARMONIC = 7,
	FieldSettings_type_LENNARDJ = 9,
	FieldSettings_type_MAGNET = 3,
	FieldSettings_type_TEXTURE = 6,
	FieldSettings_type_TURBULENCE = 11,
	FieldSettings_type_VORTEX = 2,
	FieldSettings_type_WIND = 4,
};

int FieldSettings_type_get(PointerRNA *ptr);
void FieldSettings_type_set(PointerRNA *ptr, int value);

bool FieldSettings_use_object_coords_get(PointerRNA *ptr);
void FieldSettings_use_object_coords_set(PointerRNA *ptr, bool value);

bool FieldSettings_use_global_coords_get(PointerRNA *ptr);
void FieldSettings_use_global_coords_set(PointerRNA *ptr, bool value);

bool FieldSettings_use_max_distance_get(PointerRNA *ptr);
void FieldSettings_use_max_distance_set(PointerRNA *ptr, bool value);

bool FieldSettings_use_radial_max_get(PointerRNA *ptr);
void FieldSettings_use_radial_max_set(PointerRNA *ptr, bool value);

bool FieldSettings_use_min_distance_get(PointerRNA *ptr);
void FieldSettings_use_min_distance_set(PointerRNA *ptr, bool value);

bool FieldSettings_use_radial_min_get(PointerRNA *ptr);
void FieldSettings_use_radial_min_set(PointerRNA *ptr, bool value);

bool FieldSettings_use_guide_path_weight_get(PointerRNA *ptr);
void FieldSettings_use_guide_path_weight_set(PointerRNA *ptr, bool value);

float FieldSettings_wind_factor_get(PointerRNA *ptr);
void FieldSettings_wind_factor_set(PointerRNA *ptr, float value);

enum {
	FieldSettings_z_direction_POSITIVE = 1,
	FieldSettings_z_direction_NEGATIVE = 2,
	FieldSettings_z_direction_BOTH = 0,
};

int FieldSettings_z_direction_get(PointerRNA *ptr);
void FieldSettings_z_direction_set(PointerRNA *ptr, int value);

/**************** File Select Asset Filter ****************/

extern StructRNA RNA_FileAssetSelectIDFilter;

PointerRNA FileAssetSelectIDFilter_rna_type_get(PointerRNA *ptr);

bool FileAssetSelectIDFilter_filter_action_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_filter_action_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_armature_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_armature_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_filter_brush_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_filter_brush_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_cachefile_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_cachefile_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_camera_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_camera_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_filter_group_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_filter_group_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_curve_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_curve_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_font_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_font_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_linestyle_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_linestyle_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_grease_pencil_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_grease_pencil_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_curves_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_curves_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_image_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_image_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_lattice_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_lattice_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_light_probe_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_light_probe_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_light_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_light_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_mask_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_mask_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_filter_material_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_filter_material_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_mesh_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_mesh_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_metaball_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_metaball_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_movie_clip_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_movie_clip_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_filter_node_tree_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_filter_node_tree_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_filter_object_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_filter_object_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_paint_curve_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_paint_curve_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_palette_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_palette_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_particle_settings_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_particle_settings_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_pointcloud_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_pointcloud_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_scene_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_scene_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_sound_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_sound_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_speaker_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_speaker_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_text_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_text_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_texture_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_texture_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_volume_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_volume_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_experimental_filter_work_space_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_experimental_filter_work_space_set(PointerRNA *ptr, bool value);

bool FileAssetSelectIDFilter_filter_world_get(PointerRNA *ptr);
void FileAssetSelectIDFilter_filter_world_set(PointerRNA *ptr, bool value);

/**************** Asset Select Parameters ****************/

extern StructRNA RNA_FileAssetSelectParams;
extern StructRNA RNA_FileSelectParams;

enum {
	FileAssetSelectParams_asset_library_reference_ALL = 2,
	FileAssetSelectParams_asset_library_reference_LOCAL = 1,
	FileAssetSelectParams_asset_library_reference_ESSENTIALS = 3,
	FileAssetSelectParams_asset_library_reference_CUSTOM = 100,
};

int FileAssetSelectParams_asset_library_reference_get(PointerRNA *ptr);
void FileAssetSelectParams_asset_library_reference_set(PointerRNA *ptr, int value);

void FileAssetSelectParams_catalog_id_get(PointerRNA *ptr, char *value);
int FileAssetSelectParams_catalog_id_length(PointerRNA *ptr);
void FileAssetSelectParams_catalog_id_set(PointerRNA *ptr, const char *value);

PointerRNA FileAssetSelectParams_filter_asset_id_get(PointerRNA *ptr);

enum {
	FileAssetSelectParams_import_method_FOLLOW_PREFS = 3,
	FileAssetSelectParams_import_method_LINK = 0,
	FileAssetSelectParams_import_method_APPEND = 1,
	FileAssetSelectParams_import_method_APPEND_REUSE = 2,
};

int FileAssetSelectParams_import_method_get(PointerRNA *ptr);
void FileAssetSelectParams_import_method_set(PointerRNA *ptr, int value);

bool FileAssetSelectParams_instance_collections_on_append_get(PointerRNA *ptr);
void FileAssetSelectParams_instance_collections_on_append_set(PointerRNA *ptr, bool value);

bool FileAssetSelectParams_instance_collections_on_link_get(PointerRNA *ptr);
void FileAssetSelectParams_instance_collections_on_link_set(PointerRNA *ptr, bool value);

/**************** File Select Parameters ****************/

extern StructRNA RNA_FileBrowserFSMenuEntry;

PointerRNA FileBrowserFSMenuEntry_rna_type_get(PointerRNA *ptr);

void FileBrowserFSMenuEntry_name_get(PointerRNA *ptr, char *value);
int FileBrowserFSMenuEntry_name_length(PointerRNA *ptr);
void FileBrowserFSMenuEntry_name_set(PointerRNA *ptr, const char *value);

int FileBrowserFSMenuEntry_icon_get(PointerRNA *ptr);
void FileBrowserFSMenuEntry_icon_set(PointerRNA *ptr, int value);

void FileBrowserFSMenuEntry_path_get(PointerRNA *ptr, char *value);
int FileBrowserFSMenuEntry_path_length(PointerRNA *ptr);
void FileBrowserFSMenuEntry_path_set(PointerRNA *ptr, const char *value);

bool FileBrowserFSMenuEntry_use_save_get(PointerRNA *ptr);
void FileBrowserFSMenuEntry_use_save_set(PointerRNA *ptr, bool value);

bool FileBrowserFSMenuEntry_is_valid_get(PointerRNA *ptr);
void FileBrowserFSMenuEntry_is_valid_set(PointerRNA *ptr, bool value);

/**************** File Handler Type ****************/

extern StructRNA RNA_FileHandler;

PointerRNA FileHandler_rna_type_get(PointerRNA *ptr);

void FileHandler_bl_file_extensions_get(PointerRNA *ptr, char *value);
int FileHandler_bl_file_extensions_length(PointerRNA *ptr);
void FileHandler_bl_file_extensions_set(PointerRNA *ptr, const char *value);

void FileHandler_bl_idname_get(PointerRNA *ptr, char *value);
int FileHandler_bl_idname_length(PointerRNA *ptr);
void FileHandler_bl_idname_set(PointerRNA *ptr, const char *value);

void FileHandler_bl_label_get(PointerRNA *ptr, char *value);
int FileHandler_bl_label_length(PointerRNA *ptr);
void FileHandler_bl_label_set(PointerRNA *ptr, const char *value);

void FileHandler_bl_import_operator_get(PointerRNA *ptr, char *value);
int FileHandler_bl_import_operator_length(PointerRNA *ptr);
void FileHandler_bl_import_operator_set(PointerRNA *ptr, const char *value);

void FileHandler_bl_export_operator_get(PointerRNA *ptr, char *value);
int FileHandler_bl_export_operator_length(PointerRNA *ptr);
void FileHandler_bl_export_operator_set(PointerRNA *ptr, const char *value);

bool FileHandler_poll_drop_func(struct bContext *context);
/**************** File Select Entry ****************/

extern StructRNA RNA_FileSelectEntry;

PointerRNA FileSelectEntry_rna_type_get(PointerRNA *ptr);

void FileSelectEntry_name_get(PointerRNA *ptr, char *value);
int FileSelectEntry_name_length(PointerRNA *ptr);
void FileSelectEntry_name_set(PointerRNA *ptr, const char *value);

PointerRNA FileSelectEntry_asset_data_get(PointerRNA *ptr);

int FileSelectEntry_preview_icon_id_get(PointerRNA *ptr);
void FileSelectEntry_preview_icon_id_set(PointerRNA *ptr, int value);

void FileSelectEntry_relative_path_get(PointerRNA *ptr, char *value);
int FileSelectEntry_relative_path_length(PointerRNA *ptr);
void FileSelectEntry_relative_path_set(PointerRNA *ptr, const char *value);

/**************** File Select ID Filter ****************/

extern StructRNA RNA_FileSelectIDFilter;

PointerRNA FileSelectIDFilter_rna_type_get(PointerRNA *ptr);

bool FileSelectIDFilter_filter_action_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_action_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_category_animation_get(PointerRNA *ptr);
void FileSelectIDFilter_category_animation_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_armature_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_armature_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_brush_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_brush_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_cachefile_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_cachefile_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_camera_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_camera_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_group_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_group_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_curve_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_curve_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_category_environment_get(PointerRNA *ptr);
void FileSelectIDFilter_category_environment_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_font_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_font_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_linestyle_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_linestyle_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_category_geometry_get(PointerRNA *ptr);
void FileSelectIDFilter_category_geometry_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_grease_pencil_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_grease_pencil_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_curves_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_curves_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_image_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_image_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_category_image_get(PointerRNA *ptr);
void FileSelectIDFilter_category_image_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_lattice_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_lattice_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_light_probe_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_light_probe_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_light_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_light_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_mask_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_mask_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_material_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_material_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_mesh_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_mesh_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_metaball_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_metaball_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_category_misc_get(PointerRNA *ptr);
void FileSelectIDFilter_category_misc_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_movie_clip_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_movie_clip_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_node_tree_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_node_tree_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_object_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_object_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_category_object_get(PointerRNA *ptr);
void FileSelectIDFilter_category_object_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_paint_curve_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_paint_curve_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_palette_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_palette_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_particle_settings_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_particle_settings_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_pointcloud_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_pointcloud_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_scene_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_scene_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_category_scene_get(PointerRNA *ptr);
void FileSelectIDFilter_category_scene_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_category_shading_get(PointerRNA *ptr);
void FileSelectIDFilter_category_shading_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_sound_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_sound_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_speaker_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_speaker_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_text_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_text_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_texture_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_texture_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_volume_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_volume_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_work_space_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_work_space_set(PointerRNA *ptr, bool value);

bool FileSelectIDFilter_filter_world_get(PointerRNA *ptr);
void FileSelectIDFilter_filter_world_set(PointerRNA *ptr, bool value);

/**************** File Select Parameters ****************/

extern StructRNA RNA_FileSelectParams;

PointerRNA FileSelectParams_rna_type_get(PointerRNA *ptr);

int FileSelectParams_list_column_size_get(PointerRNA *ptr);
void FileSelectParams_list_column_size_set(PointerRNA *ptr, int value);

#define FileSelectParams_directory_MAX 1090

void FileSelectParams_directory_get(PointerRNA *ptr, char *value);
int FileSelectParams_directory_length(PointerRNA *ptr);
void FileSelectParams_directory_set(PointerRNA *ptr, const char *value);

enum {
	FileSelectParams_display_type_LIST_VERTICAL = 1,
	FileSelectParams_display_type_LIST_HORIZONTAL = 2,
	FileSelectParams_display_type_THUMBNAIL = 3,
};

int FileSelectParams_display_type_get(PointerRNA *ptr);
void FileSelectParams_display_type_set(PointerRNA *ptr, int value);

int FileSelectParams_display_size_get(PointerRNA *ptr);
void FileSelectParams_display_size_set(PointerRNA *ptr, int value);

enum {
	FileSelectParams_display_size_discrete_TINY = 32,
	FileSelectParams_display_size_discrete_SMALL = 64,
	FileSelectParams_display_size_discrete_NORMAL = 96,
	FileSelectParams_display_size_discrete_BIG = 128,
	FileSelectParams_display_size_discrete_LARGE = 192,
};

int FileSelectParams_display_size_discrete_get(PointerRNA *ptr);
void FileSelectParams_display_size_discrete_set(PointerRNA *ptr, int value);

int FileSelectParams_list_display_size_get(PointerRNA *ptr);
void FileSelectParams_list_display_size_set(PointerRNA *ptr, int value);

#define FileSelectParams_filter_glob_MAX 256

void FileSelectParams_filter_glob_get(PointerRNA *ptr, char *value);
int FileSelectParams_filter_glob_length(PointerRNA *ptr);
void FileSelectParams_filter_glob_set(PointerRNA *ptr, const char *value);

bool FileSelectParams_show_details_datetime_get(PointerRNA *ptr);
void FileSelectParams_show_details_datetime_set(PointerRNA *ptr, bool value);

#define FileSelectParams_filename_MAX 256

void FileSelectParams_filename_get(PointerRNA *ptr, char *value);
int FileSelectParams_filename_length(PointerRNA *ptr);
void FileSelectParams_filename_set(PointerRNA *ptr, const char *value);

bool FileSelectParams_show_details_size_get(PointerRNA *ptr);
void FileSelectParams_show_details_size_set(PointerRNA *ptr, bool value);

bool FileSelectParams_use_filter_blender_get(PointerRNA *ptr);
void FileSelectParams_use_filter_blender_set(PointerRNA *ptr, bool value);

bool FileSelectParams_use_filter_backup_get(PointerRNA *ptr);
void FileSelectParams_use_filter_backup_set(PointerRNA *ptr, bool value);

bool FileSelectParams_use_filter_blendid_get(PointerRNA *ptr);
void FileSelectParams_use_filter_blendid_set(PointerRNA *ptr, bool value);

bool FileSelectParams_use_filter_get(PointerRNA *ptr);
void FileSelectParams_use_filter_set(PointerRNA *ptr, bool value);

bool FileSelectParams_use_filter_folder_get(PointerRNA *ptr);
void FileSelectParams_use_filter_folder_set(PointerRNA *ptr, bool value);

bool FileSelectParams_use_filter_font_get(PointerRNA *ptr);
void FileSelectParams_use_filter_font_set(PointerRNA *ptr, bool value);

PointerRNA FileSelectParams_filter_id_get(PointerRNA *ptr);

bool FileSelectParams_use_filter_image_get(PointerRNA *ptr);
void FileSelectParams_use_filter_image_set(PointerRNA *ptr, bool value);

bool FileSelectParams_use_filter_movie_get(PointerRNA *ptr);
void FileSelectParams_use_filter_movie_set(PointerRNA *ptr, bool value);

bool FileSelectParams_use_filter_script_get(PointerRNA *ptr);
void FileSelectParams_use_filter_script_set(PointerRNA *ptr, bool value);

bool FileSelectParams_use_filter_sound_get(PointerRNA *ptr);
void FileSelectParams_use_filter_sound_set(PointerRNA *ptr, bool value);

bool FileSelectParams_use_filter_text_get(PointerRNA *ptr);
void FileSelectParams_use_filter_text_set(PointerRNA *ptr, bool value);

bool FileSelectParams_use_filter_volume_get(PointerRNA *ptr);
void FileSelectParams_use_filter_volume_set(PointerRNA *ptr, bool value);

bool FileSelectParams_use_library_browsing_get(PointerRNA *ptr);
void FileSelectParams_use_library_browsing_set(PointerRNA *ptr, bool value);

#define FileSelectParams_filter_search_MAX 64

void FileSelectParams_filter_search_get(PointerRNA *ptr, char *value);
int FileSelectParams_filter_search_length(PointerRNA *ptr);
void FileSelectParams_filter_search_set(PointerRNA *ptr, const char *value);

bool FileSelectParams_use_filter_asset_only_get(PointerRNA *ptr);
void FileSelectParams_use_filter_asset_only_set(PointerRNA *ptr, bool value);

enum {
	FileSelectParams_recursion_level_NONE = 0,
	FileSelectParams_recursion_level_BLEND = 1,
	FileSelectParams_recursion_level_ALL_1 = 2,
	FileSelectParams_recursion_level_ALL_2 = 3,
	FileSelectParams_recursion_level_ALL_3 = 4,
};

int FileSelectParams_recursion_level_get(PointerRNA *ptr);
void FileSelectParams_recursion_level_set(PointerRNA *ptr, int value);

bool FileSelectParams_use_sort_invert_get(PointerRNA *ptr);
void FileSelectParams_use_sort_invert_set(PointerRNA *ptr, bool value);

bool FileSelectParams_show_hidden_get(PointerRNA *ptr);
void FileSelectParams_show_hidden_set(PointerRNA *ptr, bool value);

enum {
	FileSelectParams_sort_method_FILE_SORT_ALPHA = 1,
	FileSelectParams_sort_method_FILE_SORT_EXTENSION = 2,
	FileSelectParams_sort_method_FILE_SORT_TIME = 3,
	FileSelectParams_sort_method_FILE_SORT_SIZE = 4,
	FileSelectParams_sort_method_ASSET_CATALOG = 5,
};

int FileSelectParams_sort_method_get(PointerRNA *ptr);
void FileSelectParams_sort_method_set(PointerRNA *ptr, int value);

#define FileSelectParams_title_MAX 96

void FileSelectParams_title_get(PointerRNA *ptr, char *value);
int FileSelectParams_title_length(PointerRNA *ptr);
void FileSelectParams_title_set(PointerRNA *ptr, const char *value);

/**************** Float2 Attribute ****************/

extern StructRNA RNA_Float2Attribute;
extern StructRNA RNA_Attribute;

void Float2Attribute_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Float2Attribute_data_next(CollectionPropertyIterator *iter);
void Float2Attribute_data_end(CollectionPropertyIterator *iter);
int Float2Attribute_data_length(PointerRNA *ptr);
bool Float2Attribute_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Float2 Attribute Value ****************/

extern StructRNA RNA_Float2AttributeValue;

PointerRNA Float2AttributeValue_rna_type_get(PointerRNA *ptr);

void Float2AttributeValue_vector_get(PointerRNA *ptr, float values[2]);
void Float2AttributeValue_vector_set(PointerRNA *ptr, const float values[2]);

/**************** 4x4 Matrix Attribute ****************/

extern StructRNA RNA_Float4x4Attribute;
extern StructRNA RNA_Attribute;

void Float4x4Attribute_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Float4x4Attribute_data_next(CollectionPropertyIterator *iter);
void Float4x4Attribute_data_end(CollectionPropertyIterator *iter);
int Float4x4Attribute_data_length(PointerRNA *ptr);
bool Float4x4Attribute_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Matrix Attribute Value ****************/

extern StructRNA RNA_Float4x4AttributeValue;

PointerRNA Float4x4AttributeValue_rna_type_get(PointerRNA *ptr);

void Float4x4AttributeValue_value_get(PointerRNA *ptr, float values[16]);
void Float4x4AttributeValue_value_set(PointerRNA *ptr, const float values[16]);

/**************** Float Attribute ****************/

extern StructRNA RNA_FloatAttribute;
extern StructRNA RNA_Attribute;

void FloatAttribute_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void FloatAttribute_data_next(CollectionPropertyIterator *iter);
void FloatAttribute_data_end(CollectionPropertyIterator *iter);
int FloatAttribute_data_length(PointerRNA *ptr);
bool FloatAttribute_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Float Attribute Value ****************/

extern StructRNA RNA_FloatAttributeValue;

PointerRNA FloatAttributeValue_rna_type_get(PointerRNA *ptr);

float FloatAttributeValue_value_get(PointerRNA *ptr);
void FloatAttributeValue_value_set(PointerRNA *ptr, float value);

/**************** Float Color Attribute ****************/

extern StructRNA RNA_FloatColorAttribute;
extern StructRNA RNA_Attribute;

void FloatColorAttribute_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void FloatColorAttribute_data_next(CollectionPropertyIterator *iter);
void FloatColorAttribute_data_end(CollectionPropertyIterator *iter);
int FloatColorAttribute_data_length(PointerRNA *ptr);
bool FloatColorAttribute_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Float Color Attribute Value ****************/

extern StructRNA RNA_FloatColorAttributeValue;

PointerRNA FloatColorAttributeValue_rna_type_get(PointerRNA *ptr);

void FloatColorAttributeValue_color_get(PointerRNA *ptr, float values[4]);
void FloatColorAttributeValue_color_set(PointerRNA *ptr, const float values[4]);

void FloatColorAttributeValue_color_srgb_get(PointerRNA *ptr, float values[4]);
void FloatColorAttributeValue_color_srgb_set(PointerRNA *ptr, const float values[4]);

/**************** Float Definition ****************/

extern StructRNA RNA_FloatProperty;
extern StructRNA RNA_Property;

void FloatProperty_array_dimensions_get(PointerRNA *ptr, int values[3]);
void FloatProperty_array_dimensions_set(PointerRNA *ptr, const int values[3]);

int FloatProperty_array_length_get(PointerRNA *ptr);
void FloatProperty_array_length_set(PointerRNA *ptr, int value);

float FloatProperty_default_value_get(PointerRNA *ptr);
void FloatProperty_default_value_set(PointerRNA *ptr, float value);

void FloatProperty_default_array_get(PointerRNA *ptr, float values[]);
void FloatProperty_default_array_set(PointerRNA *ptr, const float values[]);int FloatProperty_default_array_get_length(PointerRNA *ptr, int *arraylen);

float FloatProperty_hard_max_get(PointerRNA *ptr);
void FloatProperty_hard_max_set(PointerRNA *ptr, float value);

float FloatProperty_hard_min_get(PointerRNA *ptr);
void FloatProperty_hard_min_set(PointerRNA *ptr, float value);

bool FloatProperty_is_array_get(PointerRNA *ptr);
void FloatProperty_is_array_set(PointerRNA *ptr, bool value);

int FloatProperty_precision_get(PointerRNA *ptr);
void FloatProperty_precision_set(PointerRNA *ptr, int value);

float FloatProperty_soft_max_get(PointerRNA *ptr);
void FloatProperty_soft_max_set(PointerRNA *ptr, float value);

float FloatProperty_soft_min_get(PointerRNA *ptr);
void FloatProperty_soft_min_set(PointerRNA *ptr, float value);

float FloatProperty_step_get(PointerRNA *ptr);
void FloatProperty_step_set(PointerRNA *ptr, float value);

/**************** Float Vector Attribute ****************/

extern StructRNA RNA_FloatVectorAttribute;
extern StructRNA RNA_Attribute;

void FloatVectorAttribute_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void FloatVectorAttribute_data_next(CollectionPropertyIterator *iter);
void FloatVectorAttribute_data_end(CollectionPropertyIterator *iter);
int FloatVectorAttribute_data_length(PointerRNA *ptr);
bool FloatVectorAttribute_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Float Vector Attribute Value ****************/

extern StructRNA RNA_FloatVectorAttributeValue;

PointerRNA FloatVectorAttributeValue_rna_type_get(PointerRNA *ptr);

void FloatVectorAttributeValue_vector_get(PointerRNA *ptr, float values[3]);
void FloatVectorAttributeValue_vector_set(PointerRNA *ptr, const float values[3]);

/**************** Read-Only Vector ****************/

extern StructRNA RNA_FloatVectorValueReadOnly;

PointerRNA FloatVectorValueReadOnly_rna_type_get(PointerRNA *ptr);

void FloatVectorValueReadOnly_vector_get(PointerRNA *ptr, float values[3]);
void FloatVectorValueReadOnly_vector_set(PointerRNA *ptr, const float values[3]);

/**************** Floor Constraint ****************/

extern StructRNA RNA_FloorConstraint;
extern StructRNA RNA_Constraint;

enum {
	FloorConstraint_floor_location_FLOOR_X = 0,
	FloorConstraint_floor_location_FLOOR_Y = 1,
	FloorConstraint_floor_location_FLOOR_Z = 2,
	FloorConstraint_floor_location_FLOOR_NEGATIVE_X = 3,
	FloorConstraint_floor_location_FLOOR_NEGATIVE_Y = 4,
	FloorConstraint_floor_location_FLOOR_NEGATIVE_Z = 5,
};

int FloorConstraint_floor_location_get(PointerRNA *ptr);
void FloorConstraint_floor_location_set(PointerRNA *ptr, int value);

float FloorConstraint_offset_get(PointerRNA *ptr);
void FloorConstraint_offset_set(PointerRNA *ptr, float value);

#define FloorConstraint_subtarget_MAX 64

void FloorConstraint_subtarget_get(PointerRNA *ptr, char *value);
int FloorConstraint_subtarget_length(PointerRNA *ptr);
void FloorConstraint_subtarget_set(PointerRNA *ptr, const char *value);

PointerRNA FloorConstraint_target_get(PointerRNA *ptr);

bool FloorConstraint_use_rotation_get(PointerRNA *ptr);
void FloorConstraint_use_rotation_set(PointerRNA *ptr, bool value);

/**************** Domain Settings ****************/

extern StructRNA RNA_FluidDomainSettings;

PointerRNA FluidDomainSettings_rna_type_get(PointerRNA *ptr);

PointerRNA FluidDomainSettings_guide_parent_get(PointerRNA *ptr);

bool FluidDomainSettings_use_adaptive_domain_get(PointerRNA *ptr);
void FluidDomainSettings_use_adaptive_domain_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_use_adaptive_timesteps_get(PointerRNA *ptr);
void FluidDomainSettings_use_adaptive_timesteps_set(PointerRNA *ptr, bool value);

int FluidDomainSettings_additional_res_get(PointerRNA *ptr);
void FluidDomainSettings_additional_res_set(PointerRNA *ptr, int value);

enum {
	FluidDomainSettings_slice_axis_AUTO = 0,
	FluidDomainSettings_slice_axis_X = 1,
	FluidDomainSettings_slice_axis_Y = 2,
	FluidDomainSettings_slice_axis_Z = 3,
};

int FluidDomainSettings_slice_axis_get(PointerRNA *ptr);
void FluidDomainSettings_slice_axis_set(PointerRNA *ptr, int value);

bool FluidDomainSettings_use_collision_border_back_get(PointerRNA *ptr);
void FluidDomainSettings_use_collision_border_back_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_use_collision_border_bottom_get(PointerRNA *ptr);
void FluidDomainSettings_use_collision_border_bottom_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_use_bubble_particles_get(PointerRNA *ptr);
void FluidDomainSettings_use_bubble_particles_set(PointerRNA *ptr, bool value);

float FluidDomainSettings_sndparticle_bubble_buoyancy_get(PointerRNA *ptr);
void FluidDomainSettings_sndparticle_bubble_buoyancy_set(PointerRNA *ptr, float value);

float FluidDomainSettings_sndparticle_bubble_drag_get(PointerRNA *ptr);
void FluidDomainSettings_sndparticle_bubble_drag_set(PointerRNA *ptr, float value);

float FluidDomainSettings_alpha_get(PointerRNA *ptr);
void FluidDomainSettings_alpha_set(PointerRNA *ptr, float value);

float FluidDomainSettings_beta_get(PointerRNA *ptr);
void FluidDomainSettings_beta_set(PointerRNA *ptr, float value);

float FluidDomainSettings_cfl_condition_get(PointerRNA *ptr);
void FluidDomainSettings_cfl_condition_set(PointerRNA *ptr, float value);

#define FluidDomainSettings_cache_directory_MAX 1024

void FluidDomainSettings_cache_directory_get(PointerRNA *ptr, char *value);
int FluidDomainSettings_cache_directory_length(PointerRNA *ptr);
void FluidDomainSettings_cache_directory_set(PointerRNA *ptr, const char *value);

enum {
	FluidDomainSettings_gridlines_cell_filter_NONE = 0,
	FluidDomainSettings_gridlines_cell_filter_FLUID = 1,
	FluidDomainSettings_gridlines_cell_filter_OBSTACLE = 2,
	FluidDomainSettings_gridlines_cell_filter_EMPTY = 4,
	FluidDomainSettings_gridlines_cell_filter_INFLOW = 8,
	FluidDomainSettings_gridlines_cell_filter_OUTFLOW = 16,
};

int FluidDomainSettings_gridlines_cell_filter_get(PointerRNA *ptr);
void FluidDomainSettings_gridlines_cell_filter_set(PointerRNA *ptr, int value);

bool FluidDomainSettings_delete_in_obstacle_get(PointerRNA *ptr);
void FluidDomainSettings_delete_in_obstacle_set(PointerRNA *ptr, bool value);

float FluidDomainSettings_clipping_get(PointerRNA *ptr);
void FluidDomainSettings_clipping_set(PointerRNA *ptr, float value);

void FluidDomainSettings_gridlines_range_color_get(PointerRNA *ptr, float values[4]);
void FluidDomainSettings_gridlines_range_color_set(PointerRNA *ptr, const float values[4]);

void FluidDomainSettings_color_grid_get(PointerRNA *ptr, float values[]);
void FluidDomainSettings_color_grid_set(PointerRNA *ptr, const float values[]);int FluidDomainSettings_color_grid_get_length(PointerRNA *ptr, int *arraylen);

enum {
	FluidDomainSettings_gridlines_color_field_NONE = 0,
	FluidDomainSettings_gridlines_color_field_FLAGS = 1,
	FluidDomainSettings_gridlines_color_field_RANGE = 2,
};

int FluidDomainSettings_gridlines_color_field_get(PointerRNA *ptr);
void FluidDomainSettings_gridlines_color_field_set(PointerRNA *ptr, int value);

PointerRNA FluidDomainSettings_color_ramp_get(PointerRNA *ptr);

enum {
	FluidDomainSettings_sndparticle_combined_export_OFF = 0,
	FluidDomainSettings_sndparticle_combined_export_SPRAY_FOAM = 1,
	FluidDomainSettings_sndparticle_combined_export_SPRAY_BUBBLES = 2,
	FluidDomainSettings_sndparticle_combined_export_FOAM_BUBBLES = 3,
	FluidDomainSettings_sndparticle_combined_export_SPRAY_FOAM_BUBBLES = 4,
};

int FluidDomainSettings_sndparticle_combined_export_get(PointerRNA *ptr);
void FluidDomainSettings_sndparticle_combined_export_set(PointerRNA *ptr, int value);

enum {
	FluidDomainSettings_openvdb_cache_compress_type_ZIP = 1,
	FluidDomainSettings_openvdb_cache_compress_type_BLOSC = 0,
	FluidDomainSettings_openvdb_cache_compress_type_NONE = 2,
};

int FluidDomainSettings_openvdb_cache_compress_type_get(PointerRNA *ptr);
void FluidDomainSettings_openvdb_cache_compress_type_set(PointerRNA *ptr, int value);

enum {
	FluidDomainSettings_openvdb_data_depth_NONE = 0,
};

int FluidDomainSettings_openvdb_data_depth_get(PointerRNA *ptr);
void FluidDomainSettings_openvdb_data_depth_set(PointerRNA *ptr, int value);

void FluidDomainSettings_density_grid_get(PointerRNA *ptr, float values[]);
void FluidDomainSettings_density_grid_set(PointerRNA *ptr, const float values[]);int FluidDomainSettings_density_grid_get_length(PointerRNA *ptr, int *arraylen);

enum {
	FluidDomainSettings_vector_display_type_NEEDLE = 0,
	FluidDomainSettings_vector_display_type_STREAMLINE = 1,
	FluidDomainSettings_vector_display_type_MAC = 2,
};

int FluidDomainSettings_vector_display_type_get(PointerRNA *ptr);
void FluidDomainSettings_vector_display_type_set(PointerRNA *ptr, int value);

bool FluidDomainSettings_use_dissolve_smoke_get(PointerRNA *ptr);
void FluidDomainSettings_use_dissolve_smoke_set(PointerRNA *ptr, bool value);

int FluidDomainSettings_dissolve_speed_get(PointerRNA *ptr);
void FluidDomainSettings_dissolve_speed_set(PointerRNA *ptr, int value);

enum {
	FluidDomainSettings_domain_type_GAS = 0,
	FluidDomainSettings_domain_type_LIQUID = 1,
};

int FluidDomainSettings_domain_type_get(PointerRNA *ptr);
void FluidDomainSettings_domain_type_set(PointerRNA *ptr, int value);

PointerRNA FluidDomainSettings_effector_group_get(PointerRNA *ptr);

PointerRNA FluidDomainSettings_effector_weights_get(PointerRNA *ptr);

enum {
	FluidDomainSettings_highres_sampling_FULLSAMPLE = 2,
	FluidDomainSettings_highres_sampling_LINEAR = 1,
	FluidDomainSettings_highres_sampling_NEAREST = 0,
};

int FluidDomainSettings_highres_sampling_get(PointerRNA *ptr);
void FluidDomainSettings_highres_sampling_set(PointerRNA *ptr, int value);

int FluidDomainSettings_cache_frame_end_get(PointerRNA *ptr);
void FluidDomainSettings_cache_frame_end_set(PointerRNA *ptr, int value);

bool FluidDomainSettings_export_manta_script_get(PointerRNA *ptr);
void FluidDomainSettings_export_manta_script_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_use_flip_particles_get(PointerRNA *ptr);
void FluidDomainSettings_use_flip_particles_set(PointerRNA *ptr, bool value);

float FluidDomainSettings_flip_ratio_get(PointerRNA *ptr);
void FluidDomainSettings_flip_ratio_set(PointerRNA *ptr, float value);

enum {
	FluidDomainSettings_vector_field_FLUID_VELOCITY = 0,
	FluidDomainSettings_vector_field_GUIDE_VELOCITY = 1,
	FluidDomainSettings_vector_field_FORCE = 2,
};

int FluidDomainSettings_vector_field_get(PointerRNA *ptr);
void FluidDomainSettings_vector_field_set(PointerRNA *ptr, int value);

enum {
	FluidDomainSettings_color_ramp_field_NONE = 0,
};

int FluidDomainSettings_color_ramp_field_get(PointerRNA *ptr);
void FluidDomainSettings_color_ramp_field_set(PointerRNA *ptr, int value);

enum {
	FluidDomainSettings_cache_mesh_format_UNI = 1,
	FluidDomainSettings_cache_mesh_format_OPENVDB = 2,
	FluidDomainSettings_cache_mesh_format_RAW = 4,
};

int FluidDomainSettings_cache_mesh_format_get(PointerRNA *ptr);
void FluidDomainSettings_cache_mesh_format_set(PointerRNA *ptr, int value);

enum {
	FluidDomainSettings_cache_data_format_UNI = 1,
	FluidDomainSettings_cache_data_format_OPENVDB = 2,
	FluidDomainSettings_cache_data_format_RAW = 4,
};

int FluidDomainSettings_cache_data_format_get(PointerRNA *ptr);
void FluidDomainSettings_cache_data_format_set(PointerRNA *ptr, int value);

enum {
	FluidDomainSettings_cache_particle_format_UNI = 1,
	FluidDomainSettings_cache_particle_format_OPENVDB = 2,
	FluidDomainSettings_cache_particle_format_RAW = 4,
};

int FluidDomainSettings_cache_particle_format_get(PointerRNA *ptr);
void FluidDomainSettings_cache_particle_format_set(PointerRNA *ptr, int value);

enum {
	FluidDomainSettings_cache_noise_format_UNI = 1,
	FluidDomainSettings_cache_noise_format_OPENVDB = 2,
	FluidDomainSettings_cache_noise_format_RAW = 4,
};

int FluidDomainSettings_cache_noise_format_get(PointerRNA *ptr);
void FluidDomainSettings_cache_noise_format_set(PointerRNA *ptr, int value);

void FluidDomainSettings_flame_grid_get(PointerRNA *ptr, float values[]);
void FluidDomainSettings_flame_grid_set(PointerRNA *ptr, const float values[]);int FluidDomainSettings_flame_grid_get_length(PointerRNA *ptr, int *arraylen);

PointerRNA FluidDomainSettings_fluid_group_get(PointerRNA *ptr);

bool FluidDomainSettings_use_foam_particles_get(PointerRNA *ptr);
void FluidDomainSettings_use_foam_particles_set(PointerRNA *ptr, bool value);

PointerRNA FluidDomainSettings_force_collection_get(PointerRNA *ptr);

bool FluidDomainSettings_use_fractions_get(PointerRNA *ptr);
void FluidDomainSettings_use_fractions_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_use_collision_border_front_get(PointerRNA *ptr);
void FluidDomainSettings_use_collision_border_front_set(PointerRNA *ptr, bool value);

void FluidDomainSettings_gravity_get(PointerRNA *ptr, float values[3]);
void FluidDomainSettings_gravity_set(PointerRNA *ptr, const float values[3]);

bool FluidDomainSettings_use_color_ramp_get(PointerRNA *ptr);
void FluidDomainSettings_use_color_ramp_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_show_gridlines_get(PointerRNA *ptr);
void FluidDomainSettings_show_gridlines_set(PointerRNA *ptr, bool value);

enum {
	FluidDomainSettings_guide_source_DOMAIN = 0,
	FluidDomainSettings_guide_source_EFFECTOR = 1,
};

int FluidDomainSettings_guide_source_get(PointerRNA *ptr);
void FluidDomainSettings_guide_source_set(PointerRNA *ptr, int value);

void FluidDomainSettings_heat_grid_get(PointerRNA *ptr, float values[]);
void FluidDomainSettings_heat_grid_set(PointerRNA *ptr, const float values[]);int FluidDomainSettings_heat_grid_get_length(PointerRNA *ptr, int *arraylen);

enum {
	FluidDomainSettings_display_interpolation_LINEAR = 0,
	FluidDomainSettings_display_interpolation_CUBIC = 1,
	FluidDomainSettings_display_interpolation_CLOSEST = 2,
};

int FluidDomainSettings_display_interpolation_get(PointerRNA *ptr);
void FluidDomainSettings_display_interpolation_set(PointerRNA *ptr, int value);

bool FluidDomainSettings_use_collision_border_left_get(PointerRNA *ptr);
void FluidDomainSettings_use_collision_border_left_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_use_dissolve_smoke_log_get(PointerRNA *ptr);
void FluidDomainSettings_use_dissolve_smoke_log_set(PointerRNA *ptr, bool value);

float FluidDomainSettings_gridlines_lower_bound_get(PointerRNA *ptr);
void FluidDomainSettings_gridlines_lower_bound_set(PointerRNA *ptr, float value);

float FluidDomainSettings_mesh_concave_lower_get(PointerRNA *ptr);
void FluidDomainSettings_mesh_concave_lower_set(PointerRNA *ptr, float value);

bool FluidDomainSettings_vector_scale_with_magnitude_get(PointerRNA *ptr);
void FluidDomainSettings_vector_scale_with_magnitude_set(PointerRNA *ptr, bool value);

int FluidDomainSettings_adapt_margin_get(PointerRNA *ptr);
void FluidDomainSettings_adapt_margin_set(PointerRNA *ptr, int value);

float FluidDomainSettings_flame_max_temp_get(PointerRNA *ptr);
void FluidDomainSettings_flame_max_temp_set(PointerRNA *ptr, float value);

int FluidDomainSettings_particle_max_get(PointerRNA *ptr);
void FluidDomainSettings_particle_max_set(PointerRNA *ptr, int value);

int FluidDomainSettings_timesteps_max_get(PointerRNA *ptr);
void FluidDomainSettings_timesteps_max_set(PointerRNA *ptr, int value);

float FluidDomainSettings_sndparticle_potential_max_energy_get(PointerRNA *ptr);
void FluidDomainSettings_sndparticle_potential_max_energy_set(PointerRNA *ptr, float value);

float FluidDomainSettings_sndparticle_life_max_get(PointerRNA *ptr);
void FluidDomainSettings_sndparticle_life_max_set(PointerRNA *ptr, float value);

int FluidDomainSettings_resolution_max_get(PointerRNA *ptr);
void FluidDomainSettings_resolution_max_set(PointerRNA *ptr, int value);

float FluidDomainSettings_sndparticle_potential_max_trappedair_get(PointerRNA *ptr);
void FluidDomainSettings_sndparticle_potential_max_trappedair_set(PointerRNA *ptr, float value);

float FluidDomainSettings_sndparticle_potential_max_wavecrest_get(PointerRNA *ptr);
void FluidDomainSettings_sndparticle_potential_max_wavecrest_set(PointerRNA *ptr, float value);

enum {
	FluidDomainSettings_mesh_generator_IMPROVED = 0,
	FluidDomainSettings_mesh_generator_UNION = 1,
};

int FluidDomainSettings_mesh_generator_get(PointerRNA *ptr);
void FluidDomainSettings_mesh_generator_set(PointerRNA *ptr, int value);

int FluidDomainSettings_mesh_scale_get(PointerRNA *ptr);
void FluidDomainSettings_mesh_scale_set(PointerRNA *ptr, int value);

float FluidDomainSettings_flame_ignition_get(PointerRNA *ptr);
void FluidDomainSettings_flame_ignition_set(PointerRNA *ptr, float value);

int FluidDomainSettings_particle_min_get(PointerRNA *ptr);
void FluidDomainSettings_particle_min_set(PointerRNA *ptr, int value);

int FluidDomainSettings_timesteps_min_get(PointerRNA *ptr);
void FluidDomainSettings_timesteps_min_set(PointerRNA *ptr, int value);

float FluidDomainSettings_sndparticle_potential_min_energy_get(PointerRNA *ptr);
void FluidDomainSettings_sndparticle_potential_min_energy_set(PointerRNA *ptr, float value);

float FluidDomainSettings_sndparticle_life_min_get(PointerRNA *ptr);
void FluidDomainSettings_sndparticle_life_min_set(PointerRNA *ptr, float value);

float FluidDomainSettings_sndparticle_potential_min_trappedair_get(PointerRNA *ptr);
void FluidDomainSettings_sndparticle_potential_min_trappedair_set(PointerRNA *ptr, float value);

float FluidDomainSettings_sndparticle_potential_min_wavecrest_get(PointerRNA *ptr);
void FluidDomainSettings_sndparticle_potential_min_wavecrest_set(PointerRNA *ptr, float value);

int FluidDomainSettings_noise_scale_get(PointerRNA *ptr);
void FluidDomainSettings_noise_scale_set(PointerRNA *ptr, int value);

int FluidDomainSettings_particle_number_get(PointerRNA *ptr);
void FluidDomainSettings_particle_number_set(PointerRNA *ptr, int value);

float FluidDomainSettings_fractions_distance_get(PointerRNA *ptr);
void FluidDomainSettings_fractions_distance_set(PointerRNA *ptr, float value);

float FluidDomainSettings_fractions_threshold_get(PointerRNA *ptr);
void FluidDomainSettings_fractions_threshold_set(PointerRNA *ptr, float value);

int FluidDomainSettings_cache_frame_offset_get(PointerRNA *ptr);
void FluidDomainSettings_cache_frame_offset_set(PointerRNA *ptr, int value);

int FluidDomainSettings_particle_scale_get(PointerRNA *ptr);
void FluidDomainSettings_particle_scale_set(PointerRNA *ptr, int value);

enum {
	FluidDomainSettings_sndparticle_boundary_DELETE = 0,
	FluidDomainSettings_sndparticle_boundary_PUSHOUT = 1,
};

int FluidDomainSettings_sndparticle_boundary_get(PointerRNA *ptr);
void FluidDomainSettings_sndparticle_boundary_set(PointerRNA *ptr, int value);

float FluidDomainSettings_slice_depth_get(PointerRNA *ptr);
void FluidDomainSettings_slice_depth_set(PointerRNA *ptr, float value);

int FluidDomainSettings_sndparticle_potential_radius_get(PointerRNA *ptr);
void FluidDomainSettings_sndparticle_potential_radius_set(PointerRNA *ptr, int value);

float FluidDomainSettings_particle_radius_get(PointerRNA *ptr);
void FluidDomainSettings_particle_radius_set(PointerRNA *ptr, float value);

float FluidDomainSettings_mesh_particle_radius_get(PointerRNA *ptr);
void FluidDomainSettings_mesh_particle_radius_set(PointerRNA *ptr, float value);

float FluidDomainSettings_particle_randomness_get(PointerRNA *ptr);
void FluidDomainSettings_particle_randomness_set(PointerRNA *ptr, float value);

bool FluidDomainSettings_cache_resumable_get(PointerRNA *ptr);
void FluidDomainSettings_cache_resumable_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_use_collision_border_right_get(PointerRNA *ptr);
void FluidDomainSettings_use_collision_border_right_set(PointerRNA *ptr, bool value);

float FluidDomainSettings_noise_pos_scale_get(PointerRNA *ptr);
void FluidDomainSettings_noise_pos_scale_set(PointerRNA *ptr, float value);

float FluidDomainSettings_vector_scale_get(PointerRNA *ptr);
void FluidDomainSettings_vector_scale_set(PointerRNA *ptr, float value);

float FluidDomainSettings_color_ramp_field_scale_get(PointerRNA *ptr);
void FluidDomainSettings_color_ramp_field_scale_set(PointerRNA *ptr, float value);

enum {
	FluidDomainSettings_simulation_method_FLIP = 1,
	FluidDomainSettings_simulation_method_APIC = 2,
};

int FluidDomainSettings_simulation_method_get(PointerRNA *ptr);
void FluidDomainSettings_simulation_method_set(PointerRNA *ptr, int value);

int FluidDomainSettings_guide_beta_get(PointerRNA *ptr);
void FluidDomainSettings_guide_beta_set(PointerRNA *ptr, int value);

bool FluidDomainSettings_use_slice_get(PointerRNA *ptr);
void FluidDomainSettings_use_slice_set(PointerRNA *ptr, bool value);

float FluidDomainSettings_slice_per_voxel_get(PointerRNA *ptr);
void FluidDomainSettings_slice_per_voxel_set(PointerRNA *ptr, float value);

float FluidDomainSettings_flame_smoke_get(PointerRNA *ptr);
void FluidDomainSettings_flame_smoke_set(PointerRNA *ptr, float value);

void FluidDomainSettings_flame_smoke_color_get(PointerRNA *ptr, float values[3]);
void FluidDomainSettings_flame_smoke_color_set(PointerRNA *ptr, const float values[3]);

int FluidDomainSettings_mesh_smoothen_neg_get(PointerRNA *ptr);
void FluidDomainSettings_mesh_smoothen_neg_set(PointerRNA *ptr, int value);

int FluidDomainSettings_mesh_smoothen_pos_get(PointerRNA *ptr);
void FluidDomainSettings_mesh_smoothen_pos_set(PointerRNA *ptr, int value);

float FluidDomainSettings_burning_rate_get(PointerRNA *ptr);
void FluidDomainSettings_burning_rate_set(PointerRNA *ptr, float value);

bool FluidDomainSettings_use_speed_vectors_get(PointerRNA *ptr);
void FluidDomainSettings_use_speed_vectors_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_use_spray_particles_get(PointerRNA *ptr);
void FluidDomainSettings_use_spray_particles_set(PointerRNA *ptr, bool value);

int FluidDomainSettings_cache_frame_start_get(PointerRNA *ptr);
void FluidDomainSettings_cache_frame_start_set(PointerRNA *ptr, int value);

float FluidDomainSettings_noise_strength_get(PointerRNA *ptr);
void FluidDomainSettings_noise_strength_set(PointerRNA *ptr, float value);

float FluidDomainSettings_viscosity_value_get(PointerRNA *ptr);
void FluidDomainSettings_viscosity_value_set(PointerRNA *ptr, float value);

int FluidDomainSettings_sys_particle_maximum_get(PointerRNA *ptr);
void FluidDomainSettings_sys_particle_maximum_set(PointerRNA *ptr, int value);

void FluidDomainSettings_temperature_grid_get(PointerRNA *ptr, float values[]);
void FluidDomainSettings_temperature_grid_set(PointerRNA *ptr, const float values[]);int FluidDomainSettings_temperature_grid_get_length(PointerRNA *ptr, int *arraylen);

float FluidDomainSettings_surface_tension_get(PointerRNA *ptr);
void FluidDomainSettings_surface_tension_set(PointerRNA *ptr, float value);

float FluidDomainSettings_display_thickness_get(PointerRNA *ptr);
void FluidDomainSettings_display_thickness_set(PointerRNA *ptr, float value);

float FluidDomainSettings_adapt_threshold_get(PointerRNA *ptr);
void FluidDomainSettings_adapt_threshold_set(PointerRNA *ptr, float value);

float FluidDomainSettings_noise_time_anim_get(PointerRNA *ptr);
void FluidDomainSettings_noise_time_anim_set(PointerRNA *ptr, float value);

float FluidDomainSettings_time_scale_get(PointerRNA *ptr);
void FluidDomainSettings_time_scale_set(PointerRNA *ptr, float value);

bool FluidDomainSettings_use_collision_border_top_get(PointerRNA *ptr);
void FluidDomainSettings_use_collision_border_top_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_use_tracer_particles_get(PointerRNA *ptr);
void FluidDomainSettings_use_tracer_particles_set(PointerRNA *ptr, bool value);

int FluidDomainSettings_sndparticle_sampling_trappedair_get(PointerRNA *ptr);
void FluidDomainSettings_sndparticle_sampling_trappedair_set(PointerRNA *ptr, int value);

enum {
	FluidDomainSettings_cache_type_REPLAY = 0,
	FluidDomainSettings_cache_type_MODULAR = 1,
	FluidDomainSettings_cache_type_ALL = 2,
};

int FluidDomainSettings_cache_type_get(PointerRNA *ptr);
void FluidDomainSettings_cache_type_set(PointerRNA *ptr, int value);

int FluidDomainSettings_sndparticle_update_radius_get(PointerRNA *ptr);
void FluidDomainSettings_sndparticle_update_radius_set(PointerRNA *ptr, int value);

float FluidDomainSettings_gridlines_upper_bound_get(PointerRNA *ptr);
void FluidDomainSettings_gridlines_upper_bound_set(PointerRNA *ptr, float value);

float FluidDomainSettings_mesh_concave_upper_get(PointerRNA *ptr);
void FluidDomainSettings_mesh_concave_upper_set(PointerRNA *ptr, float value);

bool FluidDomainSettings_use_diffusion_get(PointerRNA *ptr);
void FluidDomainSettings_use_diffusion_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_use_guide_get(PointerRNA *ptr);
void FluidDomainSettings_use_guide_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_use_mesh_get(PointerRNA *ptr);
void FluidDomainSettings_use_mesh_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_use_noise_get(PointerRNA *ptr);
void FluidDomainSettings_use_noise_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_use_viscosity_get(PointerRNA *ptr);
void FluidDomainSettings_use_viscosity_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_show_velocity_get(PointerRNA *ptr);
void FluidDomainSettings_show_velocity_set(PointerRNA *ptr, bool value);

float FluidDomainSettings_guide_vel_factor_get(PointerRNA *ptr);
void FluidDomainSettings_guide_vel_factor_set(PointerRNA *ptr, float value);

void FluidDomainSettings_velocity_grid_get(PointerRNA *ptr, float values[]);
void FluidDomainSettings_velocity_grid_set(PointerRNA *ptr, const float values[]);int FluidDomainSettings_velocity_grid_get_length(PointerRNA *ptr, int *arraylen);

float FluidDomainSettings_velocity_scale_get(PointerRNA *ptr);
void FluidDomainSettings_velocity_scale_set(PointerRNA *ptr, float value);

float FluidDomainSettings_viscosity_base_get(PointerRNA *ptr);
void FluidDomainSettings_viscosity_base_set(PointerRNA *ptr, float value);

int FluidDomainSettings_viscosity_exponent_get(PointerRNA *ptr);
void FluidDomainSettings_viscosity_exponent_set(PointerRNA *ptr, int value);

float FluidDomainSettings_vorticity_get(PointerRNA *ptr);
void FluidDomainSettings_vorticity_set(PointerRNA *ptr, float value);

float FluidDomainSettings_flame_vorticity_get(PointerRNA *ptr);
void FluidDomainSettings_flame_vorticity_set(PointerRNA *ptr, float value);

int FluidDomainSettings_sndparticle_sampling_wavecrest_get(PointerRNA *ptr);
void FluidDomainSettings_sndparticle_sampling_wavecrest_set(PointerRNA *ptr, int value);

float FluidDomainSettings_guide_alpha_get(PointerRNA *ptr);
void FluidDomainSettings_guide_alpha_set(PointerRNA *ptr, float value);

float FluidDomainSettings_particle_band_width_get(PointerRNA *ptr);
void FluidDomainSettings_particle_band_width_set(PointerRNA *ptr, float value);

bool FluidDomainSettings_vector_show_mac_x_get(PointerRNA *ptr);
void FluidDomainSettings_vector_show_mac_x_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_vector_show_mac_y_get(PointerRNA *ptr);
void FluidDomainSettings_vector_show_mac_y_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_vector_show_mac_z_get(PointerRNA *ptr);
void FluidDomainSettings_vector_show_mac_z_set(PointerRNA *ptr, bool value);

int FluidDomainSettings_cache_frame_pause_data_get(PointerRNA *ptr);
void FluidDomainSettings_cache_frame_pause_data_set(PointerRNA *ptr, int value);

int FluidDomainSettings_cache_frame_pause_guide_get(PointerRNA *ptr);
void FluidDomainSettings_cache_frame_pause_guide_set(PointerRNA *ptr, int value);

int FluidDomainSettings_cache_frame_pause_mesh_get(PointerRNA *ptr);
void FluidDomainSettings_cache_frame_pause_mesh_set(PointerRNA *ptr, int value);

int FluidDomainSettings_cache_frame_pause_noise_get(PointerRNA *ptr);
void FluidDomainSettings_cache_frame_pause_noise_set(PointerRNA *ptr, int value);

int FluidDomainSettings_cache_frame_pause_particles_get(PointerRNA *ptr);
void FluidDomainSettings_cache_frame_pause_particles_set(PointerRNA *ptr, int value);

void FluidDomainSettings_cell_size_get(PointerRNA *ptr, float values[3]);
void FluidDomainSettings_cell_size_set(PointerRNA *ptr, const float values[3]);

bool FluidDomainSettings_has_cache_baked_any_get(PointerRNA *ptr);
void FluidDomainSettings_has_cache_baked_any_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_has_cache_baked_data_get(PointerRNA *ptr);
void FluidDomainSettings_has_cache_baked_data_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_has_cache_baked_guide_get(PointerRNA *ptr);
void FluidDomainSettings_has_cache_baked_guide_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_has_cache_baked_mesh_get(PointerRNA *ptr);
void FluidDomainSettings_has_cache_baked_mesh_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_has_cache_baked_noise_get(PointerRNA *ptr);
void FluidDomainSettings_has_cache_baked_noise_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_has_cache_baked_particles_get(PointerRNA *ptr);
void FluidDomainSettings_has_cache_baked_particles_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_is_cache_baking_any_get(PointerRNA *ptr);
void FluidDomainSettings_is_cache_baking_any_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_is_cache_baking_data_get(PointerRNA *ptr);
void FluidDomainSettings_is_cache_baking_data_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_is_cache_baking_guide_get(PointerRNA *ptr);
void FluidDomainSettings_is_cache_baking_guide_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_is_cache_baking_mesh_get(PointerRNA *ptr);
void FluidDomainSettings_is_cache_baking_mesh_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_is_cache_baking_noise_get(PointerRNA *ptr);
void FluidDomainSettings_is_cache_baking_noise_set(PointerRNA *ptr, bool value);

bool FluidDomainSettings_is_cache_baking_particles_get(PointerRNA *ptr);
void FluidDomainSettings_is_cache_baking_particles_set(PointerRNA *ptr, bool value);

void FluidDomainSettings_start_point_get(PointerRNA *ptr, float values[3]);
void FluidDomainSettings_start_point_set(PointerRNA *ptr, const float values[3]);

void FluidDomainSettings_domain_resolution_get(PointerRNA *ptr, int values[3]);
void FluidDomainSettings_domain_resolution_set(PointerRNA *ptr, const int values[3]);

/**************** Effector Settings ****************/

extern StructRNA RNA_FluidEffectorSettings;

PointerRNA FluidEffectorSettings_rna_type_get(PointerRNA *ptr);

enum {
	FluidEffectorSettings_effector_type_COLLISION = 0,
	FluidEffectorSettings_effector_type_GUIDE = 1,
};

int FluidEffectorSettings_effector_type_get(PointerRNA *ptr);
void FluidEffectorSettings_effector_type_set(PointerRNA *ptr, int value);

bool FluidEffectorSettings_use_effector_get(PointerRNA *ptr);
void FluidEffectorSettings_use_effector_set(PointerRNA *ptr, bool value);

enum {
	FluidEffectorSettings_guide_mode_MAXIMUM = 0,
	FluidEffectorSettings_guide_mode_MINIMUM = 1,
	FluidEffectorSettings_guide_mode_OVERRIDE = 2,
	FluidEffectorSettings_guide_mode_AVERAGED = 3,
};

int FluidEffectorSettings_guide_mode_get(PointerRNA *ptr);
void FluidEffectorSettings_guide_mode_set(PointerRNA *ptr, int value);

bool FluidEffectorSettings_use_plane_init_get(PointerRNA *ptr);
void FluidEffectorSettings_use_plane_init_set(PointerRNA *ptr, bool value);

float FluidEffectorSettings_velocity_factor_get(PointerRNA *ptr);
void FluidEffectorSettings_velocity_factor_set(PointerRNA *ptr, float value);

int FluidEffectorSettings_subframes_get(PointerRNA *ptr);
void FluidEffectorSettings_subframes_set(PointerRNA *ptr, int value);

float FluidEffectorSettings_surface_distance_get(PointerRNA *ptr);
void FluidEffectorSettings_surface_distance_set(PointerRNA *ptr, float value);

/**************** Flow Settings ****************/

extern StructRNA RNA_FluidFlowSettings;

PointerRNA FluidFlowSettings_rna_type_get(PointerRNA *ptr);

bool FluidFlowSettings_use_absolute_get(PointerRNA *ptr);
void FluidFlowSettings_use_absolute_set(PointerRNA *ptr, bool value);

float FluidFlowSettings_density_get(PointerRNA *ptr);
void FluidFlowSettings_density_set(PointerRNA *ptr, float value);

float FluidFlowSettings_fuel_amount_get(PointerRNA *ptr);
void FluidFlowSettings_fuel_amount_set(PointerRNA *ptr, float value);

enum {
	FluidFlowSettings_flow_behavior_INFLOW = 0,
	FluidFlowSettings_flow_behavior_OUTFLOW = 1,
	FluidFlowSettings_flow_behavior_GEOMETRY = 2,
};

int FluidFlowSettings_flow_behavior_get(PointerRNA *ptr);
void FluidFlowSettings_flow_behavior_set(PointerRNA *ptr, int value);

enum {
	FluidFlowSettings_flow_type_SMOKE = 1,
	FluidFlowSettings_flow_type_BOTH = 3,
	FluidFlowSettings_flow_type_FIRE = 2,
	FluidFlowSettings_flow_type_LIQUID = 4,
};

int FluidFlowSettings_flow_type_get(PointerRNA *ptr);
void FluidFlowSettings_flow_type_set(PointerRNA *ptr, int value);

void FluidFlowSettings_velocity_coord_get(PointerRNA *ptr, float values[3]);
void FluidFlowSettings_velocity_coord_set(PointerRNA *ptr, const float values[3]);

bool FluidFlowSettings_use_initial_velocity_get(PointerRNA *ptr);
void FluidFlowSettings_use_initial_velocity_set(PointerRNA *ptr, bool value);

bool FluidFlowSettings_use_plane_init_get(PointerRNA *ptr);
void FluidFlowSettings_use_plane_init_set(PointerRNA *ptr, bool value);

enum {
	FluidFlowSettings_texture_map_type_AUTO = 0,
	FluidFlowSettings_texture_map_type_UV = 1,
};

int FluidFlowSettings_texture_map_type_get(PointerRNA *ptr);
void FluidFlowSettings_texture_map_type_set(PointerRNA *ptr, int value);

float FluidFlowSettings_velocity_normal_get(PointerRNA *ptr);
void FluidFlowSettings_velocity_normal_set(PointerRNA *ptr, float value);

float FluidFlowSettings_texture_offset_get(PointerRNA *ptr);
void FluidFlowSettings_texture_offset_set(PointerRNA *ptr, float value);

PointerRNA FluidFlowSettings_particle_system_get(PointerRNA *ptr);

float FluidFlowSettings_velocity_random_get(PointerRNA *ptr);
void FluidFlowSettings_velocity_random_set(PointerRNA *ptr, float value);

bool FluidFlowSettings_use_particle_size_get(PointerRNA *ptr);
void FluidFlowSettings_use_particle_size_set(PointerRNA *ptr, bool value);

float FluidFlowSettings_particle_size_get(PointerRNA *ptr);
void FluidFlowSettings_particle_size_set(PointerRNA *ptr, float value);

float FluidFlowSettings_texture_size_get(PointerRNA *ptr);
void FluidFlowSettings_texture_size_set(PointerRNA *ptr, float value);

void FluidFlowSettings_smoke_color_get(PointerRNA *ptr, float values[3]);
void FluidFlowSettings_smoke_color_set(PointerRNA *ptr, const float values[3]);

enum {
	FluidFlowSettings_flow_source_NONE = 0,
};

int FluidFlowSettings_flow_source_get(PointerRNA *ptr);
void FluidFlowSettings_flow_source_set(PointerRNA *ptr, int value);

float FluidFlowSettings_velocity_factor_get(PointerRNA *ptr);
void FluidFlowSettings_velocity_factor_set(PointerRNA *ptr, float value);

int FluidFlowSettings_subframes_get(PointerRNA *ptr);
void FluidFlowSettings_subframes_set(PointerRNA *ptr, int value);

float FluidFlowSettings_surface_distance_get(PointerRNA *ptr);
void FluidFlowSettings_surface_distance_set(PointerRNA *ptr, float value);

float FluidFlowSettings_temperature_get(PointerRNA *ptr);
void FluidFlowSettings_temperature_set(PointerRNA *ptr, float value);

PointerRNA FluidFlowSettings_noise_texture_get(PointerRNA *ptr);

#define FluidFlowSettings_uv_layer_MAX 68

void FluidFlowSettings_uv_layer_get(PointerRNA *ptr, char *value);
int FluidFlowSettings_uv_layer_length(PointerRNA *ptr);
void FluidFlowSettings_uv_layer_set(PointerRNA *ptr, const char *value);

bool FluidFlowSettings_use_inflow_get(PointerRNA *ptr);
void FluidFlowSettings_use_inflow_set(PointerRNA *ptr, bool value);

bool FluidFlowSettings_use_texture_get(PointerRNA *ptr);
void FluidFlowSettings_use_texture_set(PointerRNA *ptr, bool value);

void FluidFlowSettings_density_vertex_group_get(PointerRNA *ptr, char *value);
int FluidFlowSettings_density_vertex_group_length(PointerRNA *ptr);
void FluidFlowSettings_density_vertex_group_set(PointerRNA *ptr, const char *value);

float FluidFlowSettings_volume_density_get(PointerRNA *ptr);
void FluidFlowSettings_volume_density_set(PointerRNA *ptr, float value);

/**************** Fluid Modifier ****************/

extern StructRNA RNA_FluidModifier;
extern StructRNA RNA_Modifier;

PointerRNA FluidModifier_domain_settings_get(PointerRNA *ptr);

PointerRNA FluidModifier_effector_settings_get(PointerRNA *ptr);

PointerRNA FluidModifier_flow_settings_get(PointerRNA *ptr);

enum {
	FluidModifier_fluid_type_NONE = 0,
	FluidModifier_fluid_type_DOMAIN = 1,
	FluidModifier_fluid_type_FLOW = 2,
	FluidModifier_fluid_type_EFFECTOR = 4,
};

int FluidModifier_fluid_type_get(PointerRNA *ptr);
void FluidModifier_fluid_type_set(PointerRNA *ptr, int value);

/**************** Follow Path Constraint ****************/

extern StructRNA RNA_FollowPathConstraint;
extern StructRNA RNA_Constraint;

bool FollowPathConstraint_use_curve_radius_get(PointerRNA *ptr);
void FollowPathConstraint_use_curve_radius_set(PointerRNA *ptr, bool value);

bool FollowPathConstraint_use_fixed_location_get(PointerRNA *ptr);
void FollowPathConstraint_use_fixed_location_set(PointerRNA *ptr, bool value);

bool FollowPathConstraint_use_curve_follow_get(PointerRNA *ptr);
void FollowPathConstraint_use_curve_follow_set(PointerRNA *ptr, bool value);

enum {
	FollowPathConstraint_forward_axis_FORWARD_X = 0,
	FollowPathConstraint_forward_axis_FORWARD_Y = 1,
	FollowPathConstraint_forward_axis_FORWARD_Z = 2,
	FollowPathConstraint_forward_axis_TRACK_NEGATIVE_X = 3,
	FollowPathConstraint_forward_axis_TRACK_NEGATIVE_Y = 4,
	FollowPathConstraint_forward_axis_TRACK_NEGATIVE_Z = 5,
};

int FollowPathConstraint_forward_axis_get(PointerRNA *ptr);
void FollowPathConstraint_forward_axis_set(PointerRNA *ptr, int value);

float FollowPathConstraint_offset_get(PointerRNA *ptr);
void FollowPathConstraint_offset_set(PointerRNA *ptr, float value);

float FollowPathConstraint_offset_factor_get(PointerRNA *ptr);
void FollowPathConstraint_offset_factor_set(PointerRNA *ptr, float value);

PointerRNA FollowPathConstraint_target_get(PointerRNA *ptr);

enum {
	FollowPathConstraint_up_axis_UP_X = 0,
	FollowPathConstraint_up_axis_UP_Y = 1,
	FollowPathConstraint_up_axis_UP_Z = 2,
};

int FollowPathConstraint_up_axis_get(PointerRNA *ptr);
void FollowPathConstraint_up_axis_set(PointerRNA *ptr, int value);

/**************** Follow Track Constraint ****************/

extern StructRNA RNA_FollowTrackConstraint;
extern StructRNA RNA_Constraint;

bool FollowTrackConstraint_use_3d_position_get(PointerRNA *ptr);
void FollowTrackConstraint_use_3d_position_set(PointerRNA *ptr, bool value);

bool FollowTrackConstraint_use_active_clip_get(PointerRNA *ptr);
void FollowTrackConstraint_use_active_clip_set(PointerRNA *ptr, bool value);

PointerRNA FollowTrackConstraint_camera_get(PointerRNA *ptr);

PointerRNA FollowTrackConstraint_depth_object_get(PointerRNA *ptr);

enum {
	FollowTrackConstraint_frame_method_STRETCH = 0,
	FollowTrackConstraint_frame_method_FIT = 1,
	FollowTrackConstraint_frame_method_CROP = 2,
};

int FollowTrackConstraint_frame_method_get(PointerRNA *ptr);
void FollowTrackConstraint_frame_method_set(PointerRNA *ptr, int value);

PointerRNA FollowTrackConstraint_clip_get(PointerRNA *ptr);

#define FollowTrackConstraint_object_MAX 64

void FollowTrackConstraint_object_get(PointerRNA *ptr, char *value);
int FollowTrackConstraint_object_length(PointerRNA *ptr);
void FollowTrackConstraint_object_set(PointerRNA *ptr, const char *value);

#define FollowTrackConstraint_track_MAX 64

void FollowTrackConstraint_track_get(PointerRNA *ptr, char *value);
int FollowTrackConstraint_track_length(PointerRNA *ptr);
void FollowTrackConstraint_track_set(PointerRNA *ptr, const char *value);

bool FollowTrackConstraint_use_undistorted_position_get(PointerRNA *ptr);
void FollowTrackConstraint_use_undistorted_position_set(PointerRNA *ptr, bool value);

/**************** For Each Geometry Element Item ****************/

extern StructRNA RNA_ForeachGeometryElementGenerationItem;

PointerRNA ForeachGeometryElementGenerationItem_rna_type_get(PointerRNA *ptr);

void ForeachGeometryElementGenerationItem_name_get(PointerRNA *ptr, char *value);
int ForeachGeometryElementGenerationItem_name_length(PointerRNA *ptr);
void ForeachGeometryElementGenerationItem_name_set(PointerRNA *ptr, const char *value);

void ForeachGeometryElementGenerationItem_color_get(PointerRNA *ptr, float values[4]);
void ForeachGeometryElementGenerationItem_color_set(PointerRNA *ptr, const float values[4]);

enum {
	ForeachGeometryElementGenerationItem_domain_POINT = 0,
	ForeachGeometryElementGenerationItem_domain_EDGE = 1,
	ForeachGeometryElementGenerationItem_domain_FACE = 2,
	ForeachGeometryElementGenerationItem_domain_CORNER = 3,
	ForeachGeometryElementGenerationItem_domain_CURVE = 4,
	ForeachGeometryElementGenerationItem_domain_INSTANCE = 5,
	ForeachGeometryElementGenerationItem_domain_LAYER = 6,
};

int ForeachGeometryElementGenerationItem_domain_get(PointerRNA *ptr);
void ForeachGeometryElementGenerationItem_domain_set(PointerRNA *ptr, int value);

enum {
	ForeachGeometryElementGenerationItem_socket_type_FLOAT = 0,
	ForeachGeometryElementGenerationItem_socket_type_INT = 6,
	ForeachGeometryElementGenerationItem_socket_type_BOOLEAN = 4,
	ForeachGeometryElementGenerationItem_socket_type_VECTOR = 1,
	ForeachGeometryElementGenerationItem_socket_type_ROTATION = 14,
	ForeachGeometryElementGenerationItem_socket_type_MATRIX = 16,
	ForeachGeometryElementGenerationItem_socket_type_STRING = 7,
	ForeachGeometryElementGenerationItem_socket_type_MENU = 15,
	ForeachGeometryElementGenerationItem_socket_type_RGBA = 2,
	ForeachGeometryElementGenerationItem_socket_type_OBJECT = 8,
	ForeachGeometryElementGenerationItem_socket_type_IMAGE = 9,
	ForeachGeometryElementGenerationItem_socket_type_GEOMETRY = 10,
	ForeachGeometryElementGenerationItem_socket_type_COLLECTION = 11,
	ForeachGeometryElementGenerationItem_socket_type_TEXTURE = 12,
	ForeachGeometryElementGenerationItem_socket_type_MATERIAL = 13,
	ForeachGeometryElementGenerationItem_socket_type_BUNDLE = 17,
	ForeachGeometryElementGenerationItem_socket_type_CLOSURE = 18,
};

int ForeachGeometryElementGenerationItem_socket_type_get(PointerRNA *ptr);
void ForeachGeometryElementGenerationItem_socket_type_set(PointerRNA *ptr, int value);

/**************** For Each Geometry Element Item ****************/

extern StructRNA RNA_ForeachGeometryElementInputItem;

PointerRNA ForeachGeometryElementInputItem_rna_type_get(PointerRNA *ptr);

void ForeachGeometryElementInputItem_name_get(PointerRNA *ptr, char *value);
int ForeachGeometryElementInputItem_name_length(PointerRNA *ptr);
void ForeachGeometryElementInputItem_name_set(PointerRNA *ptr, const char *value);

void ForeachGeometryElementInputItem_color_get(PointerRNA *ptr, float values[4]);
void ForeachGeometryElementInputItem_color_set(PointerRNA *ptr, const float values[4]);

enum {
	ForeachGeometryElementInputItem_socket_type_FLOAT = 0,
	ForeachGeometryElementInputItem_socket_type_INT = 6,
	ForeachGeometryElementInputItem_socket_type_BOOLEAN = 4,
	ForeachGeometryElementInputItem_socket_type_VECTOR = 1,
	ForeachGeometryElementInputItem_socket_type_ROTATION = 14,
	ForeachGeometryElementInputItem_socket_type_MATRIX = 16,
	ForeachGeometryElementInputItem_socket_type_STRING = 7,
	ForeachGeometryElementInputItem_socket_type_MENU = 15,
	ForeachGeometryElementInputItem_socket_type_RGBA = 2,
	ForeachGeometryElementInputItem_socket_type_OBJECT = 8,
	ForeachGeometryElementInputItem_socket_type_IMAGE = 9,
	ForeachGeometryElementInputItem_socket_type_GEOMETRY = 10,
	ForeachGeometryElementInputItem_socket_type_COLLECTION = 11,
	ForeachGeometryElementInputItem_socket_type_TEXTURE = 12,
	ForeachGeometryElementInputItem_socket_type_MATERIAL = 13,
	ForeachGeometryElementInputItem_socket_type_BUNDLE = 17,
	ForeachGeometryElementInputItem_socket_type_CLOSURE = 18,
};

int ForeachGeometryElementInputItem_socket_type_get(PointerRNA *ptr);
void ForeachGeometryElementInputItem_socket_type_set(PointerRNA *ptr, int value);

/**************** For Each Geometry Element Item ****************/

extern StructRNA RNA_ForeachGeometryElementMainItem;

PointerRNA ForeachGeometryElementMainItem_rna_type_get(PointerRNA *ptr);

void ForeachGeometryElementMainItem_name_get(PointerRNA *ptr, char *value);
int ForeachGeometryElementMainItem_name_length(PointerRNA *ptr);
void ForeachGeometryElementMainItem_name_set(PointerRNA *ptr, const char *value);

void ForeachGeometryElementMainItem_color_get(PointerRNA *ptr, float values[4]);
void ForeachGeometryElementMainItem_color_set(PointerRNA *ptr, const float values[4]);

enum {
	ForeachGeometryElementMainItem_socket_type_FLOAT = 0,
	ForeachGeometryElementMainItem_socket_type_INT = 6,
	ForeachGeometryElementMainItem_socket_type_BOOLEAN = 4,
	ForeachGeometryElementMainItem_socket_type_VECTOR = 1,
	ForeachGeometryElementMainItem_socket_type_ROTATION = 14,
	ForeachGeometryElementMainItem_socket_type_MATRIX = 16,
	ForeachGeometryElementMainItem_socket_type_STRING = 7,
	ForeachGeometryElementMainItem_socket_type_MENU = 15,
	ForeachGeometryElementMainItem_socket_type_RGBA = 2,
	ForeachGeometryElementMainItem_socket_type_OBJECT = 8,
	ForeachGeometryElementMainItem_socket_type_IMAGE = 9,
	ForeachGeometryElementMainItem_socket_type_GEOMETRY = 10,
	ForeachGeometryElementMainItem_socket_type_COLLECTION = 11,
	ForeachGeometryElementMainItem_socket_type_TEXTURE = 12,
	ForeachGeometryElementMainItem_socket_type_MATERIAL = 13,
	ForeachGeometryElementMainItem_socket_type_BUNDLE = 17,
	ForeachGeometryElementMainItem_socket_type_CLOSURE = 18,
};

int ForeachGeometryElementMainItem_socket_type_get(PointerRNA *ptr);
void ForeachGeometryElementMainItem_socket_type_set(PointerRNA *ptr, int value);

/**************** ForeachGeometryElementZoneViewerPathElem ****************/

extern StructRNA RNA_ForeachGeometryElementZoneViewerPathElem;
extern StructRNA RNA_ViewerPathElem;

int ForeachGeometryElementZoneViewerPathElem_zone_output_node_id_get(PointerRNA *ptr);
void ForeachGeometryElementZoneViewerPathElem_zone_output_node_id_set(PointerRNA *ptr, int value);

/**************** Freestyle Line Set ****************/

extern StructRNA RNA_FreestyleLineSet;

PointerRNA FreestyleLineSet_rna_type_get(PointerRNA *ptr);

#define FreestyleLineSet_name_MAX 64

void FreestyleLineSet_name_get(PointerRNA *ptr, char *value);
int FreestyleLineSet_name_length(PointerRNA *ptr);
void FreestyleLineSet_name_set(PointerRNA *ptr, const char *value);

bool FreestyleLineSet_select_border_get(PointerRNA *ptr);
void FreestyleLineSet_select_border_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_exclude_border_get(PointerRNA *ptr);
void FreestyleLineSet_exclude_border_set(PointerRNA *ptr, bool value);

PointerRNA FreestyleLineSet_collection_get(PointerRNA *ptr);

enum {
	FreestyleLineSet_collection_negation_INCLUSIVE = 0,
	FreestyleLineSet_collection_negation_EXCLUSIVE = 16,
};

int FreestyleLineSet_collection_negation_get(PointerRNA *ptr);
void FreestyleLineSet_collection_negation_set(PointerRNA *ptr, int value);

bool FreestyleLineSet_select_contour_get(PointerRNA *ptr);
void FreestyleLineSet_select_contour_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_exclude_contour_get(PointerRNA *ptr);
void FreestyleLineSet_exclude_contour_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_select_crease_get(PointerRNA *ptr);
void FreestyleLineSet_select_crease_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_exclude_crease_get(PointerRNA *ptr);
void FreestyleLineSet_exclude_crease_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_select_edge_mark_get(PointerRNA *ptr);
void FreestyleLineSet_select_edge_mark_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_exclude_edge_mark_get(PointerRNA *ptr);
void FreestyleLineSet_exclude_edge_mark_set(PointerRNA *ptr, bool value);

enum {
	FreestyleLineSet_edge_type_combination_OR = 0,
	FreestyleLineSet_edge_type_combination_AND = 8,
};

int FreestyleLineSet_edge_type_combination_get(PointerRNA *ptr);
void FreestyleLineSet_edge_type_combination_set(PointerRNA *ptr, int value);

enum {
	FreestyleLineSet_edge_type_negation_INCLUSIVE = 0,
	FreestyleLineSet_edge_type_negation_EXCLUSIVE = 4,
};

int FreestyleLineSet_edge_type_negation_get(PointerRNA *ptr);
void FreestyleLineSet_edge_type_negation_set(PointerRNA *ptr, int value);

int FreestyleLineSet_qi_end_get(PointerRNA *ptr);
void FreestyleLineSet_qi_end_set(PointerRNA *ptr, int value);

bool FreestyleLineSet_select_external_contour_get(PointerRNA *ptr);
void FreestyleLineSet_select_external_contour_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_exclude_external_contour_get(PointerRNA *ptr);
void FreestyleLineSet_exclude_external_contour_set(PointerRNA *ptr, bool value);

enum {
	FreestyleLineSet_face_mark_condition_ONE = 0,
	FreestyleLineSet_face_mark_condition_BOTH = 64,
};

int FreestyleLineSet_face_mark_condition_get(PointerRNA *ptr);
void FreestyleLineSet_face_mark_condition_set(PointerRNA *ptr, int value);

enum {
	FreestyleLineSet_face_mark_negation_INCLUSIVE = 0,
	FreestyleLineSet_face_mark_negation_EXCLUSIVE = 32,
};

int FreestyleLineSet_face_mark_negation_get(PointerRNA *ptr);
void FreestyleLineSet_face_mark_negation_set(PointerRNA *ptr, int value);

PointerRNA FreestyleLineSet_linestyle_get(PointerRNA *ptr);

bool FreestyleLineSet_select_material_boundary_get(PointerRNA *ptr);
void FreestyleLineSet_select_material_boundary_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_exclude_material_boundary_get(PointerRNA *ptr);
void FreestyleLineSet_exclude_material_boundary_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_show_render_get(PointerRNA *ptr);
void FreestyleLineSet_show_render_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_select_ridge_valley_get(PointerRNA *ptr);
void FreestyleLineSet_select_ridge_valley_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_exclude_ridge_valley_get(PointerRNA *ptr);
void FreestyleLineSet_exclude_ridge_valley_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_select_by_collection_get(PointerRNA *ptr);
void FreestyleLineSet_select_by_collection_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_select_by_edge_types_get(PointerRNA *ptr);
void FreestyleLineSet_select_by_edge_types_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_select_by_face_marks_get(PointerRNA *ptr);
void FreestyleLineSet_select_by_face_marks_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_select_by_image_border_get(PointerRNA *ptr);
void FreestyleLineSet_select_by_image_border_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_select_by_visibility_get(PointerRNA *ptr);
void FreestyleLineSet_select_by_visibility_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_select_silhouette_get(PointerRNA *ptr);
void FreestyleLineSet_select_silhouette_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_exclude_silhouette_get(PointerRNA *ptr);
void FreestyleLineSet_exclude_silhouette_set(PointerRNA *ptr, bool value);

int FreestyleLineSet_qi_start_get(PointerRNA *ptr);
void FreestyleLineSet_qi_start_set(PointerRNA *ptr, int value);

bool FreestyleLineSet_select_suggestive_contour_get(PointerRNA *ptr);
void FreestyleLineSet_select_suggestive_contour_set(PointerRNA *ptr, bool value);

bool FreestyleLineSet_exclude_suggestive_contour_get(PointerRNA *ptr);
void FreestyleLineSet_exclude_suggestive_contour_set(PointerRNA *ptr, bool value);

enum {
	FreestyleLineSet_visibility_VISIBLE = 1,
	FreestyleLineSet_visibility_HIDDEN = 2,
	FreestyleLineSet_visibility_RANGE = 3,
};

int FreestyleLineSet_visibility_get(PointerRNA *ptr);
void FreestyleLineSet_visibility_set(PointerRNA *ptr, int value);

/**************** Freestyle Line Style ****************/

extern StructRNA RNA_FreestyleLineStyle;
extern StructRNA RNA_ID;

PointerRNA FreestyleLineStyle_active_texture_get(PointerRNA *ptr);

int FreestyleLineStyle_active_texture_index_get(PointerRNA *ptr);
void FreestyleLineStyle_active_texture_index_set(PointerRNA *ptr, int value);

void FreestyleLineStyle_alpha_modifiers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void FreestyleLineStyle_alpha_modifiers_next(CollectionPropertyIterator *iter);
void FreestyleLineStyle_alpha_modifiers_end(CollectionPropertyIterator *iter);
bool FreestyleLineStyle_alpha_modifiers_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool FreestyleLineStyle_alpha_modifiers_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

float FreestyleLineStyle_alpha_get(PointerRNA *ptr);
void FreestyleLineStyle_alpha_set(PointerRNA *ptr, float value);

PointerRNA FreestyleLineStyle_animation_data_get(PointerRNA *ptr);

enum {
	FreestyleLineStyle_caps_BUTT = 1,
	FreestyleLineStyle_caps_ROUND = 2,
	FreestyleLineStyle_caps_SQUARE = 3,
};

int FreestyleLineStyle_caps_get(PointerRNA *ptr);
void FreestyleLineStyle_caps_set(PointerRNA *ptr, int value);

int FreestyleLineStyle_chain_count_get(PointerRNA *ptr);
void FreestyleLineStyle_chain_count_set(PointerRNA *ptr, int value);

bool FreestyleLineStyle_use_chaining_get(PointerRNA *ptr);
void FreestyleLineStyle_use_chaining_set(PointerRNA *ptr, bool value);

enum {
	FreestyleLineStyle_chaining_PLAIN = 1,
	FreestyleLineStyle_chaining_SKETCHY = 2,
};

int FreestyleLineStyle_chaining_get(PointerRNA *ptr);
void FreestyleLineStyle_chaining_set(PointerRNA *ptr, int value);

void FreestyleLineStyle_color_get(PointerRNA *ptr, float values[3]);
void FreestyleLineStyle_color_set(PointerRNA *ptr, const float values[3]);

void FreestyleLineStyle_color_modifiers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void FreestyleLineStyle_color_modifiers_next(CollectionPropertyIterator *iter);
void FreestyleLineStyle_color_modifiers_end(CollectionPropertyIterator *iter);
bool FreestyleLineStyle_color_modifiers_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool FreestyleLineStyle_color_modifiers_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

int FreestyleLineStyle_dash1_get(PointerRNA *ptr);
void FreestyleLineStyle_dash1_set(PointerRNA *ptr, int value);

int FreestyleLineStyle_dash2_get(PointerRNA *ptr);
void FreestyleLineStyle_dash2_set(PointerRNA *ptr, int value);

int FreestyleLineStyle_dash3_get(PointerRNA *ptr);
void FreestyleLineStyle_dash3_set(PointerRNA *ptr, int value);

bool FreestyleLineStyle_use_dashed_line_get(PointerRNA *ptr);
void FreestyleLineStyle_use_dashed_line_set(PointerRNA *ptr, bool value);

int FreestyleLineStyle_gap1_get(PointerRNA *ptr);
void FreestyleLineStyle_gap1_set(PointerRNA *ptr, int value);

int FreestyleLineStyle_gap2_get(PointerRNA *ptr);
void FreestyleLineStyle_gap2_set(PointerRNA *ptr, int value);

int FreestyleLineStyle_gap3_get(PointerRNA *ptr);
void FreestyleLineStyle_gap3_set(PointerRNA *ptr, int value);

void FreestyleLineStyle_geometry_modifiers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void FreestyleLineStyle_geometry_modifiers_next(CollectionPropertyIterator *iter);
void FreestyleLineStyle_geometry_modifiers_end(CollectionPropertyIterator *iter);
bool FreestyleLineStyle_geometry_modifiers_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool FreestyleLineStyle_geometry_modifiers_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

enum {
	FreestyleLineStyle_integration_type_MEAN = 1,
	FreestyleLineStyle_integration_type_MIN = 2,
	FreestyleLineStyle_integration_type_MAX = 3,
	FreestyleLineStyle_integration_type_FIRST = 4,
	FreestyleLineStyle_integration_type_LAST = 5,
};

int FreestyleLineStyle_integration_type_get(PointerRNA *ptr);
void FreestyleLineStyle_integration_type_set(PointerRNA *ptr, int value);

bool FreestyleLineStyle_material_boundary_get(PointerRNA *ptr);
void FreestyleLineStyle_material_boundary_set(PointerRNA *ptr, bool value);

float FreestyleLineStyle_angle_max_get(PointerRNA *ptr);
void FreestyleLineStyle_angle_max_set(PointerRNA *ptr, float value);

float FreestyleLineStyle_length_max_get(PointerRNA *ptr);
void FreestyleLineStyle_length_max_set(PointerRNA *ptr, float value);

float FreestyleLineStyle_angle_min_get(PointerRNA *ptr);
void FreestyleLineStyle_angle_min_set(PointerRNA *ptr, float value);

float FreestyleLineStyle_length_min_get(PointerRNA *ptr);
void FreestyleLineStyle_length_min_set(PointerRNA *ptr, float value);

PointerRNA FreestyleLineStyle_node_tree_get(PointerRNA *ptr);

enum {
	FreestyleLineStyle_panel_STROKES = 1,
	FreestyleLineStyle_panel_COLOR = 2,
	FreestyleLineStyle_panel_ALPHA = 3,
	FreestyleLineStyle_panel_THICKNESS = 4,
	FreestyleLineStyle_panel_GEOMETRY = 5,
	FreestyleLineStyle_panel_TEXTURE = 6,
};

int FreestyleLineStyle_panel_get(PointerRNA *ptr);
void FreestyleLineStyle_panel_set(PointerRNA *ptr, int value);

int FreestyleLineStyle_rounds_get(PointerRNA *ptr);
void FreestyleLineStyle_rounds_set(PointerRNA *ptr, int value);

bool FreestyleLineStyle_use_same_object_get(PointerRNA *ptr);
void FreestyleLineStyle_use_same_object_set(PointerRNA *ptr, bool value);

enum {
	FreestyleLineStyle_sort_key_DISTANCE_FROM_CAMERA = 1,
	FreestyleLineStyle_sort_key_2D_LENGTH = 2,
	FreestyleLineStyle_sort_key_PROJECTED_X = 3,
	FreestyleLineStyle_sort_key_PROJECTED_Y = 4,
};

int FreestyleLineStyle_sort_key_get(PointerRNA *ptr);
void FreestyleLineStyle_sort_key_set(PointerRNA *ptr, int value);

enum {
	FreestyleLineStyle_sort_order_DEFAULT = 0,
	FreestyleLineStyle_sort_order_REVERSE = 4096,
};

int FreestyleLineStyle_sort_order_get(PointerRNA *ptr);
void FreestyleLineStyle_sort_order_set(PointerRNA *ptr, int value);

bool FreestyleLineStyle_use_sorting_get(PointerRNA *ptr);
void FreestyleLineStyle_use_sorting_set(PointerRNA *ptr, bool value);

int FreestyleLineStyle_split_dash1_get(PointerRNA *ptr);
void FreestyleLineStyle_split_dash1_set(PointerRNA *ptr, int value);

int FreestyleLineStyle_split_dash2_get(PointerRNA *ptr);
void FreestyleLineStyle_split_dash2_set(PointerRNA *ptr, int value);

int FreestyleLineStyle_split_dash3_get(PointerRNA *ptr);
void FreestyleLineStyle_split_dash3_set(PointerRNA *ptr, int value);

int FreestyleLineStyle_split_gap1_get(PointerRNA *ptr);
void FreestyleLineStyle_split_gap1_set(PointerRNA *ptr, int value);

int FreestyleLineStyle_split_gap2_get(PointerRNA *ptr);
void FreestyleLineStyle_split_gap2_set(PointerRNA *ptr, int value);

int FreestyleLineStyle_split_gap3_get(PointerRNA *ptr);
void FreestyleLineStyle_split_gap3_set(PointerRNA *ptr, int value);

float FreestyleLineStyle_split_length_get(PointerRNA *ptr);
void FreestyleLineStyle_split_length_set(PointerRNA *ptr, float value);

float FreestyleLineStyle_texture_spacing_get(PointerRNA *ptr);
void FreestyleLineStyle_texture_spacing_set(PointerRNA *ptr, float value);

void FreestyleLineStyle_texture_slots_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void FreestyleLineStyle_texture_slots_next(CollectionPropertyIterator *iter);
void FreestyleLineStyle_texture_slots_end(CollectionPropertyIterator *iter);

float FreestyleLineStyle_thickness_get(PointerRNA *ptr);
void FreestyleLineStyle_thickness_set(PointerRNA *ptr, float value);

void FreestyleLineStyle_thickness_modifiers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void FreestyleLineStyle_thickness_modifiers_next(CollectionPropertyIterator *iter);
void FreestyleLineStyle_thickness_modifiers_end(CollectionPropertyIterator *iter);
bool FreestyleLineStyle_thickness_modifiers_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool FreestyleLineStyle_thickness_modifiers_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

enum {
	FreestyleLineStyle_thickness_position_CENTER = 1,
	FreestyleLineStyle_thickness_position_INSIDE = 2,
	FreestyleLineStyle_thickness_position_OUTSIDE = 3,
	FreestyleLineStyle_thickness_position_RELATIVE = 4,
};

int FreestyleLineStyle_thickness_position_get(PointerRNA *ptr);
void FreestyleLineStyle_thickness_position_set(PointerRNA *ptr, int value);

float FreestyleLineStyle_thickness_ratio_get(PointerRNA *ptr);
void FreestyleLineStyle_thickness_ratio_set(PointerRNA *ptr, float value);

bool FreestyleLineStyle_use_chain_count_get(PointerRNA *ptr);
void FreestyleLineStyle_use_chain_count_set(PointerRNA *ptr, bool value);

bool FreestyleLineStyle_use_angle_max_get(PointerRNA *ptr);
void FreestyleLineStyle_use_angle_max_set(PointerRNA *ptr, bool value);

bool FreestyleLineStyle_use_length_max_get(PointerRNA *ptr);
void FreestyleLineStyle_use_length_max_set(PointerRNA *ptr, bool value);

bool FreestyleLineStyle_use_angle_min_get(PointerRNA *ptr);
void FreestyleLineStyle_use_angle_min_set(PointerRNA *ptr, bool value);

bool FreestyleLineStyle_use_length_min_get(PointerRNA *ptr);
void FreestyleLineStyle_use_length_min_set(PointerRNA *ptr, bool value);

bool FreestyleLineStyle_use_nodes_get(PointerRNA *ptr);
void FreestyleLineStyle_use_nodes_set(PointerRNA *ptr, bool value);

bool FreestyleLineStyle_use_split_length_get(PointerRNA *ptr);
void FreestyleLineStyle_use_split_length_set(PointerRNA *ptr, bool value);

bool FreestyleLineStyle_use_split_pattern_get(PointerRNA *ptr);
void FreestyleLineStyle_use_split_pattern_set(PointerRNA *ptr, bool value);

bool FreestyleLineStyle_use_texture_get(PointerRNA *ptr);
void FreestyleLineStyle_use_texture_set(PointerRNA *ptr, bool value);

/**************** Freestyle Module ****************/

extern StructRNA RNA_FreestyleModuleSettings;

PointerRNA FreestyleModuleSettings_rna_type_get(PointerRNA *ptr);

PointerRNA FreestyleModuleSettings_script_get(PointerRNA *ptr);

bool FreestyleModuleSettings_use_get(PointerRNA *ptr);
void FreestyleModuleSettings_use_set(PointerRNA *ptr, bool value);

/**************** Style Modules ****************/

extern StructRNA RNA_FreestyleModules;

PointerRNA FreestyleModules_rna_type_get(PointerRNA *ptr);

struct FreestyleModuleConfig *FreestyleModules_new_func(struct ID *_selfid, struct FreestyleSettings *_self);
void FreestyleModules_remove_func(struct ID *_selfid, struct FreestyleSettings *_self, ReportList *reports, struct PointerRNA *module);
/**************** Freestyle Settings ****************/

extern StructRNA RNA_FreestyleSettings;

PointerRNA FreestyleSettings_rna_type_get(PointerRNA *ptr);

bool FreestyleSettings_as_render_pass_get(PointerRNA *ptr);
void FreestyleSettings_as_render_pass_set(PointerRNA *ptr, bool value);

enum {
	FreestyleSettings_mode_SCRIPT = 1,
	FreestyleSettings_mode_EDITOR = 2,
};

int FreestyleSettings_mode_get(PointerRNA *ptr);
void FreestyleSettings_mode_set(PointerRNA *ptr, int value);

float FreestyleSettings_crease_angle_get(PointerRNA *ptr);
void FreestyleSettings_crease_angle_set(PointerRNA *ptr, float value);

bool FreestyleSettings_use_culling_get(PointerRNA *ptr);
void FreestyleSettings_use_culling_set(PointerRNA *ptr, bool value);

bool FreestyleSettings_use_smoothness_get(PointerRNA *ptr);
void FreestyleSettings_use_smoothness_set(PointerRNA *ptr, bool value);

float FreestyleSettings_kr_derivative_epsilon_get(PointerRNA *ptr);
void FreestyleSettings_kr_derivative_epsilon_set(PointerRNA *ptr, float value);

void FreestyleSettings_linesets_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void FreestyleSettings_linesets_next(CollectionPropertyIterator *iter);
void FreestyleSettings_linesets_end(CollectionPropertyIterator *iter);
bool FreestyleSettings_linesets_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool FreestyleSettings_linesets_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool FreestyleSettings_use_material_boundaries_get(PointerRNA *ptr);
void FreestyleSettings_use_material_boundaries_set(PointerRNA *ptr, bool value);

bool FreestyleSettings_use_ridges_and_valleys_get(PointerRNA *ptr);
void FreestyleSettings_use_ridges_and_valleys_set(PointerRNA *ptr, bool value);

float FreestyleSettings_sphere_radius_get(PointerRNA *ptr);
void FreestyleSettings_sphere_radius_set(PointerRNA *ptr, float value);

void FreestyleSettings_modules_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void FreestyleSettings_modules_next(CollectionPropertyIterator *iter);
void FreestyleSettings_modules_end(CollectionPropertyIterator *iter);
bool FreestyleSettings_modules_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool FreestyleSettings_use_suggestive_contours_get(PointerRNA *ptr);
void FreestyleSettings_use_suggestive_contours_set(PointerRNA *ptr, bool value);

bool FreestyleSettings_use_view_map_cache_get(PointerRNA *ptr);
void FreestyleSettings_use_view_map_cache_set(PointerRNA *ptr, bool value);

/**************** Function Definition ****************/

extern StructRNA RNA_Function;

PointerRNA Function_rna_type_get(PointerRNA *ptr);

void Function_description_get(PointerRNA *ptr, char *value);
int Function_description_length(PointerRNA *ptr);
void Function_description_set(PointerRNA *ptr, const char *value);

void Function_identifier_get(PointerRNA *ptr, char *value);
int Function_identifier_length(PointerRNA *ptr);
void Function_identifier_set(PointerRNA *ptr, const char *value);

bool Function_use_self_get(PointerRNA *ptr);
void Function_use_self_set(PointerRNA *ptr, bool value);

void Function_parameters_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Function_parameters_next(CollectionPropertyIterator *iter);
void Function_parameters_end(CollectionPropertyIterator *iter);

bool Function_is_registered_get(PointerRNA *ptr);
void Function_is_registered_set(PointerRNA *ptr, bool value);

bool Function_is_registered_optional_get(PointerRNA *ptr);
void Function_is_registered_optional_set(PointerRNA *ptr, bool value);

bool Function_use_self_type_get(PointerRNA *ptr);
void Function_use_self_type_set(PointerRNA *ptr, bool value);

/**************** Function Node ****************/

extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

/**************** FunctionNodeAlignEulerToVector ****************/

extern StructRNA RNA_FunctionNodeAlignEulerToVector;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeAlignEulerToVector_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeAlignEulerToVector_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeAlignEulerToVector_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeAlignRotationToVector ****************/

extern StructRNA RNA_FunctionNodeAlignRotationToVector;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeAlignRotationToVector_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeAlignRotationToVector_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeAlignRotationToVector_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeAxesToRotation ****************/

extern StructRNA RNA_FunctionNodeAxesToRotation;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeAxesToRotation_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeAxesToRotation_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeAxesToRotation_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeAxisAngleToRotation ****************/

extern StructRNA RNA_FunctionNodeAxisAngleToRotation;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeAxisAngleToRotation_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeAxisAngleToRotation_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeAxisAngleToRotation_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeBitMath ****************/

extern StructRNA RNA_FunctionNodeBitMath;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeBitMath_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeBitMath_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeBitMath_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeBooleanMath ****************/

extern StructRNA RNA_FunctionNodeBooleanMath;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeBooleanMath_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeBooleanMath_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeBooleanMath_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeCombineColor ****************/

extern StructRNA RNA_FunctionNodeCombineColor;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeCombineColor_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeCombineColor_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeCombineColor_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeCombineMatrix ****************/

extern StructRNA RNA_FunctionNodeCombineMatrix;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeCombineMatrix_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeCombineMatrix_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeCombineMatrix_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeCombineTransform ****************/

extern StructRNA RNA_FunctionNodeCombineTransform;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeCombineTransform_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeCombineTransform_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeCombineTransform_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeCompare ****************/

extern StructRNA RNA_FunctionNodeCompare;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeCompare_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeCompare_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeCompare_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeEulerToRotation ****************/

extern StructRNA RNA_FunctionNodeEulerToRotation;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeEulerToRotation_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeEulerToRotation_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeEulerToRotation_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeFindInString ****************/

extern StructRNA RNA_FunctionNodeFindInString;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeFindInString_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeFindInString_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeFindInString_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeFloatToInt ****************/

extern StructRNA RNA_FunctionNodeFloatToInt;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	FunctionNodeFloatToInt_rounding_mode_ROUND = 0,
	FunctionNodeFloatToInt_rounding_mode_FLOOR = 1,
	FunctionNodeFloatToInt_rounding_mode_CEILING = 2,
	FunctionNodeFloatToInt_rounding_mode_TRUNCATE = 3,
};

int FunctionNodeFloatToInt_rounding_mode_get(PointerRNA *ptr);
void FunctionNodeFloatToInt_rounding_mode_set(PointerRNA *ptr, int value);

bool FunctionNodeFloatToInt_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeFloatToInt_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeFloatToInt_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeFormatString ****************/

extern StructRNA RNA_FunctionNodeFormatString;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int FunctionNodeFormatString_active_index_get(PointerRNA *ptr);
void FunctionNodeFormatString_active_index_set(PointerRNA *ptr, int value);

void FunctionNodeFormatString_format_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void FunctionNodeFormatString_format_items_next(CollectionPropertyIterator *iter);
void FunctionNodeFormatString_format_items_end(CollectionPropertyIterator *iter);
int FunctionNodeFormatString_format_items_length(PointerRNA *ptr);
bool FunctionNodeFormatString_format_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool FunctionNodeFormatString_format_items_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool FunctionNodeFormatString_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeFormatString_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeFormatString_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeHashValue ****************/

extern StructRNA RNA_FunctionNodeHashValue;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeHashValue_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeHashValue_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeHashValue_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeInputBool ****************/

extern StructRNA RNA_FunctionNodeInputBool;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeInputBool_boolean_get(PointerRNA *ptr);
void FunctionNodeInputBool_boolean_set(PointerRNA *ptr, bool value);

bool FunctionNodeInputBool_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeInputBool_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeInputBool_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeInputColor ****************/

extern StructRNA RNA_FunctionNodeInputColor;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

void FunctionNodeInputColor_value_get(PointerRNA *ptr, float values[4]);
void FunctionNodeInputColor_value_set(PointerRNA *ptr, const float values[4]);

bool FunctionNodeInputColor_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeInputColor_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeInputColor_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeInputInt ****************/

extern StructRNA RNA_FunctionNodeInputInt;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int FunctionNodeInputInt_integer_get(PointerRNA *ptr);
void FunctionNodeInputInt_integer_set(PointerRNA *ptr, int value);

bool FunctionNodeInputInt_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeInputInt_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeInputInt_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeInputRotation ****************/

extern StructRNA RNA_FunctionNodeInputRotation;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

void FunctionNodeInputRotation_rotation_euler_get(PointerRNA *ptr, float values[3]);
void FunctionNodeInputRotation_rotation_euler_set(PointerRNA *ptr, const float values[3]);

bool FunctionNodeInputRotation_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeInputRotation_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeInputRotation_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeInputSpecialCharacters ****************/

extern StructRNA RNA_FunctionNodeInputSpecialCharacters;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeInputSpecialCharacters_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeInputSpecialCharacters_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeInputSpecialCharacters_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeInputString ****************/

extern StructRNA RNA_FunctionNodeInputString;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

void FunctionNodeInputString_string_get(PointerRNA *ptr, char *value);
int FunctionNodeInputString_string_length(PointerRNA *ptr);
void FunctionNodeInputString_string_set(PointerRNA *ptr, const char *value);

bool FunctionNodeInputString_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeInputString_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeInputString_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeInputVector ****************/

extern StructRNA RNA_FunctionNodeInputVector;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

void FunctionNodeInputVector_vector_get(PointerRNA *ptr, float values[3]);
void FunctionNodeInputVector_vector_set(PointerRNA *ptr, const float values[3]);

bool FunctionNodeInputVector_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeInputVector_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeInputVector_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeIntegerMath ****************/

extern StructRNA RNA_FunctionNodeIntegerMath;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeIntegerMath_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeIntegerMath_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeIntegerMath_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeInvertMatrix ****************/

extern StructRNA RNA_FunctionNodeInvertMatrix;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeInvertMatrix_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeInvertMatrix_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeInvertMatrix_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeInvertRotation ****************/

extern StructRNA RNA_FunctionNodeInvertRotation;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeInvertRotation_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeInvertRotation_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeInvertRotation_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeMatchString ****************/

extern StructRNA RNA_FunctionNodeMatchString;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeMatchString_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeMatchString_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeMatchString_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeMatrixDeterminant ****************/

extern StructRNA RNA_FunctionNodeMatrixDeterminant;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeMatrixDeterminant_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeMatrixDeterminant_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeMatrixDeterminant_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeMatrixMultiply ****************/

extern StructRNA RNA_FunctionNodeMatrixMultiply;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeMatrixMultiply_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeMatrixMultiply_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeMatrixMultiply_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeProjectPoint ****************/

extern StructRNA RNA_FunctionNodeProjectPoint;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeProjectPoint_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeProjectPoint_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeProjectPoint_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeQuaternionToRotation ****************/

extern StructRNA RNA_FunctionNodeQuaternionToRotation;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeQuaternionToRotation_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeQuaternionToRotation_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeQuaternionToRotation_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeRandomValue ****************/

extern StructRNA RNA_FunctionNodeRandomValue;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	FunctionNodeRandomValue_data_type_FLOAT = 10,
	FunctionNodeRandomValue_data_type_INT = 11,
	FunctionNodeRandomValue_data_type_FLOAT_VECTOR = 48,
	FunctionNodeRandomValue_data_type_FLOAT_COLOR = 47,
	FunctionNodeRandomValue_data_type_BYTE_COLOR = 17,
	FunctionNodeRandomValue_data_type_STRING = 12,
	FunctionNodeRandomValue_data_type_BOOLEAN = 50,
	FunctionNodeRandomValue_data_type_FLOAT2 = 49,
	FunctionNodeRandomValue_data_type_INT8 = 45,
	FunctionNodeRandomValue_data_type_INT16_2D = 22,
	FunctionNodeRandomValue_data_type_INT32_2D = 46,
	FunctionNodeRandomValue_data_type_QUATERNION = 52,
	FunctionNodeRandomValue_data_type_FLOAT4X4 = 20,
};

int FunctionNodeRandomValue_data_type_get(PointerRNA *ptr);
void FunctionNodeRandomValue_data_type_set(PointerRNA *ptr, int value);

bool FunctionNodeRandomValue_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeRandomValue_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeRandomValue_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeReplaceString ****************/

extern StructRNA RNA_FunctionNodeReplaceString;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeReplaceString_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeReplaceString_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeReplaceString_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeRotateEuler ****************/

extern StructRNA RNA_FunctionNodeRotateEuler;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	FunctionNodeRotateEuler_space_OBJECT = 0,
	FunctionNodeRotateEuler_space_LOCAL = 1,
};

int FunctionNodeRotateEuler_space_get(PointerRNA *ptr);
void FunctionNodeRotateEuler_space_set(PointerRNA *ptr, int value);

enum {
	FunctionNodeRotateEuler_rotation_type_AXIS_ANGLE = 1,
	FunctionNodeRotateEuler_rotation_type_EULER = 0,
};

int FunctionNodeRotateEuler_rotation_type_get(PointerRNA *ptr);
void FunctionNodeRotateEuler_rotation_type_set(PointerRNA *ptr, int value);

bool FunctionNodeRotateEuler_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeRotateEuler_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeRotateEuler_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeRotateRotation ****************/

extern StructRNA RNA_FunctionNodeRotateRotation;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeRotateRotation_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeRotateRotation_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeRotateRotation_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeRotateVector ****************/

extern StructRNA RNA_FunctionNodeRotateVector;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeRotateVector_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeRotateVector_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeRotateVector_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeRotationToAxisAngle ****************/

extern StructRNA RNA_FunctionNodeRotationToAxisAngle;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeRotationToAxisAngle_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeRotationToAxisAngle_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeRotationToAxisAngle_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeRotationToEuler ****************/

extern StructRNA RNA_FunctionNodeRotationToEuler;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeRotationToEuler_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeRotationToEuler_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeRotationToEuler_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeRotationToQuaternion ****************/

extern StructRNA RNA_FunctionNodeRotationToQuaternion;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeRotationToQuaternion_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeRotationToQuaternion_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeRotationToQuaternion_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeSeparateColor ****************/

extern StructRNA RNA_FunctionNodeSeparateColor;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeSeparateColor_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeSeparateColor_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeSeparateColor_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeSeparateMatrix ****************/

extern StructRNA RNA_FunctionNodeSeparateMatrix;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeSeparateMatrix_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeSeparateMatrix_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeSeparateMatrix_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeSeparateTransform ****************/

extern StructRNA RNA_FunctionNodeSeparateTransform;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeSeparateTransform_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeSeparateTransform_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeSeparateTransform_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeSliceString ****************/

extern StructRNA RNA_FunctionNodeSliceString;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeSliceString_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeSliceString_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeSliceString_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeStringLength ****************/

extern StructRNA RNA_FunctionNodeStringLength;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeStringLength_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeStringLength_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeStringLength_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeTransformDirection ****************/

extern StructRNA RNA_FunctionNodeTransformDirection;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeTransformDirection_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeTransformDirection_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeTransformDirection_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeTransformPoint ****************/

extern StructRNA RNA_FunctionNodeTransformPoint;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeTransformPoint_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeTransformPoint_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeTransformPoint_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeTransposeMatrix ****************/

extern StructRNA RNA_FunctionNodeTransposeMatrix;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeTransposeMatrix_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeTransposeMatrix_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeTransposeMatrix_output_template_func(struct StructRNA *_type, int index);
/**************** FunctionNodeValueToString ****************/

extern StructRNA RNA_FunctionNodeValueToString;
extern StructRNA RNA_FunctionNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool FunctionNodeValueToString_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA FunctionNodeValueToString_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA FunctionNodeValueToString_output_template_func(struct StructRNA *_type, int index);
/**************** Annotation Frame ****************/

extern StructRNA RNA_GPencilFrame;

PointerRNA GPencilFrame_rna_type_get(PointerRNA *ptr);

int GPencilFrame_frame_number_get(PointerRNA *ptr);
void GPencilFrame_frame_number_set(PointerRNA *ptr, int value);

bool GPencilFrame_select_get(PointerRNA *ptr);
void GPencilFrame_select_set(PointerRNA *ptr, bool value);

void GPencilFrame_strokes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GPencilFrame_strokes_next(CollectionPropertyIterator *iter);
void GPencilFrame_strokes_end(CollectionPropertyIterator *iter);
bool GPencilFrame_strokes_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Annotation Frames ****************/

extern StructRNA RNA_GPencilFrames;

PointerRNA GPencilFrames_rna_type_get(PointerRNA *ptr);

struct bGPDframe *GPencilFrames_new_func(struct bGPDlayer *_self, ReportList *reports, int frame_number, bool active);
void GPencilFrames_remove_func(struct bGPDlayer *_self, ReportList *reports, struct PointerRNA *frame);
struct bGPDframe *GPencilFrames_copy_func(struct bGPDlayer *_self, struct bGPDframe *source);
/**************** Grease Pencil Interpolate Settings ****************/

extern StructRNA RNA_GPencilInterpolateSettings;

PointerRNA GPencilInterpolateSettings_rna_type_get(PointerRNA *ptr);

PointerRNA GPencilInterpolateSettings_interpolation_curve_get(PointerRNA *ptr);

/**************** Annotation Layer ****************/

extern StructRNA RNA_GPencilLayer;

PointerRNA GPencilLayer_rna_type_get(PointerRNA *ptr);

PointerRNA GPencilLayer_active_frame_get(PointerRNA *ptr);

void GPencilLayer_annotation_onion_after_color_get(PointerRNA *ptr, float values[3]);
void GPencilLayer_annotation_onion_after_color_set(PointerRNA *ptr, const float values[3]);

void GPencilLayer_annotation_onion_before_color_get(PointerRNA *ptr, float values[3]);
void GPencilLayer_annotation_onion_before_color_set(PointerRNA *ptr, const float values[3]);

void GPencilLayer_color_get(PointerRNA *ptr, float values[3]);
void GPencilLayer_color_set(PointerRNA *ptr, const float values[3]);

bool GPencilLayer_annotation_onion_use_custom_color_get(PointerRNA *ptr);
void GPencilLayer_annotation_onion_use_custom_color_set(PointerRNA *ptr, bool value);

bool GPencilLayer_lock_frame_get(PointerRNA *ptr);
void GPencilLayer_lock_frame_set(PointerRNA *ptr, bool value);

void GPencilLayer_frames_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GPencilLayer_frames_next(CollectionPropertyIterator *iter);
void GPencilLayer_frames_end(CollectionPropertyIterator *iter);
bool GPencilLayer_frames_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

int GPencilLayer_annotation_onion_after_range_get(PointerRNA *ptr);
void GPencilLayer_annotation_onion_after_range_set(PointerRNA *ptr, int value);

int GPencilLayer_annotation_onion_before_range_get(PointerRNA *ptr);
void GPencilLayer_annotation_onion_before_range_set(PointerRNA *ptr, int value);

bool GPencilLayer_annotation_hide_get(PointerRNA *ptr);
void GPencilLayer_annotation_hide_set(PointerRNA *ptr, bool value);

bool GPencilLayer_show_in_front_get(PointerRNA *ptr);
void GPencilLayer_show_in_front_set(PointerRNA *ptr, bool value);

#define GPencilLayer_info_MAX 128

void GPencilLayer_info_get(PointerRNA *ptr, char *value);
int GPencilLayer_info_length(PointerRNA *ptr);
void GPencilLayer_info_set(PointerRNA *ptr, const char *value);

bool GPencilLayer_lock_get(PointerRNA *ptr);
void GPencilLayer_lock_set(PointerRNA *ptr, bool value);

bool GPencilLayer_use_annotation_onion_skinning_get(PointerRNA *ptr);
void GPencilLayer_use_annotation_onion_skinning_set(PointerRNA *ptr, bool value);

float GPencilLayer_annotation_opacity_get(PointerRNA *ptr);
void GPencilLayer_annotation_opacity_set(PointerRNA *ptr, float value);

bool GPencilLayer_is_ruler_get(PointerRNA *ptr);
void GPencilLayer_is_ruler_set(PointerRNA *ptr, bool value);

bool GPencilLayer_select_get(PointerRNA *ptr);
void GPencilLayer_select_set(PointerRNA *ptr, bool value);

int GPencilLayer_thickness_get(PointerRNA *ptr);
void GPencilLayer_thickness_set(PointerRNA *ptr, int value);

/**************** Grease Pencil Sculpt Guide ****************/

extern StructRNA RNA_GPencilSculptGuide;

PointerRNA GPencilSculptGuide_rna_type_get(PointerRNA *ptr);

float GPencilSculptGuide_angle_get(PointerRNA *ptr);
void GPencilSculptGuide_angle_set(PointerRNA *ptr, float value);

float GPencilSculptGuide_angle_snap_get(PointerRNA *ptr);
void GPencilSculptGuide_angle_snap_set(PointerRNA *ptr, float value);

void GPencilSculptGuide_location_get(PointerRNA *ptr, float values[3]);
void GPencilSculptGuide_location_set(PointerRNA *ptr, const float values[3]);

PointerRNA GPencilSculptGuide_reference_object_get(PointerRNA *ptr);

float GPencilSculptGuide_spacing_get(PointerRNA *ptr);
void GPencilSculptGuide_spacing_set(PointerRNA *ptr, float value);

enum {
	GPencilSculptGuide_reference_point_CURSOR = 0,
	GPencilSculptGuide_reference_point_CUSTOM = 1,
	GPencilSculptGuide_reference_point_OBJECT = 2,
};

int GPencilSculptGuide_reference_point_get(PointerRNA *ptr);
void GPencilSculptGuide_reference_point_set(PointerRNA *ptr, int value);

enum {
	GPencilSculptGuide_type_CIRCULAR = 0,
	GPencilSculptGuide_type_RADIAL = 1,
	GPencilSculptGuide_type_PARALLEL = 2,
	GPencilSculptGuide_type_GRID = 3,
	GPencilSculptGuide_type_ISO = 4,
};

int GPencilSculptGuide_type_get(PointerRNA *ptr);
void GPencilSculptGuide_type_set(PointerRNA *ptr, int value);

bool GPencilSculptGuide_use_guide_get(PointerRNA *ptr);
void GPencilSculptGuide_use_guide_set(PointerRNA *ptr, bool value);

bool GPencilSculptGuide_use_snapping_get(PointerRNA *ptr);
void GPencilSculptGuide_use_snapping_set(PointerRNA *ptr, bool value);

/**************** GPencil Sculpt Settings ****************/

extern StructRNA RNA_GPencilSculptSettings;

PointerRNA GPencilSculptSettings_rna_type_get(PointerRNA *ptr);

bool GPencilSculptSettings_use_automasking_layer_stroke_get(PointerRNA *ptr);
void GPencilSculptSettings_use_automasking_layer_stroke_set(PointerRNA *ptr, bool value);

bool GPencilSculptSettings_use_automasking_layer_active_get(PointerRNA *ptr);
void GPencilSculptSettings_use_automasking_layer_active_set(PointerRNA *ptr, bool value);

bool GPencilSculptSettings_use_automasking_material_stroke_get(PointerRNA *ptr);
void GPencilSculptSettings_use_automasking_material_stroke_set(PointerRNA *ptr, bool value);

bool GPencilSculptSettings_use_automasking_material_active_get(PointerRNA *ptr);
void GPencilSculptSettings_use_automasking_material_active_set(PointerRNA *ptr, bool value);

bool GPencilSculptSettings_use_automasking_stroke_get(PointerRNA *ptr);
void GPencilSculptSettings_use_automasking_stroke_set(PointerRNA *ptr, bool value);

PointerRNA GPencilSculptSettings_multiframe_falloff_curve_get(PointerRNA *ptr);

PointerRNA GPencilSculptSettings_thickness_primitive_curve_get(PointerRNA *ptr);

PointerRNA GPencilSculptSettings_guide_get(PointerRNA *ptr);

enum {
	GPencilSculptSettings_lock_axis_VIEW = 0,
	GPencilSculptSettings_lock_axis_AXIS_Y = 2,
	GPencilSculptSettings_lock_axis_AXIS_X = 1,
	GPencilSculptSettings_lock_axis_AXIS_Z = 3,
	GPencilSculptSettings_lock_axis_CURSOR = 4,
};

int GPencilSculptSettings_lock_axis_get(PointerRNA *ptr);
void GPencilSculptSettings_lock_axis_set(PointerRNA *ptr, int value);

bool GPencilSculptSettings_use_scale_thickness_get(PointerRNA *ptr);
void GPencilSculptSettings_use_scale_thickness_set(PointerRNA *ptr, bool value);

float GPencilSculptSettings_intersection_threshold_get(PointerRNA *ptr);
void GPencilSculptSettings_intersection_threshold_set(PointerRNA *ptr, float value);

bool GPencilSculptSettings_use_thickness_curve_get(PointerRNA *ptr);
void GPencilSculptSettings_use_thickness_curve_set(PointerRNA *ptr, bool value);

bool GPencilSculptSettings_use_multiframe_falloff_get(PointerRNA *ptr);
void GPencilSculptSettings_use_multiframe_falloff_set(PointerRNA *ptr, bool value);

/**************** Annotation Stroke ****************/

extern StructRNA RNA_GPencilStroke;

PointerRNA GPencilStroke_rna_type_get(PointerRNA *ptr);

void GPencilStroke_points_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GPencilStroke_points_next(CollectionPropertyIterator *iter);
void GPencilStroke_points_end(CollectionPropertyIterator *iter);
int GPencilStroke_points_length(PointerRNA *ptr);
bool GPencilStroke_points_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Annotation Stroke Point ****************/

extern StructRNA RNA_GPencilStrokePoint;

PointerRNA GPencilStrokePoint_rna_type_get(PointerRNA *ptr);

void GPencilStrokePoint_co_get(PointerRNA *ptr, float values[3]);
void GPencilStrokePoint_co_set(PointerRNA *ptr, const float values[3]);

/**************** Gamma Crossfade Strip ****************/

extern StructRNA RNA_GammaCrossStrip;
extern StructRNA RNA_EffectStrip;
extern StructRNA RNA_Strip;

PointerRNA GammaCrossStrip_input_1_get(PointerRNA *ptr);

PointerRNA GammaCrossStrip_input_2_get(PointerRNA *ptr);

int GammaCrossStrip_input_count_get(PointerRNA *ptr);
void GammaCrossStrip_input_count_set(PointerRNA *ptr, int value);

/**************** Gaussian Blur Strip ****************/

extern StructRNA RNA_GaussianBlurStrip;
extern StructRNA RNA_EffectStrip;
extern StructRNA RNA_Strip;

PointerRNA GaussianBlurStrip_input_1_get(PointerRNA *ptr);

float GaussianBlurStrip_size_x_get(PointerRNA *ptr);
void GaussianBlurStrip_size_x_set(PointerRNA *ptr, float value);

float GaussianBlurStrip_size_y_get(PointerRNA *ptr);
void GaussianBlurStrip_size_y_set(PointerRNA *ptr, float value);

int GaussianBlurStrip_input_count_get(PointerRNA *ptr);
void GaussianBlurStrip_input_count_set(PointerRNA *ptr, int value);

/**************** Geometry Node ****************/

extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

/**************** GeometryNodeAccumulateField ****************/

extern StructRNA RNA_GeometryNodeAccumulateField;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeAccumulateField_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeAccumulateField_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeAccumulateField_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeAttributeDomainSize ****************/

extern StructRNA RNA_GeometryNodeAttributeDomainSize;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeAttributeDomainSize_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeAttributeDomainSize_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeAttributeDomainSize_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeAttributeStatistic ****************/

extern StructRNA RNA_GeometryNodeAttributeStatistic;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeAttributeStatistic_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeAttributeStatistic_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeAttributeStatistic_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeBake ****************/

extern StructRNA RNA_GeometryNodeBake;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int GeometryNodeBake_active_index_get(PointerRNA *ptr);
void GeometryNodeBake_active_index_set(PointerRNA *ptr, int value);

PointerRNA GeometryNodeBake_active_item_get(PointerRNA *ptr);

void GeometryNodeBake_bake_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GeometryNodeBake_bake_items_next(CollectionPropertyIterator *iter);
void GeometryNodeBake_bake_items_end(CollectionPropertyIterator *iter);
int GeometryNodeBake_bake_items_length(PointerRNA *ptr);
bool GeometryNodeBake_bake_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GeometryNodeBake_bake_items_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool GeometryNodeBake_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeBake_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeBake_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeBlurAttribute ****************/

extern StructRNA RNA_GeometryNodeBlurAttribute;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeBlurAttribute_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeBlurAttribute_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeBlurAttribute_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeBoundBox ****************/

extern StructRNA RNA_GeometryNodeBoundBox;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeBoundBox_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeBoundBox_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeBoundBox_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCameraInfo ****************/

extern StructRNA RNA_GeometryNodeCameraInfo;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCameraInfo_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCameraInfo_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCameraInfo_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCaptureAttribute ****************/

extern StructRNA RNA_GeometryNodeCaptureAttribute;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int GeometryNodeCaptureAttribute_active_index_get(PointerRNA *ptr);
void GeometryNodeCaptureAttribute_active_index_set(PointerRNA *ptr, int value);

PointerRNA GeometryNodeCaptureAttribute_active_item_get(PointerRNA *ptr);

enum {
	GeometryNodeCaptureAttribute_domain_POINT = 0,
	GeometryNodeCaptureAttribute_domain_EDGE = 1,
	GeometryNodeCaptureAttribute_domain_FACE = 2,
	GeometryNodeCaptureAttribute_domain_CORNER = 3,
	GeometryNodeCaptureAttribute_domain_CURVE = 4,
	GeometryNodeCaptureAttribute_domain_INSTANCE = 5,
	GeometryNodeCaptureAttribute_domain_LAYER = 6,
};

int GeometryNodeCaptureAttribute_domain_get(PointerRNA *ptr);
void GeometryNodeCaptureAttribute_domain_set(PointerRNA *ptr, int value);

void GeometryNodeCaptureAttribute_capture_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GeometryNodeCaptureAttribute_capture_items_next(CollectionPropertyIterator *iter);
void GeometryNodeCaptureAttribute_capture_items_end(CollectionPropertyIterator *iter);
int GeometryNodeCaptureAttribute_capture_items_length(PointerRNA *ptr);
bool GeometryNodeCaptureAttribute_capture_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GeometryNodeCaptureAttribute_capture_items_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool GeometryNodeCaptureAttribute_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCaptureAttribute_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCaptureAttribute_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeClosureInput ****************/

extern StructRNA RNA_GeometryNodeClosureInput;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA GeometryNodeClosureInput_paired_output_get(PointerRNA *ptr);

bool GeometryNodeClosureInput_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeClosureInput_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeClosureInput_output_template_func(struct StructRNA *_type, int index);
bool GeometryNodeClosureInput_pair_with_output_func(struct ID *_selfid, struct bNode *_self, bContext *C, ReportList *reports, struct bNode *output_node);
/**************** GeometryNodeClosureOutput ****************/

extern StructRNA RNA_GeometryNodeClosureOutput;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int GeometryNodeClosureOutput_active_input_index_get(PointerRNA *ptr);
void GeometryNodeClosureOutput_active_input_index_set(PointerRNA *ptr, int value);

int GeometryNodeClosureOutput_active_output_index_get(PointerRNA *ptr);
void GeometryNodeClosureOutput_active_output_index_set(PointerRNA *ptr, int value);

void GeometryNodeClosureOutput_input_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GeometryNodeClosureOutput_input_items_next(CollectionPropertyIterator *iter);
void GeometryNodeClosureOutput_input_items_end(CollectionPropertyIterator *iter);
int GeometryNodeClosureOutput_input_items_length(PointerRNA *ptr);
bool GeometryNodeClosureOutput_input_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GeometryNodeClosureOutput_input_items_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void GeometryNodeClosureOutput_output_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GeometryNodeClosureOutput_output_items_next(CollectionPropertyIterator *iter);
void GeometryNodeClosureOutput_output_items_end(CollectionPropertyIterator *iter);
int GeometryNodeClosureOutput_output_items_length(PointerRNA *ptr);
bool GeometryNodeClosureOutput_output_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GeometryNodeClosureOutput_output_items_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool GeometryNodeClosureOutput_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeClosureOutput_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeClosureOutput_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCollectionInfo ****************/

extern StructRNA RNA_GeometryNodeCollectionInfo;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCollectionInfo_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCollectionInfo_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCollectionInfo_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCombineBundle ****************/

extern StructRNA RNA_GeometryNodeCombineBundle;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int GeometryNodeCombineBundle_active_index_get(PointerRNA *ptr);
void GeometryNodeCombineBundle_active_index_set(PointerRNA *ptr, int value);

void GeometryNodeCombineBundle_bundle_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GeometryNodeCombineBundle_bundle_items_next(CollectionPropertyIterator *iter);
void GeometryNodeCombineBundle_bundle_items_end(CollectionPropertyIterator *iter);
int GeometryNodeCombineBundle_bundle_items_length(PointerRNA *ptr);
bool GeometryNodeCombineBundle_bundle_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GeometryNodeCombineBundle_bundle_items_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool GeometryNodeCombineBundle_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCombineBundle_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCombineBundle_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeConvexHull ****************/

extern StructRNA RNA_GeometryNodeConvexHull;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeConvexHull_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeConvexHull_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeConvexHull_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCornersOfEdge ****************/

extern StructRNA RNA_GeometryNodeCornersOfEdge;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCornersOfEdge_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCornersOfEdge_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCornersOfEdge_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCornersOfFace ****************/

extern StructRNA RNA_GeometryNodeCornersOfFace;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCornersOfFace_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCornersOfFace_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCornersOfFace_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCornersOfVertex ****************/

extern StructRNA RNA_GeometryNodeCornersOfVertex;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCornersOfVertex_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCornersOfVertex_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCornersOfVertex_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCurveArc ****************/

extern StructRNA RNA_GeometryNodeCurveArc;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCurveArc_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCurveArc_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCurveArc_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCurveEndpointSelection ****************/

extern StructRNA RNA_GeometryNodeCurveEndpointSelection;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCurveEndpointSelection_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCurveEndpointSelection_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCurveEndpointSelection_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCurveHandleTypeSelection ****************/

extern StructRNA RNA_GeometryNodeCurveHandleTypeSelection;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	GeometryNodeCurveHandleTypeSelection_handle_type_FREE = 0,
	GeometryNodeCurveHandleTypeSelection_handle_type_AUTO = 1,
	GeometryNodeCurveHandleTypeSelection_handle_type_VECTOR = 2,
	GeometryNodeCurveHandleTypeSelection_handle_type_ALIGN = 3,
};

int GeometryNodeCurveHandleTypeSelection_handle_type_get(PointerRNA *ptr);
void GeometryNodeCurveHandleTypeSelection_handle_type_set(PointerRNA *ptr, int value);

enum {
	GeometryNodeCurveHandleTypeSelection_mode_LEFT = 1,
	GeometryNodeCurveHandleTypeSelection_mode_RIGHT = 2,
};

int GeometryNodeCurveHandleTypeSelection_mode_get(PointerRNA *ptr);
void GeometryNodeCurveHandleTypeSelection_mode_set(PointerRNA *ptr, int value);

bool GeometryNodeCurveHandleTypeSelection_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCurveHandleTypeSelection_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCurveHandleTypeSelection_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCurveLength ****************/

extern StructRNA RNA_GeometryNodeCurveLength;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCurveLength_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCurveLength_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCurveLength_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCurveOfPoint ****************/

extern StructRNA RNA_GeometryNodeCurveOfPoint;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCurveOfPoint_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCurveOfPoint_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCurveOfPoint_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCurvePrimitiveBezierSegment ****************/

extern StructRNA RNA_GeometryNodeCurvePrimitiveBezierSegment;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCurvePrimitiveBezierSegment_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCurvePrimitiveBezierSegment_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCurvePrimitiveBezierSegment_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCurvePrimitiveCircle ****************/

extern StructRNA RNA_GeometryNodeCurvePrimitiveCircle;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCurvePrimitiveCircle_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCurvePrimitiveCircle_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCurvePrimitiveCircle_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCurvePrimitiveLine ****************/

extern StructRNA RNA_GeometryNodeCurvePrimitiveLine;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCurvePrimitiveLine_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCurvePrimitiveLine_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCurvePrimitiveLine_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCurvePrimitiveQuadrilateral ****************/

extern StructRNA RNA_GeometryNodeCurvePrimitiveQuadrilateral;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCurvePrimitiveQuadrilateral_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCurvePrimitiveQuadrilateral_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCurvePrimitiveQuadrilateral_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCurveQuadraticBezier ****************/

extern StructRNA RNA_GeometryNodeCurveQuadraticBezier;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCurveQuadraticBezier_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCurveQuadraticBezier_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCurveQuadraticBezier_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCurveSetHandles ****************/

extern StructRNA RNA_GeometryNodeCurveSetHandles;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	GeometryNodeCurveSetHandles_handle_type_FREE = 0,
	GeometryNodeCurveSetHandles_handle_type_AUTO = 1,
	GeometryNodeCurveSetHandles_handle_type_VECTOR = 2,
	GeometryNodeCurveSetHandles_handle_type_ALIGN = 3,
};

int GeometryNodeCurveSetHandles_handle_type_get(PointerRNA *ptr);
void GeometryNodeCurveSetHandles_handle_type_set(PointerRNA *ptr, int value);

enum {
	GeometryNodeCurveSetHandles_mode_LEFT = 1,
	GeometryNodeCurveSetHandles_mode_RIGHT = 2,
};

int GeometryNodeCurveSetHandles_mode_get(PointerRNA *ptr);
void GeometryNodeCurveSetHandles_mode_set(PointerRNA *ptr, int value);

bool GeometryNodeCurveSetHandles_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCurveSetHandles_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCurveSetHandles_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCurveSpiral ****************/

extern StructRNA RNA_GeometryNodeCurveSpiral;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCurveSpiral_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCurveSpiral_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCurveSpiral_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCurveSplineType ****************/

extern StructRNA RNA_GeometryNodeCurveSplineType;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCurveSplineType_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCurveSplineType_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCurveSplineType_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCurveStar ****************/

extern StructRNA RNA_GeometryNodeCurveStar;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCurveStar_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCurveStar_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCurveStar_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCurveToMesh ****************/

extern StructRNA RNA_GeometryNodeCurveToMesh;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCurveToMesh_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCurveToMesh_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCurveToMesh_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCurveToPoints ****************/

extern StructRNA RNA_GeometryNodeCurveToPoints;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCurveToPoints_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCurveToPoints_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCurveToPoints_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeCurvesToGreasePencil ****************/

extern StructRNA RNA_GeometryNodeCurvesToGreasePencil;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeCurvesToGreasePencil_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeCurvesToGreasePencil_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeCurvesToGreasePencil_output_template_func(struct StructRNA *_type, int index);
/**************** Geometry Custom Group ****************/

extern StructRNA RNA_GeometryNodeCustomGroup;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA GeometryNodeCustomGroup_node_tree_get(PointerRNA *ptr);

/**************** GeometryNodeDeformCurvesOnSurface ****************/

extern StructRNA RNA_GeometryNodeDeformCurvesOnSurface;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeDeformCurvesOnSurface_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeDeformCurvesOnSurface_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeDeformCurvesOnSurface_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeDeleteGeometry ****************/

extern StructRNA RNA_GeometryNodeDeleteGeometry;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeDeleteGeometry_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeDeleteGeometry_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeDeleteGeometry_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeDistributePointsInGrid ****************/

extern StructRNA RNA_GeometryNodeDistributePointsInGrid;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeDistributePointsInGrid_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeDistributePointsInGrid_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeDistributePointsInGrid_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeDistributePointsInVolume ****************/

extern StructRNA RNA_GeometryNodeDistributePointsInVolume;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeDistributePointsInVolume_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeDistributePointsInVolume_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeDistributePointsInVolume_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeDistributePointsOnFaces ****************/

extern StructRNA RNA_GeometryNodeDistributePointsOnFaces;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	GeometryNodeDistributePointsOnFaces_distribute_method_RANDOM = 0,
	GeometryNodeDistributePointsOnFaces_distribute_method_POISSON = 1,
};

int GeometryNodeDistributePointsOnFaces_distribute_method_get(PointerRNA *ptr);
void GeometryNodeDistributePointsOnFaces_distribute_method_set(PointerRNA *ptr, int value);

bool GeometryNodeDistributePointsOnFaces_use_legacy_normal_get(PointerRNA *ptr);
void GeometryNodeDistributePointsOnFaces_use_legacy_normal_set(PointerRNA *ptr, bool value);

bool GeometryNodeDistributePointsOnFaces_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeDistributePointsOnFaces_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeDistributePointsOnFaces_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeDualMesh ****************/

extern StructRNA RNA_GeometryNodeDualMesh;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeDualMesh_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeDualMesh_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeDualMesh_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeDuplicateElements ****************/

extern StructRNA RNA_GeometryNodeDuplicateElements;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeDuplicateElements_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeDuplicateElements_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeDuplicateElements_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeEdgePathsToCurves ****************/

extern StructRNA RNA_GeometryNodeEdgePathsToCurves;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeEdgePathsToCurves_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeEdgePathsToCurves_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeEdgePathsToCurves_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeEdgePathsToSelection ****************/

extern StructRNA RNA_GeometryNodeEdgePathsToSelection;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeEdgePathsToSelection_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeEdgePathsToSelection_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeEdgePathsToSelection_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeEdgesOfCorner ****************/

extern StructRNA RNA_GeometryNodeEdgesOfCorner;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeEdgesOfCorner_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeEdgesOfCorner_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeEdgesOfCorner_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeEdgesOfVertex ****************/

extern StructRNA RNA_GeometryNodeEdgesOfVertex;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeEdgesOfVertex_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeEdgesOfVertex_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeEdgesOfVertex_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeEdgesToFaceGroups ****************/

extern StructRNA RNA_GeometryNodeEdgesToFaceGroups;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeEdgesToFaceGroups_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeEdgesToFaceGroups_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeEdgesToFaceGroups_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeEvaluateClosure ****************/

extern StructRNA RNA_GeometryNodeEvaluateClosure;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int GeometryNodeEvaluateClosure_active_input_index_get(PointerRNA *ptr);
void GeometryNodeEvaluateClosure_active_input_index_set(PointerRNA *ptr, int value);

int GeometryNodeEvaluateClosure_active_output_index_get(PointerRNA *ptr);
void GeometryNodeEvaluateClosure_active_output_index_set(PointerRNA *ptr, int value);

void GeometryNodeEvaluateClosure_input_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GeometryNodeEvaluateClosure_input_items_next(CollectionPropertyIterator *iter);
void GeometryNodeEvaluateClosure_input_items_end(CollectionPropertyIterator *iter);
int GeometryNodeEvaluateClosure_input_items_length(PointerRNA *ptr);
bool GeometryNodeEvaluateClosure_input_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GeometryNodeEvaluateClosure_input_items_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void GeometryNodeEvaluateClosure_output_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GeometryNodeEvaluateClosure_output_items_next(CollectionPropertyIterator *iter);
void GeometryNodeEvaluateClosure_output_items_end(CollectionPropertyIterator *iter);
int GeometryNodeEvaluateClosure_output_items_length(PointerRNA *ptr);
bool GeometryNodeEvaluateClosure_output_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GeometryNodeEvaluateClosure_output_items_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool GeometryNodeEvaluateClosure_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeEvaluateClosure_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeEvaluateClosure_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeExtrudeMesh ****************/

extern StructRNA RNA_GeometryNodeExtrudeMesh;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeExtrudeMesh_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeExtrudeMesh_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeExtrudeMesh_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeFaceOfCorner ****************/

extern StructRNA RNA_GeometryNodeFaceOfCorner;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeFaceOfCorner_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeFaceOfCorner_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeFaceOfCorner_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeFieldAtIndex ****************/

extern StructRNA RNA_GeometryNodeFieldAtIndex;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeFieldAtIndex_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeFieldAtIndex_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeFieldAtIndex_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeFieldAverage ****************/

extern StructRNA RNA_GeometryNodeFieldAverage;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeFieldAverage_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeFieldAverage_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeFieldAverage_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeFieldMinAndMax ****************/

extern StructRNA RNA_GeometryNodeFieldMinAndMax;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeFieldMinAndMax_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeFieldMinAndMax_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeFieldMinAndMax_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeFieldOnDomain ****************/

extern StructRNA RNA_GeometryNodeFieldOnDomain;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeFieldOnDomain_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeFieldOnDomain_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeFieldOnDomain_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeFieldVariance ****************/

extern StructRNA RNA_GeometryNodeFieldVariance;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeFieldVariance_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeFieldVariance_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeFieldVariance_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeFillCurve ****************/

extern StructRNA RNA_GeometryNodeFillCurve;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeFillCurve_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeFillCurve_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeFillCurve_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeFilletCurve ****************/

extern StructRNA RNA_GeometryNodeFilletCurve;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeFilletCurve_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeFilletCurve_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeFilletCurve_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeFlipFaces ****************/

extern StructRNA RNA_GeometryNodeFlipFaces;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeFlipFaces_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeFlipFaces_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeFlipFaces_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeForeachGeometryElementInput ****************/

extern StructRNA RNA_GeometryNodeForeachGeometryElementInput;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA GeometryNodeForeachGeometryElementInput_paired_output_get(PointerRNA *ptr);

bool GeometryNodeForeachGeometryElementInput_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeForeachGeometryElementInput_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeForeachGeometryElementInput_output_template_func(struct StructRNA *_type, int index);
bool GeometryNodeForeachGeometryElementInput_pair_with_output_func(struct ID *_selfid, struct bNode *_self, bContext *C, ReportList *reports, struct bNode *output_node);
/**************** GeometryNodeForeachGeometryElementOutput ****************/

extern StructRNA RNA_GeometryNodeForeachGeometryElementOutput;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int GeometryNodeForeachGeometryElementOutput_active_input_index_get(PointerRNA *ptr);
void GeometryNodeForeachGeometryElementOutput_active_input_index_set(PointerRNA *ptr, int value);

int GeometryNodeForeachGeometryElementOutput_active_generation_index_get(PointerRNA *ptr);
void GeometryNodeForeachGeometryElementOutput_active_generation_index_set(PointerRNA *ptr, int value);

int GeometryNodeForeachGeometryElementOutput_active_main_index_get(PointerRNA *ptr);
void GeometryNodeForeachGeometryElementOutput_active_main_index_set(PointerRNA *ptr, int value);

enum {
	GeometryNodeForeachGeometryElementOutput_domain_POINT = 0,
	GeometryNodeForeachGeometryElementOutput_domain_EDGE = 1,
	GeometryNodeForeachGeometryElementOutput_domain_FACE = 2,
	GeometryNodeForeachGeometryElementOutput_domain_CORNER = 3,
	GeometryNodeForeachGeometryElementOutput_domain_CURVE = 4,
	GeometryNodeForeachGeometryElementOutput_domain_INSTANCE = 5,
	GeometryNodeForeachGeometryElementOutput_domain_LAYER = 6,
};

int GeometryNodeForeachGeometryElementOutput_domain_get(PointerRNA *ptr);
void GeometryNodeForeachGeometryElementOutput_domain_set(PointerRNA *ptr, int value);

int GeometryNodeForeachGeometryElementOutput_inspection_index_get(PointerRNA *ptr);
void GeometryNodeForeachGeometryElementOutput_inspection_index_set(PointerRNA *ptr, int value);

void GeometryNodeForeachGeometryElementOutput_generation_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GeometryNodeForeachGeometryElementOutput_generation_items_next(CollectionPropertyIterator *iter);
void GeometryNodeForeachGeometryElementOutput_generation_items_end(CollectionPropertyIterator *iter);
int GeometryNodeForeachGeometryElementOutput_generation_items_length(PointerRNA *ptr);
bool GeometryNodeForeachGeometryElementOutput_generation_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GeometryNodeForeachGeometryElementOutput_generation_items_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void GeometryNodeForeachGeometryElementOutput_input_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GeometryNodeForeachGeometryElementOutput_input_items_next(CollectionPropertyIterator *iter);
void GeometryNodeForeachGeometryElementOutput_input_items_end(CollectionPropertyIterator *iter);
int GeometryNodeForeachGeometryElementOutput_input_items_length(PointerRNA *ptr);
bool GeometryNodeForeachGeometryElementOutput_input_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GeometryNodeForeachGeometryElementOutput_input_items_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void GeometryNodeForeachGeometryElementOutput_main_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GeometryNodeForeachGeometryElementOutput_main_items_next(CollectionPropertyIterator *iter);
void GeometryNodeForeachGeometryElementOutput_main_items_end(CollectionPropertyIterator *iter);
int GeometryNodeForeachGeometryElementOutput_main_items_length(PointerRNA *ptr);
bool GeometryNodeForeachGeometryElementOutput_main_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GeometryNodeForeachGeometryElementOutput_main_items_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool GeometryNodeForeachGeometryElementOutput_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeForeachGeometryElementOutput_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeForeachGeometryElementOutput_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeGeometryToInstance ****************/

extern StructRNA RNA_GeometryNodeGeometryToInstance;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeGeometryToInstance_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeGeometryToInstance_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeGeometryToInstance_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeGetNamedGrid ****************/

extern StructRNA RNA_GeometryNodeGetNamedGrid;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeGetNamedGrid_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeGetNamedGrid_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeGetNamedGrid_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeGizmoDial ****************/

extern StructRNA RNA_GeometryNodeGizmoDial;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeGizmoDial_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeGizmoDial_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeGizmoDial_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeGizmoLinear ****************/

extern StructRNA RNA_GeometryNodeGizmoLinear;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeGizmoLinear_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeGizmoLinear_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeGizmoLinear_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeGizmoTransform ****************/

extern StructRNA RNA_GeometryNodeGizmoTransform;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeGizmoTransform_use_rotation_x_get(PointerRNA *ptr);
void GeometryNodeGizmoTransform_use_rotation_x_set(PointerRNA *ptr, bool value);

bool GeometryNodeGizmoTransform_use_rotation_y_get(PointerRNA *ptr);
void GeometryNodeGizmoTransform_use_rotation_y_set(PointerRNA *ptr, bool value);

bool GeometryNodeGizmoTransform_use_rotation_z_get(PointerRNA *ptr);
void GeometryNodeGizmoTransform_use_rotation_z_set(PointerRNA *ptr, bool value);

bool GeometryNodeGizmoTransform_use_scale_x_get(PointerRNA *ptr);
void GeometryNodeGizmoTransform_use_scale_x_set(PointerRNA *ptr, bool value);

bool GeometryNodeGizmoTransform_use_scale_y_get(PointerRNA *ptr);
void GeometryNodeGizmoTransform_use_scale_y_set(PointerRNA *ptr, bool value);

bool GeometryNodeGizmoTransform_use_scale_z_get(PointerRNA *ptr);
void GeometryNodeGizmoTransform_use_scale_z_set(PointerRNA *ptr, bool value);

bool GeometryNodeGizmoTransform_use_translation_x_get(PointerRNA *ptr);
void GeometryNodeGizmoTransform_use_translation_x_set(PointerRNA *ptr, bool value);

bool GeometryNodeGizmoTransform_use_translation_y_get(PointerRNA *ptr);
void GeometryNodeGizmoTransform_use_translation_y_set(PointerRNA *ptr, bool value);

bool GeometryNodeGizmoTransform_use_translation_z_get(PointerRNA *ptr);
void GeometryNodeGizmoTransform_use_translation_z_set(PointerRNA *ptr, bool value);

bool GeometryNodeGizmoTransform_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeGizmoTransform_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeGizmoTransform_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeGreasePencilToCurves ****************/

extern StructRNA RNA_GeometryNodeGreasePencilToCurves;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeGreasePencilToCurves_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeGreasePencilToCurves_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeGreasePencilToCurves_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeGridInfo ****************/

extern StructRNA RNA_GeometryNodeGridInfo;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeGridInfo_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeGridInfo_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeGridInfo_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeGridToMesh ****************/

extern StructRNA RNA_GeometryNodeGridToMesh;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeGridToMesh_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeGridToMesh_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeGridToMesh_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeGroup ****************/

extern StructRNA RNA_GeometryNodeGroup;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA GeometryNodeGroup_node_tree_get(PointerRNA *ptr);

bool GeometryNodeGroup_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeGroup_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeGroup_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeImageInfo ****************/

extern StructRNA RNA_GeometryNodeImageInfo;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeImageInfo_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeImageInfo_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeImageInfo_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeImageTexture ****************/

extern StructRNA RNA_GeometryNodeImageTexture;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	GeometryNodeImageTexture_extension_REPEAT = 0,
	GeometryNodeImageTexture_extension_EXTEND = 1,
	GeometryNodeImageTexture_extension_CLIP = 2,
	GeometryNodeImageTexture_extension_MIRROR = 3,
};

int GeometryNodeImageTexture_extension_get(PointerRNA *ptr);
void GeometryNodeImageTexture_extension_set(PointerRNA *ptr, int value);

enum {
	GeometryNodeImageTexture_interpolation_Linear = 0,
	GeometryNodeImageTexture_interpolation_Closest = 1,
	GeometryNodeImageTexture_interpolation_Cubic = 2,
};

int GeometryNodeImageTexture_interpolation_get(PointerRNA *ptr);
void GeometryNodeImageTexture_interpolation_set(PointerRNA *ptr, int value);

bool GeometryNodeImageTexture_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeImageTexture_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeImageTexture_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeImportCSV ****************/

extern StructRNA RNA_GeometryNodeImportCSV;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeImportCSV_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeImportCSV_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeImportCSV_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeImportOBJ ****************/

extern StructRNA RNA_GeometryNodeImportOBJ;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeImportOBJ_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeImportOBJ_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeImportOBJ_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeImportPLY ****************/

extern StructRNA RNA_GeometryNodeImportPLY;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeImportPLY_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeImportPLY_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeImportPLY_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeImportSTL ****************/

extern StructRNA RNA_GeometryNodeImportSTL;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeImportSTL_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeImportSTL_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeImportSTL_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeImportText ****************/

extern StructRNA RNA_GeometryNodeImportText;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeImportText_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeImportText_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeImportText_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeImportVDB ****************/

extern StructRNA RNA_GeometryNodeImportVDB;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeImportVDB_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeImportVDB_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeImportVDB_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeIndexOfNearest ****************/

extern StructRNA RNA_GeometryNodeIndexOfNearest;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeIndexOfNearest_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeIndexOfNearest_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeIndexOfNearest_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeIndexSwitch ****************/

extern StructRNA RNA_GeometryNodeIndexSwitch;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

void GeometryNodeIndexSwitch_index_switch_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GeometryNodeIndexSwitch_index_switch_items_next(CollectionPropertyIterator *iter);
void GeometryNodeIndexSwitch_index_switch_items_end(CollectionPropertyIterator *iter);
int GeometryNodeIndexSwitch_index_switch_items_length(PointerRNA *ptr);
bool GeometryNodeIndexSwitch_index_switch_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool GeometryNodeIndexSwitch_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeIndexSwitch_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeIndexSwitch_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputActiveCamera ****************/

extern StructRNA RNA_GeometryNodeInputActiveCamera;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputActiveCamera_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputActiveCamera_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputActiveCamera_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputCollection ****************/

extern StructRNA RNA_GeometryNodeInputCollection;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA GeometryNodeInputCollection_collection_get(PointerRNA *ptr);

bool GeometryNodeInputCollection_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputCollection_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputCollection_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputCurveHandlePositions ****************/

extern StructRNA RNA_GeometryNodeInputCurveHandlePositions;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputCurveHandlePositions_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputCurveHandlePositions_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputCurveHandlePositions_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputCurveTilt ****************/

extern StructRNA RNA_GeometryNodeInputCurveTilt;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputCurveTilt_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputCurveTilt_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputCurveTilt_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputEdgeSmooth ****************/

extern StructRNA RNA_GeometryNodeInputEdgeSmooth;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputEdgeSmooth_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputEdgeSmooth_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputEdgeSmooth_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputID ****************/

extern StructRNA RNA_GeometryNodeInputID;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputID_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputID_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputID_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputImage ****************/

extern StructRNA RNA_GeometryNodeInputImage;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA GeometryNodeInputImage_image_get(PointerRNA *ptr);

bool GeometryNodeInputImage_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputImage_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputImage_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputIndex ****************/

extern StructRNA RNA_GeometryNodeInputIndex;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputIndex_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputIndex_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputIndex_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputInstanceBounds ****************/

extern StructRNA RNA_GeometryNodeInputInstanceBounds;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputInstanceBounds_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputInstanceBounds_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputInstanceBounds_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputInstanceRotation ****************/

extern StructRNA RNA_GeometryNodeInputInstanceRotation;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputInstanceRotation_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputInstanceRotation_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputInstanceRotation_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputInstanceScale ****************/

extern StructRNA RNA_GeometryNodeInputInstanceScale;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputInstanceScale_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputInstanceScale_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputInstanceScale_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputMaterial ****************/

extern StructRNA RNA_GeometryNodeInputMaterial;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA GeometryNodeInputMaterial_material_get(PointerRNA *ptr);

bool GeometryNodeInputMaterial_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputMaterial_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputMaterial_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputMaterialIndex ****************/

extern StructRNA RNA_GeometryNodeInputMaterialIndex;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputMaterialIndex_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputMaterialIndex_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputMaterialIndex_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputMeshEdgeAngle ****************/

extern StructRNA RNA_GeometryNodeInputMeshEdgeAngle;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputMeshEdgeAngle_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputMeshEdgeAngle_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputMeshEdgeAngle_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputMeshEdgeNeighbors ****************/

extern StructRNA RNA_GeometryNodeInputMeshEdgeNeighbors;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputMeshEdgeNeighbors_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputMeshEdgeNeighbors_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputMeshEdgeNeighbors_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputMeshEdgeVertices ****************/

extern StructRNA RNA_GeometryNodeInputMeshEdgeVertices;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputMeshEdgeVertices_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputMeshEdgeVertices_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputMeshEdgeVertices_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputMeshFaceArea ****************/

extern StructRNA RNA_GeometryNodeInputMeshFaceArea;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputMeshFaceArea_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputMeshFaceArea_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputMeshFaceArea_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputMeshFaceIsPlanar ****************/

extern StructRNA RNA_GeometryNodeInputMeshFaceIsPlanar;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputMeshFaceIsPlanar_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputMeshFaceIsPlanar_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputMeshFaceIsPlanar_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputMeshFaceNeighbors ****************/

extern StructRNA RNA_GeometryNodeInputMeshFaceNeighbors;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputMeshFaceNeighbors_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputMeshFaceNeighbors_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputMeshFaceNeighbors_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputMeshIsland ****************/

extern StructRNA RNA_GeometryNodeInputMeshIsland;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputMeshIsland_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputMeshIsland_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputMeshIsland_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputMeshVertexNeighbors ****************/

extern StructRNA RNA_GeometryNodeInputMeshVertexNeighbors;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputMeshVertexNeighbors_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputMeshVertexNeighbors_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputMeshVertexNeighbors_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputNamedAttribute ****************/

extern StructRNA RNA_GeometryNodeInputNamedAttribute;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputNamedAttribute_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputNamedAttribute_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputNamedAttribute_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputNamedLayerSelection ****************/

extern StructRNA RNA_GeometryNodeInputNamedLayerSelection;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputNamedLayerSelection_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputNamedLayerSelection_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputNamedLayerSelection_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputNormal ****************/

extern StructRNA RNA_GeometryNodeInputNormal;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputNormal_legacy_corner_normals_get(PointerRNA *ptr);
void GeometryNodeInputNormal_legacy_corner_normals_set(PointerRNA *ptr, bool value);

bool GeometryNodeInputNormal_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputNormal_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputNormal_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputObject ****************/

extern StructRNA RNA_GeometryNodeInputObject;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA GeometryNodeInputObject_object_get(PointerRNA *ptr);

bool GeometryNodeInputObject_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputObject_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputObject_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputPosition ****************/

extern StructRNA RNA_GeometryNodeInputPosition;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputPosition_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputPosition_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputPosition_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputRadius ****************/

extern StructRNA RNA_GeometryNodeInputRadius;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputRadius_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputRadius_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputRadius_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputSceneTime ****************/

extern StructRNA RNA_GeometryNodeInputSceneTime;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputSceneTime_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputSceneTime_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputSceneTime_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputShadeSmooth ****************/

extern StructRNA RNA_GeometryNodeInputShadeSmooth;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputShadeSmooth_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputShadeSmooth_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputShadeSmooth_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputShortestEdgePaths ****************/

extern StructRNA RNA_GeometryNodeInputShortestEdgePaths;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputShortestEdgePaths_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputShortestEdgePaths_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputShortestEdgePaths_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputSplineCyclic ****************/

extern StructRNA RNA_GeometryNodeInputSplineCyclic;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputSplineCyclic_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputSplineCyclic_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputSplineCyclic_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputSplineResolution ****************/

extern StructRNA RNA_GeometryNodeInputSplineResolution;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputSplineResolution_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputSplineResolution_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputSplineResolution_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInputTangent ****************/

extern StructRNA RNA_GeometryNodeInputTangent;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInputTangent_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInputTangent_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInputTangent_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInstanceOnPoints ****************/

extern StructRNA RNA_GeometryNodeInstanceOnPoints;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInstanceOnPoints_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInstanceOnPoints_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInstanceOnPoints_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInstanceTransform ****************/

extern StructRNA RNA_GeometryNodeInstanceTransform;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInstanceTransform_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInstanceTransform_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInstanceTransform_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInstancesToPoints ****************/

extern StructRNA RNA_GeometryNodeInstancesToPoints;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInstancesToPoints_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInstancesToPoints_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInstancesToPoints_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeInterpolateCurves ****************/

extern StructRNA RNA_GeometryNodeInterpolateCurves;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeInterpolateCurves_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeInterpolateCurves_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeInterpolateCurves_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeIsViewport ****************/

extern StructRNA RNA_GeometryNodeIsViewport;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeIsViewport_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeIsViewport_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeIsViewport_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeJoinGeometry ****************/

extern StructRNA RNA_GeometryNodeJoinGeometry;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeJoinGeometry_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeJoinGeometry_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeJoinGeometry_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMaterialSelection ****************/

extern StructRNA RNA_GeometryNodeMaterialSelection;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeMaterialSelection_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMaterialSelection_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMaterialSelection_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMenuSwitch ****************/

extern StructRNA RNA_GeometryNodeMenuSwitch;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA GeometryNodeMenuSwitch_active_item_get(PointerRNA *ptr);

int GeometryNodeMenuSwitch_active_index_get(PointerRNA *ptr);
void GeometryNodeMenuSwitch_active_index_set(PointerRNA *ptr, int value);

PointerRNA GeometryNodeMenuSwitch_enum_definition_get(PointerRNA *ptr);

void GeometryNodeMenuSwitch_enum_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GeometryNodeMenuSwitch_enum_items_next(CollectionPropertyIterator *iter);
void GeometryNodeMenuSwitch_enum_items_end(CollectionPropertyIterator *iter);
int GeometryNodeMenuSwitch_enum_items_length(PointerRNA *ptr);
bool GeometryNodeMenuSwitch_enum_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GeometryNodeMenuSwitch_enum_items_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool GeometryNodeMenuSwitch_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMenuSwitch_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMenuSwitch_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMergeByDistance ****************/

extern StructRNA RNA_GeometryNodeMergeByDistance;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeMergeByDistance_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMergeByDistance_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMergeByDistance_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMergeLayers ****************/

extern StructRNA RNA_GeometryNodeMergeLayers;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeMergeLayers_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMergeLayers_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMergeLayers_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMeshBoolean ****************/

extern StructRNA RNA_GeometryNodeMeshBoolean;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeMeshBoolean_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMeshBoolean_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMeshBoolean_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMeshCircle ****************/

extern StructRNA RNA_GeometryNodeMeshCircle;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeMeshCircle_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMeshCircle_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMeshCircle_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMeshCone ****************/

extern StructRNA RNA_GeometryNodeMeshCone;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeMeshCone_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMeshCone_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMeshCone_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMeshCube ****************/

extern StructRNA RNA_GeometryNodeMeshCube;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeMeshCube_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMeshCube_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMeshCube_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMeshCylinder ****************/

extern StructRNA RNA_GeometryNodeMeshCylinder;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeMeshCylinder_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMeshCylinder_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMeshCylinder_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMeshFaceSetBoundaries ****************/

extern StructRNA RNA_GeometryNodeMeshFaceSetBoundaries;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeMeshFaceSetBoundaries_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMeshFaceSetBoundaries_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMeshFaceSetBoundaries_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMeshGrid ****************/

extern StructRNA RNA_GeometryNodeMeshGrid;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeMeshGrid_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMeshGrid_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMeshGrid_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMeshIcoSphere ****************/

extern StructRNA RNA_GeometryNodeMeshIcoSphere;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeMeshIcoSphere_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMeshIcoSphere_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMeshIcoSphere_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMeshLine ****************/

extern StructRNA RNA_GeometryNodeMeshLine;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeMeshLine_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMeshLine_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMeshLine_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMeshToCurve ****************/

extern StructRNA RNA_GeometryNodeMeshToCurve;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeMeshToCurve_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMeshToCurve_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMeshToCurve_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMeshToDensityGrid ****************/

extern StructRNA RNA_GeometryNodeMeshToDensityGrid;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeMeshToDensityGrid_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMeshToDensityGrid_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMeshToDensityGrid_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMeshToPoints ****************/

extern StructRNA RNA_GeometryNodeMeshToPoints;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeMeshToPoints_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMeshToPoints_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMeshToPoints_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMeshToSDFGrid ****************/

extern StructRNA RNA_GeometryNodeMeshToSDFGrid;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeMeshToSDFGrid_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMeshToSDFGrid_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMeshToSDFGrid_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMeshToVolume ****************/

extern StructRNA RNA_GeometryNodeMeshToVolume;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeMeshToVolume_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMeshToVolume_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMeshToVolume_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeMeshUVSphere ****************/

extern StructRNA RNA_GeometryNodeMeshUVSphere;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeMeshUVSphere_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeMeshUVSphere_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeMeshUVSphere_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeObjectInfo ****************/

extern StructRNA RNA_GeometryNodeObjectInfo;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeObjectInfo_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeObjectInfo_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeObjectInfo_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeOffsetCornerInFace ****************/

extern StructRNA RNA_GeometryNodeOffsetCornerInFace;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeOffsetCornerInFace_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeOffsetCornerInFace_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeOffsetCornerInFace_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeOffsetPointInCurve ****************/

extern StructRNA RNA_GeometryNodeOffsetPointInCurve;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeOffsetPointInCurve_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeOffsetPointInCurve_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeOffsetPointInCurve_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodePoints ****************/

extern StructRNA RNA_GeometryNodePoints;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodePoints_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodePoints_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodePoints_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodePointsOfCurve ****************/

extern StructRNA RNA_GeometryNodePointsOfCurve;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodePointsOfCurve_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodePointsOfCurve_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodePointsOfCurve_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodePointsToCurves ****************/

extern StructRNA RNA_GeometryNodePointsToCurves;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodePointsToCurves_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodePointsToCurves_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodePointsToCurves_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodePointsToSDFGrid ****************/

extern StructRNA RNA_GeometryNodePointsToSDFGrid;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodePointsToSDFGrid_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodePointsToSDFGrid_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodePointsToSDFGrid_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodePointsToVertices ****************/

extern StructRNA RNA_GeometryNodePointsToVertices;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodePointsToVertices_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodePointsToVertices_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodePointsToVertices_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodePointsToVolume ****************/

extern StructRNA RNA_GeometryNodePointsToVolume;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodePointsToVolume_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodePointsToVolume_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodePointsToVolume_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeProximity ****************/

extern StructRNA RNA_GeometryNodeProximity;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeProximity_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeProximity_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeProximity_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeRaycast ****************/

extern StructRNA RNA_GeometryNodeRaycast;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeRaycast_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeRaycast_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeRaycast_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeRealizeInstances ****************/

extern StructRNA RNA_GeometryNodeRealizeInstances;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeRealizeInstances_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeRealizeInstances_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeRealizeInstances_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeRemoveAttribute ****************/

extern StructRNA RNA_GeometryNodeRemoveAttribute;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeRemoveAttribute_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeRemoveAttribute_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeRemoveAttribute_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeRepeatInput ****************/

extern StructRNA RNA_GeometryNodeRepeatInput;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA GeometryNodeRepeatInput_paired_output_get(PointerRNA *ptr);

bool GeometryNodeRepeatInput_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeRepeatInput_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeRepeatInput_output_template_func(struct StructRNA *_type, int index);
bool GeometryNodeRepeatInput_pair_with_output_func(struct ID *_selfid, struct bNode *_self, bContext *C, ReportList *reports, struct bNode *output_node);
/**************** GeometryNodeRepeatOutput ****************/

extern StructRNA RNA_GeometryNodeRepeatOutput;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int GeometryNodeRepeatOutput_active_index_get(PointerRNA *ptr);
void GeometryNodeRepeatOutput_active_index_set(PointerRNA *ptr, int value);

PointerRNA GeometryNodeRepeatOutput_active_item_get(PointerRNA *ptr);

int GeometryNodeRepeatOutput_inspection_index_get(PointerRNA *ptr);
void GeometryNodeRepeatOutput_inspection_index_set(PointerRNA *ptr, int value);

void GeometryNodeRepeatOutput_repeat_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GeometryNodeRepeatOutput_repeat_items_next(CollectionPropertyIterator *iter);
void GeometryNodeRepeatOutput_repeat_items_end(CollectionPropertyIterator *iter);
int GeometryNodeRepeatOutput_repeat_items_length(PointerRNA *ptr);
bool GeometryNodeRepeatOutput_repeat_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GeometryNodeRepeatOutput_repeat_items_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool GeometryNodeRepeatOutput_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeRepeatOutput_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeRepeatOutput_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeReplaceMaterial ****************/

extern StructRNA RNA_GeometryNodeReplaceMaterial;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeReplaceMaterial_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeReplaceMaterial_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeReplaceMaterial_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeResampleCurve ****************/

extern StructRNA RNA_GeometryNodeResampleCurve;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeResampleCurve_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeResampleCurve_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeResampleCurve_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeReverseCurve ****************/

extern StructRNA RNA_GeometryNodeReverseCurve;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeReverseCurve_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeReverseCurve_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeReverseCurve_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeRotateInstances ****************/

extern StructRNA RNA_GeometryNodeRotateInstances;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeRotateInstances_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeRotateInstances_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeRotateInstances_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSDFGridBoolean ****************/

extern StructRNA RNA_GeometryNodeSDFGridBoolean;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSDFGridBoolean_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSDFGridBoolean_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSDFGridBoolean_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSampleCurve ****************/

extern StructRNA RNA_GeometryNodeSampleCurve;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSampleCurve_use_all_curves_get(PointerRNA *ptr);
void GeometryNodeSampleCurve_use_all_curves_set(PointerRNA *ptr, bool value);

enum {
	GeometryNodeSampleCurve_data_type_FLOAT = 10,
	GeometryNodeSampleCurve_data_type_INT = 11,
	GeometryNodeSampleCurve_data_type_FLOAT_VECTOR = 48,
	GeometryNodeSampleCurve_data_type_FLOAT_COLOR = 47,
	GeometryNodeSampleCurve_data_type_BYTE_COLOR = 17,
	GeometryNodeSampleCurve_data_type_STRING = 12,
	GeometryNodeSampleCurve_data_type_BOOLEAN = 50,
	GeometryNodeSampleCurve_data_type_FLOAT2 = 49,
	GeometryNodeSampleCurve_data_type_INT8 = 45,
	GeometryNodeSampleCurve_data_type_INT16_2D = 22,
	GeometryNodeSampleCurve_data_type_INT32_2D = 46,
	GeometryNodeSampleCurve_data_type_QUATERNION = 52,
	GeometryNodeSampleCurve_data_type_FLOAT4X4 = 20,
};

int GeometryNodeSampleCurve_data_type_get(PointerRNA *ptr);
void GeometryNodeSampleCurve_data_type_set(PointerRNA *ptr, int value);

enum {
	GeometryNodeSampleCurve_mode_FACTOR = 0,
	GeometryNodeSampleCurve_mode_LENGTH = 1,
};

int GeometryNodeSampleCurve_mode_get(PointerRNA *ptr);
void GeometryNodeSampleCurve_mode_set(PointerRNA *ptr, int value);

bool GeometryNodeSampleCurve_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSampleCurve_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSampleCurve_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSampleGrid ****************/

extern StructRNA RNA_GeometryNodeSampleGrid;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSampleGrid_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSampleGrid_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSampleGrid_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSampleGridIndex ****************/

extern StructRNA RNA_GeometryNodeSampleGridIndex;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSampleGridIndex_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSampleGridIndex_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSampleGridIndex_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSampleIndex ****************/

extern StructRNA RNA_GeometryNodeSampleIndex;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSampleIndex_clamp_get(PointerRNA *ptr);
void GeometryNodeSampleIndex_clamp_set(PointerRNA *ptr, bool value);

enum {
	GeometryNodeSampleIndex_data_type_FLOAT = 10,
	GeometryNodeSampleIndex_data_type_INT = 11,
	GeometryNodeSampleIndex_data_type_FLOAT_VECTOR = 48,
	GeometryNodeSampleIndex_data_type_FLOAT_COLOR = 47,
	GeometryNodeSampleIndex_data_type_BYTE_COLOR = 17,
	GeometryNodeSampleIndex_data_type_STRING = 12,
	GeometryNodeSampleIndex_data_type_BOOLEAN = 50,
	GeometryNodeSampleIndex_data_type_FLOAT2 = 49,
	GeometryNodeSampleIndex_data_type_INT8 = 45,
	GeometryNodeSampleIndex_data_type_INT16_2D = 22,
	GeometryNodeSampleIndex_data_type_INT32_2D = 46,
	GeometryNodeSampleIndex_data_type_QUATERNION = 52,
	GeometryNodeSampleIndex_data_type_FLOAT4X4 = 20,
};

int GeometryNodeSampleIndex_data_type_get(PointerRNA *ptr);
void GeometryNodeSampleIndex_data_type_set(PointerRNA *ptr, int value);

enum {
	GeometryNodeSampleIndex_domain_POINT = 0,
	GeometryNodeSampleIndex_domain_EDGE = 1,
	GeometryNodeSampleIndex_domain_FACE = 2,
	GeometryNodeSampleIndex_domain_CORNER = 3,
	GeometryNodeSampleIndex_domain_CURVE = 4,
	GeometryNodeSampleIndex_domain_INSTANCE = 5,
	GeometryNodeSampleIndex_domain_LAYER = 6,
};

int GeometryNodeSampleIndex_domain_get(PointerRNA *ptr);
void GeometryNodeSampleIndex_domain_set(PointerRNA *ptr, int value);

bool GeometryNodeSampleIndex_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSampleIndex_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSampleIndex_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSampleNearest ****************/

extern StructRNA RNA_GeometryNodeSampleNearest;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSampleNearest_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSampleNearest_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSampleNearest_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSampleNearestSurface ****************/

extern StructRNA RNA_GeometryNodeSampleNearestSurface;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSampleNearestSurface_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSampleNearestSurface_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSampleNearestSurface_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSampleUVSurface ****************/

extern StructRNA RNA_GeometryNodeSampleUVSurface;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSampleUVSurface_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSampleUVSurface_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSampleUVSurface_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeScaleElements ****************/

extern StructRNA RNA_GeometryNodeScaleElements;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeScaleElements_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeScaleElements_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeScaleElements_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeScaleInstances ****************/

extern StructRNA RNA_GeometryNodeScaleInstances;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeScaleInstances_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeScaleInstances_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeScaleInstances_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSelfObject ****************/

extern StructRNA RNA_GeometryNodeSelfObject;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSelfObject_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSelfObject_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSelfObject_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSeparateBundle ****************/

extern StructRNA RNA_GeometryNodeSeparateBundle;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int GeometryNodeSeparateBundle_active_index_get(PointerRNA *ptr);
void GeometryNodeSeparateBundle_active_index_set(PointerRNA *ptr, int value);

void GeometryNodeSeparateBundle_bundle_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GeometryNodeSeparateBundle_bundle_items_next(CollectionPropertyIterator *iter);
void GeometryNodeSeparateBundle_bundle_items_end(CollectionPropertyIterator *iter);
int GeometryNodeSeparateBundle_bundle_items_length(PointerRNA *ptr);
bool GeometryNodeSeparateBundle_bundle_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GeometryNodeSeparateBundle_bundle_items_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool GeometryNodeSeparateBundle_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSeparateBundle_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSeparateBundle_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSeparateComponents ****************/

extern StructRNA RNA_GeometryNodeSeparateComponents;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSeparateComponents_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSeparateComponents_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSeparateComponents_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSeparateGeometry ****************/

extern StructRNA RNA_GeometryNodeSeparateGeometry;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSeparateGeometry_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSeparateGeometry_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSeparateGeometry_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSetCurveHandlePositions ****************/

extern StructRNA RNA_GeometryNodeSetCurveHandlePositions;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSetCurveHandlePositions_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSetCurveHandlePositions_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSetCurveHandlePositions_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSetCurveNormal ****************/

extern StructRNA RNA_GeometryNodeSetCurveNormal;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSetCurveNormal_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSetCurveNormal_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSetCurveNormal_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSetCurveRadius ****************/

extern StructRNA RNA_GeometryNodeSetCurveRadius;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSetCurveRadius_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSetCurveRadius_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSetCurveRadius_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSetCurveTilt ****************/

extern StructRNA RNA_GeometryNodeSetCurveTilt;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSetCurveTilt_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSetCurveTilt_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSetCurveTilt_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSetGeometryName ****************/

extern StructRNA RNA_GeometryNodeSetGeometryName;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSetGeometryName_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSetGeometryName_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSetGeometryName_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSetGreasePencilColor ****************/

extern StructRNA RNA_GeometryNodeSetGreasePencilColor;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSetGreasePencilColor_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSetGreasePencilColor_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSetGreasePencilColor_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSetGreasePencilDepth ****************/

extern StructRNA RNA_GeometryNodeSetGreasePencilDepth;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSetGreasePencilDepth_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSetGreasePencilDepth_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSetGreasePencilDepth_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSetGreasePencilSoftness ****************/

extern StructRNA RNA_GeometryNodeSetGreasePencilSoftness;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSetGreasePencilSoftness_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSetGreasePencilSoftness_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSetGreasePencilSoftness_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSetID ****************/

extern StructRNA RNA_GeometryNodeSetID;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSetID_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSetID_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSetID_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSetInstanceTransform ****************/

extern StructRNA RNA_GeometryNodeSetInstanceTransform;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSetInstanceTransform_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSetInstanceTransform_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSetInstanceTransform_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSetMaterial ****************/

extern StructRNA RNA_GeometryNodeSetMaterial;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSetMaterial_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSetMaterial_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSetMaterial_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSetMaterialIndex ****************/

extern StructRNA RNA_GeometryNodeSetMaterialIndex;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSetMaterialIndex_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSetMaterialIndex_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSetMaterialIndex_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSetMeshNormal ****************/

extern StructRNA RNA_GeometryNodeSetMeshNormal;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSetMeshNormal_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSetMeshNormal_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSetMeshNormal_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSetPointRadius ****************/

extern StructRNA RNA_GeometryNodeSetPointRadius;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSetPointRadius_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSetPointRadius_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSetPointRadius_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSetPosition ****************/

extern StructRNA RNA_GeometryNodeSetPosition;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSetPosition_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSetPosition_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSetPosition_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSetShadeSmooth ****************/

extern StructRNA RNA_GeometryNodeSetShadeSmooth;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSetShadeSmooth_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSetShadeSmooth_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSetShadeSmooth_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSetSplineCyclic ****************/

extern StructRNA RNA_GeometryNodeSetSplineCyclic;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSetSplineCyclic_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSetSplineCyclic_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSetSplineCyclic_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSetSplineResolution ****************/

extern StructRNA RNA_GeometryNodeSetSplineResolution;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSetSplineResolution_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSetSplineResolution_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSetSplineResolution_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSimulationInput ****************/

extern StructRNA RNA_GeometryNodeSimulationInput;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA GeometryNodeSimulationInput_paired_output_get(PointerRNA *ptr);

bool GeometryNodeSimulationInput_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSimulationInput_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSimulationInput_output_template_func(struct StructRNA *_type, int index);
bool GeometryNodeSimulationInput_pair_with_output_func(struct ID *_selfid, struct bNode *_self, bContext *C, ReportList *reports, struct bNode *output_node);
/**************** GeometryNodeSimulationOutput ****************/

extern StructRNA RNA_GeometryNodeSimulationOutput;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int GeometryNodeSimulationOutput_active_index_get(PointerRNA *ptr);
void GeometryNodeSimulationOutput_active_index_set(PointerRNA *ptr, int value);

PointerRNA GeometryNodeSimulationOutput_active_item_get(PointerRNA *ptr);

void GeometryNodeSimulationOutput_state_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GeometryNodeSimulationOutput_state_items_next(CollectionPropertyIterator *iter);
void GeometryNodeSimulationOutput_state_items_end(CollectionPropertyIterator *iter);
int GeometryNodeSimulationOutput_state_items_length(PointerRNA *ptr);
bool GeometryNodeSimulationOutput_state_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GeometryNodeSimulationOutput_state_items_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool GeometryNodeSimulationOutput_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSimulationOutput_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSimulationOutput_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSortElements ****************/

extern StructRNA RNA_GeometryNodeSortElements;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSortElements_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSortElements_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSortElements_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSplineLength ****************/

extern StructRNA RNA_GeometryNodeSplineLength;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSplineLength_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSplineLength_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSplineLength_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSplineParameter ****************/

extern StructRNA RNA_GeometryNodeSplineParameter;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSplineParameter_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSplineParameter_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSplineParameter_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSplitEdges ****************/

extern StructRNA RNA_GeometryNodeSplitEdges;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSplitEdges_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSplitEdges_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSplitEdges_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSplitToInstances ****************/

extern StructRNA RNA_GeometryNodeSplitToInstances;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSplitToInstances_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSplitToInstances_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSplitToInstances_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeStoreNamedAttribute ****************/

extern StructRNA RNA_GeometryNodeStoreNamedAttribute;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeStoreNamedAttribute_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeStoreNamedAttribute_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeStoreNamedAttribute_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeStoreNamedGrid ****************/

extern StructRNA RNA_GeometryNodeStoreNamedGrid;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeStoreNamedGrid_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeStoreNamedGrid_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeStoreNamedGrid_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeStringJoin ****************/

extern StructRNA RNA_GeometryNodeStringJoin;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeStringJoin_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeStringJoin_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeStringJoin_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeStringToCurves ****************/

extern StructRNA RNA_GeometryNodeStringToCurves;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA GeometryNodeStringToCurves_font_get(PointerRNA *ptr);

enum {
	GeometryNodeStringToCurves_align_x_LEFT = 0,
	GeometryNodeStringToCurves_align_x_CENTER = 1,
	GeometryNodeStringToCurves_align_x_RIGHT = 2,
	GeometryNodeStringToCurves_align_x_JUSTIFY = 3,
	GeometryNodeStringToCurves_align_x_FLUSH = 4,
};

int GeometryNodeStringToCurves_align_x_get(PointerRNA *ptr);
void GeometryNodeStringToCurves_align_x_set(PointerRNA *ptr, int value);

enum {
	GeometryNodeStringToCurves_pivot_mode_MIDPOINT = 0,
	GeometryNodeStringToCurves_pivot_mode_TOP_LEFT = 1,
	GeometryNodeStringToCurves_pivot_mode_TOP_CENTER = 2,
	GeometryNodeStringToCurves_pivot_mode_TOP_RIGHT = 3,
	GeometryNodeStringToCurves_pivot_mode_BOTTOM_LEFT = 4,
	GeometryNodeStringToCurves_pivot_mode_BOTTOM_CENTER = 5,
	GeometryNodeStringToCurves_pivot_mode_BOTTOM_RIGHT = 6,
};

int GeometryNodeStringToCurves_pivot_mode_get(PointerRNA *ptr);
void GeometryNodeStringToCurves_pivot_mode_set(PointerRNA *ptr, int value);

enum {
	GeometryNodeStringToCurves_overflow_OVERFLOW = 0,
	GeometryNodeStringToCurves_overflow_SCALE_TO_FIT = 1,
	GeometryNodeStringToCurves_overflow_TRUNCATE = 2,
};

int GeometryNodeStringToCurves_overflow_get(PointerRNA *ptr);
void GeometryNodeStringToCurves_overflow_set(PointerRNA *ptr, int value);

enum {
	GeometryNodeStringToCurves_align_y_TOP = 1,
	GeometryNodeStringToCurves_align_y_TOP_BASELINE = 0,
	GeometryNodeStringToCurves_align_y_MIDDLE = 2,
	GeometryNodeStringToCurves_align_y_BOTTOM_BASELINE = 3,
	GeometryNodeStringToCurves_align_y_BOTTOM = 4,
};

int GeometryNodeStringToCurves_align_y_get(PointerRNA *ptr);
void GeometryNodeStringToCurves_align_y_set(PointerRNA *ptr, int value);

bool GeometryNodeStringToCurves_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeStringToCurves_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeStringToCurves_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSubdivideCurve ****************/

extern StructRNA RNA_GeometryNodeSubdivideCurve;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSubdivideCurve_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSubdivideCurve_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSubdivideCurve_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSubdivideMesh ****************/

extern StructRNA RNA_GeometryNodeSubdivideMesh;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSubdivideMesh_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSubdivideMesh_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSubdivideMesh_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSubdivisionSurface ****************/

extern StructRNA RNA_GeometryNodeSubdivisionSurface;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSubdivisionSurface_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSubdivisionSurface_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSubdivisionSurface_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeSwitch ****************/

extern StructRNA RNA_GeometryNodeSwitch;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeSwitch_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeSwitch_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeSwitch_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeTool3DCursor ****************/

extern StructRNA RNA_GeometryNodeTool3DCursor;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeTool3DCursor_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeTool3DCursor_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeTool3DCursor_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeToolActiveElement ****************/

extern StructRNA RNA_GeometryNodeToolActiveElement;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeToolActiveElement_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeToolActiveElement_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeToolActiveElement_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeToolFaceSet ****************/

extern StructRNA RNA_GeometryNodeToolFaceSet;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeToolFaceSet_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeToolFaceSet_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeToolFaceSet_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeToolMousePosition ****************/

extern StructRNA RNA_GeometryNodeToolMousePosition;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeToolMousePosition_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeToolMousePosition_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeToolMousePosition_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeToolSelection ****************/

extern StructRNA RNA_GeometryNodeToolSelection;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeToolSelection_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeToolSelection_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeToolSelection_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeToolSetFaceSet ****************/

extern StructRNA RNA_GeometryNodeToolSetFaceSet;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeToolSetFaceSet_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeToolSetFaceSet_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeToolSetFaceSet_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeToolSetSelection ****************/

extern StructRNA RNA_GeometryNodeToolSetSelection;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeToolSetSelection_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeToolSetSelection_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeToolSetSelection_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeTransform ****************/

extern StructRNA RNA_GeometryNodeTransform;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeTransform_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeTransform_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeTransform_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeTranslateInstances ****************/

extern StructRNA RNA_GeometryNodeTranslateInstances;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeTranslateInstances_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeTranslateInstances_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeTranslateInstances_output_template_func(struct StructRNA *_type, int index);
/**************** Geometry Node Tree ****************/

extern StructRNA RNA_GeometryNodeTree;
extern StructRNA RNA_NodeTree;
extern StructRNA RNA_ID;

bool GeometryNodeTree_is_type_curve_get(PointerRNA *ptr);
void GeometryNodeTree_is_type_curve_set(PointerRNA *ptr, bool value);

bool GeometryNodeTree_is_mode_object_get(PointerRNA *ptr);
void GeometryNodeTree_is_mode_object_set(PointerRNA *ptr, bool value);

bool GeometryNodeTree_is_mode_edit_get(PointerRNA *ptr);
void GeometryNodeTree_is_mode_edit_set(PointerRNA *ptr, bool value);

bool GeometryNodeTree_is_type_grease_pencil_get(PointerRNA *ptr);
void GeometryNodeTree_is_type_grease_pencil_set(PointerRNA *ptr, bool value);

bool GeometryNodeTree_is_type_mesh_get(PointerRNA *ptr);
void GeometryNodeTree_is_type_mesh_set(PointerRNA *ptr, bool value);

bool GeometryNodeTree_is_modifier_get(PointerRNA *ptr);
void GeometryNodeTree_is_modifier_set(PointerRNA *ptr, bool value);

bool GeometryNodeTree_is_mode_paint_get(PointerRNA *ptr);
void GeometryNodeTree_is_mode_paint_set(PointerRNA *ptr, bool value);

bool GeometryNodeTree_is_type_pointcloud_get(PointerRNA *ptr);
void GeometryNodeTree_is_type_pointcloud_set(PointerRNA *ptr, bool value);

bool GeometryNodeTree_is_mode_sculpt_get(PointerRNA *ptr);
void GeometryNodeTree_is_mode_sculpt_set(PointerRNA *ptr, bool value);

bool GeometryNodeTree_is_tool_get(PointerRNA *ptr);
void GeometryNodeTree_is_tool_set(PointerRNA *ptr, bool value);

bool GeometryNodeTree_use_wait_for_click_get(PointerRNA *ptr);
void GeometryNodeTree_use_wait_for_click_set(PointerRNA *ptr, bool value);

/**************** GeometryNodeTriangulate ****************/

extern StructRNA RNA_GeometryNodeTriangulate;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeTriangulate_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeTriangulate_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeTriangulate_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeTrimCurve ****************/

extern StructRNA RNA_GeometryNodeTrimCurve;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeTrimCurve_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeTrimCurve_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeTrimCurve_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeUVPackIslands ****************/

extern StructRNA RNA_GeometryNodeUVPackIslands;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeUVPackIslands_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeUVPackIslands_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeUVPackIslands_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeUVUnwrap ****************/

extern StructRNA RNA_GeometryNodeUVUnwrap;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeUVUnwrap_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeUVUnwrap_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeUVUnwrap_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeVertexOfCorner ****************/

extern StructRNA RNA_GeometryNodeVertexOfCorner;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeVertexOfCorner_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeVertexOfCorner_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeVertexOfCorner_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeViewer ****************/

extern StructRNA RNA_GeometryNodeViewer;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeViewer_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeViewer_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeViewer_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeViewportTransform ****************/

extern StructRNA RNA_GeometryNodeViewportTransform;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeViewportTransform_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeViewportTransform_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeViewportTransform_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeVolumeCube ****************/

extern StructRNA RNA_GeometryNodeVolumeCube;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeVolumeCube_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeVolumeCube_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeVolumeCube_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeVolumeToMesh ****************/

extern StructRNA RNA_GeometryNodeVolumeToMesh;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeVolumeToMesh_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeVolumeToMesh_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeVolumeToMesh_output_template_func(struct StructRNA *_type, int index);
/**************** GeometryNodeWarning ****************/

extern StructRNA RNA_GeometryNodeWarning;
extern StructRNA RNA_GeometryNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool GeometryNodeWarning_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA GeometryNodeWarning_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA GeometryNodeWarning_output_template_func(struct StructRNA *_type, int index);
/**************** Gizmo ****************/

extern StructRNA RNA_Gizmo;

PointerRNA Gizmo_rna_type_get(PointerRNA *ptr);

PointerRNA Gizmo_group_get(PointerRNA *ptr);

float Gizmo_alpha_get(PointerRNA *ptr);
void Gizmo_alpha_set(PointerRNA *ptr, float value);

float Gizmo_alpha_highlight_get(PointerRNA *ptr);
void Gizmo_alpha_highlight_set(PointerRNA *ptr, float value);

void Gizmo_matrix_basis_get(PointerRNA *ptr, float values[16]);
void Gizmo_matrix_basis_set(PointerRNA *ptr, const float values[16]);

void Gizmo_matrix_world_get(PointerRNA *ptr, float values[16]);
void Gizmo_matrix_world_set(PointerRNA *ptr, const float values[16]);

bool Gizmo_use_grab_cursor_get(PointerRNA *ptr);
void Gizmo_use_grab_cursor_set(PointerRNA *ptr, bool value);

bool Gizmo_use_event_handle_all_get(PointerRNA *ptr);
void Gizmo_use_event_handle_all_set(PointerRNA *ptr, bool value);

bool Gizmo_hide_get(PointerRNA *ptr);
void Gizmo_hide_set(PointerRNA *ptr, bool value);

bool Gizmo_hide_keymap_get(PointerRNA *ptr);
void Gizmo_hide_keymap_set(PointerRNA *ptr, bool value);

bool Gizmo_hide_select_get(PointerRNA *ptr);
void Gizmo_hide_select_set(PointerRNA *ptr, bool value);

bool Gizmo_is_highlight_get(PointerRNA *ptr);
void Gizmo_is_highlight_set(PointerRNA *ptr, bool value);

bool Gizmo_is_modal_get(PointerRNA *ptr);
void Gizmo_is_modal_set(PointerRNA *ptr, bool value);

float Gizmo_line_width_get(PointerRNA *ptr);
void Gizmo_line_width_set(PointerRNA *ptr, float value);

void Gizmo_matrix_offset_get(PointerRNA *ptr, float values[16]);
void Gizmo_matrix_offset_set(PointerRNA *ptr, const float values[16]);

PointerRNA Gizmo_properties_get(PointerRNA *ptr);

bool Gizmo_use_draw_scale_get(PointerRNA *ptr);
void Gizmo_use_draw_scale_set(PointerRNA *ptr, bool value);

float Gizmo_scale_basis_get(PointerRNA *ptr);
void Gizmo_scale_basis_set(PointerRNA *ptr, float value);

bool Gizmo_use_draw_offset_scale_get(PointerRNA *ptr);
void Gizmo_use_draw_offset_scale_set(PointerRNA *ptr, bool value);

bool Gizmo_select_get(PointerRNA *ptr);
void Gizmo_select_set(PointerRNA *ptr, bool value);

bool Gizmo_use_select_background_get(PointerRNA *ptr);
void Gizmo_use_select_background_set(PointerRNA *ptr, bool value);

float Gizmo_select_bias_get(PointerRNA *ptr);
void Gizmo_select_bias_set(PointerRNA *ptr, float value);

bool Gizmo_use_draw_modal_get(PointerRNA *ptr);
void Gizmo_use_draw_modal_set(PointerRNA *ptr, bool value);

bool Gizmo_use_draw_hover_get(PointerRNA *ptr);
void Gizmo_use_draw_hover_set(PointerRNA *ptr, bool value);

bool Gizmo_use_draw_value_get(PointerRNA *ptr);
void Gizmo_use_draw_value_set(PointerRNA *ptr, bool value);

void Gizmo_matrix_space_get(PointerRNA *ptr, float values[16]);
void Gizmo_matrix_space_set(PointerRNA *ptr, const float values[16]);

bool Gizmo_use_operator_tool_properties_get(PointerRNA *ptr);
void Gizmo_use_operator_tool_properties_set(PointerRNA *ptr, bool value);

bool Gizmo_use_tooltip_get(PointerRNA *ptr);
void Gizmo_use_tooltip_set(PointerRNA *ptr, bool value);

#define Gizmo_bl_idname_MAX 64

void Gizmo_bl_idname_get(PointerRNA *ptr, char *value);
int Gizmo_bl_idname_length(PointerRNA *ptr);
void Gizmo_bl_idname_set(PointerRNA *ptr, const char *value);

void Gizmo_color_get(PointerRNA *ptr, float values[3]);
void Gizmo_color_set(PointerRNA *ptr, const float values[3]);

void Gizmo_color_highlight_get(PointerRNA *ptr, float values[3]);
void Gizmo_color_highlight_set(PointerRNA *ptr, const float values[3]);

void Gizmo_draw_func(struct wmGizmo *_self, struct bContext *context);
void Gizmo_draw_select_func(struct wmGizmo *_self, struct bContext *context, int select_id);
int Gizmo_test_select_func(struct wmGizmo *_self, struct bContext *context, int location[2]);
int Gizmo_modal_func(struct wmGizmo *_self, struct bContext *context, struct wmEvent *event, int tweak);
void Gizmo_setup_func(struct wmGizmo *_self);
int Gizmo_invoke_func(struct wmGizmo *_self, struct bContext *context, struct wmEvent *event);
void Gizmo_exit_func(struct wmGizmo *_self, struct bContext *context, bool cancel);
void Gizmo_select_refresh_func(struct wmGizmo *_self);
void Gizmo_draw_preset_box_func(struct wmGizmo *_self, float matrix[16], int select_id);
void Gizmo_draw_preset_arrow_func(struct wmGizmo *_self, float matrix[16], int axis, int select_id);
void Gizmo_draw_preset_circle_func(struct wmGizmo *_self, float matrix[16], int axis, int select_id);
void Gizmo_target_set_prop_func(struct wmGizmo *_self, ReportList *reports, const char * target, struct PointerRNA *data, const char * property, int index);
struct PointerRNA Gizmo_target_set_operator_func(struct wmGizmo *_self, ReportList *reports, const char * operator_value, int index);
bool Gizmo_target_is_valid_func(struct wmGizmo *_self, ReportList *reports, const char * property);
/**************** GizmoGroup ****************/

extern StructRNA RNA_GizmoGroup;

PointerRNA GizmoGroup_rna_type_get(PointerRNA *ptr);

void GizmoGroup_name_get(PointerRNA *ptr, char *value);
int GizmoGroup_name_length(PointerRNA *ptr);
void GizmoGroup_name_set(PointerRNA *ptr, const char *value);

void GizmoGroup_gizmos_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GizmoGroup_gizmos_next(CollectionPropertyIterator *iter);
void GizmoGroup_gizmos_end(CollectionPropertyIterator *iter);
bool GizmoGroup_gizmos_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

enum {
	GizmoGroup_bl_options_3D = 1,
	GizmoGroup_bl_options_SCALE = 2,
	GizmoGroup_bl_options_DEPTH_3D = 4,
	GizmoGroup_bl_options_SELECT = 8,
	GizmoGroup_bl_options_PERSISTENT = 16,
	GizmoGroup_bl_options_SHOW_MODAL_ALL = 32,
	GizmoGroup_bl_options_EXCLUDE_MODAL = 64,
	GizmoGroup_bl_options_TOOL_INIT = 128,
	GizmoGroup_bl_options_TOOL_FALLBACK_KEYMAP = 256,
	GizmoGroup_bl_options_VR_REDRAWS = 1024,
};

int GizmoGroup_bl_options_get(PointerRNA *ptr);
void GizmoGroup_bl_options_set(PointerRNA *ptr, int value);

enum {
	GizmoGroup_bl_region_type_WINDOW = 0,
	GizmoGroup_bl_region_type_HEADER = 1,
	GizmoGroup_bl_region_type_CHANNELS = 2,
	GizmoGroup_bl_region_type_TEMPORARY = 3,
	GizmoGroup_bl_region_type_UI = 4,
	GizmoGroup_bl_region_type_TOOLS = 5,
	GizmoGroup_bl_region_type_TOOL_PROPS = 6,
	GizmoGroup_bl_region_type_ASSET_SHELF = 14,
	GizmoGroup_bl_region_type_ASSET_SHELF_HEADER = 15,
	GizmoGroup_bl_region_type_PREVIEW = 7,
	GizmoGroup_bl_region_type_HUD = 8,
	GizmoGroup_bl_region_type_NAVIGATION_BAR = 9,
	GizmoGroup_bl_region_type_EXECUTE = 10,
	GizmoGroup_bl_region_type_FOOTER = 11,
	GizmoGroup_bl_region_type_TOOL_HEADER = 12,
	GizmoGroup_bl_region_type_XR = 13,
};

int GizmoGroup_bl_region_type_get(PointerRNA *ptr);
void GizmoGroup_bl_region_type_set(PointerRNA *ptr, int value);

enum {
	GizmoGroup_bl_space_type_EMPTY = 0,
	GizmoGroup_bl_space_type_VIEW_3D = 1,
	GizmoGroup_bl_space_type_IMAGE_EDITOR = 6,
	GizmoGroup_bl_space_type_NODE_EDITOR = 16,
	GizmoGroup_bl_space_type_SEQUENCE_EDITOR = 8,
	GizmoGroup_bl_space_type_CLIP_EDITOR = 20,
	GizmoGroup_bl_space_type_DOPESHEET_EDITOR = 12,
	GizmoGroup_bl_space_type_GRAPH_EDITOR = 2,
	GizmoGroup_bl_space_type_NLA_EDITOR = 13,
	GizmoGroup_bl_space_type_TEXT_EDITOR = 9,
	GizmoGroup_bl_space_type_CONSOLE = 18,
	GizmoGroup_bl_space_type_INFO = 7,
	GizmoGroup_bl_space_type_TOPBAR = 21,
	GizmoGroup_bl_space_type_STATUSBAR = 22,
	GizmoGroup_bl_space_type_OUTLINER = 3,
	GizmoGroup_bl_space_type_PROPERTIES = 4,
	GizmoGroup_bl_space_type_FILE_BROWSER = 5,
	GizmoGroup_bl_space_type_SPREADSHEET = 23,
	GizmoGroup_bl_space_type_PREFERENCES = 19,
};

int GizmoGroup_bl_space_type_get(PointerRNA *ptr);
void GizmoGroup_bl_space_type_set(PointerRNA *ptr, int value);

#define GizmoGroup_bl_idname_MAX 64

void GizmoGroup_bl_idname_get(PointerRNA *ptr, char *value);
int GizmoGroup_bl_idname_length(PointerRNA *ptr);
void GizmoGroup_bl_idname_set(PointerRNA *ptr, const char *value);

#define GizmoGroup_bl_label_MAX 64

void GizmoGroup_bl_label_get(PointerRNA *ptr, char *value);
int GizmoGroup_bl_label_length(PointerRNA *ptr);
void GizmoGroup_bl_label_set(PointerRNA *ptr, const char *value);

void GizmoGroup_bl_owner_id_get(PointerRNA *ptr, char *value);
int GizmoGroup_bl_owner_id_length(PointerRNA *ptr);
void GizmoGroup_bl_owner_id_set(PointerRNA *ptr, const char *value);

bool GizmoGroup_poll_func(struct bContext *context);
struct wmKeyMap *GizmoGroup_setup_keymap_func(struct wmKeyConfig *keyconfig);
void GizmoGroup_setup_func(struct wmGizmoGroup *_self, struct bContext *context);
void GizmoGroup_refresh_func(struct wmGizmoGroup *_self, struct bContext *context);
void GizmoGroup_draw_prepare_func(struct wmGizmoGroup *_self, struct bContext *context);
void GizmoGroup_invoke_prepare_func(struct wmGizmoGroup *_self, struct bContext *context, struct wmGizmo *gizmo);
/**************** Gizmo Group Properties ****************/

extern StructRNA RNA_GizmoGroupProperties;

PointerRNA GizmoGroupProperties_rna_type_get(PointerRNA *ptr);

/**************** Gizmo Properties ****************/

extern StructRNA RNA_GizmoProperties;

PointerRNA GizmoProperties_rna_type_get(PointerRNA *ptr);

/**************** Gizmos ****************/

extern StructRNA RNA_Gizmos;

PointerRNA Gizmos_rna_type_get(PointerRNA *ptr);

struct wmGizmo *Gizmos_new_func(struct wmGizmoGroup *_self, ReportList *reports, const char * type);
void Gizmos_remove_func(struct wmGizmoGroup *_self, bContext *C, struct wmGizmo *gizmo);
void Gizmos_clear_func(struct wmGizmoGroup *_self, bContext *C);
/**************** Glow Strip ****************/

extern StructRNA RNA_GlowStrip;
extern StructRNA RNA_EffectStrip;
extern StructRNA RNA_Strip;

float GlowStrip_blur_radius_get(PointerRNA *ptr);
void GlowStrip_blur_radius_set(PointerRNA *ptr, float value);

float GlowStrip_boost_factor_get(PointerRNA *ptr);
void GlowStrip_boost_factor_set(PointerRNA *ptr, float value);

float GlowStrip_clamp_get(PointerRNA *ptr);
void GlowStrip_clamp_set(PointerRNA *ptr, float value);

PointerRNA GlowStrip_input_1_get(PointerRNA *ptr);

bool GlowStrip_use_only_boost_get(PointerRNA *ptr);
void GlowStrip_use_only_boost_set(PointerRNA *ptr, bool value);

int GlowStrip_quality_get(PointerRNA *ptr);
void GlowStrip_quality_set(PointerRNA *ptr, int value);

float GlowStrip_threshold_get(PointerRNA *ptr);
void GlowStrip_threshold_set(PointerRNA *ptr, float value);

int GlowStrip_input_count_get(PointerRNA *ptr);
void GlowStrip_input_count_set(PointerRNA *ptr, int value);

/**************** Grease Pencil Paint ****************/

extern StructRNA RNA_GpPaint;
extern StructRNA RNA_Paint;

enum {
	GpPaint_color_mode_MATERIAL = 0,
	GpPaint_color_mode_VERTEXCOLOR = 1,
};

int GpPaint_color_mode_get(PointerRNA *ptr);
void GpPaint_color_mode_set(PointerRNA *ptr, int value);

/**************** Grease Pencil Sculpt Paint ****************/

extern StructRNA RNA_GpSculptPaint;
extern StructRNA RNA_Paint;

/**************** Grease Pencil Vertex Paint ****************/

extern StructRNA RNA_GpVertexPaint;
extern StructRNA RNA_Paint;

/**************** Grease Pencil Weight Paint ****************/

extern StructRNA RNA_GpWeightPaint;
extern StructRNA RNA_Paint;

/**************** Annotation ****************/

extern StructRNA RNA_GreasePencil;
extern StructRNA RNA_ID;

PointerRNA GreasePencil_animation_data_get(PointerRNA *ptr);

void GreasePencil_layers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GreasePencil_layers_next(CollectionPropertyIterator *iter);
void GreasePencil_layers_end(CollectionPropertyIterator *iter);
bool GreasePencil_layers_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GreasePencil_layers_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

/**************** Armature Modifier ****************/

extern StructRNA RNA_GreasePencilArmatureModifier;
extern StructRNA RNA_Modifier;

bool GreasePencilArmatureModifier_invert_vertex_group_get(PointerRNA *ptr);
void GreasePencilArmatureModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

PointerRNA GreasePencilArmatureModifier_object_get(PointerRNA *ptr);

bool GreasePencilArmatureModifier_use_deform_preserve_volume_get(PointerRNA *ptr);
void GreasePencilArmatureModifier_use_deform_preserve_volume_set(PointerRNA *ptr, bool value);

bool GreasePencilArmatureModifier_use_bone_envelopes_get(PointerRNA *ptr);
void GreasePencilArmatureModifier_use_bone_envelopes_set(PointerRNA *ptr, bool value);

bool GreasePencilArmatureModifier_use_vertex_groups_get(PointerRNA *ptr);
void GreasePencilArmatureModifier_use_vertex_groups_set(PointerRNA *ptr, bool value);

#define GreasePencilArmatureModifier_vertex_group_name_MAX 64

void GreasePencilArmatureModifier_vertex_group_name_get(PointerRNA *ptr, char *value);
int GreasePencilArmatureModifier_vertex_group_name_length(PointerRNA *ptr);
void GreasePencilArmatureModifier_vertex_group_name_set(PointerRNA *ptr, const char *value);

bool GreasePencilArmatureModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilArmatureModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Instance Modifier ****************/

extern StructRNA RNA_GreasePencilArrayModifier;
extern StructRNA RNA_Modifier;

void GreasePencilArrayModifier_constant_offset_get(PointerRNA *ptr, float values[3]);
void GreasePencilArrayModifier_constant_offset_set(PointerRNA *ptr, const float values[3]);

int GreasePencilArrayModifier_count_get(PointerRNA *ptr);
void GreasePencilArrayModifier_count_set(PointerRNA *ptr, int value);

bool GreasePencilArrayModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilArrayModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilArrayModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilArrayModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilArrayModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilArrayModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilArrayModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilArrayModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilArrayModifier_tree_node_filter_MAX 64

void GreasePencilArrayModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilArrayModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilArrayModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilArrayModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilArrayModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilArrayModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilArrayModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilArrayModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilArrayModifier_replace_material_get(PointerRNA *ptr);
void GreasePencilArrayModifier_replace_material_set(PointerRNA *ptr, int value);

int GreasePencilArrayModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilArrayModifier_material_pass_filter_set(PointerRNA *ptr, int value);

bool GreasePencilArrayModifier_use_constant_offset_get(PointerRNA *ptr);
void GreasePencilArrayModifier_use_constant_offset_set(PointerRNA *ptr, bool value);

PointerRNA GreasePencilArrayModifier_offset_object_get(PointerRNA *ptr);

void GreasePencilArrayModifier_random_offset_get(PointerRNA *ptr, float values[3]);
void GreasePencilArrayModifier_random_offset_set(PointerRNA *ptr, const float values[3]);

void GreasePencilArrayModifier_random_rotation_get(PointerRNA *ptr, float values[3]);
void GreasePencilArrayModifier_random_rotation_set(PointerRNA *ptr, const float values[3]);

void GreasePencilArrayModifier_relative_offset_get(PointerRNA *ptr, float values[3]);
void GreasePencilArrayModifier_relative_offset_set(PointerRNA *ptr, const float values[3]);

void GreasePencilArrayModifier_random_scale_get(PointerRNA *ptr, float values[3]);
void GreasePencilArrayModifier_random_scale_set(PointerRNA *ptr, const float values[3]);

int GreasePencilArrayModifier_seed_get(PointerRNA *ptr);
void GreasePencilArrayModifier_seed_set(PointerRNA *ptr, int value);

bool GreasePencilArrayModifier_use_relative_offset_get(PointerRNA *ptr);
void GreasePencilArrayModifier_use_relative_offset_set(PointerRNA *ptr, bool value);

bool GreasePencilArrayModifier_use_uniform_random_scale_get(PointerRNA *ptr);
void GreasePencilArrayModifier_use_uniform_random_scale_set(PointerRNA *ptr, bool value);

bool GreasePencilArrayModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilArrayModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilArrayModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilArrayModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilArrayModifier_use_object_offset_get(PointerRNA *ptr);
void GreasePencilArrayModifier_use_object_offset_set(PointerRNA *ptr, bool value);

bool GreasePencilArrayModifier_open_constant_offset_panel_get(PointerRNA *ptr);
void GreasePencilArrayModifier_open_constant_offset_panel_set(PointerRNA *ptr, bool value);

bool GreasePencilArrayModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilArrayModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

bool GreasePencilArrayModifier_open_object_offset_panel_get(PointerRNA *ptr);
void GreasePencilArrayModifier_open_object_offset_panel_set(PointerRNA *ptr, bool value);

bool GreasePencilArrayModifier_open_randomize_panel_get(PointerRNA *ptr);
void GreasePencilArrayModifier_open_randomize_panel_set(PointerRNA *ptr, bool value);

bool GreasePencilArrayModifier_open_relative_offset_panel_get(PointerRNA *ptr);
void GreasePencilArrayModifier_open_relative_offset_panel_set(PointerRNA *ptr, bool value);

/**************** Build Modifier ****************/

extern StructRNA RNA_GreasePencilBuildModifier;
extern StructRNA RNA_Modifier;

float GreasePencilBuildModifier_start_delay_get(PointerRNA *ptr);
void GreasePencilBuildModifier_start_delay_set(PointerRNA *ptr, float value);

float GreasePencilBuildModifier_frame_end_get(PointerRNA *ptr);
void GreasePencilBuildModifier_frame_end_set(PointerRNA *ptr, float value);

float GreasePencilBuildModifier_percentage_factor_get(PointerRNA *ptr);
void GreasePencilBuildModifier_percentage_factor_set(PointerRNA *ptr, float value);

float GreasePencilBuildModifier_fade_factor_get(PointerRNA *ptr);
void GreasePencilBuildModifier_fade_factor_set(PointerRNA *ptr, float value);

bool GreasePencilBuildModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilBuildModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilBuildModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilBuildModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilBuildModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilBuildModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilBuildModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilBuildModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilBuildModifier_tree_node_filter_MAX 64

void GreasePencilBuildModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilBuildModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilBuildModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilBuildModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilBuildModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilBuildModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilBuildModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

float GreasePencilBuildModifier_length_get(PointerRNA *ptr);
void GreasePencilBuildModifier_length_set(PointerRNA *ptr, float value);

PointerRNA GreasePencilBuildModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilBuildModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilBuildModifier_material_pass_filter_set(PointerRNA *ptr, int value);

float GreasePencilBuildModifier_speed_maxgap_get(PointerRNA *ptr);
void GreasePencilBuildModifier_speed_maxgap_set(PointerRNA *ptr, float value);

enum {
	GreasePencilBuildModifier_mode_SEQUENTIAL = 0,
	GreasePencilBuildModifier_mode_CONCURRENT = 1,
	GreasePencilBuildModifier_mode_ADDITIVE = 2,
};

int GreasePencilBuildModifier_mode_get(PointerRNA *ptr);
void GreasePencilBuildModifier_mode_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilBuildModifier_object_get(PointerRNA *ptr);

float GreasePencilBuildModifier_fade_opacity_strength_get(PointerRNA *ptr);
void GreasePencilBuildModifier_fade_opacity_strength_set(PointerRNA *ptr, float value);

bool GreasePencilBuildModifier_use_restrict_frame_range_get(PointerRNA *ptr);
void GreasePencilBuildModifier_use_restrict_frame_range_set(PointerRNA *ptr, bool value);

bool GreasePencilBuildModifier_use_percentage_get(PointerRNA *ptr);
void GreasePencilBuildModifier_use_percentage_set(PointerRNA *ptr, bool value);

float GreasePencilBuildModifier_speed_factor_get(PointerRNA *ptr);
void GreasePencilBuildModifier_speed_factor_set(PointerRNA *ptr, float value);

float GreasePencilBuildModifier_frame_start_get(PointerRNA *ptr);
void GreasePencilBuildModifier_frame_start_set(PointerRNA *ptr, float value);

float GreasePencilBuildModifier_fade_thickness_strength_get(PointerRNA *ptr);
void GreasePencilBuildModifier_fade_thickness_strength_set(PointerRNA *ptr, float value);

enum {
	GreasePencilBuildModifier_concurrent_time_alignment_START = 0,
	GreasePencilBuildModifier_concurrent_time_alignment_END = 1,
};

int GreasePencilBuildModifier_concurrent_time_alignment_get(PointerRNA *ptr);
void GreasePencilBuildModifier_concurrent_time_alignment_set(PointerRNA *ptr, int value);

enum {
	GreasePencilBuildModifier_time_mode_DRAWSPEED = 2,
	GreasePencilBuildModifier_time_mode_FRAMES = 0,
	GreasePencilBuildModifier_time_mode_PERCENTAGE = 1,
};

int GreasePencilBuildModifier_time_mode_get(PointerRNA *ptr);
void GreasePencilBuildModifier_time_mode_set(PointerRNA *ptr, int value);

enum {
	GreasePencilBuildModifier_transition_GROW = 0,
	GreasePencilBuildModifier_transition_SHRINK = 1,
	GreasePencilBuildModifier_transition_FADE = 2,
};

int GreasePencilBuildModifier_transition_get(PointerRNA *ptr);
void GreasePencilBuildModifier_transition_set(PointerRNA *ptr, int value);

bool GreasePencilBuildModifier_use_fading_get(PointerRNA *ptr);
void GreasePencilBuildModifier_use_fading_set(PointerRNA *ptr, bool value);

bool GreasePencilBuildModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilBuildModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilBuildModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilBuildModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilBuildModifier_target_vertex_group_MAX 64

void GreasePencilBuildModifier_target_vertex_group_get(PointerRNA *ptr, char *value);
int GreasePencilBuildModifier_target_vertex_group_length(PointerRNA *ptr);
void GreasePencilBuildModifier_target_vertex_group_set(PointerRNA *ptr, const char *value);

bool GreasePencilBuildModifier_open_fading_panel_get(PointerRNA *ptr);
void GreasePencilBuildModifier_open_fading_panel_set(PointerRNA *ptr, bool value);

bool GreasePencilBuildModifier_open_frame_range_panel_get(PointerRNA *ptr);
void GreasePencilBuildModifier_open_frame_range_panel_set(PointerRNA *ptr, bool value);

bool GreasePencilBuildModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilBuildModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Grease Pencil Color Modifier ****************/

extern StructRNA RNA_GreasePencilColorModifier;
extern StructRNA RNA_Modifier;

PointerRNA GreasePencilColorModifier_custom_curve_get(PointerRNA *ptr);

float GreasePencilColorModifier_hue_get(PointerRNA *ptr);
void GreasePencilColorModifier_hue_set(PointerRNA *ptr, float value);

bool GreasePencilColorModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilColorModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilColorModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilColorModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilColorModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilColorModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilColorModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilColorModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilColorModifier_tree_node_filter_MAX 64

void GreasePencilColorModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilColorModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilColorModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilColorModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilColorModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilColorModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilColorModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilColorModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilColorModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilColorModifier_material_pass_filter_set(PointerRNA *ptr, int value);

enum {
	GreasePencilColorModifier_color_mode_BOTH = 2,
	GreasePencilColorModifier_color_mode_STROKE = 0,
	GreasePencilColorModifier_color_mode_FILL = 1,
};

int GreasePencilColorModifier_color_mode_get(PointerRNA *ptr);
void GreasePencilColorModifier_color_mode_set(PointerRNA *ptr, int value);

float GreasePencilColorModifier_saturation_get(PointerRNA *ptr);
void GreasePencilColorModifier_saturation_set(PointerRNA *ptr, float value);

bool GreasePencilColorModifier_use_custom_curve_get(PointerRNA *ptr);
void GreasePencilColorModifier_use_custom_curve_set(PointerRNA *ptr, bool value);

bool GreasePencilColorModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilColorModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilColorModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilColorModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

float GreasePencilColorModifier_value_get(PointerRNA *ptr);
void GreasePencilColorModifier_value_set(PointerRNA *ptr, float value);

bool GreasePencilColorModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilColorModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Grease Pencil Dash Modifier ****************/

extern StructRNA RNA_GreasePencilDashModifierData;
extern StructRNA RNA_Modifier;

int GreasePencilDashModifierData_segment_active_index_get(PointerRNA *ptr);
void GreasePencilDashModifierData_segment_active_index_set(PointerRNA *ptr, int value);

bool GreasePencilDashModifierData_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilDashModifierData_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilDashModifierData_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilDashModifierData_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilDashModifierData_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilDashModifierData_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilDashModifierData_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilDashModifierData_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilDashModifierData_tree_node_filter_MAX 64

void GreasePencilDashModifierData_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilDashModifierData_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilDashModifierData_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilDashModifierData_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilDashModifierData_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilDashModifierData_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilDashModifierData_layer_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilDashModifierData_material_filter_get(PointerRNA *ptr);

int GreasePencilDashModifierData_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilDashModifierData_material_pass_filter_set(PointerRNA *ptr, int value);

int GreasePencilDashModifierData_dash_offset_get(PointerRNA *ptr);
void GreasePencilDashModifierData_dash_offset_set(PointerRNA *ptr, int value);

void GreasePencilDashModifierData_segments_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GreasePencilDashModifierData_segments_next(CollectionPropertyIterator *iter);
void GreasePencilDashModifierData_segments_end(CollectionPropertyIterator *iter);
bool GreasePencilDashModifierData_segments_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GreasePencilDashModifierData_segments_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool GreasePencilDashModifierData_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilDashModifierData_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilDashModifierData_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilDashModifierData_use_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilDashModifierData_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilDashModifierData_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Dash Modifier Segment ****************/

extern StructRNA RNA_GreasePencilDashModifierSegment;

PointerRNA GreasePencilDashModifierSegment_rna_type_get(PointerRNA *ptr);

#define GreasePencilDashModifierSegment_name_MAX 64

void GreasePencilDashModifierSegment_name_get(PointerRNA *ptr, char *value);
int GreasePencilDashModifierSegment_name_length(PointerRNA *ptr);
void GreasePencilDashModifierSegment_name_set(PointerRNA *ptr, const char *value);

bool GreasePencilDashModifierSegment_use_cyclic_get(PointerRNA *ptr);
void GreasePencilDashModifierSegment_use_cyclic_set(PointerRNA *ptr, bool value);

int GreasePencilDashModifierSegment_dash_get(PointerRNA *ptr);
void GreasePencilDashModifierSegment_dash_set(PointerRNA *ptr, int value);

int GreasePencilDashModifierSegment_gap_get(PointerRNA *ptr);
void GreasePencilDashModifierSegment_gap_set(PointerRNA *ptr, int value);

int GreasePencilDashModifierSegment_material_index_get(PointerRNA *ptr);
void GreasePencilDashModifierSegment_material_index_set(PointerRNA *ptr, int value);

float GreasePencilDashModifierSegment_opacity_get(PointerRNA *ptr);
void GreasePencilDashModifierSegment_opacity_set(PointerRNA *ptr, float value);

float GreasePencilDashModifierSegment_radius_get(PointerRNA *ptr);
void GreasePencilDashModifierSegment_radius_set(PointerRNA *ptr, float value);

/**************** Grease Pencil Drawing ****************/

extern StructRNA RNA_GreasePencilDrawing;

PointerRNA GreasePencilDrawing_rna_type_get(PointerRNA *ptr);

void GreasePencilDrawing_attributes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GreasePencilDrawing_attributes_next(CollectionPropertyIterator *iter);
void GreasePencilDrawing_attributes_end(CollectionPropertyIterator *iter);
int GreasePencilDrawing_attributes_length(PointerRNA *ptr);
bool GreasePencilDrawing_attributes_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void GreasePencilDrawing_color_attributes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GreasePencilDrawing_color_attributes_next(CollectionPropertyIterator *iter);
void GreasePencilDrawing_color_attributes_end(CollectionPropertyIterator *iter);
int GreasePencilDrawing_color_attributes_length(PointerRNA *ptr);

void GreasePencilDrawing_curve_offsets_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GreasePencilDrawing_curve_offsets_next(CollectionPropertyIterator *iter);
void GreasePencilDrawing_curve_offsets_end(CollectionPropertyIterator *iter);
int GreasePencilDrawing_curve_offsets_length(PointerRNA *ptr);
bool GreasePencilDrawing_curve_offsets_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

enum {
	GreasePencilDrawing_type_DRAWING = 0,
	GreasePencilDrawing_type_REFERENCE = 1,
};

int GreasePencilDrawing_type_get(PointerRNA *ptr);
void GreasePencilDrawing_type_set(PointerRNA *ptr, int value);

int GreasePencilDrawing_user_count_get(PointerRNA *ptr);
void GreasePencilDrawing_user_count_set(PointerRNA *ptr, int value);

void GreasePencilDrawing_add_strokes_func(struct ID *_selfid, struct GreasePencilDrawing *_self, ReportList *reports, int sizes_num, int *sizes);
void GreasePencilDrawing_remove_strokes_func(struct ID *_selfid, struct GreasePencilDrawing *_self, ReportList *reports, int indices_num, int *indices);
void GreasePencilDrawing_resize_strokes_func(struct ID *_selfid, struct GreasePencilDrawing *_self, ReportList *reports, int sizes_num, int *sizes, int indices_num, int *indices);
void GreasePencilDrawing_reorder_strokes_func(struct ID *_selfid, struct GreasePencilDrawing *_self, ReportList *reports, int new_indices_num, int *new_indices);
void GreasePencilDrawing_set_types_func(struct ID *_selfid, struct GreasePencilDrawing *_self, ReportList *reports, int type, int indices_num, int *indices);
void GreasePencilDrawing_tag_positions_changed_func(struct GreasePencilDrawing *_self);
void GreasePencilDrawing_vertex_group_assign_func(struct ID *_selfid, struct GreasePencilDrawing *_self, ReportList *reports, const char * vgroup_name, int indices_ptr_num, int *indices_ptr, float weight);
void GreasePencilDrawing_vertex_group_remove_func(struct ID *_selfid, struct GreasePencilDrawing *_self, ReportList *reports, const char * vgroup_name, int indices_ptr_num, int *indices_ptr);
void GreasePencilDrawing_set_vertex_weights_func(struct ID *_selfid, struct GreasePencilDrawing *_self, ReportList *reports, const char * vertex_group_name, int indices_num, int *indices, int weights_num, float *weights, int assign_mode);
/**************** Grease Pencil Envelope Modifier ****************/

extern StructRNA RNA_GreasePencilEnvelopeModifier;
extern StructRNA RNA_Modifier;

bool GreasePencilEnvelopeModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilEnvelopeModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilEnvelopeModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilEnvelopeModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilEnvelopeModifier_invert_vertex_group_get(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

#define GreasePencilEnvelopeModifier_tree_node_filter_MAX 64

void GreasePencilEnvelopeModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilEnvelopeModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilEnvelopeModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilEnvelopeModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilEnvelopeModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilEnvelopeModifier_mat_nr_get(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_mat_nr_set(PointerRNA *ptr, int value);

int GreasePencilEnvelopeModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_material_pass_filter_set(PointerRNA *ptr, int value);

enum {
	GreasePencilEnvelopeModifier_mode_DEFORM = 0,
	GreasePencilEnvelopeModifier_mode_SEGMENTS = 1,
	GreasePencilEnvelopeModifier_mode_FILLS = 2,
};

int GreasePencilEnvelopeModifier_mode_get(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_mode_set(PointerRNA *ptr, int value);

int GreasePencilEnvelopeModifier_skip_get(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_skip_set(PointerRNA *ptr, int value);

int GreasePencilEnvelopeModifier_spread_get(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_spread_set(PointerRNA *ptr, int value);

float GreasePencilEnvelopeModifier_strength_get(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_strength_set(PointerRNA *ptr, float value);

float GreasePencilEnvelopeModifier_thickness_get(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_thickness_set(PointerRNA *ptr, float value);

bool GreasePencilEnvelopeModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilEnvelopeModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilEnvelopeModifier_vertex_group_name_MAX 64

void GreasePencilEnvelopeModifier_vertex_group_name_get(PointerRNA *ptr, char *value);
int GreasePencilEnvelopeModifier_vertex_group_name_length(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_vertex_group_name_set(PointerRNA *ptr, const char *value);

bool GreasePencilEnvelopeModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilEnvelopeModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Grease Pencil Frame ****************/

extern StructRNA RNA_GreasePencilFrame;

PointerRNA GreasePencilFrame_rna_type_get(PointerRNA *ptr);

PointerRNA GreasePencilFrame_drawing_get(PointerRNA *ptr);

int GreasePencilFrame_frame_number_get(PointerRNA *ptr);
void GreasePencilFrame_frame_number_set(PointerRNA *ptr, int value);

enum {
	GreasePencilFrame_keyframe_type_KEYFRAME = 0,
	GreasePencilFrame_keyframe_type_BREAKDOWN = 2,
	GreasePencilFrame_keyframe_type_MOVING_HOLD = 4,
	GreasePencilFrame_keyframe_type_EXTREME = 1,
	GreasePencilFrame_keyframe_type_JITTER = 3,
	GreasePencilFrame_keyframe_type_GENERATED = 5,
};

int GreasePencilFrame_keyframe_type_get(PointerRNA *ptr);
void GreasePencilFrame_keyframe_type_set(PointerRNA *ptr, int value);

bool GreasePencilFrame_select_get(PointerRNA *ptr);
void GreasePencilFrame_select_set(PointerRNA *ptr, bool value);

/**************** Grease Pencil Frames ****************/

extern StructRNA RNA_GreasePencilFrames;

PointerRNA GreasePencilFrames_rna_type_get(PointerRNA *ptr);

struct GreasePencilFrame *GreasePencilFrames_new_func(struct ID *_selfid, struct GreasePencilLayer *_self, ReportList *reports, int frame_number);
void GreasePencilFrames_remove_func(struct ID *_selfid, struct GreasePencilLayer *_self, ReportList *reports, int frame_number);
struct GreasePencilFrame *GreasePencilFrames_copy_func(struct ID *_selfid, struct GreasePencilLayer *_self, ReportList *reports, int from_frame_number, int to_frame_number, bool instance_drawing);
struct GreasePencilFrame *GreasePencilFrames_move_func(struct ID *_selfid, struct GreasePencilLayer *_self, ReportList *reports, int from_frame_number, int to_frame_number);
/**************** Hook Modifier ****************/

extern StructRNA RNA_GreasePencilHookModifier;
extern StructRNA RNA_Modifier;

PointerRNA GreasePencilHookModifier_custom_curve_get(PointerRNA *ptr);

enum {
	GreasePencilHookModifier_falloff_type_NONE = 0,
	GreasePencilHookModifier_falloff_type_CURVE = 1,
	GreasePencilHookModifier_falloff_type_SMOOTH = 3,
	GreasePencilHookModifier_falloff_type_SPHERE = 7,
	GreasePencilHookModifier_falloff_type_ROOT = 4,
	GreasePencilHookModifier_falloff_type_INVERSE_SQUARE = 8,
	GreasePencilHookModifier_falloff_type_SHARP = 2,
	GreasePencilHookModifier_falloff_type_LINEAR = 5,
	GreasePencilHookModifier_falloff_type_CONSTANT = 6,
};

int GreasePencilHookModifier_falloff_type_get(PointerRNA *ptr);
void GreasePencilHookModifier_falloff_type_set(PointerRNA *ptr, int value);

void GreasePencilHookModifier_center_get(PointerRNA *ptr, float values[3]);
void GreasePencilHookModifier_center_set(PointerRNA *ptr, const float values[3]);

bool GreasePencilHookModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilHookModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilHookModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilHookModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilHookModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilHookModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilHookModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilHookModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilHookModifier_invert_vertex_group_get(PointerRNA *ptr);
void GreasePencilHookModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

#define GreasePencilHookModifier_tree_node_filter_MAX 64

void GreasePencilHookModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilHookModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilHookModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilHookModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilHookModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilHookModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilHookModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilHookModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilHookModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilHookModifier_material_pass_filter_set(PointerRNA *ptr, int value);

void GreasePencilHookModifier_matrix_inverse_get(PointerRNA *ptr, float values[16]);
void GreasePencilHookModifier_matrix_inverse_set(PointerRNA *ptr, const float values[16]);

PointerRNA GreasePencilHookModifier_object_get(PointerRNA *ptr);

float GreasePencilHookModifier_falloff_radius_get(PointerRNA *ptr);
void GreasePencilHookModifier_falloff_radius_set(PointerRNA *ptr, float value);

float GreasePencilHookModifier_strength_get(PointerRNA *ptr);
void GreasePencilHookModifier_strength_set(PointerRNA *ptr, float value);

#define GreasePencilHookModifier_subtarget_MAX 64

void GreasePencilHookModifier_subtarget_get(PointerRNA *ptr, char *value);
int GreasePencilHookModifier_subtarget_length(PointerRNA *ptr);
void GreasePencilHookModifier_subtarget_set(PointerRNA *ptr, const char *value);

bool GreasePencilHookModifier_use_falloff_uniform_get(PointerRNA *ptr);
void GreasePencilHookModifier_use_falloff_uniform_set(PointerRNA *ptr, bool value);

bool GreasePencilHookModifier_use_custom_curve_get(PointerRNA *ptr);
void GreasePencilHookModifier_use_custom_curve_set(PointerRNA *ptr, bool value);

bool GreasePencilHookModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilHookModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilHookModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilHookModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilHookModifier_vertex_group_name_MAX 64

void GreasePencilHookModifier_vertex_group_name_get(PointerRNA *ptr, char *value);
int GreasePencilHookModifier_vertex_group_name_length(PointerRNA *ptr);
void GreasePencilHookModifier_vertex_group_name_set(PointerRNA *ptr, const char *value);

bool GreasePencilHookModifier_open_falloff_panel_get(PointerRNA *ptr);
void GreasePencilHookModifier_open_falloff_panel_set(PointerRNA *ptr, bool value);

bool GreasePencilHookModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilHookModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Grease Pencil Lattice Modifier ****************/

extern StructRNA RNA_GreasePencilLatticeModifier;
extern StructRNA RNA_Modifier;

bool GreasePencilLatticeModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilLatticeModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilLatticeModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilLatticeModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilLatticeModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilLatticeModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilLatticeModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilLatticeModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilLatticeModifier_invert_vertex_group_get(PointerRNA *ptr);
void GreasePencilLatticeModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

#define GreasePencilLatticeModifier_tree_node_filter_MAX 64

void GreasePencilLatticeModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilLatticeModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilLatticeModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilLatticeModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilLatticeModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilLatticeModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilLatticeModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilLatticeModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilLatticeModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilLatticeModifier_material_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilLatticeModifier_object_get(PointerRNA *ptr);

float GreasePencilLatticeModifier_strength_get(PointerRNA *ptr);
void GreasePencilLatticeModifier_strength_set(PointerRNA *ptr, float value);

bool GreasePencilLatticeModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilLatticeModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilLatticeModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilLatticeModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilLatticeModifier_vertex_group_name_MAX 64

void GreasePencilLatticeModifier_vertex_group_name_get(PointerRNA *ptr, char *value);
int GreasePencilLatticeModifier_vertex_group_name_length(PointerRNA *ptr);
void GreasePencilLatticeModifier_vertex_group_name_set(PointerRNA *ptr, const char *value);

bool GreasePencilLatticeModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilLatticeModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Grease Pencil Layer ****************/

extern StructRNA RNA_GreasePencilLayer;
extern StructRNA RNA_GreasePencilTreeNode;

enum {
	GreasePencilLayer_blend_mode_REGULAR = 0,
	GreasePencilLayer_blend_mode_HARDLIGHT = 1,
	GreasePencilLayer_blend_mode_ADD = 2,
	GreasePencilLayer_blend_mode_SUBTRACT = 3,
	GreasePencilLayer_blend_mode_MULTIPLY = 4,
	GreasePencilLayer_blend_mode_DIVIDE = 5,
};

int GreasePencilLayer_blend_mode_get(PointerRNA *ptr);
void GreasePencilLayer_blend_mode_set(PointerRNA *ptr, int value);

bool GreasePencilLayer_lock_frame_get(PointerRNA *ptr);
void GreasePencilLayer_lock_frame_set(PointerRNA *ptr, bool value);

void GreasePencilLayer_frames_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GreasePencilLayer_frames_next(CollectionPropertyIterator *iter);
void GreasePencilLayer_frames_end(CollectionPropertyIterator *iter);
int GreasePencilLayer_frames_length(PointerRNA *ptr);
bool GreasePencilLayer_frames_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool GreasePencilLayer_ignore_locked_materials_get(PointerRNA *ptr);
void GreasePencilLayer_ignore_locked_materials_set(PointerRNA *ptr, bool value);

void GreasePencilLayer_matrix_parent_inverse_get(PointerRNA *ptr, float values[16]);
void GreasePencilLayer_matrix_parent_inverse_set(PointerRNA *ptr, const float values[16]);

void GreasePencilLayer_matrix_local_get(PointerRNA *ptr, float values[16]);
void GreasePencilLayer_matrix_local_set(PointerRNA *ptr, const float values[16]);

void GreasePencilLayer_mask_layers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GreasePencilLayer_mask_layers_next(CollectionPropertyIterator *iter);
void GreasePencilLayer_mask_layers_end(CollectionPropertyIterator *iter);
bool GreasePencilLayer_mask_layers_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GreasePencilLayer_mask_layers_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

float GreasePencilLayer_opacity_get(PointerRNA *ptr);
void GreasePencilLayer_opacity_set(PointerRNA *ptr, float value);

PointerRNA GreasePencilLayer_parent_get(PointerRNA *ptr);

void GreasePencilLayer_parent_bone_get(PointerRNA *ptr, char *value);
int GreasePencilLayer_parent_bone_length(PointerRNA *ptr);
void GreasePencilLayer_parent_bone_set(PointerRNA *ptr, const char *value);

int GreasePencilLayer_pass_index_get(PointerRNA *ptr);
void GreasePencilLayer_pass_index_set(PointerRNA *ptr, int value);

float GreasePencilLayer_radius_offset_get(PointerRNA *ptr);
void GreasePencilLayer_radius_offset_set(PointerRNA *ptr, float value);

void GreasePencilLayer_rotation_get(PointerRNA *ptr, float values[3]);
void GreasePencilLayer_rotation_set(PointerRNA *ptr, const float values[3]);

void GreasePencilLayer_scale_get(PointerRNA *ptr, float values[3]);
void GreasePencilLayer_scale_set(PointerRNA *ptr, const float values[3]);

void GreasePencilLayer_tint_color_get(PointerRNA *ptr, float values[3]);
void GreasePencilLayer_tint_color_set(PointerRNA *ptr, const float values[3]);

float GreasePencilLayer_tint_factor_get(PointerRNA *ptr);
void GreasePencilLayer_tint_factor_set(PointerRNA *ptr, float value);

void GreasePencilLayer_translation_get(PointerRNA *ptr, float values[3]);
void GreasePencilLayer_translation_set(PointerRNA *ptr, const float values[3]);

bool GreasePencilLayer_use_lights_get(PointerRNA *ptr);
void GreasePencilLayer_use_lights_set(PointerRNA *ptr, bool value);

bool GreasePencilLayer_use_viewlayer_masks_get(PointerRNA *ptr);
void GreasePencilLayer_use_viewlayer_masks_set(PointerRNA *ptr, bool value);

void GreasePencilLayer_viewlayer_render_get(PointerRNA *ptr, char *value);
int GreasePencilLayer_viewlayer_render_length(PointerRNA *ptr);
void GreasePencilLayer_viewlayer_render_set(PointerRNA *ptr, const char *value);

struct GreasePencilFrame *GreasePencilLayer_get_frame_at_func(struct GreasePencilLayer *_self, int frame_number);
struct GreasePencilFrame *GreasePencilLayer_current_frame_func(struct GreasePencilLayer *_self, bContext *C);
/**************** Grease Pencil Layer Group ****************/

extern StructRNA RNA_GreasePencilLayerGroup;
extern StructRNA RNA_GreasePencilTreeNode;

bool GreasePencilLayerGroup_is_expanded_get(PointerRNA *ptr);
void GreasePencilLayerGroup_is_expanded_set(PointerRNA *ptr, bool value);

enum {
	GreasePencilLayerGroup_color_tag_NONE = -1,
	GreasePencilLayerGroup_color_tag_COLOR1 = 0,
	GreasePencilLayerGroup_color_tag_COLOR2 = 1,
	GreasePencilLayerGroup_color_tag_COLOR3 = 2,
	GreasePencilLayerGroup_color_tag_COLOR4 = 3,
	GreasePencilLayerGroup_color_tag_COLOR5 = 4,
	GreasePencilLayerGroup_color_tag_COLOR6 = 5,
	GreasePencilLayerGroup_color_tag_COLOR7 = 6,
	GreasePencilLayerGroup_color_tag_COLOR8 = 7,
};

int GreasePencilLayerGroup_color_tag_get(PointerRNA *ptr);
void GreasePencilLayerGroup_color_tag_set(PointerRNA *ptr, int value);

/**************** Grease Pencil Masking Layers ****************/

extern StructRNA RNA_GreasePencilLayerMask;

PointerRNA GreasePencilLayerMask_rna_type_get(PointerRNA *ptr);

void GreasePencilLayerMask_name_get(PointerRNA *ptr, char *value);
int GreasePencilLayerMask_name_length(PointerRNA *ptr);
void GreasePencilLayerMask_name_set(PointerRNA *ptr, const char *value);

bool GreasePencilLayerMask_hide_get(PointerRNA *ptr);
void GreasePencilLayerMask_hide_set(PointerRNA *ptr, bool value);

bool GreasePencilLayerMask_invert_get(PointerRNA *ptr);
void GreasePencilLayerMask_invert_set(PointerRNA *ptr, bool value);

/**************** Grease Pencil Mask Layers ****************/

extern StructRNA RNA_GreasePencilLayerMasks;

PointerRNA GreasePencilLayerMasks_rna_type_get(PointerRNA *ptr);

int GreasePencilLayerMasks_active_mask_index_get(PointerRNA *ptr);
void GreasePencilLayerMasks_active_mask_index_set(PointerRNA *ptr, int value);

/**************** Annotation Layers ****************/

extern StructRNA RNA_GreasePencilLayers;

PointerRNA GreasePencilLayers_rna_type_get(PointerRNA *ptr);

int GreasePencilLayers_active_index_get(PointerRNA *ptr);
void GreasePencilLayers_active_index_set(PointerRNA *ptr, int value);

enum {
	GreasePencilLayers_active_note_DEFAULT = 0,
};

int GreasePencilLayers_active_note_get(PointerRNA *ptr);
void GreasePencilLayers_active_note_set(PointerRNA *ptr, int value);

struct bGPDlayer *GreasePencilLayers_new_func(struct bGPdata *_self, const char * name, bool set_active);
void GreasePencilLayers_remove_func(struct bGPdata *_self, ReportList *reports, struct PointerRNA *layer);
/**************** Length Modifier ****************/

extern StructRNA RNA_GreasePencilLengthModifier;
extern StructRNA RNA_Modifier;

float GreasePencilLengthModifier_end_factor_get(PointerRNA *ptr);
void GreasePencilLengthModifier_end_factor_set(PointerRNA *ptr, float value);

float GreasePencilLengthModifier_end_length_get(PointerRNA *ptr);
void GreasePencilLengthModifier_end_length_set(PointerRNA *ptr, float value);

float GreasePencilLengthModifier_max_angle_get(PointerRNA *ptr);
void GreasePencilLengthModifier_max_angle_set(PointerRNA *ptr, float value);

bool GreasePencilLengthModifier_invert_curvature_get(PointerRNA *ptr);
void GreasePencilLengthModifier_invert_curvature_set(PointerRNA *ptr, bool value);

bool GreasePencilLengthModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilLengthModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilLengthModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilLengthModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilLengthModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilLengthModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilLengthModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilLengthModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilLengthModifier_tree_node_filter_MAX 64

void GreasePencilLengthModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilLengthModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilLengthModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilLengthModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilLengthModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilLengthModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilLengthModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilLengthModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilLengthModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilLengthModifier_material_pass_filter_set(PointerRNA *ptr, int value);

enum {
	GreasePencilLengthModifier_mode_RELATIVE = 0,
	GreasePencilLengthModifier_mode_ABSOLUTE = 1,
};

int GreasePencilLengthModifier_mode_get(PointerRNA *ptr);
void GreasePencilLengthModifier_mode_set(PointerRNA *ptr, int value);

float GreasePencilLengthModifier_point_density_get(PointerRNA *ptr);
void GreasePencilLengthModifier_point_density_set(PointerRNA *ptr, float value);

bool GreasePencilLengthModifier_use_random_get(PointerRNA *ptr);
void GreasePencilLengthModifier_use_random_set(PointerRNA *ptr, bool value);

float GreasePencilLengthModifier_random_end_factor_get(PointerRNA *ptr);
void GreasePencilLengthModifier_random_end_factor_set(PointerRNA *ptr, float value);

float GreasePencilLengthModifier_random_offset_get(PointerRNA *ptr);
void GreasePencilLengthModifier_random_offset_set(PointerRNA *ptr, float value);

float GreasePencilLengthModifier_random_start_factor_get(PointerRNA *ptr);
void GreasePencilLengthModifier_random_start_factor_set(PointerRNA *ptr, float value);

int GreasePencilLengthModifier_seed_get(PointerRNA *ptr);
void GreasePencilLengthModifier_seed_set(PointerRNA *ptr, int value);

float GreasePencilLengthModifier_segment_influence_get(PointerRNA *ptr);
void GreasePencilLengthModifier_segment_influence_set(PointerRNA *ptr, float value);

float GreasePencilLengthModifier_start_factor_get(PointerRNA *ptr);
void GreasePencilLengthModifier_start_factor_set(PointerRNA *ptr, float value);

float GreasePencilLengthModifier_start_length_get(PointerRNA *ptr);
void GreasePencilLengthModifier_start_length_set(PointerRNA *ptr, float value);

int GreasePencilLengthModifier_step_get(PointerRNA *ptr);
void GreasePencilLengthModifier_step_set(PointerRNA *ptr, int value);

bool GreasePencilLengthModifier_use_curvature_get(PointerRNA *ptr);
void GreasePencilLengthModifier_use_curvature_set(PointerRNA *ptr, bool value);

bool GreasePencilLengthModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilLengthModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilLengthModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilLengthModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

float GreasePencilLengthModifier_overshoot_factor_get(PointerRNA *ptr);
void GreasePencilLengthModifier_overshoot_factor_set(PointerRNA *ptr, float value);

bool GreasePencilLengthModifier_open_curvature_panel_get(PointerRNA *ptr);
void GreasePencilLengthModifier_open_curvature_panel_set(PointerRNA *ptr, bool value);

bool GreasePencilLengthModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilLengthModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

bool GreasePencilLengthModifier_open_random_panel_get(PointerRNA *ptr);
void GreasePencilLengthModifier_open_random_panel_set(PointerRNA *ptr, bool value);

/**************** Line Art Modifier ****************/

extern StructRNA RNA_GreasePencilLineartModifier;
extern StructRNA RNA_Modifier;

bool GreasePencilLineartModifier_use_fuzzy_all_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_fuzzy_all_set(PointerRNA *ptr, bool value);

float GreasePencilLineartModifier_split_angle_get(PointerRNA *ptr);
void GreasePencilLineartModifier_split_angle_set(PointerRNA *ptr, float value);

bool GreasePencilLineartModifier_use_back_face_culling_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_back_face_culling_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_face_mark_boundaries_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_face_mark_boundaries_set(PointerRNA *ptr, bool value);

PointerRNA GreasePencilLineartModifier_source_camera_get(PointerRNA *ptr);

bool GreasePencilLineartModifier_use_loose_edge_chain_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_loose_edge_chain_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_clip_plane_boundaries_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_clip_plane_boundaries_set(PointerRNA *ptr, bool value);

PointerRNA GreasePencilLineartModifier_source_collection_get(PointerRNA *ptr);

bool GreasePencilLineartModifier_use_crease_on_sharp_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_crease_on_sharp_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_crease_on_smooth_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_crease_on_smooth_set(PointerRNA *ptr, bool value);

float GreasePencilLineartModifier_crease_threshold_get(PointerRNA *ptr);
void GreasePencilLineartModifier_crease_threshold_set(PointerRNA *ptr, float value);

bool GreasePencilLineartModifier_use_face_mark_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_face_mark_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_edge_overlap_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_edge_overlap_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_image_boundary_trimming_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_image_boundary_trimming_set(PointerRNA *ptr, bool value);

float GreasePencilLineartModifier_chaining_image_threshold_get(PointerRNA *ptr);
void GreasePencilLineartModifier_chaining_image_threshold_set(PointerRNA *ptr, float value);

bool GreasePencilLineartModifier_use_object_instances_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_object_instances_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_fuzzy_intersections_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_fuzzy_intersections_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_face_mark_invert_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_face_mark_invert_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_invert_collection_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_invert_collection_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_invert_silhouette_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_invert_silhouette_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_invert_source_vertex_group_get(PointerRNA *ptr);
void GreasePencilLineartModifier_invert_source_vertex_group_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_is_baked_get(PointerRNA *ptr);
void GreasePencilLineartModifier_is_baked_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_face_mark_keep_contour_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_face_mark_keep_contour_set(PointerRNA *ptr, bool value);

#define GreasePencilLineartModifier_target_layer_MAX 64

void GreasePencilLineartModifier_target_layer_get(PointerRNA *ptr, char *value);
int GreasePencilLineartModifier_target_layer_length(PointerRNA *ptr);
void GreasePencilLineartModifier_target_layer_set(PointerRNA *ptr, const char *value);

int GreasePencilLineartModifier_level_end_get(PointerRNA *ptr);
void GreasePencilLineartModifier_level_end_set(PointerRNA *ptr, int value);

int GreasePencilLineartModifier_level_start_get(PointerRNA *ptr);
void GreasePencilLineartModifier_level_start_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilLineartModifier_light_contour_object_get(PointerRNA *ptr);

bool GreasePencilLineartModifier_use_loose_as_contour_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_loose_as_contour_set(PointerRNA *ptr, bool value);

void GreasePencilLineartModifier_use_material_mask_bits_get(PointerRNA *ptr, bool values[8]);
void GreasePencilLineartModifier_use_material_mask_bits_set(PointerRNA *ptr, const bool values[8]);

void GreasePencilLineartModifier_use_intersection_mask_get(PointerRNA *ptr, bool values[8]);
void GreasePencilLineartModifier_use_intersection_mask_set(PointerRNA *ptr, const bool values[8]);

bool GreasePencilLineartModifier_use_intersection_match_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_intersection_match_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_material_mask_match_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_material_mask_match_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_output_vertex_group_match_by_name_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_output_vertex_group_match_by_name_set(PointerRNA *ptr, bool value);

PointerRNA GreasePencilLineartModifier_target_material_get(PointerRNA *ptr);

PointerRNA GreasePencilLineartModifier_source_object_get(PointerRNA *ptr);

bool GreasePencilLineartModifier_use_offset_towards_custom_camera_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_offset_towards_custom_camera_set(PointerRNA *ptr, bool value);

float GreasePencilLineartModifier_opacity_get(PointerRNA *ptr);
void GreasePencilLineartModifier_opacity_set(PointerRNA *ptr, float value);

bool GreasePencilLineartModifier_use_overlap_edge_type_support_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_overlap_edge_type_support_set(PointerRNA *ptr, bool value);

float GreasePencilLineartModifier_overscan_get(PointerRNA *ptr);
void GreasePencilLineartModifier_overscan_set(PointerRNA *ptr, float value);

bool GreasePencilLineartModifier_use_detail_preserve_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_detail_preserve_set(PointerRNA *ptr, bool value);

float GreasePencilLineartModifier_shadow_camera_far_get(PointerRNA *ptr);
void GreasePencilLineartModifier_shadow_camera_far_set(PointerRNA *ptr, float value);

float GreasePencilLineartModifier_shadow_camera_near_get(PointerRNA *ptr);
void GreasePencilLineartModifier_shadow_camera_near_set(PointerRNA *ptr, float value);

float GreasePencilLineartModifier_shadow_camera_size_get(PointerRNA *ptr);
void GreasePencilLineartModifier_shadow_camera_size_set(PointerRNA *ptr, float value);

enum {
	GreasePencilLineartModifier_shadow_region_filtering_NONE = 0,
	GreasePencilLineartModifier_shadow_region_filtering_ILLUMINATED = 1,
	GreasePencilLineartModifier_shadow_region_filtering_SHADED = 2,
	GreasePencilLineartModifier_shadow_region_filtering_ILLUMINATED_ENCLOSED = 3,
};

int GreasePencilLineartModifier_shadow_region_filtering_get(PointerRNA *ptr);
void GreasePencilLineartModifier_shadow_region_filtering_set(PointerRNA *ptr, int value);

enum {
	GreasePencilLineartModifier_silhouette_filtering_NONE = 0,
	GreasePencilLineartModifier_silhouette_filtering_GROUP = 1,
	GreasePencilLineartModifier_silhouette_filtering_INDIVIDUAL = 2,
};

int GreasePencilLineartModifier_silhouette_filtering_get(PointerRNA *ptr);
void GreasePencilLineartModifier_silhouette_filtering_set(PointerRNA *ptr, int value);

float GreasePencilLineartModifier_smooth_tolerance_get(PointerRNA *ptr);
void GreasePencilLineartModifier_smooth_tolerance_set(PointerRNA *ptr, float value);

enum {
	GreasePencilLineartModifier_source_type_COLLECTION = 0,
	GreasePencilLineartModifier_source_type_OBJECT = 1,
	GreasePencilLineartModifier_source_type_SCENE = 2,
};

int GreasePencilLineartModifier_source_type_get(PointerRNA *ptr);
void GreasePencilLineartModifier_source_type_set(PointerRNA *ptr, int value);

#define GreasePencilLineartModifier_source_vertex_group_MAX 64

void GreasePencilLineartModifier_source_vertex_group_get(PointerRNA *ptr, char *value);
int GreasePencilLineartModifier_source_vertex_group_length(PointerRNA *ptr);
void GreasePencilLineartModifier_source_vertex_group_set(PointerRNA *ptr, const char *value);

float GreasePencilLineartModifier_stroke_depth_offset_get(PointerRNA *ptr);
void GreasePencilLineartModifier_stroke_depth_offset_set(PointerRNA *ptr, float value);

int GreasePencilLineartModifier_thickness_get(PointerRNA *ptr);
void GreasePencilLineartModifier_thickness_set(PointerRNA *ptr, int value);

bool GreasePencilLineartModifier_use_cache_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_cache_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_contour_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_contour_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_crease_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_crease_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_custom_camera_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_custom_camera_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_edge_mark_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_edge_mark_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_geometry_space_chain_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_geometry_space_chain_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_intersection_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_intersection_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_light_contour_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_light_contour_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_loose_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_loose_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_material_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_material_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_material_mask_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_material_mask_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_multiple_levels_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_multiple_levels_set(PointerRNA *ptr, bool value);

bool GreasePencilLineartModifier_use_shadow_get(PointerRNA *ptr);
void GreasePencilLineartModifier_use_shadow_set(PointerRNA *ptr, bool value);

#define GreasePencilLineartModifier_vertex_group_MAX 64

void GreasePencilLineartModifier_vertex_group_get(PointerRNA *ptr, char *value);
int GreasePencilLineartModifier_vertex_group_length(PointerRNA *ptr);
void GreasePencilLineartModifier_vertex_group_set(PointerRNA *ptr, const char *value);

/**************** Grease Pencil Mirror Modifier ****************/

extern StructRNA RNA_GreasePencilMirrorModifier;
extern StructRNA RNA_Modifier;

bool GreasePencilMirrorModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilMirrorModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilMirrorModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilMirrorModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilMirrorModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilMirrorModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilMirrorModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilMirrorModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilMirrorModifier_tree_node_filter_MAX 64

void GreasePencilMirrorModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilMirrorModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilMirrorModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilMirrorModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilMirrorModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilMirrorModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilMirrorModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilMirrorModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilMirrorModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilMirrorModifier_material_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilMirrorModifier_object_get(PointerRNA *ptr);

bool GreasePencilMirrorModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilMirrorModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilMirrorModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilMirrorModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilMirrorModifier_use_axis_x_get(PointerRNA *ptr);
void GreasePencilMirrorModifier_use_axis_x_set(PointerRNA *ptr, bool value);

bool GreasePencilMirrorModifier_use_axis_y_get(PointerRNA *ptr);
void GreasePencilMirrorModifier_use_axis_y_set(PointerRNA *ptr, bool value);

bool GreasePencilMirrorModifier_use_axis_z_get(PointerRNA *ptr);
void GreasePencilMirrorModifier_use_axis_z_set(PointerRNA *ptr, bool value);

bool GreasePencilMirrorModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilMirrorModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Multiply Modifier ****************/

extern StructRNA RNA_GreasePencilMultiplyModifier;
extern StructRNA RNA_Modifier;

float GreasePencilMultiplyModifier_fading_center_get(PointerRNA *ptr);
void GreasePencilMultiplyModifier_fading_center_set(PointerRNA *ptr, float value);

float GreasePencilMultiplyModifier_distance_get(PointerRNA *ptr);
void GreasePencilMultiplyModifier_distance_set(PointerRNA *ptr, float value);

int GreasePencilMultiplyModifier_duplicates_get(PointerRNA *ptr);
void GreasePencilMultiplyModifier_duplicates_set(PointerRNA *ptr, int value);

bool GreasePencilMultiplyModifier_use_fade_get(PointerRNA *ptr);
void GreasePencilMultiplyModifier_use_fade_set(PointerRNA *ptr, bool value);

bool GreasePencilMultiplyModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilMultiplyModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilMultiplyModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilMultiplyModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilMultiplyModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilMultiplyModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilMultiplyModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilMultiplyModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilMultiplyModifier_tree_node_filter_MAX 64

void GreasePencilMultiplyModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilMultiplyModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilMultiplyModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilMultiplyModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilMultiplyModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilMultiplyModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilMultiplyModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilMultiplyModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilMultiplyModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilMultiplyModifier_material_pass_filter_set(PointerRNA *ptr, int value);

float GreasePencilMultiplyModifier_offset_get(PointerRNA *ptr);
void GreasePencilMultiplyModifier_offset_set(PointerRNA *ptr, float value);

float GreasePencilMultiplyModifier_fading_opacity_get(PointerRNA *ptr);
void GreasePencilMultiplyModifier_fading_opacity_set(PointerRNA *ptr, float value);

float GreasePencilMultiplyModifier_fading_thickness_get(PointerRNA *ptr);
void GreasePencilMultiplyModifier_fading_thickness_set(PointerRNA *ptr, float value);

bool GreasePencilMultiplyModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilMultiplyModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilMultiplyModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilMultiplyModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilMultiplyModifier_open_fading_panel_get(PointerRNA *ptr);
void GreasePencilMultiplyModifier_open_fading_panel_set(PointerRNA *ptr, bool value);

bool GreasePencilMultiplyModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilMultiplyModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Grease Pencil Noise Modifier ****************/

extern StructRNA RNA_GreasePencilNoiseModifier;
extern StructRNA RNA_Modifier;

PointerRNA GreasePencilNoiseModifier_custom_curve_get(PointerRNA *ptr);

bool GreasePencilNoiseModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilNoiseModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilNoiseModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilNoiseModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilNoiseModifier_invert_vertex_group_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

#define GreasePencilNoiseModifier_tree_node_filter_MAX 64

void GreasePencilNoiseModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilNoiseModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilNoiseModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilNoiseModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilNoiseModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilNoiseModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilNoiseModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_material_pass_filter_set(PointerRNA *ptr, int value);

enum {
	GreasePencilNoiseModifier_random_mode_STEP = 0,
	GreasePencilNoiseModifier_random_mode_KEYFRAME = 1,
};

int GreasePencilNoiseModifier_random_mode_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_random_mode_set(PointerRNA *ptr, int value);

float GreasePencilNoiseModifier_noise_offset_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_noise_offset_set(PointerRNA *ptr, float value);

float GreasePencilNoiseModifier_noise_scale_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_noise_scale_set(PointerRNA *ptr, float value);

int GreasePencilNoiseModifier_seed_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_seed_set(PointerRNA *ptr, int value);

float GreasePencilNoiseModifier_factor_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_factor_set(PointerRNA *ptr, float value);

bool GreasePencilNoiseModifier_use_random_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_use_random_set(PointerRNA *ptr, bool value);

int GreasePencilNoiseModifier_step_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_step_set(PointerRNA *ptr, int value);

float GreasePencilNoiseModifier_factor_strength_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_factor_strength_set(PointerRNA *ptr, float value);

float GreasePencilNoiseModifier_factor_thickness_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_factor_thickness_set(PointerRNA *ptr, float value);

float GreasePencilNoiseModifier_factor_uvs_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_factor_uvs_set(PointerRNA *ptr, float value);

bool GreasePencilNoiseModifier_use_custom_curve_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_use_custom_curve_set(PointerRNA *ptr, bool value);

bool GreasePencilNoiseModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilNoiseModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilNoiseModifier_vertex_group_name_MAX 64

void GreasePencilNoiseModifier_vertex_group_name_get(PointerRNA *ptr, char *value);
int GreasePencilNoiseModifier_vertex_group_name_length(PointerRNA *ptr);
void GreasePencilNoiseModifier_vertex_group_name_set(PointerRNA *ptr, const char *value);

bool GreasePencilNoiseModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

bool GreasePencilNoiseModifier_open_random_panel_get(PointerRNA *ptr);
void GreasePencilNoiseModifier_open_random_panel_set(PointerRNA *ptr, bool value);

/**************** Grease Pencil Offset Modifier ****************/

extern StructRNA RNA_GreasePencilOffsetModifier;
extern StructRNA RNA_Modifier;

bool GreasePencilOffsetModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilOffsetModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilOffsetModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilOffsetModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilOffsetModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilOffsetModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilOffsetModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilOffsetModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilOffsetModifier_invert_vertex_group_get(PointerRNA *ptr);
void GreasePencilOffsetModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

#define GreasePencilOffsetModifier_tree_node_filter_MAX 64

void GreasePencilOffsetModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilOffsetModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilOffsetModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilOffsetModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilOffsetModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilOffsetModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilOffsetModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

void GreasePencilOffsetModifier_location_get(PointerRNA *ptr, float values[3]);
void GreasePencilOffsetModifier_location_set(PointerRNA *ptr, const float values[3]);

PointerRNA GreasePencilOffsetModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilOffsetModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilOffsetModifier_material_pass_filter_set(PointerRNA *ptr, int value);

enum {
	GreasePencilOffsetModifier_offset_mode_RANDOM = 0,
	GreasePencilOffsetModifier_offset_mode_LAYER = 1,
	GreasePencilOffsetModifier_offset_mode_STROKE = 3,
	GreasePencilOffsetModifier_offset_mode_MATERIAL = 2,
};

int GreasePencilOffsetModifier_offset_mode_get(PointerRNA *ptr);
void GreasePencilOffsetModifier_offset_mode_set(PointerRNA *ptr, int value);

void GreasePencilOffsetModifier_stroke_location_get(PointerRNA *ptr, float values[3]);
void GreasePencilOffsetModifier_stroke_location_set(PointerRNA *ptr, const float values[3]);

void GreasePencilOffsetModifier_stroke_rotation_get(PointerRNA *ptr, float values[3]);
void GreasePencilOffsetModifier_stroke_rotation_set(PointerRNA *ptr, const float values[3]);

void GreasePencilOffsetModifier_rotation_get(PointerRNA *ptr, float values[3]);
void GreasePencilOffsetModifier_rotation_set(PointerRNA *ptr, const float values[3]);

void GreasePencilOffsetModifier_scale_get(PointerRNA *ptr, float values[3]);
void GreasePencilOffsetModifier_scale_set(PointerRNA *ptr, const float values[3]);

void GreasePencilOffsetModifier_stroke_scale_get(PointerRNA *ptr, float values[3]);
void GreasePencilOffsetModifier_stroke_scale_set(PointerRNA *ptr, const float values[3]);

int GreasePencilOffsetModifier_seed_get(PointerRNA *ptr);
void GreasePencilOffsetModifier_seed_set(PointerRNA *ptr, int value);

int GreasePencilOffsetModifier_stroke_start_offset_get(PointerRNA *ptr);
void GreasePencilOffsetModifier_stroke_start_offset_set(PointerRNA *ptr, int value);

int GreasePencilOffsetModifier_stroke_step_get(PointerRNA *ptr);
void GreasePencilOffsetModifier_stroke_step_set(PointerRNA *ptr, int value);

bool GreasePencilOffsetModifier_use_uniform_random_scale_get(PointerRNA *ptr);
void GreasePencilOffsetModifier_use_uniform_random_scale_set(PointerRNA *ptr, bool value);

bool GreasePencilOffsetModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilOffsetModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilOffsetModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilOffsetModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilOffsetModifier_vertex_group_name_MAX 64

void GreasePencilOffsetModifier_vertex_group_name_get(PointerRNA *ptr, char *value);
int GreasePencilOffsetModifier_vertex_group_name_length(PointerRNA *ptr);
void GreasePencilOffsetModifier_vertex_group_name_set(PointerRNA *ptr, const char *value);

bool GreasePencilOffsetModifier_open_general_panel_get(PointerRNA *ptr);
void GreasePencilOffsetModifier_open_general_panel_set(PointerRNA *ptr, bool value);

bool GreasePencilOffsetModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilOffsetModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Grease Pencil Opacity Modifier ****************/

extern StructRNA RNA_GreasePencilOpacityModifier;
extern StructRNA RNA_Modifier;

PointerRNA GreasePencilOpacityModifier_custom_curve_get(PointerRNA *ptr);

float GreasePencilOpacityModifier_hardness_factor_get(PointerRNA *ptr);
void GreasePencilOpacityModifier_hardness_factor_set(PointerRNA *ptr, float value);

bool GreasePencilOpacityModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilOpacityModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilOpacityModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilOpacityModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilOpacityModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilOpacityModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilOpacityModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilOpacityModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilOpacityModifier_invert_vertex_group_get(PointerRNA *ptr);
void GreasePencilOpacityModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

#define GreasePencilOpacityModifier_tree_node_filter_MAX 64

void GreasePencilOpacityModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilOpacityModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilOpacityModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilOpacityModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilOpacityModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilOpacityModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilOpacityModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilOpacityModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilOpacityModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilOpacityModifier_material_pass_filter_set(PointerRNA *ptr, int value);

enum {
	GreasePencilOpacityModifier_color_mode_BOTH = 2,
	GreasePencilOpacityModifier_color_mode_STROKE = 0,
	GreasePencilOpacityModifier_color_mode_FILL = 1,
	GreasePencilOpacityModifier_color_mode_HARDNESS = 3,
};

int GreasePencilOpacityModifier_color_mode_get(PointerRNA *ptr);
void GreasePencilOpacityModifier_color_mode_set(PointerRNA *ptr, int value);

float GreasePencilOpacityModifier_color_factor_get(PointerRNA *ptr);
void GreasePencilOpacityModifier_color_factor_set(PointerRNA *ptr, float value);

bool GreasePencilOpacityModifier_use_uniform_opacity_get(PointerRNA *ptr);
void GreasePencilOpacityModifier_use_uniform_opacity_set(PointerRNA *ptr, bool value);

bool GreasePencilOpacityModifier_use_custom_curve_get(PointerRNA *ptr);
void GreasePencilOpacityModifier_use_custom_curve_set(PointerRNA *ptr, bool value);

bool GreasePencilOpacityModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilOpacityModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilOpacityModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilOpacityModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilOpacityModifier_use_weight_as_factor_get(PointerRNA *ptr);
void GreasePencilOpacityModifier_use_weight_as_factor_set(PointerRNA *ptr, bool value);

#define GreasePencilOpacityModifier_vertex_group_name_MAX 64

void GreasePencilOpacityModifier_vertex_group_name_get(PointerRNA *ptr, char *value);
int GreasePencilOpacityModifier_vertex_group_name_length(PointerRNA *ptr);
void GreasePencilOpacityModifier_vertex_group_name_set(PointerRNA *ptr, const char *value);

bool GreasePencilOpacityModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilOpacityModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Outline Modifier ****************/

extern StructRNA RNA_GreasePencilOutlineModifier;
extern StructRNA RNA_Modifier;

bool GreasePencilOutlineModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilOutlineModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilOutlineModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilOutlineModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilOutlineModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilOutlineModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilOutlineModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilOutlineModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilOutlineModifier_use_keep_shape_get(PointerRNA *ptr);
void GreasePencilOutlineModifier_use_keep_shape_set(PointerRNA *ptr, bool value);

#define GreasePencilOutlineModifier_tree_node_filter_MAX 64

void GreasePencilOutlineModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilOutlineModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilOutlineModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilOutlineModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilOutlineModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilOutlineModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilOutlineModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilOutlineModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilOutlineModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilOutlineModifier_material_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilOutlineModifier_outline_material_get(PointerRNA *ptr);

float GreasePencilOutlineModifier_sample_length_get(PointerRNA *ptr);
void GreasePencilOutlineModifier_sample_length_set(PointerRNA *ptr, float value);

int GreasePencilOutlineModifier_subdivision_get(PointerRNA *ptr);
void GreasePencilOutlineModifier_subdivision_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilOutlineModifier_object_get(PointerRNA *ptr);

int GreasePencilOutlineModifier_thickness_get(PointerRNA *ptr);
void GreasePencilOutlineModifier_thickness_set(PointerRNA *ptr, int value);

bool GreasePencilOutlineModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilOutlineModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilOutlineModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilOutlineModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilOutlineModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilOutlineModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Shrinkwrap Modifier ****************/

extern StructRNA RNA_GreasePencilShrinkwrapModifier;
extern StructRNA RNA_Modifier;

PointerRNA GreasePencilShrinkwrapModifier_auxiliary_target_get(PointerRNA *ptr);

enum {
	GreasePencilShrinkwrapModifier_cull_face_OFF = 0,
	GreasePencilShrinkwrapModifier_cull_face_FRONT = 8,
	GreasePencilShrinkwrapModifier_cull_face_BACK = 16,
};

int GreasePencilShrinkwrapModifier_cull_face_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_cull_face_set(PointerRNA *ptr, int value);

bool GreasePencilShrinkwrapModifier_use_invert_cull_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_use_invert_cull_set(PointerRNA *ptr, bool value);

bool GreasePencilShrinkwrapModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilShrinkwrapModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilShrinkwrapModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilShrinkwrapModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilShrinkwrapModifier_invert_vertex_group_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

#define GreasePencilShrinkwrapModifier_tree_node_filter_MAX 64

void GreasePencilShrinkwrapModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilShrinkwrapModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilShrinkwrapModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilShrinkwrapModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilShrinkwrapModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilShrinkwrapModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_material_pass_filter_set(PointerRNA *ptr, int value);

bool GreasePencilShrinkwrapModifier_use_negative_direction_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_use_negative_direction_set(PointerRNA *ptr, bool value);

float GreasePencilShrinkwrapModifier_offset_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_offset_set(PointerRNA *ptr, float value);

bool GreasePencilShrinkwrapModifier_use_positive_direction_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_use_positive_direction_set(PointerRNA *ptr, bool value);

float GreasePencilShrinkwrapModifier_project_limit_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_project_limit_set(PointerRNA *ptr, float value);

float GreasePencilShrinkwrapModifier_smooth_factor_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_smooth_factor_set(PointerRNA *ptr, float value);

enum {
	GreasePencilShrinkwrapModifier_wrap_mode_ON_SURFACE = 0,
	GreasePencilShrinkwrapModifier_wrap_mode_INSIDE = 1,
	GreasePencilShrinkwrapModifier_wrap_mode_OUTSIDE = 2,
	GreasePencilShrinkwrapModifier_wrap_mode_OUTSIDE_SURFACE = 3,
	GreasePencilShrinkwrapModifier_wrap_mode_ABOVE_SURFACE = 4,
};

int GreasePencilShrinkwrapModifier_wrap_mode_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_wrap_mode_set(PointerRNA *ptr, int value);

int GreasePencilShrinkwrapModifier_smooth_step_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_smooth_step_set(PointerRNA *ptr, int value);

int GreasePencilShrinkwrapModifier_subsurf_levels_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_subsurf_levels_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilShrinkwrapModifier_target_get(PointerRNA *ptr);

bool GreasePencilShrinkwrapModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilShrinkwrapModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilShrinkwrapModifier_vertex_group_name_MAX 64

void GreasePencilShrinkwrapModifier_vertex_group_name_get(PointerRNA *ptr, char *value);
int GreasePencilShrinkwrapModifier_vertex_group_name_length(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_vertex_group_name_set(PointerRNA *ptr, const char *value);

enum {
	GreasePencilShrinkwrapModifier_wrap_method_NEAREST_SURFACEPOINT = 0,
	GreasePencilShrinkwrapModifier_wrap_method_PROJECT = 1,
	GreasePencilShrinkwrapModifier_wrap_method_NEAREST_VERTEX = 2,
	GreasePencilShrinkwrapModifier_wrap_method_TARGET_PROJECT = 3,
};

int GreasePencilShrinkwrapModifier_wrap_method_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_wrap_method_set(PointerRNA *ptr, int value);

bool GreasePencilShrinkwrapModifier_use_project_x_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_use_project_x_set(PointerRNA *ptr, bool value);

bool GreasePencilShrinkwrapModifier_use_project_y_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_use_project_y_set(PointerRNA *ptr, bool value);

bool GreasePencilShrinkwrapModifier_use_project_z_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_use_project_z_set(PointerRNA *ptr, bool value);

bool GreasePencilShrinkwrapModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilShrinkwrapModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Simplify Modifier ****************/

extern StructRNA RNA_GreasePencilSimplifyModifier;
extern StructRNA RNA_Modifier;

float GreasePencilSimplifyModifier_distance_get(PointerRNA *ptr);
void GreasePencilSimplifyModifier_distance_set(PointerRNA *ptr, float value);

float GreasePencilSimplifyModifier_factor_get(PointerRNA *ptr);
void GreasePencilSimplifyModifier_factor_set(PointerRNA *ptr, float value);

bool GreasePencilSimplifyModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilSimplifyModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilSimplifyModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilSimplifyModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilSimplifyModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilSimplifyModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilSimplifyModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilSimplifyModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilSimplifyModifier_invert_vertex_group_get(PointerRNA *ptr);
void GreasePencilSimplifyModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

int GreasePencilSimplifyModifier_step_get(PointerRNA *ptr);
void GreasePencilSimplifyModifier_step_set(PointerRNA *ptr, int value);

#define GreasePencilSimplifyModifier_tree_node_filter_MAX 64

void GreasePencilSimplifyModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilSimplifyModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilSimplifyModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilSimplifyModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilSimplifyModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilSimplifyModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilSimplifyModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

float GreasePencilSimplifyModifier_length_get(PointerRNA *ptr);
void GreasePencilSimplifyModifier_length_set(PointerRNA *ptr, float value);

PointerRNA GreasePencilSimplifyModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilSimplifyModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilSimplifyModifier_material_pass_filter_set(PointerRNA *ptr, int value);

enum {
	GreasePencilSimplifyModifier_mode_FIXED = 0,
	GreasePencilSimplifyModifier_mode_ADAPTIVE = 1,
	GreasePencilSimplifyModifier_mode_SAMPLE = 2,
	GreasePencilSimplifyModifier_mode_MERGE = 3,
};

int GreasePencilSimplifyModifier_mode_get(PointerRNA *ptr);
void GreasePencilSimplifyModifier_mode_set(PointerRNA *ptr, int value);

float GreasePencilSimplifyModifier_sharp_threshold_get(PointerRNA *ptr);
void GreasePencilSimplifyModifier_sharp_threshold_set(PointerRNA *ptr, float value);

bool GreasePencilSimplifyModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilSimplifyModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilSimplifyModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilSimplifyModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilSimplifyModifier_vertex_group_name_MAX 64

void GreasePencilSimplifyModifier_vertex_group_name_get(PointerRNA *ptr, char *value);
int GreasePencilSimplifyModifier_vertex_group_name_length(PointerRNA *ptr);
void GreasePencilSimplifyModifier_vertex_group_name_set(PointerRNA *ptr, const char *value);

bool GreasePencilSimplifyModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilSimplifyModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Smooth Modifier ****************/

extern StructRNA RNA_GreasePencilSmoothModifier;
extern StructRNA RNA_Modifier;

bool GreasePencilSmoothModifier_use_edit_position_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_use_edit_position_set(PointerRNA *ptr, bool value);

bool GreasePencilSmoothModifier_use_edit_strength_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_use_edit_strength_set(PointerRNA *ptr, bool value);

bool GreasePencilSmoothModifier_use_edit_thickness_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_use_edit_thickness_set(PointerRNA *ptr, bool value);

bool GreasePencilSmoothModifier_use_edit_uv_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_use_edit_uv_set(PointerRNA *ptr, bool value);

PointerRNA GreasePencilSmoothModifier_custom_curve_get(PointerRNA *ptr);

float GreasePencilSmoothModifier_factor_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_factor_set(PointerRNA *ptr, float value);

bool GreasePencilSmoothModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilSmoothModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilSmoothModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilSmoothModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilSmoothModifier_invert_vertex_group_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

bool GreasePencilSmoothModifier_use_keep_shape_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_use_keep_shape_set(PointerRNA *ptr, bool value);

#define GreasePencilSmoothModifier_tree_node_filter_MAX 64

void GreasePencilSmoothModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilSmoothModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilSmoothModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilSmoothModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilSmoothModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilSmoothModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilSmoothModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_material_pass_filter_set(PointerRNA *ptr, int value);

bool GreasePencilSmoothModifier_use_smooth_ends_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_use_smooth_ends_set(PointerRNA *ptr, bool value);

int GreasePencilSmoothModifier_step_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_step_set(PointerRNA *ptr, int value);

bool GreasePencilSmoothModifier_use_custom_curve_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_use_custom_curve_set(PointerRNA *ptr, bool value);

bool GreasePencilSmoothModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilSmoothModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilSmoothModifier_vertex_group_name_MAX 64

void GreasePencilSmoothModifier_vertex_group_name_get(PointerRNA *ptr, char *value);
int GreasePencilSmoothModifier_vertex_group_name_length(PointerRNA *ptr);
void GreasePencilSmoothModifier_vertex_group_name_set(PointerRNA *ptr, const char *value);

bool GreasePencilSmoothModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilSmoothModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Subdivision Modifier ****************/

extern StructRNA RNA_GreasePencilSubdivModifier;
extern StructRNA RNA_Modifier;

bool GreasePencilSubdivModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilSubdivModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilSubdivModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilSubdivModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilSubdivModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilSubdivModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilSubdivModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilSubdivModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilSubdivModifier_tree_node_filter_MAX 64

void GreasePencilSubdivModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilSubdivModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilSubdivModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilSubdivModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilSubdivModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilSubdivModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilSubdivModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

int GreasePencilSubdivModifier_level_get(PointerRNA *ptr);
void GreasePencilSubdivModifier_level_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilSubdivModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilSubdivModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilSubdivModifier_material_pass_filter_set(PointerRNA *ptr, int value);

enum {
	GreasePencilSubdivModifier_subdivision_type_CATMULL_CLARK = 0,
	GreasePencilSubdivModifier_subdivision_type_SIMPLE = 1,
};

int GreasePencilSubdivModifier_subdivision_type_get(PointerRNA *ptr);
void GreasePencilSubdivModifier_subdivision_type_set(PointerRNA *ptr, int value);

bool GreasePencilSubdivModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilSubdivModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilSubdivModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilSubdivModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilSubdivModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilSubdivModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Grease Pencil Texture Modifier ****************/

extern StructRNA RNA_GreasePencilTextureModifier;
extern StructRNA RNA_Modifier;

void GreasePencilTextureModifier_fill_offset_get(PointerRNA *ptr, float values[2]);
void GreasePencilTextureModifier_fill_offset_set(PointerRNA *ptr, const float values[2]);

float GreasePencilTextureModifier_fill_rotation_get(PointerRNA *ptr);
void GreasePencilTextureModifier_fill_rotation_set(PointerRNA *ptr, float value);

float GreasePencilTextureModifier_fill_scale_get(PointerRNA *ptr);
void GreasePencilTextureModifier_fill_scale_set(PointerRNA *ptr, float value);

enum {
	GreasePencilTextureModifier_fit_method_CONSTANT_LENGTH = 1,
	GreasePencilTextureModifier_fit_method_FIT_STROKE = 0,
};

int GreasePencilTextureModifier_fit_method_get(PointerRNA *ptr);
void GreasePencilTextureModifier_fit_method_set(PointerRNA *ptr, int value);

bool GreasePencilTextureModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilTextureModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilTextureModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilTextureModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilTextureModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilTextureModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilTextureModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilTextureModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilTextureModifier_tree_node_filter_MAX 64

void GreasePencilTextureModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilTextureModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilTextureModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilTextureModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilTextureModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilTextureModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilTextureModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilTextureModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilTextureModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilTextureModifier_material_pass_filter_set(PointerRNA *ptr, int value);

enum {
	GreasePencilTextureModifier_mode_STROKE = 0,
	GreasePencilTextureModifier_mode_FILL = 1,
	GreasePencilTextureModifier_mode_STROKE_AND_FILL = 2,
};

int GreasePencilTextureModifier_mode_get(PointerRNA *ptr);
void GreasePencilTextureModifier_mode_set(PointerRNA *ptr, int value);

float GreasePencilTextureModifier_alignment_rotation_get(PointerRNA *ptr);
void GreasePencilTextureModifier_alignment_rotation_set(PointerRNA *ptr, float value);

float GreasePencilTextureModifier_uv_offset_get(PointerRNA *ptr);
void GreasePencilTextureModifier_uv_offset_set(PointerRNA *ptr, float value);

float GreasePencilTextureModifier_uv_scale_get(PointerRNA *ptr);
void GreasePencilTextureModifier_uv_scale_set(PointerRNA *ptr, float value);

bool GreasePencilTextureModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilTextureModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilTextureModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilTextureModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilTextureModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilTextureModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Grease Pencil Thickness Modifier ****************/

extern StructRNA RNA_GreasePencilThickModifierData;
extern StructRNA RNA_Modifier;

PointerRNA GreasePencilThickModifierData_custom_curve_get(PointerRNA *ptr);

bool GreasePencilThickModifierData_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilThickModifierData_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilThickModifierData_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilThickModifierData_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilThickModifierData_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilThickModifierData_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilThickModifierData_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilThickModifierData_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilThickModifierData_invert_vertex_group_get(PointerRNA *ptr);
void GreasePencilThickModifierData_invert_vertex_group_set(PointerRNA *ptr, bool value);

#define GreasePencilThickModifierData_tree_node_filter_MAX 64

void GreasePencilThickModifierData_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilThickModifierData_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilThickModifierData_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilThickModifierData_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilThickModifierData_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilThickModifierData_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilThickModifierData_layer_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilThickModifierData_material_filter_get(PointerRNA *ptr);

int GreasePencilThickModifierData_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilThickModifierData_material_pass_filter_set(PointerRNA *ptr, int value);

float GreasePencilThickModifierData_thickness_get(PointerRNA *ptr);
void GreasePencilThickModifierData_thickness_set(PointerRNA *ptr, float value);

float GreasePencilThickModifierData_thickness_factor_get(PointerRNA *ptr);
void GreasePencilThickModifierData_thickness_factor_set(PointerRNA *ptr, float value);

bool GreasePencilThickModifierData_use_uniform_thickness_get(PointerRNA *ptr);
void GreasePencilThickModifierData_use_uniform_thickness_set(PointerRNA *ptr, bool value);

bool GreasePencilThickModifierData_use_custom_curve_get(PointerRNA *ptr);
void GreasePencilThickModifierData_use_custom_curve_set(PointerRNA *ptr, bool value);

bool GreasePencilThickModifierData_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilThickModifierData_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilThickModifierData_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilThickModifierData_use_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilThickModifierData_vertex_group_name_MAX 64

void GreasePencilThickModifierData_vertex_group_name_get(PointerRNA *ptr, char *value);
int GreasePencilThickModifierData_vertex_group_name_length(PointerRNA *ptr);
void GreasePencilThickModifierData_vertex_group_name_set(PointerRNA *ptr, const char *value);

bool GreasePencilThickModifierData_use_weight_factor_get(PointerRNA *ptr);
void GreasePencilThickModifierData_use_weight_factor_set(PointerRNA *ptr, bool value);

bool GreasePencilThickModifierData_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilThickModifierData_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Grease Pencil Time Modifier ****************/

extern StructRNA RNA_GreasePencilTimeModifier;
extern StructRNA RNA_Modifier;

int GreasePencilTimeModifier_segment_active_index_get(PointerRNA *ptr);
void GreasePencilTimeModifier_segment_active_index_set(PointerRNA *ptr, int value);

bool GreasePencilTimeModifier_use_custom_frame_range_get(PointerRNA *ptr);
void GreasePencilTimeModifier_use_custom_frame_range_set(PointerRNA *ptr, bool value);

int GreasePencilTimeModifier_frame_end_get(PointerRNA *ptr);
void GreasePencilTimeModifier_frame_end_set(PointerRNA *ptr, int value);

int GreasePencilTimeModifier_offset_get(PointerRNA *ptr);
void GreasePencilTimeModifier_offset_set(PointerRNA *ptr, int value);

float GreasePencilTimeModifier_frame_scale_get(PointerRNA *ptr);
void GreasePencilTimeModifier_frame_scale_set(PointerRNA *ptr, float value);

bool GreasePencilTimeModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilTimeModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilTimeModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilTimeModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilTimeModifier_use_keep_loop_get(PointerRNA *ptr);
void GreasePencilTimeModifier_use_keep_loop_set(PointerRNA *ptr, bool value);

#define GreasePencilTimeModifier_tree_node_filter_MAX 64

void GreasePencilTimeModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilTimeModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilTimeModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilTimeModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilTimeModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilTimeModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilTimeModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

enum {
	GreasePencilTimeModifier_mode_NORMAL = 0,
	GreasePencilTimeModifier_mode_REVERSE = 1,
	GreasePencilTimeModifier_mode_FIX = 2,
	GreasePencilTimeModifier_mode_PINGPONG = 3,
	GreasePencilTimeModifier_mode_CHAIN = 4,
};

int GreasePencilTimeModifier_mode_get(PointerRNA *ptr);
void GreasePencilTimeModifier_mode_set(PointerRNA *ptr, int value);

void GreasePencilTimeModifier_segments_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GreasePencilTimeModifier_segments_next(CollectionPropertyIterator *iter);
void GreasePencilTimeModifier_segments_end(CollectionPropertyIterator *iter);
bool GreasePencilTimeModifier_segments_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GreasePencilTimeModifier_segments_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

int GreasePencilTimeModifier_frame_start_get(PointerRNA *ptr);
void GreasePencilTimeModifier_frame_start_set(PointerRNA *ptr, int value);

bool GreasePencilTimeModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilTimeModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilTimeModifier_open_custom_range_panel_get(PointerRNA *ptr);
void GreasePencilTimeModifier_open_custom_range_panel_set(PointerRNA *ptr, bool value);

bool GreasePencilTimeModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilTimeModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Time Modifier Segment ****************/

extern StructRNA RNA_GreasePencilTimeModifierSegment;

PointerRNA GreasePencilTimeModifierSegment_rna_type_get(PointerRNA *ptr);

#define GreasePencilTimeModifierSegment_name_MAX 64

void GreasePencilTimeModifierSegment_name_get(PointerRNA *ptr, char *value);
int GreasePencilTimeModifierSegment_name_length(PointerRNA *ptr);
void GreasePencilTimeModifierSegment_name_set(PointerRNA *ptr, const char *value);

int GreasePencilTimeModifierSegment_segment_end_get(PointerRNA *ptr);
void GreasePencilTimeModifierSegment_segment_end_set(PointerRNA *ptr, int value);

int GreasePencilTimeModifierSegment_segment_start_get(PointerRNA *ptr);
void GreasePencilTimeModifierSegment_segment_start_set(PointerRNA *ptr, int value);

enum {
	GreasePencilTimeModifierSegment_segment_mode_NORMAL = 0,
	GreasePencilTimeModifierSegment_segment_mode_REVERSE = 1,
	GreasePencilTimeModifierSegment_segment_mode_PINGPONG = 2,
};

int GreasePencilTimeModifierSegment_segment_mode_get(PointerRNA *ptr);
void GreasePencilTimeModifierSegment_segment_mode_set(PointerRNA *ptr, int value);

int GreasePencilTimeModifierSegment_segment_repeat_get(PointerRNA *ptr);
void GreasePencilTimeModifierSegment_segment_repeat_set(PointerRNA *ptr, int value);

/**************** Grease Pencil Tint Modifier ****************/

extern StructRNA RNA_GreasePencilTintModifier;
extern StructRNA RNA_Modifier;

void GreasePencilTintModifier_color_get(PointerRNA *ptr, float values[3]);
void GreasePencilTintModifier_color_set(PointerRNA *ptr, const float values[3]);

PointerRNA GreasePencilTintModifier_color_ramp_get(PointerRNA *ptr);

PointerRNA GreasePencilTintModifier_custom_curve_get(PointerRNA *ptr);

float GreasePencilTintModifier_factor_get(PointerRNA *ptr);
void GreasePencilTintModifier_factor_set(PointerRNA *ptr, float value);

bool GreasePencilTintModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilTintModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilTintModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilTintModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilTintModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilTintModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilTintModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilTintModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilTintModifier_invert_vertex_group_get(PointerRNA *ptr);
void GreasePencilTintModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

#define GreasePencilTintModifier_tree_node_filter_MAX 64

void GreasePencilTintModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilTintModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilTintModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilTintModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilTintModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilTintModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilTintModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilTintModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilTintModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilTintModifier_material_pass_filter_set(PointerRNA *ptr, int value);

enum {
	GreasePencilTintModifier_color_mode_BOTH = 2,
	GreasePencilTintModifier_color_mode_STROKE = 0,
	GreasePencilTintModifier_color_mode_FILL = 1,
};

int GreasePencilTintModifier_color_mode_get(PointerRNA *ptr);
void GreasePencilTintModifier_color_mode_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilTintModifier_object_get(PointerRNA *ptr);

float GreasePencilTintModifier_radius_get(PointerRNA *ptr);
void GreasePencilTintModifier_radius_set(PointerRNA *ptr, float value);

enum {
	GreasePencilTintModifier_tint_mode_UNIFORM = 0,
	GreasePencilTintModifier_tint_mode_GRADIENT = 1,
};

int GreasePencilTintModifier_tint_mode_get(PointerRNA *ptr);
void GreasePencilTintModifier_tint_mode_set(PointerRNA *ptr, int value);

bool GreasePencilTintModifier_use_custom_curve_get(PointerRNA *ptr);
void GreasePencilTintModifier_use_custom_curve_set(PointerRNA *ptr, bool value);

bool GreasePencilTintModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilTintModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilTintModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilTintModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilTintModifier_use_weight_as_factor_get(PointerRNA *ptr);
void GreasePencilTintModifier_use_weight_as_factor_set(PointerRNA *ptr, bool value);

#define GreasePencilTintModifier_vertex_group_name_MAX 64

void GreasePencilTintModifier_vertex_group_name_get(PointerRNA *ptr, char *value);
int GreasePencilTintModifier_vertex_group_name_length(PointerRNA *ptr);
void GreasePencilTintModifier_vertex_group_name_set(PointerRNA *ptr, const char *value);

bool GreasePencilTintModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilTintModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Tree Node ****************/

extern StructRNA RNA_GreasePencilTreeNode;

PointerRNA GreasePencilTreeNode_rna_type_get(PointerRNA *ptr);

void GreasePencilTreeNode_name_get(PointerRNA *ptr, char *value);
int GreasePencilTreeNode_name_length(PointerRNA *ptr);
void GreasePencilTreeNode_name_set(PointerRNA *ptr, const char *value);

void GreasePencilTreeNode_channel_color_get(PointerRNA *ptr, float values[3]);
void GreasePencilTreeNode_channel_color_set(PointerRNA *ptr, const float values[3]);

bool GreasePencilTreeNode_hide_get(PointerRNA *ptr);
void GreasePencilTreeNode_hide_set(PointerRNA *ptr, bool value);

bool GreasePencilTreeNode_lock_get(PointerRNA *ptr);
void GreasePencilTreeNode_lock_set(PointerRNA *ptr, bool value);

PointerRNA GreasePencilTreeNode_next_node_get(PointerRNA *ptr);

bool GreasePencilTreeNode_use_onion_skinning_get(PointerRNA *ptr);
void GreasePencilTreeNode_use_onion_skinning_set(PointerRNA *ptr, bool value);

PointerRNA GreasePencilTreeNode_parent_group_get(PointerRNA *ptr);

PointerRNA GreasePencilTreeNode_prev_node_get(PointerRNA *ptr);

bool GreasePencilTreeNode_select_get(PointerRNA *ptr);
void GreasePencilTreeNode_select_set(PointerRNA *ptr, bool value);

bool GreasePencilTreeNode_use_masks_get(PointerRNA *ptr);
void GreasePencilTreeNode_use_masks_set(PointerRNA *ptr, bool value);

/**************** Weight Modifier Angle ****************/

extern StructRNA RNA_GreasePencilWeightAngleModifier;
extern StructRNA RNA_Modifier;

float GreasePencilWeightAngleModifier_angle_get(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_angle_set(PointerRNA *ptr, float value);

enum {
	GreasePencilWeightAngleModifier_axis_X = 0,
	GreasePencilWeightAngleModifier_axis_Y = 1,
	GreasePencilWeightAngleModifier_axis_Z = 2,
};

int GreasePencilWeightAngleModifier_axis_get(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_axis_set(PointerRNA *ptr, int value);

bool GreasePencilWeightAngleModifier_use_invert_output_get(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_use_invert_output_set(PointerRNA *ptr, bool value);

bool GreasePencilWeightAngleModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilWeightAngleModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilWeightAngleModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilWeightAngleModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilWeightAngleModifier_invert_vertex_group_get(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

#define GreasePencilWeightAngleModifier_tree_node_filter_MAX 64

void GreasePencilWeightAngleModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilWeightAngleModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilWeightAngleModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilWeightAngleModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

PointerRNA GreasePencilWeightAngleModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilWeightAngleModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_material_pass_filter_set(PointerRNA *ptr, int value);

float GreasePencilWeightAngleModifier_minimum_weight_get(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_minimum_weight_set(PointerRNA *ptr, float value);

bool GreasePencilWeightAngleModifier_use_multiply_get(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_use_multiply_set(PointerRNA *ptr, bool value);

enum {
	GreasePencilWeightAngleModifier_space_LOCAL = 0,
	GreasePencilWeightAngleModifier_space_WORLD = 1,
};

int GreasePencilWeightAngleModifier_space_get(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_space_set(PointerRNA *ptr, int value);

bool GreasePencilWeightAngleModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilWeightAngleModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilWeightAngleModifier_vertex_group_name_MAX 64

void GreasePencilWeightAngleModifier_vertex_group_name_get(PointerRNA *ptr, char *value);
int GreasePencilWeightAngleModifier_vertex_group_name_length(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_vertex_group_name_set(PointerRNA *ptr, const char *value);

#define GreasePencilWeightAngleModifier_target_vertex_group_MAX 64

void GreasePencilWeightAngleModifier_target_vertex_group_get(PointerRNA *ptr, char *value);
int GreasePencilWeightAngleModifier_target_vertex_group_length(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_target_vertex_group_set(PointerRNA *ptr, const char *value);

bool GreasePencilWeightAngleModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilWeightAngleModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Weight Modifier Proximity ****************/

extern StructRNA RNA_GreasePencilWeightProximityModifier;
extern StructRNA RNA_Modifier;

float GreasePencilWeightProximityModifier_distance_end_get(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_distance_end_set(PointerRNA *ptr, float value);

bool GreasePencilWeightProximityModifier_use_invert_output_get(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_use_invert_output_set(PointerRNA *ptr, bool value);

bool GreasePencilWeightProximityModifier_invert_layer_filter_get(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_invert_layer_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilWeightProximityModifier_invert_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_invert_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilWeightProximityModifier_invert_material_filter_get(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_invert_material_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilWeightProximityModifier_invert_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_invert_material_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilWeightProximityModifier_invert_vertex_group_get(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

#define GreasePencilWeightProximityModifier_tree_node_filter_MAX 64

void GreasePencilWeightProximityModifier_tree_node_filter_get(PointerRNA *ptr, char *value);
int GreasePencilWeightProximityModifier_tree_node_filter_length(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_tree_node_filter_set(PointerRNA *ptr, const char *value);

bool GreasePencilWeightProximityModifier_use_layer_group_filter_get(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_use_layer_group_filter_set(PointerRNA *ptr, bool value);

int GreasePencilWeightProximityModifier_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_layer_pass_filter_set(PointerRNA *ptr, int value);

float GreasePencilWeightProximityModifier_distance_start_get(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_distance_start_set(PointerRNA *ptr, float value);

PointerRNA GreasePencilWeightProximityModifier_material_filter_get(PointerRNA *ptr);

int GreasePencilWeightProximityModifier_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_material_pass_filter_set(PointerRNA *ptr, int value);

float GreasePencilWeightProximityModifier_minimum_weight_get(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_minimum_weight_set(PointerRNA *ptr, float value);

bool GreasePencilWeightProximityModifier_use_multiply_get(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_use_multiply_set(PointerRNA *ptr, bool value);

PointerRNA GreasePencilWeightProximityModifier_object_get(PointerRNA *ptr);

bool GreasePencilWeightProximityModifier_use_layer_pass_filter_get(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_use_layer_pass_filter_set(PointerRNA *ptr, bool value);

bool GreasePencilWeightProximityModifier_use_material_pass_filter_get(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_use_material_pass_filter_set(PointerRNA *ptr, bool value);

#define GreasePencilWeightProximityModifier_vertex_group_name_MAX 64

void GreasePencilWeightProximityModifier_vertex_group_name_get(PointerRNA *ptr, char *value);
int GreasePencilWeightProximityModifier_vertex_group_name_length(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_vertex_group_name_set(PointerRNA *ptr, const char *value);

#define GreasePencilWeightProximityModifier_target_vertex_group_MAX 64

void GreasePencilWeightProximityModifier_target_vertex_group_get(PointerRNA *ptr, char *value);
int GreasePencilWeightProximityModifier_target_vertex_group_length(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_target_vertex_group_set(PointerRNA *ptr, const char *value);

bool GreasePencilWeightProximityModifier_open_influence_panel_get(PointerRNA *ptr);
void GreasePencilWeightProximityModifier_open_influence_panel_set(PointerRNA *ptr, bool value);

/**************** Grease Pencil ****************/

extern StructRNA RNA_GreasePencilv3;
extern StructRNA RNA_ID;

void GreasePencilv3_after_color_get(PointerRNA *ptr, float values[3]);
void GreasePencilv3_after_color_set(PointerRNA *ptr, const float values[3]);

PointerRNA GreasePencilv3_animation_data_get(PointerRNA *ptr);

void GreasePencilv3_attributes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GreasePencilv3_attributes_next(CollectionPropertyIterator *iter);
void GreasePencilv3_attributes_end(CollectionPropertyIterator *iter);
int GreasePencilv3_attributes_length(PointerRNA *ptr);
bool GreasePencilv3_attributes_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool GreasePencilv3_use_autolock_layers_get(PointerRNA *ptr);
void GreasePencilv3_use_autolock_layers_set(PointerRNA *ptr, bool value);

void GreasePencilv3_before_color_get(PointerRNA *ptr, float values[3]);
void GreasePencilv3_before_color_set(PointerRNA *ptr, const float values[3]);

void GreasePencilv3_color_attributes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GreasePencilv3_color_attributes_next(CollectionPropertyIterator *iter);
void GreasePencilv3_color_attributes_end(CollectionPropertyIterator *iter);
int GreasePencilv3_color_attributes_length(PointerRNA *ptr);

bool GreasePencilv3_use_onion_fade_get(PointerRNA *ptr);
void GreasePencilv3_use_onion_fade_set(PointerRNA *ptr, bool value);

enum {
	GreasePencilv3_onion_keyframe_type_ALL = 31,
	GreasePencilv3_onion_keyframe_type_KEYFRAME = 1,
	GreasePencilv3_onion_keyframe_type_BREAKDOWN = 4,
	GreasePencilv3_onion_keyframe_type_MOVING_HOLD = 16,
	GreasePencilv3_onion_keyframe_type_EXTREME = 2,
	GreasePencilv3_onion_keyframe_type_JITTER = 8,
	GreasePencilv3_onion_keyframe_type_GENERATED = 5,
};

int GreasePencilv3_onion_keyframe_type_get(PointerRNA *ptr);
void GreasePencilv3_onion_keyframe_type_set(PointerRNA *ptr, int value);

int GreasePencilv3_ghost_after_range_get(PointerRNA *ptr);
void GreasePencilv3_ghost_after_range_set(PointerRNA *ptr, int value);

int GreasePencilv3_ghost_before_range_get(PointerRNA *ptr);
void GreasePencilv3_ghost_before_range_set(PointerRNA *ptr, int value);

void GreasePencilv3_layer_groups_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GreasePencilv3_layer_groups_next(CollectionPropertyIterator *iter);
void GreasePencilv3_layer_groups_end(CollectionPropertyIterator *iter);
int GreasePencilv3_layer_groups_length(PointerRNA *ptr);

void GreasePencilv3_layers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GreasePencilv3_layers_next(CollectionPropertyIterator *iter);
void GreasePencilv3_layers_end(CollectionPropertyIterator *iter);
int GreasePencilv3_layers_length(PointerRNA *ptr);

void GreasePencilv3_materials_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void GreasePencilv3_materials_next(CollectionPropertyIterator *iter);
void GreasePencilv3_materials_end(CollectionPropertyIterator *iter);
int GreasePencilv3_materials_length(PointerRNA *ptr);
bool GreasePencilv3_materials_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool GreasePencilv3_materials_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

enum {
	GreasePencilv3_onion_mode_ABSOLUTE = 0,
	GreasePencilv3_onion_mode_RELATIVE = 1,
	GreasePencilv3_onion_mode_SELECTED = 2,
};

int GreasePencilv3_onion_mode_get(PointerRNA *ptr);
void GreasePencilv3_onion_mode_set(PointerRNA *ptr, int value);

float GreasePencilv3_onion_factor_get(PointerRNA *ptr);
void GreasePencilv3_onion_factor_set(PointerRNA *ptr, float value);

bool GreasePencilv3_use_onion_loop_get(PointerRNA *ptr);
void GreasePencilv3_use_onion_loop_set(PointerRNA *ptr, bool value);

enum {
	GreasePencilv3_stroke_depth_order_2D = 0,
	GreasePencilv3_stroke_depth_order_3D = 4,
};

int GreasePencilv3_stroke_depth_order_get(PointerRNA *ptr);
void GreasePencilv3_stroke_depth_order_set(PointerRNA *ptr, int value);

bool GreasePencilv3_use_ghost_custom_colors_get(PointerRNA *ptr);
void GreasePencilv3_use_ghost_custom_colors_set(PointerRNA *ptr, bool value);

/**************** Grease Pencil Group ****************/

extern StructRNA RNA_GreasePencilv3LayerGroup;

PointerRNA GreasePencilv3LayerGroup_rna_type_get(PointerRNA *ptr);

PointerRNA GreasePencilv3LayerGroup_active_get(PointerRNA *ptr);

struct PointerRNA GreasePencilv3LayerGroup_new_func(struct GreasePencil *_self, const char * name, struct PointerRNA *parent_group);
void GreasePencilv3LayerGroup_remove_func(struct GreasePencil *_self, struct PointerRNA *layer_group, bool keep_children);
void GreasePencilv3LayerGroup_move_func(struct GreasePencil *_self, struct PointerRNA *layer_group, int type);
void GreasePencilv3LayerGroup_move_top_func(struct GreasePencil *_self, struct PointerRNA *layer_group);
void GreasePencilv3LayerGroup_move_bottom_func(struct GreasePencil *_self, struct PointerRNA *layer_group);
void GreasePencilv3LayerGroup_move_to_layer_group_func(struct GreasePencil *_self, struct PointerRNA *layer_group, struct PointerRNA *parent_group);
/**************** Grease Pencil Layers ****************/

extern StructRNA RNA_GreasePencilv3Layers;

PointerRNA GreasePencilv3Layers_rna_type_get(PointerRNA *ptr);

PointerRNA GreasePencilv3Layers_active_get(PointerRNA *ptr);

struct GreasePencilLayer *GreasePencilv3Layers_new_func(struct GreasePencil *_self, const char * name, bool set_active, struct PointerRNA *layer_group);
void GreasePencilv3Layers_remove_func(struct GreasePencil *_self, struct PointerRNA *layer);
void GreasePencilv3Layers_move_func(struct GreasePencil *_self, struct PointerRNA *layer, int type);
void GreasePencilv3Layers_move_top_func(struct GreasePencil *_self, struct PointerRNA *layer);
void GreasePencilv3Layers_move_bottom_func(struct GreasePencil *_self, struct PointerRNA *layer);
void GreasePencilv3Layers_move_to_layer_group_func(struct GreasePencil *_self, struct PointerRNA *layer, struct PointerRNA *layer_group);
/**************** GroupNodeViewerPathElem ****************/

extern StructRNA RNA_GroupNodeViewerPathElem;
extern StructRNA RNA_ViewerPathElem;

int GroupNodeViewerPathElem_node_id_get(PointerRNA *ptr);
void GroupNodeViewerPathElem_node_id_set(PointerRNA *ptr, int value);

/**************** Header ****************/

extern StructRNA RNA_Header;

PointerRNA Header_rna_type_get(PointerRNA *ptr);

void Header_bl_idname_get(PointerRNA *ptr, char *value);
int Header_bl_idname_length(PointerRNA *ptr);
void Header_bl_idname_set(PointerRNA *ptr, const char *value);

PointerRNA Header_layout_get(PointerRNA *ptr);

enum {
	Header_bl_region_type_WINDOW = 0,
	Header_bl_region_type_HEADER = 1,
	Header_bl_region_type_CHANNELS = 2,
	Header_bl_region_type_TEMPORARY = 3,
	Header_bl_region_type_UI = 4,
	Header_bl_region_type_TOOLS = 5,
	Header_bl_region_type_TOOL_PROPS = 6,
	Header_bl_region_type_ASSET_SHELF = 14,
	Header_bl_region_type_ASSET_SHELF_HEADER = 15,
	Header_bl_region_type_PREVIEW = 7,
	Header_bl_region_type_HUD = 8,
	Header_bl_region_type_NAVIGATION_BAR = 9,
	Header_bl_region_type_EXECUTE = 10,
	Header_bl_region_type_FOOTER = 11,
	Header_bl_region_type_TOOL_HEADER = 12,
	Header_bl_region_type_XR = 13,
};

int Header_bl_region_type_get(PointerRNA *ptr);
void Header_bl_region_type_set(PointerRNA *ptr, int value);

enum {
	Header_bl_space_type_EMPTY = 0,
	Header_bl_space_type_VIEW_3D = 1,
	Header_bl_space_type_IMAGE_EDITOR = 6,
	Header_bl_space_type_NODE_EDITOR = 16,
	Header_bl_space_type_SEQUENCE_EDITOR = 8,
	Header_bl_space_type_CLIP_EDITOR = 20,
	Header_bl_space_type_DOPESHEET_EDITOR = 12,
	Header_bl_space_type_GRAPH_EDITOR = 2,
	Header_bl_space_type_NLA_EDITOR = 13,
	Header_bl_space_type_TEXT_EDITOR = 9,
	Header_bl_space_type_CONSOLE = 18,
	Header_bl_space_type_INFO = 7,
	Header_bl_space_type_TOPBAR = 21,
	Header_bl_space_type_STATUSBAR = 22,
	Header_bl_space_type_OUTLINER = 3,
	Header_bl_space_type_PROPERTIES = 4,
	Header_bl_space_type_FILE_BROWSER = 5,
	Header_bl_space_type_SPREADSHEET = 23,
	Header_bl_space_type_PREFERENCES = 19,
};

int Header_bl_space_type_get(PointerRNA *ptr);
void Header_bl_space_type_set(PointerRNA *ptr, int value);

void Header_draw_func(struct Header *_self, struct bContext *context);
/**************** Histogram ****************/

extern StructRNA RNA_Histogram;

PointerRNA Histogram_rna_type_get(PointerRNA *ptr);

enum {
	Histogram_mode_LUMA = 0,
	Histogram_mode_RGB = 1,
	Histogram_mode_R = 2,
	Histogram_mode_G = 3,
	Histogram_mode_B = 4,
	Histogram_mode_A = 5,
};

int Histogram_mode_get(PointerRNA *ptr);
void Histogram_mode_set(PointerRNA *ptr, int value);

bool Histogram_show_line_get(PointerRNA *ptr);
void Histogram_show_line_set(PointerRNA *ptr, bool value);

/**************** Hook Modifier ****************/

extern StructRNA RNA_HookModifier;
extern StructRNA RNA_Modifier;

PointerRNA HookModifier_falloff_curve_get(PointerRNA *ptr);

enum {
	HookModifier_falloff_type_NONE = 0,
	HookModifier_falloff_type_CURVE = 1,
	HookModifier_falloff_type_SMOOTH = 3,
	HookModifier_falloff_type_SPHERE = 7,
	HookModifier_falloff_type_ROOT = 4,
	HookModifier_falloff_type_INVERSE_SQUARE = 8,
	HookModifier_falloff_type_SHARP = 2,
	HookModifier_falloff_type_LINEAR = 5,
	HookModifier_falloff_type_CONSTANT = 6,
};

int HookModifier_falloff_type_get(PointerRNA *ptr);
void HookModifier_falloff_type_set(PointerRNA *ptr, int value);

void HookModifier_center_get(PointerRNA *ptr, float values[3]);
void HookModifier_center_set(PointerRNA *ptr, const float values[3]);

bool HookModifier_invert_vertex_group_get(PointerRNA *ptr);
void HookModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

void HookModifier_matrix_inverse_get(PointerRNA *ptr, float values[16]);
void HookModifier_matrix_inverse_set(PointerRNA *ptr, const float values[16]);

PointerRNA HookModifier_object_get(PointerRNA *ptr);

float HookModifier_falloff_radius_get(PointerRNA *ptr);
void HookModifier_falloff_radius_set(PointerRNA *ptr, float value);

float HookModifier_strength_get(PointerRNA *ptr);
void HookModifier_strength_set(PointerRNA *ptr, float value);

#define HookModifier_subtarget_MAX 64

void HookModifier_subtarget_get(PointerRNA *ptr, char *value);
int HookModifier_subtarget_length(PointerRNA *ptr);
void HookModifier_subtarget_set(PointerRNA *ptr, const char *value);

bool HookModifier_use_falloff_uniform_get(PointerRNA *ptr);
void HookModifier_use_falloff_uniform_set(PointerRNA *ptr, bool value);

#define HookModifier_vertex_group_MAX 64

void HookModifier_vertex_group_get(PointerRNA *ptr, char *value);
int HookModifier_vertex_group_length(PointerRNA *ptr);
void HookModifier_vertex_group_set(PointerRNA *ptr, const char *value);

void HookModifier_vertex_indices_get(PointerRNA *ptr, int values[]);
void HookModifier_vertex_indices_set(PointerRNA *ptr, const int values[]);
int HookModifier_vertex_indices_get_length(PointerRNA *ptr, int *arraylen);

void HookModifier_vertex_indices_set_func(struct HookModifierData *_self, ReportList *reports, int indices_num, int *indices);
/**************** HueCorrectModifier ****************/

extern StructRNA RNA_HueCorrectModifier;
extern StructRNA RNA_StripModifier;

PointerRNA HueCorrectModifier_curve_mapping_get(PointerRNA *ptr);

/**************** Hydra Render Engine ****************/

extern StructRNA RNA_HydraRenderEngine;
extern StructRNA RNA_RenderEngine;

/**************** ID ****************/

extern StructRNA RNA_ID;

PointerRNA ID_rna_type_get(PointerRNA *ptr);

#define ID_name_MAX 64

void ID_name_get(PointerRNA *ptr, char *value);
int ID_name_length(PointerRNA *ptr);
void ID_name_set(PointerRNA *ptr, const char *value);

PointerRNA ID_asset_data_get(PointerRNA *ptr);

bool ID_is_editable_get(PointerRNA *ptr);
void ID_is_editable_set(PointerRNA *ptr, bool value);

bool ID_is_embedded_data_get(PointerRNA *ptr);
void ID_is_embedded_data_set(PointerRNA *ptr, bool value);

bool ID_use_extra_user_get(PointerRNA *ptr);
void ID_use_extra_user_set(PointerRNA *ptr, bool value);

bool ID_use_fake_user_get(PointerRNA *ptr);
void ID_use_fake_user_set(PointerRNA *ptr, bool value);

#define ID_name_full_MAX 132

void ID_name_full_get(PointerRNA *ptr, char *value);
int ID_name_full_length(PointerRNA *ptr);
void ID_name_full_set(PointerRNA *ptr, const char *value);

bool ID_is_evaluated_get(PointerRNA *ptr);
void ID_is_evaluated_set(PointerRNA *ptr, bool value);

bool ID_is_library_indirect_get(PointerRNA *ptr);
void ID_is_library_indirect_set(PointerRNA *ptr, bool value);

PointerRNA ID_library_get(PointerRNA *ptr);

PointerRNA ID_override_library_get(PointerRNA *ptr);

PointerRNA ID_library_weak_reference_get(PointerRNA *ptr);

bool ID_is_missing_get(PointerRNA *ptr);
void ID_is_missing_set(PointerRNA *ptr, bool value);

PointerRNA ID_original_get(PointerRNA *ptr);

PointerRNA ID_preview_get(PointerRNA *ptr);

bool ID_is_runtime_data_get(PointerRNA *ptr);
void ID_is_runtime_data_set(PointerRNA *ptr, bool value);

int ID_session_uid_get(PointerRNA *ptr);
void ID_session_uid_set(PointerRNA *ptr, int value);

bool ID_tag_get(PointerRNA *ptr);
void ID_tag_set(PointerRNA *ptr, bool value);

enum {
	ID_id_type_ACTION = 17217,
	ID_id_type_ARMATURE = 21057,
	ID_id_type_BRUSH = 21058,
	ID_id_type_CACHEFILE = 17987,
	ID_id_type_CAMERA = 16707,
	ID_id_type_COLLECTION = 21063,
	ID_id_type_CURVE = 21827,
	ID_id_type_CURVES = 22083,
	ID_id_type_FONT = 18006,
	ID_id_type_GREASEPENCIL = 17479,
	ID_id_type_GREASEPENCIL_V3 = 20551,
	ID_id_type_IMAGE = 19785,
	ID_id_type_KEY = 17739,
	ID_id_type_LATTICE = 21580,
	ID_id_type_LIBRARY = 18764,
	ID_id_type_LIGHT = 16716,
	ID_id_type_LIGHT_PROBE = 20556,
	ID_id_type_LINESTYLE = 21324,
	ID_id_type_MASK = 21325,
	ID_id_type_MATERIAL = 16717,
	ID_id_type_MESH = 17741,
	ID_id_type_META = 16973,
	ID_id_type_MOVIECLIP = 17229,
	ID_id_type_NODETREE = 21582,
	ID_id_type_OBJECT = 16975,
	ID_id_type_PAINTCURVE = 17232,
	ID_id_type_PALETTE = 19536,
	ID_id_type_PARTICLE = 16720,
	ID_id_type_POINTCLOUD = 21584,
	ID_id_type_SCENE = 17235,
	ID_id_type_SCREEN = 21075,
	ID_id_type_SOUND = 20307,
	ID_id_type_SPEAKER = 19283,
	ID_id_type_TEXT = 22612,
	ID_id_type_TEXTURE = 17748,
	ID_id_type_VOLUME = 20310,
	ID_id_type_WINDOWMANAGER = 19799,
	ID_id_type_WORKSPACE = 21335,
	ID_id_type_WORLD = 20311,
};

int ID_id_type_get(PointerRNA *ptr);
void ID_id_type_set(PointerRNA *ptr, int value);

int ID_users_get(PointerRNA *ptr);
void ID_users_set(PointerRNA *ptr, int value);

int ID_rename_func(struct ID *_self, Main *bmain, const char * name, int mode);
struct ID *ID_evaluated_get_func(struct ID *_self, struct Depsgraph *depsgraph);
struct ID *ID_copy_func(struct ID *_self, Main *bmain);
void ID_asset_mark_func(struct ID *_self);
void ID_asset_clear_func(struct ID *_self);
void ID_asset_generate_preview_func(struct ID *_self, bContext *C);
struct ID *ID_override_create_func(struct ID *_self, Main *bmain, bool remap_local_usages);
struct ID *ID_override_hierarchy_create_func(struct ID *_self, Main *bmain, struct Scene *scene, struct ViewLayer *view_layer, struct ID *reference, bool do_fully_editable);
void ID_user_clear_func(struct ID *_self);
void ID_user_remap_func(struct ID *_self, Main *bmain, struct ID *new_id);
struct ID *ID_make_local_func(struct ID *_self, Main *bmain, bool clear_proxy, bool clear_liboverride, bool clear_asset_data);
int ID_user_of_id_func(struct ID *_self, struct ID *id);
struct AnimData *ID_animation_data_create_func(struct ID *_self, Main *bmain);
void ID_animation_data_clear_func(struct ID *_self, Main *bmain);
void ID_update_tag_func(struct ID *_self, Main *bmain, ReportList *reports, int refresh);
struct PreviewImage *ID_preview_ensure_func(struct ID *_self);
/**************** ID Materials ****************/

extern StructRNA RNA_IDMaterials;

PointerRNA IDMaterials_rna_type_get(PointerRNA *ptr);

void IDMaterials_append_func(struct ID *_self, Main *bmain, struct Material *material);
struct Material *IDMaterials_pop_func(struct ID *_self, Main *bmain, ReportList *reports, int index);
void IDMaterials_clear_func(struct ID *_self, Main *bmain);
/**************** ID Library Override ****************/

extern StructRNA RNA_IDOverrideLibrary;

PointerRNA IDOverrideLibrary_rna_type_get(PointerRNA *ptr);

PointerRNA IDOverrideLibrary_hierarchy_root_get(PointerRNA *ptr);

bool IDOverrideLibrary_is_in_hierarchy_get(PointerRNA *ptr);
void IDOverrideLibrary_is_in_hierarchy_set(PointerRNA *ptr, bool value);

bool IDOverrideLibrary_is_system_override_get(PointerRNA *ptr);
void IDOverrideLibrary_is_system_override_set(PointerRNA *ptr, bool value);

void IDOverrideLibrary_properties_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void IDOverrideLibrary_properties_next(CollectionPropertyIterator *iter);
void IDOverrideLibrary_properties_end(CollectionPropertyIterator *iter);
bool IDOverrideLibrary_properties_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

PointerRNA IDOverrideLibrary_reference_get(PointerRNA *ptr);

void IDOverrideLibrary_operations_update_func(struct ID *_selfid, struct IDOverrideLibrary *_self, Main *bmain, ReportList *reports);
void IDOverrideLibrary_reset_func(struct ID *_selfid, struct IDOverrideLibrary *_self, Main *bmain, ReportList *reports, bool do_hierarchy, bool set_system_override);
void IDOverrideLibrary_destroy_func(struct ID *_selfid, struct IDOverrideLibrary *_self, Main *bmain, ReportList *reports, bool do_hierarchy);
bool IDOverrideLibrary_resync_func(struct ID *_selfid, struct IDOverrideLibrary *_self, Main *bmain, ReportList *reports, struct Scene *scene, struct ViewLayer *view_layer, struct Collection *residual_storage, bool do_hierarchy_enforce, bool do_whole_hierarchy);
/**************** Override Properties ****************/

extern StructRNA RNA_IDOverrideLibraryProperties;

PointerRNA IDOverrideLibraryProperties_rna_type_get(PointerRNA *ptr);

struct IDOverrideLibraryProperty *IDOverrideLibraryProperties_add_func(struct IDOverrideLibrary *_self, ReportList *reports, const char * rna_path);
void IDOverrideLibraryProperties_remove_func(struct IDOverrideLibrary *_self, ReportList *reports, struct IDOverrideLibraryProperty *property);
/**************** ID Library Override Property ****************/

extern StructRNA RNA_IDOverrideLibraryProperty;

PointerRNA IDOverrideLibraryProperty_rna_type_get(PointerRNA *ptr);

void IDOverrideLibraryProperty_operations_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void IDOverrideLibraryProperty_operations_next(CollectionPropertyIterator *iter);
void IDOverrideLibraryProperty_operations_end(CollectionPropertyIterator *iter);
bool IDOverrideLibraryProperty_operations_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

#define IDOverrideLibraryProperty_rna_path_MAX 2147483647

void IDOverrideLibraryProperty_rna_path_get(PointerRNA *ptr, char *value);
int IDOverrideLibraryProperty_rna_path_length(PointerRNA *ptr);
void IDOverrideLibraryProperty_rna_path_set(PointerRNA *ptr, const char *value);

/**************** ID Library Override Property Operation ****************/

extern StructRNA RNA_IDOverrideLibraryPropertyOperation;

PointerRNA IDOverrideLibraryPropertyOperation_rna_type_get(PointerRNA *ptr);

enum {
	IDOverrideLibraryPropertyOperation_flag_MANDATORY = 1,
	IDOverrideLibraryPropertyOperation_flag_LOCKED = 2,
	IDOverrideLibraryPropertyOperation_flag_IDPOINTER_MATCH_REFERENCE = 256,
	IDOverrideLibraryPropertyOperation_flag_IDPOINTER_ITEM_USE_ID = 512,
};

int IDOverrideLibraryPropertyOperation_flag_get(PointerRNA *ptr);
void IDOverrideLibraryPropertyOperation_flag_set(PointerRNA *ptr, int value);

enum {
	IDOverrideLibraryPropertyOperation_operation_NOOP = 0,
	IDOverrideLibraryPropertyOperation_operation_REPLACE = 1,
	IDOverrideLibraryPropertyOperation_operation_DIFF_ADD = 101,
	IDOverrideLibraryPropertyOperation_operation_DIFF_SUB = 102,
	IDOverrideLibraryPropertyOperation_operation_FACT_MULTIPLY = 103,
	IDOverrideLibraryPropertyOperation_operation_INSERT_AFTER = 201,
	IDOverrideLibraryPropertyOperation_operation_INSERT_BEFORE = 202,
};

int IDOverrideLibraryPropertyOperation_operation_get(PointerRNA *ptr);
void IDOverrideLibraryPropertyOperation_operation_set(PointerRNA *ptr, int value);

PointerRNA IDOverrideLibraryPropertyOperation_subitem_local_id_get(PointerRNA *ptr);

int IDOverrideLibraryPropertyOperation_subitem_local_index_get(PointerRNA *ptr);
void IDOverrideLibraryPropertyOperation_subitem_local_index_set(PointerRNA *ptr, int value);

#define IDOverrideLibraryPropertyOperation_subitem_local_name_MAX 2147483647

void IDOverrideLibraryPropertyOperation_subitem_local_name_get(PointerRNA *ptr, char *value);
int IDOverrideLibraryPropertyOperation_subitem_local_name_length(PointerRNA *ptr);
void IDOverrideLibraryPropertyOperation_subitem_local_name_set(PointerRNA *ptr, const char *value);

PointerRNA IDOverrideLibraryPropertyOperation_subitem_reference_id_get(PointerRNA *ptr);

int IDOverrideLibraryPropertyOperation_subitem_reference_index_get(PointerRNA *ptr);
void IDOverrideLibraryPropertyOperation_subitem_reference_index_set(PointerRNA *ptr, int value);

#define IDOverrideLibraryPropertyOperation_subitem_reference_name_MAX 2147483647

void IDOverrideLibraryPropertyOperation_subitem_reference_name_get(PointerRNA *ptr, char *value);
int IDOverrideLibraryPropertyOperation_subitem_reference_name_length(PointerRNA *ptr);
void IDOverrideLibraryPropertyOperation_subitem_reference_name_set(PointerRNA *ptr, const char *value);

/**************** Override Operations ****************/

extern StructRNA RNA_IDOverrideLibraryPropertyOperations;

PointerRNA IDOverrideLibraryPropertyOperations_rna_type_get(PointerRNA *ptr);

struct IDOverrideLibraryPropertyOperation *IDOverrideLibraryPropertyOperations_add_func(struct IDOverrideLibraryProperty *_self, ReportList *reports, int operation, bool use_id, const char * subitem_reference_name, const char * subitem_local_name, struct ID *subitem_reference_id, struct ID *subitem_local_id, int subitem_reference_index, int subitem_local_index);
void IDOverrideLibraryPropertyOperations_remove_func(struct IDOverrideLibraryProperty *_self, ReportList *reports, struct IDOverrideLibraryPropertyOperation *operation);
/**************** IDPropertyWrapPtr ****************/

extern StructRNA RNA_IDPropertyWrapPtr;

PointerRNA IDPropertyWrapPtr_rna_type_get(PointerRNA *ptr);

/**************** IDViewerPathElem ****************/

extern StructRNA RNA_IDViewerPathElem;
extern StructRNA RNA_ViewerPathElem;

PointerRNA IDViewerPathElem_id_get(PointerRNA *ptr);

/**************** IKParam ****************/

extern StructRNA RNA_IKParam;

PointerRNA IKParam_rna_type_get(PointerRNA *ptr);

enum {
	IKParam_ik_solver_LEGACY = 0,
	IKParam_ik_solver_ITASC = 1,
};

int IKParam_ik_solver_get(PointerRNA *ptr);
void IKParam_ik_solver_set(PointerRNA *ptr, int value);

/**************** Image ****************/

extern StructRNA RNA_Image;
extern StructRNA RNA_ID;

enum {
	Image_alpha_mode_STRAIGHT = 0,
	Image_alpha_mode_PREMUL = 1,
	Image_alpha_mode_CHANNEL_PACKED = 2,
	Image_alpha_mode_NONE = 3,
};

int Image_alpha_mode_get(PointerRNA *ptr);
void Image_alpha_mode_set(PointerRNA *ptr, int value);

int Image_bindcode_get(PointerRNA *ptr);
void Image_bindcode_set(PointerRNA *ptr, int value);

int Image_channels_get(PointerRNA *ptr);
void Image_channels_set(PointerRNA *ptr, int value);

void Image_generated_color_get(PointerRNA *ptr, float values[4]);
void Image_generated_color_set(PointerRNA *ptr, const float values[4]);

PointerRNA Image_colorspace_settings_get(PointerRNA *ptr);

bool Image_use_deinterlace_get(PointerRNA *ptr);
void Image_use_deinterlace_set(PointerRNA *ptr, bool value);

int Image_depth_get(PointerRNA *ptr);
void Image_depth_set(PointerRNA *ptr, int value);

bool Image_is_dirty_get(PointerRNA *ptr);
void Image_is_dirty_set(PointerRNA *ptr, bool value);

void Image_display_aspect_get(PointerRNA *ptr, float values[2]);
void Image_display_aspect_set(PointerRNA *ptr, const float values[2]);

int Image_frame_duration_get(PointerRNA *ptr);
void Image_frame_duration_set(PointerRNA *ptr, int value);

enum {
	Image_file_format_BMP = 20,
	Image_file_format_IRIS = 1,
	Image_file_format_PNG = 17,
	Image_file_format_JPEG = 4,
	Image_file_format_JPEG2000 = 30,
	Image_file_format_TARGA = 0,
	Image_file_format_TARGA_RAW = 14,
	Image_file_format_CINEON = 26,
	Image_file_format_DPX = 27,
	Image_file_format_OPEN_EXR_MULTILAYER = 28,
	Image_file_format_OPEN_EXR = 23,
	Image_file_format_HDR = 21,
	Image_file_format_TIFF = 22,
	Image_file_format_WEBP = 35,
	Image_file_format_FFMPEG = 24,
};

int Image_file_format_get(PointerRNA *ptr);
void Image_file_format_set(PointerRNA *ptr, int value);

#define Image_filepath_MAX 1024

void Image_filepath_get(PointerRNA *ptr, char *value);
int Image_filepath_length(PointerRNA *ptr);
void Image_filepath_set(PointerRNA *ptr, const char *value);

#define Image_filepath_raw_MAX 1024

void Image_filepath_raw_get(PointerRNA *ptr, char *value);
int Image_filepath_raw_length(PointerRNA *ptr);
void Image_filepath_raw_set(PointerRNA *ptr, const char *value);

bool Image_use_generated_float_get(PointerRNA *ptr);
void Image_use_generated_float_set(PointerRNA *ptr, bool value);

int Image_generated_height_get(PointerRNA *ptr);
void Image_generated_height_set(PointerRNA *ptr, int value);

enum {
	Image_generated_type_BLANK = 0,
	Image_generated_type_UV_GRID = 1,
	Image_generated_type_COLOR_GRID = 2,
};

int Image_generated_type_get(PointerRNA *ptr);
void Image_generated_type_set(PointerRNA *ptr, int value);

int Image_generated_width_get(PointerRNA *ptr);
void Image_generated_width_set(PointerRNA *ptr, int value);

bool Image_use_half_precision_get(PointerRNA *ptr);
void Image_use_half_precision_set(PointerRNA *ptr, bool value);

bool Image_has_data_get(PointerRNA *ptr);
void Image_has_data_set(PointerRNA *ptr, bool value);

void Image_tiles_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Image_tiles_next(CollectionPropertyIterator *iter);
void Image_tiles_end(CollectionPropertyIterator *iter);
bool Image_tiles_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool Image_is_float_get(PointerRNA *ptr);
void Image_is_float_set(PointerRNA *ptr, bool value);

bool Image_is_multiview_get(PointerRNA *ptr);
void Image_is_multiview_set(PointerRNA *ptr, bool value);

PointerRNA Image_packed_file_get(PointerRNA *ptr);

void Image_packed_files_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Image_packed_files_next(CollectionPropertyIterator *iter);
void Image_packed_files_end(CollectionPropertyIterator *iter);
bool Image_packed_files_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Image_packed_files_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void Image_pixels_get(PointerRNA *ptr, float values[]);
void Image_pixels_set(PointerRNA *ptr, const float values[]);int Image_pixels_get_length(PointerRNA *ptr, int *arraylen);

void Image_render_slots_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Image_render_slots_next(CollectionPropertyIterator *iter);
void Image_render_slots_end(CollectionPropertyIterator *iter);
bool Image_render_slots_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

void Image_resolution_get(PointerRNA *ptr, float values[2]);
void Image_resolution_set(PointerRNA *ptr, const float values[2]);

int Image_seam_margin_get(PointerRNA *ptr);
void Image_seam_margin_set(PointerRNA *ptr, int value);

void Image_size_get(PointerRNA *ptr, int values[2]);
void Image_size_set(PointerRNA *ptr, const int values[2]);

enum {
	Image_source_FILE = 1,
	Image_source_SEQUENCE = 2,
	Image_source_MOVIE = 3,
	Image_source_GENERATED = 4,
	Image_source_VIEWER = 5,
	Image_source_TILED = 6,
};

int Image_source_get(PointerRNA *ptr);
void Image_source_set(PointerRNA *ptr, int value);

bool Image_is_stereo_3d_get(PointerRNA *ptr);
void Image_is_stereo_3d_set(PointerRNA *ptr, bool value);

PointerRNA Image_stereo_3d_format_get(PointerRNA *ptr);

enum {
	Image_type_IMAGE = 0,
	Image_type_MULTILAYER = 1,
	Image_type_UV_TEST = 2,
	Image_type_RENDER_RESULT = 4,
	Image_type_COMPOSITING = 5,
};

int Image_type_get(PointerRNA *ptr);
void Image_type_set(PointerRNA *ptr, int value);

bool Image_use_multiview_get(PointerRNA *ptr);
void Image_use_multiview_set(PointerRNA *ptr, bool value);

bool Image_use_view_as_render_get(PointerRNA *ptr);
void Image_use_view_as_render_set(PointerRNA *ptr, bool value);

enum {
	Image_views_format_INDIVIDUAL = 0,
	Image_views_format_STEREO_3D = 1,
};

int Image_views_format_get(PointerRNA *ptr);
void Image_views_format_set(PointerRNA *ptr, int value);

void Image_save_render_func(struct Image *_self, bContext *C, ReportList *reports, const char * filepath, struct Scene *scene, int quality);
void Image_save_func(struct Image *_self, Main *bmain, bContext *C, ReportList *reports, const char * filepath, int quality, bool save_copy);
void Image_pack_func(struct Image *_self, Main *bmain, bContext *C, ReportList *reports, const char * data, int data_len);
void Image_unpack_func(struct Image *_self, Main *bmain, ReportList *reports, int method);
void Image_reload_func(struct Image *_self, Main *bmain);
void Image_update_func(struct Image *_self, ReportList *reports);
void Image_scale_func(struct Image *_self, ReportList *reports, int width, int height, int frame, int tile_index);
int Image_gl_touch_func(struct Image *_self, ReportList *reports, int frame, int layer_index, int pass_index);
int Image_gl_load_func(struct Image *_self, ReportList *reports, int frame, int layer_index, int pass_index);
void Image_gl_free_func(struct Image *_self);
void Image_filepath_from_user_func(struct Image *_self, struct ImageUser *image_user, char * filepath);
void Image_buffers_free_func(struct Image *_self);
/**************** Image Format ****************/

extern StructRNA RNA_ImageFormatSettings;

PointerRNA ImageFormatSettings_rna_type_get(PointerRNA *ptr);

int ImageFormatSettings_cineon_black_get(PointerRNA *ptr);
void ImageFormatSettings_cineon_black_set(PointerRNA *ptr, int value);

bool ImageFormatSettings_use_jpeg2k_cinema_preset_get(PointerRNA *ptr);
void ImageFormatSettings_use_jpeg2k_cinema_preset_set(PointerRNA *ptr, bool value);

bool ImageFormatSettings_use_jpeg2k_cinema_48_get(PointerRNA *ptr);
void ImageFormatSettings_use_jpeg2k_cinema_48_set(PointerRNA *ptr, bool value);

enum {
	ImageFormatSettings_exr_codec_NONE = 0,
	ImageFormatSettings_exr_codec_ZIP = 2,
	ImageFormatSettings_exr_codec_PIZ = 3,
	ImageFormatSettings_exr_codec_DWAA = 8,
	ImageFormatSettings_exr_codec_DWAB = 9,
	ImageFormatSettings_exr_codec_ZIPS = 5,
	ImageFormatSettings_exr_codec_RLE = 4,
	ImageFormatSettings_exr_codec_PXR24 = 1,
	ImageFormatSettings_exr_codec_B44 = 6,
	ImageFormatSettings_exr_codec_B44A = 7,
};

int ImageFormatSettings_exr_codec_get(PointerRNA *ptr);
void ImageFormatSettings_exr_codec_set(PointerRNA *ptr, int value);

enum {
	ImageFormatSettings_jpeg2k_codec_JP2 = 0,
	ImageFormatSettings_jpeg2k_codec_J2K = 1,
};

int ImageFormatSettings_jpeg2k_codec_get(PointerRNA *ptr);
void ImageFormatSettings_jpeg2k_codec_set(PointerRNA *ptr, int value);

enum {
	ImageFormatSettings_color_depth_8 = 2,
	ImageFormatSettings_color_depth_10 = 4,
	ImageFormatSettings_color_depth_12 = 8,
	ImageFormatSettings_color_depth_16 = 16,
	ImageFormatSettings_color_depth_32 = 64,
};

int ImageFormatSettings_color_depth_get(PointerRNA *ptr);
void ImageFormatSettings_color_depth_set(PointerRNA *ptr, int value);

enum {
	ImageFormatSettings_color_management_FOLLOW_SCENE = 0,
	ImageFormatSettings_color_management_OVERRIDE = 1,
};

int ImageFormatSettings_color_management_get(PointerRNA *ptr);
void ImageFormatSettings_color_management_set(PointerRNA *ptr, int value);

enum {
	ImageFormatSettings_color_mode_BW = 8,
	ImageFormatSettings_color_mode_RGB = 24,
	ImageFormatSettings_color_mode_RGBA = 32,
};

int ImageFormatSettings_color_mode_get(PointerRNA *ptr);
void ImageFormatSettings_color_mode_set(PointerRNA *ptr, int value);

PointerRNA ImageFormatSettings_linear_colorspace_settings_get(PointerRNA *ptr);

int ImageFormatSettings_compression_get(PointerRNA *ptr);
void ImageFormatSettings_compression_set(PointerRNA *ptr, int value);

enum {
	ImageFormatSettings_tiff_codec_NONE = 3,
	ImageFormatSettings_tiff_codec_DEFLATE = 0,
	ImageFormatSettings_tiff_codec_LZW = 1,
	ImageFormatSettings_tiff_codec_PACKBITS = 2,
};

int ImageFormatSettings_tiff_codec_get(PointerRNA *ptr);
void ImageFormatSettings_tiff_codec_set(PointerRNA *ptr, int value);

PointerRNA ImageFormatSettings_display_settings_get(PointerRNA *ptr);

enum {
	ImageFormatSettings_file_format_BMP = 20,
	ImageFormatSettings_file_format_IRIS = 1,
	ImageFormatSettings_file_format_PNG = 17,
	ImageFormatSettings_file_format_JPEG = 4,
	ImageFormatSettings_file_format_JPEG2000 = 30,
	ImageFormatSettings_file_format_TARGA = 0,
	ImageFormatSettings_file_format_TARGA_RAW = 14,
	ImageFormatSettings_file_format_CINEON = 26,
	ImageFormatSettings_file_format_DPX = 27,
	ImageFormatSettings_file_format_OPEN_EXR_MULTILAYER = 28,
	ImageFormatSettings_file_format_OPEN_EXR = 23,
	ImageFormatSettings_file_format_HDR = 21,
	ImageFormatSettings_file_format_TIFF = 22,
	ImageFormatSettings_file_format_WEBP = 35,
	ImageFormatSettings_file_format_FFMPEG = 24,
};

int ImageFormatSettings_file_format_get(PointerRNA *ptr);
void ImageFormatSettings_file_format_set(PointerRNA *ptr, int value);

float ImageFormatSettings_cineon_gamma_get(PointerRNA *ptr);
void ImageFormatSettings_cineon_gamma_set(PointerRNA *ptr, float value);

bool ImageFormatSettings_has_linear_colorspace_get(PointerRNA *ptr);
void ImageFormatSettings_has_linear_colorspace_set(PointerRNA *ptr, bool value);

bool ImageFormatSettings_use_cineon_log_get(PointerRNA *ptr);
void ImageFormatSettings_use_cineon_log_set(PointerRNA *ptr, bool value);

bool ImageFormatSettings_use_preview_get(PointerRNA *ptr);
void ImageFormatSettings_use_preview_set(PointerRNA *ptr, bool value);

int ImageFormatSettings_quality_get(PointerRNA *ptr);
void ImageFormatSettings_quality_set(PointerRNA *ptr, int value);

PointerRNA ImageFormatSettings_stereo_3d_format_get(PointerRNA *ptr);

PointerRNA ImageFormatSettings_view_settings_get(PointerRNA *ptr);

enum {
	ImageFormatSettings_views_format_INDIVIDUAL = 0,
	ImageFormatSettings_views_format_STEREO_3D = 1,
	ImageFormatSettings_views_format_MULTIVIEW = 2,
};

int ImageFormatSettings_views_format_get(PointerRNA *ptr);
void ImageFormatSettings_views_format_set(PointerRNA *ptr, int value);

int ImageFormatSettings_cineon_white_get(PointerRNA *ptr);
void ImageFormatSettings_cineon_white_set(PointerRNA *ptr, int value);

bool ImageFormatSettings_use_jpeg2k_ycc_get(PointerRNA *ptr);
void ImageFormatSettings_use_jpeg2k_ycc_set(PointerRNA *ptr, bool value);

/**************** ImagePackedFile ****************/

extern StructRNA RNA_ImagePackedFile;

PointerRNA ImagePackedFile_rna_type_get(PointerRNA *ptr);

PointerRNA ImagePackedFile_packed_file_get(PointerRNA *ptr);

int ImagePackedFile_tile_number_get(PointerRNA *ptr);
void ImagePackedFile_tile_number_set(PointerRNA *ptr, int value);

int ImagePackedFile_view_get(PointerRNA *ptr);
void ImagePackedFile_view_set(PointerRNA *ptr, int value);

#define ImagePackedFile_filepath_MAX 1024

void ImagePackedFile_filepath_get(PointerRNA *ptr, char *value);
int ImagePackedFile_filepath_length(PointerRNA *ptr);
void ImagePackedFile_filepath_set(PointerRNA *ptr, const char *value);

void ImagePackedFile_save_func(struct ImagePackedFile *_self, Main *bmain, ReportList *reports);
/**************** Image Paint ****************/

extern StructRNA RNA_ImagePaint;
extern StructRNA RNA_Paint;

int ImagePaint_normal_angle_get(PointerRNA *ptr);
void ImagePaint_normal_angle_set(PointerRNA *ptr, int value);

int ImagePaint_seam_bleed_get(PointerRNA *ptr);
void ImagePaint_seam_bleed_set(PointerRNA *ptr, int value);

PointerRNA ImagePaint_canvas_get(PointerRNA *ptr);

float ImagePaint_clone_alpha_get(PointerRNA *ptr);
void ImagePaint_clone_alpha_set(PointerRNA *ptr, float value);

PointerRNA ImagePaint_clone_image_get(PointerRNA *ptr);

bool ImagePaint_use_clone_layer_get(PointerRNA *ptr);
void ImagePaint_use_clone_layer_set(PointerRNA *ptr, bool value);

void ImagePaint_clone_offset_get(PointerRNA *ptr, float values[2]);
void ImagePaint_clone_offset_set(PointerRNA *ptr, const float values[2]);

bool ImagePaint_use_backface_culling_get(PointerRNA *ptr);
void ImagePaint_use_backface_culling_set(PointerRNA *ptr, bool value);

float ImagePaint_dither_get(PointerRNA *ptr);
void ImagePaint_dither_set(PointerRNA *ptr, float value);

enum {
	ImagePaint_interpolation_LINEAR = 0,
	ImagePaint_interpolation_CLOSEST = 1,
};

int ImagePaint_interpolation_get(PointerRNA *ptr);
void ImagePaint_interpolation_set(PointerRNA *ptr, int value);

bool ImagePaint_invert_stencil_get(PointerRNA *ptr);
void ImagePaint_invert_stencil_set(PointerRNA *ptr, bool value);

bool ImagePaint_missing_materials_get(PointerRNA *ptr);
void ImagePaint_missing_materials_set(PointerRNA *ptr, bool value);

bool ImagePaint_missing_stencil_get(PointerRNA *ptr);
void ImagePaint_missing_stencil_set(PointerRNA *ptr, bool value);

bool ImagePaint_missing_texture_get(PointerRNA *ptr);
void ImagePaint_missing_texture_set(PointerRNA *ptr, bool value);

bool ImagePaint_missing_uvs_get(PointerRNA *ptr);
void ImagePaint_missing_uvs_set(PointerRNA *ptr, bool value);

enum {
	ImagePaint_mode_MATERIAL = 0,
	ImagePaint_mode_IMAGE = 1,
};

int ImagePaint_mode_get(PointerRNA *ptr);
void ImagePaint_mode_set(PointerRNA *ptr, int value);

bool ImagePaint_use_normal_falloff_get(PointerRNA *ptr);
void ImagePaint_use_normal_falloff_set(PointerRNA *ptr, bool value);

bool ImagePaint_use_occlude_get(PointerRNA *ptr);
void ImagePaint_use_occlude_set(PointerRNA *ptr, bool value);

void ImagePaint_screen_grab_size_get(PointerRNA *ptr, int values[2]);
void ImagePaint_screen_grab_size_set(PointerRNA *ptr, const int values[2]);

void ImagePaint_stencil_color_get(PointerRNA *ptr, float values[3]);
void ImagePaint_stencil_color_set(PointerRNA *ptr, const float values[3]);

PointerRNA ImagePaint_stencil_image_get(PointerRNA *ptr);

bool ImagePaint_use_stencil_layer_get(PointerRNA *ptr);
void ImagePaint_use_stencil_layer_set(PointerRNA *ptr, bool value);

bool ImagePaint_detect_data_func(struct ImagePaintSettings *_self);
/**************** Image Preview ****************/

extern StructRNA RNA_ImagePreview;

PointerRNA ImagePreview_rna_type_get(PointerRNA *ptr);

bool ImagePreview_is_icon_custom_get(PointerRNA *ptr);
void ImagePreview_is_icon_custom_set(PointerRNA *ptr, bool value);

bool ImagePreview_is_image_custom_get(PointerRNA *ptr);
void ImagePreview_is_image_custom_set(PointerRNA *ptr, bool value);

void ImagePreview_icon_pixels_float_get(PointerRNA *ptr, float values[]);
void ImagePreview_icon_pixels_float_set(PointerRNA *ptr, const float values[]);int ImagePreview_icon_pixels_float_get_length(PointerRNA *ptr, int *arraylen);

void ImagePreview_image_pixels_float_get(PointerRNA *ptr, float values[]);
void ImagePreview_image_pixels_float_set(PointerRNA *ptr, const float values[]);int ImagePreview_image_pixels_float_get_length(PointerRNA *ptr, int *arraylen);

int ImagePreview_icon_id_get(PointerRNA *ptr);
void ImagePreview_icon_id_set(PointerRNA *ptr, int value);

void ImagePreview_icon_pixels_get(PointerRNA *ptr, int values[]);
void ImagePreview_icon_pixels_set(PointerRNA *ptr, const int values[]);
int ImagePreview_icon_pixels_get_length(PointerRNA *ptr, int *arraylen);

void ImagePreview_icon_size_get(PointerRNA *ptr, int values[2]);
void ImagePreview_icon_size_set(PointerRNA *ptr, const int values[2]);

void ImagePreview_image_pixels_get(PointerRNA *ptr, int values[]);
void ImagePreview_image_pixels_set(PointerRNA *ptr, const int values[]);
int ImagePreview_image_pixels_get_length(PointerRNA *ptr, int *arraylen);

void ImagePreview_image_size_get(PointerRNA *ptr, int values[2]);
void ImagePreview_image_size_set(PointerRNA *ptr, const int values[2]);

void ImagePreview_reload_func(struct PreviewImage *_self);
/**************** Image Strip ****************/

extern StructRNA RNA_ImageStrip;
extern StructRNA RNA_Strip;

enum {
	ImageStrip_alpha_mode_STRAIGHT = 0,
	ImageStrip_alpha_mode_PREMUL = 1,
};

int ImageStrip_alpha_mode_get(PointerRNA *ptr);
void ImageStrip_alpha_mode_set(PointerRNA *ptr, int value);

int ImageStrip_animation_offset_end_get(PointerRNA *ptr);
void ImageStrip_animation_offset_end_set(PointerRNA *ptr, int value);

int ImageStrip_animation_offset_start_get(PointerRNA *ptr);
void ImageStrip_animation_offset_start_set(PointerRNA *ptr, int value);

PointerRNA ImageStrip_colorspace_settings_get(PointerRNA *ptr);

bool ImageStrip_use_float_get(PointerRNA *ptr);
void ImageStrip_use_float_set(PointerRNA *ptr, bool value);

PointerRNA ImageStrip_crop_get(PointerRNA *ptr);

bool ImageStrip_use_deinterlace_get(PointerRNA *ptr);
void ImageStrip_use_deinterlace_set(PointerRNA *ptr, bool value);

#define ImageStrip_directory_MAX 768

void ImageStrip_directory_get(PointerRNA *ptr, char *value);
int ImageStrip_directory_length(PointerRNA *ptr);
void ImageStrip_directory_set(PointerRNA *ptr, const char *value);

void ImageStrip_elements_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ImageStrip_elements_next(CollectionPropertyIterator *iter);
void ImageStrip_elements_end(CollectionPropertyIterator *iter);
int ImageStrip_elements_length(PointerRNA *ptr);
bool ImageStrip_elements_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool ImageStrip_use_flip_x_get(PointerRNA *ptr);
void ImageStrip_use_flip_x_set(PointerRNA *ptr, bool value);

bool ImageStrip_use_flip_y_get(PointerRNA *ptr);
void ImageStrip_use_flip_y_set(PointerRNA *ptr, bool value);

bool ImageStrip_multiply_alpha_get(PointerRNA *ptr);
void ImageStrip_multiply_alpha_set(PointerRNA *ptr, bool value);

float ImageStrip_color_multiply_get(PointerRNA *ptr);
void ImageStrip_color_multiply_set(PointerRNA *ptr, float value);

PointerRNA ImageStrip_proxy_get(PointerRNA *ptr);

void ImageStrip_retiming_keys_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ImageStrip_retiming_keys_next(CollectionPropertyIterator *iter);
void ImageStrip_retiming_keys_end(CollectionPropertyIterator *iter);
int ImageStrip_retiming_keys_length(PointerRNA *ptr);
bool ImageStrip_retiming_keys_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool ImageStrip_use_reverse_frames_get(PointerRNA *ptr);
void ImageStrip_use_reverse_frames_set(PointerRNA *ptr, bool value);

float ImageStrip_color_saturation_get(PointerRNA *ptr);
void ImageStrip_color_saturation_set(PointerRNA *ptr, float value);

PointerRNA ImageStrip_stereo_3d_format_get(PointerRNA *ptr);

float ImageStrip_strobe_get(PointerRNA *ptr);
void ImageStrip_strobe_set(PointerRNA *ptr, float value);

PointerRNA ImageStrip_transform_get(PointerRNA *ptr);

bool ImageStrip_use_multiview_get(PointerRNA *ptr);
void ImageStrip_use_multiview_set(PointerRNA *ptr, bool value);

bool ImageStrip_use_proxy_get(PointerRNA *ptr);
void ImageStrip_use_proxy_set(PointerRNA *ptr, bool value);

enum {
	ImageStrip_views_format_INDIVIDUAL = 0,
	ImageStrip_views_format_STEREO_3D = 1,
};

int ImageStrip_views_format_get(PointerRNA *ptr);
void ImageStrip_views_format_set(PointerRNA *ptr, int value);

/**************** Image Texture ****************/

extern StructRNA RNA_ImageTexture;
extern StructRNA RNA_Texture;
extern StructRNA RNA_ID;

bool ImageTexture_use_calculate_alpha_get(PointerRNA *ptr);
void ImageTexture_use_calculate_alpha_set(PointerRNA *ptr, bool value);

float ImageTexture_checker_distance_get(PointerRNA *ptr);
void ImageTexture_checker_distance_set(PointerRNA *ptr, float value);

bool ImageTexture_use_checker_even_get(PointerRNA *ptr);
void ImageTexture_use_checker_even_set(PointerRNA *ptr, bool value);

bool ImageTexture_use_checker_odd_get(PointerRNA *ptr);
void ImageTexture_use_checker_odd_set(PointerRNA *ptr, bool value);

float ImageTexture_crop_max_x_get(PointerRNA *ptr);
void ImageTexture_crop_max_x_set(PointerRNA *ptr, float value);

float ImageTexture_crop_max_y_get(PointerRNA *ptr);
void ImageTexture_crop_max_y_set(PointerRNA *ptr, float value);

float ImageTexture_crop_min_x_get(PointerRNA *ptr);
void ImageTexture_crop_min_x_set(PointerRNA *ptr, float value);

float ImageTexture_crop_min_y_get(PointerRNA *ptr);
void ImageTexture_crop_min_y_set(PointerRNA *ptr, float value);

enum {
	ImageTexture_extension_EXTEND = 1,
	ImageTexture_extension_CLIP = 2,
	ImageTexture_extension_CLIP_CUBE = 4,
	ImageTexture_extension_REPEAT = 3,
	ImageTexture_extension_CHECKER = 5,
};

int ImageTexture_extension_get(PointerRNA *ptr);
void ImageTexture_extension_set(PointerRNA *ptr, int value);

enum {
	ImageTexture_filter_type_BOX = 0,
	ImageTexture_filter_type_EWA = 1,
	ImageTexture_filter_type_FELINE = 2,
	ImageTexture_filter_type_AREA = 3,
};

int ImageTexture_filter_type_get(PointerRNA *ptr);
void ImageTexture_filter_type_set(PointerRNA *ptr, int value);

int ImageTexture_filter_eccentricity_get(PointerRNA *ptr);
void ImageTexture_filter_eccentricity_set(PointerRNA *ptr, int value);

int ImageTexture_filter_lightprobes_get(PointerRNA *ptr);
void ImageTexture_filter_lightprobes_set(PointerRNA *ptr, int value);

float ImageTexture_filter_size_get(PointerRNA *ptr);
void ImageTexture_filter_size_set(PointerRNA *ptr, float value);

bool ImageTexture_use_flip_axis_get(PointerRNA *ptr);
void ImageTexture_use_flip_axis_set(PointerRNA *ptr, bool value);

PointerRNA ImageTexture_image_get(PointerRNA *ptr);

PointerRNA ImageTexture_image_user_get(PointerRNA *ptr);

bool ImageTexture_use_interpolation_get(PointerRNA *ptr);
void ImageTexture_use_interpolation_set(PointerRNA *ptr, bool value);

bool ImageTexture_invert_alpha_get(PointerRNA *ptr);
void ImageTexture_invert_alpha_set(PointerRNA *ptr, bool value);

bool ImageTexture_use_mipmap_get(PointerRNA *ptr);
void ImageTexture_use_mipmap_set(PointerRNA *ptr, bool value);

bool ImageTexture_use_mipmap_gauss_get(PointerRNA *ptr);
void ImageTexture_use_mipmap_gauss_set(PointerRNA *ptr, bool value);

bool ImageTexture_use_filter_size_min_get(PointerRNA *ptr);
void ImageTexture_use_filter_size_min_set(PointerRNA *ptr, bool value);

bool ImageTexture_use_mirror_x_get(PointerRNA *ptr);
void ImageTexture_use_mirror_x_set(PointerRNA *ptr, bool value);

bool ImageTexture_use_mirror_y_get(PointerRNA *ptr);
void ImageTexture_use_mirror_y_set(PointerRNA *ptr, bool value);

bool ImageTexture_use_normal_map_get(PointerRNA *ptr);
void ImageTexture_use_normal_map_set(PointerRNA *ptr, bool value);

int ImageTexture_repeat_x_get(PointerRNA *ptr);
void ImageTexture_repeat_x_set(PointerRNA *ptr, int value);

int ImageTexture_repeat_y_get(PointerRNA *ptr);
void ImageTexture_repeat_y_set(PointerRNA *ptr, int value);

bool ImageTexture_use_alpha_get(PointerRNA *ptr);
void ImageTexture_use_alpha_set(PointerRNA *ptr, bool value);

/**************** Image User ****************/

extern StructRNA RNA_ImageUser;

PointerRNA ImageUser_rna_type_get(PointerRNA *ptr);

bool ImageUser_use_auto_refresh_get(PointerRNA *ptr);
void ImageUser_use_auto_refresh_set(PointerRNA *ptr, bool value);

int ImageUser_frame_current_get(PointerRNA *ptr);
void ImageUser_frame_current_set(PointerRNA *ptr, int value);

bool ImageUser_use_cyclic_get(PointerRNA *ptr);
void ImageUser_use_cyclic_set(PointerRNA *ptr, bool value);

int ImageUser_frame_duration_get(PointerRNA *ptr);
void ImageUser_frame_duration_set(PointerRNA *ptr, int value);

int ImageUser_multilayer_layer_get(PointerRNA *ptr);
void ImageUser_multilayer_layer_set(PointerRNA *ptr, int value);

int ImageUser_frame_offset_get(PointerRNA *ptr);
void ImageUser_frame_offset_set(PointerRNA *ptr, int value);

int ImageUser_multilayer_pass_get(PointerRNA *ptr);
void ImageUser_multilayer_pass_set(PointerRNA *ptr, int value);

int ImageUser_frame_start_get(PointerRNA *ptr);
void ImageUser_frame_start_set(PointerRNA *ptr, int value);

int ImageUser_tile_get(PointerRNA *ptr);
void ImageUser_tile_set(PointerRNA *ptr, int value);

int ImageUser_multilayer_view_get(PointerRNA *ptr);
void ImageUser_multilayer_view_set(PointerRNA *ptr, int value);

/**************** Index Switch Item ****************/

extern StructRNA RNA_IndexSwitchItem;

PointerRNA IndexSwitchItem_rna_type_get(PointerRNA *ptr);

int IndexSwitchItem_identifier_get(PointerRNA *ptr);
void IndexSwitchItem_identifier_set(PointerRNA *ptr, int value);

/**************** 2D Integer Vector Attribute ****************/

extern StructRNA RNA_Int2Attribute;
extern StructRNA RNA_Attribute;

void Int2Attribute_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Int2Attribute_data_next(CollectionPropertyIterator *iter);
void Int2Attribute_data_end(CollectionPropertyIterator *iter);
int Int2Attribute_data_length(PointerRNA *ptr);
bool Int2Attribute_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** 2D Integer Vector Attribute Value ****************/

extern StructRNA RNA_Int2AttributeValue;

PointerRNA Int2AttributeValue_rna_type_get(PointerRNA *ptr);

void Int2AttributeValue_value_get(PointerRNA *ptr, int values[2]);
void Int2AttributeValue_value_set(PointerRNA *ptr, const int values[2]);

/**************** Integer Attribute ****************/

extern StructRNA RNA_IntAttribute;
extern StructRNA RNA_Attribute;

void IntAttribute_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void IntAttribute_data_next(CollectionPropertyIterator *iter);
void IntAttribute_data_end(CollectionPropertyIterator *iter);
int IntAttribute_data_length(PointerRNA *ptr);
bool IntAttribute_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Integer Attribute Value ****************/

extern StructRNA RNA_IntAttributeValue;

PointerRNA IntAttributeValue_rna_type_get(PointerRNA *ptr);

int IntAttributeValue_value_get(PointerRNA *ptr);
void IntAttributeValue_value_set(PointerRNA *ptr, int value);

/**************** Int Definition ****************/

extern StructRNA RNA_IntProperty;
extern StructRNA RNA_Property;

void IntProperty_array_dimensions_get(PointerRNA *ptr, int values[3]);
void IntProperty_array_dimensions_set(PointerRNA *ptr, const int values[3]);

int IntProperty_array_length_get(PointerRNA *ptr);
void IntProperty_array_length_set(PointerRNA *ptr, int value);

int IntProperty_default_value_get(PointerRNA *ptr);
void IntProperty_default_value_set(PointerRNA *ptr, int value);

void IntProperty_default_array_get(PointerRNA *ptr, int values[]);
void IntProperty_default_array_set(PointerRNA *ptr, const int values[]);
int IntProperty_default_array_get_length(PointerRNA *ptr, int *arraylen);

int IntProperty_hard_max_get(PointerRNA *ptr);
void IntProperty_hard_max_set(PointerRNA *ptr, int value);

int IntProperty_hard_min_get(PointerRNA *ptr);
void IntProperty_hard_min_set(PointerRNA *ptr, int value);

bool IntProperty_is_array_get(PointerRNA *ptr);
void IntProperty_is_array_set(PointerRNA *ptr, bool value);

int IntProperty_soft_max_get(PointerRNA *ptr);
void IntProperty_soft_max_set(PointerRNA *ptr, int value);

int IntProperty_soft_min_get(PointerRNA *ptr);
void IntProperty_soft_min_set(PointerRNA *ptr, int value);

int IntProperty_step_get(PointerRNA *ptr);
void IntProperty_step_set(PointerRNA *ptr, int value);

/**************** bItasc ****************/

extern StructRNA RNA_Itasc;
extern StructRNA RNA_IKParam;

bool Itasc_use_auto_step_get(PointerRNA *ptr);
void Itasc_use_auto_step_set(PointerRNA *ptr, bool value);

float Itasc_damping_max_get(PointerRNA *ptr);
void Itasc_damping_max_set(PointerRNA *ptr, float value);

float Itasc_damping_epsilon_get(PointerRNA *ptr);
void Itasc_damping_epsilon_set(PointerRNA *ptr, float value);

float Itasc_feedback_get(PointerRNA *ptr);
void Itasc_feedback_set(PointerRNA *ptr, float value);

int Itasc_iterations_get(PointerRNA *ptr);
void Itasc_iterations_set(PointerRNA *ptr, int value);

float Itasc_step_max_get(PointerRNA *ptr);
void Itasc_step_max_set(PointerRNA *ptr, float value);

float Itasc_velocity_max_get(PointerRNA *ptr);
void Itasc_velocity_max_set(PointerRNA *ptr, float value);

float Itasc_step_min_get(PointerRNA *ptr);
void Itasc_step_min_set(PointerRNA *ptr, float value);

enum {
	Itasc_mode_ANIMATION = 0,
	Itasc_mode_SIMULATION = 8,
};

int Itasc_mode_get(PointerRNA *ptr);
void Itasc_mode_set(PointerRNA *ptr, int value);

int Itasc_step_count_get(PointerRNA *ptr);
void Itasc_step_count_set(PointerRNA *ptr, int value);

float Itasc_precision_get(PointerRNA *ptr);
void Itasc_precision_set(PointerRNA *ptr, float value);

enum {
	Itasc_reiteration_method_NEVER = 0,
	Itasc_reiteration_method_INITIAL = 2,
	Itasc_reiteration_method_ALWAYS = 6,
};

int Itasc_reiteration_method_get(PointerRNA *ptr);
void Itasc_reiteration_method_set(PointerRNA *ptr, int value);

enum {
	Itasc_solver_SDLS = 0,
	Itasc_solver_DLS = 1,
};

int Itasc_solver_get(PointerRNA *ptr);
void Itasc_solver_set(PointerRNA *ptr, int value);

bool Itasc_translate_root_bones_get(PointerRNA *ptr);
void Itasc_translate_root_bones_set(PointerRNA *ptr, bool value);

/**************** Key ****************/

extern StructRNA RNA_Key;
extern StructRNA RNA_ID;

PointerRNA Key_animation_data_get(PointerRNA *ptr);

float Key_eval_time_get(PointerRNA *ptr);
void Key_eval_time_set(PointerRNA *ptr, float value);

void Key_key_blocks_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Key_key_blocks_next(CollectionPropertyIterator *iter);
void Key_key_blocks_end(CollectionPropertyIterator *iter);
bool Key_key_blocks_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Key_key_blocks_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

PointerRNA Key_reference_key_get(PointerRNA *ptr);

bool Key_use_relative_get(PointerRNA *ptr);
void Key_use_relative_set(PointerRNA *ptr, bool value);

PointerRNA Key_user_get(PointerRNA *ptr);

/**************** Key Configuration ****************/

extern StructRNA RNA_KeyConfig;

PointerRNA KeyConfig_rna_type_get(PointerRNA *ptr);

#define KeyConfig_name_MAX 64

void KeyConfig_name_get(PointerRNA *ptr, char *value);
int KeyConfig_name_length(PointerRNA *ptr);
void KeyConfig_name_set(PointerRNA *ptr, const char *value);

void KeyConfig_keymaps_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void KeyConfig_keymaps_next(CollectionPropertyIterator *iter);
void KeyConfig_keymaps_end(CollectionPropertyIterator *iter);
bool KeyConfig_keymaps_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool KeyConfig_keymaps_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool KeyConfig_is_user_defined_get(PointerRNA *ptr);
void KeyConfig_is_user_defined_set(PointerRNA *ptr, bool value);

PointerRNA KeyConfig_preferences_get(PointerRNA *ptr);

/**************** Key-Config Preferences ****************/

extern StructRNA RNA_KeyConfigPreferences;

PointerRNA KeyConfigPreferences_rna_type_get(PointerRNA *ptr);

#define KeyConfigPreferences_bl_idname_MAX 64

void KeyConfigPreferences_bl_idname_get(PointerRNA *ptr, char *value);
int KeyConfigPreferences_bl_idname_length(PointerRNA *ptr);
void KeyConfigPreferences_bl_idname_set(PointerRNA *ptr, const char *value);

/**************** KeyConfigs ****************/

extern StructRNA RNA_KeyConfigurations;

PointerRNA KeyConfigurations_rna_type_get(PointerRNA *ptr);

PointerRNA KeyConfigurations_active_get(PointerRNA *ptr);

PointerRNA KeyConfigurations_addon_get(PointerRNA *ptr);

PointerRNA KeyConfigurations_default_value_get(PointerRNA *ptr);

PointerRNA KeyConfigurations_user_get(PointerRNA *ptr);

struct wmKeyConfig *KeyConfigurations_new_func(struct wmWindowManager *_self, const char * name);
void KeyConfigurations_remove_func(struct wmWindowManager *_self, ReportList *reports, struct PointerRNA *keyconfig);
struct PointerRNA KeyConfigurations_find_item_from_operator_func(struct wmWindowManager *_self, bContext *C, const char * idname, int context, struct PointerRNA *properties, int include, int exclude, struct PointerRNA *keymap);
void KeyConfigurations_update_func(struct wmWindowManager *_self, bool keep_properties);
/**************** Key Map ****************/

extern StructRNA RNA_KeyMap;

PointerRNA KeyMap_rna_type_get(PointerRNA *ptr);

#define KeyMap_name_MAX 64

void KeyMap_name_get(PointerRNA *ptr, char *value);
int KeyMap_name_length(PointerRNA *ptr);
void KeyMap_name_set(PointerRNA *ptr, const char *value);

bool KeyMap_show_expanded_children_get(PointerRNA *ptr);
void KeyMap_show_expanded_children_set(PointerRNA *ptr, bool value);

void KeyMap_keymap_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void KeyMap_keymap_items_next(CollectionPropertyIterator *iter);
void KeyMap_keymap_items_end(CollectionPropertyIterator *iter);
bool KeyMap_keymap_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool KeyMap_keymap_items_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool KeyMap_show_expanded_items_get(PointerRNA *ptr);
void KeyMap_show_expanded_items_set(PointerRNA *ptr, bool value);

void KeyMap_modal_event_values_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void KeyMap_modal_event_values_next(CollectionPropertyIterator *iter);
void KeyMap_modal_event_values_end(CollectionPropertyIterator *iter);

bool KeyMap_is_modal_get(PointerRNA *ptr);
void KeyMap_is_modal_set(PointerRNA *ptr, bool value);

#define KeyMap_bl_owner_id_MAX 128

void KeyMap_bl_owner_id_get(PointerRNA *ptr, char *value);
int KeyMap_bl_owner_id_length(PointerRNA *ptr);
void KeyMap_bl_owner_id_set(PointerRNA *ptr, const char *value);

enum {
	KeyMap_region_type_WINDOW = 0,
	KeyMap_region_type_HEADER = 1,
	KeyMap_region_type_CHANNELS = 2,
	KeyMap_region_type_TEMPORARY = 3,
	KeyMap_region_type_UI = 4,
	KeyMap_region_type_TOOLS = 5,
	KeyMap_region_type_TOOL_PROPS = 6,
	KeyMap_region_type_ASSET_SHELF = 14,
	KeyMap_region_type_ASSET_SHELF_HEADER = 15,
	KeyMap_region_type_PREVIEW = 7,
	KeyMap_region_type_HUD = 8,
	KeyMap_region_type_NAVIGATION_BAR = 9,
	KeyMap_region_type_EXECUTE = 10,
	KeyMap_region_type_FOOTER = 11,
	KeyMap_region_type_TOOL_HEADER = 12,
	KeyMap_region_type_XR = 13,
};

int KeyMap_region_type_get(PointerRNA *ptr);
void KeyMap_region_type_set(PointerRNA *ptr, int value);

enum {
	KeyMap_space_type_EMPTY = 0,
	KeyMap_space_type_VIEW_3D = 1,
	KeyMap_space_type_IMAGE_EDITOR = 6,
	KeyMap_space_type_NODE_EDITOR = 16,
	KeyMap_space_type_SEQUENCE_EDITOR = 8,
	KeyMap_space_type_CLIP_EDITOR = 20,
	KeyMap_space_type_DOPESHEET_EDITOR = 12,
	KeyMap_space_type_GRAPH_EDITOR = 2,
	KeyMap_space_type_NLA_EDITOR = 13,
	KeyMap_space_type_TEXT_EDITOR = 9,
	KeyMap_space_type_CONSOLE = 18,
	KeyMap_space_type_INFO = 7,
	KeyMap_space_type_TOPBAR = 21,
	KeyMap_space_type_STATUSBAR = 22,
	KeyMap_space_type_OUTLINER = 3,
	KeyMap_space_type_PROPERTIES = 4,
	KeyMap_space_type_FILE_BROWSER = 5,
	KeyMap_space_type_SPREADSHEET = 23,
	KeyMap_space_type_PREFERENCES = 19,
};

int KeyMap_space_type_get(PointerRNA *ptr);
void KeyMap_space_type_set(PointerRNA *ptr, int value);

bool KeyMap_is_user_modified_get(PointerRNA *ptr);
void KeyMap_is_user_modified_set(PointerRNA *ptr, bool value);

struct wmKeyMap *KeyMap_active_func(struct wmKeyMap *_self, bContext *C);
void KeyMap_restore_to_default_func(struct wmKeyMap *_self, bContext *C);
void KeyMap_restore_item_to_default_func(struct wmKeyMap *_self, bContext *C, struct wmKeyMapItem *item);
/**************** Key Map Item ****************/

extern StructRNA RNA_KeyMapItem;

PointerRNA KeyMapItem_rna_type_get(PointerRNA *ptr);

void KeyMapItem_name_get(PointerRNA *ptr, char *value);
int KeyMapItem_name_length(PointerRNA *ptr);
void KeyMapItem_name_set(PointerRNA *ptr, const char *value);

bool KeyMapItem_active_get(PointerRNA *ptr);
void KeyMapItem_active_set(PointerRNA *ptr, bool value);

int KeyMapItem_alt_get(PointerRNA *ptr);
void KeyMapItem_alt_set(PointerRNA *ptr, int value);

bool KeyMapItem_alt_ui_get(PointerRNA *ptr);
void KeyMapItem_alt_ui_set(PointerRNA *ptr, bool value);

bool KeyMapItem_any_get(PointerRNA *ptr);
void KeyMapItem_any_set(PointerRNA *ptr, bool value);

int KeyMapItem_ctrl_get(PointerRNA *ptr);
void KeyMapItem_ctrl_set(PointerRNA *ptr, int value);

bool KeyMapItem_ctrl_ui_get(PointerRNA *ptr);
void KeyMapItem_ctrl_ui_set(PointerRNA *ptr, bool value);

enum {
	KeyMapItem_direction_ANY = -1,
	KeyMapItem_direction_NORTH = 1,
	KeyMapItem_direction_NORTH_EAST = 2,
	KeyMapItem_direction_EAST = 3,
	KeyMapItem_direction_SOUTH_EAST = 4,
	KeyMapItem_direction_SOUTH = 5,
	KeyMapItem_direction_SOUTH_WEST = 6,
	KeyMapItem_direction_WEST = 7,
	KeyMapItem_direction_NORTH_WEST = 8,
};

int KeyMapItem_direction_get(PointerRNA *ptr);
void KeyMapItem_direction_set(PointerRNA *ptr, int value);

bool KeyMapItem_show_expanded_get(PointerRNA *ptr);
void KeyMapItem_show_expanded_set(PointerRNA *ptr, bool value);

int KeyMapItem_hyper_get(PointerRNA *ptr);
void KeyMapItem_hyper_set(PointerRNA *ptr, int value);

bool KeyMapItem_hyper_ui_get(PointerRNA *ptr);
void KeyMapItem_hyper_ui_set(PointerRNA *ptr, bool value);

int KeyMapItem_id_get(PointerRNA *ptr);
void KeyMapItem_id_set(PointerRNA *ptr, int value);

#define KeyMapItem_idname_MAX 64

void KeyMapItem_idname_get(PointerRNA *ptr, char *value);
int KeyMapItem_idname_length(PointerRNA *ptr);
void KeyMapItem_idname_set(PointerRNA *ptr, const char *value);

enum {
	KeyMapItem_key_modifier_NONE = 0,
	KeyMapItem_key_modifier_LEFTMOUSE = 1,
	KeyMapItem_key_modifier_MIDDLEMOUSE = 2,
	KeyMapItem_key_modifier_RIGHTMOUSE = 3,
	KeyMapItem_key_modifier_BUTTON4MOUSE = 7,
	KeyMapItem_key_modifier_BUTTON5MOUSE = 8,
	KeyMapItem_key_modifier_BUTTON6MOUSE = 18,
	KeyMapItem_key_modifier_BUTTON7MOUSE = 19,
	KeyMapItem_key_modifier_PEN = 26,
	KeyMapItem_key_modifier_ERASER = 27,
	KeyMapItem_key_modifier_MOUSEMOVE = 4,
	KeyMapItem_key_modifier_INBETWEEN_MOUSEMOVE = 17,
	KeyMapItem_key_modifier_TRACKPADPAN = 14,
	KeyMapItem_key_modifier_TRACKPADZOOM = 15,
	KeyMapItem_key_modifier_MOUSEROTATE = 16,
	KeyMapItem_key_modifier_MOUSESMARTZOOM = 23,
	KeyMapItem_key_modifier_WHEELUPMOUSE = 10,
	KeyMapItem_key_modifier_WHEELDOWNMOUSE = 11,
	KeyMapItem_key_modifier_WHEELINMOUSE = 12,
	KeyMapItem_key_modifier_WHEELOUTMOUSE = 13,
	KeyMapItem_key_modifier_WHEELLEFTMOUSE = 20,
	KeyMapItem_key_modifier_WHEELRIGHTMOUSE = 21,
	KeyMapItem_key_modifier_A = 97,
	KeyMapItem_key_modifier_B = 98,
	KeyMapItem_key_modifier_C = 99,
	KeyMapItem_key_modifier_D = 100,
	KeyMapItem_key_modifier_E = 101,
	KeyMapItem_key_modifier_F = 102,
	KeyMapItem_key_modifier_G = 103,
	KeyMapItem_key_modifier_H = 104,
	KeyMapItem_key_modifier_I = 105,
	KeyMapItem_key_modifier_J = 106,
	KeyMapItem_key_modifier_K = 107,
	KeyMapItem_key_modifier_L = 108,
	KeyMapItem_key_modifier_M = 109,
	KeyMapItem_key_modifier_N = 110,
	KeyMapItem_key_modifier_O = 111,
	KeyMapItem_key_modifier_P = 112,
	KeyMapItem_key_modifier_Q = 113,
	KeyMapItem_key_modifier_R = 114,
	KeyMapItem_key_modifier_S = 115,
	KeyMapItem_key_modifier_T = 116,
	KeyMapItem_key_modifier_U = 117,
	KeyMapItem_key_modifier_V = 118,
	KeyMapItem_key_modifier_W = 119,
	KeyMapItem_key_modifier_X = 120,
	KeyMapItem_key_modifier_Y = 121,
	KeyMapItem_key_modifier_Z = 122,
	KeyMapItem_key_modifier_ZERO = 48,
	KeyMapItem_key_modifier_ONE = 49,
	KeyMapItem_key_modifier_TWO = 50,
	KeyMapItem_key_modifier_THREE = 51,
	KeyMapItem_key_modifier_FOUR = 52,
	KeyMapItem_key_modifier_FIVE = 53,
	KeyMapItem_key_modifier_SIX = 54,
	KeyMapItem_key_modifier_SEVEN = 55,
	KeyMapItem_key_modifier_EIGHT = 56,
	KeyMapItem_key_modifier_NINE = 57,
	KeyMapItem_key_modifier_LEFT_CTRL = 212,
	KeyMapItem_key_modifier_LEFT_ALT = 213,
	KeyMapItem_key_modifier_LEFT_SHIFT = 217,
	KeyMapItem_key_modifier_RIGHT_ALT = 214,
	KeyMapItem_key_modifier_RIGHT_CTRL = 215,
	KeyMapItem_key_modifier_RIGHT_SHIFT = 216,
	KeyMapItem_key_modifier_OSKEY = 172,
	KeyMapItem_key_modifier_HYPER = 179,
	KeyMapItem_key_modifier_APP = 178,
	KeyMapItem_key_modifier_GRLESS = 173,
	KeyMapItem_key_modifier_ESC = 218,
	KeyMapItem_key_modifier_TAB = 219,
	KeyMapItem_key_modifier_RET = 220,
	KeyMapItem_key_modifier_SPACE = 221,
	KeyMapItem_key_modifier_LINE_FEED = 222,
	KeyMapItem_key_modifier_BACK_SPACE = 223,
	KeyMapItem_key_modifier_DEL = 224,
	KeyMapItem_key_modifier_SEMI_COLON = 225,
	KeyMapItem_key_modifier_PERIOD = 226,
	KeyMapItem_key_modifier_COMMA = 227,
	KeyMapItem_key_modifier_QUOTE = 228,
	KeyMapItem_key_modifier_ACCENT_GRAVE = 229,
	KeyMapItem_key_modifier_MINUS = 230,
	KeyMapItem_key_modifier_PLUS = 231,
	KeyMapItem_key_modifier_SLASH = 232,
	KeyMapItem_key_modifier_BACK_SLASH = 233,
	KeyMapItem_key_modifier_EQUAL = 234,
	KeyMapItem_key_modifier_LEFT_BRACKET = 235,
	KeyMapItem_key_modifier_RIGHT_BRACKET = 236,
	KeyMapItem_key_modifier_LEFT_ARROW = 137,
	KeyMapItem_key_modifier_DOWN_ARROW = 138,
	KeyMapItem_key_modifier_RIGHT_ARROW = 139,
	KeyMapItem_key_modifier_UP_ARROW = 140,
	KeyMapItem_key_modifier_NUMPAD_2 = 152,
	KeyMapItem_key_modifier_NUMPAD_4 = 154,
	KeyMapItem_key_modifier_NUMPAD_6 = 156,
	KeyMapItem_key_modifier_NUMPAD_8 = 158,
	KeyMapItem_key_modifier_NUMPAD_1 = 151,
	KeyMapItem_key_modifier_NUMPAD_3 = 153,
	KeyMapItem_key_modifier_NUMPAD_5 = 155,
	KeyMapItem_key_modifier_NUMPAD_7 = 157,
	KeyMapItem_key_modifier_NUMPAD_9 = 159,
	KeyMapItem_key_modifier_NUMPAD_PERIOD = 199,
	KeyMapItem_key_modifier_NUMPAD_SLASH = 161,
	KeyMapItem_key_modifier_NUMPAD_ASTERIX = 160,
	KeyMapItem_key_modifier_NUMPAD_0 = 150,
	KeyMapItem_key_modifier_NUMPAD_MINUS = 162,
	KeyMapItem_key_modifier_NUMPAD_ENTER = 163,
	KeyMapItem_key_modifier_NUMPAD_PLUS = 164,
	KeyMapItem_key_modifier_F1 = 300,
	KeyMapItem_key_modifier_F2 = 301,
	KeyMapItem_key_modifier_F3 = 302,
	KeyMapItem_key_modifier_F4 = 303,
	KeyMapItem_key_modifier_F5 = 304,
	KeyMapItem_key_modifier_F6 = 305,
	KeyMapItem_key_modifier_F7 = 306,
	KeyMapItem_key_modifier_F8 = 307,
	KeyMapItem_key_modifier_F9 = 308,
	KeyMapItem_key_modifier_F10 = 309,
	KeyMapItem_key_modifier_F11 = 310,
	KeyMapItem_key_modifier_F12 = 311,
	KeyMapItem_key_modifier_F13 = 312,
	KeyMapItem_key_modifier_F14 = 313,
	KeyMapItem_key_modifier_F15 = 314,
	KeyMapItem_key_modifier_F16 = 315,
	KeyMapItem_key_modifier_F17 = 316,
	KeyMapItem_key_modifier_F18 = 317,
	KeyMapItem_key_modifier_F19 = 318,
	KeyMapItem_key_modifier_F20 = 319,
	KeyMapItem_key_modifier_F21 = 320,
	KeyMapItem_key_modifier_F22 = 321,
	KeyMapItem_key_modifier_F23 = 322,
	KeyMapItem_key_modifier_F24 = 323,
	KeyMapItem_key_modifier_PAUSE = 165,
	KeyMapItem_key_modifier_INSERT = 166,
	KeyMapItem_key_modifier_HOME = 167,
	KeyMapItem_key_modifier_PAGE_UP = 168,
	KeyMapItem_key_modifier_PAGE_DOWN = 169,
	KeyMapItem_key_modifier_END = 170,
	KeyMapItem_key_modifier_MEDIA_PLAY = 174,
	KeyMapItem_key_modifier_MEDIA_STOP = 175,
	KeyMapItem_key_modifier_MEDIA_FIRST = 176,
	KeyMapItem_key_modifier_MEDIA_LAST = 177,
	KeyMapItem_key_modifier_TEXTINPUT = -2,
	KeyMapItem_key_modifier_WINDOW_DEACTIVATE = 260,
	KeyMapItem_key_modifier_TIMER = 272,
	KeyMapItem_key_modifier_TIMER0 = 273,
	KeyMapItem_key_modifier_TIMER1 = 274,
	KeyMapItem_key_modifier_TIMER2 = 275,
	KeyMapItem_key_modifier_TIMER_JOBS = 276,
	KeyMapItem_key_modifier_TIMER_AUTOSAVE = 277,
	KeyMapItem_key_modifier_TIMER_REPORT = 278,
	KeyMapItem_key_modifier_TIMERREGION = 279,
	KeyMapItem_key_modifier_NDOF_MOTION = 400,
	KeyMapItem_key_modifier_NDOF_BUTTON_MENU = 401,
	KeyMapItem_key_modifier_NDOF_BUTTON_FIT = 402,
	KeyMapItem_key_modifier_NDOF_BUTTON_TOP = 403,
	KeyMapItem_key_modifier_NDOF_BUTTON_BOTTOM = 404,
	KeyMapItem_key_modifier_NDOF_BUTTON_LEFT = 405,
	KeyMapItem_key_modifier_NDOF_BUTTON_RIGHT = 406,
	KeyMapItem_key_modifier_NDOF_BUTTON_FRONT = 407,
	KeyMapItem_key_modifier_NDOF_BUTTON_BACK = 408,
	KeyMapItem_key_modifier_NDOF_BUTTON_ISO1 = 409,
	KeyMapItem_key_modifier_NDOF_BUTTON_ISO2 = 410,
	KeyMapItem_key_modifier_NDOF_BUTTON_ROLL_CW = 411,
	KeyMapItem_key_modifier_NDOF_BUTTON_ROLL_CCW = 412,
	KeyMapItem_key_modifier_NDOF_BUTTON_SPIN_CW = 413,
	KeyMapItem_key_modifier_NDOF_BUTTON_SPIN_CCW = 414,
	KeyMapItem_key_modifier_NDOF_BUTTON_TILT_CW = 415,
	KeyMapItem_key_modifier_NDOF_BUTTON_TILT_CCW = 416,
	KeyMapItem_key_modifier_NDOF_BUTTON_ROTATE = 417,
	KeyMapItem_key_modifier_NDOF_BUTTON_PANZOOM = 418,
	KeyMapItem_key_modifier_NDOF_BUTTON_DOMINANT = 419,
	KeyMapItem_key_modifier_NDOF_BUTTON_PLUS = 420,
	KeyMapItem_key_modifier_NDOF_BUTTON_MINUS = 421,
	KeyMapItem_key_modifier_NDOF_BUTTON_V1 = 422,
	KeyMapItem_key_modifier_NDOF_BUTTON_V2 = 423,
	KeyMapItem_key_modifier_NDOF_BUTTON_V3 = 424,
	KeyMapItem_key_modifier_NDOF_BUTTON_SAVE_V1 = 446,
	KeyMapItem_key_modifier_NDOF_BUTTON_SAVE_V2 = 447,
	KeyMapItem_key_modifier_NDOF_BUTTON_SAVE_V3 = 448,
	KeyMapItem_key_modifier_NDOF_BUTTON_1 = 426,
	KeyMapItem_key_modifier_NDOF_BUTTON_2 = 427,
	KeyMapItem_key_modifier_NDOF_BUTTON_3 = 428,
	KeyMapItem_key_modifier_NDOF_BUTTON_4 = 429,
	KeyMapItem_key_modifier_NDOF_BUTTON_5 = 430,
	KeyMapItem_key_modifier_NDOF_BUTTON_6 = 431,
	KeyMapItem_key_modifier_NDOF_BUTTON_7 = 432,
	KeyMapItem_key_modifier_NDOF_BUTTON_8 = 433,
	KeyMapItem_key_modifier_NDOF_BUTTON_9 = 434,
	KeyMapItem_key_modifier_NDOF_BUTTON_10 = 435,
	KeyMapItem_key_modifier_NDOF_BUTTON_11 = 436,
	KeyMapItem_key_modifier_NDOF_BUTTON_12 = 437,
	KeyMapItem_key_modifier_ACTIONZONE_AREA = 20480,
	KeyMapItem_key_modifier_ACTIONZONE_REGION = 20481,
	KeyMapItem_key_modifier_ACTIONZONE_FULLSCREEN = 20497,
	KeyMapItem_key_modifier_XR_ACTION = 20528,
};

int KeyMapItem_key_modifier_get(PointerRNA *ptr);
void KeyMapItem_key_modifier_set(PointerRNA *ptr, int value);

enum {
	KeyMapItem_map_type_KEYBOARD = 0,
	KeyMapItem_map_type_MOUSE = 1,
	KeyMapItem_map_type_NDOF = 5,
	KeyMapItem_map_type_TEXTINPUT = 3,
	KeyMapItem_map_type_TIMER = 4,
};

int KeyMapItem_map_type_get(PointerRNA *ptr);
void KeyMapItem_map_type_set(PointerRNA *ptr, int value);

int KeyMapItem_oskey_get(PointerRNA *ptr);
void KeyMapItem_oskey_set(PointerRNA *ptr, int value);

bool KeyMapItem_oskey_ui_get(PointerRNA *ptr);
void KeyMapItem_oskey_ui_set(PointerRNA *ptr, bool value);

PointerRNA KeyMapItem_properties_get(PointerRNA *ptr);

enum {
	KeyMapItem_propvalue_NONE = 0,
};

int KeyMapItem_propvalue_get(PointerRNA *ptr);
void KeyMapItem_propvalue_set(PointerRNA *ptr, int value);

bool KeyMapItem_repeat_get(PointerRNA *ptr);
void KeyMapItem_repeat_set(PointerRNA *ptr, bool value);

int KeyMapItem_shift_get(PointerRNA *ptr);
void KeyMapItem_shift_set(PointerRNA *ptr, int value);

bool KeyMapItem_shift_ui_get(PointerRNA *ptr);
void KeyMapItem_shift_ui_set(PointerRNA *ptr, bool value);

enum {
	KeyMapItem_type_NONE = 0,
	KeyMapItem_type_LEFTMOUSE = 1,
	KeyMapItem_type_MIDDLEMOUSE = 2,
	KeyMapItem_type_RIGHTMOUSE = 3,
	KeyMapItem_type_BUTTON4MOUSE = 7,
	KeyMapItem_type_BUTTON5MOUSE = 8,
	KeyMapItem_type_BUTTON6MOUSE = 18,
	KeyMapItem_type_BUTTON7MOUSE = 19,
	KeyMapItem_type_PEN = 26,
	KeyMapItem_type_ERASER = 27,
	KeyMapItem_type_MOUSEMOVE = 4,
	KeyMapItem_type_INBETWEEN_MOUSEMOVE = 17,
	KeyMapItem_type_TRACKPADPAN = 14,
	KeyMapItem_type_TRACKPADZOOM = 15,
	KeyMapItem_type_MOUSEROTATE = 16,
	KeyMapItem_type_MOUSESMARTZOOM = 23,
	KeyMapItem_type_WHEELUPMOUSE = 10,
	KeyMapItem_type_WHEELDOWNMOUSE = 11,
	KeyMapItem_type_WHEELINMOUSE = 12,
	KeyMapItem_type_WHEELOUTMOUSE = 13,
	KeyMapItem_type_WHEELLEFTMOUSE = 20,
	KeyMapItem_type_WHEELRIGHTMOUSE = 21,
	KeyMapItem_type_A = 97,
	KeyMapItem_type_B = 98,
	KeyMapItem_type_C = 99,
	KeyMapItem_type_D = 100,
	KeyMapItem_type_E = 101,
	KeyMapItem_type_F = 102,
	KeyMapItem_type_G = 103,
	KeyMapItem_type_H = 104,
	KeyMapItem_type_I = 105,
	KeyMapItem_type_J = 106,
	KeyMapItem_type_K = 107,
	KeyMapItem_type_L = 108,
	KeyMapItem_type_M = 109,
	KeyMapItem_type_N = 110,
	KeyMapItem_type_O = 111,
	KeyMapItem_type_P = 112,
	KeyMapItem_type_Q = 113,
	KeyMapItem_type_R = 114,
	KeyMapItem_type_S = 115,
	KeyMapItem_type_T = 116,
	KeyMapItem_type_U = 117,
	KeyMapItem_type_V = 118,
	KeyMapItem_type_W = 119,
	KeyMapItem_type_X = 120,
	KeyMapItem_type_Y = 121,
	KeyMapItem_type_Z = 122,
	KeyMapItem_type_ZERO = 48,
	KeyMapItem_type_ONE = 49,
	KeyMapItem_type_TWO = 50,
	KeyMapItem_type_THREE = 51,
	KeyMapItem_type_FOUR = 52,
	KeyMapItem_type_FIVE = 53,
	KeyMapItem_type_SIX = 54,
	KeyMapItem_type_SEVEN = 55,
	KeyMapItem_type_EIGHT = 56,
	KeyMapItem_type_NINE = 57,
	KeyMapItem_type_LEFT_CTRL = 212,
	KeyMapItem_type_LEFT_ALT = 213,
	KeyMapItem_type_LEFT_SHIFT = 217,
	KeyMapItem_type_RIGHT_ALT = 214,
	KeyMapItem_type_RIGHT_CTRL = 215,
	KeyMapItem_type_RIGHT_SHIFT = 216,
	KeyMapItem_type_OSKEY = 172,
	KeyMapItem_type_HYPER = 179,
	KeyMapItem_type_APP = 178,
	KeyMapItem_type_GRLESS = 173,
	KeyMapItem_type_ESC = 218,
	KeyMapItem_type_TAB = 219,
	KeyMapItem_type_RET = 220,
	KeyMapItem_type_SPACE = 221,
	KeyMapItem_type_LINE_FEED = 222,
	KeyMapItem_type_BACK_SPACE = 223,
	KeyMapItem_type_DEL = 224,
	KeyMapItem_type_SEMI_COLON = 225,
	KeyMapItem_type_PERIOD = 226,
	KeyMapItem_type_COMMA = 227,
	KeyMapItem_type_QUOTE = 228,
	KeyMapItem_type_ACCENT_GRAVE = 229,
	KeyMapItem_type_MINUS = 230,
	KeyMapItem_type_PLUS = 231,
	KeyMapItem_type_SLASH = 232,
	KeyMapItem_type_BACK_SLASH = 233,
	KeyMapItem_type_EQUAL = 234,
	KeyMapItem_type_LEFT_BRACKET = 235,
	KeyMapItem_type_RIGHT_BRACKET = 236,
	KeyMapItem_type_LEFT_ARROW = 137,
	KeyMapItem_type_DOWN_ARROW = 138,
	KeyMapItem_type_RIGHT_ARROW = 139,
	KeyMapItem_type_UP_ARROW = 140,
	KeyMapItem_type_NUMPAD_2 = 152,
	KeyMapItem_type_NUMPAD_4 = 154,
	KeyMapItem_type_NUMPAD_6 = 156,
	KeyMapItem_type_NUMPAD_8 = 158,
	KeyMapItem_type_NUMPAD_1 = 151,
	KeyMapItem_type_NUMPAD_3 = 153,
	KeyMapItem_type_NUMPAD_5 = 155,
	KeyMapItem_type_NUMPAD_7 = 157,
	KeyMapItem_type_NUMPAD_9 = 159,
	KeyMapItem_type_NUMPAD_PERIOD = 199,
	KeyMapItem_type_NUMPAD_SLASH = 161,
	KeyMapItem_type_NUMPAD_ASTERIX = 160,
	KeyMapItem_type_NUMPAD_0 = 150,
	KeyMapItem_type_NUMPAD_MINUS = 162,
	KeyMapItem_type_NUMPAD_ENTER = 163,
	KeyMapItem_type_NUMPAD_PLUS = 164,
	KeyMapItem_type_F1 = 300,
	KeyMapItem_type_F2 = 301,
	KeyMapItem_type_F3 = 302,
	KeyMapItem_type_F4 = 303,
	KeyMapItem_type_F5 = 304,
	KeyMapItem_type_F6 = 305,
	KeyMapItem_type_F7 = 306,
	KeyMapItem_type_F8 = 307,
	KeyMapItem_type_F9 = 308,
	KeyMapItem_type_F10 = 309,
	KeyMapItem_type_F11 = 310,
	KeyMapItem_type_F12 = 311,
	KeyMapItem_type_F13 = 312,
	KeyMapItem_type_F14 = 313,
	KeyMapItem_type_F15 = 314,
	KeyMapItem_type_F16 = 315,
	KeyMapItem_type_F17 = 316,
	KeyMapItem_type_F18 = 317,
	KeyMapItem_type_F19 = 318,
	KeyMapItem_type_F20 = 319,
	KeyMapItem_type_F21 = 320,
	KeyMapItem_type_F22 = 321,
	KeyMapItem_type_F23 = 322,
	KeyMapItem_type_F24 = 323,
	KeyMapItem_type_PAUSE = 165,
	KeyMapItem_type_INSERT = 166,
	KeyMapItem_type_HOME = 167,
	KeyMapItem_type_PAGE_UP = 168,
	KeyMapItem_type_PAGE_DOWN = 169,
	KeyMapItem_type_END = 170,
	KeyMapItem_type_MEDIA_PLAY = 174,
	KeyMapItem_type_MEDIA_STOP = 175,
	KeyMapItem_type_MEDIA_FIRST = 176,
	KeyMapItem_type_MEDIA_LAST = 177,
	KeyMapItem_type_TEXTINPUT = -2,
	KeyMapItem_type_WINDOW_DEACTIVATE = 260,
	KeyMapItem_type_TIMER = 272,
	KeyMapItem_type_TIMER0 = 273,
	KeyMapItem_type_TIMER1 = 274,
	KeyMapItem_type_TIMER2 = 275,
	KeyMapItem_type_TIMER_JOBS = 276,
	KeyMapItem_type_TIMER_AUTOSAVE = 277,
	KeyMapItem_type_TIMER_REPORT = 278,
	KeyMapItem_type_TIMERREGION = 279,
	KeyMapItem_type_NDOF_MOTION = 400,
	KeyMapItem_type_NDOF_BUTTON_MENU = 401,
	KeyMapItem_type_NDOF_BUTTON_FIT = 402,
	KeyMapItem_type_NDOF_BUTTON_TOP = 403,
	KeyMapItem_type_NDOF_BUTTON_BOTTOM = 404,
	KeyMapItem_type_NDOF_BUTTON_LEFT = 405,
	KeyMapItem_type_NDOF_BUTTON_RIGHT = 406,
	KeyMapItem_type_NDOF_BUTTON_FRONT = 407,
	KeyMapItem_type_NDOF_BUTTON_BACK = 408,
	KeyMapItem_type_NDOF_BUTTON_ISO1 = 409,
	KeyMapItem_type_NDOF_BUTTON_ISO2 = 410,
	KeyMapItem_type_NDOF_BUTTON_ROLL_CW = 411,
	KeyMapItem_type_NDOF_BUTTON_ROLL_CCW = 412,
	KeyMapItem_type_NDOF_BUTTON_SPIN_CW = 413,
	KeyMapItem_type_NDOF_BUTTON_SPIN_CCW = 414,
	KeyMapItem_type_NDOF_BUTTON_TILT_CW = 415,
	KeyMapItem_type_NDOF_BUTTON_TILT_CCW = 416,
	KeyMapItem_type_NDOF_BUTTON_ROTATE = 417,
	KeyMapItem_type_NDOF_BUTTON_PANZOOM = 418,
	KeyMapItem_type_NDOF_BUTTON_DOMINANT = 419,
	KeyMapItem_type_NDOF_BUTTON_PLUS = 420,
	KeyMapItem_type_NDOF_BUTTON_MINUS = 421,
	KeyMapItem_type_NDOF_BUTTON_V1 = 422,
	KeyMapItem_type_NDOF_BUTTON_V2 = 423,
	KeyMapItem_type_NDOF_BUTTON_V3 = 424,
	KeyMapItem_type_NDOF_BUTTON_SAVE_V1 = 446,
	KeyMapItem_type_NDOF_BUTTON_SAVE_V2 = 447,
	KeyMapItem_type_NDOF_BUTTON_SAVE_V3 = 448,
	KeyMapItem_type_NDOF_BUTTON_1 = 426,
	KeyMapItem_type_NDOF_BUTTON_2 = 427,
	KeyMapItem_type_NDOF_BUTTON_3 = 428,
	KeyMapItem_type_NDOF_BUTTON_4 = 429,
	KeyMapItem_type_NDOF_BUTTON_5 = 430,
	KeyMapItem_type_NDOF_BUTTON_6 = 431,
	KeyMapItem_type_NDOF_BUTTON_7 = 432,
	KeyMapItem_type_NDOF_BUTTON_8 = 433,
	KeyMapItem_type_NDOF_BUTTON_9 = 434,
	KeyMapItem_type_NDOF_BUTTON_10 = 435,
	KeyMapItem_type_NDOF_BUTTON_11 = 436,
	KeyMapItem_type_NDOF_BUTTON_12 = 437,
	KeyMapItem_type_ACTIONZONE_AREA = 20480,
	KeyMapItem_type_ACTIONZONE_REGION = 20481,
	KeyMapItem_type_ACTIONZONE_FULLSCREEN = 20497,
	KeyMapItem_type_XR_ACTION = 20528,
};

int KeyMapItem_type_get(PointerRNA *ptr);
void KeyMapItem_type_set(PointerRNA *ptr, int value);

bool KeyMapItem_is_user_defined_get(PointerRNA *ptr);
void KeyMapItem_is_user_defined_set(PointerRNA *ptr, bool value);

bool KeyMapItem_is_user_modified_get(PointerRNA *ptr);
void KeyMapItem_is_user_modified_set(PointerRNA *ptr, bool value);

enum {
	KeyMapItem_value_ANY = -1,
	KeyMapItem_value_PRESS = 1,
	KeyMapItem_value_RELEASE = 2,
	KeyMapItem_value_CLICK = 3,
	KeyMapItem_value_DOUBLE_CLICK = 4,
	KeyMapItem_value_CLICK_DRAG = 5,
	KeyMapItem_value_NOTHING = 0,
};

int KeyMapItem_value_get(PointerRNA *ptr);
void KeyMapItem_value_set(PointerRNA *ptr, int value);

bool KeyMapItem_compare_func(struct wmKeyMapItem *_self, struct wmKeyMapItem *item);
void KeyMapItem_to_string_func(struct wmKeyMapItem *_self, bool compact, char * result);
/**************** KeyMap Items ****************/

extern StructRNA RNA_KeyMapItems;

PointerRNA KeyMapItems_rna_type_get(PointerRNA *ptr);

struct wmKeyMapItem *KeyMapItems_new_func(struct wmKeyMap *_self, ReportList *reports, const char * idname, int type, int value, bool any, int shift, int ctrl, int alt, int oskey, int hyper, int key_modifier, int direction, bool repeat, bool head);
struct wmKeyMapItem *KeyMapItems_new_modal_func(struct wmKeyMap *_self, ReportList *reports, const char * propvalue, int type, int value, bool any, int shift, int ctrl, int alt, int oskey, int hyper, int key_modifier, int direction, bool repeat);
struct wmKeyMapItem *KeyMapItems_new_from_item_func(struct wmKeyMap *_self, ReportList *reports, struct wmKeyMapItem *item, bool head);
void KeyMapItems_remove_func(struct wmKeyMap *_self, ReportList *reports, struct PointerRNA *item);
struct wmKeyMapItem *KeyMapItems_from_id_func(struct wmKeyMap *_self, int id);
struct PointerRNA KeyMapItems_find_from_operator_func(struct ID *_selfid, struct wmKeyMap *_self, const char * idname, struct PointerRNA *properties, int include, int exclude);
struct PointerRNA KeyMapItems_find_match_func(struct ID *_selfid, struct wmKeyMap *_self, ReportList *reports, struct wmKeyMap *keymap, struct wmKeyMapItem *item);
struct PointerRNA KeyMapItems_match_event_func(struct ID *_selfid, struct wmKeyMap *_self, bContext *C, struct wmEvent *event);
/**************** Key Maps ****************/

extern StructRNA RNA_KeyMaps;

PointerRNA KeyMaps_rna_type_get(PointerRNA *ptr);

struct wmKeyMap *KeyMaps_new_func(struct wmKeyConfig *_self, ReportList *reports, const char * name, int space_type, int region_type, bool modal, bool tool);
void KeyMaps_remove_func(struct wmKeyConfig *_self, ReportList *reports, struct PointerRNA *keymap);
void KeyMaps_clear_func(struct wmKeyConfig *_self);
struct wmKeyMap *KeyMaps_find_func(struct wmKeyConfig *_self, const char * name, int space_type, int region_type);
struct wmKeyMap *KeyMaps_find_match_func(struct wmKeyConfig *_self, struct wmKeyMap *keymap);
struct wmKeyMap *KeyMaps_find_modal_func(struct wmKeyConfig *_self, const char * name);
/**************** Keyframe ****************/

extern StructRNA RNA_Keyframe;

PointerRNA Keyframe_rna_type_get(PointerRNA *ptr);

float Keyframe_amplitude_get(PointerRNA *ptr);
void Keyframe_amplitude_set(PointerRNA *ptr, float value);

float Keyframe_back_get(PointerRNA *ptr);
void Keyframe_back_set(PointerRNA *ptr, float value);

void Keyframe_co_get(PointerRNA *ptr, float values[2]);
void Keyframe_co_set(PointerRNA *ptr, const float values[2]);

void Keyframe_co_ui_get(PointerRNA *ptr, float values[2]);
void Keyframe_co_ui_set(PointerRNA *ptr, const float values[2]);

enum {
	Keyframe_easing_AUTO = 0,
	Keyframe_easing_EASE_IN = 1,
	Keyframe_easing_EASE_OUT = 2,
	Keyframe_easing_EASE_IN_OUT = 3,
};

int Keyframe_easing_get(PointerRNA *ptr);
void Keyframe_easing_set(PointerRNA *ptr, int value);

bool Keyframe_select_left_handle_get(PointerRNA *ptr);
void Keyframe_select_left_handle_set(PointerRNA *ptr, bool value);

bool Keyframe_select_right_handle_get(PointerRNA *ptr);
void Keyframe_select_right_handle_set(PointerRNA *ptr, bool value);

enum {
	Keyframe_interpolation_CONSTANT = 0,
	Keyframe_interpolation_LINEAR = 1,
	Keyframe_interpolation_BEZIER = 2,
	Keyframe_interpolation_SINE = 12,
	Keyframe_interpolation_QUAD = 9,
	Keyframe_interpolation_CUBIC = 6,
	Keyframe_interpolation_QUART = 10,
	Keyframe_interpolation_QUINT = 11,
	Keyframe_interpolation_EXPO = 8,
	Keyframe_interpolation_CIRC = 5,
	Keyframe_interpolation_BACK = 3,
	Keyframe_interpolation_BOUNCE = 4,
	Keyframe_interpolation_ELASTIC = 7,
};

int Keyframe_interpolation_get(PointerRNA *ptr);
void Keyframe_interpolation_set(PointerRNA *ptr, int value);

void Keyframe_handle_left_get(PointerRNA *ptr, float values[2]);
void Keyframe_handle_left_set(PointerRNA *ptr, const float values[2]);

enum {
	Keyframe_handle_left_type_FREE = 0,
	Keyframe_handle_left_type_ALIGNED = 3,
	Keyframe_handle_left_type_VECTOR = 2,
	Keyframe_handle_left_type_AUTO = 1,
	Keyframe_handle_left_type_AUTO_CLAMPED = 4,
};

int Keyframe_handle_left_type_get(PointerRNA *ptr);
void Keyframe_handle_left_type_set(PointerRNA *ptr, int value);

float Keyframe_period_get(PointerRNA *ptr);
void Keyframe_period_set(PointerRNA *ptr, float value);

void Keyframe_handle_right_get(PointerRNA *ptr, float values[2]);
void Keyframe_handle_right_set(PointerRNA *ptr, const float values[2]);

enum {
	Keyframe_handle_right_type_FREE = 0,
	Keyframe_handle_right_type_ALIGNED = 3,
	Keyframe_handle_right_type_VECTOR = 2,
	Keyframe_handle_right_type_AUTO = 1,
	Keyframe_handle_right_type_AUTO_CLAMPED = 4,
};

int Keyframe_handle_right_type_get(PointerRNA *ptr);
void Keyframe_handle_right_type_set(PointerRNA *ptr, int value);

bool Keyframe_select_control_point_get(PointerRNA *ptr);
void Keyframe_select_control_point_set(PointerRNA *ptr, bool value);

enum {
	Keyframe_type_KEYFRAME = 0,
	Keyframe_type_BREAKDOWN = 2,
	Keyframe_type_MOVING_HOLD = 4,
	Keyframe_type_EXTREME = 1,
	Keyframe_type_JITTER = 3,
	Keyframe_type_GENERATED = 5,
};

int Keyframe_type_get(PointerRNA *ptr);
void Keyframe_type_set(PointerRNA *ptr, int value);

/**************** Keying Set ****************/

extern StructRNA RNA_KeyingSet;

PointerRNA KeyingSet_rna_type_get(PointerRNA *ptr);

bool KeyingSet_is_path_absolute_get(PointerRNA *ptr);
void KeyingSet_is_path_absolute_set(PointerRNA *ptr, bool value);

#define KeyingSet_bl_description_MAX 1024

void KeyingSet_bl_description_get(PointerRNA *ptr, char *value);
int KeyingSet_bl_description_length(PointerRNA *ptr);
void KeyingSet_bl_description_set(PointerRNA *ptr, const char *value);

#define KeyingSet_bl_idname_MAX 64

void KeyingSet_bl_idname_get(PointerRNA *ptr, char *value);
int KeyingSet_bl_idname_length(PointerRNA *ptr);
void KeyingSet_bl_idname_set(PointerRNA *ptr, const char *value);

bool KeyingSet_use_insertkey_needed_get(PointerRNA *ptr);
void KeyingSet_use_insertkey_needed_set(PointerRNA *ptr, bool value);

bool KeyingSet_use_insertkey_visual_get(PointerRNA *ptr);
void KeyingSet_use_insertkey_visual_set(PointerRNA *ptr, bool value);

bool KeyingSet_use_insertkey_override_visual_get(PointerRNA *ptr);
void KeyingSet_use_insertkey_override_visual_set(PointerRNA *ptr, bool value);

bool KeyingSet_use_insertkey_override_needed_get(PointerRNA *ptr);
void KeyingSet_use_insertkey_override_needed_set(PointerRNA *ptr, bool value);

void KeyingSet_paths_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void KeyingSet_paths_next(CollectionPropertyIterator *iter);
void KeyingSet_paths_end(CollectionPropertyIterator *iter);
bool KeyingSet_paths_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool KeyingSet_paths_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

PointerRNA KeyingSet_type_info_get(PointerRNA *ptr);

#define KeyingSet_bl_label_MAX 64

void KeyingSet_bl_label_get(PointerRNA *ptr, char *value);
int KeyingSet_bl_label_length(PointerRNA *ptr);
void KeyingSet_bl_label_set(PointerRNA *ptr, const char *value);

void KeyingSet_refresh_func(struct KeyingSet *_self, bContext *C, ReportList *reports);
/**************** Keying Set Info ****************/

extern StructRNA RNA_KeyingSetInfo;

PointerRNA KeyingSetInfo_rna_type_get(PointerRNA *ptr);

#define KeyingSetInfo_bl_description_MAX 1024

void KeyingSetInfo_bl_description_get(PointerRNA *ptr, char *value);
int KeyingSetInfo_bl_description_length(PointerRNA *ptr);
void KeyingSetInfo_bl_description_set(PointerRNA *ptr, const char *value);

void KeyingSetInfo_bl_idname_get(PointerRNA *ptr, char *value);
int KeyingSetInfo_bl_idname_length(PointerRNA *ptr);
void KeyingSetInfo_bl_idname_set(PointerRNA *ptr, const char *value);

enum {
	KeyingSetInfo_bl_options_INSERTKEY_NEEDED = 1,
	KeyingSetInfo_bl_options_INSERTKEY_VISUAL = 2,
	KeyingSetInfo_bl_options_INSERTKEY_XYZ_TO_RGB = 0,
};

int KeyingSetInfo_bl_options_get(PointerRNA *ptr);
void KeyingSetInfo_bl_options_set(PointerRNA *ptr, int value);

void KeyingSetInfo_bl_label_get(PointerRNA *ptr, char *value);
int KeyingSetInfo_bl_label_length(PointerRNA *ptr);
void KeyingSetInfo_bl_label_set(PointerRNA *ptr, const char *value);

bool KeyingSetInfo_poll_func(struct KeyingSetInfo *_self, struct bContext *context);
void KeyingSetInfo_iterator_func(struct KeyingSetInfo *_self, struct bContext *context, struct KeyingSet *ks);
void KeyingSetInfo_generate_func(struct KeyingSetInfo *_self, struct bContext *context, struct KeyingSet *ks, struct PointerRNA *data);
/**************** Keying Set Path ****************/

extern StructRNA RNA_KeyingSetPath;

PointerRNA KeyingSetPath_rna_type_get(PointerRNA *ptr);

void KeyingSetPath_data_path_get(PointerRNA *ptr, char *value);
int KeyingSetPath_data_path_length(PointerRNA *ptr);
void KeyingSetPath_data_path_set(PointerRNA *ptr, const char *value);

bool KeyingSetPath_use_entire_array_get(PointerRNA *ptr);
void KeyingSetPath_use_entire_array_set(PointerRNA *ptr, bool value);

#define KeyingSetPath_group_MAX 64

void KeyingSetPath_group_get(PointerRNA *ptr, char *value);
int KeyingSetPath_group_length(PointerRNA *ptr);
void KeyingSetPath_group_set(PointerRNA *ptr, const char *value);

enum {
	KeyingSetPath_group_method_NAMED = 0,
	KeyingSetPath_group_method_NONE = 1,
	KeyingSetPath_group_method_KEYINGSET = 2,
};

int KeyingSetPath_group_method_get(PointerRNA *ptr);
void KeyingSetPath_group_method_set(PointerRNA *ptr, int value);

enum {
	KeyingSetPath_id_type_ACTION = 17217,
	KeyingSetPath_id_type_ARMATURE = 21057,
	KeyingSetPath_id_type_BRUSH = 21058,
	KeyingSetPath_id_type_CACHEFILE = 17987,
	KeyingSetPath_id_type_CAMERA = 16707,
	KeyingSetPath_id_type_COLLECTION = 21063,
	KeyingSetPath_id_type_CURVE = 21827,
	KeyingSetPath_id_type_CURVES = 22083,
	KeyingSetPath_id_type_FONT = 18006,
	KeyingSetPath_id_type_GREASEPENCIL = 17479,
	KeyingSetPath_id_type_GREASEPENCIL_V3 = 20551,
	KeyingSetPath_id_type_IMAGE = 19785,
	KeyingSetPath_id_type_KEY = 17739,
	KeyingSetPath_id_type_LATTICE = 21580,
	KeyingSetPath_id_type_LIBRARY = 18764,
	KeyingSetPath_id_type_LIGHT = 16716,
	KeyingSetPath_id_type_LIGHT_PROBE = 20556,
	KeyingSetPath_id_type_LINESTYLE = 21324,
	KeyingSetPath_id_type_MASK = 21325,
	KeyingSetPath_id_type_MATERIAL = 16717,
	KeyingSetPath_id_type_MESH = 17741,
	KeyingSetPath_id_type_META = 16973,
	KeyingSetPath_id_type_MOVIECLIP = 17229,
	KeyingSetPath_id_type_NODETREE = 21582,
	KeyingSetPath_id_type_OBJECT = 16975,
	KeyingSetPath_id_type_PAINTCURVE = 17232,
	KeyingSetPath_id_type_PALETTE = 19536,
	KeyingSetPath_id_type_PARTICLE = 16720,
	KeyingSetPath_id_type_POINTCLOUD = 21584,
	KeyingSetPath_id_type_SCENE = 17235,
	KeyingSetPath_id_type_SCREEN = 21075,
	KeyingSetPath_id_type_SOUND = 20307,
	KeyingSetPath_id_type_SPEAKER = 19283,
	KeyingSetPath_id_type_TEXT = 22612,
	KeyingSetPath_id_type_TEXTURE = 17748,
	KeyingSetPath_id_type_VOLUME = 20310,
	KeyingSetPath_id_type_WINDOWMANAGER = 19799,
	KeyingSetPath_id_type_WORKSPACE = 21335,
	KeyingSetPath_id_type_WORLD = 20311,
};

int KeyingSetPath_id_type_get(PointerRNA *ptr);
void KeyingSetPath_id_type_set(PointerRNA *ptr, int value);

PointerRNA KeyingSetPath_id_get(PointerRNA *ptr);

bool KeyingSetPath_use_insertkey_needed_get(PointerRNA *ptr);
void KeyingSetPath_use_insertkey_needed_set(PointerRNA *ptr, bool value);

bool KeyingSetPath_use_insertkey_visual_get(PointerRNA *ptr);
void KeyingSetPath_use_insertkey_visual_set(PointerRNA *ptr, bool value);

bool KeyingSetPath_use_insertkey_override_visual_get(PointerRNA *ptr);
void KeyingSetPath_use_insertkey_override_visual_set(PointerRNA *ptr, bool value);

bool KeyingSetPath_use_insertkey_override_needed_get(PointerRNA *ptr);
void KeyingSetPath_use_insertkey_override_needed_set(PointerRNA *ptr, bool value);

int KeyingSetPath_array_index_get(PointerRNA *ptr);
void KeyingSetPath_array_index_set(PointerRNA *ptr, int value);

/**************** Keying set paths ****************/

extern StructRNA RNA_KeyingSetPaths;

PointerRNA KeyingSetPaths_rna_type_get(PointerRNA *ptr);

PointerRNA KeyingSetPaths_active_get(PointerRNA *ptr);

int KeyingSetPaths_active_index_get(PointerRNA *ptr);
void KeyingSetPaths_active_index_set(PointerRNA *ptr, int value);

struct KS_Path *KeyingSetPaths_add_func(struct KeyingSet *_self, ReportList *reports, struct ID *target_id, const char * data_path, int index, int group_method, const char * group_name);
void KeyingSetPaths_remove_func(struct KeyingSet *_self, ReportList *reports, struct PointerRNA *path);
void KeyingSetPaths_clear_func(struct KeyingSet *_self, ReportList *reports);
/**************** Keying Sets ****************/

extern StructRNA RNA_KeyingSets;

PointerRNA KeyingSets_rna_type_get(PointerRNA *ptr);

PointerRNA KeyingSets_active_get(PointerRNA *ptr);

int KeyingSets_active_index_get(PointerRNA *ptr);
void KeyingSets_active_index_set(PointerRNA *ptr, int value);

struct KeyingSet *KeyingSets_new_func(struct Scene *_self, ReportList *reports, const char * idname, const char * name);
/**************** Keying Sets All ****************/

extern StructRNA RNA_KeyingSetsAll;

PointerRNA KeyingSetsAll_rna_type_get(PointerRNA *ptr);

PointerRNA KeyingSetsAll_active_get(PointerRNA *ptr);

int KeyingSetsAll_active_index_get(PointerRNA *ptr);
void KeyingSetsAll_active_index_set(PointerRNA *ptr, int value);

/**************** Kinematic Constraint ****************/

extern StructRNA RNA_KinematicConstraint;
extern StructRNA RNA_Constraint;

enum {
	KinematicConstraint_reference_axis_BONE = 0,
	KinematicConstraint_reference_axis_TARGET = 16384,
};

int KinematicConstraint_reference_axis_get(PointerRNA *ptr);
void KinematicConstraint_reference_axis_set(PointerRNA *ptr, int value);

int KinematicConstraint_chain_count_get(PointerRNA *ptr);
void KinematicConstraint_chain_count_set(PointerRNA *ptr, int value);

float KinematicConstraint_distance_get(PointerRNA *ptr);
void KinematicConstraint_distance_set(PointerRNA *ptr, float value);

enum {
	KinematicConstraint_ik_type_COPY_POSE = 0,
	KinematicConstraint_ik_type_DISTANCE = 1,
};

int KinematicConstraint_ik_type_get(PointerRNA *ptr);
void KinematicConstraint_ik_type_set(PointerRNA *ptr, int value);

int KinematicConstraint_iterations_get(PointerRNA *ptr);
void KinematicConstraint_iterations_set(PointerRNA *ptr, int value);

enum {
	KinematicConstraint_limit_mode_LIMITDIST_INSIDE = 0,
	KinematicConstraint_limit_mode_LIMITDIST_OUTSIDE = 1,
	KinematicConstraint_limit_mode_LIMITDIST_ONSURFACE = 2,
};

int KinematicConstraint_limit_mode_get(PointerRNA *ptr);
void KinematicConstraint_limit_mode_set(PointerRNA *ptr, int value);

bool KinematicConstraint_lock_location_x_get(PointerRNA *ptr);
void KinematicConstraint_lock_location_x_set(PointerRNA *ptr, bool value);

bool KinematicConstraint_lock_rotation_x_get(PointerRNA *ptr);
void KinematicConstraint_lock_rotation_x_set(PointerRNA *ptr, bool value);

bool KinematicConstraint_lock_location_y_get(PointerRNA *ptr);
void KinematicConstraint_lock_location_y_set(PointerRNA *ptr, bool value);

bool KinematicConstraint_lock_rotation_y_get(PointerRNA *ptr);
void KinematicConstraint_lock_rotation_y_set(PointerRNA *ptr, bool value);

bool KinematicConstraint_lock_location_z_get(PointerRNA *ptr);
void KinematicConstraint_lock_location_z_set(PointerRNA *ptr, bool value);

bool KinematicConstraint_lock_rotation_z_get(PointerRNA *ptr);
void KinematicConstraint_lock_rotation_z_set(PointerRNA *ptr, bool value);

float KinematicConstraint_orient_weight_get(PointerRNA *ptr);
void KinematicConstraint_orient_weight_set(PointerRNA *ptr, float value);

float KinematicConstraint_pole_angle_get(PointerRNA *ptr);
void KinematicConstraint_pole_angle_set(PointerRNA *ptr, float value);

#define KinematicConstraint_pole_subtarget_MAX 64

void KinematicConstraint_pole_subtarget_get(PointerRNA *ptr, char *value);
int KinematicConstraint_pole_subtarget_length(PointerRNA *ptr);
void KinematicConstraint_pole_subtarget_set(PointerRNA *ptr, const char *value);

PointerRNA KinematicConstraint_pole_target_get(PointerRNA *ptr);

bool KinematicConstraint_use_location_get(PointerRNA *ptr);
void KinematicConstraint_use_location_set(PointerRNA *ptr, bool value);

bool KinematicConstraint_use_rotation_get(PointerRNA *ptr);
void KinematicConstraint_use_rotation_set(PointerRNA *ptr, bool value);

bool KinematicConstraint_use_stretch_get(PointerRNA *ptr);
void KinematicConstraint_use_stretch_set(PointerRNA *ptr, bool value);

#define KinematicConstraint_subtarget_MAX 64

void KinematicConstraint_subtarget_get(PointerRNA *ptr, char *value);
int KinematicConstraint_subtarget_length(PointerRNA *ptr);
void KinematicConstraint_subtarget_set(PointerRNA *ptr, const char *value);

PointerRNA KinematicConstraint_target_get(PointerRNA *ptr);

bool KinematicConstraint_use_tail_get(PointerRNA *ptr);
void KinematicConstraint_use_tail_set(PointerRNA *ptr, bool value);

float KinematicConstraint_weight_get(PointerRNA *ptr);
void KinematicConstraint_weight_set(PointerRNA *ptr, float value);

/**************** Laplacian Deform Modifier ****************/

extern StructRNA RNA_LaplacianDeformModifier;
extern StructRNA RNA_Modifier;

#define LaplacianDeformModifier_vertex_group_MAX 64

void LaplacianDeformModifier_vertex_group_get(PointerRNA *ptr, char *value);
int LaplacianDeformModifier_vertex_group_length(PointerRNA *ptr);
void LaplacianDeformModifier_vertex_group_set(PointerRNA *ptr, const char *value);

bool LaplacianDeformModifier_is_bind_get(PointerRNA *ptr);
void LaplacianDeformModifier_is_bind_set(PointerRNA *ptr, bool value);

bool LaplacianDeformModifier_invert_vertex_group_get(PointerRNA *ptr);
void LaplacianDeformModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

int LaplacianDeformModifier_iterations_get(PointerRNA *ptr);
void LaplacianDeformModifier_iterations_set(PointerRNA *ptr, int value);

/**************** Laplacian Smooth Modifier ****************/

extern StructRNA RNA_LaplacianSmoothModifier;
extern StructRNA RNA_Modifier;

bool LaplacianSmoothModifier_invert_vertex_group_get(PointerRNA *ptr);
void LaplacianSmoothModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

float LaplacianSmoothModifier_lambda_border_get(PointerRNA *ptr);
void LaplacianSmoothModifier_lambda_border_set(PointerRNA *ptr, float value);

float LaplacianSmoothModifier_lambda_factor_get(PointerRNA *ptr);
void LaplacianSmoothModifier_lambda_factor_set(PointerRNA *ptr, float value);

bool LaplacianSmoothModifier_use_normalized_get(PointerRNA *ptr);
void LaplacianSmoothModifier_use_normalized_set(PointerRNA *ptr, bool value);

bool LaplacianSmoothModifier_use_volume_preserve_get(PointerRNA *ptr);
void LaplacianSmoothModifier_use_volume_preserve_set(PointerRNA *ptr, bool value);

int LaplacianSmoothModifier_iterations_get(PointerRNA *ptr);
void LaplacianSmoothModifier_iterations_set(PointerRNA *ptr, int value);

#define LaplacianSmoothModifier_vertex_group_MAX 64

void LaplacianSmoothModifier_vertex_group_get(PointerRNA *ptr, char *value);
int LaplacianSmoothModifier_vertex_group_length(PointerRNA *ptr);
void LaplacianSmoothModifier_vertex_group_set(PointerRNA *ptr, const char *value);

bool LaplacianSmoothModifier_use_x_get(PointerRNA *ptr);
void LaplacianSmoothModifier_use_x_set(PointerRNA *ptr, bool value);

bool LaplacianSmoothModifier_use_y_get(PointerRNA *ptr);
void LaplacianSmoothModifier_use_y_set(PointerRNA *ptr, bool value);

bool LaplacianSmoothModifier_use_z_get(PointerRNA *ptr);
void LaplacianSmoothModifier_use_z_set(PointerRNA *ptr, bool value);

/**************** Lattice ****************/

extern StructRNA RNA_Lattice;
extern StructRNA RNA_ID;

PointerRNA Lattice_animation_data_get(PointerRNA *ptr);

enum {
	Lattice_interpolation_type_u_KEY_LINEAR = 0,
	Lattice_interpolation_type_u_KEY_CARDINAL = 1,
	Lattice_interpolation_type_u_KEY_CATMULL_ROM = 3,
	Lattice_interpolation_type_u_KEY_BSPLINE = 2,
};

int Lattice_interpolation_type_u_get(PointerRNA *ptr);
void Lattice_interpolation_type_u_set(PointerRNA *ptr, int value);

enum {
	Lattice_interpolation_type_v_KEY_LINEAR = 0,
	Lattice_interpolation_type_v_KEY_CARDINAL = 1,
	Lattice_interpolation_type_v_KEY_CATMULL_ROM = 3,
	Lattice_interpolation_type_v_KEY_BSPLINE = 2,
};

int Lattice_interpolation_type_v_get(PointerRNA *ptr);
void Lattice_interpolation_type_v_set(PointerRNA *ptr, int value);

enum {
	Lattice_interpolation_type_w_KEY_LINEAR = 0,
	Lattice_interpolation_type_w_KEY_CARDINAL = 1,
	Lattice_interpolation_type_w_KEY_CATMULL_ROM = 3,
	Lattice_interpolation_type_w_KEY_BSPLINE = 2,
};

int Lattice_interpolation_type_w_get(PointerRNA *ptr);
void Lattice_interpolation_type_w_set(PointerRNA *ptr, int value);

bool Lattice_is_editmode_get(PointerRNA *ptr);
void Lattice_is_editmode_set(PointerRNA *ptr, bool value);

bool Lattice_use_outside_get(PointerRNA *ptr);
void Lattice_use_outside_set(PointerRNA *ptr, bool value);

void Lattice_points_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Lattice_points_next(CollectionPropertyIterator *iter);
void Lattice_points_end(CollectionPropertyIterator *iter);

PointerRNA Lattice_shape_keys_get(PointerRNA *ptr);

int Lattice_points_u_get(PointerRNA *ptr);
void Lattice_points_u_set(PointerRNA *ptr, int value);

int Lattice_points_v_get(PointerRNA *ptr);
void Lattice_points_v_set(PointerRNA *ptr, int value);

#define Lattice_vertex_group_MAX 64

void Lattice_vertex_group_get(PointerRNA *ptr, char *value);
int Lattice_vertex_group_length(PointerRNA *ptr);
void Lattice_vertex_group_set(PointerRNA *ptr, const char *value);

int Lattice_points_w_get(PointerRNA *ptr);
void Lattice_points_w_set(PointerRNA *ptr, int value);

void Lattice_transform_func(struct Lattice *_self, float matrix[16], bool shape_keys);
void Lattice_update_gpu_tag_func(struct Lattice *_self);
/**************** Lattice Modifier ****************/

extern StructRNA RNA_LatticeModifier;
extern StructRNA RNA_Modifier;

bool LatticeModifier_invert_vertex_group_get(PointerRNA *ptr);
void LatticeModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

PointerRNA LatticeModifier_object_get(PointerRNA *ptr);

float LatticeModifier_strength_get(PointerRNA *ptr);
void LatticeModifier_strength_set(PointerRNA *ptr, float value);

#define LatticeModifier_vertex_group_MAX 64

void LatticeModifier_vertex_group_get(PointerRNA *ptr, char *value);
int LatticeModifier_vertex_group_length(PointerRNA *ptr);
void LatticeModifier_vertex_group_set(PointerRNA *ptr, const char *value);

/**************** LatticePoint ****************/

extern StructRNA RNA_LatticePoint;

PointerRNA LatticePoint_rna_type_get(PointerRNA *ptr);

void LatticePoint_co_deform_get(PointerRNA *ptr, float values[3]);
void LatticePoint_co_deform_set(PointerRNA *ptr, const float values[3]);

void LatticePoint_groups_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void LatticePoint_groups_next(CollectionPropertyIterator *iter);
void LatticePoint_groups_end(CollectionPropertyIterator *iter);

void LatticePoint_co_get(PointerRNA *ptr, float values[3]);
void LatticePoint_co_set(PointerRNA *ptr, const float values[3]);

bool LatticePoint_select_get(PointerRNA *ptr);
void LatticePoint_select_set(PointerRNA *ptr, bool value);

float LatticePoint_weight_softbody_get(PointerRNA *ptr);
void LatticePoint_weight_softbody_set(PointerRNA *ptr, float value);

/**************** Layer Collection ****************/

extern StructRNA RNA_LayerCollection;

PointerRNA LayerCollection_rna_type_get(PointerRNA *ptr);

#define LayerCollection_name_MAX 66

void LayerCollection_name_get(PointerRNA *ptr, char *value);
int LayerCollection_name_length(PointerRNA *ptr);
void LayerCollection_name_set(PointerRNA *ptr, const char *value);

void LayerCollection_children_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void LayerCollection_children_next(CollectionPropertyIterator *iter);
void LayerCollection_children_end(CollectionPropertyIterator *iter);
bool LayerCollection_children_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool LayerCollection_children_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

PointerRNA LayerCollection_collection_get(PointerRNA *ptr);

bool LayerCollection_exclude_get(PointerRNA *ptr);
void LayerCollection_exclude_set(PointerRNA *ptr, bool value);

bool LayerCollection_hide_viewport_get(PointerRNA *ptr);
void LayerCollection_hide_viewport_set(PointerRNA *ptr, bool value);

bool LayerCollection_holdout_get(PointerRNA *ptr);
void LayerCollection_holdout_set(PointerRNA *ptr, bool value);

bool LayerCollection_indirect_only_get(PointerRNA *ptr);
void LayerCollection_indirect_only_set(PointerRNA *ptr, bool value);

bool LayerCollection_is_visible_get(PointerRNA *ptr);
void LayerCollection_is_visible_set(PointerRNA *ptr, bool value);

bool LayerCollection_visible_get_func(struct LayerCollection *_self, bContext *C);
bool LayerCollection_has_objects_func(struct LayerCollection *_self);
bool LayerCollection_has_selected_objects_func(struct LayerCollection *_self, Main *bmain, struct ViewLayer *view_layer);
/**************** Layer Objects ****************/

extern StructRNA RNA_LayerObjects;

PointerRNA LayerObjects_rna_type_get(PointerRNA *ptr);

PointerRNA LayerObjects_active_get(PointerRNA *ptr);

void LayerObjects_selected_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void LayerObjects_selected_next(CollectionPropertyIterator *iter);
void LayerObjects_selected_end(CollectionPropertyIterator *iter);
bool LayerObjects_selected_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool LayerObjects_selected_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

/**************** LayoutPanelState ****************/

extern StructRNA RNA_LayoutPanelState;

PointerRNA LayoutPanelState_rna_type_get(PointerRNA *ptr);

bool LayoutPanelState_is_open_get(PointerRNA *ptr);
void LayoutPanelState_is_open_set(PointerRNA *ptr, bool value);

/**************** Library ****************/

extern StructRNA RNA_Library;
extern StructRNA RNA_ID;

bool Library_is_editable_get(PointerRNA *ptr);
void Library_is_editable_set(PointerRNA *ptr, bool value);

#define Library_filepath_MAX 1024

void Library_filepath_get(PointerRNA *ptr, char *value);
int Library_filepath_length(PointerRNA *ptr);
void Library_filepath_set(PointerRNA *ptr, const char *value);

bool Library_needs_liboverride_resync_get(PointerRNA *ptr);
void Library_needs_liboverride_resync_set(PointerRNA *ptr, bool value);

PointerRNA Library_packed_file_get(PointerRNA *ptr);

PointerRNA Library_parent_get(PointerRNA *ptr);

void Library_version_get(PointerRNA *ptr, int values[3]);
void Library_version_set(PointerRNA *ptr, const int values[3]);

void Library_reload_func(struct Library *_self, bContext *C, ReportList *reports);
/**************** LibraryWeakReference ****************/

extern StructRNA RNA_LibraryWeakReference;

PointerRNA LibraryWeakReference_rna_type_get(PointerRNA *ptr);

#define LibraryWeakReference_filepath_MAX 1024

void LibraryWeakReference_filepath_get(PointerRNA *ptr, char *value);
int LibraryWeakReference_filepath_length(PointerRNA *ptr);
void LibraryWeakReference_filepath_set(PointerRNA *ptr, const char *value);

#define LibraryWeakReference_id_name_MAX 66

void LibraryWeakReference_id_name_get(PointerRNA *ptr, char *value);
int LibraryWeakReference_id_name_length(PointerRNA *ptr);
void LibraryWeakReference_id_name_set(PointerRNA *ptr, const char *value);

/**************** Light ****************/

extern StructRNA RNA_Light;
extern StructRNA RNA_ID;

PointerRNA Light_animation_data_get(PointerRNA *ptr);

void Light_color_get(PointerRNA *ptr, float values[3]);
void Light_color_set(PointerRNA *ptr, const float values[3]);

bool Light_use_custom_distance_get(PointerRNA *ptr);
void Light_use_custom_distance_set(PointerRNA *ptr, bool value);

float Light_cutoff_distance_get(PointerRNA *ptr);
void Light_cutoff_distance_set(PointerRNA *ptr, float value);

float Light_diffuse_factor_get(PointerRNA *ptr);
void Light_diffuse_factor_set(PointerRNA *ptr, float value);

float Light_exposure_get(PointerRNA *ptr);
void Light_exposure_set(PointerRNA *ptr, float value);

PointerRNA Light_node_tree_get(PointerRNA *ptr);

bool Light_normalize_get(PointerRNA *ptr);
void Light_normalize_set(PointerRNA *ptr, bool value);

float Light_specular_factor_get(PointerRNA *ptr);
void Light_specular_factor_set(PointerRNA *ptr, float value);

float Light_temperature_get(PointerRNA *ptr);
void Light_temperature_set(PointerRNA *ptr, float value);

void Light_temperature_color_get(PointerRNA *ptr, float values[3]);
void Light_temperature_color_set(PointerRNA *ptr, const float values[3]);

float Light_transmission_factor_get(PointerRNA *ptr);
void Light_transmission_factor_set(PointerRNA *ptr, float value);

enum {
	Light_type_POINT = 0,
	Light_type_SUN = 1,
	Light_type_SPOT = 2,
	Light_type_AREA = 4,
};

int Light_type_get(PointerRNA *ptr);
void Light_type_set(PointerRNA *ptr, int value);

bool Light_use_nodes_get(PointerRNA *ptr);
void Light_use_nodes_set(PointerRNA *ptr, bool value);

bool Light_use_temperature_get(PointerRNA *ptr);
void Light_use_temperature_set(PointerRNA *ptr, bool value);

float Light_volume_factor_get(PointerRNA *ptr);
void Light_volume_factor_set(PointerRNA *ptr, float value);

bool Light_use_shadow_get(PointerRNA *ptr);
void Light_use_shadow_set(PointerRNA *ptr, bool value);

float Light_area_func(struct Light *_self, float matrix_world[16]);
/**************** LightProbe ****************/

extern StructRNA RNA_LightProbe;
extern StructRNA RNA_ID;

PointerRNA LightProbe_animation_data_get(PointerRNA *ptr);

float LightProbe_clip_start_get(PointerRNA *ptr);
void LightProbe_clip_start_set(PointerRNA *ptr, float value);

bool LightProbe_show_clip_get(PointerRNA *ptr);
void LightProbe_show_clip_set(PointerRNA *ptr, bool value);

bool LightProbe_use_data_display_get(PointerRNA *ptr);
void LightProbe_use_data_display_set(PointerRNA *ptr, bool value);

bool LightProbe_show_data_get(PointerRNA *ptr);
void LightProbe_show_data_set(PointerRNA *ptr, bool value);

float LightProbe_data_display_size_get(PointerRNA *ptr);
void LightProbe_data_display_size_set(PointerRNA *ptr, float value);

bool LightProbe_show_influence_get(PointerRNA *ptr);
void LightProbe_show_influence_set(PointerRNA *ptr, bool value);

float LightProbe_influence_distance_get(PointerRNA *ptr);
void LightProbe_influence_distance_set(PointerRNA *ptr, float value);

bool LightProbe_invert_visibility_collection_get(PointerRNA *ptr);
void LightProbe_invert_visibility_collection_set(PointerRNA *ptr, bool value);

enum {
	LightProbe_type_SPHERE = 0,
	LightProbe_type_PLANE = 1,
	LightProbe_type_VOLUME = 2,
};

int LightProbe_type_get(PointerRNA *ptr);
void LightProbe_type_set(PointerRNA *ptr, int value);

float LightProbe_visibility_buffer_bias_get(PointerRNA *ptr);
void LightProbe_visibility_buffer_bias_set(PointerRNA *ptr, float value);

float LightProbe_visibility_bleed_bias_get(PointerRNA *ptr);
void LightProbe_visibility_bleed_bias_set(PointerRNA *ptr, float value);

float LightProbe_visibility_blur_get(PointerRNA *ptr);
void LightProbe_visibility_blur_set(PointerRNA *ptr, float value);

PointerRNA LightProbe_visibility_collection_get(PointerRNA *ptr);

/**************** Planar Probe ****************/

extern StructRNA RNA_LightProbePlane;
extern StructRNA RNA_LightProbe;
extern StructRNA RNA_ID;

/**************** Spherical Probe ****************/

extern StructRNA RNA_LightProbeSphere;
extern StructRNA RNA_LightProbe;
extern StructRNA RNA_ID;

float LightProbeSphere_clip_end_get(PointerRNA *ptr);
void LightProbeSphere_clip_end_set(PointerRNA *ptr, float value);

float LightProbeSphere_falloff_get(PointerRNA *ptr);
void LightProbeSphere_falloff_set(PointerRNA *ptr, float value);

bool LightProbeSphere_show_parallax_get(PointerRNA *ptr);
void LightProbeSphere_show_parallax_set(PointerRNA *ptr, bool value);

float LightProbeSphere_parallax_distance_get(PointerRNA *ptr);
void LightProbeSphere_parallax_distance_set(PointerRNA *ptr, float value);

enum {
	LightProbeSphere_influence_type_ELIPSOID = 0,
	LightProbeSphere_influence_type_BOX = 1,
};

int LightProbeSphere_influence_type_get(PointerRNA *ptr);
void LightProbeSphere_influence_type_set(PointerRNA *ptr, int value);

enum {
	LightProbeSphere_parallax_type_ELIPSOID = 0,
	LightProbeSphere_parallax_type_BOX = 1,
};

int LightProbeSphere_parallax_type_get(PointerRNA *ptr);
void LightProbeSphere_parallax_type_set(PointerRNA *ptr, int value);

bool LightProbeSphere_use_custom_parallax_get(PointerRNA *ptr);
void LightProbeSphere_use_custom_parallax_set(PointerRNA *ptr, bool value);

/**************** Volume Probe ****************/

extern StructRNA RNA_LightProbeVolume;
extern StructRNA RNA_LightProbe;
extern StructRNA RNA_ID;

int LightProbeVolume_bake_samples_get(PointerRNA *ptr);
void LightProbeVolume_bake_samples_set(PointerRNA *ptr, int value);

float LightProbeVolume_capture_distance_get(PointerRNA *ptr);
void LightProbeVolume_capture_distance_set(PointerRNA *ptr, float value);

bool LightProbeVolume_capture_emission_get(PointerRNA *ptr);
void LightProbeVolume_capture_emission_set(PointerRNA *ptr, bool value);

bool LightProbeVolume_capture_indirect_get(PointerRNA *ptr);
void LightProbeVolume_capture_indirect_set(PointerRNA *ptr, bool value);

bool LightProbeVolume_capture_world_get(PointerRNA *ptr);
void LightProbeVolume_capture_world_set(PointerRNA *ptr, bool value);

float LightProbeVolume_clamp_direct_get(PointerRNA *ptr);
void LightProbeVolume_clamp_direct_set(PointerRNA *ptr, float value);

float LightProbeVolume_clamp_indirect_get(PointerRNA *ptr);
void LightProbeVolume_clamp_indirect_set(PointerRNA *ptr, float value);

float LightProbeVolume_dilation_radius_get(PointerRNA *ptr);
void LightProbeVolume_dilation_radius_set(PointerRNA *ptr, float value);

float LightProbeVolume_dilation_threshold_get(PointerRNA *ptr);
void LightProbeVolume_dilation_threshold_set(PointerRNA *ptr, float value);

float LightProbeVolume_facing_bias_get(PointerRNA *ptr);
void LightProbeVolume_facing_bias_set(PointerRNA *ptr, float value);

float LightProbeVolume_intensity_get(PointerRNA *ptr);
void LightProbeVolume_intensity_set(PointerRNA *ptr, float value);

float LightProbeVolume_normal_bias_get(PointerRNA *ptr);
void LightProbeVolume_normal_bias_set(PointerRNA *ptr, float value);

int LightProbeVolume_resolution_x_get(PointerRNA *ptr);
void LightProbeVolume_resolution_x_set(PointerRNA *ptr, int value);

int LightProbeVolume_resolution_y_get(PointerRNA *ptr);
void LightProbeVolume_resolution_y_set(PointerRNA *ptr, int value);

int LightProbeVolume_resolution_z_get(PointerRNA *ptr);
void LightProbeVolume_resolution_z_set(PointerRNA *ptr, int value);

float LightProbeVolume_escape_bias_get(PointerRNA *ptr);
void LightProbeVolume_escape_bias_set(PointerRNA *ptr, float value);

float LightProbeVolume_surface_bias_get(PointerRNA *ptr);
void LightProbeVolume_surface_bias_set(PointerRNA *ptr, float value);

int LightProbeVolume_surfel_density_get(PointerRNA *ptr);
void LightProbeVolume_surfel_density_set(PointerRNA *ptr, int value);

float LightProbeVolume_validity_threshold_get(PointerRNA *ptr);
void LightProbeVolume_validity_threshold_set(PointerRNA *ptr, float value);

float LightProbeVolume_view_bias_get(PointerRNA *ptr);
void LightProbeVolume_view_bias_set(PointerRNA *ptr, float value);

/**************** Light Group ****************/

extern StructRNA RNA_Lightgroup;

PointerRNA Lightgroup_rna_type_get(PointerRNA *ptr);

#define Lightgroup_name_MAX 64

void Lightgroup_name_get(PointerRNA *ptr, char *value);
int Lightgroup_name_length(PointerRNA *ptr);
void Lightgroup_name_set(PointerRNA *ptr, const char *value);

/**************** List of Lightgroups ****************/

extern StructRNA RNA_Lightgroups;

PointerRNA Lightgroups_rna_type_get(PointerRNA *ptr);

struct ViewLayerLightgroup *Lightgroups_add_func(struct ViewLayer *_self, const char * name);
void Lightgroups_remove_func(struct ViewLayer *_self, struct ViewLayerLightgroup *lightgroup);
/**************** Limit Distance Constraint ****************/

extern StructRNA RNA_LimitDistanceConstraint;
extern StructRNA RNA_Constraint;

bool LimitDistanceConstraint_use_transform_limit_get(PointerRNA *ptr);
void LimitDistanceConstraint_use_transform_limit_set(PointerRNA *ptr, bool value);

float LimitDistanceConstraint_distance_get(PointerRNA *ptr);
void LimitDistanceConstraint_distance_set(PointerRNA *ptr, float value);

bool LimitDistanceConstraint_use_bbone_shape_get(PointerRNA *ptr);
void LimitDistanceConstraint_use_bbone_shape_set(PointerRNA *ptr, bool value);

float LimitDistanceConstraint_head_tail_get(PointerRNA *ptr);
void LimitDistanceConstraint_head_tail_set(PointerRNA *ptr, float value);

enum {
	LimitDistanceConstraint_limit_mode_LIMITDIST_INSIDE = 0,
	LimitDistanceConstraint_limit_mode_LIMITDIST_OUTSIDE = 1,
	LimitDistanceConstraint_limit_mode_LIMITDIST_ONSURFACE = 2,
};

int LimitDistanceConstraint_limit_mode_get(PointerRNA *ptr);
void LimitDistanceConstraint_limit_mode_set(PointerRNA *ptr, int value);

#define LimitDistanceConstraint_subtarget_MAX 64

void LimitDistanceConstraint_subtarget_get(PointerRNA *ptr, char *value);
int LimitDistanceConstraint_subtarget_length(PointerRNA *ptr);
void LimitDistanceConstraint_subtarget_set(PointerRNA *ptr, const char *value);

PointerRNA LimitDistanceConstraint_target_get(PointerRNA *ptr);

/**************** Limit Location Constraint ****************/

extern StructRNA RNA_LimitLocationConstraint;
extern StructRNA RNA_Constraint;

bool LimitLocationConstraint_use_transform_limit_get(PointerRNA *ptr);
void LimitLocationConstraint_use_transform_limit_set(PointerRNA *ptr, bool value);

bool LimitLocationConstraint_use_max_x_get(PointerRNA *ptr);
void LimitLocationConstraint_use_max_x_set(PointerRNA *ptr, bool value);

float LimitLocationConstraint_max_x_get(PointerRNA *ptr);
void LimitLocationConstraint_max_x_set(PointerRNA *ptr, float value);

bool LimitLocationConstraint_use_max_y_get(PointerRNA *ptr);
void LimitLocationConstraint_use_max_y_set(PointerRNA *ptr, bool value);

float LimitLocationConstraint_max_y_get(PointerRNA *ptr);
void LimitLocationConstraint_max_y_set(PointerRNA *ptr, float value);

bool LimitLocationConstraint_use_max_z_get(PointerRNA *ptr);
void LimitLocationConstraint_use_max_z_set(PointerRNA *ptr, bool value);

float LimitLocationConstraint_max_z_get(PointerRNA *ptr);
void LimitLocationConstraint_max_z_set(PointerRNA *ptr, float value);

bool LimitLocationConstraint_use_min_x_get(PointerRNA *ptr);
void LimitLocationConstraint_use_min_x_set(PointerRNA *ptr, bool value);

float LimitLocationConstraint_min_x_get(PointerRNA *ptr);
void LimitLocationConstraint_min_x_set(PointerRNA *ptr, float value);

bool LimitLocationConstraint_use_min_y_get(PointerRNA *ptr);
void LimitLocationConstraint_use_min_y_set(PointerRNA *ptr, bool value);

float LimitLocationConstraint_min_y_get(PointerRNA *ptr);
void LimitLocationConstraint_min_y_set(PointerRNA *ptr, float value);

bool LimitLocationConstraint_use_min_z_get(PointerRNA *ptr);
void LimitLocationConstraint_use_min_z_set(PointerRNA *ptr, bool value);

float LimitLocationConstraint_min_z_get(PointerRNA *ptr);
void LimitLocationConstraint_min_z_set(PointerRNA *ptr, float value);

/**************** Limit Rotation Constraint ****************/

extern StructRNA RNA_LimitRotationConstraint;
extern StructRNA RNA_Constraint;

bool LimitRotationConstraint_use_transform_limit_get(PointerRNA *ptr);
void LimitRotationConstraint_use_transform_limit_set(PointerRNA *ptr, bool value);

enum {
	LimitRotationConstraint_euler_order_AUTO = 0,
	LimitRotationConstraint_euler_order_XYZ = 1,
	LimitRotationConstraint_euler_order_XZY = 2,
	LimitRotationConstraint_euler_order_YXZ = 3,
	LimitRotationConstraint_euler_order_YZX = 4,
	LimitRotationConstraint_euler_order_ZXY = 5,
	LimitRotationConstraint_euler_order_ZYX = 6,
};

int LimitRotationConstraint_euler_order_get(PointerRNA *ptr);
void LimitRotationConstraint_euler_order_set(PointerRNA *ptr, int value);

bool LimitRotationConstraint_use_legacy_behavior_get(PointerRNA *ptr);
void LimitRotationConstraint_use_legacy_behavior_set(PointerRNA *ptr, bool value);

bool LimitRotationConstraint_use_limit_x_get(PointerRNA *ptr);
void LimitRotationConstraint_use_limit_x_set(PointerRNA *ptr, bool value);

bool LimitRotationConstraint_use_limit_y_get(PointerRNA *ptr);
void LimitRotationConstraint_use_limit_y_set(PointerRNA *ptr, bool value);

bool LimitRotationConstraint_use_limit_z_get(PointerRNA *ptr);
void LimitRotationConstraint_use_limit_z_set(PointerRNA *ptr, bool value);

float LimitRotationConstraint_max_x_get(PointerRNA *ptr);
void LimitRotationConstraint_max_x_set(PointerRNA *ptr, float value);

float LimitRotationConstraint_max_y_get(PointerRNA *ptr);
void LimitRotationConstraint_max_y_set(PointerRNA *ptr, float value);

float LimitRotationConstraint_max_z_get(PointerRNA *ptr);
void LimitRotationConstraint_max_z_set(PointerRNA *ptr, float value);

float LimitRotationConstraint_min_x_get(PointerRNA *ptr);
void LimitRotationConstraint_min_x_set(PointerRNA *ptr, float value);

float LimitRotationConstraint_min_y_get(PointerRNA *ptr);
void LimitRotationConstraint_min_y_set(PointerRNA *ptr, float value);

float LimitRotationConstraint_min_z_get(PointerRNA *ptr);
void LimitRotationConstraint_min_z_set(PointerRNA *ptr, float value);

/**************** Limit Size Constraint ****************/

extern StructRNA RNA_LimitScaleConstraint;
extern StructRNA RNA_Constraint;

bool LimitScaleConstraint_use_transform_limit_get(PointerRNA *ptr);
void LimitScaleConstraint_use_transform_limit_set(PointerRNA *ptr, bool value);

bool LimitScaleConstraint_use_max_x_get(PointerRNA *ptr);
void LimitScaleConstraint_use_max_x_set(PointerRNA *ptr, bool value);

float LimitScaleConstraint_max_x_get(PointerRNA *ptr);
void LimitScaleConstraint_max_x_set(PointerRNA *ptr, float value);

bool LimitScaleConstraint_use_max_y_get(PointerRNA *ptr);
void LimitScaleConstraint_use_max_y_set(PointerRNA *ptr, bool value);

float LimitScaleConstraint_max_y_get(PointerRNA *ptr);
void LimitScaleConstraint_max_y_set(PointerRNA *ptr, float value);

bool LimitScaleConstraint_use_max_z_get(PointerRNA *ptr);
void LimitScaleConstraint_use_max_z_set(PointerRNA *ptr, bool value);

float LimitScaleConstraint_max_z_get(PointerRNA *ptr);
void LimitScaleConstraint_max_z_set(PointerRNA *ptr, float value);

bool LimitScaleConstraint_use_min_x_get(PointerRNA *ptr);
void LimitScaleConstraint_use_min_x_set(PointerRNA *ptr, bool value);

float LimitScaleConstraint_min_x_get(PointerRNA *ptr);
void LimitScaleConstraint_min_x_set(PointerRNA *ptr, float value);

bool LimitScaleConstraint_use_min_y_get(PointerRNA *ptr);
void LimitScaleConstraint_use_min_y_set(PointerRNA *ptr, bool value);

float LimitScaleConstraint_min_y_get(PointerRNA *ptr);
void LimitScaleConstraint_min_y_set(PointerRNA *ptr, float value);

bool LimitScaleConstraint_use_min_z_get(PointerRNA *ptr);
void LimitScaleConstraint_use_min_z_set(PointerRNA *ptr, bool value);

float LimitScaleConstraint_min_z_get(PointerRNA *ptr);
void LimitScaleConstraint_min_z_set(PointerRNA *ptr, float value);

/**************** Line Style Alpha Modifier ****************/

extern StructRNA RNA_LineStyleAlphaModifier;
extern StructRNA RNA_LineStyleModifier;

#define LineStyleAlphaModifier_name_MAX 64

void LineStyleAlphaModifier_name_get(PointerRNA *ptr, char *value);
int LineStyleAlphaModifier_name_length(PointerRNA *ptr);
void LineStyleAlphaModifier_name_set(PointerRNA *ptr, const char *value);

/**************** Along Stroke ****************/

extern StructRNA RNA_LineStyleAlphaModifier_AlongStroke;
extern StructRNA RNA_LineStyleAlphaModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleAlphaModifier_AlongStroke_blend_MIX = 0,
	LineStyleAlphaModifier_AlongStroke_blend_ADD = 1,
	LineStyleAlphaModifier_AlongStroke_blend_SUBTRACT = 3,
	LineStyleAlphaModifier_AlongStroke_blend_MULTIPLY = 2,
	LineStyleAlphaModifier_AlongStroke_blend_DIVIDE = 4,
	LineStyleAlphaModifier_AlongStroke_blend_DIFFERENCE = 5,
	LineStyleAlphaModifier_AlongStroke_blend_MINIMUM = 6,
	LineStyleAlphaModifier_AlongStroke_blend_MAXIMUM = 7,
};

int LineStyleAlphaModifier_AlongStroke_blend_get(PointerRNA *ptr);
void LineStyleAlphaModifier_AlongStroke_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleAlphaModifier_AlongStroke_curve_get(PointerRNA *ptr);

bool LineStyleAlphaModifier_AlongStroke_expanded_get(PointerRNA *ptr);
void LineStyleAlphaModifier_AlongStroke_expanded_set(PointerRNA *ptr, bool value);

float LineStyleAlphaModifier_AlongStroke_influence_get(PointerRNA *ptr);
void LineStyleAlphaModifier_AlongStroke_influence_set(PointerRNA *ptr, float value);

bool LineStyleAlphaModifier_AlongStroke_invert_get(PointerRNA *ptr);
void LineStyleAlphaModifier_AlongStroke_invert_set(PointerRNA *ptr, bool value);

enum {
	LineStyleAlphaModifier_AlongStroke_mapping_LINEAR = 0,
	LineStyleAlphaModifier_AlongStroke_mapping_CURVE = 1,
};

int LineStyleAlphaModifier_AlongStroke_mapping_get(PointerRNA *ptr);
void LineStyleAlphaModifier_AlongStroke_mapping_set(PointerRNA *ptr, int value);

enum {
	LineStyleAlphaModifier_AlongStroke_type_ALONG_STROKE = 1,
	LineStyleAlphaModifier_AlongStroke_type_CREASE_ANGLE = 21,
	LineStyleAlphaModifier_AlongStroke_type_CURVATURE_3D = 23,
	LineStyleAlphaModifier_AlongStroke_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleAlphaModifier_AlongStroke_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleAlphaModifier_AlongStroke_type_MATERIAL = 4,
	LineStyleAlphaModifier_AlongStroke_type_NOISE = 20,
	LineStyleAlphaModifier_AlongStroke_type_TANGENT = 19,
};

int LineStyleAlphaModifier_AlongStroke_type_get(PointerRNA *ptr);
void LineStyleAlphaModifier_AlongStroke_type_set(PointerRNA *ptr, int value);

bool LineStyleAlphaModifier_AlongStroke_use_get(PointerRNA *ptr);
void LineStyleAlphaModifier_AlongStroke_use_set(PointerRNA *ptr, bool value);

/**************** Crease Angle ****************/

extern StructRNA RNA_LineStyleAlphaModifier_CreaseAngle;
extern StructRNA RNA_LineStyleAlphaModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleAlphaModifier_CreaseAngle_blend_MIX = 0,
	LineStyleAlphaModifier_CreaseAngle_blend_ADD = 1,
	LineStyleAlphaModifier_CreaseAngle_blend_SUBTRACT = 3,
	LineStyleAlphaModifier_CreaseAngle_blend_MULTIPLY = 2,
	LineStyleAlphaModifier_CreaseAngle_blend_DIVIDE = 4,
	LineStyleAlphaModifier_CreaseAngle_blend_DIFFERENCE = 5,
	LineStyleAlphaModifier_CreaseAngle_blend_MINIMUM = 6,
	LineStyleAlphaModifier_CreaseAngle_blend_MAXIMUM = 7,
};

int LineStyleAlphaModifier_CreaseAngle_blend_get(PointerRNA *ptr);
void LineStyleAlphaModifier_CreaseAngle_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleAlphaModifier_CreaseAngle_curve_get(PointerRNA *ptr);

bool LineStyleAlphaModifier_CreaseAngle_expanded_get(PointerRNA *ptr);
void LineStyleAlphaModifier_CreaseAngle_expanded_set(PointerRNA *ptr, bool value);

float LineStyleAlphaModifier_CreaseAngle_influence_get(PointerRNA *ptr);
void LineStyleAlphaModifier_CreaseAngle_influence_set(PointerRNA *ptr, float value);

bool LineStyleAlphaModifier_CreaseAngle_invert_get(PointerRNA *ptr);
void LineStyleAlphaModifier_CreaseAngle_invert_set(PointerRNA *ptr, bool value);

enum {
	LineStyleAlphaModifier_CreaseAngle_mapping_LINEAR = 0,
	LineStyleAlphaModifier_CreaseAngle_mapping_CURVE = 1,
};

int LineStyleAlphaModifier_CreaseAngle_mapping_get(PointerRNA *ptr);
void LineStyleAlphaModifier_CreaseAngle_mapping_set(PointerRNA *ptr, int value);

float LineStyleAlphaModifier_CreaseAngle_angle_max_get(PointerRNA *ptr);
void LineStyleAlphaModifier_CreaseAngle_angle_max_set(PointerRNA *ptr, float value);

float LineStyleAlphaModifier_CreaseAngle_angle_min_get(PointerRNA *ptr);
void LineStyleAlphaModifier_CreaseAngle_angle_min_set(PointerRNA *ptr, float value);

enum {
	LineStyleAlphaModifier_CreaseAngle_type_ALONG_STROKE = 1,
	LineStyleAlphaModifier_CreaseAngle_type_CREASE_ANGLE = 21,
	LineStyleAlphaModifier_CreaseAngle_type_CURVATURE_3D = 23,
	LineStyleAlphaModifier_CreaseAngle_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleAlphaModifier_CreaseAngle_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleAlphaModifier_CreaseAngle_type_MATERIAL = 4,
	LineStyleAlphaModifier_CreaseAngle_type_NOISE = 20,
	LineStyleAlphaModifier_CreaseAngle_type_TANGENT = 19,
};

int LineStyleAlphaModifier_CreaseAngle_type_get(PointerRNA *ptr);
void LineStyleAlphaModifier_CreaseAngle_type_set(PointerRNA *ptr, int value);

bool LineStyleAlphaModifier_CreaseAngle_use_get(PointerRNA *ptr);
void LineStyleAlphaModifier_CreaseAngle_use_set(PointerRNA *ptr, bool value);

/**************** Curvature 3D ****************/

extern StructRNA RNA_LineStyleAlphaModifier_Curvature_3D;
extern StructRNA RNA_LineStyleAlphaModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleAlphaModifier_Curvature_3D_blend_MIX = 0,
	LineStyleAlphaModifier_Curvature_3D_blend_ADD = 1,
	LineStyleAlphaModifier_Curvature_3D_blend_SUBTRACT = 3,
	LineStyleAlphaModifier_Curvature_3D_blend_MULTIPLY = 2,
	LineStyleAlphaModifier_Curvature_3D_blend_DIVIDE = 4,
	LineStyleAlphaModifier_Curvature_3D_blend_DIFFERENCE = 5,
	LineStyleAlphaModifier_Curvature_3D_blend_MINIMUM = 6,
	LineStyleAlphaModifier_Curvature_3D_blend_MAXIMUM = 7,
};

int LineStyleAlphaModifier_Curvature_3D_blend_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Curvature_3D_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleAlphaModifier_Curvature_3D_curve_get(PointerRNA *ptr);

bool LineStyleAlphaModifier_Curvature_3D_expanded_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Curvature_3D_expanded_set(PointerRNA *ptr, bool value);

float LineStyleAlphaModifier_Curvature_3D_influence_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Curvature_3D_influence_set(PointerRNA *ptr, float value);

bool LineStyleAlphaModifier_Curvature_3D_invert_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Curvature_3D_invert_set(PointerRNA *ptr, bool value);

enum {
	LineStyleAlphaModifier_Curvature_3D_mapping_LINEAR = 0,
	LineStyleAlphaModifier_Curvature_3D_mapping_CURVE = 1,
};

int LineStyleAlphaModifier_Curvature_3D_mapping_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Curvature_3D_mapping_set(PointerRNA *ptr, int value);

float LineStyleAlphaModifier_Curvature_3D_curvature_max_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Curvature_3D_curvature_max_set(PointerRNA *ptr, float value);

float LineStyleAlphaModifier_Curvature_3D_curvature_min_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Curvature_3D_curvature_min_set(PointerRNA *ptr, float value);

enum {
	LineStyleAlphaModifier_Curvature_3D_type_ALONG_STROKE = 1,
	LineStyleAlphaModifier_Curvature_3D_type_CREASE_ANGLE = 21,
	LineStyleAlphaModifier_Curvature_3D_type_CURVATURE_3D = 23,
	LineStyleAlphaModifier_Curvature_3D_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleAlphaModifier_Curvature_3D_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleAlphaModifier_Curvature_3D_type_MATERIAL = 4,
	LineStyleAlphaModifier_Curvature_3D_type_NOISE = 20,
	LineStyleAlphaModifier_Curvature_3D_type_TANGENT = 19,
};

int LineStyleAlphaModifier_Curvature_3D_type_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Curvature_3D_type_set(PointerRNA *ptr, int value);

bool LineStyleAlphaModifier_Curvature_3D_use_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Curvature_3D_use_set(PointerRNA *ptr, bool value);

/**************** Distance from Camera ****************/

extern StructRNA RNA_LineStyleAlphaModifier_DistanceFromCamera;
extern StructRNA RNA_LineStyleAlphaModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleAlphaModifier_DistanceFromCamera_blend_MIX = 0,
	LineStyleAlphaModifier_DistanceFromCamera_blend_ADD = 1,
	LineStyleAlphaModifier_DistanceFromCamera_blend_SUBTRACT = 3,
	LineStyleAlphaModifier_DistanceFromCamera_blend_MULTIPLY = 2,
	LineStyleAlphaModifier_DistanceFromCamera_blend_DIVIDE = 4,
	LineStyleAlphaModifier_DistanceFromCamera_blend_DIFFERENCE = 5,
	LineStyleAlphaModifier_DistanceFromCamera_blend_MINIMUM = 6,
	LineStyleAlphaModifier_DistanceFromCamera_blend_MAXIMUM = 7,
};

int LineStyleAlphaModifier_DistanceFromCamera_blend_get(PointerRNA *ptr);
void LineStyleAlphaModifier_DistanceFromCamera_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleAlphaModifier_DistanceFromCamera_curve_get(PointerRNA *ptr);

bool LineStyleAlphaModifier_DistanceFromCamera_expanded_get(PointerRNA *ptr);
void LineStyleAlphaModifier_DistanceFromCamera_expanded_set(PointerRNA *ptr, bool value);

float LineStyleAlphaModifier_DistanceFromCamera_influence_get(PointerRNA *ptr);
void LineStyleAlphaModifier_DistanceFromCamera_influence_set(PointerRNA *ptr, float value);

bool LineStyleAlphaModifier_DistanceFromCamera_invert_get(PointerRNA *ptr);
void LineStyleAlphaModifier_DistanceFromCamera_invert_set(PointerRNA *ptr, bool value);

enum {
	LineStyleAlphaModifier_DistanceFromCamera_mapping_LINEAR = 0,
	LineStyleAlphaModifier_DistanceFromCamera_mapping_CURVE = 1,
};

int LineStyleAlphaModifier_DistanceFromCamera_mapping_get(PointerRNA *ptr);
void LineStyleAlphaModifier_DistanceFromCamera_mapping_set(PointerRNA *ptr, int value);

enum {
	LineStyleAlphaModifier_DistanceFromCamera_type_ALONG_STROKE = 1,
	LineStyleAlphaModifier_DistanceFromCamera_type_CREASE_ANGLE = 21,
	LineStyleAlphaModifier_DistanceFromCamera_type_CURVATURE_3D = 23,
	LineStyleAlphaModifier_DistanceFromCamera_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleAlphaModifier_DistanceFromCamera_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleAlphaModifier_DistanceFromCamera_type_MATERIAL = 4,
	LineStyleAlphaModifier_DistanceFromCamera_type_NOISE = 20,
	LineStyleAlphaModifier_DistanceFromCamera_type_TANGENT = 19,
};

int LineStyleAlphaModifier_DistanceFromCamera_type_get(PointerRNA *ptr);
void LineStyleAlphaModifier_DistanceFromCamera_type_set(PointerRNA *ptr, int value);

float LineStyleAlphaModifier_DistanceFromCamera_range_max_get(PointerRNA *ptr);
void LineStyleAlphaModifier_DistanceFromCamera_range_max_set(PointerRNA *ptr, float value);

float LineStyleAlphaModifier_DistanceFromCamera_range_min_get(PointerRNA *ptr);
void LineStyleAlphaModifier_DistanceFromCamera_range_min_set(PointerRNA *ptr, float value);

bool LineStyleAlphaModifier_DistanceFromCamera_use_get(PointerRNA *ptr);
void LineStyleAlphaModifier_DistanceFromCamera_use_set(PointerRNA *ptr, bool value);

/**************** Distance from Object ****************/

extern StructRNA RNA_LineStyleAlphaModifier_DistanceFromObject;
extern StructRNA RNA_LineStyleAlphaModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleAlphaModifier_DistanceFromObject_blend_MIX = 0,
	LineStyleAlphaModifier_DistanceFromObject_blend_ADD = 1,
	LineStyleAlphaModifier_DistanceFromObject_blend_SUBTRACT = 3,
	LineStyleAlphaModifier_DistanceFromObject_blend_MULTIPLY = 2,
	LineStyleAlphaModifier_DistanceFromObject_blend_DIVIDE = 4,
	LineStyleAlphaModifier_DistanceFromObject_blend_DIFFERENCE = 5,
	LineStyleAlphaModifier_DistanceFromObject_blend_MINIMUM = 6,
	LineStyleAlphaModifier_DistanceFromObject_blend_MAXIMUM = 7,
};

int LineStyleAlphaModifier_DistanceFromObject_blend_get(PointerRNA *ptr);
void LineStyleAlphaModifier_DistanceFromObject_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleAlphaModifier_DistanceFromObject_curve_get(PointerRNA *ptr);

bool LineStyleAlphaModifier_DistanceFromObject_expanded_get(PointerRNA *ptr);
void LineStyleAlphaModifier_DistanceFromObject_expanded_set(PointerRNA *ptr, bool value);

float LineStyleAlphaModifier_DistanceFromObject_influence_get(PointerRNA *ptr);
void LineStyleAlphaModifier_DistanceFromObject_influence_set(PointerRNA *ptr, float value);

bool LineStyleAlphaModifier_DistanceFromObject_invert_get(PointerRNA *ptr);
void LineStyleAlphaModifier_DistanceFromObject_invert_set(PointerRNA *ptr, bool value);

enum {
	LineStyleAlphaModifier_DistanceFromObject_mapping_LINEAR = 0,
	LineStyleAlphaModifier_DistanceFromObject_mapping_CURVE = 1,
};

int LineStyleAlphaModifier_DistanceFromObject_mapping_get(PointerRNA *ptr);
void LineStyleAlphaModifier_DistanceFromObject_mapping_set(PointerRNA *ptr, int value);

enum {
	LineStyleAlphaModifier_DistanceFromObject_type_ALONG_STROKE = 1,
	LineStyleAlphaModifier_DistanceFromObject_type_CREASE_ANGLE = 21,
	LineStyleAlphaModifier_DistanceFromObject_type_CURVATURE_3D = 23,
	LineStyleAlphaModifier_DistanceFromObject_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleAlphaModifier_DistanceFromObject_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleAlphaModifier_DistanceFromObject_type_MATERIAL = 4,
	LineStyleAlphaModifier_DistanceFromObject_type_NOISE = 20,
	LineStyleAlphaModifier_DistanceFromObject_type_TANGENT = 19,
};

int LineStyleAlphaModifier_DistanceFromObject_type_get(PointerRNA *ptr);
void LineStyleAlphaModifier_DistanceFromObject_type_set(PointerRNA *ptr, int value);

float LineStyleAlphaModifier_DistanceFromObject_range_max_get(PointerRNA *ptr);
void LineStyleAlphaModifier_DistanceFromObject_range_max_set(PointerRNA *ptr, float value);

float LineStyleAlphaModifier_DistanceFromObject_range_min_get(PointerRNA *ptr);
void LineStyleAlphaModifier_DistanceFromObject_range_min_set(PointerRNA *ptr, float value);

PointerRNA LineStyleAlphaModifier_DistanceFromObject_target_get(PointerRNA *ptr);

bool LineStyleAlphaModifier_DistanceFromObject_use_get(PointerRNA *ptr);
void LineStyleAlphaModifier_DistanceFromObject_use_set(PointerRNA *ptr, bool value);

/**************** Material ****************/

extern StructRNA RNA_LineStyleAlphaModifier_Material;
extern StructRNA RNA_LineStyleAlphaModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleAlphaModifier_Material_blend_MIX = 0,
	LineStyleAlphaModifier_Material_blend_ADD = 1,
	LineStyleAlphaModifier_Material_blend_SUBTRACT = 3,
	LineStyleAlphaModifier_Material_blend_MULTIPLY = 2,
	LineStyleAlphaModifier_Material_blend_DIVIDE = 4,
	LineStyleAlphaModifier_Material_blend_DIFFERENCE = 5,
	LineStyleAlphaModifier_Material_blend_MINIMUM = 6,
	LineStyleAlphaModifier_Material_blend_MAXIMUM = 7,
};

int LineStyleAlphaModifier_Material_blend_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Material_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleAlphaModifier_Material_curve_get(PointerRNA *ptr);

bool LineStyleAlphaModifier_Material_expanded_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Material_expanded_set(PointerRNA *ptr, bool value);

float LineStyleAlphaModifier_Material_influence_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Material_influence_set(PointerRNA *ptr, float value);

bool LineStyleAlphaModifier_Material_invert_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Material_invert_set(PointerRNA *ptr, bool value);

enum {
	LineStyleAlphaModifier_Material_mapping_LINEAR = 0,
	LineStyleAlphaModifier_Material_mapping_CURVE = 1,
};

int LineStyleAlphaModifier_Material_mapping_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Material_mapping_set(PointerRNA *ptr, int value);

enum {
	LineStyleAlphaModifier_Material_material_attribute_LINE = 11,
	LineStyleAlphaModifier_Material_material_attribute_LINE_R = 12,
	LineStyleAlphaModifier_Material_material_attribute_LINE_G = 13,
	LineStyleAlphaModifier_Material_material_attribute_LINE_B = 14,
	LineStyleAlphaModifier_Material_material_attribute_LINE_A = 15,
	LineStyleAlphaModifier_Material_material_attribute_DIFF = 1,
	LineStyleAlphaModifier_Material_material_attribute_DIFF_R = 2,
	LineStyleAlphaModifier_Material_material_attribute_DIFF_G = 3,
	LineStyleAlphaModifier_Material_material_attribute_DIFF_B = 4,
	LineStyleAlphaModifier_Material_material_attribute_SPEC = 5,
	LineStyleAlphaModifier_Material_material_attribute_SPEC_R = 6,
	LineStyleAlphaModifier_Material_material_attribute_SPEC_G = 7,
	LineStyleAlphaModifier_Material_material_attribute_SPEC_B = 8,
	LineStyleAlphaModifier_Material_material_attribute_SPEC_HARD = 9,
	LineStyleAlphaModifier_Material_material_attribute_ALPHA = 10,
};

int LineStyleAlphaModifier_Material_material_attribute_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Material_material_attribute_set(PointerRNA *ptr, int value);

enum {
	LineStyleAlphaModifier_Material_type_ALONG_STROKE = 1,
	LineStyleAlphaModifier_Material_type_CREASE_ANGLE = 21,
	LineStyleAlphaModifier_Material_type_CURVATURE_3D = 23,
	LineStyleAlphaModifier_Material_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleAlphaModifier_Material_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleAlphaModifier_Material_type_MATERIAL = 4,
	LineStyleAlphaModifier_Material_type_NOISE = 20,
	LineStyleAlphaModifier_Material_type_TANGENT = 19,
};

int LineStyleAlphaModifier_Material_type_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Material_type_set(PointerRNA *ptr, int value);

bool LineStyleAlphaModifier_Material_use_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Material_use_set(PointerRNA *ptr, bool value);

/**************** Noise ****************/

extern StructRNA RNA_LineStyleAlphaModifier_Noise;
extern StructRNA RNA_LineStyleAlphaModifier;
extern StructRNA RNA_LineStyleModifier;

float LineStyleAlphaModifier_Noise_amplitude_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Noise_amplitude_set(PointerRNA *ptr, float value);

enum {
	LineStyleAlphaModifier_Noise_blend_MIX = 0,
	LineStyleAlphaModifier_Noise_blend_ADD = 1,
	LineStyleAlphaModifier_Noise_blend_SUBTRACT = 3,
	LineStyleAlphaModifier_Noise_blend_MULTIPLY = 2,
	LineStyleAlphaModifier_Noise_blend_DIVIDE = 4,
	LineStyleAlphaModifier_Noise_blend_DIFFERENCE = 5,
	LineStyleAlphaModifier_Noise_blend_MINIMUM = 6,
	LineStyleAlphaModifier_Noise_blend_MAXIMUM = 7,
};

int LineStyleAlphaModifier_Noise_blend_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Noise_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleAlphaModifier_Noise_curve_get(PointerRNA *ptr);

bool LineStyleAlphaModifier_Noise_expanded_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Noise_expanded_set(PointerRNA *ptr, bool value);

float LineStyleAlphaModifier_Noise_influence_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Noise_influence_set(PointerRNA *ptr, float value);

bool LineStyleAlphaModifier_Noise_invert_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Noise_invert_set(PointerRNA *ptr, bool value);

enum {
	LineStyleAlphaModifier_Noise_mapping_LINEAR = 0,
	LineStyleAlphaModifier_Noise_mapping_CURVE = 1,
};

int LineStyleAlphaModifier_Noise_mapping_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Noise_mapping_set(PointerRNA *ptr, int value);

enum {
	LineStyleAlphaModifier_Noise_type_ALONG_STROKE = 1,
	LineStyleAlphaModifier_Noise_type_CREASE_ANGLE = 21,
	LineStyleAlphaModifier_Noise_type_CURVATURE_3D = 23,
	LineStyleAlphaModifier_Noise_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleAlphaModifier_Noise_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleAlphaModifier_Noise_type_MATERIAL = 4,
	LineStyleAlphaModifier_Noise_type_NOISE = 20,
	LineStyleAlphaModifier_Noise_type_TANGENT = 19,
};

int LineStyleAlphaModifier_Noise_type_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Noise_type_set(PointerRNA *ptr, int value);

float LineStyleAlphaModifier_Noise_period_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Noise_period_set(PointerRNA *ptr, float value);

int LineStyleAlphaModifier_Noise_seed_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Noise_seed_set(PointerRNA *ptr, int value);

bool LineStyleAlphaModifier_Noise_use_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Noise_use_set(PointerRNA *ptr, bool value);

/**************** Tangent ****************/

extern StructRNA RNA_LineStyleAlphaModifier_Tangent;
extern StructRNA RNA_LineStyleAlphaModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleAlphaModifier_Tangent_blend_MIX = 0,
	LineStyleAlphaModifier_Tangent_blend_ADD = 1,
	LineStyleAlphaModifier_Tangent_blend_SUBTRACT = 3,
	LineStyleAlphaModifier_Tangent_blend_MULTIPLY = 2,
	LineStyleAlphaModifier_Tangent_blend_DIVIDE = 4,
	LineStyleAlphaModifier_Tangent_blend_DIFFERENCE = 5,
	LineStyleAlphaModifier_Tangent_blend_MINIMUM = 6,
	LineStyleAlphaModifier_Tangent_blend_MAXIMUM = 7,
};

int LineStyleAlphaModifier_Tangent_blend_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Tangent_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleAlphaModifier_Tangent_curve_get(PointerRNA *ptr);

bool LineStyleAlphaModifier_Tangent_expanded_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Tangent_expanded_set(PointerRNA *ptr, bool value);

float LineStyleAlphaModifier_Tangent_influence_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Tangent_influence_set(PointerRNA *ptr, float value);

bool LineStyleAlphaModifier_Tangent_invert_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Tangent_invert_set(PointerRNA *ptr, bool value);

enum {
	LineStyleAlphaModifier_Tangent_mapping_LINEAR = 0,
	LineStyleAlphaModifier_Tangent_mapping_CURVE = 1,
};

int LineStyleAlphaModifier_Tangent_mapping_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Tangent_mapping_set(PointerRNA *ptr, int value);

enum {
	LineStyleAlphaModifier_Tangent_type_ALONG_STROKE = 1,
	LineStyleAlphaModifier_Tangent_type_CREASE_ANGLE = 21,
	LineStyleAlphaModifier_Tangent_type_CURVATURE_3D = 23,
	LineStyleAlphaModifier_Tangent_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleAlphaModifier_Tangent_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleAlphaModifier_Tangent_type_MATERIAL = 4,
	LineStyleAlphaModifier_Tangent_type_NOISE = 20,
	LineStyleAlphaModifier_Tangent_type_TANGENT = 19,
};

int LineStyleAlphaModifier_Tangent_type_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Tangent_type_set(PointerRNA *ptr, int value);

bool LineStyleAlphaModifier_Tangent_use_get(PointerRNA *ptr);
void LineStyleAlphaModifier_Tangent_use_set(PointerRNA *ptr, bool value);

/**************** Alpha Modifiers ****************/

extern StructRNA RNA_LineStyleAlphaModifiers;

PointerRNA LineStyleAlphaModifiers_rna_type_get(PointerRNA *ptr);

struct LineStyleModifier *LineStyleAlphaModifiers_new_func(struct FreestyleLineStyle *_self, ReportList *reports, const char * name, int type);
void LineStyleAlphaModifiers_remove_func(struct FreestyleLineStyle *_self, ReportList *reports, struct PointerRNA *modifier);
/**************** Line Style Color Modifier ****************/

extern StructRNA RNA_LineStyleColorModifier;
extern StructRNA RNA_LineStyleModifier;

#define LineStyleColorModifier_name_MAX 64

void LineStyleColorModifier_name_get(PointerRNA *ptr, char *value);
int LineStyleColorModifier_name_length(PointerRNA *ptr);
void LineStyleColorModifier_name_set(PointerRNA *ptr, const char *value);

/**************** Along Stroke ****************/

extern StructRNA RNA_LineStyleColorModifier_AlongStroke;
extern StructRNA RNA_LineStyleColorModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleColorModifier_AlongStroke_blend_MIX = 0,
	LineStyleColorModifier_AlongStroke_blend_DARKEN = 7,
	LineStyleColorModifier_AlongStroke_blend_MULTIPLY = 2,
	LineStyleColorModifier_AlongStroke_blend_BURN = 11,
	LineStyleColorModifier_AlongStroke_blend_LIGHTEN = 8,
	LineStyleColorModifier_AlongStroke_blend_SCREEN = 4,
	LineStyleColorModifier_AlongStroke_blend_DODGE = 10,
	LineStyleColorModifier_AlongStroke_blend_ADD = 1,
	LineStyleColorModifier_AlongStroke_blend_OVERLAY = 9,
	LineStyleColorModifier_AlongStroke_blend_SOFT_LIGHT = 16,
	LineStyleColorModifier_AlongStroke_blend_LINEAR_LIGHT = 17,
	LineStyleColorModifier_AlongStroke_blend_DIFFERENCE = 6,
	LineStyleColorModifier_AlongStroke_blend_EXCLUSION = 18,
	LineStyleColorModifier_AlongStroke_blend_SUBTRACT = 3,
	LineStyleColorModifier_AlongStroke_blend_DIVIDE = 5,
	LineStyleColorModifier_AlongStroke_blend_HUE = 12,
	LineStyleColorModifier_AlongStroke_blend_SATURATION = 13,
	LineStyleColorModifier_AlongStroke_blend_COLOR = 15,
	LineStyleColorModifier_AlongStroke_blend_VALUE = 14,
};

int LineStyleColorModifier_AlongStroke_blend_get(PointerRNA *ptr);
void LineStyleColorModifier_AlongStroke_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleColorModifier_AlongStroke_color_ramp_get(PointerRNA *ptr);

bool LineStyleColorModifier_AlongStroke_expanded_get(PointerRNA *ptr);
void LineStyleColorModifier_AlongStroke_expanded_set(PointerRNA *ptr, bool value);

float LineStyleColorModifier_AlongStroke_influence_get(PointerRNA *ptr);
void LineStyleColorModifier_AlongStroke_influence_set(PointerRNA *ptr, float value);

enum {
	LineStyleColorModifier_AlongStroke_type_ALONG_STROKE = 1,
	LineStyleColorModifier_AlongStroke_type_CREASE_ANGLE = 21,
	LineStyleColorModifier_AlongStroke_type_CURVATURE_3D = 23,
	LineStyleColorModifier_AlongStroke_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleColorModifier_AlongStroke_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleColorModifier_AlongStroke_type_MATERIAL = 4,
	LineStyleColorModifier_AlongStroke_type_NOISE = 20,
	LineStyleColorModifier_AlongStroke_type_TANGENT = 19,
};

int LineStyleColorModifier_AlongStroke_type_get(PointerRNA *ptr);
void LineStyleColorModifier_AlongStroke_type_set(PointerRNA *ptr, int value);

bool LineStyleColorModifier_AlongStroke_use_get(PointerRNA *ptr);
void LineStyleColorModifier_AlongStroke_use_set(PointerRNA *ptr, bool value);

/**************** Crease Angle ****************/

extern StructRNA RNA_LineStyleColorModifier_CreaseAngle;
extern StructRNA RNA_LineStyleColorModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleColorModifier_CreaseAngle_blend_MIX = 0,
	LineStyleColorModifier_CreaseAngle_blend_DARKEN = 7,
	LineStyleColorModifier_CreaseAngle_blend_MULTIPLY = 2,
	LineStyleColorModifier_CreaseAngle_blend_BURN = 11,
	LineStyleColorModifier_CreaseAngle_blend_LIGHTEN = 8,
	LineStyleColorModifier_CreaseAngle_blend_SCREEN = 4,
	LineStyleColorModifier_CreaseAngle_blend_DODGE = 10,
	LineStyleColorModifier_CreaseAngle_blend_ADD = 1,
	LineStyleColorModifier_CreaseAngle_blend_OVERLAY = 9,
	LineStyleColorModifier_CreaseAngle_blend_SOFT_LIGHT = 16,
	LineStyleColorModifier_CreaseAngle_blend_LINEAR_LIGHT = 17,
	LineStyleColorModifier_CreaseAngle_blend_DIFFERENCE = 6,
	LineStyleColorModifier_CreaseAngle_blend_EXCLUSION = 18,
	LineStyleColorModifier_CreaseAngle_blend_SUBTRACT = 3,
	LineStyleColorModifier_CreaseAngle_blend_DIVIDE = 5,
	LineStyleColorModifier_CreaseAngle_blend_HUE = 12,
	LineStyleColorModifier_CreaseAngle_blend_SATURATION = 13,
	LineStyleColorModifier_CreaseAngle_blend_COLOR = 15,
	LineStyleColorModifier_CreaseAngle_blend_VALUE = 14,
};

int LineStyleColorModifier_CreaseAngle_blend_get(PointerRNA *ptr);
void LineStyleColorModifier_CreaseAngle_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleColorModifier_CreaseAngle_color_ramp_get(PointerRNA *ptr);

bool LineStyleColorModifier_CreaseAngle_expanded_get(PointerRNA *ptr);
void LineStyleColorModifier_CreaseAngle_expanded_set(PointerRNA *ptr, bool value);

float LineStyleColorModifier_CreaseAngle_influence_get(PointerRNA *ptr);
void LineStyleColorModifier_CreaseAngle_influence_set(PointerRNA *ptr, float value);

float LineStyleColorModifier_CreaseAngle_angle_max_get(PointerRNA *ptr);
void LineStyleColorModifier_CreaseAngle_angle_max_set(PointerRNA *ptr, float value);

float LineStyleColorModifier_CreaseAngle_angle_min_get(PointerRNA *ptr);
void LineStyleColorModifier_CreaseAngle_angle_min_set(PointerRNA *ptr, float value);

enum {
	LineStyleColorModifier_CreaseAngle_type_ALONG_STROKE = 1,
	LineStyleColorModifier_CreaseAngle_type_CREASE_ANGLE = 21,
	LineStyleColorModifier_CreaseAngle_type_CURVATURE_3D = 23,
	LineStyleColorModifier_CreaseAngle_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleColorModifier_CreaseAngle_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleColorModifier_CreaseAngle_type_MATERIAL = 4,
	LineStyleColorModifier_CreaseAngle_type_NOISE = 20,
	LineStyleColorModifier_CreaseAngle_type_TANGENT = 19,
};

int LineStyleColorModifier_CreaseAngle_type_get(PointerRNA *ptr);
void LineStyleColorModifier_CreaseAngle_type_set(PointerRNA *ptr, int value);

bool LineStyleColorModifier_CreaseAngle_use_get(PointerRNA *ptr);
void LineStyleColorModifier_CreaseAngle_use_set(PointerRNA *ptr, bool value);

/**************** Curvature 3D ****************/

extern StructRNA RNA_LineStyleColorModifier_Curvature_3D;
extern StructRNA RNA_LineStyleColorModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleColorModifier_Curvature_3D_blend_MIX = 0,
	LineStyleColorModifier_Curvature_3D_blend_DARKEN = 7,
	LineStyleColorModifier_Curvature_3D_blend_MULTIPLY = 2,
	LineStyleColorModifier_Curvature_3D_blend_BURN = 11,
	LineStyleColorModifier_Curvature_3D_blend_LIGHTEN = 8,
	LineStyleColorModifier_Curvature_3D_blend_SCREEN = 4,
	LineStyleColorModifier_Curvature_3D_blend_DODGE = 10,
	LineStyleColorModifier_Curvature_3D_blend_ADD = 1,
	LineStyleColorModifier_Curvature_3D_blend_OVERLAY = 9,
	LineStyleColorModifier_Curvature_3D_blend_SOFT_LIGHT = 16,
	LineStyleColorModifier_Curvature_3D_blend_LINEAR_LIGHT = 17,
	LineStyleColorModifier_Curvature_3D_blend_DIFFERENCE = 6,
	LineStyleColorModifier_Curvature_3D_blend_EXCLUSION = 18,
	LineStyleColorModifier_Curvature_3D_blend_SUBTRACT = 3,
	LineStyleColorModifier_Curvature_3D_blend_DIVIDE = 5,
	LineStyleColorModifier_Curvature_3D_blend_HUE = 12,
	LineStyleColorModifier_Curvature_3D_blend_SATURATION = 13,
	LineStyleColorModifier_Curvature_3D_blend_COLOR = 15,
	LineStyleColorModifier_Curvature_3D_blend_VALUE = 14,
};

int LineStyleColorModifier_Curvature_3D_blend_get(PointerRNA *ptr);
void LineStyleColorModifier_Curvature_3D_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleColorModifier_Curvature_3D_color_ramp_get(PointerRNA *ptr);

bool LineStyleColorModifier_Curvature_3D_expanded_get(PointerRNA *ptr);
void LineStyleColorModifier_Curvature_3D_expanded_set(PointerRNA *ptr, bool value);

float LineStyleColorModifier_Curvature_3D_influence_get(PointerRNA *ptr);
void LineStyleColorModifier_Curvature_3D_influence_set(PointerRNA *ptr, float value);

float LineStyleColorModifier_Curvature_3D_curvature_max_get(PointerRNA *ptr);
void LineStyleColorModifier_Curvature_3D_curvature_max_set(PointerRNA *ptr, float value);

float LineStyleColorModifier_Curvature_3D_curvature_min_get(PointerRNA *ptr);
void LineStyleColorModifier_Curvature_3D_curvature_min_set(PointerRNA *ptr, float value);

enum {
	LineStyleColorModifier_Curvature_3D_type_ALONG_STROKE = 1,
	LineStyleColorModifier_Curvature_3D_type_CREASE_ANGLE = 21,
	LineStyleColorModifier_Curvature_3D_type_CURVATURE_3D = 23,
	LineStyleColorModifier_Curvature_3D_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleColorModifier_Curvature_3D_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleColorModifier_Curvature_3D_type_MATERIAL = 4,
	LineStyleColorModifier_Curvature_3D_type_NOISE = 20,
	LineStyleColorModifier_Curvature_3D_type_TANGENT = 19,
};

int LineStyleColorModifier_Curvature_3D_type_get(PointerRNA *ptr);
void LineStyleColorModifier_Curvature_3D_type_set(PointerRNA *ptr, int value);

bool LineStyleColorModifier_Curvature_3D_use_get(PointerRNA *ptr);
void LineStyleColorModifier_Curvature_3D_use_set(PointerRNA *ptr, bool value);

/**************** Distance from Camera ****************/

extern StructRNA RNA_LineStyleColorModifier_DistanceFromCamera;
extern StructRNA RNA_LineStyleColorModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleColorModifier_DistanceFromCamera_blend_MIX = 0,
	LineStyleColorModifier_DistanceFromCamera_blend_DARKEN = 7,
	LineStyleColorModifier_DistanceFromCamera_blend_MULTIPLY = 2,
	LineStyleColorModifier_DistanceFromCamera_blend_BURN = 11,
	LineStyleColorModifier_DistanceFromCamera_blend_LIGHTEN = 8,
	LineStyleColorModifier_DistanceFromCamera_blend_SCREEN = 4,
	LineStyleColorModifier_DistanceFromCamera_blend_DODGE = 10,
	LineStyleColorModifier_DistanceFromCamera_blend_ADD = 1,
	LineStyleColorModifier_DistanceFromCamera_blend_OVERLAY = 9,
	LineStyleColorModifier_DistanceFromCamera_blend_SOFT_LIGHT = 16,
	LineStyleColorModifier_DistanceFromCamera_blend_LINEAR_LIGHT = 17,
	LineStyleColorModifier_DistanceFromCamera_blend_DIFFERENCE = 6,
	LineStyleColorModifier_DistanceFromCamera_blend_EXCLUSION = 18,
	LineStyleColorModifier_DistanceFromCamera_blend_SUBTRACT = 3,
	LineStyleColorModifier_DistanceFromCamera_blend_DIVIDE = 5,
	LineStyleColorModifier_DistanceFromCamera_blend_HUE = 12,
	LineStyleColorModifier_DistanceFromCamera_blend_SATURATION = 13,
	LineStyleColorModifier_DistanceFromCamera_blend_COLOR = 15,
	LineStyleColorModifier_DistanceFromCamera_blend_VALUE = 14,
};

int LineStyleColorModifier_DistanceFromCamera_blend_get(PointerRNA *ptr);
void LineStyleColorModifier_DistanceFromCamera_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleColorModifier_DistanceFromCamera_color_ramp_get(PointerRNA *ptr);

bool LineStyleColorModifier_DistanceFromCamera_expanded_get(PointerRNA *ptr);
void LineStyleColorModifier_DistanceFromCamera_expanded_set(PointerRNA *ptr, bool value);

float LineStyleColorModifier_DistanceFromCamera_influence_get(PointerRNA *ptr);
void LineStyleColorModifier_DistanceFromCamera_influence_set(PointerRNA *ptr, float value);

enum {
	LineStyleColorModifier_DistanceFromCamera_type_ALONG_STROKE = 1,
	LineStyleColorModifier_DistanceFromCamera_type_CREASE_ANGLE = 21,
	LineStyleColorModifier_DistanceFromCamera_type_CURVATURE_3D = 23,
	LineStyleColorModifier_DistanceFromCamera_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleColorModifier_DistanceFromCamera_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleColorModifier_DistanceFromCamera_type_MATERIAL = 4,
	LineStyleColorModifier_DistanceFromCamera_type_NOISE = 20,
	LineStyleColorModifier_DistanceFromCamera_type_TANGENT = 19,
};

int LineStyleColorModifier_DistanceFromCamera_type_get(PointerRNA *ptr);
void LineStyleColorModifier_DistanceFromCamera_type_set(PointerRNA *ptr, int value);

float LineStyleColorModifier_DistanceFromCamera_range_max_get(PointerRNA *ptr);
void LineStyleColorModifier_DistanceFromCamera_range_max_set(PointerRNA *ptr, float value);

float LineStyleColorModifier_DistanceFromCamera_range_min_get(PointerRNA *ptr);
void LineStyleColorModifier_DistanceFromCamera_range_min_set(PointerRNA *ptr, float value);

bool LineStyleColorModifier_DistanceFromCamera_use_get(PointerRNA *ptr);
void LineStyleColorModifier_DistanceFromCamera_use_set(PointerRNA *ptr, bool value);

/**************** Distance from Object ****************/

extern StructRNA RNA_LineStyleColorModifier_DistanceFromObject;
extern StructRNA RNA_LineStyleColorModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleColorModifier_DistanceFromObject_blend_MIX = 0,
	LineStyleColorModifier_DistanceFromObject_blend_DARKEN = 7,
	LineStyleColorModifier_DistanceFromObject_blend_MULTIPLY = 2,
	LineStyleColorModifier_DistanceFromObject_blend_BURN = 11,
	LineStyleColorModifier_DistanceFromObject_blend_LIGHTEN = 8,
	LineStyleColorModifier_DistanceFromObject_blend_SCREEN = 4,
	LineStyleColorModifier_DistanceFromObject_blend_DODGE = 10,
	LineStyleColorModifier_DistanceFromObject_blend_ADD = 1,
	LineStyleColorModifier_DistanceFromObject_blend_OVERLAY = 9,
	LineStyleColorModifier_DistanceFromObject_blend_SOFT_LIGHT = 16,
	LineStyleColorModifier_DistanceFromObject_blend_LINEAR_LIGHT = 17,
	LineStyleColorModifier_DistanceFromObject_blend_DIFFERENCE = 6,
	LineStyleColorModifier_DistanceFromObject_blend_EXCLUSION = 18,
	LineStyleColorModifier_DistanceFromObject_blend_SUBTRACT = 3,
	LineStyleColorModifier_DistanceFromObject_blend_DIVIDE = 5,
	LineStyleColorModifier_DistanceFromObject_blend_HUE = 12,
	LineStyleColorModifier_DistanceFromObject_blend_SATURATION = 13,
	LineStyleColorModifier_DistanceFromObject_blend_COLOR = 15,
	LineStyleColorModifier_DistanceFromObject_blend_VALUE = 14,
};

int LineStyleColorModifier_DistanceFromObject_blend_get(PointerRNA *ptr);
void LineStyleColorModifier_DistanceFromObject_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleColorModifier_DistanceFromObject_color_ramp_get(PointerRNA *ptr);

bool LineStyleColorModifier_DistanceFromObject_expanded_get(PointerRNA *ptr);
void LineStyleColorModifier_DistanceFromObject_expanded_set(PointerRNA *ptr, bool value);

float LineStyleColorModifier_DistanceFromObject_influence_get(PointerRNA *ptr);
void LineStyleColorModifier_DistanceFromObject_influence_set(PointerRNA *ptr, float value);

enum {
	LineStyleColorModifier_DistanceFromObject_type_ALONG_STROKE = 1,
	LineStyleColorModifier_DistanceFromObject_type_CREASE_ANGLE = 21,
	LineStyleColorModifier_DistanceFromObject_type_CURVATURE_3D = 23,
	LineStyleColorModifier_DistanceFromObject_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleColorModifier_DistanceFromObject_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleColorModifier_DistanceFromObject_type_MATERIAL = 4,
	LineStyleColorModifier_DistanceFromObject_type_NOISE = 20,
	LineStyleColorModifier_DistanceFromObject_type_TANGENT = 19,
};

int LineStyleColorModifier_DistanceFromObject_type_get(PointerRNA *ptr);
void LineStyleColorModifier_DistanceFromObject_type_set(PointerRNA *ptr, int value);

float LineStyleColorModifier_DistanceFromObject_range_max_get(PointerRNA *ptr);
void LineStyleColorModifier_DistanceFromObject_range_max_set(PointerRNA *ptr, float value);

float LineStyleColorModifier_DistanceFromObject_range_min_get(PointerRNA *ptr);
void LineStyleColorModifier_DistanceFromObject_range_min_set(PointerRNA *ptr, float value);

PointerRNA LineStyleColorModifier_DistanceFromObject_target_get(PointerRNA *ptr);

bool LineStyleColorModifier_DistanceFromObject_use_get(PointerRNA *ptr);
void LineStyleColorModifier_DistanceFromObject_use_set(PointerRNA *ptr, bool value);

/**************** Material ****************/

extern StructRNA RNA_LineStyleColorModifier_Material;
extern StructRNA RNA_LineStyleColorModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleColorModifier_Material_blend_MIX = 0,
	LineStyleColorModifier_Material_blend_DARKEN = 7,
	LineStyleColorModifier_Material_blend_MULTIPLY = 2,
	LineStyleColorModifier_Material_blend_BURN = 11,
	LineStyleColorModifier_Material_blend_LIGHTEN = 8,
	LineStyleColorModifier_Material_blend_SCREEN = 4,
	LineStyleColorModifier_Material_blend_DODGE = 10,
	LineStyleColorModifier_Material_blend_ADD = 1,
	LineStyleColorModifier_Material_blend_OVERLAY = 9,
	LineStyleColorModifier_Material_blend_SOFT_LIGHT = 16,
	LineStyleColorModifier_Material_blend_LINEAR_LIGHT = 17,
	LineStyleColorModifier_Material_blend_DIFFERENCE = 6,
	LineStyleColorModifier_Material_blend_EXCLUSION = 18,
	LineStyleColorModifier_Material_blend_SUBTRACT = 3,
	LineStyleColorModifier_Material_blend_DIVIDE = 5,
	LineStyleColorModifier_Material_blend_HUE = 12,
	LineStyleColorModifier_Material_blend_SATURATION = 13,
	LineStyleColorModifier_Material_blend_COLOR = 15,
	LineStyleColorModifier_Material_blend_VALUE = 14,
};

int LineStyleColorModifier_Material_blend_get(PointerRNA *ptr);
void LineStyleColorModifier_Material_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleColorModifier_Material_color_ramp_get(PointerRNA *ptr);

bool LineStyleColorModifier_Material_expanded_get(PointerRNA *ptr);
void LineStyleColorModifier_Material_expanded_set(PointerRNA *ptr, bool value);

float LineStyleColorModifier_Material_influence_get(PointerRNA *ptr);
void LineStyleColorModifier_Material_influence_set(PointerRNA *ptr, float value);

enum {
	LineStyleColorModifier_Material_material_attribute_LINE = 11,
	LineStyleColorModifier_Material_material_attribute_LINE_R = 12,
	LineStyleColorModifier_Material_material_attribute_LINE_G = 13,
	LineStyleColorModifier_Material_material_attribute_LINE_B = 14,
	LineStyleColorModifier_Material_material_attribute_LINE_A = 15,
	LineStyleColorModifier_Material_material_attribute_DIFF = 1,
	LineStyleColorModifier_Material_material_attribute_DIFF_R = 2,
	LineStyleColorModifier_Material_material_attribute_DIFF_G = 3,
	LineStyleColorModifier_Material_material_attribute_DIFF_B = 4,
	LineStyleColorModifier_Material_material_attribute_SPEC = 5,
	LineStyleColorModifier_Material_material_attribute_SPEC_R = 6,
	LineStyleColorModifier_Material_material_attribute_SPEC_G = 7,
	LineStyleColorModifier_Material_material_attribute_SPEC_B = 8,
	LineStyleColorModifier_Material_material_attribute_SPEC_HARD = 9,
	LineStyleColorModifier_Material_material_attribute_ALPHA = 10,
};

int LineStyleColorModifier_Material_material_attribute_get(PointerRNA *ptr);
void LineStyleColorModifier_Material_material_attribute_set(PointerRNA *ptr, int value);

enum {
	LineStyleColorModifier_Material_type_ALONG_STROKE = 1,
	LineStyleColorModifier_Material_type_CREASE_ANGLE = 21,
	LineStyleColorModifier_Material_type_CURVATURE_3D = 23,
	LineStyleColorModifier_Material_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleColorModifier_Material_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleColorModifier_Material_type_MATERIAL = 4,
	LineStyleColorModifier_Material_type_NOISE = 20,
	LineStyleColorModifier_Material_type_TANGENT = 19,
};

int LineStyleColorModifier_Material_type_get(PointerRNA *ptr);
void LineStyleColorModifier_Material_type_set(PointerRNA *ptr, int value);

bool LineStyleColorModifier_Material_use_ramp_get(PointerRNA *ptr);
void LineStyleColorModifier_Material_use_ramp_set(PointerRNA *ptr, bool value);

bool LineStyleColorModifier_Material_use_get(PointerRNA *ptr);
void LineStyleColorModifier_Material_use_set(PointerRNA *ptr, bool value);

/**************** Noise ****************/

extern StructRNA RNA_LineStyleColorModifier_Noise;
extern StructRNA RNA_LineStyleColorModifier;
extern StructRNA RNA_LineStyleModifier;

float LineStyleColorModifier_Noise_amplitude_get(PointerRNA *ptr);
void LineStyleColorModifier_Noise_amplitude_set(PointerRNA *ptr, float value);

enum {
	LineStyleColorModifier_Noise_blend_MIX = 0,
	LineStyleColorModifier_Noise_blend_DARKEN = 7,
	LineStyleColorModifier_Noise_blend_MULTIPLY = 2,
	LineStyleColorModifier_Noise_blend_BURN = 11,
	LineStyleColorModifier_Noise_blend_LIGHTEN = 8,
	LineStyleColorModifier_Noise_blend_SCREEN = 4,
	LineStyleColorModifier_Noise_blend_DODGE = 10,
	LineStyleColorModifier_Noise_blend_ADD = 1,
	LineStyleColorModifier_Noise_blend_OVERLAY = 9,
	LineStyleColorModifier_Noise_blend_SOFT_LIGHT = 16,
	LineStyleColorModifier_Noise_blend_LINEAR_LIGHT = 17,
	LineStyleColorModifier_Noise_blend_DIFFERENCE = 6,
	LineStyleColorModifier_Noise_blend_EXCLUSION = 18,
	LineStyleColorModifier_Noise_blend_SUBTRACT = 3,
	LineStyleColorModifier_Noise_blend_DIVIDE = 5,
	LineStyleColorModifier_Noise_blend_HUE = 12,
	LineStyleColorModifier_Noise_blend_SATURATION = 13,
	LineStyleColorModifier_Noise_blend_COLOR = 15,
	LineStyleColorModifier_Noise_blend_VALUE = 14,
};

int LineStyleColorModifier_Noise_blend_get(PointerRNA *ptr);
void LineStyleColorModifier_Noise_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleColorModifier_Noise_color_ramp_get(PointerRNA *ptr);

bool LineStyleColorModifier_Noise_expanded_get(PointerRNA *ptr);
void LineStyleColorModifier_Noise_expanded_set(PointerRNA *ptr, bool value);

float LineStyleColorModifier_Noise_influence_get(PointerRNA *ptr);
void LineStyleColorModifier_Noise_influence_set(PointerRNA *ptr, float value);

enum {
	LineStyleColorModifier_Noise_type_ALONG_STROKE = 1,
	LineStyleColorModifier_Noise_type_CREASE_ANGLE = 21,
	LineStyleColorModifier_Noise_type_CURVATURE_3D = 23,
	LineStyleColorModifier_Noise_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleColorModifier_Noise_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleColorModifier_Noise_type_MATERIAL = 4,
	LineStyleColorModifier_Noise_type_NOISE = 20,
	LineStyleColorModifier_Noise_type_TANGENT = 19,
};

int LineStyleColorModifier_Noise_type_get(PointerRNA *ptr);
void LineStyleColorModifier_Noise_type_set(PointerRNA *ptr, int value);

float LineStyleColorModifier_Noise_period_get(PointerRNA *ptr);
void LineStyleColorModifier_Noise_period_set(PointerRNA *ptr, float value);

int LineStyleColorModifier_Noise_seed_get(PointerRNA *ptr);
void LineStyleColorModifier_Noise_seed_set(PointerRNA *ptr, int value);

bool LineStyleColorModifier_Noise_use_get(PointerRNA *ptr);
void LineStyleColorModifier_Noise_use_set(PointerRNA *ptr, bool value);

/**************** Tangent ****************/

extern StructRNA RNA_LineStyleColorModifier_Tangent;
extern StructRNA RNA_LineStyleColorModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleColorModifier_Tangent_blend_MIX = 0,
	LineStyleColorModifier_Tangent_blend_DARKEN = 7,
	LineStyleColorModifier_Tangent_blend_MULTIPLY = 2,
	LineStyleColorModifier_Tangent_blend_BURN = 11,
	LineStyleColorModifier_Tangent_blend_LIGHTEN = 8,
	LineStyleColorModifier_Tangent_blend_SCREEN = 4,
	LineStyleColorModifier_Tangent_blend_DODGE = 10,
	LineStyleColorModifier_Tangent_blend_ADD = 1,
	LineStyleColorModifier_Tangent_blend_OVERLAY = 9,
	LineStyleColorModifier_Tangent_blend_SOFT_LIGHT = 16,
	LineStyleColorModifier_Tangent_blend_LINEAR_LIGHT = 17,
	LineStyleColorModifier_Tangent_blend_DIFFERENCE = 6,
	LineStyleColorModifier_Tangent_blend_EXCLUSION = 18,
	LineStyleColorModifier_Tangent_blend_SUBTRACT = 3,
	LineStyleColorModifier_Tangent_blend_DIVIDE = 5,
	LineStyleColorModifier_Tangent_blend_HUE = 12,
	LineStyleColorModifier_Tangent_blend_SATURATION = 13,
	LineStyleColorModifier_Tangent_blend_COLOR = 15,
	LineStyleColorModifier_Tangent_blend_VALUE = 14,
};

int LineStyleColorModifier_Tangent_blend_get(PointerRNA *ptr);
void LineStyleColorModifier_Tangent_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleColorModifier_Tangent_color_ramp_get(PointerRNA *ptr);

bool LineStyleColorModifier_Tangent_expanded_get(PointerRNA *ptr);
void LineStyleColorModifier_Tangent_expanded_set(PointerRNA *ptr, bool value);

float LineStyleColorModifier_Tangent_influence_get(PointerRNA *ptr);
void LineStyleColorModifier_Tangent_influence_set(PointerRNA *ptr, float value);

enum {
	LineStyleColorModifier_Tangent_type_ALONG_STROKE = 1,
	LineStyleColorModifier_Tangent_type_CREASE_ANGLE = 21,
	LineStyleColorModifier_Tangent_type_CURVATURE_3D = 23,
	LineStyleColorModifier_Tangent_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleColorModifier_Tangent_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleColorModifier_Tangent_type_MATERIAL = 4,
	LineStyleColorModifier_Tangent_type_NOISE = 20,
	LineStyleColorModifier_Tangent_type_TANGENT = 19,
};

int LineStyleColorModifier_Tangent_type_get(PointerRNA *ptr);
void LineStyleColorModifier_Tangent_type_set(PointerRNA *ptr, int value);

bool LineStyleColorModifier_Tangent_use_get(PointerRNA *ptr);
void LineStyleColorModifier_Tangent_use_set(PointerRNA *ptr, bool value);

/**************** Color Modifiers ****************/

extern StructRNA RNA_LineStyleColorModifiers;

PointerRNA LineStyleColorModifiers_rna_type_get(PointerRNA *ptr);

struct LineStyleModifier *LineStyleColorModifiers_new_func(struct FreestyleLineStyle *_self, ReportList *reports, const char * name, int type);
void LineStyleColorModifiers_remove_func(struct FreestyleLineStyle *_self, ReportList *reports, struct PointerRNA *modifier);
/**************** Line Style Geometry Modifier ****************/

extern StructRNA RNA_LineStyleGeometryModifier;
extern StructRNA RNA_LineStyleModifier;

#define LineStyleGeometryModifier_name_MAX 64

void LineStyleGeometryModifier_name_get(PointerRNA *ptr, char *value);
int LineStyleGeometryModifier_name_length(PointerRNA *ptr);
void LineStyleGeometryModifier_name_set(PointerRNA *ptr, const char *value);

/**************** 2D Offset ****************/

extern StructRNA RNA_LineStyleGeometryModifier_2DOffset;
extern StructRNA RNA_LineStyleGeometryModifier;
extern StructRNA RNA_LineStyleModifier;

float LineStyleGeometryModifier_2DOffset_end_get(PointerRNA *ptr);
void LineStyleGeometryModifier_2DOffset_end_set(PointerRNA *ptr, float value);

bool LineStyleGeometryModifier_2DOffset_expanded_get(PointerRNA *ptr);
void LineStyleGeometryModifier_2DOffset_expanded_set(PointerRNA *ptr, bool value);

enum {
	LineStyleGeometryModifier_2DOffset_type_2D_OFFSET = 17,
	LineStyleGeometryModifier_2DOffset_type_2D_TRANSFORM = 18,
	LineStyleGeometryModifier_2DOffset_type_BACKBONE_STRETCHER = 11,
	LineStyleGeometryModifier_2DOffset_type_BEZIER_CURVE = 6,
	LineStyleGeometryModifier_2DOffset_type_BLUEPRINT = 16,
	LineStyleGeometryModifier_2DOffset_type_GUIDING_LINES = 15,
	LineStyleGeometryModifier_2DOffset_type_PERLIN_NOISE_1D = 9,
	LineStyleGeometryModifier_2DOffset_type_PERLIN_NOISE_2D = 10,
	LineStyleGeometryModifier_2DOffset_type_POLYGONIZATION = 14,
	LineStyleGeometryModifier_2DOffset_type_SAMPLING = 5,
	LineStyleGeometryModifier_2DOffset_type_SIMPLIFICATION = 22,
	LineStyleGeometryModifier_2DOffset_type_SINUS_DISPLACEMENT = 7,
	LineStyleGeometryModifier_2DOffset_type_SPATIAL_NOISE = 8,
	LineStyleGeometryModifier_2DOffset_type_TIP_REMOVER = 12,
};

int LineStyleGeometryModifier_2DOffset_type_get(PointerRNA *ptr);
void LineStyleGeometryModifier_2DOffset_type_set(PointerRNA *ptr, int value);

float LineStyleGeometryModifier_2DOffset_start_get(PointerRNA *ptr);
void LineStyleGeometryModifier_2DOffset_start_set(PointerRNA *ptr, float value);

bool LineStyleGeometryModifier_2DOffset_use_get(PointerRNA *ptr);
void LineStyleGeometryModifier_2DOffset_use_set(PointerRNA *ptr, bool value);

float LineStyleGeometryModifier_2DOffset_x_get(PointerRNA *ptr);
void LineStyleGeometryModifier_2DOffset_x_set(PointerRNA *ptr, float value);

float LineStyleGeometryModifier_2DOffset_y_get(PointerRNA *ptr);
void LineStyleGeometryModifier_2DOffset_y_set(PointerRNA *ptr, float value);

/**************** 2D Transform ****************/

extern StructRNA RNA_LineStyleGeometryModifier_2DTransform;
extern StructRNA RNA_LineStyleGeometryModifier;
extern StructRNA RNA_LineStyleModifier;

bool LineStyleGeometryModifier_2DTransform_expanded_get(PointerRNA *ptr);
void LineStyleGeometryModifier_2DTransform_expanded_set(PointerRNA *ptr, bool value);

enum {
	LineStyleGeometryModifier_2DTransform_type_2D_OFFSET = 17,
	LineStyleGeometryModifier_2DTransform_type_2D_TRANSFORM = 18,
	LineStyleGeometryModifier_2DTransform_type_BACKBONE_STRETCHER = 11,
	LineStyleGeometryModifier_2DTransform_type_BEZIER_CURVE = 6,
	LineStyleGeometryModifier_2DTransform_type_BLUEPRINT = 16,
	LineStyleGeometryModifier_2DTransform_type_GUIDING_LINES = 15,
	LineStyleGeometryModifier_2DTransform_type_PERLIN_NOISE_1D = 9,
	LineStyleGeometryModifier_2DTransform_type_PERLIN_NOISE_2D = 10,
	LineStyleGeometryModifier_2DTransform_type_POLYGONIZATION = 14,
	LineStyleGeometryModifier_2DTransform_type_SAMPLING = 5,
	LineStyleGeometryModifier_2DTransform_type_SIMPLIFICATION = 22,
	LineStyleGeometryModifier_2DTransform_type_SINUS_DISPLACEMENT = 7,
	LineStyleGeometryModifier_2DTransform_type_SPATIAL_NOISE = 8,
	LineStyleGeometryModifier_2DTransform_type_TIP_REMOVER = 12,
};

int LineStyleGeometryModifier_2DTransform_type_get(PointerRNA *ptr);
void LineStyleGeometryModifier_2DTransform_type_set(PointerRNA *ptr, int value);

enum {
	LineStyleGeometryModifier_2DTransform_pivot_CENTER = 1,
	LineStyleGeometryModifier_2DTransform_pivot_START = 2,
	LineStyleGeometryModifier_2DTransform_pivot_END = 3,
	LineStyleGeometryModifier_2DTransform_pivot_PARAM = 4,
	LineStyleGeometryModifier_2DTransform_pivot_ABSOLUTE = 5,
};

int LineStyleGeometryModifier_2DTransform_pivot_get(PointerRNA *ptr);
void LineStyleGeometryModifier_2DTransform_pivot_set(PointerRNA *ptr, int value);

float LineStyleGeometryModifier_2DTransform_pivot_x_get(PointerRNA *ptr);
void LineStyleGeometryModifier_2DTransform_pivot_x_set(PointerRNA *ptr, float value);

float LineStyleGeometryModifier_2DTransform_pivot_y_get(PointerRNA *ptr);
void LineStyleGeometryModifier_2DTransform_pivot_y_set(PointerRNA *ptr, float value);

float LineStyleGeometryModifier_2DTransform_angle_get(PointerRNA *ptr);
void LineStyleGeometryModifier_2DTransform_angle_set(PointerRNA *ptr, float value);

float LineStyleGeometryModifier_2DTransform_scale_x_get(PointerRNA *ptr);
void LineStyleGeometryModifier_2DTransform_scale_x_set(PointerRNA *ptr, float value);

float LineStyleGeometryModifier_2DTransform_scale_y_get(PointerRNA *ptr);
void LineStyleGeometryModifier_2DTransform_scale_y_set(PointerRNA *ptr, float value);

float LineStyleGeometryModifier_2DTransform_pivot_u_get(PointerRNA *ptr);
void LineStyleGeometryModifier_2DTransform_pivot_u_set(PointerRNA *ptr, float value);

bool LineStyleGeometryModifier_2DTransform_use_get(PointerRNA *ptr);
void LineStyleGeometryModifier_2DTransform_use_set(PointerRNA *ptr, bool value);

/**************** Backbone Stretcher ****************/

extern StructRNA RNA_LineStyleGeometryModifier_BackboneStretcher;
extern StructRNA RNA_LineStyleGeometryModifier;
extern StructRNA RNA_LineStyleModifier;

float LineStyleGeometryModifier_BackboneStretcher_backbone_length_get(PointerRNA *ptr);
void LineStyleGeometryModifier_BackboneStretcher_backbone_length_set(PointerRNA *ptr, float value);

bool LineStyleGeometryModifier_BackboneStretcher_expanded_get(PointerRNA *ptr);
void LineStyleGeometryModifier_BackboneStretcher_expanded_set(PointerRNA *ptr, bool value);

enum {
	LineStyleGeometryModifier_BackboneStretcher_type_2D_OFFSET = 17,
	LineStyleGeometryModifier_BackboneStretcher_type_2D_TRANSFORM = 18,
	LineStyleGeometryModifier_BackboneStretcher_type_BACKBONE_STRETCHER = 11,
	LineStyleGeometryModifier_BackboneStretcher_type_BEZIER_CURVE = 6,
	LineStyleGeometryModifier_BackboneStretcher_type_BLUEPRINT = 16,
	LineStyleGeometryModifier_BackboneStretcher_type_GUIDING_LINES = 15,
	LineStyleGeometryModifier_BackboneStretcher_type_PERLIN_NOISE_1D = 9,
	LineStyleGeometryModifier_BackboneStretcher_type_PERLIN_NOISE_2D = 10,
	LineStyleGeometryModifier_BackboneStretcher_type_POLYGONIZATION = 14,
	LineStyleGeometryModifier_BackboneStretcher_type_SAMPLING = 5,
	LineStyleGeometryModifier_BackboneStretcher_type_SIMPLIFICATION = 22,
	LineStyleGeometryModifier_BackboneStretcher_type_SINUS_DISPLACEMENT = 7,
	LineStyleGeometryModifier_BackboneStretcher_type_SPATIAL_NOISE = 8,
	LineStyleGeometryModifier_BackboneStretcher_type_TIP_REMOVER = 12,
};

int LineStyleGeometryModifier_BackboneStretcher_type_get(PointerRNA *ptr);
void LineStyleGeometryModifier_BackboneStretcher_type_set(PointerRNA *ptr, int value);

bool LineStyleGeometryModifier_BackboneStretcher_use_get(PointerRNA *ptr);
void LineStyleGeometryModifier_BackboneStretcher_use_set(PointerRNA *ptr, bool value);

/**************** Bézier Curve ****************/

extern StructRNA RNA_LineStyleGeometryModifier_BezierCurve;
extern StructRNA RNA_LineStyleGeometryModifier;
extern StructRNA RNA_LineStyleModifier;

float LineStyleGeometryModifier_BezierCurve_error_get(PointerRNA *ptr);
void LineStyleGeometryModifier_BezierCurve_error_set(PointerRNA *ptr, float value);

bool LineStyleGeometryModifier_BezierCurve_expanded_get(PointerRNA *ptr);
void LineStyleGeometryModifier_BezierCurve_expanded_set(PointerRNA *ptr, bool value);

enum {
	LineStyleGeometryModifier_BezierCurve_type_2D_OFFSET = 17,
	LineStyleGeometryModifier_BezierCurve_type_2D_TRANSFORM = 18,
	LineStyleGeometryModifier_BezierCurve_type_BACKBONE_STRETCHER = 11,
	LineStyleGeometryModifier_BezierCurve_type_BEZIER_CURVE = 6,
	LineStyleGeometryModifier_BezierCurve_type_BLUEPRINT = 16,
	LineStyleGeometryModifier_BezierCurve_type_GUIDING_LINES = 15,
	LineStyleGeometryModifier_BezierCurve_type_PERLIN_NOISE_1D = 9,
	LineStyleGeometryModifier_BezierCurve_type_PERLIN_NOISE_2D = 10,
	LineStyleGeometryModifier_BezierCurve_type_POLYGONIZATION = 14,
	LineStyleGeometryModifier_BezierCurve_type_SAMPLING = 5,
	LineStyleGeometryModifier_BezierCurve_type_SIMPLIFICATION = 22,
	LineStyleGeometryModifier_BezierCurve_type_SINUS_DISPLACEMENT = 7,
	LineStyleGeometryModifier_BezierCurve_type_SPATIAL_NOISE = 8,
	LineStyleGeometryModifier_BezierCurve_type_TIP_REMOVER = 12,
};

int LineStyleGeometryModifier_BezierCurve_type_get(PointerRNA *ptr);
void LineStyleGeometryModifier_BezierCurve_type_set(PointerRNA *ptr, int value);

bool LineStyleGeometryModifier_BezierCurve_use_get(PointerRNA *ptr);
void LineStyleGeometryModifier_BezierCurve_use_set(PointerRNA *ptr, bool value);

/**************** Blueprint ****************/

extern StructRNA RNA_LineStyleGeometryModifier_Blueprint;
extern StructRNA RNA_LineStyleGeometryModifier;
extern StructRNA RNA_LineStyleModifier;

float LineStyleGeometryModifier_Blueprint_backbone_length_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Blueprint_backbone_length_set(PointerRNA *ptr, float value);

bool LineStyleGeometryModifier_Blueprint_expanded_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Blueprint_expanded_set(PointerRNA *ptr, bool value);

enum {
	LineStyleGeometryModifier_Blueprint_type_2D_OFFSET = 17,
	LineStyleGeometryModifier_Blueprint_type_2D_TRANSFORM = 18,
	LineStyleGeometryModifier_Blueprint_type_BACKBONE_STRETCHER = 11,
	LineStyleGeometryModifier_Blueprint_type_BEZIER_CURVE = 6,
	LineStyleGeometryModifier_Blueprint_type_BLUEPRINT = 16,
	LineStyleGeometryModifier_Blueprint_type_GUIDING_LINES = 15,
	LineStyleGeometryModifier_Blueprint_type_PERLIN_NOISE_1D = 9,
	LineStyleGeometryModifier_Blueprint_type_PERLIN_NOISE_2D = 10,
	LineStyleGeometryModifier_Blueprint_type_POLYGONIZATION = 14,
	LineStyleGeometryModifier_Blueprint_type_SAMPLING = 5,
	LineStyleGeometryModifier_Blueprint_type_SIMPLIFICATION = 22,
	LineStyleGeometryModifier_Blueprint_type_SINUS_DISPLACEMENT = 7,
	LineStyleGeometryModifier_Blueprint_type_SPATIAL_NOISE = 8,
	LineStyleGeometryModifier_Blueprint_type_TIP_REMOVER = 12,
};

int LineStyleGeometryModifier_Blueprint_type_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Blueprint_type_set(PointerRNA *ptr, int value);

int LineStyleGeometryModifier_Blueprint_random_backbone_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Blueprint_random_backbone_set(PointerRNA *ptr, int value);

int LineStyleGeometryModifier_Blueprint_random_center_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Blueprint_random_center_set(PointerRNA *ptr, int value);

int LineStyleGeometryModifier_Blueprint_random_radius_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Blueprint_random_radius_set(PointerRNA *ptr, int value);

int LineStyleGeometryModifier_Blueprint_rounds_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Blueprint_rounds_set(PointerRNA *ptr, int value);

enum {
	LineStyleGeometryModifier_Blueprint_shape_CIRCLES = 1,
	LineStyleGeometryModifier_Blueprint_shape_ELLIPSES = 2,
	LineStyleGeometryModifier_Blueprint_shape_SQUARES = 4,
};

int LineStyleGeometryModifier_Blueprint_shape_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Blueprint_shape_set(PointerRNA *ptr, int value);

bool LineStyleGeometryModifier_Blueprint_use_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Blueprint_use_set(PointerRNA *ptr, bool value);

/**************** Guiding Lines ****************/

extern StructRNA RNA_LineStyleGeometryModifier_GuidingLines;
extern StructRNA RNA_LineStyleGeometryModifier;
extern StructRNA RNA_LineStyleModifier;

bool LineStyleGeometryModifier_GuidingLines_expanded_get(PointerRNA *ptr);
void LineStyleGeometryModifier_GuidingLines_expanded_set(PointerRNA *ptr, bool value);

enum {
	LineStyleGeometryModifier_GuidingLines_type_2D_OFFSET = 17,
	LineStyleGeometryModifier_GuidingLines_type_2D_TRANSFORM = 18,
	LineStyleGeometryModifier_GuidingLines_type_BACKBONE_STRETCHER = 11,
	LineStyleGeometryModifier_GuidingLines_type_BEZIER_CURVE = 6,
	LineStyleGeometryModifier_GuidingLines_type_BLUEPRINT = 16,
	LineStyleGeometryModifier_GuidingLines_type_GUIDING_LINES = 15,
	LineStyleGeometryModifier_GuidingLines_type_PERLIN_NOISE_1D = 9,
	LineStyleGeometryModifier_GuidingLines_type_PERLIN_NOISE_2D = 10,
	LineStyleGeometryModifier_GuidingLines_type_POLYGONIZATION = 14,
	LineStyleGeometryModifier_GuidingLines_type_SAMPLING = 5,
	LineStyleGeometryModifier_GuidingLines_type_SIMPLIFICATION = 22,
	LineStyleGeometryModifier_GuidingLines_type_SINUS_DISPLACEMENT = 7,
	LineStyleGeometryModifier_GuidingLines_type_SPATIAL_NOISE = 8,
	LineStyleGeometryModifier_GuidingLines_type_TIP_REMOVER = 12,
};

int LineStyleGeometryModifier_GuidingLines_type_get(PointerRNA *ptr);
void LineStyleGeometryModifier_GuidingLines_type_set(PointerRNA *ptr, int value);

float LineStyleGeometryModifier_GuidingLines_offset_get(PointerRNA *ptr);
void LineStyleGeometryModifier_GuidingLines_offset_set(PointerRNA *ptr, float value);

bool LineStyleGeometryModifier_GuidingLines_use_get(PointerRNA *ptr);
void LineStyleGeometryModifier_GuidingLines_use_set(PointerRNA *ptr, bool value);

/**************** Perlin Noise 1D ****************/

extern StructRNA RNA_LineStyleGeometryModifier_PerlinNoise1D;
extern StructRNA RNA_LineStyleGeometryModifier;
extern StructRNA RNA_LineStyleModifier;

float LineStyleGeometryModifier_PerlinNoise1D_amplitude_get(PointerRNA *ptr);
void LineStyleGeometryModifier_PerlinNoise1D_amplitude_set(PointerRNA *ptr, float value);

float LineStyleGeometryModifier_PerlinNoise1D_angle_get(PointerRNA *ptr);
void LineStyleGeometryModifier_PerlinNoise1D_angle_set(PointerRNA *ptr, float value);

bool LineStyleGeometryModifier_PerlinNoise1D_expanded_get(PointerRNA *ptr);
void LineStyleGeometryModifier_PerlinNoise1D_expanded_set(PointerRNA *ptr, bool value);

float LineStyleGeometryModifier_PerlinNoise1D_frequency_get(PointerRNA *ptr);
void LineStyleGeometryModifier_PerlinNoise1D_frequency_set(PointerRNA *ptr, float value);

enum {
	LineStyleGeometryModifier_PerlinNoise1D_type_2D_OFFSET = 17,
	LineStyleGeometryModifier_PerlinNoise1D_type_2D_TRANSFORM = 18,
	LineStyleGeometryModifier_PerlinNoise1D_type_BACKBONE_STRETCHER = 11,
	LineStyleGeometryModifier_PerlinNoise1D_type_BEZIER_CURVE = 6,
	LineStyleGeometryModifier_PerlinNoise1D_type_BLUEPRINT = 16,
	LineStyleGeometryModifier_PerlinNoise1D_type_GUIDING_LINES = 15,
	LineStyleGeometryModifier_PerlinNoise1D_type_PERLIN_NOISE_1D = 9,
	LineStyleGeometryModifier_PerlinNoise1D_type_PERLIN_NOISE_2D = 10,
	LineStyleGeometryModifier_PerlinNoise1D_type_POLYGONIZATION = 14,
	LineStyleGeometryModifier_PerlinNoise1D_type_SAMPLING = 5,
	LineStyleGeometryModifier_PerlinNoise1D_type_SIMPLIFICATION = 22,
	LineStyleGeometryModifier_PerlinNoise1D_type_SINUS_DISPLACEMENT = 7,
	LineStyleGeometryModifier_PerlinNoise1D_type_SPATIAL_NOISE = 8,
	LineStyleGeometryModifier_PerlinNoise1D_type_TIP_REMOVER = 12,
};

int LineStyleGeometryModifier_PerlinNoise1D_type_get(PointerRNA *ptr);
void LineStyleGeometryModifier_PerlinNoise1D_type_set(PointerRNA *ptr, int value);

int LineStyleGeometryModifier_PerlinNoise1D_octaves_get(PointerRNA *ptr);
void LineStyleGeometryModifier_PerlinNoise1D_octaves_set(PointerRNA *ptr, int value);

int LineStyleGeometryModifier_PerlinNoise1D_seed_get(PointerRNA *ptr);
void LineStyleGeometryModifier_PerlinNoise1D_seed_set(PointerRNA *ptr, int value);

bool LineStyleGeometryModifier_PerlinNoise1D_use_get(PointerRNA *ptr);
void LineStyleGeometryModifier_PerlinNoise1D_use_set(PointerRNA *ptr, bool value);

/**************** Perlin Noise 2D ****************/

extern StructRNA RNA_LineStyleGeometryModifier_PerlinNoise2D;
extern StructRNA RNA_LineStyleGeometryModifier;
extern StructRNA RNA_LineStyleModifier;

float LineStyleGeometryModifier_PerlinNoise2D_amplitude_get(PointerRNA *ptr);
void LineStyleGeometryModifier_PerlinNoise2D_amplitude_set(PointerRNA *ptr, float value);

float LineStyleGeometryModifier_PerlinNoise2D_angle_get(PointerRNA *ptr);
void LineStyleGeometryModifier_PerlinNoise2D_angle_set(PointerRNA *ptr, float value);

bool LineStyleGeometryModifier_PerlinNoise2D_expanded_get(PointerRNA *ptr);
void LineStyleGeometryModifier_PerlinNoise2D_expanded_set(PointerRNA *ptr, bool value);

float LineStyleGeometryModifier_PerlinNoise2D_frequency_get(PointerRNA *ptr);
void LineStyleGeometryModifier_PerlinNoise2D_frequency_set(PointerRNA *ptr, float value);

enum {
	LineStyleGeometryModifier_PerlinNoise2D_type_2D_OFFSET = 17,
	LineStyleGeometryModifier_PerlinNoise2D_type_2D_TRANSFORM = 18,
	LineStyleGeometryModifier_PerlinNoise2D_type_BACKBONE_STRETCHER = 11,
	LineStyleGeometryModifier_PerlinNoise2D_type_BEZIER_CURVE = 6,
	LineStyleGeometryModifier_PerlinNoise2D_type_BLUEPRINT = 16,
	LineStyleGeometryModifier_PerlinNoise2D_type_GUIDING_LINES = 15,
	LineStyleGeometryModifier_PerlinNoise2D_type_PERLIN_NOISE_1D = 9,
	LineStyleGeometryModifier_PerlinNoise2D_type_PERLIN_NOISE_2D = 10,
	LineStyleGeometryModifier_PerlinNoise2D_type_POLYGONIZATION = 14,
	LineStyleGeometryModifier_PerlinNoise2D_type_SAMPLING = 5,
	LineStyleGeometryModifier_PerlinNoise2D_type_SIMPLIFICATION = 22,
	LineStyleGeometryModifier_PerlinNoise2D_type_SINUS_DISPLACEMENT = 7,
	LineStyleGeometryModifier_PerlinNoise2D_type_SPATIAL_NOISE = 8,
	LineStyleGeometryModifier_PerlinNoise2D_type_TIP_REMOVER = 12,
};

int LineStyleGeometryModifier_PerlinNoise2D_type_get(PointerRNA *ptr);
void LineStyleGeometryModifier_PerlinNoise2D_type_set(PointerRNA *ptr, int value);

int LineStyleGeometryModifier_PerlinNoise2D_octaves_get(PointerRNA *ptr);
void LineStyleGeometryModifier_PerlinNoise2D_octaves_set(PointerRNA *ptr, int value);

int LineStyleGeometryModifier_PerlinNoise2D_seed_get(PointerRNA *ptr);
void LineStyleGeometryModifier_PerlinNoise2D_seed_set(PointerRNA *ptr, int value);

bool LineStyleGeometryModifier_PerlinNoise2D_use_get(PointerRNA *ptr);
void LineStyleGeometryModifier_PerlinNoise2D_use_set(PointerRNA *ptr, bool value);

/**************** Polygonalization ****************/

extern StructRNA RNA_LineStyleGeometryModifier_Polygonalization;
extern StructRNA RNA_LineStyleGeometryModifier;
extern StructRNA RNA_LineStyleModifier;

float LineStyleGeometryModifier_Polygonalization_error_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Polygonalization_error_set(PointerRNA *ptr, float value);

bool LineStyleGeometryModifier_Polygonalization_expanded_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Polygonalization_expanded_set(PointerRNA *ptr, bool value);

enum {
	LineStyleGeometryModifier_Polygonalization_type_2D_OFFSET = 17,
	LineStyleGeometryModifier_Polygonalization_type_2D_TRANSFORM = 18,
	LineStyleGeometryModifier_Polygonalization_type_BACKBONE_STRETCHER = 11,
	LineStyleGeometryModifier_Polygonalization_type_BEZIER_CURVE = 6,
	LineStyleGeometryModifier_Polygonalization_type_BLUEPRINT = 16,
	LineStyleGeometryModifier_Polygonalization_type_GUIDING_LINES = 15,
	LineStyleGeometryModifier_Polygonalization_type_PERLIN_NOISE_1D = 9,
	LineStyleGeometryModifier_Polygonalization_type_PERLIN_NOISE_2D = 10,
	LineStyleGeometryModifier_Polygonalization_type_POLYGONIZATION = 14,
	LineStyleGeometryModifier_Polygonalization_type_SAMPLING = 5,
	LineStyleGeometryModifier_Polygonalization_type_SIMPLIFICATION = 22,
	LineStyleGeometryModifier_Polygonalization_type_SINUS_DISPLACEMENT = 7,
	LineStyleGeometryModifier_Polygonalization_type_SPATIAL_NOISE = 8,
	LineStyleGeometryModifier_Polygonalization_type_TIP_REMOVER = 12,
};

int LineStyleGeometryModifier_Polygonalization_type_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Polygonalization_type_set(PointerRNA *ptr, int value);

bool LineStyleGeometryModifier_Polygonalization_use_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Polygonalization_use_set(PointerRNA *ptr, bool value);

/**************** Sampling ****************/

extern StructRNA RNA_LineStyleGeometryModifier_Sampling;
extern StructRNA RNA_LineStyleGeometryModifier;
extern StructRNA RNA_LineStyleModifier;

bool LineStyleGeometryModifier_Sampling_expanded_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Sampling_expanded_set(PointerRNA *ptr, bool value);

enum {
	LineStyleGeometryModifier_Sampling_type_2D_OFFSET = 17,
	LineStyleGeometryModifier_Sampling_type_2D_TRANSFORM = 18,
	LineStyleGeometryModifier_Sampling_type_BACKBONE_STRETCHER = 11,
	LineStyleGeometryModifier_Sampling_type_BEZIER_CURVE = 6,
	LineStyleGeometryModifier_Sampling_type_BLUEPRINT = 16,
	LineStyleGeometryModifier_Sampling_type_GUIDING_LINES = 15,
	LineStyleGeometryModifier_Sampling_type_PERLIN_NOISE_1D = 9,
	LineStyleGeometryModifier_Sampling_type_PERLIN_NOISE_2D = 10,
	LineStyleGeometryModifier_Sampling_type_POLYGONIZATION = 14,
	LineStyleGeometryModifier_Sampling_type_SAMPLING = 5,
	LineStyleGeometryModifier_Sampling_type_SIMPLIFICATION = 22,
	LineStyleGeometryModifier_Sampling_type_SINUS_DISPLACEMENT = 7,
	LineStyleGeometryModifier_Sampling_type_SPATIAL_NOISE = 8,
	LineStyleGeometryModifier_Sampling_type_TIP_REMOVER = 12,
};

int LineStyleGeometryModifier_Sampling_type_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Sampling_type_set(PointerRNA *ptr, int value);

float LineStyleGeometryModifier_Sampling_sampling_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Sampling_sampling_set(PointerRNA *ptr, float value);

bool LineStyleGeometryModifier_Sampling_use_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Sampling_use_set(PointerRNA *ptr, bool value);

/**************** Simplification ****************/

extern StructRNA RNA_LineStyleGeometryModifier_Simplification;
extern StructRNA RNA_LineStyleGeometryModifier;
extern StructRNA RNA_LineStyleModifier;

bool LineStyleGeometryModifier_Simplification_expanded_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Simplification_expanded_set(PointerRNA *ptr, bool value);

enum {
	LineStyleGeometryModifier_Simplification_type_2D_OFFSET = 17,
	LineStyleGeometryModifier_Simplification_type_2D_TRANSFORM = 18,
	LineStyleGeometryModifier_Simplification_type_BACKBONE_STRETCHER = 11,
	LineStyleGeometryModifier_Simplification_type_BEZIER_CURVE = 6,
	LineStyleGeometryModifier_Simplification_type_BLUEPRINT = 16,
	LineStyleGeometryModifier_Simplification_type_GUIDING_LINES = 15,
	LineStyleGeometryModifier_Simplification_type_PERLIN_NOISE_1D = 9,
	LineStyleGeometryModifier_Simplification_type_PERLIN_NOISE_2D = 10,
	LineStyleGeometryModifier_Simplification_type_POLYGONIZATION = 14,
	LineStyleGeometryModifier_Simplification_type_SAMPLING = 5,
	LineStyleGeometryModifier_Simplification_type_SIMPLIFICATION = 22,
	LineStyleGeometryModifier_Simplification_type_SINUS_DISPLACEMENT = 7,
	LineStyleGeometryModifier_Simplification_type_SPATIAL_NOISE = 8,
	LineStyleGeometryModifier_Simplification_type_TIP_REMOVER = 12,
};

int LineStyleGeometryModifier_Simplification_type_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Simplification_type_set(PointerRNA *ptr, int value);

float LineStyleGeometryModifier_Simplification_tolerance_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Simplification_tolerance_set(PointerRNA *ptr, float value);

bool LineStyleGeometryModifier_Simplification_use_get(PointerRNA *ptr);
void LineStyleGeometryModifier_Simplification_use_set(PointerRNA *ptr, bool value);

/**************** Sinus Displacement ****************/

extern StructRNA RNA_LineStyleGeometryModifier_SinusDisplacement;
extern StructRNA RNA_LineStyleGeometryModifier;
extern StructRNA RNA_LineStyleModifier;

float LineStyleGeometryModifier_SinusDisplacement_amplitude_get(PointerRNA *ptr);
void LineStyleGeometryModifier_SinusDisplacement_amplitude_set(PointerRNA *ptr, float value);

bool LineStyleGeometryModifier_SinusDisplacement_expanded_get(PointerRNA *ptr);
void LineStyleGeometryModifier_SinusDisplacement_expanded_set(PointerRNA *ptr, bool value);

enum {
	LineStyleGeometryModifier_SinusDisplacement_type_2D_OFFSET = 17,
	LineStyleGeometryModifier_SinusDisplacement_type_2D_TRANSFORM = 18,
	LineStyleGeometryModifier_SinusDisplacement_type_BACKBONE_STRETCHER = 11,
	LineStyleGeometryModifier_SinusDisplacement_type_BEZIER_CURVE = 6,
	LineStyleGeometryModifier_SinusDisplacement_type_BLUEPRINT = 16,
	LineStyleGeometryModifier_SinusDisplacement_type_GUIDING_LINES = 15,
	LineStyleGeometryModifier_SinusDisplacement_type_PERLIN_NOISE_1D = 9,
	LineStyleGeometryModifier_SinusDisplacement_type_PERLIN_NOISE_2D = 10,
	LineStyleGeometryModifier_SinusDisplacement_type_POLYGONIZATION = 14,
	LineStyleGeometryModifier_SinusDisplacement_type_SAMPLING = 5,
	LineStyleGeometryModifier_SinusDisplacement_type_SIMPLIFICATION = 22,
	LineStyleGeometryModifier_SinusDisplacement_type_SINUS_DISPLACEMENT = 7,
	LineStyleGeometryModifier_SinusDisplacement_type_SPATIAL_NOISE = 8,
	LineStyleGeometryModifier_SinusDisplacement_type_TIP_REMOVER = 12,
};

int LineStyleGeometryModifier_SinusDisplacement_type_get(PointerRNA *ptr);
void LineStyleGeometryModifier_SinusDisplacement_type_set(PointerRNA *ptr, int value);

float LineStyleGeometryModifier_SinusDisplacement_phase_get(PointerRNA *ptr);
void LineStyleGeometryModifier_SinusDisplacement_phase_set(PointerRNA *ptr, float value);

bool LineStyleGeometryModifier_SinusDisplacement_use_get(PointerRNA *ptr);
void LineStyleGeometryModifier_SinusDisplacement_use_set(PointerRNA *ptr, bool value);

float LineStyleGeometryModifier_SinusDisplacement_wavelength_get(PointerRNA *ptr);
void LineStyleGeometryModifier_SinusDisplacement_wavelength_set(PointerRNA *ptr, float value);

/**************** Spatial Noise ****************/

extern StructRNA RNA_LineStyleGeometryModifier_SpatialNoise;
extern StructRNA RNA_LineStyleGeometryModifier;
extern StructRNA RNA_LineStyleModifier;

float LineStyleGeometryModifier_SpatialNoise_amplitude_get(PointerRNA *ptr);
void LineStyleGeometryModifier_SpatialNoise_amplitude_set(PointerRNA *ptr, float value);

bool LineStyleGeometryModifier_SpatialNoise_expanded_get(PointerRNA *ptr);
void LineStyleGeometryModifier_SpatialNoise_expanded_set(PointerRNA *ptr, bool value);

enum {
	LineStyleGeometryModifier_SpatialNoise_type_2D_OFFSET = 17,
	LineStyleGeometryModifier_SpatialNoise_type_2D_TRANSFORM = 18,
	LineStyleGeometryModifier_SpatialNoise_type_BACKBONE_STRETCHER = 11,
	LineStyleGeometryModifier_SpatialNoise_type_BEZIER_CURVE = 6,
	LineStyleGeometryModifier_SpatialNoise_type_BLUEPRINT = 16,
	LineStyleGeometryModifier_SpatialNoise_type_GUIDING_LINES = 15,
	LineStyleGeometryModifier_SpatialNoise_type_PERLIN_NOISE_1D = 9,
	LineStyleGeometryModifier_SpatialNoise_type_PERLIN_NOISE_2D = 10,
	LineStyleGeometryModifier_SpatialNoise_type_POLYGONIZATION = 14,
	LineStyleGeometryModifier_SpatialNoise_type_SAMPLING = 5,
	LineStyleGeometryModifier_SpatialNoise_type_SIMPLIFICATION = 22,
	LineStyleGeometryModifier_SpatialNoise_type_SINUS_DISPLACEMENT = 7,
	LineStyleGeometryModifier_SpatialNoise_type_SPATIAL_NOISE = 8,
	LineStyleGeometryModifier_SpatialNoise_type_TIP_REMOVER = 12,
};

int LineStyleGeometryModifier_SpatialNoise_type_get(PointerRNA *ptr);
void LineStyleGeometryModifier_SpatialNoise_type_set(PointerRNA *ptr, int value);

int LineStyleGeometryModifier_SpatialNoise_octaves_get(PointerRNA *ptr);
void LineStyleGeometryModifier_SpatialNoise_octaves_set(PointerRNA *ptr, int value);

bool LineStyleGeometryModifier_SpatialNoise_use_pure_random_get(PointerRNA *ptr);
void LineStyleGeometryModifier_SpatialNoise_use_pure_random_set(PointerRNA *ptr, bool value);

float LineStyleGeometryModifier_SpatialNoise_scale_get(PointerRNA *ptr);
void LineStyleGeometryModifier_SpatialNoise_scale_set(PointerRNA *ptr, float value);

bool LineStyleGeometryModifier_SpatialNoise_smooth_get(PointerRNA *ptr);
void LineStyleGeometryModifier_SpatialNoise_smooth_set(PointerRNA *ptr, bool value);

bool LineStyleGeometryModifier_SpatialNoise_use_get(PointerRNA *ptr);
void LineStyleGeometryModifier_SpatialNoise_use_set(PointerRNA *ptr, bool value);

/**************** Tip Remover ****************/

extern StructRNA RNA_LineStyleGeometryModifier_TipRemover;
extern StructRNA RNA_LineStyleGeometryModifier;
extern StructRNA RNA_LineStyleModifier;

bool LineStyleGeometryModifier_TipRemover_expanded_get(PointerRNA *ptr);
void LineStyleGeometryModifier_TipRemover_expanded_set(PointerRNA *ptr, bool value);

enum {
	LineStyleGeometryModifier_TipRemover_type_2D_OFFSET = 17,
	LineStyleGeometryModifier_TipRemover_type_2D_TRANSFORM = 18,
	LineStyleGeometryModifier_TipRemover_type_BACKBONE_STRETCHER = 11,
	LineStyleGeometryModifier_TipRemover_type_BEZIER_CURVE = 6,
	LineStyleGeometryModifier_TipRemover_type_BLUEPRINT = 16,
	LineStyleGeometryModifier_TipRemover_type_GUIDING_LINES = 15,
	LineStyleGeometryModifier_TipRemover_type_PERLIN_NOISE_1D = 9,
	LineStyleGeometryModifier_TipRemover_type_PERLIN_NOISE_2D = 10,
	LineStyleGeometryModifier_TipRemover_type_POLYGONIZATION = 14,
	LineStyleGeometryModifier_TipRemover_type_SAMPLING = 5,
	LineStyleGeometryModifier_TipRemover_type_SIMPLIFICATION = 22,
	LineStyleGeometryModifier_TipRemover_type_SINUS_DISPLACEMENT = 7,
	LineStyleGeometryModifier_TipRemover_type_SPATIAL_NOISE = 8,
	LineStyleGeometryModifier_TipRemover_type_TIP_REMOVER = 12,
};

int LineStyleGeometryModifier_TipRemover_type_get(PointerRNA *ptr);
void LineStyleGeometryModifier_TipRemover_type_set(PointerRNA *ptr, int value);

float LineStyleGeometryModifier_TipRemover_tip_length_get(PointerRNA *ptr);
void LineStyleGeometryModifier_TipRemover_tip_length_set(PointerRNA *ptr, float value);

bool LineStyleGeometryModifier_TipRemover_use_get(PointerRNA *ptr);
void LineStyleGeometryModifier_TipRemover_use_set(PointerRNA *ptr, bool value);

/**************** Geometry Modifiers ****************/

extern StructRNA RNA_LineStyleGeometryModifiers;

PointerRNA LineStyleGeometryModifiers_rna_type_get(PointerRNA *ptr);

struct LineStyleModifier *LineStyleGeometryModifiers_new_func(struct FreestyleLineStyle *_self, ReportList *reports, const char * name, int type);
void LineStyleGeometryModifiers_remove_func(struct FreestyleLineStyle *_self, ReportList *reports, struct PointerRNA *modifier);
/**************** Line Style Modifier ****************/

extern StructRNA RNA_LineStyleModifier;

PointerRNA LineStyleModifier_rna_type_get(PointerRNA *ptr);

/**************** LineStyle Texture Slot ****************/

extern StructRNA RNA_LineStyleTextureSlot;
extern StructRNA RNA_TextureSlot;

bool LineStyleTextureSlot_use_map_alpha_get(PointerRNA *ptr);
void LineStyleTextureSlot_use_map_alpha_set(PointerRNA *ptr, bool value);

float LineStyleTextureSlot_alpha_factor_get(PointerRNA *ptr);
void LineStyleTextureSlot_alpha_factor_set(PointerRNA *ptr, float value);

bool LineStyleTextureSlot_use_map_color_diffuse_get(PointerRNA *ptr);
void LineStyleTextureSlot_use_map_color_diffuse_set(PointerRNA *ptr, bool value);

float LineStyleTextureSlot_diffuse_color_factor_get(PointerRNA *ptr);
void LineStyleTextureSlot_diffuse_color_factor_set(PointerRNA *ptr, float value);

enum {
	LineStyleTextureSlot_mapping_FLAT = 0,
	LineStyleTextureSlot_mapping_CUBE = 1,
	LineStyleTextureSlot_mapping_TUBE = 2,
	LineStyleTextureSlot_mapping_SPHERE = 3,
};

int LineStyleTextureSlot_mapping_get(PointerRNA *ptr);
void LineStyleTextureSlot_mapping_set(PointerRNA *ptr, int value);

enum {
	LineStyleTextureSlot_texture_coords_WINDOW = 1024,
	LineStyleTextureSlot_texture_coords_GLOBAL = 8,
	LineStyleTextureSlot_texture_coords_ALONG_STROKE = 16,
	LineStyleTextureSlot_texture_coords_ORCO = 1,
};

int LineStyleTextureSlot_texture_coords_get(PointerRNA *ptr);
void LineStyleTextureSlot_texture_coords_set(PointerRNA *ptr, int value);

enum {
	LineStyleTextureSlot_mapping_x_NONE = 0,
	LineStyleTextureSlot_mapping_x_X = 1,
	LineStyleTextureSlot_mapping_x_Y = 2,
	LineStyleTextureSlot_mapping_x_Z = 3,
};

int LineStyleTextureSlot_mapping_x_get(PointerRNA *ptr);
void LineStyleTextureSlot_mapping_x_set(PointerRNA *ptr, int value);

enum {
	LineStyleTextureSlot_mapping_y_NONE = 0,
	LineStyleTextureSlot_mapping_y_X = 1,
	LineStyleTextureSlot_mapping_y_Y = 2,
	LineStyleTextureSlot_mapping_y_Z = 3,
};

int LineStyleTextureSlot_mapping_y_get(PointerRNA *ptr);
void LineStyleTextureSlot_mapping_y_set(PointerRNA *ptr, int value);

enum {
	LineStyleTextureSlot_mapping_z_NONE = 0,
	LineStyleTextureSlot_mapping_z_X = 1,
	LineStyleTextureSlot_mapping_z_Y = 2,
	LineStyleTextureSlot_mapping_z_Z = 3,
};

int LineStyleTextureSlot_mapping_z_get(PointerRNA *ptr);
void LineStyleTextureSlot_mapping_z_set(PointerRNA *ptr, int value);

/**************** Texture Slots ****************/

extern StructRNA RNA_LineStyleTextureSlots;

PointerRNA LineStyleTextureSlots_rna_type_get(PointerRNA *ptr);

struct MTex *LineStyleTextureSlots_add_func(struct ID *_selfid, bContext *C, ReportList *reports);
struct MTex *LineStyleTextureSlots_create_func(struct ID *_selfid, bContext *C, ReportList *reports, int index);
void LineStyleTextureSlots_clear_func(struct ID *_selfid, bContext *C, ReportList *reports, int index);
/**************** Line Style Thickness Modifier ****************/

extern StructRNA RNA_LineStyleThicknessModifier;
extern StructRNA RNA_LineStyleModifier;

#define LineStyleThicknessModifier_name_MAX 64

void LineStyleThicknessModifier_name_get(PointerRNA *ptr, char *value);
int LineStyleThicknessModifier_name_length(PointerRNA *ptr);
void LineStyleThicknessModifier_name_set(PointerRNA *ptr, const char *value);

/**************** Along Stroke ****************/

extern StructRNA RNA_LineStyleThicknessModifier_AlongStroke;
extern StructRNA RNA_LineStyleThicknessModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleThicknessModifier_AlongStroke_blend_MIX = 0,
	LineStyleThicknessModifier_AlongStroke_blend_ADD = 1,
	LineStyleThicknessModifier_AlongStroke_blend_SUBTRACT = 3,
	LineStyleThicknessModifier_AlongStroke_blend_MULTIPLY = 2,
	LineStyleThicknessModifier_AlongStroke_blend_DIVIDE = 4,
	LineStyleThicknessModifier_AlongStroke_blend_DIFFERENCE = 5,
	LineStyleThicknessModifier_AlongStroke_blend_MINIMUM = 6,
	LineStyleThicknessModifier_AlongStroke_blend_MAXIMUM = 7,
};

int LineStyleThicknessModifier_AlongStroke_blend_get(PointerRNA *ptr);
void LineStyleThicknessModifier_AlongStroke_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleThicknessModifier_AlongStroke_curve_get(PointerRNA *ptr);

bool LineStyleThicknessModifier_AlongStroke_expanded_get(PointerRNA *ptr);
void LineStyleThicknessModifier_AlongStroke_expanded_set(PointerRNA *ptr, bool value);

float LineStyleThicknessModifier_AlongStroke_influence_get(PointerRNA *ptr);
void LineStyleThicknessModifier_AlongStroke_influence_set(PointerRNA *ptr, float value);

bool LineStyleThicknessModifier_AlongStroke_invert_get(PointerRNA *ptr);
void LineStyleThicknessModifier_AlongStroke_invert_set(PointerRNA *ptr, bool value);

enum {
	LineStyleThicknessModifier_AlongStroke_mapping_LINEAR = 0,
	LineStyleThicknessModifier_AlongStroke_mapping_CURVE = 1,
};

int LineStyleThicknessModifier_AlongStroke_mapping_get(PointerRNA *ptr);
void LineStyleThicknessModifier_AlongStroke_mapping_set(PointerRNA *ptr, int value);

enum {
	LineStyleThicknessModifier_AlongStroke_type_ALONG_STROKE = 1,
	LineStyleThicknessModifier_AlongStroke_type_CALLIGRAPHY = 13,
	LineStyleThicknessModifier_AlongStroke_type_CREASE_ANGLE = 21,
	LineStyleThicknessModifier_AlongStroke_type_CURVATURE_3D = 23,
	LineStyleThicknessModifier_AlongStroke_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleThicknessModifier_AlongStroke_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleThicknessModifier_AlongStroke_type_MATERIAL = 4,
	LineStyleThicknessModifier_AlongStroke_type_NOISE = 20,
	LineStyleThicknessModifier_AlongStroke_type_TANGENT = 19,
};

int LineStyleThicknessModifier_AlongStroke_type_get(PointerRNA *ptr);
void LineStyleThicknessModifier_AlongStroke_type_set(PointerRNA *ptr, int value);

bool LineStyleThicknessModifier_AlongStroke_use_get(PointerRNA *ptr);
void LineStyleThicknessModifier_AlongStroke_use_set(PointerRNA *ptr, bool value);

float LineStyleThicknessModifier_AlongStroke_value_max_get(PointerRNA *ptr);
void LineStyleThicknessModifier_AlongStroke_value_max_set(PointerRNA *ptr, float value);

float LineStyleThicknessModifier_AlongStroke_value_min_get(PointerRNA *ptr);
void LineStyleThicknessModifier_AlongStroke_value_min_set(PointerRNA *ptr, float value);

/**************** Calligraphy ****************/

extern StructRNA RNA_LineStyleThicknessModifier_Calligraphy;
extern StructRNA RNA_LineStyleThicknessModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleThicknessModifier_Calligraphy_blend_MIX = 0,
	LineStyleThicknessModifier_Calligraphy_blend_ADD = 1,
	LineStyleThicknessModifier_Calligraphy_blend_SUBTRACT = 3,
	LineStyleThicknessModifier_Calligraphy_blend_MULTIPLY = 2,
	LineStyleThicknessModifier_Calligraphy_blend_DIVIDE = 4,
	LineStyleThicknessModifier_Calligraphy_blend_DIFFERENCE = 5,
	LineStyleThicknessModifier_Calligraphy_blend_MINIMUM = 6,
	LineStyleThicknessModifier_Calligraphy_blend_MAXIMUM = 7,
};

int LineStyleThicknessModifier_Calligraphy_blend_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Calligraphy_blend_set(PointerRNA *ptr, int value);

bool LineStyleThicknessModifier_Calligraphy_expanded_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Calligraphy_expanded_set(PointerRNA *ptr, bool value);

float LineStyleThicknessModifier_Calligraphy_influence_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Calligraphy_influence_set(PointerRNA *ptr, float value);

float LineStyleThicknessModifier_Calligraphy_thickness_max_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Calligraphy_thickness_max_set(PointerRNA *ptr, float value);

float LineStyleThicknessModifier_Calligraphy_thickness_min_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Calligraphy_thickness_min_set(PointerRNA *ptr, float value);

enum {
	LineStyleThicknessModifier_Calligraphy_type_ALONG_STROKE = 1,
	LineStyleThicknessModifier_Calligraphy_type_CALLIGRAPHY = 13,
	LineStyleThicknessModifier_Calligraphy_type_CREASE_ANGLE = 21,
	LineStyleThicknessModifier_Calligraphy_type_CURVATURE_3D = 23,
	LineStyleThicknessModifier_Calligraphy_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleThicknessModifier_Calligraphy_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleThicknessModifier_Calligraphy_type_MATERIAL = 4,
	LineStyleThicknessModifier_Calligraphy_type_NOISE = 20,
	LineStyleThicknessModifier_Calligraphy_type_TANGENT = 19,
};

int LineStyleThicknessModifier_Calligraphy_type_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Calligraphy_type_set(PointerRNA *ptr, int value);

float LineStyleThicknessModifier_Calligraphy_orientation_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Calligraphy_orientation_set(PointerRNA *ptr, float value);

bool LineStyleThicknessModifier_Calligraphy_use_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Calligraphy_use_set(PointerRNA *ptr, bool value);

/**************** Crease Angle ****************/

extern StructRNA RNA_LineStyleThicknessModifier_CreaseAngle;
extern StructRNA RNA_LineStyleThicknessModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleThicknessModifier_CreaseAngle_blend_MIX = 0,
	LineStyleThicknessModifier_CreaseAngle_blend_ADD = 1,
	LineStyleThicknessModifier_CreaseAngle_blend_SUBTRACT = 3,
	LineStyleThicknessModifier_CreaseAngle_blend_MULTIPLY = 2,
	LineStyleThicknessModifier_CreaseAngle_blend_DIVIDE = 4,
	LineStyleThicknessModifier_CreaseAngle_blend_DIFFERENCE = 5,
	LineStyleThicknessModifier_CreaseAngle_blend_MINIMUM = 6,
	LineStyleThicknessModifier_CreaseAngle_blend_MAXIMUM = 7,
};

int LineStyleThicknessModifier_CreaseAngle_blend_get(PointerRNA *ptr);
void LineStyleThicknessModifier_CreaseAngle_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleThicknessModifier_CreaseAngle_curve_get(PointerRNA *ptr);

bool LineStyleThicknessModifier_CreaseAngle_expanded_get(PointerRNA *ptr);
void LineStyleThicknessModifier_CreaseAngle_expanded_set(PointerRNA *ptr, bool value);

float LineStyleThicknessModifier_CreaseAngle_influence_get(PointerRNA *ptr);
void LineStyleThicknessModifier_CreaseAngle_influence_set(PointerRNA *ptr, float value);

bool LineStyleThicknessModifier_CreaseAngle_invert_get(PointerRNA *ptr);
void LineStyleThicknessModifier_CreaseAngle_invert_set(PointerRNA *ptr, bool value);

enum {
	LineStyleThicknessModifier_CreaseAngle_mapping_LINEAR = 0,
	LineStyleThicknessModifier_CreaseAngle_mapping_CURVE = 1,
};

int LineStyleThicknessModifier_CreaseAngle_mapping_get(PointerRNA *ptr);
void LineStyleThicknessModifier_CreaseAngle_mapping_set(PointerRNA *ptr, int value);

float LineStyleThicknessModifier_CreaseAngle_angle_max_get(PointerRNA *ptr);
void LineStyleThicknessModifier_CreaseAngle_angle_max_set(PointerRNA *ptr, float value);

float LineStyleThicknessModifier_CreaseAngle_thickness_max_get(PointerRNA *ptr);
void LineStyleThicknessModifier_CreaseAngle_thickness_max_set(PointerRNA *ptr, float value);

float LineStyleThicknessModifier_CreaseAngle_angle_min_get(PointerRNA *ptr);
void LineStyleThicknessModifier_CreaseAngle_angle_min_set(PointerRNA *ptr, float value);

float LineStyleThicknessModifier_CreaseAngle_thickness_min_get(PointerRNA *ptr);
void LineStyleThicknessModifier_CreaseAngle_thickness_min_set(PointerRNA *ptr, float value);

enum {
	LineStyleThicknessModifier_CreaseAngle_type_ALONG_STROKE = 1,
	LineStyleThicknessModifier_CreaseAngle_type_CALLIGRAPHY = 13,
	LineStyleThicknessModifier_CreaseAngle_type_CREASE_ANGLE = 21,
	LineStyleThicknessModifier_CreaseAngle_type_CURVATURE_3D = 23,
	LineStyleThicknessModifier_CreaseAngle_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleThicknessModifier_CreaseAngle_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleThicknessModifier_CreaseAngle_type_MATERIAL = 4,
	LineStyleThicknessModifier_CreaseAngle_type_NOISE = 20,
	LineStyleThicknessModifier_CreaseAngle_type_TANGENT = 19,
};

int LineStyleThicknessModifier_CreaseAngle_type_get(PointerRNA *ptr);
void LineStyleThicknessModifier_CreaseAngle_type_set(PointerRNA *ptr, int value);

bool LineStyleThicknessModifier_CreaseAngle_use_get(PointerRNA *ptr);
void LineStyleThicknessModifier_CreaseAngle_use_set(PointerRNA *ptr, bool value);

/**************** Curvature 3D ****************/

extern StructRNA RNA_LineStyleThicknessModifier_Curvature_3D;
extern StructRNA RNA_LineStyleThicknessModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleThicknessModifier_Curvature_3D_blend_MIX = 0,
	LineStyleThicknessModifier_Curvature_3D_blend_ADD = 1,
	LineStyleThicknessModifier_Curvature_3D_blend_SUBTRACT = 3,
	LineStyleThicknessModifier_Curvature_3D_blend_MULTIPLY = 2,
	LineStyleThicknessModifier_Curvature_3D_blend_DIVIDE = 4,
	LineStyleThicknessModifier_Curvature_3D_blend_DIFFERENCE = 5,
	LineStyleThicknessModifier_Curvature_3D_blend_MINIMUM = 6,
	LineStyleThicknessModifier_Curvature_3D_blend_MAXIMUM = 7,
};

int LineStyleThicknessModifier_Curvature_3D_blend_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Curvature_3D_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleThicknessModifier_Curvature_3D_curve_get(PointerRNA *ptr);

bool LineStyleThicknessModifier_Curvature_3D_expanded_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Curvature_3D_expanded_set(PointerRNA *ptr, bool value);

float LineStyleThicknessModifier_Curvature_3D_influence_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Curvature_3D_influence_set(PointerRNA *ptr, float value);

bool LineStyleThicknessModifier_Curvature_3D_invert_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Curvature_3D_invert_set(PointerRNA *ptr, bool value);

enum {
	LineStyleThicknessModifier_Curvature_3D_mapping_LINEAR = 0,
	LineStyleThicknessModifier_Curvature_3D_mapping_CURVE = 1,
};

int LineStyleThicknessModifier_Curvature_3D_mapping_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Curvature_3D_mapping_set(PointerRNA *ptr, int value);

float LineStyleThicknessModifier_Curvature_3D_curvature_max_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Curvature_3D_curvature_max_set(PointerRNA *ptr, float value);

float LineStyleThicknessModifier_Curvature_3D_thickness_max_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Curvature_3D_thickness_max_set(PointerRNA *ptr, float value);

float LineStyleThicknessModifier_Curvature_3D_curvature_min_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Curvature_3D_curvature_min_set(PointerRNA *ptr, float value);

float LineStyleThicknessModifier_Curvature_3D_thickness_min_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Curvature_3D_thickness_min_set(PointerRNA *ptr, float value);

enum {
	LineStyleThicknessModifier_Curvature_3D_type_ALONG_STROKE = 1,
	LineStyleThicknessModifier_Curvature_3D_type_CALLIGRAPHY = 13,
	LineStyleThicknessModifier_Curvature_3D_type_CREASE_ANGLE = 21,
	LineStyleThicknessModifier_Curvature_3D_type_CURVATURE_3D = 23,
	LineStyleThicknessModifier_Curvature_3D_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleThicknessModifier_Curvature_3D_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleThicknessModifier_Curvature_3D_type_MATERIAL = 4,
	LineStyleThicknessModifier_Curvature_3D_type_NOISE = 20,
	LineStyleThicknessModifier_Curvature_3D_type_TANGENT = 19,
};

int LineStyleThicknessModifier_Curvature_3D_type_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Curvature_3D_type_set(PointerRNA *ptr, int value);

bool LineStyleThicknessModifier_Curvature_3D_use_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Curvature_3D_use_set(PointerRNA *ptr, bool value);

/**************** Distance from Camera ****************/

extern StructRNA RNA_LineStyleThicknessModifier_DistanceFromCamera;
extern StructRNA RNA_LineStyleThicknessModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleThicknessModifier_DistanceFromCamera_blend_MIX = 0,
	LineStyleThicknessModifier_DistanceFromCamera_blend_ADD = 1,
	LineStyleThicknessModifier_DistanceFromCamera_blend_SUBTRACT = 3,
	LineStyleThicknessModifier_DistanceFromCamera_blend_MULTIPLY = 2,
	LineStyleThicknessModifier_DistanceFromCamera_blend_DIVIDE = 4,
	LineStyleThicknessModifier_DistanceFromCamera_blend_DIFFERENCE = 5,
	LineStyleThicknessModifier_DistanceFromCamera_blend_MINIMUM = 6,
	LineStyleThicknessModifier_DistanceFromCamera_blend_MAXIMUM = 7,
};

int LineStyleThicknessModifier_DistanceFromCamera_blend_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromCamera_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleThicknessModifier_DistanceFromCamera_curve_get(PointerRNA *ptr);

bool LineStyleThicknessModifier_DistanceFromCamera_expanded_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromCamera_expanded_set(PointerRNA *ptr, bool value);

float LineStyleThicknessModifier_DistanceFromCamera_influence_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromCamera_influence_set(PointerRNA *ptr, float value);

bool LineStyleThicknessModifier_DistanceFromCamera_invert_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromCamera_invert_set(PointerRNA *ptr, bool value);

enum {
	LineStyleThicknessModifier_DistanceFromCamera_mapping_LINEAR = 0,
	LineStyleThicknessModifier_DistanceFromCamera_mapping_CURVE = 1,
};

int LineStyleThicknessModifier_DistanceFromCamera_mapping_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromCamera_mapping_set(PointerRNA *ptr, int value);

enum {
	LineStyleThicknessModifier_DistanceFromCamera_type_ALONG_STROKE = 1,
	LineStyleThicknessModifier_DistanceFromCamera_type_CALLIGRAPHY = 13,
	LineStyleThicknessModifier_DistanceFromCamera_type_CREASE_ANGLE = 21,
	LineStyleThicknessModifier_DistanceFromCamera_type_CURVATURE_3D = 23,
	LineStyleThicknessModifier_DistanceFromCamera_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleThicknessModifier_DistanceFromCamera_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleThicknessModifier_DistanceFromCamera_type_MATERIAL = 4,
	LineStyleThicknessModifier_DistanceFromCamera_type_NOISE = 20,
	LineStyleThicknessModifier_DistanceFromCamera_type_TANGENT = 19,
};

int LineStyleThicknessModifier_DistanceFromCamera_type_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromCamera_type_set(PointerRNA *ptr, int value);

float LineStyleThicknessModifier_DistanceFromCamera_range_max_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromCamera_range_max_set(PointerRNA *ptr, float value);

float LineStyleThicknessModifier_DistanceFromCamera_range_min_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromCamera_range_min_set(PointerRNA *ptr, float value);

bool LineStyleThicknessModifier_DistanceFromCamera_use_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromCamera_use_set(PointerRNA *ptr, bool value);

float LineStyleThicknessModifier_DistanceFromCamera_value_max_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromCamera_value_max_set(PointerRNA *ptr, float value);

float LineStyleThicknessModifier_DistanceFromCamera_value_min_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromCamera_value_min_set(PointerRNA *ptr, float value);

/**************** Distance from Object ****************/

extern StructRNA RNA_LineStyleThicknessModifier_DistanceFromObject;
extern StructRNA RNA_LineStyleThicknessModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleThicknessModifier_DistanceFromObject_blend_MIX = 0,
	LineStyleThicknessModifier_DistanceFromObject_blend_ADD = 1,
	LineStyleThicknessModifier_DistanceFromObject_blend_SUBTRACT = 3,
	LineStyleThicknessModifier_DistanceFromObject_blend_MULTIPLY = 2,
	LineStyleThicknessModifier_DistanceFromObject_blend_DIVIDE = 4,
	LineStyleThicknessModifier_DistanceFromObject_blend_DIFFERENCE = 5,
	LineStyleThicknessModifier_DistanceFromObject_blend_MINIMUM = 6,
	LineStyleThicknessModifier_DistanceFromObject_blend_MAXIMUM = 7,
};

int LineStyleThicknessModifier_DistanceFromObject_blend_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromObject_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleThicknessModifier_DistanceFromObject_curve_get(PointerRNA *ptr);

bool LineStyleThicknessModifier_DistanceFromObject_expanded_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromObject_expanded_set(PointerRNA *ptr, bool value);

float LineStyleThicknessModifier_DistanceFromObject_influence_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromObject_influence_set(PointerRNA *ptr, float value);

bool LineStyleThicknessModifier_DistanceFromObject_invert_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromObject_invert_set(PointerRNA *ptr, bool value);

enum {
	LineStyleThicknessModifier_DistanceFromObject_mapping_LINEAR = 0,
	LineStyleThicknessModifier_DistanceFromObject_mapping_CURVE = 1,
};

int LineStyleThicknessModifier_DistanceFromObject_mapping_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromObject_mapping_set(PointerRNA *ptr, int value);

enum {
	LineStyleThicknessModifier_DistanceFromObject_type_ALONG_STROKE = 1,
	LineStyleThicknessModifier_DistanceFromObject_type_CALLIGRAPHY = 13,
	LineStyleThicknessModifier_DistanceFromObject_type_CREASE_ANGLE = 21,
	LineStyleThicknessModifier_DistanceFromObject_type_CURVATURE_3D = 23,
	LineStyleThicknessModifier_DistanceFromObject_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleThicknessModifier_DistanceFromObject_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleThicknessModifier_DistanceFromObject_type_MATERIAL = 4,
	LineStyleThicknessModifier_DistanceFromObject_type_NOISE = 20,
	LineStyleThicknessModifier_DistanceFromObject_type_TANGENT = 19,
};

int LineStyleThicknessModifier_DistanceFromObject_type_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromObject_type_set(PointerRNA *ptr, int value);

float LineStyleThicknessModifier_DistanceFromObject_range_max_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromObject_range_max_set(PointerRNA *ptr, float value);

float LineStyleThicknessModifier_DistanceFromObject_range_min_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromObject_range_min_set(PointerRNA *ptr, float value);

PointerRNA LineStyleThicknessModifier_DistanceFromObject_target_get(PointerRNA *ptr);

bool LineStyleThicknessModifier_DistanceFromObject_use_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromObject_use_set(PointerRNA *ptr, bool value);

float LineStyleThicknessModifier_DistanceFromObject_value_max_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromObject_value_max_set(PointerRNA *ptr, float value);

float LineStyleThicknessModifier_DistanceFromObject_value_min_get(PointerRNA *ptr);
void LineStyleThicknessModifier_DistanceFromObject_value_min_set(PointerRNA *ptr, float value);

/**************** Material ****************/

extern StructRNA RNA_LineStyleThicknessModifier_Material;
extern StructRNA RNA_LineStyleThicknessModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleThicknessModifier_Material_blend_MIX = 0,
	LineStyleThicknessModifier_Material_blend_ADD = 1,
	LineStyleThicknessModifier_Material_blend_SUBTRACT = 3,
	LineStyleThicknessModifier_Material_blend_MULTIPLY = 2,
	LineStyleThicknessModifier_Material_blend_DIVIDE = 4,
	LineStyleThicknessModifier_Material_blend_DIFFERENCE = 5,
	LineStyleThicknessModifier_Material_blend_MINIMUM = 6,
	LineStyleThicknessModifier_Material_blend_MAXIMUM = 7,
};

int LineStyleThicknessModifier_Material_blend_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Material_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleThicknessModifier_Material_curve_get(PointerRNA *ptr);

bool LineStyleThicknessModifier_Material_expanded_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Material_expanded_set(PointerRNA *ptr, bool value);

float LineStyleThicknessModifier_Material_influence_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Material_influence_set(PointerRNA *ptr, float value);

bool LineStyleThicknessModifier_Material_invert_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Material_invert_set(PointerRNA *ptr, bool value);

enum {
	LineStyleThicknessModifier_Material_mapping_LINEAR = 0,
	LineStyleThicknessModifier_Material_mapping_CURVE = 1,
};

int LineStyleThicknessModifier_Material_mapping_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Material_mapping_set(PointerRNA *ptr, int value);

enum {
	LineStyleThicknessModifier_Material_material_attribute_LINE = 11,
	LineStyleThicknessModifier_Material_material_attribute_LINE_R = 12,
	LineStyleThicknessModifier_Material_material_attribute_LINE_G = 13,
	LineStyleThicknessModifier_Material_material_attribute_LINE_B = 14,
	LineStyleThicknessModifier_Material_material_attribute_LINE_A = 15,
	LineStyleThicknessModifier_Material_material_attribute_DIFF = 1,
	LineStyleThicknessModifier_Material_material_attribute_DIFF_R = 2,
	LineStyleThicknessModifier_Material_material_attribute_DIFF_G = 3,
	LineStyleThicknessModifier_Material_material_attribute_DIFF_B = 4,
	LineStyleThicknessModifier_Material_material_attribute_SPEC = 5,
	LineStyleThicknessModifier_Material_material_attribute_SPEC_R = 6,
	LineStyleThicknessModifier_Material_material_attribute_SPEC_G = 7,
	LineStyleThicknessModifier_Material_material_attribute_SPEC_B = 8,
	LineStyleThicknessModifier_Material_material_attribute_SPEC_HARD = 9,
	LineStyleThicknessModifier_Material_material_attribute_ALPHA = 10,
};

int LineStyleThicknessModifier_Material_material_attribute_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Material_material_attribute_set(PointerRNA *ptr, int value);

enum {
	LineStyleThicknessModifier_Material_type_ALONG_STROKE = 1,
	LineStyleThicknessModifier_Material_type_CALLIGRAPHY = 13,
	LineStyleThicknessModifier_Material_type_CREASE_ANGLE = 21,
	LineStyleThicknessModifier_Material_type_CURVATURE_3D = 23,
	LineStyleThicknessModifier_Material_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleThicknessModifier_Material_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleThicknessModifier_Material_type_MATERIAL = 4,
	LineStyleThicknessModifier_Material_type_NOISE = 20,
	LineStyleThicknessModifier_Material_type_TANGENT = 19,
};

int LineStyleThicknessModifier_Material_type_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Material_type_set(PointerRNA *ptr, int value);

bool LineStyleThicknessModifier_Material_use_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Material_use_set(PointerRNA *ptr, bool value);

float LineStyleThicknessModifier_Material_value_max_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Material_value_max_set(PointerRNA *ptr, float value);

float LineStyleThicknessModifier_Material_value_min_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Material_value_min_set(PointerRNA *ptr, float value);

/**************** Noise ****************/

extern StructRNA RNA_LineStyleThicknessModifier_Noise;
extern StructRNA RNA_LineStyleThicknessModifier;
extern StructRNA RNA_LineStyleModifier;

float LineStyleThicknessModifier_Noise_amplitude_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Noise_amplitude_set(PointerRNA *ptr, float value);

bool LineStyleThicknessModifier_Noise_use_asymmetric_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Noise_use_asymmetric_set(PointerRNA *ptr, bool value);

enum {
	LineStyleThicknessModifier_Noise_blend_MIX = 0,
	LineStyleThicknessModifier_Noise_blend_ADD = 1,
	LineStyleThicknessModifier_Noise_blend_SUBTRACT = 3,
	LineStyleThicknessModifier_Noise_blend_MULTIPLY = 2,
	LineStyleThicknessModifier_Noise_blend_DIVIDE = 4,
	LineStyleThicknessModifier_Noise_blend_DIFFERENCE = 5,
	LineStyleThicknessModifier_Noise_blend_MINIMUM = 6,
	LineStyleThicknessModifier_Noise_blend_MAXIMUM = 7,
};

int LineStyleThicknessModifier_Noise_blend_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Noise_blend_set(PointerRNA *ptr, int value);

bool LineStyleThicknessModifier_Noise_expanded_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Noise_expanded_set(PointerRNA *ptr, bool value);

float LineStyleThicknessModifier_Noise_influence_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Noise_influence_set(PointerRNA *ptr, float value);

enum {
	LineStyleThicknessModifier_Noise_type_ALONG_STROKE = 1,
	LineStyleThicknessModifier_Noise_type_CALLIGRAPHY = 13,
	LineStyleThicknessModifier_Noise_type_CREASE_ANGLE = 21,
	LineStyleThicknessModifier_Noise_type_CURVATURE_3D = 23,
	LineStyleThicknessModifier_Noise_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleThicknessModifier_Noise_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleThicknessModifier_Noise_type_MATERIAL = 4,
	LineStyleThicknessModifier_Noise_type_NOISE = 20,
	LineStyleThicknessModifier_Noise_type_TANGENT = 19,
};

int LineStyleThicknessModifier_Noise_type_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Noise_type_set(PointerRNA *ptr, int value);

float LineStyleThicknessModifier_Noise_period_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Noise_period_set(PointerRNA *ptr, float value);

int LineStyleThicknessModifier_Noise_seed_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Noise_seed_set(PointerRNA *ptr, int value);

bool LineStyleThicknessModifier_Noise_use_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Noise_use_set(PointerRNA *ptr, bool value);

/**************** Tangent ****************/

extern StructRNA RNA_LineStyleThicknessModifier_Tangent;
extern StructRNA RNA_LineStyleThicknessModifier;
extern StructRNA RNA_LineStyleModifier;

enum {
	LineStyleThicknessModifier_Tangent_blend_MIX = 0,
	LineStyleThicknessModifier_Tangent_blend_ADD = 1,
	LineStyleThicknessModifier_Tangent_blend_SUBTRACT = 3,
	LineStyleThicknessModifier_Tangent_blend_MULTIPLY = 2,
	LineStyleThicknessModifier_Tangent_blend_DIVIDE = 4,
	LineStyleThicknessModifier_Tangent_blend_DIFFERENCE = 5,
	LineStyleThicknessModifier_Tangent_blend_MINIMUM = 6,
	LineStyleThicknessModifier_Tangent_blend_MAXIMUM = 7,
};

int LineStyleThicknessModifier_Tangent_blend_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Tangent_blend_set(PointerRNA *ptr, int value);

PointerRNA LineStyleThicknessModifier_Tangent_curve_get(PointerRNA *ptr);

bool LineStyleThicknessModifier_Tangent_expanded_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Tangent_expanded_set(PointerRNA *ptr, bool value);

float LineStyleThicknessModifier_Tangent_influence_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Tangent_influence_set(PointerRNA *ptr, float value);

bool LineStyleThicknessModifier_Tangent_invert_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Tangent_invert_set(PointerRNA *ptr, bool value);

enum {
	LineStyleThicknessModifier_Tangent_mapping_LINEAR = 0,
	LineStyleThicknessModifier_Tangent_mapping_CURVE = 1,
};

int LineStyleThicknessModifier_Tangent_mapping_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Tangent_mapping_set(PointerRNA *ptr, int value);

float LineStyleThicknessModifier_Tangent_thickness_max_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Tangent_thickness_max_set(PointerRNA *ptr, float value);

float LineStyleThicknessModifier_Tangent_thickness_min_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Tangent_thickness_min_set(PointerRNA *ptr, float value);

enum {
	LineStyleThicknessModifier_Tangent_type_ALONG_STROKE = 1,
	LineStyleThicknessModifier_Tangent_type_CALLIGRAPHY = 13,
	LineStyleThicknessModifier_Tangent_type_CREASE_ANGLE = 21,
	LineStyleThicknessModifier_Tangent_type_CURVATURE_3D = 23,
	LineStyleThicknessModifier_Tangent_type_DISTANCE_FROM_CAMERA = 2,
	LineStyleThicknessModifier_Tangent_type_DISTANCE_FROM_OBJECT = 3,
	LineStyleThicknessModifier_Tangent_type_MATERIAL = 4,
	LineStyleThicknessModifier_Tangent_type_NOISE = 20,
	LineStyleThicknessModifier_Tangent_type_TANGENT = 19,
};

int LineStyleThicknessModifier_Tangent_type_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Tangent_type_set(PointerRNA *ptr, int value);

bool LineStyleThicknessModifier_Tangent_use_get(PointerRNA *ptr);
void LineStyleThicknessModifier_Tangent_use_set(PointerRNA *ptr, bool value);

/**************** Thickness Modifiers ****************/

extern StructRNA RNA_LineStyleThicknessModifiers;

PointerRNA LineStyleThicknessModifiers_rna_type_get(PointerRNA *ptr);

struct LineStyleModifier *LineStyleThicknessModifiers_new_func(struct FreestyleLineStyle *_self, ReportList *reports, const char * name, int type);
void LineStyleThicknessModifiers_remove_func(struct FreestyleLineStyle *_self, ReportList *reports, struct PointerRNA *modifier);
/**************** Line Sets ****************/

extern StructRNA RNA_Linesets;

PointerRNA Linesets_rna_type_get(PointerRNA *ptr);

PointerRNA Linesets_active_get(PointerRNA *ptr);

int Linesets_active_index_get(PointerRNA *ptr);
void Linesets_active_index_set(PointerRNA *ptr, int value);

struct FreestyleLineSet *Linesets_new_func(struct ID *_selfid, struct FreestyleSettings *_self, Main *bmain, const char * name);
void Linesets_remove_func(struct ID *_selfid, struct FreestyleSettings *_self, ReportList *reports, struct PointerRNA *lineset);
/**************** Locked Track Constraint ****************/

extern StructRNA RNA_LockedTrackConstraint;
extern StructRNA RNA_Constraint;

bool LockedTrackConstraint_use_bbone_shape_get(PointerRNA *ptr);
void LockedTrackConstraint_use_bbone_shape_set(PointerRNA *ptr, bool value);

float LockedTrackConstraint_head_tail_get(PointerRNA *ptr);
void LockedTrackConstraint_head_tail_set(PointerRNA *ptr, float value);

enum {
	LockedTrackConstraint_lock_axis_LOCK_X = 0,
	LockedTrackConstraint_lock_axis_LOCK_Y = 1,
	LockedTrackConstraint_lock_axis_LOCK_Z = 2,
};

int LockedTrackConstraint_lock_axis_get(PointerRNA *ptr);
void LockedTrackConstraint_lock_axis_set(PointerRNA *ptr, int value);

#define LockedTrackConstraint_subtarget_MAX 64

void LockedTrackConstraint_subtarget_get(PointerRNA *ptr, char *value);
int LockedTrackConstraint_subtarget_length(PointerRNA *ptr);
void LockedTrackConstraint_subtarget_set(PointerRNA *ptr, const char *value);

PointerRNA LockedTrackConstraint_target_get(PointerRNA *ptr);

enum {
	LockedTrackConstraint_track_axis_TRACK_X = 0,
	LockedTrackConstraint_track_axis_TRACK_Y = 1,
	LockedTrackConstraint_track_axis_TRACK_Z = 2,
	LockedTrackConstraint_track_axis_TRACK_NEGATIVE_X = 3,
	LockedTrackConstraint_track_axis_TRACK_NEGATIVE_Y = 4,
	LockedTrackConstraint_track_axis_TRACK_NEGATIVE_Z = 5,
};

int LockedTrackConstraint_track_axis_get(PointerRNA *ptr);
void LockedTrackConstraint_track_axis_set(PointerRNA *ptr, int value);

/**************** Loop Colors ****************/

extern StructRNA RNA_LoopColors;

PointerRNA LoopColors_rna_type_get(PointerRNA *ptr);

int LoopColors_active_index_get(PointerRNA *ptr);
void LoopColors_active_index_set(PointerRNA *ptr, int value);

PointerRNA LoopColors_active_get(PointerRNA *ptr);

struct PointerRNA LoopColors_new_func(struct Mesh *_self, ReportList *reports, const char * name, bool do_init);
void LoopColors_remove_func(struct Mesh *_self, ReportList *reports, struct CustomDataLayer *layer);
/**************** Macro Operator ****************/

extern StructRNA RNA_Macro;

PointerRNA Macro_rna_type_get(PointerRNA *ptr);

void Macro_name_get(PointerRNA *ptr, char *value);
int Macro_name_length(PointerRNA *ptr);
void Macro_name_set(PointerRNA *ptr, const char *value);

bool Macro_has_reports_get(PointerRNA *ptr);
void Macro_has_reports_set(PointerRNA *ptr, bool value);

enum {
	Macro_bl_cursor_pending_DEFAULT = 1,
	Macro_bl_cursor_pending_NONE = 38,
	Macro_bl_cursor_pending_WAIT = 3,
	Macro_bl_cursor_pending_CROSSHAIR = 5,
	Macro_bl_cursor_pending_MOVE_X = 22,
	Macro_bl_cursor_pending_MOVE_Y = 23,
	Macro_bl_cursor_pending_KNIFE = 15,
	Macro_bl_cursor_pending_TEXT = 2,
	Macro_bl_cursor_pending_PAINT_BRUSH = 18,
	Macro_bl_cursor_pending_PAINT_CROSS = 12,
	Macro_bl_cursor_pending_DOT = 13,
	Macro_bl_cursor_pending_ERASER = 19,
	Macro_bl_cursor_pending_HAND = 8,
	Macro_bl_cursor_pending_HAND_POINT = 10,
	Macro_bl_cursor_pending_HAND_CLOSED = 9,
	Macro_bl_cursor_pending_SCROLL_X = 35,
	Macro_bl_cursor_pending_SCROLL_Y = 34,
	Macro_bl_cursor_pending_SCROLL_XY = 33,
	Macro_bl_cursor_pending_EYEDROPPER = 20,
	Macro_bl_cursor_pending_PICK_AREA = 40,
	Macro_bl_cursor_pending_STOP = 4,
	Macro_bl_cursor_pending_COPY = 6,
	Macro_bl_cursor_pending_CROSS = 11,
	Macro_bl_cursor_pending_MUTE = 39,
	Macro_bl_cursor_pending_ZOOM_IN = 36,
	Macro_bl_cursor_pending_ZOOM_OUT = 37,
};

int Macro_bl_cursor_pending_get(PointerRNA *ptr);
void Macro_bl_cursor_pending_set(PointerRNA *ptr, int value);

enum {
	Macro_bl_options_REGISTER = 1,
	Macro_bl_options_UNDO = 2,
	Macro_bl_options_UNDO_GROUPED = 1024,
	Macro_bl_options_BLOCKING = 4,
	Macro_bl_options_MACRO = 8,
	Macro_bl_options_GRAB_CURSOR = 16,
	Macro_bl_options_GRAB_CURSOR_X = 32,
	Macro_bl_options_GRAB_CURSOR_Y = 64,
	Macro_bl_options_DEPENDS_ON_CURSOR = 2048,
	Macro_bl_options_PRESET = 128,
	Macro_bl_options_INTERNAL = 256,
	Macro_bl_options_MODAL_PRIORITY = 4096,
};

int Macro_bl_options_get(PointerRNA *ptr);
void Macro_bl_options_set(PointerRNA *ptr, int value);

PointerRNA Macro_properties_get(PointerRNA *ptr);

#define Macro_bl_description_MAX 1024

void Macro_bl_description_get(PointerRNA *ptr, char *value);
int Macro_bl_description_length(PointerRNA *ptr);
void Macro_bl_description_set(PointerRNA *ptr, const char *value);

#define Macro_bl_idname_MAX 64

void Macro_bl_idname_get(PointerRNA *ptr, char *value);
int Macro_bl_idname_length(PointerRNA *ptr);
void Macro_bl_idname_set(PointerRNA *ptr, const char *value);

#define Macro_bl_label_MAX 64

void Macro_bl_label_get(PointerRNA *ptr, char *value);
int Macro_bl_label_length(PointerRNA *ptr);
void Macro_bl_label_set(PointerRNA *ptr, const char *value);

#define Macro_bl_translation_context_MAX 64

void Macro_bl_translation_context_get(PointerRNA *ptr, char *value);
int Macro_bl_translation_context_length(PointerRNA *ptr);
void Macro_bl_translation_context_set(PointerRNA *ptr, const char *value);

#define Macro_bl_undo_group_MAX 64

void Macro_bl_undo_group_get(PointerRNA *ptr, char *value);
int Macro_bl_undo_group_length(PointerRNA *ptr);
void Macro_bl_undo_group_set(PointerRNA *ptr, const char *value);

void Macro_report_func(struct wmOperator *_self, int type, const char * message);
bool Macro_poll_func(struct bContext *context);
void Macro_draw_func(struct wmOperator *_self, struct bContext *context);
/**************** Magic Texture ****************/

extern StructRNA RNA_MagicTexture;
extern StructRNA RNA_Texture;
extern StructRNA RNA_ID;

int MagicTexture_noise_depth_get(PointerRNA *ptr);
void MagicTexture_noise_depth_set(PointerRNA *ptr, int value);

float MagicTexture_turbulence_get(PointerRNA *ptr);
void MagicTexture_turbulence_set(PointerRNA *ptr, float value);

/**************** Maintain Volume Constraint ****************/

extern StructRNA RNA_MaintainVolumeConstraint;
extern StructRNA RNA_Constraint;

enum {
	MaintainVolumeConstraint_free_axis_SAMEVOL_X = 0,
	MaintainVolumeConstraint_free_axis_SAMEVOL_Y = 1,
	MaintainVolumeConstraint_free_axis_SAMEVOL_Z = 2,
};

int MaintainVolumeConstraint_free_axis_get(PointerRNA *ptr);
void MaintainVolumeConstraint_free_axis_set(PointerRNA *ptr, int value);

enum {
	MaintainVolumeConstraint_mode_STRICT = 0,
	MaintainVolumeConstraint_mode_UNIFORM = 1,
	MaintainVolumeConstraint_mode_SINGLE_AXIS = 2,
};

int MaintainVolumeConstraint_mode_get(PointerRNA *ptr);
void MaintainVolumeConstraint_mode_set(PointerRNA *ptr, int value);

float MaintainVolumeConstraint_volume_get(PointerRNA *ptr);
void MaintainVolumeConstraint_volume_set(PointerRNA *ptr, float value);

/**************** Marble Texture ****************/

extern StructRNA RNA_MarbleTexture;
extern StructRNA RNA_Texture;
extern StructRNA RNA_ID;

float MarbleTexture_nabla_get(PointerRNA *ptr);
void MarbleTexture_nabla_set(PointerRNA *ptr, float value);

enum {
	MarbleTexture_noise_basis_BLENDER_ORIGINAL = 0,
	MarbleTexture_noise_basis_ORIGINAL_PERLIN = 1,
	MarbleTexture_noise_basis_IMPROVED_PERLIN = 2,
	MarbleTexture_noise_basis_VORONOI_F1 = 3,
	MarbleTexture_noise_basis_VORONOI_F2 = 4,
	MarbleTexture_noise_basis_VORONOI_F3 = 5,
	MarbleTexture_noise_basis_VORONOI_F4 = 6,
	MarbleTexture_noise_basis_VORONOI_F2_F1 = 7,
	MarbleTexture_noise_basis_VORONOI_CRACKLE = 8,
	MarbleTexture_noise_basis_CELL_NOISE = 14,
};

int MarbleTexture_noise_basis_get(PointerRNA *ptr);
void MarbleTexture_noise_basis_set(PointerRNA *ptr, int value);

enum {
	MarbleTexture_noise_basis_2_SIN = 0,
	MarbleTexture_noise_basis_2_SAW = 1,
	MarbleTexture_noise_basis_2_TRI = 2,
};

int MarbleTexture_noise_basis_2_get(PointerRNA *ptr);
void MarbleTexture_noise_basis_2_set(PointerRNA *ptr, int value);

int MarbleTexture_noise_depth_get(PointerRNA *ptr);
void MarbleTexture_noise_depth_set(PointerRNA *ptr, int value);

float MarbleTexture_noise_scale_get(PointerRNA *ptr);
void MarbleTexture_noise_scale_set(PointerRNA *ptr, float value);

enum {
	MarbleTexture_noise_type_SOFT_NOISE = 0,
	MarbleTexture_noise_type_HARD_NOISE = 1,
};

int MarbleTexture_noise_type_get(PointerRNA *ptr);
void MarbleTexture_noise_type_set(PointerRNA *ptr, int value);

enum {
	MarbleTexture_marble_type_SOFT = 0,
	MarbleTexture_marble_type_SHARP = 1,
	MarbleTexture_marble_type_SHARPER = 2,
};

int MarbleTexture_marble_type_get(PointerRNA *ptr);
void MarbleTexture_marble_type_set(PointerRNA *ptr, int value);

float MarbleTexture_turbulence_get(PointerRNA *ptr);
void MarbleTexture_turbulence_set(PointerRNA *ptr, float value);

/**************** Mask ****************/

extern StructRNA RNA_Mask;
extern StructRNA RNA_ID;

int Mask_active_layer_index_get(PointerRNA *ptr);
void Mask_active_layer_index_set(PointerRNA *ptr, int value);

PointerRNA Mask_animation_data_get(PointerRNA *ptr);

int Mask_frame_end_get(PointerRNA *ptr);
void Mask_frame_end_set(PointerRNA *ptr, int value);

void Mask_layers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Mask_layers_next(CollectionPropertyIterator *iter);
void Mask_layers_end(CollectionPropertyIterator *iter);

int Mask_frame_start_get(PointerRNA *ptr);
void Mask_frame_start_set(PointerRNA *ptr, int value);

/**************** Mask Layer ****************/

extern StructRNA RNA_MaskLayer;

PointerRNA MaskLayer_rna_type_get(PointerRNA *ptr);

#define MaskLayer_name_MAX 64

void MaskLayer_name_get(PointerRNA *ptr, char *value);
int MaskLayer_name_length(PointerRNA *ptr);
void MaskLayer_name_set(PointerRNA *ptr, const char *value);

enum {
	MaskLayer_blend_MERGE_ADD = 7,
	MaskLayer_blend_MERGE_SUBTRACT = 8,
	MaskLayer_blend_ADD = 0,
	MaskLayer_blend_SUBTRACT = 1,
	MaskLayer_blend_LIGHTEN = 2,
	MaskLayer_blend_DARKEN = 3,
	MaskLayer_blend_MUL = 4,
	MaskLayer_blend_REPLACE = 5,
	MaskLayer_blend_DIFFERENCE = 6,
};

int MaskLayer_blend_get(PointerRNA *ptr);
void MaskLayer_blend_set(PointerRNA *ptr, int value);

bool MaskLayer_use_fill_holes_get(PointerRNA *ptr);
void MaskLayer_use_fill_holes_set(PointerRNA *ptr, bool value);

bool MaskLayer_use_fill_overlap_get(PointerRNA *ptr);
void MaskLayer_use_fill_overlap_set(PointerRNA *ptr, bool value);

enum {
	MaskLayer_falloff_SMOOTH = 0,
	MaskLayer_falloff_SPHERE = 1,
	MaskLayer_falloff_ROOT = 2,
	MaskLayer_falloff_INVERSE_SQUARE = 7,
	MaskLayer_falloff_SHARP = 3,
	MaskLayer_falloff_LINEAR = 4,
};

int MaskLayer_falloff_get(PointerRNA *ptr);
void MaskLayer_falloff_set(PointerRNA *ptr, int value);

bool MaskLayer_invert_get(PointerRNA *ptr);
void MaskLayer_invert_set(PointerRNA *ptr, bool value);

float MaskLayer_alpha_get(PointerRNA *ptr);
void MaskLayer_alpha_set(PointerRNA *ptr, float value);

bool MaskLayer_hide_render_get(PointerRNA *ptr);
void MaskLayer_hide_render_set(PointerRNA *ptr, bool value);

bool MaskLayer_hide_select_get(PointerRNA *ptr);
void MaskLayer_hide_select_set(PointerRNA *ptr, bool value);

bool MaskLayer_hide_get(PointerRNA *ptr);
void MaskLayer_hide_set(PointerRNA *ptr, bool value);

bool MaskLayer_select_get(PointerRNA *ptr);
void MaskLayer_select_set(PointerRNA *ptr, bool value);

void MaskLayer_splines_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MaskLayer_splines_next(CollectionPropertyIterator *iter);
void MaskLayer_splines_end(CollectionPropertyIterator *iter);
bool MaskLayer_splines_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Mask Layers ****************/

extern StructRNA RNA_MaskLayers;

PointerRNA MaskLayers_rna_type_get(PointerRNA *ptr);

PointerRNA MaskLayers_active_get(PointerRNA *ptr);

struct MaskLayer *MaskLayers_new_func(struct Mask *_self, const char * name);
void MaskLayers_remove_func(struct Mask *_self, ReportList *reports, struct PointerRNA *layer);
void MaskLayers_clear_func(struct Mask *_self);
/**************** Mask Modifier ****************/

extern StructRNA RNA_MaskModifier;
extern StructRNA RNA_Modifier;

PointerRNA MaskModifier_armature_get(PointerRNA *ptr);

bool MaskModifier_invert_vertex_group_get(PointerRNA *ptr);
void MaskModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

enum {
	MaskModifier_mode_VERTEX_GROUP = 0,
	MaskModifier_mode_ARMATURE = 1,
};

int MaskModifier_mode_get(PointerRNA *ptr);
void MaskModifier_mode_set(PointerRNA *ptr, int value);

bool MaskModifier_use_smooth_get(PointerRNA *ptr);
void MaskModifier_use_smooth_set(PointerRNA *ptr, bool value);

float MaskModifier_threshold_get(PointerRNA *ptr);
void MaskModifier_threshold_set(PointerRNA *ptr, float value);

#define MaskModifier_vertex_group_MAX 64

void MaskModifier_vertex_group_get(PointerRNA *ptr, char *value);
int MaskModifier_vertex_group_length(PointerRNA *ptr);
void MaskModifier_vertex_group_set(PointerRNA *ptr, const char *value);

/**************** Mask Parent ****************/

extern StructRNA RNA_MaskParent;

PointerRNA MaskParent_rna_type_get(PointerRNA *ptr);

PointerRNA MaskParent_id_get(PointerRNA *ptr);

enum {
	MaskParent_id_type_MOVIECLIP = 17229,
};

int MaskParent_id_type_get(PointerRNA *ptr);
void MaskParent_id_type_set(PointerRNA *ptr, int value);

#define MaskParent_parent_MAX 64

void MaskParent_parent_get(PointerRNA *ptr, char *value);
int MaskParent_parent_length(PointerRNA *ptr);
void MaskParent_parent_set(PointerRNA *ptr, const char *value);

enum {
	MaskParent_type_POINT_TRACK = 0,
	MaskParent_type_PLANE_TRACK = 1,
};

int MaskParent_type_get(PointerRNA *ptr);
void MaskParent_type_set(PointerRNA *ptr, int value);

#define MaskParent_sub_parent_MAX 64

void MaskParent_sub_parent_get(PointerRNA *ptr, char *value);
int MaskParent_sub_parent_length(PointerRNA *ptr);
void MaskParent_sub_parent_set(PointerRNA *ptr, const char *value);

/**************** Mask spline ****************/

extern StructRNA RNA_MaskSpline;

PointerRNA MaskSpline_rna_type_get(PointerRNA *ptr);

bool MaskSpline_use_cyclic_get(PointerRNA *ptr);
void MaskSpline_use_cyclic_set(PointerRNA *ptr, bool value);

enum {
	MaskSpline_offset_mode_EVEN = 0,
	MaskSpline_offset_mode_SMOOTH = 1,
};

int MaskSpline_offset_mode_get(PointerRNA *ptr);
void MaskSpline_offset_mode_set(PointerRNA *ptr, int value);

bool MaskSpline_use_fill_get(PointerRNA *ptr);
void MaskSpline_use_fill_set(PointerRNA *ptr, bool value);

void MaskSpline_points_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MaskSpline_points_next(CollectionPropertyIterator *iter);
void MaskSpline_points_end(CollectionPropertyIterator *iter);
int MaskSpline_points_length(PointerRNA *ptr);
bool MaskSpline_points_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool MaskSpline_use_self_intersection_check_get(PointerRNA *ptr);
void MaskSpline_use_self_intersection_check_set(PointerRNA *ptr, bool value);

enum {
	MaskSpline_weight_interpolation_LINEAR = 1,
	MaskSpline_weight_interpolation_EASE = 2,
};

int MaskSpline_weight_interpolation_get(PointerRNA *ptr);
void MaskSpline_weight_interpolation_set(PointerRNA *ptr, int value);

/**************** Mask Spline Point ****************/

extern StructRNA RNA_MaskSplinePoint;

PointerRNA MaskSplinePoint_rna_type_get(PointerRNA *ptr);

void MaskSplinePoint_co_get(PointerRNA *ptr, float values[2]);
void MaskSplinePoint_co_set(PointerRNA *ptr, const float values[2]);

void MaskSplinePoint_feather_points_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MaskSplinePoint_feather_points_next(CollectionPropertyIterator *iter);
void MaskSplinePoint_feather_points_end(CollectionPropertyIterator *iter);
int MaskSplinePoint_feather_points_length(PointerRNA *ptr);
bool MaskSplinePoint_feather_points_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

void MaskSplinePoint_handle_left_get(PointerRNA *ptr, float values[2]);
void MaskSplinePoint_handle_left_set(PointerRNA *ptr, const float values[2]);

enum {
	MaskSplinePoint_handle_left_type_AUTO = 1,
	MaskSplinePoint_handle_left_type_VECTOR = 2,
	MaskSplinePoint_handle_left_type_ALIGNED = 3,
	MaskSplinePoint_handle_left_type_ALIGNED_DOUBLESIDE = 5,
	MaskSplinePoint_handle_left_type_FREE = 0,
};

int MaskSplinePoint_handle_left_type_get(PointerRNA *ptr);
void MaskSplinePoint_handle_left_type_set(PointerRNA *ptr, int value);

void MaskSplinePoint_handle_right_get(PointerRNA *ptr, float values[2]);
void MaskSplinePoint_handle_right_set(PointerRNA *ptr, const float values[2]);

enum {
	MaskSplinePoint_handle_right_type_AUTO = 1,
	MaskSplinePoint_handle_right_type_VECTOR = 2,
	MaskSplinePoint_handle_right_type_ALIGNED = 3,
	MaskSplinePoint_handle_right_type_ALIGNED_DOUBLESIDE = 5,
	MaskSplinePoint_handle_right_type_FREE = 0,
};

int MaskSplinePoint_handle_right_type_get(PointerRNA *ptr);
void MaskSplinePoint_handle_right_type_set(PointerRNA *ptr, int value);

enum {
	MaskSplinePoint_handle_type_AUTO = 1,
	MaskSplinePoint_handle_type_VECTOR = 2,
	MaskSplinePoint_handle_type_ALIGNED = 3,
	MaskSplinePoint_handle_type_ALIGNED_DOUBLESIDE = 5,
	MaskSplinePoint_handle_type_FREE = 0,
};

int MaskSplinePoint_handle_type_get(PointerRNA *ptr);
void MaskSplinePoint_handle_type_set(PointerRNA *ptr, int value);

bool MaskSplinePoint_select_get(PointerRNA *ptr);
void MaskSplinePoint_select_set(PointerRNA *ptr, bool value);

bool MaskSplinePoint_select_single_handle_get(PointerRNA *ptr);
void MaskSplinePoint_select_single_handle_set(PointerRNA *ptr, bool value);

bool MaskSplinePoint_select_control_point_get(PointerRNA *ptr);
void MaskSplinePoint_select_control_point_set(PointerRNA *ptr, bool value);

bool MaskSplinePoint_select_left_handle_get(PointerRNA *ptr);
void MaskSplinePoint_select_left_handle_set(PointerRNA *ptr, bool value);

bool MaskSplinePoint_select_right_handle_get(PointerRNA *ptr);
void MaskSplinePoint_select_right_handle_set(PointerRNA *ptr, bool value);

float MaskSplinePoint_weight_get(PointerRNA *ptr);
void MaskSplinePoint_weight_set(PointerRNA *ptr, float value);

PointerRNA MaskSplinePoint_parent_get(PointerRNA *ptr);

/**************** Mask Spline UW Point ****************/

extern StructRNA RNA_MaskSplinePointUW;

PointerRNA MaskSplinePointUW_rna_type_get(PointerRNA *ptr);

bool MaskSplinePointUW_select_get(PointerRNA *ptr);
void MaskSplinePointUW_select_set(PointerRNA *ptr, bool value);

float MaskSplinePointUW_u_get(PointerRNA *ptr);
void MaskSplinePointUW_u_set(PointerRNA *ptr, float value);

float MaskSplinePointUW_weight_get(PointerRNA *ptr);
void MaskSplinePointUW_weight_set(PointerRNA *ptr, float value);

/**************** Mask Spline Points ****************/

extern StructRNA RNA_MaskSplinePoints;

PointerRNA MaskSplinePoints_rna_type_get(PointerRNA *ptr);

void MaskSplinePoints_add_func(struct ID *_selfid, struct MaskSpline *_self, int count);
void MaskSplinePoints_remove_func(struct ID *_selfid, struct MaskSpline *_self, ReportList *reports, struct PointerRNA *point);
/**************** Mask Splines ****************/

extern StructRNA RNA_MaskSplines;

PointerRNA MaskSplines_rna_type_get(PointerRNA *ptr);

PointerRNA MaskSplines_active_point_get(PointerRNA *ptr);

PointerRNA MaskSplines_active_get(PointerRNA *ptr);

struct MaskSpline *MaskSplines_new_func(struct ID *_selfid, struct MaskLayer *_self);
void MaskSplines_remove_func(struct ID *_selfid, struct MaskLayer *_self, ReportList *reports, struct PointerRNA *spline);
/**************** Mask Strip ****************/

extern StructRNA RNA_MaskStrip;
extern StructRNA RNA_Strip;

enum {
	MaskStrip_alpha_mode_STRAIGHT = 0,
	MaskStrip_alpha_mode_PREMUL = 1,
};

int MaskStrip_alpha_mode_get(PointerRNA *ptr);
void MaskStrip_alpha_mode_set(PointerRNA *ptr, int value);

int MaskStrip_animation_offset_end_get(PointerRNA *ptr);
void MaskStrip_animation_offset_end_set(PointerRNA *ptr, int value);

int MaskStrip_animation_offset_start_get(PointerRNA *ptr);
void MaskStrip_animation_offset_start_set(PointerRNA *ptr, int value);

bool MaskStrip_use_float_get(PointerRNA *ptr);
void MaskStrip_use_float_set(PointerRNA *ptr, bool value);

PointerRNA MaskStrip_crop_get(PointerRNA *ptr);

bool MaskStrip_use_deinterlace_get(PointerRNA *ptr);
void MaskStrip_use_deinterlace_set(PointerRNA *ptr, bool value);

bool MaskStrip_use_flip_x_get(PointerRNA *ptr);
void MaskStrip_use_flip_x_set(PointerRNA *ptr, bool value);

bool MaskStrip_use_flip_y_get(PointerRNA *ptr);
void MaskStrip_use_flip_y_set(PointerRNA *ptr, bool value);

PointerRNA MaskStrip_mask_get(PointerRNA *ptr);

bool MaskStrip_multiply_alpha_get(PointerRNA *ptr);
void MaskStrip_multiply_alpha_set(PointerRNA *ptr, bool value);

float MaskStrip_color_multiply_get(PointerRNA *ptr);
void MaskStrip_color_multiply_set(PointerRNA *ptr, float value);

bool MaskStrip_use_reverse_frames_get(PointerRNA *ptr);
void MaskStrip_use_reverse_frames_set(PointerRNA *ptr, bool value);

float MaskStrip_color_saturation_get(PointerRNA *ptr);
void MaskStrip_color_saturation_set(PointerRNA *ptr, float value);

float MaskStrip_strobe_get(PointerRNA *ptr);
void MaskStrip_strobe_set(PointerRNA *ptr, float value);

PointerRNA MaskStrip_transform_get(PointerRNA *ptr);

/**************** Material ****************/

extern StructRNA RNA_Material;
extern StructRNA RNA_ID;

int Material_paint_active_slot_get(PointerRNA *ptr);
void Material_paint_active_slot_set(PointerRNA *ptr, int value);

PointerRNA Material_animation_data_get(PointerRNA *ptr);

bool Material_use_backface_culling_get(PointerRNA *ptr);
void Material_use_backface_culling_set(PointerRNA *ptr, bool value);

enum {
	Material_blend_method_OPAQUE = 0,
	Material_blend_method_CLIP = 3,
	Material_blend_method_HASHED = 4,
	Material_blend_method_BLEND = 5,
};

int Material_blend_method_get(PointerRNA *ptr);
void Material_blend_method_set(PointerRNA *ptr, int value);

float Material_alpha_threshold_get(PointerRNA *ptr);
void Material_alpha_threshold_set(PointerRNA *ptr, float value);

int Material_paint_clone_slot_get(PointerRNA *ptr);
void Material_paint_clone_slot_set(PointerRNA *ptr, int value);

void Material_diffuse_color_get(PointerRNA *ptr, float values[4]);
void Material_diffuse_color_set(PointerRNA *ptr, const float values[4]);

enum {
	Material_displacement_method_BUMP = 0,
	Material_displacement_method_DISPLACEMENT = 1,
	Material_displacement_method_BOTH = 2,
};

int Material_displacement_method_get(PointerRNA *ptr);
void Material_displacement_method_set(PointerRNA *ptr, int value);

PointerRNA Material_grease_pencil_get(PointerRNA *ptr);

bool Material_is_grease_pencil_get(PointerRNA *ptr);
void Material_is_grease_pencil_set(PointerRNA *ptr, bool value);

bool Material_use_backface_culling_lightprobe_volume_get(PointerRNA *ptr);
void Material_use_backface_culling_lightprobe_volume_set(PointerRNA *ptr, bool value);

PointerRNA Material_lineart_get(PointerRNA *ptr);

void Material_line_color_get(PointerRNA *ptr, float values[4]);
void Material_line_color_set(PointerRNA *ptr, const float values[4]);

int Material_line_priority_get(PointerRNA *ptr);
void Material_line_priority_set(PointerRNA *ptr, int value);

float Material_max_vertex_displacement_get(PointerRNA *ptr);
void Material_max_vertex_displacement_set(PointerRNA *ptr, float value);

float Material_metallic_get(PointerRNA *ptr);
void Material_metallic_set(PointerRNA *ptr, float value);

PointerRNA Material_node_tree_get(PointerRNA *ptr);

int Material_pass_index_get(PointerRNA *ptr);
void Material_pass_index_set(PointerRNA *ptr, int value);

enum {
	Material_preview_render_type_FLAT = 0,
	Material_preview_render_type_SPHERE = 1,
	Material_preview_render_type_CUBE = 2,
	Material_preview_render_type_HAIR = 10,
	Material_preview_render_type_SHADERBALL = 3,
	Material_preview_render_type_CLOTH = 12,
	Material_preview_render_type_FLUID = 13,
};

int Material_preview_render_type_get(PointerRNA *ptr);
void Material_preview_render_type_set(PointerRNA *ptr, int value);

bool Material_use_preview_world_get(PointerRNA *ptr);
void Material_use_preview_world_set(PointerRNA *ptr, bool value);

bool Material_use_raytrace_refraction_get(PointerRNA *ptr);
void Material_use_raytrace_refraction_set(PointerRNA *ptr, bool value);

bool Material_use_screen_refraction_get(PointerRNA *ptr);
void Material_use_screen_refraction_set(PointerRNA *ptr, bool value);

float Material_refraction_depth_get(PointerRNA *ptr);
void Material_refraction_depth_set(PointerRNA *ptr, float value);

float Material_roughness_get(PointerRNA *ptr);
void Material_roughness_set(PointerRNA *ptr, float value);

bool Material_use_backface_culling_shadow_get(PointerRNA *ptr);
void Material_use_backface_culling_shadow_set(PointerRNA *ptr, bool value);

bool Material_show_transparent_back_get(PointerRNA *ptr);
void Material_show_transparent_back_set(PointerRNA *ptr, bool value);

float Material_specular_intensity_get(PointerRNA *ptr);
void Material_specular_intensity_set(PointerRNA *ptr, float value);

void Material_specular_color_get(PointerRNA *ptr, float values[3]);
void Material_specular_color_set(PointerRNA *ptr, const float values[3]);

bool Material_use_sss_translucency_get(PointerRNA *ptr);
void Material_use_sss_translucency_set(PointerRNA *ptr, bool value);

enum {
	Material_surface_render_method_DITHERED = 0,
	Material_surface_render_method_BLENDED = 1,
};

int Material_surface_render_method_get(PointerRNA *ptr);
void Material_surface_render_method_set(PointerRNA *ptr, int value);

void Material_texture_paint_images_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Material_texture_paint_images_next(CollectionPropertyIterator *iter);
void Material_texture_paint_images_end(CollectionPropertyIterator *iter);
bool Material_texture_paint_images_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Material_texture_paint_images_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void Material_texture_paint_slots_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Material_texture_paint_slots_next(CollectionPropertyIterator *iter);
void Material_texture_paint_slots_end(CollectionPropertyIterator *iter);

bool Material_use_thickness_from_shadow_get(PointerRNA *ptr);
void Material_use_thickness_from_shadow_set(PointerRNA *ptr, bool value);

enum {
	Material_thickness_mode_SPHERE = 0,
	Material_thickness_mode_SLAB = 1,
};

int Material_thickness_mode_get(PointerRNA *ptr);
void Material_thickness_mode_set(PointerRNA *ptr, int value);

bool Material_use_transparent_shadow_get(PointerRNA *ptr);
void Material_use_transparent_shadow_set(PointerRNA *ptr, bool value);

bool Material_use_nodes_get(PointerRNA *ptr);
void Material_use_nodes_set(PointerRNA *ptr, bool value);

bool Material_use_transparency_overlap_get(PointerRNA *ptr);
void Material_use_transparency_overlap_set(PointerRNA *ptr, bool value);

enum {
	Material_volume_intersection_method_FAST = 0,
	Material_volume_intersection_method_ACCURATE = 1,
};

int Material_volume_intersection_method_get(PointerRNA *ptr);
void Material_volume_intersection_method_set(PointerRNA *ptr, int value);

/**************** Grease Pencil Color ****************/

extern StructRNA RNA_MaterialGPencilStyle;

PointerRNA MaterialGPencilStyle_rna_type_get(PointerRNA *ptr);

enum {
	MaterialGPencilStyle_alignment_mode_PATH = 0,
	MaterialGPencilStyle_alignment_mode_OBJECT = 1,
	MaterialGPencilStyle_alignment_mode_FIXED = 2,
};

int MaterialGPencilStyle_alignment_mode_get(PointerRNA *ptr);
void MaterialGPencilStyle_alignment_mode_set(PointerRNA *ptr, int value);

float MaterialGPencilStyle_texture_angle_get(PointerRNA *ptr);
void MaterialGPencilStyle_texture_angle_set(PointerRNA *ptr, float value);

bool MaterialGPencilStyle_texture_clamp_get(PointerRNA *ptr);
void MaterialGPencilStyle_texture_clamp_set(PointerRNA *ptr, bool value);

void MaterialGPencilStyle_color_get(PointerRNA *ptr, float values[4]);
void MaterialGPencilStyle_color_set(PointerRNA *ptr, const float values[4]);

void MaterialGPencilStyle_fill_color_get(PointerRNA *ptr, float values[4]);
void MaterialGPencilStyle_fill_color_set(PointerRNA *ptr, const float values[4]);

enum {
	MaterialGPencilStyle_fill_style_SOLID = 0,
	MaterialGPencilStyle_fill_style_GRADIENT = 1,
	MaterialGPencilStyle_fill_style_TEXTURE = 3,
};

int MaterialGPencilStyle_fill_style_get(PointerRNA *ptr);
void MaterialGPencilStyle_fill_style_set(PointerRNA *ptr, int value);

bool MaterialGPencilStyle_flip_get(PointerRNA *ptr);
void MaterialGPencilStyle_flip_set(PointerRNA *ptr, bool value);

enum {
	MaterialGPencilStyle_gradient_type_LINEAR = 0,
	MaterialGPencilStyle_gradient_type_RADIAL = 1,
};

int MaterialGPencilStyle_gradient_type_get(PointerRNA *ptr);
void MaterialGPencilStyle_gradient_type_set(PointerRNA *ptr, int value);

bool MaterialGPencilStyle_hide_get(PointerRNA *ptr);
void MaterialGPencilStyle_hide_set(PointerRNA *ptr, bool value);

bool MaterialGPencilStyle_use_stroke_holdout_get(PointerRNA *ptr);
void MaterialGPencilStyle_use_stroke_holdout_set(PointerRNA *ptr, bool value);

bool MaterialGPencilStyle_use_fill_holdout_get(PointerRNA *ptr);
void MaterialGPencilStyle_use_fill_holdout_set(PointerRNA *ptr, bool value);

PointerRNA MaterialGPencilStyle_stroke_image_get(PointerRNA *ptr);

PointerRNA MaterialGPencilStyle_fill_image_get(PointerRNA *ptr);

bool MaterialGPencilStyle_is_fill_visible_get(PointerRNA *ptr);
void MaterialGPencilStyle_is_fill_visible_set(PointerRNA *ptr, bool value);

bool MaterialGPencilStyle_is_stroke_visible_get(PointerRNA *ptr);
void MaterialGPencilStyle_is_stroke_visible_set(PointerRNA *ptr, bool value);

enum {
	MaterialGPencilStyle_mode_LINE = 0,
	MaterialGPencilStyle_mode_DOTS = 1,
	MaterialGPencilStyle_mode_BOX = 2,
};

int MaterialGPencilStyle_mode_get(PointerRNA *ptr);
void MaterialGPencilStyle_mode_set(PointerRNA *ptr, int value);

bool MaterialGPencilStyle_lock_get(PointerRNA *ptr);
void MaterialGPencilStyle_lock_set(PointerRNA *ptr, bool value);

float MaterialGPencilStyle_mix_factor_get(PointerRNA *ptr);
void MaterialGPencilStyle_mix_factor_set(PointerRNA *ptr, float value);

float MaterialGPencilStyle_mix_stroke_factor_get(PointerRNA *ptr);
void MaterialGPencilStyle_mix_stroke_factor_set(PointerRNA *ptr, float value);

void MaterialGPencilStyle_mix_color_get(PointerRNA *ptr, float values[4]);
void MaterialGPencilStyle_mix_color_set(PointerRNA *ptr, const float values[4]);

void MaterialGPencilStyle_texture_offset_get(PointerRNA *ptr, float values[2]);
void MaterialGPencilStyle_texture_offset_set(PointerRNA *ptr, const float values[2]);

int MaterialGPencilStyle_pass_index_get(PointerRNA *ptr);
void MaterialGPencilStyle_pass_index_set(PointerRNA *ptr, int value);

float MaterialGPencilStyle_alignment_rotation_get(PointerRNA *ptr);
void MaterialGPencilStyle_alignment_rotation_set(PointerRNA *ptr, float value);

void MaterialGPencilStyle_texture_scale_get(PointerRNA *ptr, float values[2]);
void MaterialGPencilStyle_texture_scale_set(PointerRNA *ptr, const float values[2]);

bool MaterialGPencilStyle_use_overlap_strokes_get(PointerRNA *ptr);
void MaterialGPencilStyle_use_overlap_strokes_set(PointerRNA *ptr, bool value);

bool MaterialGPencilStyle_show_fill_get(PointerRNA *ptr);
void MaterialGPencilStyle_show_fill_set(PointerRNA *ptr, bool value);

bool MaterialGPencilStyle_show_stroke_get(PointerRNA *ptr);
void MaterialGPencilStyle_show_stroke_set(PointerRNA *ptr, bool value);

bool MaterialGPencilStyle_ghost_get(PointerRNA *ptr);
void MaterialGPencilStyle_ghost_set(PointerRNA *ptr, bool value);

enum {
	MaterialGPencilStyle_stroke_style_SOLID = 0,
	MaterialGPencilStyle_stroke_style_TEXTURE = 1,
};

int MaterialGPencilStyle_stroke_style_get(PointerRNA *ptr);
void MaterialGPencilStyle_stroke_style_set(PointerRNA *ptr, int value);

float MaterialGPencilStyle_pixel_size_get(PointerRNA *ptr);
void MaterialGPencilStyle_pixel_size_set(PointerRNA *ptr, float value);

/**************** Material Line Art ****************/

extern StructRNA RNA_MaterialLineArt;

PointerRNA MaterialLineArt_rna_type_get(PointerRNA *ptr);

int MaterialLineArt_mat_occlusion_get(PointerRNA *ptr);
void MaterialLineArt_mat_occlusion_set(PointerRNA *ptr, int value);

int MaterialLineArt_intersection_priority_get(PointerRNA *ptr);
void MaterialLineArt_intersection_priority_set(PointerRNA *ptr, int value);

void MaterialLineArt_use_material_mask_bits_get(PointerRNA *ptr, bool values[8]);
void MaterialLineArt_use_material_mask_bits_set(PointerRNA *ptr, const bool values[8]);

bool MaterialLineArt_use_intersection_priority_override_get(PointerRNA *ptr);
void MaterialLineArt_use_intersection_priority_override_set(PointerRNA *ptr, bool value);

bool MaterialLineArt_use_material_mask_get(PointerRNA *ptr);
void MaterialLineArt_use_material_mask_set(PointerRNA *ptr, bool value);

/**************** Material Slot ****************/

extern StructRNA RNA_MaterialSlot;

PointerRNA MaterialSlot_rna_type_get(PointerRNA *ptr);

void MaterialSlot_name_get(PointerRNA *ptr, char *value);
int MaterialSlot_name_length(PointerRNA *ptr);
void MaterialSlot_name_set(PointerRNA *ptr, const char *value);

enum {
	MaterialSlot_link_OBJECT = 1,
	MaterialSlot_link_DATA = 0,
};

int MaterialSlot_link_get(PointerRNA *ptr);
void MaterialSlot_link_set(PointerRNA *ptr, int value);

PointerRNA MaterialSlot_material_get(PointerRNA *ptr);

int MaterialSlot_slot_index_get(PointerRNA *ptr);
void MaterialSlot_slot_index_set(PointerRNA *ptr, int value);

/**************** Menu ****************/

extern StructRNA RNA_Menu;

PointerRNA Menu_rna_type_get(PointerRNA *ptr);

void Menu_bl_idname_get(PointerRNA *ptr, char *value);
int Menu_bl_idname_length(PointerRNA *ptr);
void Menu_bl_idname_set(PointerRNA *ptr, const char *value);

void Menu_bl_label_get(PointerRNA *ptr, char *value);
int Menu_bl_label_length(PointerRNA *ptr);
void Menu_bl_label_set(PointerRNA *ptr, const char *value);

PointerRNA Menu_layout_get(PointerRNA *ptr);

enum {
	Menu_bl_options_SEARCH_ON_KEY_PRESS = 2,
};

int Menu_bl_options_get(PointerRNA *ptr);
void Menu_bl_options_set(PointerRNA *ptr, int value);

#define Menu_bl_description_MAX 1024

void Menu_bl_description_get(PointerRNA *ptr, char *value);
int Menu_bl_description_length(PointerRNA *ptr);
void Menu_bl_description_set(PointerRNA *ptr, const char *value);

void Menu_bl_owner_id_get(PointerRNA *ptr, char *value);
int Menu_bl_owner_id_length(PointerRNA *ptr);
void Menu_bl_owner_id_set(PointerRNA *ptr, const char *value);

void Menu_bl_translation_context_get(PointerRNA *ptr, char *value);
int Menu_bl_translation_context_length(PointerRNA *ptr);
void Menu_bl_translation_context_set(PointerRNA *ptr, const char *value);

bool Menu_poll_func(struct bContext *context);
void Menu_draw_func(struct Menu *_self, struct bContext *context);
/**************** Mesh ****************/

extern StructRNA RNA_Mesh;
extern StructRNA RNA_ID;

float Mesh_remesh_voxel_adaptivity_get(PointerRNA *ptr);
void Mesh_remesh_voxel_adaptivity_set(PointerRNA *ptr, float value);

PointerRNA Mesh_animation_data_get(PointerRNA *ptr);

void Mesh_attributes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Mesh_attributes_next(CollectionPropertyIterator *iter);
void Mesh_attributes_end(CollectionPropertyIterator *iter);
int Mesh_attributes_length(PointerRNA *ptr);
bool Mesh_attributes_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool Mesh_use_auto_texspace_get(PointerRNA *ptr);
void Mesh_use_auto_texspace_set(PointerRNA *ptr, bool value);

bool Mesh_auto_texspace_get(PointerRNA *ptr);
void Mesh_auto_texspace_set(PointerRNA *ptr, bool value);

bool Mesh_use_paint_bone_selection_get(PointerRNA *ptr);
void Mesh_use_paint_bone_selection_set(PointerRNA *ptr, bool value);

PointerRNA Mesh_uv_layer_clone_get(PointerRNA *ptr);

int Mesh_uv_layer_clone_index_get(PointerRNA *ptr);
void Mesh_uv_layer_clone_index_set(PointerRNA *ptr, int value);

void Mesh_color_attributes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Mesh_color_attributes_next(CollectionPropertyIterator *iter);
void Mesh_color_attributes_end(CollectionPropertyIterator *iter);
int Mesh_color_attributes_length(PointerRNA *ptr);

void Mesh_corner_normals_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Mesh_corner_normals_next(CollectionPropertyIterator *iter);
void Mesh_corner_normals_end(CollectionPropertyIterator *iter);
int Mesh_corner_normals_length(PointerRNA *ptr);
bool Mesh_corner_normals_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

void Mesh_edges_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Mesh_edges_next(CollectionPropertyIterator *iter);
void Mesh_edges_end(CollectionPropertyIterator *iter);
int Mesh_edges_length(PointerRNA *ptr);
bool Mesh_edges_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool Mesh_use_remesh_fix_poles_get(PointerRNA *ptr);
void Mesh_use_remesh_fix_poles_set(PointerRNA *ptr, bool value);

bool Mesh_has_custom_normals_get(PointerRNA *ptr);
void Mesh_has_custom_normals_set(PointerRNA *ptr, bool value);

bool Mesh_is_editmode_get(PointerRNA *ptr);
void Mesh_is_editmode_set(PointerRNA *ptr, bool value);

void Mesh_loop_triangles_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Mesh_loop_triangles_next(CollectionPropertyIterator *iter);
void Mesh_loop_triangles_end(CollectionPropertyIterator *iter);
int Mesh_loop_triangles_length(PointerRNA *ptr);
bool Mesh_loop_triangles_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

void Mesh_loops_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Mesh_loops_next(CollectionPropertyIterator *iter);
void Mesh_loops_end(CollectionPropertyIterator *iter);
int Mesh_loops_length(PointerRNA *ptr);
bool Mesh_loops_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

PointerRNA Mesh_uv_layer_stencil_get(PointerRNA *ptr);

int Mesh_uv_layer_stencil_index_get(PointerRNA *ptr);
void Mesh_uv_layer_stencil_index_set(PointerRNA *ptr, int value);

void Mesh_materials_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Mesh_materials_next(CollectionPropertyIterator *iter);
void Mesh_materials_end(CollectionPropertyIterator *iter);
int Mesh_materials_length(PointerRNA *ptr);
bool Mesh_materials_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Mesh_materials_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool Mesh_use_mirror_vertex_groups_get(PointerRNA *ptr);
void Mesh_use_mirror_vertex_groups_set(PointerRNA *ptr, bool value);

enum {
	Mesh_normals_domain_POINT = 1,
	Mesh_normals_domain_FACE = 0,
	Mesh_normals_domain_CORNER = 2,
};

int Mesh_normals_domain_get(PointerRNA *ptr);
void Mesh_normals_domain_set(PointerRNA *ptr, int value);

bool Mesh_use_paint_mask_get(PointerRNA *ptr);
void Mesh_use_paint_mask_set(PointerRNA *ptr, bool value);

void Mesh_polygon_normals_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Mesh_polygon_normals_next(CollectionPropertyIterator *iter);
void Mesh_polygon_normals_end(CollectionPropertyIterator *iter);
int Mesh_polygon_normals_length(PointerRNA *ptr);
bool Mesh_polygon_normals_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

void Mesh_polygons_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Mesh_polygons_next(CollectionPropertyIterator *iter);
void Mesh_polygons_end(CollectionPropertyIterator *iter);
int Mesh_polygons_length(PointerRNA *ptr);
bool Mesh_polygons_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool Mesh_use_remesh_preserve_attributes_get(PointerRNA *ptr);
void Mesh_use_remesh_preserve_attributes_set(PointerRNA *ptr, bool value);

bool Mesh_use_remesh_preserve_volume_get(PointerRNA *ptr);
void Mesh_use_remesh_preserve_volume_set(PointerRNA *ptr, bool value);

enum {
	Mesh_remesh_mode_VOXEL = 0,
	Mesh_remesh_mode_QUAD = 1,
};

int Mesh_remesh_mode_get(PointerRNA *ptr);
void Mesh_remesh_mode_set(PointerRNA *ptr, int value);

int Mesh_total_edge_sel_get(PointerRNA *ptr);
void Mesh_total_edge_sel_set(PointerRNA *ptr, int value);

int Mesh_total_face_sel_get(PointerRNA *ptr);
void Mesh_total_face_sel_set(PointerRNA *ptr, int value);

int Mesh_total_vert_sel_get(PointerRNA *ptr);
void Mesh_total_vert_sel_set(PointerRNA *ptr, int value);

PointerRNA Mesh_shape_keys_get(PointerRNA *ptr);

void Mesh_skin_vertices_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Mesh_skin_vertices_next(CollectionPropertyIterator *iter);
void Mesh_skin_vertices_end(CollectionPropertyIterator *iter);
int Mesh_skin_vertices_length(PointerRNA *ptr);
bool Mesh_skin_vertices_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Mesh_skin_vertices_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

PointerRNA Mesh_texture_mesh_get(PointerRNA *ptr);

void Mesh_texspace_location_get(PointerRNA *ptr, float values[3]);
void Mesh_texspace_location_set(PointerRNA *ptr, const float values[3]);

PointerRNA Mesh_texco_mesh_get(PointerRNA *ptr);

void Mesh_texspace_size_get(PointerRNA *ptr, float values[3]);
void Mesh_texspace_size_set(PointerRNA *ptr, const float values[3]);

bool Mesh_use_mirror_topology_get(PointerRNA *ptr);
void Mesh_use_mirror_topology_set(PointerRNA *ptr, bool value);

void Mesh_loop_triangle_polygons_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Mesh_loop_triangle_polygons_next(CollectionPropertyIterator *iter);
void Mesh_loop_triangle_polygons_end(CollectionPropertyIterator *iter);
int Mesh_loop_triangle_polygons_length(PointerRNA *ptr);
bool Mesh_loop_triangle_polygons_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

void Mesh_uv_layers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Mesh_uv_layers_next(CollectionPropertyIterator *iter);
void Mesh_uv_layers_end(CollectionPropertyIterator *iter);
int Mesh_uv_layers_length(PointerRNA *ptr);
bool Mesh_uv_layers_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Mesh_uv_layers_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void Mesh_vertex_colors_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Mesh_vertex_colors_next(CollectionPropertyIterator *iter);
void Mesh_vertex_colors_end(CollectionPropertyIterator *iter);
int Mesh_vertex_colors_length(PointerRNA *ptr);
bool Mesh_vertex_colors_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Mesh_vertex_colors_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void Mesh_vertex_normals_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Mesh_vertex_normals_next(CollectionPropertyIterator *iter);
void Mesh_vertex_normals_end(CollectionPropertyIterator *iter);
int Mesh_vertex_normals_length(PointerRNA *ptr);
bool Mesh_vertex_normals_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool Mesh_use_paint_mask_vertex_get(PointerRNA *ptr);
void Mesh_use_paint_mask_vertex_set(PointerRNA *ptr, bool value);

void Mesh_vertices_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Mesh_vertices_next(CollectionPropertyIterator *iter);
void Mesh_vertices_end(CollectionPropertyIterator *iter);
int Mesh_vertices_length(PointerRNA *ptr);
bool Mesh_vertices_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

float Mesh_remesh_voxel_size_get(PointerRNA *ptr);
void Mesh_remesh_voxel_size_set(PointerRNA *ptr, float value);

bool Mesh_use_mirror_x_get(PointerRNA *ptr);
void Mesh_use_mirror_x_set(PointerRNA *ptr, bool value);

bool Mesh_use_mirror_y_get(PointerRNA *ptr);
void Mesh_use_mirror_y_set(PointerRNA *ptr, bool value);

bool Mesh_use_mirror_z_get(PointerRNA *ptr);
void Mesh_use_mirror_z_set(PointerRNA *ptr, bool value);

void Mesh_transform_func(struct Mesh *_self, float matrix[16], bool shape_keys);
void Mesh_flip_normals_func(struct Mesh *_self);
void Mesh_set_sharp_from_angle_func(struct Mesh *_self, float angle);
void Mesh_split_faces_func(struct Mesh *_self);
void Mesh_calc_tangents_func(struct Mesh *_self, ReportList *reports, const char * uvmap);
void Mesh_free_tangents_func(struct Mesh *_self);
void Mesh_calc_loop_triangles_func(struct Mesh *_self);
void Mesh_calc_smooth_groups_func(struct Mesh *_self, bool use_bitflags, bool use_boundary_vertices_for_bitflags, int *poly_groups_num, int **poly_groups, int *groups);
void Mesh_normals_split_custom_set_func(struct Mesh *_self, ReportList *reports, int normals_num, float *normals);
void Mesh_normals_split_custom_set_from_vertices_func(struct Mesh *_self, ReportList *reports, int normals_num, float *normals);
void Mesh_update_func(struct Mesh *_self, bContext *C, bool calc_edges, bool calc_edges_loose);
void Mesh_update_gpu_tag_func(struct Mesh *_self);
const char * Mesh_unit_test_compare_func(struct Mesh *_self, struct Mesh *mesh, float threshold);
void Mesh_clear_geometry_func(struct Mesh *_self);
bool Mesh_validate_func(struct Mesh *_self, bool verbose, bool clean_customdata);
bool Mesh_validate_material_indices_func(struct Mesh *_self);
void Mesh_count_selected_items_func(struct Mesh *_self, int result[3]);
/**************** Cache Modifier ****************/

extern StructRNA RNA_MeshCacheModifier;
extern StructRNA RNA_Modifier;

enum {
	MeshCacheModifier_deform_mode_OVERWRITE = 0,
	MeshCacheModifier_deform_mode_INTEGRATE = 1,
};

int MeshCacheModifier_deform_mode_get(PointerRNA *ptr);
void MeshCacheModifier_deform_mode_set(PointerRNA *ptr, int value);

float MeshCacheModifier_eval_factor_get(PointerRNA *ptr);
void MeshCacheModifier_eval_factor_set(PointerRNA *ptr, float value);

float MeshCacheModifier_eval_frame_get(PointerRNA *ptr);
void MeshCacheModifier_eval_frame_set(PointerRNA *ptr, float value);

float MeshCacheModifier_eval_time_get(PointerRNA *ptr);
void MeshCacheModifier_eval_time_set(PointerRNA *ptr, float value);

#define MeshCacheModifier_filepath_MAX 1024

void MeshCacheModifier_filepath_get(PointerRNA *ptr, char *value);
int MeshCacheModifier_filepath_length(PointerRNA *ptr);
void MeshCacheModifier_filepath_set(PointerRNA *ptr, const char *value);

void MeshCacheModifier_flip_axis_get(PointerRNA *ptr, bool values[3]);
void MeshCacheModifier_flip_axis_set(PointerRNA *ptr, const bool values[3]);

enum {
	MeshCacheModifier_cache_format_MDD = 1,
	MeshCacheModifier_cache_format_PC2 = 2,
};

int MeshCacheModifier_cache_format_get(PointerRNA *ptr);
void MeshCacheModifier_cache_format_set(PointerRNA *ptr, int value);

enum {
	MeshCacheModifier_forward_axis_POS_X = 0,
	MeshCacheModifier_forward_axis_POS_Y = 1,
	MeshCacheModifier_forward_axis_POS_Z = 2,
	MeshCacheModifier_forward_axis_NEG_X = 3,
	MeshCacheModifier_forward_axis_NEG_Y = 4,
	MeshCacheModifier_forward_axis_NEG_Z = 5,
};

int MeshCacheModifier_forward_axis_get(PointerRNA *ptr);
void MeshCacheModifier_forward_axis_set(PointerRNA *ptr, int value);

float MeshCacheModifier_frame_scale_get(PointerRNA *ptr);
void MeshCacheModifier_frame_scale_set(PointerRNA *ptr, float value);

float MeshCacheModifier_frame_start_get(PointerRNA *ptr);
void MeshCacheModifier_frame_start_set(PointerRNA *ptr, float value);

float MeshCacheModifier_factor_get(PointerRNA *ptr);
void MeshCacheModifier_factor_set(PointerRNA *ptr, float value);

enum {
	MeshCacheModifier_interpolation_NONE = 0,
	MeshCacheModifier_interpolation_LINEAR = 1,
};

int MeshCacheModifier_interpolation_get(PointerRNA *ptr);
void MeshCacheModifier_interpolation_set(PointerRNA *ptr, int value);

bool MeshCacheModifier_invert_vertex_group_get(PointerRNA *ptr);
void MeshCacheModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

enum {
	MeshCacheModifier_play_mode_SCENE = 0,
	MeshCacheModifier_play_mode_CUSTOM = 1,
};

int MeshCacheModifier_play_mode_get(PointerRNA *ptr);
void MeshCacheModifier_play_mode_set(PointerRNA *ptr, int value);

enum {
	MeshCacheModifier_time_mode_FRAME = 0,
	MeshCacheModifier_time_mode_TIME = 1,
	MeshCacheModifier_time_mode_FACTOR = 2,
};

int MeshCacheModifier_time_mode_get(PointerRNA *ptr);
void MeshCacheModifier_time_mode_set(PointerRNA *ptr, int value);

enum {
	MeshCacheModifier_up_axis_POS_X = 0,
	MeshCacheModifier_up_axis_POS_Y = 1,
	MeshCacheModifier_up_axis_POS_Z = 2,
	MeshCacheModifier_up_axis_NEG_X = 3,
	MeshCacheModifier_up_axis_NEG_Y = 4,
	MeshCacheModifier_up_axis_NEG_Z = 5,
};

int MeshCacheModifier_up_axis_get(PointerRNA *ptr);
void MeshCacheModifier_up_axis_set(PointerRNA *ptr, int value);

#define MeshCacheModifier_vertex_group_MAX 64

void MeshCacheModifier_vertex_group_get(PointerRNA *ptr, char *value);
int MeshCacheModifier_vertex_group_length(PointerRNA *ptr);
void MeshCacheModifier_vertex_group_set(PointerRNA *ptr, const char *value);

/**************** MeshDeform Modifier ****************/

extern StructRNA RNA_MeshDeformModifier;
extern StructRNA RNA_Modifier;

bool MeshDeformModifier_is_bound_get(PointerRNA *ptr);
void MeshDeformModifier_is_bound_set(PointerRNA *ptr, bool value);

bool MeshDeformModifier_use_dynamic_bind_get(PointerRNA *ptr);
void MeshDeformModifier_use_dynamic_bind_set(PointerRNA *ptr, bool value);

bool MeshDeformModifier_invert_vertex_group_get(PointerRNA *ptr);
void MeshDeformModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

PointerRNA MeshDeformModifier_object_get(PointerRNA *ptr);

int MeshDeformModifier_precision_get(PointerRNA *ptr);
void MeshDeformModifier_precision_set(PointerRNA *ptr, int value);

#define MeshDeformModifier_vertex_group_MAX 64

void MeshDeformModifier_vertex_group_get(PointerRNA *ptr, char *value);
int MeshDeformModifier_vertex_group_length(PointerRNA *ptr);
void MeshDeformModifier_vertex_group_set(PointerRNA *ptr, const char *value);

/**************** Mesh Edge ****************/

extern StructRNA RNA_MeshEdge;

PointerRNA MeshEdge_rna_type_get(PointerRNA *ptr);

bool MeshEdge_use_freestyle_mark_get(PointerRNA *ptr);
void MeshEdge_use_freestyle_mark_set(PointerRNA *ptr, bool value);

bool MeshEdge_hide_get(PointerRNA *ptr);
void MeshEdge_hide_set(PointerRNA *ptr, bool value);

int MeshEdge_index_get(PointerRNA *ptr);
void MeshEdge_index_set(PointerRNA *ptr, int value);

bool MeshEdge_is_loose_get(PointerRNA *ptr);
void MeshEdge_is_loose_set(PointerRNA *ptr, bool value);

bool MeshEdge_use_seam_get(PointerRNA *ptr);
void MeshEdge_use_seam_set(PointerRNA *ptr, bool value);

bool MeshEdge_select_get(PointerRNA *ptr);
void MeshEdge_select_set(PointerRNA *ptr, bool value);

bool MeshEdge_use_edge_sharp_get(PointerRNA *ptr);
void MeshEdge_use_edge_sharp_set(PointerRNA *ptr, bool value);

void MeshEdge_vertices_get(PointerRNA *ptr, int values[2]);
void MeshEdge_vertices_set(PointerRNA *ptr, const int values[2]);

/**************** Mesh Edges ****************/

extern StructRNA RNA_MeshEdges;

PointerRNA MeshEdges_rna_type_get(PointerRNA *ptr);

void MeshEdges_add_func(struct Mesh *_self, ReportList *reports, int count);
/**************** Mesh Loop ****************/

extern StructRNA RNA_MeshLoop;

PointerRNA MeshLoop_rna_type_get(PointerRNA *ptr);

void MeshLoop_bitangent_get(PointerRNA *ptr, float values[3]);
void MeshLoop_bitangent_set(PointerRNA *ptr, const float values[3]);

float MeshLoop_bitangent_sign_get(PointerRNA *ptr);
void MeshLoop_bitangent_sign_set(PointerRNA *ptr, float value);

int MeshLoop_edge_index_get(PointerRNA *ptr);
void MeshLoop_edge_index_set(PointerRNA *ptr, int value);

int MeshLoop_index_get(PointerRNA *ptr);
void MeshLoop_index_set(PointerRNA *ptr, int value);

void MeshLoop_normal_get(PointerRNA *ptr, float values[3]);
void MeshLoop_normal_set(PointerRNA *ptr, const float values[3]);

void MeshLoop_tangent_get(PointerRNA *ptr, float values[3]);
void MeshLoop_tangent_set(PointerRNA *ptr, const float values[3]);

int MeshLoop_vertex_index_get(PointerRNA *ptr);
void MeshLoop_vertex_index_set(PointerRNA *ptr, int value);

/**************** Mesh Vertex Color ****************/

extern StructRNA RNA_MeshLoopColor;

PointerRNA MeshLoopColor_rna_type_get(PointerRNA *ptr);

void MeshLoopColor_color_get(PointerRNA *ptr, float values[4]);
void MeshLoopColor_color_set(PointerRNA *ptr, const float values[4]);

/**************** Mesh Vertex Color Layer ****************/

extern StructRNA RNA_MeshLoopColorLayer;

PointerRNA MeshLoopColorLayer_rna_type_get(PointerRNA *ptr);

#define MeshLoopColorLayer_name_MAX 64

void MeshLoopColorLayer_name_get(PointerRNA *ptr, char *value);
int MeshLoopColorLayer_name_length(PointerRNA *ptr);
void MeshLoopColorLayer_name_set(PointerRNA *ptr, const char *value);

bool MeshLoopColorLayer_active_get(PointerRNA *ptr);
void MeshLoopColorLayer_active_set(PointerRNA *ptr, bool value);

bool MeshLoopColorLayer_active_render_get(PointerRNA *ptr);
void MeshLoopColorLayer_active_render_set(PointerRNA *ptr, bool value);

void MeshLoopColorLayer_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MeshLoopColorLayer_data_next(CollectionPropertyIterator *iter);
void MeshLoopColorLayer_data_end(CollectionPropertyIterator *iter);
int MeshLoopColorLayer_data_length(PointerRNA *ptr);
bool MeshLoopColorLayer_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Mesh Loop Triangle ****************/

extern StructRNA RNA_MeshLoopTriangle;

PointerRNA MeshLoopTriangle_rna_type_get(PointerRNA *ptr);

int MeshLoopTriangle_index_get(PointerRNA *ptr);
void MeshLoopTriangle_index_set(PointerRNA *ptr, int value);

void MeshLoopTriangle_loops_get(PointerRNA *ptr, int values[3]);
void MeshLoopTriangle_loops_set(PointerRNA *ptr, const int values[3]);

int MeshLoopTriangle_material_index_get(PointerRNA *ptr);
void MeshLoopTriangle_material_index_set(PointerRNA *ptr, int value);

int MeshLoopTriangle_polygon_index_get(PointerRNA *ptr);
void MeshLoopTriangle_polygon_index_set(PointerRNA *ptr, int value);

bool MeshLoopTriangle_use_smooth_get(PointerRNA *ptr);
void MeshLoopTriangle_use_smooth_set(PointerRNA *ptr, bool value);

void MeshLoopTriangle_split_normals_get(PointerRNA *ptr, float values[9]);
void MeshLoopTriangle_split_normals_set(PointerRNA *ptr, const float values[9]);

float MeshLoopTriangle_area_get(PointerRNA *ptr);
void MeshLoopTriangle_area_set(PointerRNA *ptr, float value);

void MeshLoopTriangle_normal_get(PointerRNA *ptr, float values[3]);
void MeshLoopTriangle_normal_set(PointerRNA *ptr, const float values[3]);

void MeshLoopTriangle_vertices_get(PointerRNA *ptr, int values[3]);
void MeshLoopTriangle_vertices_set(PointerRNA *ptr, const int values[3]);

/**************** Mesh Loop Triangles ****************/

extern StructRNA RNA_MeshLoopTriangles;

PointerRNA MeshLoopTriangles_rna_type_get(PointerRNA *ptr);

/**************** Mesh Loops ****************/

extern StructRNA RNA_MeshLoops;

PointerRNA MeshLoops_rna_type_get(PointerRNA *ptr);

void MeshLoops_add_func(struct Mesh *_self, ReportList *reports, int count);
/**************** Mesh Normal Vector ****************/

extern StructRNA RNA_MeshNormalValue;

PointerRNA MeshNormalValue_rna_type_get(PointerRNA *ptr);

void MeshNormalValue_vector_get(PointerRNA *ptr, float values[3]);
void MeshNormalValue_vector_set(PointerRNA *ptr, const float values[3]);

/**************** Mesh Polygon ****************/

extern StructRNA RNA_MeshPolygon;

PointerRNA MeshPolygon_rna_type_get(PointerRNA *ptr);

bool MeshPolygon_use_freestyle_mark_get(PointerRNA *ptr);
void MeshPolygon_use_freestyle_mark_set(PointerRNA *ptr, bool value);

bool MeshPolygon_hide_get(PointerRNA *ptr);
void MeshPolygon_hide_set(PointerRNA *ptr, bool value);

int MeshPolygon_index_get(PointerRNA *ptr);
void MeshPolygon_index_set(PointerRNA *ptr, int value);

int MeshPolygon_loop_start_get(PointerRNA *ptr);
void MeshPolygon_loop_start_set(PointerRNA *ptr, int value);

int MeshPolygon_loop_total_get(PointerRNA *ptr);
void MeshPolygon_loop_total_set(PointerRNA *ptr, int value);

int MeshPolygon_material_index_get(PointerRNA *ptr);
void MeshPolygon_material_index_set(PointerRNA *ptr, int value);

float MeshPolygon_area_get(PointerRNA *ptr);
void MeshPolygon_area_set(PointerRNA *ptr, float value);

void MeshPolygon_center_get(PointerRNA *ptr, float values[3]);
void MeshPolygon_center_set(PointerRNA *ptr, const float values[3]);

void MeshPolygon_normal_get(PointerRNA *ptr, float values[3]);
void MeshPolygon_normal_set(PointerRNA *ptr, const float values[3]);

bool MeshPolygon_select_get(PointerRNA *ptr);
void MeshPolygon_select_set(PointerRNA *ptr, bool value);

bool MeshPolygon_use_smooth_get(PointerRNA *ptr);
void MeshPolygon_use_smooth_set(PointerRNA *ptr, bool value);

void MeshPolygon_vertices_get(PointerRNA *ptr, int values[]);
void MeshPolygon_vertices_set(PointerRNA *ptr, const int values[]);
int MeshPolygon_vertices_get_length(PointerRNA *ptr, int *arraylen);

void MeshPolygon_flip_func(struct ID *_selfid, struct MIntProperty *_self);
/**************** Mesh Polygons ****************/

extern StructRNA RNA_MeshPolygons;

PointerRNA MeshPolygons_rna_type_get(PointerRNA *ptr);

int MeshPolygons_active_get(PointerRNA *ptr);
void MeshPolygons_active_set(PointerRNA *ptr, int value);

void MeshPolygons_add_func(struct Mesh *_self, ReportList *reports, int count);
/**************** Cache Modifier ****************/

extern StructRNA RNA_MeshSequenceCacheModifier;
extern StructRNA RNA_Modifier;

PointerRNA MeshSequenceCacheModifier_cache_file_get(PointerRNA *ptr);

#define MeshSequenceCacheModifier_object_path_MAX 1024

void MeshSequenceCacheModifier_object_path_get(PointerRNA *ptr, char *value);
int MeshSequenceCacheModifier_object_path_length(PointerRNA *ptr);
void MeshSequenceCacheModifier_object_path_set(PointerRNA *ptr, const char *value);

enum {
	MeshSequenceCacheModifier_read_data_VERT = 1,
	MeshSequenceCacheModifier_read_data_POLY = 2,
	MeshSequenceCacheModifier_read_data_UV = 4,
	MeshSequenceCacheModifier_read_data_COLOR = 8,
	MeshSequenceCacheModifier_read_data_ATTRIBUTES = 32,
};

int MeshSequenceCacheModifier_read_data_get(PointerRNA *ptr);
void MeshSequenceCacheModifier_read_data_set(PointerRNA *ptr, int value);

float MeshSequenceCacheModifier_velocity_scale_get(PointerRNA *ptr);
void MeshSequenceCacheModifier_velocity_scale_set(PointerRNA *ptr, float value);

bool MeshSequenceCacheModifier_use_vertex_interpolation_get(PointerRNA *ptr);
void MeshSequenceCacheModifier_use_vertex_interpolation_set(PointerRNA *ptr, bool value);

/**************** Skin Vertex ****************/

extern StructRNA RNA_MeshSkinVertex;

PointerRNA MeshSkinVertex_rna_type_get(PointerRNA *ptr);

bool MeshSkinVertex_use_loose_get(PointerRNA *ptr);
void MeshSkinVertex_use_loose_set(PointerRNA *ptr, bool value);

void MeshSkinVertex_radius_get(PointerRNA *ptr, float values[2]);
void MeshSkinVertex_radius_set(PointerRNA *ptr, const float values[2]);

bool MeshSkinVertex_use_root_get(PointerRNA *ptr);
void MeshSkinVertex_use_root_set(PointerRNA *ptr, bool value);

/**************** Mesh Skin Vertex Layer ****************/

extern StructRNA RNA_MeshSkinVertexLayer;

PointerRNA MeshSkinVertexLayer_rna_type_get(PointerRNA *ptr);

#define MeshSkinVertexLayer_name_MAX 64

void MeshSkinVertexLayer_name_get(PointerRNA *ptr, char *value);
int MeshSkinVertexLayer_name_length(PointerRNA *ptr);
void MeshSkinVertexLayer_name_set(PointerRNA *ptr, const char *value);

void MeshSkinVertexLayer_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MeshSkinVertexLayer_data_next(CollectionPropertyIterator *iter);
void MeshSkinVertexLayer_data_end(CollectionPropertyIterator *iter);
int MeshSkinVertexLayer_data_length(PointerRNA *ptr);
bool MeshSkinVertexLayer_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Mesh Visualize Statistics ****************/

extern StructRNA RNA_MeshStatVis;

PointerRNA MeshStatVis_rna_type_get(PointerRNA *ptr);

enum {
	MeshStatVis_overhang_axis_POS_X = 0,
	MeshStatVis_overhang_axis_POS_Y = 1,
	MeshStatVis_overhang_axis_POS_Z = 2,
	MeshStatVis_overhang_axis_NEG_X = 3,
	MeshStatVis_overhang_axis_NEG_Y = 4,
	MeshStatVis_overhang_axis_NEG_Z = 5,
};

int MeshStatVis_overhang_axis_get(PointerRNA *ptr);
void MeshStatVis_overhang_axis_set(PointerRNA *ptr, int value);

float MeshStatVis_distort_max_get(PointerRNA *ptr);
void MeshStatVis_distort_max_set(PointerRNA *ptr, float value);

float MeshStatVis_distort_min_get(PointerRNA *ptr);
void MeshStatVis_distort_min_set(PointerRNA *ptr, float value);

float MeshStatVis_overhang_max_get(PointerRNA *ptr);
void MeshStatVis_overhang_max_set(PointerRNA *ptr, float value);

float MeshStatVis_overhang_min_get(PointerRNA *ptr);
void MeshStatVis_overhang_min_set(PointerRNA *ptr, float value);

int MeshStatVis_thickness_samples_get(PointerRNA *ptr);
void MeshStatVis_thickness_samples_set(PointerRNA *ptr, int value);

float MeshStatVis_sharp_max_get(PointerRNA *ptr);
void MeshStatVis_sharp_max_set(PointerRNA *ptr, float value);

float MeshStatVis_sharp_min_get(PointerRNA *ptr);
void MeshStatVis_sharp_min_set(PointerRNA *ptr, float value);

float MeshStatVis_thickness_max_get(PointerRNA *ptr);
void MeshStatVis_thickness_max_set(PointerRNA *ptr, float value);

float MeshStatVis_thickness_min_get(PointerRNA *ptr);
void MeshStatVis_thickness_min_set(PointerRNA *ptr, float value);

enum {
	MeshStatVis_type_OVERHANG = 0,
	MeshStatVis_type_THICKNESS = 1,
	MeshStatVis_type_INTERSECT = 2,
	MeshStatVis_type_DISTORT = 3,
	MeshStatVis_type_SHARP = 4,
};

int MeshStatVis_type_get(PointerRNA *ptr);
void MeshStatVis_type_set(PointerRNA *ptr, int value);

/**************** Mesh to Volume Modifier ****************/

extern StructRNA RNA_MeshToVolumeModifier;
extern StructRNA RNA_Modifier;

float MeshToVolumeModifier_density_get(PointerRNA *ptr);
void MeshToVolumeModifier_density_set(PointerRNA *ptr, float value);

float MeshToVolumeModifier_interior_band_width_get(PointerRNA *ptr);
void MeshToVolumeModifier_interior_band_width_set(PointerRNA *ptr, float value);

PointerRNA MeshToVolumeModifier_object_get(PointerRNA *ptr);

enum {
	MeshToVolumeModifier_resolution_mode_VOXEL_AMOUNT = 0,
	MeshToVolumeModifier_resolution_mode_VOXEL_SIZE = 1,
};

int MeshToVolumeModifier_resolution_mode_get(PointerRNA *ptr);
void MeshToVolumeModifier_resolution_mode_set(PointerRNA *ptr, int value);

int MeshToVolumeModifier_voxel_amount_get(PointerRNA *ptr);
void MeshToVolumeModifier_voxel_amount_set(PointerRNA *ptr, int value);

float MeshToVolumeModifier_voxel_size_get(PointerRNA *ptr);
void MeshToVolumeModifier_voxel_size_set(PointerRNA *ptr, float value);

/**************** Mesh UV Layer ****************/

extern StructRNA RNA_MeshUVLoop;

PointerRNA MeshUVLoop_rna_type_get(PointerRNA *ptr);

bool MeshUVLoop_select_edge_get(PointerRNA *ptr);
void MeshUVLoop_select_edge_set(PointerRNA *ptr, bool value);

bool MeshUVLoop_pin_uv_get(PointerRNA *ptr);
void MeshUVLoop_pin_uv_set(PointerRNA *ptr, bool value);

bool MeshUVLoop_select_get(PointerRNA *ptr);
void MeshUVLoop_select_set(PointerRNA *ptr, bool value);

void MeshUVLoop_uv_get(PointerRNA *ptr, float values[2]);
void MeshUVLoop_uv_set(PointerRNA *ptr, const float values[2]);

/**************** MeshUVLoopLayer ****************/

extern StructRNA RNA_MeshUVLoopLayer;

PointerRNA MeshUVLoopLayer_rna_type_get(PointerRNA *ptr);

#define MeshUVLoopLayer_name_MAX 64

void MeshUVLoopLayer_name_get(PointerRNA *ptr, char *value);
int MeshUVLoopLayer_name_length(PointerRNA *ptr);
void MeshUVLoopLayer_name_set(PointerRNA *ptr, const char *value);

bool MeshUVLoopLayer_active_get(PointerRNA *ptr);
void MeshUVLoopLayer_active_set(PointerRNA *ptr, bool value);

bool MeshUVLoopLayer_active_clone_get(PointerRNA *ptr);
void MeshUVLoopLayer_active_clone_set(PointerRNA *ptr, bool value);

bool MeshUVLoopLayer_active_render_get(PointerRNA *ptr);
void MeshUVLoopLayer_active_render_set(PointerRNA *ptr, bool value);

void MeshUVLoopLayer_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MeshUVLoopLayer_data_next(CollectionPropertyIterator *iter);
void MeshUVLoopLayer_data_end(CollectionPropertyIterator *iter);
int MeshUVLoopLayer_data_length(PointerRNA *ptr);
bool MeshUVLoopLayer_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

void MeshUVLoopLayer_uv_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MeshUVLoopLayer_uv_next(CollectionPropertyIterator *iter);
void MeshUVLoopLayer_uv_end(CollectionPropertyIterator *iter);
int MeshUVLoopLayer_uv_length(PointerRNA *ptr);
bool MeshUVLoopLayer_uv_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

void MeshUVLoopLayer_edge_selection_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MeshUVLoopLayer_edge_selection_next(CollectionPropertyIterator *iter);
void MeshUVLoopLayer_edge_selection_end(CollectionPropertyIterator *iter);
int MeshUVLoopLayer_edge_selection_length(PointerRNA *ptr);
bool MeshUVLoopLayer_edge_selection_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

void MeshUVLoopLayer_pin_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MeshUVLoopLayer_pin_next(CollectionPropertyIterator *iter);
void MeshUVLoopLayer_pin_end(CollectionPropertyIterator *iter);
int MeshUVLoopLayer_pin_length(PointerRNA *ptr);
bool MeshUVLoopLayer_pin_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

void MeshUVLoopLayer_vertex_selection_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MeshUVLoopLayer_vertex_selection_next(CollectionPropertyIterator *iter);
void MeshUVLoopLayer_vertex_selection_end(CollectionPropertyIterator *iter);
int MeshUVLoopLayer_vertex_selection_length(PointerRNA *ptr);
bool MeshUVLoopLayer_vertex_selection_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Mesh Vertex ****************/

extern StructRNA RNA_MeshVertex;

PointerRNA MeshVertex_rna_type_get(PointerRNA *ptr);

void MeshVertex_groups_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MeshVertex_groups_next(CollectionPropertyIterator *iter);
void MeshVertex_groups_end(CollectionPropertyIterator *iter);

bool MeshVertex_hide_get(PointerRNA *ptr);
void MeshVertex_hide_set(PointerRNA *ptr, bool value);

int MeshVertex_index_get(PointerRNA *ptr);
void MeshVertex_index_set(PointerRNA *ptr, int value);

void MeshVertex_normal_get(PointerRNA *ptr, float values[3]);
void MeshVertex_normal_set(PointerRNA *ptr, const float values[3]);

void MeshVertex_co_get(PointerRNA *ptr, float values[3]);
void MeshVertex_co_set(PointerRNA *ptr, const float values[3]);

bool MeshVertex_select_get(PointerRNA *ptr);
void MeshVertex_select_set(PointerRNA *ptr, bool value);

void MeshVertex_undeformed_co_get(PointerRNA *ptr, float values[3]);
void MeshVertex_undeformed_co_set(PointerRNA *ptr, const float values[3]);

/**************** Mesh Vertices ****************/

extern StructRNA RNA_MeshVertices;

PointerRNA MeshVertices_rna_type_get(PointerRNA *ptr);

void MeshVertices_add_func(struct Mesh *_self, ReportList *reports, int count);
/**************** MetaBall ****************/

extern StructRNA RNA_MetaBall;
extern StructRNA RNA_ID;

PointerRNA MetaBall_animation_data_get(PointerRNA *ptr);

bool MetaBall_use_auto_texspace_get(PointerRNA *ptr);
void MetaBall_use_auto_texspace_set(PointerRNA *ptr, bool value);

void MetaBall_elements_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MetaBall_elements_next(CollectionPropertyIterator *iter);
void MetaBall_elements_end(CollectionPropertyIterator *iter);
bool MetaBall_elements_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool MetaBall_is_editmode_get(PointerRNA *ptr);
void MetaBall_is_editmode_set(PointerRNA *ptr, bool value);

void MetaBall_materials_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MetaBall_materials_next(CollectionPropertyIterator *iter);
void MetaBall_materials_end(CollectionPropertyIterator *iter);
int MetaBall_materials_length(PointerRNA *ptr);
bool MetaBall_materials_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool MetaBall_materials_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

float MetaBall_render_resolution_get(PointerRNA *ptr);
void MetaBall_render_resolution_set(PointerRNA *ptr, float value);

void MetaBall_texspace_location_get(PointerRNA *ptr, float values[3]);
void MetaBall_texspace_location_set(PointerRNA *ptr, const float values[3]);

void MetaBall_texspace_size_get(PointerRNA *ptr, float values[3]);
void MetaBall_texspace_size_set(PointerRNA *ptr, const float values[3]);

float MetaBall_threshold_get(PointerRNA *ptr);
void MetaBall_threshold_set(PointerRNA *ptr, float value);

enum {
	MetaBall_update_method_UPDATE_ALWAYS = 0,
	MetaBall_update_method_HALFRES = 1,
	MetaBall_update_method_FAST = 2,
	MetaBall_update_method_NEVER = 3,
};

int MetaBall_update_method_get(PointerRNA *ptr);
void MetaBall_update_method_set(PointerRNA *ptr, int value);

float MetaBall_resolution_get(PointerRNA *ptr);
void MetaBall_resolution_set(PointerRNA *ptr, float value);

void MetaBall_transform_func(struct MetaBall *_self, float matrix[16]);
void MetaBall_update_gpu_tag_func(struct MetaBall *_self);
/**************** Metaball Elements ****************/

extern StructRNA RNA_MetaBallElements;

PointerRNA MetaBallElements_rna_type_get(PointerRNA *ptr);

PointerRNA MetaBallElements_active_get(PointerRNA *ptr);

struct MetaElem *MetaBallElements_new_func(struct MetaBall *_self, int type);
void MetaBallElements_remove_func(struct MetaBall *_self, ReportList *reports, struct PointerRNA *element);
void MetaBallElements_clear_func(struct MetaBall *_self);
/**************** Metaball Element ****************/

extern StructRNA RNA_MetaElement;

PointerRNA MetaElement_rna_type_get(PointerRNA *ptr);

bool MetaElement_hide_get(PointerRNA *ptr);
void MetaElement_hide_set(PointerRNA *ptr, bool value);

void MetaElement_co_get(PointerRNA *ptr, float values[3]);
void MetaElement_co_set(PointerRNA *ptr, const float values[3]);

bool MetaElement_use_negative_get(PointerRNA *ptr);
void MetaElement_use_negative_set(PointerRNA *ptr, bool value);

float MetaElement_radius_get(PointerRNA *ptr);
void MetaElement_radius_set(PointerRNA *ptr, float value);

void MetaElement_rotation_get(PointerRNA *ptr, float values[4]);
void MetaElement_rotation_set(PointerRNA *ptr, const float values[4]);

bool MetaElement_use_scale_stiffness_get(PointerRNA *ptr);
void MetaElement_use_scale_stiffness_set(PointerRNA *ptr, bool value);

bool MetaElement_select_get(PointerRNA *ptr);
void MetaElement_select_set(PointerRNA *ptr, bool value);

float MetaElement_size_x_get(PointerRNA *ptr);
void MetaElement_size_x_set(PointerRNA *ptr, float value);

float MetaElement_size_y_get(PointerRNA *ptr);
void MetaElement_size_y_set(PointerRNA *ptr, float value);

float MetaElement_size_z_get(PointerRNA *ptr);
void MetaElement_size_z_set(PointerRNA *ptr, float value);

float MetaElement_stiffness_get(PointerRNA *ptr);
void MetaElement_stiffness_set(PointerRNA *ptr, float value);

enum {
	MetaElement_type_BALL = 0,
	MetaElement_type_CAPSULE = 4,
	MetaElement_type_PLANE = 5,
	MetaElement_type_ELLIPSOID = 6,
	MetaElement_type_CUBE = 7,
};

int MetaElement_type_get(PointerRNA *ptr);
void MetaElement_type_set(PointerRNA *ptr, int value);

/**************** Meta Strip ****************/

extern StructRNA RNA_MetaStrip;
extern StructRNA RNA_Strip;

enum {
	MetaStrip_alpha_mode_STRAIGHT = 0,
	MetaStrip_alpha_mode_PREMUL = 1,
};

int MetaStrip_alpha_mode_get(PointerRNA *ptr);
void MetaStrip_alpha_mode_set(PointerRNA *ptr, int value);

int MetaStrip_animation_offset_end_get(PointerRNA *ptr);
void MetaStrip_animation_offset_end_set(PointerRNA *ptr, int value);

int MetaStrip_animation_offset_start_get(PointerRNA *ptr);
void MetaStrip_animation_offset_start_set(PointerRNA *ptr, int value);

void MetaStrip_channels_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MetaStrip_channels_next(CollectionPropertyIterator *iter);
void MetaStrip_channels_end(CollectionPropertyIterator *iter);
bool MetaStrip_channels_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool MetaStrip_channels_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool MetaStrip_use_float_get(PointerRNA *ptr);
void MetaStrip_use_float_set(PointerRNA *ptr, bool value);

PointerRNA MetaStrip_crop_get(PointerRNA *ptr);

bool MetaStrip_use_deinterlace_get(PointerRNA *ptr);
void MetaStrip_use_deinterlace_set(PointerRNA *ptr, bool value);

bool MetaStrip_use_flip_x_get(PointerRNA *ptr);
void MetaStrip_use_flip_x_set(PointerRNA *ptr, bool value);

bool MetaStrip_use_flip_y_get(PointerRNA *ptr);
void MetaStrip_use_flip_y_set(PointerRNA *ptr, bool value);

bool MetaStrip_multiply_alpha_get(PointerRNA *ptr);
void MetaStrip_multiply_alpha_set(PointerRNA *ptr, bool value);

float MetaStrip_color_multiply_get(PointerRNA *ptr);
void MetaStrip_color_multiply_set(PointerRNA *ptr, float value);

PointerRNA MetaStrip_proxy_get(PointerRNA *ptr);

bool MetaStrip_use_reverse_frames_get(PointerRNA *ptr);
void MetaStrip_use_reverse_frames_set(PointerRNA *ptr, bool value);

float MetaStrip_color_saturation_get(PointerRNA *ptr);
void MetaStrip_color_saturation_set(PointerRNA *ptr, float value);

void MetaStrip_sequences_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MetaStrip_sequences_next(CollectionPropertyIterator *iter);
void MetaStrip_sequences_end(CollectionPropertyIterator *iter);
bool MetaStrip_sequences_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool MetaStrip_sequences_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void MetaStrip_strips_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MetaStrip_strips_next(CollectionPropertyIterator *iter);
void MetaStrip_strips_end(CollectionPropertyIterator *iter);
bool MetaStrip_strips_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool MetaStrip_strips_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

float MetaStrip_strobe_get(PointerRNA *ptr);
void MetaStrip_strobe_set(PointerRNA *ptr, float value);

PointerRNA MetaStrip_transform_get(PointerRNA *ptr);

bool MetaStrip_use_proxy_get(PointerRNA *ptr);
void MetaStrip_use_proxy_set(PointerRNA *ptr, bool value);

void MetaStrip_separate_func(struct ID *_selfid, struct Strip *_self, Main *bmain);
/**************** Mirror Modifier ****************/

extern StructRNA RNA_MirrorModifier;
extern StructRNA RNA_Modifier;

void MirrorModifier_use_bisect_axis_get(PointerRNA *ptr, bool values[3]);
void MirrorModifier_use_bisect_axis_set(PointerRNA *ptr, const bool values[3]);

float MirrorModifier_bisect_threshold_get(PointerRNA *ptr);
void MirrorModifier_bisect_threshold_set(PointerRNA *ptr, float value);

void MirrorModifier_use_bisect_flip_axis_get(PointerRNA *ptr, bool values[3]);
void MirrorModifier_use_bisect_flip_axis_set(PointerRNA *ptr, const bool values[3]);

bool MirrorModifier_use_clip_get(PointerRNA *ptr);
void MirrorModifier_use_clip_set(PointerRNA *ptr, bool value);

float MirrorModifier_mirror_offset_u_get(PointerRNA *ptr);
void MirrorModifier_mirror_offset_u_set(PointerRNA *ptr, float value);

float MirrorModifier_mirror_offset_v_get(PointerRNA *ptr);
void MirrorModifier_mirror_offset_v_set(PointerRNA *ptr, float value);

float MirrorModifier_merge_threshold_get(PointerRNA *ptr);
void MirrorModifier_merge_threshold_set(PointerRNA *ptr, float value);

bool MirrorModifier_use_mirror_merge_get(PointerRNA *ptr);
void MirrorModifier_use_mirror_merge_set(PointerRNA *ptr, bool value);

void MirrorModifier_use_axis_get(PointerRNA *ptr, bool values[3]);
void MirrorModifier_use_axis_set(PointerRNA *ptr, const bool values[3]);

PointerRNA MirrorModifier_mirror_object_get(PointerRNA *ptr);

bool MirrorModifier_use_mirror_u_get(PointerRNA *ptr);
void MirrorModifier_use_mirror_u_set(PointerRNA *ptr, bool value);

bool MirrorModifier_use_mirror_udim_get(PointerRNA *ptr);
void MirrorModifier_use_mirror_udim_set(PointerRNA *ptr, bool value);

bool MirrorModifier_use_mirror_v_get(PointerRNA *ptr);
void MirrorModifier_use_mirror_v_set(PointerRNA *ptr, bool value);

bool MirrorModifier_use_mirror_vertex_groups_get(PointerRNA *ptr);
void MirrorModifier_use_mirror_vertex_groups_set(PointerRNA *ptr, bool value);

float MirrorModifier_offset_u_get(PointerRNA *ptr);
void MirrorModifier_offset_u_set(PointerRNA *ptr, float value);

float MirrorModifier_offset_v_get(PointerRNA *ptr);
void MirrorModifier_offset_v_set(PointerRNA *ptr, float value);

/**************** Modifier ****************/

extern StructRNA RNA_Modifier;

PointerRNA Modifier_rna_type_get(PointerRNA *ptr);

#define Modifier_name_MAX 64

void Modifier_name_get(PointerRNA *ptr, char *value);
int Modifier_name_length(PointerRNA *ptr);
void Modifier_name_set(PointerRNA *ptr, const char *value);

bool Modifier_is_active_get(PointerRNA *ptr);
void Modifier_is_active_set(PointerRNA *ptr, bool value);

bool Modifier_use_apply_on_spline_get(PointerRNA *ptr);
void Modifier_use_apply_on_spline_set(PointerRNA *ptr, bool value);

bool Modifier_show_in_editmode_get(PointerRNA *ptr);
void Modifier_show_in_editmode_set(PointerRNA *ptr, bool value);

float Modifier_execution_time_get(PointerRNA *ptr);
void Modifier_execution_time_set(PointerRNA *ptr, float value);

bool Modifier_show_expanded_get(PointerRNA *ptr);
void Modifier_show_expanded_set(PointerRNA *ptr, bool value);

bool Modifier_show_on_cage_get(PointerRNA *ptr);
void Modifier_show_on_cage_set(PointerRNA *ptr, bool value);

bool Modifier_is_override_data_get(PointerRNA *ptr);
void Modifier_is_override_data_set(PointerRNA *ptr, bool value);

int Modifier_persistent_uid_get(PointerRNA *ptr);
void Modifier_persistent_uid_set(PointerRNA *ptr, int value);

bool Modifier_use_pin_to_last_get(PointerRNA *ptr);
void Modifier_use_pin_to_last_set(PointerRNA *ptr, bool value);

bool Modifier_show_viewport_get(PointerRNA *ptr);
void Modifier_show_viewport_set(PointerRNA *ptr, bool value);

bool Modifier_show_render_get(PointerRNA *ptr);
void Modifier_show_render_set(PointerRNA *ptr, bool value);

enum {
	Modifier_type_GREASE_PENCIL_VERTEX_WEIGHT_PROXIMITY = 76,
	Modifier_type_DATA_TRANSFER = 49,
	Modifier_type_MESH_CACHE = 46,
	Modifier_type_MESH_SEQUENCE_CACHE = 52,
	Modifier_type_NORMAL_EDIT = 50,
	Modifier_type_WEIGHTED_NORMAL = 54,
	Modifier_type_UV_PROJECT = 15,
	Modifier_type_UV_WARP = 45,
	Modifier_type_VERTEX_WEIGHT_EDIT = 36,
	Modifier_type_VERTEX_WEIGHT_MIX = 37,
	Modifier_type_VERTEX_WEIGHT_PROXIMITY = 38,
	Modifier_type_GREASE_PENCIL_COLOR = 63,
	Modifier_type_GREASE_PENCIL_TINT = 64,
	Modifier_type_GREASE_PENCIL_OPACITY = 61,
	Modifier_type_GREASE_PENCIL_VERTEX_WEIGHT_ANGLE = 74,
	Modifier_type_GREASE_PENCIL_TIME = 80,
	Modifier_type_GREASE_PENCIL_TEXTURE = 86,
	Modifier_type_ARRAY = 12,
	Modifier_type_BEVEL = 24,
	Modifier_type_BOOLEAN = 11,
	Modifier_type_BUILD = 4,
	Modifier_type_DECIMATE = 6,
	Modifier_type_EDGE_SPLIT = 13,
	Modifier_type_NODES = 57,
	Modifier_type_MASK = 27,
	Modifier_type_MIRROR = 5,
	Modifier_type_MESH_TO_VOLUME = 58,
	Modifier_type_MULTIRES = 29,
	Modifier_type_REMESH = 41,
	Modifier_type_SCREW = 34,
	Modifier_type_SKIN = 42,
	Modifier_type_SOLIDIFY = 33,
	Modifier_type_SUBSURF = 1,
	Modifier_type_TRIANGULATE = 44,
	Modifier_type_VOLUME_TO_MESH = 60,
	Modifier_type_WELD = 55,
	Modifier_type_WIREFRAME = 48,
	Modifier_type_GREASE_PENCIL_ARRAY = 75,
	Modifier_type_GREASE_PENCIL_BUILD = 84,
	Modifier_type_GREASE_PENCIL_LENGTH = 73,
	Modifier_type_LINEART = 78,
	Modifier_type_GREASE_PENCIL_MIRROR = 68,
	Modifier_type_GREASE_PENCIL_MULTIPLY = 72,
	Modifier_type_GREASE_PENCIL_SIMPLIFY = 85,
	Modifier_type_GREASE_PENCIL_SUBDIV = 62,
	Modifier_type_GREASE_PENCIL_ENVELOPE = 81,
	Modifier_type_GREASE_PENCIL_OUTLINE = 82,
	Modifier_type_ARMATURE = 8,
	Modifier_type_CAST = 17,
	Modifier_type_CURVE = 3,
	Modifier_type_DISPLACE = 14,
	Modifier_type_HOOK = 9,
	Modifier_type_LAPLACIANDEFORM = 47,
	Modifier_type_LATTICE = 2,
	Modifier_type_MESH_DEFORM = 18,
	Modifier_type_SHRINKWRAP = 25,
	Modifier_type_SIMPLE_DEFORM = 28,
	Modifier_type_SMOOTH = 16,
	Modifier_type_CORRECTIVE_SMOOTH = 51,
	Modifier_type_LAPLACIANSMOOTH = 43,
	Modifier_type_SURFACE_DEFORM = 53,
	Modifier_type_WARP = 35,
	Modifier_type_WAVE = 7,
	Modifier_type_VOLUME_DISPLACE = 59,
	Modifier_type_GREASE_PENCIL_HOOK = 77,
	Modifier_type_GREASE_PENCIL_NOISE = 67,
	Modifier_type_GREASE_PENCIL_OFFSET = 66,
	Modifier_type_GREASE_PENCIL_SMOOTH = 65,
	Modifier_type_GREASE_PENCIL_THICKNESS = 69,
	Modifier_type_GREASE_PENCIL_LATTICE = 70,
	Modifier_type_GREASE_PENCIL_DASH = 71,
	Modifier_type_GREASE_PENCIL_ARMATURE = 79,
	Modifier_type_GREASE_PENCIL_SHRINKWRAP = 83,
	Modifier_type_CLOTH = 22,
	Modifier_type_COLLISION = 23,
	Modifier_type_DYNAMIC_PAINT = 40,
	Modifier_type_EXPLODE = 21,
	Modifier_type_FLUID = 56,
	Modifier_type_OCEAN = 39,
	Modifier_type_PARTICLE_INSTANCE = 20,
	Modifier_type_PARTICLE_SYSTEM = 19,
	Modifier_type_SOFT_BODY = 10,
	Modifier_type_SURFACE = 30,
};

int Modifier_type_get(PointerRNA *ptr);
void Modifier_type_set(PointerRNA *ptr, int value);

/**************** ModifierViewerPathElem ****************/

extern StructRNA RNA_ModifierViewerPathElem;
extern StructRNA RNA_ViewerPathElem;

int ModifierViewerPathElem_modifier_uid_get(PointerRNA *ptr);
void ModifierViewerPathElem_modifier_uid_set(PointerRNA *ptr, int value);

/**************** Motion Path ****************/

extern StructRNA RNA_MotionPath;

PointerRNA MotionPath_rna_type_get(PointerRNA *ptr);

void MotionPath_color_post_get(PointerRNA *ptr, float values[3]);
void MotionPath_color_post_set(PointerRNA *ptr, const float values[3]);

void MotionPath_color_get(PointerRNA *ptr, float values[3]);
void MotionPath_color_set(PointerRNA *ptr, const float values[3]);

bool MotionPath_use_custom_color_get(PointerRNA *ptr);
void MotionPath_use_custom_color_set(PointerRNA *ptr, bool value);

bool MotionPath_is_modified_get(PointerRNA *ptr);
void MotionPath_is_modified_set(PointerRNA *ptr, bool value);

int MotionPath_frame_end_get(PointerRNA *ptr);
void MotionPath_frame_end_set(PointerRNA *ptr, int value);

int MotionPath_length_get(PointerRNA *ptr);
void MotionPath_length_set(PointerRNA *ptr, int value);

int MotionPath_line_thickness_get(PointerRNA *ptr);
void MotionPath_line_thickness_set(PointerRNA *ptr, int value);

bool MotionPath_lines_get(PointerRNA *ptr);
void MotionPath_lines_set(PointerRNA *ptr, bool value);

void MotionPath_points_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MotionPath_points_next(CollectionPropertyIterator *iter);
void MotionPath_points_end(CollectionPropertyIterator *iter);
int MotionPath_points_length(PointerRNA *ptr);
bool MotionPath_points_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

int MotionPath_frame_start_get(PointerRNA *ptr);
void MotionPath_frame_start_set(PointerRNA *ptr, int value);

bool MotionPath_use_bone_head_get(PointerRNA *ptr);
void MotionPath_use_bone_head_set(PointerRNA *ptr, bool value);

/**************** Motion Path Cache Point ****************/

extern StructRNA RNA_MotionPathVert;

PointerRNA MotionPathVert_rna_type_get(PointerRNA *ptr);

void MotionPathVert_co_get(PointerRNA *ptr, float values[3]);
void MotionPathVert_co_set(PointerRNA *ptr, const float values[3]);

bool MotionPathVert_select_get(PointerRNA *ptr);
void MotionPathVert_select_set(PointerRNA *ptr, bool value);

/**************** MovieClip ****************/

extern StructRNA RNA_MovieClip;
extern StructRNA RNA_ID;

PointerRNA MovieClip_animation_data_get(PointerRNA *ptr);

PointerRNA MovieClip_colorspace_settings_get(PointerRNA *ptr);

void MovieClip_display_aspect_get(PointerRNA *ptr, float values[2]);
void MovieClip_display_aspect_set(PointerRNA *ptr, const float values[2]);

int MovieClip_frame_duration_get(PointerRNA *ptr);
void MovieClip_frame_duration_set(PointerRNA *ptr, int value);

#define MovieClip_filepath_MAX 1024

void MovieClip_filepath_get(PointerRNA *ptr, char *value);
int MovieClip_filepath_length(PointerRNA *ptr);
void MovieClip_filepath_set(PointerRNA *ptr, const char *value);

int MovieClip_frame_offset_get(PointerRNA *ptr);
void MovieClip_frame_offset_set(PointerRNA *ptr, int value);

float MovieClip_fps_get(PointerRNA *ptr);
void MovieClip_fps_set(PointerRNA *ptr, float value);

PointerRNA MovieClip_grease_pencil_get(PointerRNA *ptr);

bool MovieClip_use_proxy_custom_directory_get(PointerRNA *ptr);
void MovieClip_use_proxy_custom_directory_set(PointerRNA *ptr, bool value);

void MovieClip_size_get(PointerRNA *ptr, int values[2]);
void MovieClip_size_set(PointerRNA *ptr, const int values[2]);

enum {
	MovieClip_source_SEQUENCE = 1,
	MovieClip_source_MOVIE = 2,
};

int MovieClip_source_get(PointerRNA *ptr);
void MovieClip_source_set(PointerRNA *ptr, int value);

int MovieClip_frame_start_get(PointerRNA *ptr);
void MovieClip_frame_start_set(PointerRNA *ptr, int value);

bool MovieClip_use_proxy_get(PointerRNA *ptr);
void MovieClip_use_proxy_set(PointerRNA *ptr, bool value);

PointerRNA MovieClip_proxy_get(PointerRNA *ptr);

PointerRNA MovieClip_tracking_get(PointerRNA *ptr);

struct PointerRNA MovieClip_metadata_func(struct MovieClip *_self);
/**************** Movie Clip Proxy ****************/

extern StructRNA RNA_MovieClipProxy;

PointerRNA MovieClipProxy_rna_type_get(PointerRNA *ptr);

bool MovieClipProxy_build_100_get(PointerRNA *ptr);
void MovieClipProxy_build_100_set(PointerRNA *ptr, bool value);

bool MovieClipProxy_build_undistorted_100_get(PointerRNA *ptr);
void MovieClipProxy_build_undistorted_100_set(PointerRNA *ptr, bool value);

bool MovieClipProxy_build_25_get(PointerRNA *ptr);
void MovieClipProxy_build_25_set(PointerRNA *ptr, bool value);

bool MovieClipProxy_build_undistorted_25_get(PointerRNA *ptr);
void MovieClipProxy_build_undistorted_25_set(PointerRNA *ptr, bool value);

bool MovieClipProxy_build_50_get(PointerRNA *ptr);
void MovieClipProxy_build_50_set(PointerRNA *ptr, bool value);

bool MovieClipProxy_build_undistorted_50_get(PointerRNA *ptr);
void MovieClipProxy_build_undistorted_50_set(PointerRNA *ptr, bool value);

bool MovieClipProxy_build_75_get(PointerRNA *ptr);
void MovieClipProxy_build_75_set(PointerRNA *ptr, bool value);

bool MovieClipProxy_build_undistorted_75_get(PointerRNA *ptr);
void MovieClipProxy_build_undistorted_75_set(PointerRNA *ptr, bool value);

#define MovieClipProxy_directory_MAX 768

void MovieClipProxy_directory_get(PointerRNA *ptr, char *value);
int MovieClipProxy_directory_length(PointerRNA *ptr);
void MovieClipProxy_directory_set(PointerRNA *ptr, const char *value);

int MovieClipProxy_quality_get(PointerRNA *ptr);
void MovieClipProxy_quality_set(PointerRNA *ptr, int value);

bool MovieClipProxy_build_record_run_get(PointerRNA *ptr);
void MovieClipProxy_build_record_run_set(PointerRNA *ptr, bool value);

enum {
	MovieClipProxy_timecode_NONE = 0,
	MovieClipProxy_timecode_RECORD_RUN = 1,
	MovieClipProxy_timecode_FREE_RUN_NO_GAPS = 8,
};

int MovieClipProxy_timecode_get(PointerRNA *ptr);
void MovieClipProxy_timecode_set(PointerRNA *ptr, int value);

/**************** MovieClipScopes ****************/

extern StructRNA RNA_MovieClipScopes;

PointerRNA MovieClipScopes_rna_type_get(PointerRNA *ptr);

/**************** MovieClip Strip ****************/

extern StructRNA RNA_MovieClipStrip;
extern StructRNA RNA_Strip;

enum {
	MovieClipStrip_alpha_mode_STRAIGHT = 0,
	MovieClipStrip_alpha_mode_PREMUL = 1,
};

int MovieClipStrip_alpha_mode_get(PointerRNA *ptr);
void MovieClipStrip_alpha_mode_set(PointerRNA *ptr, int value);

int MovieClipStrip_animation_offset_end_get(PointerRNA *ptr);
void MovieClipStrip_animation_offset_end_set(PointerRNA *ptr, int value);

int MovieClipStrip_animation_offset_start_get(PointerRNA *ptr);
void MovieClipStrip_animation_offset_start_set(PointerRNA *ptr, int value);

bool MovieClipStrip_use_float_get(PointerRNA *ptr);
void MovieClipStrip_use_float_set(PointerRNA *ptr, bool value);

PointerRNA MovieClipStrip_crop_get(PointerRNA *ptr);

bool MovieClipStrip_use_deinterlace_get(PointerRNA *ptr);
void MovieClipStrip_use_deinterlace_set(PointerRNA *ptr, bool value);

float MovieClipStrip_fps_get(PointerRNA *ptr);
void MovieClipStrip_fps_set(PointerRNA *ptr, float value);

bool MovieClipStrip_use_flip_x_get(PointerRNA *ptr);
void MovieClipStrip_use_flip_x_set(PointerRNA *ptr, bool value);

bool MovieClipStrip_use_flip_y_get(PointerRNA *ptr);
void MovieClipStrip_use_flip_y_set(PointerRNA *ptr, bool value);

PointerRNA MovieClipStrip_clip_get(PointerRNA *ptr);

bool MovieClipStrip_multiply_alpha_get(PointerRNA *ptr);
void MovieClipStrip_multiply_alpha_set(PointerRNA *ptr, bool value);

float MovieClipStrip_color_multiply_get(PointerRNA *ptr);
void MovieClipStrip_color_multiply_set(PointerRNA *ptr, float value);

bool MovieClipStrip_use_reverse_frames_get(PointerRNA *ptr);
void MovieClipStrip_use_reverse_frames_set(PointerRNA *ptr, bool value);

float MovieClipStrip_color_saturation_get(PointerRNA *ptr);
void MovieClipStrip_color_saturation_set(PointerRNA *ptr, float value);

bool MovieClipStrip_stabilize2d_get(PointerRNA *ptr);
void MovieClipStrip_stabilize2d_set(PointerRNA *ptr, bool value);

float MovieClipStrip_strobe_get(PointerRNA *ptr);
void MovieClipStrip_strobe_set(PointerRNA *ptr, float value);

PointerRNA MovieClipStrip_transform_get(PointerRNA *ptr);

bool MovieClipStrip_undistort_get(PointerRNA *ptr);
void MovieClipStrip_undistort_set(PointerRNA *ptr, bool value);

/**************** Movie Clip User ****************/

extern StructRNA RNA_MovieClipUser;

PointerRNA MovieClipUser_rna_type_get(PointerRNA *ptr);

int MovieClipUser_frame_current_get(PointerRNA *ptr);
void MovieClipUser_frame_current_set(PointerRNA *ptr, int value);

enum {
	MovieClipUser_proxy_render_size_PROXY_25 = 1,
	MovieClipUser_proxy_render_size_PROXY_50 = 2,
	MovieClipUser_proxy_render_size_PROXY_75 = 3,
	MovieClipUser_proxy_render_size_PROXY_100 = 4,
	MovieClipUser_proxy_render_size_FULL = 0,
};

int MovieClipUser_proxy_render_size_get(PointerRNA *ptr);
void MovieClipUser_proxy_render_size_set(PointerRNA *ptr, int value);

bool MovieClipUser_use_render_undistorted_get(PointerRNA *ptr);
void MovieClipUser_use_render_undistorted_set(PointerRNA *ptr, bool value);

/**************** Movie tracking reconstructed camera data ****************/

extern StructRNA RNA_MovieReconstructedCamera;

PointerRNA MovieReconstructedCamera_rna_type_get(PointerRNA *ptr);

float MovieReconstructedCamera_average_error_get(PointerRNA *ptr);
void MovieReconstructedCamera_average_error_set(PointerRNA *ptr, float value);

int MovieReconstructedCamera_frame_get(PointerRNA *ptr);
void MovieReconstructedCamera_frame_set(PointerRNA *ptr, int value);

void MovieReconstructedCamera_matrix_get(PointerRNA *ptr, float values[16]);
void MovieReconstructedCamera_matrix_set(PointerRNA *ptr, const float values[16]);

/**************** Movie Strip ****************/

extern StructRNA RNA_MovieStrip;
extern StructRNA RNA_Strip;

enum {
	MovieStrip_alpha_mode_STRAIGHT = 0,
	MovieStrip_alpha_mode_PREMUL = 1,
};

int MovieStrip_alpha_mode_get(PointerRNA *ptr);
void MovieStrip_alpha_mode_set(PointerRNA *ptr, int value);

int MovieStrip_animation_offset_end_get(PointerRNA *ptr);
void MovieStrip_animation_offset_end_set(PointerRNA *ptr, int value);

int MovieStrip_animation_offset_start_get(PointerRNA *ptr);
void MovieStrip_animation_offset_start_set(PointerRNA *ptr, int value);

PointerRNA MovieStrip_colorspace_settings_get(PointerRNA *ptr);

bool MovieStrip_use_float_get(PointerRNA *ptr);
void MovieStrip_use_float_set(PointerRNA *ptr, bool value);

PointerRNA MovieStrip_crop_get(PointerRNA *ptr);

bool MovieStrip_use_deinterlace_get(PointerRNA *ptr);
void MovieStrip_use_deinterlace_set(PointerRNA *ptr, bool value);

void MovieStrip_elements_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MovieStrip_elements_next(CollectionPropertyIterator *iter);
void MovieStrip_elements_end(CollectionPropertyIterator *iter);
int MovieStrip_elements_length(PointerRNA *ptr);
bool MovieStrip_elements_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

float MovieStrip_fps_get(PointerRNA *ptr);
void MovieStrip_fps_set(PointerRNA *ptr, float value);

void MovieStrip_filepath_get(PointerRNA *ptr, char *value);
int MovieStrip_filepath_length(PointerRNA *ptr);
void MovieStrip_filepath_set(PointerRNA *ptr, const char *value);

bool MovieStrip_use_flip_x_get(PointerRNA *ptr);
void MovieStrip_use_flip_x_set(PointerRNA *ptr, bool value);

bool MovieStrip_use_flip_y_get(PointerRNA *ptr);
void MovieStrip_use_flip_y_set(PointerRNA *ptr, bool value);

bool MovieStrip_multiply_alpha_get(PointerRNA *ptr);
void MovieStrip_multiply_alpha_set(PointerRNA *ptr, bool value);

float MovieStrip_color_multiply_get(PointerRNA *ptr);
void MovieStrip_color_multiply_set(PointerRNA *ptr, float value);

PointerRNA MovieStrip_proxy_get(PointerRNA *ptr);

void MovieStrip_retiming_keys_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MovieStrip_retiming_keys_next(CollectionPropertyIterator *iter);
void MovieStrip_retiming_keys_end(CollectionPropertyIterator *iter);
int MovieStrip_retiming_keys_length(PointerRNA *ptr);
bool MovieStrip_retiming_keys_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool MovieStrip_use_reverse_frames_get(PointerRNA *ptr);
void MovieStrip_use_reverse_frames_set(PointerRNA *ptr, bool value);

float MovieStrip_color_saturation_get(PointerRNA *ptr);
void MovieStrip_color_saturation_set(PointerRNA *ptr, float value);

PointerRNA MovieStrip_stereo_3d_format_get(PointerRNA *ptr);

int MovieStrip_stream_index_get(PointerRNA *ptr);
void MovieStrip_stream_index_set(PointerRNA *ptr, int value);

float MovieStrip_strobe_get(PointerRNA *ptr);
void MovieStrip_strobe_set(PointerRNA *ptr, float value);

PointerRNA MovieStrip_transform_get(PointerRNA *ptr);

bool MovieStrip_use_multiview_get(PointerRNA *ptr);
void MovieStrip_use_multiview_set(PointerRNA *ptr, bool value);

bool MovieStrip_use_proxy_get(PointerRNA *ptr);
void MovieStrip_use_proxy_set(PointerRNA *ptr, bool value);

enum {
	MovieStrip_views_format_INDIVIDUAL = 0,
	MovieStrip_views_format_STEREO_3D = 1,
};

int MovieStrip_views_format_get(PointerRNA *ptr);
void MovieStrip_views_format_set(PointerRNA *ptr, int value);

bool MovieStrip_reload_if_needed_func(struct ID *_selfid, struct Strip *_self, Main *bmain);
struct PointerRNA MovieStrip_metadata_func(struct ID *_selfid, struct Strip *_self);
/**************** Movie tracking data ****************/

extern StructRNA RNA_MovieTracking;

PointerRNA MovieTracking_rna_type_get(PointerRNA *ptr);

int MovieTracking_active_object_index_get(PointerRNA *ptr);
void MovieTracking_active_object_index_set(PointerRNA *ptr, int value);

void MovieTracking_objects_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MovieTracking_objects_next(CollectionPropertyIterator *iter);
void MovieTracking_objects_end(CollectionPropertyIterator *iter);
bool MovieTracking_objects_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool MovieTracking_objects_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void MovieTracking_plane_tracks_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MovieTracking_plane_tracks_next(CollectionPropertyIterator *iter);
void MovieTracking_plane_tracks_end(CollectionPropertyIterator *iter);

void MovieTracking_tracks_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MovieTracking_tracks_next(CollectionPropertyIterator *iter);
void MovieTracking_tracks_end(CollectionPropertyIterator *iter);

PointerRNA MovieTracking_camera_get(PointerRNA *ptr);

PointerRNA MovieTracking_dopesheet_get(PointerRNA *ptr);

PointerRNA MovieTracking_reconstruction_get(PointerRNA *ptr);

PointerRNA MovieTracking_settings_get(PointerRNA *ptr);

PointerRNA MovieTracking_stabilization_get(PointerRNA *ptr);

/**************** Movie tracking camera data ****************/

extern StructRNA RNA_MovieTrackingCamera;

PointerRNA MovieTrackingCamera_rna_type_get(PointerRNA *ptr);

enum {
	MovieTrackingCamera_distortion_model_POLYNOMIAL = 0,
	MovieTrackingCamera_distortion_model_DIVISION = 1,
	MovieTrackingCamera_distortion_model_NUKE = 2,
	MovieTrackingCamera_distortion_model_BROWN = 3,
};

int MovieTrackingCamera_distortion_model_get(PointerRNA *ptr);
void MovieTrackingCamera_distortion_model_set(PointerRNA *ptr, int value);

float MovieTrackingCamera_focal_length_get(PointerRNA *ptr);
void MovieTrackingCamera_focal_length_set(PointerRNA *ptr, float value);

float MovieTrackingCamera_focal_length_pixels_get(PointerRNA *ptr);
void MovieTrackingCamera_focal_length_pixels_set(PointerRNA *ptr, float value);

float MovieTrackingCamera_k1_get(PointerRNA *ptr);
void MovieTrackingCamera_k1_set(PointerRNA *ptr, float value);

float MovieTrackingCamera_division_k1_get(PointerRNA *ptr);
void MovieTrackingCamera_division_k1_set(PointerRNA *ptr, float value);

float MovieTrackingCamera_nuke_k1_get(PointerRNA *ptr);
void MovieTrackingCamera_nuke_k1_set(PointerRNA *ptr, float value);

float MovieTrackingCamera_brown_k1_get(PointerRNA *ptr);
void MovieTrackingCamera_brown_k1_set(PointerRNA *ptr, float value);

float MovieTrackingCamera_k2_get(PointerRNA *ptr);
void MovieTrackingCamera_k2_set(PointerRNA *ptr, float value);

float MovieTrackingCamera_division_k2_get(PointerRNA *ptr);
void MovieTrackingCamera_division_k2_set(PointerRNA *ptr, float value);

float MovieTrackingCamera_nuke_k2_get(PointerRNA *ptr);
void MovieTrackingCamera_nuke_k2_set(PointerRNA *ptr, float value);

float MovieTrackingCamera_brown_k2_get(PointerRNA *ptr);
void MovieTrackingCamera_brown_k2_set(PointerRNA *ptr, float value);

float MovieTrackingCamera_k3_get(PointerRNA *ptr);
void MovieTrackingCamera_k3_set(PointerRNA *ptr, float value);

float MovieTrackingCamera_brown_k3_get(PointerRNA *ptr);
void MovieTrackingCamera_brown_k3_set(PointerRNA *ptr, float value);

float MovieTrackingCamera_brown_k4_get(PointerRNA *ptr);
void MovieTrackingCamera_brown_k4_set(PointerRNA *ptr, float value);

float MovieTrackingCamera_brown_p1_get(PointerRNA *ptr);
void MovieTrackingCamera_brown_p1_set(PointerRNA *ptr, float value);

float MovieTrackingCamera_brown_p2_get(PointerRNA *ptr);
void MovieTrackingCamera_brown_p2_set(PointerRNA *ptr, float value);

float MovieTrackingCamera_pixel_aspect_get(PointerRNA *ptr);
void MovieTrackingCamera_pixel_aspect_set(PointerRNA *ptr, float value);

void MovieTrackingCamera_principal_point_get(PointerRNA *ptr, float values[2]);
void MovieTrackingCamera_principal_point_set(PointerRNA *ptr, const float values[2]);

void MovieTrackingCamera_principal_point_pixels_get(PointerRNA *ptr, float values[2]);
void MovieTrackingCamera_principal_point_pixels_set(PointerRNA *ptr, const float values[2]);

float MovieTrackingCamera_sensor_width_get(PointerRNA *ptr);
void MovieTrackingCamera_sensor_width_set(PointerRNA *ptr, float value);

enum {
	MovieTrackingCamera_units_PIXELS = 0,
	MovieTrackingCamera_units_MILLIMETERS = 1,
};

int MovieTrackingCamera_units_get(PointerRNA *ptr);
void MovieTrackingCamera_units_set(PointerRNA *ptr, int value);

/**************** Movie Tracking Dopesheet ****************/

extern StructRNA RNA_MovieTrackingDopesheet;

PointerRNA MovieTrackingDopesheet_rna_type_get(PointerRNA *ptr);

bool MovieTrackingDopesheet_show_hidden_get(PointerRNA *ptr);
void MovieTrackingDopesheet_show_hidden_set(PointerRNA *ptr, bool value);

enum {
	MovieTrackingDopesheet_sort_method_NAME = 0,
	MovieTrackingDopesheet_sort_method_LONGEST = 1,
	MovieTrackingDopesheet_sort_method_TOTAL = 2,
	MovieTrackingDopesheet_sort_method_AVERAGE_ERROR = 3,
	MovieTrackingDopesheet_sort_method_START = 4,
	MovieTrackingDopesheet_sort_method_END = 5,
};

int MovieTrackingDopesheet_sort_method_get(PointerRNA *ptr);
void MovieTrackingDopesheet_sort_method_set(PointerRNA *ptr, int value);

bool MovieTrackingDopesheet_use_invert_sort_get(PointerRNA *ptr);
void MovieTrackingDopesheet_use_invert_sort_set(PointerRNA *ptr, bool value);

bool MovieTrackingDopesheet_show_only_selected_get(PointerRNA *ptr);
void MovieTrackingDopesheet_show_only_selected_set(PointerRNA *ptr, bool value);

/**************** Movie tracking marker data ****************/

extern StructRNA RNA_MovieTrackingMarker;

PointerRNA MovieTrackingMarker_rna_type_get(PointerRNA *ptr);

int MovieTrackingMarker_frame_get(PointerRNA *ptr);
void MovieTrackingMarker_frame_set(PointerRNA *ptr, int value);

bool MovieTrackingMarker_is_keyed_get(PointerRNA *ptr);
void MovieTrackingMarker_is_keyed_set(PointerRNA *ptr, bool value);

bool MovieTrackingMarker_mute_get(PointerRNA *ptr);
void MovieTrackingMarker_mute_set(PointerRNA *ptr, bool value);

void MovieTrackingMarker_pattern_bound_box_get(PointerRNA *ptr, float values[4]);
void MovieTrackingMarker_pattern_bound_box_set(PointerRNA *ptr, const float values[4]);

void MovieTrackingMarker_pattern_corners_get(PointerRNA *ptr, float values[8]);
void MovieTrackingMarker_pattern_corners_set(PointerRNA *ptr, const float values[8]);

void MovieTrackingMarker_co_get(PointerRNA *ptr, float values[2]);
void MovieTrackingMarker_co_set(PointerRNA *ptr, const float values[2]);

void MovieTrackingMarker_search_max_get(PointerRNA *ptr, float values[2]);
void MovieTrackingMarker_search_max_set(PointerRNA *ptr, const float values[2]);

void MovieTrackingMarker_search_min_get(PointerRNA *ptr, float values[2]);
void MovieTrackingMarker_search_min_set(PointerRNA *ptr, const float values[2]);

/**************** Movie Tracking Markers ****************/

extern StructRNA RNA_MovieTrackingMarkers;

PointerRNA MovieTrackingMarkers_rna_type_get(PointerRNA *ptr);

struct MovieTrackingMarker *MovieTrackingMarkers_find_frame_func(struct MovieTrackingTrack *_self, int frame, bool exact);
struct MovieTrackingMarker *MovieTrackingMarkers_insert_frame_func(struct MovieTrackingTrack *_self, int frame, float co[2]);
void MovieTrackingMarkers_delete_frame_func(struct MovieTrackingTrack *_self, int frame);
/**************** Movie tracking object data ****************/

extern StructRNA RNA_MovieTrackingObject;

PointerRNA MovieTrackingObject_rna_type_get(PointerRNA *ptr);

#define MovieTrackingObject_name_MAX 64

void MovieTrackingObject_name_get(PointerRNA *ptr, char *value);
int MovieTrackingObject_name_length(PointerRNA *ptr);
void MovieTrackingObject_name_set(PointerRNA *ptr, const char *value);

bool MovieTrackingObject_is_camera_get(PointerRNA *ptr);
void MovieTrackingObject_is_camera_set(PointerRNA *ptr, bool value);

int MovieTrackingObject_keyframe_a_get(PointerRNA *ptr);
void MovieTrackingObject_keyframe_a_set(PointerRNA *ptr, int value);

int MovieTrackingObject_keyframe_b_get(PointerRNA *ptr);
void MovieTrackingObject_keyframe_b_set(PointerRNA *ptr, int value);

void MovieTrackingObject_plane_tracks_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MovieTrackingObject_plane_tracks_next(CollectionPropertyIterator *iter);
void MovieTrackingObject_plane_tracks_end(CollectionPropertyIterator *iter);
bool MovieTrackingObject_plane_tracks_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool MovieTrackingObject_plane_tracks_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

float MovieTrackingObject_scale_get(PointerRNA *ptr);
void MovieTrackingObject_scale_set(PointerRNA *ptr, float value);

void MovieTrackingObject_tracks_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MovieTrackingObject_tracks_next(CollectionPropertyIterator *iter);
void MovieTrackingObject_tracks_end(CollectionPropertyIterator *iter);
bool MovieTrackingObject_tracks_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool MovieTrackingObject_tracks_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

PointerRNA MovieTrackingObject_reconstruction_get(PointerRNA *ptr);

/**************** Plane Tracks ****************/

extern StructRNA RNA_MovieTrackingObjectPlaneTracks;

PointerRNA MovieTrackingObjectPlaneTracks_rna_type_get(PointerRNA *ptr);

PointerRNA MovieTrackingObjectPlaneTracks_active_get(PointerRNA *ptr);

/**************** Movie Tracks ****************/

extern StructRNA RNA_MovieTrackingObjectTracks;

PointerRNA MovieTrackingObjectTracks_rna_type_get(PointerRNA *ptr);

PointerRNA MovieTrackingObjectTracks_active_get(PointerRNA *ptr);

struct MovieTrackingTrack *MovieTrackingObjectTracks_new_func(struct ID *_selfid, struct MovieTrackingObject *_self, const char * name, int frame);
/**************** Movie Objects ****************/

extern StructRNA RNA_MovieTrackingObjects;

PointerRNA MovieTrackingObjects_rna_type_get(PointerRNA *ptr);

PointerRNA MovieTrackingObjects_active_get(PointerRNA *ptr);

struct MovieTrackingObject *MovieTrackingObjects_new_func(struct MovieTracking *_self, const char * name);
void MovieTrackingObjects_remove_func(struct MovieTracking *_self, ReportList *reports, struct PointerRNA *object);
/**************** Movie Tracking Plane Marker Data ****************/

extern StructRNA RNA_MovieTrackingPlaneMarker;

PointerRNA MovieTrackingPlaneMarker_rna_type_get(PointerRNA *ptr);

void MovieTrackingPlaneMarker_corners_get(PointerRNA *ptr, float values[8]);
void MovieTrackingPlaneMarker_corners_set(PointerRNA *ptr, const float values[8]);

int MovieTrackingPlaneMarker_frame_get(PointerRNA *ptr);
void MovieTrackingPlaneMarker_frame_set(PointerRNA *ptr, int value);

bool MovieTrackingPlaneMarker_mute_get(PointerRNA *ptr);
void MovieTrackingPlaneMarker_mute_set(PointerRNA *ptr, bool value);

/**************** Movie Tracking Plane Markers ****************/

extern StructRNA RNA_MovieTrackingPlaneMarkers;

PointerRNA MovieTrackingPlaneMarkers_rna_type_get(PointerRNA *ptr);

struct MovieTrackingPlaneMarker *MovieTrackingPlaneMarkers_find_frame_func(struct MovieTrackingPlaneTrack *_self, int frame, bool exact);
struct MovieTrackingPlaneMarker *MovieTrackingPlaneMarkers_insert_frame_func(struct MovieTrackingPlaneTrack *_self, int frame);
void MovieTrackingPlaneMarkers_delete_frame_func(struct MovieTrackingPlaneTrack *_self, int frame);
/**************** Movie tracking plane track data ****************/

extern StructRNA RNA_MovieTrackingPlaneTrack;

PointerRNA MovieTrackingPlaneTrack_rna_type_get(PointerRNA *ptr);

#define MovieTrackingPlaneTrack_name_MAX 64

void MovieTrackingPlaneTrack_name_get(PointerRNA *ptr, char *value);
int MovieTrackingPlaneTrack_name_length(PointerRNA *ptr);
void MovieTrackingPlaneTrack_name_set(PointerRNA *ptr, const char *value);

bool MovieTrackingPlaneTrack_use_auto_keying_get(PointerRNA *ptr);
void MovieTrackingPlaneTrack_use_auto_keying_set(PointerRNA *ptr, bool value);

PointerRNA MovieTrackingPlaneTrack_image_get(PointerRNA *ptr);

float MovieTrackingPlaneTrack_image_opacity_get(PointerRNA *ptr);
void MovieTrackingPlaneTrack_image_opacity_set(PointerRNA *ptr, float value);

void MovieTrackingPlaneTrack_markers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MovieTrackingPlaneTrack_markers_next(CollectionPropertyIterator *iter);
void MovieTrackingPlaneTrack_markers_end(CollectionPropertyIterator *iter);
int MovieTrackingPlaneTrack_markers_length(PointerRNA *ptr);
bool MovieTrackingPlaneTrack_markers_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool MovieTrackingPlaneTrack_select_get(PointerRNA *ptr);
void MovieTrackingPlaneTrack_select_set(PointerRNA *ptr, bool value);

/**************** Movie Plane Tracks ****************/

extern StructRNA RNA_MovieTrackingPlaneTracks;

PointerRNA MovieTrackingPlaneTracks_rna_type_get(PointerRNA *ptr);

PointerRNA MovieTrackingPlaneTracks_active_get(PointerRNA *ptr);

/**************** Reconstructed Cameras ****************/

extern StructRNA RNA_MovieTrackingReconstructedCameras;

PointerRNA MovieTrackingReconstructedCameras_rna_type_get(PointerRNA *ptr);

struct MovieReconstructedCamera *MovieTrackingReconstructedCameras_find_frame_func(struct ID *_selfid, struct MovieTrackingReconstruction *_self, int frame);
void MovieTrackingReconstructedCameras_matrix_from_frame_func(struct ID *_selfid, struct MovieTrackingReconstruction *_self, int frame, float matrix[16]);
/**************** Movie tracking reconstruction data ****************/

extern StructRNA RNA_MovieTrackingReconstruction;

PointerRNA MovieTrackingReconstruction_rna_type_get(PointerRNA *ptr);

float MovieTrackingReconstruction_average_error_get(PointerRNA *ptr);
void MovieTrackingReconstruction_average_error_set(PointerRNA *ptr, float value);

void MovieTrackingReconstruction_cameras_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MovieTrackingReconstruction_cameras_next(CollectionPropertyIterator *iter);
void MovieTrackingReconstruction_cameras_end(CollectionPropertyIterator *iter);
int MovieTrackingReconstruction_cameras_length(PointerRNA *ptr);
bool MovieTrackingReconstruction_cameras_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool MovieTrackingReconstruction_is_valid_get(PointerRNA *ptr);
void MovieTrackingReconstruction_is_valid_set(PointerRNA *ptr, bool value);

/**************** Movie tracking settings ****************/

extern StructRNA RNA_MovieTrackingSettings;

PointerRNA MovieTrackingSettings_rna_type_get(PointerRNA *ptr);

enum {
	MovieTrackingSettings_clean_action_SELECT = 0,
	MovieTrackingSettings_clean_action_DELETE_TRACK = 1,
	MovieTrackingSettings_clean_action_DELETE_SEGMENTS = 2,
};

int MovieTrackingSettings_clean_action_get(PointerRNA *ptr);
void MovieTrackingSettings_clean_action_set(PointerRNA *ptr, int value);

float MovieTrackingSettings_default_correlation_min_get(PointerRNA *ptr);
void MovieTrackingSettings_default_correlation_min_set(PointerRNA *ptr, float value);

float MovieTrackingSettings_distance_get(PointerRNA *ptr);
void MovieTrackingSettings_distance_set(PointerRNA *ptr, float value);

float MovieTrackingSettings_object_distance_get(PointerRNA *ptr);
void MovieTrackingSettings_object_distance_set(PointerRNA *ptr, float value);

int MovieTrackingSettings_default_frames_limit_get(PointerRNA *ptr);
void MovieTrackingSettings_default_frames_limit_set(PointerRNA *ptr, int value);

bool MovieTrackingSettings_use_keyframe_selection_get(PointerRNA *ptr);
void MovieTrackingSettings_use_keyframe_selection_set(PointerRNA *ptr, bool value);

int MovieTrackingSettings_default_margin_get(PointerRNA *ptr);
void MovieTrackingSettings_default_margin_set(PointerRNA *ptr, int value);

enum {
	MovieTrackingSettings_default_motion_model_Perspective = 5,
	MovieTrackingSettings_default_motion_model_Affine = 4,
	MovieTrackingSettings_default_motion_model_LocRotScale = 3,
	MovieTrackingSettings_default_motion_model_LocScale = 2,
	MovieTrackingSettings_default_motion_model_LocRot = 1,
	MovieTrackingSettings_default_motion_model_Loc = 0,
};

int MovieTrackingSettings_default_motion_model_get(PointerRNA *ptr);
void MovieTrackingSettings_default_motion_model_set(PointerRNA *ptr, int value);

bool MovieTrackingSettings_use_default_normalization_get(PointerRNA *ptr);
void MovieTrackingSettings_use_default_normalization_set(PointerRNA *ptr, bool value);

enum {
	MovieTrackingSettings_default_pattern_match_KEYFRAME = 0,
	MovieTrackingSettings_default_pattern_match_PREV_FRAME = 1,
};

int MovieTrackingSettings_default_pattern_match_get(PointerRNA *ptr);
void MovieTrackingSettings_default_pattern_match_set(PointerRNA *ptr, int value);

int MovieTrackingSettings_default_pattern_size_get(PointerRNA *ptr);
void MovieTrackingSettings_default_pattern_size_set(PointerRNA *ptr, int value);

bool MovieTrackingSettings_use_default_brute_get(PointerRNA *ptr);
void MovieTrackingSettings_use_default_brute_set(PointerRNA *ptr, bool value);

bool MovieTrackingSettings_refine_intrinsics_focal_length_get(PointerRNA *ptr);
void MovieTrackingSettings_refine_intrinsics_focal_length_set(PointerRNA *ptr, bool value);

bool MovieTrackingSettings_refine_intrinsics_principal_point_get(PointerRNA *ptr);
void MovieTrackingSettings_refine_intrinsics_principal_point_set(PointerRNA *ptr, bool value);

bool MovieTrackingSettings_refine_intrinsics_radial_distortion_get(PointerRNA *ptr);
void MovieTrackingSettings_refine_intrinsics_radial_distortion_set(PointerRNA *ptr, bool value);

bool MovieTrackingSettings_refine_intrinsics_tangential_distortion_get(PointerRNA *ptr);
void MovieTrackingSettings_refine_intrinsics_tangential_distortion_set(PointerRNA *ptr, bool value);

float MovieTrackingSettings_clean_error_get(PointerRNA *ptr);
void MovieTrackingSettings_clean_error_set(PointerRNA *ptr, float value);

int MovieTrackingSettings_default_search_size_get(PointerRNA *ptr);
void MovieTrackingSettings_default_search_size_set(PointerRNA *ptr, int value);

enum {
	MovieTrackingSettings_speed_FASTEST = 0,
	MovieTrackingSettings_speed_DOUBLE = 5,
	MovieTrackingSettings_speed_REALTIME = 1,
	MovieTrackingSettings_speed_HALF = 2,
	MovieTrackingSettings_speed_QUARTER = 4,
};

int MovieTrackingSettings_speed_get(PointerRNA *ptr);
void MovieTrackingSettings_speed_set(PointerRNA *ptr, int value);

int MovieTrackingSettings_clean_frames_get(PointerRNA *ptr);
void MovieTrackingSettings_clean_frames_set(PointerRNA *ptr, int value);

bool MovieTrackingSettings_use_tripod_solver_get(PointerRNA *ptr);
void MovieTrackingSettings_use_tripod_solver_set(PointerRNA *ptr, bool value);

bool MovieTrackingSettings_use_default_blue_channel_get(PointerRNA *ptr);
void MovieTrackingSettings_use_default_blue_channel_set(PointerRNA *ptr, bool value);

bool MovieTrackingSettings_use_default_green_channel_get(PointerRNA *ptr);
void MovieTrackingSettings_use_default_green_channel_set(PointerRNA *ptr, bool value);

bool MovieTrackingSettings_use_default_mask_get(PointerRNA *ptr);
void MovieTrackingSettings_use_default_mask_set(PointerRNA *ptr, bool value);

bool MovieTrackingSettings_use_default_red_channel_get(PointerRNA *ptr);
void MovieTrackingSettings_use_default_red_channel_set(PointerRNA *ptr, bool value);

float MovieTrackingSettings_default_weight_get(PointerRNA *ptr);
void MovieTrackingSettings_default_weight_set(PointerRNA *ptr, float value);

/**************** Movie tracking stabilization data ****************/

extern StructRNA RNA_MovieTrackingStabilization;

PointerRNA MovieTrackingStabilization_rna_type_get(PointerRNA *ptr);

int MovieTrackingStabilization_active_rotation_track_index_get(PointerRNA *ptr);
void MovieTrackingStabilization_active_rotation_track_index_set(PointerRNA *ptr, int value);

int MovieTrackingStabilization_active_track_index_get(PointerRNA *ptr);
void MovieTrackingStabilization_active_track_index_set(PointerRNA *ptr, int value);

int MovieTrackingStabilization_anchor_frame_get(PointerRNA *ptr);
void MovieTrackingStabilization_anchor_frame_set(PointerRNA *ptr, int value);

bool MovieTrackingStabilization_use_autoscale_get(PointerRNA *ptr);
void MovieTrackingStabilization_use_autoscale_set(PointerRNA *ptr, bool value);

void MovieTrackingStabilization_target_position_get(PointerRNA *ptr, float values[2]);
void MovieTrackingStabilization_target_position_set(PointerRNA *ptr, const float values[2]);

float MovieTrackingStabilization_target_rotation_get(PointerRNA *ptr);
void MovieTrackingStabilization_target_rotation_set(PointerRNA *ptr, float value);

float MovieTrackingStabilization_target_scale_get(PointerRNA *ptr);
void MovieTrackingStabilization_target_scale_set(PointerRNA *ptr, float value);

enum {
	MovieTrackingStabilization_filter_type_NEAREST = 0,
	MovieTrackingStabilization_filter_type_BILINEAR = 1,
	MovieTrackingStabilization_filter_type_BICUBIC = 2,
};

int MovieTrackingStabilization_filter_type_get(PointerRNA *ptr);
void MovieTrackingStabilization_filter_type_set(PointerRNA *ptr, int value);

float MovieTrackingStabilization_influence_location_get(PointerRNA *ptr);
void MovieTrackingStabilization_influence_location_set(PointerRNA *ptr, float value);

float MovieTrackingStabilization_scale_max_get(PointerRNA *ptr);
void MovieTrackingStabilization_scale_max_set(PointerRNA *ptr, float value);

float MovieTrackingStabilization_influence_rotation_get(PointerRNA *ptr);
void MovieTrackingStabilization_influence_rotation_set(PointerRNA *ptr, float value);

void MovieTrackingStabilization_rotation_tracks_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MovieTrackingStabilization_rotation_tracks_next(CollectionPropertyIterator *iter);
void MovieTrackingStabilization_rotation_tracks_end(CollectionPropertyIterator *iter);

float MovieTrackingStabilization_influence_scale_get(PointerRNA *ptr);
void MovieTrackingStabilization_influence_scale_set(PointerRNA *ptr, float value);

bool MovieTrackingStabilization_show_tracks_expanded_get(PointerRNA *ptr);
void MovieTrackingStabilization_show_tracks_expanded_set(PointerRNA *ptr, bool value);

bool MovieTrackingStabilization_use_stabilize_rotation_get(PointerRNA *ptr);
void MovieTrackingStabilization_use_stabilize_rotation_set(PointerRNA *ptr, bool value);

bool MovieTrackingStabilization_use_stabilize_scale_get(PointerRNA *ptr);
void MovieTrackingStabilization_use_stabilize_scale_set(PointerRNA *ptr, bool value);

void MovieTrackingStabilization_tracks_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MovieTrackingStabilization_tracks_next(CollectionPropertyIterator *iter);
void MovieTrackingStabilization_tracks_end(CollectionPropertyIterator *iter);

bool MovieTrackingStabilization_use_2d_stabilization_get(PointerRNA *ptr);
void MovieTrackingStabilization_use_2d_stabilization_set(PointerRNA *ptr, bool value);

/**************** Movie tracking track data ****************/

extern StructRNA RNA_MovieTrackingTrack;

PointerRNA MovieTrackingTrack_rna_type_get(PointerRNA *ptr);

#define MovieTrackingTrack_name_MAX 64

void MovieTrackingTrack_name_get(PointerRNA *ptr, char *value);
int MovieTrackingTrack_name_length(PointerRNA *ptr);
void MovieTrackingTrack_name_set(PointerRNA *ptr, const char *value);

bool MovieTrackingTrack_use_alpha_preview_get(PointerRNA *ptr);
void MovieTrackingTrack_use_alpha_preview_set(PointerRNA *ptr, bool value);

float MovieTrackingTrack_average_error_get(PointerRNA *ptr);
void MovieTrackingTrack_average_error_set(PointerRNA *ptr, float value);

void MovieTrackingTrack_bundle_get(PointerRNA *ptr, float values[3]);
void MovieTrackingTrack_bundle_set(PointerRNA *ptr, const float values[3]);

void MovieTrackingTrack_color_get(PointerRNA *ptr, float values[3]);
void MovieTrackingTrack_color_set(PointerRNA *ptr, const float values[3]);

float MovieTrackingTrack_correlation_min_get(PointerRNA *ptr);
void MovieTrackingTrack_correlation_min_set(PointerRNA *ptr, float value);

bool MovieTrackingTrack_use_custom_color_get(PointerRNA *ptr);
void MovieTrackingTrack_use_custom_color_set(PointerRNA *ptr, bool value);

int MovieTrackingTrack_frames_limit_get(PointerRNA *ptr);
void MovieTrackingTrack_frames_limit_set(PointerRNA *ptr, int value);

bool MovieTrackingTrack_use_grayscale_preview_get(PointerRNA *ptr);
void MovieTrackingTrack_use_grayscale_preview_set(PointerRNA *ptr, bool value);

PointerRNA MovieTrackingTrack_grease_pencil_get(PointerRNA *ptr);

bool MovieTrackingTrack_has_bundle_get(PointerRNA *ptr);
void MovieTrackingTrack_has_bundle_set(PointerRNA *ptr, bool value);

bool MovieTrackingTrack_hide_get(PointerRNA *ptr);
void MovieTrackingTrack_hide_set(PointerRNA *ptr, bool value);

bool MovieTrackingTrack_lock_get(PointerRNA *ptr);
void MovieTrackingTrack_lock_set(PointerRNA *ptr, bool value);

int MovieTrackingTrack_margin_get(PointerRNA *ptr);
void MovieTrackingTrack_margin_set(PointerRNA *ptr, int value);

void MovieTrackingTrack_markers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void MovieTrackingTrack_markers_next(CollectionPropertyIterator *iter);
void MovieTrackingTrack_markers_end(CollectionPropertyIterator *iter);
int MovieTrackingTrack_markers_length(PointerRNA *ptr);
bool MovieTrackingTrack_markers_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

enum {
	MovieTrackingTrack_motion_model_Perspective = 5,
	MovieTrackingTrack_motion_model_Affine = 4,
	MovieTrackingTrack_motion_model_LocRotScale = 3,
	MovieTrackingTrack_motion_model_LocScale = 2,
	MovieTrackingTrack_motion_model_LocRot = 1,
	MovieTrackingTrack_motion_model_Loc = 0,
};

int MovieTrackingTrack_motion_model_get(PointerRNA *ptr);
void MovieTrackingTrack_motion_model_set(PointerRNA *ptr, int value);

bool MovieTrackingTrack_use_normalization_get(PointerRNA *ptr);
void MovieTrackingTrack_use_normalization_set(PointerRNA *ptr, bool value);

void MovieTrackingTrack_offset_get(PointerRNA *ptr, float values[2]);
void MovieTrackingTrack_offset_set(PointerRNA *ptr, const float values[2]);

enum {
	MovieTrackingTrack_pattern_match_KEYFRAME = 0,
	MovieTrackingTrack_pattern_match_PREV_FRAME = 1,
};

int MovieTrackingTrack_pattern_match_get(PointerRNA *ptr);
void MovieTrackingTrack_pattern_match_set(PointerRNA *ptr, int value);

bool MovieTrackingTrack_use_brute_get(PointerRNA *ptr);
void MovieTrackingTrack_use_brute_set(PointerRNA *ptr, bool value);

bool MovieTrackingTrack_select_get(PointerRNA *ptr);
void MovieTrackingTrack_select_set(PointerRNA *ptr, bool value);

bool MovieTrackingTrack_select_anchor_get(PointerRNA *ptr);
void MovieTrackingTrack_select_anchor_set(PointerRNA *ptr, bool value);

bool MovieTrackingTrack_select_pattern_get(PointerRNA *ptr);
void MovieTrackingTrack_select_pattern_set(PointerRNA *ptr, bool value);

bool MovieTrackingTrack_select_search_get(PointerRNA *ptr);
void MovieTrackingTrack_select_search_set(PointerRNA *ptr, bool value);

float MovieTrackingTrack_weight_stab_get(PointerRNA *ptr);
void MovieTrackingTrack_weight_stab_set(PointerRNA *ptr, float value);

bool MovieTrackingTrack_use_blue_channel_get(PointerRNA *ptr);
void MovieTrackingTrack_use_blue_channel_set(PointerRNA *ptr, bool value);

bool MovieTrackingTrack_use_green_channel_get(PointerRNA *ptr);
void MovieTrackingTrack_use_green_channel_set(PointerRNA *ptr, bool value);

bool MovieTrackingTrack_use_mask_get(PointerRNA *ptr);
void MovieTrackingTrack_use_mask_set(PointerRNA *ptr, bool value);

bool MovieTrackingTrack_use_red_channel_get(PointerRNA *ptr);
void MovieTrackingTrack_use_red_channel_set(PointerRNA *ptr, bool value);

float MovieTrackingTrack_weight_get(PointerRNA *ptr);
void MovieTrackingTrack_weight_set(PointerRNA *ptr, float value);

/**************** Movie Tracks ****************/

extern StructRNA RNA_MovieTrackingTracks;

PointerRNA MovieTrackingTracks_rna_type_get(PointerRNA *ptr);

PointerRNA MovieTrackingTracks_active_get(PointerRNA *ptr);

struct MovieTrackingTrack *MovieTrackingTracks_new_func(struct ID *_selfid, struct MovieTracking *_self, const char * name, int frame);
/**************** Multicam Select Strip ****************/

extern StructRNA RNA_MulticamStrip;
extern StructRNA RNA_EffectStrip;
extern StructRNA RNA_Strip;

int MulticamStrip_animation_offset_end_get(PointerRNA *ptr);
void MulticamStrip_animation_offset_end_set(PointerRNA *ptr, int value);

int MulticamStrip_animation_offset_start_get(PointerRNA *ptr);
void MulticamStrip_animation_offset_start_set(PointerRNA *ptr, int value);

int MulticamStrip_multicam_source_get(PointerRNA *ptr);
void MulticamStrip_multicam_source_set(PointerRNA *ptr, int value);

int MulticamStrip_input_count_get(PointerRNA *ptr);
void MulticamStrip_input_count_set(PointerRNA *ptr, int value);

/**************** Multiply Strip ****************/

extern StructRNA RNA_MultiplyStrip;
extern StructRNA RNA_EffectStrip;
extern StructRNA RNA_Strip;

PointerRNA MultiplyStrip_input_1_get(PointerRNA *ptr);

PointerRNA MultiplyStrip_input_2_get(PointerRNA *ptr);

int MultiplyStrip_input_count_get(PointerRNA *ptr);
void MultiplyStrip_input_count_set(PointerRNA *ptr, int value);

/**************** Multires Modifier ****************/

extern StructRNA RNA_MultiresModifier;
extern StructRNA RNA_Modifier;

enum {
	MultiresModifier_boundary_smooth_PRESERVE_CORNERS = 1,
	MultiresModifier_boundary_smooth_ALL = 0,
};

int MultiresModifier_boundary_smooth_get(PointerRNA *ptr);
void MultiresModifier_boundary_smooth_set(PointerRNA *ptr, int value);

bool MultiresModifier_is_external_get(PointerRNA *ptr);
void MultiresModifier_is_external_set(PointerRNA *ptr, bool value);

void MultiresModifier_filepath_get(PointerRNA *ptr, char *value);
int MultiresModifier_filepath_length(PointerRNA *ptr);
void MultiresModifier_filepath_set(PointerRNA *ptr, const char *value);

int MultiresModifier_levels_get(PointerRNA *ptr);
void MultiresModifier_levels_set(PointerRNA *ptr, int value);

bool MultiresModifier_show_only_control_edges_get(PointerRNA *ptr);
void MultiresModifier_show_only_control_edges_set(PointerRNA *ptr, bool value);

int MultiresModifier_quality_get(PointerRNA *ptr);
void MultiresModifier_quality_set(PointerRNA *ptr, int value);

int MultiresModifier_render_levels_get(PointerRNA *ptr);
void MultiresModifier_render_levels_set(PointerRNA *ptr, int value);

bool MultiresModifier_use_sculpt_base_mesh_get(PointerRNA *ptr);
void MultiresModifier_use_sculpt_base_mesh_set(PointerRNA *ptr, bool value);

int MultiresModifier_sculpt_levels_get(PointerRNA *ptr);
void MultiresModifier_sculpt_levels_set(PointerRNA *ptr, int value);

int MultiresModifier_total_levels_get(PointerRNA *ptr);
void MultiresModifier_total_levels_set(PointerRNA *ptr, int value);

enum {
	MultiresModifier_uv_smooth_NONE = 0,
	MultiresModifier_uv_smooth_PRESERVE_CORNERS = 1,
	MultiresModifier_uv_smooth_PRESERVE_CORNERS_AND_JUNCTIONS = 2,
	MultiresModifier_uv_smooth_PRESERVE_CORNERS_JUNCTIONS_AND_CONCAVE = 3,
	MultiresModifier_uv_smooth_PRESERVE_BOUNDARIES = 4,
	MultiresModifier_uv_smooth_SMOOTH_ALL = 5,
};

int MultiresModifier_uv_smooth_get(PointerRNA *ptr);
void MultiresModifier_uv_smooth_set(PointerRNA *ptr, int value);

bool MultiresModifier_use_creases_get(PointerRNA *ptr);
void MultiresModifier_use_creases_set(PointerRNA *ptr, bool value);

bool MultiresModifier_use_custom_normals_get(PointerRNA *ptr);
void MultiresModifier_use_custom_normals_set(PointerRNA *ptr, bool value);

/**************** Musgrave ****************/

extern StructRNA RNA_MusgraveTexture;
extern StructRNA RNA_Texture;
extern StructRNA RNA_ID;

float MusgraveTexture_gain_get(PointerRNA *ptr);
void MusgraveTexture_gain_set(PointerRNA *ptr, float value);

float MusgraveTexture_dimension_max_get(PointerRNA *ptr);
void MusgraveTexture_dimension_max_set(PointerRNA *ptr, float value);

float MusgraveTexture_lacunarity_get(PointerRNA *ptr);
void MusgraveTexture_lacunarity_set(PointerRNA *ptr, float value);

float MusgraveTexture_nabla_get(PointerRNA *ptr);
void MusgraveTexture_nabla_set(PointerRNA *ptr, float value);

enum {
	MusgraveTexture_noise_basis_BLENDER_ORIGINAL = 0,
	MusgraveTexture_noise_basis_ORIGINAL_PERLIN = 1,
	MusgraveTexture_noise_basis_IMPROVED_PERLIN = 2,
	MusgraveTexture_noise_basis_VORONOI_F1 = 3,
	MusgraveTexture_noise_basis_VORONOI_F2 = 4,
	MusgraveTexture_noise_basis_VORONOI_F3 = 5,
	MusgraveTexture_noise_basis_VORONOI_F4 = 6,
	MusgraveTexture_noise_basis_VORONOI_F2_F1 = 7,
	MusgraveTexture_noise_basis_VORONOI_CRACKLE = 8,
	MusgraveTexture_noise_basis_CELL_NOISE = 14,
};

int MusgraveTexture_noise_basis_get(PointerRNA *ptr);
void MusgraveTexture_noise_basis_set(PointerRNA *ptr, int value);

float MusgraveTexture_noise_intensity_get(PointerRNA *ptr);
void MusgraveTexture_noise_intensity_set(PointerRNA *ptr, float value);

float MusgraveTexture_noise_scale_get(PointerRNA *ptr);
void MusgraveTexture_noise_scale_set(PointerRNA *ptr, float value);

float MusgraveTexture_octaves_get(PointerRNA *ptr);
void MusgraveTexture_octaves_set(PointerRNA *ptr, float value);

float MusgraveTexture_offset_get(PointerRNA *ptr);
void MusgraveTexture_offset_set(PointerRNA *ptr, float value);

enum {
	MusgraveTexture_musgrave_type_MULTIFRACTAL = 0,
	MusgraveTexture_musgrave_type_RIDGED_MULTIFRACTAL = 1,
	MusgraveTexture_musgrave_type_HYBRID_MULTIFRACTAL = 2,
	MusgraveTexture_musgrave_type_FBM = 3,
	MusgraveTexture_musgrave_type_HETERO_TERRAIN = 4,
};

int MusgraveTexture_musgrave_type_get(PointerRNA *ptr);
void MusgraveTexture_musgrave_type_set(PointerRNA *ptr, int value);

/**************** NDOF Motion Data ****************/

extern StructRNA RNA_NDOFMotionEventData;

PointerRNA NDOFMotionEventData_rna_type_get(PointerRNA *ptr);

enum {
	NDOFMotionEventData_progress_STARTING = 1,
	NDOFMotionEventData_progress_IN_PROGRESS = 2,
	NDOFMotionEventData_progress_FINISHING = 3,
};

int NDOFMotionEventData_progress_get(PointerRNA *ptr);
void NDOFMotionEventData_progress_set(PointerRNA *ptr, int value);

void NDOFMotionEventData_rotation_get(PointerRNA *ptr, float values[3]);
void NDOFMotionEventData_rotation_set(PointerRNA *ptr, const float values[3]);

float NDOFMotionEventData_time_delta_get(PointerRNA *ptr);
void NDOFMotionEventData_time_delta_set(PointerRNA *ptr, float value);

void NDOFMotionEventData_translation_get(PointerRNA *ptr, float values[3]);
void NDOFMotionEventData_translation_set(PointerRNA *ptr, const float values[3]);

/**************** NLA Strip ****************/

extern StructRNA RNA_NlaStrip;

PointerRNA NlaStrip_rna_type_get(PointerRNA *ptr);

#define NlaStrip_name_MAX 64

void NlaStrip_name_get(PointerRNA *ptr, char *value);
int NlaStrip_name_length(PointerRNA *ptr);
void NlaStrip_name_set(PointerRNA *ptr, const char *value);

PointerRNA NlaStrip_action_get(PointerRNA *ptr);

float NlaStrip_action_frame_end_get(PointerRNA *ptr);
void NlaStrip_action_frame_end_set(PointerRNA *ptr, float value);

PointerRNA NlaStrip_action_slot_get(PointerRNA *ptr);

int NlaStrip_action_slot_handle_get(PointerRNA *ptr);
void NlaStrip_action_slot_handle_set(PointerRNA *ptr, int value);

void NlaStrip_action_suitable_slots_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void NlaStrip_action_suitable_slots_next(CollectionPropertyIterator *iter);
void NlaStrip_action_suitable_slots_end(CollectionPropertyIterator *iter);

float NlaStrip_action_frame_start_get(PointerRNA *ptr);
void NlaStrip_action_frame_start_set(PointerRNA *ptr, float value);

bool NlaStrip_active_get(PointerRNA *ptr);
void NlaStrip_active_set(PointerRNA *ptr, bool value);

bool NlaStrip_use_animated_influence_get(PointerRNA *ptr);
void NlaStrip_use_animated_influence_set(PointerRNA *ptr, bool value);

bool NlaStrip_use_animated_time_get(PointerRNA *ptr);
void NlaStrip_use_animated_time_set(PointerRNA *ptr, bool value);

bool NlaStrip_use_auto_blend_get(PointerRNA *ptr);
void NlaStrip_use_auto_blend_set(PointerRNA *ptr, bool value);

float NlaStrip_blend_in_get(PointerRNA *ptr);
void NlaStrip_blend_in_set(PointerRNA *ptr, float value);

float NlaStrip_blend_out_get(PointerRNA *ptr);
void NlaStrip_blend_out_set(PointerRNA *ptr, float value);

enum {
	NlaStrip_blend_type_REPLACE = 0,
	NlaStrip_blend_type_COMBINE = 4,
	NlaStrip_blend_type_ADD = 1,
	NlaStrip_blend_type_SUBTRACT = 2,
	NlaStrip_blend_type_MULTIPLY = 3,
};

int NlaStrip_blend_type_get(PointerRNA *ptr);
void NlaStrip_blend_type_set(PointerRNA *ptr, int value);

bool NlaStrip_use_animated_time_cyclic_get(PointerRNA *ptr);
void NlaStrip_use_animated_time_cyclic_set(PointerRNA *ptr, bool value);

float NlaStrip_frame_end_get(PointerRNA *ptr);
void NlaStrip_frame_end_set(PointerRNA *ptr, float value);

float NlaStrip_frame_end_ui_get(PointerRNA *ptr);
void NlaStrip_frame_end_ui_set(PointerRNA *ptr, float value);

float NlaStrip_frame_end_raw_get(PointerRNA *ptr);
void NlaStrip_frame_end_raw_set(PointerRNA *ptr, float value);

enum {
	NlaStrip_extrapolation_NOTHING = 2,
	NlaStrip_extrapolation_HOLD = 0,
	NlaStrip_extrapolation_HOLD_FORWARD = 1,
};

int NlaStrip_extrapolation_get(PointerRNA *ptr);
void NlaStrip_extrapolation_set(PointerRNA *ptr, int value);

void NlaStrip_fcurves_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void NlaStrip_fcurves_next(CollectionPropertyIterator *iter);
void NlaStrip_fcurves_end(CollectionPropertyIterator *iter);
bool NlaStrip_fcurves_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

float NlaStrip_influence_get(PointerRNA *ptr);
void NlaStrip_influence_set(PointerRNA *ptr, float value);

#define NlaStrip_last_slot_identifier_MAX 66

void NlaStrip_last_slot_identifier_get(PointerRNA *ptr, char *value);
int NlaStrip_last_slot_identifier_length(PointerRNA *ptr);
void NlaStrip_last_slot_identifier_set(PointerRNA *ptr, const char *value);

void NlaStrip_modifiers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void NlaStrip_modifiers_next(CollectionPropertyIterator *iter);
void NlaStrip_modifiers_end(CollectionPropertyIterator *iter);
bool NlaStrip_modifiers_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool NlaStrip_modifiers_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool NlaStrip_mute_get(PointerRNA *ptr);
void NlaStrip_mute_set(PointerRNA *ptr, bool value);

void NlaStrip_strips_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void NlaStrip_strips_next(CollectionPropertyIterator *iter);
void NlaStrip_strips_end(CollectionPropertyIterator *iter);
bool NlaStrip_strips_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool NlaStrip_strips_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

float NlaStrip_repeat_get(PointerRNA *ptr);
void NlaStrip_repeat_set(PointerRNA *ptr, float value);

bool NlaStrip_use_reverse_get(PointerRNA *ptr);
void NlaStrip_use_reverse_set(PointerRNA *ptr, bool value);

float NlaStrip_scale_get(PointerRNA *ptr);
void NlaStrip_scale_set(PointerRNA *ptr, float value);

bool NlaStrip_select_get(PointerRNA *ptr);
void NlaStrip_select_set(PointerRNA *ptr, bool value);

float NlaStrip_frame_start_get(PointerRNA *ptr);
void NlaStrip_frame_start_set(PointerRNA *ptr, float value);

float NlaStrip_frame_start_ui_get(PointerRNA *ptr);
void NlaStrip_frame_start_ui_set(PointerRNA *ptr, float value);

float NlaStrip_frame_start_raw_get(PointerRNA *ptr);
void NlaStrip_frame_start_raw_set(PointerRNA *ptr, float value);

float NlaStrip_strip_time_get(PointerRNA *ptr);
void NlaStrip_strip_time_set(PointerRNA *ptr, float value);

bool NlaStrip_use_sync_length_get(PointerRNA *ptr);
void NlaStrip_use_sync_length_set(PointerRNA *ptr, bool value);

enum {
	NlaStrip_type_CLIP = 0,
	NlaStrip_type_TRANSITION = 1,
	NlaStrip_type_META = 2,
	NlaStrip_type_SOUND = 3,
};

int NlaStrip_type_get(PointerRNA *ptr);
void NlaStrip_type_set(PointerRNA *ptr, int value);

/**************** NLA-Strip F-Curves ****************/

extern StructRNA RNA_NlaStripFCurves;

PointerRNA NlaStripFCurves_rna_type_get(PointerRNA *ptr);

struct FCurve *NlaStripFCurves_find_func(struct NlaStrip *_self, ReportList *reports, const char * data_path, int index);
/**************** NLA Strips ****************/

extern StructRNA RNA_NlaStrips;

PointerRNA NlaStrips_rna_type_get(PointerRNA *ptr);

struct NlaStrip *NlaStrips_new_func(struct ID *_selfid, struct NlaTrack *_self, Main *bmain, bContext *C, ReportList *reports, const char * name, int start, struct bAction *action);
void NlaStrips_remove_func(struct ID *_selfid, struct NlaTrack *_self, Main *bmain, bContext *C, ReportList *reports, struct PointerRNA *strip);
/**************** NLA Track ****************/

extern StructRNA RNA_NlaTrack;

PointerRNA NlaTrack_rna_type_get(PointerRNA *ptr);

#define NlaTrack_name_MAX 64

void NlaTrack_name_get(PointerRNA *ptr, char *value);
int NlaTrack_name_length(PointerRNA *ptr);
void NlaTrack_name_set(PointerRNA *ptr, const char *value);

bool NlaTrack_active_get(PointerRNA *ptr);
void NlaTrack_active_set(PointerRNA *ptr, bool value);

bool NlaTrack_lock_get(PointerRNA *ptr);
void NlaTrack_lock_set(PointerRNA *ptr, bool value);

bool NlaTrack_mute_get(PointerRNA *ptr);
void NlaTrack_mute_set(PointerRNA *ptr, bool value);

void NlaTrack_strips_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void NlaTrack_strips_next(CollectionPropertyIterator *iter);
void NlaTrack_strips_end(CollectionPropertyIterator *iter);
bool NlaTrack_strips_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool NlaTrack_strips_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool NlaTrack_is_override_data_get(PointerRNA *ptr);
void NlaTrack_is_override_data_set(PointerRNA *ptr, bool value);

bool NlaTrack_select_get(PointerRNA *ptr);
void NlaTrack_select_set(PointerRNA *ptr, bool value);

bool NlaTrack_is_solo_get(PointerRNA *ptr);
void NlaTrack_is_solo_set(PointerRNA *ptr, bool value);

/**************** NLA Tracks ****************/

extern StructRNA RNA_NlaTracks;

PointerRNA NlaTracks_rna_type_get(PointerRNA *ptr);

PointerRNA NlaTracks_active_get(PointerRNA *ptr);

struct NlaTrack *NlaTracks_new_func(struct ID *_selfid, struct AnimData *_self, Main *bmain, bContext *C, struct NlaTrack *prev);
void NlaTracks_remove_func(struct ID *_selfid, struct AnimData *_self, Main *bmain, bContext *C, ReportList *reports, struct PointerRNA *track);
/**************** Node ****************/

extern StructRNA RNA_Node;

PointerRNA Node_rna_type_get(PointerRNA *ptr);

#define Node_name_MAX 64

void Node_name_get(PointerRNA *ptr, char *value);
int Node_name_length(PointerRNA *ptr);
void Node_name_set(PointerRNA *ptr, const char *value);

void Node_location_absolute_get(PointerRNA *ptr, float values[2]);
void Node_location_absolute_set(PointerRNA *ptr, const float values[2]);

void Node_color_get(PointerRNA *ptr, float values[3]);
void Node_color_set(PointerRNA *ptr, const float values[3]);

enum {
	Node_color_tag_NONE = 0,
	Node_color_tag_ATTRIBUTE = 1,
	Node_color_tag_COLOR = 2,
	Node_color_tag_CONVERTER = 3,
	Node_color_tag_DISTORT = 4,
	Node_color_tag_FILTER = 5,
	Node_color_tag_GEOMETRY = 6,
	Node_color_tag_INPUT = 7,
	Node_color_tag_MATTE = 8,
	Node_color_tag_OUTPUT = 9,
	Node_color_tag_SCRIPT = 10,
	Node_color_tag_SHADER = 11,
	Node_color_tag_TEXTURE = 12,
	Node_color_tag_VECTOR = 13,
	Node_color_tag_PATTERN = 14,
	Node_color_tag_INTERFACE = 15,
	Node_color_tag_GROUP = 16,
};

int Node_color_tag_get(PointerRNA *ptr);
void Node_color_tag_set(PointerRNA *ptr, int value);

bool Node_use_custom_color_get(PointerRNA *ptr);
void Node_use_custom_color_set(PointerRNA *ptr, bool value);

void Node_dimensions_get(PointerRNA *ptr, float values[2]);
void Node_dimensions_set(PointerRNA *ptr, const float values[2]);

float Node_height_get(PointerRNA *ptr);
void Node_height_set(PointerRNA *ptr, float value);

bool Node_hide_get(PointerRNA *ptr);
void Node_hide_set(PointerRNA *ptr, bool value);

void Node_bl_idname_get(PointerRNA *ptr, char *value);
int Node_bl_idname_length(PointerRNA *ptr);
void Node_bl_idname_set(PointerRNA *ptr, const char *value);

enum {
	Node_bl_icon_NONE = 0,
	Node_bl_icon_CHAR_NOTDEF = 1,
	Node_bl_icon_CHAR_REPLACEMENT = 2,
	Node_bl_icon_NOT_FOUND = 3,
	Node_bl_icon_BLANK1 = 4,
	Node_bl_icon_AUTOMERGE_OFF = 5,
	Node_bl_icon_AUTOMERGE_ON = 6,
	Node_bl_icon_CHECKBOX_DEHLT = 7,
	Node_bl_icon_CHECKBOX_HLT = 8,
	Node_bl_icon_CLIPUV_DEHLT = 9,
	Node_bl_icon_CLIPUV_HLT = 10,
	Node_bl_icon_DECORATE_UNLOCKED = 11,
	Node_bl_icon_DECORATE_LOCKED = 12,
	Node_bl_icon_FAKE_USER_OFF = 13,
	Node_bl_icon_FAKE_USER_ON = 14,
	Node_bl_icon_HIDE_ON = 15,
	Node_bl_icon_HIDE_OFF = 16,
	Node_bl_icon_INDIRECT_ONLY_OFF = 17,
	Node_bl_icon_INDIRECT_ONLY_ON = 18,
	Node_bl_icon_ONIONSKIN_OFF = 19,
	Node_bl_icon_ONIONSKIN_ON = 20,
	Node_bl_icon_UNPINNED = 21,
	Node_bl_icon_PINNED = 22,
	Node_bl_icon_RADIOBUT_OFF = 23,
	Node_bl_icon_RADIOBUT_ON = 24,
	Node_bl_icon_RECORD_OFF = 25,
	Node_bl_icon_RECORD_ON = 26,
	Node_bl_icon_RESTRICT_RENDER_ON = 27,
	Node_bl_icon_RESTRICT_RENDER_OFF = 28,
	Node_bl_icon_RESTRICT_SELECT_ON = 29,
	Node_bl_icon_RESTRICT_SELECT_OFF = 30,
	Node_bl_icon_RESTRICT_VIEW_ON = 31,
	Node_bl_icon_RESTRICT_VIEW_OFF = 32,
	Node_bl_icon_RIGHTARROW = 33,
	Node_bl_icon_DOWNARROW_HLT = 34,
	Node_bl_icon_SELECT_INTERSECT = 35,
	Node_bl_icon_SELECT_DIFFERENCE = 36,
	Node_bl_icon_SNAP_OFF = 37,
	Node_bl_icon_SNAP_ON = 38,
	Node_bl_icon_UNLOCKED = 39,
	Node_bl_icon_LOCKED = 40,
	Node_bl_icon_VIS_SEL_11 = 41,
	Node_bl_icon_VIS_SEL_10 = 42,
	Node_bl_icon_VIS_SEL_01 = 43,
	Node_bl_icon_VIS_SEL_00 = 44,
	Node_bl_icon_CANCEL = 45,
	Node_bl_icon_ERROR = 46,
	Node_bl_icon_QUESTION = 47,
	Node_bl_icon_ADD = 48,
	Node_bl_icon_ARROW_LEFTRIGHT = 49,
	Node_bl_icon_AUTO = 50,
	Node_bl_icon_BLENDER = 51,
	Node_bl_icon_BORDERMOVE = 52,
	Node_bl_icon_BRUSHES_ALL = 53,
	Node_bl_icon_CHECKMARK = 54,
	Node_bl_icon_COLLAPSEMENU = 55,
	Node_bl_icon_COLLECTION_NEW = 56,
	Node_bl_icon_COLOR = 57,
	Node_bl_icon_COPY_ID = 58,
	Node_bl_icon_DISCLOSURE_TRI_DOWN = 59,
	Node_bl_icon_DISCLOSURE_TRI_RIGHT = 60,
	Node_bl_icon_DOT = 61,
	Node_bl_icon_DRIVER_DISTANCE = 62,
	Node_bl_icon_DRIVER_ROTATIONAL_DIFFERENCE = 63,
	Node_bl_icon_DRIVER_TRANSFORM = 64,
	Node_bl_icon_DUPLICATE = 65,
	Node_bl_icon_EYEDROPPER = 66,
	Node_bl_icon_FCURVE_SNAPSHOT = 67,
	Node_bl_icon_FILE_NEW = 68,
	Node_bl_icon_FILE_TICK = 69,
	Node_bl_icon_FREEZE = 70,
	Node_bl_icon_FULLSCREEN_ENTER = 71,
	Node_bl_icon_FULLSCREEN_EXIT = 72,
	Node_bl_icon_GHOST_DISABLED = 73,
	Node_bl_icon_GHOST_ENABLED = 74,
	Node_bl_icon_GRIP = 75,
	Node_bl_icon_GRIP_V = 76,
	Node_bl_icon_HAND = 77,
	Node_bl_icon_HELP = 78,
	Node_bl_icon_LINKED = 79,
	Node_bl_icon_MENU_PANEL = 80,
	Node_bl_icon_NODE_SEL = 81,
	Node_bl_icon_NODE = 82,
	Node_bl_icon_OBJECT_HIDDEN = 83,
	Node_bl_icon_OPTIONS = 84,
	Node_bl_icon_PANEL_CLOSE = 85,
	Node_bl_icon_PLUGIN = 86,
	Node_bl_icon_PLUS = 87,
	Node_bl_icon_PRESET_NEW = 88,
	Node_bl_icon_QUIT = 89,
	Node_bl_icon_RECOVER_LAST = 90,
	Node_bl_icon_REMOVE = 91,
	Node_bl_icon_RIGHTARROW_THIN = 92,
	Node_bl_icon_SCREEN_BACK = 93,
	Node_bl_icon_STATUSBAR = 94,
	Node_bl_icon_STYLUS_PRESSURE = 95,
	Node_bl_icon_THREE_DOTS = 96,
	Node_bl_icon_TOPBAR = 97,
	Node_bl_icon_TRASH = 98,
	Node_bl_icon_TRIA_DOWN = 99,
	Node_bl_icon_TRIA_LEFT = 100,
	Node_bl_icon_TRIA_RIGHT = 101,
	Node_bl_icon_TRIA_UP = 102,
	Node_bl_icon_UNLINKED = 103,
	Node_bl_icon_URL = 104,
	Node_bl_icon_VIEWZOOM = 105,
	Node_bl_icon_WINDOW = 106,
	Node_bl_icon_WORKSPACE = 107,
	Node_bl_icon_X = 108,
	Node_bl_icon_ZOOM_ALL = 109,
	Node_bl_icon_ZOOM_IN = 110,
	Node_bl_icon_ZOOM_OUT = 111,
	Node_bl_icon_ZOOM_PREVIOUS = 112,
	Node_bl_icon_ZOOM_SELECTED = 113,
	Node_bl_icon_MODIFIER = 114,
	Node_bl_icon_PARTICLES = 115,
	Node_bl_icon_PHYSICS = 116,
	Node_bl_icon_SHADERFX = 117,
	Node_bl_icon_SPEAKER = 118,
	Node_bl_icon_OUTPUT = 119,
	Node_bl_icon_SCENE = 120,
	Node_bl_icon_TOOL_SETTINGS = 121,
	Node_bl_icon_LIGHT = 122,
	Node_bl_icon_MATERIAL = 123,
	Node_bl_icon_TEXTURE = 124,
	Node_bl_icon_WORLD = 125,
	Node_bl_icon_ANIM = 126,
	Node_bl_icon_SCRIPT = 127,
	Node_bl_icon_GEOMETRY_NODES = 128,
	Node_bl_icon_TEXT = 129,
	Node_bl_icon_ACTION = 130,
	Node_bl_icon_ASSET_MANAGER = 131,
	Node_bl_icon_CONSOLE = 132,
	Node_bl_icon_FILEBROWSER = 133,
	Node_bl_icon_GEOMETRY_SET = 134,
	Node_bl_icon_GRAPH = 135,
	Node_bl_icon_IMAGE = 136,
	Node_bl_icon_INFO = 137,
	Node_bl_icon_NLA = 138,
	Node_bl_icon_NODE_COMPOSITING = 139,
	Node_bl_icon_NODE_MATERIAL = 140,
	Node_bl_icon_NODE_TEXTURE = 141,
	Node_bl_icon_NODETREE = 142,
	Node_bl_icon_OUTLINER = 143,
	Node_bl_icon_PREFERENCES = 144,
	Node_bl_icon_PROPERTIES = 145,
	Node_bl_icon_SEQUENCE = 146,
	Node_bl_icon_SOUND = 147,
	Node_bl_icon_SPREADSHEET = 148,
	Node_bl_icon_TIME = 149,
	Node_bl_icon_TRACKER = 150,
	Node_bl_icon_UV = 151,
	Node_bl_icon_VIEW3D = 152,
	Node_bl_icon_EDITMODE_HLT = 153,
	Node_bl_icon_OBJECT_DATAMODE = 154,
	Node_bl_icon_PARTICLEMODE = 155,
	Node_bl_icon_POSE_HLT = 156,
	Node_bl_icon_SCULPTMODE_HLT = 157,
	Node_bl_icon_TPAINT_HLT = 158,
	Node_bl_icon_UV_DATA = 159,
	Node_bl_icon_VPAINT_HLT = 160,
	Node_bl_icon_WPAINT_HLT = 161,
	Node_bl_icon_TRACKER_DATA = 162,
	Node_bl_icon_TRACKING_BACKWARDS_SINGLE = 163,
	Node_bl_icon_TRACKING_BACKWARDS = 164,
	Node_bl_icon_TRACKING_CLEAR_BACKWARDS = 165,
	Node_bl_icon_TRACKING_CLEAR_FORWARDS = 166,
	Node_bl_icon_TRACKING_FORWARDS_SINGLE = 167,
	Node_bl_icon_TRACKING_FORWARDS = 168,
	Node_bl_icon_TRACKING_REFINE_BACKWARDS = 169,
	Node_bl_icon_TRACKING_REFINE_FORWARDS = 170,
	Node_bl_icon_TRACKING = 171,
	Node_bl_icon_GROUP = 172,
	Node_bl_icon_CONSTRAINT_BONE = 173,
	Node_bl_icon_CONSTRAINT = 174,
	Node_bl_icon_ARMATURE_DATA = 175,
	Node_bl_icon_BONE_DATA = 176,
	Node_bl_icon_CAMERA_DATA = 177,
	Node_bl_icon_CURVE_DATA = 178,
	Node_bl_icon_EMPTY_DATA = 179,
	Node_bl_icon_FONT_DATA = 180,
	Node_bl_icon_LATTICE_DATA = 181,
	Node_bl_icon_LIGHT_DATA = 182,
	Node_bl_icon_MESH_DATA = 183,
	Node_bl_icon_META_DATA = 184,
	Node_bl_icon_PARTICLE_DATA = 185,
	Node_bl_icon_SHAPEKEY_DATA = 186,
	Node_bl_icon_SURFACE_DATA = 187,
	Node_bl_icon_OBJECT_DATA = 188,
	Node_bl_icon_RENDER_RESULT = 189,
	Node_bl_icon_RENDERLAYERS = 190,
	Node_bl_icon_SCENE_DATA = 191,
	Node_bl_icon_BRUSH_DATA = 192,
	Node_bl_icon_IMAGE_DATA = 193,
	Node_bl_icon_LINE_DATA = 194,
	Node_bl_icon_MATERIAL_DATA = 195,
	Node_bl_icon_TEXTURE_DATA = 196,
	Node_bl_icon_WORLD_DATA = 197,
	Node_bl_icon_ANIM_DATA = 198,
	Node_bl_icon_BOIDS = 199,
	Node_bl_icon_CAMERA_STEREO = 200,
	Node_bl_icon_COMMUNITY = 201,
	Node_bl_icon_FACE_MAPS = 202,
	Node_bl_icon_FCURVE = 203,
	Node_bl_icon_FILE = 204,
	Node_bl_icon_GREASEPENCIL = 205,
	Node_bl_icon_GREASEPENCIL_LAYER_GROUP = 206,
	Node_bl_icon_GROUP_BONE = 207,
	Node_bl_icon_GROUP_UVS = 208,
	Node_bl_icon_GROUP_VCOL = 209,
	Node_bl_icon_GROUP_VERTEX = 210,
	Node_bl_icon_LIBRARY_DATA_BROKEN = 211,
	Node_bl_icon_LIBRARY_DATA_DIRECT = 212,
	Node_bl_icon_LIBRARY_DATA_OVERRIDE = 213,
	Node_bl_icon_ORPHAN_DATA = 214,
	Node_bl_icon_PACKAGE = 215,
	Node_bl_icon_PRESET = 216,
	Node_bl_icon_RENDER_ANIMATION = 217,
	Node_bl_icon_RENDER_STILL = 218,
	Node_bl_icon_RNA_ADD = 219,
	Node_bl_icon_RNA = 220,
	Node_bl_icon_STRANDS = 221,
	Node_bl_icon_UGLYPACKAGE = 222,
	Node_bl_icon_MOUSE_LMB = 223,
	Node_bl_icon_MOUSE_MMB = 224,
	Node_bl_icon_MOUSE_RMB = 225,
	Node_bl_icon_MOUSE_MMB_SCROLL = 226,
	Node_bl_icon_MOUSE_LMB_2X = 227,
	Node_bl_icon_MOUSE_MOVE = 228,
	Node_bl_icon_MOUSE_LMB_DRAG = 229,
	Node_bl_icon_MOUSE_MMB_DRAG = 230,
	Node_bl_icon_MOUSE_RMB_DRAG = 231,
	Node_bl_icon_DECORATE_ANIMATE = 232,
	Node_bl_icon_DECORATE_DRIVER = 233,
	Node_bl_icon_DECORATE_KEYFRAME = 234,
	Node_bl_icon_DECORATE_LIBRARY_OVERRIDE = 235,
	Node_bl_icon_DECORATE_LINKED = 236,
	Node_bl_icon_DECORATE_OVERRIDE = 237,
	Node_bl_icon_DECORATE = 238,
	Node_bl_icon_OUTLINER_COLLECTION = 239,
	Node_bl_icon_CURVES_DATA = 240,
	Node_bl_icon_OUTLINER_DATA_ARMATURE = 241,
	Node_bl_icon_OUTLINER_DATA_CAMERA = 242,
	Node_bl_icon_OUTLINER_DATA_CURVE = 243,
	Node_bl_icon_OUTLINER_DATA_CURVES = 244,
	Node_bl_icon_OUTLINER_DATA_EMPTY = 245,
	Node_bl_icon_OUTLINER_DATA_FONT = 246,
	Node_bl_icon_OUTLINER_DATA_GP_LAYER = 247,
	Node_bl_icon_OUTLINER_DATA_GREASEPENCIL = 248,
	Node_bl_icon_OUTLINER_DATA_LATTICE = 249,
	Node_bl_icon_OUTLINER_DATA_LIGHT = 250,
	Node_bl_icon_OUTLINER_DATA_LIGHTPROBE = 251,
	Node_bl_icon_OUTLINER_DATA_MESH = 252,
	Node_bl_icon_OUTLINER_DATA_META = 253,
	Node_bl_icon_OUTLINER_DATA_POINTCLOUD = 254,
	Node_bl_icon_OUTLINER_DATA_SPEAKER = 255,
	Node_bl_icon_OUTLINER_DATA_SURFACE = 256,
	Node_bl_icon_OUTLINER_DATA_VOLUME = 257,
	Node_bl_icon_POINTCLOUD_DATA = 258,
	Node_bl_icon_POINTCLOUD_POINT = 259,
	Node_bl_icon_VOLUME_DATA = 260,
	Node_bl_icon_OUTLINER_OB_ARMATURE = 261,
	Node_bl_icon_OUTLINER_OB_CAMERA = 262,
	Node_bl_icon_OUTLINER_OB_CURVE = 263,
	Node_bl_icon_OUTLINER_OB_CURVES = 264,
	Node_bl_icon_OUTLINER_OB_EMPTY = 265,
	Node_bl_icon_OUTLINER_OB_FONT = 266,
	Node_bl_icon_OUTLINER_OB_FORCE_FIELD = 267,
	Node_bl_icon_OUTLINER_OB_GREASEPENCIL = 268,
	Node_bl_icon_OUTLINER_OB_GROUP_INSTANCE = 269,
	Node_bl_icon_OUTLINER_OB_IMAGE = 270,
	Node_bl_icon_OUTLINER_OB_LATTICE = 271,
	Node_bl_icon_OUTLINER_OB_LIGHT = 272,
	Node_bl_icon_OUTLINER_OB_LIGHTPROBE = 273,
	Node_bl_icon_OUTLINER_OB_MESH = 274,
	Node_bl_icon_OUTLINER_OB_META = 275,
	Node_bl_icon_OUTLINER_OB_POINTCLOUD = 276,
	Node_bl_icon_OUTLINER_OB_SPEAKER = 277,
	Node_bl_icon_OUTLINER_OB_SURFACE = 278,
	Node_bl_icon_OUTLINER_OB_VOLUME = 279,
	Node_bl_icon_GP_MULTIFRAME_EDITING = 280,
	Node_bl_icon_GP_ONLY_SELECTED = 281,
	Node_bl_icon_GP_SELECT_BETWEEN_STROKES = 282,
	Node_bl_icon_GP_SELECT_POINTS = 283,
	Node_bl_icon_GP_SELECT_STROKES = 284,
	Node_bl_icon_HOLDOUT_OFF = 285,
	Node_bl_icon_HOLDOUT_ON = 286,
	Node_bl_icon_MODIFIER_OFF = 287,
	Node_bl_icon_MODIFIER_ON = 288,
	Node_bl_icon_RESTRICT_COLOR_OFF = 289,
	Node_bl_icon_RESTRICT_COLOR_ON = 290,
	Node_bl_icon_RESTRICT_INSTANCED_OFF = 291,
	Node_bl_icon_RESTRICT_INSTANCED_ON = 292,
	Node_bl_icon_LIGHT_AREA = 293,
	Node_bl_icon_LIGHT_HEMI = 294,
	Node_bl_icon_LIGHT_POINT = 295,
	Node_bl_icon_LIGHT_SPOT = 296,
	Node_bl_icon_LIGHT_SUN = 297,
	Node_bl_icon_LIGHTPROBE_PLANE = 298,
	Node_bl_icon_LIGHTPROBE_SPHERE = 299,
	Node_bl_icon_LIGHTPROBE_VOLUME = 300,
	Node_bl_icon_COLOR_BLUE = 301,
	Node_bl_icon_COLOR_GREEN = 302,
	Node_bl_icon_COLOR_RED = 303,
	Node_bl_icon_CONE = 304,
	Node_bl_icon_CUBE = 305,
	Node_bl_icon_CURVE_BEZCIRCLE = 306,
	Node_bl_icon_CURVE_BEZCURVE = 307,
	Node_bl_icon_CURVE_NCIRCLE = 308,
	Node_bl_icon_CURVE_NCURVE = 309,
	Node_bl_icon_CURVE_PATH = 310,
	Node_bl_icon_CURVES = 311,
	Node_bl_icon_EMPTY_ARROWS = 312,
	Node_bl_icon_EMPTY_AXIS = 313,
	Node_bl_icon_EMPTY_SINGLE_ARROW = 314,
	Node_bl_icon_MESH_CAPSULE = 315,
	Node_bl_icon_MESH_CIRCLE = 316,
	Node_bl_icon_MESH_CONE = 317,
	Node_bl_icon_MESH_CUBE = 318,
	Node_bl_icon_MESH_CYLINDER = 319,
	Node_bl_icon_MESH_GRID = 320,
	Node_bl_icon_MESH_ICOSPHERE = 321,
	Node_bl_icon_MESH_MONKEY = 322,
	Node_bl_icon_MESH_PLANE = 323,
	Node_bl_icon_MESH_TORUS = 324,
	Node_bl_icon_MESH_UVSPHERE = 325,
	Node_bl_icon_META_BALL = 326,
	Node_bl_icon_META_CAPSULE = 327,
	Node_bl_icon_META_CUBE = 328,
	Node_bl_icon_META_ELLIPSOID = 329,
	Node_bl_icon_META_PLANE = 330,
	Node_bl_icon_MONKEY = 331,
	Node_bl_icon_SPHERE = 332,
	Node_bl_icon_STROKE = 333,
	Node_bl_icon_SURFACE_NCIRCLE = 334,
	Node_bl_icon_SURFACE_NCURVE = 335,
	Node_bl_icon_SURFACE_NCYLINDER = 336,
	Node_bl_icon_SURFACE_NSPHERE = 337,
	Node_bl_icon_SURFACE_NSURFACE = 338,
	Node_bl_icon_SURFACE_NTORUS = 339,
	Node_bl_icon_TRIA_DOWN_BAR = 340,
	Node_bl_icon_TRIA_LEFT_BAR = 341,
	Node_bl_icon_TRIA_RIGHT_BAR = 342,
	Node_bl_icon_TRIA_UP_BAR = 343,
	Node_bl_icon_AREA_DOCK = 344,
	Node_bl_icon_AREA_JOIN_DOWN = 345,
	Node_bl_icon_AREA_JOIN_LEFT = 346,
	Node_bl_icon_AREA_JOIN_UP = 347,
	Node_bl_icon_AREA_JOIN = 348,
	Node_bl_icon_AREA_SWAP = 349,
	Node_bl_icon_FORCE_BOID = 350,
	Node_bl_icon_FORCE_CHARGE = 351,
	Node_bl_icon_FORCE_CURVE = 352,
	Node_bl_icon_FORCE_DRAG = 353,
	Node_bl_icon_FORCE_FLUIDFLOW = 354,
	Node_bl_icon_FORCE_FORCE = 355,
	Node_bl_icon_FORCE_HARMONIC = 356,
	Node_bl_icon_FORCE_LENNARDJONES = 357,
	Node_bl_icon_FORCE_MAGNETIC = 358,
	Node_bl_icon_FORCE_TEXTURE = 359,
	Node_bl_icon_FORCE_TURBULENCE = 360,
	Node_bl_icon_FORCE_VORTEX = 361,
	Node_bl_icon_FORCE_WIND = 362,
	Node_bl_icon_IMAGE_BACKGROUND = 363,
	Node_bl_icon_IMAGE_PLANE = 364,
	Node_bl_icon_IMAGE_REFERENCE = 365,
	Node_bl_icon_RIGID_BODY_CONSTRAINT = 366,
	Node_bl_icon_RIGID_BODY = 367,
	Node_bl_icon_SPLIT_HORIZONTAL = 368,
	Node_bl_icon_SPLIT_VERTICAL = 369,
	Node_bl_icon_ANCHOR_BOTTOM = 370,
	Node_bl_icon_ANCHOR_CENTER = 371,
	Node_bl_icon_ANCHOR_LEFT = 372,
	Node_bl_icon_ANCHOR_RIGHT = 373,
	Node_bl_icon_ANCHOR_TOP = 374,
	Node_bl_icon_NODE_CORNER = 375,
	Node_bl_icon_NODE_INSERT_OFF = 376,
	Node_bl_icon_NODE_INSERT_ON = 377,
	Node_bl_icon_NODE_SIDE = 378,
	Node_bl_icon_NODE_TOP = 379,
	Node_bl_icon_SELECT_EXTEND = 380,
	Node_bl_icon_SELECT_SET = 381,
	Node_bl_icon_SELECT_SUBTRACT = 382,
	Node_bl_icon_ALIGN_BOTTOM = 383,
	Node_bl_icon_ALIGN_CENTER = 384,
	Node_bl_icon_ALIGN_FLUSH = 385,
	Node_bl_icon_ALIGN_JUSTIFY = 386,
	Node_bl_icon_ALIGN_LEFT = 387,
	Node_bl_icon_ALIGN_MIDDLE = 388,
	Node_bl_icon_ALIGN_RIGHT = 389,
	Node_bl_icon_ALIGN_TOP = 390,
	Node_bl_icon_BOLD = 391,
	Node_bl_icon_ITALIC = 392,
	Node_bl_icon_LINENUMBERS_OFF = 393,
	Node_bl_icon_LINENUMBERS_ON = 394,
	Node_bl_icon_SCRIPTPLUGINS = 395,
	Node_bl_icon_SMALL_CAPS = 396,
	Node_bl_icon_SYNTAX_OFF = 397,
	Node_bl_icon_SYNTAX_ON = 398,
	Node_bl_icon_UNDERLINE = 399,
	Node_bl_icon_WORDWRAP_OFF = 400,
	Node_bl_icon_WORDWRAP_ON = 401,
	Node_bl_icon_CON_ACTION = 402,
	Node_bl_icon_CON_ARMATURE = 403,
	Node_bl_icon_CON_CAMERASOLVER = 404,
	Node_bl_icon_CON_CHILDOF = 405,
	Node_bl_icon_CON_CLAMPTO = 406,
	Node_bl_icon_CON_DISTLIMIT = 407,
	Node_bl_icon_CON_FLOOR = 408,
	Node_bl_icon_CON_FOLLOWPATH = 409,
	Node_bl_icon_CON_FOLLOWTRACK = 410,
	Node_bl_icon_CON_KINEMATIC = 411,
	Node_bl_icon_CON_LOCKTRACK = 412,
	Node_bl_icon_CON_LOCLIKE = 413,
	Node_bl_icon_CON_LOCLIMIT = 414,
	Node_bl_icon_CON_OBJECTSOLVER = 415,
	Node_bl_icon_CON_PIVOT = 416,
	Node_bl_icon_CON_ROTLIKE = 417,
	Node_bl_icon_CON_ROTLIMIT = 418,
	Node_bl_icon_CON_SAMEVOL = 419,
	Node_bl_icon_CON_SHRINKWRAP = 420,
	Node_bl_icon_CON_SIZELIKE = 421,
	Node_bl_icon_CON_SIZELIMIT = 422,
	Node_bl_icon_CON_SPLINEIK = 423,
	Node_bl_icon_CON_STRETCHTO = 424,
	Node_bl_icon_CON_TRACKTO = 425,
	Node_bl_icon_CON_TRANSFORM_CACHE = 426,
	Node_bl_icon_CON_TRANSFORM = 427,
	Node_bl_icon_CON_TRANSLIKE = 428,
	Node_bl_icon_HOOK = 429,
	Node_bl_icon_MOD_ARMATURE = 430,
	Node_bl_icon_MOD_ARRAY = 431,
	Node_bl_icon_MOD_BEVEL = 432,
	Node_bl_icon_MOD_BOOLEAN = 433,
	Node_bl_icon_MOD_BUILD = 434,
	Node_bl_icon_MOD_CAST = 435,
	Node_bl_icon_MOD_CLOTH = 436,
	Node_bl_icon_MOD_CURVE = 437,
	Node_bl_icon_MOD_DASH = 438,
	Node_bl_icon_MOD_DATA_TRANSFER = 439,
	Node_bl_icon_MOD_DECIM = 440,
	Node_bl_icon_MOD_DISPLACE = 441,
	Node_bl_icon_MOD_DYNAMICPAINT = 442,
	Node_bl_icon_MOD_EDGESPLIT = 443,
	Node_bl_icon_MOD_ENVELOPE = 444,
	Node_bl_icon_MOD_EXPLODE = 445,
	Node_bl_icon_MOD_FLUID = 446,
	Node_bl_icon_MOD_FLUIDSIM = 447,
	Node_bl_icon_MOD_HUE_SATURATION = 448,
	Node_bl_icon_MOD_INSTANCE = 449,
	Node_bl_icon_MOD_LATTICE = 450,
	Node_bl_icon_MOD_LENGTH = 451,
	Node_bl_icon_MOD_LINEART = 452,
	Node_bl_icon_MOD_MASK = 453,
	Node_bl_icon_MOD_MESHDEFORM = 454,
	Node_bl_icon_MOD_MIRROR = 455,
	Node_bl_icon_MOD_MULTIRES = 456,
	Node_bl_icon_MOD_NOISE = 457,
	Node_bl_icon_MOD_NORMALEDIT = 458,
	Node_bl_icon_MOD_OCEAN = 459,
	Node_bl_icon_MOD_OFFSET = 460,
	Node_bl_icon_MOD_OPACITY = 461,
	Node_bl_icon_MOD_OUTLINE = 462,
	Node_bl_icon_MOD_PARTICLE_INSTANCE = 463,
	Node_bl_icon_MOD_PARTICLES = 464,
	Node_bl_icon_MOD_PHYSICS = 465,
	Node_bl_icon_MOD_REMESH = 466,
	Node_bl_icon_MOD_SCREW = 467,
	Node_bl_icon_MOD_SHRINKWRAP = 468,
	Node_bl_icon_MOD_SIMPLEDEFORM = 469,
	Node_bl_icon_MOD_SIMPLIFY = 470,
	Node_bl_icon_MOD_SKIN = 471,
	Node_bl_icon_MOD_SMOOTH = 472,
	Node_bl_icon_MOD_SOFT = 473,
	Node_bl_icon_MOD_SOLIDIFY = 474,
	Node_bl_icon_MOD_SUBSURF = 475,
	Node_bl_icon_MOD_THICKNESS = 476,
	Node_bl_icon_MOD_TIME = 477,
	Node_bl_icon_MOD_TINT = 478,
	Node_bl_icon_MOD_TRIANGULATE = 479,
	Node_bl_icon_MOD_UVPROJECT = 480,
	Node_bl_icon_MOD_VERTEX_WEIGHT = 481,
	Node_bl_icon_MOD_WARP = 482,
	Node_bl_icon_MOD_WAVE = 483,
	Node_bl_icon_MOD_WIREFRAME = 484,
	Node_bl_icon_MODIFIER_DATA = 485,
	Node_bl_icon_ACTION_SLOT = 486,
	Node_bl_icon_ACTION_TWEAK = 487,
	Node_bl_icon_DRIVER = 488,
	Node_bl_icon_FF = 489,
	Node_bl_icon_FRAME_NEXT = 490,
	Node_bl_icon_FRAME_PREV = 491,
	Node_bl_icon_HANDLE_ALIGNED = 492,
	Node_bl_icon_HANDLE_AUTO = 493,
	Node_bl_icon_HANDLE_AUTOCLAMPED = 494,
	Node_bl_icon_HANDLE_FREE = 495,
	Node_bl_icon_HANDLE_VECTOR = 496,
	Node_bl_icon_IPO_BACK = 497,
	Node_bl_icon_IPO_BEZIER = 498,
	Node_bl_icon_IPO_BOUNCE = 499,
	Node_bl_icon_IPO_CIRC = 500,
	Node_bl_icon_IPO_CONSTANT = 501,
	Node_bl_icon_IPO_CUBIC = 502,
	Node_bl_icon_IPO_EASE_IN_OUT = 503,
	Node_bl_icon_IPO_EASE_IN = 504,
	Node_bl_icon_IPO_EASE_OUT = 505,
	Node_bl_icon_IPO_ELASTIC = 506,
	Node_bl_icon_IPO_EXPO = 507,
	Node_bl_icon_IPO_LINEAR = 508,
	Node_bl_icon_IPO_QUAD = 509,
	Node_bl_icon_IPO_QUART = 510,
	Node_bl_icon_IPO_QUINT = 511,
	Node_bl_icon_IPO_SINE = 512,
	Node_bl_icon_KEY_DEHLT = 513,
	Node_bl_icon_KEY_HLT = 514,
	Node_bl_icon_KEYFRAME_HLT = 515,
	Node_bl_icon_KEYFRAME = 516,
	Node_bl_icon_KEYINGSET = 517,
	Node_bl_icon_MARKER_HLT = 518,
	Node_bl_icon_MARKER = 519,
	Node_bl_icon_MUTE_IPO_OFF = 520,
	Node_bl_icon_MUTE_IPO_ON = 521,
	Node_bl_icon_NEXT_KEYFRAME = 522,
	Node_bl_icon_NLA_PUSHDOWN = 523,
	Node_bl_icon_NORMALIZE_FCURVES = 524,
	Node_bl_icon_ORIENTATION_PARENT = 525,
	Node_bl_icon_PAUSE = 526,
	Node_bl_icon_PLAY_REVERSE = 527,
	Node_bl_icon_PLAY_SOUND = 528,
	Node_bl_icon_PLAY = 529,
	Node_bl_icon_PMARKER_ACT = 530,
	Node_bl_icon_PMARKER_SEL = 531,
	Node_bl_icon_PMARKER = 532,
	Node_bl_icon_PREV_KEYFRAME = 533,
	Node_bl_icon_PREVIEW_RANGE = 534,
	Node_bl_icon_REC = 535,
	Node_bl_icon_REW = 536,
	Node_bl_icon_SOLO_OFF = 537,
	Node_bl_icon_SOLO_ON = 538,
	Node_bl_icon_CENTER_ONLY = 539,
	Node_bl_icon_CURSOR = 540,
	Node_bl_icon_EDGESEL = 541,
	Node_bl_icon_FACE_CORNER = 542,
	Node_bl_icon_FACESEL = 543,
	Node_bl_icon_INVERSESQUARECURVE = 544,
	Node_bl_icon_LINCURVE = 545,
	Node_bl_icon_NOCURVE = 546,
	Node_bl_icon_PARTICLE_PATH = 547,
	Node_bl_icon_PARTICLE_POINT = 548,
	Node_bl_icon_PARTICLE_TIP = 549,
	Node_bl_icon_PIVOT_ACTIVE = 550,
	Node_bl_icon_PIVOT_BOUNDBOX = 551,
	Node_bl_icon_PIVOT_CURSOR = 552,
	Node_bl_icon_PIVOT_INDIVIDUAL = 553,
	Node_bl_icon_PIVOT_MEDIAN = 554,
	Node_bl_icon_PROP_CON = 555,
	Node_bl_icon_PROP_OFF = 556,
	Node_bl_icon_PROP_ON = 557,
	Node_bl_icon_PROP_PROJECTED = 558,
	Node_bl_icon_RNDCURVE = 559,
	Node_bl_icon_ROOTCURVE = 560,
	Node_bl_icon_SHARPCURVE = 561,
	Node_bl_icon_SMOOTHCURVE = 562,
	Node_bl_icon_SPHERECURVE = 563,
	Node_bl_icon_VERTEXSEL = 564,
	Node_bl_icon_SNAP_EDGE = 565,
	Node_bl_icon_SNAP_FACE_CENTER = 566,
	Node_bl_icon_SNAP_FACE_NEAREST = 567,
	Node_bl_icon_SNAP_FACE = 568,
	Node_bl_icon_SNAP_GRID = 569,
	Node_bl_icon_SNAP_INCREMENT = 570,
	Node_bl_icon_SNAP_MIDPOINT = 571,
	Node_bl_icon_SNAP_NORMAL = 572,
	Node_bl_icon_SNAP_PEEL_OBJECT = 573,
	Node_bl_icon_SNAP_PERPENDICULAR = 574,
	Node_bl_icon_SNAP_VERTEX = 575,
	Node_bl_icon_SNAP_VOLUME = 576,
	Node_bl_icon_STICKY_UVS_DISABLE = 577,
	Node_bl_icon_STICKY_UVS_LOC = 578,
	Node_bl_icon_STICKY_UVS_VERT = 579,
	Node_bl_icon_ORIENTATION_GIMBAL = 580,
	Node_bl_icon_ORIENTATION_GLOBAL = 581,
	Node_bl_icon_ORIENTATION_LOCAL = 582,
	Node_bl_icon_ORIENTATION_NORMAL = 583,
	Node_bl_icon_ORIENTATION_VIEW = 584,
	Node_bl_icon_COPYDOWN = 585,
	Node_bl_icon_FIXED_SIZE = 586,
	Node_bl_icon_GIZMO = 587,
	Node_bl_icon_GP_CAPS_FLAT = 588,
	Node_bl_icon_GP_CAPS_ROUND = 589,
	Node_bl_icon_NORMALS_FACE = 590,
	Node_bl_icon_NORMALS_VERTEX_FACE = 591,
	Node_bl_icon_NORMALS_VERTEX = 592,
	Node_bl_icon_OBJECT_ORIGIN = 593,
	Node_bl_icon_ORIENTATION_CURSOR = 594,
	Node_bl_icon_PASTEDOWN = 595,
	Node_bl_icon_PASTEFLIPDOWN = 596,
	Node_bl_icon_PASTEFLIPUP = 597,
	Node_bl_icon_TRANSFORM_ORIGINS = 598,
	Node_bl_icon_UV_EDGESEL = 599,
	Node_bl_icon_UV_FACESEL = 600,
	Node_bl_icon_UV_ISLANDSEL = 601,
	Node_bl_icon_UV_SYNC_SELECT = 602,
	Node_bl_icon_UV_VERTEXSEL = 603,
	Node_bl_icon_AXIS_FRONT = 604,
	Node_bl_icon_AXIS_SIDE = 605,
	Node_bl_icon_AXIS_TOP = 606,
	Node_bl_icon_GRID = 607,
	Node_bl_icon_LAYER_ACTIVE = 608,
	Node_bl_icon_LAYER_USED = 609,
	Node_bl_icon_LOCKVIEW_OFF = 610,
	Node_bl_icon_LOCKVIEW_ON = 611,
	Node_bl_icon_OVERLAY = 612,
	Node_bl_icon_SHADING_BBOX = 613,
	Node_bl_icon_SHADING_RENDERED = 614,
	Node_bl_icon_SHADING_SOLID = 615,
	Node_bl_icon_SHADING_TEXTURE = 616,
	Node_bl_icon_SHADING_WIRE = 617,
	Node_bl_icon_XRAY = 618,
	Node_bl_icon_VIEW_CAMERA_UNSELECTED = 619,
	Node_bl_icon_VIEW_CAMERA = 620,
	Node_bl_icon_VIEW_LOCKED = 621,
	Node_bl_icon_VIEW_ORTHO = 622,
	Node_bl_icon_VIEW_PAN = 623,
	Node_bl_icon_VIEW_PERSPECTIVE = 624,
	Node_bl_icon_VIEW_UNLOCKED = 625,
	Node_bl_icon_VIEW_ZOOM = 626,
	Node_bl_icon_FILE_ALIAS = 627,
	Node_bl_icon_FILE_FOLDER = 628,
	Node_bl_icon_FOLDER_REDIRECT = 629,
	Node_bl_icon_APPEND_BLEND = 630,
	Node_bl_icon_BACK = 631,
	Node_bl_icon_BOOKMARKS = 632,
	Node_bl_icon_CURRENT_FILE = 633,
	Node_bl_icon_DESKTOP = 634,
	Node_bl_icon_DISC = 635,
	Node_bl_icon_DISK_DRIVE = 636,
	Node_bl_icon_DOCUMENTS = 637,
	Node_bl_icon_EXPORT = 638,
	Node_bl_icon_EXTERNAL_DRIVE = 639,
	Node_bl_icon_FILE_3D = 640,
	Node_bl_icon_FILE_ARCHIVE = 641,
	Node_bl_icon_FILE_BACKUP = 642,
	Node_bl_icon_FILE_BLANK = 643,
	Node_bl_icon_FILE_BLEND = 644,
	Node_bl_icon_FILE_CACHE = 645,
	Node_bl_icon_FILE_FONT = 646,
	Node_bl_icon_FILE_HIDDEN = 647,
	Node_bl_icon_FILE_IMAGE = 648,
	Node_bl_icon_FILE_MOVIE = 649,
	Node_bl_icon_FILE_PARENT = 650,
	Node_bl_icon_FILE_REFRESH = 651,
	Node_bl_icon_FILE_SCRIPT = 652,
	Node_bl_icon_FILE_SOUND = 653,
	Node_bl_icon_FILE_TEXT = 654,
	Node_bl_icon_FILE_VOLUME = 655,
	Node_bl_icon_FILTER = 656,
	Node_bl_icon_FONTPREVIEW = 657,
	Node_bl_icon_FORWARD = 658,
	Node_bl_icon_HOME = 659,
	Node_bl_icon_IMGDISPLAY = 660,
	Node_bl_icon_IMPORT = 661,
	Node_bl_icon_LINK_BLEND = 662,
	Node_bl_icon_LONGDISPLAY = 663,
	Node_bl_icon_LOOP_BACK = 664,
	Node_bl_icon_LOOP_FORWARDS = 665,
	Node_bl_icon_NETWORK_DRIVE = 666,
	Node_bl_icon_NEWFOLDER = 667,
	Node_bl_icon_PREVIEW_LOADING = 668,
	Node_bl_icon_SETTINGS = 669,
	Node_bl_icon_SHORTDISPLAY = 670,
	Node_bl_icon_SORT_ASC = 671,
	Node_bl_icon_SORT_DESC = 672,
	Node_bl_icon_SORTALPHA = 673,
	Node_bl_icon_SORTBYEXT = 674,
	Node_bl_icon_SORTSIZE = 675,
	Node_bl_icon_SORTTIME = 676,
	Node_bl_icon_SYSTEM = 677,
	Node_bl_icon_TAG = 678,
	Node_bl_icon_TEMP = 679,
	Node_bl_icon_ALIASED = 680,
	Node_bl_icon_ANTIALIASED = 681,
	Node_bl_icon_MAT_SPHERE_SKY = 682,
	Node_bl_icon_MATCLOTH = 683,
	Node_bl_icon_MATCUBE = 684,
	Node_bl_icon_MATFLUID = 685,
	Node_bl_icon_MATPLANE = 686,
	Node_bl_icon_MATSHADERBALL = 687,
	Node_bl_icon_MATSPHERE = 688,
	Node_bl_icon_SEQ_CHROMA_SCOPE = 689,
	Node_bl_icon_SEQ_HISTOGRAM = 690,
	Node_bl_icon_SEQ_LUMA_WAVEFORM = 691,
	Node_bl_icon_SEQ_PREVIEW = 692,
	Node_bl_icon_SEQ_SEQUENCER = 693,
	Node_bl_icon_SEQ_SPLITVIEW = 694,
	Node_bl_icon_SEQ_STRIP_DUPLICATE = 695,
	Node_bl_icon_SEQ_STRIP_META = 696,
	Node_bl_icon_IMAGE_ALPHA = 697,
	Node_bl_icon_IMAGE_RGB_ALPHA = 698,
	Node_bl_icon_IMAGE_RGB = 699,
	Node_bl_icon_IMAGE_ZDEPTH = 700,
	Node_bl_icon_BLENDER_LOGO_LARGE = 701,
	Node_bl_icon_CANCEL_LARGE = 702,
	Node_bl_icon_DISC_LARGE = 703,
	Node_bl_icon_DISK_DRIVE_LARGE = 704,
	Node_bl_icon_EXTERNAL_DRIVE_LARGE = 705,
	Node_bl_icon_FILE_FOLDER_LARGE = 706,
	Node_bl_icon_FILE_LARGE = 707,
	Node_bl_icon_FILE_PARENT_LARGE = 708,
	Node_bl_icon_INFO_LARGE = 709,
	Node_bl_icon_NETWORK_DRIVE_LARGE = 710,
	Node_bl_icon_QUESTION_LARGE = 711,
	Node_bl_icon_WARNING_LARGE = 712,
	Node_bl_icon_KEY_BACKSPACE_FILLED = 713,
	Node_bl_icon_KEY_BACKSPACE = 714,
	Node_bl_icon_KEY_COMMAND_FILLED = 715,
	Node_bl_icon_KEY_COMMAND = 716,
	Node_bl_icon_KEY_CONTROL_FILLED = 717,
	Node_bl_icon_KEY_CONTROL = 718,
	Node_bl_icon_KEY_EMPTY1_FILLED = 719,
	Node_bl_icon_KEY_EMPTY1 = 720,
	Node_bl_icon_KEY_EMPTY2_FILLED = 721,
	Node_bl_icon_KEY_EMPTY2 = 722,
	Node_bl_icon_KEY_EMPTY3_FILLED = 723,
	Node_bl_icon_KEY_EMPTY3 = 724,
	Node_bl_icon_KEY_MENU_FILLED = 725,
	Node_bl_icon_KEY_MENU = 726,
	Node_bl_icon_KEY_OPTION_FILLED = 727,
	Node_bl_icon_KEY_OPTION = 728,
	Node_bl_icon_KEY_RETURN_FILLED = 729,
	Node_bl_icon_KEY_RETURN = 730,
	Node_bl_icon_KEY_RING_FILLED = 731,
	Node_bl_icon_KEY_RING = 732,
	Node_bl_icon_KEY_SHIFT_FILLED = 733,
	Node_bl_icon_KEY_SHIFT = 734,
	Node_bl_icon_KEY_TAB_FILLED = 735,
	Node_bl_icon_KEY_TAB = 736,
	Node_bl_icon_KEY_WINDOWS_FILLED = 737,
	Node_bl_icon_KEY_WINDOWS = 738,
	Node_bl_icon_GESTURE_PAN = 739,
	Node_bl_icon_GESTURE_ROTATE = 740,
	Node_bl_icon_GESTURE_ZOOM = 741,
	Node_bl_icon_FUND = 742,
	Node_bl_icon_HEART = 743,
	Node_bl_icon_INTERNET_OFFLINE = 744,
	Node_bl_icon_INTERNET = 745,
	Node_bl_icon_USER = 746,
	Node_bl_icon_EXPERIMENTAL = 747,
	Node_bl_icon_MEMORY = 748,
	Node_bl_icon_RGB_RED = 750,
	Node_bl_icon_RGB_GREEN = 751,
	Node_bl_icon_RGB_BLUE = 752,
	Node_bl_icon_KEYTYPE_KEYFRAME_VEC = 753,
	Node_bl_icon_KEYTYPE_BREAKDOWN_VEC = 754,
	Node_bl_icon_KEYTYPE_EXTREME_VEC = 755,
	Node_bl_icon_KEYTYPE_JITTER_VEC = 756,
	Node_bl_icon_KEYTYPE_MOVING_HOLD_VEC = 757,
	Node_bl_icon_KEYTYPE_GENERATED_VEC = 758,
	Node_bl_icon_HANDLETYPE_FREE_VEC = 759,
	Node_bl_icon_HANDLETYPE_ALIGNED_VEC = 760,
	Node_bl_icon_HANDLETYPE_VECTOR_VEC = 761,
	Node_bl_icon_HANDLETYPE_AUTO_VEC = 762,
	Node_bl_icon_HANDLETYPE_AUTO_CLAMP_VEC = 763,
	Node_bl_icon_COLORSET_01_VEC = 764,
	Node_bl_icon_COLORSET_02_VEC = 765,
	Node_bl_icon_COLORSET_03_VEC = 766,
	Node_bl_icon_COLORSET_04_VEC = 767,
	Node_bl_icon_COLORSET_05_VEC = 768,
	Node_bl_icon_COLORSET_06_VEC = 769,
	Node_bl_icon_COLORSET_07_VEC = 770,
	Node_bl_icon_COLORSET_08_VEC = 771,
	Node_bl_icon_COLORSET_09_VEC = 772,
	Node_bl_icon_COLORSET_10_VEC = 773,
	Node_bl_icon_COLORSET_11_VEC = 774,
	Node_bl_icon_COLORSET_12_VEC = 775,
	Node_bl_icon_COLORSET_13_VEC = 776,
	Node_bl_icon_COLORSET_14_VEC = 777,
	Node_bl_icon_COLORSET_15_VEC = 778,
	Node_bl_icon_COLORSET_16_VEC = 779,
	Node_bl_icon_COLORSET_17_VEC = 780,
	Node_bl_icon_COLORSET_18_VEC = 781,
	Node_bl_icon_COLORSET_19_VEC = 782,
	Node_bl_icon_COLORSET_20_VEC = 783,
	Node_bl_icon_COLLECTION_COLOR_01 = 784,
	Node_bl_icon_COLLECTION_COLOR_02 = 785,
	Node_bl_icon_COLLECTION_COLOR_03 = 786,
	Node_bl_icon_COLLECTION_COLOR_04 = 787,
	Node_bl_icon_COLLECTION_COLOR_05 = 788,
	Node_bl_icon_COLLECTION_COLOR_06 = 789,
	Node_bl_icon_COLLECTION_COLOR_07 = 790,
	Node_bl_icon_COLLECTION_COLOR_08 = 791,
	Node_bl_icon_STRIP_COLOR_01 = 792,
	Node_bl_icon_STRIP_COLOR_02 = 793,
	Node_bl_icon_STRIP_COLOR_03 = 794,
	Node_bl_icon_STRIP_COLOR_04 = 795,
	Node_bl_icon_STRIP_COLOR_05 = 796,
	Node_bl_icon_STRIP_COLOR_06 = 797,
	Node_bl_icon_STRIP_COLOR_07 = 798,
	Node_bl_icon_STRIP_COLOR_08 = 799,
	Node_bl_icon_STRIP_COLOR_09 = 800,
	Node_bl_icon_LIBRARY_DATA_INDIRECT = 801,
	Node_bl_icon_LIBRARY_DATA_OVERRIDE_NONEDITABLE = 802,
	Node_bl_icon_LAYERGROUP_COLOR_01 = 803,
	Node_bl_icon_LAYERGROUP_COLOR_02 = 804,
	Node_bl_icon_LAYERGROUP_COLOR_03 = 805,
	Node_bl_icon_LAYERGROUP_COLOR_04 = 806,
	Node_bl_icon_LAYERGROUP_COLOR_05 = 807,
	Node_bl_icon_LAYERGROUP_COLOR_06 = 808,
	Node_bl_icon_LAYERGROUP_COLOR_07 = 809,
	Node_bl_icon_LAYERGROUP_COLOR_08 = 810,
	Node_bl_icon_EVENT_A = 811,
	Node_bl_icon_EVENT_B = 812,
	Node_bl_icon_EVENT_C = 813,
	Node_bl_icon_EVENT_D = 814,
	Node_bl_icon_EVENT_E = 815,
	Node_bl_icon_EVENT_F = 816,
	Node_bl_icon_EVENT_G = 817,
	Node_bl_icon_EVENT_H = 818,
	Node_bl_icon_EVENT_I = 819,
	Node_bl_icon_EVENT_J = 820,
	Node_bl_icon_EVENT_K = 821,
	Node_bl_icon_EVENT_L = 822,
	Node_bl_icon_EVENT_M = 823,
	Node_bl_icon_EVENT_N = 824,
	Node_bl_icon_EVENT_O = 825,
	Node_bl_icon_EVENT_P = 826,
	Node_bl_icon_EVENT_Q = 827,
	Node_bl_icon_EVENT_R = 828,
	Node_bl_icon_EVENT_S = 829,
	Node_bl_icon_EVENT_T = 830,
	Node_bl_icon_EVENT_U = 831,
	Node_bl_icon_EVENT_V = 832,
	Node_bl_icon_EVENT_W = 833,
	Node_bl_icon_EVENT_X = 834,
	Node_bl_icon_EVENT_Y = 835,
	Node_bl_icon_EVENT_Z = 836,
	Node_bl_icon_EVENT_SHIFT = 837,
	Node_bl_icon_EVENT_CTRL = 838,
	Node_bl_icon_EVENT_ALT = 839,
	Node_bl_icon_EVENT_OS = 840,
	Node_bl_icon_EVENT_HYPER = 841,
	Node_bl_icon_EVENT_F1 = 842,
	Node_bl_icon_EVENT_F2 = 843,
	Node_bl_icon_EVENT_F3 = 844,
	Node_bl_icon_EVENT_F4 = 845,
	Node_bl_icon_EVENT_F5 = 846,
	Node_bl_icon_EVENT_F6 = 847,
	Node_bl_icon_EVENT_F7 = 848,
	Node_bl_icon_EVENT_F8 = 849,
	Node_bl_icon_EVENT_F9 = 850,
	Node_bl_icon_EVENT_F10 = 851,
	Node_bl_icon_EVENT_F11 = 852,
	Node_bl_icon_EVENT_F12 = 853,
	Node_bl_icon_EVENT_F13 = 854,
	Node_bl_icon_EVENT_F14 = 855,
	Node_bl_icon_EVENT_F15 = 856,
	Node_bl_icon_EVENT_F16 = 857,
	Node_bl_icon_EVENT_F17 = 858,
	Node_bl_icon_EVENT_F18 = 859,
	Node_bl_icon_EVENT_F19 = 860,
	Node_bl_icon_EVENT_F20 = 861,
	Node_bl_icon_EVENT_F21 = 862,
	Node_bl_icon_EVENT_F22 = 863,
	Node_bl_icon_EVENT_F23 = 864,
	Node_bl_icon_EVENT_F24 = 865,
	Node_bl_icon_EVENT_ESC = 866,
	Node_bl_icon_EVENT_TAB = 867,
	Node_bl_icon_EVENT_PAGEUP = 868,
	Node_bl_icon_EVENT_PAGEDOWN = 869,
	Node_bl_icon_EVENT_RETURN = 870,
	Node_bl_icon_EVENT_SPACEKEY = 871,
	Node_bl_icon_EVENT_ZEROKEY = 872,
	Node_bl_icon_EVENT_ONEKEY = 873,
	Node_bl_icon_EVENT_TWOKEY = 874,
	Node_bl_icon_EVENT_THREEKEY = 875,
	Node_bl_icon_EVENT_FOURKEY = 876,
	Node_bl_icon_EVENT_FIVEKEY = 877,
	Node_bl_icon_EVENT_SIXKEY = 878,
	Node_bl_icon_EVENT_SEVENKEY = 879,
	Node_bl_icon_EVENT_EIGHTKEY = 880,
	Node_bl_icon_EVENT_NINEKEY = 881,
	Node_bl_icon_EVENT_PAD0 = 882,
	Node_bl_icon_EVENT_PAD1 = 883,
	Node_bl_icon_EVENT_PAD2 = 884,
	Node_bl_icon_EVENT_PAD3 = 885,
	Node_bl_icon_EVENT_PAD4 = 886,
	Node_bl_icon_EVENT_PAD5 = 887,
	Node_bl_icon_EVENT_PAD6 = 888,
	Node_bl_icon_EVENT_PAD7 = 889,
	Node_bl_icon_EVENT_PAD8 = 890,
	Node_bl_icon_EVENT_PAD9 = 891,
	Node_bl_icon_EVENT_PADASTER = 892,
	Node_bl_icon_EVENT_PADSLASH = 893,
	Node_bl_icon_EVENT_PADMINUS = 894,
	Node_bl_icon_EVENT_PADENTER = 895,
	Node_bl_icon_EVENT_PADPLUS = 896,
	Node_bl_icon_EVENT_PADPERIOD = 897,
	Node_bl_icon_EVENT_MOUSE_4 = 898,
	Node_bl_icon_EVENT_MOUSE_5 = 899,
	Node_bl_icon_EVENT_MOUSE_6 = 900,
	Node_bl_icon_EVENT_MOUSE_7 = 901,
	Node_bl_icon_EVENT_TABLET_STYLUS = 902,
	Node_bl_icon_EVENT_TABLET_ERASER = 903,
	Node_bl_icon_EVENT_LEFT_ARROW = 904,
	Node_bl_icon_EVENT_DOWN_ARROW = 905,
	Node_bl_icon_EVENT_RIGHT_ARROW = 906,
	Node_bl_icon_EVENT_UP_ARROW = 907,
	Node_bl_icon_EVENT_PAUSE = 908,
	Node_bl_icon_EVENT_INSERT = 909,
	Node_bl_icon_EVENT_HOME = 910,
	Node_bl_icon_EVENT_END = 911,
	Node_bl_icon_EVENT_UNKNOWN = 912,
	Node_bl_icon_EVENT_GRLESS = 913,
	Node_bl_icon_EVENT_MEDIAPLAY = 914,
	Node_bl_icon_EVENT_MEDIASTOP = 915,
	Node_bl_icon_EVENT_MEDIAFIRST = 916,
	Node_bl_icon_EVENT_MEDIALAST = 917,
	Node_bl_icon_EVENT_APP = 918,
	Node_bl_icon_EVENT_CAPSLOCK = 919,
	Node_bl_icon_EVENT_BACKSPACE = 920,
	Node_bl_icon_EVENT_DEL = 921,
	Node_bl_icon_EVENT_SEMICOLON = 922,
	Node_bl_icon_EVENT_PERIOD = 923,
	Node_bl_icon_EVENT_COMMA = 924,
	Node_bl_icon_EVENT_QUOTE = 925,
	Node_bl_icon_EVENT_ACCENTGRAVE = 926,
	Node_bl_icon_EVENT_MINUS = 927,
	Node_bl_icon_EVENT_PLUS = 928,
	Node_bl_icon_EVENT_SLASH = 929,
	Node_bl_icon_EVENT_BACKSLASH = 930,
	Node_bl_icon_EVENT_EQUAL = 931,
	Node_bl_icon_EVENT_LEFTBRACKET = 932,
	Node_bl_icon_EVENT_RIGHTBRACKET = 933,
	Node_bl_icon_EVENT_PAD_PAN = 934,
	Node_bl_icon_EVENT_PAD_ROTATE = 935,
	Node_bl_icon_EVENT_PAD_ZOOM = 936,
	Node_bl_icon_EVENT_NDOF_BUTTON_V1 = 937,
	Node_bl_icon_EVENT_NDOF_BUTTON_V2 = 938,
	Node_bl_icon_EVENT_NDOF_BUTTON_V3 = 939,
	Node_bl_icon_EVENT_NDOF_BUTTON_SAVE_V1 = 940,
	Node_bl_icon_EVENT_NDOF_BUTTON_SAVE_V2 = 941,
	Node_bl_icon_EVENT_NDOF_BUTTON_SAVE_V3 = 942,
	Node_bl_icon_EVENT_NDOF_BUTTON_1 = 943,
	Node_bl_icon_EVENT_NDOF_BUTTON_2 = 944,
	Node_bl_icon_EVENT_NDOF_BUTTON_3 = 945,
	Node_bl_icon_EVENT_NDOF_BUTTON_4 = 946,
	Node_bl_icon_EVENT_NDOF_BUTTON_5 = 947,
	Node_bl_icon_EVENT_NDOF_BUTTON_6 = 948,
	Node_bl_icon_EVENT_NDOF_BUTTON_7 = 949,
	Node_bl_icon_EVENT_NDOF_BUTTON_8 = 950,
	Node_bl_icon_EVENT_NDOF_BUTTON_9 = 951,
	Node_bl_icon_EVENT_NDOF_BUTTON_10 = 952,
	Node_bl_icon_EVENT_NDOF_BUTTON_11 = 953,
	Node_bl_icon_EVENT_NDOF_BUTTON_12 = 954,
	Node_bl_icon_EVENT_NDOF_BUTTON_MENU = 955,
	Node_bl_icon_EVENT_NDOF_BUTTON_FIT = 956,
	Node_bl_icon_EVENT_NDOF_BUTTON_TOP = 957,
	Node_bl_icon_EVENT_NDOF_BUTTON_BOTTOM = 958,
	Node_bl_icon_EVENT_NDOF_BUTTON_LEFT = 959,
	Node_bl_icon_EVENT_NDOF_BUTTON_RIGHT = 960,
	Node_bl_icon_EVENT_NDOF_BUTTON_FRONT = 961,
	Node_bl_icon_EVENT_NDOF_BUTTON_BACK = 962,
	Node_bl_icon_EVENT_NDOF_BUTTON_ISO1 = 963,
	Node_bl_icon_EVENT_NDOF_BUTTON_ISO2 = 964,
	Node_bl_icon_EVENT_NDOF_BUTTON_ROLL_CW = 965,
	Node_bl_icon_EVENT_NDOF_BUTTON_ROLL_CCW = 966,
	Node_bl_icon_EVENT_NDOF_BUTTON_SPIN_CW = 967,
	Node_bl_icon_EVENT_NDOF_BUTTON_SPIN_CCW = 968,
	Node_bl_icon_EVENT_NDOF_BUTTON_TILT_CW = 969,
	Node_bl_icon_EVENT_NDOF_BUTTON_TILT_CCW = 970,
	Node_bl_icon_EVENT_NDOF_BUTTON_ROTATE = 971,
	Node_bl_icon_EVENT_NDOF_BUTTON_PANZOOM = 972,
	Node_bl_icon_EVENT_NDOF_BUTTON_DOMINANT = 973,
	Node_bl_icon_EVENT_NDOF_BUTTON_PLUS = 974,
	Node_bl_icon_EVENT_NDOF_BUTTON_MINUS = 975,
	Node_bl_icon_NODE_SOCKET_FLOAT = 976,
	Node_bl_icon_NODE_SOCKET_VECTOR = 977,
	Node_bl_icon_NODE_SOCKET_RGBA = 978,
	Node_bl_icon_NODE_SOCKET_SHADER = 979,
	Node_bl_icon_NODE_SOCKET_BOOLEAN = 980,
	Node_bl_icon_NODE_SOCKET_INT = 981,
	Node_bl_icon_NODE_SOCKET_STRING = 982,
	Node_bl_icon_NODE_SOCKET_OBJECT = 983,
	Node_bl_icon_NODE_SOCKET_IMAGE = 984,
	Node_bl_icon_NODE_SOCKET_GEOMETRY = 985,
	Node_bl_icon_NODE_SOCKET_COLLECTION = 986,
	Node_bl_icon_NODE_SOCKET_TEXTURE = 987,
	Node_bl_icon_NODE_SOCKET_MATERIAL = 988,
	Node_bl_icon_NODE_SOCKET_ROTATION = 989,
	Node_bl_icon_NODE_SOCKET_MENU = 990,
	Node_bl_icon_NODE_SOCKET_MATRIX = 991,
	Node_bl_icon_NODE_SOCKET_BUNDLE = 992,
	Node_bl_icon_NODE_SOCKET_CLOSURE = 993,
};

int Node_bl_icon_get(PointerRNA *ptr);
void Node_bl_icon_set(PointerRNA *ptr, int value);

void Node_inputs_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Node_inputs_next(CollectionPropertyIterator *iter);
void Node_inputs_end(CollectionPropertyIterator *iter);
bool Node_inputs_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Node_inputs_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void Node_internal_links_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Node_internal_links_next(CollectionPropertyIterator *iter);
void Node_internal_links_end(CollectionPropertyIterator *iter);

#define Node_label_MAX 64

void Node_label_get(PointerRNA *ptr, char *value);
int Node_label_length(PointerRNA *ptr);
void Node_label_set(PointerRNA *ptr, const char *value);

void Node_bl_label_get(PointerRNA *ptr, char *value);
int Node_bl_label_length(PointerRNA *ptr);
void Node_bl_label_set(PointerRNA *ptr, const char *value);

void Node_location_get(PointerRNA *ptr, float values[2]);
void Node_location_set(PointerRNA *ptr, const float values[2]);

bool Node_mute_get(PointerRNA *ptr);
void Node_mute_set(PointerRNA *ptr, bool value);

void Node_outputs_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Node_outputs_next(CollectionPropertyIterator *iter);
void Node_outputs_end(CollectionPropertyIterator *iter);
bool Node_outputs_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Node_outputs_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

PointerRNA Node_parent_get(PointerRNA *ptr);

bool Node_select_get(PointerRNA *ptr);
void Node_select_set(PointerRNA *ptr, bool value);

bool Node_show_options_get(PointerRNA *ptr);
void Node_show_options_set(PointerRNA *ptr, bool value);

bool Node_show_preview_get(PointerRNA *ptr);
void Node_show_preview_set(PointerRNA *ptr, bool value);

bool Node_show_texture_get(PointerRNA *ptr);
void Node_show_texture_set(PointerRNA *ptr, bool value);

void Node_bl_static_type_get(PointerRNA *ptr, char *value);
int Node_bl_static_type_length(PointerRNA *ptr);
void Node_bl_static_type_set(PointerRNA *ptr, const char *value);

void Node_type_get(PointerRNA *ptr, char *value);
int Node_type_length(PointerRNA *ptr);
void Node_type_set(PointerRNA *ptr, const char *value);

enum {
	Node_warning_propagation_ALL = 0,
	Node_warning_propagation_NONE = 1,
	Node_warning_propagation_ERRORS = 2,
	Node_warning_propagation_ERRORS_AND_WARNINGS = 3,
};

int Node_warning_propagation_get(PointerRNA *ptr);
void Node_warning_propagation_set(PointerRNA *ptr, int value);

float Node_width_get(PointerRNA *ptr);
void Node_width_set(PointerRNA *ptr, float value);

void Node_bl_description_get(PointerRNA *ptr, char *value);
int Node_bl_description_length(PointerRNA *ptr);
void Node_bl_description_set(PointerRNA *ptr, const char *value);

float Node_bl_height_default_get(PointerRNA *ptr);
void Node_bl_height_default_set(PointerRNA *ptr, float value);

float Node_bl_height_max_get(PointerRNA *ptr);
void Node_bl_height_max_set(PointerRNA *ptr, float value);

float Node_bl_height_min_get(PointerRNA *ptr);
void Node_bl_height_min_set(PointerRNA *ptr, float value);

float Node_bl_width_default_get(PointerRNA *ptr);
void Node_bl_width_default_set(PointerRNA *ptr, float value);

float Node_bl_width_max_get(PointerRNA *ptr);
void Node_bl_width_max_set(PointerRNA *ptr, float value);

float Node_bl_width_min_get(PointerRNA *ptr);
void Node_bl_width_min_set(PointerRNA *ptr, float value);

void Node_socket_value_update_func(struct ID *_selfid, struct bNode *_self, struct bContext *context);
bool Node_is_registered_node_type_func(struct StructRNA *_type);
bool Node_poll_func(struct bNodeTree *node_tree);
bool Node_poll_instance_func(struct bNode *_self, struct bNodeTree *node_tree);
void Node_update_func(struct ID *_selfid, struct bNode *_self);
void Node_insert_link_func(struct ID *_selfid, struct bNode *_self, struct bNodeLink *link);
void Node_init_func(struct bNode *_self, struct bContext *context);
void Node_copy_func(struct bNode *_self, struct bNode *node);
void Node_free_func(struct bNode *_self);
void Node_draw_buttons_func(struct bNode *_self, struct bContext *context, struct uiLayout *layout);
void Node_draw_buttons_ext_func(struct bNode *_self, struct bContext *context, struct uiLayout *layout);
void Node_draw_label_func(struct bNode *_self, char * label);
void Node_debug_zone_body_lazy_function_graph_func(struct ID *_selfid, struct bNode *_self, bContext *C, int *dot_graph_num, const char * *dot_graph);
void Node_debug_zone_lazy_function_graph_func(struct ID *_selfid, struct bNode *_self, bContext *C, int *dot_graph_num, const char * *dot_graph);
/**************** Custom Group ****************/

extern StructRNA RNA_NodeCustomGroup;
extern StructRNA RNA_Node;

PointerRNA NodeCustomGroup_node_tree_get(PointerRNA *ptr);

/**************** Enum Item ****************/

extern StructRNA RNA_NodeEnumItem;

PointerRNA NodeEnumItem_rna_type_get(PointerRNA *ptr);

void NodeEnumItem_name_get(PointerRNA *ptr, char *value);
int NodeEnumItem_name_length(PointerRNA *ptr);
void NodeEnumItem_name_set(PointerRNA *ptr, const char *value);

void NodeEnumItem_description_get(PointerRNA *ptr, char *value);
int NodeEnumItem_description_length(PointerRNA *ptr);
void NodeEnumItem_description_set(PointerRNA *ptr, const char *value);

/**************** NodeFrame ****************/

extern StructRNA RNA_NodeFrame;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int NodeFrame_label_size_get(PointerRNA *ptr);
void NodeFrame_label_size_set(PointerRNA *ptr, int value);

bool NodeFrame_shrink_get(PointerRNA *ptr);
void NodeFrame_shrink_set(PointerRNA *ptr, bool value);

PointerRNA NodeFrame_text_get(PointerRNA *ptr);

bool NodeFrame_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA NodeFrame_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA NodeFrame_output_template_func(struct StructRNA *_type, int index);
/**************** Format String Item ****************/

extern StructRNA RNA_NodeFunctionFormatStringItem;

PointerRNA NodeFunctionFormatStringItem_rna_type_get(PointerRNA *ptr);

void NodeFunctionFormatStringItem_name_get(PointerRNA *ptr, char *value);
int NodeFunctionFormatStringItem_name_length(PointerRNA *ptr);
void NodeFunctionFormatStringItem_name_set(PointerRNA *ptr, const char *value);

void NodeFunctionFormatStringItem_color_get(PointerRNA *ptr, float values[4]);
void NodeFunctionFormatStringItem_color_set(PointerRNA *ptr, const float values[4]);

enum {
	NodeFunctionFormatStringItem_socket_type_FLOAT = 0,
	NodeFunctionFormatStringItem_socket_type_INT = 6,
	NodeFunctionFormatStringItem_socket_type_BOOLEAN = 4,
	NodeFunctionFormatStringItem_socket_type_VECTOR = 1,
	NodeFunctionFormatStringItem_socket_type_ROTATION = 14,
	NodeFunctionFormatStringItem_socket_type_MATRIX = 16,
	NodeFunctionFormatStringItem_socket_type_STRING = 7,
	NodeFunctionFormatStringItem_socket_type_MENU = 15,
	NodeFunctionFormatStringItem_socket_type_RGBA = 2,
	NodeFunctionFormatStringItem_socket_type_OBJECT = 8,
	NodeFunctionFormatStringItem_socket_type_IMAGE = 9,
	NodeFunctionFormatStringItem_socket_type_GEOMETRY = 10,
	NodeFunctionFormatStringItem_socket_type_COLLECTION = 11,
	NodeFunctionFormatStringItem_socket_type_TEXTURE = 12,
	NodeFunctionFormatStringItem_socket_type_MATERIAL = 13,
	NodeFunctionFormatStringItem_socket_type_BUNDLE = 17,
	NodeFunctionFormatStringItem_socket_type_CLOSURE = 18,
};

int NodeFunctionFormatStringItem_socket_type_get(PointerRNA *ptr);
void NodeFunctionFormatStringItem_socket_type_set(PointerRNA *ptr, int value);

/**************** Items ****************/

extern StructRNA RNA_NodeFunctionFormatStringItems;

PointerRNA NodeFunctionFormatStringItems_rna_type_get(PointerRNA *ptr);

struct NodeFunctionFormatStringItem *NodeFunctionFormatStringItems_new_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, int socket_type, const char * name);
void NodeFunctionFormatStringItems_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct NodeFunctionFormatStringItem *item);
void NodeFunctionFormatStringItems_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain);
void NodeFunctionFormatStringItems_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, int from_index, int to_index);
/**************** Bake Item ****************/

extern StructRNA RNA_NodeGeometryBakeItem;

PointerRNA NodeGeometryBakeItem_rna_type_get(PointerRNA *ptr);

void NodeGeometryBakeItem_name_get(PointerRNA *ptr, char *value);
int NodeGeometryBakeItem_name_length(PointerRNA *ptr);
void NodeGeometryBakeItem_name_set(PointerRNA *ptr, const char *value);

enum {
	NodeGeometryBakeItem_attribute_domain_POINT = 0,
	NodeGeometryBakeItem_attribute_domain_EDGE = 1,
	NodeGeometryBakeItem_attribute_domain_FACE = 2,
	NodeGeometryBakeItem_attribute_domain_CORNER = 3,
	NodeGeometryBakeItem_attribute_domain_CURVE = 4,
	NodeGeometryBakeItem_attribute_domain_INSTANCE = 5,
	NodeGeometryBakeItem_attribute_domain_LAYER = 6,
};

int NodeGeometryBakeItem_attribute_domain_get(PointerRNA *ptr);
void NodeGeometryBakeItem_attribute_domain_set(PointerRNA *ptr, int value);

void NodeGeometryBakeItem_color_get(PointerRNA *ptr, float values[4]);
void NodeGeometryBakeItem_color_set(PointerRNA *ptr, const float values[4]);

bool NodeGeometryBakeItem_is_attribute_get(PointerRNA *ptr);
void NodeGeometryBakeItem_is_attribute_set(PointerRNA *ptr, bool value);

enum {
	NodeGeometryBakeItem_socket_type_FLOAT = 0,
	NodeGeometryBakeItem_socket_type_INT = 6,
	NodeGeometryBakeItem_socket_type_BOOLEAN = 4,
	NodeGeometryBakeItem_socket_type_VECTOR = 1,
	NodeGeometryBakeItem_socket_type_ROTATION = 14,
	NodeGeometryBakeItem_socket_type_MATRIX = 16,
	NodeGeometryBakeItem_socket_type_STRING = 7,
	NodeGeometryBakeItem_socket_type_MENU = 15,
	NodeGeometryBakeItem_socket_type_RGBA = 2,
	NodeGeometryBakeItem_socket_type_OBJECT = 8,
	NodeGeometryBakeItem_socket_type_IMAGE = 9,
	NodeGeometryBakeItem_socket_type_GEOMETRY = 10,
	NodeGeometryBakeItem_socket_type_COLLECTION = 11,
	NodeGeometryBakeItem_socket_type_TEXTURE = 12,
	NodeGeometryBakeItem_socket_type_MATERIAL = 13,
	NodeGeometryBakeItem_socket_type_BUNDLE = 17,
	NodeGeometryBakeItem_socket_type_CLOSURE = 18,
};

int NodeGeometryBakeItem_socket_type_get(PointerRNA *ptr);
void NodeGeometryBakeItem_socket_type_set(PointerRNA *ptr, int value);

/**************** Items ****************/

extern StructRNA RNA_NodeGeometryBakeItems;

PointerRNA NodeGeometryBakeItems_rna_type_get(PointerRNA *ptr);

struct NodeGeometryBakeItem *NodeGeometryBakeItems_new_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, int socket_type, const char * name);
void NodeGeometryBakeItems_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct NodeGeometryBakeItem *item);
void NodeGeometryBakeItems_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain);
void NodeGeometryBakeItems_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, int from_index, int to_index);
/**************** Capture Attribute Item ****************/

extern StructRNA RNA_NodeGeometryCaptureAttributeItem;

PointerRNA NodeGeometryCaptureAttributeItem_rna_type_get(PointerRNA *ptr);

void NodeGeometryCaptureAttributeItem_name_get(PointerRNA *ptr, char *value);
int NodeGeometryCaptureAttributeItem_name_length(PointerRNA *ptr);
void NodeGeometryCaptureAttributeItem_name_set(PointerRNA *ptr, const char *value);

void NodeGeometryCaptureAttributeItem_color_get(PointerRNA *ptr, float values[4]);
void NodeGeometryCaptureAttributeItem_color_set(PointerRNA *ptr, const float values[4]);

enum {
	NodeGeometryCaptureAttributeItem_data_type_FLOAT = 10,
	NodeGeometryCaptureAttributeItem_data_type_INT = 11,
	NodeGeometryCaptureAttributeItem_data_type_FLOAT_VECTOR = 48,
	NodeGeometryCaptureAttributeItem_data_type_FLOAT_COLOR = 47,
	NodeGeometryCaptureAttributeItem_data_type_BYTE_COLOR = 17,
	NodeGeometryCaptureAttributeItem_data_type_STRING = 12,
	NodeGeometryCaptureAttributeItem_data_type_BOOLEAN = 50,
	NodeGeometryCaptureAttributeItem_data_type_FLOAT2 = 49,
	NodeGeometryCaptureAttributeItem_data_type_INT8 = 45,
	NodeGeometryCaptureAttributeItem_data_type_INT16_2D = 22,
	NodeGeometryCaptureAttributeItem_data_type_INT32_2D = 46,
	NodeGeometryCaptureAttributeItem_data_type_QUATERNION = 52,
	NodeGeometryCaptureAttributeItem_data_type_FLOAT4X4 = 20,
};

int NodeGeometryCaptureAttributeItem_data_type_get(PointerRNA *ptr);
void NodeGeometryCaptureAttributeItem_data_type_set(PointerRNA *ptr, int value);

/**************** Items ****************/

extern StructRNA RNA_NodeGeometryCaptureAttributeItems;

PointerRNA NodeGeometryCaptureAttributeItems_rna_type_get(PointerRNA *ptr);

struct NodeGeometryAttributeCaptureItem *NodeGeometryCaptureAttributeItems_new_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, int socket_type, const char * name);
void NodeGeometryCaptureAttributeItems_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct NodeGeometryAttributeCaptureItem *item);
void NodeGeometryCaptureAttributeItems_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain);
void NodeGeometryCaptureAttributeItems_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, int from_index, int to_index);
/**************** Closure Input Item ****************/

extern StructRNA RNA_NodeGeometryClosureInputItem;

PointerRNA NodeGeometryClosureInputItem_rna_type_get(PointerRNA *ptr);

void NodeGeometryClosureInputItem_name_get(PointerRNA *ptr, char *value);
int NodeGeometryClosureInputItem_name_length(PointerRNA *ptr);
void NodeGeometryClosureInputItem_name_set(PointerRNA *ptr, const char *value);

void NodeGeometryClosureInputItem_color_get(PointerRNA *ptr, float values[4]);
void NodeGeometryClosureInputItem_color_set(PointerRNA *ptr, const float values[4]);

enum {
	NodeGeometryClosureInputItem_socket_type_FLOAT = 0,
	NodeGeometryClosureInputItem_socket_type_INT = 6,
	NodeGeometryClosureInputItem_socket_type_BOOLEAN = 4,
	NodeGeometryClosureInputItem_socket_type_VECTOR = 1,
	NodeGeometryClosureInputItem_socket_type_ROTATION = 14,
	NodeGeometryClosureInputItem_socket_type_MATRIX = 16,
	NodeGeometryClosureInputItem_socket_type_STRING = 7,
	NodeGeometryClosureInputItem_socket_type_MENU = 15,
	NodeGeometryClosureInputItem_socket_type_RGBA = 2,
	NodeGeometryClosureInputItem_socket_type_OBJECT = 8,
	NodeGeometryClosureInputItem_socket_type_IMAGE = 9,
	NodeGeometryClosureInputItem_socket_type_GEOMETRY = 10,
	NodeGeometryClosureInputItem_socket_type_COLLECTION = 11,
	NodeGeometryClosureInputItem_socket_type_TEXTURE = 12,
	NodeGeometryClosureInputItem_socket_type_MATERIAL = 13,
	NodeGeometryClosureInputItem_socket_type_BUNDLE = 17,
	NodeGeometryClosureInputItem_socket_type_CLOSURE = 18,
};

int NodeGeometryClosureInputItem_socket_type_get(PointerRNA *ptr);
void NodeGeometryClosureInputItem_socket_type_set(PointerRNA *ptr, int value);

/**************** Closure Input Items ****************/

extern StructRNA RNA_NodeGeometryClosureInputItems;

PointerRNA NodeGeometryClosureInputItems_rna_type_get(PointerRNA *ptr);

struct NodeGeometryClosureInputItem *NodeGeometryClosureInputItems_new_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, int socket_type, const char * name);
void NodeGeometryClosureInputItems_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct NodeGeometryClosureInputItem *item);
void NodeGeometryClosureInputItems_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain);
void NodeGeometryClosureInputItems_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, int from_index, int to_index);
/**************** Closure Output Item ****************/

extern StructRNA RNA_NodeGeometryClosureOutputItem;

PointerRNA NodeGeometryClosureOutputItem_rna_type_get(PointerRNA *ptr);

void NodeGeometryClosureOutputItem_name_get(PointerRNA *ptr, char *value);
int NodeGeometryClosureOutputItem_name_length(PointerRNA *ptr);
void NodeGeometryClosureOutputItem_name_set(PointerRNA *ptr, const char *value);

void NodeGeometryClosureOutputItem_color_get(PointerRNA *ptr, float values[4]);
void NodeGeometryClosureOutputItem_color_set(PointerRNA *ptr, const float values[4]);

enum {
	NodeGeometryClosureOutputItem_socket_type_FLOAT = 0,
	NodeGeometryClosureOutputItem_socket_type_INT = 6,
	NodeGeometryClosureOutputItem_socket_type_BOOLEAN = 4,
	NodeGeometryClosureOutputItem_socket_type_VECTOR = 1,
	NodeGeometryClosureOutputItem_socket_type_ROTATION = 14,
	NodeGeometryClosureOutputItem_socket_type_MATRIX = 16,
	NodeGeometryClosureOutputItem_socket_type_STRING = 7,
	NodeGeometryClosureOutputItem_socket_type_MENU = 15,
	NodeGeometryClosureOutputItem_socket_type_RGBA = 2,
	NodeGeometryClosureOutputItem_socket_type_OBJECT = 8,
	NodeGeometryClosureOutputItem_socket_type_IMAGE = 9,
	NodeGeometryClosureOutputItem_socket_type_GEOMETRY = 10,
	NodeGeometryClosureOutputItem_socket_type_COLLECTION = 11,
	NodeGeometryClosureOutputItem_socket_type_TEXTURE = 12,
	NodeGeometryClosureOutputItem_socket_type_MATERIAL = 13,
	NodeGeometryClosureOutputItem_socket_type_BUNDLE = 17,
	NodeGeometryClosureOutputItem_socket_type_CLOSURE = 18,
};

int NodeGeometryClosureOutputItem_socket_type_get(PointerRNA *ptr);
void NodeGeometryClosureOutputItem_socket_type_set(PointerRNA *ptr, int value);

/**************** Closure Output Items ****************/

extern StructRNA RNA_NodeGeometryClosureOutputItems;

PointerRNA NodeGeometryClosureOutputItems_rna_type_get(PointerRNA *ptr);

struct NodeGeometryClosureOutputItem *NodeGeometryClosureOutputItems_new_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, int socket_type, const char * name);
void NodeGeometryClosureOutputItems_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct NodeGeometryClosureOutputItem *item);
void NodeGeometryClosureOutputItems_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain);
void NodeGeometryClosureOutputItems_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, int from_index, int to_index);
/**************** Combine Bundle Item ****************/

extern StructRNA RNA_NodeGeometryCombineBundleItem;

PointerRNA NodeGeometryCombineBundleItem_rna_type_get(PointerRNA *ptr);

void NodeGeometryCombineBundleItem_name_get(PointerRNA *ptr, char *value);
int NodeGeometryCombineBundleItem_name_length(PointerRNA *ptr);
void NodeGeometryCombineBundleItem_name_set(PointerRNA *ptr, const char *value);

void NodeGeometryCombineBundleItem_color_get(PointerRNA *ptr, float values[4]);
void NodeGeometryCombineBundleItem_color_set(PointerRNA *ptr, const float values[4]);

enum {
	NodeGeometryCombineBundleItem_socket_type_FLOAT = 0,
	NodeGeometryCombineBundleItem_socket_type_INT = 6,
	NodeGeometryCombineBundleItem_socket_type_BOOLEAN = 4,
	NodeGeometryCombineBundleItem_socket_type_VECTOR = 1,
	NodeGeometryCombineBundleItem_socket_type_ROTATION = 14,
	NodeGeometryCombineBundleItem_socket_type_MATRIX = 16,
	NodeGeometryCombineBundleItem_socket_type_STRING = 7,
	NodeGeometryCombineBundleItem_socket_type_MENU = 15,
	NodeGeometryCombineBundleItem_socket_type_RGBA = 2,
	NodeGeometryCombineBundleItem_socket_type_OBJECT = 8,
	NodeGeometryCombineBundleItem_socket_type_IMAGE = 9,
	NodeGeometryCombineBundleItem_socket_type_GEOMETRY = 10,
	NodeGeometryCombineBundleItem_socket_type_COLLECTION = 11,
	NodeGeometryCombineBundleItem_socket_type_TEXTURE = 12,
	NodeGeometryCombineBundleItem_socket_type_MATERIAL = 13,
	NodeGeometryCombineBundleItem_socket_type_BUNDLE = 17,
	NodeGeometryCombineBundleItem_socket_type_CLOSURE = 18,
};

int NodeGeometryCombineBundleItem_socket_type_get(PointerRNA *ptr);
void NodeGeometryCombineBundleItem_socket_type_set(PointerRNA *ptr, int value);

/**************** Items ****************/

extern StructRNA RNA_NodeGeometryCombineBundleItems;

PointerRNA NodeGeometryCombineBundleItems_rna_type_get(PointerRNA *ptr);

struct NodeGeometryCombineBundleItem *NodeGeometryCombineBundleItems_new_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, int socket_type, const char * name);
void NodeGeometryCombineBundleItems_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct NodeGeometryCombineBundleItem *item);
void NodeGeometryCombineBundleItems_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain);
void NodeGeometryCombineBundleItems_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, int from_index, int to_index);
/**************** Input Item ****************/

extern StructRNA RNA_NodeGeometryEvaluateClosureInputItem;

PointerRNA NodeGeometryEvaluateClosureInputItem_rna_type_get(PointerRNA *ptr);

void NodeGeometryEvaluateClosureInputItem_name_get(PointerRNA *ptr, char *value);
int NodeGeometryEvaluateClosureInputItem_name_length(PointerRNA *ptr);
void NodeGeometryEvaluateClosureInputItem_name_set(PointerRNA *ptr, const char *value);

void NodeGeometryEvaluateClosureInputItem_color_get(PointerRNA *ptr, float values[4]);
void NodeGeometryEvaluateClosureInputItem_color_set(PointerRNA *ptr, const float values[4]);

enum {
	NodeGeometryEvaluateClosureInputItem_socket_type_FLOAT = 0,
	NodeGeometryEvaluateClosureInputItem_socket_type_INT = 6,
	NodeGeometryEvaluateClosureInputItem_socket_type_BOOLEAN = 4,
	NodeGeometryEvaluateClosureInputItem_socket_type_VECTOR = 1,
	NodeGeometryEvaluateClosureInputItem_socket_type_ROTATION = 14,
	NodeGeometryEvaluateClosureInputItem_socket_type_MATRIX = 16,
	NodeGeometryEvaluateClosureInputItem_socket_type_STRING = 7,
	NodeGeometryEvaluateClosureInputItem_socket_type_MENU = 15,
	NodeGeometryEvaluateClosureInputItem_socket_type_RGBA = 2,
	NodeGeometryEvaluateClosureInputItem_socket_type_OBJECT = 8,
	NodeGeometryEvaluateClosureInputItem_socket_type_IMAGE = 9,
	NodeGeometryEvaluateClosureInputItem_socket_type_GEOMETRY = 10,
	NodeGeometryEvaluateClosureInputItem_socket_type_COLLECTION = 11,
	NodeGeometryEvaluateClosureInputItem_socket_type_TEXTURE = 12,
	NodeGeometryEvaluateClosureInputItem_socket_type_MATERIAL = 13,
	NodeGeometryEvaluateClosureInputItem_socket_type_BUNDLE = 17,
	NodeGeometryEvaluateClosureInputItem_socket_type_CLOSURE = 18,
};

int NodeGeometryEvaluateClosureInputItem_socket_type_get(PointerRNA *ptr);
void NodeGeometryEvaluateClosureInputItem_socket_type_set(PointerRNA *ptr, int value);

/**************** Input Items ****************/

extern StructRNA RNA_NodeGeometryEvaluateClosureInputItems;

PointerRNA NodeGeometryEvaluateClosureInputItems_rna_type_get(PointerRNA *ptr);

struct NodeGeometryEvaluateClosureInputItem *NodeGeometryEvaluateClosureInputItems_new_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, int socket_type, const char * name);
void NodeGeometryEvaluateClosureInputItems_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct NodeGeometryEvaluateClosureInputItem *item);
void NodeGeometryEvaluateClosureInputItems_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain);
void NodeGeometryEvaluateClosureInputItems_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, int from_index, int to_index);
/**************** Output Item ****************/

extern StructRNA RNA_NodeGeometryEvaluateClosureOutputItem;

PointerRNA NodeGeometryEvaluateClosureOutputItem_rna_type_get(PointerRNA *ptr);

void NodeGeometryEvaluateClosureOutputItem_name_get(PointerRNA *ptr, char *value);
int NodeGeometryEvaluateClosureOutputItem_name_length(PointerRNA *ptr);
void NodeGeometryEvaluateClosureOutputItem_name_set(PointerRNA *ptr, const char *value);

void NodeGeometryEvaluateClosureOutputItem_color_get(PointerRNA *ptr, float values[4]);
void NodeGeometryEvaluateClosureOutputItem_color_set(PointerRNA *ptr, const float values[4]);

enum {
	NodeGeometryEvaluateClosureOutputItem_socket_type_FLOAT = 0,
	NodeGeometryEvaluateClosureOutputItem_socket_type_INT = 6,
	NodeGeometryEvaluateClosureOutputItem_socket_type_BOOLEAN = 4,
	NodeGeometryEvaluateClosureOutputItem_socket_type_VECTOR = 1,
	NodeGeometryEvaluateClosureOutputItem_socket_type_ROTATION = 14,
	NodeGeometryEvaluateClosureOutputItem_socket_type_MATRIX = 16,
	NodeGeometryEvaluateClosureOutputItem_socket_type_STRING = 7,
	NodeGeometryEvaluateClosureOutputItem_socket_type_MENU = 15,
	NodeGeometryEvaluateClosureOutputItem_socket_type_RGBA = 2,
	NodeGeometryEvaluateClosureOutputItem_socket_type_OBJECT = 8,
	NodeGeometryEvaluateClosureOutputItem_socket_type_IMAGE = 9,
	NodeGeometryEvaluateClosureOutputItem_socket_type_GEOMETRY = 10,
	NodeGeometryEvaluateClosureOutputItem_socket_type_COLLECTION = 11,
	NodeGeometryEvaluateClosureOutputItem_socket_type_TEXTURE = 12,
	NodeGeometryEvaluateClosureOutputItem_socket_type_MATERIAL = 13,
	NodeGeometryEvaluateClosureOutputItem_socket_type_BUNDLE = 17,
	NodeGeometryEvaluateClosureOutputItem_socket_type_CLOSURE = 18,
};

int NodeGeometryEvaluateClosureOutputItem_socket_type_get(PointerRNA *ptr);
void NodeGeometryEvaluateClosureOutputItem_socket_type_set(PointerRNA *ptr, int value);

/**************** Output Items ****************/

extern StructRNA RNA_NodeGeometryEvaluateClosureOutputItems;

PointerRNA NodeGeometryEvaluateClosureOutputItems_rna_type_get(PointerRNA *ptr);

struct NodeGeometryEvaluateClosureOutputItem *NodeGeometryEvaluateClosureOutputItems_new_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, int socket_type, const char * name);
void NodeGeometryEvaluateClosureOutputItems_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct NodeGeometryEvaluateClosureOutputItem *item);
void NodeGeometryEvaluateClosureOutputItems_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain);
void NodeGeometryEvaluateClosureOutputItems_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, int from_index, int to_index);
/**************** Generation Items ****************/

extern StructRNA RNA_NodeGeometryForeachGeometryElementGenerationItems;

PointerRNA NodeGeometryForeachGeometryElementGenerationItems_rna_type_get(PointerRNA *ptr);

struct NodeForeachGeometryElementGenerationItem *NodeGeometryForeachGeometryElementGenerationItems_new_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, int socket_type, const char * name);
void NodeGeometryForeachGeometryElementGenerationItems_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct NodeForeachGeometryElementGenerationItem *item);
void NodeGeometryForeachGeometryElementGenerationItems_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain);
void NodeGeometryForeachGeometryElementGenerationItems_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, int from_index, int to_index);
/**************** Input Items ****************/

extern StructRNA RNA_NodeGeometryForeachGeometryElementInputItems;

PointerRNA NodeGeometryForeachGeometryElementInputItems_rna_type_get(PointerRNA *ptr);

struct NodeForeachGeometryElementInputItem *NodeGeometryForeachGeometryElementInputItems_new_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, int socket_type, const char * name);
void NodeGeometryForeachGeometryElementInputItems_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct NodeForeachGeometryElementInputItem *item);
void NodeGeometryForeachGeometryElementInputItems_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain);
void NodeGeometryForeachGeometryElementInputItems_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, int from_index, int to_index);
/**************** Main Items ****************/

extern StructRNA RNA_NodeGeometryForeachGeometryElementMainItems;

PointerRNA NodeGeometryForeachGeometryElementMainItems_rna_type_get(PointerRNA *ptr);

struct NodeForeachGeometryElementMainItem *NodeGeometryForeachGeometryElementMainItems_new_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, int socket_type, const char * name);
void NodeGeometryForeachGeometryElementMainItems_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct NodeForeachGeometryElementMainItem *item);
void NodeGeometryForeachGeometryElementMainItems_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain);
void NodeGeometryForeachGeometryElementMainItems_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, int from_index, int to_index);
/**************** Items ****************/

extern StructRNA RNA_NodeGeometryRepeatOutputItems;

PointerRNA NodeGeometryRepeatOutputItems_rna_type_get(PointerRNA *ptr);

struct NodeRepeatItem *NodeGeometryRepeatOutputItems_new_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, int socket_type, const char * name);
void NodeGeometryRepeatOutputItems_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct NodeRepeatItem *item);
void NodeGeometryRepeatOutputItems_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain);
void NodeGeometryRepeatOutputItems_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, int from_index, int to_index);
/**************** Separate Bundle Item ****************/

extern StructRNA RNA_NodeGeometrySeparateBundleItem;

PointerRNA NodeGeometrySeparateBundleItem_rna_type_get(PointerRNA *ptr);

void NodeGeometrySeparateBundleItem_name_get(PointerRNA *ptr, char *value);
int NodeGeometrySeparateBundleItem_name_length(PointerRNA *ptr);
void NodeGeometrySeparateBundleItem_name_set(PointerRNA *ptr, const char *value);

void NodeGeometrySeparateBundleItem_color_get(PointerRNA *ptr, float values[4]);
void NodeGeometrySeparateBundleItem_color_set(PointerRNA *ptr, const float values[4]);

enum {
	NodeGeometrySeparateBundleItem_socket_type_FLOAT = 0,
	NodeGeometrySeparateBundleItem_socket_type_INT = 6,
	NodeGeometrySeparateBundleItem_socket_type_BOOLEAN = 4,
	NodeGeometrySeparateBundleItem_socket_type_VECTOR = 1,
	NodeGeometrySeparateBundleItem_socket_type_ROTATION = 14,
	NodeGeometrySeparateBundleItem_socket_type_MATRIX = 16,
	NodeGeometrySeparateBundleItem_socket_type_STRING = 7,
	NodeGeometrySeparateBundleItem_socket_type_MENU = 15,
	NodeGeometrySeparateBundleItem_socket_type_RGBA = 2,
	NodeGeometrySeparateBundleItem_socket_type_OBJECT = 8,
	NodeGeometrySeparateBundleItem_socket_type_IMAGE = 9,
	NodeGeometrySeparateBundleItem_socket_type_GEOMETRY = 10,
	NodeGeometrySeparateBundleItem_socket_type_COLLECTION = 11,
	NodeGeometrySeparateBundleItem_socket_type_TEXTURE = 12,
	NodeGeometrySeparateBundleItem_socket_type_MATERIAL = 13,
	NodeGeometrySeparateBundleItem_socket_type_BUNDLE = 17,
	NodeGeometrySeparateBundleItem_socket_type_CLOSURE = 18,
};

int NodeGeometrySeparateBundleItem_socket_type_get(PointerRNA *ptr);
void NodeGeometrySeparateBundleItem_socket_type_set(PointerRNA *ptr, int value);

/**************** Items ****************/

extern StructRNA RNA_NodeGeometrySeparateBundleItems;

PointerRNA NodeGeometrySeparateBundleItems_rna_type_get(PointerRNA *ptr);

struct NodeGeometrySeparateBundleItem *NodeGeometrySeparateBundleItems_new_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, int socket_type, const char * name);
void NodeGeometrySeparateBundleItems_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct NodeGeometrySeparateBundleItem *item);
void NodeGeometrySeparateBundleItems_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain);
void NodeGeometrySeparateBundleItems_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, int from_index, int to_index);
/**************** Items ****************/

extern StructRNA RNA_NodeGeometrySimulationOutputItems;

PointerRNA NodeGeometrySimulationOutputItems_rna_type_get(PointerRNA *ptr);

struct NodeSimulationItem *NodeGeometrySimulationOutputItems_new_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, int socket_type, const char * name);
void NodeGeometrySimulationOutputItems_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct NodeSimulationItem *item);
void NodeGeometrySimulationOutputItems_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain);
void NodeGeometrySimulationOutputItems_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, int from_index, int to_index);
/**************** NodeGroup ****************/

extern StructRNA RNA_NodeGroup;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA NodeGroup_node_tree_get(PointerRNA *ptr);

bool NodeGroup_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA NodeGroup_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA NodeGroup_output_template_func(struct StructRNA *_type, int index);
/**************** NodeGroupInput ****************/

extern StructRNA RNA_NodeGroupInput;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool NodeGroupInput_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA NodeGroupInput_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA NodeGroupInput_output_template_func(struct StructRNA *_type, int index);
/**************** NodeGroupOutput ****************/

extern StructRNA RNA_NodeGroupOutput;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool NodeGroupOutput_is_active_output_get(PointerRNA *ptr);
void NodeGroupOutput_is_active_output_set(PointerRNA *ptr, bool value);

bool NodeGroupOutput_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA NodeGroupOutput_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA NodeGroupOutput_output_template_func(struct StructRNA *_type, int index);
/**************** Items ****************/

extern StructRNA RNA_NodeIndexSwitchItems;

PointerRNA NodeIndexSwitchItems_rna_type_get(PointerRNA *ptr);

struct IndexSwitchItem *NodeIndexSwitchItems_new_func(struct ID *_selfid, struct bNode *_self, Main *bmain);
void NodeIndexSwitchItems_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct IndexSwitchItem *item);
void NodeIndexSwitchItems_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain);
void NodeIndexSwitchItems_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, int from_index, int to_index);
/**************** Node Inputs ****************/

extern StructRNA RNA_NodeInputs;

PointerRNA NodeInputs_rna_type_get(PointerRNA *ptr);

struct bNodeSocket *NodeInputs_new_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, const char * type, const char * name, const char * identifier, bool use_multi_input);
void NodeInputs_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct bNodeSocket *socket);
void NodeInputs_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports);
void NodeInputs_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, int from_index, int to_index);
/**************** Node Instance Hash ****************/

extern StructRNA RNA_NodeInstanceHash;

PointerRNA NodeInstanceHash_rna_type_get(PointerRNA *ptr);

/**************** NodeInternal ****************/

extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool NodeInternal_poll_func(struct StructRNA *_type, struct bNodeTree *node_tree);
bool NodeInternal_poll_instance_func(struct bNode *_self, struct bNodeTree *node_tree);
void NodeInternal_update_func(struct ID *_selfid, struct bNode *_self, Main *bmain);
void NodeInternal_draw_buttons_func(struct ID *_selfid, struct bNode *_self, struct bContext *context, struct uiLayout *layout);
void NodeInternal_draw_buttons_ext_func(struct ID *_selfid, struct bNode *_self, struct bContext *context, struct uiLayout *layout);
/**************** Socket Template ****************/

extern StructRNA RNA_NodeInternalSocketTemplate;

PointerRNA NodeInternalSocketTemplate_rna_type_get(PointerRNA *ptr);

void NodeInternalSocketTemplate_name_get(PointerRNA *ptr, char *value);
int NodeInternalSocketTemplate_name_length(PointerRNA *ptr);
void NodeInternalSocketTemplate_name_set(PointerRNA *ptr, const char *value);

void NodeInternalSocketTemplate_identifier_get(PointerRNA *ptr, char *value);
int NodeInternalSocketTemplate_identifier_length(PointerRNA *ptr);
void NodeInternalSocketTemplate_identifier_set(PointerRNA *ptr, const char *value);

enum {
	NodeInternalSocketTemplate_type_CUSTOM = -1,
	NodeInternalSocketTemplate_type_VALUE = 0,
	NodeInternalSocketTemplate_type_INT = 6,
	NodeInternalSocketTemplate_type_BOOLEAN = 4,
	NodeInternalSocketTemplate_type_VECTOR = 1,
	NodeInternalSocketTemplate_type_ROTATION = 14,
	NodeInternalSocketTemplate_type_MATRIX = 16,
	NodeInternalSocketTemplate_type_STRING = 7,
	NodeInternalSocketTemplate_type_RGBA = 2,
	NodeInternalSocketTemplate_type_SHADER = 3,
	NodeInternalSocketTemplate_type_OBJECT = 8,
	NodeInternalSocketTemplate_type_IMAGE = 9,
	NodeInternalSocketTemplate_type_GEOMETRY = 10,
	NodeInternalSocketTemplate_type_COLLECTION = 11,
	NodeInternalSocketTemplate_type_TEXTURE = 12,
	NodeInternalSocketTemplate_type_MATERIAL = 13,
	NodeInternalSocketTemplate_type_MENU = 15,
	NodeInternalSocketTemplate_type_BUNDLE = 17,
	NodeInternalSocketTemplate_type_CLOSURE = 18,
};

int NodeInternalSocketTemplate_type_get(PointerRNA *ptr);
void NodeInternalSocketTemplate_type_set(PointerRNA *ptr, int value);

/**************** NodeLink ****************/

extern StructRNA RNA_NodeLink;

PointerRNA NodeLink_rna_type_get(PointerRNA *ptr);

PointerRNA NodeLink_from_node_get(PointerRNA *ptr);

PointerRNA NodeLink_from_socket_get(PointerRNA *ptr);

bool NodeLink_is_hidden_get(PointerRNA *ptr);
void NodeLink_is_hidden_set(PointerRNA *ptr, bool value);

int NodeLink_multi_input_sort_id_get(PointerRNA *ptr);
void NodeLink_multi_input_sort_id_set(PointerRNA *ptr, int value);

bool NodeLink_is_muted_get(PointerRNA *ptr);
void NodeLink_is_muted_set(PointerRNA *ptr, bool value);

PointerRNA NodeLink_to_node_get(PointerRNA *ptr);

PointerRNA NodeLink_to_socket_get(PointerRNA *ptr);

bool NodeLink_is_valid_get(PointerRNA *ptr);
void NodeLink_is_valid_set(PointerRNA *ptr, bool value);

void NodeLink_swap_multi_input_sort_id_func(struct ID *_selfid, struct bNodeLink *_self, Main *bmain, ReportList *reports, struct bNodeLink *other);
/**************** Node Links ****************/

extern StructRNA RNA_NodeLinks;

PointerRNA NodeLinks_rna_type_get(PointerRNA *ptr);

struct bNodeLink *NodeLinks_new_func(struct bNodeTree *_self, Main *bmain, ReportList *reports, struct bNodeSocket *input, struct bNodeSocket *output, bool verify_limits, bool handle_dynamic_sockets);
void NodeLinks_remove_func(struct bNodeTree *_self, Main *bmain, ReportList *reports, struct PointerRNA *link);
void NodeLinks_clear_func(struct bNodeTree *_self, Main *bmain, ReportList *reports);
/**************** Enum Definition Items ****************/

extern StructRNA RNA_NodeMenuSwitchItems;

PointerRNA NodeMenuSwitchItems_rna_type_get(PointerRNA *ptr);

struct NodeEnumItem *NodeMenuSwitchItems_new_func(struct ID *_selfid, struct bNode *_self, Main *bmain, const char * name);
void NodeMenuSwitchItems_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct NodeEnumItem *item);
void NodeMenuSwitchItems_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain);
void NodeMenuSwitchItems_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, int from_index, int to_index);
/**************** Output File Slot ****************/

extern StructRNA RNA_NodeOutputFileSlotFile;

PointerRNA NodeOutputFileSlotFile_rna_type_get(PointerRNA *ptr);

#define NodeOutputFileSlotFile_path_MAX 1024

void NodeOutputFileSlotFile_path_get(PointerRNA *ptr, char *value);
int NodeOutputFileSlotFile_path_length(PointerRNA *ptr);
void NodeOutputFileSlotFile_path_set(PointerRNA *ptr, const char *value);

bool NodeOutputFileSlotFile_save_as_render_get(PointerRNA *ptr);
void NodeOutputFileSlotFile_save_as_render_set(PointerRNA *ptr, bool value);

bool NodeOutputFileSlotFile_use_node_format_get(PointerRNA *ptr);
void NodeOutputFileSlotFile_use_node_format_set(PointerRNA *ptr, bool value);

PointerRNA NodeOutputFileSlotFile_format_get(PointerRNA *ptr);

/**************** Output File Layer Slot ****************/

extern StructRNA RNA_NodeOutputFileSlotLayer;

PointerRNA NodeOutputFileSlotLayer_rna_type_get(PointerRNA *ptr);

#define NodeOutputFileSlotLayer_name_MAX 62

void NodeOutputFileSlotLayer_name_get(PointerRNA *ptr, char *value);
int NodeOutputFileSlotLayer_name_length(PointerRNA *ptr);
void NodeOutputFileSlotLayer_name_set(PointerRNA *ptr, const char *value);

/**************** Node Outputs ****************/

extern StructRNA RNA_NodeOutputs;

PointerRNA NodeOutputs_rna_type_get(PointerRNA *ptr);

struct bNodeSocket *NodeOutputs_new_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, const char * type, const char * name, const char * identifier, bool use_multi_input);
void NodeOutputs_remove_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, struct bNodeSocket *socket);
void NodeOutputs_clear_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports);
void NodeOutputs_move_func(struct ID *_selfid, struct bNode *_self, Main *bmain, ReportList *reports, int from_index, int to_index);
/**************** NodeReroute ****************/

extern StructRNA RNA_NodeReroute;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

#define NodeReroute_socket_idname_MAX 64

void NodeReroute_socket_idname_get(PointerRNA *ptr, char *value);
int NodeReroute_socket_idname_length(PointerRNA *ptr);
void NodeReroute_socket_idname_set(PointerRNA *ptr, const char *value);

bool NodeReroute_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA NodeReroute_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA NodeReroute_output_template_func(struct StructRNA *_type, int index);
/**************** Node Socket ****************/

extern StructRNA RNA_NodeSocket;

PointerRNA NodeSocket_rna_type_get(PointerRNA *ptr);

#define NodeSocket_name_MAX 64

void NodeSocket_name_get(PointerRNA *ptr, char *value);
int NodeSocket_name_length(PointerRNA *ptr);
void NodeSocket_name_set(PointerRNA *ptr, const char *value);

bool NodeSocket_enabled_get(PointerRNA *ptr);
void NodeSocket_enabled_set(PointerRNA *ptr, bool value);

bool NodeSocket_show_expanded_get(PointerRNA *ptr);
void NodeSocket_show_expanded_set(PointerRNA *ptr, bool value);

bool NodeSocket_hide_get(PointerRNA *ptr);
void NodeSocket_hide_set(PointerRNA *ptr, bool value);

bool NodeSocket_hide_value_get(PointerRNA *ptr);
void NodeSocket_hide_value_set(PointerRNA *ptr, bool value);

void NodeSocket_bl_idname_get(PointerRNA *ptr, char *value);
int NodeSocket_bl_idname_length(PointerRNA *ptr);
void NodeSocket_bl_idname_set(PointerRNA *ptr, const char *value);

bool NodeSocket_is_icon_visible_get(PointerRNA *ptr);
void NodeSocket_is_icon_visible_set(PointerRNA *ptr, bool value);

#define NodeSocket_identifier_MAX 64

void NodeSocket_identifier_get(PointerRNA *ptr, char *value);
int NodeSocket_identifier_length(PointerRNA *ptr);
void NodeSocket_identifier_set(PointerRNA *ptr, const char *value);

bool NodeSocket_is_inactive_get(PointerRNA *ptr);
void NodeSocket_is_inactive_set(PointerRNA *ptr, bool value);

bool NodeSocket_is_output_get(PointerRNA *ptr);
void NodeSocket_is_output_set(PointerRNA *ptr, bool value);

#define NodeSocket_label_MAX 64

void NodeSocket_label_get(PointerRNA *ptr, char *value);
int NodeSocket_label_length(PointerRNA *ptr);
void NodeSocket_label_set(PointerRNA *ptr, const char *value);

int NodeSocket_link_limit_get(PointerRNA *ptr);
void NodeSocket_link_limit_set(PointerRNA *ptr, int value);

bool NodeSocket_is_linked_get(PointerRNA *ptr);
void NodeSocket_is_linked_set(PointerRNA *ptr, bool value);

bool NodeSocket_is_multi_input_get(PointerRNA *ptr);
void NodeSocket_is_multi_input_set(PointerRNA *ptr, bool value);

PointerRNA NodeSocket_node_get(PointerRNA *ptr);

bool NodeSocket_pin_gizmo_get(PointerRNA *ptr);
void NodeSocket_pin_gizmo_set(PointerRNA *ptr, bool value);

bool NodeSocket_select_get(PointerRNA *ptr);
void NodeSocket_select_set(PointerRNA *ptr, bool value);

enum {
	NodeSocket_display_shape_CIRCLE = 0,
	NodeSocket_display_shape_SQUARE = 1,
	NodeSocket_display_shape_DIAMOND = 2,
	NodeSocket_display_shape_CIRCLE_DOT = 3,
	NodeSocket_display_shape_SQUARE_DOT = 4,
	NodeSocket_display_shape_DIAMOND_DOT = 5,
};

int NodeSocket_display_shape_get(PointerRNA *ptr);
void NodeSocket_display_shape_set(PointerRNA *ptr, int value);

void NodeSocket_bl_subtype_label_get(PointerRNA *ptr, char *value);
int NodeSocket_bl_subtype_label_length(PointerRNA *ptr);
void NodeSocket_bl_subtype_label_set(PointerRNA *ptr, const char *value);

#define NodeSocket_description_MAX 64

void NodeSocket_description_get(PointerRNA *ptr, char *value);
int NodeSocket_description_length(PointerRNA *ptr);
void NodeSocket_description_set(PointerRNA *ptr, const char *value);

enum {
	NodeSocket_type_CUSTOM = -1,
	NodeSocket_type_VALUE = 0,
	NodeSocket_type_INT = 6,
	NodeSocket_type_BOOLEAN = 4,
	NodeSocket_type_VECTOR = 1,
	NodeSocket_type_ROTATION = 14,
	NodeSocket_type_MATRIX = 16,
	NodeSocket_type_STRING = 7,
	NodeSocket_type_RGBA = 2,
	NodeSocket_type_SHADER = 3,
	NodeSocket_type_OBJECT = 8,
	NodeSocket_type_IMAGE = 9,
	NodeSocket_type_GEOMETRY = 10,
	NodeSocket_type_COLLECTION = 11,
	NodeSocket_type_TEXTURE = 12,
	NodeSocket_type_MATERIAL = 13,
	NodeSocket_type_MENU = 15,
	NodeSocket_type_BUNDLE = 17,
	NodeSocket_type_CLOSURE = 18,
};

int NodeSocket_type_get(PointerRNA *ptr);
void NodeSocket_type_set(PointerRNA *ptr, int value);

void NodeSocket_bl_label_get(PointerRNA *ptr, char *value);
int NodeSocket_bl_label_length(PointerRNA *ptr);
void NodeSocket_bl_label_set(PointerRNA *ptr, const char *value);

bool NodeSocket_is_unavailable_get(PointerRNA *ptr);
void NodeSocket_is_unavailable_set(PointerRNA *ptr, bool value);

void NodeSocket_draw_func(struct bNodeSocket *_self, struct bContext *context, struct uiLayout *layout, struct PointerRNA *node, const char * text);
void NodeSocket_draw_color_func(struct bNodeSocket *_self, struct bContext *context, struct PointerRNA *node, float color[4]);
void NodeSocket_draw_color_simple_func(float color[4]);
/**************** Boolean Node Socket ****************/

extern StructRNA RNA_NodeSocketBool;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

bool NodeSocketBool_default_value_get(PointerRNA *ptr);
void NodeSocketBool_default_value_set(PointerRNA *ptr, bool value);

/**************** Bundle Node Socket ****************/

extern StructRNA RNA_NodeSocketBundle;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

/**************** Closure Node Socket ****************/

extern StructRNA RNA_NodeSocketClosure;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

/**************** Collection Node Socket ****************/

extern StructRNA RNA_NodeSocketCollection;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

PointerRNA NodeSocketCollection_default_value_get(PointerRNA *ptr);

/**************** Color Node Socket ****************/

extern StructRNA RNA_NodeSocketColor;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketColor_default_value_get(PointerRNA *ptr, float values[4]);
void NodeSocketColor_default_value_set(PointerRNA *ptr, const float values[4]);

/**************** Float Node Socket ****************/

extern StructRNA RNA_NodeSocketFloat;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

float NodeSocketFloat_default_value_get(PointerRNA *ptr);
void NodeSocketFloat_default_value_set(PointerRNA *ptr, float value);

/**************** Float Node Socket ****************/

extern StructRNA RNA_NodeSocketFloatAngle;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

float NodeSocketFloatAngle_default_value_get(PointerRNA *ptr);
void NodeSocketFloatAngle_default_value_set(PointerRNA *ptr, float value);

/**************** Float Node Socket ****************/

extern StructRNA RNA_NodeSocketFloatColorTemperature;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

float NodeSocketFloatColorTemperature_default_value_get(PointerRNA *ptr);
void NodeSocketFloatColorTemperature_default_value_set(PointerRNA *ptr, float value);

/**************** Float Node Socket ****************/

extern StructRNA RNA_NodeSocketFloatDistance;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

float NodeSocketFloatDistance_default_value_get(PointerRNA *ptr);
void NodeSocketFloatDistance_default_value_set(PointerRNA *ptr, float value);

/**************** Float Node Socket ****************/

extern StructRNA RNA_NodeSocketFloatFactor;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

float NodeSocketFloatFactor_default_value_get(PointerRNA *ptr);
void NodeSocketFloatFactor_default_value_set(PointerRNA *ptr, float value);

/**************** Float Node Socket ****************/

extern StructRNA RNA_NodeSocketFloatFrequency;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

float NodeSocketFloatFrequency_default_value_get(PointerRNA *ptr);
void NodeSocketFloatFrequency_default_value_set(PointerRNA *ptr, float value);

/**************** Float Node Socket ****************/

extern StructRNA RNA_NodeSocketFloatPercentage;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

float NodeSocketFloatPercentage_default_value_get(PointerRNA *ptr);
void NodeSocketFloatPercentage_default_value_set(PointerRNA *ptr, float value);

/**************** Float Node Socket ****************/

extern StructRNA RNA_NodeSocketFloatTime;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

float NodeSocketFloatTime_default_value_get(PointerRNA *ptr);
void NodeSocketFloatTime_default_value_set(PointerRNA *ptr, float value);

/**************** Float Node Socket ****************/

extern StructRNA RNA_NodeSocketFloatTimeAbsolute;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

float NodeSocketFloatTimeAbsolute_default_value_get(PointerRNA *ptr);
void NodeSocketFloatTimeAbsolute_default_value_set(PointerRNA *ptr, float value);

/**************** Float Node Socket ****************/

extern StructRNA RNA_NodeSocketFloatUnsigned;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

float NodeSocketFloatUnsigned_default_value_get(PointerRNA *ptr);
void NodeSocketFloatUnsigned_default_value_set(PointerRNA *ptr, float value);

/**************** Float Node Socket ****************/

extern StructRNA RNA_NodeSocketFloatWavelength;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

float NodeSocketFloatWavelength_default_value_get(PointerRNA *ptr);
void NodeSocketFloatWavelength_default_value_set(PointerRNA *ptr, float value);

/**************** Geometry Node Socket ****************/

extern StructRNA RNA_NodeSocketGeometry;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

/**************** Image Node Socket ****************/

extern StructRNA RNA_NodeSocketImage;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

PointerRNA NodeSocketImage_default_value_get(PointerRNA *ptr);

/**************** Integer Node Socket ****************/

extern StructRNA RNA_NodeSocketInt;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

int NodeSocketInt_default_value_get(PointerRNA *ptr);
void NodeSocketInt_default_value_set(PointerRNA *ptr, int value);

/**************** Integer Node Socket ****************/

extern StructRNA RNA_NodeSocketIntFactor;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

int NodeSocketIntFactor_default_value_get(PointerRNA *ptr);
void NodeSocketIntFactor_default_value_set(PointerRNA *ptr, int value);

/**************** Integer Node Socket ****************/

extern StructRNA RNA_NodeSocketIntPercentage;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

int NodeSocketIntPercentage_default_value_get(PointerRNA *ptr);
void NodeSocketIntPercentage_default_value_set(PointerRNA *ptr, int value);

/**************** Integer Node Socket ****************/

extern StructRNA RNA_NodeSocketIntUnsigned;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

int NodeSocketIntUnsigned_default_value_get(PointerRNA *ptr);
void NodeSocketIntUnsigned_default_value_set(PointerRNA *ptr, int value);

/**************** Material Node Socket ****************/

extern StructRNA RNA_NodeSocketMaterial;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

PointerRNA NodeSocketMaterial_default_value_get(PointerRNA *ptr);

/**************** Matrix Node Socket ****************/

extern StructRNA RNA_NodeSocketMatrix;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

/**************** Menu Node Socket ****************/

extern StructRNA RNA_NodeSocketMenu;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

int NodeSocketMenu_default_value_get(PointerRNA *ptr);
void NodeSocketMenu_default_value_set(PointerRNA *ptr, int value);

/**************** Object Node Socket ****************/

extern StructRNA RNA_NodeSocketObject;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

PointerRNA NodeSocketObject_default_value_get(PointerRNA *ptr);

/**************** Rotation Node Socket ****************/

extern StructRNA RNA_NodeSocketRotation;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketRotation_default_value_get(PointerRNA *ptr, float values[3]);
void NodeSocketRotation_default_value_set(PointerRNA *ptr, const float values[3]);

/**************** Shader Node Socket ****************/

extern StructRNA RNA_NodeSocketShader;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

/**************** NodeSocketStandard ****************/

extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketStandard_draw_func(struct ID *_selfid, struct bNodeSocket *_self, struct bContext *context, struct uiLayout *layout, struct PointerRNA *node, const char * text);
void NodeSocketStandard_draw_color_func(struct ID *_selfid, struct bNodeSocket *_self, struct bContext *context, struct PointerRNA *node, float color[4]);
void NodeSocketStandard_draw_color_simple_func(struct StructRNA *_type, float color[4]);
/**************** String Node Socket ****************/

extern StructRNA RNA_NodeSocketString;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

#define NodeSocketString_default_value_MAX 1024

void NodeSocketString_default_value_get(PointerRNA *ptr, char *value);
int NodeSocketString_default_value_length(PointerRNA *ptr);
void NodeSocketString_default_value_set(PointerRNA *ptr, const char *value);

/**************** String Node Socket ****************/

extern StructRNA RNA_NodeSocketStringFilePath;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

#define NodeSocketStringFilePath_default_value_MAX 1024

void NodeSocketStringFilePath_default_value_get(PointerRNA *ptr, char *value);
int NodeSocketStringFilePath_default_value_length(PointerRNA *ptr);
void NodeSocketStringFilePath_default_value_set(PointerRNA *ptr, const char *value);

/**************** Texture Node Socket ****************/

extern StructRNA RNA_NodeSocketTexture;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

PointerRNA NodeSocketTexture_default_value_get(PointerRNA *ptr);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVector;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVector_default_value_get(PointerRNA *ptr, float values[3]);
void NodeSocketVector_default_value_set(PointerRNA *ptr, const float values[3]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVector2D;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVector2D_default_value_get(PointerRNA *ptr, float values[2]);
void NodeSocketVector2D_default_value_set(PointerRNA *ptr, const float values[2]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVector4D;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVector4D_default_value_get(PointerRNA *ptr, float values[4]);
void NodeSocketVector4D_default_value_set(PointerRNA *ptr, const float values[4]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorAcceleration;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorAcceleration_default_value_get(PointerRNA *ptr, float values[3]);
void NodeSocketVectorAcceleration_default_value_set(PointerRNA *ptr, const float values[3]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorAcceleration2D;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorAcceleration2D_default_value_get(PointerRNA *ptr, float values[2]);
void NodeSocketVectorAcceleration2D_default_value_set(PointerRNA *ptr, const float values[2]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorAcceleration4D;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorAcceleration4D_default_value_get(PointerRNA *ptr, float values[4]);
void NodeSocketVectorAcceleration4D_default_value_set(PointerRNA *ptr, const float values[4]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorDirection;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorDirection_default_value_get(PointerRNA *ptr, float values[3]);
void NodeSocketVectorDirection_default_value_set(PointerRNA *ptr, const float values[3]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorDirection2D;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorDirection2D_default_value_get(PointerRNA *ptr, float values[2]);
void NodeSocketVectorDirection2D_default_value_set(PointerRNA *ptr, const float values[2]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorDirection4D;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorDirection4D_default_value_get(PointerRNA *ptr, float values[4]);
void NodeSocketVectorDirection4D_default_value_set(PointerRNA *ptr, const float values[4]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorEuler;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorEuler_default_value_get(PointerRNA *ptr, float values[3]);
void NodeSocketVectorEuler_default_value_set(PointerRNA *ptr, const float values[3]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorEuler2D;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorEuler2D_default_value_get(PointerRNA *ptr, float values[2]);
void NodeSocketVectorEuler2D_default_value_set(PointerRNA *ptr, const float values[2]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorEuler4D;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorEuler4D_default_value_get(PointerRNA *ptr, float values[4]);
void NodeSocketVectorEuler4D_default_value_set(PointerRNA *ptr, const float values[4]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorFactor;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorFactor_default_value_get(PointerRNA *ptr, float values[3]);
void NodeSocketVectorFactor_default_value_set(PointerRNA *ptr, const float values[3]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorFactor2D;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorFactor2D_default_value_get(PointerRNA *ptr, float values[2]);
void NodeSocketVectorFactor2D_default_value_set(PointerRNA *ptr, const float values[2]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorFactor4D;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorFactor4D_default_value_get(PointerRNA *ptr, float values[4]);
void NodeSocketVectorFactor4D_default_value_set(PointerRNA *ptr, const float values[4]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorPercentage;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorPercentage_default_value_get(PointerRNA *ptr, float values[3]);
void NodeSocketVectorPercentage_default_value_set(PointerRNA *ptr, const float values[3]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorPercentage2D;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorPercentage2D_default_value_get(PointerRNA *ptr, float values[2]);
void NodeSocketVectorPercentage2D_default_value_set(PointerRNA *ptr, const float values[2]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorPercentage4D;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorPercentage4D_default_value_get(PointerRNA *ptr, float values[4]);
void NodeSocketVectorPercentage4D_default_value_set(PointerRNA *ptr, const float values[4]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorTranslation;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorTranslation_default_value_get(PointerRNA *ptr, float values[3]);
void NodeSocketVectorTranslation_default_value_set(PointerRNA *ptr, const float values[3]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorTranslation2D;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorTranslation2D_default_value_get(PointerRNA *ptr, float values[2]);
void NodeSocketVectorTranslation2D_default_value_set(PointerRNA *ptr, const float values[2]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorTranslation4D;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorTranslation4D_default_value_get(PointerRNA *ptr, float values[4]);
void NodeSocketVectorTranslation4D_default_value_set(PointerRNA *ptr, const float values[4]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorVelocity;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorVelocity_default_value_get(PointerRNA *ptr, float values[3]);
void NodeSocketVectorVelocity_default_value_set(PointerRNA *ptr, const float values[3]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorVelocity2D;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorVelocity2D_default_value_get(PointerRNA *ptr, float values[2]);
void NodeSocketVectorVelocity2D_default_value_set(PointerRNA *ptr, const float values[2]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorVelocity4D;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorVelocity4D_default_value_get(PointerRNA *ptr, float values[4]);
void NodeSocketVectorVelocity4D_default_value_set(PointerRNA *ptr, const float values[4]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorXYZ;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorXYZ_default_value_get(PointerRNA *ptr, float values[3]);
void NodeSocketVectorXYZ_default_value_set(PointerRNA *ptr, const float values[3]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorXYZ2D;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorXYZ2D_default_value_get(PointerRNA *ptr, float values[2]);
void NodeSocketVectorXYZ2D_default_value_set(PointerRNA *ptr, const float values[2]);

/**************** Vector Node Socket ****************/

extern StructRNA RNA_NodeSocketVectorXYZ4D;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

void NodeSocketVectorXYZ4D_default_value_get(PointerRNA *ptr, float values[4]);
void NodeSocketVectorXYZ4D_default_value_set(PointerRNA *ptr, const float values[4]);

/**************** Virtual Node Socket ****************/

extern StructRNA RNA_NodeSocketVirtual;
extern StructRNA RNA_NodeSocketStandard;
extern StructRNA RNA_NodeSocket;

/**************** Node Tree ****************/

extern StructRNA RNA_NodeTree;
extern StructRNA RNA_ID;

void NodeTree_view_center_get(PointerRNA *ptr, float values[2]);
void NodeTree_view_center_set(PointerRNA *ptr, const float values[2]);

PointerRNA NodeTree_animation_data_get(PointerRNA *ptr);

enum {
	NodeTree_color_tag_NONE = 0,
	NodeTree_color_tag_ATTRIBUTE = 1,
	NodeTree_color_tag_COLOR = 2,
	NodeTree_color_tag_CONVERTER = 3,
	NodeTree_color_tag_DISTORT = 4,
	NodeTree_color_tag_FILTER = 5,
	NodeTree_color_tag_GEOMETRY = 6,
	NodeTree_color_tag_INPUT = 7,
	NodeTree_color_tag_MATTE = 8,
	NodeTree_color_tag_OUTPUT = 9,
	NodeTree_color_tag_SCRIPT = 10,
	NodeTree_color_tag_SHADER = 11,
	NodeTree_color_tag_TEXTURE = 12,
	NodeTree_color_tag_VECTOR = 13,
	NodeTree_color_tag_PATTERN = 14,
	NodeTree_color_tag_INTERFACE = 15,
	NodeTree_color_tag_GROUP = 16,
};

int NodeTree_color_tag_get(PointerRNA *ptr);
void NodeTree_color_tag_set(PointerRNA *ptr, int value);

int NodeTree_default_group_node_width_get(PointerRNA *ptr);
void NodeTree_default_group_node_width_set(PointerRNA *ptr, int value);

void NodeTree_description_get(PointerRNA *ptr, char *value);
int NodeTree_description_length(PointerRNA *ptr);
void NodeTree_description_set(PointerRNA *ptr, const char *value);

PointerRNA NodeTree_grease_pencil_get(PointerRNA *ptr);

void NodeTree_bl_idname_get(PointerRNA *ptr, char *value);
int NodeTree_bl_idname_length(PointerRNA *ptr);
void NodeTree_bl_idname_set(PointerRNA *ptr, const char *value);

enum {
	NodeTree_bl_icon_NONE = 0,
	NodeTree_bl_icon_CHAR_NOTDEF = 1,
	NodeTree_bl_icon_CHAR_REPLACEMENT = 2,
	NodeTree_bl_icon_NOT_FOUND = 3,
	NodeTree_bl_icon_BLANK1 = 4,
	NodeTree_bl_icon_AUTOMERGE_OFF = 5,
	NodeTree_bl_icon_AUTOMERGE_ON = 6,
	NodeTree_bl_icon_CHECKBOX_DEHLT = 7,
	NodeTree_bl_icon_CHECKBOX_HLT = 8,
	NodeTree_bl_icon_CLIPUV_DEHLT = 9,
	NodeTree_bl_icon_CLIPUV_HLT = 10,
	NodeTree_bl_icon_DECORATE_UNLOCKED = 11,
	NodeTree_bl_icon_DECORATE_LOCKED = 12,
	NodeTree_bl_icon_FAKE_USER_OFF = 13,
	NodeTree_bl_icon_FAKE_USER_ON = 14,
	NodeTree_bl_icon_HIDE_ON = 15,
	NodeTree_bl_icon_HIDE_OFF = 16,
	NodeTree_bl_icon_INDIRECT_ONLY_OFF = 17,
	NodeTree_bl_icon_INDIRECT_ONLY_ON = 18,
	NodeTree_bl_icon_ONIONSKIN_OFF = 19,
	NodeTree_bl_icon_ONIONSKIN_ON = 20,
	NodeTree_bl_icon_UNPINNED = 21,
	NodeTree_bl_icon_PINNED = 22,
	NodeTree_bl_icon_RADIOBUT_OFF = 23,
	NodeTree_bl_icon_RADIOBUT_ON = 24,
	NodeTree_bl_icon_RECORD_OFF = 25,
	NodeTree_bl_icon_RECORD_ON = 26,
	NodeTree_bl_icon_RESTRICT_RENDER_ON = 27,
	NodeTree_bl_icon_RESTRICT_RENDER_OFF = 28,
	NodeTree_bl_icon_RESTRICT_SELECT_ON = 29,
	NodeTree_bl_icon_RESTRICT_SELECT_OFF = 30,
	NodeTree_bl_icon_RESTRICT_VIEW_ON = 31,
	NodeTree_bl_icon_RESTRICT_VIEW_OFF = 32,
	NodeTree_bl_icon_RIGHTARROW = 33,
	NodeTree_bl_icon_DOWNARROW_HLT = 34,
	NodeTree_bl_icon_SELECT_INTERSECT = 35,
	NodeTree_bl_icon_SELECT_DIFFERENCE = 36,
	NodeTree_bl_icon_SNAP_OFF = 37,
	NodeTree_bl_icon_SNAP_ON = 38,
	NodeTree_bl_icon_UNLOCKED = 39,
	NodeTree_bl_icon_LOCKED = 40,
	NodeTree_bl_icon_VIS_SEL_11 = 41,
	NodeTree_bl_icon_VIS_SEL_10 = 42,
	NodeTree_bl_icon_VIS_SEL_01 = 43,
	NodeTree_bl_icon_VIS_SEL_00 = 44,
	NodeTree_bl_icon_CANCEL = 45,
	NodeTree_bl_icon_ERROR = 46,
	NodeTree_bl_icon_QUESTION = 47,
	NodeTree_bl_icon_ADD = 48,
	NodeTree_bl_icon_ARROW_LEFTRIGHT = 49,
	NodeTree_bl_icon_AUTO = 50,
	NodeTree_bl_icon_BLENDER = 51,
	NodeTree_bl_icon_BORDERMOVE = 52,
	NodeTree_bl_icon_BRUSHES_ALL = 53,
	NodeTree_bl_icon_CHECKMARK = 54,
	NodeTree_bl_icon_COLLAPSEMENU = 55,
	NodeTree_bl_icon_COLLECTION_NEW = 56,
	NodeTree_bl_icon_COLOR = 57,
	NodeTree_bl_icon_COPY_ID = 58,
	NodeTree_bl_icon_DISCLOSURE_TRI_DOWN = 59,
	NodeTree_bl_icon_DISCLOSURE_TRI_RIGHT = 60,
	NodeTree_bl_icon_DOT = 61,
	NodeTree_bl_icon_DRIVER_DISTANCE = 62,
	NodeTree_bl_icon_DRIVER_ROTATIONAL_DIFFERENCE = 63,
	NodeTree_bl_icon_DRIVER_TRANSFORM = 64,
	NodeTree_bl_icon_DUPLICATE = 65,
	NodeTree_bl_icon_EYEDROPPER = 66,
	NodeTree_bl_icon_FCURVE_SNAPSHOT = 67,
	NodeTree_bl_icon_FILE_NEW = 68,
	NodeTree_bl_icon_FILE_TICK = 69,
	NodeTree_bl_icon_FREEZE = 70,
	NodeTree_bl_icon_FULLSCREEN_ENTER = 71,
	NodeTree_bl_icon_FULLSCREEN_EXIT = 72,
	NodeTree_bl_icon_GHOST_DISABLED = 73,
	NodeTree_bl_icon_GHOST_ENABLED = 74,
	NodeTree_bl_icon_GRIP = 75,
	NodeTree_bl_icon_GRIP_V = 76,
	NodeTree_bl_icon_HAND = 77,
	NodeTree_bl_icon_HELP = 78,
	NodeTree_bl_icon_LINKED = 79,
	NodeTree_bl_icon_MENU_PANEL = 80,
	NodeTree_bl_icon_NODE_SEL = 81,
	NodeTree_bl_icon_NODE = 82,
	NodeTree_bl_icon_OBJECT_HIDDEN = 83,
	NodeTree_bl_icon_OPTIONS = 84,
	NodeTree_bl_icon_PANEL_CLOSE = 85,
	NodeTree_bl_icon_PLUGIN = 86,
	NodeTree_bl_icon_PLUS = 87,
	NodeTree_bl_icon_PRESET_NEW = 88,
	NodeTree_bl_icon_QUIT = 89,
	NodeTree_bl_icon_RECOVER_LAST = 90,
	NodeTree_bl_icon_REMOVE = 91,
	NodeTree_bl_icon_RIGHTARROW_THIN = 92,
	NodeTree_bl_icon_SCREEN_BACK = 93,
	NodeTree_bl_icon_STATUSBAR = 94,
	NodeTree_bl_icon_STYLUS_PRESSURE = 95,
	NodeTree_bl_icon_THREE_DOTS = 96,
	NodeTree_bl_icon_TOPBAR = 97,
	NodeTree_bl_icon_TRASH = 98,
	NodeTree_bl_icon_TRIA_DOWN = 99,
	NodeTree_bl_icon_TRIA_LEFT = 100,
	NodeTree_bl_icon_TRIA_RIGHT = 101,
	NodeTree_bl_icon_TRIA_UP = 102,
	NodeTree_bl_icon_UNLINKED = 103,
	NodeTree_bl_icon_URL = 104,
	NodeTree_bl_icon_VIEWZOOM = 105,
	NodeTree_bl_icon_WINDOW = 106,
	NodeTree_bl_icon_WORKSPACE = 107,
	NodeTree_bl_icon_X = 108,
	NodeTree_bl_icon_ZOOM_ALL = 109,
	NodeTree_bl_icon_ZOOM_IN = 110,
	NodeTree_bl_icon_ZOOM_OUT = 111,
	NodeTree_bl_icon_ZOOM_PREVIOUS = 112,
	NodeTree_bl_icon_ZOOM_SELECTED = 113,
	NodeTree_bl_icon_MODIFIER = 114,
	NodeTree_bl_icon_PARTICLES = 115,
	NodeTree_bl_icon_PHYSICS = 116,
	NodeTree_bl_icon_SHADERFX = 117,
	NodeTree_bl_icon_SPEAKER = 118,
	NodeTree_bl_icon_OUTPUT = 119,
	NodeTree_bl_icon_SCENE = 120,
	NodeTree_bl_icon_TOOL_SETTINGS = 121,
	NodeTree_bl_icon_LIGHT = 122,
	NodeTree_bl_icon_MATERIAL = 123,
	NodeTree_bl_icon_TEXTURE = 124,
	NodeTree_bl_icon_WORLD = 125,
	NodeTree_bl_icon_ANIM = 126,
	NodeTree_bl_icon_SCRIPT = 127,
	NodeTree_bl_icon_GEOMETRY_NODES = 128,
	NodeTree_bl_icon_TEXT = 129,
	NodeTree_bl_icon_ACTION = 130,
	NodeTree_bl_icon_ASSET_MANAGER = 131,
	NodeTree_bl_icon_CONSOLE = 132,
	NodeTree_bl_icon_FILEBROWSER = 133,
	NodeTree_bl_icon_GEOMETRY_SET = 134,
	NodeTree_bl_icon_GRAPH = 135,
	NodeTree_bl_icon_IMAGE = 136,
	NodeTree_bl_icon_INFO = 137,
	NodeTree_bl_icon_NLA = 138,
	NodeTree_bl_icon_NODE_COMPOSITING = 139,
	NodeTree_bl_icon_NODE_MATERIAL = 140,
	NodeTree_bl_icon_NODE_TEXTURE = 141,
	NodeTree_bl_icon_NODETREE = 142,
	NodeTree_bl_icon_OUTLINER = 143,
	NodeTree_bl_icon_PREFERENCES = 144,
	NodeTree_bl_icon_PROPERTIES = 145,
	NodeTree_bl_icon_SEQUENCE = 146,
	NodeTree_bl_icon_SOUND = 147,
	NodeTree_bl_icon_SPREADSHEET = 148,
	NodeTree_bl_icon_TIME = 149,
	NodeTree_bl_icon_TRACKER = 150,
	NodeTree_bl_icon_UV = 151,
	NodeTree_bl_icon_VIEW3D = 152,
	NodeTree_bl_icon_EDITMODE_HLT = 153,
	NodeTree_bl_icon_OBJECT_DATAMODE = 154,
	NodeTree_bl_icon_PARTICLEMODE = 155,
	NodeTree_bl_icon_POSE_HLT = 156,
	NodeTree_bl_icon_SCULPTMODE_HLT = 157,
	NodeTree_bl_icon_TPAINT_HLT = 158,
	NodeTree_bl_icon_UV_DATA = 159,
	NodeTree_bl_icon_VPAINT_HLT = 160,
	NodeTree_bl_icon_WPAINT_HLT = 161,
	NodeTree_bl_icon_TRACKER_DATA = 162,
	NodeTree_bl_icon_TRACKING_BACKWARDS_SINGLE = 163,
	NodeTree_bl_icon_TRACKING_BACKWARDS = 164,
	NodeTree_bl_icon_TRACKING_CLEAR_BACKWARDS = 165,
	NodeTree_bl_icon_TRACKING_CLEAR_FORWARDS = 166,
	NodeTree_bl_icon_TRACKING_FORWARDS_SINGLE = 167,
	NodeTree_bl_icon_TRACKING_FORWARDS = 168,
	NodeTree_bl_icon_TRACKING_REFINE_BACKWARDS = 169,
	NodeTree_bl_icon_TRACKING_REFINE_FORWARDS = 170,
	NodeTree_bl_icon_TRACKING = 171,
	NodeTree_bl_icon_GROUP = 172,
	NodeTree_bl_icon_CONSTRAINT_BONE = 173,
	NodeTree_bl_icon_CONSTRAINT = 174,
	NodeTree_bl_icon_ARMATURE_DATA = 175,
	NodeTree_bl_icon_BONE_DATA = 176,
	NodeTree_bl_icon_CAMERA_DATA = 177,
	NodeTree_bl_icon_CURVE_DATA = 178,
	NodeTree_bl_icon_EMPTY_DATA = 179,
	NodeTree_bl_icon_FONT_DATA = 180,
	NodeTree_bl_icon_LATTICE_DATA = 181,
	NodeTree_bl_icon_LIGHT_DATA = 182,
	NodeTree_bl_icon_MESH_DATA = 183,
	NodeTree_bl_icon_META_DATA = 184,
	NodeTree_bl_icon_PARTICLE_DATA = 185,
	NodeTree_bl_icon_SHAPEKEY_DATA = 186,
	NodeTree_bl_icon_SURFACE_DATA = 187,
	NodeTree_bl_icon_OBJECT_DATA = 188,
	NodeTree_bl_icon_RENDER_RESULT = 189,
	NodeTree_bl_icon_RENDERLAYERS = 190,
	NodeTree_bl_icon_SCENE_DATA = 191,
	NodeTree_bl_icon_BRUSH_DATA = 192,
	NodeTree_bl_icon_IMAGE_DATA = 193,
	NodeTree_bl_icon_LINE_DATA = 194,
	NodeTree_bl_icon_MATERIAL_DATA = 195,
	NodeTree_bl_icon_TEXTURE_DATA = 196,
	NodeTree_bl_icon_WORLD_DATA = 197,
	NodeTree_bl_icon_ANIM_DATA = 198,
	NodeTree_bl_icon_BOIDS = 199,
	NodeTree_bl_icon_CAMERA_STEREO = 200,
	NodeTree_bl_icon_COMMUNITY = 201,
	NodeTree_bl_icon_FACE_MAPS = 202,
	NodeTree_bl_icon_FCURVE = 203,
	NodeTree_bl_icon_FILE = 204,
	NodeTree_bl_icon_GREASEPENCIL = 205,
	NodeTree_bl_icon_GREASEPENCIL_LAYER_GROUP = 206,
	NodeTree_bl_icon_GROUP_BONE = 207,
	NodeTree_bl_icon_GROUP_UVS = 208,
	NodeTree_bl_icon_GROUP_VCOL = 209,
	NodeTree_bl_icon_GROUP_VERTEX = 210,
	NodeTree_bl_icon_LIBRARY_DATA_BROKEN = 211,
	NodeTree_bl_icon_LIBRARY_DATA_DIRECT = 212,
	NodeTree_bl_icon_LIBRARY_DATA_OVERRIDE = 213,
	NodeTree_bl_icon_ORPHAN_DATA = 214,
	NodeTree_bl_icon_PACKAGE = 215,
	NodeTree_bl_icon_PRESET = 216,
	NodeTree_bl_icon_RENDER_ANIMATION = 217,
	NodeTree_bl_icon_RENDER_STILL = 218,
	NodeTree_bl_icon_RNA_ADD = 219,
	NodeTree_bl_icon_RNA = 220,
	NodeTree_bl_icon_STRANDS = 221,
	NodeTree_bl_icon_UGLYPACKAGE = 222,
	NodeTree_bl_icon_MOUSE_LMB = 223,
	NodeTree_bl_icon_MOUSE_MMB = 224,
	NodeTree_bl_icon_MOUSE_RMB = 225,
	NodeTree_bl_icon_MOUSE_MMB_SCROLL = 226,
	NodeTree_bl_icon_MOUSE_LMB_2X = 227,
	NodeTree_bl_icon_MOUSE_MOVE = 228,
	NodeTree_bl_icon_MOUSE_LMB_DRAG = 229,
	NodeTree_bl_icon_MOUSE_MMB_DRAG = 230,
	NodeTree_bl_icon_MOUSE_RMB_DRAG = 231,
	NodeTree_bl_icon_DECORATE_ANIMATE = 232,
	NodeTree_bl_icon_DECORATE_DRIVER = 233,
	NodeTree_bl_icon_DECORATE_KEYFRAME = 234,
	NodeTree_bl_icon_DECORATE_LIBRARY_OVERRIDE = 235,
	NodeTree_bl_icon_DECORATE_LINKED = 236,
	NodeTree_bl_icon_DECORATE_OVERRIDE = 237,
	NodeTree_bl_icon_DECORATE = 238,
	NodeTree_bl_icon_OUTLINER_COLLECTION = 239,
	NodeTree_bl_icon_CURVES_DATA = 240,
	NodeTree_bl_icon_OUTLINER_DATA_ARMATURE = 241,
	NodeTree_bl_icon_OUTLINER_DATA_CAMERA = 242,
	NodeTree_bl_icon_OUTLINER_DATA_CURVE = 243,
	NodeTree_bl_icon_OUTLINER_DATA_CURVES = 244,
	NodeTree_bl_icon_OUTLINER_DATA_EMPTY = 245,
	NodeTree_bl_icon_OUTLINER_DATA_FONT = 246,
	NodeTree_bl_icon_OUTLINER_DATA_GP_LAYER = 247,
	NodeTree_bl_icon_OUTLINER_DATA_GREASEPENCIL = 248,
	NodeTree_bl_icon_OUTLINER_DATA_LATTICE = 249,
	NodeTree_bl_icon_OUTLINER_DATA_LIGHT = 250,
	NodeTree_bl_icon_OUTLINER_DATA_LIGHTPROBE = 251,
	NodeTree_bl_icon_OUTLINER_DATA_MESH = 252,
	NodeTree_bl_icon_OUTLINER_DATA_META = 253,
	NodeTree_bl_icon_OUTLINER_DATA_POINTCLOUD = 254,
	NodeTree_bl_icon_OUTLINER_DATA_SPEAKER = 255,
	NodeTree_bl_icon_OUTLINER_DATA_SURFACE = 256,
	NodeTree_bl_icon_OUTLINER_DATA_VOLUME = 257,
	NodeTree_bl_icon_POINTCLOUD_DATA = 258,
	NodeTree_bl_icon_POINTCLOUD_POINT = 259,
	NodeTree_bl_icon_VOLUME_DATA = 260,
	NodeTree_bl_icon_OUTLINER_OB_ARMATURE = 261,
	NodeTree_bl_icon_OUTLINER_OB_CAMERA = 262,
	NodeTree_bl_icon_OUTLINER_OB_CURVE = 263,
	NodeTree_bl_icon_OUTLINER_OB_CURVES = 264,
	NodeTree_bl_icon_OUTLINER_OB_EMPTY = 265,
	NodeTree_bl_icon_OUTLINER_OB_FONT = 266,
	NodeTree_bl_icon_OUTLINER_OB_FORCE_FIELD = 267,
	NodeTree_bl_icon_OUTLINER_OB_GREASEPENCIL = 268,
	NodeTree_bl_icon_OUTLINER_OB_GROUP_INSTANCE = 269,
	NodeTree_bl_icon_OUTLINER_OB_IMAGE = 270,
	NodeTree_bl_icon_OUTLINER_OB_LATTICE = 271,
	NodeTree_bl_icon_OUTLINER_OB_LIGHT = 272,
	NodeTree_bl_icon_OUTLINER_OB_LIGHTPROBE = 273,
	NodeTree_bl_icon_OUTLINER_OB_MESH = 274,
	NodeTree_bl_icon_OUTLINER_OB_META = 275,
	NodeTree_bl_icon_OUTLINER_OB_POINTCLOUD = 276,
	NodeTree_bl_icon_OUTLINER_OB_SPEAKER = 277,
	NodeTree_bl_icon_OUTLINER_OB_SURFACE = 278,
	NodeTree_bl_icon_OUTLINER_OB_VOLUME = 279,
	NodeTree_bl_icon_GP_MULTIFRAME_EDITING = 280,
	NodeTree_bl_icon_GP_ONLY_SELECTED = 281,
	NodeTree_bl_icon_GP_SELECT_BETWEEN_STROKES = 282,
	NodeTree_bl_icon_GP_SELECT_POINTS = 283,
	NodeTree_bl_icon_GP_SELECT_STROKES = 284,
	NodeTree_bl_icon_HOLDOUT_OFF = 285,
	NodeTree_bl_icon_HOLDOUT_ON = 286,
	NodeTree_bl_icon_MODIFIER_OFF = 287,
	NodeTree_bl_icon_MODIFIER_ON = 288,
	NodeTree_bl_icon_RESTRICT_COLOR_OFF = 289,
	NodeTree_bl_icon_RESTRICT_COLOR_ON = 290,
	NodeTree_bl_icon_RESTRICT_INSTANCED_OFF = 291,
	NodeTree_bl_icon_RESTRICT_INSTANCED_ON = 292,
	NodeTree_bl_icon_LIGHT_AREA = 293,
	NodeTree_bl_icon_LIGHT_HEMI = 294,
	NodeTree_bl_icon_LIGHT_POINT = 295,
	NodeTree_bl_icon_LIGHT_SPOT = 296,
	NodeTree_bl_icon_LIGHT_SUN = 297,
	NodeTree_bl_icon_LIGHTPROBE_PLANE = 298,
	NodeTree_bl_icon_LIGHTPROBE_SPHERE = 299,
	NodeTree_bl_icon_LIGHTPROBE_VOLUME = 300,
	NodeTree_bl_icon_COLOR_BLUE = 301,
	NodeTree_bl_icon_COLOR_GREEN = 302,
	NodeTree_bl_icon_COLOR_RED = 303,
	NodeTree_bl_icon_CONE = 304,
	NodeTree_bl_icon_CUBE = 305,
	NodeTree_bl_icon_CURVE_BEZCIRCLE = 306,
	NodeTree_bl_icon_CURVE_BEZCURVE = 307,
	NodeTree_bl_icon_CURVE_NCIRCLE = 308,
	NodeTree_bl_icon_CURVE_NCURVE = 309,
	NodeTree_bl_icon_CURVE_PATH = 310,
	NodeTree_bl_icon_CURVES = 311,
	NodeTree_bl_icon_EMPTY_ARROWS = 312,
	NodeTree_bl_icon_EMPTY_AXIS = 313,
	NodeTree_bl_icon_EMPTY_SINGLE_ARROW = 314,
	NodeTree_bl_icon_MESH_CAPSULE = 315,
	NodeTree_bl_icon_MESH_CIRCLE = 316,
	NodeTree_bl_icon_MESH_CONE = 317,
	NodeTree_bl_icon_MESH_CUBE = 318,
	NodeTree_bl_icon_MESH_CYLINDER = 319,
	NodeTree_bl_icon_MESH_GRID = 320,
	NodeTree_bl_icon_MESH_ICOSPHERE = 321,
	NodeTree_bl_icon_MESH_MONKEY = 322,
	NodeTree_bl_icon_MESH_PLANE = 323,
	NodeTree_bl_icon_MESH_TORUS = 324,
	NodeTree_bl_icon_MESH_UVSPHERE = 325,
	NodeTree_bl_icon_META_BALL = 326,
	NodeTree_bl_icon_META_CAPSULE = 327,
	NodeTree_bl_icon_META_CUBE = 328,
	NodeTree_bl_icon_META_ELLIPSOID = 329,
	NodeTree_bl_icon_META_PLANE = 330,
	NodeTree_bl_icon_MONKEY = 331,
	NodeTree_bl_icon_SPHERE = 332,
	NodeTree_bl_icon_STROKE = 333,
	NodeTree_bl_icon_SURFACE_NCIRCLE = 334,
	NodeTree_bl_icon_SURFACE_NCURVE = 335,
	NodeTree_bl_icon_SURFACE_NCYLINDER = 336,
	NodeTree_bl_icon_SURFACE_NSPHERE = 337,
	NodeTree_bl_icon_SURFACE_NSURFACE = 338,
	NodeTree_bl_icon_SURFACE_NTORUS = 339,
	NodeTree_bl_icon_TRIA_DOWN_BAR = 340,
	NodeTree_bl_icon_TRIA_LEFT_BAR = 341,
	NodeTree_bl_icon_TRIA_RIGHT_BAR = 342,
	NodeTree_bl_icon_TRIA_UP_BAR = 343,
	NodeTree_bl_icon_AREA_DOCK = 344,
	NodeTree_bl_icon_AREA_JOIN_DOWN = 345,
	NodeTree_bl_icon_AREA_JOIN_LEFT = 346,
	NodeTree_bl_icon_AREA_JOIN_UP = 347,
	NodeTree_bl_icon_AREA_JOIN = 348,
	NodeTree_bl_icon_AREA_SWAP = 349,
	NodeTree_bl_icon_FORCE_BOID = 350,
	NodeTree_bl_icon_FORCE_CHARGE = 351,
	NodeTree_bl_icon_FORCE_CURVE = 352,
	NodeTree_bl_icon_FORCE_DRAG = 353,
	NodeTree_bl_icon_FORCE_FLUIDFLOW = 354,
	NodeTree_bl_icon_FORCE_FORCE = 355,
	NodeTree_bl_icon_FORCE_HARMONIC = 356,
	NodeTree_bl_icon_FORCE_LENNARDJONES = 357,
	NodeTree_bl_icon_FORCE_MAGNETIC = 358,
	NodeTree_bl_icon_FORCE_TEXTURE = 359,
	NodeTree_bl_icon_FORCE_TURBULENCE = 360,
	NodeTree_bl_icon_FORCE_VORTEX = 361,
	NodeTree_bl_icon_FORCE_WIND = 362,
	NodeTree_bl_icon_IMAGE_BACKGROUND = 363,
	NodeTree_bl_icon_IMAGE_PLANE = 364,
	NodeTree_bl_icon_IMAGE_REFERENCE = 365,
	NodeTree_bl_icon_RIGID_BODY_CONSTRAINT = 366,
	NodeTree_bl_icon_RIGID_BODY = 367,
	NodeTree_bl_icon_SPLIT_HORIZONTAL = 368,
	NodeTree_bl_icon_SPLIT_VERTICAL = 369,
	NodeTree_bl_icon_ANCHOR_BOTTOM = 370,
	NodeTree_bl_icon_ANCHOR_CENTER = 371,
	NodeTree_bl_icon_ANCHOR_LEFT = 372,
	NodeTree_bl_icon_ANCHOR_RIGHT = 373,
	NodeTree_bl_icon_ANCHOR_TOP = 374,
	NodeTree_bl_icon_NODE_CORNER = 375,
	NodeTree_bl_icon_NODE_INSERT_OFF = 376,
	NodeTree_bl_icon_NODE_INSERT_ON = 377,
	NodeTree_bl_icon_NODE_SIDE = 378,
	NodeTree_bl_icon_NODE_TOP = 379,
	NodeTree_bl_icon_SELECT_EXTEND = 380,
	NodeTree_bl_icon_SELECT_SET = 381,
	NodeTree_bl_icon_SELECT_SUBTRACT = 382,
	NodeTree_bl_icon_ALIGN_BOTTOM = 383,
	NodeTree_bl_icon_ALIGN_CENTER = 384,
	NodeTree_bl_icon_ALIGN_FLUSH = 385,
	NodeTree_bl_icon_ALIGN_JUSTIFY = 386,
	NodeTree_bl_icon_ALIGN_LEFT = 387,
	NodeTree_bl_icon_ALIGN_MIDDLE = 388,
	NodeTree_bl_icon_ALIGN_RIGHT = 389,
	NodeTree_bl_icon_ALIGN_TOP = 390,
	NodeTree_bl_icon_BOLD = 391,
	NodeTree_bl_icon_ITALIC = 392,
	NodeTree_bl_icon_LINENUMBERS_OFF = 393,
	NodeTree_bl_icon_LINENUMBERS_ON = 394,
	NodeTree_bl_icon_SCRIPTPLUGINS = 395,
	NodeTree_bl_icon_SMALL_CAPS = 396,
	NodeTree_bl_icon_SYNTAX_OFF = 397,
	NodeTree_bl_icon_SYNTAX_ON = 398,
	NodeTree_bl_icon_UNDERLINE = 399,
	NodeTree_bl_icon_WORDWRAP_OFF = 400,
	NodeTree_bl_icon_WORDWRAP_ON = 401,
	NodeTree_bl_icon_CON_ACTION = 402,
	NodeTree_bl_icon_CON_ARMATURE = 403,
	NodeTree_bl_icon_CON_CAMERASOLVER = 404,
	NodeTree_bl_icon_CON_CHILDOF = 405,
	NodeTree_bl_icon_CON_CLAMPTO = 406,
	NodeTree_bl_icon_CON_DISTLIMIT = 407,
	NodeTree_bl_icon_CON_FLOOR = 408,
	NodeTree_bl_icon_CON_FOLLOWPATH = 409,
	NodeTree_bl_icon_CON_FOLLOWTRACK = 410,
	NodeTree_bl_icon_CON_KINEMATIC = 411,
	NodeTree_bl_icon_CON_LOCKTRACK = 412,
	NodeTree_bl_icon_CON_LOCLIKE = 413,
	NodeTree_bl_icon_CON_LOCLIMIT = 414,
	NodeTree_bl_icon_CON_OBJECTSOLVER = 415,
	NodeTree_bl_icon_CON_PIVOT = 416,
	NodeTree_bl_icon_CON_ROTLIKE = 417,
	NodeTree_bl_icon_CON_ROTLIMIT = 418,
	NodeTree_bl_icon_CON_SAMEVOL = 419,
	NodeTree_bl_icon_CON_SHRINKWRAP = 420,
	NodeTree_bl_icon_CON_SIZELIKE = 421,
	NodeTree_bl_icon_CON_SIZELIMIT = 422,
	NodeTree_bl_icon_CON_SPLINEIK = 423,
	NodeTree_bl_icon_CON_STRETCHTO = 424,
	NodeTree_bl_icon_CON_TRACKTO = 425,
	NodeTree_bl_icon_CON_TRANSFORM_CACHE = 426,
	NodeTree_bl_icon_CON_TRANSFORM = 427,
	NodeTree_bl_icon_CON_TRANSLIKE = 428,
	NodeTree_bl_icon_HOOK = 429,
	NodeTree_bl_icon_MOD_ARMATURE = 430,
	NodeTree_bl_icon_MOD_ARRAY = 431,
	NodeTree_bl_icon_MOD_BEVEL = 432,
	NodeTree_bl_icon_MOD_BOOLEAN = 433,
	NodeTree_bl_icon_MOD_BUILD = 434,
	NodeTree_bl_icon_MOD_CAST = 435,
	NodeTree_bl_icon_MOD_CLOTH = 436,
	NodeTree_bl_icon_MOD_CURVE = 437,
	NodeTree_bl_icon_MOD_DASH = 438,
	NodeTree_bl_icon_MOD_DATA_TRANSFER = 439,
	NodeTree_bl_icon_MOD_DECIM = 440,
	NodeTree_bl_icon_MOD_DISPLACE = 441,
	NodeTree_bl_icon_MOD_DYNAMICPAINT = 442,
	NodeTree_bl_icon_MOD_EDGESPLIT = 443,
	NodeTree_bl_icon_MOD_ENVELOPE = 444,
	NodeTree_bl_icon_MOD_EXPLODE = 445,
	NodeTree_bl_icon_MOD_FLUID = 446,
	NodeTree_bl_icon_MOD_FLUIDSIM = 447,
	NodeTree_bl_icon_MOD_HUE_SATURATION = 448,
	NodeTree_bl_icon_MOD_INSTANCE = 449,
	NodeTree_bl_icon_MOD_LATTICE = 450,
	NodeTree_bl_icon_MOD_LENGTH = 451,
	NodeTree_bl_icon_MOD_LINEART = 452,
	NodeTree_bl_icon_MOD_MASK = 453,
	NodeTree_bl_icon_MOD_MESHDEFORM = 454,
	NodeTree_bl_icon_MOD_MIRROR = 455,
	NodeTree_bl_icon_MOD_MULTIRES = 456,
	NodeTree_bl_icon_MOD_NOISE = 457,
	NodeTree_bl_icon_MOD_NORMALEDIT = 458,
	NodeTree_bl_icon_MOD_OCEAN = 459,
	NodeTree_bl_icon_MOD_OFFSET = 460,
	NodeTree_bl_icon_MOD_OPACITY = 461,
	NodeTree_bl_icon_MOD_OUTLINE = 462,
	NodeTree_bl_icon_MOD_PARTICLE_INSTANCE = 463,
	NodeTree_bl_icon_MOD_PARTICLES = 464,
	NodeTree_bl_icon_MOD_PHYSICS = 465,
	NodeTree_bl_icon_MOD_REMESH = 466,
	NodeTree_bl_icon_MOD_SCREW = 467,
	NodeTree_bl_icon_MOD_SHRINKWRAP = 468,
	NodeTree_bl_icon_MOD_SIMPLEDEFORM = 469,
	NodeTree_bl_icon_MOD_SIMPLIFY = 470,
	NodeTree_bl_icon_MOD_SKIN = 471,
	NodeTree_bl_icon_MOD_SMOOTH = 472,
	NodeTree_bl_icon_MOD_SOFT = 473,
	NodeTree_bl_icon_MOD_SOLIDIFY = 474,
	NodeTree_bl_icon_MOD_SUBSURF = 475,
	NodeTree_bl_icon_MOD_THICKNESS = 476,
	NodeTree_bl_icon_MOD_TIME = 477,
	NodeTree_bl_icon_MOD_TINT = 478,
	NodeTree_bl_icon_MOD_TRIANGULATE = 479,
	NodeTree_bl_icon_MOD_UVPROJECT = 480,
	NodeTree_bl_icon_MOD_VERTEX_WEIGHT = 481,
	NodeTree_bl_icon_MOD_WARP = 482,
	NodeTree_bl_icon_MOD_WAVE = 483,
	NodeTree_bl_icon_MOD_WIREFRAME = 484,
	NodeTree_bl_icon_MODIFIER_DATA = 485,
	NodeTree_bl_icon_ACTION_SLOT = 486,
	NodeTree_bl_icon_ACTION_TWEAK = 487,
	NodeTree_bl_icon_DRIVER = 488,
	NodeTree_bl_icon_FF = 489,
	NodeTree_bl_icon_FRAME_NEXT = 490,
	NodeTree_bl_icon_FRAME_PREV = 491,
	NodeTree_bl_icon_HANDLE_ALIGNED = 492,
	NodeTree_bl_icon_HANDLE_AUTO = 493,
	NodeTree_bl_icon_HANDLE_AUTOCLAMPED = 494,
	NodeTree_bl_icon_HANDLE_FREE = 495,
	NodeTree_bl_icon_HANDLE_VECTOR = 496,
	NodeTree_bl_icon_IPO_BACK = 497,
	NodeTree_bl_icon_IPO_BEZIER = 498,
	NodeTree_bl_icon_IPO_BOUNCE = 499,
	NodeTree_bl_icon_IPO_CIRC = 500,
	NodeTree_bl_icon_IPO_CONSTANT = 501,
	NodeTree_bl_icon_IPO_CUBIC = 502,
	NodeTree_bl_icon_IPO_EASE_IN_OUT = 503,
	NodeTree_bl_icon_IPO_EASE_IN = 504,
	NodeTree_bl_icon_IPO_EASE_OUT = 505,
	NodeTree_bl_icon_IPO_ELASTIC = 506,
	NodeTree_bl_icon_IPO_EXPO = 507,
	NodeTree_bl_icon_IPO_LINEAR = 508,
	NodeTree_bl_icon_IPO_QUAD = 509,
	NodeTree_bl_icon_IPO_QUART = 510,
	NodeTree_bl_icon_IPO_QUINT = 511,
	NodeTree_bl_icon_IPO_SINE = 512,
	NodeTree_bl_icon_KEY_DEHLT = 513,
	NodeTree_bl_icon_KEY_HLT = 514,
	NodeTree_bl_icon_KEYFRAME_HLT = 515,
	NodeTree_bl_icon_KEYFRAME = 516,
	NodeTree_bl_icon_KEYINGSET = 517,
	NodeTree_bl_icon_MARKER_HLT = 518,
	NodeTree_bl_icon_MARKER = 519,
	NodeTree_bl_icon_MUTE_IPO_OFF = 520,
	NodeTree_bl_icon_MUTE_IPO_ON = 521,
	NodeTree_bl_icon_NEXT_KEYFRAME = 522,
	NodeTree_bl_icon_NLA_PUSHDOWN = 523,
	NodeTree_bl_icon_NORMALIZE_FCURVES = 524,
	NodeTree_bl_icon_ORIENTATION_PARENT = 525,
	NodeTree_bl_icon_PAUSE = 526,
	NodeTree_bl_icon_PLAY_REVERSE = 527,
	NodeTree_bl_icon_PLAY_SOUND = 528,
	NodeTree_bl_icon_PLAY = 529,
	NodeTree_bl_icon_PMARKER_ACT = 530,
	NodeTree_bl_icon_PMARKER_SEL = 531,
	NodeTree_bl_icon_PMARKER = 532,
	NodeTree_bl_icon_PREV_KEYFRAME = 533,
	NodeTree_bl_icon_PREVIEW_RANGE = 534,
	NodeTree_bl_icon_REC = 535,
	NodeTree_bl_icon_REW = 536,
	NodeTree_bl_icon_SOLO_OFF = 537,
	NodeTree_bl_icon_SOLO_ON = 538,
	NodeTree_bl_icon_CENTER_ONLY = 539,
	NodeTree_bl_icon_CURSOR = 540,
	NodeTree_bl_icon_EDGESEL = 541,
	NodeTree_bl_icon_FACE_CORNER = 542,
	NodeTree_bl_icon_FACESEL = 543,
	NodeTree_bl_icon_INVERSESQUARECURVE = 544,
	NodeTree_bl_icon_LINCURVE = 545,
	NodeTree_bl_icon_NOCURVE = 546,
	NodeTree_bl_icon_PARTICLE_PATH = 547,
	NodeTree_bl_icon_PARTICLE_POINT = 548,
	NodeTree_bl_icon_PARTICLE_TIP = 549,
	NodeTree_bl_icon_PIVOT_ACTIVE = 550,
	NodeTree_bl_icon_PIVOT_BOUNDBOX = 551,
	NodeTree_bl_icon_PIVOT_CURSOR = 552,
	NodeTree_bl_icon_PIVOT_INDIVIDUAL = 553,
	NodeTree_bl_icon_PIVOT_MEDIAN = 554,
	NodeTree_bl_icon_PROP_CON = 555,
	NodeTree_bl_icon_PROP_OFF = 556,
	NodeTree_bl_icon_PROP_ON = 557,
	NodeTree_bl_icon_PROP_PROJECTED = 558,
	NodeTree_bl_icon_RNDCURVE = 559,
	NodeTree_bl_icon_ROOTCURVE = 560,
	NodeTree_bl_icon_SHARPCURVE = 561,
	NodeTree_bl_icon_SMOOTHCURVE = 562,
	NodeTree_bl_icon_SPHERECURVE = 563,
	NodeTree_bl_icon_VERTEXSEL = 564,
	NodeTree_bl_icon_SNAP_EDGE = 565,
	NodeTree_bl_icon_SNAP_FACE_CENTER = 566,
	NodeTree_bl_icon_SNAP_FACE_NEAREST = 567,
	NodeTree_bl_icon_SNAP_FACE = 568,
	NodeTree_bl_icon_SNAP_GRID = 569,
	NodeTree_bl_icon_SNAP_INCREMENT = 570,
	NodeTree_bl_icon_SNAP_MIDPOINT = 571,
	NodeTree_bl_icon_SNAP_NORMAL = 572,
	NodeTree_bl_icon_SNAP_PEEL_OBJECT = 573,
	NodeTree_bl_icon_SNAP_PERPENDICULAR = 574,
	NodeTree_bl_icon_SNAP_VERTEX = 575,
	NodeTree_bl_icon_SNAP_VOLUME = 576,
	NodeTree_bl_icon_STICKY_UVS_DISABLE = 577,
	NodeTree_bl_icon_STICKY_UVS_LOC = 578,
	NodeTree_bl_icon_STICKY_UVS_VERT = 579,
	NodeTree_bl_icon_ORIENTATION_GIMBAL = 580,
	NodeTree_bl_icon_ORIENTATION_GLOBAL = 581,
	NodeTree_bl_icon_ORIENTATION_LOCAL = 582,
	NodeTree_bl_icon_ORIENTATION_NORMAL = 583,
	NodeTree_bl_icon_ORIENTATION_VIEW = 584,
	NodeTree_bl_icon_COPYDOWN = 585,
	NodeTree_bl_icon_FIXED_SIZE = 586,
	NodeTree_bl_icon_GIZMO = 587,
	NodeTree_bl_icon_GP_CAPS_FLAT = 588,
	NodeTree_bl_icon_GP_CAPS_ROUND = 589,
	NodeTree_bl_icon_NORMALS_FACE = 590,
	NodeTree_bl_icon_NORMALS_VERTEX_FACE = 591,
	NodeTree_bl_icon_NORMALS_VERTEX = 592,
	NodeTree_bl_icon_OBJECT_ORIGIN = 593,
	NodeTree_bl_icon_ORIENTATION_CURSOR = 594,
	NodeTree_bl_icon_PASTEDOWN = 595,
	NodeTree_bl_icon_PASTEFLIPDOWN = 596,
	NodeTree_bl_icon_PASTEFLIPUP = 597,
	NodeTree_bl_icon_TRANSFORM_ORIGINS = 598,
	NodeTree_bl_icon_UV_EDGESEL = 599,
	NodeTree_bl_icon_UV_FACESEL = 600,
	NodeTree_bl_icon_UV_ISLANDSEL = 601,
	NodeTree_bl_icon_UV_SYNC_SELECT = 602,
	NodeTree_bl_icon_UV_VERTEXSEL = 603,
	NodeTree_bl_icon_AXIS_FRONT = 604,
	NodeTree_bl_icon_AXIS_SIDE = 605,
	NodeTree_bl_icon_AXIS_TOP = 606,
	NodeTree_bl_icon_GRID = 607,
	NodeTree_bl_icon_LAYER_ACTIVE = 608,
	NodeTree_bl_icon_LAYER_USED = 609,
	NodeTree_bl_icon_LOCKVIEW_OFF = 610,
	NodeTree_bl_icon_LOCKVIEW_ON = 611,
	NodeTree_bl_icon_OVERLAY = 612,
	NodeTree_bl_icon_SHADING_BBOX = 613,
	NodeTree_bl_icon_SHADING_RENDERED = 614,
	NodeTree_bl_icon_SHADING_SOLID = 615,
	NodeTree_bl_icon_SHADING_TEXTURE = 616,
	NodeTree_bl_icon_SHADING_WIRE = 617,
	NodeTree_bl_icon_XRAY = 618,
	NodeTree_bl_icon_VIEW_CAMERA_UNSELECTED = 619,
	NodeTree_bl_icon_VIEW_CAMERA = 620,
	NodeTree_bl_icon_VIEW_LOCKED = 621,
	NodeTree_bl_icon_VIEW_ORTHO = 622,
	NodeTree_bl_icon_VIEW_PAN = 623,
	NodeTree_bl_icon_VIEW_PERSPECTIVE = 624,
	NodeTree_bl_icon_VIEW_UNLOCKED = 625,
	NodeTree_bl_icon_VIEW_ZOOM = 626,
	NodeTree_bl_icon_FILE_ALIAS = 627,
	NodeTree_bl_icon_FILE_FOLDER = 628,
	NodeTree_bl_icon_FOLDER_REDIRECT = 629,
	NodeTree_bl_icon_APPEND_BLEND = 630,
	NodeTree_bl_icon_BACK = 631,
	NodeTree_bl_icon_BOOKMARKS = 632,
	NodeTree_bl_icon_CURRENT_FILE = 633,
	NodeTree_bl_icon_DESKTOP = 634,
	NodeTree_bl_icon_DISC = 635,
	NodeTree_bl_icon_DISK_DRIVE = 636,
	NodeTree_bl_icon_DOCUMENTS = 637,
	NodeTree_bl_icon_EXPORT = 638,
	NodeTree_bl_icon_EXTERNAL_DRIVE = 639,
	NodeTree_bl_icon_FILE_3D = 640,
	NodeTree_bl_icon_FILE_ARCHIVE = 641,
	NodeTree_bl_icon_FILE_BACKUP = 642,
	NodeTree_bl_icon_FILE_BLANK = 643,
	NodeTree_bl_icon_FILE_BLEND = 644,
	NodeTree_bl_icon_FILE_CACHE = 645,
	NodeTree_bl_icon_FILE_FONT = 646,
	NodeTree_bl_icon_FILE_HIDDEN = 647,
	NodeTree_bl_icon_FILE_IMAGE = 648,
	NodeTree_bl_icon_FILE_MOVIE = 649,
	NodeTree_bl_icon_FILE_PARENT = 650,
	NodeTree_bl_icon_FILE_REFRESH = 651,
	NodeTree_bl_icon_FILE_SCRIPT = 652,
	NodeTree_bl_icon_FILE_SOUND = 653,
	NodeTree_bl_icon_FILE_TEXT = 654,
	NodeTree_bl_icon_FILE_VOLUME = 655,
	NodeTree_bl_icon_FILTER = 656,
	NodeTree_bl_icon_FONTPREVIEW = 657,
	NodeTree_bl_icon_FORWARD = 658,
	NodeTree_bl_icon_HOME = 659,
	NodeTree_bl_icon_IMGDISPLAY = 660,
	NodeTree_bl_icon_IMPORT = 661,
	NodeTree_bl_icon_LINK_BLEND = 662,
	NodeTree_bl_icon_LONGDISPLAY = 663,
	NodeTree_bl_icon_LOOP_BACK = 664,
	NodeTree_bl_icon_LOOP_FORWARDS = 665,
	NodeTree_bl_icon_NETWORK_DRIVE = 666,
	NodeTree_bl_icon_NEWFOLDER = 667,
	NodeTree_bl_icon_PREVIEW_LOADING = 668,
	NodeTree_bl_icon_SETTINGS = 669,
	NodeTree_bl_icon_SHORTDISPLAY = 670,
	NodeTree_bl_icon_SORT_ASC = 671,
	NodeTree_bl_icon_SORT_DESC = 672,
	NodeTree_bl_icon_SORTALPHA = 673,
	NodeTree_bl_icon_SORTBYEXT = 674,
	NodeTree_bl_icon_SORTSIZE = 675,
	NodeTree_bl_icon_SORTTIME = 676,
	NodeTree_bl_icon_SYSTEM = 677,
	NodeTree_bl_icon_TAG = 678,
	NodeTree_bl_icon_TEMP = 679,
	NodeTree_bl_icon_ALIASED = 680,
	NodeTree_bl_icon_ANTIALIASED = 681,
	NodeTree_bl_icon_MAT_SPHERE_SKY = 682,
	NodeTree_bl_icon_MATCLOTH = 683,
	NodeTree_bl_icon_MATCUBE = 684,
	NodeTree_bl_icon_MATFLUID = 685,
	NodeTree_bl_icon_MATPLANE = 686,
	NodeTree_bl_icon_MATSHADERBALL = 687,
	NodeTree_bl_icon_MATSPHERE = 688,
	NodeTree_bl_icon_SEQ_CHROMA_SCOPE = 689,
	NodeTree_bl_icon_SEQ_HISTOGRAM = 690,
	NodeTree_bl_icon_SEQ_LUMA_WAVEFORM = 691,
	NodeTree_bl_icon_SEQ_PREVIEW = 692,
	NodeTree_bl_icon_SEQ_SEQUENCER = 693,
	NodeTree_bl_icon_SEQ_SPLITVIEW = 694,
	NodeTree_bl_icon_SEQ_STRIP_DUPLICATE = 695,
	NodeTree_bl_icon_SEQ_STRIP_META = 696,
	NodeTree_bl_icon_IMAGE_ALPHA = 697,
	NodeTree_bl_icon_IMAGE_RGB_ALPHA = 698,
	NodeTree_bl_icon_IMAGE_RGB = 699,
	NodeTree_bl_icon_IMAGE_ZDEPTH = 700,
	NodeTree_bl_icon_BLENDER_LOGO_LARGE = 701,
	NodeTree_bl_icon_CANCEL_LARGE = 702,
	NodeTree_bl_icon_DISC_LARGE = 703,
	NodeTree_bl_icon_DISK_DRIVE_LARGE = 704,
	NodeTree_bl_icon_EXTERNAL_DRIVE_LARGE = 705,
	NodeTree_bl_icon_FILE_FOLDER_LARGE = 706,
	NodeTree_bl_icon_FILE_LARGE = 707,
	NodeTree_bl_icon_FILE_PARENT_LARGE = 708,
	NodeTree_bl_icon_INFO_LARGE = 709,
	NodeTree_bl_icon_NETWORK_DRIVE_LARGE = 710,
	NodeTree_bl_icon_QUESTION_LARGE = 711,
	NodeTree_bl_icon_WARNING_LARGE = 712,
	NodeTree_bl_icon_KEY_BACKSPACE_FILLED = 713,
	NodeTree_bl_icon_KEY_BACKSPACE = 714,
	NodeTree_bl_icon_KEY_COMMAND_FILLED = 715,
	NodeTree_bl_icon_KEY_COMMAND = 716,
	NodeTree_bl_icon_KEY_CONTROL_FILLED = 717,
	NodeTree_bl_icon_KEY_CONTROL = 718,
	NodeTree_bl_icon_KEY_EMPTY1_FILLED = 719,
	NodeTree_bl_icon_KEY_EMPTY1 = 720,
	NodeTree_bl_icon_KEY_EMPTY2_FILLED = 721,
	NodeTree_bl_icon_KEY_EMPTY2 = 722,
	NodeTree_bl_icon_KEY_EMPTY3_FILLED = 723,
	NodeTree_bl_icon_KEY_EMPTY3 = 724,
	NodeTree_bl_icon_KEY_MENU_FILLED = 725,
	NodeTree_bl_icon_KEY_MENU = 726,
	NodeTree_bl_icon_KEY_OPTION_FILLED = 727,
	NodeTree_bl_icon_KEY_OPTION = 728,
	NodeTree_bl_icon_KEY_RETURN_FILLED = 729,
	NodeTree_bl_icon_KEY_RETURN = 730,
	NodeTree_bl_icon_KEY_RING_FILLED = 731,
	NodeTree_bl_icon_KEY_RING = 732,
	NodeTree_bl_icon_KEY_SHIFT_FILLED = 733,
	NodeTree_bl_icon_KEY_SHIFT = 734,
	NodeTree_bl_icon_KEY_TAB_FILLED = 735,
	NodeTree_bl_icon_KEY_TAB = 736,
	NodeTree_bl_icon_KEY_WINDOWS_FILLED = 737,
	NodeTree_bl_icon_KEY_WINDOWS = 738,
	NodeTree_bl_icon_GESTURE_PAN = 739,
	NodeTree_bl_icon_GESTURE_ROTATE = 740,
	NodeTree_bl_icon_GESTURE_ZOOM = 741,
	NodeTree_bl_icon_FUND = 742,
	NodeTree_bl_icon_HEART = 743,
	NodeTree_bl_icon_INTERNET_OFFLINE = 744,
	NodeTree_bl_icon_INTERNET = 745,
	NodeTree_bl_icon_USER = 746,
	NodeTree_bl_icon_EXPERIMENTAL = 747,
	NodeTree_bl_icon_MEMORY = 748,
	NodeTree_bl_icon_RGB_RED = 750,
	NodeTree_bl_icon_RGB_GREEN = 751,
	NodeTree_bl_icon_RGB_BLUE = 752,
	NodeTree_bl_icon_KEYTYPE_KEYFRAME_VEC = 753,
	NodeTree_bl_icon_KEYTYPE_BREAKDOWN_VEC = 754,
	NodeTree_bl_icon_KEYTYPE_EXTREME_VEC = 755,
	NodeTree_bl_icon_KEYTYPE_JITTER_VEC = 756,
	NodeTree_bl_icon_KEYTYPE_MOVING_HOLD_VEC = 757,
	NodeTree_bl_icon_KEYTYPE_GENERATED_VEC = 758,
	NodeTree_bl_icon_HANDLETYPE_FREE_VEC = 759,
	NodeTree_bl_icon_HANDLETYPE_ALIGNED_VEC = 760,
	NodeTree_bl_icon_HANDLETYPE_VECTOR_VEC = 761,
	NodeTree_bl_icon_HANDLETYPE_AUTO_VEC = 762,
	NodeTree_bl_icon_HANDLETYPE_AUTO_CLAMP_VEC = 763,
	NodeTree_bl_icon_COLORSET_01_VEC = 764,
	NodeTree_bl_icon_COLORSET_02_VEC = 765,
	NodeTree_bl_icon_COLORSET_03_VEC = 766,
	NodeTree_bl_icon_COLORSET_04_VEC = 767,
	NodeTree_bl_icon_COLORSET_05_VEC = 768,
	NodeTree_bl_icon_COLORSET_06_VEC = 769,
	NodeTree_bl_icon_COLORSET_07_VEC = 770,
	NodeTree_bl_icon_COLORSET_08_VEC = 771,
	NodeTree_bl_icon_COLORSET_09_VEC = 772,
	NodeTree_bl_icon_COLORSET_10_VEC = 773,
	NodeTree_bl_icon_COLORSET_11_VEC = 774,
	NodeTree_bl_icon_COLORSET_12_VEC = 775,
	NodeTree_bl_icon_COLORSET_13_VEC = 776,
	NodeTree_bl_icon_COLORSET_14_VEC = 777,
	NodeTree_bl_icon_COLORSET_15_VEC = 778,
	NodeTree_bl_icon_COLORSET_16_VEC = 779,
	NodeTree_bl_icon_COLORSET_17_VEC = 780,
	NodeTree_bl_icon_COLORSET_18_VEC = 781,
	NodeTree_bl_icon_COLORSET_19_VEC = 782,
	NodeTree_bl_icon_COLORSET_20_VEC = 783,
	NodeTree_bl_icon_COLLECTION_COLOR_01 = 784,
	NodeTree_bl_icon_COLLECTION_COLOR_02 = 785,
	NodeTree_bl_icon_COLLECTION_COLOR_03 = 786,
	NodeTree_bl_icon_COLLECTION_COLOR_04 = 787,
	NodeTree_bl_icon_COLLECTION_COLOR_05 = 788,
	NodeTree_bl_icon_COLLECTION_COLOR_06 = 789,
	NodeTree_bl_icon_COLLECTION_COLOR_07 = 790,
	NodeTree_bl_icon_COLLECTION_COLOR_08 = 791,
	NodeTree_bl_icon_STRIP_COLOR_01 = 792,
	NodeTree_bl_icon_STRIP_COLOR_02 = 793,
	NodeTree_bl_icon_STRIP_COLOR_03 = 794,
	NodeTree_bl_icon_STRIP_COLOR_04 = 795,
	NodeTree_bl_icon_STRIP_COLOR_05 = 796,
	NodeTree_bl_icon_STRIP_COLOR_06 = 797,
	NodeTree_bl_icon_STRIP_COLOR_07 = 798,
	NodeTree_bl_icon_STRIP_COLOR_08 = 799,
	NodeTree_bl_icon_STRIP_COLOR_09 = 800,
	NodeTree_bl_icon_LIBRARY_DATA_INDIRECT = 801,
	NodeTree_bl_icon_LIBRARY_DATA_OVERRIDE_NONEDITABLE = 802,
	NodeTree_bl_icon_LAYERGROUP_COLOR_01 = 803,
	NodeTree_bl_icon_LAYERGROUP_COLOR_02 = 804,
	NodeTree_bl_icon_LAYERGROUP_COLOR_03 = 805,
	NodeTree_bl_icon_LAYERGROUP_COLOR_04 = 806,
	NodeTree_bl_icon_LAYERGROUP_COLOR_05 = 807,
	NodeTree_bl_icon_LAYERGROUP_COLOR_06 = 808,
	NodeTree_bl_icon_LAYERGROUP_COLOR_07 = 809,
	NodeTree_bl_icon_LAYERGROUP_COLOR_08 = 810,
	NodeTree_bl_icon_EVENT_A = 811,
	NodeTree_bl_icon_EVENT_B = 812,
	NodeTree_bl_icon_EVENT_C = 813,
	NodeTree_bl_icon_EVENT_D = 814,
	NodeTree_bl_icon_EVENT_E = 815,
	NodeTree_bl_icon_EVENT_F = 816,
	NodeTree_bl_icon_EVENT_G = 817,
	NodeTree_bl_icon_EVENT_H = 818,
	NodeTree_bl_icon_EVENT_I = 819,
	NodeTree_bl_icon_EVENT_J = 820,
	NodeTree_bl_icon_EVENT_K = 821,
	NodeTree_bl_icon_EVENT_L = 822,
	NodeTree_bl_icon_EVENT_M = 823,
	NodeTree_bl_icon_EVENT_N = 824,
	NodeTree_bl_icon_EVENT_O = 825,
	NodeTree_bl_icon_EVENT_P = 826,
	NodeTree_bl_icon_EVENT_Q = 827,
	NodeTree_bl_icon_EVENT_R = 828,
	NodeTree_bl_icon_EVENT_S = 829,
	NodeTree_bl_icon_EVENT_T = 830,
	NodeTree_bl_icon_EVENT_U = 831,
	NodeTree_bl_icon_EVENT_V = 832,
	NodeTree_bl_icon_EVENT_W = 833,
	NodeTree_bl_icon_EVENT_X = 834,
	NodeTree_bl_icon_EVENT_Y = 835,
	NodeTree_bl_icon_EVENT_Z = 836,
	NodeTree_bl_icon_EVENT_SHIFT = 837,
	NodeTree_bl_icon_EVENT_CTRL = 838,
	NodeTree_bl_icon_EVENT_ALT = 839,
	NodeTree_bl_icon_EVENT_OS = 840,
	NodeTree_bl_icon_EVENT_HYPER = 841,
	NodeTree_bl_icon_EVENT_F1 = 842,
	NodeTree_bl_icon_EVENT_F2 = 843,
	NodeTree_bl_icon_EVENT_F3 = 844,
	NodeTree_bl_icon_EVENT_F4 = 845,
	NodeTree_bl_icon_EVENT_F5 = 846,
	NodeTree_bl_icon_EVENT_F6 = 847,
	NodeTree_bl_icon_EVENT_F7 = 848,
	NodeTree_bl_icon_EVENT_F8 = 849,
	NodeTree_bl_icon_EVENT_F9 = 850,
	NodeTree_bl_icon_EVENT_F10 = 851,
	NodeTree_bl_icon_EVENT_F11 = 852,
	NodeTree_bl_icon_EVENT_F12 = 853,
	NodeTree_bl_icon_EVENT_F13 = 854,
	NodeTree_bl_icon_EVENT_F14 = 855,
	NodeTree_bl_icon_EVENT_F15 = 856,
	NodeTree_bl_icon_EVENT_F16 = 857,
	NodeTree_bl_icon_EVENT_F17 = 858,
	NodeTree_bl_icon_EVENT_F18 = 859,
	NodeTree_bl_icon_EVENT_F19 = 860,
	NodeTree_bl_icon_EVENT_F20 = 861,
	NodeTree_bl_icon_EVENT_F21 = 862,
	NodeTree_bl_icon_EVENT_F22 = 863,
	NodeTree_bl_icon_EVENT_F23 = 864,
	NodeTree_bl_icon_EVENT_F24 = 865,
	NodeTree_bl_icon_EVENT_ESC = 866,
	NodeTree_bl_icon_EVENT_TAB = 867,
	NodeTree_bl_icon_EVENT_PAGEUP = 868,
	NodeTree_bl_icon_EVENT_PAGEDOWN = 869,
	NodeTree_bl_icon_EVENT_RETURN = 870,
	NodeTree_bl_icon_EVENT_SPACEKEY = 871,
	NodeTree_bl_icon_EVENT_ZEROKEY = 872,
	NodeTree_bl_icon_EVENT_ONEKEY = 873,
	NodeTree_bl_icon_EVENT_TWOKEY = 874,
	NodeTree_bl_icon_EVENT_THREEKEY = 875,
	NodeTree_bl_icon_EVENT_FOURKEY = 876,
	NodeTree_bl_icon_EVENT_FIVEKEY = 877,
	NodeTree_bl_icon_EVENT_SIXKEY = 878,
	NodeTree_bl_icon_EVENT_SEVENKEY = 879,
	NodeTree_bl_icon_EVENT_EIGHTKEY = 880,
	NodeTree_bl_icon_EVENT_NINEKEY = 881,
	NodeTree_bl_icon_EVENT_PAD0 = 882,
	NodeTree_bl_icon_EVENT_PAD1 = 883,
	NodeTree_bl_icon_EVENT_PAD2 = 884,
	NodeTree_bl_icon_EVENT_PAD3 = 885,
	NodeTree_bl_icon_EVENT_PAD4 = 886,
	NodeTree_bl_icon_EVENT_PAD5 = 887,
	NodeTree_bl_icon_EVENT_PAD6 = 888,
	NodeTree_bl_icon_EVENT_PAD7 = 889,
	NodeTree_bl_icon_EVENT_PAD8 = 890,
	NodeTree_bl_icon_EVENT_PAD9 = 891,
	NodeTree_bl_icon_EVENT_PADASTER = 892,
	NodeTree_bl_icon_EVENT_PADSLASH = 893,
	NodeTree_bl_icon_EVENT_PADMINUS = 894,
	NodeTree_bl_icon_EVENT_PADENTER = 895,
	NodeTree_bl_icon_EVENT_PADPLUS = 896,
	NodeTree_bl_icon_EVENT_PADPERIOD = 897,
	NodeTree_bl_icon_EVENT_MOUSE_4 = 898,
	NodeTree_bl_icon_EVENT_MOUSE_5 = 899,
	NodeTree_bl_icon_EVENT_MOUSE_6 = 900,
	NodeTree_bl_icon_EVENT_MOUSE_7 = 901,
	NodeTree_bl_icon_EVENT_TABLET_STYLUS = 902,
	NodeTree_bl_icon_EVENT_TABLET_ERASER = 903,
	NodeTree_bl_icon_EVENT_LEFT_ARROW = 904,
	NodeTree_bl_icon_EVENT_DOWN_ARROW = 905,
	NodeTree_bl_icon_EVENT_RIGHT_ARROW = 906,
	NodeTree_bl_icon_EVENT_UP_ARROW = 907,
	NodeTree_bl_icon_EVENT_PAUSE = 908,
	NodeTree_bl_icon_EVENT_INSERT = 909,
	NodeTree_bl_icon_EVENT_HOME = 910,
	NodeTree_bl_icon_EVENT_END = 911,
	NodeTree_bl_icon_EVENT_UNKNOWN = 912,
	NodeTree_bl_icon_EVENT_GRLESS = 913,
	NodeTree_bl_icon_EVENT_MEDIAPLAY = 914,
	NodeTree_bl_icon_EVENT_MEDIASTOP = 915,
	NodeTree_bl_icon_EVENT_MEDIAFIRST = 916,
	NodeTree_bl_icon_EVENT_MEDIALAST = 917,
	NodeTree_bl_icon_EVENT_APP = 918,
	NodeTree_bl_icon_EVENT_CAPSLOCK = 919,
	NodeTree_bl_icon_EVENT_BACKSPACE = 920,
	NodeTree_bl_icon_EVENT_DEL = 921,
	NodeTree_bl_icon_EVENT_SEMICOLON = 922,
	NodeTree_bl_icon_EVENT_PERIOD = 923,
	NodeTree_bl_icon_EVENT_COMMA = 924,
	NodeTree_bl_icon_EVENT_QUOTE = 925,
	NodeTree_bl_icon_EVENT_ACCENTGRAVE = 926,
	NodeTree_bl_icon_EVENT_MINUS = 927,
	NodeTree_bl_icon_EVENT_PLUS = 928,
	NodeTree_bl_icon_EVENT_SLASH = 929,
	NodeTree_bl_icon_EVENT_BACKSLASH = 930,
	NodeTree_bl_icon_EVENT_EQUAL = 931,
	NodeTree_bl_icon_EVENT_LEFTBRACKET = 932,
	NodeTree_bl_icon_EVENT_RIGHTBRACKET = 933,
	NodeTree_bl_icon_EVENT_PAD_PAN = 934,
	NodeTree_bl_icon_EVENT_PAD_ROTATE = 935,
	NodeTree_bl_icon_EVENT_PAD_ZOOM = 936,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_V1 = 937,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_V2 = 938,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_V3 = 939,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_SAVE_V1 = 940,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_SAVE_V2 = 941,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_SAVE_V3 = 942,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_1 = 943,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_2 = 944,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_3 = 945,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_4 = 946,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_5 = 947,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_6 = 948,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_7 = 949,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_8 = 950,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_9 = 951,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_10 = 952,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_11 = 953,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_12 = 954,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_MENU = 955,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_FIT = 956,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_TOP = 957,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_BOTTOM = 958,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_LEFT = 959,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_RIGHT = 960,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_FRONT = 961,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_BACK = 962,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_ISO1 = 963,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_ISO2 = 964,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_ROLL_CW = 965,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_ROLL_CCW = 966,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_SPIN_CW = 967,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_SPIN_CCW = 968,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_TILT_CW = 969,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_TILT_CCW = 970,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_ROTATE = 971,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_PANZOOM = 972,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_DOMINANT = 973,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_PLUS = 974,
	NodeTree_bl_icon_EVENT_NDOF_BUTTON_MINUS = 975,
	NodeTree_bl_icon_NODE_SOCKET_FLOAT = 976,
	NodeTree_bl_icon_NODE_SOCKET_VECTOR = 977,
	NodeTree_bl_icon_NODE_SOCKET_RGBA = 978,
	NodeTree_bl_icon_NODE_SOCKET_SHADER = 979,
	NodeTree_bl_icon_NODE_SOCKET_BOOLEAN = 980,
	NodeTree_bl_icon_NODE_SOCKET_INT = 981,
	NodeTree_bl_icon_NODE_SOCKET_STRING = 982,
	NodeTree_bl_icon_NODE_SOCKET_OBJECT = 983,
	NodeTree_bl_icon_NODE_SOCKET_IMAGE = 984,
	NodeTree_bl_icon_NODE_SOCKET_GEOMETRY = 985,
	NodeTree_bl_icon_NODE_SOCKET_COLLECTION = 986,
	NodeTree_bl_icon_NODE_SOCKET_TEXTURE = 987,
	NodeTree_bl_icon_NODE_SOCKET_MATERIAL = 988,
	NodeTree_bl_icon_NODE_SOCKET_ROTATION = 989,
	NodeTree_bl_icon_NODE_SOCKET_MENU = 990,
	NodeTree_bl_icon_NODE_SOCKET_MATRIX = 991,
	NodeTree_bl_icon_NODE_SOCKET_BUNDLE = 992,
	NodeTree_bl_icon_NODE_SOCKET_CLOSURE = 993,
};

int NodeTree_bl_icon_get(PointerRNA *ptr);
void NodeTree_bl_icon_set(PointerRNA *ptr, int value);

PointerRNA NodeTree_interface_get(PointerRNA *ptr);

void NodeTree_bl_label_get(PointerRNA *ptr, char *value);
int NodeTree_bl_label_length(PointerRNA *ptr);
void NodeTree_bl_label_set(PointerRNA *ptr, const char *value);

void NodeTree_links_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void NodeTree_links_next(CollectionPropertyIterator *iter);
void NodeTree_links_end(CollectionPropertyIterator *iter);
bool NodeTree_links_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

void NodeTree_nodes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void NodeTree_nodes_next(CollectionPropertyIterator *iter);
void NodeTree_nodes_end(CollectionPropertyIterator *iter);
bool NodeTree_nodes_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool NodeTree_nodes_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

enum {
	NodeTree_type_UNDEFINED = -2,
	NodeTree_type_CUSTOM = -1,
	NodeTree_type_SHADER = 0,
	NodeTree_type_TEXTURE = 2,
	NodeTree_type_COMPOSITING = 1,
	NodeTree_type_GEOMETRY = 3,
};

int NodeTree_type_get(PointerRNA *ptr);
void NodeTree_type_set(PointerRNA *ptr, int value);

bool NodeTree_bl_use_group_interface_get(PointerRNA *ptr);
void NodeTree_bl_use_group_interface_set(PointerRNA *ptr, bool value);

void NodeTree_bl_description_get(PointerRNA *ptr, char *value);
int NodeTree_bl_description_length(PointerRNA *ptr);
void NodeTree_bl_description_set(PointerRNA *ptr, const char *value);

void NodeTree_interface_update_func(struct bNodeTree *_self, struct bContext *context);
bool NodeTree_contains_tree_func(struct bNodeTree *_self, struct bNodeTree *sub_tree);
bool NodeTree_poll_func(struct bContext *context);
void NodeTree_update_func(struct bNodeTree *_self);
void NodeTree_get_from_context_func(struct bContext *context, struct bNodeTree **result_1, struct ID **result_2, struct ID **result_3);
bool NodeTree_valid_socket_type_func(char * idname);
void NodeTree_debug_lazy_function_graph_func(struct bNodeTree *_self, bContext *C, int *dot_graph_num, const char * *dot_graph);
/**************** Node Tree Interface ****************/

extern StructRNA RNA_NodeTreeInterface;

PointerRNA NodeTreeInterface_rna_type_get(PointerRNA *ptr);

PointerRNA NodeTreeInterface_active_get(PointerRNA *ptr);

int NodeTreeInterface_active_index_get(PointerRNA *ptr);
void NodeTreeInterface_active_index_set(PointerRNA *ptr, int value);

void NodeTreeInterface_items_tree_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void NodeTreeInterface_items_tree_next(CollectionPropertyIterator *iter);
void NodeTreeInterface_items_tree_end(CollectionPropertyIterator *iter);
int NodeTreeInterface_items_tree_length(PointerRNA *ptr);
bool NodeTreeInterface_items_tree_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool NodeTreeInterface_items_tree_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

struct bNodeTreeInterfaceSocket *NodeTreeInterface_new_socket_func(struct ID *_selfid, struct bNodeTreeInterface *_self, Main *bmain, ReportList *reports, const char * name, const char * description, int in_out, int socket_type, struct bNodeTreeInterfacePanel *parent);
struct bNodeTreeInterfacePanel *NodeTreeInterface_new_panel_func(struct ID *_selfid, struct bNodeTreeInterface *_self, Main *bmain, ReportList *reports, const char * name, const char * description, bool default_closed);
struct bNodeTreeInterfaceItem *NodeTreeInterface_copy_func(struct ID *_selfid, struct bNodeTreeInterface *_self, Main *bmain, ReportList *reports, struct bNodeTreeInterfaceItem *item);
void NodeTreeInterface_remove_func(struct ID *_selfid, struct bNodeTreeInterface *_self, Main *bmain, struct bNodeTreeInterfaceItem *item, bool move_content_to_parent);
void NodeTreeInterface_clear_func(struct ID *_selfid, struct bNodeTreeInterface *_self, Main *bmain);
void NodeTreeInterface_move_func(struct ID *_selfid, struct bNodeTreeInterface *_self, Main *bmain, struct bNodeTreeInterfaceItem *item, int to_position);
void NodeTreeInterface_move_to_parent_func(struct ID *_selfid, struct bNodeTreeInterface *_self, Main *bmain, ReportList *reports, struct bNodeTreeInterfaceItem *item, struct bNodeTreeInterfacePanel *parent, int to_position);
/**************** Node Tree Interface Item ****************/

extern StructRNA RNA_NodeTreeInterfaceItem;

PointerRNA NodeTreeInterfaceItem_rna_type_get(PointerRNA *ptr);

int NodeTreeInterfaceItem_index_get(PointerRNA *ptr);
void NodeTreeInterfaceItem_index_set(PointerRNA *ptr, int value);

enum {
	NodeTreeInterfaceItem_item_type_SOCKET = 1,
	NodeTreeInterfaceItem_item_type_PANEL = 0,
};

int NodeTreeInterfaceItem_item_type_get(PointerRNA *ptr);
void NodeTreeInterfaceItem_item_type_set(PointerRNA *ptr, int value);

PointerRNA NodeTreeInterfaceItem_parent_get(PointerRNA *ptr);

int NodeTreeInterfaceItem_position_get(PointerRNA *ptr);
void NodeTreeInterfaceItem_position_set(PointerRNA *ptr, int value);

/**************** Node Tree Interface Item ****************/

extern StructRNA RNA_NodeTreeInterfacePanel;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfacePanel_name_get(PointerRNA *ptr, char *value);
int NodeTreeInterfacePanel_name_length(PointerRNA *ptr);
void NodeTreeInterfacePanel_name_set(PointerRNA *ptr, const char *value);

bool NodeTreeInterfacePanel_default_closed_get(PointerRNA *ptr);
void NodeTreeInterfacePanel_default_closed_set(PointerRNA *ptr, bool value);

void NodeTreeInterfacePanel_description_get(PointerRNA *ptr, char *value);
int NodeTreeInterfacePanel_description_length(PointerRNA *ptr);
void NodeTreeInterfacePanel_description_set(PointerRNA *ptr, const char *value);

void NodeTreeInterfacePanel_interface_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void NodeTreeInterfacePanel_interface_items_next(CollectionPropertyIterator *iter);
void NodeTreeInterfacePanel_interface_items_end(CollectionPropertyIterator *iter);
int NodeTreeInterfacePanel_interface_items_length(PointerRNA *ptr);
bool NodeTreeInterfacePanel_interface_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

int NodeTreeInterfacePanel_persistent_uid_get(PointerRNA *ptr);
void NodeTreeInterfacePanel_persistent_uid_set(PointerRNA *ptr, int value);

/**************** Node Tree Interface Socket ****************/

extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocket_name_get(PointerRNA *ptr, char *value);
int NodeTreeInterfaceSocket_name_length(PointerRNA *ptr);
void NodeTreeInterfaceSocket_name_set(PointerRNA *ptr, const char *value);

enum {
	NodeTreeInterfaceSocket_attribute_domain_POINT = 0,
	NodeTreeInterfaceSocket_attribute_domain_EDGE = 1,
	NodeTreeInterfaceSocket_attribute_domain_FACE = 2,
	NodeTreeInterfaceSocket_attribute_domain_CORNER = 3,
	NodeTreeInterfaceSocket_attribute_domain_CURVE = 4,
	NodeTreeInterfaceSocket_attribute_domain_INSTANCE = 5,
	NodeTreeInterfaceSocket_attribute_domain_LAYER = 6,
};

int NodeTreeInterfaceSocket_attribute_domain_get(PointerRNA *ptr);
void NodeTreeInterfaceSocket_attribute_domain_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocket_default_attribute_name_get(PointerRNA *ptr, char *value);
int NodeTreeInterfaceSocket_default_attribute_name_length(PointerRNA *ptr);
void NodeTreeInterfaceSocket_default_attribute_name_set(PointerRNA *ptr, const char *value);

enum {
	NodeTreeInterfaceSocket_default_input_VALUE = 0,
	NodeTreeInterfaceSocket_default_input_INDEX = 1,
	NodeTreeInterfaceSocket_default_input_ID_OR_INDEX = 2,
	NodeTreeInterfaceSocket_default_input_NORMAL = 3,
	NodeTreeInterfaceSocket_default_input_POSITION = 4,
	NodeTreeInterfaceSocket_default_input_INSTANCE_TRANSFORM = 5,
	NodeTreeInterfaceSocket_default_input_HANDLE_LEFT = 6,
	NodeTreeInterfaceSocket_default_input_HANDLE_RIGHT = 7,
};

int NodeTreeInterfaceSocket_default_input_get(PointerRNA *ptr);
void NodeTreeInterfaceSocket_default_input_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocket_description_get(PointerRNA *ptr, char *value);
int NodeTreeInterfaceSocket_description_length(PointerRNA *ptr);
void NodeTreeInterfaceSocket_description_set(PointerRNA *ptr, const char *value);

bool NodeTreeInterfaceSocket_hide_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocket_hide_value_set(PointerRNA *ptr, bool value);

bool NodeTreeInterfaceSocket_hide_in_modifier_get(PointerRNA *ptr);
void NodeTreeInterfaceSocket_hide_in_modifier_set(PointerRNA *ptr, bool value);

void NodeTreeInterfaceSocket_identifier_get(PointerRNA *ptr, char *value);
int NodeTreeInterfaceSocket_identifier_length(PointerRNA *ptr);
void NodeTreeInterfaceSocket_identifier_set(PointerRNA *ptr, const char *value);

enum {
	NodeTreeInterfaceSocket_in_out_INPUT = 1,
	NodeTreeInterfaceSocket_in_out_OUTPUT = 2,
};

int NodeTreeInterfaceSocket_in_out_get(PointerRNA *ptr);
void NodeTreeInterfaceSocket_in_out_set(PointerRNA *ptr, int value);

bool NodeTreeInterfaceSocket_is_inspect_output_get(PointerRNA *ptr);
void NodeTreeInterfaceSocket_is_inspect_output_set(PointerRNA *ptr, bool value);

bool NodeTreeInterfaceSocket_is_panel_toggle_get(PointerRNA *ptr);
void NodeTreeInterfaceSocket_is_panel_toggle_set(PointerRNA *ptr, bool value);

bool NodeTreeInterfaceSocket_layer_selection_field_get(PointerRNA *ptr);
void NodeTreeInterfaceSocket_layer_selection_field_set(PointerRNA *ptr, bool value);

bool NodeTreeInterfaceSocket_menu_expanded_get(PointerRNA *ptr);
void NodeTreeInterfaceSocket_menu_expanded_set(PointerRNA *ptr, bool value);

bool NodeTreeInterfaceSocket_force_non_field_get(PointerRNA *ptr);
void NodeTreeInterfaceSocket_force_non_field_set(PointerRNA *ptr, bool value);

enum {
	NodeTreeInterfaceSocket_socket_type_DEFAULT = 0,
};

int NodeTreeInterfaceSocket_socket_type_get(PointerRNA *ptr);
void NodeTreeInterfaceSocket_socket_type_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocket_bl_socket_idname_get(PointerRNA *ptr, char *value);
int NodeTreeInterfaceSocket_bl_socket_idname_length(PointerRNA *ptr);
void NodeTreeInterfaceSocket_bl_socket_idname_set(PointerRNA *ptr, const char *value);

enum {
	NodeTreeInterfaceSocket_structure_type_AUTO = 0,
	NodeTreeInterfaceSocket_structure_type_SINGLE = 1,
	NodeTreeInterfaceSocket_structure_type_DYNAMIC = 2,
	NodeTreeInterfaceSocket_structure_type_FIELD = 3,
	NodeTreeInterfaceSocket_structure_type_GRID = 4,
};

int NodeTreeInterfaceSocket_structure_type_get(PointerRNA *ptr);
void NodeTreeInterfaceSocket_structure_type_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocket_draw_func(struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocket_init_socket_func(struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocket_from_socket_func(struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Boolean Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketBool;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

bool NodeTreeInterfaceSocketBool_default_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketBool_default_value_set(PointerRNA *ptr, bool value);

void NodeTreeInterfaceSocketBool_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketBool_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketBool_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Bundle Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketBundle;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketBundle_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketBundle_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketBundle_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Closure Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketClosure;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketClosure_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketClosure_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketClosure_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Collection Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketCollection;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

PointerRNA NodeTreeInterfaceSocketCollection_default_value_get(PointerRNA *ptr);

void NodeTreeInterfaceSocketCollection_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketCollection_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketCollection_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Color Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketColor;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketColor_default_value_get(PointerRNA *ptr, float values[4]);
void NodeTreeInterfaceSocketColor_default_value_set(PointerRNA *ptr, const float values[4]);

void NodeTreeInterfaceSocketColor_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketColor_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketColor_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Float Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketFloat;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

float NodeTreeInterfaceSocketFloat_default_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloat_default_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloat_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloat_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloat_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloat_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketFloat_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketFloat_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloat_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketFloat_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketFloat_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketFloat_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Float Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketFloatAngle;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

float NodeTreeInterfaceSocketFloatAngle_default_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatAngle_default_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatAngle_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatAngle_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatAngle_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatAngle_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketFloatAngle_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketFloatAngle_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatAngle_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketFloatAngle_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketFloatAngle_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketFloatAngle_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Float Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketFloatColorTemperature;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

float NodeTreeInterfaceSocketFloatColorTemperature_default_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatColorTemperature_default_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatColorTemperature_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatColorTemperature_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatColorTemperature_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatColorTemperature_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketFloatColorTemperature_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketFloatColorTemperature_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatColorTemperature_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketFloatColorTemperature_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketFloatColorTemperature_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketFloatColorTemperature_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Float Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketFloatDistance;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

float NodeTreeInterfaceSocketFloatDistance_default_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatDistance_default_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatDistance_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatDistance_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatDistance_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatDistance_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketFloatDistance_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketFloatDistance_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatDistance_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketFloatDistance_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketFloatDistance_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketFloatDistance_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Float Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketFloatFactor;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

float NodeTreeInterfaceSocketFloatFactor_default_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatFactor_default_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatFactor_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatFactor_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatFactor_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatFactor_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketFloatFactor_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketFloatFactor_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatFactor_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketFloatFactor_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketFloatFactor_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketFloatFactor_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Float Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketFloatFrequency;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

float NodeTreeInterfaceSocketFloatFrequency_default_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatFrequency_default_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatFrequency_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatFrequency_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatFrequency_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatFrequency_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketFloatFrequency_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketFloatFrequency_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatFrequency_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketFloatFrequency_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketFloatFrequency_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketFloatFrequency_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Float Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketFloatPercentage;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

float NodeTreeInterfaceSocketFloatPercentage_default_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatPercentage_default_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatPercentage_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatPercentage_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatPercentage_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatPercentage_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketFloatPercentage_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketFloatPercentage_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatPercentage_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketFloatPercentage_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketFloatPercentage_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketFloatPercentage_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Float Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketFloatTime;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

float NodeTreeInterfaceSocketFloatTime_default_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatTime_default_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatTime_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatTime_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatTime_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatTime_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketFloatTime_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketFloatTime_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatTime_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketFloatTime_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketFloatTime_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketFloatTime_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Float Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketFloatTimeAbsolute;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

float NodeTreeInterfaceSocketFloatTimeAbsolute_default_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatTimeAbsolute_default_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatTimeAbsolute_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatTimeAbsolute_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatTimeAbsolute_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatTimeAbsolute_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketFloatTimeAbsolute_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketFloatTimeAbsolute_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatTimeAbsolute_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketFloatTimeAbsolute_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketFloatTimeAbsolute_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketFloatTimeAbsolute_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Float Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketFloatUnsigned;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

float NodeTreeInterfaceSocketFloatUnsigned_default_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatUnsigned_default_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatUnsigned_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatUnsigned_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatUnsigned_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatUnsigned_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketFloatUnsigned_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketFloatUnsigned_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatUnsigned_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketFloatUnsigned_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketFloatUnsigned_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketFloatUnsigned_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Float Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketFloatWavelength;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

float NodeTreeInterfaceSocketFloatWavelength_default_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatWavelength_default_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatWavelength_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatWavelength_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketFloatWavelength_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatWavelength_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketFloatWavelength_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketFloatWavelength_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketFloatWavelength_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketFloatWavelength_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketFloatWavelength_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketFloatWavelength_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Geometry Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketGeometry;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketGeometry_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketGeometry_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketGeometry_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Image Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketImage;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

PointerRNA NodeTreeInterfaceSocketImage_default_value_get(PointerRNA *ptr);

void NodeTreeInterfaceSocketImage_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketImage_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketImage_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Integer Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketInt;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

int NodeTreeInterfaceSocketInt_default_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketInt_default_value_set(PointerRNA *ptr, int value);

int NodeTreeInterfaceSocketInt_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketInt_max_value_set(PointerRNA *ptr, int value);

int NodeTreeInterfaceSocketInt_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketInt_min_value_set(PointerRNA *ptr, int value);

enum {
	NodeTreeInterfaceSocketInt_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketInt_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketInt_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketInt_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketInt_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketInt_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Integer Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketIntFactor;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

int NodeTreeInterfaceSocketIntFactor_default_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketIntFactor_default_value_set(PointerRNA *ptr, int value);

int NodeTreeInterfaceSocketIntFactor_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketIntFactor_max_value_set(PointerRNA *ptr, int value);

int NodeTreeInterfaceSocketIntFactor_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketIntFactor_min_value_set(PointerRNA *ptr, int value);

enum {
	NodeTreeInterfaceSocketIntFactor_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketIntFactor_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketIntFactor_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketIntFactor_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketIntFactor_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketIntFactor_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Integer Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketIntPercentage;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

int NodeTreeInterfaceSocketIntPercentage_default_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketIntPercentage_default_value_set(PointerRNA *ptr, int value);

int NodeTreeInterfaceSocketIntPercentage_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketIntPercentage_max_value_set(PointerRNA *ptr, int value);

int NodeTreeInterfaceSocketIntPercentage_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketIntPercentage_min_value_set(PointerRNA *ptr, int value);

enum {
	NodeTreeInterfaceSocketIntPercentage_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketIntPercentage_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketIntPercentage_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketIntPercentage_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketIntPercentage_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketIntPercentage_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Integer Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketIntUnsigned;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

int NodeTreeInterfaceSocketIntUnsigned_default_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketIntUnsigned_default_value_set(PointerRNA *ptr, int value);

int NodeTreeInterfaceSocketIntUnsigned_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketIntUnsigned_max_value_set(PointerRNA *ptr, int value);

int NodeTreeInterfaceSocketIntUnsigned_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketIntUnsigned_min_value_set(PointerRNA *ptr, int value);

enum {
	NodeTreeInterfaceSocketIntUnsigned_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketIntUnsigned_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketIntUnsigned_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketIntUnsigned_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketIntUnsigned_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketIntUnsigned_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Material Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketMaterial;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

PointerRNA NodeTreeInterfaceSocketMaterial_default_value_get(PointerRNA *ptr);

void NodeTreeInterfaceSocketMaterial_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketMaterial_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketMaterial_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Matrix Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketMatrix;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketMatrix_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketMatrix_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketMatrix_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Menu Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketMenu;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

int NodeTreeInterfaceSocketMenu_default_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketMenu_default_value_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketMenu_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketMenu_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketMenu_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Object Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketObject;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

PointerRNA NodeTreeInterfaceSocketObject_default_value_get(PointerRNA *ptr);

void NodeTreeInterfaceSocketObject_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketObject_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketObject_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Rotation Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketRotation;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketRotation_default_value_get(PointerRNA *ptr, float values[3]);
void NodeTreeInterfaceSocketRotation_default_value_set(PointerRNA *ptr, const float values[3]);

void NodeTreeInterfaceSocketRotation_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketRotation_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketRotation_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Shader Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketShader;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketShader_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketShader_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketShader_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** String Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketString;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

#define NodeTreeInterfaceSocketString_default_value_MAX 1024

void NodeTreeInterfaceSocketString_default_value_get(PointerRNA *ptr, char *value);
int NodeTreeInterfaceSocketString_default_value_length(PointerRNA *ptr);
void NodeTreeInterfaceSocketString_default_value_set(PointerRNA *ptr, const char *value);

enum {
	NodeTreeInterfaceSocketString_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketString_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketString_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketString_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketString_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketString_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** String Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketStringFilePath;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

#define NodeTreeInterfaceSocketStringFilePath_default_value_MAX 1024

void NodeTreeInterfaceSocketStringFilePath_default_value_get(PointerRNA *ptr, char *value);
int NodeTreeInterfaceSocketStringFilePath_default_value_length(PointerRNA *ptr);
void NodeTreeInterfaceSocketStringFilePath_default_value_set(PointerRNA *ptr, const char *value);

enum {
	NodeTreeInterfaceSocketStringFilePath_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketStringFilePath_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketStringFilePath_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketStringFilePath_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketStringFilePath_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketStringFilePath_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Texture Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketTexture;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

PointerRNA NodeTreeInterfaceSocketTexture_default_value_get(PointerRNA *ptr);

void NodeTreeInterfaceSocketTexture_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketTexture_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketTexture_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVector;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVector_default_value_get(PointerRNA *ptr, float values[3]);
void NodeTreeInterfaceSocketVector_default_value_set(PointerRNA *ptr, const float values[3]);

int NodeTreeInterfaceSocketVector_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVector_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVector_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVector_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVector_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVector_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVector_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVector_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVector_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVector_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVector_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVector_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVector2D;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVector2D_default_value_get(PointerRNA *ptr, float values[2]);
void NodeTreeInterfaceSocketVector2D_default_value_set(PointerRNA *ptr, const float values[2]);

int NodeTreeInterfaceSocketVector2D_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVector2D_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVector2D_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVector2D_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVector2D_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVector2D_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVector2D_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVector2D_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVector2D_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVector2D_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVector2D_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVector2D_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVector4D;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVector4D_default_value_get(PointerRNA *ptr, float values[4]);
void NodeTreeInterfaceSocketVector4D_default_value_set(PointerRNA *ptr, const float values[4]);

int NodeTreeInterfaceSocketVector4D_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVector4D_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVector4D_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVector4D_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVector4D_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVector4D_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVector4D_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVector4D_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVector4D_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVector4D_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVector4D_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVector4D_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorAcceleration;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorAcceleration_default_value_get(PointerRNA *ptr, float values[3]);
void NodeTreeInterfaceSocketVectorAcceleration_default_value_set(PointerRNA *ptr, const float values[3]);

int NodeTreeInterfaceSocketVectorAcceleration_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorAcceleration_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorAcceleration_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorAcceleration_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorAcceleration_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorAcceleration_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorAcceleration_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorAcceleration_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorAcceleration_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorAcceleration_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorAcceleration_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorAcceleration_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorAcceleration2D;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorAcceleration2D_default_value_get(PointerRNA *ptr, float values[2]);
void NodeTreeInterfaceSocketVectorAcceleration2D_default_value_set(PointerRNA *ptr, const float values[2]);

int NodeTreeInterfaceSocketVectorAcceleration2D_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorAcceleration2D_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorAcceleration2D_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorAcceleration2D_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorAcceleration2D_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorAcceleration2D_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorAcceleration2D_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorAcceleration2D_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorAcceleration2D_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorAcceleration2D_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorAcceleration2D_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorAcceleration2D_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorAcceleration4D;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorAcceleration4D_default_value_get(PointerRNA *ptr, float values[4]);
void NodeTreeInterfaceSocketVectorAcceleration4D_default_value_set(PointerRNA *ptr, const float values[4]);

int NodeTreeInterfaceSocketVectorAcceleration4D_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorAcceleration4D_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorAcceleration4D_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorAcceleration4D_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorAcceleration4D_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorAcceleration4D_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorAcceleration4D_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorAcceleration4D_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorAcceleration4D_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorAcceleration4D_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorAcceleration4D_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorAcceleration4D_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorDirection;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorDirection_default_value_get(PointerRNA *ptr, float values[3]);
void NodeTreeInterfaceSocketVectorDirection_default_value_set(PointerRNA *ptr, const float values[3]);

int NodeTreeInterfaceSocketVectorDirection_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorDirection_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorDirection_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorDirection_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorDirection_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorDirection_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorDirection_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorDirection_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorDirection_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorDirection_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorDirection_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorDirection_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorDirection2D;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorDirection2D_default_value_get(PointerRNA *ptr, float values[2]);
void NodeTreeInterfaceSocketVectorDirection2D_default_value_set(PointerRNA *ptr, const float values[2]);

int NodeTreeInterfaceSocketVectorDirection2D_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorDirection2D_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorDirection2D_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorDirection2D_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorDirection2D_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorDirection2D_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorDirection2D_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorDirection2D_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorDirection2D_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorDirection2D_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorDirection2D_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorDirection2D_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorDirection4D;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorDirection4D_default_value_get(PointerRNA *ptr, float values[4]);
void NodeTreeInterfaceSocketVectorDirection4D_default_value_set(PointerRNA *ptr, const float values[4]);

int NodeTreeInterfaceSocketVectorDirection4D_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorDirection4D_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorDirection4D_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorDirection4D_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorDirection4D_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorDirection4D_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorDirection4D_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorDirection4D_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorDirection4D_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorDirection4D_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorDirection4D_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorDirection4D_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorEuler;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorEuler_default_value_get(PointerRNA *ptr, float values[3]);
void NodeTreeInterfaceSocketVectorEuler_default_value_set(PointerRNA *ptr, const float values[3]);

int NodeTreeInterfaceSocketVectorEuler_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorEuler_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorEuler_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorEuler_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorEuler_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorEuler_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorEuler_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorEuler_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorEuler_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorEuler_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorEuler_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorEuler_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorEuler2D;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorEuler2D_default_value_get(PointerRNA *ptr, float values[2]);
void NodeTreeInterfaceSocketVectorEuler2D_default_value_set(PointerRNA *ptr, const float values[2]);

int NodeTreeInterfaceSocketVectorEuler2D_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorEuler2D_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorEuler2D_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorEuler2D_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorEuler2D_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorEuler2D_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorEuler2D_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorEuler2D_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorEuler2D_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorEuler2D_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorEuler2D_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorEuler2D_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorEuler4D;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorEuler4D_default_value_get(PointerRNA *ptr, float values[4]);
void NodeTreeInterfaceSocketVectorEuler4D_default_value_set(PointerRNA *ptr, const float values[4]);

int NodeTreeInterfaceSocketVectorEuler4D_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorEuler4D_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorEuler4D_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorEuler4D_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorEuler4D_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorEuler4D_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorEuler4D_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorEuler4D_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorEuler4D_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorEuler4D_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorEuler4D_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorEuler4D_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorFactor;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorFactor_default_value_get(PointerRNA *ptr, float values[3]);
void NodeTreeInterfaceSocketVectorFactor_default_value_set(PointerRNA *ptr, const float values[3]);

int NodeTreeInterfaceSocketVectorFactor_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorFactor_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorFactor_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorFactor_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorFactor_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorFactor_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorFactor_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorFactor_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorFactor_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorFactor_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorFactor_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorFactor_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorFactor2D;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorFactor2D_default_value_get(PointerRNA *ptr, float values[2]);
void NodeTreeInterfaceSocketVectorFactor2D_default_value_set(PointerRNA *ptr, const float values[2]);

int NodeTreeInterfaceSocketVectorFactor2D_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorFactor2D_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorFactor2D_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorFactor2D_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorFactor2D_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorFactor2D_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorFactor2D_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorFactor2D_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorFactor2D_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorFactor2D_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorFactor2D_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorFactor2D_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorFactor4D;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorFactor4D_default_value_get(PointerRNA *ptr, float values[4]);
void NodeTreeInterfaceSocketVectorFactor4D_default_value_set(PointerRNA *ptr, const float values[4]);

int NodeTreeInterfaceSocketVectorFactor4D_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorFactor4D_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorFactor4D_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorFactor4D_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorFactor4D_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorFactor4D_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorFactor4D_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorFactor4D_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorFactor4D_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorFactor4D_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorFactor4D_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorFactor4D_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorPercentage;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorPercentage_default_value_get(PointerRNA *ptr, float values[3]);
void NodeTreeInterfaceSocketVectorPercentage_default_value_set(PointerRNA *ptr, const float values[3]);

int NodeTreeInterfaceSocketVectorPercentage_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorPercentage_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorPercentage_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorPercentage_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorPercentage_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorPercentage_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorPercentage_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorPercentage_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorPercentage_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorPercentage_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorPercentage_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorPercentage_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorPercentage2D;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorPercentage2D_default_value_get(PointerRNA *ptr, float values[2]);
void NodeTreeInterfaceSocketVectorPercentage2D_default_value_set(PointerRNA *ptr, const float values[2]);

int NodeTreeInterfaceSocketVectorPercentage2D_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorPercentage2D_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorPercentage2D_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorPercentage2D_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorPercentage2D_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorPercentage2D_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorPercentage2D_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorPercentage2D_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorPercentage2D_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorPercentage2D_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorPercentage2D_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorPercentage2D_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorPercentage4D;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorPercentage4D_default_value_get(PointerRNA *ptr, float values[4]);
void NodeTreeInterfaceSocketVectorPercentage4D_default_value_set(PointerRNA *ptr, const float values[4]);

int NodeTreeInterfaceSocketVectorPercentage4D_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorPercentage4D_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorPercentage4D_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorPercentage4D_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorPercentage4D_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorPercentage4D_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorPercentage4D_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorPercentage4D_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorPercentage4D_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorPercentage4D_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorPercentage4D_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorPercentage4D_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorTranslation;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorTranslation_default_value_get(PointerRNA *ptr, float values[3]);
void NodeTreeInterfaceSocketVectorTranslation_default_value_set(PointerRNA *ptr, const float values[3]);

int NodeTreeInterfaceSocketVectorTranslation_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorTranslation_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorTranslation_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorTranslation_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorTranslation_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorTranslation_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorTranslation_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorTranslation_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorTranslation_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorTranslation_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorTranslation_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorTranslation_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorTranslation2D;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorTranslation2D_default_value_get(PointerRNA *ptr, float values[2]);
void NodeTreeInterfaceSocketVectorTranslation2D_default_value_set(PointerRNA *ptr, const float values[2]);

int NodeTreeInterfaceSocketVectorTranslation2D_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorTranslation2D_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorTranslation2D_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorTranslation2D_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorTranslation2D_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorTranslation2D_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorTranslation2D_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorTranslation2D_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorTranslation2D_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorTranslation2D_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorTranslation2D_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorTranslation2D_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorTranslation4D;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorTranslation4D_default_value_get(PointerRNA *ptr, float values[4]);
void NodeTreeInterfaceSocketVectorTranslation4D_default_value_set(PointerRNA *ptr, const float values[4]);

int NodeTreeInterfaceSocketVectorTranslation4D_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorTranslation4D_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorTranslation4D_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorTranslation4D_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorTranslation4D_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorTranslation4D_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorTranslation4D_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorTranslation4D_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorTranslation4D_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorTranslation4D_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorTranslation4D_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorTranslation4D_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorVelocity;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorVelocity_default_value_get(PointerRNA *ptr, float values[3]);
void NodeTreeInterfaceSocketVectorVelocity_default_value_set(PointerRNA *ptr, const float values[3]);

int NodeTreeInterfaceSocketVectorVelocity_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorVelocity_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorVelocity_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorVelocity_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorVelocity_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorVelocity_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorVelocity_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorVelocity_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorVelocity_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorVelocity_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorVelocity_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorVelocity_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorVelocity2D;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorVelocity2D_default_value_get(PointerRNA *ptr, float values[2]);
void NodeTreeInterfaceSocketVectorVelocity2D_default_value_set(PointerRNA *ptr, const float values[2]);

int NodeTreeInterfaceSocketVectorVelocity2D_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorVelocity2D_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorVelocity2D_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorVelocity2D_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorVelocity2D_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorVelocity2D_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorVelocity2D_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorVelocity2D_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorVelocity2D_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorVelocity2D_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorVelocity2D_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorVelocity2D_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorVelocity4D;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorVelocity4D_default_value_get(PointerRNA *ptr, float values[4]);
void NodeTreeInterfaceSocketVectorVelocity4D_default_value_set(PointerRNA *ptr, const float values[4]);

int NodeTreeInterfaceSocketVectorVelocity4D_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorVelocity4D_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorVelocity4D_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorVelocity4D_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorVelocity4D_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorVelocity4D_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorVelocity4D_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorVelocity4D_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorVelocity4D_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorVelocity4D_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorVelocity4D_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorVelocity4D_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorXYZ;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorXYZ_default_value_get(PointerRNA *ptr, float values[3]);
void NodeTreeInterfaceSocketVectorXYZ_default_value_set(PointerRNA *ptr, const float values[3]);

int NodeTreeInterfaceSocketVectorXYZ_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorXYZ_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorXYZ_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorXYZ_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorXYZ_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorXYZ_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorXYZ_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorXYZ_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorXYZ_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorXYZ_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorXYZ_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorXYZ_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorXYZ2D;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorXYZ2D_default_value_get(PointerRNA *ptr, float values[2]);
void NodeTreeInterfaceSocketVectorXYZ2D_default_value_set(PointerRNA *ptr, const float values[2]);

int NodeTreeInterfaceSocketVectorXYZ2D_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorXYZ2D_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorXYZ2D_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorXYZ2D_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorXYZ2D_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorXYZ2D_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorXYZ2D_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorXYZ2D_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorXYZ2D_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorXYZ2D_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorXYZ2D_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorXYZ2D_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Vector Node Socket Interface ****************/

extern StructRNA RNA_NodeTreeInterfaceSocketVectorXYZ4D;
extern StructRNA RNA_NodeTreeInterfaceSocket;
extern StructRNA RNA_NodeTreeInterfaceItem;

void NodeTreeInterfaceSocketVectorXYZ4D_default_value_get(PointerRNA *ptr, float values[4]);
void NodeTreeInterfaceSocketVectorXYZ4D_default_value_set(PointerRNA *ptr, const float values[4]);

int NodeTreeInterfaceSocketVectorXYZ4D_dimensions_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorXYZ4D_dimensions_set(PointerRNA *ptr, int value);

float NodeTreeInterfaceSocketVectorXYZ4D_max_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorXYZ4D_max_value_set(PointerRNA *ptr, float value);

float NodeTreeInterfaceSocketVectorXYZ4D_min_value_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorXYZ4D_min_value_set(PointerRNA *ptr, float value);

enum {
	NodeTreeInterfaceSocketVectorXYZ4D_subtype_DEFAULT = 0,
};

int NodeTreeInterfaceSocketVectorXYZ4D_subtype_get(PointerRNA *ptr);
void NodeTreeInterfaceSocketVectorXYZ4D_subtype_set(PointerRNA *ptr, int value);

void NodeTreeInterfaceSocketVectorXYZ4D_draw_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bContext *context, struct uiLayout *layout);
void NodeTreeInterfaceSocketVectorXYZ4D_init_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket, const char * data_path);
void NodeTreeInterfaceSocketVectorXYZ4D_from_socket_func(struct ID *_selfid, struct bNodeTreeInterfaceSocket *_self, struct bNode *node, struct bNodeSocket *socket);
/**************** Node Tree Path ****************/

extern StructRNA RNA_NodeTreePath;

PointerRNA NodeTreePath_rna_type_get(PointerRNA *ptr);

PointerRNA NodeTreePath_node_tree_get(PointerRNA *ptr);

/**************** Nodes ****************/

extern StructRNA RNA_Nodes;

PointerRNA Nodes_rna_type_get(PointerRNA *ptr);

PointerRNA Nodes_active_get(PointerRNA *ptr);

struct bNode *Nodes_new_func(struct bNodeTree *_self, bContext *C, ReportList *reports, const char * type);
void Nodes_remove_func(struct bNodeTree *_self, Main *bmain, ReportList *reports, struct PointerRNA *node);
void Nodes_clear_func(struct bNodeTree *_self, Main *bmain, ReportList *reports);
/**************** Nodes Modifier ****************/

extern StructRNA RNA_NodesModifier;
extern StructRNA RNA_Modifier;

enum {
	NodesModifier_bake_target_PACKED = 1,
	NodesModifier_bake_target_DISK = 2,
};

int NodesModifier_bake_target_get(PointerRNA *ptr);
void NodesModifier_bake_target_set(PointerRNA *ptr, int value);

PointerRNA NodesModifier_node_group_get(PointerRNA *ptr);

bool NodesModifier_show_group_selector_get(PointerRNA *ptr);
void NodesModifier_show_group_selector_set(PointerRNA *ptr, bool value);

void NodesModifier_bake_directory_get(PointerRNA *ptr, char *value);
int NodesModifier_bake_directory_length(PointerRNA *ptr);
void NodesModifier_bake_directory_set(PointerRNA *ptr, const char *value);

void NodesModifier_bakes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void NodesModifier_bakes_next(CollectionPropertyIterator *iter);
void NodesModifier_bakes_end(CollectionPropertyIterator *iter);
int NodesModifier_bakes_length(PointerRNA *ptr);
bool NodesModifier_bakes_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

void NodesModifier_node_warnings_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void NodesModifier_node_warnings_next(CollectionPropertyIterator *iter);
void NodesModifier_node_warnings_end(CollectionPropertyIterator *iter);
int NodesModifier_node_warnings_length(PointerRNA *ptr);

bool NodesModifier_open_bake_data_blocks_panel_get(PointerRNA *ptr);
void NodesModifier_open_bake_data_blocks_panel_set(PointerRNA *ptr, bool value);

bool NodesModifier_open_bake_panel_get(PointerRNA *ptr);
void NodesModifier_open_bake_panel_set(PointerRNA *ptr, bool value);

bool NodesModifier_open_manage_panel_get(PointerRNA *ptr);
void NodesModifier_open_manage_panel_set(PointerRNA *ptr, bool value);

bool NodesModifier_open_named_attributes_panel_get(PointerRNA *ptr);
void NodesModifier_open_named_attributes_panel_set(PointerRNA *ptr, bool value);

bool NodesModifier_open_output_attributes_panel_get(PointerRNA *ptr);
void NodesModifier_open_output_attributes_panel_set(PointerRNA *ptr, bool value);

bool NodesModifier_open_warnings_panel_get(PointerRNA *ptr);
void NodesModifier_open_warnings_panel_set(PointerRNA *ptr, bool value);

void NodesModifier_panels_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void NodesModifier_panels_next(CollectionPropertyIterator *iter);
void NodesModifier_panels_end(CollectionPropertyIterator *iter);
int NodesModifier_panels_length(PointerRNA *ptr);
bool NodesModifier_panels_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Nodes Modifier Bake ****************/

extern StructRNA RNA_NodesModifierBake;

PointerRNA NodesModifierBake_rna_type_get(PointerRNA *ptr);

int NodesModifierBake_bake_id_get(PointerRNA *ptr);
void NodesModifierBake_bake_id_set(PointerRNA *ptr, int value);

enum {
	NodesModifierBake_bake_mode_ANIMATION = 0,
	NodesModifierBake_bake_mode_STILL = 1,
};

int NodesModifierBake_bake_mode_get(PointerRNA *ptr);
void NodesModifierBake_bake_mode_set(PointerRNA *ptr, int value);

enum {
	NodesModifierBake_bake_target_INHERIT = 0,
	NodesModifierBake_bake_target_PACKED = 1,
	NodesModifierBake_bake_target_DISK = 2,
};

int NodesModifierBake_bake_target_get(PointerRNA *ptr);
void NodesModifierBake_bake_target_set(PointerRNA *ptr, int value);

bool NodesModifierBake_use_custom_path_get(PointerRNA *ptr);
void NodesModifierBake_use_custom_path_set(PointerRNA *ptr, bool value);

bool NodesModifierBake_use_custom_simulation_frame_range_get(PointerRNA *ptr);
void NodesModifierBake_use_custom_simulation_frame_range_set(PointerRNA *ptr, bool value);

void NodesModifierBake_directory_get(PointerRNA *ptr, char *value);
int NodesModifierBake_directory_length(PointerRNA *ptr);
void NodesModifierBake_directory_set(PointerRNA *ptr, const char *value);

int NodesModifierBake_frame_end_get(PointerRNA *ptr);
void NodesModifierBake_frame_end_set(PointerRNA *ptr, int value);

PointerRNA NodesModifierBake_node_get(PointerRNA *ptr);

int NodesModifierBake_frame_start_get(PointerRNA *ptr);
void NodesModifierBake_frame_start_set(PointerRNA *ptr, int value);

void NodesModifierBake_data_blocks_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void NodesModifierBake_data_blocks_next(CollectionPropertyIterator *iter);
void NodesModifierBake_data_blocks_end(CollectionPropertyIterator *iter);
int NodesModifierBake_data_blocks_length(PointerRNA *ptr);
bool NodesModifierBake_data_blocks_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Data-Blocks ****************/

extern StructRNA RNA_NodesModifierBakeDataBlocks;

PointerRNA NodesModifierBakeDataBlocks_rna_type_get(PointerRNA *ptr);

int NodesModifierBakeDataBlocks_active_index_get(PointerRNA *ptr);
void NodesModifierBakeDataBlocks_active_index_set(PointerRNA *ptr, int value);

/**************** Bakes ****************/

extern StructRNA RNA_NodesModifierBakes;

PointerRNA NodesModifierBakes_rna_type_get(PointerRNA *ptr);

/**************** NodesModifierDataBlock ****************/

extern StructRNA RNA_NodesModifierDataBlock;

PointerRNA NodesModifierDataBlock_rna_type_get(PointerRNA *ptr);

PointerRNA NodesModifierDataBlock_id_get(PointerRNA *ptr);

void NodesModifierDataBlock_id_name_get(PointerRNA *ptr, char *value);
int NodesModifierDataBlock_id_name_length(PointerRNA *ptr);
void NodesModifierDataBlock_id_name_set(PointerRNA *ptr, const char *value);

void NodesModifierDataBlock_lib_name_get(PointerRNA *ptr, char *value);
int NodesModifierDataBlock_lib_name_length(PointerRNA *ptr);
void NodesModifierDataBlock_lib_name_set(PointerRNA *ptr, const char *value);

enum {
	NodesModifierDataBlock_id_type_ACTION = 17217,
	NodesModifierDataBlock_id_type_ARMATURE = 21057,
	NodesModifierDataBlock_id_type_BRUSH = 21058,
	NodesModifierDataBlock_id_type_CACHEFILE = 17987,
	NodesModifierDataBlock_id_type_CAMERA = 16707,
	NodesModifierDataBlock_id_type_COLLECTION = 21063,
	NodesModifierDataBlock_id_type_CURVE = 21827,
	NodesModifierDataBlock_id_type_CURVES = 22083,
	NodesModifierDataBlock_id_type_FONT = 18006,
	NodesModifierDataBlock_id_type_GREASEPENCIL = 17479,
	NodesModifierDataBlock_id_type_GREASEPENCIL_V3 = 20551,
	NodesModifierDataBlock_id_type_IMAGE = 19785,
	NodesModifierDataBlock_id_type_KEY = 17739,
	NodesModifierDataBlock_id_type_LATTICE = 21580,
	NodesModifierDataBlock_id_type_LIBRARY = 18764,
	NodesModifierDataBlock_id_type_LIGHT = 16716,
	NodesModifierDataBlock_id_type_LIGHT_PROBE = 20556,
	NodesModifierDataBlock_id_type_LINESTYLE = 21324,
	NodesModifierDataBlock_id_type_MASK = 21325,
	NodesModifierDataBlock_id_type_MATERIAL = 16717,
	NodesModifierDataBlock_id_type_MESH = 17741,
	NodesModifierDataBlock_id_type_META = 16973,
	NodesModifierDataBlock_id_type_MOVIECLIP = 17229,
	NodesModifierDataBlock_id_type_NODETREE = 21582,
	NodesModifierDataBlock_id_type_OBJECT = 16975,
	NodesModifierDataBlock_id_type_PAINTCURVE = 17232,
	NodesModifierDataBlock_id_type_PALETTE = 19536,
	NodesModifierDataBlock_id_type_PARTICLE = 16720,
	NodesModifierDataBlock_id_type_POINTCLOUD = 21584,
	NodesModifierDataBlock_id_type_SCENE = 17235,
	NodesModifierDataBlock_id_type_SCREEN = 21075,
	NodesModifierDataBlock_id_type_SOUND = 20307,
	NodesModifierDataBlock_id_type_SPEAKER = 19283,
	NodesModifierDataBlock_id_type_TEXT = 22612,
	NodesModifierDataBlock_id_type_TEXTURE = 17748,
	NodesModifierDataBlock_id_type_VOLUME = 20310,
	NodesModifierDataBlock_id_type_WINDOWMANAGER = 19799,
	NodesModifierDataBlock_id_type_WORKSPACE = 21335,
	NodesModifierDataBlock_id_type_WORLD = 20311,
};

int NodesModifierDataBlock_id_type_get(PointerRNA *ptr);
void NodesModifierDataBlock_id_type_set(PointerRNA *ptr, int value);

/**************** Nodes Modifier Panel ****************/

extern StructRNA RNA_NodesModifierPanel;

PointerRNA NodesModifierPanel_rna_type_get(PointerRNA *ptr);

bool NodesModifierPanel_is_open_get(PointerRNA *ptr);
void NodesModifierPanel_is_open_set(PointerRNA *ptr, bool value);

/**************** Panels ****************/

extern StructRNA RNA_NodesModifierPanels;

PointerRNA NodesModifierPanels_rna_type_get(PointerRNA *ptr);

/**************** Nodes Modifier Warning ****************/

extern StructRNA RNA_NodesModifierWarning;

PointerRNA NodesModifierWarning_rna_type_get(PointerRNA *ptr);

void NodesModifierWarning_message_get(PointerRNA *ptr, char *value);
int NodesModifierWarning_message_length(PointerRNA *ptr);
void NodesModifierWarning_message_set(PointerRNA *ptr, const char *value);

enum {
	NodesModifierWarning_type_ERROR = 0,
	NodesModifierWarning_type_WARNING = 1,
	NodesModifierWarning_type_INFO = 2,
};

int NodesModifierWarning_type_get(PointerRNA *ptr);
void NodesModifierWarning_type_set(PointerRNA *ptr, int value);

/**************** Noise Texture ****************/

extern StructRNA RNA_NoiseTexture;
extern StructRNA RNA_Texture;
extern StructRNA RNA_ID;

/**************** Normal Edit Modifier ****************/

extern StructRNA RNA_NormalEditModifier;
extern StructRNA RNA_Modifier;

bool NormalEditModifier_invert_vertex_group_get(PointerRNA *ptr);
void NormalEditModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

bool NormalEditModifier_no_polynors_fix_get(PointerRNA *ptr);
void NormalEditModifier_no_polynors_fix_set(PointerRNA *ptr, bool value);

float NormalEditModifier_mix_limit_get(PointerRNA *ptr);
void NormalEditModifier_mix_limit_set(PointerRNA *ptr, float value);

float NormalEditModifier_mix_factor_get(PointerRNA *ptr);
void NormalEditModifier_mix_factor_set(PointerRNA *ptr, float value);

enum {
	NormalEditModifier_mix_mode_COPY = 0,
	NormalEditModifier_mix_mode_ADD = 1,
	NormalEditModifier_mix_mode_SUB = 2,
	NormalEditModifier_mix_mode_MUL = 3,
};

int NormalEditModifier_mix_mode_get(PointerRNA *ptr);
void NormalEditModifier_mix_mode_set(PointerRNA *ptr, int value);

enum {
	NormalEditModifier_mode_RADIAL = 0,
	NormalEditModifier_mode_DIRECTIONAL = 1,
};

int NormalEditModifier_mode_get(PointerRNA *ptr);
void NormalEditModifier_mode_set(PointerRNA *ptr, int value);

void NormalEditModifier_offset_get(PointerRNA *ptr, float values[3]);
void NormalEditModifier_offset_set(PointerRNA *ptr, const float values[3]);

bool NormalEditModifier_use_direction_parallel_get(PointerRNA *ptr);
void NormalEditModifier_use_direction_parallel_set(PointerRNA *ptr, bool value);

PointerRNA NormalEditModifier_target_get(PointerRNA *ptr);

#define NormalEditModifier_vertex_group_MAX 64

void NormalEditModifier_vertex_group_get(PointerRNA *ptr, char *value);
int NormalEditModifier_vertex_group_length(PointerRNA *ptr);
void NormalEditModifier_vertex_group_set(PointerRNA *ptr, const char *value);

/**************** Object ****************/

extern StructRNA RNA_Object;
extern StructRNA RNA_ID;

PointerRNA Object_active_material_get(PointerRNA *ptr);

int Object_active_material_index_get(PointerRNA *ptr);
void Object_active_material_index_set(PointerRNA *ptr, int value);

PointerRNA Object_active_shape_key_get(PointerRNA *ptr);

int Object_active_shape_key_index_get(PointerRNA *ptr);
void Object_active_shape_key_index_set(PointerRNA *ptr, int value);

bool Object_add_rest_position_attribute_get(PointerRNA *ptr);
void Object_add_rest_position_attribute_set(PointerRNA *ptr, bool value);

PointerRNA Object_animation_data_get(PointerRNA *ptr);

PointerRNA Object_animation_visualization_get(PointerRNA *ptr);

void Object_rotation_axis_angle_get(PointerRNA *ptr, float values[4]);
void Object_rotation_axis_angle_set(PointerRNA *ptr, const float values[4]);

bool Object_is_from_instancer_get(PointerRNA *ptr);
void Object_is_from_instancer_set(PointerRNA *ptr, bool value);

bool Object_is_from_set_get(PointerRNA *ptr);
void Object_is_from_set_set(PointerRNA *ptr, bool value);

void Object_bound_box_get(PointerRNA *ptr, float values[24]);
void Object_bound_box_set(PointerRNA *ptr, const float values[24]);

bool Object_use_camera_lock_parent_get(PointerRNA *ptr);
void Object_use_camera_lock_parent_set(PointerRNA *ptr, bool value);

bool Object_visible_camera_get(PointerRNA *ptr);
void Object_visible_camera_set(PointerRNA *ptr, bool value);

PointerRNA Object_collision_get(PointerRNA *ptr);

void Object_color_get(PointerRNA *ptr, float values[4]);
void Object_color_set(PointerRNA *ptr, const float values[4]);

void Object_constraints_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Object_constraints_next(CollectionPropertyIterator *iter);
void Object_constraints_end(CollectionPropertyIterator *iter);
bool Object_constraints_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Object_constraints_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

PointerRNA Object_data_get(PointerRNA *ptr);

void Object_delta_location_get(PointerRNA *ptr, float values[3]);
void Object_delta_location_set(PointerRNA *ptr, const float values[3]);

void Object_delta_rotation_euler_get(PointerRNA *ptr, float values[3]);
void Object_delta_rotation_euler_set(PointerRNA *ptr, const float values[3]);

void Object_delta_rotation_quaternion_get(PointerRNA *ptr, float values[4]);
void Object_delta_rotation_quaternion_set(PointerRNA *ptr, const float values[4]);

void Object_delta_scale_get(PointerRNA *ptr, float values[3]);
void Object_delta_scale_set(PointerRNA *ptr, const float values[3]);

bool Object_visible_diffuse_get(PointerRNA *ptr);
void Object_visible_diffuse_set(PointerRNA *ptr, bool value);

void Object_dimensions_get(PointerRNA *ptr, float values[3]);
void Object_dimensions_set(PointerRNA *ptr, const float values[3]);

bool Object_hide_select_get(PointerRNA *ptr);
void Object_hide_select_set(PointerRNA *ptr, bool value);

bool Object_hide_probe_plane_get(PointerRNA *ptr);
void Object_hide_probe_plane_set(PointerRNA *ptr, bool value);

bool Object_hide_render_get(PointerRNA *ptr);
void Object_hide_render_set(PointerRNA *ptr, bool value);

bool Object_hide_probe_sphere_get(PointerRNA *ptr);
void Object_hide_probe_sphere_set(PointerRNA *ptr, bool value);

bool Object_hide_viewport_get(PointerRNA *ptr);
void Object_hide_viewport_set(PointerRNA *ptr, bool value);

bool Object_hide_probe_volume_get(PointerRNA *ptr);
void Object_hide_probe_volume_set(PointerRNA *ptr, bool value);

bool Object_show_all_edges_get(PointerRNA *ptr);
void Object_show_all_edges_set(PointerRNA *ptr, bool value);

enum {
	Object_display_type_BOUNDS = 1,
	Object_display_type_WIRE = 2,
	Object_display_type_SOLID = 3,
	Object_display_type_TEXTURED = 5,
};

int Object_display_type_get(PointerRNA *ptr);
void Object_display_type_set(PointerRNA *ptr, int value);

bool Object_show_axis_get(PointerRNA *ptr);
void Object_show_axis_set(PointerRNA *ptr, bool value);

bool Object_show_bounds_get(PointerRNA *ptr);
void Object_show_bounds_set(PointerRNA *ptr, bool value);

enum {
	Object_display_bounds_type_BOX = 0,
	Object_display_bounds_type_SPHERE = 1,
	Object_display_bounds_type_CYLINDER = 2,
	Object_display_bounds_type_CONE = 3,
	Object_display_bounds_type_CAPSULE = 7,
};

int Object_display_bounds_type_get(PointerRNA *ptr);
void Object_display_bounds_type_set(PointerRNA *ptr, int value);

bool Object_show_instancer_for_viewport_get(PointerRNA *ptr);
void Object_show_instancer_for_viewport_set(PointerRNA *ptr, bool value);

bool Object_show_name_get(PointerRNA *ptr);
void Object_show_name_set(PointerRNA *ptr, bool value);

bool Object_show_empty_image_only_axis_aligned_get(PointerRNA *ptr);
void Object_show_empty_image_only_axis_aligned_set(PointerRNA *ptr, bool value);

bool Object_show_texture_space_get(PointerRNA *ptr);
void Object_show_texture_space_set(PointerRNA *ptr, bool value);

bool Object_show_transparent_get(PointerRNA *ptr);
void Object_show_transparent_set(PointerRNA *ptr, bool value);

bool Object_show_wire_get(PointerRNA *ptr);
void Object_show_wire_set(PointerRNA *ptr, bool value);

bool Object_show_empty_image_orthographic_get(PointerRNA *ptr);
void Object_show_empty_image_orthographic_set(PointerRNA *ptr, bool value);

bool Object_show_empty_image_perspective_get(PointerRNA *ptr);
void Object_show_empty_image_perspective_set(PointerRNA *ptr, bool value);

bool Object_use_dynamic_topology_sculpting_get(PointerRNA *ptr);
void Object_use_dynamic_topology_sculpting_set(PointerRNA *ptr, bool value);

float Object_empty_display_size_get(PointerRNA *ptr);
void Object_empty_display_size_set(PointerRNA *ptr, float value);

enum {
	Object_empty_display_type_PLAIN_AXES = 2,
	Object_empty_display_type_ARROWS = 1,
	Object_empty_display_type_SINGLE_ARROW = 4,
	Object_empty_display_type_CIRCLE = 3,
	Object_empty_display_type_CUBE = 5,
	Object_empty_display_type_SPHERE = 6,
	Object_empty_display_type_CONE = 7,
	Object_empty_display_type_IMAGE = 8,
};

int Object_empty_display_type_get(PointerRNA *ptr);
void Object_empty_display_type_set(PointerRNA *ptr, int value);

enum {
	Object_empty_image_depth_DEFAULT = 0,
	Object_empty_image_depth_FRONT = 1,
	Object_empty_image_depth_BACK = 2,
};

int Object_empty_image_depth_get(PointerRNA *ptr);
void Object_empty_image_depth_set(PointerRNA *ptr, int value);

enum {
	Object_empty_image_side_DOUBLE_SIDED = 0,
	Object_empty_image_side_FRONT = 4,
	Object_empty_image_side_BACK = 8,
};

int Object_empty_image_side_get(PointerRNA *ptr);
void Object_empty_image_side_set(PointerRNA *ptr, int value);

void Object_rotation_euler_get(PointerRNA *ptr, float values[3]);
void Object_rotation_euler_set(PointerRNA *ptr, const float values[3]);

PointerRNA Object_field_get(PointerRNA *ptr);

bool Object_visible_glossy_get(PointerRNA *ptr);
void Object_visible_glossy_set(PointerRNA *ptr, bool value);

bool Object_is_holdout_get(PointerRNA *ptr);
void Object_is_holdout_set(PointerRNA *ptr, bool value);

PointerRNA Object_image_user_get(PointerRNA *ptr);

bool Object_show_in_front_get(PointerRNA *ptr);
void Object_show_in_front_set(PointerRNA *ptr, bool value);

void Object_matrix_basis_get(PointerRNA *ptr, float values[16]);
void Object_matrix_basis_set(PointerRNA *ptr, const float values[16]);

PointerRNA Object_instance_collection_get(PointerRNA *ptr);

float Object_instance_faces_scale_get(PointerRNA *ptr);
void Object_instance_faces_scale_set(PointerRNA *ptr, float value);

enum {
	Object_instance_type_NONE = 0,
	Object_instance_type_VERTS = 16,
	Object_instance_type_FACES = 512,
	Object_instance_type_COLLECTION = 256,
};

int Object_instance_type_get(PointerRNA *ptr);
void Object_instance_type_set(PointerRNA *ptr, int value);

PointerRNA Object_light_linking_get(PointerRNA *ptr);

void Object_lightgroup_get(PointerRNA *ptr, char *value);
int Object_lightgroup_length(PointerRNA *ptr);
void Object_lightgroup_set(PointerRNA *ptr, const char *value);

PointerRNA Object_lineart_get(PointerRNA *ptr);

void Object_matrix_local_get(PointerRNA *ptr, float values[16]);
void Object_matrix_local_set(PointerRNA *ptr, const float values[16]);

void Object_location_get(PointerRNA *ptr, float values[3]);
void Object_location_set(PointerRNA *ptr, const float values[3]);

void Object_lock_location_get(PointerRNA *ptr, bool values[3]);
void Object_lock_location_set(PointerRNA *ptr, const bool values[3]);

void Object_lock_rotation_get(PointerRNA *ptr, bool values[3]);
void Object_lock_rotation_set(PointerRNA *ptr, const bool values[3]);

bool Object_lock_rotation_w_get(PointerRNA *ptr);
void Object_lock_rotation_w_set(PointerRNA *ptr, bool value);

bool Object_lock_rotations_4d_get(PointerRNA *ptr);
void Object_lock_rotations_4d_set(PointerRNA *ptr, bool value);

void Object_lock_scale_get(PointerRNA *ptr, bool values[3]);
void Object_lock_scale_set(PointerRNA *ptr, const bool values[3]);

void Object_material_slots_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Object_material_slots_next(CollectionPropertyIterator *iter);
void Object_material_slots_end(CollectionPropertyIterator *iter);
int Object_material_slots_length(PointerRNA *ptr);

void Object_matrix_world_get(PointerRNA *ptr, float values[16]);
void Object_matrix_world_set(PointerRNA *ptr, const float values[16]);

enum {
	Object_mode_OBJECT = 0,
	Object_mode_EDIT = 1,
	Object_mode_POSE = 64,
	Object_mode_SCULPT = 2,
	Object_mode_VERTEX_PAINT = 4,
	Object_mode_WEIGHT_PAINT = 8,
	Object_mode_TEXTURE_PAINT = 16,
	Object_mode_PARTICLE_EDIT = 32,
	Object_mode_EDIT_GPENCIL = 128,
	Object_mode_SCULPT_GREASE_PENCIL = 512,
	Object_mode_PAINT_GREASE_PENCIL = 256,
	Object_mode_WEIGHT_GREASE_PENCIL = 1024,
	Object_mode_VERTEX_GREASE_PENCIL = 2048,
	Object_mode_SCULPT_CURVES = 4096,
};

int Object_mode_get(PointerRNA *ptr);
void Object_mode_set(PointerRNA *ptr, int value);

void Object_modifiers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Object_modifiers_next(CollectionPropertyIterator *iter);
void Object_modifiers_end(CollectionPropertyIterator *iter);
bool Object_modifiers_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Object_modifiers_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

PointerRNA Object_motion_path_get(PointerRNA *ptr);

PointerRNA Object_display_get(PointerRNA *ptr);

bool Object_use_instance_vertices_rotation_get(PointerRNA *ptr);
void Object_use_instance_vertices_rotation_set(PointerRNA *ptr, bool value);

void Object_empty_image_offset_get(PointerRNA *ptr, float values[2]);
void Object_empty_image_offset_set(PointerRNA *ptr, const float values[2]);

PointerRNA Object_parent_get(PointerRNA *ptr);

#define Object_parent_bone_MAX 64

void Object_parent_bone_get(PointerRNA *ptr, char *value);
int Object_parent_bone_length(PointerRNA *ptr);
void Object_parent_bone_set(PointerRNA *ptr, const char *value);

void Object_matrix_parent_inverse_get(PointerRNA *ptr, float values[16]);
void Object_matrix_parent_inverse_set(PointerRNA *ptr, const float values[16]);

enum {
	Object_parent_type_OBJECT = 0,
	Object_parent_type_ARMATURE = 4,
	Object_parent_type_LATTICE = 4,
	Object_parent_type_VERTEX = 5,
	Object_parent_type_VERTEX_3 = 6,
	Object_parent_type_BONE = 7,
};

int Object_parent_type_get(PointerRNA *ptr);
void Object_parent_type_set(PointerRNA *ptr, int value);

void Object_parent_vertices_get(PointerRNA *ptr, int values[3]);
void Object_parent_vertices_set(PointerRNA *ptr, const int values[3]);

void Object_particle_systems_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Object_particle_systems_next(CollectionPropertyIterator *iter);
void Object_particle_systems_end(CollectionPropertyIterator *iter);
bool Object_particle_systems_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Object_particle_systems_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

int Object_pass_index_get(PointerRNA *ptr);
void Object_pass_index_set(PointerRNA *ptr, int value);

PointerRNA Object_pose_get(PointerRNA *ptr);

void Object_rotation_quaternion_get(PointerRNA *ptr, float values[4]);
void Object_rotation_quaternion_set(PointerRNA *ptr, const float values[4]);

bool Object_show_instancer_for_render_get(PointerRNA *ptr);
void Object_show_instancer_for_render_set(PointerRNA *ptr, bool value);

PointerRNA Object_rigid_body_constraint_get(PointerRNA *ptr);

PointerRNA Object_rigid_body_get(PointerRNA *ptr);

enum {
	Object_rotation_mode_QUATERNION = 0,
	Object_rotation_mode_XYZ = 1,
	Object_rotation_mode_XZY = 2,
	Object_rotation_mode_YXZ = 3,
	Object_rotation_mode_YZX = 4,
	Object_rotation_mode_ZXY = 5,
	Object_rotation_mode_ZYX = 6,
	Object_rotation_mode_AXIS_ANGLE = -1,
};

int Object_rotation_mode_get(PointerRNA *ptr);
void Object_rotation_mode_set(PointerRNA *ptr, int value);

void Object_scale_get(PointerRNA *ptr, float values[3]);
void Object_scale_set(PointerRNA *ptr, const float values[3]);

bool Object_use_instance_faces_scale_get(PointerRNA *ptr);
void Object_use_instance_faces_scale_set(PointerRNA *ptr, bool value);

void Object_shader_effects_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Object_shader_effects_next(CollectionPropertyIterator *iter);
void Object_shader_effects_end(CollectionPropertyIterator *iter);
bool Object_shader_effects_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Object_shader_effects_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool Object_is_shadow_catcher_get(PointerRNA *ptr);
void Object_is_shadow_catcher_set(PointerRNA *ptr, bool value);

float Object_shadow_terminator_geometry_offset_get(PointerRNA *ptr);
void Object_shadow_terminator_geometry_offset_set(PointerRNA *ptr, float value);

float Object_shadow_terminator_normal_offset_get(PointerRNA *ptr);
void Object_shadow_terminator_normal_offset_set(PointerRNA *ptr, float value);

float Object_shadow_terminator_shading_offset_get(PointerRNA *ptr);
void Object_shadow_terminator_shading_offset_set(PointerRNA *ptr, float value);

bool Object_visible_shadow_get(PointerRNA *ptr);
void Object_visible_shadow_set(PointerRNA *ptr, bool value);

bool Object_use_shape_key_edit_mode_get(PointerRNA *ptr);
void Object_use_shape_key_edit_mode_set(PointerRNA *ptr, bool value);

PointerRNA Object_soft_body_get(PointerRNA *ptr);

bool Object_show_only_shape_key_get(PointerRNA *ptr);
void Object_show_only_shape_key_set(PointerRNA *ptr, bool value);

enum {
	Object_track_axis_POS_X = 0,
	Object_track_axis_POS_Y = 1,
	Object_track_axis_POS_Z = 2,
	Object_track_axis_NEG_X = 3,
	Object_track_axis_NEG_Y = 4,
	Object_track_axis_NEG_Z = 5,
};

int Object_track_axis_get(PointerRNA *ptr);
void Object_track_axis_set(PointerRNA *ptr, int value);

bool Object_visible_transmission_get(PointerRNA *ptr);
void Object_visible_transmission_set(PointerRNA *ptr, bool value);

enum {
	Object_type_MESH = 1,
	Object_type_CURVE = 2,
	Object_type_SURFACE = 3,
	Object_type_META = 5,
	Object_type_FONT = 4,
	Object_type_CURVES = 27,
	Object_type_POINTCLOUD = 28,
	Object_type_VOLUME = 29,
	Object_type_GREASEPENCIL = 30,
	Object_type_ARMATURE = 25,
	Object_type_LATTICE = 22,
	Object_type_EMPTY = 0,
	Object_type_LIGHT = 10,
	Object_type_LIGHT_PROBE = 13,
	Object_type_CAMERA = 11,
	Object_type_SPEAKER = 12,
};

int Object_type_get(PointerRNA *ptr);
void Object_type_set(PointerRNA *ptr, int value);

enum {
	Object_up_axis_X = 0,
	Object_up_axis_Y = 1,
	Object_up_axis_Z = 2,
};

int Object_up_axis_get(PointerRNA *ptr);
void Object_up_axis_set(PointerRNA *ptr, int value);

bool Object_use_empty_image_alpha_get(PointerRNA *ptr);
void Object_use_empty_image_alpha_set(PointerRNA *ptr, bool value);

bool Object_use_parent_final_indices_get(PointerRNA *ptr);
void Object_use_parent_final_indices_set(PointerRNA *ptr, bool value);

bool Object_use_grease_pencil_lights_get(PointerRNA *ptr);
void Object_use_grease_pencil_lights_set(PointerRNA *ptr, bool value);

bool Object_use_simulation_cache_get(PointerRNA *ptr);
void Object_use_simulation_cache_set(PointerRNA *ptr, bool value);

void Object_vertex_groups_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Object_vertex_groups_next(CollectionPropertyIterator *iter);
void Object_vertex_groups_end(CollectionPropertyIterator *iter);

bool Object_visible_volume_scatter_get(PointerRNA *ptr);
void Object_visible_volume_scatter_set(PointerRNA *ptr, bool value);

bool Object_use_mesh_mirror_x_get(PointerRNA *ptr);
void Object_use_mesh_mirror_x_set(PointerRNA *ptr, bool value);

bool Object_use_mesh_mirror_y_get(PointerRNA *ptr);
void Object_use_mesh_mirror_y_set(PointerRNA *ptr, bool value);

bool Object_use_mesh_mirror_z_get(PointerRNA *ptr);
void Object_use_mesh_mirror_z_set(PointerRNA *ptr, bool value);

bool Object_is_instancer_get(PointerRNA *ptr);
void Object_is_instancer_set(PointerRNA *ptr, bool value);

bool Object_select_get_func(struct Object *_self, bContext *C, struct PointerRNA *view_layer);
void Object_select_set_func(struct Object *_self, bContext *C, ReportList *reports, bool state, struct PointerRNA *view_layer);
bool Object_hide_get_func(struct Object *_self, bContext *C, struct PointerRNA *view_layer);
void Object_hide_set_func(struct Object *_self, bContext *C, ReportList *reports, bool state, struct PointerRNA *view_layer);
bool Object_visible_get_func(struct Object *_self, bContext *C, struct PointerRNA *view_layer, struct View3D *viewport);
bool Object_holdout_get_func(struct Object *_self, bContext *C, struct PointerRNA *view_layer);
bool Object_indirect_only_get_func(struct Object *_self, bContext *C, struct PointerRNA *view_layer);
bool Object_local_view_get_func(struct Object *_self, ReportList *reports, struct View3D *viewport);
void Object_local_view_set_func(struct Object *_self, ReportList *reports, struct PointerRNA *viewport, bool state);
bool Object_visible_in_viewport_get_func(struct Object *_self, struct View3D *viewport);
void Object_convert_space_func(struct Object *_self, ReportList *reports, struct bPoseChannel *pose_bone, float matrix[16], float matrix_return[16], int from_space, int to_space);
void Object_calc_matrix_camera_func(struct Object *_self, struct Depsgraph *depsgraph, float result[16], int x, int y, float scale_x, float scale_y);
void Object_camera_fit_coords_func(struct Object *_self, struct Depsgraph *depsgraph, int coordinates_num, float *coordinates, float coord_return[3], float *scale_return);
void Object_crazyspace_eval_func(struct Object *_self, ReportList *reports, struct Depsgraph *depsgraph, struct Scene *scene);
void Object_crazyspace_displacement_to_deformed_func(struct Object *_self, ReportList *reports, int vertex_index, float displacement[3], float displacement_deformed[3]);
void Object_crazyspace_displacement_to_original_func(struct Object *_self, ReportList *reports, int vertex_index, float displacement[3], float displacement_original[3]);
void Object_crazyspace_eval_clear_func(struct Object *_self);
struct Mesh *Object_to_mesh_func(struct Object *_self, ReportList *reports, bool preserve_all_data_layers, struct Depsgraph *depsgraph);
void Object_to_mesh_clear_func(struct Object *_self);
struct Curve *Object_to_curve_func(struct Object *_self, ReportList *reports, struct Depsgraph *depsgraph, bool apply_modifiers);
void Object_to_curve_clear_func(struct Object *_self);
struct Object *Object_find_armature_func(struct Object *_self);
struct PointerRNA Object_shape_key_add_func(struct Object *_self, bContext *C, ReportList *reports, const char * name, bool from_mix);
void Object_shape_key_remove_func(struct Object *_self, Main *bmain, ReportList *reports, struct PointerRNA *key);
void Object_shape_key_clear_func(struct Object *_self, Main *bmain);
void Object_ray_cast_func(struct Object *_self, bContext *C, ReportList *reports, float origin[3], float direction[3], float distance, struct PointerRNA *depsgraph, bool *result, float location[3], float normal[3], int *index);
void Object_closest_point_on_mesh_func(struct Object *_self, bContext *C, ReportList *reports, float origin[3], float distance, struct PointerRNA *depsgraph, bool *result, float location[3], float normal[3], int *index);
bool Object_is_modified_func(struct Object *_self, struct Scene *scene, int settings);
bool Object_is_deform_modified_func(struct Object *_self, struct Scene *scene, int settings);
bool Object_update_from_editmode_func(struct Object *_self, Main *bmain);
void Object_cache_release_func(struct Object *_self);
/**************** Object Base ****************/

extern StructRNA RNA_ObjectBase;

PointerRNA ObjectBase_rna_type_get(PointerRNA *ptr);

bool ObjectBase_hide_viewport_get(PointerRNA *ptr);
void ObjectBase_hide_viewport_set(PointerRNA *ptr, bool value);

PointerRNA ObjectBase_object_get(PointerRNA *ptr);

bool ObjectBase_select_get(PointerRNA *ptr);
void ObjectBase_select_set(PointerRNA *ptr, bool value);

/**************** Object Constraints ****************/

extern StructRNA RNA_ObjectConstraints;

PointerRNA ObjectConstraints_rna_type_get(PointerRNA *ptr);

PointerRNA ObjectConstraints_active_get(PointerRNA *ptr);

struct bConstraint *ObjectConstraints_new_func(struct Object *_self, Main *bmain, int type);
void ObjectConstraints_remove_func(struct Object *_self, Main *bmain, ReportList *reports, struct PointerRNA *constraint);
void ObjectConstraints_clear_func(struct Object *_self, Main *bmain);
void ObjectConstraints_move_func(struct Object *_self, Main *bmain, ReportList *reports, int from_index, int to_index);
struct bConstraint *ObjectConstraints_copy_func(struct Object *_self, Main *bmain, struct PointerRNA *constraint);
/**************** Object Display ****************/

extern StructRNA RNA_ObjectDisplay;

PointerRNA ObjectDisplay_rna_type_get(PointerRNA *ptr);

bool ObjectDisplay_show_shadows_get(PointerRNA *ptr);
void ObjectDisplay_show_shadows_set(PointerRNA *ptr, bool value);

/**************** Object Light Linking ****************/

extern StructRNA RNA_ObjectLightLinking;

PointerRNA ObjectLightLinking_rna_type_get(PointerRNA *ptr);

PointerRNA ObjectLightLinking_blocker_collection_get(PointerRNA *ptr);

PointerRNA ObjectLightLinking_receiver_collection_get(PointerRNA *ptr);

/**************** Object Line Art ****************/

extern StructRNA RNA_ObjectLineArt;

PointerRNA ObjectLineArt_rna_type_get(PointerRNA *ptr);

float ObjectLineArt_crease_threshold_get(PointerRNA *ptr);
void ObjectLineArt_crease_threshold_set(PointerRNA *ptr, float value);

int ObjectLineArt_intersection_priority_get(PointerRNA *ptr);
void ObjectLineArt_intersection_priority_set(PointerRNA *ptr, int value);

enum {
	ObjectLineArt_usage_INHERIT = 0,
	ObjectLineArt_usage_INCLUDE = 1,
	ObjectLineArt_usage_OCCLUSION_ONLY = 2,
	ObjectLineArt_usage_EXCLUDE = 4,
	ObjectLineArt_usage_INTERSECTION_ONLY = 8,
	ObjectLineArt_usage_NO_INTERSECTION = 16,
	ObjectLineArt_usage_FORCE_INTERSECTION = 32,
};

int ObjectLineArt_usage_get(PointerRNA *ptr);
void ObjectLineArt_usage_set(PointerRNA *ptr, int value);

bool ObjectLineArt_use_crease_override_get(PointerRNA *ptr);
void ObjectLineArt_use_crease_override_set(PointerRNA *ptr, bool value);

bool ObjectLineArt_use_intersection_priority_override_get(PointerRNA *ptr);
void ObjectLineArt_use_intersection_priority_override_set(PointerRNA *ptr, bool value);

/**************** Object Modifiers ****************/

extern StructRNA RNA_ObjectModifiers;

PointerRNA ObjectModifiers_rna_type_get(PointerRNA *ptr);

PointerRNA ObjectModifiers_active_get(PointerRNA *ptr);

struct ModifierData *ObjectModifiers_new_func(struct Object *_self, bContext *C, ReportList *reports, const char * name, int type);
void ObjectModifiers_remove_func(struct Object *_self, bContext *C, ReportList *reports, struct PointerRNA *modifier);
void ObjectModifiers_clear_func(struct Object *_self, bContext *C);
void ObjectModifiers_move_func(struct Object *_self, ReportList *reports, int from_index, int to_index);
/**************** Object Shader Effects ****************/

extern StructRNA RNA_ObjectShaderFx;

PointerRNA ObjectShaderFx_rna_type_get(PointerRNA *ptr);

struct ShaderFxData *ObjectShaderFx_new_func(struct Object *_self, bContext *C, ReportList *reports, const char * name, int type);
void ObjectShaderFx_remove_func(struct Object *_self, bContext *C, ReportList *reports, struct PointerRNA *shader_fx);
void ObjectShaderFx_clear_func(struct Object *_self, bContext *C);
/**************** Object Solver Constraint ****************/

extern StructRNA RNA_ObjectSolverConstraint;
extern StructRNA RNA_Constraint;

bool ObjectSolverConstraint_use_active_clip_get(PointerRNA *ptr);
void ObjectSolverConstraint_use_active_clip_set(PointerRNA *ptr, bool value);

PointerRNA ObjectSolverConstraint_camera_get(PointerRNA *ptr);

PointerRNA ObjectSolverConstraint_clip_get(PointerRNA *ptr);

#define ObjectSolverConstraint_object_MAX 64

void ObjectSolverConstraint_object_get(PointerRNA *ptr, char *value);
int ObjectSolverConstraint_object_length(PointerRNA *ptr);
void ObjectSolverConstraint_object_set(PointerRNA *ptr, const char *value);

bool ObjectSolverConstraint_set_inverse_pending_get(PointerRNA *ptr);
void ObjectSolverConstraint_set_inverse_pending_set(PointerRNA *ptr, bool value);

/**************** Ocean Modifier ****************/

extern StructRNA RNA_OceanModifier;
extern StructRNA RNA_Modifier;

int OceanModifier_frame_end_get(PointerRNA *ptr);
void OceanModifier_frame_end_set(PointerRNA *ptr, int value);

int OceanModifier_frame_start_get(PointerRNA *ptr);
void OceanModifier_frame_start_set(PointerRNA *ptr, int value);

#define OceanModifier_filepath_MAX 1024

void OceanModifier_filepath_get(PointerRNA *ptr, char *value);
int OceanModifier_filepath_length(PointerRNA *ptr);
void OceanModifier_filepath_set(PointerRNA *ptr, const char *value);

float OceanModifier_choppiness_get(PointerRNA *ptr);
void OceanModifier_choppiness_set(PointerRNA *ptr, float value);

float OceanModifier_damping_get(PointerRNA *ptr);
void OceanModifier_damping_set(PointerRNA *ptr, float value);

float OceanModifier_depth_get(PointerRNA *ptr);
void OceanModifier_depth_set(PointerRNA *ptr, float value);

float OceanModifier_fetch_jonswap_get(PointerRNA *ptr);
void OceanModifier_fetch_jonswap_set(PointerRNA *ptr, float value);

float OceanModifier_foam_coverage_get(PointerRNA *ptr);
void OceanModifier_foam_coverage_set(PointerRNA *ptr, float value);

float OceanModifier_bake_foam_fade_get(PointerRNA *ptr);
void OceanModifier_bake_foam_fade_set(PointerRNA *ptr, float value);

#define OceanModifier_foam_layer_name_MAX 68

void OceanModifier_foam_layer_name_get(PointerRNA *ptr, char *value);
int OceanModifier_foam_layer_name_length(PointerRNA *ptr);
void OceanModifier_foam_layer_name_set(PointerRNA *ptr, const char *value);

bool OceanModifier_use_foam_get(PointerRNA *ptr);
void OceanModifier_use_foam_set(PointerRNA *ptr, bool value);

bool OceanModifier_use_normals_get(PointerRNA *ptr);
void OceanModifier_use_normals_set(PointerRNA *ptr, bool value);

bool OceanModifier_use_spray_get(PointerRNA *ptr);
void OceanModifier_use_spray_set(PointerRNA *ptr, bool value);

enum {
	OceanModifier_geometry_mode_GENERATE = 0,
	OceanModifier_geometry_mode_DISPLACE = 1,
};

int OceanModifier_geometry_mode_get(PointerRNA *ptr);
void OceanModifier_geometry_mode_set(PointerRNA *ptr, int value);

bool OceanModifier_invert_spray_get(PointerRNA *ptr);
void OceanModifier_invert_spray_set(PointerRNA *ptr, bool value);

bool OceanModifier_is_cached_get(PointerRNA *ptr);
void OceanModifier_is_cached_set(PointerRNA *ptr, bool value);

int OceanModifier_random_seed_get(PointerRNA *ptr);
void OceanModifier_random_seed_set(PointerRNA *ptr, int value);

int OceanModifier_resolution_get(PointerRNA *ptr);
void OceanModifier_resolution_set(PointerRNA *ptr, int value);

int OceanModifier_repeat_x_get(PointerRNA *ptr);
void OceanModifier_repeat_x_set(PointerRNA *ptr, int value);

int OceanModifier_repeat_y_get(PointerRNA *ptr);
void OceanModifier_repeat_y_set(PointerRNA *ptr, int value);

float OceanModifier_sharpen_peak_jonswap_get(PointerRNA *ptr);
void OceanModifier_sharpen_peak_jonswap_set(PointerRNA *ptr, float value);

float OceanModifier_size_get(PointerRNA *ptr);
void OceanModifier_size_set(PointerRNA *ptr, float value);

float OceanModifier_wave_scale_min_get(PointerRNA *ptr);
void OceanModifier_wave_scale_min_set(PointerRNA *ptr, float value);

int OceanModifier_spatial_size_get(PointerRNA *ptr);
void OceanModifier_spatial_size_set(PointerRNA *ptr, int value);

enum {
	OceanModifier_spectrum_PHILLIPS = 0,
	OceanModifier_spectrum_PIERSON_MOSKOWITZ = 1,
	OceanModifier_spectrum_JONSWAP = 2,
	OceanModifier_spectrum_TEXEL_MARSEN_ARSLOE = 3,
};

int OceanModifier_spectrum_get(PointerRNA *ptr);
void OceanModifier_spectrum_set(PointerRNA *ptr, int value);

#define OceanModifier_spray_layer_name_MAX 68

void OceanModifier_spray_layer_name_get(PointerRNA *ptr, char *value);
int OceanModifier_spray_layer_name_length(PointerRNA *ptr);
void OceanModifier_spray_layer_name_set(PointerRNA *ptr, const char *value);

float OceanModifier_time_get(PointerRNA *ptr);
void OceanModifier_time_set(PointerRNA *ptr, float value);

int OceanModifier_viewport_resolution_get(PointerRNA *ptr);
void OceanModifier_viewport_resolution_set(PointerRNA *ptr, int value);

float OceanModifier_wave_alignment_get(PointerRNA *ptr);
void OceanModifier_wave_alignment_set(PointerRNA *ptr, float value);

float OceanModifier_wave_direction_get(PointerRNA *ptr);
void OceanModifier_wave_direction_set(PointerRNA *ptr, float value);

float OceanModifier_wave_scale_get(PointerRNA *ptr);
void OceanModifier_wave_scale_set(PointerRNA *ptr, float value);

float OceanModifier_wind_velocity_get(PointerRNA *ptr);
void OceanModifier_wind_velocity_set(PointerRNA *ptr, float value);

/**************** Operator ****************/

extern StructRNA RNA_Operator;

PointerRNA Operator_rna_type_get(PointerRNA *ptr);

void Operator_name_get(PointerRNA *ptr, char *value);
int Operator_name_length(PointerRNA *ptr);
void Operator_name_set(PointerRNA *ptr, const char *value);

bool Operator_has_reports_get(PointerRNA *ptr);
void Operator_has_reports_set(PointerRNA *ptr, bool value);

enum {
	Operator_bl_cursor_pending_DEFAULT = 1,
	Operator_bl_cursor_pending_NONE = 38,
	Operator_bl_cursor_pending_WAIT = 3,
	Operator_bl_cursor_pending_CROSSHAIR = 5,
	Operator_bl_cursor_pending_MOVE_X = 22,
	Operator_bl_cursor_pending_MOVE_Y = 23,
	Operator_bl_cursor_pending_KNIFE = 15,
	Operator_bl_cursor_pending_TEXT = 2,
	Operator_bl_cursor_pending_PAINT_BRUSH = 18,
	Operator_bl_cursor_pending_PAINT_CROSS = 12,
	Operator_bl_cursor_pending_DOT = 13,
	Operator_bl_cursor_pending_ERASER = 19,
	Operator_bl_cursor_pending_HAND = 8,
	Operator_bl_cursor_pending_HAND_POINT = 10,
	Operator_bl_cursor_pending_HAND_CLOSED = 9,
	Operator_bl_cursor_pending_SCROLL_X = 35,
	Operator_bl_cursor_pending_SCROLL_Y = 34,
	Operator_bl_cursor_pending_SCROLL_XY = 33,
	Operator_bl_cursor_pending_EYEDROPPER = 20,
	Operator_bl_cursor_pending_PICK_AREA = 40,
	Operator_bl_cursor_pending_STOP = 4,
	Operator_bl_cursor_pending_COPY = 6,
	Operator_bl_cursor_pending_CROSS = 11,
	Operator_bl_cursor_pending_MUTE = 39,
	Operator_bl_cursor_pending_ZOOM_IN = 36,
	Operator_bl_cursor_pending_ZOOM_OUT = 37,
};

int Operator_bl_cursor_pending_get(PointerRNA *ptr);
void Operator_bl_cursor_pending_set(PointerRNA *ptr, int value);

void Operator_macros_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Operator_macros_next(CollectionPropertyIterator *iter);
void Operator_macros_end(CollectionPropertyIterator *iter);
bool Operator_macros_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Operator_macros_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

enum {
	Operator_bl_options_REGISTER = 1,
	Operator_bl_options_UNDO = 2,
	Operator_bl_options_UNDO_GROUPED = 1024,
	Operator_bl_options_BLOCKING = 4,
	Operator_bl_options_MACRO = 8,
	Operator_bl_options_GRAB_CURSOR = 16,
	Operator_bl_options_GRAB_CURSOR_X = 32,
	Operator_bl_options_GRAB_CURSOR_Y = 64,
	Operator_bl_options_DEPENDS_ON_CURSOR = 2048,
	Operator_bl_options_PRESET = 128,
	Operator_bl_options_INTERNAL = 256,
	Operator_bl_options_MODAL_PRIORITY = 4096,
};

int Operator_bl_options_get(PointerRNA *ptr);
void Operator_bl_options_set(PointerRNA *ptr, int value);

PointerRNA Operator_options_get(PointerRNA *ptr);

PointerRNA Operator_properties_get(PointerRNA *ptr);

#define Operator_bl_description_MAX 1024

void Operator_bl_description_get(PointerRNA *ptr, char *value);
int Operator_bl_description_length(PointerRNA *ptr);
void Operator_bl_description_set(PointerRNA *ptr, const char *value);

#define Operator_bl_idname_MAX 64

void Operator_bl_idname_get(PointerRNA *ptr, char *value);
int Operator_bl_idname_length(PointerRNA *ptr);
void Operator_bl_idname_set(PointerRNA *ptr, const char *value);

#define Operator_bl_label_MAX 64

void Operator_bl_label_get(PointerRNA *ptr, char *value);
int Operator_bl_label_length(PointerRNA *ptr);
void Operator_bl_label_set(PointerRNA *ptr, const char *value);

#define Operator_bl_translation_context_MAX 64

void Operator_bl_translation_context_get(PointerRNA *ptr, char *value);
int Operator_bl_translation_context_length(PointerRNA *ptr);
void Operator_bl_translation_context_set(PointerRNA *ptr, const char *value);

#define Operator_bl_undo_group_MAX 64

void Operator_bl_undo_group_get(PointerRNA *ptr, char *value);
int Operator_bl_undo_group_length(PointerRNA *ptr);
void Operator_bl_undo_group_set(PointerRNA *ptr, const char *value);

PointerRNA Operator_layout_get(PointerRNA *ptr);

void Operator_report_func(struct wmOperator *_self, int type, const char * message);
bool Operator_is_repeat_func(struct wmOperator *_self, bContext *C);
bool Operator_poll_func(struct bContext *context);
int Operator_execute_func(struct wmOperator *_self, struct bContext *context);
bool Operator_check_func(struct wmOperator *_self, struct bContext *context);
int Operator_invoke_func(struct wmOperator *_self, struct bContext *context, struct wmEvent *event);
int Operator_modal_func(struct wmOperator *_self, struct bContext *context, struct wmEvent *event);
void Operator_draw_func(struct wmOperator *_self, struct bContext *context);
void Operator_cancel_func(struct wmOperator *_self, struct bContext *context);
void Operator_description_func(char * result, struct bContext *context, struct PointerRNA *properties);
/**************** Operator File List Element ****************/

extern StructRNA RNA_OperatorFileListElement;
extern StructRNA RNA_PropertyGroup;

/**************** Operator Macro ****************/

extern StructRNA RNA_OperatorMacro;

PointerRNA OperatorMacro_rna_type_get(PointerRNA *ptr);

PointerRNA OperatorMacro_properties_get(PointerRNA *ptr);

/**************** Operator Mouse Path ****************/

extern StructRNA RNA_OperatorMousePath;
extern StructRNA RNA_PropertyGroup;

/**************** Operator Options ****************/

extern StructRNA RNA_OperatorOptions;

PointerRNA OperatorOptions_rna_type_get(PointerRNA *ptr);

bool OperatorOptions_use_cursor_region_get(PointerRNA *ptr);
void OperatorOptions_use_cursor_region_set(PointerRNA *ptr, bool value);

bool OperatorOptions_is_grab_cursor_get(PointerRNA *ptr);
void OperatorOptions_is_grab_cursor_set(PointerRNA *ptr, bool value);

bool OperatorOptions_is_invoke_get(PointerRNA *ptr);
void OperatorOptions_is_invoke_set(PointerRNA *ptr, bool value);

bool OperatorOptions_is_repeat_get(PointerRNA *ptr);
void OperatorOptions_is_repeat_set(PointerRNA *ptr, bool value);

bool OperatorOptions_is_repeat_last_get(PointerRNA *ptr);
void OperatorOptions_is_repeat_last_set(PointerRNA *ptr, bool value);

/**************** Operator Properties ****************/

extern StructRNA RNA_OperatorProperties;

PointerRNA OperatorProperties_rna_type_get(PointerRNA *ptr);

/**************** Operator Stroke Element ****************/

extern StructRNA RNA_OperatorStrokeElement;
extern StructRNA RNA_PropertyGroup;

/**************** Packed File ****************/

extern StructRNA RNA_PackedFile;

PointerRNA PackedFile_rna_type_get(PointerRNA *ptr);

void PackedFile_data_get(PointerRNA *ptr, char *value);
int PackedFile_data_length(PointerRNA *ptr);
void PackedFile_data_set(PointerRNA *ptr, const char *value);

int PackedFile_size_get(PointerRNA *ptr);
void PackedFile_size_set(PointerRNA *ptr, int value);

/**************** Paint ****************/

extern StructRNA RNA_Paint;

PointerRNA Paint_rna_type_get(PointerRNA *ptr);

PointerRNA Paint_brush_get(PointerRNA *ptr);

PointerRNA Paint_brush_asset_reference_get(PointerRNA *ptr);

bool Paint_use_cavity_get(PointerRNA *ptr);
void Paint_use_cavity_set(PointerRNA *ptr, bool value);

PointerRNA Paint_cavity_curve_get(PointerRNA *ptr);

PointerRNA Paint_eraser_brush_get(PointerRNA *ptr);

bool Paint_use_sculpt_delay_updates_get(PointerRNA *ptr);
void Paint_use_sculpt_delay_updates_set(PointerRNA *ptr, bool value);

PointerRNA Paint_eraser_brush_asset_reference_get(PointerRNA *ptr);

bool Paint_show_low_resolution_get(PointerRNA *ptr);
void Paint_show_low_resolution_set(PointerRNA *ptr, bool value);

PointerRNA Paint_palette_get(PointerRNA *ptr);

bool Paint_show_brush_get(PointerRNA *ptr);
void Paint_show_brush_set(PointerRNA *ptr, bool value);

bool Paint_show_brush_on_surface_get(PointerRNA *ptr);
void Paint_show_brush_on_surface_set(PointerRNA *ptr, bool value);

bool Paint_use_symmetry_feather_get(PointerRNA *ptr);
void Paint_use_symmetry_feather_set(PointerRNA *ptr, bool value);

bool Paint_use_symmetry_x_get(PointerRNA *ptr);
void Paint_use_symmetry_x_set(PointerRNA *ptr, bool value);

bool Paint_use_symmetry_y_get(PointerRNA *ptr);
void Paint_use_symmetry_y_set(PointerRNA *ptr, bool value);

bool Paint_use_symmetry_z_get(PointerRNA *ptr);
void Paint_use_symmetry_z_set(PointerRNA *ptr, bool value);

bool Paint_tile_x_get(PointerRNA *ptr);
void Paint_tile_x_set(PointerRNA *ptr, bool value);

bool Paint_tile_y_get(PointerRNA *ptr);
void Paint_tile_y_set(PointerRNA *ptr, bool value);

bool Paint_tile_z_get(PointerRNA *ptr);
void Paint_tile_z_set(PointerRNA *ptr, bool value);

void Paint_tile_offset_get(PointerRNA *ptr, float values[3]);
void Paint_tile_offset_set(PointerRNA *ptr, const float values[3]);

/**************** Paint Curve ****************/

extern StructRNA RNA_PaintCurve;
extern StructRNA RNA_ID;

/**************** Paint Mode ****************/

extern StructRNA RNA_PaintModeSettings;

PointerRNA PaintModeSettings_rna_type_get(PointerRNA *ptr);

enum {
	PaintModeSettings_canvas_source_COLOR_ATTRIBUTE = 2,
	PaintModeSettings_canvas_source_MATERIAL = 0,
	PaintModeSettings_canvas_source_IMAGE = 1,
};

int PaintModeSettings_canvas_source_get(PointerRNA *ptr);
void PaintModeSettings_canvas_source_set(PointerRNA *ptr, int value);

PointerRNA PaintModeSettings_canvas_image_get(PointerRNA *ptr);

/**************** Palette ****************/

extern StructRNA RNA_Palette;
extern StructRNA RNA_ID;

void Palette_colors_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Palette_colors_next(CollectionPropertyIterator *iter);
void Palette_colors_end(CollectionPropertyIterator *iter);
bool Palette_colors_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Palette Color ****************/

extern StructRNA RNA_PaletteColor;

PointerRNA PaletteColor_rna_type_get(PointerRNA *ptr);

void PaletteColor_color_get(PointerRNA *ptr, float values[3]);
void PaletteColor_color_set(PointerRNA *ptr, const float values[3]);

float PaletteColor_strength_get(PointerRNA *ptr);
void PaletteColor_strength_set(PointerRNA *ptr, float value);

float PaletteColor_weight_get(PointerRNA *ptr);
void PaletteColor_weight_set(PointerRNA *ptr, float value);

/**************** Palette Splines ****************/

extern StructRNA RNA_PaletteColors;

PointerRNA PaletteColors_rna_type_get(PointerRNA *ptr);

PointerRNA PaletteColors_active_get(PointerRNA *ptr);

struct PaletteColor *PaletteColors_new_func(struct Palette *_self);
void PaletteColors_remove_func(struct Palette *_self, ReportList *reports, struct PointerRNA *color);
void PaletteColors_clear_func(struct Palette *_self);
/**************** Panel ****************/

extern StructRNA RNA_Panel;

PointerRNA Panel_rna_type_get(PointerRNA *ptr);

void Panel_bl_translation_context_get(PointerRNA *ptr, char *value);
int Panel_bl_translation_context_length(PointerRNA *ptr);
void Panel_bl_translation_context_set(PointerRNA *ptr, const char *value);

#define Panel_bl_description_MAX 1024

void Panel_bl_description_get(PointerRNA *ptr, char *value);
int Panel_bl_description_length(PointerRNA *ptr);
void Panel_bl_description_set(PointerRNA *ptr, const char *value);

void Panel_bl_category_get(PointerRNA *ptr, char *value);
int Panel_bl_category_length(PointerRNA *ptr);
void Panel_bl_category_set(PointerRNA *ptr, const char *value);

void Panel_bl_owner_id_get(PointerRNA *ptr, char *value);
int Panel_bl_owner_id_length(PointerRNA *ptr);
void Panel_bl_owner_id_set(PointerRNA *ptr, const char *value);

void Panel_bl_context_get(PointerRNA *ptr, char *value);
int Panel_bl_context_length(PointerRNA *ptr);
void Panel_bl_context_set(PointerRNA *ptr, const char *value);

PointerRNA Panel_custom_data_get(PointerRNA *ptr);

void Panel_bl_idname_get(PointerRNA *ptr, char *value);
int Panel_bl_idname_length(PointerRNA *ptr);
void Panel_bl_idname_set(PointerRNA *ptr, const char *value);

void Panel_bl_label_get(PointerRNA *ptr, char *value);
int Panel_bl_label_length(PointerRNA *ptr);
void Panel_bl_label_set(PointerRNA *ptr, const char *value);

PointerRNA Panel_layout_get(PointerRNA *ptr);

enum {
	Panel_bl_options_DEFAULT_CLOSED = 1,
	Panel_bl_options_HIDE_HEADER = 2,
	Panel_bl_options_INSTANCED = 16,
	Panel_bl_options_HEADER_LAYOUT_EXPAND = 4,
};

int Panel_bl_options_get(PointerRNA *ptr);
void Panel_bl_options_set(PointerRNA *ptr, int value);

int Panel_bl_order_get(PointerRNA *ptr);
void Panel_bl_order_set(PointerRNA *ptr, int value);

void Panel_bl_parent_id_get(PointerRNA *ptr, char *value);
int Panel_bl_parent_id_length(PointerRNA *ptr);
void Panel_bl_parent_id_set(PointerRNA *ptr, const char *value);

bool Panel_use_pin_get(PointerRNA *ptr);
void Panel_use_pin_set(PointerRNA *ptr, bool value);

bool Panel_is_popover_get(PointerRNA *ptr);
void Panel_is_popover_set(PointerRNA *ptr, bool value);

enum {
	Panel_bl_region_type_WINDOW = 0,
	Panel_bl_region_type_HEADER = 1,
	Panel_bl_region_type_CHANNELS = 2,
	Panel_bl_region_type_TEMPORARY = 3,
	Panel_bl_region_type_UI = 4,
	Panel_bl_region_type_TOOLS = 5,
	Panel_bl_region_type_TOOL_PROPS = 6,
	Panel_bl_region_type_ASSET_SHELF = 14,
	Panel_bl_region_type_ASSET_SHELF_HEADER = 15,
	Panel_bl_region_type_PREVIEW = 7,
	Panel_bl_region_type_HUD = 8,
	Panel_bl_region_type_NAVIGATION_BAR = 9,
	Panel_bl_region_type_EXECUTE = 10,
	Panel_bl_region_type_FOOTER = 11,
	Panel_bl_region_type_TOOL_HEADER = 12,
	Panel_bl_region_type_XR = 13,
};

int Panel_bl_region_type_get(PointerRNA *ptr);
void Panel_bl_region_type_set(PointerRNA *ptr, int value);

enum {
	Panel_bl_space_type_EMPTY = 0,
	Panel_bl_space_type_VIEW_3D = 1,
	Panel_bl_space_type_IMAGE_EDITOR = 6,
	Panel_bl_space_type_NODE_EDITOR = 16,
	Panel_bl_space_type_SEQUENCE_EDITOR = 8,
	Panel_bl_space_type_CLIP_EDITOR = 20,
	Panel_bl_space_type_DOPESHEET_EDITOR = 12,
	Panel_bl_space_type_GRAPH_EDITOR = 2,
	Panel_bl_space_type_NLA_EDITOR = 13,
	Panel_bl_space_type_TEXT_EDITOR = 9,
	Panel_bl_space_type_CONSOLE = 18,
	Panel_bl_space_type_INFO = 7,
	Panel_bl_space_type_TOPBAR = 21,
	Panel_bl_space_type_STATUSBAR = 22,
	Panel_bl_space_type_OUTLINER = 3,
	Panel_bl_space_type_PROPERTIES = 4,
	Panel_bl_space_type_FILE_BROWSER = 5,
	Panel_bl_space_type_SPREADSHEET = 23,
	Panel_bl_space_type_PREFERENCES = 19,
};

int Panel_bl_space_type_get(PointerRNA *ptr);
void Panel_bl_space_type_set(PointerRNA *ptr, int value);

void Panel_text_get(PointerRNA *ptr, char *value);
int Panel_text_length(PointerRNA *ptr);
void Panel_text_set(PointerRNA *ptr, const char *value);

int Panel_bl_ui_units_x_get(PointerRNA *ptr);
void Panel_bl_ui_units_x_set(PointerRNA *ptr, int value);

bool Panel_poll_func(struct bContext *context);
void Panel_draw_func(struct Panel *_self, struct bContext *context);
void Panel_draw_header_func(struct Panel *_self, struct bContext *context);
void Panel_draw_header_preset_func(struct Panel *_self, struct bContext *context);
/**************** Particle ****************/

extern StructRNA RNA_Particle;

PointerRNA Particle_rna_type_get(PointerRNA *ptr);

enum {
	Particle_alive_state_DEAD = 1,
	Particle_alive_state_UNBORN = 2,
	Particle_alive_state_ALIVE = 3,
	Particle_alive_state_DYING = 4,
};

int Particle_alive_state_get(PointerRNA *ptr);
void Particle_alive_state_set(PointerRNA *ptr, int value);

void Particle_angular_velocity_get(PointerRNA *ptr, float values[3]);
void Particle_angular_velocity_set(PointerRNA *ptr, const float values[3]);

float Particle_birth_time_get(PointerRNA *ptr);
void Particle_birth_time_set(PointerRNA *ptr, float value);

float Particle_die_time_get(PointerRNA *ptr);
void Particle_die_time_set(PointerRNA *ptr, float value);

bool Particle_is_exist_get(PointerRNA *ptr);
void Particle_is_exist_set(PointerRNA *ptr, bool value);

void Particle_hair_keys_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Particle_hair_keys_next(CollectionPropertyIterator *iter);
void Particle_hair_keys_end(CollectionPropertyIterator *iter);
int Particle_hair_keys_length(PointerRNA *ptr);
bool Particle_hair_keys_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

void Particle_particle_keys_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Particle_particle_keys_next(CollectionPropertyIterator *iter);
void Particle_particle_keys_end(CollectionPropertyIterator *iter);
int Particle_particle_keys_length(PointerRNA *ptr);
bool Particle_particle_keys_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

float Particle_lifetime_get(PointerRNA *ptr);
void Particle_lifetime_set(PointerRNA *ptr, float value);

void Particle_location_get(PointerRNA *ptr, float values[3]);
void Particle_location_set(PointerRNA *ptr, const float values[3]);

void Particle_velocity_get(PointerRNA *ptr, float values[3]);
void Particle_velocity_set(PointerRNA *ptr, const float values[3]);

void Particle_prev_angular_velocity_get(PointerRNA *ptr, float values[3]);
void Particle_prev_angular_velocity_set(PointerRNA *ptr, const float values[3]);

void Particle_prev_location_get(PointerRNA *ptr, float values[3]);
void Particle_prev_location_set(PointerRNA *ptr, const float values[3]);

void Particle_prev_velocity_get(PointerRNA *ptr, float values[3]);
void Particle_prev_velocity_set(PointerRNA *ptr, const float values[3]);

void Particle_prev_rotation_get(PointerRNA *ptr, float values[4]);
void Particle_prev_rotation_set(PointerRNA *ptr, const float values[4]);

void Particle_rotation_get(PointerRNA *ptr, float values[4]);
void Particle_rotation_set(PointerRNA *ptr, const float values[4]);

float Particle_size_get(PointerRNA *ptr);
void Particle_size_set(PointerRNA *ptr, float value);

bool Particle_is_visible_get(PointerRNA *ptr);
void Particle_is_visible_set(PointerRNA *ptr, bool value);

void Particle_uv_on_emitter_func(struct ParticleData *_self, ReportList *reports, struct ParticleSystemModifierData *modifier, float uv[2]);
/**************** Particle Brush ****************/

extern StructRNA RNA_ParticleBrush;

PointerRNA ParticleBrush_rna_type_get(PointerRNA *ptr);

int ParticleBrush_count_get(PointerRNA *ptr);
void ParticleBrush_count_set(PointerRNA *ptr, int value);

PointerRNA ParticleBrush_curve_get(PointerRNA *ptr);

enum {
	ParticleBrush_length_mode_GROW = 0,
	ParticleBrush_length_mode_SHRINK = 1,
};

int ParticleBrush_length_mode_get(PointerRNA *ptr);
void ParticleBrush_length_mode_set(PointerRNA *ptr, int value);

enum {
	ParticleBrush_puff_mode_ADD = 0,
	ParticleBrush_puff_mode_SUB = 1,
};

int ParticleBrush_puff_mode_get(PointerRNA *ptr);
void ParticleBrush_puff_mode_set(PointerRNA *ptr, int value);

bool ParticleBrush_use_puff_volume_get(PointerRNA *ptr);
void ParticleBrush_use_puff_volume_set(PointerRNA *ptr, bool value);

int ParticleBrush_size_get(PointerRNA *ptr);
void ParticleBrush_size_set(PointerRNA *ptr, int value);

int ParticleBrush_steps_get(PointerRNA *ptr);
void ParticleBrush_steps_set(PointerRNA *ptr, int value);

float ParticleBrush_strength_get(PointerRNA *ptr);
void ParticleBrush_strength_set(PointerRNA *ptr, float value);

/**************** Particle Instance Object Weight ****************/

extern StructRNA RNA_ParticleDupliWeight;

PointerRNA ParticleDupliWeight_rna_type_get(PointerRNA *ptr);

void ParticleDupliWeight_name_get(PointerRNA *ptr, char *value);
int ParticleDupliWeight_name_length(PointerRNA *ptr);
void ParticleDupliWeight_name_set(PointerRNA *ptr, const char *value);

int ParticleDupliWeight_count_get(PointerRNA *ptr);
void ParticleDupliWeight_count_set(PointerRNA *ptr, int value);

/**************** Particle Edit ****************/

extern StructRNA RNA_ParticleEdit;

PointerRNA ParticleEdit_rna_type_get(PointerRNA *ptr);

bool ParticleEdit_use_auto_velocity_get(PointerRNA *ptr);
void ParticleEdit_use_auto_velocity_set(PointerRNA *ptr, bool value);

PointerRNA ParticleEdit_brush_get(PointerRNA *ptr);

bool ParticleEdit_use_emitter_deflect_get(PointerRNA *ptr);
void ParticleEdit_use_emitter_deflect_set(PointerRNA *ptr, bool value);

bool ParticleEdit_show_particles_get(PointerRNA *ptr);
void ParticleEdit_show_particles_set(PointerRNA *ptr, bool value);

bool ParticleEdit_is_editable_get(PointerRNA *ptr);
void ParticleEdit_is_editable_set(PointerRNA *ptr, bool value);

float ParticleEdit_emitter_distance_get(PointerRNA *ptr);
void ParticleEdit_emitter_distance_set(PointerRNA *ptr, float value);

bool ParticleEdit_use_fade_time_get(PointerRNA *ptr);
void ParticleEdit_use_fade_time_set(PointerRNA *ptr, bool value);

int ParticleEdit_fade_frames_get(PointerRNA *ptr);
void ParticleEdit_fade_frames_set(PointerRNA *ptr, int value);

bool ParticleEdit_is_hair_get(PointerRNA *ptr);
void ParticleEdit_is_hair_set(PointerRNA *ptr, bool value);

bool ParticleEdit_use_default_interpolate_get(PointerRNA *ptr);
void ParticleEdit_use_default_interpolate_set(PointerRNA *ptr, bool value);

bool ParticleEdit_use_preserve_length_get(PointerRNA *ptr);
void ParticleEdit_use_preserve_length_set(PointerRNA *ptr, bool value);

bool ParticleEdit_use_preserve_root_get(PointerRNA *ptr);
void ParticleEdit_use_preserve_root_set(PointerRNA *ptr, bool value);

int ParticleEdit_default_key_count_get(PointerRNA *ptr);
void ParticleEdit_default_key_count_set(PointerRNA *ptr, int value);

PointerRNA ParticleEdit_object_get(PointerRNA *ptr);

enum {
	ParticleEdit_select_mode_PATH = 1,
	ParticleEdit_select_mode_POINT = 2,
	ParticleEdit_select_mode_TIP = 4,
};

int ParticleEdit_select_mode_get(PointerRNA *ptr);
void ParticleEdit_select_mode_set(PointerRNA *ptr, int value);

PointerRNA ParticleEdit_shape_object_get(PointerRNA *ptr);

int ParticleEdit_display_step_get(PointerRNA *ptr);
void ParticleEdit_display_step_set(PointerRNA *ptr, int value);

enum {
	ParticleEdit_tool_COMB = 0,
	ParticleEdit_tool_SMOOTH = 5,
	ParticleEdit_tool_ADD = 4,
	ParticleEdit_tool_LENGTH = 2,
	ParticleEdit_tool_PUFF = 3,
	ParticleEdit_tool_CUT = 1,
	ParticleEdit_tool_WEIGHT = 6,
};

int ParticleEdit_tool_get(PointerRNA *ptr);
void ParticleEdit_tool_set(PointerRNA *ptr, int value);

enum {
	ParticleEdit_type_PARTICLES = 0,
	ParticleEdit_type_SOFT_BODY = 1,
	ParticleEdit_type_CLOTH = 2,
};

int ParticleEdit_type_get(PointerRNA *ptr);
void ParticleEdit_type_set(PointerRNA *ptr, int value);

/**************** Particle Hair Key ****************/

extern StructRNA RNA_ParticleHairKey;

PointerRNA ParticleHairKey_rna_type_get(PointerRNA *ptr);

void ParticleHairKey_co_local_get(PointerRNA *ptr, float values[3]);
void ParticleHairKey_co_local_set(PointerRNA *ptr, const float values[3]);

void ParticleHairKey_co_get(PointerRNA *ptr, float values[3]);
void ParticleHairKey_co_set(PointerRNA *ptr, const float values[3]);

float ParticleHairKey_time_get(PointerRNA *ptr);
void ParticleHairKey_time_set(PointerRNA *ptr, float value);

float ParticleHairKey_weight_get(PointerRNA *ptr);
void ParticleHairKey_weight_set(PointerRNA *ptr, float value);

void ParticleHairKey_co_object_func(struct HairKey *_self, struct Object *object, struct ParticleSystemModifierData *modifier, struct ParticleData *particle, float co[3]);
void ParticleHairKey_co_object_set_func(struct ID *_selfid, struct HairKey *_self, struct Object *object, struct ParticleSystemModifierData *modifier, struct ParticleData *particle, float co[3]);
/**************** ParticleInstance Modifier ****************/

extern StructRNA RNA_ParticleInstanceModifier;
extern StructRNA RNA_Modifier;

bool ParticleInstanceModifier_show_alive_get(PointerRNA *ptr);
void ParticleInstanceModifier_show_alive_set(PointerRNA *ptr, bool value);

enum {
	ParticleInstanceModifier_axis_X = 0,
	ParticleInstanceModifier_axis_Y = 1,
	ParticleInstanceModifier_axis_Z = 2,
};

int ParticleInstanceModifier_axis_get(PointerRNA *ptr);
void ParticleInstanceModifier_axis_set(PointerRNA *ptr, int value);

bool ParticleInstanceModifier_use_children_get(PointerRNA *ptr);
void ParticleInstanceModifier_use_children_set(PointerRNA *ptr, bool value);

bool ParticleInstanceModifier_show_dead_get(PointerRNA *ptr);
void ParticleInstanceModifier_show_dead_set(PointerRNA *ptr, bool value);

#define ParticleInstanceModifier_index_layer_name_MAX 68

void ParticleInstanceModifier_index_layer_name_get(PointerRNA *ptr, char *value);
int ParticleInstanceModifier_index_layer_name_length(PointerRNA *ptr);
void ParticleInstanceModifier_index_layer_name_set(PointerRNA *ptr, const char *value);

bool ParticleInstanceModifier_use_preserve_shape_get(PointerRNA *ptr);
void ParticleInstanceModifier_use_preserve_shape_set(PointerRNA *ptr, bool value);

PointerRNA ParticleInstanceModifier_object_get(PointerRNA *ptr);

float ParticleInstanceModifier_particle_amount_get(PointerRNA *ptr);
void ParticleInstanceModifier_particle_amount_set(PointerRNA *ptr, float value);

float ParticleInstanceModifier_particle_offset_get(PointerRNA *ptr);
void ParticleInstanceModifier_particle_offset_set(PointerRNA *ptr, float value);

PointerRNA ParticleInstanceModifier_particle_system_get(PointerRNA *ptr);

int ParticleInstanceModifier_particle_system_index_get(PointerRNA *ptr);
void ParticleInstanceModifier_particle_system_index_set(PointerRNA *ptr, int value);

bool ParticleInstanceModifier_use_path_get(PointerRNA *ptr);
void ParticleInstanceModifier_use_path_set(PointerRNA *ptr, bool value);

float ParticleInstanceModifier_position_get(PointerRNA *ptr);
void ParticleInstanceModifier_position_set(PointerRNA *ptr, float value);

float ParticleInstanceModifier_random_position_get(PointerRNA *ptr);
void ParticleInstanceModifier_random_position_set(PointerRNA *ptr, float value);

float ParticleInstanceModifier_random_rotation_get(PointerRNA *ptr);
void ParticleInstanceModifier_random_rotation_set(PointerRNA *ptr, float value);

bool ParticleInstanceModifier_use_normal_get(PointerRNA *ptr);
void ParticleInstanceModifier_use_normal_set(PointerRNA *ptr, bool value);

float ParticleInstanceModifier_rotation_get(PointerRNA *ptr);
void ParticleInstanceModifier_rotation_set(PointerRNA *ptr, float value);

bool ParticleInstanceModifier_use_size_get(PointerRNA *ptr);
void ParticleInstanceModifier_use_size_set(PointerRNA *ptr, bool value);

enum {
	ParticleInstanceModifier_space_LOCAL = 1,
	ParticleInstanceModifier_space_WORLD = 0,
};

int ParticleInstanceModifier_space_get(PointerRNA *ptr);
void ParticleInstanceModifier_space_set(PointerRNA *ptr, int value);

bool ParticleInstanceModifier_show_unborn_get(PointerRNA *ptr);
void ParticleInstanceModifier_show_unborn_set(PointerRNA *ptr, bool value);

#define ParticleInstanceModifier_value_layer_name_MAX 68

void ParticleInstanceModifier_value_layer_name_get(PointerRNA *ptr, char *value);
int ParticleInstanceModifier_value_layer_name_length(PointerRNA *ptr);
void ParticleInstanceModifier_value_layer_name_set(PointerRNA *ptr, const char *value);

/**************** Particle Key ****************/

extern StructRNA RNA_ParticleKey;

PointerRNA ParticleKey_rna_type_get(PointerRNA *ptr);

void ParticleKey_angular_velocity_get(PointerRNA *ptr, float values[3]);
void ParticleKey_angular_velocity_set(PointerRNA *ptr, const float values[3]);

void ParticleKey_location_get(PointerRNA *ptr, float values[3]);
void ParticleKey_location_set(PointerRNA *ptr, const float values[3]);

void ParticleKey_rotation_get(PointerRNA *ptr, float values[4]);
void ParticleKey_rotation_set(PointerRNA *ptr, const float values[4]);

float ParticleKey_time_get(PointerRNA *ptr);
void ParticleKey_time_set(PointerRNA *ptr, float value);

void ParticleKey_velocity_get(PointerRNA *ptr, float values[3]);
void ParticleKey_velocity_set(PointerRNA *ptr, const float values[3]);

/**************** Particle Settings ****************/

extern StructRNA RNA_ParticleSettings;
extern StructRNA RNA_ID;

bool ParticleSettings_use_absolute_path_time_get(PointerRNA *ptr);
void ParticleSettings_use_absolute_path_time_set(PointerRNA *ptr, bool value);

PointerRNA ParticleSettings_active_instanceweight_get(PointerRNA *ptr);

int ParticleSettings_active_instanceweight_index_get(PointerRNA *ptr);
void ParticleSettings_active_instanceweight_index_set(PointerRNA *ptr, int value);

PointerRNA ParticleSettings_active_texture_get(PointerRNA *ptr);

int ParticleSettings_active_texture_index_get(PointerRNA *ptr);
void ParticleSettings_active_texture_index_set(PointerRNA *ptr, int value);

bool ParticleSettings_use_render_adaptive_get(PointerRNA *ptr);
void ParticleSettings_use_render_adaptive_set(PointerRNA *ptr, bool value);

float ParticleSettings_courant_target_get(PointerRNA *ptr);
void ParticleSettings_courant_target_set(PointerRNA *ptr, float value);

bool ParticleSettings_use_advanced_hair_get(PointerRNA *ptr);
void ParticleSettings_use_advanced_hair_set(PointerRNA *ptr, bool value);

bool ParticleSettings_apply_effector_to_children_get(PointerRNA *ptr);
void ParticleSettings_apply_effector_to_children_set(PointerRNA *ptr, bool value);

float ParticleSettings_jitter_factor_get(PointerRNA *ptr);
void ParticleSettings_jitter_factor_set(PointerRNA *ptr, float value);

float ParticleSettings_kink_amplitude_get(PointerRNA *ptr);
void ParticleSettings_kink_amplitude_set(PointerRNA *ptr, float value);

float ParticleSettings_kink_amplitude_clump_get(PointerRNA *ptr);
void ParticleSettings_kink_amplitude_clump_set(PointerRNA *ptr, float value);

float ParticleSettings_kink_amplitude_random_get(PointerRNA *ptr);
void ParticleSettings_kink_amplitude_random_set(PointerRNA *ptr, float value);

float ParticleSettings_angular_velocity_factor_get(PointerRNA *ptr);
void ParticleSettings_angular_velocity_factor_set(PointerRNA *ptr, float value);

enum {
	ParticleSettings_angular_velocity_mode_NONE = 0,
	ParticleSettings_angular_velocity_mode_VELOCITY = 1,
	ParticleSettings_angular_velocity_mode_HORIZONTAL = 3,
	ParticleSettings_angular_velocity_mode_VERTICAL = 4,
	ParticleSettings_angular_velocity_mode_GLOBAL_X = 5,
	ParticleSettings_angular_velocity_mode_GLOBAL_Y = 6,
	ParticleSettings_angular_velocity_mode_GLOBAL_Z = 7,
	ParticleSettings_angular_velocity_mode_RAND = 2,
};

int ParticleSettings_angular_velocity_mode_get(PointerRNA *ptr);
void ParticleSettings_angular_velocity_mode_set(PointerRNA *ptr, int value);

PointerRNA ParticleSettings_animation_data_get(PointerRNA *ptr);

bool ParticleSettings_use_adaptive_subframes_get(PointerRNA *ptr);
void ParticleSettings_use_adaptive_subframes_set(PointerRNA *ptr, bool value);

enum {
	ParticleSettings_kink_axis_X = 0,
	ParticleSettings_kink_axis_Y = 1,
	ParticleSettings_kink_axis_Z = 2,
};

int ParticleSettings_kink_axis_get(PointerRNA *ptr);
void ParticleSettings_kink_axis_set(PointerRNA *ptr, int value);

float ParticleSettings_kink_axis_random_get(PointerRNA *ptr);
void ParticleSettings_kink_axis_random_set(PointerRNA *ptr, float value);

bool ParticleSettings_use_hair_bspline_get(PointerRNA *ptr);
void ParticleSettings_use_hair_bspline_set(PointerRNA *ptr, bool value);

PointerRNA ParticleSettings_boids_get(PointerRNA *ptr);

bool ParticleSettings_lock_boids_to_surface_get(PointerRNA *ptr);
void ParticleSettings_lock_boids_to_surface_set(PointerRNA *ptr, bool value);

float ParticleSettings_brownian_factor_get(PointerRNA *ptr);
void ParticleSettings_brownian_factor_set(PointerRNA *ptr, float value);

float ParticleSettings_child_radius_get(PointerRNA *ptr);
void ParticleSettings_child_radius_set(PointerRNA *ptr, float value);

float ParticleSettings_child_roundness_get(PointerRNA *ptr);
void ParticleSettings_child_roundness_set(PointerRNA *ptr, float value);

float ParticleSettings_child_size_get(PointerRNA *ptr);
void ParticleSettings_child_size_set(PointerRNA *ptr, float value);

enum {
	ParticleSettings_child_type_NONE = 0,
	ParticleSettings_child_type_SIMPLE = 1,
	ParticleSettings_child_type_INTERPOLATED = 2,
};

int ParticleSettings_child_type_get(PointerRNA *ptr);
void ParticleSettings_child_type_set(PointerRNA *ptr, int value);

int ParticleSettings_child_percent_get(PointerRNA *ptr);
void ParticleSettings_child_percent_set(PointerRNA *ptr, int value);

bool ParticleSettings_use_close_tip_get(PointerRNA *ptr);
void ParticleSettings_use_close_tip_set(PointerRNA *ptr, bool value);

float ParticleSettings_clump_factor_get(PointerRNA *ptr);
void ParticleSettings_clump_factor_set(PointerRNA *ptr, float value);

PointerRNA ParticleSettings_clump_curve_get(PointerRNA *ptr);

float ParticleSettings_clump_noise_size_get(PointerRNA *ptr);
void ParticleSettings_clump_noise_size_set(PointerRNA *ptr, float value);

PointerRNA ParticleSettings_collision_collection_get(PointerRNA *ptr);

float ParticleSettings_color_maximum_get(PointerRNA *ptr);
void ParticleSettings_color_maximum_set(PointerRNA *ptr, float value);

float ParticleSettings_damping_get(PointerRNA *ptr);
void ParticleSettings_damping_set(PointerRNA *ptr, float value);

int ParticleSettings_adaptive_angle_get(PointerRNA *ptr);
void ParticleSettings_adaptive_angle_set(PointerRNA *ptr, int value);

float ParticleSettings_radius_scale_get(PointerRNA *ptr);
void ParticleSettings_radius_scale_set(PointerRNA *ptr, float value);

bool ParticleSettings_use_die_on_collision_get(PointerRNA *ptr);
void ParticleSettings_use_die_on_collision_set(PointerRNA *ptr, bool value);

bool ParticleSettings_use_dead_get(PointerRNA *ptr);
void ParticleSettings_use_dead_set(PointerRNA *ptr, bool value);

int ParticleSettings_display_percentage_get(PointerRNA *ptr);
void ParticleSettings_display_percentage_set(PointerRNA *ptr, int value);

enum {
	ParticleSettings_display_color_NONE = 0,
	ParticleSettings_display_color_MATERIAL = 1,
	ParticleSettings_display_color_VELOCITY = 2,
	ParticleSettings_display_color_ACCELERATION = 3,
};

int ParticleSettings_display_color_get(PointerRNA *ptr);
void ParticleSettings_display_color_set(PointerRNA *ptr, int value);

float ParticleSettings_display_size_get(PointerRNA *ptr);
void ParticleSettings_display_size_set(PointerRNA *ptr, float value);

enum {
	ParticleSettings_distribution_JIT = 0,
	ParticleSettings_distribution_RAND = 1,
	ParticleSettings_distribution_GRID = 2,
};

int ParticleSettings_distribution_get(PointerRNA *ptr);
void ParticleSettings_distribution_set(PointerRNA *ptr, int value);

float ParticleSettings_drag_factor_get(PointerRNA *ptr);
void ParticleSettings_drag_factor_set(PointerRNA *ptr, float value);

bool ParticleSettings_use_dynamic_rotation_get(PointerRNA *ptr);
void ParticleSettings_use_dynamic_rotation_set(PointerRNA *ptr, bool value);

int ParticleSettings_effector_amount_get(PointerRNA *ptr);
void ParticleSettings_effector_amount_set(PointerRNA *ptr, int value);

PointerRNA ParticleSettings_effector_weights_get(PointerRNA *ptr);

enum {
	ParticleSettings_emit_from_VERT = 0,
	ParticleSettings_emit_from_FACE = 1,
	ParticleSettings_emit_from_VOLUME = 2,
};

int ParticleSettings_emit_from_get(PointerRNA *ptr);
void ParticleSettings_emit_from_set(PointerRNA *ptr, int value);

float ParticleSettings_frame_end_get(PointerRNA *ptr);
void ParticleSettings_frame_end_set(PointerRNA *ptr, float value);

bool ParticleSettings_use_even_distribution_get(PointerRNA *ptr);
void ParticleSettings_use_even_distribution_set(PointerRNA *ptr, bool value);

int ParticleSettings_kink_extra_steps_get(PointerRNA *ptr);
void ParticleSettings_kink_extra_steps_set(PointerRNA *ptr, int value);

float ParticleSettings_kink_flat_get(PointerRNA *ptr);
void ParticleSettings_kink_flat_set(PointerRNA *ptr, float value);

bool ParticleSettings_is_fluid_get(PointerRNA *ptr);
void ParticleSettings_is_fluid_set(PointerRNA *ptr, bool value);

PointerRNA ParticleSettings_force_field_1_get(PointerRNA *ptr);

PointerRNA ParticleSettings_force_field_2_get(PointerRNA *ptr);

float ParticleSettings_kink_frequency_get(PointerRNA *ptr);
void ParticleSettings_kink_frequency_set(PointerRNA *ptr, float value);

bool ParticleSettings_use_global_instance_get(PointerRNA *ptr);
void ParticleSettings_use_global_instance_set(PointerRNA *ptr, bool value);

float ParticleSettings_grid_random_get(PointerRNA *ptr);
void ParticleSettings_grid_random_set(PointerRNA *ptr, float value);

bool ParticleSettings_show_guide_hairs_get(PointerRNA *ptr);
void ParticleSettings_show_guide_hairs_set(PointerRNA *ptr, bool value);

bool ParticleSettings_show_hair_grid_get(PointerRNA *ptr);
void ParticleSettings_show_hair_grid_set(PointerRNA *ptr, bool value);

float ParticleSettings_hair_length_get(PointerRNA *ptr);
void ParticleSettings_hair_length_set(PointerRNA *ptr, float value);

float ParticleSettings_line_length_head_get(PointerRNA *ptr);
void ParticleSettings_line_length_head_set(PointerRNA *ptr, float value);

bool ParticleSettings_show_health_get(PointerRNA *ptr);
void ParticleSettings_show_health_set(PointerRNA *ptr, bool value);

bool ParticleSettings_hexagonal_grid_get(PointerRNA *ptr);
void ParticleSettings_hexagonal_grid_set(PointerRNA *ptr, bool value);

PointerRNA ParticleSettings_instance_collection_get(PointerRNA *ptr);

void ParticleSettings_instance_weights_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ParticleSettings_instance_weights_next(CollectionPropertyIterator *iter);
void ParticleSettings_instance_weights_end(CollectionPropertyIterator *iter);
bool ParticleSettings_instance_weights_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool ParticleSettings_instance_weights_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

PointerRNA ParticleSettings_instance_object_get(PointerRNA *ptr);

enum {
	ParticleSettings_integrator_EULER = 0,
	ParticleSettings_integrator_VERLET = 3,
	ParticleSettings_integrator_MIDPOINT = 1,
	ParticleSettings_integrator_RK4 = 2,
};

int ParticleSettings_integrator_get(PointerRNA *ptr);
void ParticleSettings_integrator_set(PointerRNA *ptr, int value);

bool ParticleSettings_invert_grid_get(PointerRNA *ptr);
void ParticleSettings_invert_grid_set(PointerRNA *ptr, bool value);

int ParticleSettings_keys_step_get(PointerRNA *ptr);
void ParticleSettings_keys_step_set(PointerRNA *ptr, int value);

enum {
	ParticleSettings_kink_NO = 0,
	ParticleSettings_kink_CURL = 1,
	ParticleSettings_kink_RADIAL = 2,
	ParticleSettings_kink_WAVE = 3,
	ParticleSettings_kink_BRAID = 4,
	ParticleSettings_kink_SPIRAL = 5,
};

int ParticleSettings_kink_get(PointerRNA *ptr);
void ParticleSettings_kink_set(PointerRNA *ptr, int value);

float ParticleSettings_child_length_get(PointerRNA *ptr);
void ParticleSettings_child_length_set(PointerRNA *ptr, float value);

float ParticleSettings_lifetime_get(PointerRNA *ptr);
void ParticleSettings_lifetime_set(PointerRNA *ptr, float value);

bool ParticleSettings_create_long_hair_children_get(PointerRNA *ptr);
void ParticleSettings_create_long_hair_children_set(PointerRNA *ptr, bool value);

int ParticleSettings_keyed_loops_get(PointerRNA *ptr);
void ParticleSettings_keyed_loops_set(PointerRNA *ptr, int value);

float ParticleSettings_mass_get(PointerRNA *ptr);
void ParticleSettings_mass_set(PointerRNA *ptr, float value);

bool ParticleSettings_use_multiply_size_mass_get(PointerRNA *ptr);
void ParticleSettings_use_multiply_size_mass_set(PointerRNA *ptr, bool value);

int ParticleSettings_material_get(PointerRNA *ptr);
void ParticleSettings_material_set(PointerRNA *ptr, int value);

enum {
	ParticleSettings_material_slot_DEFAULT = 0,
};

int ParticleSettings_material_slot_get(PointerRNA *ptr);
void ParticleSettings_material_slot_set(PointerRNA *ptr, int value);

bool ParticleSettings_use_react_multiple_get(PointerRNA *ptr);
void ParticleSettings_use_react_multiple_set(PointerRNA *ptr, bool value);

float ParticleSettings_normal_factor_get(PointerRNA *ptr);
void ParticleSettings_normal_factor_set(PointerRNA *ptr, float value);

bool ParticleSettings_show_number_get(PointerRNA *ptr);
void ParticleSettings_show_number_set(PointerRNA *ptr, bool value);

int ParticleSettings_count_get(PointerRNA *ptr);
void ParticleSettings_count_set(PointerRNA *ptr, int value);

void ParticleSettings_object_align_factor_get(PointerRNA *ptr, float values[3]);
void ParticleSettings_object_align_factor_set(PointerRNA *ptr, const float values[3]);

float ParticleSettings_object_factor_get(PointerRNA *ptr);
void ParticleSettings_object_factor_set(PointerRNA *ptr, float value);

enum {
	ParticleSettings_rotation_mode_NONE = 0,
	ParticleSettings_rotation_mode_NOR = 1,
	ParticleSettings_rotation_mode_NOR_TAN = 9,
	ParticleSettings_rotation_mode_VEL = 2,
	ParticleSettings_rotation_mode_GLOB_X = 3,
	ParticleSettings_rotation_mode_GLOB_Y = 4,
	ParticleSettings_rotation_mode_GLOB_Z = 5,
	ParticleSettings_rotation_mode_OB_X = 6,
	ParticleSettings_rotation_mode_OB_Y = 7,
	ParticleSettings_rotation_mode_OB_Z = 8,
};

int ParticleSettings_rotation_mode_get(PointerRNA *ptr);
void ParticleSettings_rotation_mode_set(PointerRNA *ptr, int value);

bool ParticleSettings_use_parent_particles_get(PointerRNA *ptr);
void ParticleSettings_use_parent_particles_set(PointerRNA *ptr, bool value);

float ParticleSettings_particle_factor_get(PointerRNA *ptr);
void ParticleSettings_particle_factor_set(PointerRNA *ptr, float value);

enum {
	ParticleSettings_display_method_NONE = 0,
	ParticleSettings_display_method_RENDER = 10,
	ParticleSettings_display_method_DOT = 1,
	ParticleSettings_display_method_CIRC = 2,
	ParticleSettings_display_method_CROSS = 3,
	ParticleSettings_display_method_AXIS = 4,
};

int ParticleSettings_display_method_get(PointerRNA *ptr);
void ParticleSettings_display_method_set(PointerRNA *ptr, int value);

enum {
	ParticleSettings_render_type_NONE = 0,
	ParticleSettings_render_type_HALO = 1,
	ParticleSettings_render_type_LINE = 5,
	ParticleSettings_render_type_PATH = 6,
	ParticleSettings_render_type_OBJECT = 7,
	ParticleSettings_render_type_COLLECTION = 8,
};

int ParticleSettings_render_type_get(PointerRNA *ptr);
void ParticleSettings_render_type_set(PointerRNA *ptr, int value);

int ParticleSettings_userjit_get(PointerRNA *ptr);
void ParticleSettings_userjit_set(PointerRNA *ptr, int value);

float ParticleSettings_child_parting_factor_get(PointerRNA *ptr);
void ParticleSettings_child_parting_factor_set(PointerRNA *ptr, float value);

float ParticleSettings_child_parting_max_get(PointerRNA *ptr);
void ParticleSettings_child_parting_max_set(PointerRNA *ptr, float value);

float ParticleSettings_child_parting_min_get(PointerRNA *ptr);
void ParticleSettings_child_parting_min_set(PointerRNA *ptr, float value);

float ParticleSettings_path_end_get(PointerRNA *ptr);
void ParticleSettings_path_end_set(PointerRNA *ptr, float value);

float ParticleSettings_path_start_get(PointerRNA *ptr);
void ParticleSettings_path_start_set(PointerRNA *ptr, float value);

float ParticleSettings_phase_factor_get(PointerRNA *ptr);
void ParticleSettings_phase_factor_set(PointerRNA *ptr, float value);

enum {
	ParticleSettings_physics_type_NO = 0,
	ParticleSettings_physics_type_NEWTON = 1,
	ParticleSettings_physics_type_KEYED = 2,
	ParticleSettings_physics_type_BOIDS = 3,
	ParticleSettings_physics_type_FLUID = 4,
};

int ParticleSettings_physics_type_get(PointerRNA *ptr);
void ParticleSettings_physics_type_set(PointerRNA *ptr, int value);

bool ParticleSettings_use_collection_pick_random_get(PointerRNA *ptr);
void ParticleSettings_use_collection_pick_random_set(PointerRNA *ptr, bool value);

int ParticleSettings_adaptive_pixel_get(PointerRNA *ptr);
void ParticleSettings_adaptive_pixel_set(PointerRNA *ptr, int value);

bool ParticleSettings_use_emit_random_get(PointerRNA *ptr);
void ParticleSettings_use_emit_random_set(PointerRNA *ptr, bool value);

float ParticleSettings_lifetime_random_get(PointerRNA *ptr);
void ParticleSettings_lifetime_random_set(PointerRNA *ptr, float value);

float ParticleSettings_factor_random_get(PointerRNA *ptr);
void ParticleSettings_factor_random_set(PointerRNA *ptr, float value);

float ParticleSettings_bending_random_get(PointerRNA *ptr);
void ParticleSettings_bending_random_set(PointerRNA *ptr, float value);

float ParticleSettings_child_size_random_get(PointerRNA *ptr);
void ParticleSettings_child_size_random_set(PointerRNA *ptr, float value);

float ParticleSettings_length_random_get(PointerRNA *ptr);
void ParticleSettings_length_random_set(PointerRNA *ptr, float value);

float ParticleSettings_rotation_factor_random_get(PointerRNA *ptr);
void ParticleSettings_rotation_factor_random_set(PointerRNA *ptr, float value);

float ParticleSettings_phase_factor_random_get(PointerRNA *ptr);
void ParticleSettings_phase_factor_random_set(PointerRNA *ptr, float value);

float ParticleSettings_size_random_get(PointerRNA *ptr);
void ParticleSettings_size_random_set(PointerRNA *ptr, float value);

enum {
	ParticleSettings_react_event_DEATH = 0,
	ParticleSettings_react_event_COLLIDE = 1,
	ParticleSettings_react_event_NEAR = 2,
};

int ParticleSettings_react_event_get(PointerRNA *ptr);
void ParticleSettings_react_event_set(PointerRNA *ptr, int value);

float ParticleSettings_reactor_factor_get(PointerRNA *ptr);
void ParticleSettings_reactor_factor_set(PointerRNA *ptr, float value);

bool ParticleSettings_use_regrow_hair_get(PointerRNA *ptr);
void ParticleSettings_use_regrow_hair_set(PointerRNA *ptr, bool value);

int ParticleSettings_render_step_get(PointerRNA *ptr);
void ParticleSettings_render_step_set(PointerRNA *ptr, int value);

int ParticleSettings_rendered_child_count_get(PointerRNA *ptr);
void ParticleSettings_rendered_child_count_set(PointerRNA *ptr, int value);

int ParticleSettings_grid_resolution_get(PointerRNA *ptr);
void ParticleSettings_grid_resolution_set(PointerRNA *ptr, int value);

float ParticleSettings_root_radius_get(PointerRNA *ptr);
void ParticleSettings_root_radius_set(PointerRNA *ptr, float value);

bool ParticleSettings_use_rotation_instance_get(PointerRNA *ptr);
void ParticleSettings_use_rotation_instance_set(PointerRNA *ptr, bool value);

float ParticleSettings_tangent_phase_get(PointerRNA *ptr);
void ParticleSettings_tangent_phase_set(PointerRNA *ptr, float value);

bool ParticleSettings_use_rotations_get(PointerRNA *ptr);
void ParticleSettings_use_rotations_set(PointerRNA *ptr, bool value);

float ParticleSettings_roughness_1_get(PointerRNA *ptr);
void ParticleSettings_roughness_1_set(PointerRNA *ptr, float value);

float ParticleSettings_roughness_2_get(PointerRNA *ptr);
void ParticleSettings_roughness_2_set(PointerRNA *ptr, float value);

PointerRNA ParticleSettings_roughness_curve_get(PointerRNA *ptr);

float ParticleSettings_roughness_endpoint_get(PointerRNA *ptr);
void ParticleSettings_roughness_endpoint_set(PointerRNA *ptr, float value);

PointerRNA ParticleSettings_fluid_get(PointerRNA *ptr);

bool ParticleSettings_use_scale_instance_get(PointerRNA *ptr);
void ParticleSettings_use_scale_instance_set(PointerRNA *ptr, bool value);

int ParticleSettings_hair_step_get(PointerRNA *ptr);
void ParticleSettings_hair_step_set(PointerRNA *ptr, int value);

bool ParticleSettings_use_self_effect_get(PointerRNA *ptr);
void ParticleSettings_use_self_effect_set(PointerRNA *ptr, bool value);

float ParticleSettings_clump_shape_get(PointerRNA *ptr);
void ParticleSettings_clump_shape_set(PointerRNA *ptr, float value);

float ParticleSettings_kink_shape_get(PointerRNA *ptr);
void ParticleSettings_kink_shape_set(PointerRNA *ptr, float value);

float ParticleSettings_roughness_end_shape_get(PointerRNA *ptr);
void ParticleSettings_roughness_end_shape_set(PointerRNA *ptr, float value);

float ParticleSettings_shape_get(PointerRNA *ptr);
void ParticleSettings_shape_set(PointerRNA *ptr, float value);

bool ParticleSettings_show_size_get(PointerRNA *ptr);
void ParticleSettings_show_size_set(PointerRNA *ptr, bool value);

float ParticleSettings_particle_size_get(PointerRNA *ptr);
void ParticleSettings_particle_size_set(PointerRNA *ptr, float value);

float ParticleSettings_roughness_1_size_get(PointerRNA *ptr);
void ParticleSettings_roughness_1_size_set(PointerRNA *ptr, float value);

float ParticleSettings_roughness_2_size_get(PointerRNA *ptr);
void ParticleSettings_roughness_2_size_set(PointerRNA *ptr, float value);

bool ParticleSettings_use_size_deflect_get(PointerRNA *ptr);
void ParticleSettings_use_size_deflect_set(PointerRNA *ptr, bool value);

bool ParticleSettings_use_velocity_length_get(PointerRNA *ptr);
void ParticleSettings_use_velocity_length_set(PointerRNA *ptr, bool value);

float ParticleSettings_frame_start_get(PointerRNA *ptr);
void ParticleSettings_frame_start_set(PointerRNA *ptr, float value);

bool ParticleSettings_use_react_start_end_get(PointerRNA *ptr);
void ParticleSettings_use_react_start_end_set(PointerRNA *ptr, bool value);

int ParticleSettings_display_step_get(PointerRNA *ptr);
void ParticleSettings_display_step_set(PointerRNA *ptr, int value);

float ParticleSettings_effect_hair_get(PointerRNA *ptr);
void ParticleSettings_effect_hair_set(PointerRNA *ptr, float value);

bool ParticleSettings_use_strand_primitive_get(PointerRNA *ptr);
void ParticleSettings_use_strand_primitive_set(PointerRNA *ptr, bool value);

int ParticleSettings_subframes_get(PointerRNA *ptr);
void ParticleSettings_subframes_set(PointerRNA *ptr, int value);

float ParticleSettings_line_length_tail_get(PointerRNA *ptr);
void ParticleSettings_line_length_tail_set(PointerRNA *ptr, float value);

float ParticleSettings_tangent_factor_get(PointerRNA *ptr);
void ParticleSettings_tangent_factor_set(PointerRNA *ptr, float value);

void ParticleSettings_texture_slots_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ParticleSettings_texture_slots_next(CollectionPropertyIterator *iter);
void ParticleSettings_texture_slots_end(CollectionPropertyIterator *iter);

float ParticleSettings_roughness_2_threshold_get(PointerRNA *ptr);
void ParticleSettings_roughness_2_threshold_set(PointerRNA *ptr, float value);

float ParticleSettings_child_length_threshold_get(PointerRNA *ptr);
void ParticleSettings_child_length_threshold_set(PointerRNA *ptr, float value);

float ParticleSettings_branch_threshold_get(PointerRNA *ptr);
void ParticleSettings_branch_threshold_set(PointerRNA *ptr, float value);

float ParticleSettings_timestep_get(PointerRNA *ptr);
void ParticleSettings_timestep_set(PointerRNA *ptr, float value);

float ParticleSettings_tip_radius_get(PointerRNA *ptr);
void ParticleSettings_tip_radius_set(PointerRNA *ptr, float value);

int ParticleSettings_trail_count_get(PointerRNA *ptr);
void ParticleSettings_trail_count_set(PointerRNA *ptr, int value);

float ParticleSettings_time_tweak_get(PointerRNA *ptr);
void ParticleSettings_time_tweak_set(PointerRNA *ptr, float value);

float ParticleSettings_twist_get(PointerRNA *ptr);
void ParticleSettings_twist_set(PointerRNA *ptr, float value);

PointerRNA ParticleSettings_twist_curve_get(PointerRNA *ptr);

enum {
	ParticleSettings_type_EMITTER = 0,
	ParticleSettings_type_HAIR = 2,
};

int ParticleSettings_type_get(PointerRNA *ptr);
void ParticleSettings_type_set(PointerRNA *ptr, int value);

bool ParticleSettings_show_unborn_get(PointerRNA *ptr);
void ParticleSettings_show_unborn_set(PointerRNA *ptr, bool value);

bool ParticleSettings_use_clump_curve_get(PointerRNA *ptr);
void ParticleSettings_use_clump_curve_set(PointerRNA *ptr, bool value);

bool ParticleSettings_use_clump_noise_get(PointerRNA *ptr);
void ParticleSettings_use_clump_noise_set(PointerRNA *ptr, bool value);

bool ParticleSettings_use_collection_count_get(PointerRNA *ptr);
void ParticleSettings_use_collection_count_set(PointerRNA *ptr, bool value);

bool ParticleSettings_use_modifier_stack_get(PointerRNA *ptr);
void ParticleSettings_use_modifier_stack_set(PointerRNA *ptr, bool value);

bool ParticleSettings_use_roughness_curve_get(PointerRNA *ptr);
void ParticleSettings_use_roughness_curve_set(PointerRNA *ptr, bool value);

bool ParticleSettings_use_twist_curve_get(PointerRNA *ptr);
void ParticleSettings_use_twist_curve_set(PointerRNA *ptr, bool value);

bool ParticleSettings_show_velocity_get(PointerRNA *ptr);
void ParticleSettings_show_velocity_set(PointerRNA *ptr, bool value);

float ParticleSettings_virtual_parents_get(PointerRNA *ptr);
void ParticleSettings_virtual_parents_set(PointerRNA *ptr, float value);

bool ParticleSettings_use_whole_collection_get(PointerRNA *ptr);
void ParticleSettings_use_whole_collection_set(PointerRNA *ptr, bool value);

bool ParticleSettings_apply_guide_to_children_get(PointerRNA *ptr);
void ParticleSettings_apply_guide_to_children_set(PointerRNA *ptr, bool value);

/**************** Particle Settings Texture Slot ****************/

extern StructRNA RNA_ParticleSettingsTextureSlot;
extern StructRNA RNA_TextureSlot;

bool ParticleSettingsTextureSlot_use_map_clump_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_use_map_clump_set(PointerRNA *ptr, bool value);

float ParticleSettingsTextureSlot_clump_factor_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_clump_factor_set(PointerRNA *ptr, float value);

bool ParticleSettingsTextureSlot_use_map_damp_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_use_map_damp_set(PointerRNA *ptr, bool value);

float ParticleSettingsTextureSlot_damp_factor_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_damp_factor_set(PointerRNA *ptr, float value);

bool ParticleSettingsTextureSlot_use_map_density_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_use_map_density_set(PointerRNA *ptr, bool value);

float ParticleSettingsTextureSlot_density_factor_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_density_factor_set(PointerRNA *ptr, float value);

bool ParticleSettingsTextureSlot_use_map_time_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_use_map_time_set(PointerRNA *ptr, bool value);

float ParticleSettingsTextureSlot_time_factor_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_time_factor_set(PointerRNA *ptr, float value);

float ParticleSettingsTextureSlot_field_factor_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_field_factor_set(PointerRNA *ptr, float value);

bool ParticleSettingsTextureSlot_use_map_field_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_use_map_field_set(PointerRNA *ptr, bool value);

bool ParticleSettingsTextureSlot_use_map_gravity_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_use_map_gravity_set(PointerRNA *ptr, bool value);

float ParticleSettingsTextureSlot_gravity_factor_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_gravity_factor_set(PointerRNA *ptr, float value);

bool ParticleSettingsTextureSlot_use_map_velocity_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_use_map_velocity_set(PointerRNA *ptr, bool value);

bool ParticleSettingsTextureSlot_use_map_kink_amp_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_use_map_kink_amp_set(PointerRNA *ptr, bool value);

float ParticleSettingsTextureSlot_kink_amp_factor_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_kink_amp_factor_set(PointerRNA *ptr, float value);

bool ParticleSettingsTextureSlot_use_map_kink_freq_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_use_map_kink_freq_set(PointerRNA *ptr, bool value);

float ParticleSettingsTextureSlot_kink_freq_factor_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_kink_freq_factor_set(PointerRNA *ptr, float value);

bool ParticleSettingsTextureSlot_use_map_length_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_use_map_length_set(PointerRNA *ptr, bool value);

float ParticleSettingsTextureSlot_length_factor_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_length_factor_set(PointerRNA *ptr, float value);

bool ParticleSettingsTextureSlot_use_map_life_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_use_map_life_set(PointerRNA *ptr, bool value);

float ParticleSettingsTextureSlot_life_factor_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_life_factor_set(PointerRNA *ptr, float value);

enum {
	ParticleSettingsTextureSlot_mapping_FLAT = 0,
	ParticleSettingsTextureSlot_mapping_CUBE = 1,
	ParticleSettingsTextureSlot_mapping_TUBE = 2,
	ParticleSettingsTextureSlot_mapping_SPHERE = 3,
};

int ParticleSettingsTextureSlot_mapping_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_mapping_set(PointerRNA *ptr, int value);

PointerRNA ParticleSettingsTextureSlot_object_get(PointerRNA *ptr);

bool ParticleSettingsTextureSlot_use_map_rough_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_use_map_rough_set(PointerRNA *ptr, bool value);

float ParticleSettingsTextureSlot_rough_factor_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_rough_factor_set(PointerRNA *ptr, float value);

bool ParticleSettingsTextureSlot_use_map_size_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_use_map_size_set(PointerRNA *ptr, bool value);

float ParticleSettingsTextureSlot_size_factor_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_size_factor_set(PointerRNA *ptr, float value);

enum {
	ParticleSettingsTextureSlot_texture_coords_GLOBAL = 8,
	ParticleSettingsTextureSlot_texture_coords_OBJECT = 32,
	ParticleSettingsTextureSlot_texture_coords_UV = 16,
	ParticleSettingsTextureSlot_texture_coords_ORCO = 1,
	ParticleSettingsTextureSlot_texture_coords_STRAND = 8192,
};

int ParticleSettingsTextureSlot_texture_coords_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_texture_coords_set(PointerRNA *ptr, int value);

bool ParticleSettingsTextureSlot_use_map_twist_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_use_map_twist_set(PointerRNA *ptr, bool value);

float ParticleSettingsTextureSlot_twist_factor_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_twist_factor_set(PointerRNA *ptr, float value);

#define ParticleSettingsTextureSlot_uv_layer_MAX 68

void ParticleSettingsTextureSlot_uv_layer_get(PointerRNA *ptr, char *value);
int ParticleSettingsTextureSlot_uv_layer_length(PointerRNA *ptr);
void ParticleSettingsTextureSlot_uv_layer_set(PointerRNA *ptr, const char *value);

float ParticleSettingsTextureSlot_velocity_factor_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_velocity_factor_set(PointerRNA *ptr, float value);

enum {
	ParticleSettingsTextureSlot_mapping_x_NONE = 0,
	ParticleSettingsTextureSlot_mapping_x_X = 1,
	ParticleSettingsTextureSlot_mapping_x_Y = 2,
	ParticleSettingsTextureSlot_mapping_x_Z = 3,
};

int ParticleSettingsTextureSlot_mapping_x_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_mapping_x_set(PointerRNA *ptr, int value);

enum {
	ParticleSettingsTextureSlot_mapping_y_NONE = 0,
	ParticleSettingsTextureSlot_mapping_y_X = 1,
	ParticleSettingsTextureSlot_mapping_y_Y = 2,
	ParticleSettingsTextureSlot_mapping_y_Z = 3,
};

int ParticleSettingsTextureSlot_mapping_y_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_mapping_y_set(PointerRNA *ptr, int value);

enum {
	ParticleSettingsTextureSlot_mapping_z_NONE = 0,
	ParticleSettingsTextureSlot_mapping_z_X = 1,
	ParticleSettingsTextureSlot_mapping_z_Y = 2,
	ParticleSettingsTextureSlot_mapping_z_Z = 3,
};

int ParticleSettingsTextureSlot_mapping_z_get(PointerRNA *ptr);
void ParticleSettingsTextureSlot_mapping_z_set(PointerRNA *ptr, int value);

/**************** Texture Slots ****************/

extern StructRNA RNA_ParticleSettingsTextureSlots;

PointerRNA ParticleSettingsTextureSlots_rna_type_get(PointerRNA *ptr);

struct MTex *ParticleSettingsTextureSlots_add_func(struct ID *_selfid, bContext *C, ReportList *reports);
struct MTex *ParticleSettingsTextureSlots_create_func(struct ID *_selfid, bContext *C, ReportList *reports, int index);
void ParticleSettingsTextureSlots_clear_func(struct ID *_selfid, bContext *C, ReportList *reports, int index);
/**************** Particle System ****************/

extern StructRNA RNA_ParticleSystem;

PointerRNA ParticleSystem_rna_type_get(PointerRNA *ptr);

#define ParticleSystem_name_MAX 64

void ParticleSystem_name_get(PointerRNA *ptr, char *value);
int ParticleSystem_name_length(PointerRNA *ptr);
void ParticleSystem_name_set(PointerRNA *ptr, const char *value);

PointerRNA ParticleSystem_active_particle_target_get(PointerRNA *ptr);

int ParticleSystem_active_particle_target_index_get(PointerRNA *ptr);
void ParticleSystem_active_particle_target_index_set(PointerRNA *ptr, int value);

void ParticleSystem_child_particles_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ParticleSystem_child_particles_next(CollectionPropertyIterator *iter);
void ParticleSystem_child_particles_end(CollectionPropertyIterator *iter);
int ParticleSystem_child_particles_length(PointerRNA *ptr);
bool ParticleSystem_child_particles_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

int ParticleSystem_child_seed_get(PointerRNA *ptr);
void ParticleSystem_child_seed_set(PointerRNA *ptr, int value);

PointerRNA ParticleSystem_cloth_get(PointerRNA *ptr);

bool ParticleSystem_is_editable_get(PointerRNA *ptr);
void ParticleSystem_is_editable_set(PointerRNA *ptr, bool value);

bool ParticleSystem_is_edited_get(PointerRNA *ptr);
void ParticleSystem_is_edited_set(PointerRNA *ptr, bool value);

bool ParticleSystem_is_global_hair_get(PointerRNA *ptr);
void ParticleSystem_is_global_hair_set(PointerRNA *ptr, bool value);

bool ParticleSystem_use_hair_dynamics_get(PointerRNA *ptr);
void ParticleSystem_use_hair_dynamics_set(PointerRNA *ptr, bool value);

bool ParticleSystem_use_keyed_timing_get(PointerRNA *ptr);
void ParticleSystem_use_keyed_timing_set(PointerRNA *ptr, bool value);

bool ParticleSystem_has_multiple_caches_get(PointerRNA *ptr);
void ParticleSystem_has_multiple_caches_set(PointerRNA *ptr, bool value);

PointerRNA ParticleSystem_parent_get(PointerRNA *ptr);

void ParticleSystem_particles_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ParticleSystem_particles_next(CollectionPropertyIterator *iter);
void ParticleSystem_particles_end(CollectionPropertyIterator *iter);
int ParticleSystem_particles_length(PointerRNA *ptr);
bool ParticleSystem_particles_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

PointerRNA ParticleSystem_point_cache_get(PointerRNA *ptr);

PointerRNA ParticleSystem_reactor_target_object_get(PointerRNA *ptr);

int ParticleSystem_reactor_target_particle_system_get(PointerRNA *ptr);
void ParticleSystem_reactor_target_particle_system_set(PointerRNA *ptr, int value);

int ParticleSystem_seed_get(PointerRNA *ptr);
void ParticleSystem_seed_set(PointerRNA *ptr, int value);

PointerRNA ParticleSystem_settings_get(PointerRNA *ptr);

void ParticleSystem_targets_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ParticleSystem_targets_next(CollectionPropertyIterator *iter);
void ParticleSystem_targets_end(CollectionPropertyIterator *iter);
bool ParticleSystem_targets_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool ParticleSystem_targets_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

float ParticleSystem_dt_frac_get(PointerRNA *ptr);
void ParticleSystem_dt_frac_set(PointerRNA *ptr, float value);

void ParticleSystem_vertex_group_clump_get(PointerRNA *ptr, char *value);
int ParticleSystem_vertex_group_clump_length(PointerRNA *ptr);
void ParticleSystem_vertex_group_clump_set(PointerRNA *ptr, const char *value);

bool ParticleSystem_invert_vertex_group_clump_get(PointerRNA *ptr);
void ParticleSystem_invert_vertex_group_clump_set(PointerRNA *ptr, bool value);

void ParticleSystem_vertex_group_density_get(PointerRNA *ptr, char *value);
int ParticleSystem_vertex_group_density_length(PointerRNA *ptr);
void ParticleSystem_vertex_group_density_set(PointerRNA *ptr, const char *value);

bool ParticleSystem_invert_vertex_group_density_get(PointerRNA *ptr);
void ParticleSystem_invert_vertex_group_density_set(PointerRNA *ptr, bool value);

void ParticleSystem_vertex_group_field_get(PointerRNA *ptr, char *value);
int ParticleSystem_vertex_group_field_length(PointerRNA *ptr);
void ParticleSystem_vertex_group_field_set(PointerRNA *ptr, const char *value);

bool ParticleSystem_invert_vertex_group_field_get(PointerRNA *ptr);
void ParticleSystem_invert_vertex_group_field_set(PointerRNA *ptr, bool value);

void ParticleSystem_vertex_group_kink_get(PointerRNA *ptr, char *value);
int ParticleSystem_vertex_group_kink_length(PointerRNA *ptr);
void ParticleSystem_vertex_group_kink_set(PointerRNA *ptr, const char *value);

bool ParticleSystem_invert_vertex_group_kink_get(PointerRNA *ptr);
void ParticleSystem_invert_vertex_group_kink_set(PointerRNA *ptr, bool value);

void ParticleSystem_vertex_group_length_get(PointerRNA *ptr, char *value);
int ParticleSystem_vertex_group_length_length(PointerRNA *ptr);
void ParticleSystem_vertex_group_length_set(PointerRNA *ptr, const char *value);

bool ParticleSystem_invert_vertex_group_length_get(PointerRNA *ptr);
void ParticleSystem_invert_vertex_group_length_set(PointerRNA *ptr, bool value);

void ParticleSystem_vertex_group_rotation_get(PointerRNA *ptr, char *value);
int ParticleSystem_vertex_group_rotation_length(PointerRNA *ptr);
void ParticleSystem_vertex_group_rotation_set(PointerRNA *ptr, const char *value);

bool ParticleSystem_invert_vertex_group_rotation_get(PointerRNA *ptr);
void ParticleSystem_invert_vertex_group_rotation_set(PointerRNA *ptr, bool value);

void ParticleSystem_vertex_group_roughness_1_get(PointerRNA *ptr, char *value);
int ParticleSystem_vertex_group_roughness_1_length(PointerRNA *ptr);
void ParticleSystem_vertex_group_roughness_1_set(PointerRNA *ptr, const char *value);

bool ParticleSystem_invert_vertex_group_roughness_1_get(PointerRNA *ptr);
void ParticleSystem_invert_vertex_group_roughness_1_set(PointerRNA *ptr, bool value);

void ParticleSystem_vertex_group_roughness_2_get(PointerRNA *ptr, char *value);
int ParticleSystem_vertex_group_roughness_2_length(PointerRNA *ptr);
void ParticleSystem_vertex_group_roughness_2_set(PointerRNA *ptr, const char *value);

bool ParticleSystem_invert_vertex_group_roughness_2_get(PointerRNA *ptr);
void ParticleSystem_invert_vertex_group_roughness_2_set(PointerRNA *ptr, bool value);

void ParticleSystem_vertex_group_roughness_end_get(PointerRNA *ptr, char *value);
int ParticleSystem_vertex_group_roughness_end_length(PointerRNA *ptr);
void ParticleSystem_vertex_group_roughness_end_set(PointerRNA *ptr, const char *value);

bool ParticleSystem_invert_vertex_group_roughness_end_get(PointerRNA *ptr);
void ParticleSystem_invert_vertex_group_roughness_end_set(PointerRNA *ptr, bool value);

void ParticleSystem_vertex_group_size_get(PointerRNA *ptr, char *value);
int ParticleSystem_vertex_group_size_length(PointerRNA *ptr);
void ParticleSystem_vertex_group_size_set(PointerRNA *ptr, const char *value);

bool ParticleSystem_invert_vertex_group_size_get(PointerRNA *ptr);
void ParticleSystem_invert_vertex_group_size_set(PointerRNA *ptr, bool value);

void ParticleSystem_vertex_group_tangent_get(PointerRNA *ptr, char *value);
int ParticleSystem_vertex_group_tangent_length(PointerRNA *ptr);
void ParticleSystem_vertex_group_tangent_set(PointerRNA *ptr, const char *value);

bool ParticleSystem_invert_vertex_group_tangent_get(PointerRNA *ptr);
void ParticleSystem_invert_vertex_group_tangent_set(PointerRNA *ptr, bool value);

void ParticleSystem_vertex_group_twist_get(PointerRNA *ptr, char *value);
int ParticleSystem_vertex_group_twist_length(PointerRNA *ptr);
void ParticleSystem_vertex_group_twist_set(PointerRNA *ptr, const char *value);

bool ParticleSystem_invert_vertex_group_twist_get(PointerRNA *ptr);
void ParticleSystem_invert_vertex_group_twist_set(PointerRNA *ptr, bool value);

void ParticleSystem_vertex_group_velocity_get(PointerRNA *ptr, char *value);
int ParticleSystem_vertex_group_velocity_length(PointerRNA *ptr);
void ParticleSystem_vertex_group_velocity_set(PointerRNA *ptr, const char *value);

bool ParticleSystem_invert_vertex_group_velocity_get(PointerRNA *ptr);
void ParticleSystem_invert_vertex_group_velocity_set(PointerRNA *ptr, bool value);

void ParticleSystem_co_hair_func(struct ParticleSystem *_self, struct Object *object, int particle_no, int step, float co[3]);
void ParticleSystem_uv_on_emitter_func(struct ParticleSystem *_self, ReportList *reports, struct ParticleSystemModifierData *modifier, struct ParticleData *particle, int particle_no, int uv_no, float uv[2]);
void ParticleSystem_mcol_on_emitter_func(struct ParticleSystem *_self, ReportList *reports, struct ParticleSystemModifierData *modifier, struct ParticleData *particle, int particle_no, int vcol_no, float mcol[3]);
/**************** ParticleSystem Modifier ****************/

extern StructRNA RNA_ParticleSystemModifier;
extern StructRNA RNA_Modifier;

PointerRNA ParticleSystemModifier_particle_system_get(PointerRNA *ptr);

/**************** Particle Systems ****************/

extern StructRNA RNA_ParticleSystems;

PointerRNA ParticleSystems_rna_type_get(PointerRNA *ptr);

PointerRNA ParticleSystems_active_get(PointerRNA *ptr);

int ParticleSystems_active_index_get(PointerRNA *ptr);
void ParticleSystems_active_index_set(PointerRNA *ptr, int value);

/**************** Particle Target ****************/

extern StructRNA RNA_ParticleTarget;

PointerRNA ParticleTarget_rna_type_get(PointerRNA *ptr);

void ParticleTarget_name_get(PointerRNA *ptr, char *value);
int ParticleTarget_name_length(PointerRNA *ptr);
void ParticleTarget_name_set(PointerRNA *ptr, const char *value);

float ParticleTarget_duration_get(PointerRNA *ptr);
void ParticleTarget_duration_set(PointerRNA *ptr, float value);

enum {
	ParticleTarget_alliance_FRIEND = 1,
	ParticleTarget_alliance_NEUTRAL = 0,
	ParticleTarget_alliance_ENEMY = 2,
};

int ParticleTarget_alliance_get(PointerRNA *ptr);
void ParticleTarget_alliance_set(PointerRNA *ptr, int value);

PointerRNA ParticleTarget_object_get(PointerRNA *ptr);

int ParticleTarget_system_get(PointerRNA *ptr);
void ParticleTarget_system_set(PointerRNA *ptr, int value);

float ParticleTarget_time_get(PointerRNA *ptr);
void ParticleTarget_time_set(PointerRNA *ptr, float value);

bool ParticleTarget_is_valid_get(PointerRNA *ptr);
void ParticleTarget_is_valid_set(PointerRNA *ptr, bool value);

/**************** Path Compare ****************/

extern StructRNA RNA_PathCompare;

PointerRNA PathCompare_rna_type_get(PointerRNA *ptr);

#define PathCompare_path_MAX 768

void PathCompare_path_get(PointerRNA *ptr, char *value);
int PathCompare_path_length(PointerRNA *ptr);
void PathCompare_path_set(PointerRNA *ptr, const char *value);

bool PathCompare_use_glob_get(PointerRNA *ptr);
void PathCompare_use_glob_set(PointerRNA *ptr, bool value);

/**************** Paths Compare ****************/

extern StructRNA RNA_PathCompareCollection;

PointerRNA PathCompareCollection_rna_type_get(PointerRNA *ptr);

struct bPathCompare *PathCompareCollection_new_func(void);
void PathCompareCollection_remove_func(ReportList *reports, struct PointerRNA *pathcmp);
/**************** Pivot Constraint ****************/

extern StructRNA RNA_PivotConstraint;
extern StructRNA RNA_Constraint;

enum {
	PivotConstraint_rotation_range_ALWAYS_ACTIVE = -1,
	PivotConstraint_rotation_range_NX = 0,
	PivotConstraint_rotation_range_NY = 1,
	PivotConstraint_rotation_range_NZ = 2,
	PivotConstraint_rotation_range_X = 3,
	PivotConstraint_rotation_range_Y = 4,
	PivotConstraint_rotation_range_Z = 5,
};

int PivotConstraint_rotation_range_get(PointerRNA *ptr);
void PivotConstraint_rotation_range_set(PointerRNA *ptr, int value);

bool PivotConstraint_use_bbone_shape_get(PointerRNA *ptr);
void PivotConstraint_use_bbone_shape_set(PointerRNA *ptr, bool value);

float PivotConstraint_head_tail_get(PointerRNA *ptr);
void PivotConstraint_head_tail_set(PointerRNA *ptr, float value);

void PivotConstraint_offset_get(PointerRNA *ptr, float values[3]);
void PivotConstraint_offset_set(PointerRNA *ptr, const float values[3]);

#define PivotConstraint_subtarget_MAX 64

void PivotConstraint_subtarget_get(PointerRNA *ptr, char *value);
int PivotConstraint_subtarget_length(PointerRNA *ptr);
void PivotConstraint_subtarget_set(PointerRNA *ptr, const char *value);

PointerRNA PivotConstraint_target_get(PointerRNA *ptr);

bool PivotConstraint_use_relative_location_get(PointerRNA *ptr);
void PivotConstraint_use_relative_location_set(PointerRNA *ptr, bool value);

/**************** Point ****************/

extern StructRNA RNA_Point;

PointerRNA Point_rna_type_get(PointerRNA *ptr);

int Point_index_get(PointerRNA *ptr);
void Point_index_set(PointerRNA *ptr, int value);

void Point_co_get(PointerRNA *ptr, float values[3]);
void Point_co_set(PointerRNA *ptr, const float values[3]);

float Point_radius_get(PointerRNA *ptr);
void Point_radius_set(PointerRNA *ptr, float value);

/**************** Active Point Cache ****************/

extern StructRNA RNA_PointCache;

PointerRNA PointCache_rna_type_get(PointerRNA *ptr);

#define PointCache_name_MAX 64

void PointCache_name_get(PointerRNA *ptr, char *value);
int PointCache_name_length(PointerRNA *ptr);
void PointCache_name_set(PointerRNA *ptr, const char *value);

bool PointCache_is_baked_get(PointerRNA *ptr);
void PointCache_is_baked_set(PointerRNA *ptr, bool value);

bool PointCache_is_baking_get(PointerRNA *ptr);
void PointCache_is_baking_set(PointerRNA *ptr, bool value);

bool PointCache_is_frame_skip_get(PointerRNA *ptr);
void PointCache_is_frame_skip_set(PointerRNA *ptr, bool value);

enum {
	PointCache_compression_NO = 0,
	PointCache_compression_LIGHT = 1,
	PointCache_compression_HEAVY = 2,
};

int PointCache_compression_get(PointerRNA *ptr);
void PointCache_compression_set(PointerRNA *ptr, int value);

int PointCache_index_get(PointerRNA *ptr);
void PointCache_index_set(PointerRNA *ptr, int value);

#define PointCache_info_MAX 128

void PointCache_info_get(PointerRNA *ptr, char *value);
int PointCache_info_length(PointerRNA *ptr);
void PointCache_info_set(PointerRNA *ptr, const char *value);

bool PointCache_is_outdated_get(PointerRNA *ptr);
void PointCache_is_outdated_set(PointerRNA *ptr, bool value);

int PointCache_frame_step_get(PointerRNA *ptr);
void PointCache_frame_step_set(PointerRNA *ptr, int value);

bool PointCache_use_disk_cache_get(PointerRNA *ptr);
void PointCache_use_disk_cache_set(PointerRNA *ptr, bool value);

int PointCache_frame_end_get(PointerRNA *ptr);
void PointCache_frame_end_set(PointerRNA *ptr, int value);

bool PointCache_use_external_get(PointerRNA *ptr);
void PointCache_use_external_set(PointerRNA *ptr, bool value);

#define PointCache_filepath_MAX 1024

void PointCache_filepath_get(PointerRNA *ptr, char *value);
int PointCache_filepath_length(PointerRNA *ptr);
void PointCache_filepath_set(PointerRNA *ptr, const char *value);

bool PointCache_use_library_path_get(PointerRNA *ptr);
void PointCache_use_library_path_set(PointerRNA *ptr, bool value);

void PointCache_point_caches_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void PointCache_point_caches_next(CollectionPropertyIterator *iter);
void PointCache_point_caches_end(CollectionPropertyIterator *iter);

int PointCache_frame_start_get(PointerRNA *ptr);
void PointCache_frame_start_set(PointerRNA *ptr, int value);

/**************** Point Cache ****************/

extern StructRNA RNA_PointCacheItem;

PointerRNA PointCacheItem_rna_type_get(PointerRNA *ptr);

#define PointCacheItem_name_MAX 64

void PointCacheItem_name_get(PointerRNA *ptr, char *value);
int PointCacheItem_name_length(PointerRNA *ptr);
void PointCacheItem_name_set(PointerRNA *ptr, const char *value);

bool PointCacheItem_is_baked_get(PointerRNA *ptr);
void PointCacheItem_is_baked_set(PointerRNA *ptr, bool value);

bool PointCacheItem_is_baking_get(PointerRNA *ptr);
void PointCacheItem_is_baking_set(PointerRNA *ptr, bool value);

bool PointCacheItem_is_frame_skip_get(PointerRNA *ptr);
void PointCacheItem_is_frame_skip_set(PointerRNA *ptr, bool value);

enum {
	PointCacheItem_compression_NO = 0,
	PointCacheItem_compression_LIGHT = 1,
	PointCacheItem_compression_HEAVY = 2,
};

int PointCacheItem_compression_get(PointerRNA *ptr);
void PointCacheItem_compression_set(PointerRNA *ptr, int value);

int PointCacheItem_index_get(PointerRNA *ptr);
void PointCacheItem_index_set(PointerRNA *ptr, int value);

#define PointCacheItem_info_MAX 128

void PointCacheItem_info_get(PointerRNA *ptr, char *value);
int PointCacheItem_info_length(PointerRNA *ptr);
void PointCacheItem_info_set(PointerRNA *ptr, const char *value);

bool PointCacheItem_is_outdated_get(PointerRNA *ptr);
void PointCacheItem_is_outdated_set(PointerRNA *ptr, bool value);

int PointCacheItem_frame_step_get(PointerRNA *ptr);
void PointCacheItem_frame_step_set(PointerRNA *ptr, int value);

bool PointCacheItem_use_disk_cache_get(PointerRNA *ptr);
void PointCacheItem_use_disk_cache_set(PointerRNA *ptr, bool value);

int PointCacheItem_frame_end_get(PointerRNA *ptr);
void PointCacheItem_frame_end_set(PointerRNA *ptr, int value);

bool PointCacheItem_use_external_get(PointerRNA *ptr);
void PointCacheItem_use_external_set(PointerRNA *ptr, bool value);

#define PointCacheItem_filepath_MAX 1024

void PointCacheItem_filepath_get(PointerRNA *ptr, char *value);
int PointCacheItem_filepath_length(PointerRNA *ptr);
void PointCacheItem_filepath_set(PointerRNA *ptr, const char *value);

bool PointCacheItem_use_library_path_get(PointerRNA *ptr);
void PointCacheItem_use_library_path_set(PointerRNA *ptr, bool value);

int PointCacheItem_frame_start_get(PointerRNA *ptr);
void PointCacheItem_frame_start_set(PointerRNA *ptr, int value);

/**************** Point Caches ****************/

extern StructRNA RNA_PointCaches;

PointerRNA PointCaches_rna_type_get(PointerRNA *ptr);

int PointCaches_active_index_get(PointerRNA *ptr);
void PointCaches_active_index_set(PointerRNA *ptr, int value);

/**************** Point Cloud ****************/

extern StructRNA RNA_PointCloud;
extern StructRNA RNA_ID;

PointerRNA PointCloud_animation_data_get(PointerRNA *ptr);

void PointCloud_attributes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void PointCloud_attributes_next(CollectionPropertyIterator *iter);
void PointCloud_attributes_end(CollectionPropertyIterator *iter);
int PointCloud_attributes_length(PointerRNA *ptr);
bool PointCloud_attributes_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void PointCloud_color_attributes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void PointCloud_color_attributes_next(CollectionPropertyIterator *iter);
void PointCloud_color_attributes_end(CollectionPropertyIterator *iter);
int PointCloud_color_attributes_length(PointerRNA *ptr);

void PointCloud_materials_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void PointCloud_materials_next(CollectionPropertyIterator *iter);
void PointCloud_materials_end(CollectionPropertyIterator *iter);
int PointCloud_materials_length(PointerRNA *ptr);
bool PointCloud_materials_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool PointCloud_materials_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void PointCloud_points_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void PointCloud_points_next(CollectionPropertyIterator *iter);
void PointCloud_points_end(CollectionPropertyIterator *iter);
int PointCloud_points_length(PointerRNA *ptr);
bool PointCloud_points_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Point Light ****************/

extern StructRNA RNA_PointLight;
extern StructRNA RNA_Light;
extern StructRNA RNA_ID;

bool PointLight_use_absolute_resolution_get(PointerRNA *ptr);
void PointLight_use_absolute_resolution_set(PointerRNA *ptr, bool value);

float PointLight_energy_get(PointerRNA *ptr);
void PointLight_energy_set(PointerRNA *ptr, float value);

float PointLight_shadow_buffer_clip_start_get(PointerRNA *ptr);
void PointLight_shadow_buffer_clip_start_set(PointerRNA *ptr, float value);

float PointLight_shadow_filter_radius_get(PointerRNA *ptr);
void PointLight_shadow_filter_radius_set(PointerRNA *ptr, float value);

bool PointLight_use_shadow_jitter_get(PointerRNA *ptr);
void PointLight_use_shadow_jitter_set(PointerRNA *ptr, bool value);

float PointLight_shadow_jitter_overblur_get(PointerRNA *ptr);
void PointLight_shadow_jitter_overblur_set(PointerRNA *ptr, float value);

float PointLight_shadow_soft_size_get(PointerRNA *ptr);
void PointLight_shadow_soft_size_set(PointerRNA *ptr, float value);

float PointLight_shadow_maximum_resolution_get(PointerRNA *ptr);
void PointLight_shadow_maximum_resolution_set(PointerRNA *ptr, float value);

bool PointLight_use_soft_falloff_get(PointerRNA *ptr);
void PointLight_use_soft_falloff_set(PointerRNA *ptr, bool value);

/**************** Pointer Definition ****************/

extern StructRNA RNA_PointerProperty;
extern StructRNA RNA_Property;

PointerRNA PointerProperty_fixed_type_get(PointerRNA *ptr);

/**************** Pose ****************/

extern StructRNA RNA_Pose;

PointerRNA Pose_rna_type_get(PointerRNA *ptr);

PointerRNA Pose_animation_visualization_get(PointerRNA *ptr);

bool Pose_use_auto_ik_get(PointerRNA *ptr);
void Pose_use_auto_ik_set(PointerRNA *ptr, bool value);

PointerRNA Pose_ik_param_get(PointerRNA *ptr);

enum {
	Pose_ik_solver_LEGACY = 0,
	Pose_ik_solver_ITASC = 1,
};

int Pose_ik_solver_get(PointerRNA *ptr);
void Pose_ik_solver_set(PointerRNA *ptr, int value);

void Pose_bones_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Pose_bones_next(CollectionPropertyIterator *iter);
void Pose_bones_end(CollectionPropertyIterator *iter);
bool Pose_bones_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Pose_bones_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool Pose_use_mirror_relative_get(PointerRNA *ptr);
void Pose_use_mirror_relative_set(PointerRNA *ptr, bool value);

bool Pose_use_mirror_x_get(PointerRNA *ptr);
void Pose_use_mirror_x_set(PointerRNA *ptr, bool value);

void Pose_apply_pose_from_action_func(struct ID *_selfid, bContext *C, struct bAction *action, float evaluation_time);
void Pose_blend_pose_from_action_func(struct ID *_selfid, bContext *C, struct bAction *action, float blend_factor, float evaluation_time);
void Pose_backup_create_func(struct ID *_selfid, struct bAction *action);
bool Pose_backup_restore_func(struct ID *_selfid, bContext *C);
void Pose_backup_clear_func(struct ID *_selfid);
/**************** Pose Bone ****************/

extern StructRNA RNA_PoseBone;

PointerRNA PoseBone_rna_type_get(PointerRNA *ptr);

#define PoseBone_name_MAX 64

void PoseBone_name_get(PointerRNA *ptr, char *value);
int PoseBone_name_length(PointerRNA *ptr);
void PoseBone_name_set(PointerRNA *ptr, const char *value);

void PoseBone_rotation_axis_angle_get(PointerRNA *ptr, float values[4]);
void PoseBone_rotation_axis_angle_set(PointerRNA *ptr, const float values[4]);

PointerRNA PoseBone_bbone_custom_handle_end_get(PointerRNA *ptr);

PointerRNA PoseBone_bbone_custom_handle_start_get(PointerRNA *ptr);

void PoseBone_matrix_basis_get(PointerRNA *ptr, float values[16]);
void PoseBone_matrix_basis_set(PointerRNA *ptr, const float values[16]);

PointerRNA PoseBone_bone_get(PointerRNA *ptr);

void PoseBone_matrix_channel_get(PointerRNA *ptr, float values[16]);
void PoseBone_matrix_channel_set(PointerRNA *ptr, const float values[16]);

PointerRNA PoseBone_child_get(PointerRNA *ptr);

void PoseBone_constraints_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void PoseBone_constraints_next(CollectionPropertyIterator *iter);
void PoseBone_constraints_end(CollectionPropertyIterator *iter);
bool PoseBone_constraints_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool PoseBone_constraints_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

PointerRNA PoseBone_custom_shape_get(PointerRNA *ptr);

void PoseBone_custom_shape_rotation_euler_get(PointerRNA *ptr, float values[3]);
void PoseBone_custom_shape_rotation_euler_set(PointerRNA *ptr, const float values[3]);

void PoseBone_custom_shape_scale_xyz_get(PointerRNA *ptr, float values[3]);
void PoseBone_custom_shape_scale_xyz_set(PointerRNA *ptr, const float values[3]);

PointerRNA PoseBone_custom_shape_transform_get(PointerRNA *ptr);

void PoseBone_custom_shape_translation_get(PointerRNA *ptr, float values[3]);
void PoseBone_custom_shape_translation_set(PointerRNA *ptr, const float values[3]);

float PoseBone_bbone_easein_get(PointerRNA *ptr);
void PoseBone_bbone_easein_set(PointerRNA *ptr, float value);

float PoseBone_bbone_easeout_get(PointerRNA *ptr);
void PoseBone_bbone_easeout_set(PointerRNA *ptr, float value);

void PoseBone_rotation_euler_get(PointerRNA *ptr, float values[3]);
void PoseBone_rotation_euler_set(PointerRNA *ptr, const float values[3]);

bool PoseBone_is_in_ik_chain_get(PointerRNA *ptr);
void PoseBone_is_in_ik_chain_set(PointerRNA *ptr, bool value);

float PoseBone_ik_linear_weight_get(PointerRNA *ptr);
void PoseBone_ik_linear_weight_set(PointerRNA *ptr, float value);

bool PoseBone_use_ik_linear_control_get(PointerRNA *ptr);
void PoseBone_use_ik_linear_control_set(PointerRNA *ptr, bool value);

bool PoseBone_use_ik_rotation_control_get(PointerRNA *ptr);
void PoseBone_use_ik_rotation_control_set(PointerRNA *ptr, bool value);

float PoseBone_ik_rotation_weight_get(PointerRNA *ptr);
void PoseBone_ik_rotation_weight_set(PointerRNA *ptr, float value);

float PoseBone_ik_stretch_get(PointerRNA *ptr);
void PoseBone_ik_stretch_set(PointerRNA *ptr, float value);

bool PoseBone_use_ik_limit_x_get(PointerRNA *ptr);
void PoseBone_use_ik_limit_x_set(PointerRNA *ptr, bool value);

bool PoseBone_lock_ik_x_get(PointerRNA *ptr);
void PoseBone_lock_ik_x_set(PointerRNA *ptr, bool value);

float PoseBone_ik_max_x_get(PointerRNA *ptr);
void PoseBone_ik_max_x_set(PointerRNA *ptr, float value);

float PoseBone_ik_min_x_get(PointerRNA *ptr);
void PoseBone_ik_min_x_set(PointerRNA *ptr, float value);

float PoseBone_ik_stiffness_x_get(PointerRNA *ptr);
void PoseBone_ik_stiffness_x_set(PointerRNA *ptr, float value);

bool PoseBone_use_ik_limit_y_get(PointerRNA *ptr);
void PoseBone_use_ik_limit_y_set(PointerRNA *ptr, bool value);

bool PoseBone_lock_ik_y_get(PointerRNA *ptr);
void PoseBone_lock_ik_y_set(PointerRNA *ptr, bool value);

float PoseBone_ik_max_y_get(PointerRNA *ptr);
void PoseBone_ik_max_y_set(PointerRNA *ptr, float value);

float PoseBone_ik_min_y_get(PointerRNA *ptr);
void PoseBone_ik_min_y_set(PointerRNA *ptr, float value);

float PoseBone_ik_stiffness_y_get(PointerRNA *ptr);
void PoseBone_ik_stiffness_y_set(PointerRNA *ptr, float value);

bool PoseBone_use_ik_limit_z_get(PointerRNA *ptr);
void PoseBone_use_ik_limit_z_set(PointerRNA *ptr, bool value);

bool PoseBone_lock_ik_z_get(PointerRNA *ptr);
void PoseBone_lock_ik_z_set(PointerRNA *ptr, bool value);

float PoseBone_ik_max_z_get(PointerRNA *ptr);
void PoseBone_ik_max_z_set(PointerRNA *ptr, float value);

float PoseBone_ik_min_z_get(PointerRNA *ptr);
void PoseBone_ik_min_z_set(PointerRNA *ptr, float value);

float PoseBone_ik_stiffness_z_get(PointerRNA *ptr);
void PoseBone_ik_stiffness_z_set(PointerRNA *ptr, float value);

float PoseBone_bbone_curveinx_get(PointerRNA *ptr);
void PoseBone_bbone_curveinx_set(PointerRNA *ptr, float value);

float PoseBone_bbone_curveinz_get(PointerRNA *ptr);
void PoseBone_bbone_curveinz_set(PointerRNA *ptr, float value);

float PoseBone_length_get(PointerRNA *ptr);
void PoseBone_length_set(PointerRNA *ptr, float value);

void PoseBone_location_get(PointerRNA *ptr, float values[3]);
void PoseBone_location_set(PointerRNA *ptr, const float values[3]);

void PoseBone_lock_location_get(PointerRNA *ptr, bool values[3]);
void PoseBone_lock_location_set(PointerRNA *ptr, const bool values[3]);

void PoseBone_lock_rotation_get(PointerRNA *ptr, bool values[3]);
void PoseBone_lock_rotation_set(PointerRNA *ptr, const bool values[3]);

bool PoseBone_lock_rotation_w_get(PointerRNA *ptr);
void PoseBone_lock_rotation_w_set(PointerRNA *ptr, bool value);

bool PoseBone_lock_rotations_4d_get(PointerRNA *ptr);
void PoseBone_lock_rotations_4d_set(PointerRNA *ptr, bool value);

void PoseBone_lock_scale_get(PointerRNA *ptr, bool values[3]);
void PoseBone_lock_scale_set(PointerRNA *ptr, const bool values[3]);

PointerRNA PoseBone_motion_path_get(PointerRNA *ptr);

float PoseBone_bbone_curveoutx_get(PointerRNA *ptr);
void PoseBone_bbone_curveoutx_set(PointerRNA *ptr, float value);

float PoseBone_bbone_curveoutz_get(PointerRNA *ptr);
void PoseBone_bbone_curveoutz_set(PointerRNA *ptr, float value);

PointerRNA PoseBone_parent_get(PointerRNA *ptr);

void PoseBone_head_get(PointerRNA *ptr, float values[3]);
void PoseBone_head_set(PointerRNA *ptr, const float values[3]);

void PoseBone_matrix_get(PointerRNA *ptr, float values[16]);
void PoseBone_matrix_set(PointerRNA *ptr, const float values[16]);

void PoseBone_tail_get(PointerRNA *ptr, float values[3]);
void PoseBone_tail_set(PointerRNA *ptr, const float values[3]);

void PoseBone_rotation_quaternion_get(PointerRNA *ptr, float values[4]);
void PoseBone_rotation_quaternion_set(PointerRNA *ptr, const float values[4]);

float PoseBone_bbone_rollin_get(PointerRNA *ptr);
void PoseBone_bbone_rollin_set(PointerRNA *ptr, float value);

float PoseBone_bbone_rollout_get(PointerRNA *ptr);
void PoseBone_bbone_rollout_set(PointerRNA *ptr, float value);

enum {
	PoseBone_rotation_mode_QUATERNION = 0,
	PoseBone_rotation_mode_XYZ = 1,
	PoseBone_rotation_mode_XZY = 2,
	PoseBone_rotation_mode_YXZ = 3,
	PoseBone_rotation_mode_YZX = 4,
	PoseBone_rotation_mode_ZXY = 5,
	PoseBone_rotation_mode_ZYX = 6,
	PoseBone_rotation_mode_AXIS_ANGLE = -1,
};

int PoseBone_rotation_mode_get(PointerRNA *ptr);
void PoseBone_rotation_mode_set(PointerRNA *ptr, int value);

void PoseBone_scale_get(PointerRNA *ptr, float values[3]);
void PoseBone_scale_set(PointerRNA *ptr, const float values[3]);

void PoseBone_bbone_scalein_get(PointerRNA *ptr, float values[3]);
void PoseBone_bbone_scalein_set(PointerRNA *ptr, const float values[3]);

void PoseBone_bbone_scaleout_get(PointerRNA *ptr, float values[3]);
void PoseBone_bbone_scaleout_set(PointerRNA *ptr, const float values[3]);

bool PoseBone_use_custom_shape_bone_size_get(PointerRNA *ptr);
void PoseBone_use_custom_shape_bone_size_set(PointerRNA *ptr, bool value);

float PoseBone_custom_shape_wire_width_get(PointerRNA *ptr);
void PoseBone_custom_shape_wire_width_set(PointerRNA *ptr, float value);

PointerRNA PoseBone_color_get(PointerRNA *ptr);

float PoseBone_evaluate_envelope_func(struct bPoseChannel *_self, float point[3]);
void PoseBone_bbone_segment_index_func(struct bPoseChannel *_self, ReportList *reports, float point[3], int *index, float *blend_next);
void PoseBone_bbone_segment_matrix_func(struct bPoseChannel *_self, ReportList *reports, float matrix_return[16], int index, bool rest);
void PoseBone_compute_bbone_handles_func(struct bPoseChannel *_self, ReportList *reports, float handle1[3], float *roll1, float handle2[3], float *roll2, bool rest, bool ease, bool offsets);
/**************** PoseBone Constraints ****************/

extern StructRNA RNA_PoseBoneConstraints;

PointerRNA PoseBoneConstraints_rna_type_get(PointerRNA *ptr);

PointerRNA PoseBoneConstraints_active_get(PointerRNA *ptr);

struct bConstraint *PoseBoneConstraints_new_func(struct ID *_selfid, struct bPoseChannel *_self, Main *bmain, int type);
void PoseBoneConstraints_remove_func(struct ID *_selfid, struct bPoseChannel *_self, Main *bmain, ReportList *reports, struct PointerRNA *constraint);
void PoseBoneConstraints_move_func(struct ID *_selfid, struct bPoseChannel *_self, Main *bmain, ReportList *reports, int from_index, int to_index);
struct bConstraint *PoseBoneConstraints_copy_func(struct ID *_selfid, struct bPoseChannel *_self, Main *bmain, struct PointerRNA *constraint);
/**************** Preferences ****************/

extern StructRNA RNA_Preferences;

PointerRNA Preferences_rna_type_get(PointerRNA *ptr);

enum {
	Preferences_active_section_INTERFACE = 0,
	Preferences_active_section_VIEWPORT = 12,
	Preferences_active_section_LIGHTS = 7,
	Preferences_active_section_EDITING = 1,
	Preferences_active_section_ANIMATION = 13,
	Preferences_active_section_EXTENSIONS = 17,
	Preferences_active_section_ADDONS = 6,
	Preferences_active_section_THEMES = 4,
	Preferences_active_section_INPUT = 5,
	Preferences_active_section_NAVIGATION = 14,
	Preferences_active_section_KEYMAP = 8,
	Preferences_active_section_SYSTEM = 3,
	Preferences_active_section_SAVE_LOAD = 2,
	Preferences_active_section_FILE_PATHS = 15,
	Preferences_active_section_EXPERIMENTAL = 16,
};

int Preferences_active_section_get(PointerRNA *ptr);
void Preferences_active_section_set(PointerRNA *ptr, int value);

void Preferences_addons_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Preferences_addons_next(CollectionPropertyIterator *iter);
void Preferences_addons_end(CollectionPropertyIterator *iter);
bool Preferences_addons_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Preferences_addons_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

#define Preferences_app_template_MAX 64

void Preferences_app_template_get(PointerRNA *ptr, char *value);
int Preferences_app_template_length(PointerRNA *ptr);
void Preferences_app_template_set(PointerRNA *ptr, const char *value);

PointerRNA Preferences_apps_get(PointerRNA *ptr);

void Preferences_autoexec_paths_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Preferences_autoexec_paths_next(CollectionPropertyIterator *iter);
void Preferences_autoexec_paths_end(CollectionPropertyIterator *iter);
bool Preferences_autoexec_paths_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Preferences_autoexec_paths_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool Preferences_is_dirty_get(PointerRNA *ptr);
void Preferences_is_dirty_set(PointerRNA *ptr, bool value);

PointerRNA Preferences_edit_get(PointerRNA *ptr);

PointerRNA Preferences_experimental_get(PointerRNA *ptr);

PointerRNA Preferences_extensions_get(PointerRNA *ptr);

PointerRNA Preferences_filepaths_get(PointerRNA *ptr);

PointerRNA Preferences_inputs_get(PointerRNA *ptr);

PointerRNA Preferences_keymap_get(PointerRNA *ptr);

bool Preferences_use_recent_searches_get(PointerRNA *ptr);
void Preferences_use_recent_searches_set(PointerRNA *ptr, bool value);

bool Preferences_use_preferences_save_get(PointerRNA *ptr);
void Preferences_use_preferences_save_set(PointerRNA *ptr, bool value);

void Preferences_studio_lights_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Preferences_studio_lights_next(CollectionPropertyIterator *iter);
void Preferences_studio_lights_end(CollectionPropertyIterator *iter);

void Preferences_ui_styles_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Preferences_ui_styles_next(CollectionPropertyIterator *iter);
void Preferences_ui_styles_end(CollectionPropertyIterator *iter);
bool Preferences_ui_styles_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

PointerRNA Preferences_system_get(PointerRNA *ptr);

void Preferences_themes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Preferences_themes_next(CollectionPropertyIterator *iter);
void Preferences_themes_end(CollectionPropertyIterator *iter);
bool Preferences_themes_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Preferences_themes_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void Preferences_version_get(PointerRNA *ptr, int values[3]);
void Preferences_version_set(PointerRNA *ptr, const int values[3]);

PointerRNA Preferences_view_get(PointerRNA *ptr);

/**************** Apps ****************/

extern StructRNA RNA_PreferencesApps;

PointerRNA PreferencesApps_rna_type_get(PointerRNA *ptr);

bool PreferencesApps_show_corner_split_get(PointerRNA *ptr);
void PreferencesApps_show_corner_split_set(PointerRNA *ptr, bool value);

bool PreferencesApps_show_edge_resize_get(PointerRNA *ptr);
void PreferencesApps_show_edge_resize_set(PointerRNA *ptr, bool value);

bool PreferencesApps_show_regions_visibility_toggle_get(PointerRNA *ptr);
void PreferencesApps_show_regions_visibility_toggle_set(PointerRNA *ptr, bool value);

/**************** Edit Methods ****************/

extern StructRNA RNA_PreferencesEdit;

PointerRNA PreferencesEdit_rna_type_get(PointerRNA *ptr);

enum {
	PreferencesEdit_object_align_WORLD = 0,
	PreferencesEdit_object_align_VIEW = 524288,
	PreferencesEdit_object_align_CURSOR = 16384,
};

int PreferencesEdit_object_align_get(PointerRNA *ptr);
void PreferencesEdit_object_align_set(PointerRNA *ptr, int value);

bool PreferencesEdit_use_negative_frames_get(PointerRNA *ptr);
void PreferencesEdit_use_negative_frames_set(PointerRNA *ptr, bool value);

void PreferencesEdit_grease_pencil_default_color_get(PointerRNA *ptr, float values[4]);
void PreferencesEdit_grease_pencil_default_color_set(PointerRNA *ptr, const float values[4]);

bool PreferencesEdit_use_text_edit_auto_close_get(PointerRNA *ptr);
void PreferencesEdit_use_text_edit_auto_close_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_keyframe_insert_available_get(PointerRNA *ptr);
void PreferencesEdit_use_keyframe_insert_available_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_auto_keying_get(PointerRNA *ptr);
void PreferencesEdit_use_auto_keying_set(PointerRNA *ptr, bool value);

enum {
	PreferencesEdit_auto_keying_mode_ADD_REPLACE_KEYS = 3,
	PreferencesEdit_auto_keying_mode_REPLACE_KEYS = 5,
};

int PreferencesEdit_auto_keying_mode_get(PointerRNA *ptr);
void PreferencesEdit_auto_keying_mode_set(PointerRNA *ptr, int value);

bool PreferencesEdit_node_use_insert_offset_get(PointerRNA *ptr);
void PreferencesEdit_node_use_insert_offset_set(PointerRNA *ptr, bool value);

int PreferencesEdit_node_margin_get(PointerRNA *ptr);
void PreferencesEdit_node_margin_set(PointerRNA *ptr, int value);

bool PreferencesEdit_use_auto_keyframe_insert_needed_get(PointerRNA *ptr);
void PreferencesEdit_use_auto_keyframe_insert_needed_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_anim_channel_group_colors_get(PointerRNA *ptr);
void PreferencesEdit_use_anim_channel_group_colors_set(PointerRNA *ptr, bool value);

float PreferencesEdit_collection_instance_empty_size_get(PointerRNA *ptr);
void PreferencesEdit_collection_instance_empty_size_set(PointerRNA *ptr, float value);

bool PreferencesEdit_connect_strips_by_default_get(PointerRNA *ptr);
void PreferencesEdit_connect_strips_by_default_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_cursor_lock_adjust_get(PointerRNA *ptr);
void PreferencesEdit_use_cursor_lock_adjust_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_mouse_depth_cursor_get(PointerRNA *ptr);
void PreferencesEdit_use_mouse_depth_cursor_set(PointerRNA *ptr, bool value);

enum {
	PreferencesEdit_key_insert_channels_LOCATION = 1,
	PreferencesEdit_key_insert_channels_ROTATION = 2,
	PreferencesEdit_key_insert_channels_SCALE = 4,
	PreferencesEdit_key_insert_channels_ROTATE_MODE = 8,
	PreferencesEdit_key_insert_channels_CUSTOM_PROPS = 16,
};

int PreferencesEdit_key_insert_channels_get(PointerRNA *ptr);
void PreferencesEdit_key_insert_channels_set(PointerRNA *ptr, int value);

bool PreferencesEdit_use_duplicate_action_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_action_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_duplicate_armature_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_armature_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_duplicate_camera_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_camera_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_duplicate_curve_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_curve_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_duplicate_curves_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_curves_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_duplicate_grease_pencil_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_grease_pencil_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_duplicate_lattice_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_lattice_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_duplicate_light_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_light_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_duplicate_lightprobe_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_lightprobe_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_duplicate_material_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_material_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_duplicate_mesh_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_mesh_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_duplicate_metaball_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_metaball_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_duplicate_node_tree_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_node_tree_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_duplicate_particle_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_particle_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_duplicate_pointcloud_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_pointcloud_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_duplicate_speaker_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_speaker_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_duplicate_surface_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_surface_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_duplicate_text_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_text_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_duplicate_volume_get(PointerRNA *ptr);
void PreferencesEdit_use_duplicate_volume_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_enter_edit_mode_get(PointerRNA *ptr);
void PreferencesEdit_use_enter_edit_mode_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_fcurve_high_quality_drawing_get(PointerRNA *ptr);
void PreferencesEdit_use_fcurve_high_quality_drawing_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_global_undo_get(PointerRNA *ptr);
void PreferencesEdit_use_global_undo_set(PointerRNA *ptr, bool value);

int PreferencesEdit_grease_pencil_eraser_radius_get(PointerRNA *ptr);
void PreferencesEdit_grease_pencil_eraser_radius_set(PointerRNA *ptr, int value);

int PreferencesEdit_grease_pencil_euclidean_distance_get(PointerRNA *ptr);
void PreferencesEdit_grease_pencil_euclidean_distance_set(PointerRNA *ptr, int value);

int PreferencesEdit_grease_pencil_manhattan_distance_get(PointerRNA *ptr);
void PreferencesEdit_grease_pencil_manhattan_distance_set(PointerRNA *ptr, int value);

bool PreferencesEdit_use_keyframe_insert_needed_get(PointerRNA *ptr);
void PreferencesEdit_use_keyframe_insert_needed_set(PointerRNA *ptr, bool value);

enum {
	PreferencesEdit_material_link_OBDATA = 0,
	PreferencesEdit_material_link_OBJECT = 256,
};

int PreferencesEdit_material_link_get(PointerRNA *ptr);
void PreferencesEdit_material_link_set(PointerRNA *ptr, int value);

enum {
	PreferencesEdit_fcurve_new_auto_smoothing_NONE = 0,
	PreferencesEdit_fcurve_new_auto_smoothing_CONT_ACCEL = 1,
};

int PreferencesEdit_fcurve_new_auto_smoothing_get(PointerRNA *ptr);
void PreferencesEdit_fcurve_new_auto_smoothing_set(PointerRNA *ptr, int value);

bool PreferencesEdit_use_insertkey_xyz_to_rgb_get(PointerRNA *ptr);
void PreferencesEdit_use_insertkey_xyz_to_rgb_set(PointerRNA *ptr, bool value);

enum {
	PreferencesEdit_keyframe_new_handle_type_FREE = 0,
	PreferencesEdit_keyframe_new_handle_type_ALIGNED = 3,
	PreferencesEdit_keyframe_new_handle_type_VECTOR = 2,
	PreferencesEdit_keyframe_new_handle_type_AUTO = 1,
	PreferencesEdit_keyframe_new_handle_type_AUTO_CLAMPED = 4,
};

int PreferencesEdit_keyframe_new_handle_type_get(PointerRNA *ptr);
void PreferencesEdit_keyframe_new_handle_type_set(PointerRNA *ptr, int value);

enum {
	PreferencesEdit_keyframe_new_interpolation_type_CONSTANT = 0,
	PreferencesEdit_keyframe_new_interpolation_type_LINEAR = 1,
	PreferencesEdit_keyframe_new_interpolation_type_BEZIER = 2,
	PreferencesEdit_keyframe_new_interpolation_type_SINE = 12,
	PreferencesEdit_keyframe_new_interpolation_type_QUAD = 9,
	PreferencesEdit_keyframe_new_interpolation_type_CUBIC = 6,
	PreferencesEdit_keyframe_new_interpolation_type_QUART = 10,
	PreferencesEdit_keyframe_new_interpolation_type_QUINT = 11,
	PreferencesEdit_keyframe_new_interpolation_type_EXPO = 8,
	PreferencesEdit_keyframe_new_interpolation_type_CIRC = 5,
	PreferencesEdit_keyframe_new_interpolation_type_BACK = 3,
	PreferencesEdit_keyframe_new_interpolation_type_BOUNCE = 4,
	PreferencesEdit_keyframe_new_interpolation_type_ELASTIC = 7,
};

int PreferencesEdit_keyframe_new_interpolation_type_get(PointerRNA *ptr);
void PreferencesEdit_keyframe_new_interpolation_type_set(PointerRNA *ptr, int value);

int PreferencesEdit_node_preview_resolution_get(PointerRNA *ptr);
void PreferencesEdit_node_preview_resolution_set(PointerRNA *ptr, int value);

bool PreferencesEdit_show_only_selected_curve_keyframes_get(PointerRNA *ptr);
void PreferencesEdit_show_only_selected_curve_keyframes_set(PointerRNA *ptr, bool value);

void PreferencesEdit_sculpt_paint_overlay_color_get(PointerRNA *ptr, float values[3]);
void PreferencesEdit_sculpt_paint_overlay_color_set(PointerRNA *ptr, const float values[3]);

bool PreferencesEdit_use_auto_keying_warning_get(PointerRNA *ptr);
void PreferencesEdit_use_auto_keying_warning_set(PointerRNA *ptr, bool value);

bool PreferencesEdit_use_sequencer_simplified_tweaking_get(PointerRNA *ptr);
void PreferencesEdit_use_sequencer_simplified_tweaking_set(PointerRNA *ptr, bool value);

int PreferencesEdit_undo_memory_limit_get(PointerRNA *ptr);
void PreferencesEdit_undo_memory_limit_set(PointerRNA *ptr, int value);

int PreferencesEdit_undo_steps_get(PointerRNA *ptr);
void PreferencesEdit_undo_steps_set(PointerRNA *ptr, int value);

float PreferencesEdit_fcurve_unselected_alpha_get(PointerRNA *ptr);
void PreferencesEdit_fcurve_unselected_alpha_set(PointerRNA *ptr, float value);

bool PreferencesEdit_use_visual_keying_get(PointerRNA *ptr);
void PreferencesEdit_use_visual_keying_set(PointerRNA *ptr, bool value);

/**************** Experimental ****************/

extern StructRNA RNA_PreferencesExperimental;

PointerRNA PreferencesExperimental_rna_type_get(PointerRNA *ptr);

bool PreferencesExperimental_use_all_linked_data_direct_get(PointerRNA *ptr);
void PreferencesExperimental_use_all_linked_data_direct_set(PointerRNA *ptr, bool value);

bool PreferencesExperimental_show_asset_debug_info_get(PointerRNA *ptr);
void PreferencesExperimental_show_asset_debug_info_set(PointerRNA *ptr, bool value);

bool PreferencesExperimental_use_bundle_and_closure_nodes_get(PointerRNA *ptr);
void PreferencesExperimental_use_bundle_and_closure_nodes_set(PointerRNA *ptr, bool value);

bool PreferencesExperimental_use_cycles_debug_get(PointerRNA *ptr);
void PreferencesExperimental_use_cycles_debug_set(PointerRNA *ptr, bool value);

bool PreferencesExperimental_use_eevee_debug_get(PointerRNA *ptr);
void PreferencesExperimental_use_eevee_debug_set(PointerRNA *ptr, bool value);

bool PreferencesExperimental_use_extended_asset_browser_get(PointerRNA *ptr);
void PreferencesExperimental_use_extended_asset_browser_set(PointerRNA *ptr, bool value);

bool PreferencesExperimental_use_extensions_debug_get(PointerRNA *ptr);
void PreferencesExperimental_use_extensions_debug_set(PointerRNA *ptr, bool value);

bool PreferencesExperimental_use_new_curves_tools_get(PointerRNA *ptr);
void PreferencesExperimental_use_new_curves_tools_set(PointerRNA *ptr, bool value);

bool PreferencesExperimental_use_new_volume_nodes_get(PointerRNA *ptr);
void PreferencesExperimental_use_new_volume_nodes_set(PointerRNA *ptr, bool value);

bool PreferencesExperimental_use_asset_indexing_get(PointerRNA *ptr);
void PreferencesExperimental_use_asset_indexing_set(PointerRNA *ptr, bool value);

bool PreferencesExperimental_override_auto_resync_get(PointerRNA *ptr);
void PreferencesExperimental_override_auto_resync_set(PointerRNA *ptr, bool value);

bool PreferencesExperimental_use_socket_structure_type_get(PointerRNA *ptr);
void PreferencesExperimental_use_socket_structure_type_set(PointerRNA *ptr, bool value);

bool PreferencesExperimental_use_recompute_usercount_on_save_debug_get(PointerRNA *ptr);
void PreferencesExperimental_use_recompute_usercount_on_save_debug_set(PointerRNA *ptr, bool value);

bool PreferencesExperimental_use_sculpt_texture_paint_get(PointerRNA *ptr);
void PreferencesExperimental_use_sculpt_texture_paint_set(PointerRNA *ptr, bool value);

bool PreferencesExperimental_use_shader_node_previews_get(PointerRNA *ptr);
void PreferencesExperimental_use_shader_node_previews_set(PointerRNA *ptr, bool value);

bool PreferencesExperimental_use_undo_legacy_get(PointerRNA *ptr);
void PreferencesExperimental_use_undo_legacy_set(PointerRNA *ptr, bool value);

bool PreferencesExperimental_use_viewport_debug_get(PointerRNA *ptr);
void PreferencesExperimental_use_viewport_debug_set(PointerRNA *ptr, bool value);

bool PreferencesExperimental_write_large_blend_file_blocks_get(PointerRNA *ptr);
void PreferencesExperimental_write_large_blend_file_blocks_set(PointerRNA *ptr, bool value);

bool PreferencesExperimental_use_attribute_storage_write_get(PointerRNA *ptr);
void PreferencesExperimental_use_attribute_storage_write_set(PointerRNA *ptr, bool value);

/**************** Extensions ****************/

extern StructRNA RNA_PreferencesExtensions;

PointerRNA PreferencesExtensions_rna_type_get(PointerRNA *ptr);

int PreferencesExtensions_active_repo_get(PointerRNA *ptr);
void PreferencesExtensions_active_repo_set(PointerRNA *ptr, int value);

void PreferencesExtensions_repos_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void PreferencesExtensions_repos_next(CollectionPropertyIterator *iter);
void PreferencesExtensions_repos_end(CollectionPropertyIterator *iter);
bool PreferencesExtensions_repos_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool PreferencesExtensions_repos_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool PreferencesExtensions_use_online_access_handled_get(PointerRNA *ptr);
void PreferencesExtensions_use_online_access_handled_set(PointerRNA *ptr, bool value);

/**************** File Paths ****************/

extern StructRNA RNA_PreferencesFilePaths;

PointerRNA PreferencesFilePaths_rna_type_get(PointerRNA *ptr);

int PreferencesFilePaths_active_asset_library_get(PointerRNA *ptr);
void PreferencesFilePaths_active_asset_library_set(PointerRNA *ptr, int value);

#define PreferencesFilePaths_animation_player_MAX 1024

void PreferencesFilePaths_animation_player_get(PointerRNA *ptr, char *value);
int PreferencesFilePaths_animation_player_length(PointerRNA *ptr);
void PreferencesFilePaths_animation_player_set(PointerRNA *ptr, const char *value);

enum {
	PreferencesFilePaths_animation_player_preset_INTERNAL = 0,
	PreferencesFilePaths_animation_player_preset_DJV = 2,
	PreferencesFilePaths_animation_player_preset_FRAMECYCLER = 3,
	PreferencesFilePaths_animation_player_preset_RV = 4,
	PreferencesFilePaths_animation_player_preset_MPLAYER = 5,
	PreferencesFilePaths_animation_player_preset_CUSTOM = 50,
};

int PreferencesFilePaths_animation_player_preset_get(PointerRNA *ptr);
void PreferencesFilePaths_animation_player_preset_set(PointerRNA *ptr, int value);

void PreferencesFilePaths_asset_libraries_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void PreferencesFilePaths_asset_libraries_next(CollectionPropertyIterator *iter);
void PreferencesFilePaths_asset_libraries_end(CollectionPropertyIterator *iter);
bool PreferencesFilePaths_asset_libraries_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool PreferencesFilePaths_asset_libraries_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool PreferencesFilePaths_use_scripts_auto_execute_get(PointerRNA *ptr);
void PreferencesFilePaths_use_scripts_auto_execute_set(PointerRNA *ptr, bool value);

bool PreferencesFilePaths_use_auto_save_temporary_files_get(PointerRNA *ptr);
void PreferencesFilePaths_use_auto_save_temporary_files_set(PointerRNA *ptr, bool value);

int PreferencesFilePaths_auto_save_time_get(PointerRNA *ptr);
void PreferencesFilePaths_auto_save_time_set(PointerRNA *ptr, int value);

bool PreferencesFilePaths_use_file_compression_get(PointerRNA *ptr);
void PreferencesFilePaths_use_file_compression_set(PointerRNA *ptr, bool value);

enum {
	PreferencesFilePaths_file_preview_type_NONE = 0,
	PreferencesFilePaths_file_preview_type_AUTO = 1,
	PreferencesFilePaths_file_preview_type_SCREENSHOT = 2,
	PreferencesFilePaths_file_preview_type_CAMERA = 3,
};

int PreferencesFilePaths_file_preview_type_get(PointerRNA *ptr);
void PreferencesFilePaths_file_preview_type_set(PointerRNA *ptr, int value);

bool PreferencesFilePaths_use_filter_files_get(PointerRNA *ptr);
void PreferencesFilePaths_use_filter_files_set(PointerRNA *ptr, bool value);

#define PreferencesFilePaths_font_directory_MAX 768

void PreferencesFilePaths_font_directory_get(PointerRNA *ptr, char *value);
int PreferencesFilePaths_font_directory_length(PointerRNA *ptr);
void PreferencesFilePaths_font_directory_set(PointerRNA *ptr, const char *value);

#define PreferencesFilePaths_image_editor_MAX 1024

void PreferencesFilePaths_image_editor_get(PointerRNA *ptr, char *value);
int PreferencesFilePaths_image_editor_length(PointerRNA *ptr);
void PreferencesFilePaths_image_editor_set(PointerRNA *ptr, const char *value);

bool PreferencesFilePaths_use_load_ui_get(PointerRNA *ptr);
void PreferencesFilePaths_use_load_ui_set(PointerRNA *ptr, bool value);

bool PreferencesFilePaths_use_extension_online_access_handled_get(PointerRNA *ptr);
void PreferencesFilePaths_use_extension_online_access_handled_set(PointerRNA *ptr, bool value);

void PreferencesFilePaths_script_directories_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void PreferencesFilePaths_script_directories_next(CollectionPropertyIterator *iter);
void PreferencesFilePaths_script_directories_end(CollectionPropertyIterator *iter);
bool PreferencesFilePaths_script_directories_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool PreferencesFilePaths_script_directories_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

int PreferencesFilePaths_recent_files_get(PointerRNA *ptr);
void PreferencesFilePaths_recent_files_set(PointerRNA *ptr, int value);

bool PreferencesFilePaths_use_relative_paths_get(PointerRNA *ptr);
void PreferencesFilePaths_use_relative_paths_set(PointerRNA *ptr, bool value);

#define PreferencesFilePaths_render_cache_directory_MAX 768

void PreferencesFilePaths_render_cache_directory_get(PointerRNA *ptr, char *value);
int PreferencesFilePaths_render_cache_directory_length(PointerRNA *ptr);
void PreferencesFilePaths_render_cache_directory_set(PointerRNA *ptr, const char *value);

#define PreferencesFilePaths_render_output_directory_MAX 1024

void PreferencesFilePaths_render_output_directory_get(PointerRNA *ptr, char *value);
int PreferencesFilePaths_render_output_directory_length(PointerRNA *ptr);
void PreferencesFilePaths_render_output_directory_set(PointerRNA *ptr, const char *value);

int PreferencesFilePaths_save_version_get(PointerRNA *ptr);
void PreferencesFilePaths_save_version_set(PointerRNA *ptr, int value);

bool PreferencesFilePaths_show_hidden_files_datablocks_get(PointerRNA *ptr);
void PreferencesFilePaths_show_hidden_files_datablocks_set(PointerRNA *ptr, bool value);

bool PreferencesFilePaths_show_recent_locations_get(PointerRNA *ptr);
void PreferencesFilePaths_show_recent_locations_set(PointerRNA *ptr, bool value);

bool PreferencesFilePaths_show_system_bookmarks_get(PointerRNA *ptr);
void PreferencesFilePaths_show_system_bookmarks_set(PointerRNA *ptr, bool value);

#define PreferencesFilePaths_sound_directory_MAX 768

void PreferencesFilePaths_sound_directory_get(PointerRNA *ptr, char *value);
int PreferencesFilePaths_sound_directory_length(PointerRNA *ptr);
void PreferencesFilePaths_sound_directory_set(PointerRNA *ptr, const char *value);

bool PreferencesFilePaths_use_tabs_as_spaces_get(PointerRNA *ptr);
void PreferencesFilePaths_use_tabs_as_spaces_set(PointerRNA *ptr, bool value);

#define PreferencesFilePaths_temporary_directory_MAX 768

void PreferencesFilePaths_temporary_directory_get(PointerRNA *ptr, char *value);
int PreferencesFilePaths_temporary_directory_length(PointerRNA *ptr);
void PreferencesFilePaths_temporary_directory_set(PointerRNA *ptr, const char *value);

#define PreferencesFilePaths_text_editor_MAX 1024

void PreferencesFilePaths_text_editor_get(PointerRNA *ptr, char *value);
int PreferencesFilePaths_text_editor_length(PointerRNA *ptr);
void PreferencesFilePaths_text_editor_set(PointerRNA *ptr, const char *value);

#define PreferencesFilePaths_text_editor_args_MAX 256

void PreferencesFilePaths_text_editor_args_get(PointerRNA *ptr, char *value);
int PreferencesFilePaths_text_editor_args_length(PointerRNA *ptr);
void PreferencesFilePaths_text_editor_args_set(PointerRNA *ptr, const char *value);

#define PreferencesFilePaths_texture_directory_MAX 768

void PreferencesFilePaths_texture_directory_get(PointerRNA *ptr, char *value);
int PreferencesFilePaths_texture_directory_length(PointerRNA *ptr);
void PreferencesFilePaths_texture_directory_set(PointerRNA *ptr, const char *value);

#define PreferencesFilePaths_i18n_branches_directory_MAX 768

void PreferencesFilePaths_i18n_branches_directory_get(PointerRNA *ptr, char *value);
int PreferencesFilePaths_i18n_branches_directory_length(PointerRNA *ptr);
void PreferencesFilePaths_i18n_branches_directory_set(PointerRNA *ptr, const char *value);

/**************** Input ****************/

extern StructRNA RNA_PreferencesInput;

PointerRNA PreferencesInput_rna_type_get(PointerRNA *ptr);

bool PreferencesInput_ndof_orbit_center_auto_get(PointerRNA *ptr);
void PreferencesInput_ndof_orbit_center_auto_set(PointerRNA *ptr, bool value);

bool PreferencesInput_use_mouse_depth_navigate_get(PointerRNA *ptr);
void PreferencesInput_use_mouse_depth_navigate_set(PointerRNA *ptr, bool value);

bool PreferencesInput_use_auto_perspective_get(PointerRNA *ptr);
void PreferencesInput_use_auto_perspective_set(PointerRNA *ptr, bool value);

bool PreferencesInput_use_mouse_continuous_get(PointerRNA *ptr);
void PreferencesInput_use_mouse_continuous_set(PointerRNA *ptr, bool value);

float PreferencesInput_ndof_deadzone_get(PointerRNA *ptr);
void PreferencesInput_ndof_deadzone_set(PointerRNA *ptr, float value);

bool PreferencesInput_use_numeric_input_advanced_get(PointerRNA *ptr);
void PreferencesInput_use_numeric_input_advanced_set(PointerRNA *ptr, bool value);

int PreferencesInput_mouse_double_click_time_get(PointerRNA *ptr);
void PreferencesInput_mouse_double_click_time_set(PointerRNA *ptr, int value);

int PreferencesInput_drag_threshold_get(PointerRNA *ptr);
void PreferencesInput_drag_threshold_set(PointerRNA *ptr, int value);

enum {
	PreferencesInput_mouse_emulate_3_button_modifier_ALT = 0,
	PreferencesInput_mouse_emulate_3_button_modifier_OSKEY = 1,
};

int PreferencesInput_mouse_emulate_3_button_modifier_get(PointerRNA *ptr);
void PreferencesInput_mouse_emulate_3_button_modifier_set(PointerRNA *ptr, int value);

bool PreferencesInput_use_mouse_emulate_3_button_get(PointerRNA *ptr);
void PreferencesInput_use_mouse_emulate_3_button_set(PointerRNA *ptr, bool value);

bool PreferencesInput_use_emulate_numpad_get(PointerRNA *ptr);
void PreferencesInput_use_emulate_numpad_set(PointerRNA *ptr, bool value);

bool PreferencesInput_ndof_fly_helicopter_get(PointerRNA *ptr);
void PreferencesInput_ndof_fly_helicopter_set(PointerRNA *ptr, bool value);

bool PreferencesInput_ndof_rotx_invert_axis_get(PointerRNA *ptr);
void PreferencesInput_ndof_rotx_invert_axis_set(PointerRNA *ptr, bool value);

bool PreferencesInput_ndof_rotz_invert_axis_get(PointerRNA *ptr);
void PreferencesInput_ndof_rotz_invert_axis_set(PointerRNA *ptr, bool value);

bool PreferencesInput_ndof_panx_invert_axis_get(PointerRNA *ptr);
void PreferencesInput_ndof_panx_invert_axis_set(PointerRNA *ptr, bool value);

bool PreferencesInput_ndof_pany_invert_axis_get(PointerRNA *ptr);
void PreferencesInput_ndof_pany_invert_axis_set(PointerRNA *ptr, bool value);

bool PreferencesInput_ndof_roty_invert_axis_get(PointerRNA *ptr);
void PreferencesInput_ndof_roty_invert_axis_set(PointerRNA *ptr, bool value);

bool PreferencesInput_ndof_panz_invert_axis_get(PointerRNA *ptr);
void PreferencesInput_ndof_panz_invert_axis_set(PointerRNA *ptr, bool value);

bool PreferencesInput_invert_mouse_zoom_get(PointerRNA *ptr);
void PreferencesInput_invert_mouse_zoom_set(PointerRNA *ptr, bool value);

float PreferencesInput_pressure_threshold_max_get(PointerRNA *ptr);
void PreferencesInput_pressure_threshold_max_set(PointerRNA *ptr, float value);

int PreferencesInput_move_threshold_get(PointerRNA *ptr);
void PreferencesInput_move_threshold_set(PointerRNA *ptr, int value);

int PreferencesInput_drag_threshold_mouse_get(PointerRNA *ptr);
void PreferencesInput_drag_threshold_mouse_set(PointerRNA *ptr, int value);

bool PreferencesInput_use_multitouch_gestures_get(PointerRNA *ptr);
void PreferencesInput_use_multitouch_gestures_set(PointerRNA *ptr, bool value);

bool PreferencesInput_ndof_lock_horizon_get(PointerRNA *ptr);
void PreferencesInput_ndof_lock_horizon_set(PointerRNA *ptr, bool value);

enum {
	PreferencesInput_ndof_navigation_mode_OBJECT = 0,
	PreferencesInput_ndof_navigation_mode_FLY = 1,
};

int PreferencesInput_ndof_navigation_mode_get(PointerRNA *ptr);
void PreferencesInput_ndof_navigation_mode_set(PointerRNA *ptr, int value);

bool PreferencesInput_use_rotate_around_active_get(PointerRNA *ptr);
void PreferencesInput_use_rotate_around_active_set(PointerRNA *ptr, bool value);

enum {
	PreferencesInput_view_rotate_method_TURNTABLE = 0,
	PreferencesInput_view_rotate_method_TRACKBALL = 32,
};

int PreferencesInput_view_rotate_method_get(PointerRNA *ptr);
void PreferencesInput_view_rotate_method_set(PointerRNA *ptr, int value);

float PreferencesInput_view_rotate_sensitivity_turntable_get(PointerRNA *ptr);
void PreferencesInput_view_rotate_sensitivity_turntable_set(PointerRNA *ptr, float value);

float PreferencesInput_view_rotate_sensitivity_trackball_get(PointerRNA *ptr);
void PreferencesInput_view_rotate_sensitivity_trackball_set(PointerRNA *ptr, float value);

float PreferencesInput_ndof_orbit_sensitivity_get(PointerRNA *ptr);
void PreferencesInput_ndof_orbit_sensitivity_set(PointerRNA *ptr, float value);

bool PreferencesInput_ndof_lock_camera_pan_zoom_get(PointerRNA *ptr);
void PreferencesInput_ndof_lock_camera_pan_zoom_set(PointerRNA *ptr, bool value);

bool PreferencesInput_use_drag_immediately_get(PointerRNA *ptr);
void PreferencesInput_use_drag_immediately_set(PointerRNA *ptr, bool value);

bool PreferencesInput_ndof_orbit_center_selected_get(PointerRNA *ptr);
void PreferencesInput_ndof_orbit_center_selected_set(PointerRNA *ptr, bool value);

float PreferencesInput_ndof_sensitivity_get(PointerRNA *ptr);
void PreferencesInput_ndof_sensitivity_set(PointerRNA *ptr, float value);

bool PreferencesInput_ndof_show_guide_orbit_axis_get(PointerRNA *ptr);
void PreferencesInput_ndof_show_guide_orbit_axis_set(PointerRNA *ptr, bool value);

bool PreferencesInput_ndof_show_guide_orbit_center_get(PointerRNA *ptr);
void PreferencesInput_ndof_show_guide_orbit_center_set(PointerRNA *ptr, bool value);

float PreferencesInput_pressure_softness_get(PointerRNA *ptr);
void PreferencesInput_pressure_softness_set(PointerRNA *ptr, float value);

enum {
	PreferencesInput_tablet_api_AUTOMATIC = 0,
	PreferencesInput_tablet_api_WINDOWS_INK = 1,
	PreferencesInput_tablet_api_WINTAB = 2,
};

int PreferencesInput_tablet_api_get(PointerRNA *ptr);
void PreferencesInput_tablet_api_set(PointerRNA *ptr, int value);

int PreferencesInput_drag_threshold_tablet_get(PointerRNA *ptr);
void PreferencesInput_drag_threshold_tablet_set(PointerRNA *ptr, int value);

enum {
	PreferencesInput_touchpad_scroll_direction_TRADITIONAL = 0,
	PreferencesInput_touchpad_scroll_direction_NATURAL = 1,
};

int PreferencesInput_touchpad_scroll_direction_get(PointerRNA *ptr);
void PreferencesInput_touchpad_scroll_direction_set(PointerRNA *ptr, int value);

enum {
	PreferencesInput_navigation_mode_WALK = 0,
	PreferencesInput_navigation_mode_FLY = 1,
};

int PreferencesInput_navigation_mode_get(PointerRNA *ptr);
void PreferencesInput_navigation_mode_set(PointerRNA *ptr, int value);

PointerRNA PreferencesInput_walk_navigation_get(PointerRNA *ptr);

bool PreferencesInput_invert_zoom_wheel_get(PointerRNA *ptr);
void PreferencesInput_invert_zoom_wheel_set(PointerRNA *ptr, bool value);

enum {
	PreferencesInput_view_zoom_axis_VERTICAL = 0,
	PreferencesInput_view_zoom_axis_HORIZONTAL = 67108864,
};

int PreferencesInput_view_zoom_axis_get(PointerRNA *ptr);
void PreferencesInput_view_zoom_axis_set(PointerRNA *ptr, int value);

enum {
	PreferencesInput_view_zoom_method_CONTINUE = 0,
	PreferencesInput_view_zoom_method_DOLLY = 2,
	PreferencesInput_view_zoom_method_SCALE = 1,
};

int PreferencesInput_view_zoom_method_get(PointerRNA *ptr);
void PreferencesInput_view_zoom_method_set(PointerRNA *ptr, int value);

enum {
	PreferencesInput_ndof_zoom_direction_NDOF_ZOOM_FORWARD = 0,
	PreferencesInput_ndof_zoom_direction_NDOF_ZOOM_UP = 128,
};

int PreferencesInput_ndof_zoom_direction_get(PointerRNA *ptr);
void PreferencesInput_ndof_zoom_direction_set(PointerRNA *ptr, int value);

bool PreferencesInput_use_zoom_to_mouse_get(PointerRNA *ptr);
void PreferencesInput_use_zoom_to_mouse_set(PointerRNA *ptr, bool value);

/**************** Keymap ****************/

extern StructRNA RNA_PreferencesKeymap;

PointerRNA PreferencesKeymap_rna_type_get(PointerRNA *ptr);

#define PreferencesKeymap_active_keyconfig_MAX 64

void PreferencesKeymap_active_keyconfig_get(PointerRNA *ptr, char *value);
int PreferencesKeymap_active_keyconfig_length(PointerRNA *ptr);
void PreferencesKeymap_active_keyconfig_set(PointerRNA *ptr, const char *value);

bool PreferencesKeymap_show_ui_keyconfig_get(PointerRNA *ptr);
void PreferencesKeymap_show_ui_keyconfig_set(PointerRNA *ptr, bool value);

/**************** System & OpenGL ****************/

extern StructRNA RNA_PreferencesSystem;

PointerRNA PreferencesSystem_rna_type_get(PointerRNA *ptr);

bool PreferencesSystem_use_online_access_get(PointerRNA *ptr);
void PreferencesSystem_use_online_access_set(PointerRNA *ptr, bool value);

void PreferencesSystem_light_ambient_get(PointerRNA *ptr, float values[3]);
void PreferencesSystem_light_ambient_set(PointerRNA *ptr, const float values[3]);

enum {
	PreferencesSystem_anisotropic_filter_FILTER_0 = 1,
	PreferencesSystem_anisotropic_filter_FILTER_2 = 2,
	PreferencesSystem_anisotropic_filter_FILTER_4 = 4,
	PreferencesSystem_anisotropic_filter_FILTER_8 = 8,
	PreferencesSystem_anisotropic_filter_FILTER_16 = 16,
};

int PreferencesSystem_anisotropic_filter_get(PointerRNA *ptr);
void PreferencesSystem_anisotropic_filter_set(PointerRNA *ptr, int value);

enum {
	PreferencesSystem_audio_channels_MONO = 1,
	PreferencesSystem_audio_channels_STEREO = 2,
	PreferencesSystem_audio_channels_SURROUND4 = 4,
	PreferencesSystem_audio_channels_SURROUND51 = 6,
	PreferencesSystem_audio_channels_SURROUND71 = 8,
};

int PreferencesSystem_audio_channels_get(PointerRNA *ptr);
void PreferencesSystem_audio_channels_set(PointerRNA *ptr, int value);

enum {
	PreferencesSystem_audio_device_None = 0,
};

int PreferencesSystem_audio_device_get(PointerRNA *ptr);
void PreferencesSystem_audio_device_set(PointerRNA *ptr, int value);

enum {
	PreferencesSystem_audio_mixing_buffer_SAMPLES_256 = 256,
	PreferencesSystem_audio_mixing_buffer_SAMPLES_512 = 512,
	PreferencesSystem_audio_mixing_buffer_SAMPLES_1024 = 1024,
	PreferencesSystem_audio_mixing_buffer_SAMPLES_2048 = 2048,
	PreferencesSystem_audio_mixing_buffer_SAMPLES_4096 = 4096,
	PreferencesSystem_audio_mixing_buffer_SAMPLES_8192 = 8192,
	PreferencesSystem_audio_mixing_buffer_SAMPLES_16384 = 16384,
	PreferencesSystem_audio_mixing_buffer_SAMPLES_32768 = 32768,
};

int PreferencesSystem_audio_mixing_buffer_get(PointerRNA *ptr);
void PreferencesSystem_audio_mixing_buffer_set(PointerRNA *ptr, int value);

enum {
	PreferencesSystem_audio_sample_format_U8 = 1,
	PreferencesSystem_audio_sample_format_S16 = 18,
	PreferencesSystem_audio_sample_format_S24 = 19,
	PreferencesSystem_audio_sample_format_S32 = 20,
	PreferencesSystem_audio_sample_format_FLOAT = 36,
	PreferencesSystem_audio_sample_format_DOUBLE = 40,
};

int PreferencesSystem_audio_sample_format_get(PointerRNA *ptr);
void PreferencesSystem_audio_sample_format_set(PointerRNA *ptr, int value);

enum {
	PreferencesSystem_audio_sample_rate_RATE_44100 = 44100,
	PreferencesSystem_audio_sample_rate_RATE_48000 = 48000,
	PreferencesSystem_audio_sample_rate_RATE_96000 = 96000,
	PreferencesSystem_audio_sample_rate_RATE_192000 = 192000,
};

int PreferencesSystem_audio_sample_rate_get(PointerRNA *ptr);
void PreferencesSystem_audio_sample_rate_set(PointerRNA *ptr, int value);

float PreferencesSystem_gl_clip_alpha_get(PointerRNA *ptr);
void PreferencesSystem_gl_clip_alpha_set(PointerRNA *ptr, float value);

enum {
	PreferencesSystem_gpu_preferred_device_AUTO = 0,
};

int PreferencesSystem_gpu_preferred_device_get(PointerRNA *ptr);
void PreferencesSystem_gpu_preferred_device_set(PointerRNA *ptr, int value);

bool PreferencesSystem_use_edit_mode_smooth_wire_get(PointerRNA *ptr);
void PreferencesSystem_use_edit_mode_smooth_wire_set(PointerRNA *ptr, bool value);

bool PreferencesSystem_use_studio_light_edit_get(PointerRNA *ptr);
void PreferencesSystem_use_studio_light_edit_set(PointerRNA *ptr, bool value);

enum {
	PreferencesSystem_gl_texture_limit_CLAMP_OFF = 0,
	PreferencesSystem_gl_texture_limit_CLAMP_8192 = 8192,
	PreferencesSystem_gl_texture_limit_CLAMP_4096 = 4096,
	PreferencesSystem_gl_texture_limit_CLAMP_2048 = 2048,
	PreferencesSystem_gl_texture_limit_CLAMP_1024 = 1024,
	PreferencesSystem_gl_texture_limit_CLAMP_512 = 512,
	PreferencesSystem_gl_texture_limit_CLAMP_256 = 256,
	PreferencesSystem_gl_texture_limit_CLAMP_128 = 128,
};

int PreferencesSystem_gl_texture_limit_get(PointerRNA *ptr);
void PreferencesSystem_gl_texture_limit_set(PointerRNA *ptr, int value);

enum {
	PreferencesSystem_gpu_backend_OPENGL = 1,
	PreferencesSystem_gpu_backend_METAL = 2,
	PreferencesSystem_gpu_backend_VULKAN = 8,
};

int PreferencesSystem_gpu_backend_get(PointerRNA *ptr);
void PreferencesSystem_gpu_backend_set(PointerRNA *ptr, int value);

bool PreferencesSystem_use_select_pick_depth_get(PointerRNA *ptr);
void PreferencesSystem_use_select_pick_depth_set(PointerRNA *ptr, bool value);

bool PreferencesSystem_use_gpu_subdivision_get(PointerRNA *ptr);
void PreferencesSystem_use_gpu_subdivision_set(PointerRNA *ptr, bool value);

enum {
	PreferencesSystem_image_draw_method_AUTO = 0,
	PreferencesSystem_image_draw_method_2DTEXTURE = 2,
	PreferencesSystem_image_draw_method_GLSL = 1,
};

int PreferencesSystem_image_draw_method_get(PointerRNA *ptr);
void PreferencesSystem_image_draw_method_set(PointerRNA *ptr, int value);

bool PreferencesSystem_is_microsoft_store_install_get(PointerRNA *ptr);
void PreferencesSystem_is_microsoft_store_install_set(PointerRNA *ptr, bool value);

int PreferencesSystem_legacy_compute_device_type_get(PointerRNA *ptr);
void PreferencesSystem_legacy_compute_device_type_set(PointerRNA *ptr, int value);

int PreferencesSystem_memory_cache_limit_get(PointerRNA *ptr);
void PreferencesSystem_memory_cache_limit_set(PointerRNA *ptr, int value);

int PreferencesSystem_network_connection_limit_get(PointerRNA *ptr);
void PreferencesSystem_network_connection_limit_set(PointerRNA *ptr, int value);

int PreferencesSystem_network_timeout_get(PointerRNA *ptr);
void PreferencesSystem_network_timeout_set(PointerRNA *ptr, int value);

bool PreferencesSystem_use_overlay_smooth_wire_get(PointerRNA *ptr);
void PreferencesSystem_use_overlay_smooth_wire_set(PointerRNA *ptr, bool value);

enum {
	PreferencesSystem_sequencer_proxy_setup_MANUAL = 0,
	PreferencesSystem_sequencer_proxy_setup_AUTOMATIC = 1,
};

int PreferencesSystem_sequencer_proxy_setup_get(PointerRNA *ptr);
void PreferencesSystem_sequencer_proxy_setup_set(PointerRNA *ptr, int value);

bool PreferencesSystem_use_region_overlap_get(PointerRNA *ptr);
void PreferencesSystem_use_region_overlap_set(PointerRNA *ptr, bool value);

bool PreferencesSystem_register_all_users_get(PointerRNA *ptr);
void PreferencesSystem_register_all_users_set(PointerRNA *ptr, bool value);

int PreferencesSystem_scrollback_get(PointerRNA *ptr);
void PreferencesSystem_scrollback_set(PointerRNA *ptr, int value);

enum {
	PreferencesSystem_shader_compilation_method_THREAD = 0,
	PreferencesSystem_shader_compilation_method_SUBPROCESS = 1,
};

int PreferencesSystem_shader_compilation_method_get(PointerRNA *ptr);
void PreferencesSystem_shader_compilation_method_set(PointerRNA *ptr, int value);

int PreferencesSystem_gpu_shader_workers_get(PointerRNA *ptr);
void PreferencesSystem_gpu_shader_workers_set(PointerRNA *ptr, int value);

void PreferencesSystem_solid_lights_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void PreferencesSystem_solid_lights_next(CollectionPropertyIterator *iter);
void PreferencesSystem_solid_lights_end(CollectionPropertyIterator *iter);
int PreferencesSystem_solid_lights_length(PointerRNA *ptr);
bool PreferencesSystem_solid_lights_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

int PreferencesSystem_texture_collection_rate_get(PointerRNA *ptr);
void PreferencesSystem_texture_collection_rate_set(PointerRNA *ptr, int value);

int PreferencesSystem_texture_time_out_get(PointerRNA *ptr);
void PreferencesSystem_texture_time_out_set(PointerRNA *ptr, int value);

float PreferencesSystem_ui_line_width_get(PointerRNA *ptr);
void PreferencesSystem_ui_line_width_set(PointerRNA *ptr, float value);

float PreferencesSystem_ui_scale_get(PointerRNA *ptr);
void PreferencesSystem_ui_scale_set(PointerRNA *ptr, float value);

int PreferencesSystem_vbo_collection_rate_get(PointerRNA *ptr);
void PreferencesSystem_vbo_collection_rate_set(PointerRNA *ptr, int value);

int PreferencesSystem_vbo_time_out_get(PointerRNA *ptr);
void PreferencesSystem_vbo_time_out_set(PointerRNA *ptr, int value);

enum {
	PreferencesSystem_viewport_aa_OFF = 0,
	PreferencesSystem_viewport_aa_FXAA = 1,
	PreferencesSystem_viewport_aa_5 = 5,
	PreferencesSystem_viewport_aa_8 = 8,
	PreferencesSystem_viewport_aa_11 = 11,
	PreferencesSystem_viewport_aa_16 = 16,
	PreferencesSystem_viewport_aa_32 = 32,
};

int PreferencesSystem_viewport_aa_get(PointerRNA *ptr);
void PreferencesSystem_viewport_aa_set(PointerRNA *ptr, int value);

int PreferencesSystem_dpi_get(PointerRNA *ptr);
void PreferencesSystem_dpi_set(PointerRNA *ptr, int value);

float PreferencesSystem_pixel_size_get(PointerRNA *ptr);
void PreferencesSystem_pixel_size_set(PointerRNA *ptr, float value);

/**************** View & Controls ****************/

extern StructRNA RNA_PreferencesView;

PointerRNA PreferencesView_rna_type_get(PointerRNA *ptr);

int PreferencesView_view2d_grid_spacing_min_get(PointerRNA *ptr);
void PreferencesView_view2d_grid_spacing_min_set(PointerRNA *ptr, int value);

int PreferencesView_pie_animation_timeout_get(PointerRNA *ptr);
void PreferencesView_pie_animation_timeout_set(PointerRNA *ptr, int value);

int PreferencesView_border_width_get(PointerRNA *ptr);
void PreferencesView_border_width_set(PointerRNA *ptr, int value);

enum {
	PreferencesView_color_picker_type_CIRCLE_HSV = 0,
	PreferencesView_color_picker_type_CIRCLE_HSL = 4,
	PreferencesView_color_picker_type_SQUARE_SV = 1,
	PreferencesView_color_picker_type_SQUARE_HS = 2,
	PreferencesView_color_picker_type_SQUARE_HV = 3,
};

int PreferencesView_color_picker_type_get(PointerRNA *ptr);
void PreferencesView_color_picker_type_set(PointerRNA *ptr, int value);

int PreferencesView_pie_menu_confirm_get(PointerRNA *ptr);
void PreferencesView_pie_menu_confirm_set(PointerRNA *ptr, int value);

bool PreferencesView_show_developer_ui_get(PointerRNA *ptr);
void PreferencesView_show_developer_ui_set(PointerRNA *ptr, bool value);

bool PreferencesView_show_object_info_get(PointerRNA *ptr);
void PreferencesView_show_object_info_set(PointerRNA *ptr, bool value);

bool PreferencesView_show_playback_fps_get(PointerRNA *ptr);
void PreferencesView_show_playback_fps_set(PointerRNA *ptr, bool value);

bool PreferencesView_show_view_name_get(PointerRNA *ptr);
void PreferencesView_show_view_name_set(PointerRNA *ptr, bool value);

bool PreferencesView_use_fresnel_edit_get(PointerRNA *ptr);
void PreferencesView_use_fresnel_edit_set(PointerRNA *ptr, bool value);

bool PreferencesView_show_addons_enabled_only_get(PointerRNA *ptr);
void PreferencesView_show_addons_enabled_only_set(PointerRNA *ptr, bool value);

bool PreferencesView_show_extensions_updates_get(PointerRNA *ptr);
void PreferencesView_show_extensions_updates_set(PointerRNA *ptr, bool value);

int PreferencesView_playback_fps_samples_get(PointerRNA *ptr);
void PreferencesView_playback_fps_samples_set(PointerRNA *ptr, int value);

enum {
	PreferencesView_factor_display_type_FACTOR = 0,
	PreferencesView_factor_display_type_PERCENTAGE = 1,
};

int PreferencesView_factor_display_type_get(PointerRNA *ptr);
void PreferencesView_factor_display_type_set(PointerRNA *ptr, int value);

enum {
	PreferencesView_filebrowser_display_type_SCREEN = 0,
	PreferencesView_filebrowser_display_type_WINDOW = 1,
};

int PreferencesView_filebrowser_display_type_get(PointerRNA *ptr);
void PreferencesView_filebrowser_display_type_set(PointerRNA *ptr, int value);

bool PreferencesView_use_filter_brushes_by_tool_get(PointerRNA *ptr);
void PreferencesView_use_filter_brushes_by_tool_set(PointerRNA *ptr, bool value);

int PreferencesView_gizmo_size_get(PointerRNA *ptr);
void PreferencesView_gizmo_size_set(PointerRNA *ptr, int value);

bool PreferencesView_show_gizmo_get(PointerRNA *ptr);
void PreferencesView_show_gizmo_set(PointerRNA *ptr, bool value);

int PreferencesView_lookdev_sphere_size_get(PointerRNA *ptr);
void PreferencesView_lookdev_sphere_size_set(PointerRNA *ptr, int value);

enum {
	PreferencesView_header_align_NONE = 0,
	PreferencesView_header_align_TOP = 256,
	PreferencesView_header_align_BOTTOM = 384,
};

int PreferencesView_header_align_get(PointerRNA *ptr);
void PreferencesView_header_align_set(PointerRNA *ptr, int value);

#define PreferencesView_font_path_ui_MAX 1024

void PreferencesView_font_path_ui_get(PointerRNA *ptr, char *value);
int PreferencesView_font_path_ui_length(PointerRNA *ptr);
void PreferencesView_font_path_ui_set(PointerRNA *ptr, const char *value);

enum {
	PreferencesView_language_DEFAULT = 0,
};

int PreferencesView_language_get(PointerRNA *ptr);
void PreferencesView_language_set(PointerRNA *ptr, int value);

int PreferencesView_mini_axis_brightness_get(PointerRNA *ptr);
void PreferencesView_mini_axis_brightness_set(PointerRNA *ptr, int value);

int PreferencesView_mini_axis_size_get(PointerRNA *ptr);
void PreferencesView_mini_axis_size_set(PointerRNA *ptr, int value);

enum {
	PreferencesView_mini_axis_type_NONE = 2,
	PreferencesView_mini_axis_type_MINIMAL = 1,
	PreferencesView_mini_axis_type_GIZMO = 0,
};

int PreferencesView_mini_axis_type_get(PointerRNA *ptr);
void PreferencesView_mini_axis_type_set(PointerRNA *ptr, int value);

#define PreferencesView_font_path_ui_mono_MAX 1024

void PreferencesView_font_path_ui_mono_get(PointerRNA *ptr, char *value);
int PreferencesView_font_path_ui_mono_length(PointerRNA *ptr);
void PreferencesView_font_path_ui_mono_set(PointerRNA *ptr, const char *value);

int PreferencesView_gizmo_size_navigate_v3d_get(PointerRNA *ptr);
void PreferencesView_gizmo_size_navigate_v3d_set(PointerRNA *ptr, int value);

bool PreferencesView_show_navigate_ui_get(PointerRNA *ptr);
void PreferencesView_show_navigate_ui_set(PointerRNA *ptr, bool value);

bool PreferencesView_use_mouse_over_open_get(PointerRNA *ptr);
void PreferencesView_use_mouse_over_open_set(PointerRNA *ptr, bool value);

bool PreferencesView_show_tooltips_python_get(PointerRNA *ptr);
void PreferencesView_show_tooltips_python_set(PointerRNA *ptr, bool value);

int PreferencesView_pie_menu_radius_get(PointerRNA *ptr);
void PreferencesView_pie_menu_radius_set(PointerRNA *ptr, int value);

int PreferencesView_pie_initial_timeout_get(PointerRNA *ptr);
void PreferencesView_pie_initial_timeout_set(PointerRNA *ptr, int value);

enum {
	PreferencesView_render_display_type_NONE = 0,
	PreferencesView_render_display_type_SCREEN = 1,
	PreferencesView_render_display_type_AREA = 2,
	PreferencesView_render_display_type_WINDOW = 3,
};

int PreferencesView_render_display_type_get(PointerRNA *ptr);
void PreferencesView_render_display_type_set(PointerRNA *ptr, int value);

float PreferencesView_rotation_angle_get(PointerRNA *ptr);
void PreferencesView_rotation_angle_set(PointerRNA *ptr, float value);

bool PreferencesView_use_save_prompt_get(PointerRNA *ptr);
void PreferencesView_use_save_prompt_set(PointerRNA *ptr, bool value);

bool PreferencesView_show_statusbar_memory_get(PointerRNA *ptr);
void PreferencesView_show_statusbar_memory_set(PointerRNA *ptr, bool value);

bool PreferencesView_show_statusbar_scene_duration_get(PointerRNA *ptr);
void PreferencesView_show_statusbar_scene_duration_set(PointerRNA *ptr, bool value);

bool PreferencesView_show_splash_get(PointerRNA *ptr);
void PreferencesView_show_splash_set(PointerRNA *ptr, bool value);

bool PreferencesView_show_statusbar_stats_get(PointerRNA *ptr);
void PreferencesView_show_statusbar_stats_set(PointerRNA *ptr, bool value);

bool PreferencesView_show_statusbar_vram_get(PointerRNA *ptr);
void PreferencesView_show_statusbar_vram_set(PointerRNA *ptr, bool value);

bool PreferencesView_show_statusbar_version_get(PointerRNA *ptr);
void PreferencesView_show_statusbar_version_set(PointerRNA *ptr, bool value);

int PreferencesView_smooth_view_get(PointerRNA *ptr);
void PreferencesView_smooth_view_set(PointerRNA *ptr, int value);

int PreferencesView_open_sublevel_delay_get(PointerRNA *ptr);
void PreferencesView_open_sublevel_delay_set(PointerRNA *ptr, int value);

int PreferencesView_pie_tap_timeout_get(PointerRNA *ptr);
void PreferencesView_pie_tap_timeout_set(PointerRNA *ptr, int value);

bool PreferencesView_use_text_antialiasing_get(PointerRNA *ptr);
void PreferencesView_use_text_antialiasing_set(PointerRNA *ptr, bool value);

enum {
	PreferencesView_text_hinting_AUTO = 0,
	PreferencesView_text_hinting_NONE = 2,
	PreferencesView_text_hinting_SLIGHT = 4,
	PreferencesView_text_hinting_FULL = 8,
};

int PreferencesView_text_hinting_get(PointerRNA *ptr);
void PreferencesView_text_hinting_set(PointerRNA *ptr, int value);

bool PreferencesView_use_text_render_subpixelaa_get(PointerRNA *ptr);
void PreferencesView_use_text_render_subpixelaa_set(PointerRNA *ptr, bool value);

int PreferencesView_pie_menu_threshold_get(PointerRNA *ptr);
void PreferencesView_pie_menu_threshold_set(PointerRNA *ptr, int value);

enum {
	PreferencesView_timecode_style_MINIMAL = 0,
	PreferencesView_timecode_style_SMPTE = 2,
	PreferencesView_timecode_style_SMPTE_COMPACT = 1,
	PreferencesView_timecode_style_MILLISECONDS = 3,
	PreferencesView_timecode_style_SECONDS_ONLY = 4,
};

int PreferencesView_timecode_style_get(PointerRNA *ptr);
void PreferencesView_timecode_style_set(PointerRNA *ptr, int value);

bool PreferencesView_show_column_layout_get(PointerRNA *ptr);
void PreferencesView_show_column_layout_set(PointerRNA *ptr, bool value);

bool PreferencesView_show_tooltips_get(PointerRNA *ptr);
void PreferencesView_show_tooltips_set(PointerRNA *ptr, bool value);

int PreferencesView_open_toplevel_delay_get(PointerRNA *ptr);
void PreferencesView_open_toplevel_delay_set(PointerRNA *ptr, int value);

bool PreferencesView_use_translate_interface_get(PointerRNA *ptr);
void PreferencesView_use_translate_interface_set(PointerRNA *ptr, bool value);

bool PreferencesView_use_translate_new_dataname_get(PointerRNA *ptr);
void PreferencesView_use_translate_new_dataname_set(PointerRNA *ptr, bool value);

bool PreferencesView_use_translate_reports_get(PointerRNA *ptr);
void PreferencesView_use_translate_reports_set(PointerRNA *ptr, bool value);

bool PreferencesView_use_translate_tooltips_get(PointerRNA *ptr);
void PreferencesView_use_translate_tooltips_set(PointerRNA *ptr, bool value);

enum {
	PreferencesView_ui_line_width_THIN = -1,
	PreferencesView_ui_line_width_AUTO = 0,
	PreferencesView_ui_line_width_THICK = 1,
};

int PreferencesView_ui_line_width_get(PointerRNA *ptr);
void PreferencesView_ui_line_width_set(PointerRNA *ptr, int value);

float PreferencesView_ui_scale_get(PointerRNA *ptr);
void PreferencesView_ui_scale_set(PointerRNA *ptr, float value);

bool PreferencesView_use_weight_color_range_get(PointerRNA *ptr);
void PreferencesView_use_weight_color_range_set(PointerRNA *ptr, bool value);

PointerRNA PreferencesView_weight_color_range_get(PointerRNA *ptr);

int PreferencesView_view_frame_keyframes_get(PointerRNA *ptr);
void PreferencesView_view_frame_keyframes_set(PointerRNA *ptr, int value);

float PreferencesView_view_frame_seconds_get(PointerRNA *ptr);
void PreferencesView_view_frame_seconds_set(PointerRNA *ptr, float value);

enum {
	PreferencesView_view_frame_type_KEEP_RANGE = 0,
	PreferencesView_view_frame_type_SECONDS = 1,
	PreferencesView_view_frame_type_KEYFRAMES = 2,
};

int PreferencesView_view_frame_type_get(PointerRNA *ptr);
void PreferencesView_view_frame_type_set(PointerRNA *ptr, int value);

/**************** Primitive Boolean ****************/

extern StructRNA RNA_PrimitiveBoolean;

PointerRNA PrimitiveBoolean_rna_type_get(PointerRNA *ptr);

bool PrimitiveBoolean_value_get(PointerRNA *ptr);
void PrimitiveBoolean_value_set(PointerRNA *ptr, bool value);

/**************** Primitive Float ****************/

extern StructRNA RNA_PrimitiveFloat;

PointerRNA PrimitiveFloat_rna_type_get(PointerRNA *ptr);

float PrimitiveFloat_value_get(PointerRNA *ptr);
void PrimitiveFloat_value_set(PointerRNA *ptr, float value);

/**************** Primitive Int ****************/

extern StructRNA RNA_PrimitiveInt;

PointerRNA PrimitiveInt_rna_type_get(PointerRNA *ptr);

int PrimitiveInt_value_get(PointerRNA *ptr);
void PrimitiveInt_value_set(PointerRNA *ptr, int value);

/**************** String Value ****************/

extern StructRNA RNA_PrimitiveString;

PointerRNA PrimitiveString_rna_type_get(PointerRNA *ptr);

void PrimitiveString_value_get(PointerRNA *ptr, char *value);
int PrimitiveString_value_length(PointerRNA *ptr);
void PrimitiveString_value_set(PointerRNA *ptr, const char *value);

/**************** Property Definition ****************/

extern StructRNA RNA_Property;

PointerRNA Property_rna_type_get(PointerRNA *ptr);

void Property_name_get(PointerRNA *ptr, char *value);
int Property_name_length(PointerRNA *ptr);
void Property_name_set(PointerRNA *ptr, const char *value);

bool Property_is_animatable_get(PointerRNA *ptr);
void Property_is_animatable_set(PointerRNA *ptr, bool value);

PointerRNA Property_srna_get(PointerRNA *ptr);

void Property_description_get(PointerRNA *ptr, char *value);
int Property_description_length(PointerRNA *ptr);
void Property_description_set(PointerRNA *ptr, const char *value);

bool Property_is_enum_flag_get(PointerRNA *ptr);
void Property_is_enum_flag_set(PointerRNA *ptr, bool value);

bool Property_is_hidden_get(PointerRNA *ptr);
void Property_is_hidden_set(PointerRNA *ptr, bool value);

enum {
	Property_icon_NONE = 0,
	Property_icon_CHAR_NOTDEF = 1,
	Property_icon_CHAR_REPLACEMENT = 2,
	Property_icon_NOT_FOUND = 3,
	Property_icon_BLANK1 = 4,
	Property_icon_AUTOMERGE_OFF = 5,
	Property_icon_AUTOMERGE_ON = 6,
	Property_icon_CHECKBOX_DEHLT = 7,
	Property_icon_CHECKBOX_HLT = 8,
	Property_icon_CLIPUV_DEHLT = 9,
	Property_icon_CLIPUV_HLT = 10,
	Property_icon_DECORATE_UNLOCKED = 11,
	Property_icon_DECORATE_LOCKED = 12,
	Property_icon_FAKE_USER_OFF = 13,
	Property_icon_FAKE_USER_ON = 14,
	Property_icon_HIDE_ON = 15,
	Property_icon_HIDE_OFF = 16,
	Property_icon_INDIRECT_ONLY_OFF = 17,
	Property_icon_INDIRECT_ONLY_ON = 18,
	Property_icon_ONIONSKIN_OFF = 19,
	Property_icon_ONIONSKIN_ON = 20,
	Property_icon_UNPINNED = 21,
	Property_icon_PINNED = 22,
	Property_icon_RADIOBUT_OFF = 23,
	Property_icon_RADIOBUT_ON = 24,
	Property_icon_RECORD_OFF = 25,
	Property_icon_RECORD_ON = 26,
	Property_icon_RESTRICT_RENDER_ON = 27,
	Property_icon_RESTRICT_RENDER_OFF = 28,
	Property_icon_RESTRICT_SELECT_ON = 29,
	Property_icon_RESTRICT_SELECT_OFF = 30,
	Property_icon_RESTRICT_VIEW_ON = 31,
	Property_icon_RESTRICT_VIEW_OFF = 32,
	Property_icon_RIGHTARROW = 33,
	Property_icon_DOWNARROW_HLT = 34,
	Property_icon_SELECT_INTERSECT = 35,
	Property_icon_SELECT_DIFFERENCE = 36,
	Property_icon_SNAP_OFF = 37,
	Property_icon_SNAP_ON = 38,
	Property_icon_UNLOCKED = 39,
	Property_icon_LOCKED = 40,
	Property_icon_VIS_SEL_11 = 41,
	Property_icon_VIS_SEL_10 = 42,
	Property_icon_VIS_SEL_01 = 43,
	Property_icon_VIS_SEL_00 = 44,
	Property_icon_CANCEL = 45,
	Property_icon_ERROR = 46,
	Property_icon_QUESTION = 47,
	Property_icon_ADD = 48,
	Property_icon_ARROW_LEFTRIGHT = 49,
	Property_icon_AUTO = 50,
	Property_icon_BLENDER = 51,
	Property_icon_BORDERMOVE = 52,
	Property_icon_BRUSHES_ALL = 53,
	Property_icon_CHECKMARK = 54,
	Property_icon_COLLAPSEMENU = 55,
	Property_icon_COLLECTION_NEW = 56,
	Property_icon_COLOR = 57,
	Property_icon_COPY_ID = 58,
	Property_icon_DISCLOSURE_TRI_DOWN = 59,
	Property_icon_DISCLOSURE_TRI_RIGHT = 60,
	Property_icon_DOT = 61,
	Property_icon_DRIVER_DISTANCE = 62,
	Property_icon_DRIVER_ROTATIONAL_DIFFERENCE = 63,
	Property_icon_DRIVER_TRANSFORM = 64,
	Property_icon_DUPLICATE = 65,
	Property_icon_EYEDROPPER = 66,
	Property_icon_FCURVE_SNAPSHOT = 67,
	Property_icon_FILE_NEW = 68,
	Property_icon_FILE_TICK = 69,
	Property_icon_FREEZE = 70,
	Property_icon_FULLSCREEN_ENTER = 71,
	Property_icon_FULLSCREEN_EXIT = 72,
	Property_icon_GHOST_DISABLED = 73,
	Property_icon_GHOST_ENABLED = 74,
	Property_icon_GRIP = 75,
	Property_icon_GRIP_V = 76,
	Property_icon_HAND = 77,
	Property_icon_HELP = 78,
	Property_icon_LINKED = 79,
	Property_icon_MENU_PANEL = 80,
	Property_icon_NODE_SEL = 81,
	Property_icon_NODE = 82,
	Property_icon_OBJECT_HIDDEN = 83,
	Property_icon_OPTIONS = 84,
	Property_icon_PANEL_CLOSE = 85,
	Property_icon_PLUGIN = 86,
	Property_icon_PLUS = 87,
	Property_icon_PRESET_NEW = 88,
	Property_icon_QUIT = 89,
	Property_icon_RECOVER_LAST = 90,
	Property_icon_REMOVE = 91,
	Property_icon_RIGHTARROW_THIN = 92,
	Property_icon_SCREEN_BACK = 93,
	Property_icon_STATUSBAR = 94,
	Property_icon_STYLUS_PRESSURE = 95,
	Property_icon_THREE_DOTS = 96,
	Property_icon_TOPBAR = 97,
	Property_icon_TRASH = 98,
	Property_icon_TRIA_DOWN = 99,
	Property_icon_TRIA_LEFT = 100,
	Property_icon_TRIA_RIGHT = 101,
	Property_icon_TRIA_UP = 102,
	Property_icon_UNLINKED = 103,
	Property_icon_URL = 104,
	Property_icon_VIEWZOOM = 105,
	Property_icon_WINDOW = 106,
	Property_icon_WORKSPACE = 107,
	Property_icon_X = 108,
	Property_icon_ZOOM_ALL = 109,
	Property_icon_ZOOM_IN = 110,
	Property_icon_ZOOM_OUT = 111,
	Property_icon_ZOOM_PREVIOUS = 112,
	Property_icon_ZOOM_SELECTED = 113,
	Property_icon_MODIFIER = 114,
	Property_icon_PARTICLES = 115,
	Property_icon_PHYSICS = 116,
	Property_icon_SHADERFX = 117,
	Property_icon_SPEAKER = 118,
	Property_icon_OUTPUT = 119,
	Property_icon_SCENE = 120,
	Property_icon_TOOL_SETTINGS = 121,
	Property_icon_LIGHT = 122,
	Property_icon_MATERIAL = 123,
	Property_icon_TEXTURE = 124,
	Property_icon_WORLD = 125,
	Property_icon_ANIM = 126,
	Property_icon_SCRIPT = 127,
	Property_icon_GEOMETRY_NODES = 128,
	Property_icon_TEXT = 129,
	Property_icon_ACTION = 130,
	Property_icon_ASSET_MANAGER = 131,
	Property_icon_CONSOLE = 132,
	Property_icon_FILEBROWSER = 133,
	Property_icon_GEOMETRY_SET = 134,
	Property_icon_GRAPH = 135,
	Property_icon_IMAGE = 136,
	Property_icon_INFO = 137,
	Property_icon_NLA = 138,
	Property_icon_NODE_COMPOSITING = 139,
	Property_icon_NODE_MATERIAL = 140,
	Property_icon_NODE_TEXTURE = 141,
	Property_icon_NODETREE = 142,
	Property_icon_OUTLINER = 143,
	Property_icon_PREFERENCES = 144,
	Property_icon_PROPERTIES = 145,
	Property_icon_SEQUENCE = 146,
	Property_icon_SOUND = 147,
	Property_icon_SPREADSHEET = 148,
	Property_icon_TIME = 149,
	Property_icon_TRACKER = 150,
	Property_icon_UV = 151,
	Property_icon_VIEW3D = 152,
	Property_icon_EDITMODE_HLT = 153,
	Property_icon_OBJECT_DATAMODE = 154,
	Property_icon_PARTICLEMODE = 155,
	Property_icon_POSE_HLT = 156,
	Property_icon_SCULPTMODE_HLT = 157,
	Property_icon_TPAINT_HLT = 158,
	Property_icon_UV_DATA = 159,
	Property_icon_VPAINT_HLT = 160,
	Property_icon_WPAINT_HLT = 161,
	Property_icon_TRACKER_DATA = 162,
	Property_icon_TRACKING_BACKWARDS_SINGLE = 163,
	Property_icon_TRACKING_BACKWARDS = 164,
	Property_icon_TRACKING_CLEAR_BACKWARDS = 165,
	Property_icon_TRACKING_CLEAR_FORWARDS = 166,
	Property_icon_TRACKING_FORWARDS_SINGLE = 167,
	Property_icon_TRACKING_FORWARDS = 168,
	Property_icon_TRACKING_REFINE_BACKWARDS = 169,
	Property_icon_TRACKING_REFINE_FORWARDS = 170,
	Property_icon_TRACKING = 171,
	Property_icon_GROUP = 172,
	Property_icon_CONSTRAINT_BONE = 173,
	Property_icon_CONSTRAINT = 174,
	Property_icon_ARMATURE_DATA = 175,
	Property_icon_BONE_DATA = 176,
	Property_icon_CAMERA_DATA = 177,
	Property_icon_CURVE_DATA = 178,
	Property_icon_EMPTY_DATA = 179,
	Property_icon_FONT_DATA = 180,
	Property_icon_LATTICE_DATA = 181,
	Property_icon_LIGHT_DATA = 182,
	Property_icon_MESH_DATA = 183,
	Property_icon_META_DATA = 184,
	Property_icon_PARTICLE_DATA = 185,
	Property_icon_SHAPEKEY_DATA = 186,
	Property_icon_SURFACE_DATA = 187,
	Property_icon_OBJECT_DATA = 188,
	Property_icon_RENDER_RESULT = 189,
	Property_icon_RENDERLAYERS = 190,
	Property_icon_SCENE_DATA = 191,
	Property_icon_BRUSH_DATA = 192,
	Property_icon_IMAGE_DATA = 193,
	Property_icon_LINE_DATA = 194,
	Property_icon_MATERIAL_DATA = 195,
	Property_icon_TEXTURE_DATA = 196,
	Property_icon_WORLD_DATA = 197,
	Property_icon_ANIM_DATA = 198,
	Property_icon_BOIDS = 199,
	Property_icon_CAMERA_STEREO = 200,
	Property_icon_COMMUNITY = 201,
	Property_icon_FACE_MAPS = 202,
	Property_icon_FCURVE = 203,
	Property_icon_FILE = 204,
	Property_icon_GREASEPENCIL = 205,
	Property_icon_GREASEPENCIL_LAYER_GROUP = 206,
	Property_icon_GROUP_BONE = 207,
	Property_icon_GROUP_UVS = 208,
	Property_icon_GROUP_VCOL = 209,
	Property_icon_GROUP_VERTEX = 210,
	Property_icon_LIBRARY_DATA_BROKEN = 211,
	Property_icon_LIBRARY_DATA_DIRECT = 212,
	Property_icon_LIBRARY_DATA_OVERRIDE = 213,
	Property_icon_ORPHAN_DATA = 214,
	Property_icon_PACKAGE = 215,
	Property_icon_PRESET = 216,
	Property_icon_RENDER_ANIMATION = 217,
	Property_icon_RENDER_STILL = 218,
	Property_icon_RNA_ADD = 219,
	Property_icon_RNA = 220,
	Property_icon_STRANDS = 221,
	Property_icon_UGLYPACKAGE = 222,
	Property_icon_MOUSE_LMB = 223,
	Property_icon_MOUSE_MMB = 224,
	Property_icon_MOUSE_RMB = 225,
	Property_icon_MOUSE_MMB_SCROLL = 226,
	Property_icon_MOUSE_LMB_2X = 227,
	Property_icon_MOUSE_MOVE = 228,
	Property_icon_MOUSE_LMB_DRAG = 229,
	Property_icon_MOUSE_MMB_DRAG = 230,
	Property_icon_MOUSE_RMB_DRAG = 231,
	Property_icon_DECORATE_ANIMATE = 232,
	Property_icon_DECORATE_DRIVER = 233,
	Property_icon_DECORATE_KEYFRAME = 234,
	Property_icon_DECORATE_LIBRARY_OVERRIDE = 235,
	Property_icon_DECORATE_LINKED = 236,
	Property_icon_DECORATE_OVERRIDE = 237,
	Property_icon_DECORATE = 238,
	Property_icon_OUTLINER_COLLECTION = 239,
	Property_icon_CURVES_DATA = 240,
	Property_icon_OUTLINER_DATA_ARMATURE = 241,
	Property_icon_OUTLINER_DATA_CAMERA = 242,
	Property_icon_OUTLINER_DATA_CURVE = 243,
	Property_icon_OUTLINER_DATA_CURVES = 244,
	Property_icon_OUTLINER_DATA_EMPTY = 245,
	Property_icon_OUTLINER_DATA_FONT = 246,
	Property_icon_OUTLINER_DATA_GP_LAYER = 247,
	Property_icon_OUTLINER_DATA_GREASEPENCIL = 248,
	Property_icon_OUTLINER_DATA_LATTICE = 249,
	Property_icon_OUTLINER_DATA_LIGHT = 250,
	Property_icon_OUTLINER_DATA_LIGHTPROBE = 251,
	Property_icon_OUTLINER_DATA_MESH = 252,
	Property_icon_OUTLINER_DATA_META = 253,
	Property_icon_OUTLINER_DATA_POINTCLOUD = 254,
	Property_icon_OUTLINER_DATA_SPEAKER = 255,
	Property_icon_OUTLINER_DATA_SURFACE = 256,
	Property_icon_OUTLINER_DATA_VOLUME = 257,
	Property_icon_POINTCLOUD_DATA = 258,
	Property_icon_POINTCLOUD_POINT = 259,
	Property_icon_VOLUME_DATA = 260,
	Property_icon_OUTLINER_OB_ARMATURE = 261,
	Property_icon_OUTLINER_OB_CAMERA = 262,
	Property_icon_OUTLINER_OB_CURVE = 263,
	Property_icon_OUTLINER_OB_CURVES = 264,
	Property_icon_OUTLINER_OB_EMPTY = 265,
	Property_icon_OUTLINER_OB_FONT = 266,
	Property_icon_OUTLINER_OB_FORCE_FIELD = 267,
	Property_icon_OUTLINER_OB_GREASEPENCIL = 268,
	Property_icon_OUTLINER_OB_GROUP_INSTANCE = 269,
	Property_icon_OUTLINER_OB_IMAGE = 270,
	Property_icon_OUTLINER_OB_LATTICE = 271,
	Property_icon_OUTLINER_OB_LIGHT = 272,
	Property_icon_OUTLINER_OB_LIGHTPROBE = 273,
	Property_icon_OUTLINER_OB_MESH = 274,
	Property_icon_OUTLINER_OB_META = 275,
	Property_icon_OUTLINER_OB_POINTCLOUD = 276,
	Property_icon_OUTLINER_OB_SPEAKER = 277,
	Property_icon_OUTLINER_OB_SURFACE = 278,
	Property_icon_OUTLINER_OB_VOLUME = 279,
	Property_icon_GP_MULTIFRAME_EDITING = 280,
	Property_icon_GP_ONLY_SELECTED = 281,
	Property_icon_GP_SELECT_BETWEEN_STROKES = 282,
	Property_icon_GP_SELECT_POINTS = 283,
	Property_icon_GP_SELECT_STROKES = 284,
	Property_icon_HOLDOUT_OFF = 285,
	Property_icon_HOLDOUT_ON = 286,
	Property_icon_MODIFIER_OFF = 287,
	Property_icon_MODIFIER_ON = 288,
	Property_icon_RESTRICT_COLOR_OFF = 289,
	Property_icon_RESTRICT_COLOR_ON = 290,
	Property_icon_RESTRICT_INSTANCED_OFF = 291,
	Property_icon_RESTRICT_INSTANCED_ON = 292,
	Property_icon_LIGHT_AREA = 293,
	Property_icon_LIGHT_HEMI = 294,
	Property_icon_LIGHT_POINT = 295,
	Property_icon_LIGHT_SPOT = 296,
	Property_icon_LIGHT_SUN = 297,
	Property_icon_LIGHTPROBE_PLANE = 298,
	Property_icon_LIGHTPROBE_SPHERE = 299,
	Property_icon_LIGHTPROBE_VOLUME = 300,
	Property_icon_COLOR_BLUE = 301,
	Property_icon_COLOR_GREEN = 302,
	Property_icon_COLOR_RED = 303,
	Property_icon_CONE = 304,
	Property_icon_CUBE = 305,
	Property_icon_CURVE_BEZCIRCLE = 306,
	Property_icon_CURVE_BEZCURVE = 307,
	Property_icon_CURVE_NCIRCLE = 308,
	Property_icon_CURVE_NCURVE = 309,
	Property_icon_CURVE_PATH = 310,
	Property_icon_CURVES = 311,
	Property_icon_EMPTY_ARROWS = 312,
	Property_icon_EMPTY_AXIS = 313,
	Property_icon_EMPTY_SINGLE_ARROW = 314,
	Property_icon_MESH_CAPSULE = 315,
	Property_icon_MESH_CIRCLE = 316,
	Property_icon_MESH_CONE = 317,
	Property_icon_MESH_CUBE = 318,
	Property_icon_MESH_CYLINDER = 319,
	Property_icon_MESH_GRID = 320,
	Property_icon_MESH_ICOSPHERE = 321,
	Property_icon_MESH_MONKEY = 322,
	Property_icon_MESH_PLANE = 323,
	Property_icon_MESH_TORUS = 324,
	Property_icon_MESH_UVSPHERE = 325,
	Property_icon_META_BALL = 326,
	Property_icon_META_CAPSULE = 327,
	Property_icon_META_CUBE = 328,
	Property_icon_META_ELLIPSOID = 329,
	Property_icon_META_PLANE = 330,
	Property_icon_MONKEY = 331,
	Property_icon_SPHERE = 332,
	Property_icon_STROKE = 333,
	Property_icon_SURFACE_NCIRCLE = 334,
	Property_icon_SURFACE_NCURVE = 335,
	Property_icon_SURFACE_NCYLINDER = 336,
	Property_icon_SURFACE_NSPHERE = 337,
	Property_icon_SURFACE_NSURFACE = 338,
	Property_icon_SURFACE_NTORUS = 339,
	Property_icon_TRIA_DOWN_BAR = 340,
	Property_icon_TRIA_LEFT_BAR = 341,
	Property_icon_TRIA_RIGHT_BAR = 342,
	Property_icon_TRIA_UP_BAR = 343,
	Property_icon_AREA_DOCK = 344,
	Property_icon_AREA_JOIN_DOWN = 345,
	Property_icon_AREA_JOIN_LEFT = 346,
	Property_icon_AREA_JOIN_UP = 347,
	Property_icon_AREA_JOIN = 348,
	Property_icon_AREA_SWAP = 349,
	Property_icon_FORCE_BOID = 350,
	Property_icon_FORCE_CHARGE = 351,
	Property_icon_FORCE_CURVE = 352,
	Property_icon_FORCE_DRAG = 353,
	Property_icon_FORCE_FLUIDFLOW = 354,
	Property_icon_FORCE_FORCE = 355,
	Property_icon_FORCE_HARMONIC = 356,
	Property_icon_FORCE_LENNARDJONES = 357,
	Property_icon_FORCE_MAGNETIC = 358,
	Property_icon_FORCE_TEXTURE = 359,
	Property_icon_FORCE_TURBULENCE = 360,
	Property_icon_FORCE_VORTEX = 361,
	Property_icon_FORCE_WIND = 362,
	Property_icon_IMAGE_BACKGROUND = 363,
	Property_icon_IMAGE_PLANE = 364,
	Property_icon_IMAGE_REFERENCE = 365,
	Property_icon_RIGID_BODY_CONSTRAINT = 366,
	Property_icon_RIGID_BODY = 367,
	Property_icon_SPLIT_HORIZONTAL = 368,
	Property_icon_SPLIT_VERTICAL = 369,
	Property_icon_ANCHOR_BOTTOM = 370,
	Property_icon_ANCHOR_CENTER = 371,
	Property_icon_ANCHOR_LEFT = 372,
	Property_icon_ANCHOR_RIGHT = 373,
	Property_icon_ANCHOR_TOP = 374,
	Property_icon_NODE_CORNER = 375,
	Property_icon_NODE_INSERT_OFF = 376,
	Property_icon_NODE_INSERT_ON = 377,
	Property_icon_NODE_SIDE = 378,
	Property_icon_NODE_TOP = 379,
	Property_icon_SELECT_EXTEND = 380,
	Property_icon_SELECT_SET = 381,
	Property_icon_SELECT_SUBTRACT = 382,
	Property_icon_ALIGN_BOTTOM = 383,
	Property_icon_ALIGN_CENTER = 384,
	Property_icon_ALIGN_FLUSH = 385,
	Property_icon_ALIGN_JUSTIFY = 386,
	Property_icon_ALIGN_LEFT = 387,
	Property_icon_ALIGN_MIDDLE = 388,
	Property_icon_ALIGN_RIGHT = 389,
	Property_icon_ALIGN_TOP = 390,
	Property_icon_BOLD = 391,
	Property_icon_ITALIC = 392,
	Property_icon_LINENUMBERS_OFF = 393,
	Property_icon_LINENUMBERS_ON = 394,
	Property_icon_SCRIPTPLUGINS = 395,
	Property_icon_SMALL_CAPS = 396,
	Property_icon_SYNTAX_OFF = 397,
	Property_icon_SYNTAX_ON = 398,
	Property_icon_UNDERLINE = 399,
	Property_icon_WORDWRAP_OFF = 400,
	Property_icon_WORDWRAP_ON = 401,
	Property_icon_CON_ACTION = 402,
	Property_icon_CON_ARMATURE = 403,
	Property_icon_CON_CAMERASOLVER = 404,
	Property_icon_CON_CHILDOF = 405,
	Property_icon_CON_CLAMPTO = 406,
	Property_icon_CON_DISTLIMIT = 407,
	Property_icon_CON_FLOOR = 408,
	Property_icon_CON_FOLLOWPATH = 409,
	Property_icon_CON_FOLLOWTRACK = 410,
	Property_icon_CON_KINEMATIC = 411,
	Property_icon_CON_LOCKTRACK = 412,
	Property_icon_CON_LOCLIKE = 413,
	Property_icon_CON_LOCLIMIT = 414,
	Property_icon_CON_OBJECTSOLVER = 415,
	Property_icon_CON_PIVOT = 416,
	Property_icon_CON_ROTLIKE = 417,
	Property_icon_CON_ROTLIMIT = 418,
	Property_icon_CON_SAMEVOL = 419,
	Property_icon_CON_SHRINKWRAP = 420,
	Property_icon_CON_SIZELIKE = 421,
	Property_icon_CON_SIZELIMIT = 422,
	Property_icon_CON_SPLINEIK = 423,
	Property_icon_CON_STRETCHTO = 424,
	Property_icon_CON_TRACKTO = 425,
	Property_icon_CON_TRANSFORM_CACHE = 426,
	Property_icon_CON_TRANSFORM = 427,
	Property_icon_CON_TRANSLIKE = 428,
	Property_icon_HOOK = 429,
	Property_icon_MOD_ARMATURE = 430,
	Property_icon_MOD_ARRAY = 431,
	Property_icon_MOD_BEVEL = 432,
	Property_icon_MOD_BOOLEAN = 433,
	Property_icon_MOD_BUILD = 434,
	Property_icon_MOD_CAST = 435,
	Property_icon_MOD_CLOTH = 436,
	Property_icon_MOD_CURVE = 437,
	Property_icon_MOD_DASH = 438,
	Property_icon_MOD_DATA_TRANSFER = 439,
	Property_icon_MOD_DECIM = 440,
	Property_icon_MOD_DISPLACE = 441,
	Property_icon_MOD_DYNAMICPAINT = 442,
	Property_icon_MOD_EDGESPLIT = 443,
	Property_icon_MOD_ENVELOPE = 444,
	Property_icon_MOD_EXPLODE = 445,
	Property_icon_MOD_FLUID = 446,
	Property_icon_MOD_FLUIDSIM = 447,
	Property_icon_MOD_HUE_SATURATION = 448,
	Property_icon_MOD_INSTANCE = 449,
	Property_icon_MOD_LATTICE = 450,
	Property_icon_MOD_LENGTH = 451,
	Property_icon_MOD_LINEART = 452,
	Property_icon_MOD_MASK = 453,
	Property_icon_MOD_MESHDEFORM = 454,
	Property_icon_MOD_MIRROR = 455,
	Property_icon_MOD_MULTIRES = 456,
	Property_icon_MOD_NOISE = 457,
	Property_icon_MOD_NORMALEDIT = 458,
	Property_icon_MOD_OCEAN = 459,
	Property_icon_MOD_OFFSET = 460,
	Property_icon_MOD_OPACITY = 461,
	Property_icon_MOD_OUTLINE = 462,
	Property_icon_MOD_PARTICLE_INSTANCE = 463,
	Property_icon_MOD_PARTICLES = 464,
	Property_icon_MOD_PHYSICS = 465,
	Property_icon_MOD_REMESH = 466,
	Property_icon_MOD_SCREW = 467,
	Property_icon_MOD_SHRINKWRAP = 468,
	Property_icon_MOD_SIMPLEDEFORM = 469,
	Property_icon_MOD_SIMPLIFY = 470,
	Property_icon_MOD_SKIN = 471,
	Property_icon_MOD_SMOOTH = 472,
	Property_icon_MOD_SOFT = 473,
	Property_icon_MOD_SOLIDIFY = 474,
	Property_icon_MOD_SUBSURF = 475,
	Property_icon_MOD_THICKNESS = 476,
	Property_icon_MOD_TIME = 477,
	Property_icon_MOD_TINT = 478,
	Property_icon_MOD_TRIANGULATE = 479,
	Property_icon_MOD_UVPROJECT = 480,
	Property_icon_MOD_VERTEX_WEIGHT = 481,
	Property_icon_MOD_WARP = 482,
	Property_icon_MOD_WAVE = 483,
	Property_icon_MOD_WIREFRAME = 484,
	Property_icon_MODIFIER_DATA = 485,
	Property_icon_ACTION_SLOT = 486,
	Property_icon_ACTION_TWEAK = 487,
	Property_icon_DRIVER = 488,
	Property_icon_FF = 489,
	Property_icon_FRAME_NEXT = 490,
	Property_icon_FRAME_PREV = 491,
	Property_icon_HANDLE_ALIGNED = 492,
	Property_icon_HANDLE_AUTO = 493,
	Property_icon_HANDLE_AUTOCLAMPED = 494,
	Property_icon_HANDLE_FREE = 495,
	Property_icon_HANDLE_VECTOR = 496,
	Property_icon_IPO_BACK = 497,
	Property_icon_IPO_BEZIER = 498,
	Property_icon_IPO_BOUNCE = 499,
	Property_icon_IPO_CIRC = 500,
	Property_icon_IPO_CONSTANT = 501,
	Property_icon_IPO_CUBIC = 502,
	Property_icon_IPO_EASE_IN_OUT = 503,
	Property_icon_IPO_EASE_IN = 504,
	Property_icon_IPO_EASE_OUT = 505,
	Property_icon_IPO_ELASTIC = 506,
	Property_icon_IPO_EXPO = 507,
	Property_icon_IPO_LINEAR = 508,
	Property_icon_IPO_QUAD = 509,
	Property_icon_IPO_QUART = 510,
	Property_icon_IPO_QUINT = 511,
	Property_icon_IPO_SINE = 512,
	Property_icon_KEY_DEHLT = 513,
	Property_icon_KEY_HLT = 514,
	Property_icon_KEYFRAME_HLT = 515,
	Property_icon_KEYFRAME = 516,
	Property_icon_KEYINGSET = 517,
	Property_icon_MARKER_HLT = 518,
	Property_icon_MARKER = 519,
	Property_icon_MUTE_IPO_OFF = 520,
	Property_icon_MUTE_IPO_ON = 521,
	Property_icon_NEXT_KEYFRAME = 522,
	Property_icon_NLA_PUSHDOWN = 523,
	Property_icon_NORMALIZE_FCURVES = 524,
	Property_icon_ORIENTATION_PARENT = 525,
	Property_icon_PAUSE = 526,
	Property_icon_PLAY_REVERSE = 527,
	Property_icon_PLAY_SOUND = 528,
	Property_icon_PLAY = 529,
	Property_icon_PMARKER_ACT = 530,
	Property_icon_PMARKER_SEL = 531,
	Property_icon_PMARKER = 532,
	Property_icon_PREV_KEYFRAME = 533,
	Property_icon_PREVIEW_RANGE = 534,
	Property_icon_REC = 535,
	Property_icon_REW = 536,
	Property_icon_SOLO_OFF = 537,
	Property_icon_SOLO_ON = 538,
	Property_icon_CENTER_ONLY = 539,
	Property_icon_CURSOR = 540,
	Property_icon_EDGESEL = 541,
	Property_icon_FACE_CORNER = 542,
	Property_icon_FACESEL = 543,
	Property_icon_INVERSESQUARECURVE = 544,
	Property_icon_LINCURVE = 545,
	Property_icon_NOCURVE = 546,
	Property_icon_PARTICLE_PATH = 547,
	Property_icon_PARTICLE_POINT = 548,
	Property_icon_PARTICLE_TIP = 549,
	Property_icon_PIVOT_ACTIVE = 550,
	Property_icon_PIVOT_BOUNDBOX = 551,
	Property_icon_PIVOT_CURSOR = 552,
	Property_icon_PIVOT_INDIVIDUAL = 553,
	Property_icon_PIVOT_MEDIAN = 554,
	Property_icon_PROP_CON = 555,
	Property_icon_PROP_OFF = 556,
	Property_icon_PROP_ON = 557,
	Property_icon_PROP_PROJECTED = 558,
	Property_icon_RNDCURVE = 559,
	Property_icon_ROOTCURVE = 560,
	Property_icon_SHARPCURVE = 561,
	Property_icon_SMOOTHCURVE = 562,
	Property_icon_SPHERECURVE = 563,
	Property_icon_VERTEXSEL = 564,
	Property_icon_SNAP_EDGE = 565,
	Property_icon_SNAP_FACE_CENTER = 566,
	Property_icon_SNAP_FACE_NEAREST = 567,
	Property_icon_SNAP_FACE = 568,
	Property_icon_SNAP_GRID = 569,
	Property_icon_SNAP_INCREMENT = 570,
	Property_icon_SNAP_MIDPOINT = 571,
	Property_icon_SNAP_NORMAL = 572,
	Property_icon_SNAP_PEEL_OBJECT = 573,
	Property_icon_SNAP_PERPENDICULAR = 574,
	Property_icon_SNAP_VERTEX = 575,
	Property_icon_SNAP_VOLUME = 576,
	Property_icon_STICKY_UVS_DISABLE = 577,
	Property_icon_STICKY_UVS_LOC = 578,
	Property_icon_STICKY_UVS_VERT = 579,
	Property_icon_ORIENTATION_GIMBAL = 580,
	Property_icon_ORIENTATION_GLOBAL = 581,
	Property_icon_ORIENTATION_LOCAL = 582,
	Property_icon_ORIENTATION_NORMAL = 583,
	Property_icon_ORIENTATION_VIEW = 584,
	Property_icon_COPYDOWN = 585,
	Property_icon_FIXED_SIZE = 586,
	Property_icon_GIZMO = 587,
	Property_icon_GP_CAPS_FLAT = 588,
	Property_icon_GP_CAPS_ROUND = 589,
	Property_icon_NORMALS_FACE = 590,
	Property_icon_NORMALS_VERTEX_FACE = 591,
	Property_icon_NORMALS_VERTEX = 592,
	Property_icon_OBJECT_ORIGIN = 593,
	Property_icon_ORIENTATION_CURSOR = 594,
	Property_icon_PASTEDOWN = 595,
	Property_icon_PASTEFLIPDOWN = 596,
	Property_icon_PASTEFLIPUP = 597,
	Property_icon_TRANSFORM_ORIGINS = 598,
	Property_icon_UV_EDGESEL = 599,
	Property_icon_UV_FACESEL = 600,
	Property_icon_UV_ISLANDSEL = 601,
	Property_icon_UV_SYNC_SELECT = 602,
	Property_icon_UV_VERTEXSEL = 603,
	Property_icon_AXIS_FRONT = 604,
	Property_icon_AXIS_SIDE = 605,
	Property_icon_AXIS_TOP = 606,
	Property_icon_GRID = 607,
	Property_icon_LAYER_ACTIVE = 608,
	Property_icon_LAYER_USED = 609,
	Property_icon_LOCKVIEW_OFF = 610,
	Property_icon_LOCKVIEW_ON = 611,
	Property_icon_OVERLAY = 612,
	Property_icon_SHADING_BBOX = 613,
	Property_icon_SHADING_RENDERED = 614,
	Property_icon_SHADING_SOLID = 615,
	Property_icon_SHADING_TEXTURE = 616,
	Property_icon_SHADING_WIRE = 617,
	Property_icon_XRAY = 618,
	Property_icon_VIEW_CAMERA_UNSELECTED = 619,
	Property_icon_VIEW_CAMERA = 620,
	Property_icon_VIEW_LOCKED = 621,
	Property_icon_VIEW_ORTHO = 622,
	Property_icon_VIEW_PAN = 623,
	Property_icon_VIEW_PERSPECTIVE = 624,
	Property_icon_VIEW_UNLOCKED = 625,
	Property_icon_VIEW_ZOOM = 626,
	Property_icon_FILE_ALIAS = 627,
	Property_icon_FILE_FOLDER = 628,
	Property_icon_FOLDER_REDIRECT = 629,
	Property_icon_APPEND_BLEND = 630,
	Property_icon_BACK = 631,
	Property_icon_BOOKMARKS = 632,
	Property_icon_CURRENT_FILE = 633,
	Property_icon_DESKTOP = 634,
	Property_icon_DISC = 635,
	Property_icon_DISK_DRIVE = 636,
	Property_icon_DOCUMENTS = 637,
	Property_icon_EXPORT = 638,
	Property_icon_EXTERNAL_DRIVE = 639,
	Property_icon_FILE_3D = 640,
	Property_icon_FILE_ARCHIVE = 641,
	Property_icon_FILE_BACKUP = 642,
	Property_icon_FILE_BLANK = 643,
	Property_icon_FILE_BLEND = 644,
	Property_icon_FILE_CACHE = 645,
	Property_icon_FILE_FONT = 646,
	Property_icon_FILE_HIDDEN = 647,
	Property_icon_FILE_IMAGE = 648,
	Property_icon_FILE_MOVIE = 649,
	Property_icon_FILE_PARENT = 650,
	Property_icon_FILE_REFRESH = 651,
	Property_icon_FILE_SCRIPT = 652,
	Property_icon_FILE_SOUND = 653,
	Property_icon_FILE_TEXT = 654,
	Property_icon_FILE_VOLUME = 655,
	Property_icon_FILTER = 656,
	Property_icon_FONTPREVIEW = 657,
	Property_icon_FORWARD = 658,
	Property_icon_HOME = 659,
	Property_icon_IMGDISPLAY = 660,
	Property_icon_IMPORT = 661,
	Property_icon_LINK_BLEND = 662,
	Property_icon_LONGDISPLAY = 663,
	Property_icon_LOOP_BACK = 664,
	Property_icon_LOOP_FORWARDS = 665,
	Property_icon_NETWORK_DRIVE = 666,
	Property_icon_NEWFOLDER = 667,
	Property_icon_PREVIEW_LOADING = 668,
	Property_icon_SETTINGS = 669,
	Property_icon_SHORTDISPLAY = 670,
	Property_icon_SORT_ASC = 671,
	Property_icon_SORT_DESC = 672,
	Property_icon_SORTALPHA = 673,
	Property_icon_SORTBYEXT = 674,
	Property_icon_SORTSIZE = 675,
	Property_icon_SORTTIME = 676,
	Property_icon_SYSTEM = 677,
	Property_icon_TAG = 678,
	Property_icon_TEMP = 679,
	Property_icon_ALIASED = 680,
	Property_icon_ANTIALIASED = 681,
	Property_icon_MAT_SPHERE_SKY = 682,
	Property_icon_MATCLOTH = 683,
	Property_icon_MATCUBE = 684,
	Property_icon_MATFLUID = 685,
	Property_icon_MATPLANE = 686,
	Property_icon_MATSHADERBALL = 687,
	Property_icon_MATSPHERE = 688,
	Property_icon_SEQ_CHROMA_SCOPE = 689,
	Property_icon_SEQ_HISTOGRAM = 690,
	Property_icon_SEQ_LUMA_WAVEFORM = 691,
	Property_icon_SEQ_PREVIEW = 692,
	Property_icon_SEQ_SEQUENCER = 693,
	Property_icon_SEQ_SPLITVIEW = 694,
	Property_icon_SEQ_STRIP_DUPLICATE = 695,
	Property_icon_SEQ_STRIP_META = 696,
	Property_icon_IMAGE_ALPHA = 697,
	Property_icon_IMAGE_RGB_ALPHA = 698,
	Property_icon_IMAGE_RGB = 699,
	Property_icon_IMAGE_ZDEPTH = 700,
	Property_icon_BLENDER_LOGO_LARGE = 701,
	Property_icon_CANCEL_LARGE = 702,
	Property_icon_DISC_LARGE = 703,
	Property_icon_DISK_DRIVE_LARGE = 704,
	Property_icon_EXTERNAL_DRIVE_LARGE = 705,
	Property_icon_FILE_FOLDER_LARGE = 706,
	Property_icon_FILE_LARGE = 707,
	Property_icon_FILE_PARENT_LARGE = 708,
	Property_icon_INFO_LARGE = 709,
	Property_icon_NETWORK_DRIVE_LARGE = 710,
	Property_icon_QUESTION_LARGE = 711,
	Property_icon_WARNING_LARGE = 712,
	Property_icon_KEY_BACKSPACE_FILLED = 713,
	Property_icon_KEY_BACKSPACE = 714,
	Property_icon_KEY_COMMAND_FILLED = 715,
	Property_icon_KEY_COMMAND = 716,
	Property_icon_KEY_CONTROL_FILLED = 717,
	Property_icon_KEY_CONTROL = 718,
	Property_icon_KEY_EMPTY1_FILLED = 719,
	Property_icon_KEY_EMPTY1 = 720,
	Property_icon_KEY_EMPTY2_FILLED = 721,
	Property_icon_KEY_EMPTY2 = 722,
	Property_icon_KEY_EMPTY3_FILLED = 723,
	Property_icon_KEY_EMPTY3 = 724,
	Property_icon_KEY_MENU_FILLED = 725,
	Property_icon_KEY_MENU = 726,
	Property_icon_KEY_OPTION_FILLED = 727,
	Property_icon_KEY_OPTION = 728,
	Property_icon_KEY_RETURN_FILLED = 729,
	Property_icon_KEY_RETURN = 730,
	Property_icon_KEY_RING_FILLED = 731,
	Property_icon_KEY_RING = 732,
	Property_icon_KEY_SHIFT_FILLED = 733,
	Property_icon_KEY_SHIFT = 734,
	Property_icon_KEY_TAB_FILLED = 735,
	Property_icon_KEY_TAB = 736,
	Property_icon_KEY_WINDOWS_FILLED = 737,
	Property_icon_KEY_WINDOWS = 738,
	Property_icon_GESTURE_PAN = 739,
	Property_icon_GESTURE_ROTATE = 740,
	Property_icon_GESTURE_ZOOM = 741,
	Property_icon_FUND = 742,
	Property_icon_HEART = 743,
	Property_icon_INTERNET_OFFLINE = 744,
	Property_icon_INTERNET = 745,
	Property_icon_USER = 746,
	Property_icon_EXPERIMENTAL = 747,
	Property_icon_MEMORY = 748,
	Property_icon_RGB_RED = 750,
	Property_icon_RGB_GREEN = 751,
	Property_icon_RGB_BLUE = 752,
	Property_icon_KEYTYPE_KEYFRAME_VEC = 753,
	Property_icon_KEYTYPE_BREAKDOWN_VEC = 754,
	Property_icon_KEYTYPE_EXTREME_VEC = 755,
	Property_icon_KEYTYPE_JITTER_VEC = 756,
	Property_icon_KEYTYPE_MOVING_HOLD_VEC = 757,
	Property_icon_KEYTYPE_GENERATED_VEC = 758,
	Property_icon_HANDLETYPE_FREE_VEC = 759,
	Property_icon_HANDLETYPE_ALIGNED_VEC = 760,
	Property_icon_HANDLETYPE_VECTOR_VEC = 761,
	Property_icon_HANDLETYPE_AUTO_VEC = 762,
	Property_icon_HANDLETYPE_AUTO_CLAMP_VEC = 763,
	Property_icon_COLORSET_01_VEC = 764,
	Property_icon_COLORSET_02_VEC = 765,
	Property_icon_COLORSET_03_VEC = 766,
	Property_icon_COLORSET_04_VEC = 767,
	Property_icon_COLORSET_05_VEC = 768,
	Property_icon_COLORSET_06_VEC = 769,
	Property_icon_COLORSET_07_VEC = 770,
	Property_icon_COLORSET_08_VEC = 771,
	Property_icon_COLORSET_09_VEC = 772,
	Property_icon_COLORSET_10_VEC = 773,
	Property_icon_COLORSET_11_VEC = 774,
	Property_icon_COLORSET_12_VEC = 775,
	Property_icon_COLORSET_13_VEC = 776,
	Property_icon_COLORSET_14_VEC = 777,
	Property_icon_COLORSET_15_VEC = 778,
	Property_icon_COLORSET_16_VEC = 779,
	Property_icon_COLORSET_17_VEC = 780,
	Property_icon_COLORSET_18_VEC = 781,
	Property_icon_COLORSET_19_VEC = 782,
	Property_icon_COLORSET_20_VEC = 783,
	Property_icon_COLLECTION_COLOR_01 = 784,
	Property_icon_COLLECTION_COLOR_02 = 785,
	Property_icon_COLLECTION_COLOR_03 = 786,
	Property_icon_COLLECTION_COLOR_04 = 787,
	Property_icon_COLLECTION_COLOR_05 = 788,
	Property_icon_COLLECTION_COLOR_06 = 789,
	Property_icon_COLLECTION_COLOR_07 = 790,
	Property_icon_COLLECTION_COLOR_08 = 791,
	Property_icon_STRIP_COLOR_01 = 792,
	Property_icon_STRIP_COLOR_02 = 793,
	Property_icon_STRIP_COLOR_03 = 794,
	Property_icon_STRIP_COLOR_04 = 795,
	Property_icon_STRIP_COLOR_05 = 796,
	Property_icon_STRIP_COLOR_06 = 797,
	Property_icon_STRIP_COLOR_07 = 798,
	Property_icon_STRIP_COLOR_08 = 799,
	Property_icon_STRIP_COLOR_09 = 800,
	Property_icon_LIBRARY_DATA_INDIRECT = 801,
	Property_icon_LIBRARY_DATA_OVERRIDE_NONEDITABLE = 802,
	Property_icon_LAYERGROUP_COLOR_01 = 803,
	Property_icon_LAYERGROUP_COLOR_02 = 804,
	Property_icon_LAYERGROUP_COLOR_03 = 805,
	Property_icon_LAYERGROUP_COLOR_04 = 806,
	Property_icon_LAYERGROUP_COLOR_05 = 807,
	Property_icon_LAYERGROUP_COLOR_06 = 808,
	Property_icon_LAYERGROUP_COLOR_07 = 809,
	Property_icon_LAYERGROUP_COLOR_08 = 810,
	Property_icon_EVENT_A = 811,
	Property_icon_EVENT_B = 812,
	Property_icon_EVENT_C = 813,
	Property_icon_EVENT_D = 814,
	Property_icon_EVENT_E = 815,
	Property_icon_EVENT_F = 816,
	Property_icon_EVENT_G = 817,
	Property_icon_EVENT_H = 818,
	Property_icon_EVENT_I = 819,
	Property_icon_EVENT_J = 820,
	Property_icon_EVENT_K = 821,
	Property_icon_EVENT_L = 822,
	Property_icon_EVENT_M = 823,
	Property_icon_EVENT_N = 824,
	Property_icon_EVENT_O = 825,
	Property_icon_EVENT_P = 826,
	Property_icon_EVENT_Q = 827,
	Property_icon_EVENT_R = 828,
	Property_icon_EVENT_S = 829,
	Property_icon_EVENT_T = 830,
	Property_icon_EVENT_U = 831,
	Property_icon_EVENT_V = 832,
	Property_icon_EVENT_W = 833,
	Property_icon_EVENT_X = 834,
	Property_icon_EVENT_Y = 835,
	Property_icon_EVENT_Z = 836,
	Property_icon_EVENT_SHIFT = 837,
	Property_icon_EVENT_CTRL = 838,
	Property_icon_EVENT_ALT = 839,
	Property_icon_EVENT_OS = 840,
	Property_icon_EVENT_HYPER = 841,
	Property_icon_EVENT_F1 = 842,
	Property_icon_EVENT_F2 = 843,
	Property_icon_EVENT_F3 = 844,
	Property_icon_EVENT_F4 = 845,
	Property_icon_EVENT_F5 = 846,
	Property_icon_EVENT_F6 = 847,
	Property_icon_EVENT_F7 = 848,
	Property_icon_EVENT_F8 = 849,
	Property_icon_EVENT_F9 = 850,
	Property_icon_EVENT_F10 = 851,
	Property_icon_EVENT_F11 = 852,
	Property_icon_EVENT_F12 = 853,
	Property_icon_EVENT_F13 = 854,
	Property_icon_EVENT_F14 = 855,
	Property_icon_EVENT_F15 = 856,
	Property_icon_EVENT_F16 = 857,
	Property_icon_EVENT_F17 = 858,
	Property_icon_EVENT_F18 = 859,
	Property_icon_EVENT_F19 = 860,
	Property_icon_EVENT_F20 = 861,
	Property_icon_EVENT_F21 = 862,
	Property_icon_EVENT_F22 = 863,
	Property_icon_EVENT_F23 = 864,
	Property_icon_EVENT_F24 = 865,
	Property_icon_EVENT_ESC = 866,
	Property_icon_EVENT_TAB = 867,
	Property_icon_EVENT_PAGEUP = 868,
	Property_icon_EVENT_PAGEDOWN = 869,
	Property_icon_EVENT_RETURN = 870,
	Property_icon_EVENT_SPACEKEY = 871,
	Property_icon_EVENT_ZEROKEY = 872,
	Property_icon_EVENT_ONEKEY = 873,
	Property_icon_EVENT_TWOKEY = 874,
	Property_icon_EVENT_THREEKEY = 875,
	Property_icon_EVENT_FOURKEY = 876,
	Property_icon_EVENT_FIVEKEY = 877,
	Property_icon_EVENT_SIXKEY = 878,
	Property_icon_EVENT_SEVENKEY = 879,
	Property_icon_EVENT_EIGHTKEY = 880,
	Property_icon_EVENT_NINEKEY = 881,
	Property_icon_EVENT_PAD0 = 882,
	Property_icon_EVENT_PAD1 = 883,
	Property_icon_EVENT_PAD2 = 884,
	Property_icon_EVENT_PAD3 = 885,
	Property_icon_EVENT_PAD4 = 886,
	Property_icon_EVENT_PAD5 = 887,
	Property_icon_EVENT_PAD6 = 888,
	Property_icon_EVENT_PAD7 = 889,
	Property_icon_EVENT_PAD8 = 890,
	Property_icon_EVENT_PAD9 = 891,
	Property_icon_EVENT_PADASTER = 892,
	Property_icon_EVENT_PADSLASH = 893,
	Property_icon_EVENT_PADMINUS = 894,
	Property_icon_EVENT_PADENTER = 895,
	Property_icon_EVENT_PADPLUS = 896,
	Property_icon_EVENT_PADPERIOD = 897,
	Property_icon_EVENT_MOUSE_4 = 898,
	Property_icon_EVENT_MOUSE_5 = 899,
	Property_icon_EVENT_MOUSE_6 = 900,
	Property_icon_EVENT_MOUSE_7 = 901,
	Property_icon_EVENT_TABLET_STYLUS = 902,
	Property_icon_EVENT_TABLET_ERASER = 903,
	Property_icon_EVENT_LEFT_ARROW = 904,
	Property_icon_EVENT_DOWN_ARROW = 905,
	Property_icon_EVENT_RIGHT_ARROW = 906,
	Property_icon_EVENT_UP_ARROW = 907,
	Property_icon_EVENT_PAUSE = 908,
	Property_icon_EVENT_INSERT = 909,
	Property_icon_EVENT_HOME = 910,
	Property_icon_EVENT_END = 911,
	Property_icon_EVENT_UNKNOWN = 912,
	Property_icon_EVENT_GRLESS = 913,
	Property_icon_EVENT_MEDIAPLAY = 914,
	Property_icon_EVENT_MEDIASTOP = 915,
	Property_icon_EVENT_MEDIAFIRST = 916,
	Property_icon_EVENT_MEDIALAST = 917,
	Property_icon_EVENT_APP = 918,
	Property_icon_EVENT_CAPSLOCK = 919,
	Property_icon_EVENT_BACKSPACE = 920,
	Property_icon_EVENT_DEL = 921,
	Property_icon_EVENT_SEMICOLON = 922,
	Property_icon_EVENT_PERIOD = 923,
	Property_icon_EVENT_COMMA = 924,
	Property_icon_EVENT_QUOTE = 925,
	Property_icon_EVENT_ACCENTGRAVE = 926,
	Property_icon_EVENT_MINUS = 927,
	Property_icon_EVENT_PLUS = 928,
	Property_icon_EVENT_SLASH = 929,
	Property_icon_EVENT_BACKSLASH = 930,
	Property_icon_EVENT_EQUAL = 931,
	Property_icon_EVENT_LEFTBRACKET = 932,
	Property_icon_EVENT_RIGHTBRACKET = 933,
	Property_icon_EVENT_PAD_PAN = 934,
	Property_icon_EVENT_PAD_ROTATE = 935,
	Property_icon_EVENT_PAD_ZOOM = 936,
	Property_icon_EVENT_NDOF_BUTTON_V1 = 937,
	Property_icon_EVENT_NDOF_BUTTON_V2 = 938,
	Property_icon_EVENT_NDOF_BUTTON_V3 = 939,
	Property_icon_EVENT_NDOF_BUTTON_SAVE_V1 = 940,
	Property_icon_EVENT_NDOF_BUTTON_SAVE_V2 = 941,
	Property_icon_EVENT_NDOF_BUTTON_SAVE_V3 = 942,
	Property_icon_EVENT_NDOF_BUTTON_1 = 943,
	Property_icon_EVENT_NDOF_BUTTON_2 = 944,
	Property_icon_EVENT_NDOF_BUTTON_3 = 945,
	Property_icon_EVENT_NDOF_BUTTON_4 = 946,
	Property_icon_EVENT_NDOF_BUTTON_5 = 947,
	Property_icon_EVENT_NDOF_BUTTON_6 = 948,
	Property_icon_EVENT_NDOF_BUTTON_7 = 949,
	Property_icon_EVENT_NDOF_BUTTON_8 = 950,
	Property_icon_EVENT_NDOF_BUTTON_9 = 951,
	Property_icon_EVENT_NDOF_BUTTON_10 = 952,
	Property_icon_EVENT_NDOF_BUTTON_11 = 953,
	Property_icon_EVENT_NDOF_BUTTON_12 = 954,
	Property_icon_EVENT_NDOF_BUTTON_MENU = 955,
	Property_icon_EVENT_NDOF_BUTTON_FIT = 956,
	Property_icon_EVENT_NDOF_BUTTON_TOP = 957,
	Property_icon_EVENT_NDOF_BUTTON_BOTTOM = 958,
	Property_icon_EVENT_NDOF_BUTTON_LEFT = 959,
	Property_icon_EVENT_NDOF_BUTTON_RIGHT = 960,
	Property_icon_EVENT_NDOF_BUTTON_FRONT = 961,
	Property_icon_EVENT_NDOF_BUTTON_BACK = 962,
	Property_icon_EVENT_NDOF_BUTTON_ISO1 = 963,
	Property_icon_EVENT_NDOF_BUTTON_ISO2 = 964,
	Property_icon_EVENT_NDOF_BUTTON_ROLL_CW = 965,
	Property_icon_EVENT_NDOF_BUTTON_ROLL_CCW = 966,
	Property_icon_EVENT_NDOF_BUTTON_SPIN_CW = 967,
	Property_icon_EVENT_NDOF_BUTTON_SPIN_CCW = 968,
	Property_icon_EVENT_NDOF_BUTTON_TILT_CW = 969,
	Property_icon_EVENT_NDOF_BUTTON_TILT_CCW = 970,
	Property_icon_EVENT_NDOF_BUTTON_ROTATE = 971,
	Property_icon_EVENT_NDOF_BUTTON_PANZOOM = 972,
	Property_icon_EVENT_NDOF_BUTTON_DOMINANT = 973,
	Property_icon_EVENT_NDOF_BUTTON_PLUS = 974,
	Property_icon_EVENT_NDOF_BUTTON_MINUS = 975,
	Property_icon_NODE_SOCKET_FLOAT = 976,
	Property_icon_NODE_SOCKET_VECTOR = 977,
	Property_icon_NODE_SOCKET_RGBA = 978,
	Property_icon_NODE_SOCKET_SHADER = 979,
	Property_icon_NODE_SOCKET_BOOLEAN = 980,
	Property_icon_NODE_SOCKET_INT = 981,
	Property_icon_NODE_SOCKET_STRING = 982,
	Property_icon_NODE_SOCKET_OBJECT = 983,
	Property_icon_NODE_SOCKET_IMAGE = 984,
	Property_icon_NODE_SOCKET_GEOMETRY = 985,
	Property_icon_NODE_SOCKET_COLLECTION = 986,
	Property_icon_NODE_SOCKET_TEXTURE = 987,
	Property_icon_NODE_SOCKET_MATERIAL = 988,
	Property_icon_NODE_SOCKET_ROTATION = 989,
	Property_icon_NODE_SOCKET_MENU = 990,
	Property_icon_NODE_SOCKET_MATRIX = 991,
	Property_icon_NODE_SOCKET_BUNDLE = 992,
	Property_icon_NODE_SOCKET_CLOSURE = 993,
};

int Property_icon_get(PointerRNA *ptr);
void Property_icon_set(PointerRNA *ptr, int value);

void Property_identifier_get(PointerRNA *ptr, char *value);
int Property_identifier_length(PointerRNA *ptr);
void Property_identifier_set(PointerRNA *ptr, const char *value);

bool Property_is_library_editable_get(PointerRNA *ptr);
void Property_is_library_editable_set(PointerRNA *ptr, bool value);

bool Property_is_never_none_get(PointerRNA *ptr);
void Property_is_never_none_set(PointerRNA *ptr, bool value);

bool Property_is_argument_optional_get(PointerRNA *ptr);
void Property_is_argument_optional_set(PointerRNA *ptr, bool value);

bool Property_is_overridable_get(PointerRNA *ptr);
void Property_is_overridable_set(PointerRNA *ptr, bool value);

bool Property_is_path_output_get(PointerRNA *ptr);
void Property_is_path_output_set(PointerRNA *ptr, bool value);

bool Property_is_path_supports_blend_relative_get(PointerRNA *ptr);
void Property_is_path_supports_blend_relative_set(PointerRNA *ptr, bool value);

bool Property_is_readonly_get(PointerRNA *ptr);
void Property_is_readonly_set(PointerRNA *ptr, bool value);

bool Property_is_registered_get(PointerRNA *ptr);
void Property_is_registered_set(PointerRNA *ptr, bool value);

bool Property_is_registered_optional_get(PointerRNA *ptr);
void Property_is_registered_optional_set(PointerRNA *ptr, bool value);

bool Property_is_required_get(PointerRNA *ptr);
void Property_is_required_set(PointerRNA *ptr, bool value);

bool Property_is_output_get(PointerRNA *ptr);
void Property_is_output_set(PointerRNA *ptr, bool value);

bool Property_is_runtime_get(PointerRNA *ptr);
void Property_is_runtime_set(PointerRNA *ptr, bool value);

bool Property_is_skip_preset_get(PointerRNA *ptr);
void Property_is_skip_preset_set(PointerRNA *ptr, bool value);

bool Property_is_skip_save_get(PointerRNA *ptr);
void Property_is_skip_save_set(PointerRNA *ptr, bool value);

enum {
	Property_subtype_NONE = 0,
	Property_subtype_FILE_PATH = 1,
	Property_subtype_DIR_PATH = 2,
	Property_subtype_FILE_NAME = 3,
	Property_subtype_BYTE_STRING = 4,
	Property_subtype_PASSWORD = 6,
	Property_subtype_PIXEL = 12,
	Property_subtype_UNSIGNED = 13,
	Property_subtype_PERCENTAGE = 14,
	Property_subtype_FACTOR = 15,
	Property_subtype_ANGLE = 327696,
	Property_subtype_TIME = 393233,
	Property_subtype_TIME_ABSOLUTE = 458769,
	Property_subtype_DISTANCE = 65554,
	Property_subtype_DISTANCE_CAMERA = 655379,
	Property_subtype_POWER = 720938,
	Property_subtype_TEMPERATURE = 786475,
	Property_subtype_WAVELENGTH = 852012,
	Property_subtype_COLOR_TEMPERATURE = 917549,
	Property_subtype_FREQUENCY = 983086,
	Property_subtype_COLOR = 20,
	Property_subtype_TRANSLATION = 65557,
	Property_subtype_DIRECTION = 22,
	Property_subtype_VELOCITY = 524311,
	Property_subtype_ACCELERATION = 589848,
	Property_subtype_MATRIX = 25,
	Property_subtype_EULER = 327706,
	Property_subtype_QUATERNION = 27,
	Property_subtype_AXISANGLE = 28,
	Property_subtype_XYZ = 29,
	Property_subtype_XYZ_LENGTH = 65565,
	Property_subtype_COLOR_GAMMA = 30,
	Property_subtype_COORDINATES = 31,
	Property_subtype_LAYER = 40,
	Property_subtype_LAYER_MEMBER = 41,
};

int Property_subtype_get(PointerRNA *ptr);
void Property_subtype_set(PointerRNA *ptr, int value);

int Property_tags_get(PointerRNA *ptr);
void Property_tags_set(PointerRNA *ptr, int value);

void Property_translation_context_get(PointerRNA *ptr, char *value);
int Property_translation_context_length(PointerRNA *ptr);
void Property_translation_context_set(PointerRNA *ptr, const char *value);

enum {
	Property_type_BOOLEAN = 0,
	Property_type_INT = 1,
	Property_type_FLOAT = 2,
	Property_type_STRING = 3,
	Property_type_ENUM = 4,
	Property_type_POINTER = 5,
	Property_type_COLLECTION = 6,
};

int Property_type_get(PointerRNA *ptr);
void Property_type_set(PointerRNA *ptr, int value);

enum {
	Property_unit_NONE = 0,
	Property_unit_LENGTH = 65536,
	Property_unit_AREA = 131072,
	Property_unit_VOLUME = 196608,
	Property_unit_ROTATION = 327680,
	Property_unit_TIME = 393216,
	Property_unit_TIME_ABSOLUTE = 458752,
	Property_unit_VELOCITY = 524288,
	Property_unit_ACCELERATION = 589824,
	Property_unit_MASS = 262144,
	Property_unit_CAMERA = 655360,
	Property_unit_POWER = 720896,
	Property_unit_TEMPERATURE = 786432,
	Property_unit_WAVELENGTH = 851968,
	Property_unit_COLOR_TEMPERATURE = 917504,
	Property_unit_FREQUENCY = 983040,
};

int Property_unit_get(PointerRNA *ptr);
void Property_unit_set(PointerRNA *ptr, int value);

bool Property_is_path_supports_templates_get(PointerRNA *ptr);
void Property_is_path_supports_templates_set(PointerRNA *ptr, bool value);

/**************** ID Property Group ****************/

extern StructRNA RNA_PropertyGroup;

PointerRNA PropertyGroup_rna_type_get(PointerRNA *ptr);

/**************** ID Property ****************/

extern StructRNA RNA_PropertyGroupItem;

PointerRNA PropertyGroupItem_rna_type_get(PointerRNA *ptr);

/**************** Quaternion Attribute ****************/

extern StructRNA RNA_QuaternionAttribute;
extern StructRNA RNA_Attribute;

void QuaternionAttribute_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void QuaternionAttribute_data_next(CollectionPropertyIterator *iter);
void QuaternionAttribute_data_end(CollectionPropertyIterator *iter);
int QuaternionAttribute_data_length(PointerRNA *ptr);
bool QuaternionAttribute_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Quaternion Attribute Value ****************/

extern StructRNA RNA_QuaternionAttributeValue;

PointerRNA QuaternionAttributeValue_rna_type_get(PointerRNA *ptr);

void QuaternionAttributeValue_value_get(PointerRNA *ptr, float values[4]);
void QuaternionAttributeValue_value_set(PointerRNA *ptr, const float values[4]);

/**************** EEVEE Raytrace Options ****************/

extern StructRNA RNA_RaytraceEEVEE;

PointerRNA RaytraceEEVEE_rna_type_get(PointerRNA *ptr);

bool RaytraceEEVEE_denoise_bilateral_get(PointerRNA *ptr);
void RaytraceEEVEE_denoise_bilateral_set(PointerRNA *ptr, bool value);

bool RaytraceEEVEE_use_denoise_get(PointerRNA *ptr);
void RaytraceEEVEE_use_denoise_set(PointerRNA *ptr, bool value);

float RaytraceEEVEE_trace_max_roughness_get(PointerRNA *ptr);
void RaytraceEEVEE_trace_max_roughness_set(PointerRNA *ptr, float value);

enum {
	RaytraceEEVEE_resolution_scale_1 = 1,
	RaytraceEEVEE_resolution_scale_2 = 2,
	RaytraceEEVEE_resolution_scale_4 = 4,
	RaytraceEEVEE_resolution_scale_8 = 8,
	RaytraceEEVEE_resolution_scale_16 = 16,
};

int RaytraceEEVEE_resolution_scale_get(PointerRNA *ptr);
void RaytraceEEVEE_resolution_scale_set(PointerRNA *ptr, int value);

float RaytraceEEVEE_screen_trace_quality_get(PointerRNA *ptr);
void RaytraceEEVEE_screen_trace_quality_set(PointerRNA *ptr, float value);

float RaytraceEEVEE_screen_trace_thickness_get(PointerRNA *ptr);
void RaytraceEEVEE_screen_trace_thickness_set(PointerRNA *ptr, float value);

bool RaytraceEEVEE_denoise_spatial_get(PointerRNA *ptr);
void RaytraceEEVEE_denoise_spatial_set(PointerRNA *ptr, bool value);

bool RaytraceEEVEE_denoise_temporal_get(PointerRNA *ptr);
void RaytraceEEVEE_denoise_temporal_set(PointerRNA *ptr, bool value);

/**************** Read-only Integer ****************/

extern StructRNA RNA_ReadOnlyInteger;

PointerRNA ReadOnlyInteger_rna_type_get(PointerRNA *ptr);

int ReadOnlyInteger_value_get(PointerRNA *ptr);
void ReadOnlyInteger_value_set(PointerRNA *ptr, int value);

/**************** Region ****************/

extern StructRNA RNA_Region;

PointerRNA Region_rna_type_get(PointerRNA *ptr);

enum {
	Region_active_panel_category_UNSUPPORTED = -1,
};

int Region_active_panel_category_get(PointerRNA *ptr);
void Region_active_panel_category_set(PointerRNA *ptr, int value);

enum {
	Region_alignment_NONE = 0,
	Region_alignment_TOP = 1,
	Region_alignment_BOTTOM = 2,
	Region_alignment_LEFT = 3,
	Region_alignment_RIGHT = 4,
	Region_alignment_HORIZONTAL_SPLIT = 5,
	Region_alignment_VERTICAL_SPLIT = 6,
	Region_alignment_FLOAT = 7,
	Region_alignment_QUAD_SPLIT = 8,
};

int Region_alignment_get(PointerRNA *ptr);
void Region_alignment_set(PointerRNA *ptr, int value);

int Region_height_get(PointerRNA *ptr);
void Region_height_set(PointerRNA *ptr, int value);

PointerRNA Region_data_get(PointerRNA *ptr);

enum {
	Region_type_WINDOW = 0,
	Region_type_HEADER = 1,
	Region_type_CHANNELS = 2,
	Region_type_TEMPORARY = 3,
	Region_type_UI = 4,
	Region_type_TOOLS = 5,
	Region_type_TOOL_PROPS = 6,
	Region_type_ASSET_SHELF = 14,
	Region_type_ASSET_SHELF_HEADER = 15,
	Region_type_PREVIEW = 7,
	Region_type_HUD = 8,
	Region_type_NAVIGATION_BAR = 9,
	Region_type_EXECUTE = 10,
	Region_type_FOOTER = 11,
	Region_type_TOOL_HEADER = 12,
	Region_type_XR = 13,
};

int Region_type_get(PointerRNA *ptr);
void Region_type_set(PointerRNA *ptr, int value);

PointerRNA Region_view2d_get(PointerRNA *ptr);

int Region_width_get(PointerRNA *ptr);
void Region_width_set(PointerRNA *ptr, int value);

int Region_x_get(PointerRNA *ptr);
void Region_x_set(PointerRNA *ptr, int value);

int Region_y_get(PointerRNA *ptr);
void Region_y_set(PointerRNA *ptr, int value);

void Region_tag_redraw_func(struct ARegion *_self);
void Region_tag_refresh_ui_func(struct ARegion *_self, ReportList *reports);
/**************** 3D View Region ****************/

extern StructRNA RNA_RegionView3D;

PointerRNA RegionView3D_rna_type_get(PointerRNA *ptr);

void RegionView3D_view_camera_offset_get(PointerRNA *ptr, float values[2]);
void RegionView3D_view_camera_offset_set(PointerRNA *ptr, const float values[2]);

float RegionView3D_view_camera_zoom_get(PointerRNA *ptr);
void RegionView3D_view_camera_zoom_set(PointerRNA *ptr, float value);

bool RegionView3D_use_box_clip_get(PointerRNA *ptr);
void RegionView3D_use_box_clip_set(PointerRNA *ptr, bool value);

void RegionView3D_clip_planes_get(PointerRNA *ptr, float values[24]);
void RegionView3D_clip_planes_set(PointerRNA *ptr, const float values[24]);

float RegionView3D_view_distance_get(PointerRNA *ptr);
void RegionView3D_view_distance_set(PointerRNA *ptr, float value);

bool RegionView3D_is_orthographic_side_view_get(PointerRNA *ptr);
void RegionView3D_is_orthographic_side_view_set(PointerRNA *ptr, bool value);

bool RegionView3D_is_perspective_get(PointerRNA *ptr);
void RegionView3D_is_perspective_set(PointerRNA *ptr, bool value);

bool RegionView3D_lock_rotation_get(PointerRNA *ptr);
void RegionView3D_lock_rotation_set(PointerRNA *ptr, bool value);

enum {
	RegionView3D_view_perspective_PERSP = 1,
	RegionView3D_view_perspective_ORTHO = 0,
	RegionView3D_view_perspective_CAMERA = 2,
};

int RegionView3D_view_perspective_get(PointerRNA *ptr);
void RegionView3D_view_perspective_set(PointerRNA *ptr, int value);

void RegionView3D_perspective_matrix_get(PointerRNA *ptr, float values[16]);
void RegionView3D_perspective_matrix_set(PointerRNA *ptr, const float values[16]);

bool RegionView3D_show_sync_view_get(PointerRNA *ptr);
void RegionView3D_show_sync_view_set(PointerRNA *ptr, bool value);

bool RegionView3D_use_clip_planes_get(PointerRNA *ptr);
void RegionView3D_use_clip_planes_set(PointerRNA *ptr, bool value);

void RegionView3D_view_location_get(PointerRNA *ptr, float values[3]);
void RegionView3D_view_location_set(PointerRNA *ptr, const float values[3]);

void RegionView3D_view_matrix_get(PointerRNA *ptr, float values[16]);
void RegionView3D_view_matrix_set(PointerRNA *ptr, const float values[16]);

void RegionView3D_view_rotation_get(PointerRNA *ptr, float values[4]);
void RegionView3D_view_rotation_set(PointerRNA *ptr, const float values[4]);

void RegionView3D_window_matrix_get(PointerRNA *ptr, float values[16]);
void RegionView3D_window_matrix_set(PointerRNA *ptr, const float values[16]);

void RegionView3D_update_func(struct ID *_selfid, struct RegionView3D *_self, bContext *C);
/**************** Remesh Modifier ****************/

extern StructRNA RNA_RemeshModifier;
extern StructRNA RNA_Modifier;

float RemeshModifier_adaptivity_get(PointerRNA *ptr);
void RemeshModifier_adaptivity_set(PointerRNA *ptr, float value);

enum {
	RemeshModifier_mode_BLOCKS = 0,
	RemeshModifier_mode_SMOOTH = 1,
	RemeshModifier_mode_SHARP = 2,
	RemeshModifier_mode_VOXEL = 3,
};

int RemeshModifier_mode_get(PointerRNA *ptr);
void RemeshModifier_mode_set(PointerRNA *ptr, int value);

int RemeshModifier_octree_depth_get(PointerRNA *ptr);
void RemeshModifier_octree_depth_set(PointerRNA *ptr, int value);

bool RemeshModifier_use_remove_disconnected_get(PointerRNA *ptr);
void RemeshModifier_use_remove_disconnected_set(PointerRNA *ptr, bool value);

float RemeshModifier_scale_get(PointerRNA *ptr);
void RemeshModifier_scale_set(PointerRNA *ptr, float value);

float RemeshModifier_sharpness_get(PointerRNA *ptr);
void RemeshModifier_sharpness_set(PointerRNA *ptr, float value);

bool RemeshModifier_use_smooth_shade_get(PointerRNA *ptr);
void RemeshModifier_use_smooth_shade_set(PointerRNA *ptr, bool value);

float RemeshModifier_threshold_get(PointerRNA *ptr);
void RemeshModifier_threshold_set(PointerRNA *ptr, float value);

float RemeshModifier_voxel_size_get(PointerRNA *ptr);
void RemeshModifier_voxel_size_set(PointerRNA *ptr, float value);

/**************** Render Engine ****************/

extern StructRNA RNA_RenderEngine;

PointerRNA RenderEngine_rna_type_get(PointerRNA *ptr);

PointerRNA RenderEngine_render_get(PointerRNA *ptr);

bool RenderEngine_bl_use_alembic_procedural_get(PointerRNA *ptr);
void RenderEngine_bl_use_alembic_procedural_set(PointerRNA *ptr, bool value);

bool RenderEngine_bl_use_custom_freestyle_get(PointerRNA *ptr);
void RenderEngine_bl_use_custom_freestyle_set(PointerRNA *ptr, bool value);

bool RenderEngine_bl_use_shading_nodes_custom_get(PointerRNA *ptr);
void RenderEngine_bl_use_shading_nodes_custom_set(PointerRNA *ptr, bool value);

bool RenderEngine_bl_use_eevee_viewport_get(PointerRNA *ptr);
void RenderEngine_bl_use_eevee_viewport_set(PointerRNA *ptr, bool value);

bool RenderEngine_bl_use_gpu_context_get(PointerRNA *ptr);
void RenderEngine_bl_use_gpu_context_set(PointerRNA *ptr, bool value);

bool RenderEngine_bl_use_image_save_get(PointerRNA *ptr);
void RenderEngine_bl_use_image_save_set(PointerRNA *ptr, bool value);

bool RenderEngine_bl_use_materialx_get(PointerRNA *ptr);
void RenderEngine_bl_use_materialx_set(PointerRNA *ptr, bool value);

bool RenderEngine_bl_use_postprocess_get(PointerRNA *ptr);
void RenderEngine_bl_use_postprocess_set(PointerRNA *ptr, bool value);

bool RenderEngine_bl_use_preview_get(PointerRNA *ptr);
void RenderEngine_bl_use_preview_set(PointerRNA *ptr, bool value);

bool RenderEngine_bl_use_spherical_stereo_get(PointerRNA *ptr);
void RenderEngine_bl_use_spherical_stereo_set(PointerRNA *ptr, bool value);

bool RenderEngine_bl_use_stereo_viewport_get(PointerRNA *ptr);
void RenderEngine_bl_use_stereo_viewport_set(PointerRNA *ptr, bool value);

void RenderEngine_bl_idname_get(PointerRNA *ptr, char *value);
int RenderEngine_bl_idname_length(PointerRNA *ptr);
void RenderEngine_bl_idname_set(PointerRNA *ptr, const char *value);

void RenderEngine_bl_label_get(PointerRNA *ptr, char *value);
int RenderEngine_bl_label_length(PointerRNA *ptr);
void RenderEngine_bl_label_set(PointerRNA *ptr, const char *value);

PointerRNA RenderEngine_camera_override_get(PointerRNA *ptr);

bool RenderEngine_is_animation_get(PointerRNA *ptr);
void RenderEngine_is_animation_set(PointerRNA *ptr, bool value);

bool RenderEngine_is_preview_get(PointerRNA *ptr);
void RenderEngine_is_preview_set(PointerRNA *ptr, bool value);

void RenderEngine_layer_override_get(PointerRNA *ptr, bool values[20]);
void RenderEngine_layer_override_set(PointerRNA *ptr, const bool values[20]);

int RenderEngine_resolution_x_get(PointerRNA *ptr);
void RenderEngine_resolution_x_set(PointerRNA *ptr, int value);

int RenderEngine_resolution_y_get(PointerRNA *ptr);
void RenderEngine_resolution_y_set(PointerRNA *ptr, int value);

void RenderEngine_temporary_directory_get(PointerRNA *ptr, char *value);
int RenderEngine_temporary_directory_length(PointerRNA *ptr);
void RenderEngine_temporary_directory_set(PointerRNA *ptr, const char *value);

bool RenderEngine_use_highlight_tiles_get(PointerRNA *ptr);
void RenderEngine_use_highlight_tiles_set(PointerRNA *ptr, bool value);

void RenderEngine_update_func(struct RenderEngine *_self, struct BlendData *data, struct Depsgraph *depsgraph);
void RenderEngine_render_func(struct RenderEngine *_self, struct Depsgraph *depsgraph);
void RenderEngine_render_frame_finish_func(struct RenderEngine *_self);
void RenderEngine_draw_func(struct RenderEngine *_self, struct bContext *context, struct Depsgraph *depsgraph);
void RenderEngine_bake_func(struct RenderEngine *_self, struct Depsgraph *depsgraph, struct Object *object, int pass_type, int pass_filter, int width, int height);
void RenderEngine_view_update_func(struct RenderEngine *_self, struct bContext *context, struct Depsgraph *depsgraph);
void RenderEngine_view_draw_func(struct RenderEngine *_self, struct bContext *context, struct Depsgraph *depsgraph);
void RenderEngine_update_script_node_func(struct RenderEngine *_self, struct PointerRNA *node);
void RenderEngine_update_render_passes_func(struct RenderEngine *_self, struct Scene *scene, struct ViewLayer *renderlayer);
void RenderEngine_update_custom_camera_func(struct RenderEngine *_self, struct Camera *cam);
void RenderEngine_tag_redraw_func(struct RenderEngine *_self);
void RenderEngine_tag_update_func(struct RenderEngine *_self);
struct RenderResult *RenderEngine_begin_result_func(struct RenderEngine *_self, int x, int y, int w, int h, const char * layer, const char * view);
void RenderEngine_update_result_func(struct RenderEngine *_self, struct RenderResult *result);
void RenderEngine_end_result_func(struct RenderEngine *_self, struct RenderResult *result, bool cancel, bool highlight, bool do_merge_results);
void RenderEngine_add_pass_func(struct RenderEngine *_self, const char * name, int channels, const char * chan_id, const char * layer);
struct RenderResult *RenderEngine_get_result_func(struct RenderEngine *_self);
bool RenderEngine_test_break_func(struct RenderEngine *_self);
struct RenderPass *RenderEngine_pass_by_index_get_func(struct RenderEngine *_self, const char * layer, int index);
const char * RenderEngine_active_view_get_func(struct RenderEngine *_self);
void RenderEngine_active_view_set_func(struct RenderEngine *_self, const char * view);
float RenderEngine_camera_shift_x_func(struct RenderEngine *_self, struct Object *camera, bool use_spherical_stereo);
void RenderEngine_camera_model_matrix_func(struct RenderEngine *_self, struct Object *camera, bool use_spherical_stereo, float r_model_matrix[16]);
bool RenderEngine_use_spherical_stereo_func(struct RenderEngine *_self, struct Object *camera);
void RenderEngine_update_stats_func(struct RenderEngine *_self, const char * stats, const char * info);
void RenderEngine_frame_set_func(struct RenderEngine *_self, int frame, float subframe);
void RenderEngine_update_progress_func(struct RenderEngine *_self, float progress);
void RenderEngine_update_memory_stats_func(struct RenderEngine *_self, float memory_used, float memory_peak);
void RenderEngine_report_func(struct RenderEngine *_self, int type, const char * message);
void RenderEngine_error_set_func(struct RenderEngine *_self, const char * message);
void RenderEngine_bind_display_space_shader_func(struct RenderEngine *_self, struct Scene *scene);
void RenderEngine_unbind_display_space_shader_func(struct RenderEngine *_self);
bool RenderEngine_support_display_space_shader_func(struct RenderEngine *_self, struct Scene *scene);
int RenderEngine_get_preview_pixel_size_func(struct RenderEngine *_self, struct Scene *scene);
void RenderEngine_free_blender_memory_func(struct RenderEngine *_self);
void RenderEngine_tile_highlight_set_func(struct RenderEngine *_self, int x, int y, int width, int height, bool highlight);
void RenderEngine_tile_highlight_clear_all_func(struct RenderEngine *_self);
void RenderEngine_register_pass_func(struct RenderEngine *_self, struct Scene *scene, struct ViewLayer *view_layer, const char * name, int channels, const char * chanid, eNodeSocketDatatype type);
/**************** Render Layer ****************/

extern StructRNA RNA_RenderLayer;

PointerRNA RenderLayer_rna_type_get(PointerRNA *ptr);

void RenderLayer_name_get(PointerRNA *ptr, char *value);
int RenderLayer_name_length(PointerRNA *ptr);
void RenderLayer_name_set(PointerRNA *ptr, const char *value);

bool RenderLayer_use_ao_get(PointerRNA *ptr);
void RenderLayer_use_ao_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_ambient_occlusion_get(PointerRNA *ptr);
void RenderLayer_use_pass_ambient_occlusion_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_combined_get(PointerRNA *ptr);
void RenderLayer_use_pass_combined_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_diffuse_color_get(PointerRNA *ptr);
void RenderLayer_use_pass_diffuse_color_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_diffuse_direct_get(PointerRNA *ptr);
void RenderLayer_use_pass_diffuse_direct_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_diffuse_indirect_get(PointerRNA *ptr);
void RenderLayer_use_pass_diffuse_indirect_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_emit_get(PointerRNA *ptr);
void RenderLayer_use_pass_emit_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_environment_get(PointerRNA *ptr);
void RenderLayer_use_pass_environment_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_glossy_color_get(PointerRNA *ptr);
void RenderLayer_use_pass_glossy_color_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_glossy_direct_get(PointerRNA *ptr);
void RenderLayer_use_pass_glossy_direct_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_glossy_indirect_get(PointerRNA *ptr);
void RenderLayer_use_pass_glossy_indirect_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_grease_pencil_get(PointerRNA *ptr);
void RenderLayer_use_grease_pencil_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_material_index_get(PointerRNA *ptr);
void RenderLayer_use_pass_material_index_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_mist_get(PointerRNA *ptr);
void RenderLayer_use_pass_mist_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_motion_blur_get(PointerRNA *ptr);
void RenderLayer_use_motion_blur_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_normal_get(PointerRNA *ptr);
void RenderLayer_use_pass_normal_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_object_index_get(PointerRNA *ptr);
void RenderLayer_use_pass_object_index_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_position_get(PointerRNA *ptr);
void RenderLayer_use_pass_position_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_shadow_get(PointerRNA *ptr);
void RenderLayer_use_pass_shadow_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_sky_get(PointerRNA *ptr);
void RenderLayer_use_sky_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_solid_get(PointerRNA *ptr);
void RenderLayer_use_solid_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_strand_get(PointerRNA *ptr);
void RenderLayer_use_strand_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_subsurface_color_get(PointerRNA *ptr);
void RenderLayer_use_pass_subsurface_color_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_subsurface_direct_get(PointerRNA *ptr);
void RenderLayer_use_pass_subsurface_direct_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_subsurface_indirect_get(PointerRNA *ptr);
void RenderLayer_use_pass_subsurface_indirect_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_transmission_color_get(PointerRNA *ptr);
void RenderLayer_use_pass_transmission_color_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_transmission_direct_get(PointerRNA *ptr);
void RenderLayer_use_pass_transmission_direct_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_transmission_indirect_get(PointerRNA *ptr);
void RenderLayer_use_pass_transmission_indirect_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_uv_get(PointerRNA *ptr);
void RenderLayer_use_pass_uv_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_vector_get(PointerRNA *ptr);
void RenderLayer_use_pass_vector_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_volumes_get(PointerRNA *ptr);
void RenderLayer_use_volumes_set(PointerRNA *ptr, bool value);

bool RenderLayer_use_pass_z_get(PointerRNA *ptr);
void RenderLayer_use_pass_z_set(PointerRNA *ptr, bool value);

void RenderLayer_passes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void RenderLayer_passes_next(CollectionPropertyIterator *iter);
void RenderLayer_passes_end(CollectionPropertyIterator *iter);

void RenderLayer_load_from_file_func(struct RenderLayer *_self, ReportList *reports, const char * filepath, int x, int y);
/**************** Render Pass ****************/

extern StructRNA RNA_RenderPass;

PointerRNA RenderPass_rna_type_get(PointerRNA *ptr);

void RenderPass_name_get(PointerRNA *ptr, char *value);
int RenderPass_name_length(PointerRNA *ptr);
void RenderPass_name_set(PointerRNA *ptr, const char *value);

void RenderPass_channel_id_get(PointerRNA *ptr, char *value);
int RenderPass_channel_id_length(PointerRNA *ptr);
void RenderPass_channel_id_set(PointerRNA *ptr, const char *value);

int RenderPass_channels_get(PointerRNA *ptr);
void RenderPass_channels_set(PointerRNA *ptr, int value);

void RenderPass_fullname_get(PointerRNA *ptr, char *value);
int RenderPass_fullname_length(PointerRNA *ptr);
void RenderPass_fullname_set(PointerRNA *ptr, const char *value);

void RenderPass_rect_get(PointerRNA *ptr, float values[]);
void RenderPass_rect_set(PointerRNA *ptr, const float values[]);int RenderPass_rect_get_length(PointerRNA *ptr, int *arraylen);

int RenderPass_view_id_get(PointerRNA *ptr);
void RenderPass_view_id_set(PointerRNA *ptr, int value);

/**************** Render Passes ****************/

extern StructRNA RNA_RenderPasses;

PointerRNA RenderPasses_rna_type_get(PointerRNA *ptr);

struct RenderPass *RenderPasses_find_by_type_func(struct RenderLayer *_self, int pass_type, const char * view);
struct RenderPass *RenderPasses_find_by_name_func(struct RenderLayer *_self, const char * name, const char * view);
/**************** Render Result ****************/

extern StructRNA RNA_RenderResult;

PointerRNA RenderResult_rna_type_get(PointerRNA *ptr);

void RenderResult_layers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void RenderResult_layers_next(CollectionPropertyIterator *iter);
void RenderResult_layers_end(CollectionPropertyIterator *iter);

int RenderResult_resolution_x_get(PointerRNA *ptr);
void RenderResult_resolution_x_set(PointerRNA *ptr, int value);

int RenderResult_resolution_y_get(PointerRNA *ptr);
void RenderResult_resolution_y_set(PointerRNA *ptr, int value);

void RenderResult_views_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void RenderResult_views_next(CollectionPropertyIterator *iter);
void RenderResult_views_end(CollectionPropertyIterator *iter);

void RenderResult_load_from_file_func(struct RenderResult *_self, ReportList *reports, const char * filepath);
void RenderResult_stamp_data_add_field_func(struct RenderResult *_self, const char * field, const char * value);
/**************** Render Data ****************/

extern StructRNA RNA_RenderSettings;

PointerRNA RenderSettings_rna_type_get(PointerRNA *ptr);

int RenderSettings_hair_subdiv_get(PointerRNA *ptr);
void RenderSettings_hair_subdiv_set(PointerRNA *ptr, int value);

bool RenderSettings_simplify_gpencil_antialiasing_get(PointerRNA *ptr);
void RenderSettings_simplify_gpencil_antialiasing_set(PointerRNA *ptr, bool value);

void RenderSettings_stamp_background_get(PointerRNA *ptr, float values[4]);
void RenderSettings_stamp_background_set(PointerRNA *ptr, const float values[4]);

PointerRNA RenderSettings_bake_get(PointerRNA *ptr);

enum {
	RenderSettings_bake_type_NORMALS = 0,
	RenderSettings_bake_type_DISPLACEMENT = 1,
};

int RenderSettings_bake_type_get(PointerRNA *ptr);
void RenderSettings_bake_type_set(PointerRNA *ptr, int value);

bool RenderSettings_use_bake_multires_get(PointerRNA *ptr);
void RenderSettings_use_bake_multires_set(PointerRNA *ptr, bool value);

float RenderSettings_bake_bias_get(PointerRNA *ptr);
void RenderSettings_bake_bias_set(PointerRNA *ptr, float value);

bool RenderSettings_use_render_cache_get(PointerRNA *ptr);
void RenderSettings_use_render_cache_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_bake_clear_get(PointerRNA *ptr);
void RenderSettings_use_bake_clear_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_compositing_get(PointerRNA *ptr);
void RenderSettings_use_compositing_set(PointerRNA *ptr, bool value);

enum {
	RenderSettings_compositor_denoise_device_AUTO = 0,
	RenderSettings_compositor_denoise_device_CPU = 1,
	RenderSettings_compositor_denoise_device_GPU = 2,
};

int RenderSettings_compositor_denoise_device_get(PointerRNA *ptr);
void RenderSettings_compositor_denoise_device_set(PointerRNA *ptr, int value);

enum {
	RenderSettings_compositor_device_CPU = 0,
	RenderSettings_compositor_device_GPU = 1,
};

int RenderSettings_compositor_device_get(PointerRNA *ptr);
void RenderSettings_compositor_device_set(PointerRNA *ptr, int value);

enum {
	RenderSettings_compositor_denoise_final_quality_HIGH = 0,
	RenderSettings_compositor_denoise_final_quality_BALANCED = 1,
	RenderSettings_compositor_denoise_final_quality_FAST = 2,
};

int RenderSettings_compositor_denoise_final_quality_get(PointerRNA *ptr);
void RenderSettings_compositor_denoise_final_quality_set(PointerRNA *ptr, int value);

enum {
	RenderSettings_compositor_precision_AUTO = 0,
	RenderSettings_compositor_precision_FULL = 1,
};

int RenderSettings_compositor_precision_get(PointerRNA *ptr);
void RenderSettings_compositor_precision_set(PointerRNA *ptr, int value);

enum {
	RenderSettings_compositor_denoise_preview_quality_HIGH = 0,
	RenderSettings_compositor_denoise_preview_quality_BALANCED = 1,
	RenderSettings_compositor_denoise_preview_quality_FAST = 2,
};

int RenderSettings_compositor_denoise_preview_quality_get(PointerRNA *ptr);
void RenderSettings_compositor_denoise_preview_quality_set(PointerRNA *ptr, int value);

bool RenderSettings_use_crop_to_border_get(PointerRNA *ptr);
void RenderSettings_use_crop_to_border_set(PointerRNA *ptr, bool value);

enum {
	RenderSettings_hair_type_STRAND = 0,
	RenderSettings_hair_type_STRIP = 1,
};

int RenderSettings_hair_type_get(PointerRNA *ptr);
void RenderSettings_hair_type_set(PointerRNA *ptr, int value);

float RenderSettings_dither_intensity_get(PointerRNA *ptr);
void RenderSettings_dither_intensity_set(PointerRNA *ptr, float value);

enum {
	RenderSettings_engine_BLENDER_EEVEE_NEXT = 0,
};

int RenderSettings_engine_get(PointerRNA *ptr);
void RenderSettings_engine_set(PointerRNA *ptr, int value);

void RenderSettings_file_extension_get(PointerRNA *ptr, char *value);
int RenderSettings_file_extension_length(PointerRNA *ptr);
void RenderSettings_file_extension_set(PointerRNA *ptr, const char *value);

PointerRNA RenderSettings_ffmpeg_get(PointerRNA *ptr);

int RenderSettings_fps_get(PointerRNA *ptr);
void RenderSettings_fps_set(PointerRNA *ptr, int value);

float RenderSettings_fps_base_get(PointerRNA *ptr);
void RenderSettings_fps_base_set(PointerRNA *ptr, float value);

bool RenderSettings_use_file_extension_get(PointerRNA *ptr);
void RenderSettings_use_file_extension_set(PointerRNA *ptr, bool value);

bool RenderSettings_simplify_gpencil_view_fill_get(PointerRNA *ptr);
void RenderSettings_simplify_gpencil_view_fill_set(PointerRNA *ptr, bool value);

float RenderSettings_filter_size_get(PointerRNA *ptr);
void RenderSettings_filter_size_set(PointerRNA *ptr, float value);

int RenderSettings_stamp_font_size_get(PointerRNA *ptr);
void RenderSettings_stamp_font_size_set(PointerRNA *ptr, int value);

int RenderSettings_frame_map_new_get(PointerRNA *ptr);
void RenderSettings_frame_map_new_set(PointerRNA *ptr, int value);

int RenderSettings_frame_map_old_get(PointerRNA *ptr);
void RenderSettings_frame_map_old_set(PointerRNA *ptr, int value);

bool RenderSettings_use_high_quality_normals_get(PointerRNA *ptr);
void RenderSettings_use_high_quality_normals_set(PointerRNA *ptr, bool value);

PointerRNA RenderSettings_image_settings_get(PointerRNA *ptr);

bool RenderSettings_simplify_gpencil_tint_get(PointerRNA *ptr);
void RenderSettings_simplify_gpencil_tint_set(PointerRNA *ptr, bool value);

float RenderSettings_line_thickness_get(PointerRNA *ptr);
void RenderSettings_line_thickness_set(PointerRNA *ptr, float value);

enum {
	RenderSettings_line_thickness_mode_ABSOLUTE = 1,
	RenderSettings_line_thickness_mode_RELATIVE = 2,
};

int RenderSettings_line_thickness_mode_get(PointerRNA *ptr);
void RenderSettings_line_thickness_mode_set(PointerRNA *ptr, int value);

bool RenderSettings_use_lock_interface_get(PointerRNA *ptr);
void RenderSettings_use_lock_interface_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_bake_lores_mesh_get(PointerRNA *ptr);
void RenderSettings_use_bake_lores_mesh_set(PointerRNA *ptr, bool value);

int RenderSettings_bake_margin_get(PointerRNA *ptr);
void RenderSettings_bake_margin_set(PointerRNA *ptr, int value);

enum {
	RenderSettings_bake_margin_type_ADJACENT_FACES = 0,
	RenderSettings_bake_margin_type_EXTEND = 1,
};

int RenderSettings_bake_margin_type_get(PointerRNA *ptr);
void RenderSettings_bake_margin_type_set(PointerRNA *ptr, int value);

bool RenderSettings_use_simplify_normals_get(PointerRNA *ptr);
void RenderSettings_use_simplify_normals_set(PointerRNA *ptr, bool value);

enum {
	RenderSettings_metadata_input_SCENE = 0,
	RenderSettings_metadata_input_STRIPS = 4096,
};

int RenderSettings_metadata_input_get(PointerRNA *ptr);
void RenderSettings_metadata_input_set(PointerRNA *ptr, int value);

bool RenderSettings_simplify_gpencil_modifier_get(PointerRNA *ptr);
void RenderSettings_simplify_gpencil_modifier_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_motion_blur_get(PointerRNA *ptr);
void RenderSettings_use_motion_blur_set(PointerRNA *ptr, bool value);

enum {
	RenderSettings_motion_blur_position_START = 1,
	RenderSettings_motion_blur_position_CENTER = 0,
	RenderSettings_motion_blur_position_END = 2,
};

int RenderSettings_motion_blur_position_get(PointerRNA *ptr);
void RenderSettings_motion_blur_position_set(PointerRNA *ptr, int value);

bool RenderSettings_is_movie_format_get(PointerRNA *ptr);
void RenderSettings_is_movie_format_set(PointerRNA *ptr, bool value);

bool RenderSettings_has_multiple_engines_get(PointerRNA *ptr);
void RenderSettings_has_multiple_engines_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_multiview_get(PointerRNA *ptr);
void RenderSettings_use_multiview_set(PointerRNA *ptr, bool value);

#define RenderSettings_filepath_MAX 1024

void RenderSettings_filepath_get(PointerRNA *ptr, char *value);
int RenderSettings_filepath_length(PointerRNA *ptr);
void RenderSettings_filepath_set(PointerRNA *ptr, const char *value);

bool RenderSettings_use_sequencer_override_scene_strip_get(PointerRNA *ptr);
void RenderSettings_use_sequencer_override_scene_strip_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_overwrite_get(PointerRNA *ptr);
void RenderSettings_use_overwrite_set(PointerRNA *ptr, bool value);

float RenderSettings_ppm_base_get(PointerRNA *ptr);
void RenderSettings_ppm_base_set(PointerRNA *ptr, float value);

float RenderSettings_ppm_factor_get(PointerRNA *ptr);
void RenderSettings_ppm_factor_set(PointerRNA *ptr, float value);

bool RenderSettings_use_persistent_data_get(PointerRNA *ptr);
void RenderSettings_use_persistent_data_set(PointerRNA *ptr, bool value);

float RenderSettings_pixel_aspect_x_get(PointerRNA *ptr);
void RenderSettings_pixel_aspect_x_set(PointerRNA *ptr, float value);

float RenderSettings_pixel_aspect_y_get(PointerRNA *ptr);
void RenderSettings_pixel_aspect_y_set(PointerRNA *ptr, float value);

enum {
	RenderSettings_preview_pixel_size_AUTO = 0,
	RenderSettings_preview_pixel_size_1 = 1,
	RenderSettings_preview_pixel_size_2 = 2,
	RenderSettings_preview_pixel_size_4 = 4,
	RenderSettings_preview_pixel_size_8 = 8,
};

int RenderSettings_preview_pixel_size_get(PointerRNA *ptr);
void RenderSettings_preview_pixel_size_set(PointerRNA *ptr, int value);

bool RenderSettings_use_placeholder_get(PointerRNA *ptr);
void RenderSettings_use_placeholder_set(PointerRNA *ptr, bool value);

bool RenderSettings_simplify_gpencil_onplay_get(PointerRNA *ptr);
void RenderSettings_simplify_gpencil_onplay_set(PointerRNA *ptr, bool value);

float RenderSettings_border_max_x_get(PointerRNA *ptr);
void RenderSettings_border_max_x_set(PointerRNA *ptr, float value);

float RenderSettings_border_max_y_get(PointerRNA *ptr);
void RenderSettings_border_max_y_set(PointerRNA *ptr, float value);

float RenderSettings_border_min_x_get(PointerRNA *ptr);
void RenderSettings_border_min_x_set(PointerRNA *ptr, float value);

float RenderSettings_border_min_y_get(PointerRNA *ptr);
void RenderSettings_border_min_y_set(PointerRNA *ptr, float value);

bool RenderSettings_use_border_get(PointerRNA *ptr);
void RenderSettings_use_border_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_single_layer_get(PointerRNA *ptr);
void RenderSettings_use_single_layer_set(PointerRNA *ptr, bool value);

void RenderSettings_views_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void RenderSettings_views_next(CollectionPropertyIterator *iter);
void RenderSettings_views_end(CollectionPropertyIterator *iter);
bool RenderSettings_views_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool RenderSettings_views_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void RenderSettings_stereo_views_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void RenderSettings_stereo_views_next(CollectionPropertyIterator *iter);
void RenderSettings_stereo_views_end(CollectionPropertyIterator *iter);
bool RenderSettings_stereo_views_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool RenderSettings_stereo_views_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

int RenderSettings_resolution_percentage_get(PointerRNA *ptr);
void RenderSettings_resolution_percentage_set(PointerRNA *ptr, int value);

int RenderSettings_resolution_x_get(PointerRNA *ptr);
void RenderSettings_resolution_x_set(PointerRNA *ptr, int value);

int RenderSettings_resolution_y_get(PointerRNA *ptr);
void RenderSettings_resolution_y_set(PointerRNA *ptr, int value);

int RenderSettings_bake_samples_get(PointerRNA *ptr);
void RenderSettings_bake_samples_set(PointerRNA *ptr, int value);

float RenderSettings_bake_user_scale_get(PointerRNA *ptr);
void RenderSettings_bake_user_scale_set(PointerRNA *ptr, float value);

bool RenderSettings_use_bake_selected_to_active_get(PointerRNA *ptr);
void RenderSettings_use_bake_selected_to_active_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_sequencer_get(PointerRNA *ptr);
void RenderSettings_use_sequencer_set(PointerRNA *ptr, bool value);

enum {
	RenderSettings_sequencer_gl_preview_WIREFRAME = 2,
	RenderSettings_sequencer_gl_preview_SOLID = 3,
	RenderSettings_sequencer_gl_preview_MATERIAL = 4,
	RenderSettings_sequencer_gl_preview_RENDERED = 6,
};

int RenderSettings_sequencer_gl_preview_get(PointerRNA *ptr);
void RenderSettings_sequencer_gl_preview_set(PointerRNA *ptr, int value);

enum {
	RenderSettings_views_format_STEREO_3D = 0,
	RenderSettings_views_format_MULTIVIEW = 1,
};

int RenderSettings_views_format_get(PointerRNA *ptr);
void RenderSettings_views_format_set(PointerRNA *ptr, int value);

bool RenderSettings_simplify_gpencil_shader_fx_get(PointerRNA *ptr);
void RenderSettings_simplify_gpencil_shader_fx_set(PointerRNA *ptr, bool value);

float RenderSettings_motion_blur_shutter_get(PointerRNA *ptr);
void RenderSettings_motion_blur_shutter_set(PointerRNA *ptr, float value);

PointerRNA RenderSettings_motion_blur_shutter_curve_get(PointerRNA *ptr);

bool RenderSettings_simplify_gpencil_get(PointerRNA *ptr);
void RenderSettings_simplify_gpencil_set(PointerRNA *ptr, bool value);

float RenderSettings_simplify_child_particles_get(PointerRNA *ptr);
void RenderSettings_simplify_child_particles_set(PointerRNA *ptr, float value);

float RenderSettings_simplify_child_particles_render_get(PointerRNA *ptr);
void RenderSettings_simplify_child_particles_render_set(PointerRNA *ptr, float value);

int RenderSettings_simplify_subdivision_get(PointerRNA *ptr);
void RenderSettings_simplify_subdivision_set(PointerRNA *ptr, int value);

int RenderSettings_simplify_subdivision_render_get(PointerRNA *ptr);
void RenderSettings_simplify_subdivision_render_set(PointerRNA *ptr, int value);

float RenderSettings_simplify_volumes_get(PointerRNA *ptr);
void RenderSettings_simplify_volumes_set(PointerRNA *ptr, float value);

bool RenderSettings_use_stamp_camera_get(PointerRNA *ptr);
void RenderSettings_use_stamp_camera_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_stamp_date_get(PointerRNA *ptr);
void RenderSettings_use_stamp_date_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_stamp_filename_get(PointerRNA *ptr);
void RenderSettings_use_stamp_filename_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_stamp_frame_get(PointerRNA *ptr);
void RenderSettings_use_stamp_frame_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_stamp_frame_range_get(PointerRNA *ptr);
void RenderSettings_use_stamp_frame_range_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_stamp_hostname_get(PointerRNA *ptr);
void RenderSettings_use_stamp_hostname_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_stamp_labels_get(PointerRNA *ptr);
void RenderSettings_use_stamp_labels_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_stamp_lens_get(PointerRNA *ptr);
void RenderSettings_use_stamp_lens_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_stamp_marker_get(PointerRNA *ptr);
void RenderSettings_use_stamp_marker_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_stamp_note_get(PointerRNA *ptr);
void RenderSettings_use_stamp_note_set(PointerRNA *ptr, bool value);

#define RenderSettings_stamp_note_text_MAX 768

void RenderSettings_stamp_note_text_get(PointerRNA *ptr, char *value);
int RenderSettings_stamp_note_text_length(PointerRNA *ptr);
void RenderSettings_stamp_note_text_set(PointerRNA *ptr, const char *value);

bool RenderSettings_use_stamp_get(PointerRNA *ptr);
void RenderSettings_use_stamp_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_stamp_memory_get(PointerRNA *ptr);
void RenderSettings_use_stamp_memory_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_stamp_render_time_get(PointerRNA *ptr);
void RenderSettings_use_stamp_render_time_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_stamp_scene_get(PointerRNA *ptr);
void RenderSettings_use_stamp_scene_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_stamp_sequencer_strip_get(PointerRNA *ptr);
void RenderSettings_use_stamp_sequencer_strip_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_stamp_time_get(PointerRNA *ptr);
void RenderSettings_use_stamp_time_set(PointerRNA *ptr, bool value);

void RenderSettings_stamp_foreground_get(PointerRNA *ptr, float values[4]);
void RenderSettings_stamp_foreground_set(PointerRNA *ptr, const float values[4]);

int RenderSettings_threads_get(PointerRNA *ptr);
void RenderSettings_threads_set(PointerRNA *ptr, int value);

enum {
	RenderSettings_threads_mode_AUTO = 0,
	RenderSettings_threads_mode_FIXED = 524288,
};

int RenderSettings_threads_mode_get(PointerRNA *ptr);
void RenderSettings_threads_mode_set(PointerRNA *ptr, int value);

bool RenderSettings_film_transparent_get(PointerRNA *ptr);
void RenderSettings_film_transparent_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_freestyle_get(PointerRNA *ptr);
void RenderSettings_use_freestyle_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_simplify_get(PointerRNA *ptr);
void RenderSettings_use_simplify_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_spherical_stereo_get(PointerRNA *ptr);
void RenderSettings_use_spherical_stereo_set(PointerRNA *ptr, bool value);

bool RenderSettings_use_bake_user_scale_get(PointerRNA *ptr);
void RenderSettings_use_bake_user_scale_set(PointerRNA *ptr, bool value);

void RenderSettings_frame_path_func(struct RenderData *_self, Main *bmain, ReportList *reports, int frame, bool preview, const char * view, char * filepath);
/**************** Render Slot ****************/

extern StructRNA RNA_RenderSlot;

PointerRNA RenderSlot_rna_type_get(PointerRNA *ptr);

#define RenderSlot_name_MAX 64

void RenderSlot_name_get(PointerRNA *ptr, char *value);
int RenderSlot_name_length(PointerRNA *ptr);
void RenderSlot_name_set(PointerRNA *ptr, const char *value);

void RenderSlot_clear_func(struct ID *_selfid, struct RenderSlot *_self, struct ImageUser *iuser);
/**************** Render Layers ****************/

extern StructRNA RNA_RenderSlots;

PointerRNA RenderSlots_rna_type_get(PointerRNA *ptr);

int RenderSlots_active_index_get(PointerRNA *ptr);
void RenderSlots_active_index_set(PointerRNA *ptr, int value);

PointerRNA RenderSlots_active_get(PointerRNA *ptr);

struct RenderSlot *RenderSlots_new_func(struct Image *_self, const char * name);
/**************** Render View ****************/

extern StructRNA RNA_RenderView;

PointerRNA RenderView_rna_type_get(PointerRNA *ptr);

void RenderView_name_get(PointerRNA *ptr, char *value);
int RenderView_name_length(PointerRNA *ptr);
void RenderView_name_set(PointerRNA *ptr, const char *value);

/**************** Render Views ****************/

extern StructRNA RNA_RenderViews;

PointerRNA RenderViews_rna_type_get(PointerRNA *ptr);

PointerRNA RenderViews_active_get(PointerRNA *ptr);

int RenderViews_active_index_get(PointerRNA *ptr);
void RenderViews_active_index_set(PointerRNA *ptr, int value);

struct SceneRenderView *RenderViews_new_func(struct ID *_selfid, struct RenderData *_self, const char * name);
void RenderViews_remove_func(struct ID *_selfid, struct RenderData *_self, Main *bmain, ReportList *reports, struct PointerRNA *view);
/**************** Repeat Item ****************/

extern StructRNA RNA_RepeatItem;

PointerRNA RepeatItem_rna_type_get(PointerRNA *ptr);

void RepeatItem_name_get(PointerRNA *ptr, char *value);
int RepeatItem_name_length(PointerRNA *ptr);
void RepeatItem_name_set(PointerRNA *ptr, const char *value);

void RepeatItem_color_get(PointerRNA *ptr, float values[4]);
void RepeatItem_color_set(PointerRNA *ptr, const float values[4]);

enum {
	RepeatItem_socket_type_FLOAT = 0,
	RepeatItem_socket_type_INT = 6,
	RepeatItem_socket_type_BOOLEAN = 4,
	RepeatItem_socket_type_VECTOR = 1,
	RepeatItem_socket_type_ROTATION = 14,
	RepeatItem_socket_type_MATRIX = 16,
	RepeatItem_socket_type_STRING = 7,
	RepeatItem_socket_type_MENU = 15,
	RepeatItem_socket_type_RGBA = 2,
	RepeatItem_socket_type_OBJECT = 8,
	RepeatItem_socket_type_IMAGE = 9,
	RepeatItem_socket_type_GEOMETRY = 10,
	RepeatItem_socket_type_COLLECTION = 11,
	RepeatItem_socket_type_TEXTURE = 12,
	RepeatItem_socket_type_MATERIAL = 13,
	RepeatItem_socket_type_BUNDLE = 17,
	RepeatItem_socket_type_CLOSURE = 18,
};

int RepeatItem_socket_type_get(PointerRNA *ptr);
void RepeatItem_socket_type_set(PointerRNA *ptr, int value);

/**************** RepeatZoneViewerPathElem ****************/

extern StructRNA RNA_RepeatZoneViewerPathElem;
extern StructRNA RNA_ViewerPathElem;

int RepeatZoneViewerPathElem_repeat_output_node_id_get(PointerRNA *ptr);
void RepeatZoneViewerPathElem_repeat_output_node_id_set(PointerRNA *ptr, int value);

/**************** Retiming Key ****************/

extern StructRNA RNA_RetimingKey;

PointerRNA RetimingKey_rna_type_get(PointerRNA *ptr);

int RetimingKey_timeline_frame_get(PointerRNA *ptr);
void RetimingKey_timeline_frame_set(PointerRNA *ptr, int value);

void RetimingKey_remove_func(struct ID *_selfid, struct SeqRetimingKey *_self);
/**************** RetimingKeys ****************/

extern StructRNA RNA_RetimingKeys;

PointerRNA RetimingKeys_rna_type_get(PointerRNA *ptr);

struct SeqRetimingKey *RetimingKeys_add_func(struct ID *_selfid, struct Strip *_self, int timeline_frame);
void RetimingKeys_reset_func(struct ID *_selfid, struct Strip *_self);
/**************** Rigid Body Constraint ****************/

extern StructRNA RNA_RigidBodyConstraint;

PointerRNA RigidBodyConstraint_rna_type_get(PointerRNA *ptr);

bool RigidBodyConstraint_use_motor_ang_get(PointerRNA *ptr);
void RigidBodyConstraint_use_motor_ang_set(PointerRNA *ptr, bool value);

bool RigidBodyConstraint_use_breaking_get(PointerRNA *ptr);
void RigidBodyConstraint_use_breaking_set(PointerRNA *ptr, bool value);

float RigidBodyConstraint_breaking_threshold_get(PointerRNA *ptr);
void RigidBodyConstraint_breaking_threshold_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_spring_damping_x_get(PointerRNA *ptr);
void RigidBodyConstraint_spring_damping_x_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_spring_damping_ang_x_get(PointerRNA *ptr);
void RigidBodyConstraint_spring_damping_ang_x_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_spring_damping_y_get(PointerRNA *ptr);
void RigidBodyConstraint_spring_damping_y_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_spring_damping_ang_y_get(PointerRNA *ptr);
void RigidBodyConstraint_spring_damping_ang_y_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_spring_damping_z_get(PointerRNA *ptr);
void RigidBodyConstraint_spring_damping_z_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_spring_damping_ang_z_get(PointerRNA *ptr);
void RigidBodyConstraint_spring_damping_ang_z_set(PointerRNA *ptr, float value);

bool RigidBodyConstraint_disable_collisions_get(PointerRNA *ptr);
void RigidBodyConstraint_disable_collisions_set(PointerRNA *ptr, bool value);

bool RigidBodyConstraint_enabled_get(PointerRNA *ptr);
void RigidBodyConstraint_enabled_set(PointerRNA *ptr, bool value);

bool RigidBodyConstraint_use_motor_lin_get(PointerRNA *ptr);
void RigidBodyConstraint_use_motor_lin_set(PointerRNA *ptr, bool value);

float RigidBodyConstraint_limit_ang_x_lower_get(PointerRNA *ptr);
void RigidBodyConstraint_limit_ang_x_lower_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_limit_lin_x_lower_get(PointerRNA *ptr);
void RigidBodyConstraint_limit_lin_x_lower_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_limit_ang_y_lower_get(PointerRNA *ptr);
void RigidBodyConstraint_limit_ang_y_lower_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_limit_lin_y_lower_get(PointerRNA *ptr);
void RigidBodyConstraint_limit_lin_y_lower_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_limit_ang_z_lower_get(PointerRNA *ptr);
void RigidBodyConstraint_limit_ang_z_lower_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_limit_lin_z_lower_get(PointerRNA *ptr);
void RigidBodyConstraint_limit_lin_z_lower_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_motor_lin_max_impulse_get(PointerRNA *ptr);
void RigidBodyConstraint_motor_lin_max_impulse_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_motor_ang_max_impulse_get(PointerRNA *ptr);
void RigidBodyConstraint_motor_ang_max_impulse_set(PointerRNA *ptr, float value);

PointerRNA RigidBodyConstraint_object1_get(PointerRNA *ptr);

PointerRNA RigidBodyConstraint_object2_get(PointerRNA *ptr);

bool RigidBodyConstraint_use_override_solver_iterations_get(PointerRNA *ptr);
void RigidBodyConstraint_use_override_solver_iterations_set(PointerRNA *ptr, bool value);

int RigidBodyConstraint_solver_iterations_get(PointerRNA *ptr);
void RigidBodyConstraint_solver_iterations_set(PointerRNA *ptr, int value);

enum {
	RigidBodyConstraint_spring_type_SPRING1 = 0,
	RigidBodyConstraint_spring_type_SPRING2 = 1,
};

int RigidBodyConstraint_spring_type_get(PointerRNA *ptr);
void RigidBodyConstraint_spring_type_set(PointerRNA *ptr, int value);

float RigidBodyConstraint_motor_lin_target_velocity_get(PointerRNA *ptr);
void RigidBodyConstraint_motor_lin_target_velocity_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_motor_ang_target_velocity_get(PointerRNA *ptr);
void RigidBodyConstraint_motor_ang_target_velocity_set(PointerRNA *ptr, float value);

enum {
	RigidBodyConstraint_type_FIXED = 8,
	RigidBodyConstraint_type_POINT = 0,
	RigidBodyConstraint_type_HINGE = 1,
	RigidBodyConstraint_type_SLIDER = 3,
	RigidBodyConstraint_type_PISTON = 9,
	RigidBodyConstraint_type_GENERIC = 5,
	RigidBodyConstraint_type_GENERIC_SPRING = 6,
	RigidBodyConstraint_type_MOTOR = 11,
};

int RigidBodyConstraint_type_get(PointerRNA *ptr);
void RigidBodyConstraint_type_set(PointerRNA *ptr, int value);

float RigidBodyConstraint_limit_ang_x_upper_get(PointerRNA *ptr);
void RigidBodyConstraint_limit_ang_x_upper_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_limit_lin_x_upper_get(PointerRNA *ptr);
void RigidBodyConstraint_limit_lin_x_upper_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_limit_ang_y_upper_get(PointerRNA *ptr);
void RigidBodyConstraint_limit_ang_y_upper_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_limit_lin_y_upper_get(PointerRNA *ptr);
void RigidBodyConstraint_limit_lin_y_upper_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_limit_ang_z_upper_get(PointerRNA *ptr);
void RigidBodyConstraint_limit_ang_z_upper_set(PointerRNA *ptr, float value);

float RigidBodyConstraint_limit_lin_z_upper_get(PointerRNA *ptr);
void RigidBodyConstraint_limit_lin_z_upper_set(PointerRNA *ptr, float value);

bool RigidBodyConstraint_use_limit_ang_x_get(PointerRNA *ptr);
void RigidBodyConstraint_use_limit_ang_x_set(PointerRNA *ptr, bool value);

bool RigidBodyConstraint_use_spring_ang_x_get(PointerRNA *ptr);
void RigidBodyConstraint_use_spring_ang_x_set(PointerRNA *ptr, bool value);

float RigidBodyConstraint_spring_stiffness_ang_x_get(PointerRNA *ptr);
void RigidBodyConstraint_spring_stiffness_ang_x_set(PointerRNA *ptr, float value);

bool RigidBodyConstraint_use_limit_lin_x_get(PointerRNA *ptr);
void RigidBodyConstraint_use_limit_lin_x_set(PointerRNA *ptr, bool value);

float RigidBodyConstraint_spring_stiffness_x_get(PointerRNA *ptr);
void RigidBodyConstraint_spring_stiffness_x_set(PointerRNA *ptr, float value);

bool RigidBodyConstraint_use_spring_x_get(PointerRNA *ptr);
void RigidBodyConstraint_use_spring_x_set(PointerRNA *ptr, bool value);

bool RigidBodyConstraint_use_limit_ang_y_get(PointerRNA *ptr);
void RigidBodyConstraint_use_limit_ang_y_set(PointerRNA *ptr, bool value);

bool RigidBodyConstraint_use_spring_ang_y_get(PointerRNA *ptr);
void RigidBodyConstraint_use_spring_ang_y_set(PointerRNA *ptr, bool value);

float RigidBodyConstraint_spring_stiffness_ang_y_get(PointerRNA *ptr);
void RigidBodyConstraint_spring_stiffness_ang_y_set(PointerRNA *ptr, float value);

bool RigidBodyConstraint_use_limit_lin_y_get(PointerRNA *ptr);
void RigidBodyConstraint_use_limit_lin_y_set(PointerRNA *ptr, bool value);

float RigidBodyConstraint_spring_stiffness_y_get(PointerRNA *ptr);
void RigidBodyConstraint_spring_stiffness_y_set(PointerRNA *ptr, float value);

bool RigidBodyConstraint_use_spring_y_get(PointerRNA *ptr);
void RigidBodyConstraint_use_spring_y_set(PointerRNA *ptr, bool value);

bool RigidBodyConstraint_use_limit_ang_z_get(PointerRNA *ptr);
void RigidBodyConstraint_use_limit_ang_z_set(PointerRNA *ptr, bool value);

bool RigidBodyConstraint_use_spring_ang_z_get(PointerRNA *ptr);
void RigidBodyConstraint_use_spring_ang_z_set(PointerRNA *ptr, bool value);

float RigidBodyConstraint_spring_stiffness_ang_z_get(PointerRNA *ptr);
void RigidBodyConstraint_spring_stiffness_ang_z_set(PointerRNA *ptr, float value);

bool RigidBodyConstraint_use_limit_lin_z_get(PointerRNA *ptr);
void RigidBodyConstraint_use_limit_lin_z_set(PointerRNA *ptr, bool value);

float RigidBodyConstraint_spring_stiffness_z_get(PointerRNA *ptr);
void RigidBodyConstraint_spring_stiffness_z_set(PointerRNA *ptr, float value);

bool RigidBodyConstraint_use_spring_z_get(PointerRNA *ptr);
void RigidBodyConstraint_use_spring_z_set(PointerRNA *ptr, bool value);

/**************** Rigid Body Object ****************/

extern StructRNA RNA_RigidBodyObject;

PointerRNA RigidBodyObject_rna_type_get(PointerRNA *ptr);

float RigidBodyObject_angular_damping_get(PointerRNA *ptr);
void RigidBodyObject_angular_damping_set(PointerRNA *ptr, float value);

float RigidBodyObject_deactivate_angular_velocity_get(PointerRNA *ptr);
void RigidBodyObject_deactivate_angular_velocity_set(PointerRNA *ptr, float value);

float RigidBodyObject_restitution_get(PointerRNA *ptr);
void RigidBodyObject_restitution_set(PointerRNA *ptr, float value);

void RigidBodyObject_collision_collections_get(PointerRNA *ptr, bool values[20]);
void RigidBodyObject_collision_collections_set(PointerRNA *ptr, const bool values[20]);

bool RigidBodyObject_use_margin_get(PointerRNA *ptr);
void RigidBodyObject_use_margin_set(PointerRNA *ptr, bool value);

float RigidBodyObject_collision_margin_get(PointerRNA *ptr);
void RigidBodyObject_collision_margin_set(PointerRNA *ptr, float value);

enum {
	RigidBodyObject_collision_shape_BOX = 0,
	RigidBodyObject_collision_shape_SPHERE = 1,
	RigidBodyObject_collision_shape_CAPSULE = 2,
	RigidBodyObject_collision_shape_CYLINDER = 3,
	RigidBodyObject_collision_shape_CONE = 4,
	RigidBodyObject_collision_shape_CONVEX_HULL = 5,
	RigidBodyObject_collision_shape_MESH = 6,
	RigidBodyObject_collision_shape_COMPOUND = 7,
};

int RigidBodyObject_collision_shape_get(PointerRNA *ptr);
void RigidBodyObject_collision_shape_set(PointerRNA *ptr, int value);

bool RigidBodyObject_use_deform_get(PointerRNA *ptr);
void RigidBodyObject_use_deform_set(PointerRNA *ptr, bool value);

bool RigidBodyObject_use_deactivation_get(PointerRNA *ptr);
void RigidBodyObject_use_deactivation_set(PointerRNA *ptr, bool value);

bool RigidBodyObject_enabled_get(PointerRNA *ptr);
void RigidBodyObject_enabled_set(PointerRNA *ptr, bool value);

float RigidBodyObject_friction_get(PointerRNA *ptr);
void RigidBodyObject_friction_set(PointerRNA *ptr, float value);

bool RigidBodyObject_kinematic_get(PointerRNA *ptr);
void RigidBodyObject_kinematic_set(PointerRNA *ptr, bool value);

float RigidBodyObject_linear_damping_get(PointerRNA *ptr);
void RigidBodyObject_linear_damping_set(PointerRNA *ptr, float value);

float RigidBodyObject_deactivate_linear_velocity_get(PointerRNA *ptr);
void RigidBodyObject_deactivate_linear_velocity_set(PointerRNA *ptr, float value);

float RigidBodyObject_mass_get(PointerRNA *ptr);
void RigidBodyObject_mass_set(PointerRNA *ptr, float value);

enum {
	RigidBodyObject_mesh_source_BASE = 0,
	RigidBodyObject_mesh_source_DEFORM = 1,
	RigidBodyObject_mesh_source_FINAL = 2,
};

int RigidBodyObject_mesh_source_get(PointerRNA *ptr);
void RigidBodyObject_mesh_source_set(PointerRNA *ptr, int value);

bool RigidBodyObject_use_start_deactivated_get(PointerRNA *ptr);
void RigidBodyObject_use_start_deactivated_set(PointerRNA *ptr, bool value);

enum {
	RigidBodyObject_type_ACTIVE = 0,
	RigidBodyObject_type_PASSIVE = 1,
};

int RigidBodyObject_type_get(PointerRNA *ptr);
void RigidBodyObject_type_set(PointerRNA *ptr, int value);

/**************** Rigid Body World ****************/

extern StructRNA RNA_RigidBodyWorld;

PointerRNA RigidBodyWorld_rna_type_get(PointerRNA *ptr);

PointerRNA RigidBodyWorld_collection_get(PointerRNA *ptr);

PointerRNA RigidBodyWorld_constraints_get(PointerRNA *ptr);

PointerRNA RigidBodyWorld_effector_weights_get(PointerRNA *ptr);

bool RigidBodyWorld_enabled_get(PointerRNA *ptr);
void RigidBodyWorld_enabled_set(PointerRNA *ptr, bool value);

PointerRNA RigidBodyWorld_point_cache_get(PointerRNA *ptr);

int RigidBodyWorld_solver_iterations_get(PointerRNA *ptr);
void RigidBodyWorld_solver_iterations_set(PointerRNA *ptr, int value);

bool RigidBodyWorld_use_split_impulse_get(PointerRNA *ptr);
void RigidBodyWorld_use_split_impulse_set(PointerRNA *ptr, bool value);

int RigidBodyWorld_substeps_per_frame_get(PointerRNA *ptr);
void RigidBodyWorld_substeps_per_frame_set(PointerRNA *ptr, int value);

float RigidBodyWorld_time_scale_get(PointerRNA *ptr);
void RigidBodyWorld_time_scale_set(PointerRNA *ptr, float value);

void RigidBodyWorld_convex_sweep_test_func(struct RigidBodyWorld *_self, ReportList *reports, struct Object *object, float start[3], float end[3], float object_location[3], float hitpoint[3], float normal[3], int *has_hit);
/**************** SPH Fluid Settings ****************/

extern StructRNA RNA_SPHFluidSettings;

PointerRNA SPHFluidSettings_rna_type_get(PointerRNA *ptr);

float SPHFluidSettings_buoyancy_get(PointerRNA *ptr);
void SPHFluidSettings_buoyancy_set(PointerRNA *ptr, float value);

float SPHFluidSettings_yield_ratio_get(PointerRNA *ptr);
void SPHFluidSettings_yield_ratio_set(PointerRNA *ptr, float value);

bool SPHFluidSettings_use_factor_density_get(PointerRNA *ptr);
void SPHFluidSettings_use_factor_density_set(PointerRNA *ptr, bool value);

bool SPHFluidSettings_use_factor_radius_get(PointerRNA *ptr);
void SPHFluidSettings_use_factor_radius_set(PointerRNA *ptr, bool value);

bool SPHFluidSettings_use_factor_repulsion_get(PointerRNA *ptr);
void SPHFluidSettings_use_factor_repulsion_set(PointerRNA *ptr, bool value);

bool SPHFluidSettings_use_factor_rest_length_get(PointerRNA *ptr);
void SPHFluidSettings_use_factor_rest_length_set(PointerRNA *ptr, bool value);

bool SPHFluidSettings_use_factor_stiff_viscosity_get(PointerRNA *ptr);
void SPHFluidSettings_use_factor_stiff_viscosity_set(PointerRNA *ptr, bool value);

bool SPHFluidSettings_use_initial_rest_length_get(PointerRNA *ptr);
void SPHFluidSettings_use_initial_rest_length_set(PointerRNA *ptr, bool value);

float SPHFluidSettings_fluid_radius_get(PointerRNA *ptr);
void SPHFluidSettings_fluid_radius_set(PointerRNA *ptr, float value);

float SPHFluidSettings_plasticity_get(PointerRNA *ptr);
void SPHFluidSettings_plasticity_set(PointerRNA *ptr, float value);

float SPHFluidSettings_repulsion_get(PointerRNA *ptr);
void SPHFluidSettings_repulsion_set(PointerRNA *ptr, float value);

float SPHFluidSettings_rest_density_get(PointerRNA *ptr);
void SPHFluidSettings_rest_density_set(PointerRNA *ptr, float value);

float SPHFluidSettings_rest_length_get(PointerRNA *ptr);
void SPHFluidSettings_rest_length_set(PointerRNA *ptr, float value);

enum {
	SPHFluidSettings_solver_DDR = 0,
	SPHFluidSettings_solver_CLASSICAL = 1,
};

int SPHFluidSettings_solver_get(PointerRNA *ptr);
void SPHFluidSettings_solver_set(PointerRNA *ptr, int value);

float SPHFluidSettings_spring_force_get(PointerRNA *ptr);
void SPHFluidSettings_spring_force_set(PointerRNA *ptr, float value);

int SPHFluidSettings_spring_frames_get(PointerRNA *ptr);
void SPHFluidSettings_spring_frames_set(PointerRNA *ptr, int value);

float SPHFluidSettings_stiff_viscosity_get(PointerRNA *ptr);
void SPHFluidSettings_stiff_viscosity_set(PointerRNA *ptr, float value);

float SPHFluidSettings_stiffness_get(PointerRNA *ptr);
void SPHFluidSettings_stiffness_set(PointerRNA *ptr, float value);

bool SPHFluidSettings_use_viscoelastic_springs_get(PointerRNA *ptr);
void SPHFluidSettings_use_viscoelastic_springs_set(PointerRNA *ptr, bool value);

float SPHFluidSettings_linear_viscosity_get(PointerRNA *ptr);
void SPHFluidSettings_linear_viscosity_set(PointerRNA *ptr, float value);

/**************** Scene ****************/

extern StructRNA RNA_Scene;
extern StructRNA RNA_ID;

PointerRNA Scene_cursor_get(PointerRNA *ptr);

void Scene_keying_sets_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Scene_keying_sets_next(CollectionPropertyIterator *iter);
void Scene_keying_sets_end(CollectionPropertyIterator *iter);
bool Scene_keying_sets_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Scene_keying_sets_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

PointerRNA Scene_active_clip_get(PointerRNA *ptr);

void Scene_keying_sets_all_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Scene_keying_sets_all_next(CollectionPropertyIterator *iter);
void Scene_keying_sets_all_end(CollectionPropertyIterator *iter);

PointerRNA Scene_animation_data_get(PointerRNA *ptr);

PointerRNA Scene_grease_pencil_get(PointerRNA *ptr);

bool Scene_use_audio_scrub_get(PointerRNA *ptr);
void Scene_use_audio_scrub_set(PointerRNA *ptr, bool value);

PointerRNA Scene_background_set_get(PointerRNA *ptr);

PointerRNA Scene_camera_get(PointerRNA *ptr);

PointerRNA Scene_collection_get(PointerRNA *ptr);

int Scene_frame_current_get(PointerRNA *ptr);
void Scene_frame_current_set(PointerRNA *ptr, int value);

float Scene_frame_current_final_get(PointerRNA *ptr);
void Scene_frame_current_final_set(PointerRNA *ptr, float value);

float Scene_frame_subframe_get(PointerRNA *ptr);
void Scene_frame_subframe_set(PointerRNA *ptr, float value);

float Scene_frame_float_get(PointerRNA *ptr);
void Scene_frame_float_set(PointerRNA *ptr, float value);

bool Scene_use_custom_simulation_range_get(PointerRNA *ptr);
void Scene_use_custom_simulation_range_set(PointerRNA *ptr, bool value);

PointerRNA Scene_display_settings_get(PointerRNA *ptr);

enum {
	Scene_audio_distance_model_NONE = 0,
	Scene_audio_distance_model_INVERSE = 1,
	Scene_audio_distance_model_INVERSE_CLAMPED = 2,
	Scene_audio_distance_model_LINEAR = 3,
	Scene_audio_distance_model_LINEAR_CLAMPED = 4,
	Scene_audio_distance_model_EXPONENT = 5,
	Scene_audio_distance_model_EXPONENT_CLAMPED = 6,
};

int Scene_audio_distance_model_get(PointerRNA *ptr);
void Scene_audio_distance_model_set(PointerRNA *ptr, int value);

float Scene_audio_doppler_factor_get(PointerRNA *ptr);
void Scene_audio_doppler_factor_set(PointerRNA *ptr, float value);

PointerRNA Scene_eevee_get(PointerRNA *ptr);

int Scene_frame_end_get(PointerRNA *ptr);
void Scene_frame_end_set(PointerRNA *ptr, int value);

int Scene_frame_step_get(PointerRNA *ptr);
void Scene_frame_step_set(PointerRNA *ptr, int value);

bool Scene_use_gravity_get(PointerRNA *ptr);
void Scene_use_gravity_set(PointerRNA *ptr, bool value);

void Scene_gravity_get(PointerRNA *ptr, float values[3]);
void Scene_gravity_set(PointerRNA *ptr, const float values[3]);

PointerRNA Scene_grease_pencil_settings_get(PointerRNA *ptr);

PointerRNA Scene_hydra_get(PointerRNA *ptr);

bool Scene_lock_frame_selection_to_range_get(PointerRNA *ptr);
void Scene_lock_frame_selection_to_range_set(PointerRNA *ptr, bool value);

bool Scene_is_nla_tweakmode_get(PointerRNA *ptr);
void Scene_is_nla_tweakmode_set(PointerRNA *ptr, bool value);

PointerRNA Scene_node_tree_get(PointerRNA *ptr);

void Scene_objects_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Scene_objects_next(CollectionPropertyIterator *iter);
void Scene_objects_end(CollectionPropertyIterator *iter);

bool Scene_show_keys_from_selected_only_get(PointerRNA *ptr);
void Scene_show_keys_from_selected_only_set(PointerRNA *ptr, bool value);

bool Scene_use_audio_get(PointerRNA *ptr);
void Scene_use_audio_set(PointerRNA *ptr, bool value);

int Scene_frame_preview_end_get(PointerRNA *ptr);
void Scene_frame_preview_end_set(PointerRNA *ptr, int value);

int Scene_frame_preview_start_get(PointerRNA *ptr);
void Scene_frame_preview_start_set(PointerRNA *ptr, int value);

PointerRNA Scene_render_get(PointerRNA *ptr);

PointerRNA Scene_rigidbody_world_get(PointerRNA *ptr);

PointerRNA Scene_safe_areas_get(PointerRNA *ptr);

PointerRNA Scene_display_get(PointerRNA *ptr);

PointerRNA Scene_sequence_editor_get(PointerRNA *ptr);

PointerRNA Scene_sequencer_colorspace_settings_get(PointerRNA *ptr);

bool Scene_show_subframe_get(PointerRNA *ptr);
void Scene_show_subframe_set(PointerRNA *ptr, bool value);

int Scene_simulation_frame_end_get(PointerRNA *ptr);
void Scene_simulation_frame_end_set(PointerRNA *ptr, int value);

int Scene_simulation_frame_start_get(PointerRNA *ptr);
void Scene_simulation_frame_start_set(PointerRNA *ptr, int value);

float Scene_audio_doppler_speed_get(PointerRNA *ptr);
void Scene_audio_doppler_speed_set(PointerRNA *ptr, float value);

#define Scene_use_stamp_note_MAX 768

void Scene_use_stamp_note_get(PointerRNA *ptr, char *value);
int Scene_use_stamp_note_length(PointerRNA *ptr);
void Scene_use_stamp_note_set(PointerRNA *ptr, const char *value);

int Scene_frame_start_get(PointerRNA *ptr);
void Scene_frame_start_set(PointerRNA *ptr, int value);

enum {
	Scene_sync_mode_NONE = 0,
	Scene_sync_mode_FRAME_DROP = 8,
	Scene_sync_mode_AUDIO_SYNC = 2,
};

int Scene_sync_mode_get(PointerRNA *ptr);
void Scene_sync_mode_set(PointerRNA *ptr, int value);

void Scene_timeline_markers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Scene_timeline_markers_next(CollectionPropertyIterator *iter);
void Scene_timeline_markers_end(CollectionPropertyIterator *iter);
bool Scene_timeline_markers_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Scene_timeline_markers_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

PointerRNA Scene_tool_settings_get(PointerRNA *ptr);

void Scene_transform_orientation_slots_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Scene_transform_orientation_slots_next(CollectionPropertyIterator *iter);
void Scene_transform_orientation_slots_end(CollectionPropertyIterator *iter);
int Scene_transform_orientation_slots_length(PointerRNA *ptr);

PointerRNA Scene_unit_settings_get(PointerRNA *ptr);

bool Scene_use_nodes_get(PointerRNA *ptr);
void Scene_use_nodes_set(PointerRNA *ptr, bool value);

bool Scene_use_preview_range_get(PointerRNA *ptr);
void Scene_use_preview_range_set(PointerRNA *ptr, bool value);

void Scene_view_layers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Scene_view_layers_next(CollectionPropertyIterator *iter);
void Scene_view_layers_end(CollectionPropertyIterator *iter);
bool Scene_view_layers_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Scene_view_layers_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

PointerRNA Scene_view_settings_get(PointerRNA *ptr);

float Scene_audio_volume_get(PointerRNA *ptr);
void Scene_audio_volume_set(PointerRNA *ptr, float value);

PointerRNA Scene_world_get(PointerRNA *ptr);

void Scene_update_render_engine_func(Main *bmain);
const char * Scene_statistics_func(struct Scene *_self, Main *bmain, ReportList *reports, struct ViewLayer *view_layer);
void Scene_frame_set_func(struct Scene *_self, Main *bmain, int frame, float subframe);
void Scene_uvedit_aspect_func(struct Scene *_self, struct Object *object, float result[2]);
void Scene_ray_cast_func(struct Scene *_self, struct Depsgraph *depsgraph, float origin[3], float direction[3], float distance, bool *result, float location[3], float normal[3], int *index, struct Object **object, float matrix[16]);
struct Editing *Scene_sequence_editor_create_func(struct Scene *_self);
void Scene_sequence_editor_clear_func(struct Scene *_self);
void Scene_alembic_export_func(struct Scene *_self, bContext *C, const char * filepath, int frame_start, int frame_end, int xform_samples, int geom_samples, float shutter_open, float shutter_close, bool selected_only, bool uvs, bool normals, bool vcolors, bool apply_subdiv, bool flatten, bool visible_objects_only, bool face_sets, bool subdiv_schema, bool export_hair, bool export_particles, bool packuv, float scale, bool triangulate, int quad_method, int ngon_method);
/**************** Scene Display ****************/

extern StructRNA RNA_SceneDisplay;

PointerRNA SceneDisplay_rna_type_get(PointerRNA *ptr);

float SceneDisplay_matcap_ssao_attenuation_get(PointerRNA *ptr);
void SceneDisplay_matcap_ssao_attenuation_set(PointerRNA *ptr, float value);

float SceneDisplay_matcap_ssao_distance_get(PointerRNA *ptr);
void SceneDisplay_matcap_ssao_distance_set(PointerRNA *ptr, float value);

void SceneDisplay_light_direction_get(PointerRNA *ptr, float values[3]);
void SceneDisplay_light_direction_set(PointerRNA *ptr, const float values[3]);

enum {
	SceneDisplay_render_aa_OFF = 0,
	SceneDisplay_render_aa_FXAA = 1,
	SceneDisplay_render_aa_5 = 5,
	SceneDisplay_render_aa_8 = 8,
	SceneDisplay_render_aa_11 = 11,
	SceneDisplay_render_aa_16 = 16,
	SceneDisplay_render_aa_32 = 32,
};

int SceneDisplay_render_aa_get(PointerRNA *ptr);
void SceneDisplay_render_aa_set(PointerRNA *ptr, int value);

int SceneDisplay_matcap_ssao_samples_get(PointerRNA *ptr);
void SceneDisplay_matcap_ssao_samples_set(PointerRNA *ptr, int value);

PointerRNA SceneDisplay_shading_get(PointerRNA *ptr);

float SceneDisplay_shadow_focus_get(PointerRNA *ptr);
void SceneDisplay_shadow_focus_set(PointerRNA *ptr, float value);

float SceneDisplay_shadow_shift_get(PointerRNA *ptr);
void SceneDisplay_shadow_shift_set(PointerRNA *ptr, float value);

enum {
	SceneDisplay_viewport_aa_OFF = 0,
	SceneDisplay_viewport_aa_FXAA = 1,
	SceneDisplay_viewport_aa_5 = 5,
	SceneDisplay_viewport_aa_8 = 8,
	SceneDisplay_viewport_aa_11 = 11,
	SceneDisplay_viewport_aa_16 = 16,
	SceneDisplay_viewport_aa_32 = 32,
};

int SceneDisplay_viewport_aa_get(PointerRNA *ptr);
void SceneDisplay_viewport_aa_set(PointerRNA *ptr, int value);

/**************** Scene Display ****************/

extern StructRNA RNA_SceneEEVEE;

PointerRNA SceneEEVEE_rna_type_get(PointerRNA *ptr);

bool SceneEEVEE_use_gtao_get(PointerRNA *ptr);
void SceneEEVEE_use_gtao_set(PointerRNA *ptr, bool value);

float SceneEEVEE_fast_gi_bias_get(PointerRNA *ptr);
void SceneEEVEE_fast_gi_bias_set(PointerRNA *ptr, float value);

float SceneEEVEE_motion_blur_depth_scale_get(PointerRNA *ptr);
void SceneEEVEE_motion_blur_depth_scale_set(PointerRNA *ptr, float value);

float SceneEEVEE_volumetric_light_clamp_get(PointerRNA *ptr);
void SceneEEVEE_volumetric_light_clamp_set(PointerRNA *ptr, float value);

float SceneEEVEE_gi_glossy_clamp_get(PointerRNA *ptr);
void SceneEEVEE_gi_glossy_clamp_set(PointerRNA *ptr, float value);

float SceneEEVEE_clamp_surface_direct_get(PointerRNA *ptr);
void SceneEEVEE_clamp_surface_direct_set(PointerRNA *ptr, float value);

float SceneEEVEE_clamp_surface_indirect_get(PointerRNA *ptr);
void SceneEEVEE_clamp_surface_indirect_set(PointerRNA *ptr, float value);

float SceneEEVEE_clamp_volume_direct_get(PointerRNA *ptr);
void SceneEEVEE_clamp_volume_direct_set(PointerRNA *ptr, float value);

float SceneEEVEE_clamp_volume_indirect_get(PointerRNA *ptr);
void SceneEEVEE_clamp_volume_indirect_set(PointerRNA *ptr, float value);

enum {
	SceneEEVEE_gi_cubemap_resolution_128 = 128,
	SceneEEVEE_gi_cubemap_resolution_256 = 256,
	SceneEEVEE_gi_cubemap_resolution_512 = 512,
	SceneEEVEE_gi_cubemap_resolution_1024 = 1024,
	SceneEEVEE_gi_cubemap_resolution_2048 = 2048,
	SceneEEVEE_gi_cubemap_resolution_4096 = 4096,
};

int SceneEEVEE_gi_cubemap_resolution_get(PointerRNA *ptr);
void SceneEEVEE_gi_cubemap_resolution_set(PointerRNA *ptr, int value);

int SceneEEVEE_gi_diffuse_bounces_get(PointerRNA *ptr);
void SceneEEVEE_gi_diffuse_bounces_set(PointerRNA *ptr, int value);

float SceneEEVEE_gtao_distance_get(PointerRNA *ptr);
void SceneEEVEE_gtao_distance_set(PointerRNA *ptr, float value);

float SceneEEVEE_fast_gi_distance_get(PointerRNA *ptr);
void SceneEEVEE_fast_gi_distance_set(PointerRNA *ptr, float value);

float SceneEEVEE_volumetric_end_get(PointerRNA *ptr);
void SceneEEVEE_volumetric_end_set(PointerRNA *ptr, float value);

float SceneEEVEE_volumetric_sample_distribution_get(PointerRNA *ptr);
void SceneEEVEE_volumetric_sample_distribution_set(PointerRNA *ptr, float value);

float SceneEEVEE_fast_gi_thickness_far_get(PointerRNA *ptr);
void SceneEEVEE_fast_gi_thickness_far_set(PointerRNA *ptr, float value);

bool SceneEEVEE_use_fast_gi_get(PointerRNA *ptr);
void SceneEEVEE_use_fast_gi_set(PointerRNA *ptr, bool value);

enum {
	SceneEEVEE_gi_irradiance_pool_size_16 = 16,
	SceneEEVEE_gi_irradiance_pool_size_32 = 32,
	SceneEEVEE_gi_irradiance_pool_size_64 = 64,
	SceneEEVEE_gi_irradiance_pool_size_128 = 128,
	SceneEEVEE_gi_irradiance_pool_size_256 = 256,
	SceneEEVEE_gi_irradiance_pool_size_512 = 512,
	SceneEEVEE_gi_irradiance_pool_size_1024 = 1024,
};

int SceneEEVEE_gi_irradiance_pool_size_get(PointerRNA *ptr);
void SceneEEVEE_gi_irradiance_pool_size_set(PointerRNA *ptr, int value);

enum {
	SceneEEVEE_gi_visibility_resolution_8 = 8,
	SceneEEVEE_gi_visibility_resolution_16 = 16,
	SceneEEVEE_gi_visibility_resolution_32 = 32,
	SceneEEVEE_gi_visibility_resolution_64 = 64,
};

int SceneEEVEE_gi_visibility_resolution_get(PointerRNA *ptr);
void SceneEEVEE_gi_visibility_resolution_set(PointerRNA *ptr, int value);

bool SceneEEVEE_use_bokeh_jittered_get(PointerRNA *ptr);
void SceneEEVEE_use_bokeh_jittered_set(PointerRNA *ptr, bool value);

bool SceneEEVEE_use_shadow_jitter_viewport_get(PointerRNA *ptr);
void SceneEEVEE_use_shadow_jitter_viewport_set(PointerRNA *ptr, bool value);

float SceneEEVEE_light_threshold_get(PointerRNA *ptr);
void SceneEEVEE_light_threshold_set(PointerRNA *ptr, float value);

int SceneEEVEE_motion_blur_max_get(PointerRNA *ptr);
void SceneEEVEE_motion_blur_max_set(PointerRNA *ptr, int value);

float SceneEEVEE_bokeh_max_size_get(PointerRNA *ptr);
void SceneEEVEE_bokeh_max_size_set(PointerRNA *ptr, float value);

enum {
	SceneEEVEE_fast_gi_method_AMBIENT_OCCLUSION_ONLY = 1,
	SceneEEVEE_fast_gi_method_GLOBAL_ILLUMINATION = 0,
};

int SceneEEVEE_fast_gi_method_get(PointerRNA *ptr);
void SceneEEVEE_fast_gi_method_set(PointerRNA *ptr, int value);

int SceneEEVEE_motion_blur_steps_get(PointerRNA *ptr);
void SceneEEVEE_motion_blur_steps_set(PointerRNA *ptr, int value);

float SceneEEVEE_fast_gi_thickness_near_get(PointerRNA *ptr);
void SceneEEVEE_fast_gi_thickness_near_set(PointerRNA *ptr, float value);

float SceneEEVEE_bokeh_neighbor_max_get(PointerRNA *ptr);
void SceneEEVEE_bokeh_neighbor_max_set(PointerRNA *ptr, float value);

float SceneEEVEE_bokeh_overblur_get(PointerRNA *ptr);
void SceneEEVEE_bokeh_overblur_set(PointerRNA *ptr, float value);

bool SceneEEVEE_use_overscan_get(PointerRNA *ptr);
void SceneEEVEE_use_overscan_set(PointerRNA *ptr, bool value);

float SceneEEVEE_overscan_size_get(PointerRNA *ptr);
void SceneEEVEE_overscan_size_set(PointerRNA *ptr, float value);

int SceneEEVEE_fast_gi_ray_count_get(PointerRNA *ptr);
void SceneEEVEE_fast_gi_ray_count_set(PointerRNA *ptr, int value);

PointerRNA SceneEEVEE_ray_tracing_options_get(PointerRNA *ptr);

int SceneEEVEE_taa_render_samples_get(PointerRNA *ptr);
void SceneEEVEE_taa_render_samples_set(PointerRNA *ptr, int value);

enum {
	SceneEEVEE_volumetric_tile_size_1 = 1,
	SceneEEVEE_volumetric_tile_size_2 = 2,
	SceneEEVEE_volumetric_tile_size_4 = 4,
	SceneEEVEE_volumetric_tile_size_8 = 8,
	SceneEEVEE_volumetric_tile_size_16 = 16,
};

int SceneEEVEE_volumetric_tile_size_get(PointerRNA *ptr);
void SceneEEVEE_volumetric_tile_size_set(PointerRNA *ptr, int value);

enum {
	SceneEEVEE_fast_gi_resolution_1 = 1,
	SceneEEVEE_fast_gi_resolution_2 = 2,
	SceneEEVEE_fast_gi_resolution_4 = 4,
	SceneEEVEE_fast_gi_resolution_8 = 8,
	SceneEEVEE_fast_gi_resolution_16 = 16,
};

int SceneEEVEE_fast_gi_resolution_get(PointerRNA *ptr);
void SceneEEVEE_fast_gi_resolution_set(PointerRNA *ptr, int value);

enum {
	SceneEEVEE_shadow_pool_size_16 = 16,
	SceneEEVEE_shadow_pool_size_32 = 32,
	SceneEEVEE_shadow_pool_size_64 = 64,
	SceneEEVEE_shadow_pool_size_128 = 128,
	SceneEEVEE_shadow_pool_size_256 = 256,
	SceneEEVEE_shadow_pool_size_512 = 512,
	SceneEEVEE_shadow_pool_size_1024 = 1024,
};

int SceneEEVEE_shadow_pool_size_get(PointerRNA *ptr);
void SceneEEVEE_shadow_pool_size_set(PointerRNA *ptr, int value);

int SceneEEVEE_shadow_ray_count_get(PointerRNA *ptr);
void SceneEEVEE_shadow_ray_count_set(PointerRNA *ptr, int value);

int SceneEEVEE_shadow_step_count_get(PointerRNA *ptr);
void SceneEEVEE_shadow_step_count_set(PointerRNA *ptr, int value);

bool SceneEEVEE_use_shadows_get(PointerRNA *ptr);
void SceneEEVEE_use_shadows_set(PointerRNA *ptr, bool value);

float SceneEEVEE_shadow_resolution_scale_get(PointerRNA *ptr);
void SceneEEVEE_shadow_resolution_scale_set(PointerRNA *ptr, float value);

float SceneEEVEE_bokeh_threshold_get(PointerRNA *ptr);
void SceneEEVEE_bokeh_threshold_set(PointerRNA *ptr, float value);

float SceneEEVEE_volumetric_start_get(PointerRNA *ptr);
void SceneEEVEE_volumetric_start_set(PointerRNA *ptr, float value);

int SceneEEVEE_fast_gi_step_count_get(PointerRNA *ptr);
void SceneEEVEE_fast_gi_step_count_set(PointerRNA *ptr, int value);

int SceneEEVEE_volumetric_samples_get(PointerRNA *ptr);
void SceneEEVEE_volumetric_samples_set(PointerRNA *ptr, int value);

float SceneEEVEE_gtao_quality_get(PointerRNA *ptr);
void SceneEEVEE_gtao_quality_set(PointerRNA *ptr, float value);

float SceneEEVEE_fast_gi_quality_get(PointerRNA *ptr);
void SceneEEVEE_fast_gi_quality_set(PointerRNA *ptr, float value);

enum {
	SceneEEVEE_ray_tracing_method_PROBE = 0,
	SceneEEVEE_ray_tracing_method_SCREEN = 1,
};

int SceneEEVEE_ray_tracing_method_get(PointerRNA *ptr);
void SceneEEVEE_ray_tracing_method_set(PointerRNA *ptr, int value);

bool SceneEEVEE_use_raytracing_get(PointerRNA *ptr);
void SceneEEVEE_use_raytracing_set(PointerRNA *ptr, bool value);

bool SceneEEVEE_use_taa_reprojection_get(PointerRNA *ptr);
void SceneEEVEE_use_taa_reprojection_set(PointerRNA *ptr, bool value);

int SceneEEVEE_taa_samples_get(PointerRNA *ptr);
void SceneEEVEE_taa_samples_set(PointerRNA *ptr, int value);

bool SceneEEVEE_use_volume_custom_range_get(PointerRNA *ptr);
void SceneEEVEE_use_volume_custom_range_set(PointerRNA *ptr, bool value);

int SceneEEVEE_volumetric_ray_depth_get(PointerRNA *ptr);
void SceneEEVEE_volumetric_ray_depth_set(PointerRNA *ptr, int value);

int SceneEEVEE_volumetric_shadow_samples_get(PointerRNA *ptr);
void SceneEEVEE_volumetric_shadow_samples_set(PointerRNA *ptr, int value);

bool SceneEEVEE_use_volumetric_shadows_get(PointerRNA *ptr);
void SceneEEVEE_use_volumetric_shadows_set(PointerRNA *ptr, bool value);

/**************** Grease Pencil Render ****************/

extern StructRNA RNA_SceneGpencil;

PointerRNA SceneGpencil_rna_type_get(PointerRNA *ptr);

int SceneGpencil_aa_samples_get(PointerRNA *ptr);
void SceneGpencil_aa_samples_set(PointerRNA *ptr, int value);

float SceneGpencil_antialias_threshold_render_get(PointerRNA *ptr);
void SceneGpencil_antialias_threshold_render_set(PointerRNA *ptr, float value);

float SceneGpencil_antialias_threshold_get(PointerRNA *ptr);
void SceneGpencil_antialias_threshold_set(PointerRNA *ptr, float value);

/**************** Scene Hydra ****************/

extern StructRNA RNA_SceneHydra;

PointerRNA SceneHydra_rna_type_get(PointerRNA *ptr);

enum {
	SceneHydra_export_method_HYDRA = 0,
	SceneHydra_export_method_USD = 1,
};

int SceneHydra_export_method_get(PointerRNA *ptr);
void SceneHydra_export_method_set(PointerRNA *ptr, int value);

/**************** Scene Objects ****************/

extern StructRNA RNA_SceneObjects;

PointerRNA SceneObjects_rna_type_get(PointerRNA *ptr);

/**************** Scene Render View ****************/

extern StructRNA RNA_SceneRenderView;

PointerRNA SceneRenderView_rna_type_get(PointerRNA *ptr);

#define SceneRenderView_name_MAX 64

void SceneRenderView_name_get(PointerRNA *ptr, char *value);
int SceneRenderView_name_length(PointerRNA *ptr);
void SceneRenderView_name_set(PointerRNA *ptr, const char *value);

#define SceneRenderView_camera_suffix_MAX 64

void SceneRenderView_camera_suffix_get(PointerRNA *ptr, char *value);
int SceneRenderView_camera_suffix_length(PointerRNA *ptr);
void SceneRenderView_camera_suffix_set(PointerRNA *ptr, const char *value);

bool SceneRenderView_use_get(PointerRNA *ptr);
void SceneRenderView_use_set(PointerRNA *ptr, bool value);

#define SceneRenderView_file_suffix_MAX 64

void SceneRenderView_file_suffix_get(PointerRNA *ptr, char *value);
int SceneRenderView_file_suffix_length(PointerRNA *ptr);
void SceneRenderView_file_suffix_set(PointerRNA *ptr, const char *value);

/**************** Scene Strip ****************/

extern StructRNA RNA_SceneStrip;
extern StructRNA RNA_Strip;

enum {
	SceneStrip_alpha_mode_STRAIGHT = 0,
	SceneStrip_alpha_mode_PREMUL = 1,
};

int SceneStrip_alpha_mode_get(PointerRNA *ptr);
void SceneStrip_alpha_mode_set(PointerRNA *ptr, int value);

int SceneStrip_animation_offset_end_get(PointerRNA *ptr);
void SceneStrip_animation_offset_end_set(PointerRNA *ptr, int value);

int SceneStrip_animation_offset_start_get(PointerRNA *ptr);
void SceneStrip_animation_offset_start_set(PointerRNA *ptr, int value);

PointerRNA SceneStrip_scene_camera_get(PointerRNA *ptr);

bool SceneStrip_use_float_get(PointerRNA *ptr);
void SceneStrip_use_float_set(PointerRNA *ptr, bool value);

PointerRNA SceneStrip_crop_get(PointerRNA *ptr);

bool SceneStrip_use_deinterlace_get(PointerRNA *ptr);
void SceneStrip_use_deinterlace_set(PointerRNA *ptr, bool value);

float SceneStrip_fps_get(PointerRNA *ptr);
void SceneStrip_fps_set(PointerRNA *ptr, float value);

bool SceneStrip_use_flip_x_get(PointerRNA *ptr);
void SceneStrip_use_flip_x_set(PointerRNA *ptr, bool value);

bool SceneStrip_use_flip_y_get(PointerRNA *ptr);
void SceneStrip_use_flip_y_set(PointerRNA *ptr, bool value);

enum {
	SceneStrip_scene_input_CAMERA = 0,
	SceneStrip_scene_input_SEQUENCER = 1073741824,
};

int SceneStrip_scene_input_get(PointerRNA *ptr);
void SceneStrip_scene_input_set(PointerRNA *ptr, int value);

bool SceneStrip_multiply_alpha_get(PointerRNA *ptr);
void SceneStrip_multiply_alpha_set(PointerRNA *ptr, bool value);

float SceneStrip_color_multiply_get(PointerRNA *ptr);
void SceneStrip_color_multiply_set(PointerRNA *ptr, float value);

PointerRNA SceneStrip_proxy_get(PointerRNA *ptr);

void SceneStrip_retiming_keys_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SceneStrip_retiming_keys_next(CollectionPropertyIterator *iter);
void SceneStrip_retiming_keys_end(CollectionPropertyIterator *iter);
int SceneStrip_retiming_keys_length(PointerRNA *ptr);
bool SceneStrip_retiming_keys_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool SceneStrip_use_reverse_frames_get(PointerRNA *ptr);
void SceneStrip_use_reverse_frames_set(PointerRNA *ptr, bool value);

float SceneStrip_color_saturation_get(PointerRNA *ptr);
void SceneStrip_color_saturation_set(PointerRNA *ptr, float value);

PointerRNA SceneStrip_scene_get(PointerRNA *ptr);

float SceneStrip_strobe_get(PointerRNA *ptr);
void SceneStrip_strobe_set(PointerRNA *ptr, float value);

PointerRNA SceneStrip_transform_get(PointerRNA *ptr);

bool SceneStrip_use_annotations_get(PointerRNA *ptr);
void SceneStrip_use_annotations_set(PointerRNA *ptr, bool value);

bool SceneStrip_use_proxy_get(PointerRNA *ptr);
void SceneStrip_use_proxy_set(PointerRNA *ptr, bool value);

float SceneStrip_volume_get(PointerRNA *ptr);
void SceneStrip_volume_set(PointerRNA *ptr, float value);

/**************** Scopes ****************/

extern StructRNA RNA_Scopes;

PointerRNA Scopes_rna_type_get(PointerRNA *ptr);

float Scopes_accuracy_get(PointerRNA *ptr);
void Scopes_accuracy_set(PointerRNA *ptr, float value);

bool Scopes_use_full_resolution_get(PointerRNA *ptr);
void Scopes_use_full_resolution_set(PointerRNA *ptr, bool value);

PointerRNA Scopes_histogram_get(PointerRNA *ptr);

enum {
	Scopes_vectorscope_mode_LUMA = 1,
	Scopes_vectorscope_mode_RGB = 0,
};

int Scopes_vectorscope_mode_get(PointerRNA *ptr);
void Scopes_vectorscope_mode_set(PointerRNA *ptr, int value);

float Scopes_vectorscope_alpha_get(PointerRNA *ptr);
void Scopes_vectorscope_alpha_set(PointerRNA *ptr, float value);

enum {
	Scopes_waveform_mode_LUMA = 0,
	Scopes_waveform_mode_PARADE = 1,
	Scopes_waveform_mode_YCBCR601 = 2,
	Scopes_waveform_mode_YCBCR709 = 3,
	Scopes_waveform_mode_YCBCRJPG = 4,
	Scopes_waveform_mode_RGB = 5,
};

int Scopes_waveform_mode_get(PointerRNA *ptr);
void Scopes_waveform_mode_set(PointerRNA *ptr, int value);

float Scopes_waveform_alpha_get(PointerRNA *ptr);
void Scopes_waveform_alpha_set(PointerRNA *ptr, float value);

/**************** Screen ****************/

extern StructRNA RNA_Screen;
extern StructRNA RNA_ID;

bool Screen_use_play_3d_editors_get(PointerRNA *ptr);
void Screen_use_play_3d_editors_set(PointerRNA *ptr, bool value);

bool Screen_use_play_animation_editors_get(PointerRNA *ptr);
void Screen_use_play_animation_editors_set(PointerRNA *ptr, bool value);

bool Screen_is_animation_playing_get(PointerRNA *ptr);
void Screen_is_animation_playing_set(PointerRNA *ptr, bool value);

void Screen_areas_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Screen_areas_next(CollectionPropertyIterator *iter);
void Screen_areas_end(CollectionPropertyIterator *iter);
bool Screen_areas_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool Screen_use_play_clip_editors_get(PointerRNA *ptr);
void Screen_use_play_clip_editors_set(PointerRNA *ptr, bool value);

bool Screen_use_follow_get(PointerRNA *ptr);
void Screen_use_follow_set(PointerRNA *ptr, bool value);

bool Screen_use_play_image_editors_get(PointerRNA *ptr);
void Screen_use_play_image_editors_set(PointerRNA *ptr, bool value);

bool Screen_show_fullscreen_get(PointerRNA *ptr);
void Screen_show_fullscreen_set(PointerRNA *ptr, bool value);

bool Screen_use_play_node_editors_get(PointerRNA *ptr);
void Screen_use_play_node_editors_set(PointerRNA *ptr, bool value);

bool Screen_use_play_properties_editors_get(PointerRNA *ptr);
void Screen_use_play_properties_editors_set(PointerRNA *ptr, bool value);

bool Screen_use_play_sequence_editors_get(PointerRNA *ptr);
void Screen_use_play_sequence_editors_set(PointerRNA *ptr, bool value);

bool Screen_show_statusbar_get(PointerRNA *ptr);
void Screen_show_statusbar_set(PointerRNA *ptr, bool value);

bool Screen_use_play_spreadsheet_editors_get(PointerRNA *ptr);
void Screen_use_play_spreadsheet_editors_set(PointerRNA *ptr, bool value);

bool Screen_is_temporary_get(PointerRNA *ptr);
void Screen_is_temporary_set(PointerRNA *ptr, bool value);

bool Screen_use_play_top_left_3d_editor_get(PointerRNA *ptr);
void Screen_use_play_top_left_3d_editor_set(PointerRNA *ptr, bool value);

bool Screen_is_scrubbing_get(PointerRNA *ptr);
void Screen_is_scrubbing_set(PointerRNA *ptr, bool value);

const char * Screen_statusbar_info_func(struct bScreen *_self, Main *bmain, bContext *C);
/**************** Screw Modifier ****************/

extern StructRNA RNA_ScrewModifier;
extern StructRNA RNA_Modifier;

float ScrewModifier_angle_get(PointerRNA *ptr);
void ScrewModifier_angle_set(PointerRNA *ptr, float value);

enum {
	ScrewModifier_axis_X = 0,
	ScrewModifier_axis_Y = 1,
	ScrewModifier_axis_Z = 2,
};

int ScrewModifier_axis_get(PointerRNA *ptr);
void ScrewModifier_axis_set(PointerRNA *ptr, int value);

bool ScrewModifier_use_normal_calculate_get(PointerRNA *ptr);
void ScrewModifier_use_normal_calculate_set(PointerRNA *ptr, bool value);

bool ScrewModifier_use_normal_flip_get(PointerRNA *ptr);
void ScrewModifier_use_normal_flip_set(PointerRNA *ptr, bool value);

int ScrewModifier_iterations_get(PointerRNA *ptr);
void ScrewModifier_iterations_set(PointerRNA *ptr, int value);

float ScrewModifier_merge_threshold_get(PointerRNA *ptr);
void ScrewModifier_merge_threshold_set(PointerRNA *ptr, float value);

bool ScrewModifier_use_merge_vertices_get(PointerRNA *ptr);
void ScrewModifier_use_merge_vertices_set(PointerRNA *ptr, bool value);

PointerRNA ScrewModifier_object_get(PointerRNA *ptr);

bool ScrewModifier_use_object_screw_offset_get(PointerRNA *ptr);
void ScrewModifier_use_object_screw_offset_set(PointerRNA *ptr, bool value);

int ScrewModifier_render_steps_get(PointerRNA *ptr);
void ScrewModifier_render_steps_set(PointerRNA *ptr, int value);

float ScrewModifier_screw_offset_get(PointerRNA *ptr);
void ScrewModifier_screw_offset_set(PointerRNA *ptr, float value);

bool ScrewModifier_use_smooth_shade_get(PointerRNA *ptr);
void ScrewModifier_use_smooth_shade_set(PointerRNA *ptr, bool value);

int ScrewModifier_steps_get(PointerRNA *ptr);
void ScrewModifier_steps_set(PointerRNA *ptr, int value);

bool ScrewModifier_use_stretch_u_get(PointerRNA *ptr);
void ScrewModifier_use_stretch_u_set(PointerRNA *ptr, bool value);

bool ScrewModifier_use_stretch_v_get(PointerRNA *ptr);
void ScrewModifier_use_stretch_v_set(PointerRNA *ptr, bool value);

/**************** Python Scripts Directory ****************/

extern StructRNA RNA_ScriptDirectory;

PointerRNA ScriptDirectory_rna_type_get(PointerRNA *ptr);

#define ScriptDirectory_name_MAX 64

void ScriptDirectory_name_get(PointerRNA *ptr, char *value);
int ScriptDirectory_name_length(PointerRNA *ptr);
void ScriptDirectory_name_set(PointerRNA *ptr, const char *value);

#define ScriptDirectory_directory_MAX 768

void ScriptDirectory_directory_get(PointerRNA *ptr, char *value);
int ScriptDirectory_directory_length(PointerRNA *ptr);
void ScriptDirectory_directory_set(PointerRNA *ptr, const char *value);

/**************** Python Scripts Directories ****************/

extern StructRNA RNA_ScriptDirectoryCollection;

PointerRNA ScriptDirectoryCollection_rna_type_get(PointerRNA *ptr);

struct bUserScriptDirectory *ScriptDirectoryCollection_new_func(void);
void ScriptDirectoryCollection_remove_func(ReportList *reports, struct PointerRNA *script_directory);
/**************** Sculpt ****************/

extern StructRNA RNA_Sculpt;
extern StructRNA RNA_Paint;

bool Sculpt_use_automasking_start_normal_get(PointerRNA *ptr);
void Sculpt_use_automasking_start_normal_set(PointerRNA *ptr, bool value);

float Sculpt_automasking_start_normal_falloff_get(PointerRNA *ptr);
void Sculpt_automasking_start_normal_falloff_set(PointerRNA *ptr, float value);

float Sculpt_automasking_start_normal_limit_get(PointerRNA *ptr);
void Sculpt_automasking_start_normal_limit_set(PointerRNA *ptr, float value);

int Sculpt_automasking_cavity_blur_steps_get(PointerRNA *ptr);
void Sculpt_automasking_cavity_blur_steps_set(PointerRNA *ptr, int value);

PointerRNA Sculpt_automasking_cavity_curve_get(PointerRNA *ptr);

PointerRNA Sculpt_automasking_cavity_curve_op_get(PointerRNA *ptr);

float Sculpt_automasking_cavity_factor_get(PointerRNA *ptr);
void Sculpt_automasking_cavity_factor_set(PointerRNA *ptr, float value);

bool Sculpt_use_automasking_cavity_get(PointerRNA *ptr);
void Sculpt_use_automasking_cavity_set(PointerRNA *ptr, bool value);

bool Sculpt_use_automasking_custom_cavity_curve_get(PointerRNA *ptr);
void Sculpt_use_automasking_custom_cavity_curve_set(PointerRNA *ptr, bool value);

float Sculpt_detail_percent_get(PointerRNA *ptr);
void Sculpt_detail_percent_set(PointerRNA *ptr, float value);

enum {
	Sculpt_detail_refine_method_SUBDIVIDE = 4096,
	Sculpt_detail_refine_method_COLLAPSE = 2048,
	Sculpt_detail_refine_method_SUBDIVIDE_COLLAPSE = 6144,
};

int Sculpt_detail_refine_method_get(PointerRNA *ptr);
void Sculpt_detail_refine_method_set(PointerRNA *ptr, int value);

float Sculpt_detail_size_get(PointerRNA *ptr);
void Sculpt_detail_size_set(PointerRNA *ptr, float value);

enum {
	Sculpt_detail_type_method_RELATIVE = 0,
	Sculpt_detail_type_method_CONSTANT = 8192,
	Sculpt_detail_type_method_BRUSH = 16384,
	Sculpt_detail_type_method_MANUAL = 65536,
};

int Sculpt_detail_type_method_get(PointerRNA *ptr);
void Sculpt_detail_type_method_set(PointerRNA *ptr, int value);

enum {
	Sculpt_symmetrize_direction_NEGATIVE_X = 0,
	Sculpt_symmetrize_direction_POSITIVE_X = 3,
	Sculpt_symmetrize_direction_NEGATIVE_Y = 1,
	Sculpt_symmetrize_direction_POSITIVE_Y = 4,
	Sculpt_symmetrize_direction_NEGATIVE_Z = 2,
	Sculpt_symmetrize_direction_POSITIVE_Z = 5,
};

int Sculpt_symmetrize_direction_get(PointerRNA *ptr);
void Sculpt_symmetrize_direction_set(PointerRNA *ptr, int value);

bool Sculpt_use_automasking_face_sets_get(PointerRNA *ptr);
void Sculpt_use_automasking_face_sets_set(PointerRNA *ptr, bool value);

bool Sculpt_use_automasking_boundary_face_sets_get(PointerRNA *ptr);
void Sculpt_use_automasking_boundary_face_sets_set(PointerRNA *ptr, bool value);

float Sculpt_gravity_get(PointerRNA *ptr);
void Sculpt_gravity_set(PointerRNA *ptr, float value);

bool Sculpt_use_automasking_cavity_inverted_get(PointerRNA *ptr);
void Sculpt_use_automasking_cavity_inverted_set(PointerRNA *ptr, bool value);

bool Sculpt_lock_x_get(PointerRNA *ptr);
void Sculpt_lock_x_set(PointerRNA *ptr, bool value);

bool Sculpt_lock_y_get(PointerRNA *ptr);
void Sculpt_lock_y_set(PointerRNA *ptr, bool value);

bool Sculpt_lock_z_get(PointerRNA *ptr);
void Sculpt_lock_z_set(PointerRNA *ptr, bool value);

bool Sculpt_use_automasking_boundary_edges_get(PointerRNA *ptr);
void Sculpt_use_automasking_boundary_edges_set(PointerRNA *ptr, bool value);

bool Sculpt_use_automasking_view_occlusion_get(PointerRNA *ptr);
void Sculpt_use_automasking_view_occlusion_set(PointerRNA *ptr, bool value);

PointerRNA Sculpt_gravity_object_get(PointerRNA *ptr);

int Sculpt_automasking_boundary_edges_propagation_steps_get(PointerRNA *ptr);
void Sculpt_automasking_boundary_edges_propagation_steps_set(PointerRNA *ptr, int value);

void Sculpt_radial_symmetry_get(PointerRNA *ptr, int values[3]);
void Sculpt_radial_symmetry_set(PointerRNA *ptr, const int values[3]);

float Sculpt_constant_detail_resolution_get(PointerRNA *ptr);
void Sculpt_constant_detail_resolution_set(PointerRNA *ptr, float value);

bool Sculpt_use_automasking_topology_get(PointerRNA *ptr);
void Sculpt_use_automasking_topology_set(PointerRNA *ptr, bool value);

enum {
	Sculpt_transform_mode_ALL_VERTICES = 0,
	Sculpt_transform_mode_RADIUS_ELASTIC = 1,
};

int Sculpt_transform_mode_get(PointerRNA *ptr);
void Sculpt_transform_mode_set(PointerRNA *ptr, int value);

bool Sculpt_use_deform_only_get(PointerRNA *ptr);
void Sculpt_use_deform_only_set(PointerRNA *ptr, bool value);

bool Sculpt_use_automasking_view_normal_get(PointerRNA *ptr);
void Sculpt_use_automasking_view_normal_set(PointerRNA *ptr, bool value);

float Sculpt_automasking_view_normal_falloff_get(PointerRNA *ptr);
void Sculpt_automasking_view_normal_falloff_set(PointerRNA *ptr, float value);

float Sculpt_automasking_view_normal_limit_get(PointerRNA *ptr);
void Sculpt_automasking_view_normal_limit_set(PointerRNA *ptr, float value);

/**************** Selected UV Element ****************/

extern StructRNA RNA_SelectedUvElement;
extern StructRNA RNA_PropertyGroup;

/**************** Sequence Editor ****************/

extern StructRNA RNA_SequenceEditor;

PointerRNA SequenceEditor_rna_type_get(PointerRNA *ptr);

PointerRNA SequenceEditor_active_strip_get(PointerRNA *ptr);

void SequenceEditor_sequences_all_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SequenceEditor_sequences_all_next(CollectionPropertyIterator *iter);
void SequenceEditor_sequences_all_end(CollectionPropertyIterator *iter);
bool SequenceEditor_sequences_all_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void SequenceEditor_strips_all_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SequenceEditor_strips_all_next(CollectionPropertyIterator *iter);
void SequenceEditor_strips_all_end(CollectionPropertyIterator *iter);
bool SequenceEditor_strips_all_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool SequenceEditor_use_cache_final_get(PointerRNA *ptr);
void SequenceEditor_use_cache_final_set(PointerRNA *ptr, bool value);

bool SequenceEditor_use_cache_raw_get(PointerRNA *ptr);
void SequenceEditor_use_cache_raw_set(PointerRNA *ptr, bool value);

void SequenceEditor_channels_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SequenceEditor_channels_next(CollectionPropertyIterator *iter);
void SequenceEditor_channels_end(CollectionPropertyIterator *iter);
bool SequenceEditor_channels_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool SequenceEditor_channels_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

int SequenceEditor_cache_final_size_get(PointerRNA *ptr);
void SequenceEditor_cache_final_size_set(PointerRNA *ptr, int value);

void SequenceEditor_meta_stack_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SequenceEditor_meta_stack_next(CollectionPropertyIterator *iter);
void SequenceEditor_meta_stack_end(CollectionPropertyIterator *iter);
bool SequenceEditor_meta_stack_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool SequenceEditor_meta_stack_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool SequenceEditor_use_overlay_frame_lock_get(PointerRNA *ptr);
void SequenceEditor_use_overlay_frame_lock_set(PointerRNA *ptr, bool value);

int SequenceEditor_overlay_frame_get(PointerRNA *ptr);
void SequenceEditor_overlay_frame_set(PointerRNA *ptr, int value);

bool SequenceEditor_use_prefetch_get(PointerRNA *ptr);
void SequenceEditor_use_prefetch_set(PointerRNA *ptr, bool value);

#define SequenceEditor_proxy_dir_MAX 1024

void SequenceEditor_proxy_dir_get(PointerRNA *ptr, char *value);
int SequenceEditor_proxy_dir_length(PointerRNA *ptr);
void SequenceEditor_proxy_dir_set(PointerRNA *ptr, const char *value);

enum {
	SequenceEditor_proxy_storage_PER_STRIP = 0,
	SequenceEditor_proxy_storage_PROJECT = 1,
};

int SequenceEditor_proxy_storage_get(PointerRNA *ptr);
void SequenceEditor_proxy_storage_set(PointerRNA *ptr, int value);

int SequenceEditor_cache_raw_size_get(PointerRNA *ptr);
void SequenceEditor_cache_raw_size_set(PointerRNA *ptr, int value);

bool SequenceEditor_selected_retiming_keys_get(PointerRNA *ptr);
void SequenceEditor_selected_retiming_keys_set(PointerRNA *ptr, bool value);

bool SequenceEditor_show_missing_media_get(PointerRNA *ptr);
void SequenceEditor_show_missing_media_set(PointerRNA *ptr, bool value);

bool SequenceEditor_show_overlay_frame_get(PointerRNA *ptr);
void SequenceEditor_show_overlay_frame_set(PointerRNA *ptr, bool value);

void SequenceEditor_sequences_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SequenceEditor_sequences_next(CollectionPropertyIterator *iter);
void SequenceEditor_sequences_end(CollectionPropertyIterator *iter);
bool SequenceEditor_sequences_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool SequenceEditor_sequences_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void SequenceEditor_strips_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SequenceEditor_strips_next(CollectionPropertyIterator *iter);
void SequenceEditor_strips_end(CollectionPropertyIterator *iter);
bool SequenceEditor_strips_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool SequenceEditor_strips_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void SequenceEditor_display_stack_func(struct ID *_selfid, struct Editing *_self, ReportList *reports, struct Strip *meta_sequence);
/**************** Channel ****************/

extern StructRNA RNA_SequenceTimelineChannel;

PointerRNA SequenceTimelineChannel_rna_type_get(PointerRNA *ptr);

#define SequenceTimelineChannel_name_MAX 64

void SequenceTimelineChannel_name_get(PointerRNA *ptr, char *value);
int SequenceTimelineChannel_name_length(PointerRNA *ptr);
void SequenceTimelineChannel_name_set(PointerRNA *ptr, const char *value);

bool SequenceTimelineChannel_lock_get(PointerRNA *ptr);
void SequenceTimelineChannel_lock_set(PointerRNA *ptr, bool value);

bool SequenceTimelineChannel_mute_get(PointerRNA *ptr);
void SequenceTimelineChannel_mute_set(PointerRNA *ptr, bool value);

/**************** Cache Overlay Settings ****************/

extern StructRNA RNA_SequencerCacheOverlay;

PointerRNA SequencerCacheOverlay_rna_type_get(PointerRNA *ptr);

bool SequencerCacheOverlay_show_cache_final_out_get(PointerRNA *ptr);
void SequencerCacheOverlay_show_cache_final_out_set(PointerRNA *ptr, bool value);

bool SequencerCacheOverlay_show_cache_raw_get(PointerRNA *ptr);
void SequencerCacheOverlay_show_cache_raw_set(PointerRNA *ptr, bool value);

bool SequencerCacheOverlay_show_cache_get(PointerRNA *ptr);
void SequencerCacheOverlay_show_cache_set(PointerRNA *ptr, bool value);

/**************** Preview Overlay Settings ****************/

extern StructRNA RNA_SequencerPreviewOverlay;

PointerRNA SequencerPreviewOverlay_rna_type_get(PointerRNA *ptr);

bool SequencerPreviewOverlay_show_cursor_get(PointerRNA *ptr);
void SequencerPreviewOverlay_show_cursor_set(PointerRNA *ptr, bool value);

bool SequencerPreviewOverlay_show_safe_center_get(PointerRNA *ptr);
void SequencerPreviewOverlay_show_safe_center_set(PointerRNA *ptr, bool value);

bool SequencerPreviewOverlay_show_image_outline_get(PointerRNA *ptr);
void SequencerPreviewOverlay_show_image_outline_set(PointerRNA *ptr, bool value);

bool SequencerPreviewOverlay_show_safe_areas_get(PointerRNA *ptr);
void SequencerPreviewOverlay_show_safe_areas_set(PointerRNA *ptr, bool value);

bool SequencerPreviewOverlay_show_annotation_get(PointerRNA *ptr);
void SequencerPreviewOverlay_show_annotation_set(PointerRNA *ptr, bool value);

bool SequencerPreviewOverlay_show_metadata_get(PointerRNA *ptr);
void SequencerPreviewOverlay_show_metadata_set(PointerRNA *ptr, bool value);

/**************** Timeline Overlay Settings ****************/

extern StructRNA RNA_SequencerTimelineOverlay;

PointerRNA SequencerTimelineOverlay_rna_type_get(PointerRNA *ptr);

bool SequencerTimelineOverlay_show_strip_tag_color_get(PointerRNA *ptr);
void SequencerTimelineOverlay_show_strip_tag_color_set(PointerRNA *ptr, bool value);

bool SequencerTimelineOverlay_show_strip_duration_get(PointerRNA *ptr);
void SequencerTimelineOverlay_show_strip_duration_set(PointerRNA *ptr, bool value);

bool SequencerTimelineOverlay_show_fcurves_get(PointerRNA *ptr);
void SequencerTimelineOverlay_show_fcurves_set(PointerRNA *ptr, bool value);

bool SequencerTimelineOverlay_show_grid_get(PointerRNA *ptr);
void SequencerTimelineOverlay_show_grid_set(PointerRNA *ptr, bool value);

bool SequencerTimelineOverlay_show_strip_name_get(PointerRNA *ptr);
void SequencerTimelineOverlay_show_strip_name_set(PointerRNA *ptr, bool value);

bool SequencerTimelineOverlay_show_strip_offset_get(PointerRNA *ptr);
void SequencerTimelineOverlay_show_strip_offset_set(PointerRNA *ptr, bool value);

bool SequencerTimelineOverlay_show_strip_retiming_get(PointerRNA *ptr);
void SequencerTimelineOverlay_show_strip_retiming_set(PointerRNA *ptr, bool value);

bool SequencerTimelineOverlay_show_strip_source_get(PointerRNA *ptr);
void SequencerTimelineOverlay_show_strip_source_set(PointerRNA *ptr, bool value);

bool SequencerTimelineOverlay_show_thumbnails_get(PointerRNA *ptr);
void SequencerTimelineOverlay_show_thumbnails_set(PointerRNA *ptr, bool value);

enum {
	SequencerTimelineOverlay_waveform_display_type_ALL_WAVEFORMS = 128,
	SequencerTimelineOverlay_waveform_display_type_DEFAULT_WAVEFORMS = 0,
	SequencerTimelineOverlay_waveform_display_type_NO_WAVEFORMS = 256,
};

int SequencerTimelineOverlay_waveform_display_type_get(PointerRNA *ptr);
void SequencerTimelineOverlay_waveform_display_type_set(PointerRNA *ptr, int value);

enum {
	SequencerTimelineOverlay_waveform_display_style_FULL_WAVEFORMS = 0,
	SequencerTimelineOverlay_waveform_display_style_HALF_WAVEFORMS = 512,
};

int SequencerTimelineOverlay_waveform_display_style_get(PointerRNA *ptr);
void SequencerTimelineOverlay_waveform_display_style_set(PointerRNA *ptr, int value);

/**************** SequencerTonemapModifierData ****************/

extern StructRNA RNA_SequencerTonemapModifierData;
extern StructRNA RNA_StripModifier;

float SequencerTonemapModifierData_adaptation_get(PointerRNA *ptr);
void SequencerTonemapModifierData_adaptation_set(PointerRNA *ptr, float value);

float SequencerTonemapModifierData_correction_get(PointerRNA *ptr);
void SequencerTonemapModifierData_correction_set(PointerRNA *ptr, float value);

float SequencerTonemapModifierData_contrast_get(PointerRNA *ptr);
void SequencerTonemapModifierData_contrast_set(PointerRNA *ptr, float value);

float SequencerTonemapModifierData_gamma_get(PointerRNA *ptr);
void SequencerTonemapModifierData_gamma_set(PointerRNA *ptr, float value);

float SequencerTonemapModifierData_intensity_get(PointerRNA *ptr);
void SequencerTonemapModifierData_intensity_set(PointerRNA *ptr, float value);

float SequencerTonemapModifierData_key_get(PointerRNA *ptr);
void SequencerTonemapModifierData_key_set(PointerRNA *ptr, float value);

float SequencerTonemapModifierData_offset_get(PointerRNA *ptr);
void SequencerTonemapModifierData_offset_set(PointerRNA *ptr, float value);

enum {
	SequencerTonemapModifierData_tonemap_type_RD_PHOTORECEPTOR = 1,
	SequencerTonemapModifierData_tonemap_type_RH_SIMPLE = 0,
};

int SequencerTonemapModifierData_tonemap_type_get(PointerRNA *ptr);
void SequencerTonemapModifierData_tonemap_type_set(PointerRNA *ptr, int value);

/**************** Sequencer Tool Settings ****************/

extern StructRNA RNA_SequencerToolSettings;

PointerRNA SequencerToolSettings_rna_type_get(PointerRNA *ptr);

bool SequencerToolSettings_snap_to_borders_get(PointerRNA *ptr);
void SequencerToolSettings_snap_to_borders_set(PointerRNA *ptr, bool value);

bool SequencerToolSettings_snap_to_center_get(PointerRNA *ptr);
void SequencerToolSettings_snap_to_center_set(PointerRNA *ptr, bool value);

bool SequencerToolSettings_snap_to_current_frame_get(PointerRNA *ptr);
void SequencerToolSettings_snap_to_current_frame_set(PointerRNA *ptr, bool value);

enum {
	SequencerToolSettings_fit_method_FIT = 0,
	SequencerToolSettings_fit_method_FILL = 1,
	SequencerToolSettings_fit_method_STRETCH = 2,
	SequencerToolSettings_fit_method_ORIGINAL = 3,
};

int SequencerToolSettings_fit_method_get(PointerRNA *ptr);
void SequencerToolSettings_fit_method_set(PointerRNA *ptr, int value);

bool SequencerToolSettings_snap_to_frame_range_get(PointerRNA *ptr);
void SequencerToolSettings_snap_to_frame_range_set(PointerRNA *ptr, bool value);

bool SequencerToolSettings_snap_to_hold_offset_get(PointerRNA *ptr);
void SequencerToolSettings_snap_to_hold_offset_set(PointerRNA *ptr, bool value);

bool SequencerToolSettings_snap_ignore_muted_get(PointerRNA *ptr);
void SequencerToolSettings_snap_ignore_muted_set(PointerRNA *ptr, bool value);

bool SequencerToolSettings_snap_ignore_sound_get(PointerRNA *ptr);
void SequencerToolSettings_snap_ignore_sound_set(PointerRNA *ptr, bool value);

bool SequencerToolSettings_snap_to_markers_get(PointerRNA *ptr);
void SequencerToolSettings_snap_to_markers_set(PointerRNA *ptr, bool value);

bool SequencerToolSettings_snap_to_strips_preview_get(PointerRNA *ptr);
void SequencerToolSettings_snap_to_strips_preview_set(PointerRNA *ptr, bool value);

enum {
	SequencerToolSettings_overlap_mode_EXPAND = 0,
	SequencerToolSettings_overlap_mode_OVERWRITE = 1,
	SequencerToolSettings_overlap_mode_SHUFFLE = 2,
};

int SequencerToolSettings_overlap_mode_get(PointerRNA *ptr);
void SequencerToolSettings_overlap_mode_set(PointerRNA *ptr, int value);

enum {
	SequencerToolSettings_pivot_point_CENTER = 0,
	SequencerToolSettings_pivot_point_MEDIAN = 3,
	SequencerToolSettings_pivot_point_CURSOR = 1,
	SequencerToolSettings_pivot_point_INDIVIDUAL_ORIGINS = 2,
};

int SequencerToolSettings_pivot_point_get(PointerRNA *ptr);
void SequencerToolSettings_pivot_point_set(PointerRNA *ptr, int value);

bool SequencerToolSettings_snap_to_retiming_keys_get(PointerRNA *ptr);
void SequencerToolSettings_snap_to_retiming_keys_set(PointerRNA *ptr, bool value);

bool SequencerToolSettings_use_snap_current_frame_to_strips_get(PointerRNA *ptr);
void SequencerToolSettings_use_snap_current_frame_to_strips_set(PointerRNA *ptr, bool value);

int SequencerToolSettings_snap_distance_get(PointerRNA *ptr);
void SequencerToolSettings_snap_distance_set(PointerRNA *ptr, int value);

/**************** ShaderFx ****************/

extern StructRNA RNA_ShaderFx;

PointerRNA ShaderFx_rna_type_get(PointerRNA *ptr);

#define ShaderFx_name_MAX 64

void ShaderFx_name_get(PointerRNA *ptr, char *value);
int ShaderFx_name_length(PointerRNA *ptr);
void ShaderFx_name_set(PointerRNA *ptr, const char *value);

bool ShaderFx_show_in_editmode_get(PointerRNA *ptr);
void ShaderFx_show_in_editmode_set(PointerRNA *ptr, bool value);

bool ShaderFx_show_expanded_get(PointerRNA *ptr);
void ShaderFx_show_expanded_set(PointerRNA *ptr, bool value);

bool ShaderFx_show_viewport_get(PointerRNA *ptr);
void ShaderFx_show_viewport_set(PointerRNA *ptr, bool value);

bool ShaderFx_show_render_get(PointerRNA *ptr);
void ShaderFx_show_render_set(PointerRNA *ptr, bool value);

enum {
	ShaderFx_type_FX_BLUR = 1,
	ShaderFx_type_FX_COLORIZE = 8,
	ShaderFx_type_FX_FLIP = 2,
	ShaderFx_type_FX_GLOW = 10,
	ShaderFx_type_FX_PIXEL = 4,
	ShaderFx_type_FX_RIM = 7,
	ShaderFx_type_FX_SHADOW = 9,
	ShaderFx_type_FX_SWIRL = 5,
	ShaderFx_type_FX_WAVE = 6,
};

int ShaderFx_type_get(PointerRNA *ptr);
void ShaderFx_type_set(PointerRNA *ptr, int value);

/**************** Gaussian Blur Effect ****************/

extern StructRNA RNA_ShaderFxBlur;
extern StructRNA RNA_ShaderFx;

float ShaderFxBlur_rotation_get(PointerRNA *ptr);
void ShaderFxBlur_rotation_set(PointerRNA *ptr, float value);

int ShaderFxBlur_samples_get(PointerRNA *ptr);
void ShaderFxBlur_samples_set(PointerRNA *ptr, int value);

void ShaderFxBlur_size_get(PointerRNA *ptr, float values[2]);
void ShaderFxBlur_size_set(PointerRNA *ptr, const float values[2]);

bool ShaderFxBlur_use_dof_mode_get(PointerRNA *ptr);
void ShaderFxBlur_use_dof_mode_set(PointerRNA *ptr, bool value);

/**************** Colorize Effect ****************/

extern StructRNA RNA_ShaderFxColorize;
extern StructRNA RNA_ShaderFx;

float ShaderFxColorize_factor_get(PointerRNA *ptr);
void ShaderFxColorize_factor_set(PointerRNA *ptr, float value);

void ShaderFxColorize_high_color_get(PointerRNA *ptr, float values[4]);
void ShaderFxColorize_high_color_set(PointerRNA *ptr, const float values[4]);

void ShaderFxColorize_low_color_get(PointerRNA *ptr, float values[4]);
void ShaderFxColorize_low_color_set(PointerRNA *ptr, const float values[4]);

enum {
	ShaderFxColorize_mode_GRAYSCALE = 0,
	ShaderFxColorize_mode_SEPIA = 1,
	ShaderFxColorize_mode_DUOTONE = 2,
	ShaderFxColorize_mode_TRANSPARENT = 4,
	ShaderFxColorize_mode_CUSTOM = 3,
};

int ShaderFxColorize_mode_get(PointerRNA *ptr);
void ShaderFxColorize_mode_set(PointerRNA *ptr, int value);

/**************** Flip Effect ****************/

extern StructRNA RNA_ShaderFxFlip;
extern StructRNA RNA_ShaderFx;

bool ShaderFxFlip_use_flip_x_get(PointerRNA *ptr);
void ShaderFxFlip_use_flip_x_set(PointerRNA *ptr, bool value);

bool ShaderFxFlip_use_flip_y_get(PointerRNA *ptr);
void ShaderFxFlip_use_flip_y_set(PointerRNA *ptr, bool value);

/**************** Glow Effect ****************/

extern StructRNA RNA_ShaderFxGlow;
extern StructRNA RNA_ShaderFx;

enum {
	ShaderFxGlow_blend_mode_REGULAR = 0,
	ShaderFxGlow_blend_mode_ADD = 2,
	ShaderFxGlow_blend_mode_SUBTRACT = 3,
	ShaderFxGlow_blend_mode_MULTIPLY = 4,
	ShaderFxGlow_blend_mode_DIVIDE = 5,
};

int ShaderFxGlow_blend_mode_get(PointerRNA *ptr);
void ShaderFxGlow_blend_mode_set(PointerRNA *ptr, int value);

void ShaderFxGlow_glow_color_get(PointerRNA *ptr, float values[3]);
void ShaderFxGlow_glow_color_set(PointerRNA *ptr, const float values[3]);

bool ShaderFxGlow_use_glow_under_get(PointerRNA *ptr);
void ShaderFxGlow_use_glow_under_set(PointerRNA *ptr, bool value);

enum {
	ShaderFxGlow_mode_LUMINANCE = 0,
	ShaderFxGlow_mode_COLOR = 1,
};

int ShaderFxGlow_mode_get(PointerRNA *ptr);
void ShaderFxGlow_mode_set(PointerRNA *ptr, int value);

float ShaderFxGlow_opacity_get(PointerRNA *ptr);
void ShaderFxGlow_opacity_set(PointerRNA *ptr, float value);

float ShaderFxGlow_rotation_get(PointerRNA *ptr);
void ShaderFxGlow_rotation_set(PointerRNA *ptr, float value);

int ShaderFxGlow_samples_get(PointerRNA *ptr);
void ShaderFxGlow_samples_set(PointerRNA *ptr, int value);

void ShaderFxGlow_select_color_get(PointerRNA *ptr, float values[3]);
void ShaderFxGlow_select_color_set(PointerRNA *ptr, const float values[3]);

void ShaderFxGlow_size_get(PointerRNA *ptr, float values[2]);
void ShaderFxGlow_size_set(PointerRNA *ptr, const float values[2]);

float ShaderFxGlow_threshold_get(PointerRNA *ptr);
void ShaderFxGlow_threshold_set(PointerRNA *ptr, float value);

/**************** Pixelate Effect ****************/

extern StructRNA RNA_ShaderFxPixel;
extern StructRNA RNA_ShaderFx;

bool ShaderFxPixel_use_antialiasing_get(PointerRNA *ptr);
void ShaderFxPixel_use_antialiasing_set(PointerRNA *ptr, bool value);

void ShaderFxPixel_size_get(PointerRNA *ptr, int values[2]);
void ShaderFxPixel_size_set(PointerRNA *ptr, const int values[2]);

/**************** Rim Effect ****************/

extern StructRNA RNA_ShaderFxRim;
extern StructRNA RNA_ShaderFx;

void ShaderFxRim_blur_get(PointerRNA *ptr, int values[2]);
void ShaderFxRim_blur_set(PointerRNA *ptr, const int values[2]);

void ShaderFxRim_mask_color_get(PointerRNA *ptr, float values[3]);
void ShaderFxRim_mask_color_set(PointerRNA *ptr, const float values[3]);

enum {
	ShaderFxRim_mode_NORMAL = 0,
	ShaderFxRim_mode_OVERLAY = 1,
	ShaderFxRim_mode_ADD = 2,
	ShaderFxRim_mode_SUBTRACT = 3,
	ShaderFxRim_mode_MULTIPLY = 4,
	ShaderFxRim_mode_DIVIDE = 5,
};

int ShaderFxRim_mode_get(PointerRNA *ptr);
void ShaderFxRim_mode_set(PointerRNA *ptr, int value);

void ShaderFxRim_offset_get(PointerRNA *ptr, int values[2]);
void ShaderFxRim_offset_set(PointerRNA *ptr, const int values[2]);

void ShaderFxRim_rim_color_get(PointerRNA *ptr, float values[3]);
void ShaderFxRim_rim_color_set(PointerRNA *ptr, const float values[3]);

int ShaderFxRim_samples_get(PointerRNA *ptr);
void ShaderFxRim_samples_set(PointerRNA *ptr, int value);

/**************** Shadow Effect ****************/

extern StructRNA RNA_ShaderFxShadow;
extern StructRNA RNA_ShaderFx;

float ShaderFxShadow_amplitude_get(PointerRNA *ptr);
void ShaderFxShadow_amplitude_set(PointerRNA *ptr, float value);

void ShaderFxShadow_blur_get(PointerRNA *ptr, int values[2]);
void ShaderFxShadow_blur_set(PointerRNA *ptr, const int values[2]);

PointerRNA ShaderFxShadow_object_get(PointerRNA *ptr);

void ShaderFxShadow_offset_get(PointerRNA *ptr, int values[2]);
void ShaderFxShadow_offset_set(PointerRNA *ptr, const int values[2]);

enum {
	ShaderFxShadow_orientation_HORIZONTAL = 0,
	ShaderFxShadow_orientation_VERTICAL = 1,
};

int ShaderFxShadow_orientation_get(PointerRNA *ptr);
void ShaderFxShadow_orientation_set(PointerRNA *ptr, int value);

float ShaderFxShadow_period_get(PointerRNA *ptr);
void ShaderFxShadow_period_set(PointerRNA *ptr, float value);

float ShaderFxShadow_phase_get(PointerRNA *ptr);
void ShaderFxShadow_phase_set(PointerRNA *ptr, float value);

float ShaderFxShadow_rotation_get(PointerRNA *ptr);
void ShaderFxShadow_rotation_set(PointerRNA *ptr, float value);

int ShaderFxShadow_samples_get(PointerRNA *ptr);
void ShaderFxShadow_samples_set(PointerRNA *ptr, int value);

void ShaderFxShadow_scale_get(PointerRNA *ptr, float values[2]);
void ShaderFxShadow_scale_set(PointerRNA *ptr, const float values[2]);

void ShaderFxShadow_shadow_color_get(PointerRNA *ptr, float values[4]);
void ShaderFxShadow_shadow_color_set(PointerRNA *ptr, const float values[4]);

bool ShaderFxShadow_use_object_get(PointerRNA *ptr);
void ShaderFxShadow_use_object_set(PointerRNA *ptr, bool value);

bool ShaderFxShadow_use_wave_get(PointerRNA *ptr);
void ShaderFxShadow_use_wave_set(PointerRNA *ptr, bool value);

/**************** Swirl Effect ****************/

extern StructRNA RNA_ShaderFxSwirl;
extern StructRNA RNA_ShaderFx;

float ShaderFxSwirl_angle_get(PointerRNA *ptr);
void ShaderFxSwirl_angle_set(PointerRNA *ptr, float value);

PointerRNA ShaderFxSwirl_object_get(PointerRNA *ptr);

int ShaderFxSwirl_radius_get(PointerRNA *ptr);
void ShaderFxSwirl_radius_set(PointerRNA *ptr, int value);

bool ShaderFxSwirl_use_transparent_get(PointerRNA *ptr);
void ShaderFxSwirl_use_transparent_set(PointerRNA *ptr, bool value);

/**************** Wave Deformation Effect ****************/

extern StructRNA RNA_ShaderFxWave;
extern StructRNA RNA_ShaderFx;

float ShaderFxWave_amplitude_get(PointerRNA *ptr);
void ShaderFxWave_amplitude_set(PointerRNA *ptr, float value);

enum {
	ShaderFxWave_orientation_HORIZONTAL = 0,
	ShaderFxWave_orientation_VERTICAL = 1,
};

int ShaderFxWave_orientation_get(PointerRNA *ptr);
void ShaderFxWave_orientation_set(PointerRNA *ptr, int value);

float ShaderFxWave_period_get(PointerRNA *ptr);
void ShaderFxWave_period_set(PointerRNA *ptr, float value);

float ShaderFxWave_phase_get(PointerRNA *ptr);
void ShaderFxWave_phase_set(PointerRNA *ptr, float value);

/**************** Shader Node ****************/

extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

/**************** ShaderNodeAddShader ****************/

extern StructRNA RNA_ShaderNodeAddShader;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeAddShader_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeAddShader_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeAddShader_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeAmbientOcclusion ****************/

extern StructRNA RNA_ShaderNodeAmbientOcclusion;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeAmbientOcclusion_inside_get(PointerRNA *ptr);
void ShaderNodeAmbientOcclusion_inside_set(PointerRNA *ptr, bool value);

bool ShaderNodeAmbientOcclusion_only_local_get(PointerRNA *ptr);
void ShaderNodeAmbientOcclusion_only_local_set(PointerRNA *ptr, bool value);

int ShaderNodeAmbientOcclusion_samples_get(PointerRNA *ptr);
void ShaderNodeAmbientOcclusion_samples_set(PointerRNA *ptr, int value);

bool ShaderNodeAmbientOcclusion_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeAmbientOcclusion_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeAmbientOcclusion_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeAttribute ****************/

extern StructRNA RNA_ShaderNodeAttribute;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

#define ShaderNodeAttribute_attribute_name_MAX 256

void ShaderNodeAttribute_attribute_name_get(PointerRNA *ptr, char *value);
int ShaderNodeAttribute_attribute_name_length(PointerRNA *ptr);
void ShaderNodeAttribute_attribute_name_set(PointerRNA *ptr, const char *value);

enum {
	ShaderNodeAttribute_attribute_type_GEOMETRY = 0,
	ShaderNodeAttribute_attribute_type_OBJECT = 1,
	ShaderNodeAttribute_attribute_type_INSTANCER = 2,
	ShaderNodeAttribute_attribute_type_VIEW_LAYER = 3,
};

int ShaderNodeAttribute_attribute_type_get(PointerRNA *ptr);
void ShaderNodeAttribute_attribute_type_set(PointerRNA *ptr, int value);

bool ShaderNodeAttribute_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeAttribute_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeAttribute_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeBackground ****************/

extern StructRNA RNA_ShaderNodeBackground;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeBackground_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeBackground_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeBackground_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeBevel ****************/

extern StructRNA RNA_ShaderNodeBevel;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int ShaderNodeBevel_samples_get(PointerRNA *ptr);
void ShaderNodeBevel_samples_set(PointerRNA *ptr, int value);

bool ShaderNodeBevel_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeBevel_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeBevel_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeBlackbody ****************/

extern StructRNA RNA_ShaderNodeBlackbody;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeBlackbody_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeBlackbody_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeBlackbody_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeBrightContrast ****************/

extern StructRNA RNA_ShaderNodeBrightContrast;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeBrightContrast_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeBrightContrast_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeBrightContrast_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeBsdfAnisotropic ****************/

extern StructRNA RNA_ShaderNodeBsdfAnisotropic;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeBsdfAnisotropic_distribution_BECKMANN = 0,
	ShaderNodeBsdfAnisotropic_distribution_GGX = 2,
	ShaderNodeBsdfAnisotropic_distribution_ASHIKHMIN_SHIRLEY = 3,
	ShaderNodeBsdfAnisotropic_distribution_MULTI_GGX = 4,
};

int ShaderNodeBsdfAnisotropic_distribution_get(PointerRNA *ptr);
void ShaderNodeBsdfAnisotropic_distribution_set(PointerRNA *ptr, int value);

bool ShaderNodeBsdfAnisotropic_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeBsdfAnisotropic_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeBsdfAnisotropic_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeBsdfDiffuse ****************/

extern StructRNA RNA_ShaderNodeBsdfDiffuse;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeBsdfDiffuse_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeBsdfDiffuse_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeBsdfDiffuse_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeBsdfGlass ****************/

extern StructRNA RNA_ShaderNodeBsdfGlass;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeBsdfGlass_distribution_BECKMANN = 0,
	ShaderNodeBsdfGlass_distribution_GGX = 2,
	ShaderNodeBsdfGlass_distribution_MULTI_GGX = 4,
};

int ShaderNodeBsdfGlass_distribution_get(PointerRNA *ptr);
void ShaderNodeBsdfGlass_distribution_set(PointerRNA *ptr, int value);

bool ShaderNodeBsdfGlass_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeBsdfGlass_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeBsdfGlass_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeBsdfHair ****************/

extern StructRNA RNA_ShaderNodeBsdfHair;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeBsdfHair_component_Reflection = 0,
	ShaderNodeBsdfHair_component_Transmission = 1,
};

int ShaderNodeBsdfHair_component_get(PointerRNA *ptr);
void ShaderNodeBsdfHair_component_set(PointerRNA *ptr, int value);

bool ShaderNodeBsdfHair_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeBsdfHair_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeBsdfHair_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeBsdfHairPrincipled ****************/

extern StructRNA RNA_ShaderNodeBsdfHairPrincipled;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeBsdfHairPrincipled_parametrization_ABSORPTION = 2,
	ShaderNodeBsdfHairPrincipled_parametrization_MELANIN = 1,
	ShaderNodeBsdfHairPrincipled_parametrization_COLOR = 0,
};

int ShaderNodeBsdfHairPrincipled_parametrization_get(PointerRNA *ptr);
void ShaderNodeBsdfHairPrincipled_parametrization_set(PointerRNA *ptr, int value);

enum {
	ShaderNodeBsdfHairPrincipled_model_CHIANG = 0,
	ShaderNodeBsdfHairPrincipled_model_HUANG = 1,
};

int ShaderNodeBsdfHairPrincipled_model_get(PointerRNA *ptr);
void ShaderNodeBsdfHairPrincipled_model_set(PointerRNA *ptr, int value);

bool ShaderNodeBsdfHairPrincipled_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeBsdfHairPrincipled_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeBsdfHairPrincipled_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeBsdfMetallic ****************/

extern StructRNA RNA_ShaderNodeBsdfMetallic;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeBsdfMetallic_distribution_BECKMANN = 0,
	ShaderNodeBsdfMetallic_distribution_GGX = 2,
	ShaderNodeBsdfMetallic_distribution_MULTI_GGX = 4,
};

int ShaderNodeBsdfMetallic_distribution_get(PointerRNA *ptr);
void ShaderNodeBsdfMetallic_distribution_set(PointerRNA *ptr, int value);

enum {
	ShaderNodeBsdfMetallic_fresnel_type_PHYSICAL_CONDUCTOR = 0,
	ShaderNodeBsdfMetallic_fresnel_type_F82 = 1,
};

int ShaderNodeBsdfMetallic_fresnel_type_get(PointerRNA *ptr);
void ShaderNodeBsdfMetallic_fresnel_type_set(PointerRNA *ptr, int value);

bool ShaderNodeBsdfMetallic_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeBsdfMetallic_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeBsdfMetallic_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeBsdfPrincipled ****************/

extern StructRNA RNA_ShaderNodeBsdfPrincipled;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeBsdfPrincipled_distribution_GGX = 2,
	ShaderNodeBsdfPrincipled_distribution_MULTI_GGX = 4,
};

int ShaderNodeBsdfPrincipled_distribution_get(PointerRNA *ptr);
void ShaderNodeBsdfPrincipled_distribution_set(PointerRNA *ptr, int value);

enum {
	ShaderNodeBsdfPrincipled_subsurface_method_BURLEY = 3,
	ShaderNodeBsdfPrincipled_subsurface_method_RANDOM_WALK = 4,
	ShaderNodeBsdfPrincipled_subsurface_method_RANDOM_WALK_SKIN = 5,
};

int ShaderNodeBsdfPrincipled_subsurface_method_get(PointerRNA *ptr);
void ShaderNodeBsdfPrincipled_subsurface_method_set(PointerRNA *ptr, int value);

bool ShaderNodeBsdfPrincipled_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeBsdfPrincipled_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeBsdfPrincipled_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeBsdfRayPortal ****************/

extern StructRNA RNA_ShaderNodeBsdfRayPortal;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeBsdfRayPortal_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeBsdfRayPortal_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeBsdfRayPortal_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeBsdfRefraction ****************/

extern StructRNA RNA_ShaderNodeBsdfRefraction;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeBsdfRefraction_distribution_BECKMANN = 0,
	ShaderNodeBsdfRefraction_distribution_GGX = 2,
};

int ShaderNodeBsdfRefraction_distribution_get(PointerRNA *ptr);
void ShaderNodeBsdfRefraction_distribution_set(PointerRNA *ptr, int value);

bool ShaderNodeBsdfRefraction_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeBsdfRefraction_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeBsdfRefraction_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeBsdfSheen ****************/

extern StructRNA RNA_ShaderNodeBsdfSheen;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeBsdfSheen_distribution_ASHIKHMIN = 0,
	ShaderNodeBsdfSheen_distribution_MICROFIBER = 1,
};

int ShaderNodeBsdfSheen_distribution_get(PointerRNA *ptr);
void ShaderNodeBsdfSheen_distribution_set(PointerRNA *ptr, int value);

bool ShaderNodeBsdfSheen_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeBsdfSheen_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeBsdfSheen_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeBsdfToon ****************/

extern StructRNA RNA_ShaderNodeBsdfToon;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeBsdfToon_component_DIFFUSE = 0,
	ShaderNodeBsdfToon_component_GLOSSY = 1,
};

int ShaderNodeBsdfToon_component_get(PointerRNA *ptr);
void ShaderNodeBsdfToon_component_set(PointerRNA *ptr, int value);

bool ShaderNodeBsdfToon_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeBsdfToon_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeBsdfToon_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeBsdfTranslucent ****************/

extern StructRNA RNA_ShaderNodeBsdfTranslucent;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeBsdfTranslucent_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeBsdfTranslucent_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeBsdfTranslucent_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeBsdfTransparent ****************/

extern StructRNA RNA_ShaderNodeBsdfTransparent;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeBsdfTransparent_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeBsdfTransparent_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeBsdfTransparent_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeBump ****************/

extern StructRNA RNA_ShaderNodeBump;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeBump_invert_get(PointerRNA *ptr);
void ShaderNodeBump_invert_set(PointerRNA *ptr, bool value);

bool ShaderNodeBump_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeBump_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeBump_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeCameraData ****************/

extern StructRNA RNA_ShaderNodeCameraData;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeCameraData_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeCameraData_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeCameraData_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeClamp ****************/

extern StructRNA RNA_ShaderNodeClamp;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeClamp_clamp_type_MINMAX = 0,
	ShaderNodeClamp_clamp_type_RANGE = 1,
};

int ShaderNodeClamp_clamp_type_get(PointerRNA *ptr);
void ShaderNodeClamp_clamp_type_set(PointerRNA *ptr, int value);

bool ShaderNodeClamp_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeClamp_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeClamp_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeCombineColor ****************/

extern StructRNA RNA_ShaderNodeCombineColor;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeCombineColor_mode_RGB = 0,
	ShaderNodeCombineColor_mode_HSV = 1,
	ShaderNodeCombineColor_mode_HSL = 2,
};

int ShaderNodeCombineColor_mode_get(PointerRNA *ptr);
void ShaderNodeCombineColor_mode_set(PointerRNA *ptr, int value);

bool ShaderNodeCombineColor_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeCombineColor_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeCombineColor_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeCombineHSV ****************/

extern StructRNA RNA_ShaderNodeCombineHSV;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeCombineHSV_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeCombineHSV_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeCombineHSV_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeCombineRGB ****************/

extern StructRNA RNA_ShaderNodeCombineRGB;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeCombineRGB_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeCombineRGB_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeCombineRGB_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeCombineXYZ ****************/

extern StructRNA RNA_ShaderNodeCombineXYZ;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeCombineXYZ_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeCombineXYZ_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeCombineXYZ_output_template_func(struct StructRNA *_type, int index);
/**************** Shader Custom Group ****************/

extern StructRNA RNA_ShaderNodeCustomGroup;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA ShaderNodeCustomGroup_node_tree_get(PointerRNA *ptr);

/**************** ShaderNodeDisplacement ****************/

extern StructRNA RNA_ShaderNodeDisplacement;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeDisplacement_space_OBJECT = 1,
	ShaderNodeDisplacement_space_WORLD = 2,
};

int ShaderNodeDisplacement_space_get(PointerRNA *ptr);
void ShaderNodeDisplacement_space_set(PointerRNA *ptr, int value);

bool ShaderNodeDisplacement_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeDisplacement_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeDisplacement_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeEeveeSpecular ****************/

extern StructRNA RNA_ShaderNodeEeveeSpecular;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeEeveeSpecular_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeEeveeSpecular_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeEeveeSpecular_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeEmission ****************/

extern StructRNA RNA_ShaderNodeEmission;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeEmission_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeEmission_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeEmission_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeFloatCurve ****************/

extern StructRNA RNA_ShaderNodeFloatCurve;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA ShaderNodeFloatCurve_mapping_get(PointerRNA *ptr);

bool ShaderNodeFloatCurve_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeFloatCurve_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeFloatCurve_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeFresnel ****************/

extern StructRNA RNA_ShaderNodeFresnel;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeFresnel_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeFresnel_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeFresnel_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeGamma ****************/

extern StructRNA RNA_ShaderNodeGamma;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeGamma_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeGamma_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeGamma_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeGroup ****************/

extern StructRNA RNA_ShaderNodeGroup;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA ShaderNodeGroup_node_tree_get(PointerRNA *ptr);

bool ShaderNodeGroup_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeGroup_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeGroup_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeHairInfo ****************/

extern StructRNA RNA_ShaderNodeHairInfo;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeHairInfo_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeHairInfo_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeHairInfo_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeHoldout ****************/

extern StructRNA RNA_ShaderNodeHoldout;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeHoldout_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeHoldout_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeHoldout_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeHueSaturation ****************/

extern StructRNA RNA_ShaderNodeHueSaturation;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeHueSaturation_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeHueSaturation_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeHueSaturation_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeInvert ****************/

extern StructRNA RNA_ShaderNodeInvert;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeInvert_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeInvert_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeInvert_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeLayerWeight ****************/

extern StructRNA RNA_ShaderNodeLayerWeight;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeLayerWeight_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeLayerWeight_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeLayerWeight_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeLightFalloff ****************/

extern StructRNA RNA_ShaderNodeLightFalloff;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeLightFalloff_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeLightFalloff_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeLightFalloff_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeLightPath ****************/

extern StructRNA RNA_ShaderNodeLightPath;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeLightPath_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeLightPath_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeLightPath_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeMapRange ****************/

extern StructRNA RNA_ShaderNodeMapRange;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeMapRange_clamp_get(PointerRNA *ptr);
void ShaderNodeMapRange_clamp_set(PointerRNA *ptr, bool value);

enum {
	ShaderNodeMapRange_data_type_FLOAT = 10,
	ShaderNodeMapRange_data_type_FLOAT_VECTOR = 48,
};

int ShaderNodeMapRange_data_type_get(PointerRNA *ptr);
void ShaderNodeMapRange_data_type_set(PointerRNA *ptr, int value);

enum {
	ShaderNodeMapRange_interpolation_type_LINEAR = 0,
	ShaderNodeMapRange_interpolation_type_STEPPED = 1,
	ShaderNodeMapRange_interpolation_type_SMOOTHSTEP = 2,
	ShaderNodeMapRange_interpolation_type_SMOOTHERSTEP = 3,
};

int ShaderNodeMapRange_interpolation_type_get(PointerRNA *ptr);
void ShaderNodeMapRange_interpolation_type_set(PointerRNA *ptr, int value);

bool ShaderNodeMapRange_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeMapRange_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeMapRange_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeMapping ****************/

extern StructRNA RNA_ShaderNodeMapping;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeMapping_vector_type_POINT = 0,
	ShaderNodeMapping_vector_type_TEXTURE = 1,
	ShaderNodeMapping_vector_type_VECTOR = 2,
	ShaderNodeMapping_vector_type_NORMAL = 3,
};

int ShaderNodeMapping_vector_type_get(PointerRNA *ptr);
void ShaderNodeMapping_vector_type_set(PointerRNA *ptr, int value);

bool ShaderNodeMapping_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeMapping_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeMapping_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeMath ****************/

extern StructRNA RNA_ShaderNodeMath;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeMath_use_clamp_get(PointerRNA *ptr);
void ShaderNodeMath_use_clamp_set(PointerRNA *ptr, bool value);

enum {
	ShaderNodeMath_operation_ADD = 0,
	ShaderNodeMath_operation_SUBTRACT = 1,
	ShaderNodeMath_operation_MULTIPLY = 2,
	ShaderNodeMath_operation_DIVIDE = 3,
	ShaderNodeMath_operation_MULTIPLY_ADD = 36,
	ShaderNodeMath_operation_POWER = 10,
	ShaderNodeMath_operation_LOGARITHM = 11,
	ShaderNodeMath_operation_SQRT = 23,
	ShaderNodeMath_operation_INVERSE_SQRT = 24,
	ShaderNodeMath_operation_ABSOLUTE = 18,
	ShaderNodeMath_operation_EXPONENT = 26,
	ShaderNodeMath_operation_MINIMUM = 12,
	ShaderNodeMath_operation_MAXIMUM = 13,
	ShaderNodeMath_operation_LESS_THAN = 15,
	ShaderNodeMath_operation_GREATER_THAN = 16,
	ShaderNodeMath_operation_SIGN = 25,
	ShaderNodeMath_operation_COMPARE = 35,
	ShaderNodeMath_operation_SMOOTH_MIN = 38,
	ShaderNodeMath_operation_SMOOTH_MAX = 39,
	ShaderNodeMath_operation_ROUND = 14,
	ShaderNodeMath_operation_FLOOR = 20,
	ShaderNodeMath_operation_CEIL = 21,
	ShaderNodeMath_operation_TRUNC = 32,
	ShaderNodeMath_operation_FRACT = 22,
	ShaderNodeMath_operation_MODULO = 17,
	ShaderNodeMath_operation_FLOORED_MODULO = 40,
	ShaderNodeMath_operation_WRAP = 34,
	ShaderNodeMath_operation_SNAP = 33,
	ShaderNodeMath_operation_PINGPONG = 37,
	ShaderNodeMath_operation_SINE = 4,
	ShaderNodeMath_operation_COSINE = 5,
	ShaderNodeMath_operation_TANGENT = 6,
	ShaderNodeMath_operation_ARCSINE = 7,
	ShaderNodeMath_operation_ARCCOSINE = 8,
	ShaderNodeMath_operation_ARCTANGENT = 9,
	ShaderNodeMath_operation_ARCTAN2 = 19,
	ShaderNodeMath_operation_SINH = 29,
	ShaderNodeMath_operation_COSH = 30,
	ShaderNodeMath_operation_TANH = 31,
	ShaderNodeMath_operation_RADIANS = 27,
	ShaderNodeMath_operation_DEGREES = 28,
};

int ShaderNodeMath_operation_get(PointerRNA *ptr);
void ShaderNodeMath_operation_set(PointerRNA *ptr, int value);

bool ShaderNodeMath_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeMath_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeMath_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeMix ****************/

extern StructRNA RNA_ShaderNodeMix;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeMix_blend_type_MIX = 0,
	ShaderNodeMix_blend_type_DARKEN = 7,
	ShaderNodeMix_blend_type_MULTIPLY = 2,
	ShaderNodeMix_blend_type_BURN = 11,
	ShaderNodeMix_blend_type_LIGHTEN = 8,
	ShaderNodeMix_blend_type_SCREEN = 4,
	ShaderNodeMix_blend_type_DODGE = 10,
	ShaderNodeMix_blend_type_ADD = 1,
	ShaderNodeMix_blend_type_OVERLAY = 9,
	ShaderNodeMix_blend_type_SOFT_LIGHT = 16,
	ShaderNodeMix_blend_type_LINEAR_LIGHT = 17,
	ShaderNodeMix_blend_type_DIFFERENCE = 6,
	ShaderNodeMix_blend_type_EXCLUSION = 18,
	ShaderNodeMix_blend_type_SUBTRACT = 3,
	ShaderNodeMix_blend_type_DIVIDE = 5,
	ShaderNodeMix_blend_type_HUE = 12,
	ShaderNodeMix_blend_type_SATURATION = 13,
	ShaderNodeMix_blend_type_COLOR = 15,
	ShaderNodeMix_blend_type_VALUE = 14,
};

int ShaderNodeMix_blend_type_get(PointerRNA *ptr);
void ShaderNodeMix_blend_type_set(PointerRNA *ptr, int value);

bool ShaderNodeMix_clamp_factor_get(PointerRNA *ptr);
void ShaderNodeMix_clamp_factor_set(PointerRNA *ptr, bool value);

bool ShaderNodeMix_clamp_result_get(PointerRNA *ptr);
void ShaderNodeMix_clamp_result_set(PointerRNA *ptr, bool value);

enum {
	ShaderNodeMix_data_type_FLOAT = 0,
	ShaderNodeMix_data_type_VECTOR = 1,
	ShaderNodeMix_data_type_RGBA = 2,
	ShaderNodeMix_data_type_ROTATION = 14,
};

int ShaderNodeMix_data_type_get(PointerRNA *ptr);
void ShaderNodeMix_data_type_set(PointerRNA *ptr, int value);

enum {
	ShaderNodeMix_factor_mode_UNIFORM = 0,
	ShaderNodeMix_factor_mode_NON_UNIFORM = 1,
};

int ShaderNodeMix_factor_mode_get(PointerRNA *ptr);
void ShaderNodeMix_factor_mode_set(PointerRNA *ptr, int value);

bool ShaderNodeMix_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeMix_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeMix_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeMixRGB ****************/

extern StructRNA RNA_ShaderNodeMixRGB;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeMixRGB_use_alpha_get(PointerRNA *ptr);
void ShaderNodeMixRGB_use_alpha_set(PointerRNA *ptr, bool value);

enum {
	ShaderNodeMixRGB_blend_type_MIX = 0,
	ShaderNodeMixRGB_blend_type_DARKEN = 7,
	ShaderNodeMixRGB_blend_type_MULTIPLY = 2,
	ShaderNodeMixRGB_blend_type_BURN = 11,
	ShaderNodeMixRGB_blend_type_LIGHTEN = 8,
	ShaderNodeMixRGB_blend_type_SCREEN = 4,
	ShaderNodeMixRGB_blend_type_DODGE = 10,
	ShaderNodeMixRGB_blend_type_ADD = 1,
	ShaderNodeMixRGB_blend_type_OVERLAY = 9,
	ShaderNodeMixRGB_blend_type_SOFT_LIGHT = 16,
	ShaderNodeMixRGB_blend_type_LINEAR_LIGHT = 17,
	ShaderNodeMixRGB_blend_type_DIFFERENCE = 6,
	ShaderNodeMixRGB_blend_type_EXCLUSION = 18,
	ShaderNodeMixRGB_blend_type_SUBTRACT = 3,
	ShaderNodeMixRGB_blend_type_DIVIDE = 5,
	ShaderNodeMixRGB_blend_type_HUE = 12,
	ShaderNodeMixRGB_blend_type_SATURATION = 13,
	ShaderNodeMixRGB_blend_type_COLOR = 15,
	ShaderNodeMixRGB_blend_type_VALUE = 14,
};

int ShaderNodeMixRGB_blend_type_get(PointerRNA *ptr);
void ShaderNodeMixRGB_blend_type_set(PointerRNA *ptr, int value);

bool ShaderNodeMixRGB_use_clamp_get(PointerRNA *ptr);
void ShaderNodeMixRGB_use_clamp_set(PointerRNA *ptr, bool value);

bool ShaderNodeMixRGB_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeMixRGB_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeMixRGB_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeMixShader ****************/

extern StructRNA RNA_ShaderNodeMixShader;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeMixShader_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeMixShader_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeMixShader_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeNewGeometry ****************/

extern StructRNA RNA_ShaderNodeNewGeometry;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeNewGeometry_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeNewGeometry_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeNewGeometry_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeNormal ****************/

extern StructRNA RNA_ShaderNodeNormal;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeNormal_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeNormal_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeNormal_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeNormalMap ****************/

extern StructRNA RNA_ShaderNodeNormalMap;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeNormalMap_space_TANGENT = 0,
	ShaderNodeNormalMap_space_OBJECT = 1,
	ShaderNodeNormalMap_space_WORLD = 2,
	ShaderNodeNormalMap_space_BLENDER_OBJECT = 3,
	ShaderNodeNormalMap_space_BLENDER_WORLD = 4,
};

int ShaderNodeNormalMap_space_get(PointerRNA *ptr);
void ShaderNodeNormalMap_space_set(PointerRNA *ptr, int value);

#define ShaderNodeNormalMap_uv_map_MAX 64

void ShaderNodeNormalMap_uv_map_get(PointerRNA *ptr, char *value);
int ShaderNodeNormalMap_uv_map_length(PointerRNA *ptr);
void ShaderNodeNormalMap_uv_map_set(PointerRNA *ptr, const char *value);

bool ShaderNodeNormalMap_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeNormalMap_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeNormalMap_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeObjectInfo ****************/

extern StructRNA RNA_ShaderNodeObjectInfo;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeObjectInfo_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeObjectInfo_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeObjectInfo_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeOutputAOV ****************/

extern StructRNA RNA_ShaderNodeOutputAOV;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

#define ShaderNodeOutputAOV_aov_name_MAX 64

void ShaderNodeOutputAOV_aov_name_get(PointerRNA *ptr, char *value);
int ShaderNodeOutputAOV_aov_name_length(PointerRNA *ptr);
void ShaderNodeOutputAOV_aov_name_set(PointerRNA *ptr, const char *value);

bool ShaderNodeOutputAOV_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeOutputAOV_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeOutputAOV_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeOutputLight ****************/

extern StructRNA RNA_ShaderNodeOutputLight;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeOutputLight_is_active_output_get(PointerRNA *ptr);
void ShaderNodeOutputLight_is_active_output_set(PointerRNA *ptr, bool value);

enum {
	ShaderNodeOutputLight_target_ALL = 0,
	ShaderNodeOutputLight_target_EEVEE = 1,
	ShaderNodeOutputLight_target_CYCLES = 2,
};

int ShaderNodeOutputLight_target_get(PointerRNA *ptr);
void ShaderNodeOutputLight_target_set(PointerRNA *ptr, int value);

bool ShaderNodeOutputLight_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeOutputLight_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeOutputLight_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeOutputLineStyle ****************/

extern StructRNA RNA_ShaderNodeOutputLineStyle;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeOutputLineStyle_is_active_output_get(PointerRNA *ptr);
void ShaderNodeOutputLineStyle_is_active_output_set(PointerRNA *ptr, bool value);

bool ShaderNodeOutputLineStyle_use_alpha_get(PointerRNA *ptr);
void ShaderNodeOutputLineStyle_use_alpha_set(PointerRNA *ptr, bool value);

enum {
	ShaderNodeOutputLineStyle_blend_type_MIX = 0,
	ShaderNodeOutputLineStyle_blend_type_DARKEN = 7,
	ShaderNodeOutputLineStyle_blend_type_MULTIPLY = 2,
	ShaderNodeOutputLineStyle_blend_type_BURN = 11,
	ShaderNodeOutputLineStyle_blend_type_LIGHTEN = 8,
	ShaderNodeOutputLineStyle_blend_type_SCREEN = 4,
	ShaderNodeOutputLineStyle_blend_type_DODGE = 10,
	ShaderNodeOutputLineStyle_blend_type_ADD = 1,
	ShaderNodeOutputLineStyle_blend_type_OVERLAY = 9,
	ShaderNodeOutputLineStyle_blend_type_SOFT_LIGHT = 16,
	ShaderNodeOutputLineStyle_blend_type_LINEAR_LIGHT = 17,
	ShaderNodeOutputLineStyle_blend_type_DIFFERENCE = 6,
	ShaderNodeOutputLineStyle_blend_type_EXCLUSION = 18,
	ShaderNodeOutputLineStyle_blend_type_SUBTRACT = 3,
	ShaderNodeOutputLineStyle_blend_type_DIVIDE = 5,
	ShaderNodeOutputLineStyle_blend_type_HUE = 12,
	ShaderNodeOutputLineStyle_blend_type_SATURATION = 13,
	ShaderNodeOutputLineStyle_blend_type_COLOR = 15,
	ShaderNodeOutputLineStyle_blend_type_VALUE = 14,
};

int ShaderNodeOutputLineStyle_blend_type_get(PointerRNA *ptr);
void ShaderNodeOutputLineStyle_blend_type_set(PointerRNA *ptr, int value);

bool ShaderNodeOutputLineStyle_use_clamp_get(PointerRNA *ptr);
void ShaderNodeOutputLineStyle_use_clamp_set(PointerRNA *ptr, bool value);

enum {
	ShaderNodeOutputLineStyle_target_ALL = 0,
	ShaderNodeOutputLineStyle_target_EEVEE = 1,
	ShaderNodeOutputLineStyle_target_CYCLES = 2,
};

int ShaderNodeOutputLineStyle_target_get(PointerRNA *ptr);
void ShaderNodeOutputLineStyle_target_set(PointerRNA *ptr, int value);

bool ShaderNodeOutputLineStyle_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeOutputLineStyle_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeOutputLineStyle_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeOutputMaterial ****************/

extern StructRNA RNA_ShaderNodeOutputMaterial;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeOutputMaterial_is_active_output_get(PointerRNA *ptr);
void ShaderNodeOutputMaterial_is_active_output_set(PointerRNA *ptr, bool value);

enum {
	ShaderNodeOutputMaterial_target_ALL = 0,
	ShaderNodeOutputMaterial_target_EEVEE = 1,
	ShaderNodeOutputMaterial_target_CYCLES = 2,
};

int ShaderNodeOutputMaterial_target_get(PointerRNA *ptr);
void ShaderNodeOutputMaterial_target_set(PointerRNA *ptr, int value);

bool ShaderNodeOutputMaterial_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeOutputMaterial_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeOutputMaterial_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeOutputWorld ****************/

extern StructRNA RNA_ShaderNodeOutputWorld;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeOutputWorld_is_active_output_get(PointerRNA *ptr);
void ShaderNodeOutputWorld_is_active_output_set(PointerRNA *ptr, bool value);

enum {
	ShaderNodeOutputWorld_target_ALL = 0,
	ShaderNodeOutputWorld_target_EEVEE = 1,
	ShaderNodeOutputWorld_target_CYCLES = 2,
};

int ShaderNodeOutputWorld_target_get(PointerRNA *ptr);
void ShaderNodeOutputWorld_target_set(PointerRNA *ptr, int value);

bool ShaderNodeOutputWorld_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeOutputWorld_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeOutputWorld_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeParticleInfo ****************/

extern StructRNA RNA_ShaderNodeParticleInfo;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeParticleInfo_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeParticleInfo_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeParticleInfo_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodePointInfo ****************/

extern StructRNA RNA_ShaderNodePointInfo;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodePointInfo_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodePointInfo_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodePointInfo_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeRGB ****************/

extern StructRNA RNA_ShaderNodeRGB;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeRGB_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeRGB_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeRGB_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeRGBCurve ****************/

extern StructRNA RNA_ShaderNodeRGBCurve;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA ShaderNodeRGBCurve_mapping_get(PointerRNA *ptr);

bool ShaderNodeRGBCurve_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeRGBCurve_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeRGBCurve_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeRGBToBW ****************/

extern StructRNA RNA_ShaderNodeRGBToBW;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeRGBToBW_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeRGBToBW_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeRGBToBW_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeScript ****************/

extern StructRNA RNA_ShaderNodeScript;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeScript_use_auto_update_get(PointerRNA *ptr);
void ShaderNodeScript_use_auto_update_set(PointerRNA *ptr, bool value);

void ShaderNodeScript_bytecode_get(PointerRNA *ptr, char *value);
int ShaderNodeScript_bytecode_length(PointerRNA *ptr);
void ShaderNodeScript_bytecode_set(PointerRNA *ptr, const char *value);

#define ShaderNodeScript_bytecode_hash_MAX 64

void ShaderNodeScript_bytecode_hash_get(PointerRNA *ptr, char *value);
int ShaderNodeScript_bytecode_hash_length(PointerRNA *ptr);
void ShaderNodeScript_bytecode_hash_set(PointerRNA *ptr, const char *value);

#define ShaderNodeScript_filepath_MAX 1024

void ShaderNodeScript_filepath_get(PointerRNA *ptr, char *value);
int ShaderNodeScript_filepath_length(PointerRNA *ptr);
void ShaderNodeScript_filepath_set(PointerRNA *ptr, const char *value);

PointerRNA ShaderNodeScript_script_get(PointerRNA *ptr);

enum {
	ShaderNodeScript_mode_INTERNAL = 0,
	ShaderNodeScript_mode_EXTERNAL = 1,
};

int ShaderNodeScript_mode_get(PointerRNA *ptr);
void ShaderNodeScript_mode_set(PointerRNA *ptr, int value);

bool ShaderNodeScript_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeScript_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeScript_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeSeparateColor ****************/

extern StructRNA RNA_ShaderNodeSeparateColor;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeSeparateColor_mode_RGB = 0,
	ShaderNodeSeparateColor_mode_HSV = 1,
	ShaderNodeSeparateColor_mode_HSL = 2,
};

int ShaderNodeSeparateColor_mode_get(PointerRNA *ptr);
void ShaderNodeSeparateColor_mode_set(PointerRNA *ptr, int value);

bool ShaderNodeSeparateColor_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeSeparateColor_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeSeparateColor_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeSeparateHSV ****************/

extern StructRNA RNA_ShaderNodeSeparateHSV;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeSeparateHSV_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeSeparateHSV_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeSeparateHSV_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeSeparateRGB ****************/

extern StructRNA RNA_ShaderNodeSeparateRGB;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeSeparateRGB_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeSeparateRGB_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeSeparateRGB_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeSeparateXYZ ****************/

extern StructRNA RNA_ShaderNodeSeparateXYZ;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeSeparateXYZ_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeSeparateXYZ_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeSeparateXYZ_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeShaderToRGB ****************/

extern StructRNA RNA_ShaderNodeShaderToRGB;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeShaderToRGB_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeShaderToRGB_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeShaderToRGB_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeSqueeze ****************/

extern StructRNA RNA_ShaderNodeSqueeze;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeSqueeze_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeSqueeze_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeSqueeze_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeSubsurfaceScattering ****************/

extern StructRNA RNA_ShaderNodeSubsurfaceScattering;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeSubsurfaceScattering_falloff_BURLEY = 3,
	ShaderNodeSubsurfaceScattering_falloff_RANDOM_WALK = 4,
	ShaderNodeSubsurfaceScattering_falloff_RANDOM_WALK_SKIN = 5,
};

int ShaderNodeSubsurfaceScattering_falloff_get(PointerRNA *ptr);
void ShaderNodeSubsurfaceScattering_falloff_set(PointerRNA *ptr, int value);

bool ShaderNodeSubsurfaceScattering_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeSubsurfaceScattering_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeSubsurfaceScattering_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeTangent ****************/

extern StructRNA RNA_ShaderNodeTangent;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeTangent_axis_X = 0,
	ShaderNodeTangent_axis_Y = 1,
	ShaderNodeTangent_axis_Z = 2,
};

int ShaderNodeTangent_axis_get(PointerRNA *ptr);
void ShaderNodeTangent_axis_set(PointerRNA *ptr, int value);

enum {
	ShaderNodeTangent_direction_type_RADIAL = 0,
	ShaderNodeTangent_direction_type_UV_MAP = 1,
};

int ShaderNodeTangent_direction_type_get(PointerRNA *ptr);
void ShaderNodeTangent_direction_type_set(PointerRNA *ptr, int value);

#define ShaderNodeTangent_uv_map_MAX 64

void ShaderNodeTangent_uv_map_get(PointerRNA *ptr, char *value);
int ShaderNodeTangent_uv_map_length(PointerRNA *ptr);
void ShaderNodeTangent_uv_map_set(PointerRNA *ptr, const char *value);

bool ShaderNodeTangent_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeTangent_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeTangent_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeTexBrick ****************/

extern StructRNA RNA_ShaderNodeTexBrick;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA ShaderNodeTexBrick_color_mapping_get(PointerRNA *ptr);

float ShaderNodeTexBrick_offset_get(PointerRNA *ptr);
void ShaderNodeTexBrick_offset_set(PointerRNA *ptr, float value);

int ShaderNodeTexBrick_offset_frequency_get(PointerRNA *ptr);
void ShaderNodeTexBrick_offset_frequency_set(PointerRNA *ptr, int value);

float ShaderNodeTexBrick_squash_get(PointerRNA *ptr);
void ShaderNodeTexBrick_squash_set(PointerRNA *ptr, float value);

int ShaderNodeTexBrick_squash_frequency_get(PointerRNA *ptr);
void ShaderNodeTexBrick_squash_frequency_set(PointerRNA *ptr, int value);

PointerRNA ShaderNodeTexBrick_texture_mapping_get(PointerRNA *ptr);

bool ShaderNodeTexBrick_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeTexBrick_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeTexBrick_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeTexChecker ****************/

extern StructRNA RNA_ShaderNodeTexChecker;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA ShaderNodeTexChecker_color_mapping_get(PointerRNA *ptr);

PointerRNA ShaderNodeTexChecker_texture_mapping_get(PointerRNA *ptr);

bool ShaderNodeTexChecker_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeTexChecker_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeTexChecker_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeTexCoord ****************/

extern StructRNA RNA_ShaderNodeTexCoord;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeTexCoord_from_instancer_get(PointerRNA *ptr);
void ShaderNodeTexCoord_from_instancer_set(PointerRNA *ptr, bool value);

PointerRNA ShaderNodeTexCoord_object_get(PointerRNA *ptr);

bool ShaderNodeTexCoord_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeTexCoord_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeTexCoord_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeTexEnvironment ****************/

extern StructRNA RNA_ShaderNodeTexEnvironment;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA ShaderNodeTexEnvironment_color_mapping_get(PointerRNA *ptr);

PointerRNA ShaderNodeTexEnvironment_image_get(PointerRNA *ptr);

PointerRNA ShaderNodeTexEnvironment_image_user_get(PointerRNA *ptr);

enum {
	ShaderNodeTexEnvironment_interpolation_Linear = 0,
	ShaderNodeTexEnvironment_interpolation_Closest = 1,
	ShaderNodeTexEnvironment_interpolation_Cubic = 2,
	ShaderNodeTexEnvironment_interpolation_Smart = 3,
};

int ShaderNodeTexEnvironment_interpolation_get(PointerRNA *ptr);
void ShaderNodeTexEnvironment_interpolation_set(PointerRNA *ptr, int value);

enum {
	ShaderNodeTexEnvironment_projection_EQUIRECTANGULAR = 0,
	ShaderNodeTexEnvironment_projection_MIRROR_BALL = 1,
};

int ShaderNodeTexEnvironment_projection_get(PointerRNA *ptr);
void ShaderNodeTexEnvironment_projection_set(PointerRNA *ptr, int value);

PointerRNA ShaderNodeTexEnvironment_texture_mapping_get(PointerRNA *ptr);

bool ShaderNodeTexEnvironment_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeTexEnvironment_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeTexEnvironment_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeTexGabor ****************/

extern StructRNA RNA_ShaderNodeTexGabor;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA ShaderNodeTexGabor_color_mapping_get(PointerRNA *ptr);

PointerRNA ShaderNodeTexGabor_texture_mapping_get(PointerRNA *ptr);

enum {
	ShaderNodeTexGabor_gabor_type_2D = 0,
	ShaderNodeTexGabor_gabor_type_3D = 1,
};

int ShaderNodeTexGabor_gabor_type_get(PointerRNA *ptr);
void ShaderNodeTexGabor_gabor_type_set(PointerRNA *ptr, int value);

bool ShaderNodeTexGabor_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeTexGabor_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeTexGabor_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeTexGradient ****************/

extern StructRNA RNA_ShaderNodeTexGradient;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA ShaderNodeTexGradient_color_mapping_get(PointerRNA *ptr);

enum {
	ShaderNodeTexGradient_gradient_type_LINEAR = 0,
	ShaderNodeTexGradient_gradient_type_QUADRATIC = 1,
	ShaderNodeTexGradient_gradient_type_EASING = 2,
	ShaderNodeTexGradient_gradient_type_DIAGONAL = 3,
	ShaderNodeTexGradient_gradient_type_SPHERICAL = 6,
	ShaderNodeTexGradient_gradient_type_QUADRATIC_SPHERE = 5,
	ShaderNodeTexGradient_gradient_type_RADIAL = 4,
};

int ShaderNodeTexGradient_gradient_type_get(PointerRNA *ptr);
void ShaderNodeTexGradient_gradient_type_set(PointerRNA *ptr, int value);

PointerRNA ShaderNodeTexGradient_texture_mapping_get(PointerRNA *ptr);

bool ShaderNodeTexGradient_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeTexGradient_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeTexGradient_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeTexIES ****************/

extern StructRNA RNA_ShaderNodeTexIES;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

#define ShaderNodeTexIES_filepath_MAX 1024

void ShaderNodeTexIES_filepath_get(PointerRNA *ptr, char *value);
int ShaderNodeTexIES_filepath_length(PointerRNA *ptr);
void ShaderNodeTexIES_filepath_set(PointerRNA *ptr, const char *value);

PointerRNA ShaderNodeTexIES_ies_get(PointerRNA *ptr);

enum {
	ShaderNodeTexIES_mode_INTERNAL = 0,
	ShaderNodeTexIES_mode_EXTERNAL = 1,
};

int ShaderNodeTexIES_mode_get(PointerRNA *ptr);
void ShaderNodeTexIES_mode_set(PointerRNA *ptr, int value);

bool ShaderNodeTexIES_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeTexIES_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeTexIES_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeTexImage ****************/

extern StructRNA RNA_ShaderNodeTexImage;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA ShaderNodeTexImage_color_mapping_get(PointerRNA *ptr);

enum {
	ShaderNodeTexImage_extension_REPEAT = 0,
	ShaderNodeTexImage_extension_EXTEND = 1,
	ShaderNodeTexImage_extension_CLIP = 2,
	ShaderNodeTexImage_extension_MIRROR = 3,
};

int ShaderNodeTexImage_extension_get(PointerRNA *ptr);
void ShaderNodeTexImage_extension_set(PointerRNA *ptr, int value);

PointerRNA ShaderNodeTexImage_image_get(PointerRNA *ptr);

PointerRNA ShaderNodeTexImage_image_user_get(PointerRNA *ptr);

enum {
	ShaderNodeTexImage_interpolation_Linear = 0,
	ShaderNodeTexImage_interpolation_Closest = 1,
	ShaderNodeTexImage_interpolation_Cubic = 2,
	ShaderNodeTexImage_interpolation_Smart = 3,
};

int ShaderNodeTexImage_interpolation_get(PointerRNA *ptr);
void ShaderNodeTexImage_interpolation_set(PointerRNA *ptr, int value);

enum {
	ShaderNodeTexImage_projection_FLAT = 0,
	ShaderNodeTexImage_projection_BOX = 1,
	ShaderNodeTexImage_projection_SPHERE = 2,
	ShaderNodeTexImage_projection_TUBE = 3,
};

int ShaderNodeTexImage_projection_get(PointerRNA *ptr);
void ShaderNodeTexImage_projection_set(PointerRNA *ptr, int value);

float ShaderNodeTexImage_projection_blend_get(PointerRNA *ptr);
void ShaderNodeTexImage_projection_blend_set(PointerRNA *ptr, float value);

PointerRNA ShaderNodeTexImage_texture_mapping_get(PointerRNA *ptr);

bool ShaderNodeTexImage_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeTexImage_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeTexImage_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeTexMagic ****************/

extern StructRNA RNA_ShaderNodeTexMagic;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA ShaderNodeTexMagic_color_mapping_get(PointerRNA *ptr);

int ShaderNodeTexMagic_turbulence_depth_get(PointerRNA *ptr);
void ShaderNodeTexMagic_turbulence_depth_set(PointerRNA *ptr, int value);

PointerRNA ShaderNodeTexMagic_texture_mapping_get(PointerRNA *ptr);

bool ShaderNodeTexMagic_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeTexMagic_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeTexMagic_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeTexNoise ****************/

extern StructRNA RNA_ShaderNodeTexNoise;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA ShaderNodeTexNoise_color_mapping_get(PointerRNA *ptr);

enum {
	ShaderNodeTexNoise_noise_dimensions_1D = 1,
	ShaderNodeTexNoise_noise_dimensions_2D = 2,
	ShaderNodeTexNoise_noise_dimensions_3D = 3,
	ShaderNodeTexNoise_noise_dimensions_4D = 4,
};

int ShaderNodeTexNoise_noise_dimensions_get(PointerRNA *ptr);
void ShaderNodeTexNoise_noise_dimensions_set(PointerRNA *ptr, int value);

bool ShaderNodeTexNoise_normalize_get(PointerRNA *ptr);
void ShaderNodeTexNoise_normalize_set(PointerRNA *ptr, bool value);

PointerRNA ShaderNodeTexNoise_texture_mapping_get(PointerRNA *ptr);

enum {
	ShaderNodeTexNoise_noise_type_MULTIFRACTAL = 0,
	ShaderNodeTexNoise_noise_type_RIDGED_MULTIFRACTAL = 3,
	ShaderNodeTexNoise_noise_type_HYBRID_MULTIFRACTAL = 2,
	ShaderNodeTexNoise_noise_type_FBM = 1,
	ShaderNodeTexNoise_noise_type_HETERO_TERRAIN = 4,
};

int ShaderNodeTexNoise_noise_type_get(PointerRNA *ptr);
void ShaderNodeTexNoise_noise_type_set(PointerRNA *ptr, int value);

bool ShaderNodeTexNoise_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeTexNoise_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeTexNoise_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeTexPointDensity ****************/

extern StructRNA RNA_ShaderNodeTexPointDensity;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeTexPointDensity_particle_color_source_PARTICLE_AGE = 1,
	ShaderNodeTexPointDensity_particle_color_source_PARTICLE_SPEED = 2,
	ShaderNodeTexPointDensity_particle_color_source_PARTICLE_VELOCITY = 3,
};

int ShaderNodeTexPointDensity_particle_color_source_get(PointerRNA *ptr);
void ShaderNodeTexPointDensity_particle_color_source_set(PointerRNA *ptr, int value);

enum {
	ShaderNodeTexPointDensity_vertex_color_source_VERTEX_COLOR = 0,
	ShaderNodeTexPointDensity_vertex_color_source_VERTEX_WEIGHT = 1,
	ShaderNodeTexPointDensity_vertex_color_source_VERTEX_NORMAL = 2,
};

int ShaderNodeTexPointDensity_vertex_color_source_get(PointerRNA *ptr);
void ShaderNodeTexPointDensity_vertex_color_source_set(PointerRNA *ptr, int value);

enum {
	ShaderNodeTexPointDensity_interpolation_Closest = 1,
	ShaderNodeTexPointDensity_interpolation_Linear = 0,
	ShaderNodeTexPointDensity_interpolation_Cubic = 2,
};

int ShaderNodeTexPointDensity_interpolation_get(PointerRNA *ptr);
void ShaderNodeTexPointDensity_interpolation_set(PointerRNA *ptr, int value);

PointerRNA ShaderNodeTexPointDensity_object_get(PointerRNA *ptr);

PointerRNA ShaderNodeTexPointDensity_particle_system_get(PointerRNA *ptr);

enum {
	ShaderNodeTexPointDensity_point_source_PARTICLE_SYSTEM = 0,
	ShaderNodeTexPointDensity_point_source_OBJECT = 1,
};

int ShaderNodeTexPointDensity_point_source_get(PointerRNA *ptr);
void ShaderNodeTexPointDensity_point_source_set(PointerRNA *ptr, int value);

float ShaderNodeTexPointDensity_radius_get(PointerRNA *ptr);
void ShaderNodeTexPointDensity_radius_set(PointerRNA *ptr, float value);

int ShaderNodeTexPointDensity_resolution_get(PointerRNA *ptr);
void ShaderNodeTexPointDensity_resolution_set(PointerRNA *ptr, int value);

enum {
	ShaderNodeTexPointDensity_space_OBJECT = 0,
	ShaderNodeTexPointDensity_space_WORLD = 1,
};

int ShaderNodeTexPointDensity_space_get(PointerRNA *ptr);
void ShaderNodeTexPointDensity_space_set(PointerRNA *ptr, int value);

#define ShaderNodeTexPointDensity_vertex_attribute_name_MAX 68

void ShaderNodeTexPointDensity_vertex_attribute_name_get(PointerRNA *ptr, char *value);
int ShaderNodeTexPointDensity_vertex_attribute_name_length(PointerRNA *ptr);
void ShaderNodeTexPointDensity_vertex_attribute_name_set(PointerRNA *ptr, const char *value);

bool ShaderNodeTexPointDensity_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeTexPointDensity_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeTexPointDensity_output_template_func(struct StructRNA *_type, int index);
void ShaderNodeTexPointDensity_cache_point_density_func(struct bNode *_self, struct Depsgraph *depsgraph);
void ShaderNodeTexPointDensity_calc_point_density_func(struct bNode *_self, struct Depsgraph *depsgraph, int *rgba_values_num, float **rgba_values);
void ShaderNodeTexPointDensity_calc_point_density_minmax_func(struct bNode *_self, struct Depsgraph *depsgraph, float min[3], float max[3]);
/**************** ShaderNodeTexSky ****************/

extern StructRNA RNA_ShaderNodeTexSky;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float ShaderNodeTexSky_air_density_get(PointerRNA *ptr);
void ShaderNodeTexSky_air_density_set(PointerRNA *ptr, float value);

float ShaderNodeTexSky_altitude_get(PointerRNA *ptr);
void ShaderNodeTexSky_altitude_set(PointerRNA *ptr, float value);

PointerRNA ShaderNodeTexSky_color_mapping_get(PointerRNA *ptr);

float ShaderNodeTexSky_dust_density_get(PointerRNA *ptr);
void ShaderNodeTexSky_dust_density_set(PointerRNA *ptr, float value);

float ShaderNodeTexSky_ground_albedo_get(PointerRNA *ptr);
void ShaderNodeTexSky_ground_albedo_set(PointerRNA *ptr, float value);

float ShaderNodeTexSky_ozone_density_get(PointerRNA *ptr);
void ShaderNodeTexSky_ozone_density_set(PointerRNA *ptr, float value);

enum {
	ShaderNodeTexSky_sky_type_PREETHAM = 0,
	ShaderNodeTexSky_sky_type_HOSEK_WILKIE = 1,
	ShaderNodeTexSky_sky_type_NISHITA = 2,
};

int ShaderNodeTexSky_sky_type_get(PointerRNA *ptr);
void ShaderNodeTexSky_sky_type_set(PointerRNA *ptr, int value);

void ShaderNodeTexSky_sun_direction_get(PointerRNA *ptr, float values[3]);
void ShaderNodeTexSky_sun_direction_set(PointerRNA *ptr, const float values[3]);

bool ShaderNodeTexSky_sun_disc_get(PointerRNA *ptr);
void ShaderNodeTexSky_sun_disc_set(PointerRNA *ptr, bool value);

float ShaderNodeTexSky_sun_elevation_get(PointerRNA *ptr);
void ShaderNodeTexSky_sun_elevation_set(PointerRNA *ptr, float value);

float ShaderNodeTexSky_sun_intensity_get(PointerRNA *ptr);
void ShaderNodeTexSky_sun_intensity_set(PointerRNA *ptr, float value);

float ShaderNodeTexSky_sun_rotation_get(PointerRNA *ptr);
void ShaderNodeTexSky_sun_rotation_set(PointerRNA *ptr, float value);

float ShaderNodeTexSky_sun_size_get(PointerRNA *ptr);
void ShaderNodeTexSky_sun_size_set(PointerRNA *ptr, float value);

PointerRNA ShaderNodeTexSky_texture_mapping_get(PointerRNA *ptr);

float ShaderNodeTexSky_turbidity_get(PointerRNA *ptr);
void ShaderNodeTexSky_turbidity_set(PointerRNA *ptr, float value);

bool ShaderNodeTexSky_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeTexSky_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeTexSky_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeTexVoronoi ****************/

extern StructRNA RNA_ShaderNodeTexVoronoi;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA ShaderNodeTexVoronoi_color_mapping_get(PointerRNA *ptr);

enum {
	ShaderNodeTexVoronoi_voronoi_dimensions_1D = 1,
	ShaderNodeTexVoronoi_voronoi_dimensions_2D = 2,
	ShaderNodeTexVoronoi_voronoi_dimensions_3D = 3,
	ShaderNodeTexVoronoi_voronoi_dimensions_4D = 4,
};

int ShaderNodeTexVoronoi_voronoi_dimensions_get(PointerRNA *ptr);
void ShaderNodeTexVoronoi_voronoi_dimensions_set(PointerRNA *ptr, int value);

enum {
	ShaderNodeTexVoronoi_distance_EUCLIDEAN = 0,
	ShaderNodeTexVoronoi_distance_MANHATTAN = 1,
	ShaderNodeTexVoronoi_distance_CHEBYCHEV = 2,
	ShaderNodeTexVoronoi_distance_MINKOWSKI = 3,
};

int ShaderNodeTexVoronoi_distance_get(PointerRNA *ptr);
void ShaderNodeTexVoronoi_distance_set(PointerRNA *ptr, int value);

enum {
	ShaderNodeTexVoronoi_feature_F1 = 0,
	ShaderNodeTexVoronoi_feature_F2 = 1,
	ShaderNodeTexVoronoi_feature_SMOOTH_F1 = 2,
	ShaderNodeTexVoronoi_feature_DISTANCE_TO_EDGE = 3,
	ShaderNodeTexVoronoi_feature_N_SPHERE_RADIUS = 4,
};

int ShaderNodeTexVoronoi_feature_get(PointerRNA *ptr);
void ShaderNodeTexVoronoi_feature_set(PointerRNA *ptr, int value);

bool ShaderNodeTexVoronoi_normalize_get(PointerRNA *ptr);
void ShaderNodeTexVoronoi_normalize_set(PointerRNA *ptr, bool value);

PointerRNA ShaderNodeTexVoronoi_texture_mapping_get(PointerRNA *ptr);

bool ShaderNodeTexVoronoi_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeTexVoronoi_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeTexVoronoi_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeTexWave ****************/

extern StructRNA RNA_ShaderNodeTexWave;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeTexWave_bands_direction_X = 0,
	ShaderNodeTexWave_bands_direction_Y = 1,
	ShaderNodeTexWave_bands_direction_Z = 2,
	ShaderNodeTexWave_bands_direction_DIAGONAL = 3,
};

int ShaderNodeTexWave_bands_direction_get(PointerRNA *ptr);
void ShaderNodeTexWave_bands_direction_set(PointerRNA *ptr, int value);

PointerRNA ShaderNodeTexWave_color_mapping_get(PointerRNA *ptr);

enum {
	ShaderNodeTexWave_rings_direction_X = 0,
	ShaderNodeTexWave_rings_direction_Y = 1,
	ShaderNodeTexWave_rings_direction_Z = 2,
	ShaderNodeTexWave_rings_direction_SPHERICAL = 3,
};

int ShaderNodeTexWave_rings_direction_get(PointerRNA *ptr);
void ShaderNodeTexWave_rings_direction_set(PointerRNA *ptr, int value);

PointerRNA ShaderNodeTexWave_texture_mapping_get(PointerRNA *ptr);

enum {
	ShaderNodeTexWave_wave_profile_SIN = 0,
	ShaderNodeTexWave_wave_profile_SAW = 1,
	ShaderNodeTexWave_wave_profile_TRI = 2,
};

int ShaderNodeTexWave_wave_profile_get(PointerRNA *ptr);
void ShaderNodeTexWave_wave_profile_set(PointerRNA *ptr, int value);

enum {
	ShaderNodeTexWave_wave_type_BANDS = 0,
	ShaderNodeTexWave_wave_type_RINGS = 1,
};

int ShaderNodeTexWave_wave_type_get(PointerRNA *ptr);
void ShaderNodeTexWave_wave_type_set(PointerRNA *ptr, int value);

bool ShaderNodeTexWave_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeTexWave_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeTexWave_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeTexWhiteNoise ****************/

extern StructRNA RNA_ShaderNodeTexWhiteNoise;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeTexWhiteNoise_noise_dimensions_1D = 1,
	ShaderNodeTexWhiteNoise_noise_dimensions_2D = 2,
	ShaderNodeTexWhiteNoise_noise_dimensions_3D = 3,
	ShaderNodeTexWhiteNoise_noise_dimensions_4D = 4,
};

int ShaderNodeTexWhiteNoise_noise_dimensions_get(PointerRNA *ptr);
void ShaderNodeTexWhiteNoise_noise_dimensions_set(PointerRNA *ptr, int value);

bool ShaderNodeTexWhiteNoise_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeTexWhiteNoise_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeTexWhiteNoise_output_template_func(struct StructRNA *_type, int index);
/**************** Shader Node Tree ****************/

extern StructRNA RNA_ShaderNodeTree;
extern StructRNA RNA_NodeTree;
extern StructRNA RNA_ID;

struct bNode *ShaderNodeTree_get_output_node_func(struct bNodeTree *_self, int target);
/**************** ShaderNodeUVAlongStroke ****************/

extern StructRNA RNA_ShaderNodeUVAlongStroke;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeUVAlongStroke_use_tips_get(PointerRNA *ptr);
void ShaderNodeUVAlongStroke_use_tips_set(PointerRNA *ptr, bool value);

bool ShaderNodeUVAlongStroke_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeUVAlongStroke_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeUVAlongStroke_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeUVMap ****************/

extern StructRNA RNA_ShaderNodeUVMap;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeUVMap_from_instancer_get(PointerRNA *ptr);
void ShaderNodeUVMap_from_instancer_set(PointerRNA *ptr, bool value);

#define ShaderNodeUVMap_uv_map_MAX 64

void ShaderNodeUVMap_uv_map_get(PointerRNA *ptr, char *value);
int ShaderNodeUVMap_uv_map_length(PointerRNA *ptr);
void ShaderNodeUVMap_uv_map_set(PointerRNA *ptr, const char *value);

bool ShaderNodeUVMap_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeUVMap_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeUVMap_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeValToRGB ****************/

extern StructRNA RNA_ShaderNodeValToRGB;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA ShaderNodeValToRGB_color_ramp_get(PointerRNA *ptr);

bool ShaderNodeValToRGB_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeValToRGB_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeValToRGB_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeValue ****************/

extern StructRNA RNA_ShaderNodeValue;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeValue_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeValue_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeValue_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeVectorCurve ****************/

extern StructRNA RNA_ShaderNodeVectorCurve;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA ShaderNodeVectorCurve_mapping_get(PointerRNA *ptr);

bool ShaderNodeVectorCurve_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeVectorCurve_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeVectorCurve_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeVectorDisplacement ****************/

extern StructRNA RNA_ShaderNodeVectorDisplacement;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeVectorDisplacement_space_TANGENT = 0,
	ShaderNodeVectorDisplacement_space_OBJECT = 1,
	ShaderNodeVectorDisplacement_space_WORLD = 2,
};

int ShaderNodeVectorDisplacement_space_get(PointerRNA *ptr);
void ShaderNodeVectorDisplacement_space_set(PointerRNA *ptr, int value);

bool ShaderNodeVectorDisplacement_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeVectorDisplacement_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeVectorDisplacement_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeVectorMath ****************/

extern StructRNA RNA_ShaderNodeVectorMath;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeVectorMath_operation_ADD = 0,
	ShaderNodeVectorMath_operation_SUBTRACT = 1,
	ShaderNodeVectorMath_operation_MULTIPLY = 2,
	ShaderNodeVectorMath_operation_DIVIDE = 3,
	ShaderNodeVectorMath_operation_MULTIPLY_ADD = 26,
	ShaderNodeVectorMath_operation_CROSS_PRODUCT = 4,
	ShaderNodeVectorMath_operation_PROJECT = 5,
	ShaderNodeVectorMath_operation_REFLECT = 6,
	ShaderNodeVectorMath_operation_REFRACT = 24,
	ShaderNodeVectorMath_operation_FACEFORWARD = 25,
	ShaderNodeVectorMath_operation_DOT_PRODUCT = 7,
	ShaderNodeVectorMath_operation_DISTANCE = 8,
	ShaderNodeVectorMath_operation_LENGTH = 9,
	ShaderNodeVectorMath_operation_SCALE = 10,
	ShaderNodeVectorMath_operation_NORMALIZE = 11,
	ShaderNodeVectorMath_operation_ABSOLUTE = 17,
	ShaderNodeVectorMath_operation_POWER = 27,
	ShaderNodeVectorMath_operation_SIGN = 28,
	ShaderNodeVectorMath_operation_MINIMUM = 18,
	ShaderNodeVectorMath_operation_MAXIMUM = 19,
	ShaderNodeVectorMath_operation_FLOOR = 13,
	ShaderNodeVectorMath_operation_CEIL = 14,
	ShaderNodeVectorMath_operation_FRACTION = 16,
	ShaderNodeVectorMath_operation_MODULO = 15,
	ShaderNodeVectorMath_operation_WRAP = 20,
	ShaderNodeVectorMath_operation_SNAP = 12,
	ShaderNodeVectorMath_operation_SINE = 21,
	ShaderNodeVectorMath_operation_COSINE = 22,
	ShaderNodeVectorMath_operation_TANGENT = 23,
};

int ShaderNodeVectorMath_operation_get(PointerRNA *ptr);
void ShaderNodeVectorMath_operation_set(PointerRNA *ptr, int value);

bool ShaderNodeVectorMath_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeVectorMath_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeVectorMath_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeVectorRotate ****************/

extern StructRNA RNA_ShaderNodeVectorRotate;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeVectorRotate_invert_get(PointerRNA *ptr);
void ShaderNodeVectorRotate_invert_set(PointerRNA *ptr, bool value);

enum {
	ShaderNodeVectorRotate_rotation_type_AXIS_ANGLE = 0,
	ShaderNodeVectorRotate_rotation_type_X_AXIS = 1,
	ShaderNodeVectorRotate_rotation_type_Y_AXIS = 2,
	ShaderNodeVectorRotate_rotation_type_Z_AXIS = 3,
	ShaderNodeVectorRotate_rotation_type_EULER_XYZ = 4,
};

int ShaderNodeVectorRotate_rotation_type_get(PointerRNA *ptr);
void ShaderNodeVectorRotate_rotation_type_set(PointerRNA *ptr, int value);

bool ShaderNodeVectorRotate_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeVectorRotate_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeVectorRotate_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeVectorTransform ****************/

extern StructRNA RNA_ShaderNodeVectorTransform;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeVectorTransform_convert_from_WORLD = 0,
	ShaderNodeVectorTransform_convert_from_OBJECT = 1,
	ShaderNodeVectorTransform_convert_from_CAMERA = 2,
};

int ShaderNodeVectorTransform_convert_from_get(PointerRNA *ptr);
void ShaderNodeVectorTransform_convert_from_set(PointerRNA *ptr, int value);

enum {
	ShaderNodeVectorTransform_convert_to_WORLD = 0,
	ShaderNodeVectorTransform_convert_to_OBJECT = 1,
	ShaderNodeVectorTransform_convert_to_CAMERA = 2,
};

int ShaderNodeVectorTransform_convert_to_get(PointerRNA *ptr);
void ShaderNodeVectorTransform_convert_to_set(PointerRNA *ptr, int value);

enum {
	ShaderNodeVectorTransform_vector_type_POINT = 1,
	ShaderNodeVectorTransform_vector_type_VECTOR = 0,
	ShaderNodeVectorTransform_vector_type_NORMAL = 2,
};

int ShaderNodeVectorTransform_vector_type_get(PointerRNA *ptr);
void ShaderNodeVectorTransform_vector_type_set(PointerRNA *ptr, int value);

bool ShaderNodeVectorTransform_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeVectorTransform_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeVectorTransform_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeVertexColor ****************/

extern StructRNA RNA_ShaderNodeVertexColor;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

#define ShaderNodeVertexColor_layer_name_MAX 64

void ShaderNodeVertexColor_layer_name_get(PointerRNA *ptr, char *value);
int ShaderNodeVertexColor_layer_name_length(PointerRNA *ptr);
void ShaderNodeVertexColor_layer_name_set(PointerRNA *ptr, const char *value);

bool ShaderNodeVertexColor_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeVertexColor_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeVertexColor_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeVolumeAbsorption ****************/

extern StructRNA RNA_ShaderNodeVolumeAbsorption;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeVolumeAbsorption_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeVolumeAbsorption_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeVolumeAbsorption_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeVolumeCoefficients ****************/

extern StructRNA RNA_ShaderNodeVolumeCoefficients;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeVolumeCoefficients_phase_HENYEY_GREENSTEIN = 0,
	ShaderNodeVolumeCoefficients_phase_FOURNIER_FORAND = 1,
	ShaderNodeVolumeCoefficients_phase_DRAINE = 2,
	ShaderNodeVolumeCoefficients_phase_RAYLEIGH = 3,
	ShaderNodeVolumeCoefficients_phase_MIE = 4,
};

int ShaderNodeVolumeCoefficients_phase_get(PointerRNA *ptr);
void ShaderNodeVolumeCoefficients_phase_set(PointerRNA *ptr, int value);

bool ShaderNodeVolumeCoefficients_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeVolumeCoefficients_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeVolumeCoefficients_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeVolumeInfo ****************/

extern StructRNA RNA_ShaderNodeVolumeInfo;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeVolumeInfo_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeVolumeInfo_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeVolumeInfo_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeVolumePrincipled ****************/

extern StructRNA RNA_ShaderNodeVolumePrincipled;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeVolumePrincipled_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeVolumePrincipled_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeVolumePrincipled_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeVolumeScatter ****************/

extern StructRNA RNA_ShaderNodeVolumeScatter;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	ShaderNodeVolumeScatter_phase_HENYEY_GREENSTEIN = 0,
	ShaderNodeVolumeScatter_phase_FOURNIER_FORAND = 1,
	ShaderNodeVolumeScatter_phase_DRAINE = 2,
	ShaderNodeVolumeScatter_phase_RAYLEIGH = 3,
	ShaderNodeVolumeScatter_phase_MIE = 4,
};

int ShaderNodeVolumeScatter_phase_get(PointerRNA *ptr);
void ShaderNodeVolumeScatter_phase_set(PointerRNA *ptr, int value);

bool ShaderNodeVolumeScatter_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeVolumeScatter_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeVolumeScatter_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeWavelength ****************/

extern StructRNA RNA_ShaderNodeWavelength;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeWavelength_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeWavelength_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeWavelength_output_template_func(struct StructRNA *_type, int index);
/**************** ShaderNodeWireframe ****************/

extern StructRNA RNA_ShaderNodeWireframe;
extern StructRNA RNA_ShaderNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool ShaderNodeWireframe_use_pixel_size_get(PointerRNA *ptr);
void ShaderNodeWireframe_use_pixel_size_set(PointerRNA *ptr, bool value);

bool ShaderNodeWireframe_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA ShaderNodeWireframe_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA ShaderNodeWireframe_output_template_func(struct StructRNA *_type, int index);
/**************** Shape Key ****************/

extern StructRNA RNA_ShapeKey;

PointerRNA ShapeKey_rna_type_get(PointerRNA *ptr);

#define ShapeKey_name_MAX 64

void ShapeKey_name_get(PointerRNA *ptr, char *value);
int ShapeKey_name_length(PointerRNA *ptr);
void ShapeKey_name_set(PointerRNA *ptr, const char *value);

void ShapeKey_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ShapeKey_data_next(CollectionPropertyIterator *iter);
void ShapeKey_data_end(CollectionPropertyIterator *iter);
int ShapeKey_data_length(PointerRNA *ptr);
bool ShapeKey_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

float ShapeKey_frame_get(PointerRNA *ptr);
void ShapeKey_frame_set(PointerRNA *ptr, float value);

enum {
	ShapeKey_interpolation_KEY_LINEAR = 0,
	ShapeKey_interpolation_KEY_CARDINAL = 1,
	ShapeKey_interpolation_KEY_CATMULL_ROM = 3,
	ShapeKey_interpolation_KEY_BSPLINE = 2,
};

int ShapeKey_interpolation_get(PointerRNA *ptr);
void ShapeKey_interpolation_set(PointerRNA *ptr, int value);

bool ShapeKey_lock_shape_get(PointerRNA *ptr);
void ShapeKey_lock_shape_set(PointerRNA *ptr, bool value);

bool ShapeKey_mute_get(PointerRNA *ptr);
void ShapeKey_mute_set(PointerRNA *ptr, bool value);

void ShapeKey_points_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ShapeKey_points_next(CollectionPropertyIterator *iter);
void ShapeKey_points_end(CollectionPropertyIterator *iter);
int ShapeKey_points_length(PointerRNA *ptr);
bool ShapeKey_points_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

PointerRNA ShapeKey_relative_key_get(PointerRNA *ptr);

float ShapeKey_slider_max_get(PointerRNA *ptr);
void ShapeKey_slider_max_set(PointerRNA *ptr, float value);

float ShapeKey_slider_min_get(PointerRNA *ptr);
void ShapeKey_slider_min_set(PointerRNA *ptr, float value);

float ShapeKey_value_get(PointerRNA *ptr);
void ShapeKey_value_set(PointerRNA *ptr, float value);

#define ShapeKey_vertex_group_MAX 64

void ShapeKey_vertex_group_get(PointerRNA *ptr, char *value);
int ShapeKey_vertex_group_length(PointerRNA *ptr);
void ShapeKey_vertex_group_set(PointerRNA *ptr, const char *value);

void ShapeKey_normals_vertex_get_func(struct ID *_selfid, struct KeyBlock *_self, int *normals_num, float **normals);
void ShapeKey_normals_polygon_get_func(struct ID *_selfid, struct KeyBlock *_self, int *normals_num, float **normals);
void ShapeKey_normals_split_get_func(struct ID *_selfid, struct KeyBlock *_self, int *normals_num, float **normals);
/**************** Shape Key Bézier Point ****************/

extern StructRNA RNA_ShapeKeyBezierPoint;

PointerRNA ShapeKeyBezierPoint_rna_type_get(PointerRNA *ptr);

void ShapeKeyBezierPoint_handle_left_get(PointerRNA *ptr, float values[3]);
void ShapeKeyBezierPoint_handle_left_set(PointerRNA *ptr, const float values[3]);

void ShapeKeyBezierPoint_handle_right_get(PointerRNA *ptr, float values[3]);
void ShapeKeyBezierPoint_handle_right_set(PointerRNA *ptr, const float values[3]);

void ShapeKeyBezierPoint_co_get(PointerRNA *ptr, float values[3]);
void ShapeKeyBezierPoint_co_set(PointerRNA *ptr, const float values[3]);

float ShapeKeyBezierPoint_radius_get(PointerRNA *ptr);
void ShapeKeyBezierPoint_radius_set(PointerRNA *ptr, float value);

float ShapeKeyBezierPoint_tilt_get(PointerRNA *ptr);
void ShapeKeyBezierPoint_tilt_set(PointerRNA *ptr, float value);

/**************** Shape Key Curve Point ****************/

extern StructRNA RNA_ShapeKeyCurvePoint;

PointerRNA ShapeKeyCurvePoint_rna_type_get(PointerRNA *ptr);

void ShapeKeyCurvePoint_co_get(PointerRNA *ptr, float values[3]);
void ShapeKeyCurvePoint_co_set(PointerRNA *ptr, const float values[3]);

float ShapeKeyCurvePoint_radius_get(PointerRNA *ptr);
void ShapeKeyCurvePoint_radius_set(PointerRNA *ptr, float value);

float ShapeKeyCurvePoint_tilt_get(PointerRNA *ptr);
void ShapeKeyCurvePoint_tilt_set(PointerRNA *ptr, float value);

/**************** Shape Key Point ****************/

extern StructRNA RNA_ShapeKeyPoint;

PointerRNA ShapeKeyPoint_rna_type_get(PointerRNA *ptr);

void ShapeKeyPoint_co_get(PointerRNA *ptr, float values[3]);
void ShapeKeyPoint_co_set(PointerRNA *ptr, const float values[3]);

/**************** 2D 16-Bit Integer Vector Attribute ****************/

extern StructRNA RNA_Short2Attribute;
extern StructRNA RNA_Attribute;

void Short2Attribute_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Short2Attribute_data_next(CollectionPropertyIterator *iter);
void Short2Attribute_data_end(CollectionPropertyIterator *iter);
int Short2Attribute_data_length(PointerRNA *ptr);
bool Short2Attribute_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** 2D 16-Bit Integer Vector Attribute Value ****************/

extern StructRNA RNA_Short2AttributeValue;

PointerRNA Short2AttributeValue_rna_type_get(PointerRNA *ptr);

void Short2AttributeValue_value_get(PointerRNA *ptr, int values[2]);
void Short2AttributeValue_value_set(PointerRNA *ptr, const int values[2]);

/**************** Shrinkwrap Constraint ****************/

extern StructRNA RNA_ShrinkwrapConstraint;
extern StructRNA RNA_Constraint;

bool ShrinkwrapConstraint_use_track_normal_get(PointerRNA *ptr);
void ShrinkwrapConstraint_use_track_normal_set(PointerRNA *ptr, bool value);

enum {
	ShrinkwrapConstraint_project_axis_space_WORLD = 0,
	ShrinkwrapConstraint_project_axis_space_CUSTOM = 5,
	ShrinkwrapConstraint_project_axis_space_POSE = 2,
	ShrinkwrapConstraint_project_axis_space_LOCAL_WITH_PARENT = 3,
	ShrinkwrapConstraint_project_axis_space_LOCAL = 1,
};

int ShrinkwrapConstraint_project_axis_space_get(PointerRNA *ptr);
void ShrinkwrapConstraint_project_axis_space_set(PointerRNA *ptr, int value);

float ShrinkwrapConstraint_distance_get(PointerRNA *ptr);
void ShrinkwrapConstraint_distance_set(PointerRNA *ptr, float value);

enum {
	ShrinkwrapConstraint_cull_face_OFF = 0,
	ShrinkwrapConstraint_cull_face_FRONT = 8,
	ShrinkwrapConstraint_cull_face_BACK = 16,
};

int ShrinkwrapConstraint_cull_face_get(PointerRNA *ptr);
void ShrinkwrapConstraint_cull_face_set(PointerRNA *ptr, int value);

bool ShrinkwrapConstraint_use_invert_cull_get(PointerRNA *ptr);
void ShrinkwrapConstraint_use_invert_cull_set(PointerRNA *ptr, bool value);

enum {
	ShrinkwrapConstraint_project_axis_POS_X = 0,
	ShrinkwrapConstraint_project_axis_POS_Y = 1,
	ShrinkwrapConstraint_project_axis_POS_Z = 2,
	ShrinkwrapConstraint_project_axis_NEG_X = 3,
	ShrinkwrapConstraint_project_axis_NEG_Y = 4,
	ShrinkwrapConstraint_project_axis_NEG_Z = 5,
};

int ShrinkwrapConstraint_project_axis_get(PointerRNA *ptr);
void ShrinkwrapConstraint_project_axis_set(PointerRNA *ptr, int value);

float ShrinkwrapConstraint_project_limit_get(PointerRNA *ptr);
void ShrinkwrapConstraint_project_limit_set(PointerRNA *ptr, float value);

bool ShrinkwrapConstraint_use_project_opposite_get(PointerRNA *ptr);
void ShrinkwrapConstraint_use_project_opposite_set(PointerRNA *ptr, bool value);

enum {
	ShrinkwrapConstraint_shrinkwrap_type_NEAREST_SURFACE = 0,
	ShrinkwrapConstraint_shrinkwrap_type_PROJECT = 1,
	ShrinkwrapConstraint_shrinkwrap_type_NEAREST_VERTEX = 2,
	ShrinkwrapConstraint_shrinkwrap_type_TARGET_PROJECT = 3,
};

int ShrinkwrapConstraint_shrinkwrap_type_get(PointerRNA *ptr);
void ShrinkwrapConstraint_shrinkwrap_type_set(PointerRNA *ptr, int value);

enum {
	ShrinkwrapConstraint_wrap_mode_ON_SURFACE = 0,
	ShrinkwrapConstraint_wrap_mode_INSIDE = 1,
	ShrinkwrapConstraint_wrap_mode_OUTSIDE = 2,
	ShrinkwrapConstraint_wrap_mode_OUTSIDE_SURFACE = 3,
	ShrinkwrapConstraint_wrap_mode_ABOVE_SURFACE = 4,
};

int ShrinkwrapConstraint_wrap_mode_get(PointerRNA *ptr);
void ShrinkwrapConstraint_wrap_mode_set(PointerRNA *ptr, int value);

PointerRNA ShrinkwrapConstraint_target_get(PointerRNA *ptr);

enum {
	ShrinkwrapConstraint_track_axis_TRACK_X = 0,
	ShrinkwrapConstraint_track_axis_TRACK_Y = 1,
	ShrinkwrapConstraint_track_axis_TRACK_Z = 2,
	ShrinkwrapConstraint_track_axis_TRACK_NEGATIVE_X = 3,
	ShrinkwrapConstraint_track_axis_TRACK_NEGATIVE_Y = 4,
	ShrinkwrapConstraint_track_axis_TRACK_NEGATIVE_Z = 5,
};

int ShrinkwrapConstraint_track_axis_get(PointerRNA *ptr);
void ShrinkwrapConstraint_track_axis_set(PointerRNA *ptr, int value);

/**************** Shrinkwrap Modifier ****************/

extern StructRNA RNA_ShrinkwrapModifier;
extern StructRNA RNA_Modifier;

PointerRNA ShrinkwrapModifier_auxiliary_target_get(PointerRNA *ptr);

enum {
	ShrinkwrapModifier_cull_face_OFF = 0,
	ShrinkwrapModifier_cull_face_FRONT = 8,
	ShrinkwrapModifier_cull_face_BACK = 16,
};

int ShrinkwrapModifier_cull_face_get(PointerRNA *ptr);
void ShrinkwrapModifier_cull_face_set(PointerRNA *ptr, int value);

bool ShrinkwrapModifier_invert_vertex_group_get(PointerRNA *ptr);
void ShrinkwrapModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

bool ShrinkwrapModifier_use_invert_cull_get(PointerRNA *ptr);
void ShrinkwrapModifier_use_invert_cull_set(PointerRNA *ptr, bool value);

bool ShrinkwrapModifier_use_negative_direction_get(PointerRNA *ptr);
void ShrinkwrapModifier_use_negative_direction_set(PointerRNA *ptr, bool value);

float ShrinkwrapModifier_offset_get(PointerRNA *ptr);
void ShrinkwrapModifier_offset_set(PointerRNA *ptr, float value);

bool ShrinkwrapModifier_use_positive_direction_get(PointerRNA *ptr);
void ShrinkwrapModifier_use_positive_direction_set(PointerRNA *ptr, bool value);

float ShrinkwrapModifier_project_limit_get(PointerRNA *ptr);
void ShrinkwrapModifier_project_limit_set(PointerRNA *ptr, float value);

enum {
	ShrinkwrapModifier_wrap_mode_ON_SURFACE = 0,
	ShrinkwrapModifier_wrap_mode_INSIDE = 1,
	ShrinkwrapModifier_wrap_mode_OUTSIDE = 2,
	ShrinkwrapModifier_wrap_mode_OUTSIDE_SURFACE = 3,
	ShrinkwrapModifier_wrap_mode_ABOVE_SURFACE = 4,
};

int ShrinkwrapModifier_wrap_mode_get(PointerRNA *ptr);
void ShrinkwrapModifier_wrap_mode_set(PointerRNA *ptr, int value);

int ShrinkwrapModifier_subsurf_levels_get(PointerRNA *ptr);
void ShrinkwrapModifier_subsurf_levels_set(PointerRNA *ptr, int value);

PointerRNA ShrinkwrapModifier_target_get(PointerRNA *ptr);

#define ShrinkwrapModifier_vertex_group_MAX 64

void ShrinkwrapModifier_vertex_group_get(PointerRNA *ptr, char *value);
int ShrinkwrapModifier_vertex_group_length(PointerRNA *ptr);
void ShrinkwrapModifier_vertex_group_set(PointerRNA *ptr, const char *value);

enum {
	ShrinkwrapModifier_wrap_method_NEAREST_SURFACEPOINT = 0,
	ShrinkwrapModifier_wrap_method_PROJECT = 1,
	ShrinkwrapModifier_wrap_method_NEAREST_VERTEX = 2,
	ShrinkwrapModifier_wrap_method_TARGET_PROJECT = 3,
};

int ShrinkwrapModifier_wrap_method_get(PointerRNA *ptr);
void ShrinkwrapModifier_wrap_method_set(PointerRNA *ptr, int value);

bool ShrinkwrapModifier_use_project_x_get(PointerRNA *ptr);
void ShrinkwrapModifier_use_project_x_set(PointerRNA *ptr, bool value);

bool ShrinkwrapModifier_use_project_y_get(PointerRNA *ptr);
void ShrinkwrapModifier_use_project_y_set(PointerRNA *ptr, bool value);

bool ShrinkwrapModifier_use_project_z_get(PointerRNA *ptr);
void ShrinkwrapModifier_use_project_z_set(PointerRNA *ptr, bool value);

/**************** SimpleDeform Modifier ****************/

extern StructRNA RNA_SimpleDeformModifier;
extern StructRNA RNA_Modifier;

float SimpleDeformModifier_angle_get(PointerRNA *ptr);
void SimpleDeformModifier_angle_set(PointerRNA *ptr, float value);

enum {
	SimpleDeformModifier_deform_axis_X = 0,
	SimpleDeformModifier_deform_axis_Y = 1,
	SimpleDeformModifier_deform_axis_Z = 2,
};

int SimpleDeformModifier_deform_axis_get(PointerRNA *ptr);
void SimpleDeformModifier_deform_axis_set(PointerRNA *ptr, int value);

float SimpleDeformModifier_factor_get(PointerRNA *ptr);
void SimpleDeformModifier_factor_set(PointerRNA *ptr, float value);

bool SimpleDeformModifier_invert_vertex_group_get(PointerRNA *ptr);
void SimpleDeformModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

void SimpleDeformModifier_limits_get(PointerRNA *ptr, float values[2]);
void SimpleDeformModifier_limits_set(PointerRNA *ptr, const float values[2]);

enum {
	SimpleDeformModifier_deform_method_TWIST = 1,
	SimpleDeformModifier_deform_method_BEND = 2,
	SimpleDeformModifier_deform_method_TAPER = 3,
	SimpleDeformModifier_deform_method_STRETCH = 4,
};

int SimpleDeformModifier_deform_method_get(PointerRNA *ptr);
void SimpleDeformModifier_deform_method_set(PointerRNA *ptr, int value);

PointerRNA SimpleDeformModifier_origin_get(PointerRNA *ptr);

#define SimpleDeformModifier_vertex_group_MAX 64

void SimpleDeformModifier_vertex_group_get(PointerRNA *ptr, char *value);
int SimpleDeformModifier_vertex_group_length(PointerRNA *ptr);
void SimpleDeformModifier_vertex_group_set(PointerRNA *ptr, const char *value);

bool SimpleDeformModifier_lock_x_get(PointerRNA *ptr);
void SimpleDeformModifier_lock_x_set(PointerRNA *ptr, bool value);

bool SimpleDeformModifier_lock_y_get(PointerRNA *ptr);
void SimpleDeformModifier_lock_y_set(PointerRNA *ptr, bool value);

bool SimpleDeformModifier_lock_z_get(PointerRNA *ptr);
void SimpleDeformModifier_lock_z_set(PointerRNA *ptr, bool value);

/**************** Simulation Item ****************/

extern StructRNA RNA_SimulationStateItem;

PointerRNA SimulationStateItem_rna_type_get(PointerRNA *ptr);

void SimulationStateItem_name_get(PointerRNA *ptr, char *value);
int SimulationStateItem_name_length(PointerRNA *ptr);
void SimulationStateItem_name_set(PointerRNA *ptr, const char *value);

enum {
	SimulationStateItem_attribute_domain_POINT = 0,
	SimulationStateItem_attribute_domain_EDGE = 1,
	SimulationStateItem_attribute_domain_FACE = 2,
	SimulationStateItem_attribute_domain_CORNER = 3,
	SimulationStateItem_attribute_domain_CURVE = 4,
	SimulationStateItem_attribute_domain_INSTANCE = 5,
	SimulationStateItem_attribute_domain_LAYER = 6,
};

int SimulationStateItem_attribute_domain_get(PointerRNA *ptr);
void SimulationStateItem_attribute_domain_set(PointerRNA *ptr, int value);

void SimulationStateItem_color_get(PointerRNA *ptr, float values[4]);
void SimulationStateItem_color_set(PointerRNA *ptr, const float values[4]);

enum {
	SimulationStateItem_socket_type_FLOAT = 0,
	SimulationStateItem_socket_type_INT = 6,
	SimulationStateItem_socket_type_BOOLEAN = 4,
	SimulationStateItem_socket_type_VECTOR = 1,
	SimulationStateItem_socket_type_ROTATION = 14,
	SimulationStateItem_socket_type_MATRIX = 16,
	SimulationStateItem_socket_type_STRING = 7,
	SimulationStateItem_socket_type_MENU = 15,
	SimulationStateItem_socket_type_RGBA = 2,
	SimulationStateItem_socket_type_OBJECT = 8,
	SimulationStateItem_socket_type_IMAGE = 9,
	SimulationStateItem_socket_type_GEOMETRY = 10,
	SimulationStateItem_socket_type_COLLECTION = 11,
	SimulationStateItem_socket_type_TEXTURE = 12,
	SimulationStateItem_socket_type_MATERIAL = 13,
	SimulationStateItem_socket_type_BUNDLE = 17,
	SimulationStateItem_socket_type_CLOSURE = 18,
};

int SimulationStateItem_socket_type_get(PointerRNA *ptr);
void SimulationStateItem_socket_type_set(PointerRNA *ptr, int value);

/**************** SimulationZoneViewerPathElem ****************/

extern StructRNA RNA_SimulationZoneViewerPathElem;
extern StructRNA RNA_ViewerPathElem;

int SimulationZoneViewerPathElem_sim_output_node_id_get(PointerRNA *ptr);
void SimulationZoneViewerPathElem_sim_output_node_id_set(PointerRNA *ptr, int value);

/**************** Skin Modifier ****************/

extern StructRNA RNA_SkinModifier;
extern StructRNA RNA_Modifier;

float SkinModifier_branch_smoothing_get(PointerRNA *ptr);
void SkinModifier_branch_smoothing_set(PointerRNA *ptr, float value);

bool SkinModifier_use_smooth_shade_get(PointerRNA *ptr);
void SkinModifier_use_smooth_shade_set(PointerRNA *ptr, bool value);

bool SkinModifier_use_x_symmetry_get(PointerRNA *ptr);
void SkinModifier_use_x_symmetry_set(PointerRNA *ptr, bool value);

bool SkinModifier_use_y_symmetry_get(PointerRNA *ptr);
void SkinModifier_use_y_symmetry_set(PointerRNA *ptr, bool value);

bool SkinModifier_use_z_symmetry_get(PointerRNA *ptr);
void SkinModifier_use_z_symmetry_set(PointerRNA *ptr, bool value);

/**************** Smooth Modifier ****************/

extern StructRNA RNA_SmoothModifier;
extern StructRNA RNA_Modifier;

float SmoothModifier_factor_get(PointerRNA *ptr);
void SmoothModifier_factor_set(PointerRNA *ptr, float value);

bool SmoothModifier_invert_vertex_group_get(PointerRNA *ptr);
void SmoothModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

int SmoothModifier_iterations_get(PointerRNA *ptr);
void SmoothModifier_iterations_set(PointerRNA *ptr, int value);

#define SmoothModifier_vertex_group_MAX 64

void SmoothModifier_vertex_group_get(PointerRNA *ptr, char *value);
int SmoothModifier_vertex_group_length(PointerRNA *ptr);
void SmoothModifier_vertex_group_set(PointerRNA *ptr, const char *value);

bool SmoothModifier_use_x_get(PointerRNA *ptr);
void SmoothModifier_use_x_set(PointerRNA *ptr, bool value);

bool SmoothModifier_use_y_get(PointerRNA *ptr);
void SmoothModifier_use_y_set(PointerRNA *ptr, bool value);

bool SmoothModifier_use_z_get(PointerRNA *ptr);
void SmoothModifier_use_z_set(PointerRNA *ptr, bool value);

/**************** Soft Body Modifier ****************/

extern StructRNA RNA_SoftBodyModifier;
extern StructRNA RNA_Modifier;

PointerRNA SoftBodyModifier_point_cache_get(PointerRNA *ptr);

PointerRNA SoftBodyModifier_settings_get(PointerRNA *ptr);

/**************** Soft Body Settings ****************/

extern StructRNA RNA_SoftBodySettings;

PointerRNA SoftBodySettings_rna_type_get(PointerRNA *ptr);

int SoftBodySettings_aero_get(PointerRNA *ptr);
void SoftBodySettings_aero_set(PointerRNA *ptr, int value);

enum {
	SoftBodySettings_aerodynamics_type_SIMPLE = 0,
	SoftBodySettings_aerodynamics_type_LIFT_FORCE = 1,
};

int SoftBodySettings_aerodynamics_type_get(PointerRNA *ptr);
void SoftBodySettings_aerodynamics_type_set(PointerRNA *ptr, int value);

float SoftBodySettings_ball_size_get(PointerRNA *ptr);
void SoftBodySettings_ball_size_set(PointerRNA *ptr, float value);

float SoftBodySettings_bend_get(PointerRNA *ptr);
void SoftBodySettings_bend_set(PointerRNA *ptr, float value);

void SoftBodySettings_location_mass_center_get(PointerRNA *ptr, float values[3]);
void SoftBodySettings_location_mass_center_set(PointerRNA *ptr, const float values[3]);

int SoftBodySettings_choke_get(PointerRNA *ptr);
void SoftBodySettings_choke_set(PointerRNA *ptr, int value);

PointerRNA SoftBodySettings_collision_collection_get(PointerRNA *ptr);

enum {
	SoftBodySettings_collision_type_MANUAL = 0,
	SoftBodySettings_collision_type_AVERAGE = 1,
	SoftBodySettings_collision_type_MINIMAL = 2,
	SoftBodySettings_collision_type_MAXIMAL = 3,
	SoftBodySettings_collision_type_MINMAX = 4,
};

int SoftBodySettings_collision_type_get(PointerRNA *ptr);
void SoftBodySettings_collision_type_set(PointerRNA *ptr, int value);

float SoftBodySettings_damping_get(PointerRNA *ptr);
void SoftBodySettings_damping_set(PointerRNA *ptr, float value);

float SoftBodySettings_ball_damp_get(PointerRNA *ptr);
void SoftBodySettings_ball_damp_set(PointerRNA *ptr, float value);

bool SoftBodySettings_use_edge_collision_get(PointerRNA *ptr);
void SoftBodySettings_use_edge_collision_set(PointerRNA *ptr, bool value);

PointerRNA SoftBodySettings_effector_weights_get(PointerRNA *ptr);

float SoftBodySettings_error_threshold_get(PointerRNA *ptr);
void SoftBodySettings_error_threshold_set(PointerRNA *ptr, float value);

bool SoftBodySettings_use_estimate_matrix_get(PointerRNA *ptr);
void SoftBodySettings_use_estimate_matrix_set(PointerRNA *ptr, bool value);

bool SoftBodySettings_use_face_collision_get(PointerRNA *ptr);
void SoftBodySettings_use_face_collision_set(PointerRNA *ptr, bool value);

float SoftBodySettings_friction_get(PointerRNA *ptr);
void SoftBodySettings_friction_set(PointerRNA *ptr, float value);

int SoftBodySettings_fuzzy_get(PointerRNA *ptr);
void SoftBodySettings_fuzzy_set(PointerRNA *ptr, int value);

float SoftBodySettings_goal_friction_get(PointerRNA *ptr);
void SoftBodySettings_goal_friction_set(PointerRNA *ptr, float value);

float SoftBodySettings_goal_default_get(PointerRNA *ptr);
void SoftBodySettings_goal_default_set(PointerRNA *ptr, float value);

float SoftBodySettings_goal_max_get(PointerRNA *ptr);
void SoftBodySettings_goal_max_set(PointerRNA *ptr, float value);

float SoftBodySettings_goal_min_get(PointerRNA *ptr);
void SoftBodySettings_goal_min_set(PointerRNA *ptr, float value);

float SoftBodySettings_goal_spring_get(PointerRNA *ptr);
void SoftBodySettings_goal_spring_set(PointerRNA *ptr, float value);

void SoftBodySettings_vertex_group_goal_get(PointerRNA *ptr, char *value);
int SoftBodySettings_vertex_group_goal_length(PointerRNA *ptr);
void SoftBodySettings_vertex_group_goal_set(PointerRNA *ptr, const char *value);

float SoftBodySettings_gravity_get(PointerRNA *ptr);
void SoftBodySettings_gravity_set(PointerRNA *ptr, float value);

float SoftBodySettings_mass_get(PointerRNA *ptr);
void SoftBodySettings_mass_set(PointerRNA *ptr, float value);

#define SoftBodySettings_vertex_group_mass_MAX 64

void SoftBodySettings_vertex_group_mass_get(PointerRNA *ptr, char *value);
int SoftBodySettings_vertex_group_mass_length(PointerRNA *ptr);
void SoftBodySettings_vertex_group_mass_set(PointerRNA *ptr, const char *value);

int SoftBodySettings_step_max_get(PointerRNA *ptr);
void SoftBodySettings_step_max_set(PointerRNA *ptr, int value);

int SoftBodySettings_step_min_get(PointerRNA *ptr);
void SoftBodySettings_step_min_set(PointerRNA *ptr, int value);

int SoftBodySettings_plastic_get(PointerRNA *ptr);
void SoftBodySettings_plastic_set(PointerRNA *ptr, int value);

bool SoftBodySettings_use_diagnose_get(PointerRNA *ptr);
void SoftBodySettings_use_diagnose_set(PointerRNA *ptr, bool value);

float SoftBodySettings_pull_get(PointerRNA *ptr);
void SoftBodySettings_pull_set(PointerRNA *ptr, float value);

float SoftBodySettings_push_get(PointerRNA *ptr);
void SoftBodySettings_push_set(PointerRNA *ptr, float value);

void SoftBodySettings_rotation_estimate_get(PointerRNA *ptr, float values[9]);
void SoftBodySettings_rotation_estimate_set(PointerRNA *ptr, const float values[9]);

void SoftBodySettings_scale_estimate_get(PointerRNA *ptr, float values[9]);
void SoftBodySettings_scale_estimate_set(PointerRNA *ptr, const float values[9]);

bool SoftBodySettings_use_self_collision_get(PointerRNA *ptr);
void SoftBodySettings_use_self_collision_set(PointerRNA *ptr, bool value);

float SoftBodySettings_shear_get(PointerRNA *ptr);
void SoftBodySettings_shear_set(PointerRNA *ptr, float value);

float SoftBodySettings_speed_get(PointerRNA *ptr);
void SoftBodySettings_speed_set(PointerRNA *ptr, float value);

int SoftBodySettings_spring_length_get(PointerRNA *ptr);
void SoftBodySettings_spring_length_set(PointerRNA *ptr, int value);

#define SoftBodySettings_vertex_group_spring_MAX 64

void SoftBodySettings_vertex_group_spring_get(PointerRNA *ptr, char *value);
int SoftBodySettings_vertex_group_spring_length(PointerRNA *ptr);
void SoftBodySettings_vertex_group_spring_set(PointerRNA *ptr, const char *value);

bool SoftBodySettings_use_stiff_quads_get(PointerRNA *ptr);
void SoftBodySettings_use_stiff_quads_set(PointerRNA *ptr, bool value);

float SoftBodySettings_ball_stiff_get(PointerRNA *ptr);
void SoftBodySettings_ball_stiff_set(PointerRNA *ptr, float value);

bool SoftBodySettings_use_edges_get(PointerRNA *ptr);
void SoftBodySettings_use_edges_set(PointerRNA *ptr, bool value);

bool SoftBodySettings_use_goal_get(PointerRNA *ptr);
void SoftBodySettings_use_goal_set(PointerRNA *ptr, bool value);

bool SoftBodySettings_use_auto_step_get(PointerRNA *ptr);
void SoftBodySettings_use_auto_step_set(PointerRNA *ptr, bool value);

/**************** Solidify Modifier ****************/

extern StructRNA RNA_SolidifyModifier;
extern StructRNA RNA_Modifier;

bool SolidifyModifier_use_thickness_angle_clamp_get(PointerRNA *ptr);
void SolidifyModifier_use_thickness_angle_clamp_set(PointerRNA *ptr, bool value);

float SolidifyModifier_bevel_convex_get(PointerRNA *ptr);
void SolidifyModifier_bevel_convex_set(PointerRNA *ptr, float value);

enum {
	SolidifyModifier_nonmanifold_boundary_mode_NONE = 0,
	SolidifyModifier_nonmanifold_boundary_mode_ROUND = 1,
	SolidifyModifier_nonmanifold_boundary_mode_FLAT = 2,
};

int SolidifyModifier_nonmanifold_boundary_mode_get(PointerRNA *ptr);
void SolidifyModifier_nonmanifold_boundary_mode_set(PointerRNA *ptr, int value);

float SolidifyModifier_thickness_clamp_get(PointerRNA *ptr);
void SolidifyModifier_thickness_clamp_set(PointerRNA *ptr, float value);

bool SolidifyModifier_use_even_offset_get(PointerRNA *ptr);
void SolidifyModifier_use_even_offset_set(PointerRNA *ptr, bool value);

bool SolidifyModifier_use_rim_get(PointerRNA *ptr);
void SolidifyModifier_use_rim_set(PointerRNA *ptr, bool value);

bool SolidifyModifier_use_flat_faces_get(PointerRNA *ptr);
void SolidifyModifier_use_flat_faces_set(PointerRNA *ptr, bool value);

bool SolidifyModifier_use_flip_normals_get(PointerRNA *ptr);
void SolidifyModifier_use_flip_normals_set(PointerRNA *ptr, bool value);

bool SolidifyModifier_use_quality_normals_get(PointerRNA *ptr);
void SolidifyModifier_use_quality_normals_set(PointerRNA *ptr, bool value);

float SolidifyModifier_edge_crease_inner_get(PointerRNA *ptr);
void SolidifyModifier_edge_crease_inner_set(PointerRNA *ptr, float value);

int SolidifyModifier_material_offset_get(PointerRNA *ptr);
void SolidifyModifier_material_offset_set(PointerRNA *ptr, int value);

float SolidifyModifier_nonmanifold_merge_threshold_get(PointerRNA *ptr);
void SolidifyModifier_nonmanifold_merge_threshold_set(PointerRNA *ptr, float value);

enum {
	SolidifyModifier_solidify_mode_EXTRUDE = 0,
	SolidifyModifier_solidify_mode_NON_MANIFOLD = 1,
};

int SolidifyModifier_solidify_mode_get(PointerRNA *ptr);
void SolidifyModifier_solidify_mode_set(PointerRNA *ptr, int value);

float SolidifyModifier_offset_get(PointerRNA *ptr);
void SolidifyModifier_offset_set(PointerRNA *ptr, float value);

bool SolidifyModifier_use_rim_only_get(PointerRNA *ptr);
void SolidifyModifier_use_rim_only_set(PointerRNA *ptr, bool value);

float SolidifyModifier_edge_crease_outer_get(PointerRNA *ptr);
void SolidifyModifier_edge_crease_outer_set(PointerRNA *ptr, float value);

float SolidifyModifier_edge_crease_rim_get(PointerRNA *ptr);
void SolidifyModifier_edge_crease_rim_set(PointerRNA *ptr, float value);

int SolidifyModifier_material_offset_rim_get(PointerRNA *ptr);
void SolidifyModifier_material_offset_rim_set(PointerRNA *ptr, int value);

#define SolidifyModifier_rim_vertex_group_MAX 64

void SolidifyModifier_rim_vertex_group_get(PointerRNA *ptr, char *value);
int SolidifyModifier_rim_vertex_group_length(PointerRNA *ptr);
void SolidifyModifier_rim_vertex_group_set(PointerRNA *ptr, const char *value);

#define SolidifyModifier_shell_vertex_group_MAX 64

void SolidifyModifier_shell_vertex_group_get(PointerRNA *ptr, char *value);
int SolidifyModifier_shell_vertex_group_length(PointerRNA *ptr);
void SolidifyModifier_shell_vertex_group_set(PointerRNA *ptr, const char *value);

float SolidifyModifier_thickness_get(PointerRNA *ptr);
void SolidifyModifier_thickness_set(PointerRNA *ptr, float value);

enum {
	SolidifyModifier_nonmanifold_thickness_mode_FIXED = 0,
	SolidifyModifier_nonmanifold_thickness_mode_EVEN = 1,
	SolidifyModifier_nonmanifold_thickness_mode_CONSTRAINTS = 2,
};

int SolidifyModifier_nonmanifold_thickness_mode_get(PointerRNA *ptr);
void SolidifyModifier_nonmanifold_thickness_mode_set(PointerRNA *ptr, int value);

#define SolidifyModifier_vertex_group_MAX 64

void SolidifyModifier_vertex_group_get(PointerRNA *ptr, char *value);
int SolidifyModifier_vertex_group_length(PointerRNA *ptr);
void SolidifyModifier_vertex_group_set(PointerRNA *ptr, const char *value);

float SolidifyModifier_thickness_vertex_group_get(PointerRNA *ptr);
void SolidifyModifier_thickness_vertex_group_set(PointerRNA *ptr, float value);

bool SolidifyModifier_invert_vertex_group_get(PointerRNA *ptr);
void SolidifyModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

/**************** Sound ****************/

extern StructRNA RNA_Sound;
extern StructRNA RNA_ID;

enum {
	Sound_channels_INVALID = 0,
	Sound_channels_MONO = 1,
	Sound_channels_STEREO = 2,
	Sound_channels_STEREO_LFE = 3,
	Sound_channels_CHANNELS_4 = 4,
	Sound_channels_CHANNELS_5 = 5,
	Sound_channels_SURROUND_51 = 6,
	Sound_channels_SURROUND_61 = 7,
	Sound_channels_SURROUND_71 = 8,
};

int Sound_channels_get(PointerRNA *ptr);
void Sound_channels_set(PointerRNA *ptr, int value);

bool Sound_use_memory_cache_get(PointerRNA *ptr);
void Sound_use_memory_cache_set(PointerRNA *ptr, bool value);

#define Sound_filepath_MAX 1024

void Sound_filepath_get(PointerRNA *ptr, char *value);
int Sound_filepath_length(PointerRNA *ptr);
void Sound_filepath_set(PointerRNA *ptr, const char *value);

bool Sound_use_mono_get(PointerRNA *ptr);
void Sound_use_mono_set(PointerRNA *ptr, bool value);

PointerRNA Sound_packed_file_get(PointerRNA *ptr);

int Sound_samplerate_get(PointerRNA *ptr);
void Sound_samplerate_set(PointerRNA *ptr, int value);

void Sound_pack_func(struct bSound *_self, Main *bmain, ReportList *reports);
void Sound_unpack_func(struct bSound *_self, Main *bmain, ReportList *reports, int method);
/**************** SoundEqualizerModifier ****************/

extern StructRNA RNA_SoundEqualizerModifier;
extern StructRNA RNA_StripModifier;

void SoundEqualizerModifier_graphics_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SoundEqualizerModifier_graphics_next(CollectionPropertyIterator *iter);
void SoundEqualizerModifier_graphics_end(CollectionPropertyIterator *iter);
bool SoundEqualizerModifier_graphics_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

struct EQCurveMappingData *SoundEqualizerModifier_new_graphic_func(struct SoundEqualizerModifierData *_self, bContext *C, float min_freq, float max_freq);
void SoundEqualizerModifier_clear_soundeqs_func(struct SoundEqualizerModifierData *_self, bContext *C);
/**************** Sound Strip ****************/

extern StructRNA RNA_SoundStrip;
extern StructRNA RNA_Strip;

int SoundStrip_animation_offset_end_get(PointerRNA *ptr);
void SoundStrip_animation_offset_end_set(PointerRNA *ptr, int value);

int SoundStrip_animation_offset_start_get(PointerRNA *ptr);
void SoundStrip_animation_offset_start_set(PointerRNA *ptr, int value);

bool SoundStrip_show_waveform_get(PointerRNA *ptr);
void SoundStrip_show_waveform_set(PointerRNA *ptr, bool value);

float SoundStrip_pan_get(PointerRNA *ptr);
void SoundStrip_pan_set(PointerRNA *ptr, float value);

void SoundStrip_retiming_keys_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SoundStrip_retiming_keys_next(CollectionPropertyIterator *iter);
void SoundStrip_retiming_keys_end(CollectionPropertyIterator *iter);
int SoundStrip_retiming_keys_length(PointerRNA *ptr);
bool SoundStrip_retiming_keys_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

PointerRNA SoundStrip_sound_get(PointerRNA *ptr);

float SoundStrip_sound_offset_get(PointerRNA *ptr);
void SoundStrip_sound_offset_set(PointerRNA *ptr, float value);

float SoundStrip_volume_get(PointerRNA *ptr);
void SoundStrip_volume_set(PointerRNA *ptr, float value);

/**************** Space ****************/

extern StructRNA RNA_Space;

PointerRNA Space_rna_type_get(PointerRNA *ptr);

bool Space_show_region_header_get(PointerRNA *ptr);
void Space_show_region_header_set(PointerRNA *ptr, bool value);

bool Space_show_locked_time_get(PointerRNA *ptr);
void Space_show_locked_time_set(PointerRNA *ptr, bool value);

enum {
	Space_type_EMPTY = 0,
	Space_type_VIEW_3D = 1,
	Space_type_IMAGE_EDITOR = 6,
	Space_type_NODE_EDITOR = 16,
	Space_type_SEQUENCE_EDITOR = 8,
	Space_type_CLIP_EDITOR = 20,
	Space_type_DOPESHEET_EDITOR = 12,
	Space_type_GRAPH_EDITOR = 2,
	Space_type_NLA_EDITOR = 13,
	Space_type_TEXT_EDITOR = 9,
	Space_type_CONSOLE = 18,
	Space_type_INFO = 7,
	Space_type_TOPBAR = 21,
	Space_type_STATUSBAR = 22,
	Space_type_OUTLINER = 3,
	Space_type_PROPERTIES = 4,
	Space_type_FILE_BROWSER = 5,
	Space_type_SPREADSHEET = 23,
	Space_type_PREFERENCES = 19,
};

int Space_type_get(PointerRNA *ptr);
void Space_type_set(PointerRNA *ptr, int value);

/**************** Space Clip Editor ****************/

extern StructRNA RNA_SpaceClipEditor;
extern StructRNA RNA_Space;

void SpaceClipEditor_cursor_location_get(PointerRNA *ptr, float values[2]);
void SpaceClipEditor_cursor_location_set(PointerRNA *ptr, const float values[2]);

bool SpaceClipEditor_show_region_hud_get(PointerRNA *ptr);
void SpaceClipEditor_show_region_hud_set(PointerRNA *ptr, bool value);

enum {
	SpaceClipEditor_annotation_source_CLIP = 0,
	SpaceClipEditor_annotation_source_TRACK = 1,
};

int SpaceClipEditor_annotation_source_get(PointerRNA *ptr);
void SpaceClipEditor_annotation_source_set(PointerRNA *ptr, int value);

float SpaceClipEditor_blend_factor_get(PointerRNA *ptr);
void SpaceClipEditor_blend_factor_set(PointerRNA *ptr, float value);

bool SpaceClipEditor_show_region_channels_get(PointerRNA *ptr);
void SpaceClipEditor_show_region_channels_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_graph_hidden_get(PointerRNA *ptr);
void SpaceClipEditor_show_graph_hidden_set(PointerRNA *ptr, bool value);

enum {
	SpaceClipEditor_mask_display_type_OUTLINE = 0,
	SpaceClipEditor_mask_display_type_DASH = 1,
	SpaceClipEditor_mask_display_type_BLACK = 2,
	SpaceClipEditor_mask_display_type_WHITE = 3,
};

int SpaceClipEditor_mask_display_type_get(PointerRNA *ptr);
void SpaceClipEditor_mask_display_type_set(PointerRNA *ptr, int value);

bool SpaceClipEditor_use_grayscale_preview_get(PointerRNA *ptr);
void SpaceClipEditor_use_grayscale_preview_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_lock_selection_get(PointerRNA *ptr);
void SpaceClipEditor_lock_selection_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_lock_time_cursor_get(PointerRNA *ptr);
void SpaceClipEditor_lock_time_cursor_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_use_manual_calibration_get(PointerRNA *ptr);
void SpaceClipEditor_use_manual_calibration_set(PointerRNA *ptr, bool value);

PointerRNA SpaceClipEditor_mask_get(PointerRNA *ptr);

enum {
	SpaceClipEditor_mode_TRACKING = 0,
	SpaceClipEditor_mode_MASK = 3,
};

int SpaceClipEditor_mode_get(PointerRNA *ptr);
void SpaceClipEditor_mode_set(PointerRNA *ptr, int value);

PointerRNA SpaceClipEditor_clip_get(PointerRNA *ptr);

PointerRNA SpaceClipEditor_clip_user_get(PointerRNA *ptr);

bool SpaceClipEditor_use_mute_footage_get(PointerRNA *ptr);
void SpaceClipEditor_use_mute_footage_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_gizmo_navigate_get(PointerRNA *ptr);
void SpaceClipEditor_show_gizmo_navigate_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_graph_only_selected_get(PointerRNA *ptr);
void SpaceClipEditor_show_graph_only_selected_set(PointerRNA *ptr, bool value);

enum {
	SpaceClipEditor_mask_overlay_mode_ALPHACHANNEL = 0,
	SpaceClipEditor_mask_overlay_mode_COMBINED = 1,
};

int SpaceClipEditor_mask_overlay_mode_get(PointerRNA *ptr);
void SpaceClipEditor_mask_overlay_mode_set(PointerRNA *ptr, int value);

int SpaceClipEditor_path_length_get(PointerRNA *ptr);
void SpaceClipEditor_path_length_set(PointerRNA *ptr, int value);

enum {
	SpaceClipEditor_pivot_point_BOUNDING_BOX_CENTER = 0,
	SpaceClipEditor_pivot_point_CURSOR = 1,
	SpaceClipEditor_pivot_point_INDIVIDUAL_ORIGINS = 2,
	SpaceClipEditor_pivot_point_MEDIAN_POINT = 3,
};

int SpaceClipEditor_pivot_point_get(PointerRNA *ptr);
void SpaceClipEditor_pivot_point_set(PointerRNA *ptr, int value);

PointerRNA SpaceClipEditor_scopes_get(PointerRNA *ptr);

bool SpaceClipEditor_show_annotation_get(PointerRNA *ptr);
void SpaceClipEditor_show_annotation_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_blue_channel_get(PointerRNA *ptr);
void SpaceClipEditor_show_blue_channel_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_bundles_get(PointerRNA *ptr);
void SpaceClipEditor_show_bundles_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_disabled_get(PointerRNA *ptr);
void SpaceClipEditor_show_disabled_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_filters_get(PointerRNA *ptr);
void SpaceClipEditor_show_filters_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_graph_frames_get(PointerRNA *ptr);
void SpaceClipEditor_show_graph_frames_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_gizmo_get(PointerRNA *ptr);
void SpaceClipEditor_show_gizmo_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_green_channel_get(PointerRNA *ptr);
void SpaceClipEditor_show_green_channel_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_grid_get(PointerRNA *ptr);
void SpaceClipEditor_show_grid_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_marker_pattern_get(PointerRNA *ptr);
void SpaceClipEditor_show_marker_pattern_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_marker_search_get(PointerRNA *ptr);
void SpaceClipEditor_show_marker_search_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_mask_overlay_get(PointerRNA *ptr);
void SpaceClipEditor_show_mask_overlay_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_mask_spline_get(PointerRNA *ptr);
void SpaceClipEditor_show_mask_spline_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_metadata_get(PointerRNA *ptr);
void SpaceClipEditor_show_metadata_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_names_get(PointerRNA *ptr);
void SpaceClipEditor_show_names_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_red_channel_get(PointerRNA *ptr);
void SpaceClipEditor_show_red_channel_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_stable_get(PointerRNA *ptr);
void SpaceClipEditor_show_stable_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_tiny_markers_get(PointerRNA *ptr);
void SpaceClipEditor_show_tiny_markers_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_track_path_get(PointerRNA *ptr);
void SpaceClipEditor_show_track_path_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_graph_tracks_error_get(PointerRNA *ptr);
void SpaceClipEditor_show_graph_tracks_error_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_graph_tracks_motion_get(PointerRNA *ptr);
void SpaceClipEditor_show_graph_tracks_motion_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_region_ui_get(PointerRNA *ptr);
void SpaceClipEditor_show_region_ui_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_region_toolbar_get(PointerRNA *ptr);
void SpaceClipEditor_show_region_toolbar_set(PointerRNA *ptr, bool value);

bool SpaceClipEditor_show_seconds_get(PointerRNA *ptr);
void SpaceClipEditor_show_seconds_set(PointerRNA *ptr, bool value);

enum {
	SpaceClipEditor_view_CLIP = 0,
	SpaceClipEditor_view_GRAPH = 1,
	SpaceClipEditor_view_DOPESHEET = 2,
};

int SpaceClipEditor_view_get(PointerRNA *ptr);
void SpaceClipEditor_view_set(PointerRNA *ptr, int value);

float SpaceClipEditor_zoom_percentage_get(PointerRNA *ptr);
void SpaceClipEditor_zoom_percentage_set(PointerRNA *ptr, float value);

/**************** Space Console ****************/

extern StructRNA RNA_SpaceConsole;
extern StructRNA RNA_Space;

int SpaceConsole_font_size_get(PointerRNA *ptr);
void SpaceConsole_font_size_set(PointerRNA *ptr, int value);

void SpaceConsole_history_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SpaceConsole_history_next(CollectionPropertyIterator *iter);
void SpaceConsole_history_end(CollectionPropertyIterator *iter);
bool SpaceConsole_history_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

#define SpaceConsole_language_MAX 32

void SpaceConsole_language_get(PointerRNA *ptr, char *value);
int SpaceConsole_language_length(PointerRNA *ptr);
void SpaceConsole_language_set(PointerRNA *ptr, const char *value);

void SpaceConsole_scrollback_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SpaceConsole_scrollback_next(CollectionPropertyIterator *iter);
void SpaceConsole_scrollback_end(CollectionPropertyIterator *iter);
bool SpaceConsole_scrollback_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

#define SpaceConsole_prompt_MAX 256

void SpaceConsole_prompt_get(PointerRNA *ptr, char *value);
int SpaceConsole_prompt_length(PointerRNA *ptr);
void SpaceConsole_prompt_set(PointerRNA *ptr, const char *value);

int SpaceConsole_select_end_get(PointerRNA *ptr);
void SpaceConsole_select_end_set(PointerRNA *ptr, int value);

int SpaceConsole_select_start_get(PointerRNA *ptr);
void SpaceConsole_select_start_set(PointerRNA *ptr, int value);

/**************** Space Dope Sheet Editor ****************/

extern StructRNA RNA_SpaceDopeSheetEditor;
extern StructRNA RNA_Space;

PointerRNA SpaceDopeSheetEditor_action_get(PointerRNA *ptr);

bool SpaceDopeSheetEditor_show_region_hud_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_show_region_hud_set(PointerRNA *ptr, bool value);

bool SpaceDopeSheetEditor_use_auto_merge_keyframes_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_use_auto_merge_keyframes_set(PointerRNA *ptr, bool value);

bool SpaceDopeSheetEditor_show_region_channels_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_show_region_channels_set(PointerRNA *ptr, bool value);

bool SpaceDopeSheetEditor_cache_cloth_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_cache_cloth_set(PointerRNA *ptr, bool value);

PointerRNA SpaceDopeSheetEditor_dopesheet_get(PointerRNA *ptr);

bool SpaceDopeSheetEditor_cache_dynamicpaint_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_cache_dynamicpaint_set(PointerRNA *ptr, bool value);

enum {
	SpaceDopeSheetEditor_mode_DOPESHEET = 3,
	SpaceDopeSheetEditor_mode_TIMELINE = 6,
	SpaceDopeSheetEditor_mode_ACTION = 0,
	SpaceDopeSheetEditor_mode_SHAPEKEY = 1,
	SpaceDopeSheetEditor_mode_GPENCIL = 2,
	SpaceDopeSheetEditor_mode_MASK = 4,
	SpaceDopeSheetEditor_mode_CACHEFILE = 5,
};

int SpaceDopeSheetEditor_mode_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_mode_set(PointerRNA *ptr, int value);

enum {
	SpaceDopeSheetEditor_ui_mode_DOPESHEET = 3,
	SpaceDopeSheetEditor_ui_mode_ACTION = 0,
	SpaceDopeSheetEditor_ui_mode_SHAPEKEY = 1,
	SpaceDopeSheetEditor_ui_mode_GPENCIL = 2,
	SpaceDopeSheetEditor_ui_mode_MASK = 4,
	SpaceDopeSheetEditor_ui_mode_CACHEFILE = 5,
};

int SpaceDopeSheetEditor_ui_mode_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_ui_mode_set(PointerRNA *ptr, int value);

bool SpaceDopeSheetEditor_cache_particles_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_cache_particles_set(PointerRNA *ptr, bool value);

bool SpaceDopeSheetEditor_use_realtime_update_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_use_realtime_update_set(PointerRNA *ptr, bool value);

bool SpaceDopeSheetEditor_cache_rigidbody_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_cache_rigidbody_set(PointerRNA *ptr, bool value);

bool SpaceDopeSheetEditor_show_cache_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_show_cache_set(PointerRNA *ptr, bool value);

bool SpaceDopeSheetEditor_show_extremes_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_show_extremes_set(PointerRNA *ptr, bool value);

bool SpaceDopeSheetEditor_show_interpolation_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_show_interpolation_set(PointerRNA *ptr, bool value);

bool SpaceDopeSheetEditor_show_markers_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_show_markers_set(PointerRNA *ptr, bool value);

bool SpaceDopeSheetEditor_show_pose_markers_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_show_pose_markers_set(PointerRNA *ptr, bool value);

bool SpaceDopeSheetEditor_show_sliders_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_show_sliders_set(PointerRNA *ptr, bool value);

bool SpaceDopeSheetEditor_show_region_ui_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_show_region_ui_set(PointerRNA *ptr, bool value);

bool SpaceDopeSheetEditor_cache_simulation_nodes_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_cache_simulation_nodes_set(PointerRNA *ptr, bool value);

bool SpaceDopeSheetEditor_cache_smoke_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_cache_smoke_set(PointerRNA *ptr, bool value);

bool SpaceDopeSheetEditor_cache_softbody_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_cache_softbody_set(PointerRNA *ptr, bool value);

bool SpaceDopeSheetEditor_use_marker_sync_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_use_marker_sync_set(PointerRNA *ptr, bool value);

bool SpaceDopeSheetEditor_show_seconds_get(PointerRNA *ptr);
void SpaceDopeSheetEditor_show_seconds_set(PointerRNA *ptr, bool value);

/**************** Space File Browser ****************/

extern StructRNA RNA_SpaceFileBrowser;
extern StructRNA RNA_Space;

int SpaceFileBrowser_bookmarks_active_get(PointerRNA *ptr);
void SpaceFileBrowser_bookmarks_active_set(PointerRNA *ptr, int value);

PointerRNA SpaceFileBrowser_active_operator_get(PointerRNA *ptr);

PointerRNA SpaceFileBrowser_operator_value_get(PointerRNA *ptr);

int SpaceFileBrowser_recent_folders_active_get(PointerRNA *ptr);
void SpaceFileBrowser_recent_folders_active_set(PointerRNA *ptr, int value);

int SpaceFileBrowser_system_bookmarks_active_get(PointerRNA *ptr);
void SpaceFileBrowser_system_bookmarks_active_set(PointerRNA *ptr, int value);

int SpaceFileBrowser_system_folders_active_get(PointerRNA *ptr);
void SpaceFileBrowser_system_folders_active_set(PointerRNA *ptr, int value);

void SpaceFileBrowser_bookmarks_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SpaceFileBrowser_bookmarks_next(CollectionPropertyIterator *iter);
void SpaceFileBrowser_bookmarks_end(CollectionPropertyIterator *iter);
int SpaceFileBrowser_bookmarks_length(PointerRNA *ptr);

enum {
	SpaceFileBrowser_browse_mode_FILES = 0,
	SpaceFileBrowser_browse_mode_ASSETS = 1,
};

int SpaceFileBrowser_browse_mode_get(PointerRNA *ptr);
void SpaceFileBrowser_browse_mode_set(PointerRNA *ptr, int value);

PointerRNA SpaceFileBrowser_params_get(PointerRNA *ptr);

void SpaceFileBrowser_recent_folders_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SpaceFileBrowser_recent_folders_next(CollectionPropertyIterator *iter);
void SpaceFileBrowser_recent_folders_end(CollectionPropertyIterator *iter);
int SpaceFileBrowser_recent_folders_length(PointerRNA *ptr);

bool SpaceFileBrowser_show_region_ui_get(PointerRNA *ptr);
void SpaceFileBrowser_show_region_ui_set(PointerRNA *ptr, bool value);

void SpaceFileBrowser_system_bookmarks_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SpaceFileBrowser_system_bookmarks_next(CollectionPropertyIterator *iter);
void SpaceFileBrowser_system_bookmarks_end(CollectionPropertyIterator *iter);
int SpaceFileBrowser_system_bookmarks_length(PointerRNA *ptr);

void SpaceFileBrowser_system_folders_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SpaceFileBrowser_system_folders_next(CollectionPropertyIterator *iter);
void SpaceFileBrowser_system_folders_end(CollectionPropertyIterator *iter);
int SpaceFileBrowser_system_folders_length(PointerRNA *ptr);

bool SpaceFileBrowser_show_region_toolbar_get(PointerRNA *ptr);
void SpaceFileBrowser_show_region_toolbar_set(PointerRNA *ptr, bool value);

bool SpaceFileBrowser_show_region_tool_props_get(PointerRNA *ptr);
void SpaceFileBrowser_show_region_tool_props_set(PointerRNA *ptr, bool value);

void SpaceFileBrowser_activate_asset_by_id_func(struct SpaceFile *_self, struct ID *id_to_activate, bool deferred);
void SpaceFileBrowser_activate_file_by_relative_path_func(struct SpaceFile *_self, const char * relative_path);
void SpaceFileBrowser_deselect_all_func(struct SpaceFile *_self);
/**************** Space Graph Editor ****************/

extern StructRNA RNA_SpaceGraphEditor;
extern StructRNA RNA_Space;

bool SpaceGraphEditor_show_region_hud_get(PointerRNA *ptr);
void SpaceGraphEditor_show_region_hud_set(PointerRNA *ptr, bool value);

bool SpaceGraphEditor_use_auto_normalization_get(PointerRNA *ptr);
void SpaceGraphEditor_use_auto_normalization_set(PointerRNA *ptr, bool value);

bool SpaceGraphEditor_use_auto_lock_translation_axis_get(PointerRNA *ptr);
void SpaceGraphEditor_use_auto_lock_translation_axis_set(PointerRNA *ptr, bool value);

bool SpaceGraphEditor_use_auto_merge_keyframes_get(PointerRNA *ptr);
void SpaceGraphEditor_use_auto_merge_keyframes_set(PointerRNA *ptr, bool value);

bool SpaceGraphEditor_show_region_channels_get(PointerRNA *ptr);
void SpaceGraphEditor_show_region_channels_set(PointerRNA *ptr, bool value);

float SpaceGraphEditor_cursor_position_x_get(PointerRNA *ptr);
void SpaceGraphEditor_cursor_position_x_set(PointerRNA *ptr, float value);

float SpaceGraphEditor_cursor_position_y_get(PointerRNA *ptr);
void SpaceGraphEditor_cursor_position_y_set(PointerRNA *ptr, float value);

PointerRNA SpaceGraphEditor_dopesheet_get(PointerRNA *ptr);

bool SpaceGraphEditor_has_ghost_curves_get(PointerRNA *ptr);
void SpaceGraphEditor_has_ghost_curves_set(PointerRNA *ptr, bool value);

enum {
	SpaceGraphEditor_mode_FCURVES = 0,
	SpaceGraphEditor_mode_DRIVERS = 1,
};

int SpaceGraphEditor_mode_get(PointerRNA *ptr);
void SpaceGraphEditor_mode_set(PointerRNA *ptr, int value);

bool SpaceGraphEditor_use_only_selected_keyframe_handles_get(PointerRNA *ptr);
void SpaceGraphEditor_use_only_selected_keyframe_handles_set(PointerRNA *ptr, bool value);

enum {
	SpaceGraphEditor_pivot_point_BOUNDING_BOX_CENTER = 0,
	SpaceGraphEditor_pivot_point_CURSOR = 1,
	SpaceGraphEditor_pivot_point_INDIVIDUAL_ORIGINS = 2,
};

int SpaceGraphEditor_pivot_point_get(PointerRNA *ptr);
void SpaceGraphEditor_pivot_point_set(PointerRNA *ptr, int value);

bool SpaceGraphEditor_use_realtime_update_get(PointerRNA *ptr);
void SpaceGraphEditor_use_realtime_update_set(PointerRNA *ptr, bool value);

bool SpaceGraphEditor_show_cursor_get(PointerRNA *ptr);
void SpaceGraphEditor_show_cursor_set(PointerRNA *ptr, bool value);

bool SpaceGraphEditor_show_extrapolation_get(PointerRNA *ptr);
void SpaceGraphEditor_show_extrapolation_set(PointerRNA *ptr, bool value);

bool SpaceGraphEditor_show_handles_get(PointerRNA *ptr);
void SpaceGraphEditor_show_handles_set(PointerRNA *ptr, bool value);

bool SpaceGraphEditor_show_markers_get(PointerRNA *ptr);
void SpaceGraphEditor_show_markers_set(PointerRNA *ptr, bool value);

bool SpaceGraphEditor_show_sliders_get(PointerRNA *ptr);
void SpaceGraphEditor_show_sliders_set(PointerRNA *ptr, bool value);

bool SpaceGraphEditor_show_region_ui_get(PointerRNA *ptr);
void SpaceGraphEditor_show_region_ui_set(PointerRNA *ptr, bool value);

bool SpaceGraphEditor_use_normalization_get(PointerRNA *ptr);
void SpaceGraphEditor_use_normalization_set(PointerRNA *ptr, bool value);

bool SpaceGraphEditor_show_seconds_get(PointerRNA *ptr);
void SpaceGraphEditor_show_seconds_set(PointerRNA *ptr, bool value);

/**************** Space Image Editor ****************/

extern StructRNA RNA_SpaceImageEditor;
extern StructRNA RNA_Space;

void SpaceImageEditor_cursor_location_get(PointerRNA *ptr, float values[2]);
void SpaceImageEditor_cursor_location_set(PointerRNA *ptr, const float values[2]);

bool SpaceImageEditor_show_region_hud_get(PointerRNA *ptr);
void SpaceImageEditor_show_region_hud_set(PointerRNA *ptr, bool value);

bool SpaceImageEditor_show_region_asset_shelf_get(PointerRNA *ptr);
void SpaceImageEditor_show_region_asset_shelf_set(PointerRNA *ptr, bool value);

float SpaceImageEditor_blend_factor_get(PointerRNA *ptr);
void SpaceImageEditor_blend_factor_set(PointerRNA *ptr, float value);

enum {
	SpaceImageEditor_display_channels_COLOR_ALPHA = 4096,
	SpaceImageEditor_display_channels_COLOR = 0,
	SpaceImageEditor_display_channels_ALPHA = 8192,
	SpaceImageEditor_display_channels_Z_BUFFER = 16384,
	SpaceImageEditor_display_channels_RED = 134217728,
	SpaceImageEditor_display_channels_GREEN = 268435456,
	SpaceImageEditor_display_channels_BLUE = 536870912,
};

int SpaceImageEditor_display_channels_get(PointerRNA *ptr);
void SpaceImageEditor_display_channels_set(PointerRNA *ptr, int value);

bool SpaceImageEditor_show_repeat_get(PointerRNA *ptr);
void SpaceImageEditor_show_repeat_set(PointerRNA *ptr, bool value);

enum {
	SpaceImageEditor_mask_display_type_OUTLINE = 0,
	SpaceImageEditor_mask_display_type_DASH = 1,
	SpaceImageEditor_mask_display_type_BLACK = 2,
	SpaceImageEditor_mask_display_type_WHITE = 3,
};

int SpaceImageEditor_mask_display_type_get(PointerRNA *ptr);
void SpaceImageEditor_mask_display_type_set(PointerRNA *ptr, int value);

PointerRNA SpaceImageEditor_grease_pencil_get(PointerRNA *ptr);

PointerRNA SpaceImageEditor_image_get(PointerRNA *ptr);

bool SpaceImageEditor_use_image_pin_get(PointerRNA *ptr);
void SpaceImageEditor_use_image_pin_set(PointerRNA *ptr, bool value);

PointerRNA SpaceImageEditor_image_user_get(PointerRNA *ptr);

PointerRNA SpaceImageEditor_sample_histogram_get(PointerRNA *ptr);

PointerRNA SpaceImageEditor_mask_get(PointerRNA *ptr);

enum {
	SpaceImageEditor_mode_VIEW = 0,
	SpaceImageEditor_mode_UV = 3,
	SpaceImageEditor_mode_PAINT = 1,
	SpaceImageEditor_mode_MASK = 2,
};

int SpaceImageEditor_mode_get(PointerRNA *ptr);
void SpaceImageEditor_mode_set(PointerRNA *ptr, int value);

enum {
	SpaceImageEditor_ui_mode_VIEW = 0,
	SpaceImageEditor_ui_mode_PAINT = 1,
	SpaceImageEditor_ui_mode_MASK = 2,
};

int SpaceImageEditor_ui_mode_get(PointerRNA *ptr);
void SpaceImageEditor_ui_mode_set(PointerRNA *ptr, int value);

bool SpaceImageEditor_show_gizmo_navigate_get(PointerRNA *ptr);
void SpaceImageEditor_show_gizmo_navigate_set(PointerRNA *ptr, bool value);

enum {
	SpaceImageEditor_mask_overlay_mode_ALPHACHANNEL = 0,
	SpaceImageEditor_mask_overlay_mode_COMBINED = 1,
};

int SpaceImageEditor_mask_overlay_mode_get(PointerRNA *ptr);
void SpaceImageEditor_mask_overlay_mode_set(PointerRNA *ptr, int value);

PointerRNA SpaceImageEditor_overlay_get(PointerRNA *ptr);

enum {
	SpaceImageEditor_pivot_point_BOUNDING_BOX_CENTER = 0,
	SpaceImageEditor_pivot_point_CURSOR = 1,
	SpaceImageEditor_pivot_point_INDIVIDUAL_ORIGINS = 2,
	SpaceImageEditor_pivot_point_MEDIAN_POINT = 3,
	SpaceImageEditor_pivot_point_ACTIVE_ELEMENT = 4,
};

int SpaceImageEditor_pivot_point_get(PointerRNA *ptr);
void SpaceImageEditor_pivot_point_set(PointerRNA *ptr, int value);

PointerRNA SpaceImageEditor_scopes_get(PointerRNA *ptr);

bool SpaceImageEditor_show_annotation_get(PointerRNA *ptr);
void SpaceImageEditor_show_annotation_set(PointerRNA *ptr, bool value);

bool SpaceImageEditor_show_gizmo_get(PointerRNA *ptr);
void SpaceImageEditor_show_gizmo_set(PointerRNA *ptr, bool value);

bool SpaceImageEditor_show_maskedit_get(PointerRNA *ptr);
void SpaceImageEditor_show_maskedit_set(PointerRNA *ptr, bool value);

bool SpaceImageEditor_show_mask_overlay_get(PointerRNA *ptr);
void SpaceImageEditor_show_mask_overlay_set(PointerRNA *ptr, bool value);

bool SpaceImageEditor_show_mask_spline_get(PointerRNA *ptr);
void SpaceImageEditor_show_mask_spline_set(PointerRNA *ptr, bool value);

bool SpaceImageEditor_show_paint_get(PointerRNA *ptr);
void SpaceImageEditor_show_paint_set(PointerRNA *ptr, bool value);

bool SpaceImageEditor_show_render_get(PointerRNA *ptr);
void SpaceImageEditor_show_render_set(PointerRNA *ptr, bool value);

bool SpaceImageEditor_show_stereo_3d_get(PointerRNA *ptr);
void SpaceImageEditor_show_stereo_3d_set(PointerRNA *ptr, bool value);

bool SpaceImageEditor_show_uvedit_get(PointerRNA *ptr);
void SpaceImageEditor_show_uvedit_set(PointerRNA *ptr, bool value);

bool SpaceImageEditor_show_region_ui_get(PointerRNA *ptr);
void SpaceImageEditor_show_region_ui_set(PointerRNA *ptr, bool value);

bool SpaceImageEditor_show_region_tool_header_get(PointerRNA *ptr);
void SpaceImageEditor_show_region_tool_header_set(PointerRNA *ptr, bool value);

bool SpaceImageEditor_show_region_toolbar_get(PointerRNA *ptr);
void SpaceImageEditor_show_region_toolbar_set(PointerRNA *ptr, bool value);

PointerRNA SpaceImageEditor_uv_editor_get(PointerRNA *ptr);

bool SpaceImageEditor_use_realtime_update_get(PointerRNA *ptr);
void SpaceImageEditor_use_realtime_update_set(PointerRNA *ptr, bool value);

void SpaceImageEditor_zoom_get(PointerRNA *ptr, float values[2]);
void SpaceImageEditor_zoom_set(PointerRNA *ptr, const float values[2]);

float SpaceImageEditor_zoom_percentage_get(PointerRNA *ptr);
void SpaceImageEditor_zoom_percentage_set(PointerRNA *ptr, float value);

/**************** Overlay Settings ****************/

extern StructRNA RNA_SpaceImageOverlay;

PointerRNA SpaceImageOverlay_rna_type_get(PointerRNA *ptr);

bool SpaceImageOverlay_show_grid_background_get(PointerRNA *ptr);
void SpaceImageOverlay_show_grid_background_set(PointerRNA *ptr, bool value);

float SpaceImageOverlay_passepartout_alpha_get(PointerRNA *ptr);
void SpaceImageOverlay_passepartout_alpha_set(PointerRNA *ptr, float value);

bool SpaceImageOverlay_show_render_size_get(PointerRNA *ptr);
void SpaceImageOverlay_show_render_size_set(PointerRNA *ptr, bool value);

bool SpaceImageOverlay_show_overlays_get(PointerRNA *ptr);
void SpaceImageOverlay_show_overlays_set(PointerRNA *ptr, bool value);

bool SpaceImageOverlay_show_text_info_get(PointerRNA *ptr);
void SpaceImageOverlay_show_text_info_set(PointerRNA *ptr, bool value);

/**************** Space Info ****************/

extern StructRNA RNA_SpaceInfo;
extern StructRNA RNA_Space;

bool SpaceInfo_show_report_debug_get(PointerRNA *ptr);
void SpaceInfo_show_report_debug_set(PointerRNA *ptr, bool value);

bool SpaceInfo_show_report_error_get(PointerRNA *ptr);
void SpaceInfo_show_report_error_set(PointerRNA *ptr, bool value);

bool SpaceInfo_show_report_info_get(PointerRNA *ptr);
void SpaceInfo_show_report_info_set(PointerRNA *ptr, bool value);

bool SpaceInfo_show_report_operator_get(PointerRNA *ptr);
void SpaceInfo_show_report_operator_set(PointerRNA *ptr, bool value);

bool SpaceInfo_show_report_warning_get(PointerRNA *ptr);
void SpaceInfo_show_report_warning_set(PointerRNA *ptr, bool value);

/**************** Space Nla Editor ****************/

extern StructRNA RNA_SpaceNLA;
extern StructRNA RNA_Space;

bool SpaceNLA_show_region_hud_get(PointerRNA *ptr);
void SpaceNLA_show_region_hud_set(PointerRNA *ptr, bool value);

bool SpaceNLA_show_region_channels_get(PointerRNA *ptr);
void SpaceNLA_show_region_channels_set(PointerRNA *ptr, bool value);

PointerRNA SpaceNLA_dopesheet_get(PointerRNA *ptr);

bool SpaceNLA_use_realtime_update_get(PointerRNA *ptr);
void SpaceNLA_use_realtime_update_set(PointerRNA *ptr, bool value);

bool SpaceNLA_show_strip_curves_get(PointerRNA *ptr);
void SpaceNLA_show_strip_curves_set(PointerRNA *ptr, bool value);

bool SpaceNLA_show_local_markers_get(PointerRNA *ptr);
void SpaceNLA_show_local_markers_set(PointerRNA *ptr, bool value);

bool SpaceNLA_show_markers_get(PointerRNA *ptr);
void SpaceNLA_show_markers_set(PointerRNA *ptr, bool value);

bool SpaceNLA_show_region_ui_get(PointerRNA *ptr);
void SpaceNLA_show_region_ui_set(PointerRNA *ptr, bool value);

bool SpaceNLA_show_seconds_get(PointerRNA *ptr);
void SpaceNLA_show_seconds_set(PointerRNA *ptr, bool value);

/**************** Space Node Editor ****************/

extern StructRNA RNA_SpaceNodeEditor;
extern StructRNA RNA_Space;

bool SpaceNodeEditor_show_gizmo_active_node_get(PointerRNA *ptr);
void SpaceNodeEditor_show_gizmo_active_node_set(PointerRNA *ptr, bool value);

enum {
	SpaceNodeEditor_insert_offset_direction_RIGHT = 0,
	SpaceNodeEditor_insert_offset_direction_LEFT = 1,
};

int SpaceNodeEditor_insert_offset_direction_get(PointerRNA *ptr);
void SpaceNodeEditor_insert_offset_direction_set(PointerRNA *ptr, int value);

bool SpaceNodeEditor_show_backdrop_get(PointerRNA *ptr);
void SpaceNodeEditor_show_backdrop_set(PointerRNA *ptr, bool value);

void SpaceNodeEditor_backdrop_offset_get(PointerRNA *ptr, float values[2]);
void SpaceNodeEditor_backdrop_offset_set(PointerRNA *ptr, const float values[2]);

float SpaceNodeEditor_backdrop_zoom_get(PointerRNA *ptr);
void SpaceNodeEditor_backdrop_zoom_set(PointerRNA *ptr, float value);

void SpaceNodeEditor_cursor_location_get(PointerRNA *ptr, float values[2]);
void SpaceNodeEditor_cursor_location_set(PointerRNA *ptr, const float values[2]);

enum {
	SpaceNodeEditor_backdrop_channels_COLOR_ALPHA = 8,
	SpaceNodeEditor_backdrop_channels_COLOR = 0,
	SpaceNodeEditor_backdrop_channels_ALPHA = 16,
	SpaceNodeEditor_backdrop_channels_RED = 128,
	SpaceNodeEditor_backdrop_channels_GREEN = 256,
	SpaceNodeEditor_backdrop_channels_BLUE = 512,
};

int SpaceNodeEditor_backdrop_channels_get(PointerRNA *ptr);
void SpaceNodeEditor_backdrop_channels_set(PointerRNA *ptr, int value);

PointerRNA SpaceNodeEditor_edit_tree_get(PointerRNA *ptr);

enum {
	SpaceNodeEditor_geometry_nodes_type_MODIFIER = 0,
	SpaceNodeEditor_geometry_nodes_type_TOOL = 1,
};

int SpaceNodeEditor_geometry_nodes_type_get(PointerRNA *ptr);
void SpaceNodeEditor_geometry_nodes_type_set(PointerRNA *ptr, int value);

PointerRNA SpaceNodeEditor_id_get(PointerRNA *ptr);

PointerRNA SpaceNodeEditor_id_from_get(PointerRNA *ptr);

PointerRNA SpaceNodeEditor_geometry_nodes_tool_tree_get(PointerRNA *ptr);

PointerRNA SpaceNodeEditor_node_tree_get(PointerRNA *ptr);

void SpaceNodeEditor_path_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SpaceNodeEditor_path_next(CollectionPropertyIterator *iter);
void SpaceNodeEditor_path_end(CollectionPropertyIterator *iter);
bool SpaceNodeEditor_path_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

PointerRNA SpaceNodeEditor_overlay_get(PointerRNA *ptr);

bool SpaceNodeEditor_pin_get(PointerRNA *ptr);
void SpaceNodeEditor_pin_set(PointerRNA *ptr, bool value);

enum {
	SpaceNodeEditor_shader_type_OBJECT = 0,
	SpaceNodeEditor_shader_type_WORLD = 1,
	SpaceNodeEditor_shader_type_LINESTYLE = 2,
};

int SpaceNodeEditor_shader_type_get(PointerRNA *ptr);
void SpaceNodeEditor_shader_type_set(PointerRNA *ptr, int value);

bool SpaceNodeEditor_show_annotation_get(PointerRNA *ptr);
void SpaceNodeEditor_show_annotation_set(PointerRNA *ptr, bool value);

bool SpaceNodeEditor_show_gizmo_get(PointerRNA *ptr);
void SpaceNodeEditor_show_gizmo_set(PointerRNA *ptr, bool value);

bool SpaceNodeEditor_show_region_ui_get(PointerRNA *ptr);
void SpaceNodeEditor_show_region_ui_set(PointerRNA *ptr, bool value);

bool SpaceNodeEditor_supports_previews_get(PointerRNA *ptr);
void SpaceNodeEditor_supports_previews_set(PointerRNA *ptr, bool value);

enum {
	SpaceNodeEditor_texture_type_WORLD = 1,
	SpaceNodeEditor_texture_type_BRUSH = 2,
	SpaceNodeEditor_texture_type_LINESTYLE = 3,
};

int SpaceNodeEditor_texture_type_get(PointerRNA *ptr);
void SpaceNodeEditor_texture_type_set(PointerRNA *ptr, int value);

bool SpaceNodeEditor_show_region_toolbar_get(PointerRNA *ptr);
void SpaceNodeEditor_show_region_toolbar_set(PointerRNA *ptr, bool value);

enum {
	SpaceNodeEditor_tree_type_DEFAULT = 0,
};

int SpaceNodeEditor_tree_type_get(PointerRNA *ptr);
void SpaceNodeEditor_tree_type_set(PointerRNA *ptr, int value);

void SpaceNodeEditor_cursor_location_from_region_func(struct SpaceNode *_self, bContext *C, int x, int y);
/**************** Path ****************/

extern StructRNA RNA_SpaceNodeEditorPath;

PointerRNA SpaceNodeEditorPath_rna_type_get(PointerRNA *ptr);

void SpaceNodeEditorPath_to_string_get(PointerRNA *ptr, char *value);
int SpaceNodeEditorPath_to_string_length(PointerRNA *ptr);
void SpaceNodeEditorPath_to_string_set(PointerRNA *ptr, const char *value);

void SpaceNodeEditorPath_clear_func(struct SpaceNode *_self, bContext *C);
void SpaceNodeEditorPath_start_func(struct SpaceNode *_self, bContext *C, struct PointerRNA *node_tree);
void SpaceNodeEditorPath_append_func(struct SpaceNode *_self, bContext *C, struct PointerRNA *node_tree, struct PointerRNA *node);
void SpaceNodeEditorPath_pop_func(struct SpaceNode *_self, bContext *C);
/**************** Overlay Settings ****************/

extern StructRNA RNA_SpaceNodeOverlay;

PointerRNA SpaceNodeOverlay_rna_type_get(PointerRNA *ptr);

enum {
	SpaceNodeOverlay_preview_shape_FLAT = 0,
	SpaceNodeOverlay_preview_shape_3D = 1,
};

int SpaceNodeOverlay_preview_shape_get(PointerRNA *ptr);
void SpaceNodeOverlay_preview_shape_set(PointerRNA *ptr, int value);

bool SpaceNodeOverlay_show_named_attributes_get(PointerRNA *ptr);
void SpaceNodeOverlay_show_named_attributes_set(PointerRNA *ptr, bool value);

bool SpaceNodeOverlay_show_previews_get(PointerRNA *ptr);
void SpaceNodeOverlay_show_previews_set(PointerRNA *ptr, bool value);

bool SpaceNodeOverlay_show_overlays_get(PointerRNA *ptr);
void SpaceNodeOverlay_show_overlays_set(PointerRNA *ptr, bool value);

bool SpaceNodeOverlay_show_reroute_auto_labels_get(PointerRNA *ptr);
void SpaceNodeOverlay_show_reroute_auto_labels_set(PointerRNA *ptr, bool value);

bool SpaceNodeOverlay_show_timing_get(PointerRNA *ptr);
void SpaceNodeOverlay_show_timing_set(PointerRNA *ptr, bool value);

bool SpaceNodeOverlay_show_context_path_get(PointerRNA *ptr);
void SpaceNodeOverlay_show_context_path_set(PointerRNA *ptr, bool value);

bool SpaceNodeOverlay_show_wire_color_get(PointerRNA *ptr);
void SpaceNodeOverlay_show_wire_color_set(PointerRNA *ptr, bool value);

/**************** Space Outliner ****************/

extern StructRNA RNA_SpaceOutliner;
extern StructRNA RNA_Space;

bool SpaceOutliner_use_filter_case_sensitive_get(PointerRNA *ptr);
void SpaceOutliner_use_filter_case_sensitive_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_use_filter_complete_get(PointerRNA *ptr);
void SpaceOutliner_use_filter_complete_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_show_restrict_column_render_get(PointerRNA *ptr);
void SpaceOutliner_show_restrict_column_render_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_show_restrict_column_viewport_get(PointerRNA *ptr);
void SpaceOutliner_show_restrict_column_viewport_set(PointerRNA *ptr, bool value);

#define SpaceOutliner_filter_text_MAX 64

void SpaceOutliner_filter_text_get(PointerRNA *ptr, char *value);
int SpaceOutliner_filter_text_length(PointerRNA *ptr);
void SpaceOutliner_filter_text_set(PointerRNA *ptr, const char *value);

enum {
	SpaceOutliner_display_mode_SCENES = 0,
	SpaceOutliner_display_mode_VIEW_LAYER = 15,
	SpaceOutliner_display_mode_SEQUENCE = 10,
	SpaceOutliner_display_mode_LIBRARIES = 7,
	SpaceOutliner_display_mode_DATA_API = 11,
	SpaceOutliner_display_mode_LIBRARY_OVERRIDES = 16,
	SpaceOutliner_display_mode_ORPHAN_DATA = 14,
};

int SpaceOutliner_display_mode_get(PointerRNA *ptr);
void SpaceOutliner_display_mode_set(PointerRNA *ptr, int value);

bool SpaceOutliner_show_restrict_column_enable_get(PointerRNA *ptr);
void SpaceOutliner_show_restrict_column_enable_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_use_filter_object_get(PointerRNA *ptr);
void SpaceOutliner_use_filter_object_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_use_filter_id_type_get(PointerRNA *ptr);
void SpaceOutliner_use_filter_id_type_set(PointerRNA *ptr, bool value);

enum {
	SpaceOutliner_filter_id_type_ACTION = 17217,
	SpaceOutliner_filter_id_type_ARMATURE = 21057,
	SpaceOutliner_filter_id_type_BRUSH = 21058,
	SpaceOutliner_filter_id_type_CACHEFILE = 17987,
	SpaceOutliner_filter_id_type_CAMERA = 16707,
	SpaceOutliner_filter_id_type_COLLECTION = 21063,
	SpaceOutliner_filter_id_type_CURVE = 21827,
	SpaceOutliner_filter_id_type_CURVES = 22083,
	SpaceOutliner_filter_id_type_FONT = 18006,
	SpaceOutliner_filter_id_type_GREASEPENCIL = 17479,
	SpaceOutliner_filter_id_type_GREASEPENCIL_V3 = 20551,
	SpaceOutliner_filter_id_type_IMAGE = 19785,
	SpaceOutliner_filter_id_type_KEY = 17739,
	SpaceOutliner_filter_id_type_LATTICE = 21580,
	SpaceOutliner_filter_id_type_LIBRARY = 18764,
	SpaceOutliner_filter_id_type_LIGHT = 16716,
	SpaceOutliner_filter_id_type_LIGHT_PROBE = 20556,
	SpaceOutliner_filter_id_type_LINESTYLE = 21324,
	SpaceOutliner_filter_id_type_MASK = 21325,
	SpaceOutliner_filter_id_type_MATERIAL = 16717,
	SpaceOutliner_filter_id_type_MESH = 17741,
	SpaceOutliner_filter_id_type_META = 16973,
	SpaceOutliner_filter_id_type_MOVIECLIP = 17229,
	SpaceOutliner_filter_id_type_NODETREE = 21582,
	SpaceOutliner_filter_id_type_OBJECT = 16975,
	SpaceOutliner_filter_id_type_PAINTCURVE = 17232,
	SpaceOutliner_filter_id_type_PALETTE = 19536,
	SpaceOutliner_filter_id_type_PARTICLE = 16720,
	SpaceOutliner_filter_id_type_POINTCLOUD = 21584,
	SpaceOutliner_filter_id_type_SCENE = 17235,
	SpaceOutliner_filter_id_type_SCREEN = 21075,
	SpaceOutliner_filter_id_type_SOUND = 20307,
	SpaceOutliner_filter_id_type_SPEAKER = 19283,
	SpaceOutliner_filter_id_type_TEXT = 22612,
	SpaceOutliner_filter_id_type_TEXTURE = 17748,
	SpaceOutliner_filter_id_type_VOLUME = 20310,
	SpaceOutliner_filter_id_type_WINDOWMANAGER = 19799,
	SpaceOutliner_filter_id_type_WORKSPACE = 21335,
	SpaceOutliner_filter_id_type_WORLD = 20311,
};

int SpaceOutliner_filter_id_type_get(PointerRNA *ptr);
void SpaceOutliner_filter_id_type_set(PointerRNA *ptr, int value);

bool SpaceOutliner_show_restrict_column_hide_get(PointerRNA *ptr);
void SpaceOutliner_show_restrict_column_hide_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_show_restrict_column_holdout_get(PointerRNA *ptr);
void SpaceOutliner_show_restrict_column_holdout_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_show_restrict_column_indirect_only_get(PointerRNA *ptr);
void SpaceOutliner_show_restrict_column_indirect_only_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_filter_invert_get(PointerRNA *ptr);
void SpaceOutliner_filter_invert_set(PointerRNA *ptr, bool value);

enum {
	SpaceOutliner_lib_override_view_mode_PROPERTIES = 0,
	SpaceOutliner_lib_override_view_mode_HIERARCHIES = 1,
};

int SpaceOutliner_lib_override_view_mode_get(PointerRNA *ptr);
void SpaceOutliner_lib_override_view_mode_set(PointerRNA *ptr, int value);

enum {
	SpaceOutliner_filter_state_ALL = 0,
	SpaceOutliner_filter_state_VISIBLE = 1,
	SpaceOutliner_filter_state_SELECTED = 3,
	SpaceOutliner_filter_state_ACTIVE = 4,
	SpaceOutliner_filter_state_SELECTABLE = 5,
};

int SpaceOutliner_filter_state_get(PointerRNA *ptr);
void SpaceOutliner_filter_state_set(PointerRNA *ptr, int value);

bool SpaceOutliner_show_restrict_column_select_get(PointerRNA *ptr);
void SpaceOutliner_show_restrict_column_select_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_use_filter_view_layers_get(PointerRNA *ptr);
void SpaceOutliner_use_filter_view_layers_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_use_filter_object_armature_get(PointerRNA *ptr);
void SpaceOutliner_use_filter_object_armature_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_use_filter_object_camera_get(PointerRNA *ptr);
void SpaceOutliner_use_filter_object_camera_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_use_filter_collection_get(PointerRNA *ptr);
void SpaceOutliner_use_filter_collection_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_use_filter_object_empty_get(PointerRNA *ptr);
void SpaceOutliner_use_filter_object_empty_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_use_filter_object_grease_pencil_get(PointerRNA *ptr);
void SpaceOutliner_use_filter_object_grease_pencil_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_use_filter_object_light_get(PointerRNA *ptr);
void SpaceOutliner_use_filter_object_light_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_use_filter_object_mesh_get(PointerRNA *ptr);
void SpaceOutliner_use_filter_object_mesh_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_show_mode_column_get(PointerRNA *ptr);
void SpaceOutliner_show_mode_column_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_use_filter_children_get(PointerRNA *ptr);
void SpaceOutliner_use_filter_children_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_use_filter_object_content_get(PointerRNA *ptr);
void SpaceOutliner_use_filter_object_content_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_use_filter_object_others_get(PointerRNA *ptr);
void SpaceOutliner_use_filter_object_others_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_use_filter_lib_override_system_get(PointerRNA *ptr);
void SpaceOutliner_use_filter_lib_override_system_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_use_sort_alpha_get(PointerRNA *ptr);
void SpaceOutliner_use_sort_alpha_set(PointerRNA *ptr, bool value);

bool SpaceOutliner_use_sync_select_get(PointerRNA *ptr);
void SpaceOutliner_use_sync_select_set(PointerRNA *ptr, bool value);

/**************** Space Preferences ****************/

extern StructRNA RNA_SpacePreferences;
extern StructRNA RNA_Space;

#define SpacePreferences_filter_text_MAX 64

void SpacePreferences_filter_text_get(PointerRNA *ptr, char *value);
int SpacePreferences_filter_text_length(PointerRNA *ptr);
void SpacePreferences_filter_text_set(PointerRNA *ptr, const char *value);

enum {
	SpacePreferences_filter_type_NAME = 0,
	SpacePreferences_filter_type_KEY = 1,
};

int SpacePreferences_filter_type_get(PointerRNA *ptr);
void SpacePreferences_filter_type_set(PointerRNA *ptr, int value);

/**************** Properties Space ****************/

extern StructRNA RNA_SpaceProperties;
extern StructRNA RNA_Space;

enum {
	SpaceProperties_context_TOOL = 14,
	SpaceProperties_context_SCENE = 1,
	SpaceProperties_context_RENDER = 0,
	SpaceProperties_context_OUTPUT = 16,
	SpaceProperties_context_VIEW_LAYER = 13,
	SpaceProperties_context_WORLD = 2,
	SpaceProperties_context_COLLECTION = 17,
	SpaceProperties_context_OBJECT = 3,
	SpaceProperties_context_CONSTRAINT = 11,
	SpaceProperties_context_MODIFIER = 10,
	SpaceProperties_context_DATA = 4,
	SpaceProperties_context_BONE = 9,
	SpaceProperties_context_BONE_CONSTRAINT = 12,
	SpaceProperties_context_MATERIAL = 5,
	SpaceProperties_context_TEXTURE = 6,
	SpaceProperties_context_PARTICLES = 7,
	SpaceProperties_context_PHYSICS = 8,
	SpaceProperties_context_SHADERFX = 15,
};

int SpaceProperties_context_get(PointerRNA *ptr);
void SpaceProperties_context_set(PointerRNA *ptr, int value);

bool SpaceProperties_show_properties_bone_get(PointerRNA *ptr);
void SpaceProperties_show_properties_bone_set(PointerRNA *ptr, bool value);

bool SpaceProperties_show_properties_bone_constraints_get(PointerRNA *ptr);
void SpaceProperties_show_properties_bone_constraints_set(PointerRNA *ptr, bool value);

bool SpaceProperties_show_properties_collection_get(PointerRNA *ptr);
void SpaceProperties_show_properties_collection_set(PointerRNA *ptr, bool value);

bool SpaceProperties_show_properties_constraints_get(PointerRNA *ptr);
void SpaceProperties_show_properties_constraints_set(PointerRNA *ptr, bool value);

bool SpaceProperties_show_properties_data_get(PointerRNA *ptr);
void SpaceProperties_show_properties_data_set(PointerRNA *ptr, bool value);

void SpaceProperties_search_filter_get(PointerRNA *ptr, char *value);
int SpaceProperties_search_filter_length(PointerRNA *ptr);
void SpaceProperties_search_filter_set(PointerRNA *ptr, const char *value);

bool SpaceProperties_show_properties_effects_get(PointerRNA *ptr);
void SpaceProperties_show_properties_effects_set(PointerRNA *ptr, bool value);

bool SpaceProperties_show_properties_material_get(PointerRNA *ptr);
void SpaceProperties_show_properties_material_set(PointerRNA *ptr, bool value);

bool SpaceProperties_show_properties_modifiers_get(PointerRNA *ptr);
void SpaceProperties_show_properties_modifiers_set(PointerRNA *ptr, bool value);

bool SpaceProperties_show_properties_object_get(PointerRNA *ptr);
void SpaceProperties_show_properties_object_set(PointerRNA *ptr, bool value);

enum {
	SpaceProperties_outliner_sync_ALWAYS = 2,
	SpaceProperties_outliner_sync_NEVER = 1,
	SpaceProperties_outliner_sync_AUTO = 0,
};

int SpaceProperties_outliner_sync_get(PointerRNA *ptr);
void SpaceProperties_outliner_sync_set(PointerRNA *ptr, int value);

bool SpaceProperties_show_properties_output_get(PointerRNA *ptr);
void SpaceProperties_show_properties_output_set(PointerRNA *ptr, bool value);

bool SpaceProperties_show_properties_particles_get(PointerRNA *ptr);
void SpaceProperties_show_properties_particles_set(PointerRNA *ptr, bool value);

bool SpaceProperties_show_properties_physics_get(PointerRNA *ptr);
void SpaceProperties_show_properties_physics_set(PointerRNA *ptr, bool value);

bool SpaceProperties_use_pin_id_get(PointerRNA *ptr);
void SpaceProperties_use_pin_id_set(PointerRNA *ptr, bool value);

bool SpaceProperties_show_properties_render_get(PointerRNA *ptr);
void SpaceProperties_show_properties_render_set(PointerRNA *ptr, bool value);

bool SpaceProperties_show_properties_scene_get(PointerRNA *ptr);
void SpaceProperties_show_properties_scene_set(PointerRNA *ptr, bool value);

void SpaceProperties_tab_search_results_get(PointerRNA *ptr, bool values[]);
void SpaceProperties_tab_search_results_set(PointerRNA *ptr, const bool values[]);
int SpaceProperties_tab_search_results_get_length(PointerRNA *ptr, int *arraylen);

bool SpaceProperties_show_properties_texture_get(PointerRNA *ptr);
void SpaceProperties_show_properties_texture_set(PointerRNA *ptr, bool value);

bool SpaceProperties_show_properties_tool_get(PointerRNA *ptr);
void SpaceProperties_show_properties_tool_set(PointerRNA *ptr, bool value);

bool SpaceProperties_show_properties_view_layer_get(PointerRNA *ptr);
void SpaceProperties_show_properties_view_layer_set(PointerRNA *ptr, bool value);

bool SpaceProperties_show_properties_world_get(PointerRNA *ptr);
void SpaceProperties_show_properties_world_set(PointerRNA *ptr, bool value);

PointerRNA SpaceProperties_pin_id_get(PointerRNA *ptr);

/**************** Space Sequence Editor ****************/

extern StructRNA RNA_SpaceSequenceEditor;
extern StructRNA RNA_Space;

void SpaceSequenceEditor_cursor_location_get(PointerRNA *ptr, float values[2]);
void SpaceSequenceEditor_cursor_location_set(PointerRNA *ptr, const float values[2]);

bool SpaceSequenceEditor_show_region_hud_get(PointerRNA *ptr);
void SpaceSequenceEditor_show_region_hud_set(PointerRNA *ptr, bool value);

PointerRNA SpaceSequenceEditor_cache_overlay_get(PointerRNA *ptr);

bool SpaceSequenceEditor_show_region_channels_get(PointerRNA *ptr);
void SpaceSequenceEditor_show_region_channels_set(PointerRNA *ptr, bool value);

bool SpaceSequenceEditor_show_gizmo_context_get(PointerRNA *ptr);
void SpaceSequenceEditor_show_gizmo_context_set(PointerRNA *ptr, bool value);

int SpaceSequenceEditor_display_channel_get(PointerRNA *ptr);
void SpaceSequenceEditor_display_channel_set(PointerRNA *ptr, int value);

enum {
	SpaceSequenceEditor_preview_channels_COLOR_ALPHA = 64,
	SpaceSequenceEditor_preview_channels_COLOR = 0,
};

int SpaceSequenceEditor_preview_channels_get(PointerRNA *ptr);
void SpaceSequenceEditor_preview_channels_set(PointerRNA *ptr, int value);

bool SpaceSequenceEditor_show_frames_get(PointerRNA *ptr);
void SpaceSequenceEditor_show_frames_set(PointerRNA *ptr, bool value);

enum {
	SpaceSequenceEditor_display_mode_IMAGE = 1,
	SpaceSequenceEditor_display_mode_WAVEFORM = 2,
	SpaceSequenceEditor_display_mode_RGB_PARADE = 5,
	SpaceSequenceEditor_display_mode_VECTOR_SCOPE = 3,
	SpaceSequenceEditor_display_mode_HISTOGRAM = 4,
};

int SpaceSequenceEditor_display_mode_get(PointerRNA *ptr);
void SpaceSequenceEditor_display_mode_set(PointerRNA *ptr, int value);

PointerRNA SpaceSequenceEditor_grease_pencil_get(PointerRNA *ptr);

bool SpaceSequenceEditor_use_clamp_view_get(PointerRNA *ptr);
void SpaceSequenceEditor_use_clamp_view_set(PointerRNA *ptr, bool value);

bool SpaceSequenceEditor_show_gizmo_navigate_get(PointerRNA *ptr);
void SpaceSequenceEditor_show_gizmo_navigate_set(PointerRNA *ptr, bool value);

enum {
	SpaceSequenceEditor_overlay_frame_type_RECTANGLE = 0,
	SpaceSequenceEditor_overlay_frame_type_REFERENCE = 1,
	SpaceSequenceEditor_overlay_frame_type_CURRENT = 2,
};

int SpaceSequenceEditor_overlay_frame_type_get(PointerRNA *ptr);
void SpaceSequenceEditor_overlay_frame_type_set(PointerRNA *ptr, int value);

PointerRNA SpaceSequenceEditor_preview_overlay_get(PointerRNA *ptr);

enum {
	SpaceSequenceEditor_proxy_render_size_NONE = -1,
	SpaceSequenceEditor_proxy_render_size_SCENE = 0,
	SpaceSequenceEditor_proxy_render_size_PROXY_25 = 25,
	SpaceSequenceEditor_proxy_render_size_PROXY_50 = 50,
	SpaceSequenceEditor_proxy_render_size_PROXY_75 = 75,
	SpaceSequenceEditor_proxy_render_size_PROXY_100 = 99,
};

int SpaceSequenceEditor_proxy_render_size_get(PointerRNA *ptr);
void SpaceSequenceEditor_proxy_render_size_set(PointerRNA *ptr, int value);

bool SpaceSequenceEditor_show_gizmo_get(PointerRNA *ptr);
void SpaceSequenceEditor_show_gizmo_set(PointerRNA *ptr, bool value);

bool SpaceSequenceEditor_show_markers_get(PointerRNA *ptr);
void SpaceSequenceEditor_show_markers_set(PointerRNA *ptr, bool value);

int SpaceSequenceEditor_show_overexposed_get(PointerRNA *ptr);
void SpaceSequenceEditor_show_overexposed_set(PointerRNA *ptr, int value);

bool SpaceSequenceEditor_show_overlays_get(PointerRNA *ptr);
void SpaceSequenceEditor_show_overlays_set(PointerRNA *ptr, bool value);

bool SpaceSequenceEditor_show_region_ui_get(PointerRNA *ptr);
void SpaceSequenceEditor_show_region_ui_set(PointerRNA *ptr, bool value);

bool SpaceSequenceEditor_use_marker_sync_get(PointerRNA *ptr);
void SpaceSequenceEditor_use_marker_sync_set(PointerRNA *ptr, bool value);

PointerRNA SpaceSequenceEditor_timeline_overlay_get(PointerRNA *ptr);

bool SpaceSequenceEditor_show_gizmo_tool_get(PointerRNA *ptr);
void SpaceSequenceEditor_show_gizmo_tool_set(PointerRNA *ptr, bool value);

bool SpaceSequenceEditor_show_region_tool_header_get(PointerRNA *ptr);
void SpaceSequenceEditor_show_region_tool_header_set(PointerRNA *ptr, bool value);

bool SpaceSequenceEditor_show_region_toolbar_get(PointerRNA *ptr);
void SpaceSequenceEditor_show_region_toolbar_set(PointerRNA *ptr, bool value);

bool SpaceSequenceEditor_show_transform_preview_get(PointerRNA *ptr);
void SpaceSequenceEditor_show_transform_preview_set(PointerRNA *ptr, bool value);

bool SpaceSequenceEditor_use_proxies_get(PointerRNA *ptr);
void SpaceSequenceEditor_use_proxies_set(PointerRNA *ptr, bool value);

bool SpaceSequenceEditor_show_seconds_get(PointerRNA *ptr);
void SpaceSequenceEditor_show_seconds_set(PointerRNA *ptr, bool value);

enum {
	SpaceSequenceEditor_view_type_SEQUENCER = 1,
	SpaceSequenceEditor_view_type_PREVIEW = 2,
	SpaceSequenceEditor_view_type_SEQUENCER_PREVIEW = 3,
};

int SpaceSequenceEditor_view_type_get(PointerRNA *ptr);
void SpaceSequenceEditor_view_type_set(PointerRNA *ptr, int value);

float SpaceSequenceEditor_zoom_percentage_get(PointerRNA *ptr);
void SpaceSequenceEditor_zoom_percentage_set(PointerRNA *ptr, float value);

bool SpaceSequenceEditor_use_zoom_to_fit_get(PointerRNA *ptr);
void SpaceSequenceEditor_use_zoom_to_fit_set(PointerRNA *ptr, bool value);

/**************** Space Spreadsheet ****************/

extern StructRNA RNA_SpaceSpreadsheet;
extern StructRNA RNA_Space;

enum {
	SpaceSpreadsheet_attribute_domain_POINT = 0,
	SpaceSpreadsheet_attribute_domain_EDGE = 1,
	SpaceSpreadsheet_attribute_domain_FACE = 2,
	SpaceSpreadsheet_attribute_domain_CORNER = 3,
	SpaceSpreadsheet_attribute_domain_CURVE = 4,
	SpaceSpreadsheet_attribute_domain_INSTANCE = 5,
	SpaceSpreadsheet_attribute_domain_LAYER = 6,
};

int SpaceSpreadsheet_attribute_domain_get(PointerRNA *ptr);
void SpaceSpreadsheet_attribute_domain_set(PointerRNA *ptr, int value);

bool SpaceSpreadsheet_show_region_channels_get(PointerRNA *ptr);
void SpaceSpreadsheet_show_region_channels_set(PointerRNA *ptr, bool value);

bool SpaceSpreadsheet_show_region_footer_get(PointerRNA *ptr);
void SpaceSpreadsheet_show_region_footer_set(PointerRNA *ptr, bool value);

enum {
	SpaceSpreadsheet_geometry_component_type_MESH = 0,
	SpaceSpreadsheet_geometry_component_type_POINTCLOUD = 1,
	SpaceSpreadsheet_geometry_component_type_CURVE = 4,
	SpaceSpreadsheet_geometry_component_type_INSTANCES = 2,
	SpaceSpreadsheet_geometry_component_type_GREASEPENCIL = 6,
};

int SpaceSpreadsheet_geometry_component_type_get(PointerRNA *ptr);
void SpaceSpreadsheet_geometry_component_type_set(PointerRNA *ptr, int value);

bool SpaceSpreadsheet_is_pinned_get(PointerRNA *ptr);
void SpaceSpreadsheet_is_pinned_set(PointerRNA *ptr, bool value);

enum {
	SpaceSpreadsheet_object_eval_state_EVALUATED = 0,
	SpaceSpreadsheet_object_eval_state_ORIGINAL = 1,
	SpaceSpreadsheet_object_eval_state_VIEWER_NODE = 2,
};

int SpaceSpreadsheet_object_eval_state_get(PointerRNA *ptr);
void SpaceSpreadsheet_object_eval_state_set(PointerRNA *ptr, int value);

void SpaceSpreadsheet_row_filters_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SpaceSpreadsheet_row_filters_next(CollectionPropertyIterator *iter);
void SpaceSpreadsheet_row_filters_end(CollectionPropertyIterator *iter);
bool SpaceSpreadsheet_row_filters_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool SpaceSpreadsheet_show_internal_attributes_get(PointerRNA *ptr);
void SpaceSpreadsheet_show_internal_attributes_set(PointerRNA *ptr, bool value);

bool SpaceSpreadsheet_show_only_selected_get(PointerRNA *ptr);
void SpaceSpreadsheet_show_only_selected_set(PointerRNA *ptr, bool value);

bool SpaceSpreadsheet_show_region_ui_get(PointerRNA *ptr);
void SpaceSpreadsheet_show_region_ui_set(PointerRNA *ptr, bool value);

void SpaceSpreadsheet_tables_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SpaceSpreadsheet_tables_next(CollectionPropertyIterator *iter);
void SpaceSpreadsheet_tables_end(CollectionPropertyIterator *iter);
int SpaceSpreadsheet_tables_length(PointerRNA *ptr);
bool SpaceSpreadsheet_tables_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool SpaceSpreadsheet_show_region_toolbar_get(PointerRNA *ptr);
void SpaceSpreadsheet_show_region_toolbar_set(PointerRNA *ptr, bool value);

bool SpaceSpreadsheet_use_filter_get(PointerRNA *ptr);
void SpaceSpreadsheet_use_filter_set(PointerRNA *ptr, bool value);

PointerRNA SpaceSpreadsheet_viewer_path_get(PointerRNA *ptr);

/**************** Space Text Editor ****************/

extern StructRNA RNA_SpaceTextEditor;
extern StructRNA RNA_Space;

bool SpaceTextEditor_use_find_all_get(PointerRNA *ptr);
void SpaceTextEditor_use_find_all_set(PointerRNA *ptr, bool value);

#define SpaceTextEditor_find_text_MAX 256

void SpaceTextEditor_find_text_get(PointerRNA *ptr, char *value);
int SpaceTextEditor_find_text_length(PointerRNA *ptr);
void SpaceTextEditor_find_text_set(PointerRNA *ptr, const char *value);

bool SpaceTextEditor_use_find_wrap_get(PointerRNA *ptr);
void SpaceTextEditor_use_find_wrap_set(PointerRNA *ptr, bool value);

int SpaceTextEditor_font_size_get(PointerRNA *ptr);
void SpaceTextEditor_font_size_set(PointerRNA *ptr, int value);

bool SpaceTextEditor_show_region_footer_get(PointerRNA *ptr);
void SpaceTextEditor_show_region_footer_set(PointerRNA *ptr, bool value);

bool SpaceTextEditor_show_line_highlight_get(PointerRNA *ptr);
void SpaceTextEditor_show_line_highlight_set(PointerRNA *ptr, bool value);

bool SpaceTextEditor_show_line_numbers_get(PointerRNA *ptr);
void SpaceTextEditor_show_line_numbers_set(PointerRNA *ptr, bool value);

bool SpaceTextEditor_use_live_edit_get(PointerRNA *ptr);
void SpaceTextEditor_use_live_edit_set(PointerRNA *ptr, bool value);

int SpaceTextEditor_margin_column_get(PointerRNA *ptr);
void SpaceTextEditor_margin_column_set(PointerRNA *ptr, int value);

bool SpaceTextEditor_use_match_case_get(PointerRNA *ptr);
void SpaceTextEditor_use_match_case_set(PointerRNA *ptr, bool value);

bool SpaceTextEditor_use_overwrite_get(PointerRNA *ptr);
void SpaceTextEditor_use_overwrite_set(PointerRNA *ptr, bool value);

#define SpaceTextEditor_replace_text_MAX 256

void SpaceTextEditor_replace_text_get(PointerRNA *ptr, char *value);
int SpaceTextEditor_replace_text_length(PointerRNA *ptr);
void SpaceTextEditor_replace_text_set(PointerRNA *ptr, const char *value);

bool SpaceTextEditor_show_margin_get(PointerRNA *ptr);
void SpaceTextEditor_show_margin_set(PointerRNA *ptr, bool value);

bool SpaceTextEditor_show_region_ui_get(PointerRNA *ptr);
void SpaceTextEditor_show_region_ui_set(PointerRNA *ptr, bool value);

bool SpaceTextEditor_show_syntax_highlight_get(PointerRNA *ptr);
void SpaceTextEditor_show_syntax_highlight_set(PointerRNA *ptr, bool value);

int SpaceTextEditor_tab_width_get(PointerRNA *ptr);
void SpaceTextEditor_tab_width_set(PointerRNA *ptr, int value);

PointerRNA SpaceTextEditor_text_get(PointerRNA *ptr);

int SpaceTextEditor_top_get(PointerRNA *ptr);
void SpaceTextEditor_top_set(PointerRNA *ptr, int value);

int SpaceTextEditor_visible_lines_get(PointerRNA *ptr);
void SpaceTextEditor_visible_lines_set(PointerRNA *ptr, int value);

bool SpaceTextEditor_show_word_wrap_get(PointerRNA *ptr);
void SpaceTextEditor_show_word_wrap_set(PointerRNA *ptr, bool value);

bool SpaceTextEditor_is_syntax_highlight_supported_func(struct SpaceText *_self);
void SpaceTextEditor_region_location_from_cursor_func(struct ID *_selfid, struct SpaceText *_self, int line, int column, int result[2]);
/**************** Space UV Editor ****************/

extern StructRNA RNA_SpaceUVEditor;

PointerRNA SpaceUVEditor_rna_type_get(PointerRNA *ptr);

bool SpaceUVEditor_lock_bounds_get(PointerRNA *ptr);
void SpaceUVEditor_lock_bounds_set(PointerRNA *ptr, bool value);

enum {
	SpaceUVEditor_edge_display_type_OUTLINE = 0,
	SpaceUVEditor_edge_display_type_DASH = 1,
	SpaceUVEditor_edge_display_type_BLACK = 2,
	SpaceUVEditor_edge_display_type_WHITE = 3,
};

int SpaceUVEditor_edge_display_type_get(PointerRNA *ptr);
void SpaceUVEditor_edge_display_type_set(PointerRNA *ptr, int value);

bool SpaceUVEditor_show_faces_get(PointerRNA *ptr);
void SpaceUVEditor_show_faces_set(PointerRNA *ptr, bool value);

bool SpaceUVEditor_show_modified_edges_get(PointerRNA *ptr);
void SpaceUVEditor_show_modified_edges_set(PointerRNA *ptr, bool value);

bool SpaceUVEditor_show_stretch_get(PointerRNA *ptr);
void SpaceUVEditor_show_stretch_set(PointerRNA *ptr, bool value);

enum {
	SpaceUVEditor_display_stretch_type_ANGLE = 0,
	SpaceUVEditor_display_stretch_type_AREA = 1,
};

int SpaceUVEditor_display_stretch_type_get(PointerRNA *ptr);
void SpaceUVEditor_display_stretch_type_set(PointerRNA *ptr, int value);

bool SpaceUVEditor_show_uv_get(PointerRNA *ptr);
void SpaceUVEditor_show_uv_set(PointerRNA *ptr, bool value);

void SpaceUVEditor_custom_grid_subdivisions_get(PointerRNA *ptr, int values[2]);
void SpaceUVEditor_custom_grid_subdivisions_set(PointerRNA *ptr, const int values[2]);

bool SpaceUVEditor_show_grid_over_image_get(PointerRNA *ptr);
void SpaceUVEditor_show_grid_over_image_set(PointerRNA *ptr, bool value);

enum {
	SpaceUVEditor_grid_shape_source_DYNAMIC = 0,
	SpaceUVEditor_grid_shape_source_FIXED = 1,
	SpaceUVEditor_grid_shape_source_PIXEL = 2,
};

int SpaceUVEditor_grid_shape_source_get(PointerRNA *ptr);
void SpaceUVEditor_grid_shape_source_set(PointerRNA *ptr, int value);

bool SpaceUVEditor_use_live_unwrap_get(PointerRNA *ptr);
void SpaceUVEditor_use_live_unwrap_set(PointerRNA *ptr, bool value);

bool SpaceUVEditor_show_pixel_coords_get(PointerRNA *ptr);
void SpaceUVEditor_show_pixel_coords_set(PointerRNA *ptr, bool value);

enum {
	SpaceUVEditor_pixel_round_mode_DISABLED = 0,
	SpaceUVEditor_pixel_round_mode_CORNER = 2,
	SpaceUVEditor_pixel_round_mode_CENTER = 1,
};

int SpaceUVEditor_pixel_round_mode_get(PointerRNA *ptr);
void SpaceUVEditor_pixel_round_mode_set(PointerRNA *ptr, int value);

bool SpaceUVEditor_show_metadata_get(PointerRNA *ptr);
void SpaceUVEditor_show_metadata_set(PointerRNA *ptr, bool value);

float SpaceUVEditor_stretch_opacity_get(PointerRNA *ptr);
void SpaceUVEditor_stretch_opacity_set(PointerRNA *ptr, float value);

void SpaceUVEditor_tile_grid_shape_get(PointerRNA *ptr, int values[2]);
void SpaceUVEditor_tile_grid_shape_set(PointerRNA *ptr, const int values[2]);

float SpaceUVEditor_uv_face_opacity_get(PointerRNA *ptr);
void SpaceUVEditor_uv_face_opacity_set(PointerRNA *ptr, float value);

float SpaceUVEditor_uv_opacity_get(PointerRNA *ptr);
void SpaceUVEditor_uv_opacity_set(PointerRNA *ptr, float value);

/**************** 3D View Space ****************/

extern StructRNA RNA_SpaceView3D;
extern StructRNA RNA_Space;

PointerRNA SpaceView3D_region_3d_get(PointerRNA *ptr);

bool SpaceView3D_show_region_hud_get(PointerRNA *ptr);
void SpaceView3D_show_region_hud_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_viewport_armature_get(PointerRNA *ptr);
void SpaceView3D_show_object_viewport_armature_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_select_armature_get(PointerRNA *ptr);
void SpaceView3D_show_object_select_armature_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_region_asset_shelf_get(PointerRNA *ptr);
void SpaceView3D_show_region_asset_shelf_set(PointerRNA *ptr, bool value);

PointerRNA SpaceView3D_camera_get(PointerRNA *ptr);

enum {
	SpaceView3D_stereo_3d_camera_LEFT = 0,
	SpaceView3D_stereo_3d_camera_RIGHT = 1,
	SpaceView3D_stereo_3d_camera_S3D = 2,
};

int SpaceView3D_stereo_3d_camera_get(PointerRNA *ptr);
void SpaceView3D_stereo_3d_camera_set(PointerRNA *ptr, int value);

bool SpaceView3D_show_object_viewport_camera_get(PointerRNA *ptr);
void SpaceView3D_show_object_viewport_camera_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_select_camera_get(PointerRNA *ptr);
void SpaceView3D_show_object_select_camera_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_stereo_3d_cameras_get(PointerRNA *ptr);
void SpaceView3D_show_stereo_3d_cameras_set(PointerRNA *ptr, bool value);

float SpaceView3D_clip_end_get(PointerRNA *ptr);
void SpaceView3D_clip_end_set(PointerRNA *ptr, float value);

float SpaceView3D_clip_start_get(PointerRNA *ptr);
void SpaceView3D_clip_start_set(PointerRNA *ptr, float value);

bool SpaceView3D_show_gizmo_context_get(PointerRNA *ptr);
void SpaceView3D_show_gizmo_context_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_viewport_curve_get(PointerRNA *ptr);
void SpaceView3D_show_object_viewport_curve_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_select_curve_get(PointerRNA *ptr);
void SpaceView3D_show_object_select_curve_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_viewport_empty_get(PointerRNA *ptr);
void SpaceView3D_show_object_viewport_empty_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_select_empty_get(PointerRNA *ptr);
void SpaceView3D_show_object_select_empty_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_viewport_font_get(PointerRNA *ptr);
void SpaceView3D_show_object_viewport_font_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_select_font_get(PointerRNA *ptr);
void SpaceView3D_show_object_select_font_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_viewport_grease_pencil_get(PointerRNA *ptr);
void SpaceView3D_show_object_viewport_grease_pencil_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_select_grease_pencil_get(PointerRNA *ptr);
void SpaceView3D_show_object_select_grease_pencil_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_viewport_curves_get(PointerRNA *ptr);
void SpaceView3D_show_object_viewport_curves_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_select_curves_get(PointerRNA *ptr);
void SpaceView3D_show_object_select_curves_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_viewport_lattice_get(PointerRNA *ptr);
void SpaceView3D_show_object_viewport_lattice_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_select_lattice_get(PointerRNA *ptr);
void SpaceView3D_show_object_select_lattice_set(PointerRNA *ptr, bool value);

float SpaceView3D_lens_get(PointerRNA *ptr);
void SpaceView3D_lens_set(PointerRNA *ptr, float value);

bool SpaceView3D_show_object_viewport_light_get(PointerRNA *ptr);
void SpaceView3D_show_object_viewport_light_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_select_light_get(PointerRNA *ptr);
void SpaceView3D_show_object_select_light_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_viewport_light_probe_get(PointerRNA *ptr);
void SpaceView3D_show_object_viewport_light_probe_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_select_light_probe_get(PointerRNA *ptr);
void SpaceView3D_show_object_select_light_probe_set(PointerRNA *ptr, bool value);

bool SpaceView3D_use_local_collections_get(PointerRNA *ptr);
void SpaceView3D_use_local_collections_set(PointerRNA *ptr, bool value);

PointerRNA SpaceView3D_local_view_get(PointerRNA *ptr);

bool SpaceView3D_lock_camera_get(PointerRNA *ptr);
void SpaceView3D_lock_camera_set(PointerRNA *ptr, bool value);

#define SpaceView3D_lock_bone_MAX 64

void SpaceView3D_lock_bone_get(PointerRNA *ptr, char *value);
int SpaceView3D_lock_bone_length(PointerRNA *ptr);
void SpaceView3D_lock_bone_set(PointerRNA *ptr, const char *value);

bool SpaceView3D_lock_cursor_get(PointerRNA *ptr);
void SpaceView3D_lock_cursor_set(PointerRNA *ptr, bool value);

PointerRNA SpaceView3D_lock_object_get(PointerRNA *ptr);

bool SpaceView3D_show_object_viewport_mesh_get(PointerRNA *ptr);
void SpaceView3D_show_object_viewport_mesh_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_select_mesh_get(PointerRNA *ptr);
void SpaceView3D_show_object_select_mesh_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_viewport_meta_get(PointerRNA *ptr);
void SpaceView3D_show_object_viewport_meta_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_select_meta_get(PointerRNA *ptr);
void SpaceView3D_show_object_select_meta_set(PointerRNA *ptr, bool value);

bool SpaceView3D_mirror_xr_session_get(PointerRNA *ptr);
void SpaceView3D_mirror_xr_session_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_gizmo_modifier_get(PointerRNA *ptr);
void SpaceView3D_show_gizmo_modifier_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_gizmo_navigate_get(PointerRNA *ptr);
void SpaceView3D_show_gizmo_navigate_set(PointerRNA *ptr, bool value);

PointerRNA SpaceView3D_overlay_get(PointerRNA *ptr);

bool SpaceView3D_show_stereo_3d_convergence_plane_get(PointerRNA *ptr);
void SpaceView3D_show_stereo_3d_convergence_plane_set(PointerRNA *ptr, bool value);

float SpaceView3D_stereo_3d_convergence_plane_alpha_get(PointerRNA *ptr);
void SpaceView3D_stereo_3d_convergence_plane_alpha_set(PointerRNA *ptr, float value);

bool SpaceView3D_show_object_viewport_pointcloud_get(PointerRNA *ptr);
void SpaceView3D_show_object_viewport_pointcloud_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_select_pointcloud_get(PointerRNA *ptr);
void SpaceView3D_show_object_select_pointcloud_set(PointerRNA *ptr, bool value);

void SpaceView3D_region_quadviews_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SpaceView3D_region_quadviews_next(CollectionPropertyIterator *iter);
void SpaceView3D_region_quadviews_end(CollectionPropertyIterator *iter);

float SpaceView3D_render_border_max_x_get(PointerRNA *ptr);
void SpaceView3D_render_border_max_x_set(PointerRNA *ptr, float value);

float SpaceView3D_render_border_max_y_get(PointerRNA *ptr);
void SpaceView3D_render_border_max_y_set(PointerRNA *ptr, float value);

float SpaceView3D_render_border_min_x_get(PointerRNA *ptr);
void SpaceView3D_render_border_min_x_set(PointerRNA *ptr, float value);

float SpaceView3D_render_border_min_y_get(PointerRNA *ptr);
void SpaceView3D_render_border_min_y_set(PointerRNA *ptr, float value);

bool SpaceView3D_use_render_border_get(PointerRNA *ptr);
void SpaceView3D_use_render_border_set(PointerRNA *ptr, bool value);

PointerRNA SpaceView3D_shading_get(PointerRNA *ptr);

bool SpaceView3D_show_bundle_names_get(PointerRNA *ptr);
void SpaceView3D_show_bundle_names_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_gizmo_camera_dof_distance_get(PointerRNA *ptr);
void SpaceView3D_show_gizmo_camera_dof_distance_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_gizmo_camera_lens_get(PointerRNA *ptr);
void SpaceView3D_show_gizmo_camera_lens_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_camera_path_get(PointerRNA *ptr);
void SpaceView3D_show_camera_path_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_gizmo_empty_force_field_get(PointerRNA *ptr);
void SpaceView3D_show_gizmo_empty_force_field_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_gizmo_empty_image_get(PointerRNA *ptr);
void SpaceView3D_show_gizmo_empty_image_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_gizmo_get(PointerRNA *ptr);
void SpaceView3D_show_gizmo_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_gizmo_light_look_at_get(PointerRNA *ptr);
void SpaceView3D_show_gizmo_light_look_at_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_gizmo_light_size_get(PointerRNA *ptr);
void SpaceView3D_show_gizmo_light_size_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_gizmo_object_translate_get(PointerRNA *ptr);
void SpaceView3D_show_gizmo_object_translate_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_gizmo_object_rotate_get(PointerRNA *ptr);
void SpaceView3D_show_gizmo_object_rotate_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_gizmo_object_scale_get(PointerRNA *ptr);
void SpaceView3D_show_gizmo_object_scale_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_reconstruction_get(PointerRNA *ptr);
void SpaceView3D_show_reconstruction_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_viewer_get(PointerRNA *ptr);
void SpaceView3D_show_viewer_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_region_ui_get(PointerRNA *ptr);
void SpaceView3D_show_region_ui_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_viewport_speaker_get(PointerRNA *ptr);
void SpaceView3D_show_object_viewport_speaker_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_select_speaker_get(PointerRNA *ptr);
void SpaceView3D_show_object_select_speaker_set(PointerRNA *ptr, bool value);

enum {
	SpaceView3D_stereo_3d_eye_LEFT_EYE = 0,
	SpaceView3D_stereo_3d_eye_RIGHT_EYE = 1,
};

int SpaceView3D_stereo_3d_eye_get(PointerRNA *ptr);
void SpaceView3D_stereo_3d_eye_set(PointerRNA *ptr, int value);

bool SpaceView3D_show_object_viewport_surf_get(PointerRNA *ptr);
void SpaceView3D_show_object_viewport_surf_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_select_surf_get(PointerRNA *ptr);
void SpaceView3D_show_object_select_surf_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_gizmo_tool_get(PointerRNA *ptr);
void SpaceView3D_show_gizmo_tool_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_region_tool_header_get(PointerRNA *ptr);
void SpaceView3D_show_region_tool_header_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_region_toolbar_get(PointerRNA *ptr);
void SpaceView3D_show_region_toolbar_set(PointerRNA *ptr, bool value);

enum {
	SpaceView3D_tracks_display_type_PLAIN_AXES = 2,
	SpaceView3D_tracks_display_type_ARROWS = 1,
	SpaceView3D_tracks_display_type_SINGLE_ARROW = 4,
	SpaceView3D_tracks_display_type_CIRCLE = 3,
	SpaceView3D_tracks_display_type_CUBE = 5,
	SpaceView3D_tracks_display_type_SPHERE = 6,
	SpaceView3D_tracks_display_type_CONE = 7,
};

int SpaceView3D_tracks_display_type_get(PointerRNA *ptr);
void SpaceView3D_tracks_display_type_set(PointerRNA *ptr, int value);

float SpaceView3D_tracks_display_size_get(PointerRNA *ptr);
void SpaceView3D_tracks_display_size_set(PointerRNA *ptr, float value);

bool SpaceView3D_use_local_camera_get(PointerRNA *ptr);
void SpaceView3D_use_local_camera_set(PointerRNA *ptr, bool value);

int SpaceView3D_icon_from_show_object_viewport_get(PointerRNA *ptr);
void SpaceView3D_icon_from_show_object_viewport_set(PointerRNA *ptr, int value);

bool SpaceView3D_show_stereo_3d_volume_get(PointerRNA *ptr);
void SpaceView3D_show_stereo_3d_volume_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_viewport_volume_get(PointerRNA *ptr);
void SpaceView3D_show_object_viewport_volume_set(PointerRNA *ptr, bool value);

bool SpaceView3D_show_object_select_volume_get(PointerRNA *ptr);
void SpaceView3D_show_object_select_volume_set(PointerRNA *ptr, bool value);

float SpaceView3D_stereo_3d_volume_alpha_get(PointerRNA *ptr);
void SpaceView3D_stereo_3d_volume_alpha_set(PointerRNA *ptr, float value);

/**************** Speaker ****************/

extern StructRNA RNA_Speaker;
extern StructRNA RNA_ID;

PointerRNA Speaker_animation_data_get(PointerRNA *ptr);

float Speaker_attenuation_get(PointerRNA *ptr);
void Speaker_attenuation_set(PointerRNA *ptr, float value);

float Speaker_cone_angle_inner_get(PointerRNA *ptr);
void Speaker_cone_angle_inner_set(PointerRNA *ptr, float value);

float Speaker_distance_max_get(PointerRNA *ptr);
void Speaker_distance_max_set(PointerRNA *ptr, float value);

float Speaker_volume_max_get(PointerRNA *ptr);
void Speaker_volume_max_set(PointerRNA *ptr, float value);

float Speaker_volume_min_get(PointerRNA *ptr);
void Speaker_volume_min_set(PointerRNA *ptr, float value);

bool Speaker_muted_get(PointerRNA *ptr);
void Speaker_muted_set(PointerRNA *ptr, bool value);

float Speaker_cone_angle_outer_get(PointerRNA *ptr);
void Speaker_cone_angle_outer_set(PointerRNA *ptr, float value);

float Speaker_cone_volume_outer_get(PointerRNA *ptr);
void Speaker_cone_volume_outer_set(PointerRNA *ptr, float value);

float Speaker_pitch_get(PointerRNA *ptr);
void Speaker_pitch_set(PointerRNA *ptr, float value);

float Speaker_distance_reference_get(PointerRNA *ptr);
void Speaker_distance_reference_set(PointerRNA *ptr, float value);

PointerRNA Speaker_sound_get(PointerRNA *ptr);

float Speaker_volume_get(PointerRNA *ptr);
void Speaker_volume_set(PointerRNA *ptr, float value);

/**************** SpeedControl Strip ****************/

extern StructRNA RNA_SpeedControlStrip;
extern StructRNA RNA_EffectStrip;
extern StructRNA RNA_Strip;

bool SpeedControlStrip_use_frame_interpolate_get(PointerRNA *ptr);
void SpeedControlStrip_use_frame_interpolate_set(PointerRNA *ptr, bool value);

float SpeedControlStrip_speed_frame_number_get(PointerRNA *ptr);
void SpeedControlStrip_speed_frame_number_set(PointerRNA *ptr, float value);

PointerRNA SpeedControlStrip_input_1_get(PointerRNA *ptr);

float SpeedControlStrip_speed_length_get(PointerRNA *ptr);
void SpeedControlStrip_speed_length_set(PointerRNA *ptr, float value);

float SpeedControlStrip_speed_factor_get(PointerRNA *ptr);
void SpeedControlStrip_speed_factor_set(PointerRNA *ptr, float value);

enum {
	SpeedControlStrip_speed_control_STRETCH = 0,
	SpeedControlStrip_speed_control_MULTIPLY = 1,
	SpeedControlStrip_speed_control_FRAME_NUMBER = 3,
	SpeedControlStrip_speed_control_LENGTH = 2,
};

int SpeedControlStrip_speed_control_get(PointerRNA *ptr);
void SpeedControlStrip_speed_control_set(PointerRNA *ptr, int value);

int SpeedControlStrip_input_count_get(PointerRNA *ptr);
void SpeedControlStrip_input_count_set(PointerRNA *ptr, int value);

/**************** Spline ****************/

extern StructRNA RNA_Spline;

PointerRNA Spline_rna_type_get(PointerRNA *ptr);

void Spline_bezier_points_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Spline_bezier_points_next(CollectionPropertyIterator *iter);
void Spline_bezier_points_end(CollectionPropertyIterator *iter);
int Spline_bezier_points_length(PointerRNA *ptr);
bool Spline_bezier_points_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool Spline_use_bezier_u_get(PointerRNA *ptr);
void Spline_use_bezier_u_set(PointerRNA *ptr, bool value);

bool Spline_use_bezier_v_get(PointerRNA *ptr);
void Spline_use_bezier_v_set(PointerRNA *ptr, bool value);

int Spline_character_index_get(PointerRNA *ptr);
void Spline_character_index_set(PointerRNA *ptr, int value);

bool Spline_use_cyclic_u_get(PointerRNA *ptr);
void Spline_use_cyclic_u_set(PointerRNA *ptr, bool value);

bool Spline_use_cyclic_v_get(PointerRNA *ptr);
void Spline_use_cyclic_v_set(PointerRNA *ptr, bool value);

bool Spline_use_endpoint_u_get(PointerRNA *ptr);
void Spline_use_endpoint_u_set(PointerRNA *ptr, bool value);

bool Spline_use_endpoint_v_get(PointerRNA *ptr);
void Spline_use_endpoint_v_set(PointerRNA *ptr, bool value);

bool Spline_hide_get(PointerRNA *ptr);
void Spline_hide_set(PointerRNA *ptr, bool value);

int Spline_material_index_get(PointerRNA *ptr);
void Spline_material_index_set(PointerRNA *ptr, int value);

int Spline_order_u_get(PointerRNA *ptr);
void Spline_order_u_set(PointerRNA *ptr, int value);

int Spline_order_v_get(PointerRNA *ptr);
void Spline_order_v_set(PointerRNA *ptr, int value);

void Spline_points_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Spline_points_next(CollectionPropertyIterator *iter);
void Spline_points_end(CollectionPropertyIterator *iter);
int Spline_points_length(PointerRNA *ptr);
bool Spline_points_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

int Spline_point_count_u_get(PointerRNA *ptr);
void Spline_point_count_u_set(PointerRNA *ptr, int value);

int Spline_point_count_v_get(PointerRNA *ptr);
void Spline_point_count_v_set(PointerRNA *ptr, int value);

enum {
	Spline_radius_interpolation_LINEAR = 0,
	Spline_radius_interpolation_CARDINAL = 1,
	Spline_radius_interpolation_BSPLINE = 2,
	Spline_radius_interpolation_EASE = 3,
};

int Spline_radius_interpolation_get(PointerRNA *ptr);
void Spline_radius_interpolation_set(PointerRNA *ptr, int value);

int Spline_resolution_u_get(PointerRNA *ptr);
void Spline_resolution_u_set(PointerRNA *ptr, int value);

int Spline_resolution_v_get(PointerRNA *ptr);
void Spline_resolution_v_set(PointerRNA *ptr, int value);

bool Spline_use_smooth_get(PointerRNA *ptr);
void Spline_use_smooth_set(PointerRNA *ptr, bool value);

enum {
	Spline_tilt_interpolation_LINEAR = 0,
	Spline_tilt_interpolation_CARDINAL = 1,
	Spline_tilt_interpolation_BSPLINE = 2,
	Spline_tilt_interpolation_EASE = 3,
};

int Spline_tilt_interpolation_get(PointerRNA *ptr);
void Spline_tilt_interpolation_set(PointerRNA *ptr, int value);

enum {
	Spline_type_POLY = 0,
	Spline_type_BEZIER = 1,
	Spline_type_NURBS = 4,
};

int Spline_type_get(PointerRNA *ptr);
void Spline_type_set(PointerRNA *ptr, int value);

float Spline_calc_length_func(struct Nurb *_self, int resolution);
void Spline_valid_message_func(struct Nurb *_self, int direction, int *result_num, const char * *result);
/**************** Spline Bézier Points ****************/

extern StructRNA RNA_SplineBezierPoints;

PointerRNA SplineBezierPoints_rna_type_get(PointerRNA *ptr);

void SplineBezierPoints_add_func(struct ID *_selfid, struct Nurb *_self, ReportList *reports, int count);
/**************** Spline IK Constraint ****************/

extern StructRNA RNA_SplineIKConstraint;
extern StructRNA RNA_Constraint;

int SplineIKConstraint_chain_count_get(PointerRNA *ptr);
void SplineIKConstraint_chain_count_set(PointerRNA *ptr, int value);

bool SplineIKConstraint_use_chain_offset_get(PointerRNA *ptr);
void SplineIKConstraint_use_chain_offset_set(PointerRNA *ptr, bool value);

bool SplineIKConstraint_use_even_divisions_get(PointerRNA *ptr);
void SplineIKConstraint_use_even_divisions_set(PointerRNA *ptr, bool value);

void SplineIKConstraint_joint_bindings_get(PointerRNA *ptr, float values[]);
void SplineIKConstraint_joint_bindings_set(PointerRNA *ptr, const float values[]);int SplineIKConstraint_joint_bindings_get_length(PointerRNA *ptr, int *arraylen);

PointerRNA SplineIKConstraint_target_get(PointerRNA *ptr);

bool SplineIKConstraint_use_curve_radius_get(PointerRNA *ptr);
void SplineIKConstraint_use_curve_radius_set(PointerRNA *ptr, bool value);

bool SplineIKConstraint_use_original_scale_get(PointerRNA *ptr);
void SplineIKConstraint_use_original_scale_set(PointerRNA *ptr, bool value);

bool SplineIKConstraint_use_bulge_max_get(PointerRNA *ptr);
void SplineIKConstraint_use_bulge_max_set(PointerRNA *ptr, bool value);

bool SplineIKConstraint_use_bulge_min_get(PointerRNA *ptr);
void SplineIKConstraint_use_bulge_min_set(PointerRNA *ptr, bool value);

float SplineIKConstraint_bulge_get(PointerRNA *ptr);
void SplineIKConstraint_bulge_set(PointerRNA *ptr, float value);

float SplineIKConstraint_bulge_max_get(PointerRNA *ptr);
void SplineIKConstraint_bulge_max_set(PointerRNA *ptr, float value);

float SplineIKConstraint_bulge_min_get(PointerRNA *ptr);
void SplineIKConstraint_bulge_min_set(PointerRNA *ptr, float value);

float SplineIKConstraint_bulge_smooth_get(PointerRNA *ptr);
void SplineIKConstraint_bulge_smooth_set(PointerRNA *ptr, float value);

enum {
	SplineIKConstraint_xz_scale_mode_NONE = 0,
	SplineIKConstraint_xz_scale_mode_BONE_ORIGINAL = 1,
	SplineIKConstraint_xz_scale_mode_INVERSE_PRESERVE = 2,
	SplineIKConstraint_xz_scale_mode_VOLUME_PRESERVE = 3,
};

int SplineIKConstraint_xz_scale_mode_get(PointerRNA *ptr);
void SplineIKConstraint_xz_scale_mode_set(PointerRNA *ptr, int value);

enum {
	SplineIKConstraint_y_scale_mode_NONE = 0,
	SplineIKConstraint_y_scale_mode_FIT_CURVE = 1,
	SplineIKConstraint_y_scale_mode_BONE_ORIGINAL = 2,
};

int SplineIKConstraint_y_scale_mode_get(PointerRNA *ptr);
void SplineIKConstraint_y_scale_mode_set(PointerRNA *ptr, int value);

/**************** SplinePoint ****************/

extern StructRNA RNA_SplinePoint;

PointerRNA SplinePoint_rna_type_get(PointerRNA *ptr);

float SplinePoint_radius_get(PointerRNA *ptr);
void SplinePoint_radius_set(PointerRNA *ptr, float value);

bool SplinePoint_hide_get(PointerRNA *ptr);
void SplinePoint_hide_set(PointerRNA *ptr, bool value);

void SplinePoint_co_get(PointerRNA *ptr, float values[4]);
void SplinePoint_co_set(PointerRNA *ptr, const float values[4]);

bool SplinePoint_select_get(PointerRNA *ptr);
void SplinePoint_select_set(PointerRNA *ptr, bool value);

float SplinePoint_tilt_get(PointerRNA *ptr);
void SplinePoint_tilt_set(PointerRNA *ptr, float value);

float SplinePoint_weight_get(PointerRNA *ptr);
void SplinePoint_weight_set(PointerRNA *ptr, float value);

float SplinePoint_weight_softbody_get(PointerRNA *ptr);
void SplinePoint_weight_softbody_set(PointerRNA *ptr, float value);

/**************** Spline Points ****************/

extern StructRNA RNA_SplinePoints;

PointerRNA SplinePoints_rna_type_get(PointerRNA *ptr);

void SplinePoints_add_func(struct ID *_selfid, struct Nurb *_self, ReportList *reports, int count);
/**************** Spot Light ****************/

extern StructRNA RNA_SpotLight;
extern StructRNA RNA_Light;
extern StructRNA RNA_ID;

bool SpotLight_use_absolute_resolution_get(PointerRNA *ptr);
void SpotLight_use_absolute_resolution_set(PointerRNA *ptr, bool value);

float SpotLight_energy_get(PointerRNA *ptr);
void SpotLight_energy_set(PointerRNA *ptr, float value);

float SpotLight_shadow_buffer_clip_start_get(PointerRNA *ptr);
void SpotLight_shadow_buffer_clip_start_set(PointerRNA *ptr, float value);

float SpotLight_shadow_filter_radius_get(PointerRNA *ptr);
void SpotLight_shadow_filter_radius_set(PointerRNA *ptr, float value);

bool SpotLight_use_shadow_jitter_get(PointerRNA *ptr);
void SpotLight_use_shadow_jitter_set(PointerRNA *ptr, bool value);

float SpotLight_shadow_jitter_overblur_get(PointerRNA *ptr);
void SpotLight_shadow_jitter_overblur_set(PointerRNA *ptr, float value);

float SpotLight_shadow_soft_size_get(PointerRNA *ptr);
void SpotLight_shadow_soft_size_set(PointerRNA *ptr, float value);

float SpotLight_shadow_maximum_resolution_get(PointerRNA *ptr);
void SpotLight_shadow_maximum_resolution_set(PointerRNA *ptr, float value);

bool SpotLight_show_cone_get(PointerRNA *ptr);
void SpotLight_show_cone_set(PointerRNA *ptr, bool value);

bool SpotLight_use_soft_falloff_get(PointerRNA *ptr);
void SpotLight_use_soft_falloff_set(PointerRNA *ptr, bool value);

float SpotLight_spot_blend_get(PointerRNA *ptr);
void SpotLight_spot_blend_set(PointerRNA *ptr, float value);

float SpotLight_spot_size_get(PointerRNA *ptr);
void SpotLight_spot_size_set(PointerRNA *ptr, float value);

bool SpotLight_use_square_get(PointerRNA *ptr);
void SpotLight_use_square_set(PointerRNA *ptr, bool value);

/**************** Spreadsheet Column ****************/

extern StructRNA RNA_SpreadsheetColumn;

PointerRNA SpreadsheetColumn_rna_type_get(PointerRNA *ptr);

enum {
	SpreadsheetColumn_data_type_INT32 = 1,
	SpreadsheetColumn_data_type_FLOAT = 2,
	SpreadsheetColumn_data_type_BOOLEAN = 0,
	SpreadsheetColumn_data_type_INSTANCES = 6,
};

int SpreadsheetColumn_data_type_get(PointerRNA *ptr);
void SpreadsheetColumn_data_type_set(PointerRNA *ptr, int value);

PointerRNA SpreadsheetColumn_id_get(PointerRNA *ptr);

/**************** Spreadsheet Column ID ****************/

extern StructRNA RNA_SpreadsheetColumnID;

PointerRNA SpreadsheetColumnID_rna_type_get(PointerRNA *ptr);

void SpreadsheetColumnID_name_get(PointerRNA *ptr, char *value);
int SpreadsheetColumnID_name_length(PointerRNA *ptr);
void SpreadsheetColumnID_name_set(PointerRNA *ptr, const char *value);

/**************** Spreadsheet Row Filter ****************/

extern StructRNA RNA_SpreadsheetRowFilter;

PointerRNA SpreadsheetRowFilter_rna_type_get(PointerRNA *ptr);

void SpreadsheetRowFilter_value_float2_get(PointerRNA *ptr, float values[2]);
void SpreadsheetRowFilter_value_float2_set(PointerRNA *ptr, const float values[2]);

void SpreadsheetRowFilter_value_int2_get(PointerRNA *ptr, int values[2]);
void SpreadsheetRowFilter_value_int2_set(PointerRNA *ptr, const int values[2]);

int SpreadsheetRowFilter_value_int8_get(PointerRNA *ptr);
void SpreadsheetRowFilter_value_int8_set(PointerRNA *ptr, int value);

bool SpreadsheetRowFilter_value_boolean_get(PointerRNA *ptr);
void SpreadsheetRowFilter_value_boolean_set(PointerRNA *ptr, bool value);

void SpreadsheetRowFilter_value_color_get(PointerRNA *ptr, float values[4]);
void SpreadsheetRowFilter_value_color_set(PointerRNA *ptr, const float values[4]);

#define SpreadsheetRowFilter_column_name_MAX 64

void SpreadsheetRowFilter_column_name_get(PointerRNA *ptr, char *value);
int SpreadsheetRowFilter_column_name_length(PointerRNA *ptr);
void SpreadsheetRowFilter_column_name_set(PointerRNA *ptr, const char *value);

bool SpreadsheetRowFilter_enabled_get(PointerRNA *ptr);
void SpreadsheetRowFilter_enabled_set(PointerRNA *ptr, bool value);

float SpreadsheetRowFilter_value_float_get(PointerRNA *ptr);
void SpreadsheetRowFilter_value_float_set(PointerRNA *ptr, float value);

int SpreadsheetRowFilter_value_int_get(PointerRNA *ptr);
void SpreadsheetRowFilter_value_int_set(PointerRNA *ptr, int value);

enum {
	SpreadsheetRowFilter_operation_EQUAL = 0,
	SpreadsheetRowFilter_operation_GREATER = 1,
	SpreadsheetRowFilter_operation_LESS = 2,
};

int SpreadsheetRowFilter_operation_get(PointerRNA *ptr);
void SpreadsheetRowFilter_operation_set(PointerRNA *ptr, int value);

bool SpreadsheetRowFilter_show_expanded_get(PointerRNA *ptr);
void SpreadsheetRowFilter_show_expanded_set(PointerRNA *ptr, bool value);

void SpreadsheetRowFilter_value_string_get(PointerRNA *ptr, char *value);
int SpreadsheetRowFilter_value_string_length(PointerRNA *ptr);
void SpreadsheetRowFilter_value_string_set(PointerRNA *ptr, const char *value);

float SpreadsheetRowFilter_threshold_get(PointerRNA *ptr);
void SpreadsheetRowFilter_threshold_set(PointerRNA *ptr, float value);

void SpreadsheetRowFilter_value_float3_get(PointerRNA *ptr, float values[3]);
void SpreadsheetRowFilter_value_float3_set(PointerRNA *ptr, const float values[3]);

/**************** Spreadsheet Table ****************/

extern StructRNA RNA_SpreadsheetTable;

PointerRNA SpreadsheetTable_rna_type_get(PointerRNA *ptr);

void SpreadsheetTable_columns_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void SpreadsheetTable_columns_next(CollectionPropertyIterator *iter);
void SpreadsheetTable_columns_end(CollectionPropertyIterator *iter);
int SpreadsheetTable_columns_length(PointerRNA *ptr);
bool SpreadsheetTable_columns_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

PointerRNA SpreadsheetTable_id_get(PointerRNA *ptr);

/**************** Spreadsheet Table ID ****************/

extern StructRNA RNA_SpreadsheetTableID;

PointerRNA SpreadsheetTableID_rna_type_get(PointerRNA *ptr);

enum {
	SpreadsheetTableID_type_GEOMETRY = 0,
};

int SpreadsheetTableID_type_get(PointerRNA *ptr);
void SpreadsheetTableID_type_set(PointerRNA *ptr, int value);

/**************** SpreadsheetTableIDGeometry ****************/

extern StructRNA RNA_SpreadsheetTableIDGeometry;
extern StructRNA RNA_SpreadsheetTableID;

enum {
	SpreadsheetTableIDGeometry_attribute_domain_POINT = 0,
	SpreadsheetTableIDGeometry_attribute_domain_EDGE = 1,
	SpreadsheetTableIDGeometry_attribute_domain_FACE = 2,
	SpreadsheetTableIDGeometry_attribute_domain_CORNER = 3,
	SpreadsheetTableIDGeometry_attribute_domain_CURVE = 4,
	SpreadsheetTableIDGeometry_attribute_domain_INSTANCE = 5,
	SpreadsheetTableIDGeometry_attribute_domain_LAYER = 6,
};

int SpreadsheetTableIDGeometry_attribute_domain_get(PointerRNA *ptr);
void SpreadsheetTableIDGeometry_attribute_domain_set(PointerRNA *ptr, int value);

enum {
	SpreadsheetTableIDGeometry_geometry_component_type_MESH = 0,
	SpreadsheetTableIDGeometry_geometry_component_type_POINTCLOUD = 1,
	SpreadsheetTableIDGeometry_geometry_component_type_CURVE = 4,
	SpreadsheetTableIDGeometry_geometry_component_type_INSTANCES = 2,
	SpreadsheetTableIDGeometry_geometry_component_type_GREASEPENCIL = 6,
};

int SpreadsheetTableIDGeometry_geometry_component_type_get(PointerRNA *ptr);
void SpreadsheetTableIDGeometry_geometry_component_type_set(PointerRNA *ptr, int value);

int SpreadsheetTableIDGeometry_layer_index_get(PointerRNA *ptr);
void SpreadsheetTableIDGeometry_layer_index_set(PointerRNA *ptr, int value);

enum {
	SpreadsheetTableIDGeometry_object_eval_state_EVALUATED = 0,
	SpreadsheetTableIDGeometry_object_eval_state_ORIGINAL = 1,
	SpreadsheetTableIDGeometry_object_eval_state_VIEWER_NODE = 2,
};

int SpreadsheetTableIDGeometry_object_eval_state_get(PointerRNA *ptr);
void SpreadsheetTableIDGeometry_object_eval_state_set(PointerRNA *ptr, int value);

PointerRNA SpreadsheetTableIDGeometry_viewer_path_get(PointerRNA *ptr);

/**************** Spreadsheet Tables ****************/

extern StructRNA RNA_SpreadsheetTables;

PointerRNA SpreadsheetTables_rna_type_get(PointerRNA *ptr);

PointerRNA SpreadsheetTables_active_get(PointerRNA *ptr);

/**************** Stereo 3D Display ****************/

extern StructRNA RNA_Stereo3dDisplay;

PointerRNA Stereo3dDisplay_rna_type_get(PointerRNA *ptr);

enum {
	Stereo3dDisplay_anaglyph_type_RED_CYAN = 0,
	Stereo3dDisplay_anaglyph_type_GREEN_MAGENTA = 1,
	Stereo3dDisplay_anaglyph_type_YELLOW_BLUE = 2,
};

int Stereo3dDisplay_anaglyph_type_get(PointerRNA *ptr);
void Stereo3dDisplay_anaglyph_type_set(PointerRNA *ptr, int value);

bool Stereo3dDisplay_use_sidebyside_crosseyed_get(PointerRNA *ptr);
void Stereo3dDisplay_use_sidebyside_crosseyed_set(PointerRNA *ptr, bool value);

enum {
	Stereo3dDisplay_display_mode_ANAGLYPH = 0,
	Stereo3dDisplay_display_mode_INTERLACE = 1,
	Stereo3dDisplay_display_mode_TIMESEQUENTIAL = 2,
	Stereo3dDisplay_display_mode_SIDEBYSIDE = 3,
	Stereo3dDisplay_display_mode_TOPBOTTOM = 4,
};

int Stereo3dDisplay_display_mode_get(PointerRNA *ptr);
void Stereo3dDisplay_display_mode_set(PointerRNA *ptr, int value);

enum {
	Stereo3dDisplay_interlace_type_ROW_INTERLEAVED = 0,
	Stereo3dDisplay_interlace_type_COLUMN_INTERLEAVED = 1,
	Stereo3dDisplay_interlace_type_CHECKERBOARD_INTERLEAVED = 2,
};

int Stereo3dDisplay_interlace_type_get(PointerRNA *ptr);
void Stereo3dDisplay_interlace_type_set(PointerRNA *ptr, int value);

bool Stereo3dDisplay_use_interlace_swap_get(PointerRNA *ptr);
void Stereo3dDisplay_use_interlace_swap_set(PointerRNA *ptr, bool value);

/**************** Stereo Output ****************/

extern StructRNA RNA_Stereo3dFormat;

PointerRNA Stereo3dFormat_rna_type_get(PointerRNA *ptr);

enum {
	Stereo3dFormat_anaglyph_type_RED_CYAN = 0,
	Stereo3dFormat_anaglyph_type_GREEN_MAGENTA = 1,
	Stereo3dFormat_anaglyph_type_YELLOW_BLUE = 2,
};

int Stereo3dFormat_anaglyph_type_get(PointerRNA *ptr);
void Stereo3dFormat_anaglyph_type_set(PointerRNA *ptr, int value);

bool Stereo3dFormat_use_sidebyside_crosseyed_get(PointerRNA *ptr);
void Stereo3dFormat_use_sidebyside_crosseyed_set(PointerRNA *ptr, bool value);

enum {
	Stereo3dFormat_interlace_type_ROW_INTERLEAVED = 0,
	Stereo3dFormat_interlace_type_COLUMN_INTERLEAVED = 1,
	Stereo3dFormat_interlace_type_CHECKERBOARD_INTERLEAVED = 2,
};

int Stereo3dFormat_interlace_type_get(PointerRNA *ptr);
void Stereo3dFormat_interlace_type_set(PointerRNA *ptr, int value);

bool Stereo3dFormat_use_squeezed_frame_get(PointerRNA *ptr);
void Stereo3dFormat_use_squeezed_frame_set(PointerRNA *ptr, bool value);

enum {
	Stereo3dFormat_display_mode_ANAGLYPH = 0,
	Stereo3dFormat_display_mode_INTERLACE = 1,
	Stereo3dFormat_display_mode_SIDEBYSIDE = 3,
	Stereo3dFormat_display_mode_TOPBOTTOM = 4,
};

int Stereo3dFormat_display_mode_get(PointerRNA *ptr);
void Stereo3dFormat_display_mode_set(PointerRNA *ptr, int value);

bool Stereo3dFormat_use_interlace_swap_get(PointerRNA *ptr);
void Stereo3dFormat_use_interlace_swap_set(PointerRNA *ptr, bool value);

/**************** Stretch To Constraint ****************/

extern StructRNA RNA_StretchToConstraint;
extern StructRNA RNA_Constraint;

bool StretchToConstraint_use_bbone_shape_get(PointerRNA *ptr);
void StretchToConstraint_use_bbone_shape_set(PointerRNA *ptr, bool value);

float StretchToConstraint_head_tail_get(PointerRNA *ptr);
void StretchToConstraint_head_tail_set(PointerRNA *ptr, float value);

enum {
	StretchToConstraint_keep_axis_PLANE_X = 0,
	StretchToConstraint_keep_axis_PLANE_Z = 2,
	StretchToConstraint_keep_axis_SWING_Y = 1,
};

int StretchToConstraint_keep_axis_get(PointerRNA *ptr);
void StretchToConstraint_keep_axis_set(PointerRNA *ptr, int value);

enum {
	StretchToConstraint_volume_VOLUME_XZX = 0,
	StretchToConstraint_volume_VOLUME_X = 1,
	StretchToConstraint_volume_VOLUME_Z = 2,
	StretchToConstraint_volume_NO_VOLUME = 3,
};

int StretchToConstraint_volume_get(PointerRNA *ptr);
void StretchToConstraint_volume_set(PointerRNA *ptr, int value);

float StretchToConstraint_rest_length_get(PointerRNA *ptr);
void StretchToConstraint_rest_length_set(PointerRNA *ptr, float value);

#define StretchToConstraint_subtarget_MAX 64

void StretchToConstraint_subtarget_get(PointerRNA *ptr, char *value);
int StretchToConstraint_subtarget_length(PointerRNA *ptr);
void StretchToConstraint_subtarget_set(PointerRNA *ptr, const char *value);

PointerRNA StretchToConstraint_target_get(PointerRNA *ptr);

bool StretchToConstraint_use_bulge_max_get(PointerRNA *ptr);
void StretchToConstraint_use_bulge_max_set(PointerRNA *ptr, bool value);

bool StretchToConstraint_use_bulge_min_get(PointerRNA *ptr);
void StretchToConstraint_use_bulge_min_set(PointerRNA *ptr, bool value);

float StretchToConstraint_bulge_get(PointerRNA *ptr);
void StretchToConstraint_bulge_set(PointerRNA *ptr, float value);

float StretchToConstraint_bulge_max_get(PointerRNA *ptr);
void StretchToConstraint_bulge_max_set(PointerRNA *ptr, float value);

float StretchToConstraint_bulge_min_get(PointerRNA *ptr);
void StretchToConstraint_bulge_min_set(PointerRNA *ptr, float value);

float StretchToConstraint_bulge_smooth_get(PointerRNA *ptr);
void StretchToConstraint_bulge_smooth_set(PointerRNA *ptr, float value);

/**************** String Attribute ****************/

extern StructRNA RNA_StringAttribute;
extern StructRNA RNA_Attribute;

void StringAttribute_data_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void StringAttribute_data_next(CollectionPropertyIterator *iter);
void StringAttribute_data_end(CollectionPropertyIterator *iter);
int StringAttribute_data_length(PointerRNA *ptr);
bool StringAttribute_data_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** String Attribute Value ****************/

extern StructRNA RNA_StringAttributeValue;

PointerRNA StringAttributeValue_rna_type_get(PointerRNA *ptr);

#define StringAttributeValue_value_MAX 255

void StringAttributeValue_value_get(PointerRNA *ptr, char *value);
int StringAttributeValue_value_length(PointerRNA *ptr);
void StringAttributeValue_value_set(PointerRNA *ptr, const char *value);

/**************** String Definition ****************/

extern StructRNA RNA_StringProperty;
extern StructRNA RNA_Property;

void StringProperty_default_value_get(PointerRNA *ptr, char *value);
int StringProperty_default_value_length(PointerRNA *ptr);
void StringProperty_default_value_set(PointerRNA *ptr, const char *value);

int StringProperty_length_max_get(PointerRNA *ptr);
void StringProperty_length_max_set(PointerRNA *ptr, int value);

/**************** Strip ****************/

extern StructRNA RNA_Strip;

PointerRNA Strip_rna_type_get(PointerRNA *ptr);

#define Strip_name_MAX 62

void Strip_name_get(PointerRNA *ptr, char *value);
int Strip_name_length(PointerRNA *ptr);
void Strip_name_set(PointerRNA *ptr, const char *value);

float Strip_blend_alpha_get(PointerRNA *ptr);
void Strip_blend_alpha_set(PointerRNA *ptr, float value);

enum {
	Strip_blend_type_REPLACE = 0,
	Strip_blend_type_CROSS = 8,
	Strip_blend_type_DARKEN = 46,
	Strip_blend_type_MULTIPLY = 14,
	Strip_blend_type_BURN = 47,
	Strip_blend_type_LINEAR_BURN = 48,
	Strip_blend_type_LIGHTEN = 44,
	Strip_blend_type_SCREEN = 43,
	Strip_blend_type_DODGE = 45,
	Strip_blend_type_ADD = 9,
	Strip_blend_type_OVERLAY = 49,
	Strip_blend_type_SOFT_LIGHT = 51,
	Strip_blend_type_HARD_LIGHT = 50,
	Strip_blend_type_VIVID_LIGHT = 54,
	Strip_blend_type_LINEAR_LIGHT = 53,
	Strip_blend_type_PIN_LIGHT = 52,
	Strip_blend_type_DIFFERENCE = 59,
	Strip_blend_type_EXCLUSION = 60,
	Strip_blend_type_SUBTRACT = 10,
	Strip_blend_type_HUE = 55,
	Strip_blend_type_SATURATION = 56,
	Strip_blend_type_COLOR = 58,
	Strip_blend_type_VALUE = 57,
	Strip_blend_type_ALPHA_OVER = 11,
	Strip_blend_type_ALPHA_UNDER = 12,
	Strip_blend_type_GAMMA_CROSS = 13,
};

int Strip_blend_type_get(PointerRNA *ptr);
void Strip_blend_type_set(PointerRNA *ptr, int value);

int Strip_channel_get(PointerRNA *ptr);
void Strip_channel_set(PointerRNA *ptr, int value);

float Strip_effect_fader_get(PointerRNA *ptr);
void Strip_effect_fader_set(PointerRNA *ptr, float value);

int Strip_frame_final_end_get(PointerRNA *ptr);
void Strip_frame_final_end_set(PointerRNA *ptr, int value);

float Strip_frame_offset_end_get(PointerRNA *ptr);
void Strip_frame_offset_end_set(PointerRNA *ptr, float value);

bool Strip_select_left_handle_get(PointerRNA *ptr);
void Strip_select_left_handle_set(PointerRNA *ptr, bool value);

int Strip_frame_final_duration_get(PointerRNA *ptr);
void Strip_frame_final_duration_set(PointerRNA *ptr, int value);

int Strip_frame_duration_get(PointerRNA *ptr);
void Strip_frame_duration_set(PointerRNA *ptr, int value);

bool Strip_lock_get(PointerRNA *ptr);
void Strip_lock_set(PointerRNA *ptr, bool value);

void Strip_modifiers_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Strip_modifiers_next(CollectionPropertyIterator *iter);
void Strip_modifiers_end(CollectionPropertyIterator *iter);
bool Strip_modifiers_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Strip_modifiers_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool Strip_mute_get(PointerRNA *ptr);
void Strip_mute_set(PointerRNA *ptr, bool value);

bool Strip_select_right_handle_get(PointerRNA *ptr);
void Strip_select_right_handle_set(PointerRNA *ptr, bool value);

bool Strip_select_get(PointerRNA *ptr);
void Strip_select_set(PointerRNA *ptr, bool value);

bool Strip_show_retiming_keys_get(PointerRNA *ptr);
void Strip_show_retiming_keys_set(PointerRNA *ptr, bool value);

float Strip_frame_start_get(PointerRNA *ptr);
void Strip_frame_start_set(PointerRNA *ptr, float value);

int Strip_frame_final_start_get(PointerRNA *ptr);
void Strip_frame_final_start_set(PointerRNA *ptr, int value);

float Strip_frame_offset_start_get(PointerRNA *ptr);
void Strip_frame_offset_start_set(PointerRNA *ptr, float value);

enum {
	Strip_color_tag_NONE = -1,
	Strip_color_tag_COLOR_01 = 0,
	Strip_color_tag_COLOR_02 = 1,
	Strip_color_tag_COLOR_03 = 2,
	Strip_color_tag_COLOR_04 = 3,
	Strip_color_tag_COLOR_05 = 4,
	Strip_color_tag_COLOR_06 = 5,
	Strip_color_tag_COLOR_07 = 6,
	Strip_color_tag_COLOR_08 = 7,
	Strip_color_tag_COLOR_09 = 8,
};

int Strip_color_tag_get(PointerRNA *ptr);
void Strip_color_tag_set(PointerRNA *ptr, int value);

enum {
	Strip_type_IMAGE = 0,
	Strip_type_META = 1,
	Strip_type_SCENE = 2,
	Strip_type_MOVIE = 3,
	Strip_type_MOVIECLIP = 6,
	Strip_type_MASK = 7,
	Strip_type_SOUND = 4,
	Strip_type_CROSS = 8,
	Strip_type_ADD = 9,
	Strip_type_SUBTRACT = 10,
	Strip_type_ALPHA_OVER = 11,
	Strip_type_ALPHA_UNDER = 12,
	Strip_type_GAMMA_CROSS = 13,
	Strip_type_MULTIPLY = 14,
	Strip_type_WIPE = 25,
	Strip_type_GLOW = 26,
	Strip_type_TRANSFORM = 27,
	Strip_type_COLOR = 28,
	Strip_type_SPEED = 29,
	Strip_type_MULTICAM = 30,
	Strip_type_ADJUSTMENT = 31,
	Strip_type_GAUSSIAN_BLUR = 40,
	Strip_type_TEXT = 41,
	Strip_type_COLORMIX = 42,
};

int Strip_type_get(PointerRNA *ptr);
void Strip_type_set(PointerRNA *ptr, int value);

bool Strip_use_default_fade_get(PointerRNA *ptr);
void Strip_use_default_fade_set(PointerRNA *ptr, bool value);

bool Strip_use_linear_modifiers_get(PointerRNA *ptr);
void Strip_use_linear_modifiers_set(PointerRNA *ptr, bool value);

struct StripElem *Strip_strip_elem_from_frame_func(struct ID *_selfid, struct Strip *_self, int frame);
void Strip_swap_func(struct ID *_selfid, struct Strip *_self, ReportList *reports, struct Strip *other);
void Strip_move_to_meta_func(struct ID *_selfid, struct Strip *_self, Main *bmain, ReportList *reports, struct Strip *meta_sequence);
struct Strip *Strip_parent_meta_func(struct ID *_selfid, struct Strip *_self);
void Strip_invalidate_cache_func(struct ID *_selfid, struct Strip *_self, int type);
struct Strip *Strip_split_func(struct ID *_selfid, struct Strip *_self, Main *bmain, ReportList *reports, int frame, int split_method);
/**************** Strip Color Balance ****************/

extern StructRNA RNA_StripColorBalance;
extern StructRNA RNA_StripColorBalanceData;

/**************** Strip Color Balance Data ****************/

extern StructRNA RNA_StripColorBalanceData;

PointerRNA StripColorBalanceData_rna_type_get(PointerRNA *ptr);

enum {
	StripColorBalanceData_correction_method_LIFT_GAMMA_GAIN = 0,
	StripColorBalanceData_correction_method_OFFSET_POWER_SLOPE = 1,
};

int StripColorBalanceData_correction_method_get(PointerRNA *ptr);
void StripColorBalanceData_correction_method_set(PointerRNA *ptr, int value);

void StripColorBalanceData_gain_get(PointerRNA *ptr, float values[3]);
void StripColorBalanceData_gain_set(PointerRNA *ptr, const float values[3]);

void StripColorBalanceData_gamma_get(PointerRNA *ptr, float values[3]);
void StripColorBalanceData_gamma_set(PointerRNA *ptr, const float values[3]);

bool StripColorBalanceData_invert_gain_get(PointerRNA *ptr);
void StripColorBalanceData_invert_gain_set(PointerRNA *ptr, bool value);

bool StripColorBalanceData_invert_gamma_get(PointerRNA *ptr);
void StripColorBalanceData_invert_gamma_set(PointerRNA *ptr, bool value);

bool StripColorBalanceData_invert_lift_get(PointerRNA *ptr);
void StripColorBalanceData_invert_lift_set(PointerRNA *ptr, bool value);

bool StripColorBalanceData_invert_offset_get(PointerRNA *ptr);
void StripColorBalanceData_invert_offset_set(PointerRNA *ptr, bool value);

bool StripColorBalanceData_invert_power_get(PointerRNA *ptr);
void StripColorBalanceData_invert_power_set(PointerRNA *ptr, bool value);

bool StripColorBalanceData_invert_slope_get(PointerRNA *ptr);
void StripColorBalanceData_invert_slope_set(PointerRNA *ptr, bool value);

void StripColorBalanceData_lift_get(PointerRNA *ptr, float values[3]);
void StripColorBalanceData_lift_set(PointerRNA *ptr, const float values[3]);

void StripColorBalanceData_offset_get(PointerRNA *ptr, float values[3]);
void StripColorBalanceData_offset_set(PointerRNA *ptr, const float values[3]);

void StripColorBalanceData_power_get(PointerRNA *ptr, float values[3]);
void StripColorBalanceData_power_set(PointerRNA *ptr, const float values[3]);

void StripColorBalanceData_slope_get(PointerRNA *ptr, float values[3]);
void StripColorBalanceData_slope_set(PointerRNA *ptr, const float values[3]);

/**************** Strip Crop ****************/

extern StructRNA RNA_StripCrop;

PointerRNA StripCrop_rna_type_get(PointerRNA *ptr);

int StripCrop_min_y_get(PointerRNA *ptr);
void StripCrop_min_y_set(PointerRNA *ptr, int value);

int StripCrop_min_x_get(PointerRNA *ptr);
void StripCrop_min_x_set(PointerRNA *ptr, int value);

int StripCrop_max_x_get(PointerRNA *ptr);
void StripCrop_max_x_set(PointerRNA *ptr, int value);

int StripCrop_max_y_get(PointerRNA *ptr);
void StripCrop_max_y_set(PointerRNA *ptr, int value);

/**************** Strip Element ****************/

extern StructRNA RNA_StripElement;

PointerRNA StripElement_rna_type_get(PointerRNA *ptr);

#define StripElement_filename_MAX 256

void StripElement_filename_get(PointerRNA *ptr, char *value);
int StripElement_filename_length(PointerRNA *ptr);
void StripElement_filename_set(PointerRNA *ptr, const char *value);

float StripElement_orig_fps_get(PointerRNA *ptr);
void StripElement_orig_fps_set(PointerRNA *ptr, float value);

int StripElement_orig_height_get(PointerRNA *ptr);
void StripElement_orig_height_set(PointerRNA *ptr, int value);

int StripElement_orig_width_get(PointerRNA *ptr);
void StripElement_orig_width_set(PointerRNA *ptr, int value);

/**************** StripElements ****************/

extern StructRNA RNA_StripElements;

PointerRNA StripElements_rna_type_get(PointerRNA *ptr);

struct StripElem *StripElements_append_func(struct ID *_selfid, struct Strip *_self, const char * filename);
void StripElements_pop_func(struct ID *_selfid, struct Strip *_self, ReportList *reports, int index);
/**************** Strip Modifier ****************/

extern StructRNA RNA_StripModifier;

PointerRNA StripModifier_rna_type_get(PointerRNA *ptr);

#define StripModifier_name_MAX 64

void StripModifier_name_get(PointerRNA *ptr, char *value);
int StripModifier_name_length(PointerRNA *ptr);
void StripModifier_name_set(PointerRNA *ptr, const char *value);

bool StripModifier_show_expanded_get(PointerRNA *ptr);
void StripModifier_show_expanded_set(PointerRNA *ptr, bool value);

PointerRNA StripModifier_input_mask_id_get(PointerRNA *ptr);

enum {
	StripModifier_input_mask_type_STRIP = 0,
	StripModifier_input_mask_type_ID = 1,
};

int StripModifier_input_mask_type_get(PointerRNA *ptr);
void StripModifier_input_mask_type_set(PointerRNA *ptr, int value);

PointerRNA StripModifier_input_mask_strip_get(PointerRNA *ptr);

enum {
	StripModifier_mask_time_RELATIVE = 0,
	StripModifier_mask_time_ABSOLUTE = 1,
};

int StripModifier_mask_time_get(PointerRNA *ptr);
void StripModifier_mask_time_set(PointerRNA *ptr, int value);

bool StripModifier_mute_get(PointerRNA *ptr);
void StripModifier_mute_set(PointerRNA *ptr, bool value);

enum {
	StripModifier_type_BRIGHT_CONTRAST = 4,
	StripModifier_type_COLOR_BALANCE = 1,
	StripModifier_type_CURVES = 2,
	StripModifier_type_HUE_CORRECT = 3,
	StripModifier_type_MASK = 5,
	StripModifier_type_TONEMAP = 7,
	StripModifier_type_WHITE_BALANCE = 6,
	StripModifier_type_SOUND_EQUALIZER = 8,
};

int StripModifier_type_get(PointerRNA *ptr);
void StripModifier_type_set(PointerRNA *ptr, int value);

/**************** Strip Modifiers ****************/

extern StructRNA RNA_StripModifiers;

PointerRNA StripModifiers_rna_type_get(PointerRNA *ptr);

struct StripModifierData *StripModifiers_new_func(struct Strip *_self, bContext *C, ReportList *reports, const char * name, int type);
void StripModifiers_remove_func(struct Strip *_self, bContext *C, ReportList *reports, struct PointerRNA *modifier);
void StripModifiers_clear_func(struct Strip *_self, bContext *C);
/**************** Strip Proxy ****************/

extern StructRNA RNA_StripProxy;

PointerRNA StripProxy_rna_type_get(PointerRNA *ptr);

bool StripProxy_build_100_get(PointerRNA *ptr);
void StripProxy_build_100_set(PointerRNA *ptr, bool value);

bool StripProxy_build_25_get(PointerRNA *ptr);
void StripProxy_build_25_set(PointerRNA *ptr, bool value);

bool StripProxy_build_50_get(PointerRNA *ptr);
void StripProxy_build_50_set(PointerRNA *ptr, bool value);

bool StripProxy_build_75_get(PointerRNA *ptr);
void StripProxy_build_75_set(PointerRNA *ptr, bool value);

#define StripProxy_directory_MAX 768

void StripProxy_directory_get(PointerRNA *ptr, char *value);
int StripProxy_directory_length(PointerRNA *ptr);
void StripProxy_directory_set(PointerRNA *ptr, const char *value);

bool StripProxy_use_overwrite_get(PointerRNA *ptr);
void StripProxy_use_overwrite_set(PointerRNA *ptr, bool value);

void StripProxy_filepath_get(PointerRNA *ptr, char *value);
int StripProxy_filepath_length(PointerRNA *ptr);
void StripProxy_filepath_set(PointerRNA *ptr, const char *value);

bool StripProxy_use_proxy_custom_directory_get(PointerRNA *ptr);
void StripProxy_use_proxy_custom_directory_set(PointerRNA *ptr, bool value);

bool StripProxy_use_proxy_custom_file_get(PointerRNA *ptr);
void StripProxy_use_proxy_custom_file_set(PointerRNA *ptr, bool value);

int StripProxy_quality_get(PointerRNA *ptr);
void StripProxy_quality_set(PointerRNA *ptr, int value);

bool StripProxy_build_record_run_get(PointerRNA *ptr);
void StripProxy_build_record_run_set(PointerRNA *ptr, bool value);

enum {
	StripProxy_timecode_NONE = 0,
	StripProxy_timecode_RECORD_RUN = 1,
	StripProxy_timecode_RECORD_RUN_NO_GAPS = 2,
};

int StripProxy_timecode_get(PointerRNA *ptr);
void StripProxy_timecode_set(PointerRNA *ptr, int value);

/**************** Strip Transform ****************/

extern StructRNA RNA_StripTransform;

PointerRNA StripTransform_rna_type_get(PointerRNA *ptr);

enum {
	StripTransform_filter_AUTO = -1,
	StripTransform_filter_NEAREST = 0,
	StripTransform_filter_BILINEAR = 1,
	StripTransform_filter_CUBIC_MITCHELL = 4,
	StripTransform_filter_CUBIC_BSPLINE = 3,
	StripTransform_filter_BOX = 2,
};

int StripTransform_filter_get(PointerRNA *ptr);
void StripTransform_filter_set(PointerRNA *ptr, int value);

void StripTransform_origin_get(PointerRNA *ptr, float values[2]);
void StripTransform_origin_set(PointerRNA *ptr, const float values[2]);

float StripTransform_rotation_get(PointerRNA *ptr);
void StripTransform_rotation_set(PointerRNA *ptr, float value);

float StripTransform_scale_x_get(PointerRNA *ptr);
void StripTransform_scale_x_set(PointerRNA *ptr, float value);

float StripTransform_scale_y_get(PointerRNA *ptr);
void StripTransform_scale_y_set(PointerRNA *ptr, float value);

float StripTransform_offset_x_get(PointerRNA *ptr);
void StripTransform_offset_x_set(PointerRNA *ptr, float value);

float StripTransform_offset_y_get(PointerRNA *ptr);
void StripTransform_offset_y_set(PointerRNA *ptr, float value);

/**************** Strips ****************/

extern StructRNA RNA_StripsMeta;

PointerRNA StripsMeta_rna_type_get(PointerRNA *ptr);

struct Strip *StripsMeta_new_clip_func(struct ID *_selfid, struct Strip *_self, Main *bmain, const char * name, struct MovieClip *clip, int channel, int frame_start);
struct Strip *StripsMeta_new_mask_func(struct ID *_selfid, struct Strip *_self, Main *bmain, const char * name, struct Mask *mask, int channel, int frame_start);
struct Strip *StripsMeta_new_scene_func(struct ID *_selfid, struct Strip *_self, Main *bmain, const char * name, struct Scene *scene, int channel, int frame_start);
struct Strip *StripsMeta_new_image_func(struct ID *_selfid, struct Strip *_self, Main *bmain, ReportList *reports, const char * name, const char * filepath, int channel, int frame_start, int fit_method);
struct Strip *StripsMeta_new_movie_func(struct ID *_selfid, struct Strip *_self, Main *bmain, ReportList *reports, const char * name, const char * filepath, int channel, int frame_start, int fit_method);
struct Strip *StripsMeta_new_sound_func(struct ID *_selfid, struct Strip *_self, Main *bmain, ReportList *reports, const char * name, const char * filepath, int channel, int frame_start);
struct Strip *StripsMeta_new_meta_func(struct ID *_selfid, struct Strip *_self, const char * name, int channel, int frame_start);
struct Strip *StripsMeta_new_effect_func(struct ID *_selfid, struct Strip *_self, ReportList *reports, const char * name, int type, int channel, int frame_start, int frame_end, struct Strip *input1, struct Strip *input2);
void StripsMeta_remove_func(struct ID *_selfid, struct Strip *_self, Main *bmain, ReportList *reports, struct PointerRNA *sequence);
/**************** Strips ****************/

extern StructRNA RNA_StripsTopLevel;

PointerRNA StripsTopLevel_rna_type_get(PointerRNA *ptr);

struct Strip *StripsTopLevel_new_clip_func(struct ID *_selfid, struct Editing *_self, Main *bmain, const char * name, struct MovieClip *clip, int channel, int frame_start);
struct Strip *StripsTopLevel_new_mask_func(struct ID *_selfid, struct Editing *_self, Main *bmain, const char * name, struct Mask *mask, int channel, int frame_start);
struct Strip *StripsTopLevel_new_scene_func(struct ID *_selfid, struct Editing *_self, Main *bmain, const char * name, struct Scene *scene, int channel, int frame_start);
struct Strip *StripsTopLevel_new_image_func(struct ID *_selfid, struct Editing *_self, Main *bmain, ReportList *reports, const char * name, const char * filepath, int channel, int frame_start, int fit_method);
struct Strip *StripsTopLevel_new_movie_func(struct ID *_selfid, struct Editing *_self, Main *bmain, ReportList *reports, const char * name, const char * filepath, int channel, int frame_start, int fit_method);
struct Strip *StripsTopLevel_new_sound_func(struct ID *_selfid, struct Editing *_self, Main *bmain, ReportList *reports, const char * name, const char * filepath, int channel, int frame_start);
struct Strip *StripsTopLevel_new_meta_func(struct ID *_selfid, struct Editing *_self, const char * name, int channel, int frame_start);
struct Strip *StripsTopLevel_new_effect_func(struct ID *_selfid, struct Editing *_self, ReportList *reports, const char * name, int type, int channel, int frame_start, int frame_end, struct Strip *input1, struct Strip *input2);
void StripsTopLevel_remove_func(struct ID *_selfid, struct Editing *_self, Main *bmain, ReportList *reports, struct PointerRNA *sequence);
/**************** Struct Definition ****************/

extern StructRNA RNA_Struct;

PointerRNA Struct_rna_type_get(PointerRNA *ptr);

void Struct_name_get(PointerRNA *ptr, char *value);
int Struct_name_length(PointerRNA *ptr);
void Struct_name_set(PointerRNA *ptr, const char *value);

PointerRNA Struct_base_get(PointerRNA *ptr);

void Struct_description_get(PointerRNA *ptr, char *value);
int Struct_description_length(PointerRNA *ptr);
void Struct_description_set(PointerRNA *ptr, const char *value);

void Struct_functions_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Struct_functions_next(CollectionPropertyIterator *iter);
void Struct_functions_end(CollectionPropertyIterator *iter);

void Struct_identifier_get(PointerRNA *ptr, char *value);
int Struct_identifier_length(PointerRNA *ptr);
void Struct_identifier_set(PointerRNA *ptr, const char *value);

PointerRNA Struct_name_property_get(PointerRNA *ptr);

PointerRNA Struct_nested_get(PointerRNA *ptr);

void Struct_properties_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Struct_properties_next(CollectionPropertyIterator *iter);
void Struct_properties_end(CollectionPropertyIterator *iter);

void Struct_property_tags_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Struct_property_tags_next(CollectionPropertyIterator *iter);
void Struct_property_tags_end(CollectionPropertyIterator *iter);

void Struct_translation_context_get(PointerRNA *ptr, char *value);
int Struct_translation_context_length(PointerRNA *ptr);
void Struct_translation_context_set(PointerRNA *ptr, const char *value);

/**************** Stucci Texture ****************/

extern StructRNA RNA_StucciTexture;
extern StructRNA RNA_Texture;
extern StructRNA RNA_ID;

enum {
	StucciTexture_noise_basis_BLENDER_ORIGINAL = 0,
	StucciTexture_noise_basis_ORIGINAL_PERLIN = 1,
	StucciTexture_noise_basis_IMPROVED_PERLIN = 2,
	StucciTexture_noise_basis_VORONOI_F1 = 3,
	StucciTexture_noise_basis_VORONOI_F2 = 4,
	StucciTexture_noise_basis_VORONOI_F3 = 5,
	StucciTexture_noise_basis_VORONOI_F4 = 6,
	StucciTexture_noise_basis_VORONOI_F2_F1 = 7,
	StucciTexture_noise_basis_VORONOI_CRACKLE = 8,
	StucciTexture_noise_basis_CELL_NOISE = 14,
};

int StucciTexture_noise_basis_get(PointerRNA *ptr);
void StucciTexture_noise_basis_set(PointerRNA *ptr, int value);

float StucciTexture_noise_scale_get(PointerRNA *ptr);
void StucciTexture_noise_scale_set(PointerRNA *ptr, float value);

enum {
	StucciTexture_noise_type_SOFT_NOISE = 0,
	StucciTexture_noise_type_HARD_NOISE = 1,
};

int StucciTexture_noise_type_get(PointerRNA *ptr);
void StucciTexture_noise_type_set(PointerRNA *ptr, int value);

enum {
	StucciTexture_stucci_type_PLASTIC = 0,
	StucciTexture_stucci_type_WALL_IN = 1,
	StucciTexture_stucci_type_WALL_OUT = 2,
};

int StucciTexture_stucci_type_get(PointerRNA *ptr);
void StucciTexture_stucci_type_set(PointerRNA *ptr, int value);

float StucciTexture_turbulence_get(PointerRNA *ptr);
void StucciTexture_turbulence_set(PointerRNA *ptr, float value);

/**************** Studio Light ****************/

extern StructRNA RNA_StudioLight;

PointerRNA StudioLight_rna_type_get(PointerRNA *ptr);

void StudioLight_name_get(PointerRNA *ptr, char *value);
int StudioLight_name_length(PointerRNA *ptr);
void StudioLight_name_set(PointerRNA *ptr, const char *value);

void StudioLight_light_ambient_get(PointerRNA *ptr, float values[3]);
void StudioLight_light_ambient_set(PointerRNA *ptr, const float values[3]);

bool StudioLight_has_specular_highlight_pass_get(PointerRNA *ptr);
void StudioLight_has_specular_highlight_pass_set(PointerRNA *ptr, bool value);

int StudioLight_index_get(PointerRNA *ptr);
void StudioLight_index_set(PointerRNA *ptr, int value);

void StudioLight_path_get(PointerRNA *ptr, char *value);
int StudioLight_path_length(PointerRNA *ptr);
void StudioLight_path_set(PointerRNA *ptr, const char *value);

void StudioLight_solid_lights_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void StudioLight_solid_lights_next(CollectionPropertyIterator *iter);
void StudioLight_solid_lights_end(CollectionPropertyIterator *iter);
int StudioLight_solid_lights_length(PointerRNA *ptr);
bool StudioLight_solid_lights_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

enum {
	StudioLight_type_STUDIO = 4,
	StudioLight_type_WORLD = 8,
	StudioLight_type_MATCAP = 16,
};

int StudioLight_type_get(PointerRNA *ptr);
void StudioLight_type_set(PointerRNA *ptr, int value);

bool StudioLight_is_user_defined_get(PointerRNA *ptr);
void StudioLight_is_user_defined_set(PointerRNA *ptr, bool value);

/**************** Studio Lights ****************/

extern StructRNA RNA_StudioLights;

PointerRNA StudioLights_rna_type_get(PointerRNA *ptr);

struct StudioLight *StudioLights_load_func(struct UserDef *_self, const char * path, int type);
struct StudioLight *StudioLights_new_func(struct UserDef *_self, const char * path);
void StudioLights_remove_func(struct UserDef *_self, struct StudioLight *studio_light);
void StudioLights_refresh_func(struct UserDef *_self);
/**************** Subdivision Surface Modifier ****************/

extern StructRNA RNA_SubsurfModifier;
extern StructRNA RNA_Modifier;

enum {
	SubsurfModifier_boundary_smooth_PRESERVE_CORNERS = 1,
	SubsurfModifier_boundary_smooth_ALL = 0,
};

int SubsurfModifier_boundary_smooth_get(PointerRNA *ptr);
void SubsurfModifier_boundary_smooth_set(PointerRNA *ptr, int value);

int SubsurfModifier_levels_get(PointerRNA *ptr);
void SubsurfModifier_levels_set(PointerRNA *ptr, int value);

bool SubsurfModifier_show_only_control_edges_get(PointerRNA *ptr);
void SubsurfModifier_show_only_control_edges_set(PointerRNA *ptr, bool value);

int SubsurfModifier_quality_get(PointerRNA *ptr);
void SubsurfModifier_quality_set(PointerRNA *ptr, int value);

int SubsurfModifier_render_levels_get(PointerRNA *ptr);
void SubsurfModifier_render_levels_set(PointerRNA *ptr, int value);

enum {
	SubsurfModifier_subdivision_type_CATMULL_CLARK = 0,
	SubsurfModifier_subdivision_type_SIMPLE = 1,
};

int SubsurfModifier_subdivision_type_get(PointerRNA *ptr);
void SubsurfModifier_subdivision_type_set(PointerRNA *ptr, int value);

enum {
	SubsurfModifier_uv_smooth_NONE = 0,
	SubsurfModifier_uv_smooth_PRESERVE_CORNERS = 1,
	SubsurfModifier_uv_smooth_PRESERVE_CORNERS_AND_JUNCTIONS = 2,
	SubsurfModifier_uv_smooth_PRESERVE_CORNERS_JUNCTIONS_AND_CONCAVE = 3,
	SubsurfModifier_uv_smooth_PRESERVE_BOUNDARIES = 4,
	SubsurfModifier_uv_smooth_SMOOTH_ALL = 5,
};

int SubsurfModifier_uv_smooth_get(PointerRNA *ptr);
void SubsurfModifier_uv_smooth_set(PointerRNA *ptr, int value);

bool SubsurfModifier_use_creases_get(PointerRNA *ptr);
void SubsurfModifier_use_creases_set(PointerRNA *ptr, bool value);

bool SubsurfModifier_use_custom_normals_get(PointerRNA *ptr);
void SubsurfModifier_use_custom_normals_set(PointerRNA *ptr, bool value);

bool SubsurfModifier_use_limit_surface_get(PointerRNA *ptr);
void SubsurfModifier_use_limit_surface_set(PointerRNA *ptr, bool value);

bool SubsurfModifier_open_adaptive_subdivision_panel_get(PointerRNA *ptr);
void SubsurfModifier_open_adaptive_subdivision_panel_set(PointerRNA *ptr, bool value);

bool SubsurfModifier_open_advanced_panel_get(PointerRNA *ptr);
void SubsurfModifier_open_advanced_panel_set(PointerRNA *ptr, bool value);

/**************** Subtract Strip ****************/

extern StructRNA RNA_SubtractStrip;
extern StructRNA RNA_EffectStrip;
extern StructRNA RNA_Strip;

PointerRNA SubtractStrip_input_1_get(PointerRNA *ptr);

PointerRNA SubtractStrip_input_2_get(PointerRNA *ptr);

int SubtractStrip_input_count_get(PointerRNA *ptr);
void SubtractStrip_input_count_set(PointerRNA *ptr, int value);

/**************** Sun Light ****************/

extern StructRNA RNA_SunLight;
extern StructRNA RNA_Light;
extern StructRNA RNA_ID;

float SunLight_angle_get(PointerRNA *ptr);
void SunLight_angle_set(PointerRNA *ptr, float value);

int SunLight_shadow_cascade_count_get(PointerRNA *ptr);
void SunLight_shadow_cascade_count_set(PointerRNA *ptr, int value);

float SunLight_shadow_cascade_fade_get(PointerRNA *ptr);
void SunLight_shadow_cascade_fade_set(PointerRNA *ptr, float value);

float SunLight_shadow_cascade_max_distance_get(PointerRNA *ptr);
void SunLight_shadow_cascade_max_distance_set(PointerRNA *ptr, float value);

float SunLight_shadow_cascade_exponent_get(PointerRNA *ptr);
void SunLight_shadow_cascade_exponent_set(PointerRNA *ptr, float value);

float SunLight_shadow_buffer_clip_start_get(PointerRNA *ptr);
void SunLight_shadow_buffer_clip_start_set(PointerRNA *ptr, float value);

float SunLight_shadow_filter_radius_get(PointerRNA *ptr);
void SunLight_shadow_filter_radius_set(PointerRNA *ptr, float value);

bool SunLight_use_shadow_jitter_get(PointerRNA *ptr);
void SunLight_use_shadow_jitter_set(PointerRNA *ptr, bool value);

float SunLight_shadow_jitter_overblur_get(PointerRNA *ptr);
void SunLight_shadow_jitter_overblur_set(PointerRNA *ptr, float value);

float SunLight_shadow_soft_size_get(PointerRNA *ptr);
void SunLight_shadow_soft_size_set(PointerRNA *ptr, float value);

float SunLight_shadow_maximum_resolution_get(PointerRNA *ptr);
void SunLight_shadow_maximum_resolution_set(PointerRNA *ptr, float value);

float SunLight_energy_get(PointerRNA *ptr);
void SunLight_energy_set(PointerRNA *ptr, float value);

/**************** Surface Curve ****************/

extern StructRNA RNA_SurfaceCurve;
extern StructRNA RNA_Curve;
extern StructRNA RNA_ID;

/**************** SurfaceDeform Modifier ****************/

extern StructRNA RNA_SurfaceDeformModifier;
extern StructRNA RNA_Modifier;

bool SurfaceDeformModifier_is_bound_get(PointerRNA *ptr);
void SurfaceDeformModifier_is_bound_set(PointerRNA *ptr, bool value);

float SurfaceDeformModifier_falloff_get(PointerRNA *ptr);
void SurfaceDeformModifier_falloff_set(PointerRNA *ptr, float value);

bool SurfaceDeformModifier_invert_vertex_group_get(PointerRNA *ptr);
void SurfaceDeformModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

bool SurfaceDeformModifier_use_sparse_bind_get(PointerRNA *ptr);
void SurfaceDeformModifier_use_sparse_bind_set(PointerRNA *ptr, bool value);

float SurfaceDeformModifier_strength_get(PointerRNA *ptr);
void SurfaceDeformModifier_strength_set(PointerRNA *ptr, float value);

PointerRNA SurfaceDeformModifier_target_get(PointerRNA *ptr);

#define SurfaceDeformModifier_vertex_group_MAX 64

void SurfaceDeformModifier_vertex_group_get(PointerRNA *ptr, char *value);
int SurfaceDeformModifier_vertex_group_length(PointerRNA *ptr);
void SurfaceDeformModifier_vertex_group_set(PointerRNA *ptr, const char *value);

/**************** Surface Modifier ****************/

extern StructRNA RNA_SurfaceModifier;
extern StructRNA RNA_Modifier;

/**************** Texture Mapping ****************/

extern StructRNA RNA_TexMapping;

PointerRNA TexMapping_rna_type_get(PointerRNA *ptr);

bool TexMapping_use_max_get(PointerRNA *ptr);
void TexMapping_use_max_set(PointerRNA *ptr, bool value);

bool TexMapping_use_min_get(PointerRNA *ptr);
void TexMapping_use_min_set(PointerRNA *ptr, bool value);

void TexMapping_translation_get(PointerRNA *ptr, float values[3]);
void TexMapping_translation_set(PointerRNA *ptr, const float values[3]);

enum {
	TexMapping_mapping_FLAT = 0,
	TexMapping_mapping_CUBE = 1,
	TexMapping_mapping_TUBE = 2,
	TexMapping_mapping_SPHERE = 3,
};

int TexMapping_mapping_get(PointerRNA *ptr);
void TexMapping_mapping_set(PointerRNA *ptr, int value);

void TexMapping_max_get(PointerRNA *ptr, float values[3]);
void TexMapping_max_set(PointerRNA *ptr, const float values[3]);

void TexMapping_min_get(PointerRNA *ptr, float values[3]);
void TexMapping_min_set(PointerRNA *ptr, const float values[3]);

void TexMapping_rotation_get(PointerRNA *ptr, float values[3]);
void TexMapping_rotation_set(PointerRNA *ptr, const float values[3]);

void TexMapping_scale_get(PointerRNA *ptr, float values[3]);
void TexMapping_scale_set(PointerRNA *ptr, const float values[3]);

enum {
	TexMapping_vector_type_POINT = 0,
	TexMapping_vector_type_TEXTURE = 1,
	TexMapping_vector_type_VECTOR = 2,
	TexMapping_vector_type_NORMAL = 3,
};

int TexMapping_vector_type_get(PointerRNA *ptr);
void TexMapping_vector_type_set(PointerRNA *ptr, int value);

enum {
	TexMapping_mapping_x_NONE = 0,
	TexMapping_mapping_x_X = 1,
	TexMapping_mapping_x_Y = 2,
	TexMapping_mapping_x_Z = 3,
};

int TexMapping_mapping_x_get(PointerRNA *ptr);
void TexMapping_mapping_x_set(PointerRNA *ptr, int value);

enum {
	TexMapping_mapping_y_NONE = 0,
	TexMapping_mapping_y_X = 1,
	TexMapping_mapping_y_Y = 2,
	TexMapping_mapping_y_Z = 3,
};

int TexMapping_mapping_y_get(PointerRNA *ptr);
void TexMapping_mapping_y_set(PointerRNA *ptr, int value);

enum {
	TexMapping_mapping_z_NONE = 0,
	TexMapping_mapping_z_X = 1,
	TexMapping_mapping_z_Y = 2,
	TexMapping_mapping_z_Z = 3,
};

int TexMapping_mapping_z_get(PointerRNA *ptr);
void TexMapping_mapping_z_set(PointerRNA *ptr, int value);

/**************** Texture Paint Slot ****************/

extern StructRNA RNA_TexPaintSlot;

PointerRNA TexPaintSlot_rna_type_get(PointerRNA *ptr);

void TexPaintSlot_name_get(PointerRNA *ptr, char *value);
int TexPaintSlot_name_length(PointerRNA *ptr);
void TexPaintSlot_name_set(PointerRNA *ptr, const char *value);

int TexPaintSlot_icon_value_get(PointerRNA *ptr);
void TexPaintSlot_icon_value_set(PointerRNA *ptr, int value);

#define TexPaintSlot_uv_layer_MAX 64

void TexPaintSlot_uv_layer_get(PointerRNA *ptr, char *value);
int TexPaintSlot_uv_layer_length(PointerRNA *ptr);
void TexPaintSlot_uv_layer_set(PointerRNA *ptr, const char *value);

bool TexPaintSlot_is_valid_get(PointerRNA *ptr);
void TexPaintSlot_is_valid_set(PointerRNA *ptr, bool value);

/**************** Text ****************/

extern StructRNA RNA_Text;
extern StructRNA RNA_ID;

int Text_current_character_get(PointerRNA *ptr);
void Text_current_character_set(PointerRNA *ptr, int value);

PointerRNA Text_current_line_get(PointerRNA *ptr);

int Text_current_line_index_get(PointerRNA *ptr);
void Text_current_line_index_set(PointerRNA *ptr, int value);

bool Text_is_dirty_get(PointerRNA *ptr);
void Text_is_dirty_set(PointerRNA *ptr, bool value);

void Text_filepath_get(PointerRNA *ptr, char *value);
int Text_filepath_length(PointerRNA *ptr);
void Text_filepath_set(PointerRNA *ptr, const char *value);

enum {
	Text_indentation_TABS = 0,
	Text_indentation_SPACES = 1024,
};

int Text_indentation_get(PointerRNA *ptr);
void Text_indentation_set(PointerRNA *ptr, int value);

void Text_lines_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Text_lines_next(CollectionPropertyIterator *iter);
void Text_lines_end(CollectionPropertyIterator *iter);
bool Text_lines_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

bool Text_is_in_memory_get(PointerRNA *ptr);
void Text_is_in_memory_set(PointerRNA *ptr, bool value);

bool Text_is_modified_get(PointerRNA *ptr);
void Text_is_modified_set(PointerRNA *ptr, bool value);

bool Text_use_module_get(PointerRNA *ptr);
void Text_use_module_set(PointerRNA *ptr, bool value);

int Text_select_end_line_index_get(PointerRNA *ptr);
void Text_select_end_line_index_set(PointerRNA *ptr, int value);

int Text_select_end_character_get(PointerRNA *ptr);
void Text_select_end_character_set(PointerRNA *ptr, int value);

PointerRNA Text_select_end_line_get(PointerRNA *ptr);

void Text_clear_func(struct Text *_self);
void Text_write_func(struct Text *_self, const char * text);
void Text_from_string_func(struct Text *_self, const char * text);
void Text_as_string_func(struct Text *_self, int *text_num, const char * *text);
bool Text_is_syntax_highlight_supported_func(struct Text *_self);
void Text_select_set_func(struct Text *_self, int line_start, int char_start, int line_end, int char_end);
void Text_cursor_set_func(struct Text *_self, int line, int character, bool select);
/**************** Text Box ****************/

extern StructRNA RNA_TextBox;

PointerRNA TextBox_rna_type_get(PointerRNA *ptr);

float TextBox_height_get(PointerRNA *ptr);
void TextBox_height_set(PointerRNA *ptr, float value);

float TextBox_width_get(PointerRNA *ptr);
void TextBox_width_set(PointerRNA *ptr, float value);

float TextBox_x_get(PointerRNA *ptr);
void TextBox_x_set(PointerRNA *ptr, float value);

float TextBox_y_get(PointerRNA *ptr);
void TextBox_y_set(PointerRNA *ptr, float value);

/**************** Text Character Format ****************/

extern StructRNA RNA_TextCharacterFormat;

PointerRNA TextCharacterFormat_rna_type_get(PointerRNA *ptr);

bool TextCharacterFormat_use_bold_get(PointerRNA *ptr);
void TextCharacterFormat_use_bold_set(PointerRNA *ptr, bool value);

bool TextCharacterFormat_use_italic_get(PointerRNA *ptr);
void TextCharacterFormat_use_italic_set(PointerRNA *ptr, bool value);

float TextCharacterFormat_kerning_get(PointerRNA *ptr);
void TextCharacterFormat_kerning_set(PointerRNA *ptr, float value);

int TextCharacterFormat_material_index_get(PointerRNA *ptr);
void TextCharacterFormat_material_index_set(PointerRNA *ptr, int value);

bool TextCharacterFormat_use_small_caps_get(PointerRNA *ptr);
void TextCharacterFormat_use_small_caps_set(PointerRNA *ptr, bool value);

bool TextCharacterFormat_use_underline_get(PointerRNA *ptr);
void TextCharacterFormat_use_underline_set(PointerRNA *ptr, bool value);

/**************** Text Curve ****************/

extern StructRNA RNA_TextCurve;
extern StructRNA RNA_Curve;
extern StructRNA RNA_ID;

int TextCurve_active_textbox_get(PointerRNA *ptr);
void TextCurve_active_textbox_set(PointerRNA *ptr, int value);

#define TextCurve_body_MAX 8192

void TextCurve_body_get(PointerRNA *ptr, char *value);
int TextCurve_body_length(PointerRNA *ptr);
void TextCurve_body_set(PointerRNA *ptr, const char *value);

void TextCurve_body_format_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void TextCurve_body_format_next(CollectionPropertyIterator *iter);
void TextCurve_body_format_end(CollectionPropertyIterator *iter);
int TextCurve_body_format_length(PointerRNA *ptr);
bool TextCurve_body_format_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

float TextCurve_space_line_get(PointerRNA *ptr);
void TextCurve_space_line_set(PointerRNA *ptr, float value);

PointerRNA TextCurve_edit_format_get(PointerRNA *ptr);

bool TextCurve_use_fast_edit_get(PointerRNA *ptr);
void TextCurve_use_fast_edit_set(PointerRNA *ptr, bool value);

PointerRNA TextCurve_font_get(PointerRNA *ptr);

PointerRNA TextCurve_font_bold_get(PointerRNA *ptr);

PointerRNA TextCurve_font_bold_italic_get(PointerRNA *ptr);

PointerRNA TextCurve_font_italic_get(PointerRNA *ptr);

float TextCurve_size_get(PointerRNA *ptr);
void TextCurve_size_set(PointerRNA *ptr, float value);

float TextCurve_space_character_get(PointerRNA *ptr);
void TextCurve_space_character_set(PointerRNA *ptr, float value);

enum {
	TextCurve_align_x_LEFT = 0,
	TextCurve_align_x_CENTER = 1,
	TextCurve_align_x_RIGHT = 2,
	TextCurve_align_x_JUSTIFY = 3,
	TextCurve_align_x_FLUSH = 4,
};

int TextCurve_align_x_get(PointerRNA *ptr);
void TextCurve_align_x_set(PointerRNA *ptr, int value);

#define TextCurve_family_MAX 64

void TextCurve_family_get(PointerRNA *ptr, char *value);
int TextCurve_family_length(PointerRNA *ptr);
void TextCurve_family_set(PointerRNA *ptr, const char *value);

bool TextCurve_is_select_bold_get(PointerRNA *ptr);
void TextCurve_is_select_bold_set(PointerRNA *ptr, bool value);

bool TextCurve_is_select_italic_get(PointerRNA *ptr);
void TextCurve_is_select_italic_set(PointerRNA *ptr, bool value);

bool TextCurve_is_select_smallcaps_get(PointerRNA *ptr);
void TextCurve_is_select_smallcaps_set(PointerRNA *ptr, bool value);

bool TextCurve_is_select_underline_get(PointerRNA *ptr);
void TextCurve_is_select_underline_set(PointerRNA *ptr, bool value);

float TextCurve_shear_get(PointerRNA *ptr);
void TextCurve_shear_set(PointerRNA *ptr, float value);

float TextCurve_small_caps_scale_get(PointerRNA *ptr);
void TextCurve_small_caps_scale_set(PointerRNA *ptr, float value);

float TextCurve_space_word_get(PointerRNA *ptr);
void TextCurve_space_word_set(PointerRNA *ptr, float value);

bool TextCurve_has_selection_get(PointerRNA *ptr);
void TextCurve_has_selection_set(PointerRNA *ptr, bool value);

PointerRNA TextCurve_follow_curve_get(PointerRNA *ptr);

enum {
	TextCurve_overflow_NONE = 0,
	TextCurve_overflow_SCALE = 1,
	TextCurve_overflow_TRUNCATE = 2,
};

int TextCurve_overflow_get(PointerRNA *ptr);
void TextCurve_overflow_set(PointerRNA *ptr, int value);

void TextCurve_text_boxes_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void TextCurve_text_boxes_next(CollectionPropertyIterator *iter);
void TextCurve_text_boxes_end(CollectionPropertyIterator *iter);
int TextCurve_text_boxes_length(PointerRNA *ptr);
bool TextCurve_text_boxes_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

float TextCurve_underline_position_get(PointerRNA *ptr);
void TextCurve_underline_position_set(PointerRNA *ptr, float value);

float TextCurve_underline_height_get(PointerRNA *ptr);
void TextCurve_underline_height_set(PointerRNA *ptr, float value);

enum {
	TextCurve_align_y_TOP = 1,
	TextCurve_align_y_TOP_BASELINE = 0,
	TextCurve_align_y_CENTER = 2,
	TextCurve_align_y_BOTTOM_BASELINE = 3,
	TextCurve_align_y_BOTTOM = 4,
};

int TextCurve_align_y_get(PointerRNA *ptr);
void TextCurve_align_y_set(PointerRNA *ptr, int value);

float TextCurve_offset_x_get(PointerRNA *ptr);
void TextCurve_offset_x_set(PointerRNA *ptr, float value);

float TextCurve_offset_y_get(PointerRNA *ptr);
void TextCurve_offset_y_set(PointerRNA *ptr, float value);

/**************** Text Line ****************/

extern StructRNA RNA_TextLine;

PointerRNA TextLine_rna_type_get(PointerRNA *ptr);

void TextLine_body_get(PointerRNA *ptr, char *value);
int TextLine_body_length(PointerRNA *ptr);
void TextLine_body_set(PointerRNA *ptr, const char *value);

/**************** Text Strip ****************/

extern StructRNA RNA_TextStrip;
extern StructRNA RNA_EffectStrip;
extern StructRNA RNA_Strip;

enum {
	TextStrip_alignment_x_LEFT = 0,
	TextStrip_alignment_x_CENTER = 1,
	TextStrip_alignment_x_RIGHT = 2,
};

int TextStrip_alignment_x_get(PointerRNA *ptr);
void TextStrip_alignment_x_set(PointerRNA *ptr, int value);

enum {
	TextStrip_anchor_x_LEFT = 0,
	TextStrip_anchor_x_CENTER = 1,
	TextStrip_anchor_x_RIGHT = 2,
};

int TextStrip_anchor_x_get(PointerRNA *ptr);
void TextStrip_anchor_x_set(PointerRNA *ptr, int value);

enum {
	TextStrip_anchor_y_TOP = 0,
	TextStrip_anchor_y_CENTER = 1,
	TextStrip_anchor_y_BOTTOM = 2,
};

int TextStrip_anchor_y_get(PointerRNA *ptr);
void TextStrip_anchor_y_set(PointerRNA *ptr, int value);

bool TextStrip_use_bold_get(PointerRNA *ptr);
void TextStrip_use_bold_set(PointerRNA *ptr, bool value);

bool TextStrip_use_box_get(PointerRNA *ptr);
void TextStrip_use_box_set(PointerRNA *ptr, bool value);

void TextStrip_box_color_get(PointerRNA *ptr, float values[4]);
void TextStrip_box_color_set(PointerRNA *ptr, const float values[4]);

float TextStrip_box_margin_get(PointerRNA *ptr);
void TextStrip_box_margin_set(PointerRNA *ptr, float value);

float TextStrip_box_roundness_get(PointerRNA *ptr);
void TextStrip_box_roundness_set(PointerRNA *ptr, float value);

void TextStrip_color_get(PointerRNA *ptr, float values[4]);
void TextStrip_color_set(PointerRNA *ptr, const float values[4]);

PointerRNA TextStrip_font_get(PointerRNA *ptr);

bool TextStrip_use_italic_get(PointerRNA *ptr);
void TextStrip_use_italic_set(PointerRNA *ptr, bool value);

void TextStrip_location_get(PointerRNA *ptr, float values[2]);
void TextStrip_location_set(PointerRNA *ptr, const float values[2]);

bool TextStrip_use_outline_get(PointerRNA *ptr);
void TextStrip_use_outline_set(PointerRNA *ptr, bool value);

void TextStrip_outline_color_get(PointerRNA *ptr, float values[4]);
void TextStrip_outline_color_set(PointerRNA *ptr, const float values[4]);

float TextStrip_outline_width_get(PointerRNA *ptr);
void TextStrip_outline_width_set(PointerRNA *ptr, float value);

bool TextStrip_use_shadow_get(PointerRNA *ptr);
void TextStrip_use_shadow_set(PointerRNA *ptr, bool value);

float TextStrip_shadow_angle_get(PointerRNA *ptr);
void TextStrip_shadow_angle_set(PointerRNA *ptr, float value);

float TextStrip_shadow_blur_get(PointerRNA *ptr);
void TextStrip_shadow_blur_set(PointerRNA *ptr, float value);

void TextStrip_shadow_color_get(PointerRNA *ptr, float values[4]);
void TextStrip_shadow_color_set(PointerRNA *ptr, const float values[4]);

float TextStrip_shadow_offset_get(PointerRNA *ptr);
void TextStrip_shadow_offset_set(PointerRNA *ptr, float value);

float TextStrip_font_size_get(PointerRNA *ptr);
void TextStrip_font_size_set(PointerRNA *ptr, float value);

#define TextStrip_text_MAX 512

void TextStrip_text_get(PointerRNA *ptr, char *value);
int TextStrip_text_length(PointerRNA *ptr);
void TextStrip_text_set(PointerRNA *ptr, const char *value);

float TextStrip_wrap_width_get(PointerRNA *ptr);
void TextStrip_wrap_width_set(PointerRNA *ptr, float value);

int TextStrip_input_count_get(PointerRNA *ptr);
void TextStrip_input_count_set(PointerRNA *ptr, int value);

/**************** Texture ****************/

extern StructRNA RNA_Texture;
extern StructRNA RNA_ID;

PointerRNA Texture_animation_data_get(PointerRNA *ptr);

float Texture_intensity_get(PointerRNA *ptr);
void Texture_intensity_set(PointerRNA *ptr, float value);

bool Texture_use_clamp_get(PointerRNA *ptr);
void Texture_use_clamp_set(PointerRNA *ptr, bool value);

PointerRNA Texture_color_ramp_get(PointerRNA *ptr);

float Texture_contrast_get(PointerRNA *ptr);
void Texture_contrast_set(PointerRNA *ptr, float value);

float Texture_factor_blue_get(PointerRNA *ptr);
void Texture_factor_blue_set(PointerRNA *ptr, float value);

float Texture_factor_green_get(PointerRNA *ptr);
void Texture_factor_green_set(PointerRNA *ptr, float value);

float Texture_factor_red_get(PointerRNA *ptr);
void Texture_factor_red_set(PointerRNA *ptr, float value);

PointerRNA Texture_node_tree_get(PointerRNA *ptr);

float Texture_saturation_get(PointerRNA *ptr);
void Texture_saturation_set(PointerRNA *ptr, float value);

bool Texture_use_preview_alpha_get(PointerRNA *ptr);
void Texture_use_preview_alpha_set(PointerRNA *ptr, bool value);

enum {
	Texture_type_NONE = 0,
	Texture_type_BLEND = 5,
	Texture_type_CLOUDS = 1,
	Texture_type_DISTORTED_NOISE = 13,
	Texture_type_IMAGE = 8,
	Texture_type_MAGIC = 4,
	Texture_type_MARBLE = 3,
	Texture_type_MUSGRAVE = 11,
	Texture_type_NOISE = 7,
	Texture_type_STUCCI = 6,
	Texture_type_VORONOI = 12,
	Texture_type_WOOD = 2,
};

int Texture_type_get(PointerRNA *ptr);
void Texture_type_set(PointerRNA *ptr, int value);

bool Texture_use_color_ramp_get(PointerRNA *ptr);
void Texture_use_color_ramp_set(PointerRNA *ptr, bool value);

bool Texture_use_nodes_get(PointerRNA *ptr);
void Texture_use_nodes_set(PointerRNA *ptr, bool value);

void Texture_evaluate_func(struct Tex *_self, float value[3], float result[4]);
/**************** Texture Node ****************/

extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

/**************** TextureNodeAt ****************/

extern StructRNA RNA_TextureNodeAt;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeAt_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeAt_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeAt_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeBricks ****************/

extern StructRNA RNA_TextureNodeBricks;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

float TextureNodeBricks_offset_get(PointerRNA *ptr);
void TextureNodeBricks_offset_set(PointerRNA *ptr, float value);

int TextureNodeBricks_offset_frequency_get(PointerRNA *ptr);
void TextureNodeBricks_offset_frequency_set(PointerRNA *ptr, int value);

float TextureNodeBricks_squash_get(PointerRNA *ptr);
void TextureNodeBricks_squash_set(PointerRNA *ptr, float value);

int TextureNodeBricks_squash_frequency_get(PointerRNA *ptr);
void TextureNodeBricks_squash_frequency_set(PointerRNA *ptr, int value);

bool TextureNodeBricks_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeBricks_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeBricks_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeChecker ****************/

extern StructRNA RNA_TextureNodeChecker;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeChecker_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeChecker_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeChecker_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeCombineColor ****************/

extern StructRNA RNA_TextureNodeCombineColor;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	TextureNodeCombineColor_mode_RGB = 0,
	TextureNodeCombineColor_mode_HSV = 1,
	TextureNodeCombineColor_mode_HSL = 2,
};

int TextureNodeCombineColor_mode_get(PointerRNA *ptr);
void TextureNodeCombineColor_mode_set(PointerRNA *ptr, int value);

bool TextureNodeCombineColor_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeCombineColor_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeCombineColor_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeCompose ****************/

extern StructRNA RNA_TextureNodeCompose;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeCompose_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeCompose_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeCompose_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeCoordinates ****************/

extern StructRNA RNA_TextureNodeCoordinates;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeCoordinates_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeCoordinates_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeCoordinates_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeCurveRGB ****************/

extern StructRNA RNA_TextureNodeCurveRGB;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA TextureNodeCurveRGB_mapping_get(PointerRNA *ptr);

bool TextureNodeCurveRGB_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeCurveRGB_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeCurveRGB_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeCurveTime ****************/

extern StructRNA RNA_TextureNodeCurveTime;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA TextureNodeCurveTime_curve_get(PointerRNA *ptr);

int TextureNodeCurveTime_frame_end_get(PointerRNA *ptr);
void TextureNodeCurveTime_frame_end_set(PointerRNA *ptr, int value);

int TextureNodeCurveTime_frame_start_get(PointerRNA *ptr);
void TextureNodeCurveTime_frame_start_set(PointerRNA *ptr, int value);

bool TextureNodeCurveTime_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeCurveTime_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeCurveTime_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeDecompose ****************/

extern StructRNA RNA_TextureNodeDecompose;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeDecompose_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeDecompose_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeDecompose_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeDistance ****************/

extern StructRNA RNA_TextureNodeDistance;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeDistance_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeDistance_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeDistance_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeGroup ****************/

extern StructRNA RNA_TextureNodeGroup;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA TextureNodeGroup_node_tree_get(PointerRNA *ptr);

bool TextureNodeGroup_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeGroup_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeGroup_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeHueSaturation ****************/

extern StructRNA RNA_TextureNodeHueSaturation;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeHueSaturation_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeHueSaturation_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeHueSaturation_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeImage ****************/

extern StructRNA RNA_TextureNodeImage;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA TextureNodeImage_image_get(PointerRNA *ptr);

PointerRNA TextureNodeImage_image_user_get(PointerRNA *ptr);

bool TextureNodeImage_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeImage_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeImage_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeInvert ****************/

extern StructRNA RNA_TextureNodeInvert;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeInvert_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeInvert_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeInvert_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeMath ****************/

extern StructRNA RNA_TextureNodeMath;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeMath_use_clamp_get(PointerRNA *ptr);
void TextureNodeMath_use_clamp_set(PointerRNA *ptr, bool value);

enum {
	TextureNodeMath_operation_ADD = 0,
	TextureNodeMath_operation_SUBTRACT = 1,
	TextureNodeMath_operation_MULTIPLY = 2,
	TextureNodeMath_operation_DIVIDE = 3,
	TextureNodeMath_operation_MULTIPLY_ADD = 36,
	TextureNodeMath_operation_POWER = 10,
	TextureNodeMath_operation_LOGARITHM = 11,
	TextureNodeMath_operation_SQRT = 23,
	TextureNodeMath_operation_INVERSE_SQRT = 24,
	TextureNodeMath_operation_ABSOLUTE = 18,
	TextureNodeMath_operation_EXPONENT = 26,
	TextureNodeMath_operation_MINIMUM = 12,
	TextureNodeMath_operation_MAXIMUM = 13,
	TextureNodeMath_operation_LESS_THAN = 15,
	TextureNodeMath_operation_GREATER_THAN = 16,
	TextureNodeMath_operation_SIGN = 25,
	TextureNodeMath_operation_COMPARE = 35,
	TextureNodeMath_operation_SMOOTH_MIN = 38,
	TextureNodeMath_operation_SMOOTH_MAX = 39,
	TextureNodeMath_operation_ROUND = 14,
	TextureNodeMath_operation_FLOOR = 20,
	TextureNodeMath_operation_CEIL = 21,
	TextureNodeMath_operation_TRUNC = 32,
	TextureNodeMath_operation_FRACT = 22,
	TextureNodeMath_operation_MODULO = 17,
	TextureNodeMath_operation_FLOORED_MODULO = 40,
	TextureNodeMath_operation_WRAP = 34,
	TextureNodeMath_operation_SNAP = 33,
	TextureNodeMath_operation_PINGPONG = 37,
	TextureNodeMath_operation_SINE = 4,
	TextureNodeMath_operation_COSINE = 5,
	TextureNodeMath_operation_TANGENT = 6,
	TextureNodeMath_operation_ARCSINE = 7,
	TextureNodeMath_operation_ARCCOSINE = 8,
	TextureNodeMath_operation_ARCTANGENT = 9,
	TextureNodeMath_operation_ARCTAN2 = 19,
	TextureNodeMath_operation_SINH = 29,
	TextureNodeMath_operation_COSH = 30,
	TextureNodeMath_operation_TANH = 31,
	TextureNodeMath_operation_RADIANS = 27,
	TextureNodeMath_operation_DEGREES = 28,
};

int TextureNodeMath_operation_get(PointerRNA *ptr);
void TextureNodeMath_operation_set(PointerRNA *ptr, int value);

bool TextureNodeMath_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeMath_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeMath_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeMixRGB ****************/

extern StructRNA RNA_TextureNodeMixRGB;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeMixRGB_use_alpha_get(PointerRNA *ptr);
void TextureNodeMixRGB_use_alpha_set(PointerRNA *ptr, bool value);

enum {
	TextureNodeMixRGB_blend_type_MIX = 0,
	TextureNodeMixRGB_blend_type_DARKEN = 7,
	TextureNodeMixRGB_blend_type_MULTIPLY = 2,
	TextureNodeMixRGB_blend_type_BURN = 11,
	TextureNodeMixRGB_blend_type_LIGHTEN = 8,
	TextureNodeMixRGB_blend_type_SCREEN = 4,
	TextureNodeMixRGB_blend_type_DODGE = 10,
	TextureNodeMixRGB_blend_type_ADD = 1,
	TextureNodeMixRGB_blend_type_OVERLAY = 9,
	TextureNodeMixRGB_blend_type_SOFT_LIGHT = 16,
	TextureNodeMixRGB_blend_type_LINEAR_LIGHT = 17,
	TextureNodeMixRGB_blend_type_DIFFERENCE = 6,
	TextureNodeMixRGB_blend_type_EXCLUSION = 18,
	TextureNodeMixRGB_blend_type_SUBTRACT = 3,
	TextureNodeMixRGB_blend_type_DIVIDE = 5,
	TextureNodeMixRGB_blend_type_HUE = 12,
	TextureNodeMixRGB_blend_type_SATURATION = 13,
	TextureNodeMixRGB_blend_type_COLOR = 15,
	TextureNodeMixRGB_blend_type_VALUE = 14,
};

int TextureNodeMixRGB_blend_type_get(PointerRNA *ptr);
void TextureNodeMixRGB_blend_type_set(PointerRNA *ptr, int value);

bool TextureNodeMixRGB_use_clamp_get(PointerRNA *ptr);
void TextureNodeMixRGB_use_clamp_set(PointerRNA *ptr, bool value);

bool TextureNodeMixRGB_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeMixRGB_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeMixRGB_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeOutput ****************/

extern StructRNA RNA_TextureNodeOutput;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

#define TextureNodeOutput_filepath_MAX 64

void TextureNodeOutput_filepath_get(PointerRNA *ptr, char *value);
int TextureNodeOutput_filepath_length(PointerRNA *ptr);
void TextureNodeOutput_filepath_set(PointerRNA *ptr, const char *value);

bool TextureNodeOutput_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeOutput_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeOutput_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeRGBToBW ****************/

extern StructRNA RNA_TextureNodeRGBToBW;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeRGBToBW_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeRGBToBW_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeRGBToBW_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeRotate ****************/

extern StructRNA RNA_TextureNodeRotate;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeRotate_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeRotate_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeRotate_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeScale ****************/

extern StructRNA RNA_TextureNodeScale;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeScale_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeScale_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeScale_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeSeparateColor ****************/

extern StructRNA RNA_TextureNodeSeparateColor;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

enum {
	TextureNodeSeparateColor_mode_RGB = 0,
	TextureNodeSeparateColor_mode_HSV = 1,
	TextureNodeSeparateColor_mode_HSL = 2,
};

int TextureNodeSeparateColor_mode_get(PointerRNA *ptr);
void TextureNodeSeparateColor_mode_set(PointerRNA *ptr, int value);

bool TextureNodeSeparateColor_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeSeparateColor_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeSeparateColor_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeTexBlend ****************/

extern StructRNA RNA_TextureNodeTexBlend;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeTexBlend_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeTexBlend_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeTexBlend_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeTexClouds ****************/

extern StructRNA RNA_TextureNodeTexClouds;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeTexClouds_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeTexClouds_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeTexClouds_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeTexDistNoise ****************/

extern StructRNA RNA_TextureNodeTexDistNoise;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeTexDistNoise_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeTexDistNoise_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeTexDistNoise_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeTexMagic ****************/

extern StructRNA RNA_TextureNodeTexMagic;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeTexMagic_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeTexMagic_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeTexMagic_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeTexMarble ****************/

extern StructRNA RNA_TextureNodeTexMarble;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeTexMarble_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeTexMarble_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeTexMarble_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeTexMusgrave ****************/

extern StructRNA RNA_TextureNodeTexMusgrave;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeTexMusgrave_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeTexMusgrave_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeTexMusgrave_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeTexNoise ****************/

extern StructRNA RNA_TextureNodeTexNoise;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeTexNoise_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeTexNoise_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeTexNoise_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeTexStucci ****************/

extern StructRNA RNA_TextureNodeTexStucci;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeTexStucci_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeTexStucci_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeTexStucci_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeTexVoronoi ****************/

extern StructRNA RNA_TextureNodeTexVoronoi;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeTexVoronoi_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeTexVoronoi_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeTexVoronoi_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeTexWood ****************/

extern StructRNA RNA_TextureNodeTexWood;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeTexWood_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeTexWood_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeTexWood_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeTexture ****************/

extern StructRNA RNA_TextureNodeTexture;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

int TextureNodeTexture_node_output_get(PointerRNA *ptr);
void TextureNodeTexture_node_output_set(PointerRNA *ptr, int value);

PointerRNA TextureNodeTexture_texture_get(PointerRNA *ptr);

bool TextureNodeTexture_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeTexture_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeTexture_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeTranslate ****************/

extern StructRNA RNA_TextureNodeTranslate;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeTranslate_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeTranslate_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeTranslate_output_template_func(struct StructRNA *_type, int index);
/**************** Texture Node Tree ****************/

extern StructRNA RNA_TextureNodeTree;
extern StructRNA RNA_NodeTree;
extern StructRNA RNA_ID;

/**************** TextureNodeValToNor ****************/

extern StructRNA RNA_TextureNodeValToNor;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeValToNor_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeValToNor_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeValToNor_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeValToRGB ****************/

extern StructRNA RNA_TextureNodeValToRGB;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

PointerRNA TextureNodeValToRGB_color_ramp_get(PointerRNA *ptr);

bool TextureNodeValToRGB_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeValToRGB_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeValToRGB_output_template_func(struct StructRNA *_type, int index);
/**************** TextureNodeViewer ****************/

extern StructRNA RNA_TextureNodeViewer;
extern StructRNA RNA_TextureNode;
extern StructRNA RNA_NodeInternal;
extern StructRNA RNA_Node;

bool TextureNodeViewer_is_registered_node_type_func(struct StructRNA *_type);
struct PointerRNA TextureNodeViewer_input_template_func(struct StructRNA *_type, int index);
struct PointerRNA TextureNodeViewer_output_template_func(struct StructRNA *_type, int index);
/**************** Texture Slot ****************/

extern StructRNA RNA_TextureSlot;

PointerRNA TextureSlot_rna_type_get(PointerRNA *ptr);

void TextureSlot_name_get(PointerRNA *ptr, char *value);
int TextureSlot_name_length(PointerRNA *ptr);
void TextureSlot_name_set(PointerRNA *ptr, const char *value);

enum {
	TextureSlot_blend_type_MIX = 0,
	TextureSlot_blend_type_DARKEN = 5,
	TextureSlot_blend_type_MULTIPLY = 1,
	TextureSlot_blend_type_LIGHTEN = 7,
	TextureSlot_blend_type_SCREEN = 8,
	TextureSlot_blend_type_ADD = 2,
	TextureSlot_blend_type_OVERLAY = 9,
	TextureSlot_blend_type_SOFT_LIGHT = 15,
	TextureSlot_blend_type_LINEAR_LIGHT = 16,
	TextureSlot_blend_type_DIFFERENCE = 6,
	TextureSlot_blend_type_SUBTRACT = 3,
	TextureSlot_blend_type_DIVIDE = 4,
	TextureSlot_blend_type_HUE = 10,
	TextureSlot_blend_type_SATURATION = 11,
	TextureSlot_blend_type_COLOR = 13,
	TextureSlot_blend_type_VALUE = 12,
};

int TextureSlot_blend_type_get(PointerRNA *ptr);
void TextureSlot_blend_type_set(PointerRNA *ptr, int value);

void TextureSlot_color_get(PointerRNA *ptr, float values[3]);
void TextureSlot_color_set(PointerRNA *ptr, const float values[3]);

float TextureSlot_default_value_get(PointerRNA *ptr);
void TextureSlot_default_value_set(PointerRNA *ptr, float value);

void TextureSlot_offset_get(PointerRNA *ptr, float values[3]);
void TextureSlot_offset_set(PointerRNA *ptr, const float values[3]);

enum {
	TextureSlot_output_node_DEFAULT = 0,
};

int TextureSlot_output_node_get(PointerRNA *ptr);
void TextureSlot_output_node_set(PointerRNA *ptr, int value);

void TextureSlot_scale_get(PointerRNA *ptr, float values[3]);
void TextureSlot_scale_set(PointerRNA *ptr, const float values[3]);

PointerRNA TextureSlot_texture_get(PointerRNA *ptr);

/**************** Theme ****************/

extern StructRNA RNA_Theme;

PointerRNA Theme_rna_type_get(PointerRNA *ptr);

#define Theme_name_MAX 64

void Theme_name_get(PointerRNA *ptr, char *value);
int Theme_name_length(PointerRNA *ptr);
void Theme_name_set(PointerRNA *ptr, const char *value);

PointerRNA Theme_view_3d_get(PointerRNA *ptr);

enum {
	Theme_theme_area_USER_INTERFACE = 0,
	Theme_theme_area_STYLE = 19,
	Theme_theme_area_VIEW_3D = 1,
	Theme_theme_area_DOPESHEET_EDITOR = 4,
	Theme_theme_area_FILE_BROWSER = 16,
	Theme_theme_area_GRAPH_EDITOR = 3,
	Theme_theme_area_IMAGE_EDITOR = 6,
	Theme_theme_area_INFO = 15,
	Theme_theme_area_CLIP_EDITOR = 20,
	Theme_theme_area_NODE_EDITOR = 9,
	Theme_theme_area_NLA_EDITOR = 5,
	Theme_theme_area_OUTLINER = 12,
	Theme_theme_area_PREFERENCES = 14,
	Theme_theme_area_PROPERTIES = 11,
	Theme_theme_area_CONSOLE = 17,
	Theme_theme_area_SPREADSHEET = 23,
	Theme_theme_area_STATUSBAR = 22,
	Theme_theme_area_TEXT_EDITOR = 8,
	Theme_theme_area_TOPBAR = 21,
	Theme_theme_area_SEQUENCE_EDITOR = 7,
	Theme_theme_area_BONE_COLOR_SETS = 18,
};

int Theme_theme_area_get(PointerRNA *ptr);
void Theme_theme_area_set(PointerRNA *ptr, int value);

void Theme_bone_color_sets_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Theme_bone_color_sets_next(CollectionPropertyIterator *iter);
void Theme_bone_color_sets_end(CollectionPropertyIterator *iter);
int Theme_bone_color_sets_length(PointerRNA *ptr);
bool Theme_bone_color_sets_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

PointerRNA Theme_clip_editor_get(PointerRNA *ptr);

void Theme_collection_color_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Theme_collection_color_next(CollectionPropertyIterator *iter);
void Theme_collection_color_end(CollectionPropertyIterator *iter);
int Theme_collection_color_length(PointerRNA *ptr);
bool Theme_collection_color_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

PointerRNA Theme_console_get(PointerRNA *ptr);

PointerRNA Theme_dopesheet_editor_get(PointerRNA *ptr);

PointerRNA Theme_file_browser_get(PointerRNA *ptr);

#define Theme_filepath_MAX 1024

void Theme_filepath_get(PointerRNA *ptr, char *value);
int Theme_filepath_length(PointerRNA *ptr);
void Theme_filepath_set(PointerRNA *ptr, const char *value);

PointerRNA Theme_graph_editor_get(PointerRNA *ptr);

PointerRNA Theme_image_editor_get(PointerRNA *ptr);

PointerRNA Theme_info_get(PointerRNA *ptr);

PointerRNA Theme_node_editor_get(PointerRNA *ptr);

PointerRNA Theme_nla_editor_get(PointerRNA *ptr);

PointerRNA Theme_outliner_get(PointerRNA *ptr);

PointerRNA Theme_preferences_get(PointerRNA *ptr);

PointerRNA Theme_properties_get(PointerRNA *ptr);

PointerRNA Theme_sequence_editor_get(PointerRNA *ptr);

PointerRNA Theme_spreadsheet_get(PointerRNA *ptr);

PointerRNA Theme_statusbar_get(PointerRNA *ptr);

void Theme_strip_color_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Theme_strip_color_next(CollectionPropertyIterator *iter);
void Theme_strip_color_end(CollectionPropertyIterator *iter);
int Theme_strip_color_length(PointerRNA *ptr);
bool Theme_strip_color_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

PointerRNA Theme_text_editor_get(PointerRNA *ptr);

PointerRNA Theme_topbar_get(PointerRNA *ptr);

PointerRNA Theme_user_interface_get(PointerRNA *ptr);

/**************** Theme Asset Shelf Color ****************/

extern StructRNA RNA_ThemeAssetShelf;

PointerRNA ThemeAssetShelf_rna_type_get(PointerRNA *ptr);

void ThemeAssetShelf_header_back_get(PointerRNA *ptr, float values[4]);
void ThemeAssetShelf_header_back_set(PointerRNA *ptr, const float values[4]);

void ThemeAssetShelf_back_get(PointerRNA *ptr, float values[4]);
void ThemeAssetShelf_back_set(PointerRNA *ptr, const float values[4]);

/**************** Theme Bone Color Set ****************/

extern StructRNA RNA_ThemeBoneColorSet;

PointerRNA ThemeBoneColorSet_rna_type_get(PointerRNA *ptr);

void ThemeBoneColorSet_active_get(PointerRNA *ptr, float values[3]);
void ThemeBoneColorSet_active_set(PointerRNA *ptr, const float values[3]);

bool ThemeBoneColorSet_show_colored_constraints_get(PointerRNA *ptr);
void ThemeBoneColorSet_show_colored_constraints_set(PointerRNA *ptr, bool value);

void ThemeBoneColorSet_normal_get(PointerRNA *ptr, float values[3]);
void ThemeBoneColorSet_normal_set(PointerRNA *ptr, const float values[3]);

void ThemeBoneColorSet_select_get(PointerRNA *ptr, float values[3]);
void ThemeBoneColorSet_select_set(PointerRNA *ptr, const float values[3]);

/**************** Theme Clip Editor ****************/

extern StructRNA RNA_ThemeClipEditor;

PointerRNA ThemeClipEditor_rna_type_get(PointerRNA *ptr);

void ThemeClipEditor_active_marker_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_active_marker_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_handle_align_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_handle_align_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_handle_sel_align_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_handle_sel_align_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_handle_auto_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_handle_auto_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_handle_sel_auto_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_handle_sel_auto_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_handle_auto_clamped_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_handle_auto_clamped_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_handle_sel_auto_clamped_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_handle_sel_auto_clamped_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_frame_current_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_frame_current_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_disabled_marker_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_disabled_marker_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_handle_free_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_handle_free_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_handle_sel_free_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_handle_sel_free_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_grid_get(PointerRNA *ptr, float values[4]);
void ThemeClipEditor_grid_set(PointerRNA *ptr, const float values[4]);

void ThemeClipEditor_handle_vertex_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_handle_vertex_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_handle_vertex_select_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_handle_vertex_select_set(PointerRNA *ptr, const float values[3]);

int ThemeClipEditor_handle_vertex_size_get(PointerRNA *ptr);
void ThemeClipEditor_handle_vertex_size_set(PointerRNA *ptr, int value);

void ThemeClipEditor_locked_marker_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_locked_marker_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_marker_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_marker_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_time_marker_line_get(PointerRNA *ptr, float values[4]);
void ThemeClipEditor_time_marker_line_set(PointerRNA *ptr, const float values[4]);

void ThemeClipEditor_time_marker_line_selected_get(PointerRNA *ptr, float values[4]);
void ThemeClipEditor_time_marker_line_selected_set(PointerRNA *ptr, const float values[4]);

void ThemeClipEditor_marker_outline_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_marker_outline_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_metadatabg_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_metadatabg_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_metadatatext_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_metadatatext_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_path_after_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_path_after_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_path_before_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_path_before_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_path_keyframe_after_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_path_keyframe_after_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_path_keyframe_before_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_path_keyframe_before_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_preview_range_get(PointerRNA *ptr, float values[4]);
void ThemeClipEditor_preview_range_set(PointerRNA *ptr, const float values[4]);

void ThemeClipEditor_time_scrub_background_get(PointerRNA *ptr, float values[4]);
void ThemeClipEditor_time_scrub_background_set(PointerRNA *ptr, const float values[4]);

void ThemeClipEditor_selected_marker_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_selected_marker_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_strips_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_strips_set(PointerRNA *ptr, const float values[3]);

void ThemeClipEditor_strips_selected_get(PointerRNA *ptr, float values[3]);
void ThemeClipEditor_strips_selected_set(PointerRNA *ptr, const float values[3]);

PointerRNA ThemeClipEditor_space_get(PointerRNA *ptr);

PointerRNA ThemeClipEditor_space_list_get(PointerRNA *ptr);

/**************** Theme Collection Color ****************/

extern StructRNA RNA_ThemeCollectionColor;

PointerRNA ThemeCollectionColor_rna_type_get(PointerRNA *ptr);

void ThemeCollectionColor_color_get(PointerRNA *ptr, float values[3]);
void ThemeCollectionColor_color_set(PointerRNA *ptr, const float values[3]);

/**************** Theme Console ****************/

extern StructRNA RNA_ThemeConsole;

PointerRNA ThemeConsole_rna_type_get(PointerRNA *ptr);

void ThemeConsole_cursor_get(PointerRNA *ptr, float values[3]);
void ThemeConsole_cursor_set(PointerRNA *ptr, const float values[3]);

void ThemeConsole_line_error_get(PointerRNA *ptr, float values[3]);
void ThemeConsole_line_error_set(PointerRNA *ptr, const float values[3]);

void ThemeConsole_line_info_get(PointerRNA *ptr, float values[3]);
void ThemeConsole_line_info_set(PointerRNA *ptr, const float values[3]);

void ThemeConsole_line_input_get(PointerRNA *ptr, float values[3]);
void ThemeConsole_line_input_set(PointerRNA *ptr, const float values[3]);

void ThemeConsole_line_output_get(PointerRNA *ptr, float values[3]);
void ThemeConsole_line_output_set(PointerRNA *ptr, const float values[3]);

void ThemeConsole_select_get(PointerRNA *ptr, float values[4]);
void ThemeConsole_select_set(PointerRNA *ptr, const float values[4]);

PointerRNA ThemeConsole_space_get(PointerRNA *ptr);

/**************** Theme Dope Sheet ****************/

extern StructRNA RNA_ThemeDopeSheet;

PointerRNA ThemeDopeSheet_rna_type_get(PointerRNA *ptr);

void ThemeDopeSheet_active_channels_group_get(PointerRNA *ptr, float values[4]);
void ThemeDopeSheet_active_channels_group_set(PointerRNA *ptr, const float values[4]);

void ThemeDopeSheet_keyframe_breakdown_get(PointerRNA *ptr, float values[3]);
void ThemeDopeSheet_keyframe_breakdown_set(PointerRNA *ptr, const float values[3]);

void ThemeDopeSheet_keyframe_breakdown_selected_get(PointerRNA *ptr, float values[3]);
void ThemeDopeSheet_keyframe_breakdown_selected_set(PointerRNA *ptr, const float values[3]);

void ThemeDopeSheet_channel_group_get(PointerRNA *ptr, float values[4]);
void ThemeDopeSheet_channel_group_set(PointerRNA *ptr, const float values[4]);

void ThemeDopeSheet_channels_get(PointerRNA *ptr, float values[4]);
void ThemeDopeSheet_channels_set(PointerRNA *ptr, const float values[4]);

void ThemeDopeSheet_channels_selected_get(PointerRNA *ptr, float values[4]);
void ThemeDopeSheet_channels_selected_set(PointerRNA *ptr, const float values[4]);

void ThemeDopeSheet_frame_current_get(PointerRNA *ptr, float values[3]);
void ThemeDopeSheet_frame_current_set(PointerRNA *ptr, const float values[3]);

void ThemeDopeSheet_dopesheet_channel_get(PointerRNA *ptr, float values[4]);
void ThemeDopeSheet_dopesheet_channel_set(PointerRNA *ptr, const float values[4]);

void ThemeDopeSheet_dopesheet_subchannel_get(PointerRNA *ptr, float values[4]);
void ThemeDopeSheet_dopesheet_subchannel_set(PointerRNA *ptr, const float values[4]);

void ThemeDopeSheet_keyframe_extreme_get(PointerRNA *ptr, float values[3]);
void ThemeDopeSheet_keyframe_extreme_set(PointerRNA *ptr, const float values[3]);

void ThemeDopeSheet_keyframe_extreme_selected_get(PointerRNA *ptr, float values[3]);
void ThemeDopeSheet_keyframe_extreme_selected_set(PointerRNA *ptr, const float values[3]);

void ThemeDopeSheet_keyframe_generated_get(PointerRNA *ptr, float values[3]);
void ThemeDopeSheet_keyframe_generated_set(PointerRNA *ptr, const float values[3]);

void ThemeDopeSheet_keyframe_generated_selected_get(PointerRNA *ptr, float values[3]);
void ThemeDopeSheet_keyframe_generated_selected_set(PointerRNA *ptr, const float values[3]);

void ThemeDopeSheet_grid_get(PointerRNA *ptr, float values[3]);
void ThemeDopeSheet_grid_set(PointerRNA *ptr, const float values[3]);

void ThemeDopeSheet_interpolation_line_get(PointerRNA *ptr, float values[4]);
void ThemeDopeSheet_interpolation_line_set(PointerRNA *ptr, const float values[4]);

void ThemeDopeSheet_keyframe_jitter_get(PointerRNA *ptr, float values[3]);
void ThemeDopeSheet_keyframe_jitter_set(PointerRNA *ptr, const float values[3]);

void ThemeDopeSheet_keyframe_jitter_selected_get(PointerRNA *ptr, float values[3]);
void ThemeDopeSheet_keyframe_jitter_selected_set(PointerRNA *ptr, const float values[3]);

void ThemeDopeSheet_keyframe_get(PointerRNA *ptr, float values[3]);
void ThemeDopeSheet_keyframe_set(PointerRNA *ptr, const float values[3]);

void ThemeDopeSheet_keyframe_border_get(PointerRNA *ptr, float values[4]);
void ThemeDopeSheet_keyframe_border_set(PointerRNA *ptr, const float values[4]);

void ThemeDopeSheet_keyframe_border_selected_get(PointerRNA *ptr, float values[4]);
void ThemeDopeSheet_keyframe_border_selected_set(PointerRNA *ptr, const float values[4]);

float ThemeDopeSheet_keyframe_scale_factor_get(PointerRNA *ptr);
void ThemeDopeSheet_keyframe_scale_factor_set(PointerRNA *ptr, float value);

void ThemeDopeSheet_keyframe_selected_get(PointerRNA *ptr, float values[3]);
void ThemeDopeSheet_keyframe_selected_set(PointerRNA *ptr, const float values[3]);

void ThemeDopeSheet_long_key_get(PointerRNA *ptr, float values[4]);
void ThemeDopeSheet_long_key_set(PointerRNA *ptr, const float values[4]);

void ThemeDopeSheet_long_key_selected_get(PointerRNA *ptr, float values[4]);
void ThemeDopeSheet_long_key_selected_set(PointerRNA *ptr, const float values[4]);

void ThemeDopeSheet_time_marker_line_get(PointerRNA *ptr, float values[4]);
void ThemeDopeSheet_time_marker_line_set(PointerRNA *ptr, const float values[4]);

void ThemeDopeSheet_time_marker_line_selected_get(PointerRNA *ptr, float values[4]);
void ThemeDopeSheet_time_marker_line_selected_set(PointerRNA *ptr, const float values[4]);

void ThemeDopeSheet_keyframe_movehold_get(PointerRNA *ptr, float values[3]);
void ThemeDopeSheet_keyframe_movehold_set(PointerRNA *ptr, const float values[3]);

void ThemeDopeSheet_keyframe_movehold_selected_get(PointerRNA *ptr, float values[3]);
void ThemeDopeSheet_keyframe_movehold_selected_set(PointerRNA *ptr, const float values[3]);

void ThemeDopeSheet_preview_range_get(PointerRNA *ptr, float values[4]);
void ThemeDopeSheet_preview_range_set(PointerRNA *ptr, const float values[4]);

void ThemeDopeSheet_time_scrub_background_get(PointerRNA *ptr, float values[4]);
void ThemeDopeSheet_time_scrub_background_set(PointerRNA *ptr, const float values[4]);

void ThemeDopeSheet_simulated_frames_get(PointerRNA *ptr, float values[4]);
void ThemeDopeSheet_simulated_frames_set(PointerRNA *ptr, const float values[4]);

void ThemeDopeSheet_summary_get(PointerRNA *ptr, float values[4]);
void ThemeDopeSheet_summary_set(PointerRNA *ptr, const float values[4]);

PointerRNA ThemeDopeSheet_space_get(PointerRNA *ptr);

PointerRNA ThemeDopeSheet_space_list_get(PointerRNA *ptr);

void ThemeDopeSheet_value_sliders_get(PointerRNA *ptr, float values[3]);
void ThemeDopeSheet_value_sliders_set(PointerRNA *ptr, const float values[3]);

void ThemeDopeSheet_view_sliders_get(PointerRNA *ptr, float values[3]);
void ThemeDopeSheet_view_sliders_set(PointerRNA *ptr, const float values[3]);

/**************** Theme File Browser ****************/

extern StructRNA RNA_ThemeFileBrowser;

PointerRNA ThemeFileBrowser_rna_type_get(PointerRNA *ptr);

void ThemeFileBrowser_row_alternate_get(PointerRNA *ptr, float values[4]);
void ThemeFileBrowser_row_alternate_set(PointerRNA *ptr, const float values[4]);

void ThemeFileBrowser_selected_file_get(PointerRNA *ptr, float values[3]);
void ThemeFileBrowser_selected_file_set(PointerRNA *ptr, const float values[3]);

PointerRNA ThemeFileBrowser_space_get(PointerRNA *ptr);

/**************** Font Style ****************/

extern StructRNA RNA_ThemeFontStyle;

PointerRNA ThemeFontStyle_rna_type_get(PointerRNA *ptr);

int ThemeFontStyle_character_weight_get(PointerRNA *ptr);
void ThemeFontStyle_character_weight_set(PointerRNA *ptr, int value);

float ThemeFontStyle_points_get(PointerRNA *ptr);
void ThemeFontStyle_points_set(PointerRNA *ptr, float value);

float ThemeFontStyle_shadow_alpha_get(PointerRNA *ptr);
void ThemeFontStyle_shadow_alpha_set(PointerRNA *ptr, float value);

float ThemeFontStyle_shadow_value_get(PointerRNA *ptr);
void ThemeFontStyle_shadow_value_set(PointerRNA *ptr, float value);

int ThemeFontStyle_shadow_get(PointerRNA *ptr);
void ThemeFontStyle_shadow_set(PointerRNA *ptr, int value);

int ThemeFontStyle_shadow_offset_x_get(PointerRNA *ptr);
void ThemeFontStyle_shadow_offset_x_set(PointerRNA *ptr, int value);

int ThemeFontStyle_shadow_offset_y_get(PointerRNA *ptr);
void ThemeFontStyle_shadow_offset_y_set(PointerRNA *ptr, int value);

/**************** Theme Background Color ****************/

extern StructRNA RNA_ThemeGradientColors;

PointerRNA ThemeGradientColors_rna_type_get(PointerRNA *ptr);

enum {
	ThemeGradientColors_background_type_SINGLE_COLOR = 0,
	ThemeGradientColors_background_type_LINEAR = 1,
	ThemeGradientColors_background_type_RADIAL = 2,
};

int ThemeGradientColors_background_type_get(PointerRNA *ptr);
void ThemeGradientColors_background_type_set(PointerRNA *ptr, int value);

void ThemeGradientColors_high_gradient_get(PointerRNA *ptr, float values[3]);
void ThemeGradientColors_high_gradient_set(PointerRNA *ptr, const float values[3]);

void ThemeGradientColors_gradient_get(PointerRNA *ptr, float values[3]);
void ThemeGradientColors_gradient_set(PointerRNA *ptr, const float values[3]);

/**************** Theme Graph Editor ****************/

extern StructRNA RNA_ThemeGraphEditor;

PointerRNA ThemeGraphEditor_rna_type_get(PointerRNA *ptr);

void ThemeGraphEditor_active_channels_group_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_active_channels_group_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_vertex_active_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_vertex_active_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_handle_align_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_handle_align_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_handle_sel_align_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_handle_sel_align_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_handle_auto_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_handle_auto_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_handle_sel_auto_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_handle_sel_auto_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_handle_auto_clamped_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_handle_auto_clamped_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_handle_sel_auto_clamped_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_handle_sel_auto_clamped_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_channel_group_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_channel_group_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_channels_region_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_channels_region_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_frame_current_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_frame_current_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_dopesheet_channel_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_dopesheet_channel_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_dopesheet_subchannel_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_dopesheet_subchannel_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_handle_free_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_handle_free_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_handle_sel_free_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_handle_sel_free_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_grid_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_grid_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_handle_vertex_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_handle_vertex_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_handle_vertex_select_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_handle_vertex_select_set(PointerRNA *ptr, const float values[3]);

int ThemeGraphEditor_handle_vertex_size_get(PointerRNA *ptr);
void ThemeGraphEditor_handle_vertex_size_set(PointerRNA *ptr, int value);

void ThemeGraphEditor_lastsel_point_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_lastsel_point_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_time_marker_line_get(PointerRNA *ptr, float values[4]);
void ThemeGraphEditor_time_marker_line_set(PointerRNA *ptr, const float values[4]);

void ThemeGraphEditor_time_marker_line_selected_get(PointerRNA *ptr, float values[4]);
void ThemeGraphEditor_time_marker_line_selected_set(PointerRNA *ptr, const float values[4]);

void ThemeGraphEditor_preview_range_get(PointerRNA *ptr, float values[4]);
void ThemeGraphEditor_preview_range_set(PointerRNA *ptr, const float values[4]);

void ThemeGraphEditor_time_scrub_background_get(PointerRNA *ptr, float values[4]);
void ThemeGraphEditor_time_scrub_background_set(PointerRNA *ptr, const float values[4]);

PointerRNA ThemeGraphEditor_space_get(PointerRNA *ptr);

PointerRNA ThemeGraphEditor_space_list_get(PointerRNA *ptr);

void ThemeGraphEditor_handle_vect_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_handle_vect_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_handle_sel_vect_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_handle_sel_vect_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_vertex_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_vertex_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_vertex_bevel_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_vertex_bevel_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_vertex_unreferenced_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_vertex_unreferenced_set(PointerRNA *ptr, const float values[3]);

void ThemeGraphEditor_vertex_select_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_vertex_select_set(PointerRNA *ptr, const float values[3]);

int ThemeGraphEditor_vertex_size_get(PointerRNA *ptr);
void ThemeGraphEditor_vertex_size_set(PointerRNA *ptr, int value);

void ThemeGraphEditor_window_sliders_get(PointerRNA *ptr, float values[3]);
void ThemeGraphEditor_window_sliders_set(PointerRNA *ptr, const float values[3]);

/**************** Theme Image Editor ****************/

extern StructRNA RNA_ThemeImageEditor;

PointerRNA ThemeImageEditor_rna_type_get(PointerRNA *ptr);

void ThemeImageEditor_editmesh_active_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_editmesh_active_set(PointerRNA *ptr, const float values[4]);

void ThemeImageEditor_handle_align_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_handle_align_set(PointerRNA *ptr, const float values[3]);

void ThemeImageEditor_handle_sel_align_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_handle_sel_align_set(PointerRNA *ptr, const float values[3]);

PointerRNA ThemeImageEditor_asset_shelf_get(PointerRNA *ptr);

void ThemeImageEditor_handle_auto_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_handle_auto_set(PointerRNA *ptr, const float values[3]);

void ThemeImageEditor_handle_sel_auto_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_handle_sel_auto_set(PointerRNA *ptr, const float values[3]);

void ThemeImageEditor_handle_auto_clamped_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_handle_auto_clamped_set(PointerRNA *ptr, const float values[3]);

void ThemeImageEditor_handle_sel_auto_clamped_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_handle_sel_auto_clamped_set(PointerRNA *ptr, const float values[3]);

void ThemeImageEditor_frame_current_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_frame_current_set(PointerRNA *ptr, const float values[3]);

void ThemeImageEditor_edge_select_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_edge_select_set(PointerRNA *ptr, const float values[3]);

int ThemeImageEditor_edge_width_get(PointerRNA *ptr);
void ThemeImageEditor_edge_width_set(PointerRNA *ptr, int value);

void ThemeImageEditor_face_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_face_set(PointerRNA *ptr, const float values[4]);

void ThemeImageEditor_face_dot_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_face_dot_set(PointerRNA *ptr, const float values[3]);

int ThemeImageEditor_facedot_size_get(PointerRNA *ptr);
void ThemeImageEditor_facedot_size_set(PointerRNA *ptr, int value);

void ThemeImageEditor_face_mode_select_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_face_mode_select_set(PointerRNA *ptr, const float values[4]);

void ThemeImageEditor_face_back_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_face_back_set(PointerRNA *ptr, const float values[4]);

void ThemeImageEditor_face_front_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_face_front_set(PointerRNA *ptr, const float values[4]);

void ThemeImageEditor_face_retopology_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_face_retopology_set(PointerRNA *ptr, const float values[4]);

void ThemeImageEditor_face_select_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_face_select_set(PointerRNA *ptr, const float values[4]);

void ThemeImageEditor_handle_free_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_handle_free_set(PointerRNA *ptr, const float values[3]);

void ThemeImageEditor_handle_sel_free_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_handle_sel_free_set(PointerRNA *ptr, const float values[3]);

void ThemeImageEditor_freestyle_face_mark_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_freestyle_face_mark_set(PointerRNA *ptr, const float values[4]);

void ThemeImageEditor_grid_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_grid_set(PointerRNA *ptr, const float values[4]);

void ThemeImageEditor_handle_vertex_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_handle_vertex_set(PointerRNA *ptr, const float values[3]);

void ThemeImageEditor_handle_vertex_select_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_handle_vertex_select_set(PointerRNA *ptr, const float values[3]);

int ThemeImageEditor_handle_vertex_size_get(PointerRNA *ptr);
void ThemeImageEditor_handle_vertex_size_set(PointerRNA *ptr, int value);

void ThemeImageEditor_metadatabg_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_metadatabg_set(PointerRNA *ptr, const float values[3]);

void ThemeImageEditor_metadatatext_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_metadatatext_set(PointerRNA *ptr, const float values[3]);

void ThemeImageEditor_paint_curve_handle_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_paint_curve_handle_set(PointerRNA *ptr, const float values[4]);

void ThemeImageEditor_paint_curve_pivot_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_paint_curve_pivot_set(PointerRNA *ptr, const float values[4]);

void ThemeImageEditor_scope_back_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_scope_back_set(PointerRNA *ptr, const float values[4]);

void ThemeImageEditor_preview_stitch_active_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_preview_stitch_active_set(PointerRNA *ptr, const float values[4]);

void ThemeImageEditor_preview_stitch_edge_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_preview_stitch_edge_set(PointerRNA *ptr, const float values[4]);

void ThemeImageEditor_preview_stitch_face_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_preview_stitch_face_set(PointerRNA *ptr, const float values[4]);

void ThemeImageEditor_preview_stitch_stitchable_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_preview_stitch_stitchable_set(PointerRNA *ptr, const float values[4]);

void ThemeImageEditor_preview_stitch_unstitchable_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_preview_stitch_unstitchable_set(PointerRNA *ptr, const float values[4]);

void ThemeImageEditor_preview_stitch_vert_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_preview_stitch_vert_set(PointerRNA *ptr, const float values[4]);

void ThemeImageEditor_uv_shadow_get(PointerRNA *ptr, float values[4]);
void ThemeImageEditor_uv_shadow_set(PointerRNA *ptr, const float values[4]);

PointerRNA ThemeImageEditor_space_get(PointerRNA *ptr);

void ThemeImageEditor_vertex_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_vertex_set(PointerRNA *ptr, const float values[3]);

void ThemeImageEditor_vertex_bevel_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_vertex_bevel_set(PointerRNA *ptr, const float values[3]);

void ThemeImageEditor_vertex_unreferenced_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_vertex_unreferenced_set(PointerRNA *ptr, const float values[3]);

void ThemeImageEditor_vertex_select_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_vertex_select_set(PointerRNA *ptr, const float values[3]);

int ThemeImageEditor_vertex_size_get(PointerRNA *ptr);
void ThemeImageEditor_vertex_size_set(PointerRNA *ptr, int value);

void ThemeImageEditor_wire_edit_get(PointerRNA *ptr, float values[3]);
void ThemeImageEditor_wire_edit_set(PointerRNA *ptr, const float values[3]);

/**************** Theme Info ****************/

extern StructRNA RNA_ThemeInfo;

PointerRNA ThemeInfo_rna_type_get(PointerRNA *ptr);

void ThemeInfo_info_debug_get(PointerRNA *ptr, float values[4]);
void ThemeInfo_info_debug_set(PointerRNA *ptr, const float values[4]);

void ThemeInfo_info_debug_text_get(PointerRNA *ptr, float values[3]);
void ThemeInfo_info_debug_text_set(PointerRNA *ptr, const float values[3]);

void ThemeInfo_info_error_text_get(PointerRNA *ptr, float values[3]);
void ThemeInfo_info_error_text_set(PointerRNA *ptr, const float values[3]);

void ThemeInfo_info_info_text_get(PointerRNA *ptr, float values[3]);
void ThemeInfo_info_info_text_set(PointerRNA *ptr, const float values[3]);

void ThemeInfo_info_operator_get(PointerRNA *ptr, float values[4]);
void ThemeInfo_info_operator_set(PointerRNA *ptr, const float values[4]);

void ThemeInfo_info_operator_text_get(PointerRNA *ptr, float values[3]);
void ThemeInfo_info_operator_text_set(PointerRNA *ptr, const float values[3]);

void ThemeInfo_info_property_get(PointerRNA *ptr, float values[4]);
void ThemeInfo_info_property_set(PointerRNA *ptr, const float values[4]);

void ThemeInfo_info_property_text_get(PointerRNA *ptr, float values[3]);
void ThemeInfo_info_property_text_set(PointerRNA *ptr, const float values[3]);

void ThemeInfo_info_selected_get(PointerRNA *ptr, float values[3]);
void ThemeInfo_info_selected_set(PointerRNA *ptr, const float values[3]);

void ThemeInfo_info_selected_text_get(PointerRNA *ptr, float values[3]);
void ThemeInfo_info_selected_text_set(PointerRNA *ptr, const float values[3]);

PointerRNA ThemeInfo_space_get(PointerRNA *ptr);

void ThemeInfo_info_warning_text_get(PointerRNA *ptr, float values[3]);
void ThemeInfo_info_warning_text_set(PointerRNA *ptr, const float values[3]);

/**************** Theme Nonlinear Animation ****************/

extern StructRNA RNA_ThemeNLAEditor;

PointerRNA ThemeNLAEditor_rna_type_get(PointerRNA *ptr);

void ThemeNLAEditor_active_action_get(PointerRNA *ptr, float values[4]);
void ThemeNLAEditor_active_action_set(PointerRNA *ptr, const float values[4]);

void ThemeNLAEditor_dopesheet_channel_get(PointerRNA *ptr, float values[3]);
void ThemeNLAEditor_dopesheet_channel_set(PointerRNA *ptr, const float values[3]);

void ThemeNLAEditor_frame_current_get(PointerRNA *ptr, float values[3]);
void ThemeNLAEditor_frame_current_set(PointerRNA *ptr, const float values[3]);

void ThemeNLAEditor_grid_get(PointerRNA *ptr, float values[3]);
void ThemeNLAEditor_grid_set(PointerRNA *ptr, const float values[3]);

void ThemeNLAEditor_keyframe_border_get(PointerRNA *ptr, float values[4]);
void ThemeNLAEditor_keyframe_border_set(PointerRNA *ptr, const float values[4]);

void ThemeNLAEditor_keyframe_border_selected_get(PointerRNA *ptr, float values[4]);
void ThemeNLAEditor_keyframe_border_selected_set(PointerRNA *ptr, const float values[4]);

void ThemeNLAEditor_time_marker_line_get(PointerRNA *ptr, float values[4]);
void ThemeNLAEditor_time_marker_line_set(PointerRNA *ptr, const float values[4]);

void ThemeNLAEditor_time_marker_line_selected_get(PointerRNA *ptr, float values[4]);
void ThemeNLAEditor_time_marker_line_selected_set(PointerRNA *ptr, const float values[4]);

void ThemeNLAEditor_meta_strips_get(PointerRNA *ptr, float values[3]);
void ThemeNLAEditor_meta_strips_set(PointerRNA *ptr, const float values[3]);

void ThemeNLAEditor_meta_strips_selected_get(PointerRNA *ptr, float values[3]);
void ThemeNLAEditor_meta_strips_selected_set(PointerRNA *ptr, const float values[3]);

void ThemeNLAEditor_active_action_unset_get(PointerRNA *ptr, float values[4]);
void ThemeNLAEditor_active_action_unset_set(PointerRNA *ptr, const float values[4]);

void ThemeNLAEditor_preview_range_get(PointerRNA *ptr, float values[4]);
void ThemeNLAEditor_preview_range_set(PointerRNA *ptr, const float values[4]);

void ThemeNLAEditor_time_scrub_background_get(PointerRNA *ptr, float values[4]);
void ThemeNLAEditor_time_scrub_background_set(PointerRNA *ptr, const float values[4]);

void ThemeNLAEditor_sound_strips_get(PointerRNA *ptr, float values[3]);
void ThemeNLAEditor_sound_strips_set(PointerRNA *ptr, const float values[3]);

void ThemeNLAEditor_sound_strips_selected_get(PointerRNA *ptr, float values[3]);
void ThemeNLAEditor_sound_strips_selected_set(PointerRNA *ptr, const float values[3]);

void ThemeNLAEditor_strips_get(PointerRNA *ptr, float values[3]);
void ThemeNLAEditor_strips_set(PointerRNA *ptr, const float values[3]);

void ThemeNLAEditor_strips_selected_get(PointerRNA *ptr, float values[3]);
void ThemeNLAEditor_strips_selected_set(PointerRNA *ptr, const float values[3]);

void ThemeNLAEditor_dopesheet_subchannel_get(PointerRNA *ptr, float values[3]);
void ThemeNLAEditor_dopesheet_subchannel_set(PointerRNA *ptr, const float values[3]);

PointerRNA ThemeNLAEditor_space_get(PointerRNA *ptr);

PointerRNA ThemeNLAEditor_space_list_get(PointerRNA *ptr);

void ThemeNLAEditor_nla_track_get(PointerRNA *ptr, float values[3]);
void ThemeNLAEditor_nla_track_set(PointerRNA *ptr, const float values[3]);

void ThemeNLAEditor_transition_strips_get(PointerRNA *ptr, float values[3]);
void ThemeNLAEditor_transition_strips_set(PointerRNA *ptr, const float values[3]);

void ThemeNLAEditor_transition_strips_selected_get(PointerRNA *ptr, float values[3]);
void ThemeNLAEditor_transition_strips_selected_set(PointerRNA *ptr, const float values[3]);

void ThemeNLAEditor_tweak_get(PointerRNA *ptr, float values[3]);
void ThemeNLAEditor_tweak_set(PointerRNA *ptr, const float values[3]);

void ThemeNLAEditor_tweak_duplicate_get(PointerRNA *ptr, float values[3]);
void ThemeNLAEditor_tweak_duplicate_set(PointerRNA *ptr, const float values[3]);

void ThemeNLAEditor_view_sliders_get(PointerRNA *ptr, float values[3]);
void ThemeNLAEditor_view_sliders_set(PointerRNA *ptr, const float values[3]);

/**************** Theme Node Editor ****************/

extern StructRNA RNA_ThemeNodeEditor;

PointerRNA ThemeNodeEditor_rna_type_get(PointerRNA *ptr);

void ThemeNodeEditor_node_active_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_node_active_set(PointerRNA *ptr, const float values[3]);

void ThemeNodeEditor_attribute_node_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_attribute_node_set(PointerRNA *ptr, const float values[3]);

void ThemeNodeEditor_closure_zone_get(PointerRNA *ptr, float values[4]);
void ThemeNodeEditor_closure_zone_set(PointerRNA *ptr, const float values[4]);

void ThemeNodeEditor_color_node_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_color_node_set(PointerRNA *ptr, const float values[3]);

void ThemeNodeEditor_converter_node_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_converter_node_set(PointerRNA *ptr, const float values[3]);

float ThemeNodeEditor_dash_alpha_get(PointerRNA *ptr);
void ThemeNodeEditor_dash_alpha_set(PointerRNA *ptr, float value);

void ThemeNodeEditor_distor_node_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_distor_node_set(PointerRNA *ptr, const float values[3]);

void ThemeNodeEditor_filter_node_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_filter_node_set(PointerRNA *ptr, const float values[3]);

void ThemeNodeEditor_foreach_geometry_element_zone_get(PointerRNA *ptr, float values[4]);
void ThemeNodeEditor_foreach_geometry_element_zone_set(PointerRNA *ptr, const float values[4]);

void ThemeNodeEditor_frame_node_get(PointerRNA *ptr, float values[4]);
void ThemeNodeEditor_frame_node_set(PointerRNA *ptr, const float values[4]);

void ThemeNodeEditor_geometry_node_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_geometry_node_set(PointerRNA *ptr, const float values[3]);

void ThemeNodeEditor_grid_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_grid_set(PointerRNA *ptr, const float values[3]);

int ThemeNodeEditor_grid_levels_get(PointerRNA *ptr);
void ThemeNodeEditor_grid_levels_set(PointerRNA *ptr, int value);

void ThemeNodeEditor_group_node_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_group_node_set(PointerRNA *ptr, const float values[3]);

void ThemeNodeEditor_group_socket_node_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_group_socket_node_set(PointerRNA *ptr, const float values[3]);

void ThemeNodeEditor_input_node_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_input_node_set(PointerRNA *ptr, const float values[3]);

void ThemeNodeEditor_layout_node_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_layout_node_set(PointerRNA *ptr, const float values[3]);

void ThemeNodeEditor_matte_node_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_matte_node_set(PointerRNA *ptr, const float values[3]);

void ThemeNodeEditor_node_backdrop_get(PointerRNA *ptr, float values[4]);
void ThemeNodeEditor_node_backdrop_set(PointerRNA *ptr, const float values[4]);

void ThemeNodeEditor_node_selected_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_node_selected_set(PointerRNA *ptr, const float values[3]);

int ThemeNodeEditor_noodle_curving_get(PointerRNA *ptr);
void ThemeNodeEditor_noodle_curving_set(PointerRNA *ptr, int value);

void ThemeNodeEditor_output_node_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_output_node_set(PointerRNA *ptr, const float values[3]);

void ThemeNodeEditor_pattern_node_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_pattern_node_set(PointerRNA *ptr, const float values[3]);

void ThemeNodeEditor_repeat_zone_get(PointerRNA *ptr, float values[4]);
void ThemeNodeEditor_repeat_zone_set(PointerRNA *ptr, const float values[4]);

void ThemeNodeEditor_script_node_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_script_node_set(PointerRNA *ptr, const float values[3]);

void ThemeNodeEditor_selected_text_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_selected_text_set(PointerRNA *ptr, const float values[3]);

void ThemeNodeEditor_shader_node_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_shader_node_set(PointerRNA *ptr, const float values[3]);

void ThemeNodeEditor_simulation_zone_get(PointerRNA *ptr, float values[4]);
void ThemeNodeEditor_simulation_zone_set(PointerRNA *ptr, const float values[4]);

void ThemeNodeEditor_texture_node_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_texture_node_set(PointerRNA *ptr, const float values[3]);

PointerRNA ThemeNodeEditor_space_get(PointerRNA *ptr);

PointerRNA ThemeNodeEditor_space_list_get(PointerRNA *ptr);

void ThemeNodeEditor_vector_node_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_vector_node_set(PointerRNA *ptr, const float values[3]);

void ThemeNodeEditor_wire_inner_get(PointerRNA *ptr, float values[3]);
void ThemeNodeEditor_wire_inner_set(PointerRNA *ptr, const float values[3]);

void ThemeNodeEditor_wire_select_get(PointerRNA *ptr, float values[4]);
void ThemeNodeEditor_wire_select_set(PointerRNA *ptr, const float values[4]);

void ThemeNodeEditor_wire_get(PointerRNA *ptr, float values[4]);
void ThemeNodeEditor_wire_set(PointerRNA *ptr, const float values[4]);

/**************** Theme Outliner ****************/

extern StructRNA RNA_ThemeOutliner;

PointerRNA ThemeOutliner_rna_type_get(PointerRNA *ptr);

void ThemeOutliner_active_get(PointerRNA *ptr, float values[3]);
void ThemeOutliner_active_set(PointerRNA *ptr, const float values[3]);

void ThemeOutliner_active_object_get(PointerRNA *ptr, float values[3]);
void ThemeOutliner_active_object_set(PointerRNA *ptr, const float values[3]);

void ThemeOutliner_row_alternate_get(PointerRNA *ptr, float values[4]);
void ThemeOutliner_row_alternate_set(PointerRNA *ptr, const float values[4]);

void ThemeOutliner_edited_object_get(PointerRNA *ptr, float values[4]);
void ThemeOutliner_edited_object_set(PointerRNA *ptr, const float values[4]);

void ThemeOutliner_match_get(PointerRNA *ptr, float values[3]);
void ThemeOutliner_match_set(PointerRNA *ptr, const float values[3]);

void ThemeOutliner_selected_highlight_get(PointerRNA *ptr, float values[3]);
void ThemeOutliner_selected_highlight_set(PointerRNA *ptr, const float values[3]);

void ThemeOutliner_selected_object_get(PointerRNA *ptr, float values[3]);
void ThemeOutliner_selected_object_set(PointerRNA *ptr, const float values[3]);

PointerRNA ThemeOutliner_space_get(PointerRNA *ptr);

/**************** Theme Panel Color ****************/

extern StructRNA RNA_ThemePanelColors;

PointerRNA ThemePanelColors_rna_type_get(PointerRNA *ptr);

void ThemePanelColors_back_get(PointerRNA *ptr, float values[4]);
void ThemePanelColors_back_set(PointerRNA *ptr, const float values[4]);

void ThemePanelColors_header_get(PointerRNA *ptr, float values[4]);
void ThemePanelColors_header_set(PointerRNA *ptr, const float values[4]);

void ThemePanelColors_sub_back_get(PointerRNA *ptr, float values[4]);
void ThemePanelColors_sub_back_set(PointerRNA *ptr, const float values[4]);

/**************** Theme Preferences ****************/

extern StructRNA RNA_ThemePreferences;

PointerRNA ThemePreferences_rna_type_get(PointerRNA *ptr);

PointerRNA ThemePreferences_space_get(PointerRNA *ptr);

/**************** Theme Properties ****************/

extern StructRNA RNA_ThemeProperties;

PointerRNA ThemeProperties_rna_type_get(PointerRNA *ptr);

void ThemeProperties_active_modifier_get(PointerRNA *ptr, float values[4]);
void ThemeProperties_active_modifier_set(PointerRNA *ptr, const float values[4]);

void ThemeProperties_match_get(PointerRNA *ptr, float values[3]);
void ThemeProperties_match_set(PointerRNA *ptr, const float values[3]);

PointerRNA ThemeProperties_space_get(PointerRNA *ptr);

/**************** Theme Sequence Editor ****************/

extern StructRNA RNA_ThemeSequenceEditor;

PointerRNA ThemeSequenceEditor_rna_type_get(PointerRNA *ptr);

void ThemeSequenceEditor_active_strip_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_active_strip_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_row_alternate_get(PointerRNA *ptr, float values[4]);
void ThemeSequenceEditor_row_alternate_set(PointerRNA *ptr, const float values[4]);

void ThemeSequenceEditor_audio_strip_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_audio_strip_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_keyframe_breakdown_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_keyframe_breakdown_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_keyframe_breakdown_selected_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_keyframe_breakdown_selected_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_movieclip_strip_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_movieclip_strip_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_color_strip_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_color_strip_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_frame_current_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_frame_current_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_draw_action_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_draw_action_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_effect_strip_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_effect_strip_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_keyframe_generated_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_keyframe_generated_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_keyframe_generated_selected_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_keyframe_generated_selected_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_grid_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_grid_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_image_strip_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_image_strip_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_keyframe_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_keyframe_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_keyframe_border_get(PointerRNA *ptr, float values[4]);
void ThemeSequenceEditor_keyframe_border_set(PointerRNA *ptr, const float values[4]);

void ThemeSequenceEditor_keyframe_border_selected_get(PointerRNA *ptr, float values[4]);
void ThemeSequenceEditor_keyframe_border_selected_set(PointerRNA *ptr, const float values[4]);

void ThemeSequenceEditor_keyframe_selected_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_keyframe_selected_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_time_marker_line_get(PointerRNA *ptr, float values[4]);
void ThemeSequenceEditor_time_marker_line_set(PointerRNA *ptr, const float values[4]);

void ThemeSequenceEditor_time_marker_line_selected_get(PointerRNA *ptr, float values[4]);
void ThemeSequenceEditor_time_marker_line_selected_set(PointerRNA *ptr, const float values[4]);

void ThemeSequenceEditor_mask_strip_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_mask_strip_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_meta_strip_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_meta_strip_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_metadatabg_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_metadatabg_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_metadatatext_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_metadatatext_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_movie_strip_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_movie_strip_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_keyframe_movehold_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_keyframe_movehold_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_keyframe_movehold_selected_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_keyframe_movehold_selected_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_preview_back_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_preview_back_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_preview_range_get(PointerRNA *ptr, float values[4]);
void ThemeSequenceEditor_preview_range_set(PointerRNA *ptr, const float values[4]);

void ThemeSequenceEditor_scene_strip_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_scene_strip_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_time_scrub_background_get(PointerRNA *ptr, float values[4]);
void ThemeSequenceEditor_time_scrub_background_set(PointerRNA *ptr, const float values[4]);

void ThemeSequenceEditor_selected_strip_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_selected_strip_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_selected_text_get(PointerRNA *ptr, float values[4]);
void ThemeSequenceEditor_selected_text_set(PointerRNA *ptr, const float values[4]);

void ThemeSequenceEditor_text_strip_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_text_strip_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_text_strip_cursor_get(PointerRNA *ptr, float values[4]);
void ThemeSequenceEditor_text_strip_cursor_set(PointerRNA *ptr, const float values[4]);

PointerRNA ThemeSequenceEditor_space_get(PointerRNA *ptr);

PointerRNA ThemeSequenceEditor_space_list_get(PointerRNA *ptr);

void ThemeSequenceEditor_transition_strip_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_transition_strip_set(PointerRNA *ptr, const float values[3]);

void ThemeSequenceEditor_window_sliders_get(PointerRNA *ptr, float values[3]);
void ThemeSequenceEditor_window_sliders_set(PointerRNA *ptr, const float values[3]);

/**************** Theme Space Settings ****************/

extern StructRNA RNA_ThemeSpaceGeneric;

PointerRNA ThemeSpaceGeneric_rna_type_get(PointerRNA *ptr);

void ThemeSpaceGeneric_execution_buts_get(PointerRNA *ptr, float values[4]);
void ThemeSpaceGeneric_execution_buts_set(PointerRNA *ptr, const float values[4]);

void ThemeSpaceGeneric_header_get(PointerRNA *ptr, float values[4]);
void ThemeSpaceGeneric_header_set(PointerRNA *ptr, const float values[4]);

void ThemeSpaceGeneric_header_text_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGeneric_header_text_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGeneric_header_text_hi_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGeneric_header_text_hi_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGeneric_navigation_bar_get(PointerRNA *ptr, float values[4]);
void ThemeSpaceGeneric_navigation_bar_set(PointerRNA *ptr, const float values[4]);

PointerRNA ThemeSpaceGeneric_panelcolors_get(PointerRNA *ptr);

void ThemeSpaceGeneric_button_get(PointerRNA *ptr, float values[4]);
void ThemeSpaceGeneric_button_set(PointerRNA *ptr, const float values[4]);

void ThemeSpaceGeneric_button_text_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGeneric_button_text_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGeneric_button_text_hi_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGeneric_button_text_hi_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGeneric_button_title_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGeneric_button_title_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGeneric_tab_active_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGeneric_tab_active_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGeneric_tab_back_get(PointerRNA *ptr, float values[4]);
void ThemeSpaceGeneric_tab_back_set(PointerRNA *ptr, const float values[4]);

void ThemeSpaceGeneric_tab_inactive_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGeneric_tab_inactive_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGeneric_tab_outline_get(PointerRNA *ptr, float values[4]);
void ThemeSpaceGeneric_tab_outline_set(PointerRNA *ptr, const float values[4]);

void ThemeSpaceGeneric_text_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGeneric_text_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGeneric_text_hi_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGeneric_text_hi_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGeneric_title_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGeneric_title_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGeneric_back_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGeneric_back_set(PointerRNA *ptr, const float values[3]);

/**************** Theme Space Settings ****************/

extern StructRNA RNA_ThemeSpaceGradient;

PointerRNA ThemeSpaceGradient_rna_type_get(PointerRNA *ptr);

void ThemeSpaceGradient_execution_buts_get(PointerRNA *ptr, float values[4]);
void ThemeSpaceGradient_execution_buts_set(PointerRNA *ptr, const float values[4]);

PointerRNA ThemeSpaceGradient_gradients_get(PointerRNA *ptr);

void ThemeSpaceGradient_header_get(PointerRNA *ptr, float values[4]);
void ThemeSpaceGradient_header_set(PointerRNA *ptr, const float values[4]);

void ThemeSpaceGradient_header_text_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGradient_header_text_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGradient_header_text_hi_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGradient_header_text_hi_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGradient_navigation_bar_get(PointerRNA *ptr, float values[4]);
void ThemeSpaceGradient_navigation_bar_set(PointerRNA *ptr, const float values[4]);

PointerRNA ThemeSpaceGradient_panelcolors_get(PointerRNA *ptr);

void ThemeSpaceGradient_button_get(PointerRNA *ptr, float values[4]);
void ThemeSpaceGradient_button_set(PointerRNA *ptr, const float values[4]);

void ThemeSpaceGradient_button_text_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGradient_button_text_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGradient_button_text_hi_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGradient_button_text_hi_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGradient_button_title_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGradient_button_title_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGradient_tab_active_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGradient_tab_active_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGradient_tab_back_get(PointerRNA *ptr, float values[4]);
void ThemeSpaceGradient_tab_back_set(PointerRNA *ptr, const float values[4]);

void ThemeSpaceGradient_tab_inactive_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGradient_tab_inactive_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGradient_tab_outline_get(PointerRNA *ptr, float values[4]);
void ThemeSpaceGradient_tab_outline_set(PointerRNA *ptr, const float values[4]);

void ThemeSpaceGradient_text_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGradient_text_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGradient_text_hi_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGradient_text_hi_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceGradient_title_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceGradient_title_set(PointerRNA *ptr, const float values[3]);

/**************** Theme Space List Settings ****************/

extern StructRNA RNA_ThemeSpaceListGeneric;

PointerRNA ThemeSpaceListGeneric_rna_type_get(PointerRNA *ptr);

void ThemeSpaceListGeneric_list_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceListGeneric_list_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceListGeneric_list_text_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceListGeneric_list_text_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceListGeneric_list_text_hi_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceListGeneric_list_text_hi_set(PointerRNA *ptr, const float values[3]);

void ThemeSpaceListGeneric_list_title_get(PointerRNA *ptr, float values[3]);
void ThemeSpaceListGeneric_list_title_set(PointerRNA *ptr, const float values[3]);

/**************** Theme Spreadsheet ****************/

extern StructRNA RNA_ThemeSpreadsheet;

PointerRNA ThemeSpreadsheet_rna_type_get(PointerRNA *ptr);

void ThemeSpreadsheet_row_alternate_get(PointerRNA *ptr, float values[4]);
void ThemeSpreadsheet_row_alternate_set(PointerRNA *ptr, const float values[4]);

PointerRNA ThemeSpreadsheet_space_get(PointerRNA *ptr);

PointerRNA ThemeSpreadsheet_space_list_get(PointerRNA *ptr);

/**************** Theme Status Bar ****************/

extern StructRNA RNA_ThemeStatusBar;

PointerRNA ThemeStatusBar_rna_type_get(PointerRNA *ptr);

PointerRNA ThemeStatusBar_space_get(PointerRNA *ptr);

/**************** Theme Strip Color ****************/

extern StructRNA RNA_ThemeStripColor;

PointerRNA ThemeStripColor_rna_type_get(PointerRNA *ptr);

void ThemeStripColor_color_get(PointerRNA *ptr, float values[3]);
void ThemeStripColor_color_set(PointerRNA *ptr, const float values[3]);

/**************** Style ****************/

extern StructRNA RNA_ThemeStyle;

PointerRNA ThemeStyle_rna_type_get(PointerRNA *ptr);

PointerRNA ThemeStyle_panel_title_get(PointerRNA *ptr);

PointerRNA ThemeStyle_tooltip_get(PointerRNA *ptr);

PointerRNA ThemeStyle_widget_get(PointerRNA *ptr);

/**************** Theme Text Editor ****************/

extern StructRNA RNA_ThemeTextEditor;

PointerRNA ThemeTextEditor_rna_type_get(PointerRNA *ptr);

void ThemeTextEditor_cursor_get(PointerRNA *ptr, float values[3]);
void ThemeTextEditor_cursor_set(PointerRNA *ptr, const float values[3]);

void ThemeTextEditor_line_numbers_get(PointerRNA *ptr, float values[3]);
void ThemeTextEditor_line_numbers_set(PointerRNA *ptr, const float values[3]);

void ThemeTextEditor_line_numbers_background_get(PointerRNA *ptr, float values[3]);
void ThemeTextEditor_line_numbers_background_set(PointerRNA *ptr, const float values[3]);

void ThemeTextEditor_selected_text_get(PointerRNA *ptr, float values[3]);
void ThemeTextEditor_selected_text_set(PointerRNA *ptr, const float values[3]);

void ThemeTextEditor_syntax_builtin_get(PointerRNA *ptr, float values[3]);
void ThemeTextEditor_syntax_builtin_set(PointerRNA *ptr, const float values[3]);

void ThemeTextEditor_syntax_comment_get(PointerRNA *ptr, float values[3]);
void ThemeTextEditor_syntax_comment_set(PointerRNA *ptr, const float values[3]);

void ThemeTextEditor_syntax_numbers_get(PointerRNA *ptr, float values[3]);
void ThemeTextEditor_syntax_numbers_set(PointerRNA *ptr, const float values[3]);

void ThemeTextEditor_syntax_preprocessor_get(PointerRNA *ptr, float values[3]);
void ThemeTextEditor_syntax_preprocessor_set(PointerRNA *ptr, const float values[3]);

void ThemeTextEditor_syntax_reserved_get(PointerRNA *ptr, float values[3]);
void ThemeTextEditor_syntax_reserved_set(PointerRNA *ptr, const float values[3]);

void ThemeTextEditor_syntax_special_get(PointerRNA *ptr, float values[3]);
void ThemeTextEditor_syntax_special_set(PointerRNA *ptr, const float values[3]);

void ThemeTextEditor_syntax_string_get(PointerRNA *ptr, float values[3]);
void ThemeTextEditor_syntax_string_set(PointerRNA *ptr, const float values[3]);

void ThemeTextEditor_syntax_symbols_get(PointerRNA *ptr, float values[3]);
void ThemeTextEditor_syntax_symbols_set(PointerRNA *ptr, const float values[3]);

PointerRNA ThemeTextEditor_space_get(PointerRNA *ptr);

/**************** Theme Top Bar ****************/

extern StructRNA RNA_ThemeTopBar;

PointerRNA ThemeTopBar_rna_type_get(PointerRNA *ptr);

PointerRNA ThemeTopBar_space_get(PointerRNA *ptr);

/**************** Theme User Interface ****************/

extern StructRNA RNA_ThemeUserInterface;

PointerRNA ThemeUserInterface_rna_type_get(PointerRNA *ptr);

void ThemeUserInterface_editor_outline_active_get(PointerRNA *ptr, float values[4]);
void ThemeUserInterface_editor_outline_active_set(PointerRNA *ptr, const float values[4]);

void ThemeUserInterface_icon_autokey_get(PointerRNA *ptr, float values[4]);
void ThemeUserInterface_icon_autokey_set(PointerRNA *ptr, const float values[4]);

PointerRNA ThemeUserInterface_wcol_box_get(PointerRNA *ptr);

int ThemeUserInterface_transparent_checker_size_get(PointerRNA *ptr);
void ThemeUserInterface_transparent_checker_size_set(PointerRNA *ptr, int value);

void ThemeUserInterface_icon_collection_get(PointerRNA *ptr, float values[4]);
void ThemeUserInterface_icon_collection_set(PointerRNA *ptr, const float values[4]);

void ThemeUserInterface_editor_border_get(PointerRNA *ptr, float values[3]);
void ThemeUserInterface_editor_border_set(PointerRNA *ptr, const float values[3]);

void ThemeUserInterface_editor_outline_get(PointerRNA *ptr, float values[4]);
void ThemeUserInterface_editor_outline_set(PointerRNA *ptr, const float values[4]);

void ThemeUserInterface_icon_folder_get(PointerRNA *ptr, float values[4]);
void ThemeUserInterface_icon_folder_set(PointerRNA *ptr, const float values[4]);

void ThemeUserInterface_gizmo_a_get(PointerRNA *ptr, float values[3]);
void ThemeUserInterface_gizmo_a_set(PointerRNA *ptr, const float values[3]);

void ThemeUserInterface_gizmo_b_get(PointerRNA *ptr, float values[3]);
void ThemeUserInterface_gizmo_b_set(PointerRNA *ptr, const float values[3]);

void ThemeUserInterface_gizmo_hi_get(PointerRNA *ptr, float values[3]);
void ThemeUserInterface_gizmo_hi_set(PointerRNA *ptr, const float values[3]);

void ThemeUserInterface_gizmo_primary_get(PointerRNA *ptr, float values[3]);
void ThemeUserInterface_gizmo_primary_set(PointerRNA *ptr, const float values[3]);

void ThemeUserInterface_gizmo_secondary_get(PointerRNA *ptr, float values[3]);
void ThemeUserInterface_gizmo_secondary_set(PointerRNA *ptr, const float values[3]);

void ThemeUserInterface_gizmo_view_align_get(PointerRNA *ptr, float values[3]);
void ThemeUserInterface_gizmo_view_align_set(PointerRNA *ptr, const float values[3]);

float ThemeUserInterface_icon_alpha_get(PointerRNA *ptr);
void ThemeUserInterface_icon_alpha_set(PointerRNA *ptr, float value);

float ThemeUserInterface_icon_border_intensity_get(PointerRNA *ptr);
void ThemeUserInterface_icon_border_intensity_set(PointerRNA *ptr, float value);

float ThemeUserInterface_icon_saturation_get(PointerRNA *ptr);
void ThemeUserInterface_icon_saturation_set(PointerRNA *ptr, float value);

PointerRNA ThemeUserInterface_wcol_list_item_get(PointerRNA *ptr);

PointerRNA ThemeUserInterface_wcol_menu_back_get(PointerRNA *ptr);

PointerRNA ThemeUserInterface_wcol_menu_item_get(PointerRNA *ptr);

float ThemeUserInterface_menu_shadow_fac_get(PointerRNA *ptr);
void ThemeUserInterface_menu_shadow_fac_set(PointerRNA *ptr, float value);

int ThemeUserInterface_menu_shadow_width_get(PointerRNA *ptr);
void ThemeUserInterface_menu_shadow_width_set(PointerRNA *ptr, int value);

PointerRNA ThemeUserInterface_wcol_menu_get(PointerRNA *ptr);

void ThemeUserInterface_icon_modifier_get(PointerRNA *ptr, float values[4]);
void ThemeUserInterface_icon_modifier_set(PointerRNA *ptr, const float values[4]);

PointerRNA ThemeUserInterface_wcol_num_get(PointerRNA *ptr);

void ThemeUserInterface_icon_object_get(PointerRNA *ptr, float values[4]);
void ThemeUserInterface_icon_object_set(PointerRNA *ptr, const float values[4]);

void ThemeUserInterface_icon_object_data_get(PointerRNA *ptr, float values[4]);
void ThemeUserInterface_icon_object_data_set(PointerRNA *ptr, const float values[4]);

PointerRNA ThemeUserInterface_wcol_option_get(PointerRNA *ptr);

float ThemeUserInterface_panel_roundness_get(PointerRNA *ptr);
void ThemeUserInterface_panel_roundness_set(PointerRNA *ptr, float value);

PointerRNA ThemeUserInterface_wcol_pie_menu_get(PointerRNA *ptr);

void ThemeUserInterface_transparent_checker_primary_get(PointerRNA *ptr, float values[3]);
void ThemeUserInterface_transparent_checker_primary_set(PointerRNA *ptr, const float values[3]);

PointerRNA ThemeUserInterface_wcol_progress_get(PointerRNA *ptr);

PointerRNA ThemeUserInterface_wcol_pulldown_get(PointerRNA *ptr);

PointerRNA ThemeUserInterface_wcol_radio_get(PointerRNA *ptr);

PointerRNA ThemeUserInterface_wcol_regular_get(PointerRNA *ptr);

void ThemeUserInterface_icon_scene_get(PointerRNA *ptr, float values[4]);
void ThemeUserInterface_icon_scene_set(PointerRNA *ptr, const float values[4]);

PointerRNA ThemeUserInterface_wcol_scroll_get(PointerRNA *ptr);

void ThemeUserInterface_transparent_checker_secondary_get(PointerRNA *ptr, float values[3]);
void ThemeUserInterface_transparent_checker_secondary_set(PointerRNA *ptr, const float values[3]);

void ThemeUserInterface_icon_shading_get(PointerRNA *ptr, float values[4]);
void ThemeUserInterface_icon_shading_set(PointerRNA *ptr, const float values[4]);

PointerRNA ThemeUserInterface_wcol_numslider_get(PointerRNA *ptr);

PointerRNA ThemeUserInterface_wcol_state_get(PointerRNA *ptr);

PointerRNA ThemeUserInterface_wcol_tab_get(PointerRNA *ptr);

void ThemeUserInterface_widget_text_cursor_get(PointerRNA *ptr, float values[3]);
void ThemeUserInterface_widget_text_cursor_set(PointerRNA *ptr, const float values[3]);

PointerRNA ThemeUserInterface_wcol_text_get(PointerRNA *ptr);

PointerRNA ThemeUserInterface_wcol_toggle_get(PointerRNA *ptr);

PointerRNA ThemeUserInterface_wcol_tool_get(PointerRNA *ptr);

PointerRNA ThemeUserInterface_wcol_toolbar_item_get(PointerRNA *ptr);

PointerRNA ThemeUserInterface_wcol_tooltip_get(PointerRNA *ptr);

void ThemeUserInterface_widget_emboss_get(PointerRNA *ptr, float values[4]);
void ThemeUserInterface_widget_emboss_set(PointerRNA *ptr, const float values[4]);

void ThemeUserInterface_axis_x_get(PointerRNA *ptr, float values[3]);
void ThemeUserInterface_axis_x_set(PointerRNA *ptr, const float values[3]);

void ThemeUserInterface_axis_y_get(PointerRNA *ptr, float values[3]);
void ThemeUserInterface_axis_y_set(PointerRNA *ptr, const float values[3]);

void ThemeUserInterface_axis_z_get(PointerRNA *ptr, float values[3]);
void ThemeUserInterface_axis_z_set(PointerRNA *ptr, const float values[3]);

/**************** Theme 3D Viewport ****************/

extern StructRNA RNA_ThemeView3D;

PointerRNA ThemeView3D_rna_type_get(PointerRNA *ptr);

void ThemeView3D_object_active_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_object_active_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_act_spline_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_act_spline_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_editmesh_active_get(PointerRNA *ptr, float values[4]);
void ThemeView3D_editmesh_active_set(PointerRNA *ptr, const float values[4]);

void ThemeView3D_after_current_frame_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_after_current_frame_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_handle_align_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_handle_align_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_handle_sel_align_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_handle_sel_align_set(PointerRNA *ptr, const float values[3]);

PointerRNA ThemeView3D_asset_shelf_get(PointerRNA *ptr);

void ThemeView3D_handle_auto_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_handle_auto_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_handle_sel_auto_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_handle_sel_auto_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_before_current_frame_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_before_current_frame_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_bone_locked_weight_get(PointerRNA *ptr, float values[4]);
void ThemeView3D_bone_locked_weight_set(PointerRNA *ptr, const float values[4]);

void ThemeView3D_bone_pose_active_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_bone_pose_active_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_bone_pose_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_bone_pose_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_bone_solid_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_bone_solid_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_bundle_solid_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_bundle_solid_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_camera_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_camera_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_camera_passepartout_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_camera_passepartout_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_camera_path_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_camera_path_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_clipping_border_3d_get(PointerRNA *ptr, float values[4]);
void ThemeView3D_clipping_border_3d_set(PointerRNA *ptr, const float values[4]);

void ThemeView3D_frame_current_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_frame_current_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_extra_edge_angle_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_extra_edge_angle_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_edge_bevel_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_edge_bevel_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_edge_crease_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_edge_crease_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_extra_edge_len_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_extra_edge_len_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_edge_mode_select_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_edge_mode_select_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_edge_seam_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_edge_seam_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_edge_select_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_edge_select_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_edge_sharp_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_edge_sharp_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_edge_facesel_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_edge_facesel_set(PointerRNA *ptr, const float values[3]);

int ThemeView3D_edge_width_get(PointerRNA *ptr);
void ThemeView3D_edge_width_set(PointerRNA *ptr, int value);

void ThemeView3D_empty_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_empty_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_face_get(PointerRNA *ptr, float values[4]);
void ThemeView3D_face_set(PointerRNA *ptr, const float values[4]);

void ThemeView3D_extra_face_angle_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_extra_face_angle_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_extra_face_area_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_extra_face_area_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_face_dot_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_face_dot_set(PointerRNA *ptr, const float values[3]);

int ThemeView3D_facedot_size_get(PointerRNA *ptr);
void ThemeView3D_facedot_size_set(PointerRNA *ptr, int value);

void ThemeView3D_face_mode_select_get(PointerRNA *ptr, float values[4]);
void ThemeView3D_face_mode_select_set(PointerRNA *ptr, const float values[4]);

void ThemeView3D_normal_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_normal_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_face_back_get(PointerRNA *ptr, float values[4]);
void ThemeView3D_face_back_set(PointerRNA *ptr, const float values[4]);

void ThemeView3D_face_front_get(PointerRNA *ptr, float values[4]);
void ThemeView3D_face_front_set(PointerRNA *ptr, const float values[4]);

void ThemeView3D_face_retopology_get(PointerRNA *ptr, float values[4]);
void ThemeView3D_face_retopology_set(PointerRNA *ptr, const float values[4]);

void ThemeView3D_face_select_get(PointerRNA *ptr, float values[4]);
void ThemeView3D_face_select_set(PointerRNA *ptr, const float values[4]);

void ThemeView3D_handle_free_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_handle_free_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_handle_sel_free_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_handle_sel_free_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_freestyle_edge_mark_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_freestyle_edge_mark_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_freestyle_face_mark_get(PointerRNA *ptr, float values[4]);
void ThemeView3D_freestyle_face_mark_set(PointerRNA *ptr, const float values[4]);

void ThemeView3D_text_grease_pencil_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_text_grease_pencil_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_gp_vertex_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_gp_vertex_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_gp_vertex_select_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_gp_vertex_select_set(PointerRNA *ptr, const float values[3]);

int ThemeView3D_gp_vertex_size_get(PointerRNA *ptr);
void ThemeView3D_gp_vertex_size_set(PointerRNA *ptr, int value);

void ThemeView3D_grid_get(PointerRNA *ptr, float values[4]);
void ThemeView3D_grid_set(PointerRNA *ptr, const float values[4]);

void ThemeView3D_lastsel_point_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_lastsel_point_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_light_get(PointerRNA *ptr, float values[4]);
void ThemeView3D_light_set(PointerRNA *ptr, const float values[4]);

void ThemeView3D_nurb_sel_uline_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_nurb_sel_uline_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_nurb_sel_vline_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_nurb_sel_vline_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_nurb_uline_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_nurb_uline_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_nurb_vline_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_nurb_vline_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_text_keyframe_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_text_keyframe_set(PointerRNA *ptr, const float values[3]);

int ThemeView3D_object_origin_size_get(PointerRNA *ptr);
void ThemeView3D_object_origin_size_set(PointerRNA *ptr, int value);

void ThemeView3D_object_selected_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_object_selected_set(PointerRNA *ptr, const float values[3]);

int ThemeView3D_outline_width_get(PointerRNA *ptr);
void ThemeView3D_outline_width_set(PointerRNA *ptr, int value);

void ThemeView3D_paint_curve_handle_get(PointerRNA *ptr, float values[4]);
void ThemeView3D_paint_curve_handle_set(PointerRNA *ptr, const float values[4]);

void ThemeView3D_paint_curve_pivot_get(PointerRNA *ptr, float values[4]);
void ThemeView3D_paint_curve_pivot_set(PointerRNA *ptr, const float values[4]);

void ThemeView3D_skin_root_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_skin_root_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_speaker_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_speaker_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_split_normal_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_split_normal_set(PointerRNA *ptr, const float values[3]);

PointerRNA ThemeView3D_space_get(PointerRNA *ptr);

void ThemeView3D_transform_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_transform_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_handle_vect_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_handle_vect_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_handle_sel_vect_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_handle_sel_vect_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_vertex_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_vertex_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_vertex_bevel_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_vertex_bevel_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_vertex_unreferenced_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_vertex_unreferenced_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_vertex_normal_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_vertex_normal_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_vertex_select_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_vertex_select_set(PointerRNA *ptr, const float values[3]);

int ThemeView3D_vertex_size_get(PointerRNA *ptr);
void ThemeView3D_vertex_size_set(PointerRNA *ptr, int value);

void ThemeView3D_view_overlay_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_view_overlay_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_wire_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_wire_set(PointerRNA *ptr, const float values[3]);

void ThemeView3D_wire_edit_get(PointerRNA *ptr, float values[3]);
void ThemeView3D_wire_edit_set(PointerRNA *ptr, const float values[3]);

/**************** Theme Widget Color Set ****************/

extern StructRNA RNA_ThemeWidgetColors;

PointerRNA ThemeWidgetColors_rna_type_get(PointerRNA *ptr);

void ThemeWidgetColors_inner_get(PointerRNA *ptr, float values[4]);
void ThemeWidgetColors_inner_set(PointerRNA *ptr, const float values[4]);

void ThemeWidgetColors_inner_sel_get(PointerRNA *ptr, float values[4]);
void ThemeWidgetColors_inner_sel_set(PointerRNA *ptr, const float values[4]);

void ThemeWidgetColors_item_get(PointerRNA *ptr, float values[4]);
void ThemeWidgetColors_item_set(PointerRNA *ptr, const float values[4]);

void ThemeWidgetColors_outline_get(PointerRNA *ptr, float values[4]);
void ThemeWidgetColors_outline_set(PointerRNA *ptr, const float values[4]);

float ThemeWidgetColors_roundness_get(PointerRNA *ptr);
void ThemeWidgetColors_roundness_set(PointerRNA *ptr, float value);

int ThemeWidgetColors_shadedown_get(PointerRNA *ptr);
void ThemeWidgetColors_shadedown_set(PointerRNA *ptr, int value);

int ThemeWidgetColors_shadetop_get(PointerRNA *ptr);
void ThemeWidgetColors_shadetop_set(PointerRNA *ptr, int value);

bool ThemeWidgetColors_show_shaded_get(PointerRNA *ptr);
void ThemeWidgetColors_show_shaded_set(PointerRNA *ptr, bool value);

void ThemeWidgetColors_text_get(PointerRNA *ptr, float values[3]);
void ThemeWidgetColors_text_set(PointerRNA *ptr, const float values[3]);

void ThemeWidgetColors_text_sel_get(PointerRNA *ptr, float values[3]);
void ThemeWidgetColors_text_sel_set(PointerRNA *ptr, const float values[3]);

/**************** Theme Widget State Color ****************/

extern StructRNA RNA_ThemeWidgetStateColors;

PointerRNA ThemeWidgetStateColors_rna_type_get(PointerRNA *ptr);

void ThemeWidgetStateColors_inner_anim_get(PointerRNA *ptr, float values[3]);
void ThemeWidgetStateColors_inner_anim_set(PointerRNA *ptr, const float values[3]);

void ThemeWidgetStateColors_inner_anim_sel_get(PointerRNA *ptr, float values[3]);
void ThemeWidgetStateColors_inner_anim_sel_set(PointerRNA *ptr, const float values[3]);

float ThemeWidgetStateColors_blend_get(PointerRNA *ptr);
void ThemeWidgetStateColors_blend_set(PointerRNA *ptr, float value);

void ThemeWidgetStateColors_inner_changed_get(PointerRNA *ptr, float values[3]);
void ThemeWidgetStateColors_inner_changed_set(PointerRNA *ptr, const float values[3]);

void ThemeWidgetStateColors_inner_changed_sel_get(PointerRNA *ptr, float values[3]);
void ThemeWidgetStateColors_inner_changed_sel_set(PointerRNA *ptr, const float values[3]);

void ThemeWidgetStateColors_inner_driven_get(PointerRNA *ptr, float values[3]);
void ThemeWidgetStateColors_inner_driven_set(PointerRNA *ptr, const float values[3]);

void ThemeWidgetStateColors_inner_driven_sel_get(PointerRNA *ptr, float values[3]);
void ThemeWidgetStateColors_inner_driven_sel_set(PointerRNA *ptr, const float values[3]);

void ThemeWidgetStateColors_error_get(PointerRNA *ptr, float values[4]);
void ThemeWidgetStateColors_error_set(PointerRNA *ptr, const float values[4]);

void ThemeWidgetStateColors_info_get(PointerRNA *ptr, float values[4]);
void ThemeWidgetStateColors_info_set(PointerRNA *ptr, const float values[4]);

void ThemeWidgetStateColors_inner_key_get(PointerRNA *ptr, float values[3]);
void ThemeWidgetStateColors_inner_key_set(PointerRNA *ptr, const float values[3]);

void ThemeWidgetStateColors_inner_key_sel_get(PointerRNA *ptr, float values[3]);
void ThemeWidgetStateColors_inner_key_sel_set(PointerRNA *ptr, const float values[3]);

void ThemeWidgetStateColors_inner_overridden_get(PointerRNA *ptr, float values[3]);
void ThemeWidgetStateColors_inner_overridden_set(PointerRNA *ptr, const float values[3]);

void ThemeWidgetStateColors_inner_overridden_sel_get(PointerRNA *ptr, float values[3]);
void ThemeWidgetStateColors_inner_overridden_sel_set(PointerRNA *ptr, const float values[3]);

void ThemeWidgetStateColors_success_get(PointerRNA *ptr, float values[4]);
void ThemeWidgetStateColors_success_set(PointerRNA *ptr, const float values[4]);

void ThemeWidgetStateColors_warning_get(PointerRNA *ptr, float values[4]);
void ThemeWidgetStateColors_warning_set(PointerRNA *ptr, const float values[4]);

/**************** Marker ****************/

extern StructRNA RNA_TimelineMarker;

PointerRNA TimelineMarker_rna_type_get(PointerRNA *ptr);

#define TimelineMarker_name_MAX 64

void TimelineMarker_name_get(PointerRNA *ptr, char *value);
int TimelineMarker_name_length(PointerRNA *ptr);
void TimelineMarker_name_set(PointerRNA *ptr, const char *value);

PointerRNA TimelineMarker_camera_get(PointerRNA *ptr);

int TimelineMarker_frame_get(PointerRNA *ptr);
void TimelineMarker_frame_set(PointerRNA *ptr, int value);

bool TimelineMarker_select_get(PointerRNA *ptr);
void TimelineMarker_select_set(PointerRNA *ptr, bool value);

/**************** Timeline Markers ****************/

extern StructRNA RNA_TimelineMarkers;

PointerRNA TimelineMarkers_rna_type_get(PointerRNA *ptr);

struct TimeMarker *TimelineMarkers_new_func(struct Scene *_self, const char * name, int frame);
void TimelineMarkers_remove_func(struct Scene *_self, ReportList *reports, struct PointerRNA *marker);
void TimelineMarkers_clear_func(struct Scene *_self);
/**************** Timer ****************/

extern StructRNA RNA_Timer;

PointerRNA Timer_rna_type_get(PointerRNA *ptr);

float Timer_time_delta_get(PointerRNA *ptr);
void Timer_time_delta_set(PointerRNA *ptr, float value);

float Timer_time_duration_get(PointerRNA *ptr);
void Timer_time_duration_set(PointerRNA *ptr, float value);

float Timer_time_step_get(PointerRNA *ptr);
void Timer_time_step_set(PointerRNA *ptr, float value);

/**************** Tool Settings ****************/

extern StructRNA RNA_ToolSettings;

PointerRNA ToolSettings_rna_type_get(PointerRNA *ptr);

bool ToolSettings_use_snap_grid_absolute_get(PointerRNA *ptr);
void ToolSettings_use_snap_grid_absolute_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_snap_driver_absolute_get(PointerRNA *ptr);
void ToolSettings_use_snap_driver_absolute_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_snap_time_absolute_get(PointerRNA *ptr);
void ToolSettings_use_snap_time_absolute_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_gpencil_weight_data_add_get(PointerRNA *ptr);
void ToolSettings_use_gpencil_weight_data_add_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_snap_align_rotation_get(PointerRNA *ptr);
void ToolSettings_use_snap_align_rotation_set(PointerRNA *ptr, bool value);

enum {
	ToolSettings_annotation_stroke_placement_view3d_CURSOR = 33,
	ToolSettings_annotation_stroke_placement_view3d_VIEW = 0,
	ToolSettings_annotation_stroke_placement_view3d_SURFACE = 5,
};

int ToolSettings_annotation_stroke_placement_view3d_get(PointerRNA *ptr);
void ToolSettings_annotation_stroke_placement_view3d_set(PointerRNA *ptr, int value);

int ToolSettings_annotation_thickness_get(PointerRNA *ptr);
void ToolSettings_annotation_thickness_set(PointerRNA *ptr, int value);

bool ToolSettings_plane_axis_auto_get(PointerRNA *ptr);
void ToolSettings_plane_axis_auto_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_keyframe_insert_keyingset_get(PointerRNA *ptr);
void ToolSettings_use_keyframe_insert_keyingset_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_keyframe_insert_auto_get(PointerRNA *ptr);
void ToolSettings_use_keyframe_insert_auto_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_mesh_automerge_get(PointerRNA *ptr);
void ToolSettings_use_mesh_automerge_set(PointerRNA *ptr, bool value);

enum {
	ToolSettings_auto_keying_mode_ADD_REPLACE_KEYS = 2,
	ToolSettings_auto_keying_mode_REPLACE_KEYS = 4,
};

int ToolSettings_auto_keying_mode_get(PointerRNA *ptr);
void ToolSettings_auto_keying_mode_set(PointerRNA *ptr, int value);

bool ToolSettings_use_gpencil_automerge_strokes_get(PointerRNA *ptr);
void ToolSettings_use_gpencil_automerge_strokes_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_snap_backface_culling_get(PointerRNA *ptr);
void ToolSettings_use_snap_backface_culling_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_gpencil_thumbnail_list_get(PointerRNA *ptr);
void ToolSettings_use_gpencil_thumbnail_list_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_proportional_connected_get(PointerRNA *ptr);
void ToolSettings_use_proportional_connected_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_transform_correct_face_attributes_get(PointerRNA *ptr);
void ToolSettings_use_transform_correct_face_attributes_set(PointerRNA *ptr, bool value);

PointerRNA ToolSettings_curve_paint_settings_get(PointerRNA *ptr);

PointerRNA ToolSettings_custom_bevel_profile_preset_get(PointerRNA *ptr);

PointerRNA ToolSettings_curves_sculpt_get(PointerRNA *ptr);

bool ToolSettings_use_keyframe_cycle_aware_get(PointerRNA *ptr);
void ToolSettings_use_keyframe_cycle_aware_set(PointerRNA *ptr, bool value);

enum {
	ToolSettings_workspace_tool_type_DEFAULT = 1,
	ToolSettings_workspace_tool_type_FALLBACK = 0,
};

int ToolSettings_workspace_tool_type_get(PointerRNA *ptr);
void ToolSettings_workspace_tool_type_set(PointerRNA *ptr, int value);

bool ToolSettings_use_gpencil_draw_onback_get(PointerRNA *ptr);
void ToolSettings_use_gpencil_draw_onback_set(PointerRNA *ptr, bool value);

int ToolSettings_snap_face_nearest_steps_get(PointerRNA *ptr);
void ToolSettings_snap_face_nearest_steps_set(PointerRNA *ptr, int value);

int ToolSettings_snap_playhead_frame_step_get(PointerRNA *ptr);
void ToolSettings_snap_playhead_frame_step_set(PointerRNA *ptr, int value);

PointerRNA ToolSettings_gpencil_interpolate_get(PointerRNA *ptr);

PointerRNA ToolSettings_gpencil_paint_get(PointerRNA *ptr);

PointerRNA ToolSettings_gpencil_sculpt_get(PointerRNA *ptr);

PointerRNA ToolSettings_gpencil_sculpt_paint_get(PointerRNA *ptr);

PointerRNA ToolSettings_gpencil_vertex_paint_get(PointerRNA *ptr);

PointerRNA ToolSettings_gpencil_weight_paint_get(PointerRNA *ptr);

PointerRNA ToolSettings_image_paint_get(PointerRNA *ptr);

bool ToolSettings_use_transform_correct_keep_connected_get(PointerRNA *ptr);
void ToolSettings_use_transform_correct_keep_connected_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_record_with_nla_get(PointerRNA *ptr);
void ToolSettings_use_record_with_nla_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_edge_path_live_unwrap_get(PointerRNA *ptr);
void ToolSettings_use_edge_path_live_unwrap_set(PointerRNA *ptr, bool value);

bool ToolSettings_uv_sculpt_lock_borders_get(PointerRNA *ptr);
void ToolSettings_uv_sculpt_lock_borders_set(PointerRNA *ptr, bool value);

bool ToolSettings_lock_markers_get(PointerRNA *ptr);
void ToolSettings_lock_markers_set(PointerRNA *ptr, bool value);

bool ToolSettings_lock_object_mode_get(PointerRNA *ptr);
void ToolSettings_lock_object_mode_set(PointerRNA *ptr, bool value);

enum {
	ToolSettings_vertex_group_user_NONE = 0,
	ToolSettings_vertex_group_user_ACTIVE = 1,
	ToolSettings_vertex_group_user_ALL = 2,
};

int ToolSettings_vertex_group_user_get(PointerRNA *ptr);
void ToolSettings_vertex_group_user_set(PointerRNA *ptr, int value);

float ToolSettings_double_threshold_get(PointerRNA *ptr);
void ToolSettings_double_threshold_set(PointerRNA *ptr, float value);

void ToolSettings_mesh_select_mode_get(PointerRNA *ptr, bool values[3]);
void ToolSettings_mesh_select_mode_set(PointerRNA *ptr, const bool values[3]);

PointerRNA ToolSettings_statvis_get(PointerRNA *ptr);

bool ToolSettings_use_grease_pencil_multi_frame_editing_get(PointerRNA *ptr);
void ToolSettings_use_grease_pencil_multi_frame_editing_set(PointerRNA *ptr, bool value);

enum {
	ToolSettings_keyframe_type_KEYFRAME = 0,
	ToolSettings_keyframe_type_BREAKDOWN = 2,
	ToolSettings_keyframe_type_MOVING_HOLD = 4,
	ToolSettings_keyframe_type_EXTREME = 1,
	ToolSettings_keyframe_type_JITTER = 3,
	ToolSettings_keyframe_type_GENERATED = 5,
};

int ToolSettings_keyframe_type_get(PointerRNA *ptr);
void ToolSettings_keyframe_type_set(PointerRNA *ptr, int value);

void ToolSettings_normal_vector_get(PointerRNA *ptr, float values[3]);
void ToolSettings_normal_vector_set(PointerRNA *ptr, const float values[3]);

bool ToolSettings_use_annotation_stroke_endpoints_get(PointerRNA *ptr);
void ToolSettings_use_annotation_stroke_endpoints_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_transform_pivot_point_align_get(PointerRNA *ptr);
void ToolSettings_use_transform_pivot_point_align_set(PointerRNA *ptr, bool value);

enum {
	ToolSettings_plane_orientation_SURFACE = 0,
	ToolSettings_plane_orientation_DEFAULT = 1,
};

int ToolSettings_plane_orientation_get(PointerRNA *ptr);
void ToolSettings_plane_orientation_set(PointerRNA *ptr, int value);

PointerRNA ToolSettings_paint_mode_get(PointerRNA *ptr);

PointerRNA ToolSettings_particle_edit_get(PointerRNA *ptr);

enum {
	ToolSettings_plane_axis_X = 0,
	ToolSettings_plane_axis_Y = 1,
	ToolSettings_plane_axis_Z = 2,
};

int ToolSettings_plane_axis_get(PointerRNA *ptr);
void ToolSettings_plane_axis_set(PointerRNA *ptr, int value);

enum {
	ToolSettings_plane_depth_SURFACE = 0,
	ToolSettings_plane_depth_CURSOR_PLANE = 1,
	ToolSettings_plane_depth_CURSOR_VIEW = 2,
};

int ToolSettings_plane_depth_get(PointerRNA *ptr);
void ToolSettings_plane_depth_set(PointerRNA *ptr, int value);

enum {
	ToolSettings_snap_elements_individual_FACE_PROJECT = 1024,
	ToolSettings_snap_elements_individual_FACE_NEAREST = 512,
};

int ToolSettings_snap_elements_individual_get(PointerRNA *ptr);
void ToolSettings_snap_elements_individual_set(PointerRNA *ptr, int value);

bool ToolSettings_use_gpencil_project_only_selected_get(PointerRNA *ptr);
void ToolSettings_use_gpencil_project_only_selected_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_annotation_project_only_selected_get(PointerRNA *ptr);
void ToolSettings_use_annotation_project_only_selected_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_proportional_projected_get(PointerRNA *ptr);
void ToolSettings_use_proportional_projected_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_proportional_edit_get(PointerRNA *ptr);
void ToolSettings_use_proportional_edit_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_proportional_action_get(PointerRNA *ptr);
void ToolSettings_use_proportional_action_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_proportional_fcurve_get(PointerRNA *ptr);
void ToolSettings_use_proportional_fcurve_set(PointerRNA *ptr, bool value);

enum {
	ToolSettings_proportional_edit_falloff_SMOOTH = 0,
	ToolSettings_proportional_edit_falloff_SPHERE = 1,
	ToolSettings_proportional_edit_falloff_ROOT = 2,
	ToolSettings_proportional_edit_falloff_INVERSE_SQUARE = 7,
	ToolSettings_proportional_edit_falloff_SHARP = 3,
	ToolSettings_proportional_edit_falloff_LINEAR = 4,
	ToolSettings_proportional_edit_falloff_CONSTANT = 5,
	ToolSettings_proportional_edit_falloff_RANDOM = 6,
};

int ToolSettings_proportional_edit_falloff_get(PointerRNA *ptr);
void ToolSettings_proportional_edit_falloff_set(PointerRNA *ptr, int value);

bool ToolSettings_use_proportional_edit_objects_get(PointerRNA *ptr);
void ToolSettings_use_proportional_edit_objects_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_proportional_edit_mask_get(PointerRNA *ptr);
void ToolSettings_use_proportional_edit_mask_set(PointerRNA *ptr, bool value);

float ToolSettings_proportional_size_get(PointerRNA *ptr);
void ToolSettings_proportional_size_set(PointerRNA *ptr, float value);

float ToolSettings_proportional_distance_get(PointerRNA *ptr);
void ToolSettings_proportional_distance_set(PointerRNA *ptr, float value);

float ToolSettings_snap_angle_increment_2d_get(PointerRNA *ptr);
void ToolSettings_snap_angle_increment_2d_set(PointerRNA *ptr, float value);

float ToolSettings_snap_angle_increment_3d_get(PointerRNA *ptr);
void ToolSettings_snap_angle_increment_3d_set(PointerRNA *ptr, float value);

float ToolSettings_snap_angle_increment_2d_precision_get(PointerRNA *ptr);
void ToolSettings_snap_angle_increment_2d_precision_set(PointerRNA *ptr, float value);

float ToolSettings_snap_angle_increment_3d_precision_get(PointerRNA *ptr);
void ToolSettings_snap_angle_increment_3d_precision_set(PointerRNA *ptr, float value);

PointerRNA ToolSettings_sculpt_get(PointerRNA *ptr);

bool ToolSettings_uv_sculpt_all_islands_get(PointerRNA *ptr);
void ToolSettings_uv_sculpt_all_islands_set(PointerRNA *ptr, bool value);

int ToolSettings_snap_playhead_second_step_get(PointerRNA *ptr);
void ToolSettings_snap_playhead_second_step_set(PointerRNA *ptr, int value);

enum {
	ToolSettings_gpencil_selectmode_edit_POINT = 0,
	ToolSettings_gpencil_selectmode_edit_STROKE = 1,
	ToolSettings_gpencil_selectmode_edit_SEGMENT = 2,
};

int ToolSettings_gpencil_selectmode_edit_get(PointerRNA *ptr);
void ToolSettings_gpencil_selectmode_edit_set(PointerRNA *ptr, int value);

bool ToolSettings_use_gpencil_select_mask_point_get(PointerRNA *ptr);
void ToolSettings_use_gpencil_select_mask_point_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_gpencil_select_mask_stroke_get(PointerRNA *ptr);
void ToolSettings_use_gpencil_select_mask_stroke_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_gpencil_select_mask_segment_get(PointerRNA *ptr);
void ToolSettings_use_gpencil_select_mask_segment_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_gpencil_vertex_select_mask_point_get(PointerRNA *ptr);
void ToolSettings_use_gpencil_vertex_select_mask_point_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_gpencil_vertex_select_mask_stroke_get(PointerRNA *ptr);
void ToolSettings_use_gpencil_vertex_select_mask_stroke_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_gpencil_vertex_select_mask_segment_get(PointerRNA *ptr);
void ToolSettings_use_gpencil_vertex_select_mask_segment_set(PointerRNA *ptr, bool value);

PointerRNA ToolSettings_sequencer_tool_settings_get(PointerRNA *ptr);

bool ToolSettings_use_snap_get(PointerRNA *ptr);
void ToolSettings_use_snap_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_snap_node_get(PointerRNA *ptr);
void ToolSettings_use_snap_node_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_snap_uv_get(PointerRNA *ptr);
void ToolSettings_use_snap_uv_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_snap_anim_get(PointerRNA *ptr);
void ToolSettings_use_snap_anim_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_snap_driver_get(PointerRNA *ptr);
void ToolSettings_use_snap_driver_set(PointerRNA *ptr, bool value);

enum {
	ToolSettings_snap_anim_element_FRAME = 1,
	ToolSettings_snap_anim_element_SECOND = 2,
	ToolSettings_snap_anim_element_MARKER = 4,
};

int ToolSettings_snap_anim_element_get(PointerRNA *ptr);
void ToolSettings_snap_anim_element_set(PointerRNA *ptr, int value);

int ToolSettings_playhead_snap_distance_get(PointerRNA *ptr);
void ToolSettings_playhead_snap_distance_set(PointerRNA *ptr, int value);

enum {
	ToolSettings_snap_elements_INCREMENT = 256,
	ToolSettings_snap_elements_GRID = 128,
	ToolSettings_snap_elements_VERTEX = 5,
	ToolSettings_snap_elements_EDGE = 16,
	ToolSettings_snap_elements_FACE = 32,
	ToolSettings_snap_elements_VOLUME = 64,
	ToolSettings_snap_elements_EDGE_MIDPOINT = 2,
	ToolSettings_snap_elements_EDGE_PERPENDICULAR = 8,
	ToolSettings_snap_elements_FACE_PROJECT = 1024,
	ToolSettings_snap_elements_FACE_NEAREST = 512,
};

int ToolSettings_snap_elements_get(PointerRNA *ptr);
void ToolSettings_snap_elements_set(PointerRNA *ptr, int value);

enum {
	ToolSettings_snap_elements_base_INCREMENT = 256,
	ToolSettings_snap_elements_base_GRID = 128,
	ToolSettings_snap_elements_base_VERTEX = 5,
	ToolSettings_snap_elements_base_EDGE = 16,
	ToolSettings_snap_elements_base_FACE = 32,
	ToolSettings_snap_elements_base_VOLUME = 64,
	ToolSettings_snap_elements_base_EDGE_MIDPOINT = 2,
	ToolSettings_snap_elements_base_EDGE_PERPENDICULAR = 8,
};

int ToolSettings_snap_elements_base_get(PointerRNA *ptr);
void ToolSettings_snap_elements_base_set(PointerRNA *ptr, int value);

bool ToolSettings_use_snap_peel_object_get(PointerRNA *ptr);
void ToolSettings_use_snap_peel_object_set(PointerRNA *ptr, bool value);

enum {
	ToolSettings_snap_playhead_element_FRAME = 1,
	ToolSettings_snap_playhead_element_SECOND = 2,
	ToolSettings_snap_playhead_element_MARKER = 4,
	ToolSettings_snap_playhead_element_KEY = 8,
	ToolSettings_snap_playhead_element_Strip = 16,
};

int ToolSettings_snap_playhead_element_get(PointerRNA *ptr);
void ToolSettings_snap_playhead_element_set(PointerRNA *ptr, int value);

enum {
	ToolSettings_snap_target_CLOSEST = 0,
	ToolSettings_snap_target_CENTER = 1,
	ToolSettings_snap_target_MEDIAN = 2,
	ToolSettings_snap_target_ACTIVE = 3,
};

int ToolSettings_snap_target_get(PointerRNA *ptr);
void ToolSettings_snap_target_set(PointerRNA *ptr, int value);

enum {
	ToolSettings_snap_uv_element_INCREMENT = 256,
	ToolSettings_snap_uv_element_GRID = 128,
	ToolSettings_snap_uv_element_VERTEX = 5,
};

int ToolSettings_snap_uv_element_get(PointerRNA *ptr);
void ToolSettings_snap_uv_element_set(PointerRNA *ptr, int value);

bool ToolSettings_use_snap_self_get(PointerRNA *ptr);
void ToolSettings_use_snap_self_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_snap_edit_get(PointerRNA *ptr);
void ToolSettings_use_snap_edit_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_snap_nonedit_get(PointerRNA *ptr);
void ToolSettings_use_snap_nonedit_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_snap_selectable_get(PointerRNA *ptr);
void ToolSettings_use_snap_selectable_set(PointerRNA *ptr, bool value);

enum {
	ToolSettings_snap_elements_tool_GEOMETRY = 63,
	ToolSettings_snap_elements_tool_DEFAULT = 0,
};

int ToolSettings_snap_elements_tool_get(PointerRNA *ptr);
void ToolSettings_snap_elements_tool_set(PointerRNA *ptr, int value);

bool ToolSettings_use_snap_to_same_target_get(PointerRNA *ptr);
void ToolSettings_use_snap_to_same_target_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_mesh_automerge_and_split_get(PointerRNA *ptr);
void ToolSettings_use_mesh_automerge_and_split_set(PointerRNA *ptr, bool value);

enum {
	ToolSettings_uv_sticky_select_mode_DISABLED = 1,
	ToolSettings_uv_sticky_select_mode_SHARED_LOCATION = 0,
	ToolSettings_uv_sticky_select_mode_SHARED_VERTEX = 2,
};

int ToolSettings_uv_sticky_select_mode_get(PointerRNA *ptr);
void ToolSettings_uv_sticky_select_mode_set(PointerRNA *ptr, int value);

enum {
	ToolSettings_annotation_stroke_placement_view2d_IMAGE = 33,
	ToolSettings_annotation_stroke_placement_view2d_VIEW = 0,
};

int ToolSettings_annotation_stroke_placement_view2d_get(PointerRNA *ptr);
void ToolSettings_annotation_stroke_placement_view2d_set(PointerRNA *ptr, int value);

enum {
	ToolSettings_gpencil_stroke_placement_view3d_ORIGIN = 1,
	ToolSettings_gpencil_stroke_placement_view3d_CURSOR = 33,
	ToolSettings_gpencil_stroke_placement_view3d_SURFACE = 5,
	ToolSettings_gpencil_stroke_placement_view3d_STROKE = 9,
};

int ToolSettings_gpencil_stroke_placement_view3d_get(PointerRNA *ptr);
void ToolSettings_gpencil_stroke_placement_view3d_set(PointerRNA *ptr, int value);

enum {
	ToolSettings_gpencil_stroke_snap_mode_NONE = 0,
	ToolSettings_gpencil_stroke_snap_mode_ENDS = 16,
	ToolSettings_gpencil_stroke_snap_mode_FIRST = 64,
};

int ToolSettings_gpencil_stroke_snap_mode_get(PointerRNA *ptr);
void ToolSettings_gpencil_stroke_snap_mode_set(PointerRNA *ptr, int value);

enum {
	ToolSettings_vertex_group_subset_ALL = 0,
	ToolSettings_vertex_group_subset_BONE_DEFORM = 3,
	ToolSettings_vertex_group_subset_OTHER_DEFORM = 4,
};

int ToolSettings_vertex_group_subset_get(PointerRNA *ptr);
void ToolSettings_vertex_group_subset_set(PointerRNA *ptr, int value);

float ToolSettings_gpencil_surface_offset_get(PointerRNA *ptr);
void ToolSettings_gpencil_surface_offset_set(PointerRNA *ptr, float value);

bool ToolSettings_use_transform_data_origin_get(PointerRNA *ptr);
void ToolSettings_use_transform_data_origin_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_transform_skip_children_get(PointerRNA *ptr);
void ToolSettings_use_transform_skip_children_set(PointerRNA *ptr, bool value);

enum {
	ToolSettings_transform_pivot_point_BOUNDING_BOX_CENTER = 0,
	ToolSettings_transform_pivot_point_CURSOR = 1,
	ToolSettings_transform_pivot_point_INDIVIDUAL_ORIGINS = 2,
	ToolSettings_transform_pivot_point_MEDIAN_POINT = 3,
	ToolSettings_transform_pivot_point_ACTIVE_ELEMENT = 4,
};

int ToolSettings_transform_pivot_point_get(PointerRNA *ptr);
void ToolSettings_transform_pivot_point_set(PointerRNA *ptr, int value);

bool ToolSettings_show_uv_local_view_get(PointerRNA *ptr);
void ToolSettings_show_uv_local_view_set(PointerRNA *ptr, bool value);

PointerRNA ToolSettings_uv_sculpt_get(PointerRNA *ptr);

enum {
	ToolSettings_uv_select_mode_VERTEX = 1,
	ToolSettings_uv_select_mode_EDGE = 2,
	ToolSettings_uv_select_mode_FACE = 4,
	ToolSettings_uv_select_mode_ISLAND = 8,
};

int ToolSettings_uv_select_mode_get(PointerRNA *ptr);
void ToolSettings_uv_select_mode_set(PointerRNA *ptr, int value);

bool ToolSettings_use_uv_select_sync_get(PointerRNA *ptr);
void ToolSettings_use_uv_select_sync_set(PointerRNA *ptr, bool value);

PointerRNA ToolSettings_unified_paint_settings_get(PointerRNA *ptr);

bool ToolSettings_use_gpencil_draw_additive_get(PointerRNA *ptr);
void ToolSettings_use_gpencil_draw_additive_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_snap_rotate_get(PointerRNA *ptr);
void ToolSettings_use_snap_rotate_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_snap_scale_get(PointerRNA *ptr);
void ToolSettings_use_snap_scale_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_snap_translate_get(PointerRNA *ptr);
void ToolSettings_use_snap_translate_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_snap_sequencer_get(PointerRNA *ptr);
void ToolSettings_use_snap_sequencer_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_snap_playhead_get(PointerRNA *ptr);
void ToolSettings_use_snap_playhead_set(PointerRNA *ptr, bool value);

float ToolSettings_vertex_group_weight_get(PointerRNA *ptr);
void ToolSettings_vertex_group_weight_set(PointerRNA *ptr, float value);

PointerRNA ToolSettings_vertex_paint_get(PointerRNA *ptr);

PointerRNA ToolSettings_weight_paint_get(PointerRNA *ptr);

bool ToolSettings_use_auto_normalize_get(PointerRNA *ptr);
void ToolSettings_use_auto_normalize_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_lock_relative_get(PointerRNA *ptr);
void ToolSettings_use_lock_relative_set(PointerRNA *ptr, bool value);

bool ToolSettings_use_multipaint_get(PointerRNA *ptr);
void ToolSettings_use_multipaint_set(PointerRNA *ptr, bool value);

/**************** Track To Constraint ****************/

extern StructRNA RNA_TrackToConstraint;
extern StructRNA RNA_Constraint;

bool TrackToConstraint_use_bbone_shape_get(PointerRNA *ptr);
void TrackToConstraint_use_bbone_shape_set(PointerRNA *ptr, bool value);

float TrackToConstraint_head_tail_get(PointerRNA *ptr);
void TrackToConstraint_head_tail_set(PointerRNA *ptr, float value);

#define TrackToConstraint_subtarget_MAX 64

void TrackToConstraint_subtarget_get(PointerRNA *ptr, char *value);
int TrackToConstraint_subtarget_length(PointerRNA *ptr);
void TrackToConstraint_subtarget_set(PointerRNA *ptr, const char *value);

PointerRNA TrackToConstraint_target_get(PointerRNA *ptr);

bool TrackToConstraint_use_target_z_get(PointerRNA *ptr);
void TrackToConstraint_use_target_z_set(PointerRNA *ptr, bool value);

enum {
	TrackToConstraint_track_axis_TRACK_X = 0,
	TrackToConstraint_track_axis_TRACK_Y = 1,
	TrackToConstraint_track_axis_TRACK_Z = 2,
	TrackToConstraint_track_axis_TRACK_NEGATIVE_X = 3,
	TrackToConstraint_track_axis_TRACK_NEGATIVE_Y = 4,
	TrackToConstraint_track_axis_TRACK_NEGATIVE_Z = 5,
};

int TrackToConstraint_track_axis_get(PointerRNA *ptr);
void TrackToConstraint_track_axis_set(PointerRNA *ptr, int value);

enum {
	TrackToConstraint_up_axis_UP_X = 0,
	TrackToConstraint_up_axis_UP_Y = 1,
	TrackToConstraint_up_axis_UP_Z = 2,
};

int TrackToConstraint_up_axis_get(PointerRNA *ptr);
void TrackToConstraint_up_axis_set(PointerRNA *ptr, int value);

/**************** Transform Cache Constraint ****************/

extern StructRNA RNA_TransformCacheConstraint;
extern StructRNA RNA_Constraint;

PointerRNA TransformCacheConstraint_cache_file_get(PointerRNA *ptr);

#define TransformCacheConstraint_object_path_MAX 1024

void TransformCacheConstraint_object_path_get(PointerRNA *ptr, char *value);
int TransformCacheConstraint_object_path_length(PointerRNA *ptr);
void TransformCacheConstraint_object_path_set(PointerRNA *ptr, const char *value);

/**************** Transformation Constraint ****************/

extern StructRNA RNA_TransformConstraint;
extern StructRNA RNA_Constraint;

bool TransformConstraint_use_motion_extrapolate_get(PointerRNA *ptr);
void TransformConstraint_use_motion_extrapolate_set(PointerRNA *ptr, bool value);

float TransformConstraint_from_max_x_get(PointerRNA *ptr);
void TransformConstraint_from_max_x_set(PointerRNA *ptr, float value);

float TransformConstraint_from_max_x_rot_get(PointerRNA *ptr);
void TransformConstraint_from_max_x_rot_set(PointerRNA *ptr, float value);

float TransformConstraint_from_max_x_scale_get(PointerRNA *ptr);
void TransformConstraint_from_max_x_scale_set(PointerRNA *ptr, float value);

float TransformConstraint_from_max_y_get(PointerRNA *ptr);
void TransformConstraint_from_max_y_set(PointerRNA *ptr, float value);

float TransformConstraint_from_max_y_rot_get(PointerRNA *ptr);
void TransformConstraint_from_max_y_rot_set(PointerRNA *ptr, float value);

float TransformConstraint_from_max_y_scale_get(PointerRNA *ptr);
void TransformConstraint_from_max_y_scale_set(PointerRNA *ptr, float value);

float TransformConstraint_from_max_z_get(PointerRNA *ptr);
void TransformConstraint_from_max_z_set(PointerRNA *ptr, float value);

float TransformConstraint_from_max_z_rot_get(PointerRNA *ptr);
void TransformConstraint_from_max_z_rot_set(PointerRNA *ptr, float value);

float TransformConstraint_from_max_z_scale_get(PointerRNA *ptr);
void TransformConstraint_from_max_z_scale_set(PointerRNA *ptr, float value);

float TransformConstraint_from_min_x_get(PointerRNA *ptr);
void TransformConstraint_from_min_x_set(PointerRNA *ptr, float value);

float TransformConstraint_from_min_x_rot_get(PointerRNA *ptr);
void TransformConstraint_from_min_x_rot_set(PointerRNA *ptr, float value);

float TransformConstraint_from_min_x_scale_get(PointerRNA *ptr);
void TransformConstraint_from_min_x_scale_set(PointerRNA *ptr, float value);

float TransformConstraint_from_min_y_get(PointerRNA *ptr);
void TransformConstraint_from_min_y_set(PointerRNA *ptr, float value);

float TransformConstraint_from_min_y_rot_get(PointerRNA *ptr);
void TransformConstraint_from_min_y_rot_set(PointerRNA *ptr, float value);

float TransformConstraint_from_min_y_scale_get(PointerRNA *ptr);
void TransformConstraint_from_min_y_scale_set(PointerRNA *ptr, float value);

float TransformConstraint_from_min_z_get(PointerRNA *ptr);
void TransformConstraint_from_min_z_set(PointerRNA *ptr, float value);

float TransformConstraint_from_min_z_rot_get(PointerRNA *ptr);
void TransformConstraint_from_min_z_rot_set(PointerRNA *ptr, float value);

float TransformConstraint_from_min_z_scale_get(PointerRNA *ptr);
void TransformConstraint_from_min_z_scale_set(PointerRNA *ptr, float value);

enum {
	TransformConstraint_from_rotation_mode_AUTO = 0,
	TransformConstraint_from_rotation_mode_XYZ = 1,
	TransformConstraint_from_rotation_mode_XZY = 2,
	TransformConstraint_from_rotation_mode_YXZ = 3,
	TransformConstraint_from_rotation_mode_YZX = 4,
	TransformConstraint_from_rotation_mode_ZXY = 5,
	TransformConstraint_from_rotation_mode_ZYX = 6,
	TransformConstraint_from_rotation_mode_QUATERNION = 7,
	TransformConstraint_from_rotation_mode_SWING_TWIST_X = 8,
	TransformConstraint_from_rotation_mode_SWING_TWIST_Y = 9,
	TransformConstraint_from_rotation_mode_SWING_TWIST_Z = 10,
};

int TransformConstraint_from_rotation_mode_get(PointerRNA *ptr);
void TransformConstraint_from_rotation_mode_set(PointerRNA *ptr, int value);

enum {
	TransformConstraint_mix_mode_REPLACE = 1,
	TransformConstraint_mix_mode_ADD = 0,
};

int TransformConstraint_mix_mode_get(PointerRNA *ptr);
void TransformConstraint_mix_mode_set(PointerRNA *ptr, int value);

enum {
	TransformConstraint_map_from_LOCATION = 0,
	TransformConstraint_map_from_ROTATION = 1,
	TransformConstraint_map_from_SCALE = 2,
};

int TransformConstraint_map_from_get(PointerRNA *ptr);
void TransformConstraint_map_from_set(PointerRNA *ptr, int value);

enum {
	TransformConstraint_map_to_LOCATION = 0,
	TransformConstraint_map_to_ROTATION = 1,
	TransformConstraint_map_to_SCALE = 2,
};

int TransformConstraint_map_to_get(PointerRNA *ptr);
void TransformConstraint_map_to_set(PointerRNA *ptr, int value);

enum {
	TransformConstraint_map_to_x_from_X = 0,
	TransformConstraint_map_to_x_from_Y = 1,
	TransformConstraint_map_to_x_from_Z = 2,
};

int TransformConstraint_map_to_x_from_get(PointerRNA *ptr);
void TransformConstraint_map_to_x_from_set(PointerRNA *ptr, int value);

enum {
	TransformConstraint_map_to_y_from_X = 0,
	TransformConstraint_map_to_y_from_Y = 1,
	TransformConstraint_map_to_y_from_Z = 2,
};

int TransformConstraint_map_to_y_from_get(PointerRNA *ptr);
void TransformConstraint_map_to_y_from_set(PointerRNA *ptr, int value);

enum {
	TransformConstraint_map_to_z_from_X = 0,
	TransformConstraint_map_to_z_from_Y = 1,
	TransformConstraint_map_to_z_from_Z = 2,
};

int TransformConstraint_map_to_z_from_get(PointerRNA *ptr);
void TransformConstraint_map_to_z_from_set(PointerRNA *ptr, int value);

enum {
	TransformConstraint_mix_mode_rot_REPLACE = 1,
	TransformConstraint_mix_mode_rot_ADD = 0,
	TransformConstraint_mix_mode_rot_BEFORE = 2,
	TransformConstraint_mix_mode_rot_AFTER = 3,
};

int TransformConstraint_mix_mode_rot_get(PointerRNA *ptr);
void TransformConstraint_mix_mode_rot_set(PointerRNA *ptr, int value);

enum {
	TransformConstraint_mix_mode_scale_REPLACE = 0,
	TransformConstraint_mix_mode_scale_MULTIPLY = 1,
};

int TransformConstraint_mix_mode_scale_get(PointerRNA *ptr);
void TransformConstraint_mix_mode_scale_set(PointerRNA *ptr, int value);

#define TransformConstraint_subtarget_MAX 64

void TransformConstraint_subtarget_get(PointerRNA *ptr, char *value);
int TransformConstraint_subtarget_length(PointerRNA *ptr);
void TransformConstraint_subtarget_set(PointerRNA *ptr, const char *value);

PointerRNA TransformConstraint_target_get(PointerRNA *ptr);

float TransformConstraint_to_max_x_get(PointerRNA *ptr);
void TransformConstraint_to_max_x_set(PointerRNA *ptr, float value);

float TransformConstraint_to_max_x_rot_get(PointerRNA *ptr);
void TransformConstraint_to_max_x_rot_set(PointerRNA *ptr, float value);

float TransformConstraint_to_max_x_scale_get(PointerRNA *ptr);
void TransformConstraint_to_max_x_scale_set(PointerRNA *ptr, float value);

float TransformConstraint_to_max_y_get(PointerRNA *ptr);
void TransformConstraint_to_max_y_set(PointerRNA *ptr, float value);

float TransformConstraint_to_max_y_rot_get(PointerRNA *ptr);
void TransformConstraint_to_max_y_rot_set(PointerRNA *ptr, float value);

float TransformConstraint_to_max_y_scale_get(PointerRNA *ptr);
void TransformConstraint_to_max_y_scale_set(PointerRNA *ptr, float value);

float TransformConstraint_to_max_z_get(PointerRNA *ptr);
void TransformConstraint_to_max_z_set(PointerRNA *ptr, float value);

float TransformConstraint_to_max_z_rot_get(PointerRNA *ptr);
void TransformConstraint_to_max_z_rot_set(PointerRNA *ptr, float value);

float TransformConstraint_to_max_z_scale_get(PointerRNA *ptr);
void TransformConstraint_to_max_z_scale_set(PointerRNA *ptr, float value);

float TransformConstraint_to_min_x_get(PointerRNA *ptr);
void TransformConstraint_to_min_x_set(PointerRNA *ptr, float value);

float TransformConstraint_to_min_x_rot_get(PointerRNA *ptr);
void TransformConstraint_to_min_x_rot_set(PointerRNA *ptr, float value);

float TransformConstraint_to_min_x_scale_get(PointerRNA *ptr);
void TransformConstraint_to_min_x_scale_set(PointerRNA *ptr, float value);

float TransformConstraint_to_min_y_get(PointerRNA *ptr);
void TransformConstraint_to_min_y_set(PointerRNA *ptr, float value);

float TransformConstraint_to_min_y_rot_get(PointerRNA *ptr);
void TransformConstraint_to_min_y_rot_set(PointerRNA *ptr, float value);

float TransformConstraint_to_min_y_scale_get(PointerRNA *ptr);
void TransformConstraint_to_min_y_scale_set(PointerRNA *ptr, float value);

float TransformConstraint_to_min_z_get(PointerRNA *ptr);
void TransformConstraint_to_min_z_set(PointerRNA *ptr, float value);

float TransformConstraint_to_min_z_rot_get(PointerRNA *ptr);
void TransformConstraint_to_min_z_rot_set(PointerRNA *ptr, float value);

float TransformConstraint_to_min_z_scale_get(PointerRNA *ptr);
void TransformConstraint_to_min_z_scale_set(PointerRNA *ptr, float value);

enum {
	TransformConstraint_to_euler_order_AUTO = 0,
	TransformConstraint_to_euler_order_XYZ = 1,
	TransformConstraint_to_euler_order_XZY = 2,
	TransformConstraint_to_euler_order_YXZ = 3,
	TransformConstraint_to_euler_order_YZX = 4,
	TransformConstraint_to_euler_order_ZXY = 5,
	TransformConstraint_to_euler_order_ZYX = 6,
};

int TransformConstraint_to_euler_order_get(PointerRNA *ptr);
void TransformConstraint_to_euler_order_set(PointerRNA *ptr, int value);

/**************** TransformOrientation ****************/

extern StructRNA RNA_TransformOrientation;

PointerRNA TransformOrientation_rna_type_get(PointerRNA *ptr);

#define TransformOrientation_name_MAX 64

void TransformOrientation_name_get(PointerRNA *ptr, char *value);
int TransformOrientation_name_length(PointerRNA *ptr);
void TransformOrientation_name_set(PointerRNA *ptr, const char *value);

void TransformOrientation_matrix_get(PointerRNA *ptr, float values[9]);
void TransformOrientation_matrix_set(PointerRNA *ptr, const float values[9]);

/**************** Orientation Slot ****************/

extern StructRNA RNA_TransformOrientationSlot;

PointerRNA TransformOrientationSlot_rna_type_get(PointerRNA *ptr);

PointerRNA TransformOrientationSlot_custom_orientation_get(PointerRNA *ptr);

enum {
	TransformOrientationSlot_type_GLOBAL = 0,
	TransformOrientationSlot_type_LOCAL = 1,
	TransformOrientationSlot_type_NORMAL = 2,
	TransformOrientationSlot_type_GIMBAL = 4,
	TransformOrientationSlot_type_VIEW = 3,
	TransformOrientationSlot_type_CURSOR = 5,
	TransformOrientationSlot_type_PARENT = 6,
};

int TransformOrientationSlot_type_get(PointerRNA *ptr);
void TransformOrientationSlot_type_set(PointerRNA *ptr, int value);

bool TransformOrientationSlot_use_get(PointerRNA *ptr);
void TransformOrientationSlot_use_set(PointerRNA *ptr, bool value);

/**************** Transform Strip ****************/

extern StructRNA RNA_TransformStrip;
extern StructRNA RNA_EffectStrip;
extern StructRNA RNA_Strip;

PointerRNA TransformStrip_input_1_get(PointerRNA *ptr);

enum {
	TransformStrip_interpolation_NONE = 0,
	TransformStrip_interpolation_BILINEAR = 1,
	TransformStrip_interpolation_BICUBIC = 2,
};

int TransformStrip_interpolation_get(PointerRNA *ptr);
void TransformStrip_interpolation_set(PointerRNA *ptr, int value);

float TransformStrip_rotation_start_get(PointerRNA *ptr);
void TransformStrip_rotation_start_set(PointerRNA *ptr, float value);

float TransformStrip_scale_start_x_get(PointerRNA *ptr);
void TransformStrip_scale_start_x_set(PointerRNA *ptr, float value);

float TransformStrip_scale_start_y_get(PointerRNA *ptr);
void TransformStrip_scale_start_y_set(PointerRNA *ptr, float value);

float TransformStrip_translate_start_x_get(PointerRNA *ptr);
void TransformStrip_translate_start_x_set(PointerRNA *ptr, float value);

float TransformStrip_translate_start_y_get(PointerRNA *ptr);
void TransformStrip_translate_start_y_set(PointerRNA *ptr, float value);

enum {
	TransformStrip_translation_unit_PIXELS = 0,
	TransformStrip_translation_unit_PERCENT = 1,
};

int TransformStrip_translation_unit_get(PointerRNA *ptr);
void TransformStrip_translation_unit_set(PointerRNA *ptr, int value);

bool TransformStrip_use_uniform_scale_get(PointerRNA *ptr);
void TransformStrip_use_uniform_scale_set(PointerRNA *ptr, bool value);

int TransformStrip_input_count_get(PointerRNA *ptr);
void TransformStrip_input_count_set(PointerRNA *ptr, int value);

/**************** Triangulate Modifier ****************/

extern StructRNA RNA_TriangulateModifier;
extern StructRNA RNA_Modifier;

bool TriangulateModifier_keep_custom_normals_get(PointerRNA *ptr);
void TriangulateModifier_keep_custom_normals_set(PointerRNA *ptr, bool value);

int TriangulateModifier_min_vertices_get(PointerRNA *ptr);
void TriangulateModifier_min_vertices_set(PointerRNA *ptr, int value);

enum {
	TriangulateModifier_ngon_method_BEAUTY = 0,
	TriangulateModifier_ngon_method_CLIP = 1,
};

int TriangulateModifier_ngon_method_get(PointerRNA *ptr);
void TriangulateModifier_ngon_method_set(PointerRNA *ptr, int value);

enum {
	TriangulateModifier_quad_method_BEAUTY = 0,
	TriangulateModifier_quad_method_FIXED = 1,
	TriangulateModifier_quad_method_FIXED_ALTERNATE = 2,
	TriangulateModifier_quad_method_SHORTEST_DIAGONAL = 3,
	TriangulateModifier_quad_method_LONGEST_DIAGONAL = 4,
};

int TriangulateModifier_quad_method_get(PointerRNA *ptr);
void TriangulateModifier_quad_method_set(PointerRNA *ptr, int value);

/**************** UDIM Tile ****************/

extern StructRNA RNA_UDIMTile;

PointerRNA UDIMTile_rna_type_get(PointerRNA *ptr);

int UDIMTile_channels_get(PointerRNA *ptr);
void UDIMTile_channels_set(PointerRNA *ptr, int value);

void UDIMTile_generated_color_get(PointerRNA *ptr, float values[4]);
void UDIMTile_generated_color_set(PointerRNA *ptr, const float values[4]);

bool UDIMTile_use_generated_float_get(PointerRNA *ptr);
void UDIMTile_use_generated_float_set(PointerRNA *ptr, bool value);

int UDIMTile_generated_height_get(PointerRNA *ptr);
void UDIMTile_generated_height_set(PointerRNA *ptr, int value);

enum {
	UDIMTile_generated_type_BLANK = 0,
	UDIMTile_generated_type_UV_GRID = 1,
	UDIMTile_generated_type_COLOR_GRID = 2,
};

int UDIMTile_generated_type_get(PointerRNA *ptr);
void UDIMTile_generated_type_set(PointerRNA *ptr, int value);

int UDIMTile_generated_width_get(PointerRNA *ptr);
void UDIMTile_generated_width_set(PointerRNA *ptr, int value);

bool UDIMTile_is_generated_tile_get(PointerRNA *ptr);
void UDIMTile_is_generated_tile_set(PointerRNA *ptr, bool value);

#define UDIMTile_label_MAX 64

void UDIMTile_label_get(PointerRNA *ptr, char *value);
int UDIMTile_label_length(PointerRNA *ptr);
void UDIMTile_label_set(PointerRNA *ptr, const char *value);

int UDIMTile_number_get(PointerRNA *ptr);
void UDIMTile_number_set(PointerRNA *ptr, int value);

void UDIMTile_size_get(PointerRNA *ptr, int values[2]);
void UDIMTile_size_set(PointerRNA *ptr, const int values[2]);

/**************** UDIM Tiles ****************/

extern StructRNA RNA_UDIMTiles;

PointerRNA UDIMTiles_rna_type_get(PointerRNA *ptr);

PointerRNA UDIMTiles_active_get(PointerRNA *ptr);

int UDIMTiles_active_index_get(PointerRNA *ptr);
void UDIMTiles_active_index_set(PointerRNA *ptr, int value);

struct ImageTile *UDIMTiles_new_func(struct Image *_self, int tile_number, const char * label);
struct ImageTile *UDIMTiles_get_func(struct Image *_self, int tile_number);
void UDIMTiles_remove_func(struct Image *_self, struct PointerRNA *tile);
/**************** UI Layout ****************/

extern StructRNA RNA_UILayout;

PointerRNA UILayout_rna_type_get(PointerRNA *ptr);

bool UILayout_activate_init_get(PointerRNA *ptr);
void UILayout_activate_init_set(PointerRNA *ptr, bool value);

bool UILayout_active_default_get(PointerRNA *ptr);
void UILayout_active_default_set(PointerRNA *ptr, bool value);

bool UILayout_enabled_get(PointerRNA *ptr);
void UILayout_enabled_set(PointerRNA *ptr, bool value);

enum {
	UILayout_operator_context_INVOKE_DEFAULT = 0,
	UILayout_operator_context_INVOKE_REGION_WIN = 1,
	UILayout_operator_context_INVOKE_REGION_CHANNELS = 2,
	UILayout_operator_context_INVOKE_REGION_PREVIEW = 3,
	UILayout_operator_context_INVOKE_AREA = 4,
	UILayout_operator_context_INVOKE_SCREEN = 5,
	UILayout_operator_context_EXEC_DEFAULT = 6,
	UILayout_operator_context_EXEC_REGION_WIN = 7,
	UILayout_operator_context_EXEC_REGION_CHANNELS = 8,
	UILayout_operator_context_EXEC_REGION_PREVIEW = 9,
	UILayout_operator_context_EXEC_AREA = 10,
	UILayout_operator_context_EXEC_SCREEN = 11,
};

int UILayout_operator_context_get(PointerRNA *ptr);
void UILayout_operator_context_set(PointerRNA *ptr, int value);

float UILayout_scale_x_get(PointerRNA *ptr);
void UILayout_scale_x_set(PointerRNA *ptr, float value);

float UILayout_scale_y_get(PointerRNA *ptr);
void UILayout_scale_y_set(PointerRNA *ptr, float value);

float UILayout_ui_units_x_get(PointerRNA *ptr);
void UILayout_ui_units_x_set(PointerRNA *ptr, float value);

float UILayout_ui_units_y_get(PointerRNA *ptr);
void UILayout_ui_units_y_set(PointerRNA *ptr, float value);

bool UILayout_active_get(PointerRNA *ptr);
void UILayout_active_set(PointerRNA *ptr, bool value);

bool UILayout_alert_get(PointerRNA *ptr);
void UILayout_alert_set(PointerRNA *ptr, bool value);

enum {
	UILayout_alignment_EXPAND = 0,
	UILayout_alignment_LEFT = 1,
	UILayout_alignment_CENTER = 2,
	UILayout_alignment_RIGHT = 3,
};

int UILayout_alignment_get(PointerRNA *ptr);
void UILayout_alignment_set(PointerRNA *ptr, int value);

enum {
	UILayout_direction_HORIZONTAL = 0,
	UILayout_direction_VERTICAL = 1,
};

int UILayout_direction_get(PointerRNA *ptr);
void UILayout_direction_set(PointerRNA *ptr, int value);

enum {
	UILayout_emboss_NORMAL = 0,
	UILayout_emboss_NONE = 1,
	UILayout_emboss_PULLDOWN_MENU = 2,
	UILayout_emboss_RADIAL_MENU = 3,
	UILayout_emboss_NONE_OR_STATUS = 4,
};

int UILayout_emboss_get(PointerRNA *ptr);
void UILayout_emboss_set(PointerRNA *ptr, int value);

bool UILayout_use_property_decorate_get(PointerRNA *ptr);
void UILayout_use_property_decorate_set(PointerRNA *ptr, bool value);

bool UILayout_use_property_split_get(PointerRNA *ptr);
void UILayout_use_property_split_set(PointerRNA *ptr, bool value);

struct uiLayout *UILayout_row_func(struct uiLayout *_self, bool align, const char * heading, const char * heading_ctxt, bool translate);
struct uiLayout *UILayout_column_func(struct uiLayout *_self, bool align, const char * heading, const char * heading_ctxt, bool translate);
void UILayout_panel_func(struct uiLayout *_self, bContext *C, ReportList *reports, const char * idname, bool default_closed, struct uiLayout **layout_header, struct uiLayout **layout_body);
void UILayout_panel_prop_func(struct uiLayout *_self, bContext *C, ReportList *reports, struct PointerRNA *data, const char * property, struct uiLayout **layout_header, struct uiLayout **layout_body);
struct uiLayout *UILayout_column_flow_func(struct uiLayout *_self, int columns, bool align);
struct uiLayout *UILayout_grid_flow_func(struct uiLayout *_self, bool row_major, int columns, bool even_columns, bool even_rows, bool align);
struct uiLayout *UILayout_box_func(struct uiLayout *_self);
struct uiLayout *UILayout_split_func(struct uiLayout *_self, float factor, bool align);
struct uiLayout *UILayout_menu_pie_func(struct uiLayout *_self);
int UILayout_icon_func(bContext *C, struct PointerRNA *data);
const char * UILayout_enum_item_name_func(bContext *C, struct PointerRNA *data, const char * property, const char * identifier);
const char * UILayout_enum_item_description_func(bContext *C, struct PointerRNA *data, const char * property, const char * identifier);
int UILayout_enum_item_icon_func(bContext *C, struct PointerRNA *data, const char * property, const char * identifier);
void UILayout_prop_func(struct uiLayout *_self, struct PointerRNA *data, const char * property, const char * text, const char * text_ctxt, bool translate, int icon, const char * placeholder, bool expand, bool slider, int toggle, bool icon_only, bool event, bool full_event, bool emboss, int index, int icon_value, bool invert_checkbox);
void UILayout_props_enum_func(struct uiLayout *_self, struct PointerRNA *data, const char * property);
void UILayout_prop_menu_enum_func(struct uiLayout *_self, struct PointerRNA *data, const char * property, const char * text, const char * text_ctxt, bool translate, int icon);
void UILayout_prop_with_popover_func(struct uiLayout *_self, struct PointerRNA *data, const char * property, const char * text, const char * text_ctxt, bool translate, int icon, bool icon_only, const char * panel);
void UILayout_prop_with_menu_func(struct uiLayout *_self, struct PointerRNA *data, const char * property, const char * text, const char * text_ctxt, bool translate, int icon, bool icon_only, const char * menu);
void UILayout_prop_tabs_enum_func(struct uiLayout *_self, bContext *C, struct PointerRNA *data, const char * property, struct PointerRNA *data_highlight, const char * property_highlight, bool icon_only);
void UILayout_prop_enum_func(struct uiLayout *_self, struct PointerRNA *data, const char * property, const char * value, const char * text, const char * text_ctxt, bool translate, int icon);
void UILayout_prop_search_func(struct uiLayout *_self, struct PointerRNA *data, const char * property, struct PointerRNA *search_data, const char * search_property, const char * text, const char * text_ctxt, bool translate, int icon, bool results_are_suggestions);
void UILayout_prop_decorator_func(struct uiLayout *_self, struct PointerRNA *data, const char * property, int index);
struct PointerRNA UILayout_operator_func(struct uiLayout *_self, const char * operator_value, const char * text, const char * text_ctxt, bool translate, int icon, bool emboss, bool depress, int icon_value, float search_weight);
struct PointerRNA UILayout_operator_menu_hold_func(struct uiLayout *_self, const char * operator_value, const char * text, const char * text_ctxt, bool translate, int icon, bool emboss, bool depress, int icon_value, const char * menu);
void UILayout_operator_enum_func(struct uiLayout *_self, const char * operator_value, const char * property, bool icon_only);
struct PointerRNA UILayout_operator_menu_enum_func(struct uiLayout *_self, bContext *C, const char * operator_value, const char * property, const char * text, const char * text_ctxt, bool translate, int icon);
void UILayout_label_func(struct uiLayout *_self, const char * text, const char * text_ctxt, bool translate, int icon, int icon_value);
void UILayout_menu_func(struct uiLayout *_self, const char * menu, const char * text, const char * text_ctxt, bool translate, int icon, int icon_value);
void UILayout_menu_contents_func(struct uiLayout *_self, const char * menu);
void UILayout_popover_func(struct uiLayout *_self, bContext *C, const char * panel, const char * text, const char * text_ctxt, bool translate, int icon, int icon_value);
void UILayout_popover_group_func(struct uiLayout *_self, bContext *C, int space_type, int region_type, const char * context, const char * category);
void UILayout_separator_func(struct uiLayout *_self, float factor, int type);
void UILayout_separator_spacer_func(struct uiLayout *_self);
void UILayout_progress_func(struct uiLayout *_self, const char * text, const char * text_ctxt, bool translate, float factor, int type);
void UILayout_context_pointer_set_func(struct uiLayout *_self, const char * name, struct PointerRNA *data);
void UILayout_context_string_set_func(struct uiLayout *_self, const char * name, const char * value);
void UILayout_template_header_func(struct uiLayout *_self, bContext *C);
void UILayout_template_ID_func(struct uiLayout *_self, bContext *C, struct PointerRNA *data, const char * property, const char * create, const char * open, const char * unlink, int filter, bool live_icon, const char * text, const char * text_ctxt, bool translate);
void UILayout_template_ID_preview_func(struct uiLayout *_self, bContext *C, struct PointerRNA *data, const char * property, const char * create, const char * open, const char * unlink, int rows, int cols, int filter, bool hide_buttons);
void UILayout_template_any_ID_func(struct uiLayout *_self, struct PointerRNA *data, const char * property, const char * type_property, const char * text, const char * text_ctxt, bool translate);
void UILayout_template_ID_tabs_func(struct uiLayout *_self, bContext *C, struct PointerRNA *data, const char * property, const char * create, const char * menu, int filter);
void UILayout_template_action_func(struct uiLayout *_self, bContext *C, struct ID *id, const char * create, const char * unlink, const char * text, const char * text_ctxt, bool translate);
void UILayout_template_search_func(struct uiLayout *_self, bContext *C, struct PointerRNA *data, const char * property, struct PointerRNA *search_data, const char * search_property, const char * create, const char * unlink, const char * text, const char * text_ctxt, bool translate);
void UILayout_template_search_preview_func(struct uiLayout *_self, bContext *C, struct PointerRNA *data, const char * property, struct PointerRNA *search_data, const char * search_property, const char * create, const char * unlink, const char * text, const char * text_ctxt, bool translate, int rows, int cols);
void UILayout_template_path_builder_func(struct uiLayout *_self, struct PointerRNA *data, const char * property, struct PointerRNA *root, const char * text, const char * text_ctxt, bool translate);
void UILayout_template_modifiers_func(struct uiLayout *_self, bContext *C);
void UILayout_template_collection_exporters_func(struct uiLayout *_self, bContext *C);
void UILayout_template_constraints_func(struct uiLayout *_self, bContext *C, bool use_bone_constraints);
void UILayout_template_shaderfx_func(struct uiLayout *_self, bContext *C);
void UILayout_template_greasepencil_color_func(struct uiLayout *_self, bContext *C, struct PointerRNA *data, const char * property, int rows, int cols, float scale, int filter);
void UILayout_template_constraint_header_func(struct uiLayout *_self, struct PointerRNA *data);
void UILayout_template_preview_func(struct uiLayout *_self, bContext *C, struct ID *id, bool show_buttons, struct ID *parent, struct MTex *slot, const char * preview_id);
void UILayout_template_curve_mapping_func(struct uiLayout *_self, struct PointerRNA *data, const char * property, int type, bool levels, bool brush, bool use_negative_slope, bool show_tone);
void UILayout_template_curveprofile_func(struct uiLayout *_self, struct PointerRNA *data, const char * property);
void UILayout_template_color_ramp_func(struct uiLayout *_self, struct PointerRNA *data, const char * property, bool expand);
void UILayout_template_icon_func(struct uiLayout *_self, int icon_value, float scale);
void UILayout_template_icon_view_func(struct uiLayout *_self, struct PointerRNA *data, const char * property, bool show_labels, float scale, float scale_popup);
void UILayout_template_histogram_func(struct uiLayout *_self, struct PointerRNA *data, const char * property);
void UILayout_template_waveform_func(struct uiLayout *_self, struct PointerRNA *data, const char * property);
void UILayout_template_vectorscope_func(struct uiLayout *_self, struct PointerRNA *data, const char * property);
void UILayout_template_layers_func(struct uiLayout *_self, struct PointerRNA *data, const char * property, struct PointerRNA *used_layers_data, const char * used_layers_property, int active_layer);
void UILayout_template_color_picker_func(struct uiLayout *_self, struct PointerRNA *data, const char * property, bool value_slider, bool lock, bool lock_luminosity, bool cubic);
void UILayout_template_palette_func(struct uiLayout *_self, struct PointerRNA *data, const char * property, bool color);
void UILayout_template_image_layers_func(struct uiLayout *_self, bContext *C, struct Image *image, struct ImageUser *image_user);
void UILayout_template_image_func(struct uiLayout *_self, bContext *C, struct PointerRNA *data, const char * property, struct PointerRNA *image_user, bool compact, bool multiview);
void UILayout_template_image_settings_func(struct uiLayout *_self, struct PointerRNA *image_settings, bool color_management);
void UILayout_template_image_stereo_3d_func(struct uiLayout *_self, struct PointerRNA *stereo_3d_format);
void UILayout_template_image_views_func(struct uiLayout *_self, struct PointerRNA *image_settings);
void UILayout_template_movieclip_func(struct uiLayout *_self, bContext *C, struct PointerRNA *data, const char * property, bool compact);
void UILayout_template_track_func(struct uiLayout *_self, struct PointerRNA *data, const char * property);
void UILayout_template_marker_func(struct uiLayout *_self, struct PointerRNA *data, const char * property, struct PointerRNA *clip_user, struct PointerRNA *track, bool compact);
void UILayout_template_movieclip_information_func(struct uiLayout *_self, struct PointerRNA *data, const char * property, struct PointerRNA *clip_user);
void UILayout_template_list_func(struct uiLayout *_self, bContext *C, const char * listtype_name, const char * list_id, struct PointerRNA *dataptr, const char * propname, struct PointerRNA *active_dataptr, const char * active_propname, const char * item_dyntip_propname, int rows, int maxrows, int type, int columns, bool sort_reverse, bool sort_lock);
void UILayout_template_running_jobs_func(struct uiLayout *_self, bContext *C);
void UILayout_template_operator_search_func(struct uiLayout *_self);
void UILayout_template_menu_search_func(struct uiLayout *_self);
void UILayout_template_header_3D_mode_func(struct uiLayout *_self, bContext *C);
void UILayout_template_edit_mode_selection_func(struct uiLayout *_self, bContext *C);
void UILayout_template_reports_banner_func(struct uiLayout *_self, bContext *C);
void UILayout_template_input_status_func(struct uiLayout *_self, bContext *C);
void UILayout_template_status_info_func(struct uiLayout *_self, bContext *C);
void UILayout_template_node_link_func(struct uiLayout *_self, bContext *C, struct bNodeTree *ntree, struct bNode *node, struct bNodeSocket *socket);
void UILayout_template_node_view_func(struct uiLayout *_self, bContext *C, struct bNodeTree *ntree, struct bNode *node, struct bNodeSocket *socket);
void UILayout_template_node_asset_menu_items_func(struct uiLayout *_self, bContext *C, const char * catalog_path);
void UILayout_template_modifier_asset_menu_items_func(struct uiLayout *_self, const char * catalog_path);
void UILayout_template_node_operator_asset_menu_items_func(struct uiLayout *_self, bContext *C, const char * catalog_path);
void UILayout_template_node_operator_asset_root_items_func(struct uiLayout *_self, bContext *C);
void UILayout_template_texture_user_func(struct uiLayout *_self, bContext *C);
void UILayout_template_keymap_item_properties_func(struct uiLayout *_self, struct PointerRNA *item);
void UILayout_template_component_menu_func(struct uiLayout *_self, struct PointerRNA *data, const char * property, const char * name);
void UILayout_template_colorspace_settings_func(struct uiLayout *_self, struct PointerRNA *data, const char * property);
void UILayout_template_colormanaged_view_settings_func(struct uiLayout *_self, bContext *C, struct PointerRNA *data, const char * property);
void UILayout_template_node_socket_func(struct uiLayout *_self, bContext *C, float color[4]);
void UILayout_template_cache_file_func(struct uiLayout *_self, bContext *C, struct PointerRNA *data, const char * property);
void UILayout_template_cache_file_velocity_func(struct uiLayout *_self, struct PointerRNA *data, const char * property);
void UILayout_template_cache_file_procedural_func(struct uiLayout *_self, bContext *C, struct PointerRNA *data, const char * property);
void UILayout_template_cache_file_time_settings_func(struct uiLayout *_self, struct PointerRNA *data, const char * property);
void UILayout_template_cache_file_layers_func(struct uiLayout *_self, bContext *C, struct PointerRNA *data, const char * property);
int UILayout_template_recent_files_func(struct uiLayout *_self, int rows);
void UILayout_template_file_select_path_func(struct uiLayout *_self, bContext *C, struct FileSelectParams *params);
void UILayout_template_event_from_keymap_item_func(struct uiLayout *_self, struct wmKeyMapItem *item, const char * text, const char * text_ctxt, bool translate);
void UILayout_template_asset_view_func(struct uiLayout *_self, bContext *C, const char * list_id, struct PointerRNA *asset_library_dataptr, const char * asset_library_propname, struct PointerRNA *assets_dataptr, const char * assets_propname, struct PointerRNA *active_dataptr, const char * active_propname, int filter_id_types, int display_options, const char * activate_operator, struct PointerRNA *activate_operator_properties, const char * drag_operator, struct PointerRNA *drag_operator_properties);
void UILayout_template_light_linking_collection_func(struct uiLayout *_self, bContext *C, struct uiLayout *context_layout, struct PointerRNA *data, const char * property);
void UILayout_template_bone_collection_tree_func(struct uiLayout *_self, bContext *C);
void UILayout_template_grease_pencil_layer_tree_func(struct uiLayout *_self, bContext *C);
void UILayout_template_node_tree_interface_func(struct uiLayout *_self, bContext *C, struct PointerRNA *interface);
void UILayout_template_node_inputs_func(struct uiLayout *_self, bContext *C, struct PointerRNA *node);
void UILayout_template_asset_shelf_popover_func(struct uiLayout *_self, bContext *C, const char * asset_shelf, const char * name, int icon, int icon_value);
struct PointerRNA UILayout_template_popup_confirm_func(struct uiLayout *_self, ReportList *reports, const char * operator_value, const char * text, const char * text_ctxt, bool translate, int icon, const char * cancel_text, bool cancel_default);
/**************** UIList ****************/

extern StructRNA RNA_UIList;

PointerRNA UIList_rna_type_get(PointerRNA *ptr);

int UIList_bitflag_filter_item_get(PointerRNA *ptr);
void UIList_bitflag_filter_item_set(PointerRNA *ptr, int value);

#define UIList_filter_name_MAX 128

void UIList_filter_name_get(PointerRNA *ptr, char *value);
int UIList_filter_name_length(PointerRNA *ptr);
void UIList_filter_name_set(PointerRNA *ptr, const char *value);

void UIList_bl_idname_get(PointerRNA *ptr, char *value);
int UIList_bl_idname_length(PointerRNA *ptr);
void UIList_bl_idname_set(PointerRNA *ptr, const char *value);

int UIList_bitflag_item_never_show_get(PointerRNA *ptr);
void UIList_bitflag_item_never_show_set(PointerRNA *ptr, int value);

bool UIList_use_filter_invert_get(PointerRNA *ptr);
void UIList_use_filter_invert_set(PointerRNA *ptr, bool value);

#define UIList_list_id_MAX 128

void UIList_list_id_get(PointerRNA *ptr, char *value);
int UIList_list_id_length(PointerRNA *ptr);
void UIList_list_id_set(PointerRNA *ptr, const char *value);

bool UIList_use_filter_sort_lock_get(PointerRNA *ptr);
void UIList_use_filter_sort_lock_set(PointerRNA *ptr, bool value);

bool UIList_use_filter_sort_reverse_get(PointerRNA *ptr);
void UIList_use_filter_sort_reverse_set(PointerRNA *ptr, bool value);

bool UIList_use_filter_show_get(PointerRNA *ptr);
void UIList_use_filter_show_set(PointerRNA *ptr, bool value);

bool UIList_use_filter_sort_alpha_get(PointerRNA *ptr);
void UIList_use_filter_sort_alpha_set(PointerRNA *ptr, bool value);

enum {
	UIList_layout_type_DEFAULT = 0,
	UIList_layout_type_COMPACT = 1,
	UIList_layout_type_GRID = 2,
};

int UIList_layout_type_get(PointerRNA *ptr);
void UIList_layout_type_set(PointerRNA *ptr, int value);

void UIList_draw_item_func(struct uiList *_self, struct bContext *context, struct uiLayout *layout, struct PointerRNA *data, struct PointerRNA *item, int icon, struct PointerRNA *active_data, const char * active_property, int index, int flt_flag);
void UIList_draw_filter_func(struct uiList *_self, struct bContext *context, struct uiLayout *layout);
void UIList_filter_items_func(struct uiList *_self, struct bContext *context, struct PointerRNA *data, const char * property, int *filter_flags_num, int **filter_flags, int *filter_neworder_num, int **filter_neworder);
/**************** UIPieMenu ****************/

extern StructRNA RNA_UIPieMenu;

PointerRNA UIPieMenu_rna_type_get(PointerRNA *ptr);

PointerRNA UIPieMenu_layout_get(PointerRNA *ptr);

/**************** UIPopover ****************/

extern StructRNA RNA_UIPopover;

PointerRNA UIPopover_rna_type_get(PointerRNA *ptr);

PointerRNA UIPopover_layout_get(PointerRNA *ptr);

/**************** UIPopupMenu ****************/

extern StructRNA RNA_UIPopupMenu;

PointerRNA UIPopupMenu_rna_type_get(PointerRNA *ptr);

PointerRNA UIPopupMenu_layout_get(PointerRNA *ptr);

/**************** USD Hook ****************/

extern StructRNA RNA_USDHook;

PointerRNA USDHook_rna_type_get(PointerRNA *ptr);

#define USDHook_bl_description_MAX 1024

void USDHook_bl_description_get(PointerRNA *ptr, char *value);
int USDHook_bl_description_length(PointerRNA *ptr);
void USDHook_bl_description_set(PointerRNA *ptr, const char *value);

void USDHook_bl_idname_get(PointerRNA *ptr, char *value);
int USDHook_bl_idname_length(PointerRNA *ptr);
void USDHook_bl_idname_set(PointerRNA *ptr, const char *value);

void USDHook_bl_label_get(PointerRNA *ptr, char *value);
int USDHook_bl_label_length(PointerRNA *ptr);
void USDHook_bl_label_set(PointerRNA *ptr, const char *value);

/**************** UV Map Layers ****************/

extern StructRNA RNA_UVLoopLayers;

PointerRNA UVLoopLayers_rna_type_get(PointerRNA *ptr);

int UVLoopLayers_active_index_get(PointerRNA *ptr);
void UVLoopLayers_active_index_set(PointerRNA *ptr, int value);

PointerRNA UVLoopLayers_active_get(PointerRNA *ptr);

struct PointerRNA UVLoopLayers_new_func(struct Mesh *_self, ReportList *reports, const char * name, bool do_init);
void UVLoopLayers_remove_func(struct Mesh *_self, ReportList *reports, struct CustomDataLayer *layer);
/**************** UV Project Modifier ****************/

extern StructRNA RNA_UVProjectModifier;
extern StructRNA RNA_Modifier;

float UVProjectModifier_aspect_x_get(PointerRNA *ptr);
void UVProjectModifier_aspect_x_set(PointerRNA *ptr, float value);

float UVProjectModifier_aspect_y_get(PointerRNA *ptr);
void UVProjectModifier_aspect_y_set(PointerRNA *ptr, float value);

int UVProjectModifier_projector_count_get(PointerRNA *ptr);
void UVProjectModifier_projector_count_set(PointerRNA *ptr, int value);

void UVProjectModifier_projectors_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void UVProjectModifier_projectors_next(CollectionPropertyIterator *iter);
void UVProjectModifier_projectors_end(CollectionPropertyIterator *iter);
bool UVProjectModifier_projectors_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

float UVProjectModifier_scale_x_get(PointerRNA *ptr);
void UVProjectModifier_scale_x_set(PointerRNA *ptr, float value);

float UVProjectModifier_scale_y_get(PointerRNA *ptr);
void UVProjectModifier_scale_y_set(PointerRNA *ptr, float value);

#define UVProjectModifier_uv_layer_MAX 68

void UVProjectModifier_uv_layer_get(PointerRNA *ptr, char *value);
int UVProjectModifier_uv_layer_length(PointerRNA *ptr);
void UVProjectModifier_uv_layer_set(PointerRNA *ptr, const char *value);

/**************** UVProjector ****************/

extern StructRNA RNA_UVProjector;

PointerRNA UVProjector_rna_type_get(PointerRNA *ptr);

PointerRNA UVProjector_object_get(PointerRNA *ptr);

/**************** UVWarp Modifier ****************/

extern StructRNA RNA_UVWarpModifier;
extern StructRNA RNA_Modifier;

#define UVWarpModifier_bone_from_MAX 64

void UVWarpModifier_bone_from_get(PointerRNA *ptr, char *value);
int UVWarpModifier_bone_from_length(PointerRNA *ptr);
void UVWarpModifier_bone_from_set(PointerRNA *ptr, const char *value);

#define UVWarpModifier_bone_to_MAX 64

void UVWarpModifier_bone_to_get(PointerRNA *ptr, char *value);
int UVWarpModifier_bone_to_length(PointerRNA *ptr);
void UVWarpModifier_bone_to_set(PointerRNA *ptr, const char *value);

bool UVWarpModifier_invert_vertex_group_get(PointerRNA *ptr);
void UVWarpModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

PointerRNA UVWarpModifier_object_from_get(PointerRNA *ptr);

PointerRNA UVWarpModifier_object_to_get(PointerRNA *ptr);

void UVWarpModifier_offset_get(PointerRNA *ptr, float values[2]);
void UVWarpModifier_offset_set(PointerRNA *ptr, const float values[2]);

float UVWarpModifier_rotation_get(PointerRNA *ptr);
void UVWarpModifier_rotation_set(PointerRNA *ptr, float value);

void UVWarpModifier_scale_get(PointerRNA *ptr, float values[2]);
void UVWarpModifier_scale_set(PointerRNA *ptr, const float values[2]);

enum {
	UVWarpModifier_axis_u_X = 0,
	UVWarpModifier_axis_u_Y = 1,
	UVWarpModifier_axis_u_Z = 2,
};

int UVWarpModifier_axis_u_get(PointerRNA *ptr);
void UVWarpModifier_axis_u_set(PointerRNA *ptr, int value);

void UVWarpModifier_center_get(PointerRNA *ptr, float values[2]);
void UVWarpModifier_center_set(PointerRNA *ptr, const float values[2]);

#define UVWarpModifier_uv_layer_MAX 68

void UVWarpModifier_uv_layer_get(PointerRNA *ptr, char *value);
int UVWarpModifier_uv_layer_length(PointerRNA *ptr);
void UVWarpModifier_uv_layer_set(PointerRNA *ptr, const char *value);

enum {
	UVWarpModifier_axis_v_X = 0,
	UVWarpModifier_axis_v_Y = 1,
	UVWarpModifier_axis_v_Z = 2,
};

int UVWarpModifier_axis_v_get(PointerRNA *ptr);
void UVWarpModifier_axis_v_set(PointerRNA *ptr, int value);

#define UVWarpModifier_vertex_group_MAX 64

void UVWarpModifier_vertex_group_get(PointerRNA *ptr, char *value);
int UVWarpModifier_vertex_group_length(PointerRNA *ptr);
void UVWarpModifier_vertex_group_set(PointerRNA *ptr, const char *value);

/**************** Unified Paint Settings ****************/

extern StructRNA RNA_UnifiedPaintSettings;

PointerRNA UnifiedPaintSettings_rna_type_get(PointerRNA *ptr);

void UnifiedPaintSettings_color_get(PointerRNA *ptr, float values[3]);
void UnifiedPaintSettings_color_set(PointerRNA *ptr, const float values[3]);

float UnifiedPaintSettings_hue_jitter_get(PointerRNA *ptr);
void UnifiedPaintSettings_hue_jitter_set(PointerRNA *ptr, float value);

int UnifiedPaintSettings_input_samples_get(PointerRNA *ptr);
void UnifiedPaintSettings_input_samples_set(PointerRNA *ptr, int value);

int UnifiedPaintSettings_size_get(PointerRNA *ptr);
void UnifiedPaintSettings_size_set(PointerRNA *ptr, int value);

enum {
	UnifiedPaintSettings_use_locked_size_VIEW = 0,
	UnifiedPaintSettings_use_locked_size_SCENE = 4,
};

int UnifiedPaintSettings_use_locked_size_get(PointerRNA *ptr);
void UnifiedPaintSettings_use_locked_size_set(PointerRNA *ptr, int value);

float UnifiedPaintSettings_saturation_jitter_get(PointerRNA *ptr);
void UnifiedPaintSettings_saturation_jitter_set(PointerRNA *ptr, float value);

void UnifiedPaintSettings_secondary_color_get(PointerRNA *ptr, float values[3]);
void UnifiedPaintSettings_secondary_color_set(PointerRNA *ptr, const float values[3]);

float UnifiedPaintSettings_strength_get(PointerRNA *ptr);
void UnifiedPaintSettings_strength_set(PointerRNA *ptr, float value);

bool UnifiedPaintSettings_use_stroke_random_hue_get(PointerRNA *ptr);
void UnifiedPaintSettings_use_stroke_random_hue_set(PointerRNA *ptr, bool value);

bool UnifiedPaintSettings_use_stroke_random_sat_get(PointerRNA *ptr);
void UnifiedPaintSettings_use_stroke_random_sat_set(PointerRNA *ptr, bool value);

bool UnifiedPaintSettings_use_stroke_random_val_get(PointerRNA *ptr);
void UnifiedPaintSettings_use_stroke_random_val_set(PointerRNA *ptr, bool value);

float UnifiedPaintSettings_unprojected_radius_get(PointerRNA *ptr);
void UnifiedPaintSettings_unprojected_radius_set(PointerRNA *ptr, float value);

bool UnifiedPaintSettings_use_color_jitter_get(PointerRNA *ptr);
void UnifiedPaintSettings_use_color_jitter_set(PointerRNA *ptr, bool value);

bool UnifiedPaintSettings_use_random_press_hue_get(PointerRNA *ptr);
void UnifiedPaintSettings_use_random_press_hue_set(PointerRNA *ptr, bool value);

bool UnifiedPaintSettings_use_random_press_sat_get(PointerRNA *ptr);
void UnifiedPaintSettings_use_random_press_sat_set(PointerRNA *ptr, bool value);

bool UnifiedPaintSettings_use_random_press_val_get(PointerRNA *ptr);
void UnifiedPaintSettings_use_random_press_val_set(PointerRNA *ptr, bool value);

bool UnifiedPaintSettings_use_unified_color_get(PointerRNA *ptr);
void UnifiedPaintSettings_use_unified_color_set(PointerRNA *ptr, bool value);

bool UnifiedPaintSettings_use_unified_input_samples_get(PointerRNA *ptr);
void UnifiedPaintSettings_use_unified_input_samples_set(PointerRNA *ptr, bool value);

bool UnifiedPaintSettings_use_unified_size_get(PointerRNA *ptr);
void UnifiedPaintSettings_use_unified_size_set(PointerRNA *ptr, bool value);

bool UnifiedPaintSettings_use_unified_strength_get(PointerRNA *ptr);
void UnifiedPaintSettings_use_unified_strength_set(PointerRNA *ptr, bool value);

bool UnifiedPaintSettings_use_unified_weight_get(PointerRNA *ptr);
void UnifiedPaintSettings_use_unified_weight_set(PointerRNA *ptr, bool value);

float UnifiedPaintSettings_value_jitter_get(PointerRNA *ptr);
void UnifiedPaintSettings_value_jitter_set(PointerRNA *ptr, float value);

float UnifiedPaintSettings_weight_get(PointerRNA *ptr);
void UnifiedPaintSettings_weight_set(PointerRNA *ptr, float value);

/**************** Unit Settings ****************/

extern StructRNA RNA_UnitSettings;

PointerRNA UnitSettings_rna_type_get(PointerRNA *ptr);

enum {
	UnitSettings_length_unit_DEFAULT = 0,
};

int UnitSettings_length_unit_get(PointerRNA *ptr);
void UnitSettings_length_unit_set(PointerRNA *ptr, int value);

enum {
	UnitSettings_mass_unit_DEFAULT = 0,
};

int UnitSettings_mass_unit_get(PointerRNA *ptr);
void UnitSettings_mass_unit_set(PointerRNA *ptr, int value);

enum {
	UnitSettings_system_rotation_DEGREES = 0,
	UnitSettings_system_rotation_RADIANS = 2,
};

int UnitSettings_system_rotation_get(PointerRNA *ptr);
void UnitSettings_system_rotation_set(PointerRNA *ptr, int value);

bool UnitSettings_use_separate_get(PointerRNA *ptr);
void UnitSettings_use_separate_set(PointerRNA *ptr, bool value);

enum {
	UnitSettings_temperature_unit_DEFAULT = 0,
};

int UnitSettings_temperature_unit_get(PointerRNA *ptr);
void UnitSettings_temperature_unit_set(PointerRNA *ptr, int value);

enum {
	UnitSettings_time_unit_DEFAULT = 0,
};

int UnitSettings_time_unit_get(PointerRNA *ptr);
void UnitSettings_time_unit_set(PointerRNA *ptr, int value);

float UnitSettings_scale_length_get(PointerRNA *ptr);
void UnitSettings_scale_length_set(PointerRNA *ptr, float value);

enum {
	UnitSettings_system_NONE = 0,
	UnitSettings_system_METRIC = 1,
	UnitSettings_system_IMPERIAL = 2,
};

int UnitSettings_system_get(PointerRNA *ptr);
void UnitSettings_system_set(PointerRNA *ptr, int value);

/**************** Unknown Type ****************/

extern StructRNA RNA_UnknownType;

PointerRNA UnknownType_rna_type_get(PointerRNA *ptr);

/**************** Asset Library ****************/

extern StructRNA RNA_UserAssetLibrary;

PointerRNA UserAssetLibrary_rna_type_get(PointerRNA *ptr);

#define UserAssetLibrary_name_MAX 64

void UserAssetLibrary_name_get(PointerRNA *ptr, char *value);
int UserAssetLibrary_name_length(PointerRNA *ptr);
void UserAssetLibrary_name_set(PointerRNA *ptr, const char *value);

enum {
	UserAssetLibrary_import_method_LINK = 0,
	UserAssetLibrary_import_method_APPEND = 1,
	UserAssetLibrary_import_method_APPEND_REUSE = 2,
};

int UserAssetLibrary_import_method_get(PointerRNA *ptr);
void UserAssetLibrary_import_method_set(PointerRNA *ptr, int value);

#define UserAssetLibrary_path_MAX 1024

void UserAssetLibrary_path_get(PointerRNA *ptr, char *value);
int UserAssetLibrary_path_length(PointerRNA *ptr);
void UserAssetLibrary_path_set(PointerRNA *ptr, const char *value);

bool UserAssetLibrary_use_relative_path_get(PointerRNA *ptr);
void UserAssetLibrary_use_relative_path_set(PointerRNA *ptr, bool value);

/**************** Extension Repository ****************/

extern StructRNA RNA_UserExtensionRepo;

PointerRNA UserExtensionRepo_rna_type_get(PointerRNA *ptr);

#define UserExtensionRepo_name_MAX 64

void UserExtensionRepo_name_get(PointerRNA *ptr, char *value);
int UserExtensionRepo_name_length(PointerRNA *ptr);
void UserExtensionRepo_name_set(PointerRNA *ptr, const char *value);

bool UserExtensionRepo_use_sync_on_startup_get(PointerRNA *ptr);
void UserExtensionRepo_use_sync_on_startup_set(PointerRNA *ptr, bool value);

bool UserExtensionRepo_use_cache_get(PointerRNA *ptr);
void UserExtensionRepo_use_cache_set(PointerRNA *ptr, bool value);

#define UserExtensionRepo_custom_directory_MAX 1024

void UserExtensionRepo_custom_directory_get(PointerRNA *ptr, char *value);
int UserExtensionRepo_custom_directory_length(PointerRNA *ptr);
void UserExtensionRepo_custom_directory_set(PointerRNA *ptr, const char *value);

bool UserExtensionRepo_use_custom_directory_get(PointerRNA *ptr);
void UserExtensionRepo_use_custom_directory_set(PointerRNA *ptr, bool value);

void UserExtensionRepo_directory_get(PointerRNA *ptr, char *value);
int UserExtensionRepo_directory_length(PointerRNA *ptr);
void UserExtensionRepo_directory_set(PointerRNA *ptr, const char *value);

bool UserExtensionRepo_enabled_get(PointerRNA *ptr);
void UserExtensionRepo_enabled_set(PointerRNA *ptr, bool value);

#define UserExtensionRepo_module_MAX 48

void UserExtensionRepo_module_get(PointerRNA *ptr, char *value);
int UserExtensionRepo_module_length(PointerRNA *ptr);
void UserExtensionRepo_module_set(PointerRNA *ptr, const char *value);

bool UserExtensionRepo_use_access_token_get(PointerRNA *ptr);
void UserExtensionRepo_use_access_token_set(PointerRNA *ptr, bool value);

void UserExtensionRepo_access_token_get(PointerRNA *ptr, char *value);
int UserExtensionRepo_access_token_length(PointerRNA *ptr);
void UserExtensionRepo_access_token_set(PointerRNA *ptr, const char *value);

enum {
	UserExtensionRepo_source_USER = 0,
	UserExtensionRepo_source_SYSTEM = 1,
};

int UserExtensionRepo_source_get(PointerRNA *ptr);
void UserExtensionRepo_source_set(PointerRNA *ptr, int value);

#define UserExtensionRepo_remote_url_MAX 1024

void UserExtensionRepo_remote_url_get(PointerRNA *ptr, char *value);
int UserExtensionRepo_remote_url_length(PointerRNA *ptr);
void UserExtensionRepo_remote_url_set(PointerRNA *ptr, const char *value);

bool UserExtensionRepo_use_remote_url_get(PointerRNA *ptr);
void UserExtensionRepo_use_remote_url_set(PointerRNA *ptr, bool value);

/**************** User Extension Repositories ****************/

extern StructRNA RNA_UserExtensionRepoCollection;

PointerRNA UserExtensionRepoCollection_rna_type_get(PointerRNA *ptr);

struct bUserExtensionRepo *UserExtensionRepoCollection_new_func(const char * name, const char * module, const char * custom_directory, const char * remote_url, int source);
void UserExtensionRepoCollection_remove_func(ReportList *reports, struct PointerRNA *repo);
/**************** Solid Light ****************/

extern StructRNA RNA_UserSolidLight;

PointerRNA UserSolidLight_rna_type_get(PointerRNA *ptr);

void UserSolidLight_diffuse_color_get(PointerRNA *ptr, float values[3]);
void UserSolidLight_diffuse_color_set(PointerRNA *ptr, const float values[3]);

void UserSolidLight_direction_get(PointerRNA *ptr, float values[3]);
void UserSolidLight_direction_set(PointerRNA *ptr, const float values[3]);

bool UserSolidLight_use_get(PointerRNA *ptr);
void UserSolidLight_use_set(PointerRNA *ptr, bool value);

float UserSolidLight_smooth_get(PointerRNA *ptr);
void UserSolidLight_smooth_set(PointerRNA *ptr, float value);

void UserSolidLight_specular_color_get(PointerRNA *ptr, float values[3]);
void UserSolidLight_specular_color_set(PointerRNA *ptr, const float values[3]);

/**************** UV Sculpting ****************/

extern StructRNA RNA_UvSculpt;

PointerRNA UvSculpt_rna_type_get(PointerRNA *ptr);

int UvSculpt_size_get(PointerRNA *ptr);
void UvSculpt_size_set(PointerRNA *ptr, int value);

float UvSculpt_strength_get(PointerRNA *ptr);
void UvSculpt_strength_set(PointerRNA *ptr, float value);

PointerRNA UvSculpt_strength_curve_get(PointerRNA *ptr);

enum {
	UvSculpt_curve_preset_CUSTOM = 0,
	UvSculpt_curve_preset_SMOOTH = 1,
	UvSculpt_curve_preset_SMOOTHER = 9,
	UvSculpt_curve_preset_SPHERE = 2,
	UvSculpt_curve_preset_ROOT = 3,
	UvSculpt_curve_preset_SHARP = 4,
	UvSculpt_curve_preset_LIN = 5,
	UvSculpt_curve_preset_POW4 = 6,
	UvSculpt_curve_preset_INVSQUARE = 7,
	UvSculpt_curve_preset_CONSTANT = 8,
};

int UvSculpt_curve_preset_get(PointerRNA *ptr);
void UvSculpt_curve_preset_set(PointerRNA *ptr, int value);

/**************** Vector Font ****************/

extern StructRNA RNA_VectorFont;
extern StructRNA RNA_ID;

#define VectorFont_filepath_MAX 1024

void VectorFont_filepath_get(PointerRNA *ptr, char *value);
int VectorFont_filepath_length(PointerRNA *ptr);
void VectorFont_filepath_set(PointerRNA *ptr, const char *value);

PointerRNA VectorFont_packed_file_get(PointerRNA *ptr);

void VectorFont_pack_func(struct VFont *_self, Main *bmain, ReportList *reports);
void VectorFont_unpack_func(struct VFont *_self, Main *bmain, ReportList *reports, int method);
/**************** Vertex Group ****************/

extern StructRNA RNA_VertexGroup;

PointerRNA VertexGroup_rna_type_get(PointerRNA *ptr);

#define VertexGroup_name_MAX 64

void VertexGroup_name_get(PointerRNA *ptr, char *value);
int VertexGroup_name_length(PointerRNA *ptr);
void VertexGroup_name_set(PointerRNA *ptr, const char *value);

bool VertexGroup_lock_weight_get(PointerRNA *ptr);
void VertexGroup_lock_weight_set(PointerRNA *ptr, bool value);

int VertexGroup_index_get(PointerRNA *ptr);
void VertexGroup_index_set(PointerRNA *ptr, int value);

void VertexGroup_add_func(struct ID *_selfid, struct bDeformGroup *_self, ReportList *reports, int index_num, int *index, float weight, int type);
void VertexGroup_remove_func(struct ID *_selfid, struct bDeformGroup *_self, ReportList *reports, int index_num, int *index);
float VertexGroup_weight_func(struct ID *_selfid, struct bDeformGroup *_self, ReportList *reports, int index);
/**************** Vertex Group Element ****************/

extern StructRNA RNA_VertexGroupElement;

PointerRNA VertexGroupElement_rna_type_get(PointerRNA *ptr);

int VertexGroupElement_group_get(PointerRNA *ptr);
void VertexGroupElement_group_set(PointerRNA *ptr, int value);

float VertexGroupElement_weight_get(PointerRNA *ptr);
void VertexGroupElement_weight_set(PointerRNA *ptr, float value);

/**************** Vertex Groups ****************/

extern StructRNA RNA_VertexGroups;

PointerRNA VertexGroups_rna_type_get(PointerRNA *ptr);

PointerRNA VertexGroups_active_get(PointerRNA *ptr);

int VertexGroups_active_index_get(PointerRNA *ptr);
void VertexGroups_active_index_set(PointerRNA *ptr, int value);

struct bDeformGroup *VertexGroups_new_func(struct Object *_self, Main *bmain, ReportList *reports, const char * name);
void VertexGroups_remove_func(struct Object *_self, Main *bmain, ReportList *reports, struct PointerRNA *group);
void VertexGroups_clear_func(struct Object *_self, Main *bmain, ReportList *reports);
/**************** Vertex Paint ****************/

extern StructRNA RNA_VertexPaint;
extern StructRNA RNA_Paint;

void VertexPaint_radial_symmetry_get(PointerRNA *ptr, int values[3]);
void VertexPaint_radial_symmetry_set(PointerRNA *ptr, const int values[3]);

bool VertexPaint_use_group_restrict_get(PointerRNA *ptr);
void VertexPaint_use_group_restrict_set(PointerRNA *ptr, bool value);

/**************** WeightVG Edit Modifier ****************/

extern StructRNA RNA_VertexWeightEditModifier;
extern StructRNA RNA_Modifier;

float VertexWeightEditModifier_add_threshold_get(PointerRNA *ptr);
void VertexWeightEditModifier_add_threshold_set(PointerRNA *ptr, float value);

float VertexWeightEditModifier_default_weight_get(PointerRNA *ptr);
void VertexWeightEditModifier_default_weight_set(PointerRNA *ptr, float value);

enum {
	VertexWeightEditModifier_falloff_type_LINEAR = 0,
	VertexWeightEditModifier_falloff_type_CURVE = 1,
	VertexWeightEditModifier_falloff_type_SHARP = 2,
	VertexWeightEditModifier_falloff_type_SMOOTH = 3,
	VertexWeightEditModifier_falloff_type_ROOT = 4,
	VertexWeightEditModifier_falloff_type_ICON_SPHERECURVE = 7,
	VertexWeightEditModifier_falloff_type_RANDOM = 8,
	VertexWeightEditModifier_falloff_type_STEP = 9,
};

int VertexWeightEditModifier_falloff_type_get(PointerRNA *ptr);
void VertexWeightEditModifier_falloff_type_set(PointerRNA *ptr, int value);

bool VertexWeightEditModifier_use_add_get(PointerRNA *ptr);
void VertexWeightEditModifier_use_add_set(PointerRNA *ptr, bool value);

bool VertexWeightEditModifier_use_remove_get(PointerRNA *ptr);
void VertexWeightEditModifier_use_remove_set(PointerRNA *ptr, bool value);

float VertexWeightEditModifier_mask_constant_get(PointerRNA *ptr);
void VertexWeightEditModifier_mask_constant_set(PointerRNA *ptr, float value);

bool VertexWeightEditModifier_invert_mask_vertex_group_get(PointerRNA *ptr);
void VertexWeightEditModifier_invert_mask_vertex_group_set(PointerRNA *ptr, bool value);

bool VertexWeightEditModifier_invert_falloff_get(PointerRNA *ptr);
void VertexWeightEditModifier_invert_falloff_set(PointerRNA *ptr, bool value);

PointerRNA VertexWeightEditModifier_map_curve_get(PointerRNA *ptr);

#define VertexWeightEditModifier_mask_vertex_group_MAX 64

void VertexWeightEditModifier_mask_vertex_group_get(PointerRNA *ptr, char *value);
int VertexWeightEditModifier_mask_vertex_group_length(PointerRNA *ptr);
void VertexWeightEditModifier_mask_vertex_group_set(PointerRNA *ptr, const char *value);

PointerRNA VertexWeightEditModifier_mask_texture_get(PointerRNA *ptr);

bool VertexWeightEditModifier_normalize_get(PointerRNA *ptr);
void VertexWeightEditModifier_normalize_set(PointerRNA *ptr, bool value);

float VertexWeightEditModifier_remove_threshold_get(PointerRNA *ptr);
void VertexWeightEditModifier_remove_threshold_set(PointerRNA *ptr, float value);

#define VertexWeightEditModifier_mask_tex_map_bone_MAX 64

void VertexWeightEditModifier_mask_tex_map_bone_get(PointerRNA *ptr, char *value);
int VertexWeightEditModifier_mask_tex_map_bone_length(PointerRNA *ptr);
void VertexWeightEditModifier_mask_tex_map_bone_set(PointerRNA *ptr, const char *value);

PointerRNA VertexWeightEditModifier_mask_tex_map_object_get(PointerRNA *ptr);

enum {
	VertexWeightEditModifier_mask_tex_mapping_LOCAL = 0,
	VertexWeightEditModifier_mask_tex_mapping_GLOBAL = 1,
	VertexWeightEditModifier_mask_tex_mapping_OBJECT = 2,
	VertexWeightEditModifier_mask_tex_mapping_UV = 3,
};

int VertexWeightEditModifier_mask_tex_mapping_get(PointerRNA *ptr);
void VertexWeightEditModifier_mask_tex_mapping_set(PointerRNA *ptr, int value);

#define VertexWeightEditModifier_mask_tex_uv_layer_MAX 68

void VertexWeightEditModifier_mask_tex_uv_layer_get(PointerRNA *ptr, char *value);
int VertexWeightEditModifier_mask_tex_uv_layer_length(PointerRNA *ptr);
void VertexWeightEditModifier_mask_tex_uv_layer_set(PointerRNA *ptr, const char *value);

enum {
	VertexWeightEditModifier_mask_tex_use_channel_INT = 1,
	VertexWeightEditModifier_mask_tex_use_channel_RED = 2,
	VertexWeightEditModifier_mask_tex_use_channel_GREEN = 3,
	VertexWeightEditModifier_mask_tex_use_channel_BLUE = 4,
	VertexWeightEditModifier_mask_tex_use_channel_HUE = 5,
	VertexWeightEditModifier_mask_tex_use_channel_SAT = 6,
	VertexWeightEditModifier_mask_tex_use_channel_VAL = 7,
	VertexWeightEditModifier_mask_tex_use_channel_ALPHA = 8,
};

int VertexWeightEditModifier_mask_tex_use_channel_get(PointerRNA *ptr);
void VertexWeightEditModifier_mask_tex_use_channel_set(PointerRNA *ptr, int value);

#define VertexWeightEditModifier_vertex_group_MAX 64

void VertexWeightEditModifier_vertex_group_get(PointerRNA *ptr, char *value);
int VertexWeightEditModifier_vertex_group_length(PointerRNA *ptr);
void VertexWeightEditModifier_vertex_group_set(PointerRNA *ptr, const char *value);

/**************** WeightVG Mix Modifier ****************/

extern StructRNA RNA_VertexWeightMixModifier;
extern StructRNA RNA_Modifier;

float VertexWeightMixModifier_default_weight_a_get(PointerRNA *ptr);
void VertexWeightMixModifier_default_weight_a_set(PointerRNA *ptr, float value);

float VertexWeightMixModifier_default_weight_b_get(PointerRNA *ptr);
void VertexWeightMixModifier_default_weight_b_set(PointerRNA *ptr, float value);

float VertexWeightMixModifier_mask_constant_get(PointerRNA *ptr);
void VertexWeightMixModifier_mask_constant_set(PointerRNA *ptr, float value);

bool VertexWeightMixModifier_invert_mask_vertex_group_get(PointerRNA *ptr);
void VertexWeightMixModifier_invert_mask_vertex_group_set(PointerRNA *ptr, bool value);

bool VertexWeightMixModifier_invert_vertex_group_a_get(PointerRNA *ptr);
void VertexWeightMixModifier_invert_vertex_group_a_set(PointerRNA *ptr, bool value);

bool VertexWeightMixModifier_invert_vertex_group_b_get(PointerRNA *ptr);
void VertexWeightMixModifier_invert_vertex_group_b_set(PointerRNA *ptr, bool value);

#define VertexWeightMixModifier_mask_vertex_group_MAX 64

void VertexWeightMixModifier_mask_vertex_group_get(PointerRNA *ptr, char *value);
int VertexWeightMixModifier_mask_vertex_group_length(PointerRNA *ptr);
void VertexWeightMixModifier_mask_vertex_group_set(PointerRNA *ptr, const char *value);

PointerRNA VertexWeightMixModifier_mask_texture_get(PointerRNA *ptr);

enum {
	VertexWeightMixModifier_mix_mode_SET = 1,
	VertexWeightMixModifier_mix_mode_ADD = 2,
	VertexWeightMixModifier_mix_mode_SUB = 3,
	VertexWeightMixModifier_mix_mode_MUL = 4,
	VertexWeightMixModifier_mix_mode_DIV = 5,
	VertexWeightMixModifier_mix_mode_DIF = 6,
	VertexWeightMixModifier_mix_mode_AVG = 7,
	VertexWeightMixModifier_mix_mode_MIN = 8,
	VertexWeightMixModifier_mix_mode_MAX = 9,
};

int VertexWeightMixModifier_mix_mode_get(PointerRNA *ptr);
void VertexWeightMixModifier_mix_mode_set(PointerRNA *ptr, int value);

bool VertexWeightMixModifier_normalize_get(PointerRNA *ptr);
void VertexWeightMixModifier_normalize_set(PointerRNA *ptr, bool value);

#define VertexWeightMixModifier_mask_tex_map_bone_MAX 64

void VertexWeightMixModifier_mask_tex_map_bone_get(PointerRNA *ptr, char *value);
int VertexWeightMixModifier_mask_tex_map_bone_length(PointerRNA *ptr);
void VertexWeightMixModifier_mask_tex_map_bone_set(PointerRNA *ptr, const char *value);

PointerRNA VertexWeightMixModifier_mask_tex_map_object_get(PointerRNA *ptr);

enum {
	VertexWeightMixModifier_mask_tex_mapping_LOCAL = 0,
	VertexWeightMixModifier_mask_tex_mapping_GLOBAL = 1,
	VertexWeightMixModifier_mask_tex_mapping_OBJECT = 2,
	VertexWeightMixModifier_mask_tex_mapping_UV = 3,
};

int VertexWeightMixModifier_mask_tex_mapping_get(PointerRNA *ptr);
void VertexWeightMixModifier_mask_tex_mapping_set(PointerRNA *ptr, int value);

#define VertexWeightMixModifier_mask_tex_uv_layer_MAX 68

void VertexWeightMixModifier_mask_tex_uv_layer_get(PointerRNA *ptr, char *value);
int VertexWeightMixModifier_mask_tex_uv_layer_length(PointerRNA *ptr);
void VertexWeightMixModifier_mask_tex_uv_layer_set(PointerRNA *ptr, const char *value);

enum {
	VertexWeightMixModifier_mask_tex_use_channel_INT = 1,
	VertexWeightMixModifier_mask_tex_use_channel_RED = 2,
	VertexWeightMixModifier_mask_tex_use_channel_GREEN = 3,
	VertexWeightMixModifier_mask_tex_use_channel_BLUE = 4,
	VertexWeightMixModifier_mask_tex_use_channel_HUE = 5,
	VertexWeightMixModifier_mask_tex_use_channel_SAT = 6,
	VertexWeightMixModifier_mask_tex_use_channel_VAL = 7,
	VertexWeightMixModifier_mask_tex_use_channel_ALPHA = 8,
};

int VertexWeightMixModifier_mask_tex_use_channel_get(PointerRNA *ptr);
void VertexWeightMixModifier_mask_tex_use_channel_set(PointerRNA *ptr, int value);

#define VertexWeightMixModifier_vertex_group_a_MAX 64

void VertexWeightMixModifier_vertex_group_a_get(PointerRNA *ptr, char *value);
int VertexWeightMixModifier_vertex_group_a_length(PointerRNA *ptr);
void VertexWeightMixModifier_vertex_group_a_set(PointerRNA *ptr, const char *value);

#define VertexWeightMixModifier_vertex_group_b_MAX 64

void VertexWeightMixModifier_vertex_group_b_get(PointerRNA *ptr, char *value);
int VertexWeightMixModifier_vertex_group_b_length(PointerRNA *ptr);
void VertexWeightMixModifier_vertex_group_b_set(PointerRNA *ptr, const char *value);

enum {
	VertexWeightMixModifier_mix_set_ALL = 1,
	VertexWeightMixModifier_mix_set_A = 2,
	VertexWeightMixModifier_mix_set_B = 3,
	VertexWeightMixModifier_mix_set_OR = 4,
	VertexWeightMixModifier_mix_set_AND = 5,
};

int VertexWeightMixModifier_mix_set_get(PointerRNA *ptr);
void VertexWeightMixModifier_mix_set_set(PointerRNA *ptr, int value);

/**************** WeightVG Proximity Modifier ****************/

extern StructRNA RNA_VertexWeightProximityModifier;
extern StructRNA RNA_Modifier;

enum {
	VertexWeightProximityModifier_falloff_type_LINEAR = 0,
	VertexWeightProximityModifier_falloff_type_CURVE = 1,
	VertexWeightProximityModifier_falloff_type_SHARP = 2,
	VertexWeightProximityModifier_falloff_type_SMOOTH = 3,
	VertexWeightProximityModifier_falloff_type_ROOT = 4,
	VertexWeightProximityModifier_falloff_type_ICON_SPHERECURVE = 7,
	VertexWeightProximityModifier_falloff_type_RANDOM = 8,
	VertexWeightProximityModifier_falloff_type_STEP = 9,
};

int VertexWeightProximityModifier_falloff_type_get(PointerRNA *ptr);
void VertexWeightProximityModifier_falloff_type_set(PointerRNA *ptr, int value);

float VertexWeightProximityModifier_max_dist_get(PointerRNA *ptr);
void VertexWeightProximityModifier_max_dist_set(PointerRNA *ptr, float value);

float VertexWeightProximityModifier_mask_constant_get(PointerRNA *ptr);
void VertexWeightProximityModifier_mask_constant_set(PointerRNA *ptr, float value);

bool VertexWeightProximityModifier_invert_mask_vertex_group_get(PointerRNA *ptr);
void VertexWeightProximityModifier_invert_mask_vertex_group_set(PointerRNA *ptr, bool value);

bool VertexWeightProximityModifier_invert_falloff_get(PointerRNA *ptr);
void VertexWeightProximityModifier_invert_falloff_set(PointerRNA *ptr, bool value);

float VertexWeightProximityModifier_min_dist_get(PointerRNA *ptr);
void VertexWeightProximityModifier_min_dist_set(PointerRNA *ptr, float value);

PointerRNA VertexWeightProximityModifier_map_curve_get(PointerRNA *ptr);

#define VertexWeightProximityModifier_mask_vertex_group_MAX 64

void VertexWeightProximityModifier_mask_vertex_group_get(PointerRNA *ptr, char *value);
int VertexWeightProximityModifier_mask_vertex_group_length(PointerRNA *ptr);
void VertexWeightProximityModifier_mask_vertex_group_set(PointerRNA *ptr, const char *value);

PointerRNA VertexWeightProximityModifier_mask_texture_get(PointerRNA *ptr);

bool VertexWeightProximityModifier_normalize_get(PointerRNA *ptr);
void VertexWeightProximityModifier_normalize_set(PointerRNA *ptr, bool value);

enum {
	VertexWeightProximityModifier_proximity_geometry_VERTEX = 1,
	VertexWeightProximityModifier_proximity_geometry_EDGE = 2,
	VertexWeightProximityModifier_proximity_geometry_FACE = 4,
};

int VertexWeightProximityModifier_proximity_geometry_get(PointerRNA *ptr);
void VertexWeightProximityModifier_proximity_geometry_set(PointerRNA *ptr, int value);

enum {
	VertexWeightProximityModifier_proximity_mode_OBJECT = 1,
	VertexWeightProximityModifier_proximity_mode_GEOMETRY = 2,
};

int VertexWeightProximityModifier_proximity_mode_get(PointerRNA *ptr);
void VertexWeightProximityModifier_proximity_mode_set(PointerRNA *ptr, int value);

PointerRNA VertexWeightProximityModifier_target_get(PointerRNA *ptr);

#define VertexWeightProximityModifier_mask_tex_map_bone_MAX 64

void VertexWeightProximityModifier_mask_tex_map_bone_get(PointerRNA *ptr, char *value);
int VertexWeightProximityModifier_mask_tex_map_bone_length(PointerRNA *ptr);
void VertexWeightProximityModifier_mask_tex_map_bone_set(PointerRNA *ptr, const char *value);

PointerRNA VertexWeightProximityModifier_mask_tex_map_object_get(PointerRNA *ptr);

enum {
	VertexWeightProximityModifier_mask_tex_mapping_LOCAL = 0,
	VertexWeightProximityModifier_mask_tex_mapping_GLOBAL = 1,
	VertexWeightProximityModifier_mask_tex_mapping_OBJECT = 2,
	VertexWeightProximityModifier_mask_tex_mapping_UV = 3,
};

int VertexWeightProximityModifier_mask_tex_mapping_get(PointerRNA *ptr);
void VertexWeightProximityModifier_mask_tex_mapping_set(PointerRNA *ptr, int value);

#define VertexWeightProximityModifier_mask_tex_uv_layer_MAX 68

void VertexWeightProximityModifier_mask_tex_uv_layer_get(PointerRNA *ptr, char *value);
int VertexWeightProximityModifier_mask_tex_uv_layer_length(PointerRNA *ptr);
void VertexWeightProximityModifier_mask_tex_uv_layer_set(PointerRNA *ptr, const char *value);

enum {
	VertexWeightProximityModifier_mask_tex_use_channel_INT = 1,
	VertexWeightProximityModifier_mask_tex_use_channel_RED = 2,
	VertexWeightProximityModifier_mask_tex_use_channel_GREEN = 3,
	VertexWeightProximityModifier_mask_tex_use_channel_BLUE = 4,
	VertexWeightProximityModifier_mask_tex_use_channel_HUE = 5,
	VertexWeightProximityModifier_mask_tex_use_channel_SAT = 6,
	VertexWeightProximityModifier_mask_tex_use_channel_VAL = 7,
	VertexWeightProximityModifier_mask_tex_use_channel_ALPHA = 8,
};

int VertexWeightProximityModifier_mask_tex_use_channel_get(PointerRNA *ptr);
void VertexWeightProximityModifier_mask_tex_use_channel_set(PointerRNA *ptr, int value);

#define VertexWeightProximityModifier_vertex_group_MAX 64

void VertexWeightProximityModifier_vertex_group_get(PointerRNA *ptr, char *value);
int VertexWeightProximityModifier_vertex_group_length(PointerRNA *ptr);
void VertexWeightProximityModifier_vertex_group_set(PointerRNA *ptr, const char *value);

/**************** View2D ****************/

extern StructRNA RNA_View2D;

PointerRNA View2D_rna_type_get(PointerRNA *ptr);

void View2D_region_to_view_func(struct View2D *_self, float x, float y, float result[2]);
void View2D_view_to_region_func(struct View2D *_self, float x, float y, bool clip, int result[2]);
/**************** 3D Cursor ****************/

extern StructRNA RNA_View3DCursor;

PointerRNA View3DCursor_rna_type_get(PointerRNA *ptr);

void View3DCursor_rotation_axis_angle_get(PointerRNA *ptr, float values[4]);
void View3DCursor_rotation_axis_angle_set(PointerRNA *ptr, const float values[4]);

void View3DCursor_rotation_euler_get(PointerRNA *ptr, float values[3]);
void View3DCursor_rotation_euler_set(PointerRNA *ptr, const float values[3]);

void View3DCursor_location_get(PointerRNA *ptr, float values[3]);
void View3DCursor_location_set(PointerRNA *ptr, const float values[3]);

void View3DCursor_rotation_quaternion_get(PointerRNA *ptr, float values[4]);
void View3DCursor_rotation_quaternion_set(PointerRNA *ptr, const float values[4]);

enum {
	View3DCursor_rotation_mode_QUATERNION = 0,
	View3DCursor_rotation_mode_XYZ = 1,
	View3DCursor_rotation_mode_XZY = 2,
	View3DCursor_rotation_mode_YXZ = 3,
	View3DCursor_rotation_mode_YZX = 4,
	View3DCursor_rotation_mode_ZXY = 5,
	View3DCursor_rotation_mode_ZYX = 6,
	View3DCursor_rotation_mode_AXIS_ANGLE = -1,
};

int View3DCursor_rotation_mode_get(PointerRNA *ptr);
void View3DCursor_rotation_mode_set(PointerRNA *ptr, int value);

void View3DCursor_matrix_get(PointerRNA *ptr, float values[16]);
void View3DCursor_matrix_set(PointerRNA *ptr, const float values[16]);

/**************** 3D View Overlay Settings ****************/

extern StructRNA RNA_View3DOverlay;

PointerRNA View3DOverlay_rna_type_get(PointerRNA *ptr);

bool View3DOverlay_use_gpencil_onion_skin_active_object_get(PointerRNA *ptr);
void View3DOverlay_use_gpencil_onion_skin_active_object_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_object_origins_all_get(PointerRNA *ptr);
void View3DOverlay_show_object_origins_all_set(PointerRNA *ptr, bool value);

float View3DOverlay_bone_wire_alpha_get(PointerRNA *ptr);
void View3DOverlay_bone_wire_alpha_set(PointerRNA *ptr, float value);

bool View3DOverlay_use_gpencil_canvas_xray_get(PointerRNA *ptr);
void View3DOverlay_use_gpencil_canvas_xray_set(PointerRNA *ptr, bool value);

bool View3DOverlay_use_normals_constant_screen_size_get(PointerRNA *ptr);
void View3DOverlay_use_normals_constant_screen_size_set(PointerRNA *ptr, bool value);

float View3DOverlay_sculpt_curves_cage_opacity_get(PointerRNA *ptr);
void View3DOverlay_sculpt_curves_cage_opacity_set(PointerRNA *ptr, float value);

bool View3DOverlay_show_edge_bevel_weight_get(PointerRNA *ptr);
void View3DOverlay_show_edge_bevel_weight_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_edge_crease_get(PointerRNA *ptr);
void View3DOverlay_show_edge_crease_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_face_center_get(PointerRNA *ptr);
void View3DOverlay_show_face_center_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_faces_get(PointerRNA *ptr);
void View3DOverlay_show_faces_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_freestyle_edge_marks_get(PointerRNA *ptr);
void View3DOverlay_show_freestyle_edge_marks_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_freestyle_face_marks_get(PointerRNA *ptr);
void View3DOverlay_show_freestyle_face_marks_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_ortho_grid_get(PointerRNA *ptr);
void View3DOverlay_show_ortho_grid_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_floor_get(PointerRNA *ptr);
void View3DOverlay_show_floor_set(PointerRNA *ptr, bool value);

enum {
	View3DOverlay_display_handle_NONE = 2,
	View3DOverlay_display_handle_SELECTED = 0,
	View3DOverlay_display_handle_ALL = 1,
};

int View3DOverlay_display_handle_get(PointerRNA *ptr);
void View3DOverlay_display_handle_set(PointerRNA *ptr, int value);

bool View3DOverlay_show_face_normals_get(PointerRNA *ptr);
void View3DOverlay_show_face_normals_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_edge_seams_get(PointerRNA *ptr);
void View3DOverlay_show_edge_seams_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_edge_sharp_get(PointerRNA *ptr);
void View3DOverlay_show_edge_sharp_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_split_normals_get(PointerRNA *ptr);
void View3DOverlay_show_split_normals_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_vertex_normals_get(PointerRNA *ptr);
void View3DOverlay_show_vertex_normals_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_axis_x_get(PointerRNA *ptr);
void View3DOverlay_show_axis_x_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_axis_y_get(PointerRNA *ptr);
void View3DOverlay_show_axis_y_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_axis_z_get(PointerRNA *ptr);
void View3DOverlay_show_axis_z_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_curve_normals_get(PointerRNA *ptr);
void View3DOverlay_show_curve_normals_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_extra_edge_angle_get(PointerRNA *ptr);
void View3DOverlay_show_extra_edge_angle_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_extra_edge_length_get(PointerRNA *ptr);
void View3DOverlay_show_extra_edge_length_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_extras_get(PointerRNA *ptr);
void View3DOverlay_show_extras_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_extra_face_angle_get(PointerRNA *ptr);
void View3DOverlay_show_extra_face_angle_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_extra_face_area_get(PointerRNA *ptr);
void View3DOverlay_show_extra_face_area_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_face_orientation_get(PointerRNA *ptr);
void View3DOverlay_show_face_orientation_set(PointerRNA *ptr, bool value);

bool View3DOverlay_use_gpencil_fade_gp_objects_get(PointerRNA *ptr);
void View3DOverlay_use_gpencil_fade_gp_objects_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_fade_inactive_get(PointerRNA *ptr);
void View3DOverlay_show_fade_inactive_set(PointerRNA *ptr, bool value);

bool View3DOverlay_use_gpencil_fade_layers_get(PointerRNA *ptr);
void View3DOverlay_use_gpencil_fade_layers_set(PointerRNA *ptr, bool value);

bool View3DOverlay_use_gpencil_fade_objects_get(PointerRNA *ptr);
void View3DOverlay_use_gpencil_fade_objects_set(PointerRNA *ptr, bool value);

bool View3DOverlay_use_debug_freeze_view_culling_get(PointerRNA *ptr);
void View3DOverlay_use_debug_freeze_view_culling_set(PointerRNA *ptr, bool value);

void View3DOverlay_gpencil_grid_color_get(PointerRNA *ptr, float values[3]);
void View3DOverlay_gpencil_grid_color_set(PointerRNA *ptr, const float values[3]);

int View3DOverlay_grid_lines_get(PointerRNA *ptr);
void View3DOverlay_grid_lines_set(PointerRNA *ptr, int value);

float View3DOverlay_grid_scale_get(PointerRNA *ptr);
void View3DOverlay_grid_scale_set(PointerRNA *ptr, float value);

float View3DOverlay_grid_scale_unit_get(PointerRNA *ptr);
void View3DOverlay_grid_scale_unit_set(PointerRNA *ptr, float value);

int View3DOverlay_grid_subdivisions_get(PointerRNA *ptr);
void View3DOverlay_grid_subdivisions_set(PointerRNA *ptr, int value);

bool View3DOverlay_show_look_dev_get(PointerRNA *ptr);
void View3DOverlay_show_look_dev_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_extra_indices_get(PointerRNA *ptr);
void View3DOverlay_show_extra_indices_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_light_colors_get(PointerRNA *ptr);
void View3DOverlay_show_light_colors_set(PointerRNA *ptr, bool value);

bool View3DOverlay_use_gpencil_multiedit_line_only_get(PointerRNA *ptr);
void View3DOverlay_use_gpencil_multiedit_line_only_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_statvis_get(PointerRNA *ptr);
void View3DOverlay_show_statvis_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_motion_paths_get(PointerRNA *ptr);
void View3DOverlay_show_motion_paths_set(PointerRNA *ptr, bool value);

float View3DOverlay_normals_constant_screen_size_get(PointerRNA *ptr);
void View3DOverlay_normals_constant_screen_size_set(PointerRNA *ptr, float value);

float View3DOverlay_normals_length_get(PointerRNA *ptr);
void View3DOverlay_normals_length_set(PointerRNA *ptr, float value);

bool View3DOverlay_show_object_origins_get(PointerRNA *ptr);
void View3DOverlay_show_object_origins_set(PointerRNA *ptr, bool value);

void View3DOverlay_gpencil_grid_offset_get(PointerRNA *ptr, float values[2]);
void View3DOverlay_gpencil_grid_offset_set(PointerRNA *ptr, const float values[2]);

bool View3DOverlay_show_onion_skins_get(PointerRNA *ptr);
void View3DOverlay_show_onion_skins_set(PointerRNA *ptr, bool value);

bool View3DOverlay_use_gpencil_onion_skin_get(PointerRNA *ptr);
void View3DOverlay_use_gpencil_onion_skin_set(PointerRNA *ptr, bool value);

float View3DOverlay_fade_inactive_alpha_get(PointerRNA *ptr);
void View3DOverlay_fade_inactive_alpha_set(PointerRNA *ptr, float value);

float View3DOverlay_xray_alpha_bone_get(PointerRNA *ptr);
void View3DOverlay_xray_alpha_bone_set(PointerRNA *ptr, float value);

float View3DOverlay_gpencil_grid_opacity_get(PointerRNA *ptr);
void View3DOverlay_gpencil_grid_opacity_set(PointerRNA *ptr, float value);

float View3DOverlay_gpencil_fade_objects_get(PointerRNA *ptr);
void View3DOverlay_gpencil_fade_objects_set(PointerRNA *ptr, float value);

float View3DOverlay_gpencil_fade_layer_get(PointerRNA *ptr);
void View3DOverlay_gpencil_fade_layer_set(PointerRNA *ptr, float value);

float View3DOverlay_gpencil_vertex_paint_opacity_get(PointerRNA *ptr);
void View3DOverlay_gpencil_vertex_paint_opacity_set(PointerRNA *ptr, float value);

bool View3DOverlay_show_outline_selected_get(PointerRNA *ptr);
void View3DOverlay_show_outline_selected_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_relationship_lines_get(PointerRNA *ptr);
void View3DOverlay_show_relationship_lines_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_retopology_get(PointerRNA *ptr);
void View3DOverlay_show_retopology_set(PointerRNA *ptr, bool value);

float View3DOverlay_retopology_offset_get(PointerRNA *ptr);
void View3DOverlay_retopology_offset_set(PointerRNA *ptr, float value);

void View3DOverlay_gpencil_grid_scale_get(PointerRNA *ptr, float values[2]);
void View3DOverlay_gpencil_grid_scale_set(PointerRNA *ptr, const float values[2]);

bool View3DOverlay_show_sculpt_curves_cage_get(PointerRNA *ptr);
void View3DOverlay_show_sculpt_curves_cage_set(PointerRNA *ptr, bool value);

float View3DOverlay_sculpt_mode_face_sets_opacity_get(PointerRNA *ptr);
void View3DOverlay_sculpt_mode_face_sets_opacity_set(PointerRNA *ptr, float value);

float View3DOverlay_sculpt_mode_mask_opacity_get(PointerRNA *ptr);
void View3DOverlay_sculpt_mode_mask_opacity_set(PointerRNA *ptr, float value);

bool View3DOverlay_show_sculpt_face_sets_get(PointerRNA *ptr);
void View3DOverlay_show_sculpt_face_sets_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_sculpt_mask_get(PointerRNA *ptr);
void View3DOverlay_show_sculpt_mask_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_cursor_get(PointerRNA *ptr);
void View3DOverlay_show_cursor_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_annotation_get(PointerRNA *ptr);
void View3DOverlay_show_annotation_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_xray_bone_get(PointerRNA *ptr);
void View3DOverlay_show_xray_bone_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_bones_get(PointerRNA *ptr);
void View3DOverlay_show_bones_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_camera_guides_get(PointerRNA *ptr);
void View3DOverlay_show_camera_guides_set(PointerRNA *ptr, bool value);

bool View3DOverlay_use_gpencil_edit_lines_get(PointerRNA *ptr);
void View3DOverlay_use_gpencil_edit_lines_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_overlays_get(PointerRNA *ptr);
void View3DOverlay_show_overlays_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_camera_passepartout_get(PointerRNA *ptr);
void View3DOverlay_show_camera_passepartout_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_stats_get(PointerRNA *ptr);
void View3DOverlay_show_stats_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_text_get(PointerRNA *ptr);
void View3DOverlay_show_text_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_wpaint_contours_get(PointerRNA *ptr);
void View3DOverlay_show_wpaint_contours_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_weight_get(PointerRNA *ptr);
void View3DOverlay_show_weight_set(PointerRNA *ptr, bool value);

bool View3DOverlay_show_paint_wire_get(PointerRNA *ptr);
void View3DOverlay_show_paint_wire_set(PointerRNA *ptr, bool value);

float View3DOverlay_texture_paint_mode_opacity_get(PointerRNA *ptr);
void View3DOverlay_texture_paint_mode_opacity_set(PointerRNA *ptr, float value);

float View3DOverlay_vertex_paint_mode_opacity_get(PointerRNA *ptr);
void View3DOverlay_vertex_paint_mode_opacity_set(PointerRNA *ptr, float value);

bool View3DOverlay_use_gpencil_show_directions_get(PointerRNA *ptr);
void View3DOverlay_use_gpencil_show_directions_set(PointerRNA *ptr, bool value);

bool View3DOverlay_use_gpencil_show_material_name_get(PointerRNA *ptr);
void View3DOverlay_use_gpencil_show_material_name_set(PointerRNA *ptr, bool value);

int View3DOverlay_gpencil_grid_subdivisions_get(PointerRNA *ptr);
void View3DOverlay_gpencil_grid_subdivisions_set(PointerRNA *ptr, int value);

bool View3DOverlay_use_gpencil_grid_get(PointerRNA *ptr);
void View3DOverlay_use_gpencil_grid_set(PointerRNA *ptr, bool value);

float View3DOverlay_vertex_opacity_get(PointerRNA *ptr);
void View3DOverlay_vertex_opacity_set(PointerRNA *ptr, float value);

bool View3DOverlay_show_viewer_text_get(PointerRNA *ptr);
void View3DOverlay_show_viewer_text_set(PointerRNA *ptr, bool value);

float View3DOverlay_viewer_attribute_opacity_get(PointerRNA *ptr);
void View3DOverlay_viewer_attribute_opacity_set(PointerRNA *ptr, float value);

bool View3DOverlay_show_viewer_attribute_get(PointerRNA *ptr);
void View3DOverlay_show_viewer_attribute_set(PointerRNA *ptr, bool value);

float View3DOverlay_weight_paint_mode_opacity_get(PointerRNA *ptr);
void View3DOverlay_weight_paint_mode_opacity_set(PointerRNA *ptr, float value);

bool View3DOverlay_show_wireframes_get(PointerRNA *ptr);
void View3DOverlay_show_wireframes_set(PointerRNA *ptr, bool value);

float View3DOverlay_wireframe_opacity_get(PointerRNA *ptr);
void View3DOverlay_wireframe_opacity_set(PointerRNA *ptr, float value);

float View3DOverlay_wireframe_threshold_get(PointerRNA *ptr);
void View3DOverlay_wireframe_threshold_set(PointerRNA *ptr, float value);

/**************** 3D View Shading Settings ****************/

extern StructRNA RNA_View3DShading;

PointerRNA View3DShading_rna_type_get(PointerRNA *ptr);

bool View3DShading_show_backface_culling_get(PointerRNA *ptr);
void View3DShading_show_backface_culling_set(PointerRNA *ptr, bool value);

enum {
	View3DShading_background_type_THEME = 0,
	View3DShading_background_type_WORLD = 1,
	View3DShading_background_type_VIEWPORT = 2,
};

int View3DShading_background_type_get(PointerRNA *ptr);
void View3DShading_background_type_set(PointerRNA *ptr, int value);

void View3DShading_background_color_get(PointerRNA *ptr, float values[3]);
void View3DShading_background_color_set(PointerRNA *ptr, const float values[3]);

float View3DShading_studiolight_background_blur_get(PointerRNA *ptr);
void View3DShading_studiolight_background_blur_set(PointerRNA *ptr, float value);

bool View3DShading_show_cavity_get(PointerRNA *ptr);
void View3DShading_show_cavity_set(PointerRNA *ptr, bool value);

float View3DShading_cavity_ridge_factor_get(PointerRNA *ptr);
void View3DShading_cavity_ridge_factor_set(PointerRNA *ptr, float value);

enum {
	View3DShading_cavity_type_WORLD = 0,
	View3DShading_cavity_type_SCREEN = 1,
	View3DShading_cavity_type_BOTH = 2,
};

int View3DShading_cavity_type_get(PointerRNA *ptr);
void View3DShading_cavity_type_set(PointerRNA *ptr, int value);

float View3DShading_cavity_valley_factor_get(PointerRNA *ptr);
void View3DShading_cavity_valley_factor_set(PointerRNA *ptr, float value);

enum {
	View3DShading_color_type_MATERIAL = 0,
	View3DShading_color_type_OBJECT = 4,
	View3DShading_color_type_RANDOM = 1,
	View3DShading_color_type_VERTEX = 5,
	View3DShading_color_type_TEXTURE = 3,
	View3DShading_color_type_SINGLE = 2,
};

int View3DShading_color_type_get(PointerRNA *ptr);
void View3DShading_color_type_set(PointerRNA *ptr, int value);

void View3DShading_single_color_get(PointerRNA *ptr, float values[3]);
void View3DShading_single_color_set(PointerRNA *ptr, const float values[3]);

enum {
	View3DShading_use_compositor_DISABLED = 0,
	View3DShading_use_compositor_CAMERA = 1,
	View3DShading_use_compositor_ALWAYS = 2,
};

int View3DShading_use_compositor_get(PointerRNA *ptr);
void View3DShading_use_compositor_set(PointerRNA *ptr, int value);

float View3DShading_curvature_ridge_factor_get(PointerRNA *ptr);
void View3DShading_curvature_ridge_factor_set(PointerRNA *ptr, float value);

float View3DShading_curvature_valley_factor_get(PointerRNA *ptr);
void View3DShading_curvature_valley_factor_set(PointerRNA *ptr, float value);

bool View3DShading_use_dof_get(PointerRNA *ptr);
void View3DShading_use_dof_set(PointerRNA *ptr, bool value);

enum {
	View3DShading_light_STUDIO = 1,
	View3DShading_light_MATCAP = 2,
	View3DShading_light_FLAT = 0,
};

int View3DShading_light_get(PointerRNA *ptr);
void View3DShading_light_set(PointerRNA *ptr, int value);

bool View3DShading_show_object_outline_get(PointerRNA *ptr);
void View3DShading_show_object_outline_set(PointerRNA *ptr, bool value);

void View3DShading_object_outline_color_get(PointerRNA *ptr, float values[3]);
void View3DShading_object_outline_color_set(PointerRNA *ptr, const float values[3]);

enum {
	View3DShading_render_pass_COMBINED = 1,
	View3DShading_render_pass_EMISSION = 1024,
	View3DShading_render_pass_ENVIRONMENT = 2048,
	View3DShading_render_pass_AO = 8192,
	View3DShading_render_pass_SHADOW = 4096,
	View3DShading_render_pass_TRANSPARENT = 1048576,
	View3DShading_render_pass_DIFFUSE_LIGHT = 16,
	View3DShading_render_pass_DIFFUSE_COLOR = 32,
	View3DShading_render_pass_SPECULAR_LIGHT = 64,
	View3DShading_render_pass_SPECULAR_COLOR = 128,
	View3DShading_render_pass_VOLUME_LIGHT = 512,
	View3DShading_render_pass_POSITION = 2097152,
	View3DShading_render_pass_NORMAL = 8,
	View3DShading_render_pass_MIST = 4,
	View3DShading_render_pass_CryptoObject = 65536,
	View3DShading_render_pass_CryptoAsset = 131072,
	View3DShading_render_pass_CryptoMaterial = 262144,
	View3DShading_render_pass_AOV = 32768,
};

int View3DShading_render_pass_get(PointerRNA *ptr);
void View3DShading_render_pass_set(PointerRNA *ptr, int value);

bool View3DShading_use_scene_lights_get(PointerRNA *ptr);
void View3DShading_use_scene_lights_set(PointerRNA *ptr, bool value);

bool View3DShading_use_scene_lights_render_get(PointerRNA *ptr);
void View3DShading_use_scene_lights_render_set(PointerRNA *ptr, bool value);

bool View3DShading_use_scene_world_get(PointerRNA *ptr);
void View3DShading_use_scene_world_set(PointerRNA *ptr, bool value);

bool View3DShading_use_scene_world_render_get(PointerRNA *ptr);
void View3DShading_use_scene_world_render_set(PointerRNA *ptr, bool value);

#define View3DShading_aov_name_MAX 64

void View3DShading_aov_name_get(PointerRNA *ptr, char *value);
int View3DShading_aov_name_length(PointerRNA *ptr);
void View3DShading_aov_name_set(PointerRNA *ptr, const char *value);

bool View3DShading_show_shadows_get(PointerRNA *ptr);
void View3DShading_show_shadows_set(PointerRNA *ptr, bool value);

float View3DShading_shadow_intensity_get(PointerRNA *ptr);
void View3DShading_shadow_intensity_set(PointerRNA *ptr, float value);

bool View3DShading_show_xray_get(PointerRNA *ptr);
void View3DShading_show_xray_set(PointerRNA *ptr, bool value);

bool View3DShading_show_xray_wireframe_get(PointerRNA *ptr);
void View3DShading_show_xray_wireframe_set(PointerRNA *ptr, bool value);

bool View3DShading_show_specular_highlight_get(PointerRNA *ptr);
void View3DShading_show_specular_highlight_set(PointerRNA *ptr, bool value);

float View3DShading_studiolight_intensity_get(PointerRNA *ptr);
void View3DShading_studiolight_intensity_set(PointerRNA *ptr, float value);

PointerRNA View3DShading_selected_studio_light_get(PointerRNA *ptr);

enum {
	View3DShading_studio_light_DEFAULT = 0,
};

int View3DShading_studio_light_get(PointerRNA *ptr);
void View3DShading_studio_light_set(PointerRNA *ptr, int value);

float View3DShading_studiolight_rotate_z_get(PointerRNA *ptr);
void View3DShading_studiolight_rotate_z_set(PointerRNA *ptr, float value);

enum {
	View3DShading_type_WIREFRAME = 2,
	View3DShading_type_SOLID = 3,
	View3DShading_type_MATERIAL = 4,
	View3DShading_type_RENDERED = 6,
};

int View3DShading_type_get(PointerRNA *ptr);
void View3DShading_type_set(PointerRNA *ptr, int value);

enum {
	View3DShading_wireframe_color_type_THEME = 2,
	View3DShading_wireframe_color_type_OBJECT = 4,
	View3DShading_wireframe_color_type_RANDOM = 1,
};

int View3DShading_wireframe_color_type_get(PointerRNA *ptr);
void View3DShading_wireframe_color_type_set(PointerRNA *ptr, int value);

float View3DShading_studiolight_background_alpha_get(PointerRNA *ptr);
void View3DShading_studiolight_background_alpha_set(PointerRNA *ptr, float value);

bool View3DShading_use_world_space_lighting_get(PointerRNA *ptr);
void View3DShading_use_world_space_lighting_set(PointerRNA *ptr, bool value);

bool View3DShading_use_studiolight_view_rotation_get(PointerRNA *ptr);
void View3DShading_use_studiolight_view_rotation_set(PointerRNA *ptr, bool value);

float View3DShading_xray_alpha_get(PointerRNA *ptr);
void View3DShading_xray_alpha_set(PointerRNA *ptr, float value);

float View3DShading_xray_alpha_wireframe_get(PointerRNA *ptr);
void View3DShading_xray_alpha_wireframe_set(PointerRNA *ptr, float value);

/**************** View Layer ****************/

extern StructRNA RNA_ViewLayer;

PointerRNA ViewLayer_rna_type_get(PointerRNA *ptr);

#define ViewLayer_name_MAX 64

void ViewLayer_name_get(PointerRNA *ptr, char *value);
int ViewLayer_name_length(PointerRNA *ptr);
void ViewLayer_name_set(PointerRNA *ptr, const char *value);

int ViewLayer_active_aov_index_get(PointerRNA *ptr);
void ViewLayer_active_aov_index_set(PointerRNA *ptr, int value);

PointerRNA ViewLayer_active_layer_collection_get(PointerRNA *ptr);

int ViewLayer_active_lightgroup_index_get(PointerRNA *ptr);
void ViewLayer_active_lightgroup_index_set(PointerRNA *ptr, int value);

float ViewLayer_pass_alpha_threshold_get(PointerRNA *ptr);
void ViewLayer_pass_alpha_threshold_set(PointerRNA *ptr, float value);

bool ViewLayer_use_ao_get(PointerRNA *ptr);
void ViewLayer_use_ao_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_ambient_occlusion_get(PointerRNA *ptr);
void ViewLayer_use_pass_ambient_occlusion_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_combined_get(PointerRNA *ptr);
void ViewLayer_use_pass_combined_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_cryptomatte_accurate_get(PointerRNA *ptr);
void ViewLayer_use_pass_cryptomatte_accurate_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_cryptomatte_asset_get(PointerRNA *ptr);
void ViewLayer_use_pass_cryptomatte_asset_set(PointerRNA *ptr, bool value);

int ViewLayer_pass_cryptomatte_depth_get(PointerRNA *ptr);
void ViewLayer_pass_cryptomatte_depth_set(PointerRNA *ptr, int value);

bool ViewLayer_use_pass_cryptomatte_material_get(PointerRNA *ptr);
void ViewLayer_use_pass_cryptomatte_material_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_cryptomatte_object_get(PointerRNA *ptr);
void ViewLayer_use_pass_cryptomatte_object_set(PointerRNA *ptr, bool value);

PointerRNA ViewLayer_depsgraph_get(PointerRNA *ptr);

bool ViewLayer_use_pass_diffuse_color_get(PointerRNA *ptr);
void ViewLayer_use_pass_diffuse_color_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_diffuse_direct_get(PointerRNA *ptr);
void ViewLayer_use_pass_diffuse_direct_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_diffuse_indirect_get(PointerRNA *ptr);
void ViewLayer_use_pass_diffuse_indirect_set(PointerRNA *ptr, bool value);

PointerRNA ViewLayer_eevee_get(PointerRNA *ptr);

bool ViewLayer_use_pass_emit_get(PointerRNA *ptr);
void ViewLayer_use_pass_emit_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_get(PointerRNA *ptr);
void ViewLayer_use_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_environment_get(PointerRNA *ptr);
void ViewLayer_use_pass_environment_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_freestyle_get(PointerRNA *ptr);
void ViewLayer_use_freestyle_set(PointerRNA *ptr, bool value);

PointerRNA ViewLayer_freestyle_settings_get(PointerRNA *ptr);

bool ViewLayer_use_pass_glossy_color_get(PointerRNA *ptr);
void ViewLayer_use_pass_glossy_color_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_glossy_direct_get(PointerRNA *ptr);
void ViewLayer_use_pass_glossy_direct_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_glossy_indirect_get(PointerRNA *ptr);
void ViewLayer_use_pass_glossy_indirect_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_grease_pencil_get(PointerRNA *ptr);
void ViewLayer_use_grease_pencil_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_grease_pencil_get(PointerRNA *ptr);
void ViewLayer_use_pass_grease_pencil_set(PointerRNA *ptr, bool value);

bool ViewLayer_has_export_collections_get(PointerRNA *ptr);
void ViewLayer_has_export_collections_set(PointerRNA *ptr, bool value);

PointerRNA ViewLayer_layer_collection_get(PointerRNA *ptr);

void ViewLayer_lightgroups_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ViewLayer_lightgroups_next(CollectionPropertyIterator *iter);
void ViewLayer_lightgroups_end(CollectionPropertyIterator *iter);
bool ViewLayer_lightgroups_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool ViewLayer_lightgroups_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

PointerRNA ViewLayer_active_lightgroup_get(PointerRNA *ptr);

bool ViewLayer_use_pass_material_index_get(PointerRNA *ptr);
void ViewLayer_use_pass_material_index_set(PointerRNA *ptr, bool value);

PointerRNA ViewLayer_material_override_get(PointerRNA *ptr);

bool ViewLayer_use_pass_mist_get(PointerRNA *ptr);
void ViewLayer_use_pass_mist_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_motion_blur_get(PointerRNA *ptr);
void ViewLayer_use_motion_blur_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_normal_get(PointerRNA *ptr);
void ViewLayer_use_pass_normal_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_object_index_get(PointerRNA *ptr);
void ViewLayer_use_pass_object_index_set(PointerRNA *ptr, bool value);

void ViewLayer_objects_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ViewLayer_objects_next(CollectionPropertyIterator *iter);
void ViewLayer_objects_end(CollectionPropertyIterator *iter);
bool ViewLayer_objects_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool ViewLayer_objects_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool ViewLayer_use_pass_position_get(PointerRNA *ptr);
void ViewLayer_use_pass_position_set(PointerRNA *ptr, bool value);

int ViewLayer_samples_get(PointerRNA *ptr);
void ViewLayer_samples_set(PointerRNA *ptr, int value);

void ViewLayer_aovs_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ViewLayer_aovs_next(CollectionPropertyIterator *iter);
void ViewLayer_aovs_end(CollectionPropertyIterator *iter);
bool ViewLayer_aovs_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool ViewLayer_aovs_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

PointerRNA ViewLayer_active_aov_get(PointerRNA *ptr);

bool ViewLayer_use_pass_shadow_get(PointerRNA *ptr);
void ViewLayer_use_pass_shadow_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_sky_get(PointerRNA *ptr);
void ViewLayer_use_sky_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_solid_get(PointerRNA *ptr);
void ViewLayer_use_solid_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_strand_get(PointerRNA *ptr);
void ViewLayer_use_strand_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_subsurface_color_get(PointerRNA *ptr);
void ViewLayer_use_pass_subsurface_color_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_subsurface_direct_get(PointerRNA *ptr);
void ViewLayer_use_pass_subsurface_direct_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_subsurface_indirect_get(PointerRNA *ptr);
void ViewLayer_use_pass_subsurface_indirect_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_transmission_color_get(PointerRNA *ptr);
void ViewLayer_use_pass_transmission_color_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_transmission_direct_get(PointerRNA *ptr);
void ViewLayer_use_pass_transmission_direct_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_transmission_indirect_get(PointerRNA *ptr);
void ViewLayer_use_pass_transmission_indirect_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_uv_get(PointerRNA *ptr);
void ViewLayer_use_pass_uv_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_pass_vector_get(PointerRNA *ptr);
void ViewLayer_use_pass_vector_set(PointerRNA *ptr, bool value);

bool ViewLayer_use_volumes_get(PointerRNA *ptr);
void ViewLayer_use_volumes_set(PointerRNA *ptr, bool value);

PointerRNA ViewLayer_world_override_get(PointerRNA *ptr);

bool ViewLayer_use_pass_z_get(PointerRNA *ptr);
void ViewLayer_use_pass_z_set(PointerRNA *ptr, bool value);

void ViewLayer_update_render_passes_func(struct ID *_selfid);
void ViewLayer_update_func(struct ID *_selfid, struct ViewLayer *_self, Main *bmain, ReportList *reports);
/**************** EEVEE Settings ****************/

extern StructRNA RNA_ViewLayerEEVEE;

PointerRNA ViewLayerEEVEE_rna_type_get(PointerRNA *ptr);

bool ViewLayerEEVEE_use_pass_bloom_get(PointerRNA *ptr);
void ViewLayerEEVEE_use_pass_bloom_set(PointerRNA *ptr, bool value);

bool ViewLayerEEVEE_use_pass_transparent_get(PointerRNA *ptr);
void ViewLayerEEVEE_use_pass_transparent_set(PointerRNA *ptr, bool value);

bool ViewLayerEEVEE_use_pass_volume_direct_get(PointerRNA *ptr);
void ViewLayerEEVEE_use_pass_volume_direct_set(PointerRNA *ptr, bool value);

/**************** Render Layers ****************/

extern StructRNA RNA_ViewLayers;

PointerRNA ViewLayers_rna_type_get(PointerRNA *ptr);

struct ViewLayer *ViewLayers_new_func(struct ID *_selfid, struct Scene *_self, Main *bmain, const char * name);
void ViewLayers_remove_func(struct ID *_selfid, struct Scene *_self, Main *bmain, ReportList *reports, struct PointerRNA *layer);
void ViewLayers_move_func(struct ID *_selfid, struct Scene *_self, Main *bmain, ReportList *reports, int from_index, int to_index);
/**************** ViewerNodeViewerPathElem ****************/

extern StructRNA RNA_ViewerNodeViewerPathElem;
extern StructRNA RNA_ViewerPathElem;

int ViewerNodeViewerPathElem_node_id_get(PointerRNA *ptr);
void ViewerNodeViewerPathElem_node_id_set(PointerRNA *ptr, int value);

/**************** Viewer Path ****************/

extern StructRNA RNA_ViewerPath;

PointerRNA ViewerPath_rna_type_get(PointerRNA *ptr);

void ViewerPath_path_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void ViewerPath_path_next(CollectionPropertyIterator *iter);
void ViewerPath_path_end(CollectionPropertyIterator *iter);
bool ViewerPath_path_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** Viewer Path Element ****************/

extern StructRNA RNA_ViewerPathElem;

PointerRNA ViewerPathElem_rna_type_get(PointerRNA *ptr);

enum {
	ViewerPathElem_type_ID = 0,
	ViewerPathElem_type_MODIFIER = 1,
	ViewerPathElem_type_GROUP_NODE = 2,
	ViewerPathElem_type_SIMULATION_ZONE = 3,
	ViewerPathElem_type_VIEWER_NODE = 4,
	ViewerPathElem_type_REPEAT_ZONE = 5,
	ViewerPathElem_type_FOREACH_GEOMETRY_ELEMENT_ZONE = 6,
	ViewerPathElem_type_EVALUATE_CLOSURE = 7,
};

int ViewerPathElem_type_get(PointerRNA *ptr);
void ViewerPathElem_type_set(PointerRNA *ptr, int value);

void ViewerPathElem_ui_name_get(PointerRNA *ptr, char *value);
int ViewerPathElem_ui_name_length(PointerRNA *ptr);
void ViewerPathElem_ui_name_set(PointerRNA *ptr, const char *value);

/**************** Volume ****************/

extern StructRNA RNA_Volume;
extern StructRNA RNA_ID;

PointerRNA Volume_animation_data_get(PointerRNA *ptr);

PointerRNA Volume_display_get(PointerRNA *ptr);

#define Volume_filepath_MAX 1024

void Volume_filepath_get(PointerRNA *ptr, char *value);
int Volume_filepath_length(PointerRNA *ptr);
void Volume_filepath_set(PointerRNA *ptr, const char *value);

int Volume_frame_duration_get(PointerRNA *ptr);
void Volume_frame_duration_set(PointerRNA *ptr, int value);

void Volume_grids_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Volume_grids_next(CollectionPropertyIterator *iter);
void Volume_grids_end(CollectionPropertyIterator *iter);
int Volume_grids_length(PointerRNA *ptr);

void Volume_materials_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Volume_materials_next(CollectionPropertyIterator *iter);
void Volume_materials_end(CollectionPropertyIterator *iter);
int Volume_materials_length(PointerRNA *ptr);
bool Volume_materials_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool Volume_materials_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

int Volume_frame_offset_get(PointerRNA *ptr);
void Volume_frame_offset_set(PointerRNA *ptr, int value);

PointerRNA Volume_packed_file_get(PointerRNA *ptr);

PointerRNA Volume_render_get(PointerRNA *ptr);

bool Volume_is_sequence_get(PointerRNA *ptr);
void Volume_is_sequence_set(PointerRNA *ptr, bool value);

enum {
	Volume_sequence_mode_CLIP = 0,
	Volume_sequence_mode_EXTEND = 1,
	Volume_sequence_mode_REPEAT = 2,
	Volume_sequence_mode_PING_PONG = 3,
};

int Volume_sequence_mode_get(PointerRNA *ptr);
void Volume_sequence_mode_set(PointerRNA *ptr, int value);

int Volume_frame_start_get(PointerRNA *ptr);
void Volume_frame_start_set(PointerRNA *ptr, int value);

#define Volume_velocity_grid_MAX 64

void Volume_velocity_grid_get(PointerRNA *ptr, char *value);
int Volume_velocity_grid_length(PointerRNA *ptr);
void Volume_velocity_grid_set(PointerRNA *ptr, const char *value);

float Volume_velocity_scale_get(PointerRNA *ptr);
void Volume_velocity_scale_set(PointerRNA *ptr, float value);

enum {
	Volume_velocity_unit_SECOND = 1,
	Volume_velocity_unit_FRAME = 0,
};

int Volume_velocity_unit_get(PointerRNA *ptr);
void Volume_velocity_unit_set(PointerRNA *ptr, int value);

void Volume_velocity_x_grid_get(PointerRNA *ptr, char *value);
int Volume_velocity_x_grid_length(PointerRNA *ptr);
void Volume_velocity_x_grid_set(PointerRNA *ptr, const char *value);

void Volume_velocity_y_grid_get(PointerRNA *ptr, char *value);
int Volume_velocity_y_grid_length(PointerRNA *ptr);
void Volume_velocity_y_grid_set(PointerRNA *ptr, const char *value);

void Volume_velocity_z_grid_get(PointerRNA *ptr, char *value);
int Volume_velocity_z_grid_length(PointerRNA *ptr);
void Volume_velocity_z_grid_set(PointerRNA *ptr, const char *value);

/**************** Volume Displace Modifier ****************/

extern StructRNA RNA_VolumeDisplaceModifier;
extern StructRNA RNA_Modifier;

PointerRNA VolumeDisplaceModifier_texture_map_object_get(PointerRNA *ptr);

float VolumeDisplaceModifier_strength_get(PointerRNA *ptr);
void VolumeDisplaceModifier_strength_set(PointerRNA *ptr, float value);

PointerRNA VolumeDisplaceModifier_texture_get(PointerRNA *ptr);

enum {
	VolumeDisplaceModifier_texture_map_mode_LOCAL = 0,
	VolumeDisplaceModifier_texture_map_mode_GLOBAL = 1,
	VolumeDisplaceModifier_texture_map_mode_OBJECT = 2,
};

int VolumeDisplaceModifier_texture_map_mode_get(PointerRNA *ptr);
void VolumeDisplaceModifier_texture_map_mode_set(PointerRNA *ptr, int value);

void VolumeDisplaceModifier_texture_mid_level_get(PointerRNA *ptr, float values[3]);
void VolumeDisplaceModifier_texture_mid_level_set(PointerRNA *ptr, const float values[3]);

float VolumeDisplaceModifier_texture_sample_radius_get(PointerRNA *ptr);
void VolumeDisplaceModifier_texture_sample_radius_set(PointerRNA *ptr, float value);

/**************** Volume Display ****************/

extern StructRNA RNA_VolumeDisplay;

PointerRNA VolumeDisplay_rna_type_get(PointerRNA *ptr);

enum {
	VolumeDisplay_slice_axis_AUTO = 0,
	VolumeDisplay_slice_axis_X = 1,
	VolumeDisplay_slice_axis_Y = 2,
	VolumeDisplay_slice_axis_Z = 3,
};

int VolumeDisplay_slice_axis_get(PointerRNA *ptr);
void VolumeDisplay_slice_axis_set(PointerRNA *ptr, int value);

float VolumeDisplay_density_get(PointerRNA *ptr);
void VolumeDisplay_density_set(PointerRNA *ptr, float value);

enum {
	VolumeDisplay_interpolation_method_LINEAR = 0,
	VolumeDisplay_interpolation_method_CUBIC = 1,
	VolumeDisplay_interpolation_method_CLOSEST = 2,
};

int VolumeDisplay_interpolation_method_get(PointerRNA *ptr);
void VolumeDisplay_interpolation_method_set(PointerRNA *ptr, int value);

float VolumeDisplay_slice_depth_get(PointerRNA *ptr);
void VolumeDisplay_slice_depth_set(PointerRNA *ptr, float value);

bool VolumeDisplay_use_slice_get(PointerRNA *ptr);
void VolumeDisplay_use_slice_set(PointerRNA *ptr, bool value);

enum {
	VolumeDisplay_wireframe_type_NONE = 0,
	VolumeDisplay_wireframe_type_BOUNDS = 1,
	VolumeDisplay_wireframe_type_BOXES = 2,
	VolumeDisplay_wireframe_type_POINTS = 3,
};

int VolumeDisplay_wireframe_type_get(PointerRNA *ptr);
void VolumeDisplay_wireframe_type_set(PointerRNA *ptr, int value);

enum {
	VolumeDisplay_wireframe_detail_COARSE = 0,
	VolumeDisplay_wireframe_detail_FINE = 1,
};

int VolumeDisplay_wireframe_detail_get(PointerRNA *ptr);
void VolumeDisplay_wireframe_detail_set(PointerRNA *ptr, int value);

/**************** Volume Grid ****************/

extern StructRNA RNA_VolumeGrid;

PointerRNA VolumeGrid_rna_type_get(PointerRNA *ptr);

void VolumeGrid_name_get(PointerRNA *ptr, char *value);
int VolumeGrid_name_length(PointerRNA *ptr);
void VolumeGrid_name_set(PointerRNA *ptr, const char *value);

int VolumeGrid_channels_get(PointerRNA *ptr);
void VolumeGrid_channels_set(PointerRNA *ptr, int value);

enum {
	VolumeGrid_data_type_BOOLEAN = 1,
	VolumeGrid_data_type_FLOAT = 2,
	VolumeGrid_data_type_DOUBLE = 3,
	VolumeGrid_data_type_INT = 4,
	VolumeGrid_data_type_INT64 = 5,
	VolumeGrid_data_type_MASK = 6,
	VolumeGrid_data_type_VECTOR_FLOAT = 7,
	VolumeGrid_data_type_VECTOR_DOUBLE = 8,
	VolumeGrid_data_type_VECTOR_INT = 9,
	VolumeGrid_data_type_POINTS = 10,
	VolumeGrid_data_type_UNKNOWN = 0,
};

int VolumeGrid_data_type_get(PointerRNA *ptr);
void VolumeGrid_data_type_set(PointerRNA *ptr, int value);

bool VolumeGrid_is_loaded_get(PointerRNA *ptr);
void VolumeGrid_is_loaded_set(PointerRNA *ptr, bool value);

void VolumeGrid_matrix_object_get(PointerRNA *ptr, float values[16]);
void VolumeGrid_matrix_object_set(PointerRNA *ptr, const float values[16]);

bool VolumeGrid_load_func(struct ID *_selfid, struct DummyVolumeGridData *_self);
void VolumeGrid_unload_func(struct ID *_selfid, struct DummyVolumeGridData *_self);
/**************** Volume Grids ****************/

extern StructRNA RNA_VolumeGrids;

PointerRNA VolumeGrids_rna_type_get(PointerRNA *ptr);

int VolumeGrids_active_index_get(PointerRNA *ptr);
void VolumeGrids_active_index_set(PointerRNA *ptr, int value);

void VolumeGrids_error_message_get(PointerRNA *ptr, char *value);
int VolumeGrids_error_message_length(PointerRNA *ptr);
void VolumeGrids_error_message_set(PointerRNA *ptr, const char *value);

int VolumeGrids_frame_get(PointerRNA *ptr);
void VolumeGrids_frame_set(PointerRNA *ptr, int value);

void VolumeGrids_frame_filepath_get(PointerRNA *ptr, char *value);
int VolumeGrids_frame_filepath_length(PointerRNA *ptr);
void VolumeGrids_frame_filepath_set(PointerRNA *ptr, const char *value);

bool VolumeGrids_is_loaded_get(PointerRNA *ptr);
void VolumeGrids_is_loaded_set(PointerRNA *ptr, bool value);

bool VolumeGrids_load_func(struct Volume *_self, Main *bmain);
void VolumeGrids_unload_func(struct Volume *_self);
bool VolumeGrids_save_func(struct Volume *_self, Main *bmain, ReportList *reports, const char * filepath);
/**************** Volume Render ****************/

extern StructRNA RNA_VolumeRender;

PointerRNA VolumeRender_rna_type_get(PointerRNA *ptr);

float VolumeRender_clipping_get(PointerRNA *ptr);
void VolumeRender_clipping_set(PointerRNA *ptr, float value);

enum {
	VolumeRender_precision_FULL = 1,
	VolumeRender_precision_HALF = 0,
	VolumeRender_precision_VARIABLE = 2,
};

int VolumeRender_precision_get(PointerRNA *ptr);
void VolumeRender_precision_set(PointerRNA *ptr, int value);

enum {
	VolumeRender_space_OBJECT = 0,
	VolumeRender_space_WORLD = 1,
};

int VolumeRender_space_get(PointerRNA *ptr);
void VolumeRender_space_set(PointerRNA *ptr, int value);

float VolumeRender_step_size_get(PointerRNA *ptr);
void VolumeRender_step_size_set(PointerRNA *ptr, float value);

/**************** Volume to Mesh Modifier ****************/

extern StructRNA RNA_VolumeToMeshModifier;
extern StructRNA RNA_Modifier;

float VolumeToMeshModifier_adaptivity_get(PointerRNA *ptr);
void VolumeToMeshModifier_adaptivity_set(PointerRNA *ptr, float value);

#define VolumeToMeshModifier_grid_name_MAX 64

void VolumeToMeshModifier_grid_name_get(PointerRNA *ptr, char *value);
int VolumeToMeshModifier_grid_name_length(PointerRNA *ptr);
void VolumeToMeshModifier_grid_name_set(PointerRNA *ptr, const char *value);

PointerRNA VolumeToMeshModifier_object_get(PointerRNA *ptr);

enum {
	VolumeToMeshModifier_resolution_mode_GRID = 0,
	VolumeToMeshModifier_resolution_mode_VOXEL_AMOUNT = 1,
	VolumeToMeshModifier_resolution_mode_VOXEL_SIZE = 2,
};

int VolumeToMeshModifier_resolution_mode_get(PointerRNA *ptr);
void VolumeToMeshModifier_resolution_mode_set(PointerRNA *ptr, int value);

bool VolumeToMeshModifier_use_smooth_shade_get(PointerRNA *ptr);
void VolumeToMeshModifier_use_smooth_shade_set(PointerRNA *ptr, bool value);

float VolumeToMeshModifier_threshold_get(PointerRNA *ptr);
void VolumeToMeshModifier_threshold_set(PointerRNA *ptr, float value);

int VolumeToMeshModifier_voxel_amount_get(PointerRNA *ptr);
void VolumeToMeshModifier_voxel_amount_set(PointerRNA *ptr, int value);

float VolumeToMeshModifier_voxel_size_get(PointerRNA *ptr);
void VolumeToMeshModifier_voxel_size_set(PointerRNA *ptr, float value);

/**************** Voronoi ****************/

extern StructRNA RNA_VoronoiTexture;
extern StructRNA RNA_Texture;
extern StructRNA RNA_ID;

enum {
	VoronoiTexture_color_mode_INTENSITY = 0,
	VoronoiTexture_color_mode_POSITION = 1,
	VoronoiTexture_color_mode_POSITION_OUTLINE = 2,
	VoronoiTexture_color_mode_POSITION_OUTLINE_INTENSITY = 3,
};

int VoronoiTexture_color_mode_get(PointerRNA *ptr);
void VoronoiTexture_color_mode_set(PointerRNA *ptr, int value);

enum {
	VoronoiTexture_distance_metric_DISTANCE = 0,
	VoronoiTexture_distance_metric_DISTANCE_SQUARED = 1,
	VoronoiTexture_distance_metric_MANHATTAN = 2,
	VoronoiTexture_distance_metric_CHEBYCHEV = 3,
	VoronoiTexture_distance_metric_MINKOVSKY_HALF = 4,
	VoronoiTexture_distance_metric_MINKOVSKY_FOUR = 5,
	VoronoiTexture_distance_metric_MINKOVSKY = 6,
};

int VoronoiTexture_distance_metric_get(PointerRNA *ptr);
void VoronoiTexture_distance_metric_set(PointerRNA *ptr, int value);

float VoronoiTexture_minkovsky_exponent_get(PointerRNA *ptr);
void VoronoiTexture_minkovsky_exponent_set(PointerRNA *ptr, float value);

float VoronoiTexture_nabla_get(PointerRNA *ptr);
void VoronoiTexture_nabla_set(PointerRNA *ptr, float value);

float VoronoiTexture_noise_intensity_get(PointerRNA *ptr);
void VoronoiTexture_noise_intensity_set(PointerRNA *ptr, float value);

float VoronoiTexture_noise_scale_get(PointerRNA *ptr);
void VoronoiTexture_noise_scale_set(PointerRNA *ptr, float value);

float VoronoiTexture_weight_1_get(PointerRNA *ptr);
void VoronoiTexture_weight_1_set(PointerRNA *ptr, float value);

float VoronoiTexture_weight_2_get(PointerRNA *ptr);
void VoronoiTexture_weight_2_set(PointerRNA *ptr, float value);

float VoronoiTexture_weight_3_get(PointerRNA *ptr);
void VoronoiTexture_weight_3_set(PointerRNA *ptr, float value);

float VoronoiTexture_weight_4_get(PointerRNA *ptr);
void VoronoiTexture_weight_4_set(PointerRNA *ptr, float value);

/**************** Walk Navigation ****************/

extern StructRNA RNA_WalkNavigation;

PointerRNA WalkNavigation_rna_type_get(PointerRNA *ptr);

bool WalkNavigation_use_gravity_get(PointerRNA *ptr);
void WalkNavigation_use_gravity_set(PointerRNA *ptr, bool value);

float WalkNavigation_jump_height_get(PointerRNA *ptr);
void WalkNavigation_jump_height_set(PointerRNA *ptr, float value);

float WalkNavigation_mouse_speed_get(PointerRNA *ptr);
void WalkNavigation_mouse_speed_set(PointerRNA *ptr, float value);

bool WalkNavigation_use_mouse_reverse_get(PointerRNA *ptr);
void WalkNavigation_use_mouse_reverse_set(PointerRNA *ptr, bool value);

float WalkNavigation_walk_speed_factor_get(PointerRNA *ptr);
void WalkNavigation_walk_speed_factor_set(PointerRNA *ptr, float value);

float WalkNavigation_teleport_time_get(PointerRNA *ptr);
void WalkNavigation_teleport_time_set(PointerRNA *ptr, float value);

float WalkNavigation_view_height_get(PointerRNA *ptr);
void WalkNavigation_view_height_set(PointerRNA *ptr, float value);

float WalkNavigation_walk_speed_get(PointerRNA *ptr);
void WalkNavigation_walk_speed_set(PointerRNA *ptr, float value);

/**************** Warp Modifier ****************/

extern StructRNA RNA_WarpModifier;
extern StructRNA RNA_Modifier;

#define WarpModifier_bone_from_MAX 64

void WarpModifier_bone_from_get(PointerRNA *ptr, char *value);
int WarpModifier_bone_from_length(PointerRNA *ptr);
void WarpModifier_bone_from_set(PointerRNA *ptr, const char *value);

#define WarpModifier_bone_to_MAX 64

void WarpModifier_bone_to_get(PointerRNA *ptr, char *value);
int WarpModifier_bone_to_length(PointerRNA *ptr);
void WarpModifier_bone_to_set(PointerRNA *ptr, const char *value);

PointerRNA WarpModifier_falloff_curve_get(PointerRNA *ptr);

enum {
	WarpModifier_falloff_type_NONE = 0,
	WarpModifier_falloff_type_CURVE = 1,
	WarpModifier_falloff_type_SMOOTH = 3,
	WarpModifier_falloff_type_SPHERE = 7,
	WarpModifier_falloff_type_ROOT = 4,
	WarpModifier_falloff_type_INVERSE_SQUARE = 8,
	WarpModifier_falloff_type_SHARP = 2,
	WarpModifier_falloff_type_LINEAR = 5,
	WarpModifier_falloff_type_CONSTANT = 6,
};

int WarpModifier_falloff_type_get(PointerRNA *ptr);
void WarpModifier_falloff_type_set(PointerRNA *ptr, int value);

bool WarpModifier_invert_vertex_group_get(PointerRNA *ptr);
void WarpModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

PointerRNA WarpModifier_object_from_get(PointerRNA *ptr);

PointerRNA WarpModifier_object_to_get(PointerRNA *ptr);

bool WarpModifier_use_volume_preserve_get(PointerRNA *ptr);
void WarpModifier_use_volume_preserve_set(PointerRNA *ptr, bool value);

float WarpModifier_falloff_radius_get(PointerRNA *ptr);
void WarpModifier_falloff_radius_set(PointerRNA *ptr, float value);

float WarpModifier_strength_get(PointerRNA *ptr);
void WarpModifier_strength_set(PointerRNA *ptr, float value);

PointerRNA WarpModifier_texture_get(PointerRNA *ptr);

#define WarpModifier_texture_coords_bone_MAX 64

void WarpModifier_texture_coords_bone_get(PointerRNA *ptr, char *value);
int WarpModifier_texture_coords_bone_length(PointerRNA *ptr);
void WarpModifier_texture_coords_bone_set(PointerRNA *ptr, const char *value);

PointerRNA WarpModifier_texture_coords_object_get(PointerRNA *ptr);

enum {
	WarpModifier_texture_coords_LOCAL = 0,
	WarpModifier_texture_coords_GLOBAL = 1,
	WarpModifier_texture_coords_OBJECT = 2,
	WarpModifier_texture_coords_UV = 3,
};

int WarpModifier_texture_coords_get(PointerRNA *ptr);
void WarpModifier_texture_coords_set(PointerRNA *ptr, int value);

#define WarpModifier_uv_layer_MAX 68

void WarpModifier_uv_layer_get(PointerRNA *ptr, char *value);
int WarpModifier_uv_layer_length(PointerRNA *ptr);
void WarpModifier_uv_layer_set(PointerRNA *ptr, const char *value);

#define WarpModifier_vertex_group_MAX 64

void WarpModifier_vertex_group_get(PointerRNA *ptr, char *value);
int WarpModifier_vertex_group_length(PointerRNA *ptr);
void WarpModifier_vertex_group_set(PointerRNA *ptr, const char *value);

/**************** Wave Modifier ****************/

extern StructRNA RNA_WaveModifier;
extern StructRNA RNA_Modifier;

bool WaveModifier_use_cyclic_get(PointerRNA *ptr);
void WaveModifier_use_cyclic_set(PointerRNA *ptr, bool value);

float WaveModifier_damping_time_get(PointerRNA *ptr);
void WaveModifier_damping_time_set(PointerRNA *ptr, float value);

float WaveModifier_falloff_radius_get(PointerRNA *ptr);
void WaveModifier_falloff_radius_set(PointerRNA *ptr, float value);

float WaveModifier_height_get(PointerRNA *ptr);
void WaveModifier_height_set(PointerRNA *ptr, float value);

bool WaveModifier_invert_vertex_group_get(PointerRNA *ptr);
void WaveModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

float WaveModifier_lifetime_get(PointerRNA *ptr);
void WaveModifier_lifetime_set(PointerRNA *ptr, float value);

float WaveModifier_narrowness_get(PointerRNA *ptr);
void WaveModifier_narrowness_set(PointerRNA *ptr, float value);

bool WaveModifier_use_normal_get(PointerRNA *ptr);
void WaveModifier_use_normal_set(PointerRNA *ptr, bool value);

float WaveModifier_speed_get(PointerRNA *ptr);
void WaveModifier_speed_set(PointerRNA *ptr, float value);

PointerRNA WaveModifier_start_position_object_get(PointerRNA *ptr);

float WaveModifier_start_position_x_get(PointerRNA *ptr);
void WaveModifier_start_position_x_set(PointerRNA *ptr, float value);

float WaveModifier_start_position_y_get(PointerRNA *ptr);
void WaveModifier_start_position_y_set(PointerRNA *ptr, float value);

PointerRNA WaveModifier_texture_get(PointerRNA *ptr);

#define WaveModifier_texture_coords_bone_MAX 64

void WaveModifier_texture_coords_bone_get(PointerRNA *ptr, char *value);
int WaveModifier_texture_coords_bone_length(PointerRNA *ptr);
void WaveModifier_texture_coords_bone_set(PointerRNA *ptr, const char *value);

PointerRNA WaveModifier_texture_coords_object_get(PointerRNA *ptr);

enum {
	WaveModifier_texture_coords_LOCAL = 0,
	WaveModifier_texture_coords_GLOBAL = 1,
	WaveModifier_texture_coords_OBJECT = 2,
	WaveModifier_texture_coords_UV = 3,
};

int WaveModifier_texture_coords_get(PointerRNA *ptr);
void WaveModifier_texture_coords_set(PointerRNA *ptr, int value);

float WaveModifier_time_offset_get(PointerRNA *ptr);
void WaveModifier_time_offset_set(PointerRNA *ptr, float value);

#define WaveModifier_uv_layer_MAX 68

void WaveModifier_uv_layer_get(PointerRNA *ptr, char *value);
int WaveModifier_uv_layer_length(PointerRNA *ptr);
void WaveModifier_uv_layer_set(PointerRNA *ptr, const char *value);

#define WaveModifier_vertex_group_MAX 64

void WaveModifier_vertex_group_get(PointerRNA *ptr, char *value);
int WaveModifier_vertex_group_length(PointerRNA *ptr);
void WaveModifier_vertex_group_set(PointerRNA *ptr, const char *value);

float WaveModifier_width_get(PointerRNA *ptr);
void WaveModifier_width_set(PointerRNA *ptr, float value);

bool WaveModifier_use_x_get(PointerRNA *ptr);
void WaveModifier_use_x_set(PointerRNA *ptr, bool value);

bool WaveModifier_use_normal_x_get(PointerRNA *ptr);
void WaveModifier_use_normal_x_set(PointerRNA *ptr, bool value);

bool WaveModifier_use_y_get(PointerRNA *ptr);
void WaveModifier_use_y_set(PointerRNA *ptr, bool value);

bool WaveModifier_use_normal_y_get(PointerRNA *ptr);
void WaveModifier_use_normal_y_set(PointerRNA *ptr, bool value);

bool WaveModifier_use_normal_z_get(PointerRNA *ptr);
void WaveModifier_use_normal_z_set(PointerRNA *ptr, bool value);

/**************** WeightedNormal Modifier ****************/

extern StructRNA RNA_WeightedNormalModifier;
extern StructRNA RNA_Modifier;

bool WeightedNormalModifier_use_face_influence_get(PointerRNA *ptr);
void WeightedNormalModifier_use_face_influence_set(PointerRNA *ptr, bool value);

bool WeightedNormalModifier_invert_vertex_group_get(PointerRNA *ptr);
void WeightedNormalModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

bool WeightedNormalModifier_keep_sharp_get(PointerRNA *ptr);
void WeightedNormalModifier_keep_sharp_set(PointerRNA *ptr, bool value);

float WeightedNormalModifier_thresh_get(PointerRNA *ptr);
void WeightedNormalModifier_thresh_set(PointerRNA *ptr, float value);

#define WeightedNormalModifier_vertex_group_MAX 64

void WeightedNormalModifier_vertex_group_get(PointerRNA *ptr, char *value);
int WeightedNormalModifier_vertex_group_length(PointerRNA *ptr);
void WeightedNormalModifier_vertex_group_set(PointerRNA *ptr, const char *value);

int WeightedNormalModifier_weight_get(PointerRNA *ptr);
void WeightedNormalModifier_weight_set(PointerRNA *ptr, int value);

enum {
	WeightedNormalModifier_mode_FACE_AREA = 0,
	WeightedNormalModifier_mode_CORNER_ANGLE = 1,
	WeightedNormalModifier_mode_FACE_AREA_WITH_ANGLE = 2,
};

int WeightedNormalModifier_mode_get(PointerRNA *ptr);
void WeightedNormalModifier_mode_set(PointerRNA *ptr, int value);

/**************** Weld Modifier ****************/

extern StructRNA RNA_WeldModifier;
extern StructRNA RNA_Modifier;

bool WeldModifier_invert_vertex_group_get(PointerRNA *ptr);
void WeldModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

float WeldModifier_merge_threshold_get(PointerRNA *ptr);
void WeldModifier_merge_threshold_set(PointerRNA *ptr, float value);

enum {
	WeldModifier_mode_ALL = 0,
	WeldModifier_mode_CONNECTED = 1,
};

int WeldModifier_mode_get(PointerRNA *ptr);
void WeldModifier_mode_set(PointerRNA *ptr, int value);

bool WeldModifier_loose_edges_get(PointerRNA *ptr);
void WeldModifier_loose_edges_set(PointerRNA *ptr, bool value);

#define WeldModifier_vertex_group_MAX 64

void WeldModifier_vertex_group_get(PointerRNA *ptr, char *value);
int WeldModifier_vertex_group_length(PointerRNA *ptr);
void WeldModifier_vertex_group_set(PointerRNA *ptr, const char *value);

/**************** WhiteBalanceModifier ****************/

extern StructRNA RNA_WhiteBalanceModifier;
extern StructRNA RNA_StripModifier;

void WhiteBalanceModifier_white_value_get(PointerRNA *ptr, float values[3]);
void WhiteBalanceModifier_white_value_set(PointerRNA *ptr, const float values[3]);

/**************** Window ****************/

extern StructRNA RNA_Window;

PointerRNA Window_rna_type_get(PointerRNA *ptr);

PointerRNA Window_view_layer_get(PointerRNA *ptr);

int Window_height_get(PointerRNA *ptr);
void Window_height_set(PointerRNA *ptr, int value);

void Window_modal_operators_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void Window_modal_operators_next(CollectionPropertyIterator *iter);
void Window_modal_operators_end(CollectionPropertyIterator *iter);

PointerRNA Window_parent_get(PointerRNA *ptr);

PointerRNA Window_scene_get(PointerRNA *ptr);

PointerRNA Window_screen_get(PointerRNA *ptr);

PointerRNA Window_stereo_3d_display_get(PointerRNA *ptr);

int Window_width_get(PointerRNA *ptr);
void Window_width_set(PointerRNA *ptr, int value);

PointerRNA Window_workspace_get(PointerRNA *ptr);

int Window_x_get(PointerRNA *ptr);
void Window_x_set(PointerRNA *ptr, int value);

int Window_y_get(PointerRNA *ptr);
void Window_y_set(PointerRNA *ptr, int value);

void Window_cursor_warp_func(struct wmWindow *_self, int x, int y);
void Window_cursor_set_func(struct wmWindow *_self, int cursor);
void Window_cursor_modal_set_func(struct wmWindow *_self, int cursor);
void Window_cursor_modal_restore_func(struct wmWindow *_self);
struct wmEvent *Window_event_simulate_func(struct wmWindow *_self, ReportList *reports, int type, int value, const char * unicode, int x, int y, bool shift, bool ctrl, bool alt, bool oskey, bool hyper);
/**************** Window Manager ****************/

extern StructRNA RNA_WindowManager;
extern StructRNA RNA_ID;

int WindowManager_extensions_blocked_get(PointerRNA *ptr);
void WindowManager_extensions_blocked_set(PointerRNA *ptr, int value);

int WindowManager_extensions_updates_get(PointerRNA *ptr);
void WindowManager_extensions_updates_set(PointerRNA *ptr, int value);

bool WindowManager_is_interface_locked_get(PointerRNA *ptr);
void WindowManager_is_interface_locked_set(PointerRNA *ptr, bool value);

void WindowManager_keyconfigs_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void WindowManager_keyconfigs_next(CollectionPropertyIterator *iter);
void WindowManager_keyconfigs_end(CollectionPropertyIterator *iter);
bool WindowManager_keyconfigs_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool WindowManager_keyconfigs_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void WindowManager_operators_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void WindowManager_operators_next(CollectionPropertyIterator *iter);
void WindowManager_operators_end(CollectionPropertyIterator *iter);
bool WindowManager_operators_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool WindowManager_operators_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void WindowManager_windows_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void WindowManager_windows_next(CollectionPropertyIterator *iter);
void WindowManager_windows_end(CollectionPropertyIterator *iter);
bool WindowManager_windows_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

PointerRNA WindowManager_xr_session_settings_get(PointerRNA *ptr);

PointerRNA WindowManager_xr_session_state_get(PointerRNA *ptr);

void WindowManager_fileselect_add_func(bContext *C, struct wmOperator *operator_value);
bool WindowManager_modal_handler_add_func(bContext *C, ReportList *reports, struct wmOperator *operator_value);
struct wmTimer *WindowManager_event_timer_add_func(struct wmWindowManager *_self, float time_step, struct wmWindow *window);
void WindowManager_event_timer_remove_func(struct wmWindowManager *_self, struct wmTimer *timer);
void WindowManager_gizmo_group_type_ensure_func(ReportList *reports, const char * identifier);
void WindowManager_gizmo_group_type_unlink_delayed_func(ReportList *reports, const char * identifier);
void WindowManager_progress_begin_func(struct wmWindowManager *_self, float min, float max);
void WindowManager_progress_update_func(struct wmWindowManager *_self, float value);
void WindowManager_progress_end_func(struct wmWindowManager *_self);
int WindowManager_invoke_props_popup_func(bContext *C, struct wmOperator *operator_value, struct wmEvent *event);
int WindowManager_invoke_props_dialog_func(bContext *C, struct wmOperator *operator_value, int width, const char * title, const char * confirm_text, bool cancel_default, const char * text_ctxt, bool translate);
void WindowManager_invoke_search_popup_func(bContext *C, struct wmOperator *operator_value);
int WindowManager_invoke_popup_func(bContext *C, struct wmOperator *operator_value, int width);
int WindowManager_invoke_confirm_func(bContext *C, struct wmOperator *operator_value, struct wmEvent *event, const char * title, const char * message, const char * confirm_text, int icon, const char * text_ctxt, bool translate);
struct PointerRNA WindowManager_popmenu_begin__internal_func(bContext *C, ReportList *reports, const char * title, int icon);
void WindowManager_popmenu_end__internal_func(bContext *C, struct PointerRNA *menu);
struct PointerRNA WindowManager_popover_begin__internal_func(bContext *C, ReportList *reports, int ui_units_x, bool from_active_button);
void WindowManager_popover_end__internal_func(bContext *C, struct PointerRNA *menu, struct wmKeyMap *keymap);
struct PointerRNA WindowManager_piemenu_begin__internal_func(bContext *C, ReportList *reports, const char * title, int icon, struct PointerRNA *event);
void WindowManager_piemenu_end__internal_func(bContext *C, struct PointerRNA *menu);
struct PointerRNA WindowManager_operator_properties_last_func(const char * operator_value);
void WindowManager_print_undo_steps_func(struct wmWindowManager *_self);
void WindowManager_tag_script_reload_func(void);
/**************** Wipe Strip ****************/

extern StructRNA RNA_WipeStrip;
extern StructRNA RNA_EffectStrip;
extern StructRNA RNA_Strip;

float WipeStrip_angle_get(PointerRNA *ptr);
void WipeStrip_angle_set(PointerRNA *ptr, float value);

float WipeStrip_blur_width_get(PointerRNA *ptr);
void WipeStrip_blur_width_set(PointerRNA *ptr, float value);

enum {
	WipeStrip_direction_OUT = 0,
	WipeStrip_direction_IN = 1,
};

int WipeStrip_direction_get(PointerRNA *ptr);
void WipeStrip_direction_set(PointerRNA *ptr, int value);

PointerRNA WipeStrip_input_1_get(PointerRNA *ptr);

PointerRNA WipeStrip_input_2_get(PointerRNA *ptr);

enum {
	WipeStrip_transition_type_SINGLE = 0,
	WipeStrip_transition_type_DOUBLE = 1,
	WipeStrip_transition_type_IRIS = 2,
	WipeStrip_transition_type_CLOCK = 3,
};

int WipeStrip_transition_type_get(PointerRNA *ptr);
void WipeStrip_transition_type_set(PointerRNA *ptr, int value);

int WipeStrip_input_count_get(PointerRNA *ptr);
void WipeStrip_input_count_set(PointerRNA *ptr, int value);

/**************** Wireframe Modifier ****************/

extern StructRNA RNA_WireframeModifier;
extern StructRNA RNA_Modifier;

bool WireframeModifier_use_boundary_get(PointerRNA *ptr);
void WireframeModifier_use_boundary_set(PointerRNA *ptr, bool value);

bool WireframeModifier_invert_vertex_group_get(PointerRNA *ptr);
void WireframeModifier_invert_vertex_group_set(PointerRNA *ptr, bool value);

int WireframeModifier_material_offset_get(PointerRNA *ptr);
void WireframeModifier_material_offset_set(PointerRNA *ptr, int value);

float WireframeModifier_offset_get(PointerRNA *ptr);
void WireframeModifier_offset_set(PointerRNA *ptr, float value);

bool WireframeModifier_use_even_offset_get(PointerRNA *ptr);
void WireframeModifier_use_even_offset_set(PointerRNA *ptr, bool value);

bool WireframeModifier_use_relative_offset_get(PointerRNA *ptr);
void WireframeModifier_use_relative_offset_set(PointerRNA *ptr, bool value);

bool WireframeModifier_use_crease_get(PointerRNA *ptr);
void WireframeModifier_use_crease_set(PointerRNA *ptr, bool value);

bool WireframeModifier_use_replace_get(PointerRNA *ptr);
void WireframeModifier_use_replace_set(PointerRNA *ptr, bool value);

float WireframeModifier_thickness_get(PointerRNA *ptr);
void WireframeModifier_thickness_set(PointerRNA *ptr, float value);

#define WireframeModifier_vertex_group_MAX 64

void WireframeModifier_vertex_group_get(PointerRNA *ptr, char *value);
int WireframeModifier_vertex_group_length(PointerRNA *ptr);
void WireframeModifier_vertex_group_set(PointerRNA *ptr, const char *value);

float WireframeModifier_thickness_vertex_group_get(PointerRNA *ptr);
void WireframeModifier_thickness_vertex_group_set(PointerRNA *ptr, float value);

float WireframeModifier_crease_weight_get(PointerRNA *ptr);
void WireframeModifier_crease_weight_set(PointerRNA *ptr, float value);

/**************** Wood Texture ****************/

extern StructRNA RNA_WoodTexture;
extern StructRNA RNA_Texture;
extern StructRNA RNA_ID;

float WoodTexture_nabla_get(PointerRNA *ptr);
void WoodTexture_nabla_set(PointerRNA *ptr, float value);

enum {
	WoodTexture_noise_basis_BLENDER_ORIGINAL = 0,
	WoodTexture_noise_basis_ORIGINAL_PERLIN = 1,
	WoodTexture_noise_basis_IMPROVED_PERLIN = 2,
	WoodTexture_noise_basis_VORONOI_F1 = 3,
	WoodTexture_noise_basis_VORONOI_F2 = 4,
	WoodTexture_noise_basis_VORONOI_F3 = 5,
	WoodTexture_noise_basis_VORONOI_F4 = 6,
	WoodTexture_noise_basis_VORONOI_F2_F1 = 7,
	WoodTexture_noise_basis_VORONOI_CRACKLE = 8,
	WoodTexture_noise_basis_CELL_NOISE = 14,
};

int WoodTexture_noise_basis_get(PointerRNA *ptr);
void WoodTexture_noise_basis_set(PointerRNA *ptr, int value);

enum {
	WoodTexture_noise_basis_2_SIN = 0,
	WoodTexture_noise_basis_2_SAW = 1,
	WoodTexture_noise_basis_2_TRI = 2,
};

int WoodTexture_noise_basis_2_get(PointerRNA *ptr);
void WoodTexture_noise_basis_2_set(PointerRNA *ptr, int value);

float WoodTexture_noise_scale_get(PointerRNA *ptr);
void WoodTexture_noise_scale_set(PointerRNA *ptr, float value);

enum {
	WoodTexture_noise_type_SOFT_NOISE = 0,
	WoodTexture_noise_type_HARD_NOISE = 1,
};

int WoodTexture_noise_type_get(PointerRNA *ptr);
void WoodTexture_noise_type_set(PointerRNA *ptr, int value);

enum {
	WoodTexture_wood_type_BANDS = 0,
	WoodTexture_wood_type_RINGS = 1,
	WoodTexture_wood_type_BANDNOISE = 2,
	WoodTexture_wood_type_RINGNOISE = 3,
};

int WoodTexture_wood_type_get(PointerRNA *ptr);
void WoodTexture_wood_type_set(PointerRNA *ptr, int value);

float WoodTexture_turbulence_get(PointerRNA *ptr);
void WoodTexture_turbulence_set(PointerRNA *ptr, float value);

/**************** Workspace ****************/

extern StructRNA RNA_WorkSpace;
extern StructRNA RNA_ID;

enum {
	WorkSpace_asset_library_reference_ALL = 2,
	WorkSpace_asset_library_reference_LOCAL = 1,
	WorkSpace_asset_library_reference_ESSENTIALS = 3,
	WorkSpace_asset_library_reference_CUSTOM = 100,
};

int WorkSpace_asset_library_reference_get(PointerRNA *ptr);
void WorkSpace_asset_library_reference_set(PointerRNA *ptr, int value);

enum {
	WorkSpace_object_mode_OBJECT = 0,
	WorkSpace_object_mode_EDIT = 1,
	WorkSpace_object_mode_POSE = 64,
	WorkSpace_object_mode_SCULPT = 2,
	WorkSpace_object_mode_VERTEX_PAINT = 4,
	WorkSpace_object_mode_WEIGHT_PAINT = 8,
	WorkSpace_object_mode_TEXTURE_PAINT = 16,
	WorkSpace_object_mode_PARTICLE_EDIT = 32,
	WorkSpace_object_mode_EDIT_GPENCIL = 128,
	WorkSpace_object_mode_SCULPT_GREASE_PENCIL = 512,
	WorkSpace_object_mode_PAINT_GREASE_PENCIL = 256,
	WorkSpace_object_mode_VERTEX_GREASE_PENCIL = 2048,
	WorkSpace_object_mode_WEIGHT_GREASE_PENCIL = 1024,
};

int WorkSpace_object_mode_get(PointerRNA *ptr);
void WorkSpace_object_mode_set(PointerRNA *ptr, int value);

bool WorkSpace_use_pin_scene_get(PointerRNA *ptr);
void WorkSpace_use_pin_scene_set(PointerRNA *ptr, bool value);

void WorkSpace_screens_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void WorkSpace_screens_next(CollectionPropertyIterator *iter);
void WorkSpace_screens_end(CollectionPropertyIterator *iter);
bool WorkSpace_screens_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool WorkSpace_screens_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void WorkSpace_tools_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void WorkSpace_tools_next(CollectionPropertyIterator *iter);
void WorkSpace_tools_end(CollectionPropertyIterator *iter);
bool WorkSpace_tools_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool WorkSpace_tools_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

void WorkSpace_owner_ids_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void WorkSpace_owner_ids_next(CollectionPropertyIterator *iter);
void WorkSpace_owner_ids_end(CollectionPropertyIterator *iter);
bool WorkSpace_owner_ids_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool WorkSpace_owner_ids_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

bool WorkSpace_use_filter_by_owner_get(PointerRNA *ptr);
void WorkSpace_use_filter_by_owner_set(PointerRNA *ptr, bool value);

void WorkSpace_status_text_set_internal_func(bContext *C, const char * text);
/**************** Work Space Tool ****************/

extern StructRNA RNA_WorkSpaceTool;

PointerRNA WorkSpaceTool_rna_type_get(PointerRNA *ptr);

enum {
	WorkSpaceTool_brush_type_DEFAULT = 0,
};

int WorkSpaceTool_brush_type_get(PointerRNA *ptr);
void WorkSpaceTool_brush_type_set(PointerRNA *ptr, int value);

bool WorkSpaceTool_has_datablock_get(PointerRNA *ptr);
void WorkSpaceTool_has_datablock_set(PointerRNA *ptr, bool value);

#define WorkSpaceTool_idname_MAX 64

void WorkSpaceTool_idname_get(PointerRNA *ptr, char *value);
int WorkSpaceTool_idname_length(PointerRNA *ptr);
void WorkSpaceTool_idname_set(PointerRNA *ptr, const char *value);

#define WorkSpaceTool_idname_fallback_MAX 64

void WorkSpaceTool_idname_fallback_get(PointerRNA *ptr, char *value);
int WorkSpaceTool_idname_fallback_length(PointerRNA *ptr);
void WorkSpaceTool_idname_fallback_set(PointerRNA *ptr, const char *value);

int WorkSpaceTool_index_get(PointerRNA *ptr);
void WorkSpaceTool_index_set(PointerRNA *ptr, int value);

enum {
	WorkSpaceTool_space_type_EMPTY = 0,
	WorkSpaceTool_space_type_VIEW_3D = 1,
	WorkSpaceTool_space_type_IMAGE_EDITOR = 6,
	WorkSpaceTool_space_type_NODE_EDITOR = 16,
	WorkSpaceTool_space_type_SEQUENCE_EDITOR = 8,
	WorkSpaceTool_space_type_CLIP_EDITOR = 20,
	WorkSpaceTool_space_type_DOPESHEET_EDITOR = 12,
	WorkSpaceTool_space_type_GRAPH_EDITOR = 2,
	WorkSpaceTool_space_type_NLA_EDITOR = 13,
	WorkSpaceTool_space_type_TEXT_EDITOR = 9,
	WorkSpaceTool_space_type_CONSOLE = 18,
	WorkSpaceTool_space_type_INFO = 7,
	WorkSpaceTool_space_type_TOPBAR = 21,
	WorkSpaceTool_space_type_STATUSBAR = 22,
	WorkSpaceTool_space_type_OUTLINER = 3,
	WorkSpaceTool_space_type_PROPERTIES = 4,
	WorkSpaceTool_space_type_FILE_BROWSER = 5,
	WorkSpaceTool_space_type_SPREADSHEET = 23,
	WorkSpaceTool_space_type_PREFERENCES = 19,
};

int WorkSpaceTool_space_type_get(PointerRNA *ptr);
void WorkSpaceTool_space_type_set(PointerRNA *ptr, int value);

enum {
	WorkSpaceTool_mode_DEFAULT = 0,
};

int WorkSpaceTool_mode_get(PointerRNA *ptr);
void WorkSpaceTool_mode_set(PointerRNA *ptr, int value);

bool WorkSpaceTool_use_paint_canvas_get(PointerRNA *ptr);
void WorkSpaceTool_use_paint_canvas_set(PointerRNA *ptr, bool value);

bool WorkSpaceTool_use_brushes_get(PointerRNA *ptr);
void WorkSpaceTool_use_brushes_set(PointerRNA *ptr, bool value);

void WorkSpaceTool_widget_get(PointerRNA *ptr, char *value);
int WorkSpaceTool_widget_length(PointerRNA *ptr);
void WorkSpaceTool_widget_set(PointerRNA *ptr, const char *value);

void WorkSpaceTool_setup_func(struct ID *_selfid, struct bToolRef *_self, bContext *C, const char * idname, int cursor, const char * keymap, const char * gizmo_group, int brush_type, const char * data_block, const char * operator_value, int index, int options, const char * idname_fallback, const char * keymap_fallback);
struct PointerRNA WorkSpaceTool_operator_properties_func(struct bToolRef *_self, ReportList *reports, const char * operator_value);
struct PointerRNA WorkSpaceTool_gizmo_group_properties_func(struct bToolRef *_self, ReportList *reports, const char * group);
void WorkSpaceTool_refresh_from_context_func(struct ID *_selfid, struct bToolRef *_self, Main *bmain);
/**************** World ****************/

extern StructRNA RNA_World;
extern StructRNA RNA_ID;

PointerRNA World_animation_data_get(PointerRNA *ptr);

void World_color_get(PointerRNA *ptr, float values[3]);
void World_color_set(PointerRNA *ptr, const float values[3]);

bool World_use_eevee_finite_volume_get(PointerRNA *ptr);
void World_use_eevee_finite_volume_set(PointerRNA *ptr, bool value);

void World_lightgroup_get(PointerRNA *ptr, char *value);
int World_lightgroup_length(PointerRNA *ptr);
void World_lightgroup_set(PointerRNA *ptr, const char *value);

PointerRNA World_light_settings_get(PointerRNA *ptr);

PointerRNA World_mist_settings_get(PointerRNA *ptr);

PointerRNA World_node_tree_get(PointerRNA *ptr);

enum {
	World_probe_resolution_128 = 7,
	World_probe_resolution_256 = 8,
	World_probe_resolution_512 = 9,
	World_probe_resolution_1024 = 10,
	World_probe_resolution_2048 = 11,
	World_probe_resolution_4096 = 12,
};

int World_probe_resolution_get(PointerRNA *ptr);
void World_probe_resolution_set(PointerRNA *ptr, int value);

float World_sun_shadow_filter_radius_get(PointerRNA *ptr);
void World_sun_shadow_filter_radius_set(PointerRNA *ptr, float value);

bool World_use_sun_shadow_jitter_get(PointerRNA *ptr);
void World_use_sun_shadow_jitter_set(PointerRNA *ptr, bool value);

float World_sun_shadow_jitter_overblur_get(PointerRNA *ptr);
void World_sun_shadow_jitter_overblur_set(PointerRNA *ptr, float value);

float World_sun_shadow_maximum_resolution_get(PointerRNA *ptr);
void World_sun_shadow_maximum_resolution_set(PointerRNA *ptr, float value);

float World_sun_angle_get(PointerRNA *ptr);
void World_sun_angle_set(PointerRNA *ptr, float value);

float World_sun_threshold_get(PointerRNA *ptr);
void World_sun_threshold_set(PointerRNA *ptr, float value);

bool World_use_nodes_get(PointerRNA *ptr);
void World_use_nodes_set(PointerRNA *ptr, bool value);

bool World_use_sun_shadow_get(PointerRNA *ptr);
void World_use_sun_shadow_set(PointerRNA *ptr, bool value);

/**************** Lighting ****************/

extern StructRNA RNA_WorldLighting;

PointerRNA WorldLighting_rna_type_get(PointerRNA *ptr);

float WorldLighting_distance_get(PointerRNA *ptr);
void WorldLighting_distance_set(PointerRNA *ptr, float value);

float WorldLighting_ao_factor_get(PointerRNA *ptr);
void WorldLighting_ao_factor_set(PointerRNA *ptr, float value);

/**************** World Mist ****************/

extern StructRNA RNA_WorldMistSettings;

PointerRNA WorldMistSettings_rna_type_get(PointerRNA *ptr);

float WorldMistSettings_depth_get(PointerRNA *ptr);
void WorldMistSettings_depth_set(PointerRNA *ptr, float value);

enum {
	WorldMistSettings_falloff_QUADRATIC = 0,
	WorldMistSettings_falloff_LINEAR = 1,
	WorldMistSettings_falloff_INVERSE_QUADRATIC = 2,
};

int WorldMistSettings_falloff_get(PointerRNA *ptr);
void WorldMistSettings_falloff_set(PointerRNA *ptr, int value);

float WorldMistSettings_height_get(PointerRNA *ptr);
void WorldMistSettings_height_set(PointerRNA *ptr, float value);

float WorldMistSettings_intensity_get(PointerRNA *ptr);
void WorldMistSettings_intensity_set(PointerRNA *ptr, float value);

float WorldMistSettings_start_get(PointerRNA *ptr);
void WorldMistSettings_start_set(PointerRNA *ptr, float value);

bool WorldMistSettings_use_mist_get(PointerRNA *ptr);
void WorldMistSettings_use_mist_set(PointerRNA *ptr, bool value);

/**************** XR Action Map ****************/

extern StructRNA RNA_XrActionMap;

PointerRNA XrActionMap_rna_type_get(PointerRNA *ptr);

#define XrActionMap_name_MAX 64

void XrActionMap_name_get(PointerRNA *ptr, char *value);
int XrActionMap_name_length(PointerRNA *ptr);
void XrActionMap_name_set(PointerRNA *ptr, const char *value);

void XrActionMap_actionmap_items_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void XrActionMap_actionmap_items_next(CollectionPropertyIterator *iter);
void XrActionMap_actionmap_items_end(CollectionPropertyIterator *iter);
int XrActionMap_actionmap_items_length(PointerRNA *ptr);
bool XrActionMap_actionmap_items_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool XrActionMap_actionmap_items_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

int XrActionMap_selected_item_get(PointerRNA *ptr);
void XrActionMap_selected_item_set(PointerRNA *ptr, int value);

/**************** XR Action Map Binding ****************/

extern StructRNA RNA_XrActionMapBinding;

PointerRNA XrActionMapBinding_rna_type_get(PointerRNA *ptr);

#define XrActionMapBinding_name_MAX 64

void XrActionMapBinding_name_get(PointerRNA *ptr, char *value);
int XrActionMapBinding_name_length(PointerRNA *ptr);
void XrActionMapBinding_name_set(PointerRNA *ptr, const char *value);

enum {
	XrActionMapBinding_axis0_region_ANY = 0,
	XrActionMapBinding_axis0_region_POSITIVE = 1,
	XrActionMapBinding_axis0_region_NEGATIVE = 2,
};

int XrActionMapBinding_axis0_region_get(PointerRNA *ptr);
void XrActionMapBinding_axis0_region_set(PointerRNA *ptr, int value);

enum {
	XrActionMapBinding_axis1_region_ANY = 0,
	XrActionMapBinding_axis1_region_POSITIVE = 4,
	XrActionMapBinding_axis1_region_NEGATIVE = 8,
};

int XrActionMapBinding_axis1_region_get(PointerRNA *ptr);
void XrActionMapBinding_axis1_region_set(PointerRNA *ptr, int value);

void XrActionMapBinding_component_paths_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void XrActionMapBinding_component_paths_next(CollectionPropertyIterator *iter);
void XrActionMapBinding_component_paths_end(CollectionPropertyIterator *iter);
int XrActionMapBinding_component_paths_length(PointerRNA *ptr);
bool XrActionMapBinding_component_paths_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

void XrActionMapBinding_pose_location_get(PointerRNA *ptr, float values[3]);
void XrActionMapBinding_pose_location_set(PointerRNA *ptr, const float values[3]);

void XrActionMapBinding_pose_rotation_get(PointerRNA *ptr, float values[3]);
void XrActionMapBinding_pose_rotation_set(PointerRNA *ptr, const float values[3]);

#define XrActionMapBinding_profile_MAX 256

void XrActionMapBinding_profile_get(PointerRNA *ptr, char *value);
int XrActionMapBinding_profile_length(PointerRNA *ptr);
void XrActionMapBinding_profile_set(PointerRNA *ptr, const char *value);

float XrActionMapBinding_threshold_get(PointerRNA *ptr);
void XrActionMapBinding_threshold_set(PointerRNA *ptr, float value);

/**************** XR Action Map Bindings ****************/

extern StructRNA RNA_XrActionMapBindings;

PointerRNA XrActionMapBindings_rna_type_get(PointerRNA *ptr);

struct XrActionMapBinding *XrActionMapBindings_new_func(struct XrActionMapItem *_self, const char * name, bool replace_existing);
struct XrActionMapBinding *XrActionMapBindings_new_from_binding_func(struct XrActionMapItem *_self, struct XrActionMapBinding *binding);
void XrActionMapBindings_remove_func(struct XrActionMapItem *_self, ReportList *reports, struct PointerRNA *binding);
struct XrActionMapBinding *XrActionMapBindings_find_func(struct XrActionMapItem *_self, const char * name);
/**************** XR Action Map Item ****************/

extern StructRNA RNA_XrActionMapItem;

PointerRNA XrActionMapItem_rna_type_get(PointerRNA *ptr);

#define XrActionMapItem_name_MAX 64

void XrActionMapItem_name_get(PointerRNA *ptr, char *value);
int XrActionMapItem_name_length(PointerRNA *ptr);
void XrActionMapItem_name_set(PointerRNA *ptr, const char *value);

bool XrActionMapItem_bimanual_get(PointerRNA *ptr);
void XrActionMapItem_bimanual_set(PointerRNA *ptr, bool value);

void XrActionMapItem_bindings_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void XrActionMapItem_bindings_next(CollectionPropertyIterator *iter);
void XrActionMapItem_bindings_end(CollectionPropertyIterator *iter);
int XrActionMapItem_bindings_length(PointerRNA *ptr);
bool XrActionMapItem_bindings_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);
bool XrActionMapItem_bindings_lookup_string(PointerRNA *ptr, const char *key, PointerRNA *r_ptr);

float XrActionMapItem_haptic_amplitude_get(PointerRNA *ptr);
void XrActionMapItem_haptic_amplitude_set(PointerRNA *ptr, float value);

float XrActionMapItem_haptic_duration_get(PointerRNA *ptr);
void XrActionMapItem_haptic_duration_set(PointerRNA *ptr, float value);

float XrActionMapItem_haptic_frequency_get(PointerRNA *ptr);
void XrActionMapItem_haptic_frequency_set(PointerRNA *ptr, float value);

bool XrActionMapItem_haptic_match_user_paths_get(PointerRNA *ptr);
void XrActionMapItem_haptic_match_user_paths_set(PointerRNA *ptr, bool value);

#define XrActionMapItem_haptic_name_MAX 64

void XrActionMapItem_haptic_name_get(PointerRNA *ptr, char *value);
int XrActionMapItem_haptic_name_length(PointerRNA *ptr);
void XrActionMapItem_haptic_name_set(PointerRNA *ptr, const char *value);

enum {
	XrActionMapItem_haptic_mode_PRESS = 2,
	XrActionMapItem_haptic_mode_RELEASE = 4,
	XrActionMapItem_haptic_mode_PRESS_RELEASE = 6,
	XrActionMapItem_haptic_mode_REPEAT = 8,
};

int XrActionMapItem_haptic_mode_get(PointerRNA *ptr);
void XrActionMapItem_haptic_mode_set(PointerRNA *ptr, int value);

bool XrActionMapItem_pose_is_controller_aim_get(PointerRNA *ptr);
void XrActionMapItem_pose_is_controller_aim_set(PointerRNA *ptr, bool value);

bool XrActionMapItem_pose_is_controller_grip_get(PointerRNA *ptr);
void XrActionMapItem_pose_is_controller_grip_set(PointerRNA *ptr, bool value);

#define XrActionMapItem_op_MAX 64

void XrActionMapItem_op_get(PointerRNA *ptr, char *value);
int XrActionMapItem_op_length(PointerRNA *ptr);
void XrActionMapItem_op_set(PointerRNA *ptr, const char *value);

enum {
	XrActionMapItem_op_mode_PRESS = 0,
	XrActionMapItem_op_mode_RELEASE = 1,
	XrActionMapItem_op_mode_MODAL = 2,
};

int XrActionMapItem_op_mode_get(PointerRNA *ptr);
void XrActionMapItem_op_mode_set(PointerRNA *ptr, int value);

void XrActionMapItem_op_name_get(PointerRNA *ptr, char *value);
int XrActionMapItem_op_name_length(PointerRNA *ptr);
void XrActionMapItem_op_name_set(PointerRNA *ptr, const char *value);

PointerRNA XrActionMapItem_op_properties_get(PointerRNA *ptr);

int XrActionMapItem_selected_binding_get(PointerRNA *ptr);
void XrActionMapItem_selected_binding_set(PointerRNA *ptr, int value);

enum {
	XrActionMapItem_type_FLOAT = 2,
	XrActionMapItem_type_VECTOR2D = 3,
	XrActionMapItem_type_POSE = 4,
	XrActionMapItem_type_VIBRATION = 100,
};

int XrActionMapItem_type_get(PointerRNA *ptr);
void XrActionMapItem_type_set(PointerRNA *ptr, int value);

void XrActionMapItem_user_paths_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void XrActionMapItem_user_paths_next(CollectionPropertyIterator *iter);
void XrActionMapItem_user_paths_end(CollectionPropertyIterator *iter);
int XrActionMapItem_user_paths_length(PointerRNA *ptr);
bool XrActionMapItem_user_paths_lookup_int(PointerRNA *ptr, int key, PointerRNA *r_ptr);

/**************** XR Action Map Items ****************/

extern StructRNA RNA_XrActionMapItems;

PointerRNA XrActionMapItems_rna_type_get(PointerRNA *ptr);

struct XrActionMapItem *XrActionMapItems_new_func(struct XrActionMap *_self, const char * name, bool replace_existing);
struct XrActionMapItem *XrActionMapItems_new_from_item_func(struct XrActionMap *_self, struct XrActionMapItem *item);
void XrActionMapItems_remove_func(struct XrActionMap *_self, ReportList *reports, struct PointerRNA *item);
struct XrActionMapItem *XrActionMapItems_find_func(struct XrActionMap *_self, const char * name);
/**************** XR Action Maps ****************/

extern StructRNA RNA_XrActionMaps;

PointerRNA XrActionMaps_rna_type_get(PointerRNA *ptr);

struct XrActionMap *XrActionMaps_new_func(struct PointerRNA *xr_session_state, const char * name, bool replace_existing);
struct XrActionMap *XrActionMaps_new_from_actionmap_func(struct PointerRNA *xr_session_state, struct XrActionMap *actionmap);
void XrActionMaps_remove_func(ReportList *reports, struct PointerRNA *xr_session_state, struct PointerRNA *actionmap);
struct XrActionMap *XrActionMaps_find_func(struct PointerRNA *xr_session_state, const char * name);
/**************** XR Component Path ****************/

extern StructRNA RNA_XrComponentPath;

PointerRNA XrComponentPath_rna_type_get(PointerRNA *ptr);

#define XrComponentPath_path_MAX 192

void XrComponentPath_path_get(PointerRNA *ptr, char *value);
int XrComponentPath_path_length(PointerRNA *ptr);
void XrComponentPath_path_set(PointerRNA *ptr, const char *value);

/**************** XR Component Paths ****************/

extern StructRNA RNA_XrComponentPaths;

PointerRNA XrComponentPaths_rna_type_get(PointerRNA *ptr);

struct XrComponentPath *XrComponentPaths_new_func(struct XrActionMapBinding *_self, const char * path);
void XrComponentPaths_remove_func(struct XrActionMapBinding *_self, struct PointerRNA *component_path);
struct XrComponentPath *XrComponentPaths_find_func(struct XrActionMapBinding *_self, const char * path);
/**************** XrEventData ****************/

extern StructRNA RNA_XrEventData;

PointerRNA XrEventData_rna_type_get(PointerRNA *ptr);

void XrEventData_action_get(PointerRNA *ptr, char *value);
int XrEventData_action_length(PointerRNA *ptr);
void XrEventData_action_set(PointerRNA *ptr, const char *value);

void XrEventData_action_set_get(PointerRNA *ptr, char *value);
int XrEventData_action_set_length(PointerRNA *ptr);
void XrEventData_action_set_set(PointerRNA *ptr, const char *value);

bool XrEventData_bimanual_get(PointerRNA *ptr);
void XrEventData_bimanual_set(PointerRNA *ptr, bool value);

void XrEventData_controller_location_get(PointerRNA *ptr, float values[3]);
void XrEventData_controller_location_set(PointerRNA *ptr, const float values[3]);

void XrEventData_controller_location_other_get(PointerRNA *ptr, float values[3]);
void XrEventData_controller_location_other_set(PointerRNA *ptr, const float values[3]);

void XrEventData_controller_rotation_get(PointerRNA *ptr, float values[4]);
void XrEventData_controller_rotation_set(PointerRNA *ptr, const float values[4]);

void XrEventData_controller_rotation_other_get(PointerRNA *ptr, float values[4]);
void XrEventData_controller_rotation_other_set(PointerRNA *ptr, const float values[4]);

float XrEventData_float_threshold_get(PointerRNA *ptr);
void XrEventData_float_threshold_set(PointerRNA *ptr, float value);

void XrEventData_state_get(PointerRNA *ptr, float values[2]);
void XrEventData_state_set(PointerRNA *ptr, const float values[2]);

void XrEventData_state_other_get(PointerRNA *ptr, float values[2]);
void XrEventData_state_other_set(PointerRNA *ptr, const float values[2]);

enum {
	XrEventData_type_FLOAT = 2,
	XrEventData_type_VECTOR2D = 3,
	XrEventData_type_POSE = 4,
	XrEventData_type_VIBRATION = 100,
};

int XrEventData_type_get(PointerRNA *ptr);
void XrEventData_type_set(PointerRNA *ptr, int value);

void XrEventData_user_path_get(PointerRNA *ptr, char *value);
int XrEventData_user_path_length(PointerRNA *ptr);
void XrEventData_user_path_set(PointerRNA *ptr, const char *value);

void XrEventData_user_path_other_get(PointerRNA *ptr, char *value);
int XrEventData_user_path_other_length(PointerRNA *ptr);
void XrEventData_user_path_other_set(PointerRNA *ptr, const char *value);

/**************** XR Session Settings ****************/

extern StructRNA RNA_XrSessionSettings;

PointerRNA XrSessionSettings_rna_type_get(PointerRNA *ptr);

bool XrSessionSettings_use_absolute_tracking_get(PointerRNA *ptr);
void XrSessionSettings_use_absolute_tracking_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_viewport_armature_get(PointerRNA *ptr);
void XrSessionSettings_show_object_viewport_armature_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_select_armature_get(PointerRNA *ptr);
void XrSessionSettings_show_object_select_armature_set(PointerRNA *ptr, bool value);

float XrSessionSettings_base_pose_angle_get(PointerRNA *ptr);
void XrSessionSettings_base_pose_angle_set(PointerRNA *ptr, float value);

void XrSessionSettings_base_pose_location_get(PointerRNA *ptr, float values[3]);
void XrSessionSettings_base_pose_location_set(PointerRNA *ptr, const float values[3]);

PointerRNA XrSessionSettings_base_pose_object_get(PointerRNA *ptr);

enum {
	XrSessionSettings_base_pose_type_SCENE_CAMERA = 0,
	XrSessionSettings_base_pose_type_OBJECT = 1,
	XrSessionSettings_base_pose_type_CUSTOM = 2,
};

int XrSessionSettings_base_pose_type_get(PointerRNA *ptr);
void XrSessionSettings_base_pose_type_set(PointerRNA *ptr, int value);

float XrSessionSettings_base_scale_get(PointerRNA *ptr);
void XrSessionSettings_base_scale_set(PointerRNA *ptr, float value);

bool XrSessionSettings_show_object_viewport_camera_get(PointerRNA *ptr);
void XrSessionSettings_show_object_viewport_camera_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_select_camera_get(PointerRNA *ptr);
void XrSessionSettings_show_object_select_camera_set(PointerRNA *ptr, bool value);

float XrSessionSettings_clip_end_get(PointerRNA *ptr);
void XrSessionSettings_clip_end_set(PointerRNA *ptr, float value);

float XrSessionSettings_clip_start_get(PointerRNA *ptr);
void XrSessionSettings_clip_start_set(PointerRNA *ptr, float value);

enum {
	XrSessionSettings_controller_draw_style_DARK = 0,
	XrSessionSettings_controller_draw_style_LIGHT = 1,
	XrSessionSettings_controller_draw_style_DARK_RAY = 2,
	XrSessionSettings_controller_draw_style_LIGHT_RAY = 3,
};

int XrSessionSettings_controller_draw_style_get(PointerRNA *ptr);
void XrSessionSettings_controller_draw_style_set(PointerRNA *ptr, int value);

bool XrSessionSettings_show_object_viewport_curve_get(PointerRNA *ptr);
void XrSessionSettings_show_object_viewport_curve_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_select_curve_get(PointerRNA *ptr);
void XrSessionSettings_show_object_select_curve_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_floor_get(PointerRNA *ptr);
void XrSessionSettings_show_floor_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_viewport_empty_get(PointerRNA *ptr);
void XrSessionSettings_show_object_viewport_empty_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_select_empty_get(PointerRNA *ptr);
void XrSessionSettings_show_object_select_empty_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_viewport_font_get(PointerRNA *ptr);
void XrSessionSettings_show_object_viewport_font_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_select_font_get(PointerRNA *ptr);
void XrSessionSettings_show_object_select_font_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_viewport_grease_pencil_get(PointerRNA *ptr);
void XrSessionSettings_show_object_viewport_grease_pencil_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_select_grease_pencil_get(PointerRNA *ptr);
void XrSessionSettings_show_object_select_grease_pencil_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_viewport_curves_get(PointerRNA *ptr);
void XrSessionSettings_show_object_viewport_curves_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_select_curves_get(PointerRNA *ptr);
void XrSessionSettings_show_object_select_curves_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_viewport_lattice_get(PointerRNA *ptr);
void XrSessionSettings_show_object_viewport_lattice_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_select_lattice_get(PointerRNA *ptr);
void XrSessionSettings_show_object_select_lattice_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_viewport_light_get(PointerRNA *ptr);
void XrSessionSettings_show_object_viewport_light_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_select_light_get(PointerRNA *ptr);
void XrSessionSettings_show_object_select_light_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_viewport_light_probe_get(PointerRNA *ptr);
void XrSessionSettings_show_object_viewport_light_probe_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_select_light_probe_get(PointerRNA *ptr);
void XrSessionSettings_show_object_select_light_probe_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_viewport_mesh_get(PointerRNA *ptr);
void XrSessionSettings_show_object_viewport_mesh_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_select_mesh_get(PointerRNA *ptr);
void XrSessionSettings_show_object_select_mesh_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_viewport_meta_get(PointerRNA *ptr);
void XrSessionSettings_show_object_viewport_meta_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_select_meta_get(PointerRNA *ptr);
void XrSessionSettings_show_object_select_meta_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_viewport_pointcloud_get(PointerRNA *ptr);
void XrSessionSettings_show_object_viewport_pointcloud_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_select_pointcloud_get(PointerRNA *ptr);
void XrSessionSettings_show_object_select_pointcloud_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_use_positional_tracking_get(PointerRNA *ptr);
void XrSessionSettings_use_positional_tracking_set(PointerRNA *ptr, bool value);

PointerRNA XrSessionSettings_shading_get(PointerRNA *ptr);

bool XrSessionSettings_show_annotation_get(PointerRNA *ptr);
void XrSessionSettings_show_annotation_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_controllers_get(PointerRNA *ptr);
void XrSessionSettings_show_controllers_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_custom_overlays_get(PointerRNA *ptr);
void XrSessionSettings_show_custom_overlays_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_extras_get(PointerRNA *ptr);
void XrSessionSettings_show_object_extras_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_passthrough_get(PointerRNA *ptr);
void XrSessionSettings_show_passthrough_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_selection_get(PointerRNA *ptr);
void XrSessionSettings_show_selection_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_viewport_speaker_get(PointerRNA *ptr);
void XrSessionSettings_show_object_viewport_speaker_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_select_speaker_get(PointerRNA *ptr);
void XrSessionSettings_show_object_select_speaker_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_viewport_surf_get(PointerRNA *ptr);
void XrSessionSettings_show_object_viewport_surf_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_select_surf_get(PointerRNA *ptr);
void XrSessionSettings_show_object_select_surf_set(PointerRNA *ptr, bool value);

int XrSessionSettings_icon_from_show_object_viewport_get(PointerRNA *ptr);
void XrSessionSettings_icon_from_show_object_viewport_set(PointerRNA *ptr, int value);

bool XrSessionSettings_show_object_viewport_volume_get(PointerRNA *ptr);
void XrSessionSettings_show_object_viewport_volume_set(PointerRNA *ptr, bool value);

bool XrSessionSettings_show_object_select_volume_get(PointerRNA *ptr);
void XrSessionSettings_show_object_select_volume_set(PointerRNA *ptr, bool value);

/**************** Session State ****************/

extern StructRNA RNA_XrSessionState;

PointerRNA XrSessionState_rna_type_get(PointerRNA *ptr);

int XrSessionState_active_actionmap_get(PointerRNA *ptr);
void XrSessionState_active_actionmap_set(PointerRNA *ptr, int value);

void XrSessionState_navigation_location_get(PointerRNA *ptr, float values[3]);
void XrSessionState_navigation_location_set(PointerRNA *ptr, const float values[3]);

void XrSessionState_navigation_rotation_get(PointerRNA *ptr, float values[4]);
void XrSessionState_navigation_rotation_set(PointerRNA *ptr, const float values[4]);

float XrSessionState_navigation_scale_get(PointerRNA *ptr);
void XrSessionState_navigation_scale_set(PointerRNA *ptr, float value);

int XrSessionState_selected_actionmap_get(PointerRNA *ptr);
void XrSessionState_selected_actionmap_set(PointerRNA *ptr, int value);

void XrSessionState_viewer_pose_location_get(PointerRNA *ptr, float values[3]);
void XrSessionState_viewer_pose_location_set(PointerRNA *ptr, const float values[3]);

void XrSessionState_viewer_pose_rotation_get(PointerRNA *ptr, float values[4]);
void XrSessionState_viewer_pose_rotation_set(PointerRNA *ptr, const float values[4]);

void XrSessionState_actionmaps_begin(CollectionPropertyIterator *iter, PointerRNA *ptr);
void XrSessionState_actionmaps_next(CollectionPropertyIterator *iter);
void XrSessionState_actionmaps_end(CollectionPropertyIterator *iter);
int XrSessionState_actionmaps_length(PointerRNA *ptr);

bool XrSessionState_is_running_func(struct bContext *context);
void XrSessionState_reset_to_base_pose_func(struct bContext *context);
bool XrSessionState_action_set_create_func(struct bContext *context, struct XrActionMap *actionmap);
bool XrSessionState_action_create_func(struct bContext *context, struct XrActionMap *actionmap, struct XrActionMapItem *actionmap_item);
bool XrSessionState_action_binding_create_func(struct bContext *context, struct XrActionMap *actionmap, struct XrActionMapItem *actionmap_item, struct XrActionMapBinding *actionmap_binding);
bool XrSessionState_active_action_set_set_func(struct bContext *context, const char * action_set);
bool XrSessionState_controller_pose_actions_set_func(struct bContext *context, const char * action_set, const char * grip_action, const char * aim_action);
void XrSessionState_action_state_get_func(struct bContext *context, const char * action_set_name, const char * action_name, const char * user_path, float state[2]);
bool XrSessionState_haptic_action_apply_func(struct bContext *context, const char * action_set_name, const char * action_name, const char * user_path, float duration, float frequency, float amplitude);
void XrSessionState_haptic_action_stop_func(struct bContext *context, const char * action_set_name, const char * action_name, const char * user_path);
void XrSessionState_controller_grip_location_get_func(struct bContext *context, int index, float location[3]);
void XrSessionState_controller_grip_rotation_get_func(struct bContext *context, int index, float rotation[4]);
void XrSessionState_controller_aim_location_get_func(struct bContext *context, int index, float location[3]);
void XrSessionState_controller_aim_rotation_get_func(struct bContext *context, int index, float rotation[4]);
/**************** XR User Path ****************/

extern StructRNA RNA_XrUserPath;

PointerRNA XrUserPath_rna_type_get(PointerRNA *ptr);

#define XrUserPath_path_MAX 64

void XrUserPath_path_get(PointerRNA *ptr, char *value);
int XrUserPath_path_length(PointerRNA *ptr);
void XrUserPath_path_set(PointerRNA *ptr, const char *value);

/**************** XR User Paths ****************/

extern StructRNA RNA_XrUserPaths;

PointerRNA XrUserPaths_rna_type_get(PointerRNA *ptr);

struct XrUserPath *XrUserPaths_new_func(struct XrActionMapItem *_self, const char * path);
void XrUserPaths_remove_func(struct XrActionMapItem *_self, struct PointerRNA *user_path);
struct XrUserPath *XrUserPaths_find_func(struct XrActionMapItem *_self, const char * path);
/**************** Work Space UI Tag ****************/

extern StructRNA RNA_wmOwnerID;

PointerRNA wmOwnerID_rna_type_get(PointerRNA *ptr);

#define wmOwnerID_name_MAX 128

void wmOwnerID_name_get(PointerRNA *ptr, char *value);
int wmOwnerID_name_length(PointerRNA *ptr);
void wmOwnerID_name_set(PointerRNA *ptr, const char *value);

/**************** WorkSpace UI Tags ****************/

extern StructRNA RNA_wmOwnerIDs;

PointerRNA wmOwnerIDs_rna_type_get(PointerRNA *ptr);

struct wmOwnerID *wmOwnerIDs_new_func(struct WorkSpace *_self, const char * name);
void wmOwnerIDs_remove_func(struct WorkSpace *_self, ReportList *reports, struct PointerRNA *owner_id);
void wmOwnerIDs_clear_func(struct WorkSpace *_self);
/**************** WorkSpace UI Tags ****************/

extern StructRNA RNA_wmTools;

PointerRNA wmTools_rna_type_get(PointerRNA *ptr);

struct bToolRef *wmTools_from_space_view3d_mode_func(struct WorkSpace *_self, int mode, bool create);
struct bToolRef *wmTools_from_space_image_mode_func(struct WorkSpace *_self, int mode, bool create);
struct bToolRef *wmTools_from_space_node_func(struct WorkSpace *_self, bool create);
struct bToolRef *wmTools_from_space_sequencer_func(struct WorkSpace *_self, int mode, bool create);
#endif /* __RNA_BLENDER_H__ */

